/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","fs","os","vs/base/common/process","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/charCode","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/iterator","vs/platform/telemetry/common/telemetryUtils","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/base/common/json","vs/base/common/performance","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/editor/common/core/range","vs/base/common/marshalling","vs/base/parts/ipc/common/ipc","vs/platform/files/common/watcher","vs/platform/terminal/common/terminal","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stopwatch","vs/base/common/stream","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uriIpc","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/themables","path","net","vs/editor/common/core/position","vs/base/common/glob","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/storage/common/storage","vs/server/node/serverConnectionToken","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/encodedTokenAttributes","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/terminal/common/remote/terminal","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/collections","vs/base/common/equals","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/config/editorOptions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/chat/common/languageModels","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","https","http","vs/server/node/server.main"],Se=function(fe){for(var e=[],n=0,r=fe.length;n<r;n++)e[n]=Ee[fe[n]];return e};define(Ee[104],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.LoaderEventType=e.$T=void 0,e.$T=!1;var n;(function(S){S[S.LoaderAvailable=1]="LoaderAvailable",S[S.BeginLoadingScript=10]="BeginLoadingScript",S[S.EndLoadingScriptOK=11]="EndLoadingScriptOK",S[S.EndLoadingScriptError=12]="EndLoadingScriptError",S[S.BeginInvokeFactory=21]="BeginInvokeFactory",S[S.EndInvokeFactory=22]="EndInvokeFactory",S[S.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",S[S.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",S[S.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",S[S.NodeEndNativeRequire=34]="NodeEndNativeRequire",S[S.CachedDataFound=60]="CachedDataFound",S[S.CachedDataMissed=61]="CachedDataMissed",S[S.CachedDataRejected=62]="CachedDataRejected",S[S.CachedDataCreated=63]="CachedDataCreated"})(n||(e.LoaderEventType=n={}));class r{static get(){const D=new Map,A=new Map,R=new Map,v=new Map;function s(a,f){a.has(f.detail)||a.set(f.detail,-f.timestamp)}function E(a,f){const h=a.get(f.detail);h&&(h>=0||a.set(f.detail,h+f.timestamp))}let y=[];typeof fe=="function"&&typeof fe.getStats=="function"&&(y=fe.getStats().slice(0).sort((a,f)=>a.timestamp-f.timestamp));for(const a of y)switch(a.type){case n.BeginLoadingScript:s(D,a);break;case n.EndLoadingScriptOK:case n.EndLoadingScriptError:E(D,a);break;case n.BeginInvokeFactory:s(A,a);break;case n.EndInvokeFactory:E(A,a);break;case n.NodeBeginNativeRequire:s(R,a);break;case n.NodeEndNativeRequire:E(R,a);break;case n.NodeBeginEvaluatingScript:s(v,a);break;case n.NodeEndEvaluatingScript:E(v,a);break}let p=0;R.forEach(a=>p+=a);function b(a){const f=[];return a.forEach((h,g)=>f.push([g,h])),f}return{amdLoad:b(D),amdInvoke:b(A),nodeRequire:b(R),nodeEval:b(v),nodeRequireTotal:p}}static toMarkdownTable(D,A){let R="";const v=[];return D.forEach((s,E)=>{v[E]=s.length}),A.forEach(s=>{s.forEach((E,y)=>{typeof E>"u"&&(E=s[y]="-");const p=E.toString().length;v[y]=Math.max(p,v[y])})}),D.forEach((s,E)=>{R+=`| ${s+" ".repeat(v[E]-s.toString().length)} `}),R+=`|
`,D.forEach((s,E)=>{R+=`| ${"-".repeat(v[E])} `}),R+=`|
`,A.forEach(s=>{s.forEach((E,y)=>{typeof E<"u"&&(R+=`| ${E+" ".repeat(v[y]-E.toString().length)} `)}),R+=`|
`}),R}}e.$U=r}),define(Ee[105],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=r,e.$hb=S,e.$ib=D,e.$jb=A,e.$kb=R,e.$lb=v,e.$nb=E,e.$ob=y,e.$pb=p,e.$qb=b,e.$rb=a;function n(f,h){const g=r(f,h);if(g!==-1)return f[g]}function r(f,h,g=f.length-1){for(let w=g;w>=0;w--){const m=f[w];if(h(m))return w}return-1}function S(f,h){const g=D(f,h);return g===-1?void 0:f[g]}function D(f,h,g=0,w=f.length){let m=g,$=w;for(;m<$;){const l=Math.floor((m+$)/2);h(f[l])?m=l+1:$=l}return m-1}function A(f,h){const g=R(f,h);return g===f.length?void 0:f[g]}function R(f,h,g=0,w=f.length){let m=g,$=w;for(;m<$;){const l=Math.floor((m+$)/2);h(f[l])?$=l:m=l+1}return m}function v(f,h,g=0,w=f.length){const m=R(f,h,g,w);return m===f.length?-1:m}class s{static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if(s.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!h(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const g=D(this.e,h,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$mb=s;function E(f,h){if(f.length===0)return;let g=f[0];for(let w=1;w<f.length;w++){const m=f[w];h(m,g)>0&&(g=m)}return g}function y(f,h){if(f.length===0)return;let g=f[0];for(let w=1;w<f.length;w++){const m=f[w];h(m,g)>=0&&(g=m)}return g}function p(f,h){return E(f,(g,w)=>-h(g,w))}function b(f,h){if(f.length===0)return-1;let g=0;for(let w=1;w<f.length;w++){const m=f[w];h(m,f[g])>0&&(g=w)}return g}function a(f,h){for(const g of f){const w=h(g);if(w!==void 0)return w}}}),define(Ee[35],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(Ee[156],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=n,e.$L=r,e.$M=S,e.$N=D;function n(A,R){const v=Object.create(null);for(const s of A){const E=R(s);let y=v[E];y||(y=v[E]=[]),y.push(s)}return v}function r(A,R){const v=[],s=[];for(const E of A)R.has(E)||v.push(E);for(const E of R)A.has(E)||s.push(E);return{removed:v,added:s}}function S(A,R){const v=[],s=[];for(const[E,y]of A)R.has(E)||v.push(y);for(const[E,y]of R)A.has(E)||s.push(y);return{removed:v,added:s}}function D(A,R){const v=new Set;for(const s of R)A.has(s)&&v.add(s);return v}}),define(Ee[77],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=r,e.$6h=S,e.$7h=D;function n(A){return(R,v,s)=>{let E=null,y=null;if(typeof s.value=="function"?(E="value",y=s.value):typeof s.get=="function"&&(E="get",y=s.get),!y)throw new Error("not supported");s[E]=A(y,v)}}function r(A,R,v){let s=null,E=null;if(typeof v.value=="function"?(s="value",E=v.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(s="get",E=v.get),!E)throw new Error("not supported");const y=`$memoize$${R}`;v[s]=function(...p){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,p)}),this[y]}}function S(A,R,v){return n((s,E)=>{const y=`$debounce$${E}`,p=`$debounce$result$${E}`;return function(...b){this[p]||(this[p]=v?v():void 0),clearTimeout(this[y]),R&&(this[p]=R(this[p],...b),b=[this[p]]),this[y]=setTimeout(()=>{s.apply(this,b),this[p]=v?v():void 0},A)}})}function D(A,R,v){return n((s,E)=>{const y=`$throttle$timer$${E}`,p=`$throttle$result$${E}`,b=`$throttle$lastRun$${E}`,a=`$throttle$pending$${E}`;return function(...f){if(this[p]||(this[p]=v?v():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),R&&(this[p]=R(this[p],...f)),this[a])return;const h=this[b]+A;h<=Date.now()?(this[b]=Date.now(),s.apply(this,[this[p]]),this[p]=v?v():void 0):(this[a]=!0,this[y]=setTimeout(()=>{this[a]=!1,this[b]=Date.now(),s.apply(this,[this[p]]),this[p]=v?v():void 0},h-Date.now()))}})}}),define(Ee[10],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=r,e.$Z=S,e.$1=D,e.$2=A,e.$3=R,e.$4=s,e.$6=y,e.$7=p,e.$8=b,e.$0=f;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?m.isErrorNoTelemetry(t)?new m(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function r(l){e.$X.setUnexpectedErrorHandler(l)}function S(l){if(!l||typeof l!="object")return!1;const t=l;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function D(l){s(l)||e.$X.onUnexpectedError(l)}function A(l){s(l)||e.$X.onUnexpectedExternalError(l)}function R(l){if(l instanceof Error){const{name:t,message:o}=l,d=l.stacktrace||l.stack;return{$isError:!0,name:t,message:o,stack:d,noTelemetry:m.isErrorNoTelemetry(l)}}return l}const v="Canceled";function s(l){return l instanceof E?!0:l instanceof Error&&l.name===v&&l.message===v}class E extends Error{constructor(){super(v),this.name=this.message}}e.$5=E;function y(){const l=new Error(v);return l.name=l.message,l}function p(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function b(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class a extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=a;function f(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class h extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=h;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=g;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=w;class m extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof m)return t;const o=new m;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=m;class $ extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}e.$cb=$}),define(Ee[18],Se([1,0,10,105]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=S,e.$tb=D,e.$ub=A,e.$vb=R,e.$wb=v,e.$xb=s,e.$yb=E,e.$zb=y,e.$Ab=p,e.$Bb=b,e.$Cb=a,e.$Db=f,e.$Eb=h,e.top=g,e.$Gb=w,e.$Hb=$,e.$Ib=l,e.$Jb=t,e.$Kb=o,e.$Lb=d,e.$Mb=i,e.$Nb=c,e.$Ob=u,e.$Pb=k,e.$Qb=I,e.$Rb=C,e.$Sb=T,e.$Tb=O,e.$Ub=P,e.$Vb=V,e.$Wb=Q,e.$Xb=ie,e.$Yb=re,e.$Zb=ne,e.$1b=se,e.$2b=Z,e.$3b=ee,e.$4b=ue,e.$5b=j,e.$6b=le,e.$7b=pe,e.$0b=Y;function S(z,U=0){return z[z.length-(1+U)]}function D(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function A(z,U,J=(x,M)=>x===M){if(z===U)return!0;if(!z||!U||z.length!==U.length)return!1;for(let x=0,M=z.length;x<M;x++)if(!J(z[x],U[x]))return!1;return!0}function R(z,U){const J=z.length-1;U<J&&(z[U]=z[J]),z.pop()}function v(z,U,J){return s(z.length,x=>J(z[x],U))}function s(z,U){let J=0,x=z-1;for(;J<=x;){const M=(J+x)/2|0,G=U(M);if(G<0)J=M+1;else if(G>0)x=M-1;else return M}return-(J+1)}function E(z,U,J){if(z=z|0,z>=U.length)throw new TypeError("invalid index");const x=U[Math.floor(U.length*Math.random())],M=[],G=[],te=[];for(const he of U){const ke=J(he,x);ke<0?M.push(he):ke>0?G.push(he):te.push(he)}return z<M.length?E(z,M,J):z<M.length+te.length?te[0]:E(z-(M.length+te.length),G,J)}function y(z,U){const J=[];let x;for(const M of z.slice(0).sort(U))!x||U(x[0],M)!==0?(x=[M],J.push(x)):x.push(M);return J}function*p(z,U){let J,x;for(const M of z)x!==void 0&&U(x,M)?J.push(M):(J&&(yield J),J=[M]),x=M;J&&(yield J)}function b(z,U){for(let J=0;J<=z.length;J++)U(J===0?void 0:z[J-1],J===z.length?void 0:z[J])}function a(z,U){for(let J=0;J<z.length;J++)U(J===0?void 0:z[J-1],z[J],J+1===z.length?void 0:z[J+1])}function f(z,U,J){const x=[];function M(he,ke,Ne){if(ke===0&&Ne.length===0)return;const me=x[x.length-1];me&&me.start+me.deleteCount===he?(me.deleteCount+=ke,me.toInsert.push(...Ne)):x.push({start:he,deleteCount:ke,toInsert:Ne})}let G=0,te=0;for(;;){if(G===z.length){M(G,0,U.slice(te));break}if(te===U.length){M(G,z.length-G,[]);break}const he=z[G],ke=U[te],Ne=J(he,ke);Ne===0?(G+=1,te+=1):Ne<0?(M(G,1,[]),G+=1):Ne>0&&(M(G,0,[ke]),te+=1)}return x}function h(z,U,J){const x=f(z,U,J),M=[],G=[];for(const te of x)M.push(...z.slice(te.start,te.start+te.deleteCount)),G.push(...te.toInsert);return{removed:M,added:G}}function g(z,U,J){if(J===0)return[];const x=z.slice(0,J).sort(U);return m(z,U,x,J,z.length),x}function w(z,U,J,x,M){return J===0?Promise.resolve([]):new Promise((G,te)=>{(async()=>{const he=z.length,ke=z.slice(0,J).sort(U);for(let Ne=J,me=Math.min(J+x,he);Ne<he;Ne=me,me=Math.min(me+x,he)){if(Ne>J&&await new Promise(be=>setTimeout(be)),M&&M.isCancellationRequested)throw new n.$5;m(z,U,ke,Ne,me)}return ke})().then(G,te)})}function m(z,U,J,x,M){for(const G=J.length;x<M;x++){const te=z[x];if(U(te,J[G-1])<0){J.pop();const he=(0,r.$kb)(J,ke=>U(te,ke)<0);J.splice(he,0,te)}}}function $(z){return z.filter(U=>!!U)}function l(z){let U=0;for(let J=0;J<z.length;J++)z[J]&&(z[U]=z[J],U+=1);z.length=U}function t(z,U,J){z.splice(J,0,z.splice(U,1)[0])}function o(z){return!Array.isArray(z)||z.length===0}function d(z){return Array.isArray(z)&&z.length>0}function i(z,U=J=>J){const J=new Set;return z.filter(x=>{const M=U(x);return J.has(M)?!1:(J.add(M),!0)})}function c(z){const U=new Set;return J=>{const x=z(J);return U.has(x)?!1:(U.add(x),!0)}}function u(z,U){return z.length>0?z[0]:U}function k(z,U){return z.length>0?z[z.length-1]:U}function I(z,U,J=(x,M)=>x===M){let x=0;for(let M=0,G=Math.min(z.length,U.length);M<G&&J(z[M],U[M]);M++)x++;return x}function C(z,U){let J=typeof U=="number"?z:0;typeof U=="number"?J=z:(J=0,U=z);const x=[];if(J<=U)for(let M=J;M<U;M++)x.push(M);else for(let M=J;M>U;M--)x.push(M);return x}function T(z,U,J){return z.reduce((x,M)=>(x[U(M)]=J?J(M):M,x),Object.create(null))}function O(z,U){return z.push(U),()=>P(z,U)}function P(z,U){const J=z.indexOf(U);if(J>-1)return z.splice(J,1),U}function V(z,U,J){const x=z.slice(0,U),M=z.slice(U);return x.concat(J,M)}function Q(z,U){let J;if(typeof U=="number"){let x=U;J=()=>{const M=Math.sin(x++)*179426549;return M-Math.floor(M)}}else J=Math.random;for(let x=z.length-1;x>0;x-=1){const M=Math.floor(J()*(x+1)),G=z[x];z[x]=z[M],z[M]=G}}function ie(z,U){const J=z.indexOf(U);J>-1&&(z.splice(J,1),z.unshift(U))}function re(z,U){const J=z.indexOf(U);J>-1&&(z.splice(J,1),z.push(U))}function ne(z,U){for(const J of U)z.push(J)}function se(z,U){return Array.isArray(z)?z.map(U):U(z)}function Z(z){return Array.isArray(z)?z:[z]}function ee(z){return z[Math.floor(Math.random()*z.length)]}function ue(z,U,J){const x=B(z,U),M=z.length,G=J.length;z.length=M+G;for(let te=M-1;te>=x;te--)z[te+G]=z[te];for(let te=0;te<G;te++)z[te+x]=J[te]}function j(z,U,J,x){const M=B(z,U);let G=z.splice(M,J);return G===void 0&&(G=[]),ue(z,M,x),G}function B(z,U){return U<0?Math.max(U+z.length,0):Math.min(U,z.length)}var oe;(function(z){function U(G){return G<0}z.isLessThan=U;function J(G){return G<=0}z.isLessThanOrEqual=J;function x(G){return G>0}z.isGreaterThan=x;function M(G){return G===0}z.isNeitherLessOrGreaterThan=M,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function le(z,U){return(J,x)=>U(z(J),z(x))}function pe(...z){return(U,J)=>{for(const x of z){const M=x(U,J);if(!oe.isNeitherLessOrGreaterThan(M))return M}return oe.neitherLessOrGreaterThan}}const q=(z,U)=>z-U;e.$8b=q;const ae=(z,U)=>(0,e.$8b)(z?1:0,U?1:0);e.$9b=ae;function Y(z){return(U,J)=>-z(U,J)}class H{constructor(U){this.g=U,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(U){let J=this.c;for(;J<this.g.length&&U(this.g[J]);)J++;const x=J===this.c?null:this.g.slice(this.c,J);return this.c=J,x}takeFromEndWhile(U){let J=this.d;for(;J>=0&&U(this.g[J]);)J--;const x=J===this.d?null:this.g.slice(J+1,this.d+1);return this.d=J,x}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const U=this.g[this.c];return this.c++,U}removeLast(){const U=this.g[this.d];return this.d--,U}takeCount(U){const J=this.g.slice(this.c,this.c+U);return this.c+=U,J}}e.$$b=H;class L{static{this.empty=new L(U=>{})}constructor(U){this.iterate=U}forEach(U){this.iterate(J=>(U(J),!0))}toArray(){const U=[];return this.iterate(J=>(U.push(J),!0)),U}filter(U){return new L(J=>this.iterate(x=>U(x)?J(x):!0))}map(U){return new L(J=>this.iterate(x=>J(U(x))))}some(U){let J=!1;return this.iterate(x=>(J=U(x),!J)),J}findFirst(U){let J;return this.iterate(x=>U(x)?(J=x,!1):!0),J}findLast(U){let J;return this.iterate(x=>(U(x)&&(J=x),!0)),J}findLastMaxBy(U){let J,x=!0;return this.iterate(M=>((x||oe.isGreaterThan(U(M,J)))&&(x=!1,J=M),!0)),J}}e.$_b=L;class W{constructor(U){this.c=U}static createSortPermutation(U,J){const x=Array.from(U.keys()).sort((M,G)=>J(U[M],U[G]));return new W(x)}apply(U){return U.map((J,x)=>U[this.c[x]])}inverse(){const U=this.c.slice();for(let J=0;J<this.c.length;J++)U[this.c[J]]=J;return new W(U)}}e.$ac=W}),define(Ee[106],Se([1,0,10]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$ed=S,e.$fd=D,e.$gd=A,e.$hd=R,e.$id=v;function r(s,E){if(!s)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function S(s,E="Unreachable"){throw new Error(E)}function D(s,E="unexpected state"){if(!s)throw new n.$cb(`Assertion Failed: ${E}`)}function A(s){s||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function R(s){if(!s()){debugger;s(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function v(s,E){let y=0;for(;y<s.length-1;){const p=s[y],b=s[y+1];if(!E(p,b))return!1;y++}return!0}}),define(Ee[157],Se([1,0,18]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=S,e.$8c=D,e.$9c=A,e.$0c=R,e.$$c=v,e.$_c=s;const r=(b,a)=>b===a;e.$6c=r;function S(b=e.$6c){return(a,f)=>n.$ub(a,f,b)}function D(){return(b,a)=>JSON.stringify(b)===JSON.stringify(a)}function A(){return(b,a)=>b.equals(a)}function R(b,a,f){return!b||!a?b===a:f(b,a)}function v(b,a){if(b===a)return!0;if(Array.isArray(b)&&Array.isArray(a)){if(b.length!==a.length)return!1;for(let f=0;f<b.length;f++)if(!v(b[f],a[f]))return!1;return!0}if(b&&typeof b=="object"&&a&&typeof a=="object"&&Object.getPrototypeOf(b)===Object.prototype&&Object.getPrototypeOf(a)===Object.prototype){const f=b,h=a,g=Object.keys(f),w=Object.keys(h),m=new Set(w);if(g.length!==w.length)return!1;for(const $ of g)if(!m.has($)||!v(f[$],h[$]))return!1;return!0}return!1}function s(b){return JSON.stringify(p(b))}let E=0;const y=new WeakMap;function p(b){if(Array.isArray(b))return b.map(p);if(b&&typeof b=="object")if(Object.getPrototypeOf(b)===Object.prototype){const a=b,f=Object.create(null);for(const h of Object.keys(a).sort())f[h]=p(a[h]);return f}else{let a=y.get(b);return a===void 0&&(a=E++,y.set(b,a)),a+"----2b76a038c20c4bcc"}return b}}),define(Ee[78],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(r,S){const D=this;let A=!1,R;return function(){if(A)return R;if(A=!0,S)try{R=r.apply(D,arguments)}finally{S()}else R=r.apply(D,arguments);return R}}}),define(Ee[40],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function S(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}r.is=S;const D=Object.freeze([]);function A(){return D}r.empty=A;function*R(t){yield t}r.single=R;function v(t){return S(t)?t:R(t)}r.wrap=v;function s(t){return t||D}r.from=s;function*E(t){for(let o=t.length-1;o>=0;o--)yield t[o]}r.reverse=E;function y(t){return!t||t[Symbol.iterator]().next().done===!0}r.isEmpty=y;function p(t){return t[Symbol.iterator]().next().value}r.first=p;function b(t,o){for(const d of t)if(o(d))return!0;return!1}r.some=b;function a(t,o){for(const d of t)if(o(d))return d}r.find=a;function*f(t,o){for(const d of t)o(d)&&(yield d)}r.filter=f;function*h(t,o){let d=0;for(const i of t)yield o(i,d++)}r.map=h;function*g(...t){for(const o of t)yield*o}r.concat=g;function w(t,o,d){let i=d;for(const c of t)i=o(i,c);return i}r.reduce=w;function*m(t,o,d=t.length){for(o<0&&(o+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);o<d;o++)yield t[o]}r.slice=m;function $(t,o=Number.POSITIVE_INFINITY){const d=[];if(o===0)return[d,t];const i=t[Symbol.iterator]();for(let c=0;c<o;c++){const u=i.next();if(u.done)return[d,r.empty()];d.push(u.value)}return[d,{[Symbol.iterator](){return i}}]}r.consume=$;async function l(t){const o=[];for await(const d of t)o.push(d);return Promise.resolve(o)}r.asyncToArray=l})(n||(e.Iterable=n={}))}),define(Ee[44],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Nn=A,e.$On=y,e.$Pn=p,e.$Qn=b,e.$Rn=a,e.$Sn=f,e.$Tn=h,e.$Un=g,e.$Vn=w,e.$Wn=m,e.$Xn=$,e.$Yn=l;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function A(t,o=!1){let d=0;const i=t.length;let c="",u=0,k=r.Unknown,I=n.None;function C(re){let ne=0,se=0;for(;ne<re;){const Z=t.charCodeAt(d);if(Z>=E._0&&Z<=E._9)se=se*16+Z-E._0;else if(Z>=E.A&&Z<=E.F)se=se*16+Z-E.A+10;else if(Z>=E.a&&Z<=E.f)se=se*16+Z-E.a+10;else break;d++,ne++}return ne<re&&(se=-1),se}function T(re){d=re,c="",u=0,k=r.Unknown,I=n.None}function O(){const re=d;if(t.charCodeAt(d)===E._0)d++;else for(d++;d<t.length&&s(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===E.dot)if(d++,d<t.length&&s(t.charCodeAt(d)))for(d++;d<t.length&&s(t.charCodeAt(d));)d++;else return I=n.UnexpectedEndOfNumber,t.substring(re,d);let ne=d;if(d<t.length&&(t.charCodeAt(d)===E.E||t.charCodeAt(d)===E.e))if(d++,(d<t.length&&t.charCodeAt(d)===E.plus||t.charCodeAt(d)===E.minus)&&d++,d<t.length&&s(t.charCodeAt(d))){for(d++;d<t.length&&s(t.charCodeAt(d));)d++;ne=d}else I=n.UnexpectedEndOfNumber;return t.substring(re,ne)}function P(){let re="",ne=d;for(;;){if(d>=i){re+=t.substring(ne,d),I=n.UnexpectedEndOfString;break}const se=t.charCodeAt(d);if(se===E.doubleQuote){re+=t.substring(ne,d),d++;break}if(se===E.backslash){if(re+=t.substring(ne,d),d++,d>=i){I=n.UnexpectedEndOfString;break}switch(t.charCodeAt(d++)){case E.doubleQuote:re+='"';break;case E.backslash:re+="\\";break;case E.slash:re+="/";break;case E.b:re+="\b";break;case E.f:re+="\f";break;case E.n:re+=`
`;break;case E.r:re+="\r";break;case E.t:re+="	";break;case E.u:{const ee=C(4);ee>=0?re+=String.fromCharCode(ee):I=n.InvalidUnicode;break}default:I=n.InvalidEscapeCharacter}ne=d;continue}if(se>=0&&se<=31)if(v(se)){re+=t.substring(ne,d),I=n.UnexpectedEndOfString;break}else I=n.InvalidCharacter;d++}return re}function V(){if(c="",I=n.None,u=d,d>=i)return u=i,k=r.EOF;let re=t.charCodeAt(d);if(R(re)){do d++,c+=String.fromCharCode(re),re=t.charCodeAt(d);while(R(re));return k=r.Trivia}if(v(re))return d++,c+=String.fromCharCode(re),re===E.carriageReturn&&t.charCodeAt(d)===E.lineFeed&&(d++,c+=`
`),k=r.LineBreakTrivia;switch(re){case E.openBrace:return d++,k=r.OpenBraceToken;case E.closeBrace:return d++,k=r.CloseBraceToken;case E.openBracket:return d++,k=r.OpenBracketToken;case E.closeBracket:return d++,k=r.CloseBracketToken;case E.colon:return d++,k=r.ColonToken;case E.comma:return d++,k=r.CommaToken;case E.doubleQuote:return d++,c=P(),k=r.StringLiteral;case E.slash:{const ne=d-1;if(t.charCodeAt(d+1)===E.slash){for(d+=2;d<i&&!v(t.charCodeAt(d));)d++;return c=t.substring(ne,d),k=r.LineCommentTrivia}if(t.charCodeAt(d+1)===E.asterisk){d+=2;const se=i-1;let Z=!1;for(;d<se;){if(t.charCodeAt(d)===E.asterisk&&t.charCodeAt(d+1)===E.slash){d+=2,Z=!0;break}d++}return Z||(d++,I=n.UnexpectedEndOfComment),c=t.substring(ne,d),k=r.BlockCommentTrivia}return c+=String.fromCharCode(re),d++,k=r.Unknown}case E.minus:if(c+=String.fromCharCode(re),d++,d===i||!s(t.charCodeAt(d)))return k=r.Unknown;case E._0:case E._1:case E._2:case E._3:case E._4:case E._5:case E._6:case E._7:case E._8:case E._9:return c+=O(),k=r.NumericLiteral;default:for(;d<i&&Q(re);)d++,re=t.charCodeAt(d);if(u!==d){switch(c=t.substring(u,d),c){case"true":return k=r.TrueKeyword;case"false":return k=r.FalseKeyword;case"null":return k=r.NullKeyword}return k=r.Unknown}return c+=String.fromCharCode(re),d++,k=r.Unknown}}function Q(re){if(R(re)||v(re))return!1;switch(re){case E.closeBrace:case E.closeBracket:case E.openBrace:case E.openBracket:case E.doubleQuote:case E.colon:case E.comma:case E.slash:return!1}return!0}function ie(){let re;do re=V();while(re>=r.LineCommentTrivia&&re<=r.Trivia);return re}return{setPosition:T,getPosition:()=>d,scan:o?ie:V,getToken:()=>k,getTokenValue:()=>c,getTokenOffset:()=>u,getTokenLength:()=>d-u,getTokenError:()=>I}}function R(t){return t===E.space||t===E.tab||t===E.verticalTab||t===E.formFeed||t===E.nonBreakingSpace||t===E.ogham||t>=E.enQuad&&t<=E.zeroWidthSpace||t===E.narrowNoBreakSpace||t===E.mathematicalSpace||t===E.ideographicSpace||t===E.byteOrderMark}function v(t){return t===E.lineFeed||t===E.carriageReturn||t===E.lineSeparator||t===E.paragraphSeparator}function s(t){return t>=E._0&&t<=E._9}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function y(t,o){const d=[],i=new Object;let c;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function I(C,T,O,P){u.value=C,u.offset=T,u.length=O,u.type=P,u.colonOffset=void 0,c=u}try{m(t,{onObjectBegin:(C,T)=>{if(o<=C)throw i;c=void 0,k=o>C,d.push("")},onObjectProperty:(C,T,O)=>{if(o<T||(I(C,T,O,"property"),d[d.length-1]=C,o<=T+O))throw i},onObjectEnd:(C,T)=>{if(o<=C)throw i;c=void 0,d.pop()},onArrayBegin:(C,T)=>{if(o<=C)throw i;c=void 0,d.push(0)},onArrayEnd:(C,T)=>{if(o<=C)throw i;c=void 0,d.pop()},onLiteralValue:(C,T,O)=>{if(o<T||(I(C,T,O,l(C)),o<=T+O))throw i},onSeparator:(C,T,O)=>{if(o<=T)throw i;if(C===":"&&c&&c.type==="property")c.colonOffset=T,k=!1,c=void 0;else if(C===","){const P=d[d.length-1];typeof P=="number"?d[d.length-1]=P+1:(k=!0,d[d.length-1]=""),c=void 0}}})}catch(C){if(C!==i)throw C}return{path:d,previousNode:c,isAtPropertyKey:k,matches:C=>{let T=0;for(let O=0;T<C.length&&O<d.length;O++)if(C[T]===d[O]||C[T]==="*")T++;else if(C[T]!=="**")return!1;return T===C.length}}}function p(t,o=[],d=D.DEFAULT){let i=null,c=[];const u=[];function k(C){Array.isArray(c)?c.push(C):i!==null&&(c[i]=C)}return m(t,{onObjectBegin:()=>{const C={};k(C),u.push(c),c=C,i=null},onObjectProperty:C=>{i=C},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{const C=[];k(C),u.push(c),c=C,i=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:k,onError:(C,T,O)=>{o.push({error:C,offset:T,length:O})}},d),c[0]}function b(t,o=[],d=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(C){i.type==="property"&&(i.length=C-i.offset,i=i.parent)}function u(C){return i.children.push(C),C}m(t,{onObjectBegin:C=>{i=u({type:"object",offset:C,length:-1,parent:i,children:[]})},onObjectProperty:(C,T,O)=>{i=u({type:"property",offset:T,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:C,offset:T,length:O,parent:i})},onObjectEnd:(C,T)=>{i.length=C+T-i.offset,i=i.parent,c(C+T)},onArrayBegin:(C,T)=>{i=u({type:"array",offset:C,length:-1,parent:i,children:[]})},onArrayEnd:(C,T)=>{i.length=C+T-i.offset,i=i.parent,c(C+T)},onLiteralValue:(C,T,O)=>{u({type:l(C),offset:T,length:O,parent:i,value:C}),c(T+O)},onSeparator:(C,T,O)=>{i.type==="property"&&(C===":"?i.colonOffset=T:C===","&&c(T))},onError:(C,T,O)=>{o.push({error:C,offset:T,length:O})}},d);const I=i.children[0];return I&&delete I.parent,I}function a(t,o){if(!t)return;let d=t;for(const i of o)if(typeof i=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let c=!1;for(const u of d.children)if(Array.isArray(u.children)&&u.children[0].value===i){d=u.children[1],c=!0;break}if(!c)return}else{const c=i;if(d.type!=="array"||c<0||!Array.isArray(d.children)||c>=d.children.length)return;d=d.children[c]}return d}function f(t){if(!t.parent||!t.parent.children)return[];const o=f(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;o.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&o.push(d)}return o}function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const o=Object.create(null);for(const d of t.children){const i=d.children[1];i&&(o[d.children[0].value]=h(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function g(t,o,d=!1){return o>=t.offset&&o<t.offset+t.length||d&&o===t.offset+t.length}function w(t,o,d=!1){if(g(t,o,d)){const i=t.children;if(Array.isArray(i))for(let c=0;c<i.length&&i[c].offset<=o;c++){const u=w(i[c],o,d);if(u)return u}return t}}function m(t,o,d=D.DEFAULT){const i=A(t,!1);function c(pe){return pe?()=>pe(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(pe){return pe?q=>pe(q,i.getTokenOffset(),i.getTokenLength()):()=>!0}const k=c(o.onObjectBegin),I=u(o.onObjectProperty),C=c(o.onObjectEnd),T=c(o.onArrayBegin),O=c(o.onArrayEnd),P=u(o.onLiteralValue),V=u(o.onSeparator),Q=c(o.onComment),ie=u(o.onError),re=d&&d.disallowComments,ne=d&&d.allowTrailingComma;function se(){for(;;){const pe=i.scan();switch(i.getTokenError()){case n.InvalidUnicode:Z(S.InvalidUnicode);break;case n.InvalidEscapeCharacter:Z(S.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:Z(S.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:re||Z(S.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:Z(S.UnexpectedEndOfString);break;case n.InvalidCharacter:Z(S.InvalidCharacter);break}switch(pe){case r.LineCommentTrivia:case r.BlockCommentTrivia:re?Z(S.InvalidCommentToken):Q();break;case r.Unknown:Z(S.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return pe}}}function Z(pe,q=[],ae=[]){if(ie(pe),q.length+ae.length>0){let Y=i.getToken();for(;Y!==r.EOF;){if(q.indexOf(Y)!==-1){se();break}else if(ae.indexOf(Y)!==-1)break;Y=se()}}}function ee(pe){const q=i.getTokenValue();return pe?P(q):I(q),se(),!0}function ue(){switch(i.getToken()){case r.NumericLiteral:{let pe=0;try{pe=JSON.parse(i.getTokenValue()),typeof pe!="number"&&(Z(S.InvalidNumberFormat),pe=0)}catch{Z(S.InvalidNumberFormat)}P(pe);break}case r.NullKeyword:P(null);break;case r.TrueKeyword:P(!0);break;case r.FalseKeyword:P(!1);break;default:return!1}return se(),!0}function j(){return i.getToken()!==r.StringLiteral?(Z(S.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(ee(!1),i.getToken()===r.ColonToken?(V(":"),se(),le()||Z(S.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):Z(S.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function B(){k(),se();let pe=!1;for(;i.getToken()!==r.CloseBraceToken&&i.getToken()!==r.EOF;){if(i.getToken()===r.CommaToken){if(pe||Z(S.ValueExpected,[],[]),V(","),se(),i.getToken()===r.CloseBraceToken&&ne)break}else pe&&Z(S.CommaExpected,[],[]);j()||Z(S.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),pe=!0}return C(),i.getToken()!==r.CloseBraceToken?Z(S.CloseBraceExpected,[r.CloseBraceToken],[]):se(),!0}function oe(){T(),se();let pe=!1;for(;i.getToken()!==r.CloseBracketToken&&i.getToken()!==r.EOF;){if(i.getToken()===r.CommaToken){if(pe||Z(S.ValueExpected,[],[]),V(","),se(),i.getToken()===r.CloseBracketToken&&ne)break}else pe&&Z(S.CommaExpected,[],[]);le()||Z(S.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),pe=!0}return O(),i.getToken()!==r.CloseBracketToken?Z(S.CloseBracketExpected,[r.CloseBracketToken],[]):se(),!0}function le(){switch(i.getToken()){case r.OpenBracketToken:return oe();case r.OpenBraceToken:return B();case r.StringLiteral:return ee(!0);default:return ue()}}return se(),i.getToken()===r.EOF?d.allowEmptyContent?!0:(Z(S.ValueExpected,[],[]),!1):le()?(i.getToken()!==r.EOF&&Z(S.EndOfFileExpected,[],[]),!0):(Z(S.ValueExpected,[],[]),!1)}function $(t,o){const d=A(t),i=[];let c,u=0,k;do switch(k=d.getPosition(),c=d.scan(),c){case r.LineCommentTrivia:case r.BlockCommentTrivia:case r.EOF:u!==k&&i.push(t.substring(u,k)),o!==void 0&&i.push(d.getTokenValue().replace(/[^\r\n]/g,o)),u=d.getPosition();break}while(c!==r.EOF);return i.join("")}function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[158],Se([1,0,44]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=r,e.$1n=S,e.$2n=R,e.$3n=v;function r(s,E,y){let p,b,a,f,h;if(E){for(f=E.offset,h=f+E.length,a=f;a>0&&!v(s,a-1);)a--;let k=h;for(;k<s.length&&!v(s,k);)k++;b=s.substring(a,k),p=A(b,y)}else b=s,p=0,a=0,f=0,h=s.length;const g=R(y,s);let w=!1,m=0,$;y.insertSpaces?$=D(" ",y.tabSize||4):$="	";const l=(0,n.$Nn)(b,!1);let t=!1;function o(){return g+D($,p+m)}function d(){let k=l.scan();for(w=!1;k===n.SyntaxKind.Trivia||k===n.SyntaxKind.LineBreakTrivia;)w=w||k===n.SyntaxKind.LineBreakTrivia,k=l.scan();return t=k===n.SyntaxKind.Unknown||l.getTokenError()!==n.ScanError.None,k}const i=[];function c(k,I,C){!t&&I<h&&C>f&&s.substring(I,C)!==k&&i.push({offset:I,length:C-I,content:k})}let u=d();if(u!==n.SyntaxKind.EOF){const k=l.getTokenOffset()+a,I=D($,p);c(I,a,k)}for(;u!==n.SyntaxKind.EOF;){let k=l.getTokenOffset()+l.getTokenLength()+a,I=d(),C="";for(;!w&&(I===n.SyntaxKind.LineCommentTrivia||I===n.SyntaxKind.BlockCommentTrivia);){const O=l.getTokenOffset()+a;c(" ",k,O),k=l.getTokenOffset()+l.getTokenLength()+a,C=I===n.SyntaxKind.LineCommentTrivia?o():"",I=d()}if(I===n.SyntaxKind.CloseBraceToken)u!==n.SyntaxKind.OpenBraceToken&&(m--,C=o());else if(I===n.SyntaxKind.CloseBracketToken)u!==n.SyntaxKind.OpenBracketToken&&(m--,C=o());else{switch(u){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:m++,C=o();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:C=o();break;case n.SyntaxKind.BlockCommentTrivia:w?C=o():C=" ";break;case n.SyntaxKind.ColonToken:C=" ";break;case n.SyntaxKind.StringLiteral:if(I===n.SyntaxKind.ColonToken){C="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:I===n.SyntaxKind.LineCommentTrivia||I===n.SyntaxKind.BlockCommentTrivia?C=" ":I!==n.SyntaxKind.CommaToken&&I!==n.SyntaxKind.EOF&&(t=!0);break;case n.SyntaxKind.Unknown:t=!0;break}w&&(I===n.SyntaxKind.LineCommentTrivia||I===n.SyntaxKind.BlockCommentTrivia)&&(C=o())}const T=l.getTokenOffset()+a;c(C,k,T),u=I}return i}function S(s,E){const y=JSON.stringify(s,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?y.replace(/\r\n|\r|\n/g,E.eol):y}function D(s,E){let y="";for(let p=0;p<E;p++)y+=s;return y}function A(s,E){let y=0,p=0;const b=E.tabSize||4;for(;y<s.length;){const a=s.charAt(y);if(a===" ")p++;else if(a==="	")p+=b;else break;y++}return Math.floor(p/b)}function R(s,E){for(let y=0;y<E.length;y++){const p=E.charAt(y);if(p==="\r")return y+1<E.length&&E.charAt(y+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return s&&s.eol||`
`}function v(s,E){return`\r
`.indexOf(s.charAt(E))!==-1}}),define(Ee[159],Se([1,0,44,158]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=S,e.$5n=D,e.$6n=A,e.$7n=R,e.$8n=v;function S(s,E,y){return D(s,E,void 0,y)}function D(s,E,y,p,b){const a=E.slice(),f=[],h=(0,n.$Qn)(s,f);let g,w;for(;a.length>0&&(w=a.pop(),g=(0,n.$Rn)(h,a),g===void 0&&y!==void 0);)typeof w=="string"?y={[w]:y}:y=[y];if(g)if(g.type==="object"&&typeof w=="string"&&Array.isArray(g.children)){const m=(0,n.$Rn)(g,[w]);if(m!==void 0)if(y===void 0){if(!m.parent)throw new Error("Malformed AST");const $=g.children.indexOf(m.parent);let l,t=m.parent.offset+m.parent.length;if($>0){const o=g.children[$-1];l=o.offset+o.length}else l=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return A(s,{offset:l,length:t-l,content:""},p)}else return A(s,{offset:m.offset,length:m.length,content:JSON.stringify(y)},p);else{if(y===void 0)return[];const $=`${JSON.stringify(w)}: ${JSON.stringify(y)}`,l=b?b(g.children.map(o=>o.children[0].value)):g.children.length;let t;if(l>0){const o=g.children[l-1];t={offset:o.offset+o.length,length:0,content:","+$}}else g.children.length===0?t={offset:g.offset+1,length:0,content:$}:t={offset:g.offset+1,length:0,content:$+","};return A(s,t,p)}}else if(g.type==="array"&&typeof w=="number"&&Array.isArray(g.children))if(y!==void 0){const m=`${JSON.stringify(y)}`;let $;if(g.children.length===0||w===0)$={offset:g.offset+1,length:0,content:g.children.length===0?m:m+","};else{const l=w===-1||w>g.children.length?g.children.length:w,t=g.children[l-1];$={offset:t.offset+t.length,length:0,content:","+m}}return A(s,$,p)}else{const m=w,$=g.children[m];let l;if(g.children.length===1)l={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===m){const t=g.children[m-1],o=t.offset+t.length,d=g.offset+g.length;l={offset:o,length:d-2-o,content:""}}else l={offset:$.offset,length:g.children[m+1].offset-$.offset,content:""};return A(s,l,p)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${g.type}`);else return y===void 0?[]:A(s,{offset:h?h.offset:0,length:h?h.length:0,content:JSON.stringify(y)},p)}function A(s,E,y){let p=R(s,E),b=E.offset,a=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;b>0&&!(0,r.$3n)(p,b-1);)b--;for(;a<p.length&&!(0,r.$3n)(p,a);)a++}const f=(0,r.$Zn)(p,{offset:b,length:a-b},y);for(let g=f.length-1;g>=0;g--){const w=f[g];p=R(p,w),b=Math.min(b,w.offset),a=Math.max(a,w.offset+w.length),a+=w.content.length-w.length}const h=s.length-(p.length-a)-b;return[{offset:b,length:h,content:p.substring(b,a)}]}function R(s,E){return s.substring(0,E.offset)+E.content+s.substring(E.offset+E.length)}function v(s,E){const y=E.slice(0).sort((b,a)=>{const f=b.offset-a.offset;return f===0?b.length-a.length:f});let p=s.length;for(let b=y.length-1;b>=0;b--){const a=y[b];if(a.offset+a.length<=p)s=R(s,a);else throw new Error("Overlapping edit");p=a.offset}return s}}),define(Ee[65],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(Ee[79],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(D){this.element=D,this.next=n.Undefined,this.prev=n.Undefined}}class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let D=this.a;for(;D!==n.Undefined;){const A=D.next;D.prev=n.Undefined,D.next=n.Undefined,D=A}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,A){const R=new n(D);if(this.a===n.Undefined)this.a=R,this.b=R;else if(A){const s=this.b;this.b=R,R.prev=s,s.next=R}else{const s=this.a;this.a=R,R.next=s,s.prev=R}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(R))}}shift(){if(this.a!==n.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==n.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==n.Undefined&&D.next!==n.Undefined){const A=D.prev;A.next=D.next,D.next.prev=A}else D.prev===n.Undefined&&D.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):D.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):D.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==n.Undefined;)yield D.element,D=D.next}}e.$5c=r}),define(Ee[26],Se([1,0]),function(fe,e){"use strict";var n,r,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=D,e.$yc=A,e.$zc=R,e.$Ic=$;function D(l,t,o){let d=l.get(t);return d===void 0&&(d=o,l.set(t,d)),d}function A(l){const t=[];return l.forEach((o,d)=>{t.push(`${d} => ${o}`)}),`Map(${l.size}) {${t.join(", ")}}`}function R(l){const t=[];return l.forEach(o=>{t.push(o)}),`Set(${l.size}) {${t.join(", ")}}`}class v{constructor(t,o){this.uri=t,this.value=o}}function s(l){return Array.isArray(l)}class E{static{this.c=t=>t.toString()}constructor(t,o){if(this[n]="ResourceMap",t instanceof E)this.d=new Map(t.d),this.e=o??E.c;else if(s(t)){this.d=new Map,this.e=o??E.c;for(const[d,i]of t)this.set(d,i)}else this.d=new Map,this.e=t??E.c}set(t,o){return this.d.set(this.e(t),new v(t,o)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[d,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=E;class y{constructor(t,o){this[r]="ResourceSet",!t||typeof t=="function"?this.c=new E(t):(this.c=new E(o),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,o){this.c.forEach((d,i)=>t.call(o,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=y;var p;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class b{constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,o=p.None){const d=this.c.get(t);if(d)return o!==p.None&&this.m(d,o),d.value}set(t,o,d=p.None){let i=this.c.get(t);if(i)i.value=o,d!==p.None&&this.m(i,d);else{switch(i={key:t,value:o,next:void 0,previous:void 0},d){case p.None:this.k(i);break;case p.AsOld:this.j(i);break;case p.AsNew:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this.c.get(t);if(o)return this.c.delete(t),this.l(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,o){const d=this.g;let i=this.d;for(;i;){if(o?t.bind(o)(i.value,i.key,this):t(i.value,i.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,o=this.g;let d=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const c={value:d.key,done:!1};return d=d.next,c}else return{value:void 0,done:!0}}};return i}values(){const t=this,o=this.g;let d=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const c={value:d.value,done:!1};return d=d.next,c}else return{value:void 0,done:!0}}};return i}entries(){const t=this,o=this.g;let d=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const c={value:[d.key,d.value],done:!1};return d=d.next,c}else return{value:void 0,done:!0}}};return i}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.d,d=this.size;for(;o&&d>t;)this.c.delete(o.key),o=o.next,d--;this.d=o,this.f=d,o&&(o.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.e,d=this.size;for(;o&&d>t;)this.c.delete(o.key),o=o.previous,d--;this.e=o,this.f=d,o&&(o.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const o=t.next,d=t.previous;if(!o||!d)throw new Error("Invalid list");o.previous=d,d.next=o}t.next=void 0,t.previous=void 0,this.g++}m(t,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==p.AsOld&&o!==p.AsNew)){if(o===p.AsOld){if(t===this.d)return;const d=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(d.previous=i,i.next=d),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(o===p.AsNew){if(t===this.e)return;const d=t.next,i=t.previous;t===this.d?(d.previous=void 0,this.d=d):(d.previous=i,i.next=d),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((o,d)=>{t.push([d,o])}),t}fromJSON(t){this.clear();for(const[o,d]of t)this.set(o,d)}}e.$Cc=b;class a extends b{constructor(t,o=1){super(),this.n=t,this.o=Math.min(Math.max(0,o),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,o=p.AsNew){return super.get(t,o)}peek(t){return super.get(t,p.None)}set(t,o){return super.set(t,o,p.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class f extends a{constructor(t,o=1){super(t,o)}q(t){this.h(t)}set(t,o){return super.set(t,o),this.p(),this}}e.$Dc=f;class h extends a{constructor(t,o=1){super(t,o)}q(t){this.i(t)}set(t,o){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,o),this}}e.$Ec=h;class g{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let o=this.c.get(t)||0;return o===0?!1:(o--,o===0?this.c.delete(t):this.c.set(t,o),!0)}has(t){return this.c.has(t)}}e.$Fc=g;class w{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[o,d]of t)this.set(o,d)}clear(){this.c.clear(),this.d.clear()}set(t,o){this.c.set(t,o),this.d.set(o,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const o=this.c.get(t);return o===void 0?!1:(this.c.delete(t),this.d.delete(o),!0)}forEach(t,o){this.c.forEach((d,i)=>{t.call(o,d,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=w;class m{constructor(){this.c=new Map}add(t,o){let d=this.c.get(t);d||(d=new Set,this.c.set(t,d)),d.add(o)}delete(t,o){const d=this.c.get(t);d&&(d.delete(o),d.size===0&&this.c.delete(t))}forEach(t,o){const d=this.c.get(t);d&&d.forEach(o)}get(t){const o=this.c.get(t);return o||new Set}}e.$Hc=m;function $(l,t){if(l===t)return!0;if(l.size!==t.size)return!1;for(const[o,d]of l)if(!t.has(o)||t.get(o)!==d)return!1;for(const[o]of t)if(!l.has(o))return!1;return!0}}),define(Ee[2],Se([1,0,18,156,26,78,40]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=E,e.$Lc=y,e.$Mc=p,e.$Nc=f,e.$Oc=h,e.$Pc=g,e.$Qc=w,e.$Rc=m,e.$Sc=$,e.$3c=C;const R=!1;let v=null;class s{constructor(){this.b=new Map}static{this.a=0}c(P){let V=this.b.get(P);return V||(V={parent:null,source:null,isSingleton:!1,value:P,idx:s.a++},this.b.set(P,V)),V}trackDisposable(P){const V=this.c(P);V.source||(V.source=new Error().stack)}setParent(P,V){const Q=this.c(P);Q.parent=V}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,V){const Q=V.get(P);if(Q)return Q;const ie=P.parent?this.f(this.c(P.parent),V):P;return V.set(P,ie),ie}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,Q])=>Q.source!==null&&!this.f(Q,P).isSingleton).flatMap(([Q])=>Q)}computeLeakingDisposables(P=10,V){let Q;if(V)Q=V;else{const Z=new Map,ee=[...this.b.values()].filter(j=>j.source!==null&&!this.f(j,Z).isSingleton);if(ee.length===0)return;const ue=new Set(ee.map(j=>j.value));if(Q=ee.filter(j=>!(j.parent&&ue.has(j.parent))),Q.length===0)throw new Error("There are cyclic diposable chains!")}if(!Q)return;function ie(Z){function ee(j,B){for(;j.length>0&&B.some(oe=>typeof oe=="string"?oe===j[0]:j[0].match(oe));)j.shift()}const ue=Z.source.split(`
`).map(j=>j.trim().replace("at ","")).filter(j=>j!=="");return ee(ue,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ue.reverse()}const re=new S.$Hc;for(const Z of Q){const ee=ie(Z);for(let ue=0;ue<=ee.length;ue++)re.add(ee.slice(0,ue).join(`
`),Z)}Q.sort((0,n.$6b)(Z=>Z.idx,n.$8b));let ne="",se=0;for(const Z of Q.slice(0,P)){se++;const ee=ie(Z),ue=[];for(let j=0;j<ee.length;j++){let B=ee[j];B=`(shared with ${re.get(ee.slice(0,j+1).join(`
`)).size}/${Q.length} leaks) at ${B}`;const le=re.get(ee.slice(0,j).join(`
`)),pe=(0,r.$K)([...le].map(q=>ie(q)[j]),q=>q);delete pe[ee[j]];for(const[q,ae]of Object.entries(pe))ue.unshift(`    - stacktraces of ${ae.length} other leaks continue with ${q}`);ue.unshift(B)}ne+=`


==================== Leaking disposable ${se}/${Q.length}: ${Z.value.constructor.name} ====================
${ue.join(`
`)}
============================================================

`}return Q.length>P&&(ne+=`


... and ${Q.length-P} more leaking disposables

`),{leaks:Q,details:ne}}}e.$Jc=s;function E(O){v=O}if(R){const O="__is_disposable_tracked__";E(new class{trackDisposable(P){const V=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[O]||console.log(V)},3e3)}setParent(P,V){if(P&&P!==t.None)try{P[O]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[O]=!0}catch{}}markAsSingleton(P){}})}function y(O){return v?.trackDisposable(O),O}function p(O){v?.markAsDisposed(O)}function b(O,P){v?.setParent(O,P)}function a(O,P){if(v)for(const V of O)v.setParent(V,P)}function f(O){return v?.markAsSingleton(O),O}function h(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function g(O){if(A.Iterable.is(O)){const P=[];for(const V of O)if(V)try{V.dispose()}catch(Q){P.push(Q)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function w(O){for(const P of O)h(P)&&P.dispose();return[]}function m(...O){const P=$(()=>g(O));return a(O,P),P}function $(O){const P=y({dispose:(0,D.$db)(()=>{p(P),O()})});return P}class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return b(P,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),b(P,null))}}e.$Tc=l;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,y(this),b(this.q,this)}dispose(){p(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Uc=t;class o{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&b(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&b(P,null),P}}e.$Vc=o;class d{constructor(P){this.a=new o,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class i{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=i;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(P){let V=P;return this.unset=()=>V=void 0,this.isset=()=>V!==void 0,this.dispose=()=>{V&&(V(),V=void 0,p(this))},this}}e.$Yc=c;class u{constructor(){this.a=new Map}acquire(P,...V){let Q=this.a.get(P);Q||(Q={counter:0,object:this.b(P,...V)},this.a.set(P,Q));const{object:ie}=Q,re=(0,D.$db)(()=>{--Q.counter===0&&(this.c(P,Q.object),this.a.delete(P))});return Q.counter++,{object:ie,dispose:re}}}e.$Zc=u;class k{constructor(P){this.a=P}async acquire(P,...V){const Q=this.a.acquire(P,...V);try{return{object:await Q.object,dispose:()=>Q.dispose()}}catch(ie){throw Q.dispose(),ie}}}e.$1c=k;class I{constructor(P){this.object=P}dispose(){}}e.$2c=I;function C(O){const P=new l;try{O(P)}finally{P.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,V,Q=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Q||this.a.get(P)?.dispose(),this.a.set(P,V)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}deleteAndLeak(P){const V=this.a.get(P);return this.a.delete(P),V}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=T}),function(fe,e){typeof define=="function"&&define.amd?define(Ee[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(U,J){for(var x=0;x<J.length;x++){var M=J[x];M.enumerable=M.enumerable||!1,M.configurable=!0,"value"in M&&(M.writable=!0),Object.defineProperty(U,M.key,M)}}function n(U,J,x){return J&&e(U.prototype,J),x&&e(U,x),Object.defineProperty(U,"prototype",{writable:!1}),U}function r(U,J){if(U){if(typeof U=="string")return S(U,J);var x=Object.prototype.toString.call(U).slice(8,-1);if(x==="Object"&&U.constructor&&(x=U.constructor.name),x==="Map"||x==="Set")return Array.from(U);if(x==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(x))return S(U,J)}}function S(U,J){(J==null||J>U.length)&&(J=U.length);for(var x=0,M=new Array(J);x<J;x++)M[x]=U[x];return M}function D(U,J){var x=typeof Symbol<"u"&&U[Symbol.iterator]||U["@@iterator"];if(x)return(x=x.call(U)).next.bind(x);if(Array.isArray(U)||(x=r(U))||J&&U&&typeof U.length=="number"){x&&(U=x);var M=0;return function(){return M>=U.length?{done:!0}:{done:!1,value:U[M++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=A();function R(U){fe.defaults=U}var v=/[&<>"']/,s=/[&<>"']/g,E=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(J){return p[J]};function a(U,J){if(J){if(v.test(U))return U.replace(s,b)}else if(E.test(U))return U.replace(y,b);return U}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(U){return U.replace(f,function(J,x){return x=x.toLowerCase(),x==="colon"?":":x.charAt(0)==="#"?x.charAt(1)==="x"?String.fromCharCode(parseInt(x.substring(2),16)):String.fromCharCode(+x.substring(1)):""})}var g=/(^|[^\[])\^/g;function w(U,J){U=typeof U=="string"?U:U.source,J=J||"";var x={replace:function(G,te){return te=te.source||te,te=te.replace(g,"$1"),U=U.replace(G,te),x},getRegex:function(){return new RegExp(U,J)}};return x}var m=/[^\w:]/g,$=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(U,J,x){if(U){var M;try{M=decodeURIComponent(h(x)).replace(m,"").toLowerCase()}catch{return null}if(M.indexOf("javascript:")===0||M.indexOf("vbscript:")===0||M.indexOf("data:")===0)return null}J&&!$.test(x)&&(x=c(J,x));try{x=encodeURI(x).replace(/%25/g,"%")}catch{return null}return x}var t={},o=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(U,J){t[" "+U]||(o.test(U)?t[" "+U]=U+"/":t[" "+U]=C(U,"/",!0)),U=t[" "+U];var x=U.indexOf(":")===-1;return J.substring(0,2)==="//"?x?J:U.replace(d,"$1")+J:J.charAt(0)==="/"?x?J:U.replace(i,"$1")+J:U+J}var u={exec:function(){}};function k(U){for(var J=1,x,M;J<arguments.length;J++){x=arguments[J];for(M in x)Object.prototype.hasOwnProperty.call(x,M)&&(U[M]=x[M])}return U}function I(U,J){var x=U.replace(/\|/g,function(te,he,ke){for(var Ne=!1,me=he;--me>=0&&ke[me]==="\\";)Ne=!Ne;return Ne?"|":" |"}),M=x.split(/ \|/),G=0;if(M[0].trim()||M.shift(),M.length>0&&!M[M.length-1].trim()&&M.pop(),M.length>J)M.splice(J);else for(;M.length<J;)M.push("");for(;G<M.length;G++)M[G]=M[G].trim().replace(/\\\|/g,"|");return M}function C(U,J,x){var M=U.length;if(M===0)return"";for(var G=0;G<M;){var te=U.charAt(M-G-1);if(te===J&&!x)G++;else if(te!==J&&x)G++;else break}return U.slice(0,M-G)}function T(U,J){if(U.indexOf(J[1])===-1)return-1;for(var x=U.length,M=0,G=0;G<x;G++)if(U[G]==="\\")G++;else if(U[G]===J[0])M++;else if(U[G]===J[1]&&(M--,M<0))return G;return-1}function O(U){U&&U.sanitize&&!U.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(U,J){if(J<1)return"";for(var x="";J>1;)J&1&&(x+=U),J>>=1,U+=U;return x+U}function V(U,J,x,M){var G=J.href,te=J.title?a(J.title):null,he=U[1].replace(/\\([\[\]])/g,"$1");if(U[0].charAt(0)!=="!"){M.state.inLink=!0;var ke={type:"link",raw:x,href:G,title:te,text:he,tokens:M.inlineTokens(he)};return M.state.inLink=!1,ke}return{type:"image",raw:x,href:G,title:te,text:a(he)}}function Q(U,J){var x=U.match(/^(\s+)(?:```)/);if(x===null)return J;var M=x[1];return J.split(`
`).map(function(G){var te=G.match(/^\s+/);if(te===null)return G;var he=te[0];return he.length>=M.length?G.slice(M.length):G}).join(`
`)}var ie=function(){function U(x){this.options=x||fe.defaults}var J=U.prototype;return J.space=function(M){var G=this.rules.block.newline.exec(M);if(G&&G[0].length>0)return{type:"space",raw:G[0]}},J.code=function(M){var G=this.rules.block.code.exec(M);if(G){var te=G[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:G[0],codeBlockStyle:"indented",text:this.options.pedantic?te:C(te,`
`)}}},J.fences=function(M){var G=this.rules.block.fences.exec(M);if(G){var te=G[0],he=Q(te,G[3]||"");return{type:"code",raw:te,lang:G[2]?G[2].trim():G[2],text:he}}},J.heading=function(M){var G=this.rules.block.heading.exec(M);if(G){var te=G[2].trim();if(/#$/.test(te)){var he=C(te,"#");(this.options.pedantic||!he||/ $/.test(he))&&(te=he.trim())}return{type:"heading",raw:G[0],depth:G[1].length,text:te,tokens:this.lexer.inline(te)}}},J.hr=function(M){var G=this.rules.block.hr.exec(M);if(G)return{type:"hr",raw:G[0]}},J.blockquote=function(M){var G=this.rules.block.blockquote.exec(M);if(G){var te=G[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:G[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},J.list=function(M){var G=this.rules.block.list.exec(M);if(G){var te,he,ke,Ne,me,be,Ae,Le,de,Ie,Re,Me,He=G[1].trim(),Ke=He.length>1,We={type:"list",raw:"",ordered:Ke,start:Ke?+He.slice(0,-1):"",loose:!1,items:[]};He=Ke?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=Ke?He:"[*+-]");for(var Ve=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");M&&(Me=!1,!(!(G=Ve.exec(M))||this.rules.block.hr.test(M)));){if(te=G[0],M=M.substring(te.length),Le=G[2].split(`
`,1)[0],de=M.split(`
`,1)[0],this.options.pedantic?(Ne=2,Re=Le.trimLeft()):(Ne=G[2].search(/[^ ]/),Ne=Ne>4?1:Ne,Re=Le.slice(Ne),Ne+=G[1].length),be=!1,!Le&&/^ *$/.test(de)&&(te+=de+`
`,M=M.substring(de.length+1),Me=!0),!Me)for(var Ze=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}#");M&&(Ie=M.split(`
`,1)[0],Le=Ie,this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Le)||ot.test(Le)||Ze.test(Le)||nt.test(M)));){if(Le.search(/[^ ]/)>=Ne||!Le.trim())Re+=`
`+Le.slice(Ne);else if(!be)Re+=`
`+Le;else break;!be&&!Le.trim()&&(be=!0),te+=Ie+`
`,M=M.substring(Ie.length+1)}We.loose||(Ae?We.loose=!0:/\n *\n *$/.test(te)&&(Ae=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(Re),he&&(ke=he[0]!=="[ ] ",Re=Re.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:te,task:!!he,checked:ke,loose:!1,text:Re}),We.raw+=te}We.items[We.items.length-1].raw=te.trimRight(),We.items[We.items.length-1].text=Re.trimRight(),We.raw=We.raw.trimRight();var tt=We.items.length;for(me=0;me<tt;me++){this.lexer.state.top=!1,We.items[me].tokens=this.lexer.blockTokens(We.items[me].text,[]);var _e=We.items[me].tokens.filter(function(Qe){return Qe.type==="space"}),Xe=_e.every(function(Qe){for(var $e=Qe.raw.split(""),Oe=0,ve=D($e),ye;!(ye=ve()).done;){var X=ye.value;if(X===`
`&&(Oe+=1),Oe>1)return!0}return!1});!We.loose&&_e.length&&Xe&&(We.loose=!0,We.items[me].loose=!0)}return We}},J.html=function(M){var G=this.rules.block.html.exec(M);if(G){var te={type:"html",raw:G[0],pre:!this.options.sanitizer&&(G[1]==="pre"||G[1]==="script"||G[1]==="style"),text:G[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(G[0]):a(G[0]);te.type="paragraph",te.text=he,te.tokens=this.lexer.inline(he)}return te}},J.def=function(M){var G=this.rules.block.def.exec(M);if(G){G[3]&&(G[3]=G[3].substring(1,G[3].length-1));var te=G[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:G[0],href:G[2],title:G[3]}}},J.table=function(M){var G=this.rules.block.table.exec(M);if(G){var te={type:"table",header:I(G[1]).map(function(Ae){return{text:Ae}}),align:G[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:G[3]&&G[3].trim()?G[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=G[0];var he=te.align.length,ke,Ne,me,be;for(ke=0;ke<he;ke++)/^ *-+: *$/.test(te.align[ke])?te.align[ke]="right":/^ *:-+: *$/.test(te.align[ke])?te.align[ke]="center":/^ *:-+ *$/.test(te.align[ke])?te.align[ke]="left":te.align[ke]=null;for(he=te.rows.length,ke=0;ke<he;ke++)te.rows[ke]=I(te.rows[ke],te.header.length).map(function(Ae){return{text:Ae}});for(he=te.header.length,Ne=0;Ne<he;Ne++)te.header[Ne].tokens=this.lexer.inline(te.header[Ne].text);for(he=te.rows.length,Ne=0;Ne<he;Ne++)for(be=te.rows[Ne],me=0;me<be.length;me++)be[me].tokens=this.lexer.inline(be[me].text);return te}}},J.lheading=function(M){var G=this.rules.block.lheading.exec(M);if(G)return{type:"heading",raw:G[0],depth:G[2].charAt(0)==="="?1:2,text:G[1],tokens:this.lexer.inline(G[1])}},J.paragraph=function(M){var G=this.rules.block.paragraph.exec(M);if(G){var te=G[1].charAt(G[1].length-1)===`
`?G[1].slice(0,-1):G[1];return{type:"paragraph",raw:G[0],text:te,tokens:this.lexer.inline(te)}}},J.text=function(M){var G=this.rules.block.text.exec(M);if(G)return{type:"text",raw:G[0],text:G[0],tokens:this.lexer.inline(G[0])}},J.escape=function(M){var G=this.rules.inline.escape.exec(M);if(G)return{type:"escape",raw:G[0],text:a(G[1])}},J.tag=function(M){var G=this.rules.inline.tag.exec(M);if(G)return!this.lexer.state.inLink&&/^<a /i.test(G[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(G[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(G[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(G[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:G[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):a(G[0]):G[0]}},J.link=function(M){var G=this.rules.inline.link.exec(M);if(G){var te=G[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var he=C(te.slice(0,-1),"\\");if((te.length-he.length)%2===0)return}else{var ke=T(G[2],"()");if(ke>-1){var Ne=G[0].indexOf("!")===0?5:4,me=Ne+G[1].length+ke;G[2]=G[2].substring(0,ke),G[0]=G[0].substring(0,me).trim(),G[3]=""}}var be=G[2],Ae="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(be);Le&&(be=Le[1],Ae=Le[3])}else Ae=G[3]?G[3].slice(1,-1):"";return be=be.trim(),/^</.test(be)&&(this.options.pedantic&&!/>$/.test(te)?be=be.slice(1):be=be.slice(1,-1)),V(G,{href:be&&be.replace(this.rules.inline._escapes,"$1"),title:Ae&&Ae.replace(this.rules.inline._escapes,"$1")},G[0],this.lexer)}},J.reflink=function(M,G){var te;if((te=this.rules.inline.reflink.exec(M))||(te=this.rules.inline.nolink.exec(M))){var he=(te[2]||te[1]).replace(/\s+/g," ");if(he=G[he.toLowerCase()],!he||!he.href){var ke=te[0].charAt(0);return{type:"text",raw:ke,text:ke}}return V(te,he,te[0],this.lexer)}},J.emStrong=function(M,G,te){te===void 0&&(te="");var he=this.rules.inline.emStrong.lDelim.exec(M);if(he&&!(he[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=he[1]||he[2]||"";if(!ke||ke&&(te===""||this.rules.inline.punctuation.exec(te))){var Ne=he[0].length-1,me,be,Ae=Ne,Le=0,de=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,G=G.slice(-1*M.length+Ne);(he=de.exec(G))!=null;)if(me=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!me){if(be=me.length,he[3]||he[4]){Ae+=be;continue}else if((he[5]||he[6])&&Ne%3&&!((Ne+be)%3)){Le+=be;continue}if(Ae-=be,!(Ae>0)){if(be=Math.min(be,be+Ae+Le),Math.min(Ne,be)%2){var Ie=M.slice(1,Ne+he.index+be);return{type:"em",raw:M.slice(0,Ne+he.index+be+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}var Re=M.slice(2,Ne+he.index+be-1);return{type:"strong",raw:M.slice(0,Ne+he.index+be+1),text:Re,tokens:this.lexer.inlineTokens(Re)}}}}}},J.codespan=function(M){var G=this.rules.inline.code.exec(M);if(G){var te=G[2].replace(/\n/g," "),he=/[^ ]/.test(te),ke=/^ /.test(te)&&/ $/.test(te);return he&&ke&&(te=te.substring(1,te.length-1)),te=a(te,!0),{type:"codespan",raw:G[0],text:te}}},J.br=function(M){var G=this.rules.inline.br.exec(M);if(G)return{type:"br",raw:G[0]}},J.del=function(M){var G=this.rules.inline.del.exec(M);if(G)return{type:"del",raw:G[0],text:G[2],tokens:this.lexer.inlineTokens(G[2])}},J.autolink=function(M,G){var te=this.rules.inline.autolink.exec(M);if(te){var he,ke;return te[2]==="@"?(he=a(this.options.mangle?G(te[1]):te[1]),ke="mailto:"+he):(he=a(te[1]),ke=he),{type:"link",raw:te[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},J.url=function(M,G){var te;if(te=this.rules.inline.url.exec(M)){var he,ke;if(te[2]==="@")he=a(this.options.mangle?G(te[0]):te[0]),ke="mailto:"+he;else{var Ne;do Ne=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Ne!==te[0]);he=a(te[0]),te[1]==="www."?ke="http://"+he:ke=he}return{type:"link",raw:te[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},J.inlineText=function(M,G){var te=this.rules.inline.text.exec(M);if(te){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):a(te[0]):te[0]:he=a(this.options.smartypants?G(te[0]):te[0]),{type:"text",raw:te[0],text:he}}},U}(),re={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};re._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,re._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,re.def=w(re.def).replace("label",re._label).replace("title",re._title).getRegex(),re.bullet=/(?:[*+-]|\d{1,9}[.)])/,re.listItemStart=w(/^( *)(bull) */).replace("bull",re.bullet).getRegex(),re.list=w(re.list).replace(/bull/g,re.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+re.def.source+")").getRegex(),re._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",re._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,re.html=w(re.html,"i").replace("comment",re._comment).replace("tag",re._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),re.paragraph=w(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.blockquote=w(re.blockquote).replace("paragraph",re.paragraph).getRegex(),re.normal=k({},re),re.gfm=k({},re.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),re.gfm.table=w(re.gfm.table).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.gfm.paragraph=w(re._paragraph).replace("hr",re.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",re.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",re._tag).getRegex(),re.pedantic=k({},re.normal,{html:w(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",re._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:w(re.normal._paragraph).replace("hr",re.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",re.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=w(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=w(re._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=w(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=w(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=w(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=w(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=w(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=w(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=w(ne.reflink).replace("label",ne._label).replace("ref",re._label).getRegex(),ne.nolink=w(ne.nolink).replace("ref",re._label).getRegex(),ne.reflinkSearch=w(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=k({},ne),ne.pedantic=k({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:w(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:w(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=k({},ne.normal,{escape:w(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ne.gfm.url=w(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=k({},ne.gfm,{br:w(ne.br).replace("{2,}","*").getRegex(),text:w(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function se(U){return U.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Z(U){var J="",x,M,G=U.length;for(x=0;x<G;x++)M=U.charCodeAt(x),Math.random()>.5&&(M="x"+M.toString(16)),J+="&#"+M+";";return J}var ee=function(){function U(x){this.tokens=[],this.tokens.links=Object.create(null),this.options=x||fe.defaults,this.options.tokenizer=this.options.tokenizer||new ie,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var M={block:re.normal,inline:ne.normal};this.options.pedantic?(M.block=re.pedantic,M.inline=ne.pedantic):this.options.gfm&&(M.block=re.gfm,this.options.breaks?M.inline=ne.breaks:M.inline=ne.gfm),this.tokenizer.rules=M}U.lex=function(M,G){var te=new U(G);return te.lex(M)},U.lexInline=function(M,G){var te=new U(G);return te.inlineTokens(M)};var J=U.prototype;return J.lex=function(M){M=M.replace(/\r\n|\r/g,`
`),this.blockTokens(M,this.tokens);for(var G;G=this.inlineQueue.shift();)this.inlineTokens(G.src,G.tokens);return this.tokens},J.blockTokens=function(M,G){var te=this;G===void 0&&(G=[]),this.options.pedantic?M=M.replace(/\t/g,"    ").replace(/^ +$/gm,""):M=M.replace(/^( *)(\t+)/gm,function(Ae,Le,de){return Le+"    ".repeat(de.length)});for(var he,ke,Ne,me;M;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ae){return(he=Ae.call({lexer:te},M,G))?(M=M.substring(he.raw.length),G.push(he),!0):!1}))){if(he=this.tokenizer.space(M)){M=M.substring(he.raw.length),he.raw.length===1&&G.length>0?G[G.length-1].raw+=`
`:G.push(he);continue}if(he=this.tokenizer.code(M)){M=M.substring(he.raw.length),ke=G[G.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):G.push(he);continue}if(he=this.tokenizer.fences(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.heading(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.hr(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.blockquote(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.list(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.html(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.def(M)){M=M.substring(he.raw.length),ke=G[G.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.lheading(M)){M=M.substring(he.raw.length),G.push(he);continue}if(Ne=M,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ae=1/0,Le=M.slice(1),de=void 0;te.options.extensions.startBlock.forEach(function(Ie){de=Ie.call({lexer:this},Le),typeof de=="number"&&de>=0&&(Ae=Math.min(Ae,de))}),Ae<1/0&&Ae>=0&&(Ne=M.substring(0,Ae+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Ne))){ke=G[G.length-1],me&&ke.type==="paragraph"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):G.push(he),me=Ne.length!==M.length,M=M.substring(he.raw.length);continue}if(he=this.tokenizer.text(M)){M=M.substring(he.raw.length),ke=G[G.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):G.push(he);continue}if(M){var be="Infinite loop on byte: "+M.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return this.state.top=!0,G},J.inline=function(M,G){return G===void 0&&(G=[]),this.inlineQueue.push({src:M,tokens:G}),G},J.inlineTokens=function(M,G){var te=this;G===void 0&&(G=[]);var he,ke,Ne,me=M,be,Ae,Le;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(be=this.tokenizer.rules.inline.reflinkSearch.exec(me))!=null;)de.includes(be[0].slice(be[0].lastIndexOf("[")+1,-1))&&(me=me.slice(0,be.index)+"["+P("a",be[0].length-2)+"]"+me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(be=this.tokenizer.rules.inline.blockSkip.exec(me))!=null;)me=me.slice(0,be.index)+"["+P("a",be[0].length-2)+"]"+me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(be=this.tokenizer.rules.inline.escapedEmSt.exec(me))!=null;)me=me.slice(0,be.index)+"++"+me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;M;)if(Ae||(Le=""),Ae=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Re){return(he=Re.call({lexer:te},M,G))?(M=M.substring(he.raw.length),G.push(he),!0):!1}))){if(he=this.tokenizer.escape(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.tag(M)){M=M.substring(he.raw.length),ke=G[G.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):G.push(he);continue}if(he=this.tokenizer.link(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.reflink(M,this.tokens.links)){M=M.substring(he.raw.length),ke=G[G.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):G.push(he);continue}if(he=this.tokenizer.emStrong(M,me,Le)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.codespan(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.br(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.del(M)){M=M.substring(he.raw.length),G.push(he);continue}if(he=this.tokenizer.autolink(M,Z)){M=M.substring(he.raw.length),G.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(M,Z))){M=M.substring(he.raw.length),G.push(he);continue}if(Ne=M,this.options.extensions&&this.options.extensions.startInline&&function(){var Re=1/0,Me=M.slice(1),He=void 0;te.options.extensions.startInline.forEach(function(Ke){He=Ke.call({lexer:this},Me),typeof He=="number"&&He>=0&&(Re=Math.min(Re,He))}),Re<1/0&&Re>=0&&(Ne=M.substring(0,Re+1))}(),he=this.tokenizer.inlineText(Ne,se)){M=M.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(Le=he.raw.slice(-1)),Ae=!0,ke=G[G.length-1],ke&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):G.push(he);continue}if(M){var Ie="Infinite loop on byte: "+M.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return G},n(U,null,[{key:"rules",get:function(){return{block:re,inline:ne}}}]),U}(),ue=function(){function U(x){this.options=x||fe.defaults}var J=U.prototype;return J.code=function(M,G,te){var he=(G||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(M,he);ke!=null&&ke!==M&&(te=!0,M=ke)}return M=M.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+a(he,!0)+'">'+(te?M:a(M,!0))+`</code></pre>
`:"<pre><code>"+(te?M:a(M,!0))+`</code></pre>
`},J.blockquote=function(M){return`<blockquote>
`+M+`</blockquote>
`},J.html=function(M){return M},J.heading=function(M,G,te,he){if(this.options.headerIds){var ke=this.options.headerPrefix+he.slug(te);return"<h"+G+' id="'+ke+'">'+M+"</h"+G+`>
`}return"<h"+G+">"+M+"</h"+G+`>
`},J.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},J.list=function(M,G,te){var he=G?"ol":"ul",ke=G&&te!==1?' start="'+te+'"':"";return"<"+he+ke+`>
`+M+"</"+he+`>
`},J.listitem=function(M){return"<li>"+M+`</li>
`},J.checkbox=function(M){return"<input "+(M?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},J.paragraph=function(M){return"<p>"+M+`</p>
`},J.table=function(M,G){return G&&(G="<tbody>"+G+"</tbody>"),`<table>
<thead>
`+M+`</thead>
`+G+`</table>
`},J.tablerow=function(M){return`<tr>
`+M+`</tr>
`},J.tablecell=function(M,G){var te=G.header?"th":"td",he=G.align?"<"+te+' align="'+G.align+'">':"<"+te+">";return he+M+("</"+te+`>
`)},J.strong=function(M){return"<strong>"+M+"</strong>"},J.em=function(M){return"<em>"+M+"</em>"},J.codespan=function(M){return"<code>"+M+"</code>"},J.br=function(){return this.options.xhtml?"<br/>":"<br>"},J.del=function(M){return"<del>"+M+"</del>"},J.link=function(M,G,te){if(M=l(this.options.sanitize,this.options.baseUrl,M),M===null)return te;var he='<a href="'+a(M)+'"';return G&&(he+=' title="'+G+'"'),he+=">"+te+"</a>",he},J.image=function(M,G,te){if(M=l(this.options.sanitize,this.options.baseUrl,M),M===null)return te;var he='<img src="'+M+'" alt="'+te+'"';return G&&(he+=' title="'+G+'"'),he+=this.options.xhtml?"/>":">",he},J.text=function(M){return M},U}(),j=function(){function U(){}var J=U.prototype;return J.strong=function(M){return M},J.em=function(M){return M},J.codespan=function(M){return M},J.del=function(M){return M},J.html=function(M){return M},J.text=function(M){return M},J.link=function(M,G,te){return""+te},J.image=function(M,G,te){return""+te},J.br=function(){return""},U}(),B=function(){function U(){this.seen={}}var J=U.prototype;return J.serialize=function(M){return M.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},J.getNextSafeSlug=function(M,G){var te=M,he=0;if(this.seen.hasOwnProperty(te)){he=this.seen[M];do he++,te=M+"-"+he;while(this.seen.hasOwnProperty(te))}return G||(this.seen[M]=he,this.seen[te]=0),te},J.slug=function(M,G){G===void 0&&(G={});var te=this.serialize(M);return this.getNextSafeSlug(te,G.dryrun)},U}(),oe=function(){function U(x){this.options=x||fe.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new j,this.slugger=new B}U.parse=function(M,G){var te=new U(G);return te.parse(M)},U.parseInline=function(M,G){var te=new U(G);return te.parseInline(M)};var J=U.prototype;return J.parse=function(M,G){G===void 0&&(G=!0);var te="",he,ke,Ne,me,be,Ae,Le,de,Ie,Re,Me,He,Ke,We,Ve,Ze,nt,it,ot,tt=M.length;for(he=0;he<tt;he++){if(Re=M[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(ot=this.options.extensions.renderers[Re.type].call({parser:this},Re),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Re.type))){te+=ot||"";continue}switch(Re.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(Re.tokens),Re.depth,h(this.parseInline(Re.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(Re.text,Re.lang,Re.escaped);continue}case"table":{for(de="",Le="",me=Re.header.length,ke=0;ke<me;ke++)Le+=this.renderer.tablecell(this.parseInline(Re.header[ke].tokens),{header:!0,align:Re.align[ke]});for(de+=this.renderer.tablerow(Le),Ie="",me=Re.rows.length,ke=0;ke<me;ke++){for(Ae=Re.rows[ke],Le="",be=Ae.length,Ne=0;Ne<be;Ne++)Le+=this.renderer.tablecell(this.parseInline(Ae[Ne].tokens),{header:!1,align:Re.align[Ne]});Ie+=this.renderer.tablerow(Le)}te+=this.renderer.table(de,Ie);continue}case"blockquote":{Ie=this.parse(Re.tokens),te+=this.renderer.blockquote(Ie);continue}case"list":{for(Me=Re.ordered,He=Re.start,Ke=Re.loose,me=Re.items.length,Ie="",ke=0;ke<me;ke++)Ve=Re.items[ke],Ze=Ve.checked,nt=Ve.task,We="",Ve.task&&(it=this.renderer.checkbox(Ze),Ke?Ve.tokens.length>0&&Ve.tokens[0].type==="paragraph"?(Ve.tokens[0].text=it+" "+Ve.tokens[0].text,Ve.tokens[0].tokens&&Ve.tokens[0].tokens.length>0&&Ve.tokens[0].tokens[0].type==="text"&&(Ve.tokens[0].tokens[0].text=it+" "+Ve.tokens[0].tokens[0].text)):Ve.tokens.unshift({type:"text",text:it}):We+=it),We+=this.parse(Ve.tokens,Ke),Ie+=this.renderer.listitem(We,nt,Ze);te+=this.renderer.list(Ie,Me,He);continue}case"html":{te+=this.renderer.html(Re.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(Re.tokens));continue}case"text":{for(Ie=Re.tokens?this.parseInline(Re.tokens):Re.text;he+1<tt&&M[he+1].type==="text";)Re=M[++he],Ie+=`
`+(Re.tokens?this.parseInline(Re.tokens):Re.text);te+=G?this.renderer.paragraph(Ie):Ie;continue}default:{var _e='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(_e);return}else throw new Error(_e)}}}return te},J.parseInline=function(M,G){G=G||this.renderer;var te="",he,ke,Ne,me=M.length;for(he=0;he<me;he++){if(ke=M[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Ne=this.options.extensions.renderers[ke.type].call({parser:this},ke),Ne!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){te+=Ne||"";continue}switch(ke.type){case"escape":{te+=G.text(ke.text);break}case"html":{te+=G.html(ke.text);break}case"link":{te+=G.link(ke.href,ke.title,this.parseInline(ke.tokens,G));break}case"image":{te+=G.image(ke.href,ke.title,ke.text);break}case"strong":{te+=G.strong(this.parseInline(ke.tokens,G));break}case"em":{te+=G.em(this.parseInline(ke.tokens,G));break}case"codespan":{te+=G.codespan(ke.text);break}case"br":{te+=G.br();break}case"del":{te+=G.del(this.parseInline(ke.tokens,G));break}case"text":{te+=G.text(ke.text);break}default:{var be='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}}return te},U}();function le(U,J,x){if(typeof U>"u"||U===null)throw new Error("marked(): input parameter is undefined or null");if(typeof U!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(U)+", string expected");if(typeof J=="function"&&(x=J,J=null),J=k({},le.defaults,J||{}),O(J),x){var M=J.highlight,G;try{G=ee.lex(U,J)}catch(me){return x(me)}var te=function(be){var Ae;if(!be)try{J.walkTokens&&le.walkTokens(G,J.walkTokens),Ae=oe.parse(G,J)}catch(Le){be=Le}return J.highlight=M,be?x(be):x(null,Ae)};if(!M||M.length<3||(delete J.highlight,!G.length))return te();var he=0;le.walkTokens(G,function(me){me.type==="code"&&(he++,setTimeout(function(){M(me.text,me.lang,function(be,Ae){if(be)return te(be);Ae!=null&&Ae!==me.text&&(me.text=Ae,me.escaped=!0),he--,he===0&&te()})},0))}),he===0&&te();return}function ke(me){if(me.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+a(me.message+"",!0)+"</pre>";throw me}try{var Ne=ee.lex(U,J);if(J.walkTokens){if(J.async)return Promise.all(le.walkTokens(Ne,J.walkTokens)).then(function(){return oe.parse(Ne,J)}).catch(ke);le.walkTokens(Ne,J.walkTokens)}return oe.parse(Ne,J)}catch(me){ke(me)}}le.options=le.setOptions=function(U){return k(le.defaults,U),R(le.defaults),le},le.getDefaults=A,le.defaults=fe.defaults,le.use=function(){for(var U=arguments.length,J=new Array(U),x=0;x<U;x++)J[x]=arguments[x];var M=k.apply(void 0,[{}].concat(J)),G=le.defaults.extensions||{renderers:{},childTokens:{}},te;J.forEach(function(he){if(he.extensions&&(te=!0,he.extensions.forEach(function(Ne){if(!Ne.name)throw new Error("extension name required");if(Ne.renderer){var me=G.renderers?G.renderers[Ne.name]:null;me?G.renderers[Ne.name]=function(){for(var be=arguments.length,Ae=new Array(be),Le=0;Le<be;Le++)Ae[Le]=arguments[Le];var de=Ne.renderer.apply(this,Ae);return de===!1&&(de=me.apply(this,Ae)),de}:G.renderers[Ne.name]=Ne.renderer}if(Ne.tokenizer){if(!Ne.level||Ne.level!=="block"&&Ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");G[Ne.level]?G[Ne.level].unshift(Ne.tokenizer):G[Ne.level]=[Ne.tokenizer],Ne.start&&(Ne.level==="block"?G.startBlock?G.startBlock.push(Ne.start):G.startBlock=[Ne.start]:Ne.level==="inline"&&(G.startInline?G.startInline.push(Ne.start):G.startInline=[Ne.start]))}Ne.childTokens&&(G.childTokens[Ne.name]=Ne.childTokens)})),he.renderer&&function(){var Ne=le.defaults.renderer||new ue,me=function(Le){var de=Ne[Le];Ne[Le]=function(){for(var Ie=arguments.length,Re=new Array(Ie),Me=0;Me<Ie;Me++)Re[Me]=arguments[Me];var He=he.renderer[Le].apply(Ne,Re);return He===!1&&(He=de.apply(Ne,Re)),He}};for(var be in he.renderer)me(be);M.renderer=Ne}(),he.tokenizer&&function(){var Ne=le.defaults.tokenizer||new ie,me=function(Le){var de=Ne[Le];Ne[Le]=function(){for(var Ie=arguments.length,Re=new Array(Ie),Me=0;Me<Ie;Me++)Re[Me]=arguments[Me];var He=he.tokenizer[Le].apply(Ne,Re);return He===!1&&(He=de.apply(Ne,Re)),He}};for(var be in he.tokenizer)me(be);M.tokenizer=Ne}(),he.walkTokens){var ke=le.defaults.walkTokens;M.walkTokens=function(Ne){var me=[];return me.push(he.walkTokens.call(this,Ne)),ke&&(me=me.concat(ke.call(this,Ne))),me}}te&&(M.extensions=G),le.setOptions(M)})},le.walkTokens=function(U,J){for(var x=[],M=function(){var ke=te.value;switch(x=x.concat(J.call(le,ke)),ke.type){case"table":{for(var Ne=D(ke.header),me;!(me=Ne()).done;){var be=me.value;x=x.concat(le.walkTokens(be.tokens,J))}for(var Ae=D(ke.rows),Le;!(Le=Ae()).done;)for(var de=Le.value,Ie=D(de),Re;!(Re=Ie()).done;){var Me=Re.value;x=x.concat(le.walkTokens(Me.tokens,J))}break}case"list":{x=x.concat(le.walkTokens(ke.items,J));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[ke.type]?le.defaults.extensions.childTokens[ke.type].forEach(function(He){x=x.concat(le.walkTokens(ke[He],J))}):ke.tokens&&(x=x.concat(le.walkTokens(ke.tokens,J)))}},G=D(U),te;!(te=G()).done;)M();return x},le.parseInline=function(U,J){if(typeof U>"u"||U===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof U!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(U)+", string expected");J=k({},le.defaults,J||{}),O(J);try{var x=ee.lexInline(U,J);return J.walkTokens&&le.walkTokens(x,J.walkTokens),oe.parseInline(x,J)}catch(M){if(M.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+a(M.message+"",!0)+"</pre>";throw M}},le.Parser=oe,le.parser=oe.parse,le.Renderer=ue,le.TextRenderer=j,le.Lexer=ee,le.lexer=ee.lex,le.Tokenizer=ie,le.Slugger=B,le.parse=le;var pe=le.options,q=le.setOptions,ae=le.use,Y=le.walkTokens,H=le.parseInline,L=le,W=oe.parse,z=ee.lex;fe.Lexer=ee,fe.Parser=oe,fe.Renderer=ue,fe.Slugger=B,fe.TextRenderer=j,fe.Tokenizer=ie,fe.getDefaults=A,fe.lexer=z,fe.marked=le,fe.options=pe,fe.parse=L,fe.parseInline=H,fe.parser=W,fe.setOptions=q,fe.use=ae,fe.walkTokens=Y,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Ee[80],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(Ee[161],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=n;function n(f){const h=D(f);if(h&&h.length>0)return new Uint32Array(h)}let r=0;const S=new Uint32Array(10);function D(f){if(r=0,A(f,y,v.InitialConsonant),r>0||(A(f,p,v.Vowel),r>0)||(A(f,b,v.FinalConsonant),r>0)||(A(f,a,v.CompatibilityJamo),r))return S.subarray(0,r);if(f>=44032&&f<=55203){const h=f-44032,g=h%588,w=Math.floor(h/588),m=Math.floor(g/28),$=g%28-1;if(w<y.length?A(w,y,0):v.InitialConsonant+w-v.CompatibilityJamo<a.length&&A(v.InitialConsonant+w,a,v.CompatibilityJamo),m<p.length?A(m,p,0):v.Vowel+m-v.CompatibilityJamo<a.length&&A(v.Vowel+m-v.CompatibilityJamo,a,v.CompatibilityJamo),$>=0&&($<b.length?A($,b,0):v.FinalConsonant+$-v.CompatibilityJamo<a.length&&A(v.FinalConsonant+$-v.CompatibilityJamo,a,v.CompatibilityJamo)),r>0)return S.subarray(0,r)}}function A(f,h,g){f>=g&&f<g+h.length&&R(h[f-g])}function R(f){f!==s.NUL&&(S[r++]=f&255,f>>8&&(S[r++]=f>>8&255),f>>16&&(S[r++]=f>>16&255))}var v;(function(f){f[f.InitialConsonant=4352]="InitialConsonant",f[f.Vowel=4449]="Vowel",f[f.FinalConsonant=4520]="FinalConsonant",f[f.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var s;(function(f){f[f.NUL=0]="NUL",f[f.A=65]="A",f[f.B=66]="B",f[f.C=67]="C",f[f.D=68]="D",f[f.E=69]="E",f[f.F=70]="F",f[f.G=71]="G",f[f.H=72]="H",f[f.I=73]="I",f[f.J=74]="J",f[f.K=75]="K",f[f.L=76]="L",f[f.M=77]="M",f[f.N=78]="N",f[f.O=79]="O",f[f.P=80]="P",f[f.Q=81]="Q",f[f.R=82]="R",f[f.S=83]="S",f[f.T=84]="T",f[f.U=85]="U",f[f.V=86]="V",f[f.W=87]="W",f[f.X=88]="X",f[f.Y=89]="Y",f[f.Z=90]="Z",f[f.a=97]="a",f[f.b=98]="b",f[f.c=99]="c",f[f.d=100]="d",f[f.e=101]="e",f[f.f=102]="f",f[f.g=103]="g",f[f.h=104]="h",f[f.i=105]="i",f[f.j=106]="j",f[f.k=107]="k",f[f.l=108]="l",f[f.m=109]="m",f[f.n=110]="n",f[f.o=111]="o",f[f.p=112]="p",f[f.q=113]="q",f[f.r=114]="r",f[f.s=115]="s",f[f.t=116]="t",f[f.u=117]="u",f[f.v=118]="v",f[f.w=119]="w",f[f.x=120]="x",f[f.y=121]="y",f[f.z=122]="z"})(s||(s={}));var E;(function(f){f[f.fa=24934]="fa",f[f.fg=26470]="fg",f[f.fq=29030]="fq",f[f.fr=29286]="fr",f[f.ft=29798]="ft",f[f.fv=30310]="fv",f[f.fx=30822]="fx",f[f.hk=27496]="hk",f[f.hl=27752]="hl",f[f.ho=28520]="ho",f[f.ml=27757]="ml",f[f.nj=27246]="nj",f[f.nl=27758]="nl",f[f.np=28782]="np",f[f.qt=29809]="qt",f[f.rt=29810]="rt",f[f.sg=26483]="sg",f[f.sw=30579]="sw"})(E||(E={}));const y=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),p=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,E.hk,E.ho,E.hl,s.y,s.n,E.nj,E.np,E.nl,s.b,s.m,E.ml,s.l]),b=new Uint16Array([s.r,s.R,E.rt,s.s,E.sw,E.sg,s.e,s.f,E.fr,E.fa,E.fq,E.ft,E.fx,E.fv,E.fg,s.a,s.q,E.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),a=new Uint16Array([s.r,s.R,E.rt,s.s,E.sw,E.sg,s.e,s.E,s.f,E.fr,E.fa,E.fq,E.ft,E.fx,E.fv,E.fg,s.a,s.q,s.Q,E.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,E.hk,E.ho,E.hl,s.y,s.n,E.nj,E.np,E.nl,s.b,s.m,E.ml,s.l])}),define(Ee[107],Se([1,0,26]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=void 0,e.$gm=S,e.$hm=A;const r=new n.$Dc(1e4);function S(s){return v(s,"NFC",r)}const D=new n.$Dc(1e4);function A(s){return v(s,"NFD",D)}const R=/[^\u0000-\u0080]/;function v(s,E,y){if(!s)return s;const p=y.get(s);if(p)return p;let b;return R.test(s)?b=s.normalize(E):b=s,y.set(s,b),b}e.$im=function(){const s=/[\u0300-\u036f]/g;return function(E){return A(E).replace(s,"")}}()}),define(Ee[162],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=e.$Im=void 0,e.$Gm=n,e.rot=r;function n(R,v,s){return Math.min(Math.max(R,v),s)}function r(R,v){return(v+R%v)%v}class S{constructor(){this.a=0}getNext(){return this.a++}}e.$Im=S;class D{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jm=D;class A{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const s=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=s,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Km=A}),define(Ee[163],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=D,e.$cd=p;class n{constructor(a,f,h){this.owner=a,this.debugNameSource=f,this.referenceFn=h}getDebugName(a){return D(a,this)}}e.$ad=n;const r=new Map,S=new WeakMap;function D(b,a){const f=S.get(b);if(f)return f;const h=A(b,a);if(h){let g=r.get(h)??0;g++,r.set(h,g);const w=g===1?h:`${h}#${g}`;return S.set(b,w),w}}function A(b,a){const f=S.get(b);if(f)return f;const h=a.owner?E(a.owner)+".":"";let g;const w=a.debugNameSource;if(w!==void 0)if(typeof w=="function"){if(g=w(),g!==void 0)return h+g}else return h+w;const m=a.referenceFn;if(m!==void 0&&(g=p(m),g!==void 0))return h+g;if(a.owner!==void 0){const $=R(a.owner,b);if($!==void 0)return h+$}}function R(b,a){for(const f in b)if(b[f]===a)return f}const v=new Map,s=new WeakMap;function E(b){const a=s.get(b);if(a)return a;const f=y(b);let h=v.get(f)??0;h++,v.set(f,h);const g=h===1?f:`${f}#${h}`;return s.set(b,g),g}function y(b){const a=b.constructor;return a?a.name:"Object"}function p(b){const a=b.toString(),h=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(a);return(h?h[1]:void 0)?.trim()}}),define(Ee[164],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=r,e.$Id=S;let n;function r(f){n=f}function S(){return n}class D{constructor(){this.a=0,this.d=new WeakMap}b(h){return A([R(b("|  ",this.a)),h])}c(h){return h.hadValue?h.didChange?[R(" "),s(E(h.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),s(E(h.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),s(E(h.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged(h,g){console.log(...this.b([v("observable value changed"),s(h.debugName,{color:"BlueViolet"}),...this.c(g)]))}formatChanges(h){if(h.size!==0)return s(" (changed deps: "+[...h].map(g=>g.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(h){const g=h.handleChange;this.d.set(h,new Set),h.handleChange=(w,m)=>(this.d.get(h).add(w),g.apply(h,[w,m]))}handleDerivedRecomputed(h,g){const w=this.d.get(h);console.log(...this.b([v("derived recomputed"),s(h.debugName,{color:"BlueViolet"}),...this.c(g),this.formatChanges(w),{data:[{fn:h._computeFn}]}])),w.clear()}handleFromEventObservableTriggered(h,g){console.log(...this.b([v("observable from event triggered"),s(h.debugName,{color:"BlueViolet"}),...this.c(g),{data:[{fn:h._getValue}]}]))}handleAutorunCreated(h){const g=h.handleChange;this.d.set(h,new Set),h.handleChange=(w,m)=>(this.d.get(h).add(w),g.apply(h,[w,m]))}handleAutorunTriggered(h){const g=this.d.get(h);console.log(...this.b([v("autorun"),s(h.debugName,{color:"BlueViolet"}),this.formatChanges(g),{data:[{fn:h._runFn}]}])),g.clear(),this.a++}handleAutorunFinished(h){this.a--}handleBeginTransaction(h){let g=h.getDebugName();g===void 0&&(g=""),console.log(...this.b([v("transaction"),s(g,{color:"BlueViolet"}),{data:[{fn:h._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=D;function A(f){const h=new Array,g=[];let w="";function m(l){if("length"in l)for(const t of l)t&&m(t);else"text"in l?(w+=`%c${l.text}`,h.push(l.style),l.data&&g.push(...l.data)):"data"in l&&g.push(...l.data)}m(f);const $=[w,...h];return $.push(...g),$}function R(f){return s(f,{color:"black"})}function v(f){return s(a(`${f}: `,10),{color:"black",bold:!0})}function s(f,h={color:"black"}){function g(m){return Object.entries(m).reduce(($,[l,t])=>`${$}${l}:${t};`,"")}const w={color:h.color};return h.strikeThrough&&(w["text-decoration"]="line-through"),h.bold&&(w["font-weight"]="bold"),{text:f,style:g(w)}}function E(f,h){switch(typeof f){case"number":return""+f;case"string":return f.length+2<=h?`"${f}"`:`"${f.substr(0,h-7)}"+...`;case"boolean":return f?"true":"false";case"undefined":return"undefined";case"object":return f===null?"null":Array.isArray(f)?y(f,h):p(f,h);case"symbol":return f.toString();case"function":return`[[Function${f.name?" "+f.name:""}]]`;default:return""+f}}function y(f,h){let g="[ ",w=!0;for(const m of f){if(w||(g+=", "),g.length-5>h){g+="...";break}w=!1,g+=`${E(m,h-g.length)}`}return g+=" ]",g}function p(f,h){let g="{ ",w=!0;for(const[m,$]of Object.entries(f)){if(w||(g+=", "),g.length-5>h){g+="...";break}w=!1,g+=`${m}: ${E($,h-g.length)}`}return g+=" }",g}function b(f,h){let g="";for(let w=1;w<=h;w++)g+=f;return g}function a(f,h){for(;f.length<h;)f+=" ";return f}}),define(Ee[165],Se([1,0,157,163,164]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=A,e.$Td=v,e.$Ud=E,e.$Xd=b,e.$Yd=f,e.$Zd=h,e.$1d=g,e.$3d=m,e.$4d=$,e.$6d=t;let D;function A(d){D=d}let R;function v(d){R=d}let s;function E(d){s=d}class y{get TChange(){return null}reportChanges(){this.get()}read(i){return i?i.readObservable(this):this.get()}map(i,c){const u=c===void 0?void 0:i,k=c===void 0?i:c;return s({owner:u,debugName:()=>{const I=(0,r.$cd)(k);if(I!==void 0)return I;const T=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(k.toString());if(T)return`${this.debugName}.${T[2]}`;if(!u)return`${this.debugName} (mapped)`},debugReferenceFn:k},I=>k(this.read(I),I))}recomputeInitiallyAndOnChange(i,c){return i.add(D(this,c)),this}keepObserved(i){return i.add(R(this)),this}get a(){return this.get()}}e.$Vd=y;class p extends y{constructor(){super(...arguments),this.b=new Set}addObserver(i){const c=this.b.size;this.b.add(i),c===0&&this.c()}removeObserver(i){this.b.delete(i)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=p;function b(d,i){const c=new w(d,i);try{d(c)}finally{c.finish()}}let a;function f(d){if(a)d(a);else{const i=new w(d,void 0);a=i;try{d(i)}finally{i.finish(),a=void 0}}}async function h(d,i){const c=new w(d,i);try{await d(c)}finally{c.finish()}}function g(d,i,c){d?i(d):b(i,c)}class w{constructor(i,c){this._fn=i,this.b=c,this.a=[],(0,S.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,r.$cd)(this._fn)}updateObserver(i,c){this.a.push({observer:i,observable:c}),i.beginUpdate(c)}finish(){const i=this.a;for(let c=0;c<i.length;c++){const{observer:u,observable:k}=i[c];u.endUpdate(k)}this.a=null,(0,S.$Id)()?.handleEndTransaction()}}e.$2d=w;function m(d,i){let c;return typeof d=="string"?c=new r.$ad(void 0,d,void 0):c=new r.$ad(d,void 0,void 0),new l(c,i,n.$6c)}function $(d,i){return new l(new r.$ad(d.owner,d.debugName,void 0),i,d.equalsFn??n.$6c)}class l extends p{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(i,c,u){super(),this.e=i,this.g=u,this.d=c}get(){return this.d}set(i,c,u){if(u===void 0&&this.g(this.d,i))return;let k;c||(c=k=new w(()=>{},()=>`Setting ${this.debugName}`));try{const I=this.d;this.h(i),(0,S.$Id)()?.handleObservableChanged(this,{oldValue:I,newValue:i,change:u,didChange:!0,hadValue:!0});for(const C of this.b)c.updateObserver(C,this),C.handleChange(this,u)}finally{k&&k.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(i){this.d=i}}e.$5d=l;function t(d,i){let c;return typeof d=="string"?c=new r.$ad(void 0,d,void 0):c=new r.$ad(d,void 0,void 0),new o(c,i,n.$6c)}class o extends l{h(i){this.d!==i&&(this.d&&this.d.dispose(),this.d=i)}dispose(){this.d?.dispose()}}e.$7d=o}),function(){function fe(S){const D=[];typeof S=="number"&&D.push("code/timeOrigin",S);function A(v){D.push(v,Date.now())}function R(){const v=[];for(let s=0;s<D.length;s+=2)v.push({name:D[s],startTime:D[s+1]});return v}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const A of performance.getEntriesByType("mark"))D.push({name:A.name,startTime:Math.round(S+A.startTime)});return D}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function n(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),define(Ee[166],Se([1,0,40]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=void 0;const r=Symbol("unset");class S{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||n.Iterable.empty()}insert(v,s,E){this.d(v,y=>y._value=s,E)}mutate(v,s){this.d(v,E=>E._value=s(E._value===r?void 0:E._value))}mutatePath(v,s){this.d(v,()=>{},E=>s(E))}delete(v){const s=this.c(v);if(!s)return;let E=s.length-1;const y=s[E].node._value;if(y!==r){for(this.b--,s[E].node._value=r;E>0;E--){const{node:p,part:b}=s[E];if(p.children?.size||p._value!==r)break;s[E-1].node.children.delete(b)}return y}}*deleteRecursive(v){const s=this.c(v);if(!s)return;const E=s[s.length-1].node;for(let y=s.length-1;y>0;y--){const p=s[y-1];if(p.node.children.delete(s[y].part),p.node.children.size>0||p.node._value!==r)break}for(const y of D(E))y._value!==r&&(this.b--,yield y._value)}find(v){let s=this.a;for(const E of v){const y=s.children?.get(E);if(!y)return;s=y}return s._value===r?void 0:s._value}hasKeyOrParent(v){let s=this.a;for(const E of v){const y=s.children?.get(E);if(!y)return!1;if(y._value!==r)return!0;s=y}return!1}hasKeyOrChildren(v){let s=this.a;for(const E of v){const y=s.children?.get(E);if(!y)return!1;s=y}return!0}hasKey(v){let s=this.a;for(const E of v){const y=s.children?.get(E);if(!y)return!1;s=y}return s._value!==r}c(v){const s=[{part:"",node:this.a}];let E=0;for(const y of v){const p=s[E].node.children?.get(y);if(!p)return;s.push({part:y,node:p}),E++}return s}d(v,s,E){let y=this.a;for(const a of v){if(y.children)if(y.children.has(a))y=y.children.get(a);else{const f=new A;y.children.set(a,f),y=f}else{const f=new A;y.children=new Map([[a,f]]),y=f}E?.(y)}const p=y._value===r?0:1;s(y);const b=y._value===r?0:1;this.b+=b-p}*values(){for(const{_value:v}of D(this.a))v!==r&&(yield v)}}e.$NO=S;function*D(R){const v=[R];for(;v.length>0;){const s=v.pop();if(yield s,s.children)for(const E of s.children.values())v.push(E)}}class A{constructor(){this._value=r}get value(){return this._value===r?void 0:this._value}set value(v){this._value=v===void 0?r:v}}}),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:fe)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function n(r){if(e[r])return e[r].exports;var S=e[r]={i:r,l:!1,exports:{}};return fe[r].call(S.exports,S,S.exports,n),S.l=!0,S.exports}return n.m=fe,n.c=e,n.d=function(r,S,D){n.o(r,S)||Object.defineProperty(r,S,{enumerable:!0,get:D})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,S){if(1&S&&(r=n(r)),8&S||4&S&&typeof r=="object"&&r&&r.__esModule)return r;var D=Object.create(null);if(n.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:r}),2&S&&typeof r!="string")for(var A in r)n.d(D,A,function(R){return r[R]}.bind(null,A));return D},n.n=function(r){var S=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(S,"a",S),S},n.o=function(r,S){return Object.prototype.hasOwnProperty.call(r,S)},n.p="",n(n.s=0)}([function(fe,e,n){(function(r){var S;e=fe.exports=ae,S=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var de=Array.prototype.slice.call(arguments,0);de.unshift("SEMVER"),console.log.apply(console,de)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],v=e.src=[],s=0,E=s++;v[E]="0|[1-9]\\d*";var y=s++;v[y]="[0-9]+";var p=s++;v[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=s++;v[b]="("+v[E]+")\\.("+v[E]+")\\.("+v[E]+")";var a=s++;v[a]="("+v[y]+")\\.("+v[y]+")\\.("+v[y]+")";var f=s++;v[f]="(?:"+v[E]+"|"+v[p]+")";var h=s++;v[h]="(?:"+v[y]+"|"+v[p]+")";var g=s++;v[g]="(?:-("+v[f]+"(?:\\."+v[f]+")*))";var w=s++;v[w]="(?:-?("+v[h]+"(?:\\."+v[h]+")*))";var m=s++;v[m]="[0-9A-Za-z-]+";var $=s++;v[$]="(?:\\+("+v[m]+"(?:\\."+v[m]+")*))";var l=s++,t="v?"+v[b]+v[g]+"?"+v[$]+"?";v[l]="^"+t+"$";var o="[v=\\s]*"+v[a]+v[w]+"?"+v[$]+"?",d=s++;v[d]="^"+o+"$";var i=s++;v[i]="((?:<|>)?=?)";var c=s++;v[c]=v[y]+"|x|X|\\*";var u=s++;v[u]=v[E]+"|x|X|\\*";var k=s++;v[k]="[v=\\s]*("+v[u]+")(?:\\.("+v[u]+")(?:\\.("+v[u]+")(?:"+v[g]+")?"+v[$]+"?)?)?";var I=s++;v[I]="[v=\\s]*("+v[c]+")(?:\\.("+v[c]+")(?:\\.("+v[c]+")(?:"+v[w]+")?"+v[$]+"?)?)?";var C=s++;v[C]="^"+v[i]+"\\s*"+v[k]+"$";var T=s++;v[T]="^"+v[i]+"\\s*"+v[I]+"$";var O=s++;v[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=s++;v[P]="(?:~>?)";var V=s++;v[V]="(\\s*)"+v[P]+"\\s+",R[V]=new RegExp(v[V],"g");var Q=s++;v[Q]="^"+v[P]+v[k]+"$";var ie=s++;v[ie]="^"+v[P]+v[I]+"$";var re=s++;v[re]="(?:\\^)";var ne=s++;v[ne]="(\\s*)"+v[re]+"\\s+",R[ne]=new RegExp(v[ne],"g");var se=s++;v[se]="^"+v[re]+v[k]+"$";var Z=s++;v[Z]="^"+v[re]+v[I]+"$";var ee=s++;v[ee]="^"+v[i]+"\\s*("+o+")$|^$";var ue=s++;v[ue]="^"+v[i]+"\\s*("+t+")$|^$";var j=s++;v[j]="(\\s*)"+v[i]+"\\s*("+o+"|"+v[k]+")",R[j]=new RegExp(v[j],"g");var B=s++;v[B]="^\\s*("+v[k]+")\\s+-\\s+("+v[k]+")\\s*$";var oe=s++;v[oe]="^\\s*("+v[I]+")\\s+-\\s+("+v[I]+")\\s*$";var le=s++;v[le]="(<|>)?=?\\s*\\*";for(var pe=0;pe<35;pe++)S(pe,v[pe]),R[pe]||(R[pe]=new RegExp(v[pe]));function q(de,Ie){if(de instanceof ae)return de;if(typeof de!="string"||de.length>D||!(Ie?R[d]:R[l]).test(de))return null;try{return new ae(de,Ie)}catch{return null}}function ae(de,Ie){if(de instanceof ae){if(de.loose===Ie)return de;de=de.version}else if(typeof de!="string")throw new TypeError("Invalid Version: "+de);if(de.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof ae))return new ae(de,Ie);S("SemVer",de,Ie),this.loose=Ie;var Re=de.trim().match(Ie?R[d]:R[l]);if(!Re)throw new TypeError("Invalid Version: "+de);if(this.raw=de,this.major=+Re[1],this.minor=+Re[2],this.patch=+Re[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Re[4]?this.prerelease=Re[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var He=+Me;if(He>=0&&He<A)return He}return Me}):this.prerelease=[],this.build=Re[5]?Re[5].split("."):[],this.format()}e.parse=q,e.valid=function(de,Ie){var Re=q(de,Ie);return Re?Re.version:null},e.clean=function(de,Ie){var Re=q(de.trim().replace(/^[=v]+/,""),Ie);return Re?Re.version:null},e.SemVer=ae,ae.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ae.prototype.toString=function(){return this.version},ae.prototype.compare=function(de){return S("SemVer.compare",this.version,this.loose,de),de instanceof ae||(de=new ae(de,this.loose)),this.compareMain(de)||this.comparePre(de)},ae.prototype.compareMain=function(de){return de instanceof ae||(de=new ae(de,this.loose)),H(this.major,de.major)||H(this.minor,de.minor)||H(this.patch,de.patch)},ae.prototype.comparePre=function(de){if(de instanceof ae||(de=new ae(de,this.loose)),this.prerelease.length&&!de.prerelease.length)return-1;if(!this.prerelease.length&&de.prerelease.length)return 1;if(!this.prerelease.length&&!de.prerelease.length)return 0;var Ie=0;do{var Re=this.prerelease[Ie],Me=de.prerelease[Ie];if(S("prerelease compare",Ie,Re,Me),Re===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(Re===void 0)return-1;if(Re!==Me)return H(Re,Me)}while(++Ie)},ae.prototype.inc=function(de,Ie){switch(de){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ie),this.inc("pre",Ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ie),this.inc("pre",Ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Re=this.prerelease.length;--Re>=0;)typeof this.prerelease[Re]=="number"&&(this.prerelease[Re]++,Re=-2);Re===-1&&this.prerelease.push(0)}Ie&&(this.prerelease[0]===Ie?isNaN(this.prerelease[1])&&(this.prerelease=[Ie,0]):this.prerelease=[Ie,0]);break;default:throw new Error("invalid increment argument: "+de)}return this.format(),this.raw=this.version,this},e.inc=function(de,Ie,Re,Me){typeof Re=="string"&&(Me=Re,Re=void 0);try{return new ae(de,Re).inc(Ie,Me).version}catch{return null}},e.diff=function(de,Ie){if(U(de,Ie))return null;var Re=q(de),Me=q(Ie);if(Re.prerelease.length||Me.prerelease.length){for(var He in Re)if((He==="major"||He==="minor"||He==="patch")&&Re[He]!==Me[He])return"pre"+He;return"prerelease"}for(var He in Re)if((He==="major"||He==="minor"||He==="patch")&&Re[He]!==Me[He])return He},e.compareIdentifiers=H;var Y=/^[0-9]+$/;function H(de,Ie){var Re=Y.test(de),Me=Y.test(Ie);return Re&&Me&&(de=+de,Ie=+Ie),Re&&!Me?-1:Me&&!Re?1:de<Ie?-1:de>Ie?1:0}function L(de,Ie,Re){return new ae(de,Re).compare(new ae(Ie,Re))}function W(de,Ie,Re){return L(de,Ie,Re)>0}function z(de,Ie,Re){return L(de,Ie,Re)<0}function U(de,Ie,Re){return L(de,Ie,Re)===0}function J(de,Ie,Re){return L(de,Ie,Re)!==0}function x(de,Ie,Re){return L(de,Ie,Re)>=0}function M(de,Ie,Re){return L(de,Ie,Re)<=0}function G(de,Ie,Re,Me){var He;switch(Ie){case"===":typeof de=="object"&&(de=de.version),typeof Re=="object"&&(Re=Re.version),He=de===Re;break;case"!==":typeof de=="object"&&(de=de.version),typeof Re=="object"&&(Re=Re.version),He=de!==Re;break;case"":case"=":case"==":He=U(de,Re,Me);break;case"!=":He=J(de,Re,Me);break;case">":He=W(de,Re,Me);break;case">=":He=x(de,Re,Me);break;case"<":He=z(de,Re,Me);break;case"<=":He=M(de,Re,Me);break;default:throw new TypeError("Invalid operator: "+Ie)}return He}function te(de,Ie){if(de instanceof te){if(de.loose===Ie)return de;de=de.value}if(!(this instanceof te))return new te(de,Ie);S("comparator",de,Ie),this.loose=Ie,this.parse(de),this.semver===he?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(de,Ie){return H(Ie,de)},e.major=function(de,Ie){return new ae(de,Ie).major},e.minor=function(de,Ie){return new ae(de,Ie).minor},e.patch=function(de,Ie){return new ae(de,Ie).patch},e.compare=L,e.compareLoose=function(de,Ie){return L(de,Ie,!0)},e.rcompare=function(de,Ie,Re){return L(Ie,de,Re)},e.sort=function(de,Ie){return de.sort(function(Re,Me){return e.compare(Re,Me,Ie)})},e.rsort=function(de,Ie){return de.sort(function(Re,Me){return e.rcompare(Re,Me,Ie)})},e.gt=W,e.lt=z,e.eq=U,e.neq=J,e.gte=x,e.lte=M,e.cmp=G,e.Comparator=te;var he={};function ke(de,Ie){if(de instanceof ke)return de.loose===Ie?de:new ke(de.raw,Ie);if(de instanceof te)return new ke(de.value,Ie);if(!(this instanceof ke))return new ke(de,Ie);if(this.loose=Ie,this.raw=de,this.set=de.split(/\s*\|\|\s*/).map(function(Re){return this.parseRange(Re.trim())},this).filter(function(Re){return Re.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+de);this.format()}function Ne(de){return!de||de.toLowerCase()==="x"||de==="*"}function me(de,Ie,Re,Me,He,Ke,We,Ve,Ze,nt,it,ot,tt){return((Ie=Ne(Re)?"":Ne(Me)?">="+Re+".0.0":Ne(He)?">="+Re+"."+Me+".0":">="+Ie)+" "+(Ve=Ne(Ze)?"":Ne(nt)?"<"+(+Ze+1)+".0.0":Ne(it)?"<"+Ze+"."+(+nt+1)+".0":ot?"<="+Ze+"."+nt+"."+it+"-"+ot:"<="+Ve)).trim()}function be(de,Ie){for(var Re=0;Re<de.length;Re++)if(!de[Re].test(Ie))return!1;if(Ie.prerelease.length){for(Re=0;Re<de.length;Re++)if(S(de[Re].semver),de[Re].semver!==he&&de[Re].semver.prerelease.length>0){var Me=de[Re].semver;if(Me.major===Ie.major&&Me.minor===Ie.minor&&Me.patch===Ie.patch)return!0}return!1}return!0}function Ae(de,Ie,Re){try{Ie=new ke(Ie,Re)}catch{return!1}return Ie.test(de)}function Le(de,Ie,Re,Me){var He,Ke,We,Ve,Ze;switch(de=new ae(de,Me),Ie=new ke(Ie,Me),Re){case">":He=W,Ke=M,We=z,Ve=">",Ze=">=";break;case"<":He=z,Ke=x,We=W,Ve="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(de,Ie,Me))return!1;for(var nt=0;nt<Ie.set.length;++nt){var it=Ie.set[nt],ot=null,tt=null;if(it.forEach(function(_e){_e.semver===he&&(_e=new te(">=0.0.0")),ot=ot||_e,tt=tt||_e,He(_e.semver,ot.semver,Me)?ot=_e:We(_e.semver,tt.semver,Me)&&(tt=_e)}),ot.operator===Ve||ot.operator===Ze||(!tt.operator||tt.operator===Ve)&&Ke(de,tt.semver)||tt.operator===Ze&&We(de,tt.semver))return!1}return!0}te.prototype.parse=function(de){var Ie=this.loose?R[ee]:R[ue],Re=de.match(Ie);if(!Re)throw new TypeError("Invalid comparator: "+de);this.operator=Re[1],this.operator==="="&&(this.operator=""),Re[2]?this.semver=new ae(Re[2],this.loose):this.semver=he},te.prototype.toString=function(){return this.value},te.prototype.test=function(de){return S("Comparator.test",de,this.loose),this.semver===he||(typeof de=="string"&&(de=new ae(de,this.loose)),G(de,this.operator,this.semver,this.loose))},te.prototype.intersects=function(de,Ie){if(!(de instanceof te))throw new TypeError("a Comparator is required");var Re;if(this.operator==="")return Re=new ke(de.value,Ie),Ae(this.value,Re,Ie);if(de.operator==="")return Re=new ke(this.value,Ie),Ae(de.semver,Re,Ie);var Me=!(this.operator!==">="&&this.operator!==">"||de.operator!==">="&&de.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||de.operator!=="<="&&de.operator!=="<"),Ke=this.semver.version===de.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||de.operator!==">="&&de.operator!=="<="),Ve=G(this.semver,"<",de.semver,Ie)&&(this.operator===">="||this.operator===">")&&(de.operator==="<="||de.operator==="<"),Ze=G(this.semver,">",de.semver,Ie)&&(this.operator==="<="||this.operator==="<")&&(de.operator===">="||de.operator===">");return Me||He||Ke&&We||Ve||Ze},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(de){return de.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(de){var Ie=this.loose;de=de.trim(),S("range",de,Ie);var Re=Ie?R[oe]:R[B];de=de.replace(Re,me),S("hyphen replace",de),de=de.replace(R[j],"$1$2$3"),S("comparator trim",de,R[j]),de=(de=(de=de.replace(R[V],"$1~")).replace(R[ne],"$1^")).split(/\s+/).join(" ");var Me=Ie?R[ee]:R[ue],He=de.split(" ").map(function(Ke){return function(We,Ve){return S("comp",We),We=function(Ze,nt){return Ze.trim().split(/\s+/).map(function(it){return function(ot,tt){S("caret",ot,tt);var _e=tt?R[Z]:R[se];return ot.replace(_e,function(Xe,Qe,$e,Oe,ve){var ye;return S("caret",ot,Xe,Qe,$e,Oe,ve),Ne(Qe)?ye="":Ne($e)?ye=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":Ne(Oe)?ye=Qe==="0"?">="+Qe+"."+$e+".0 <"+Qe+"."+(+$e+1)+".0":">="+Qe+"."+$e+".0 <"+(+Qe+1)+".0.0":ve?(S("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ye=Qe==="0"?$e==="0"?">="+Qe+"."+$e+"."+Oe+ve+" <"+Qe+"."+$e+"."+(+Oe+1):">="+Qe+"."+$e+"."+Oe+ve+" <"+Qe+"."+(+$e+1)+".0":">="+Qe+"."+$e+"."+Oe+ve+" <"+(+Qe+1)+".0.0"):(S("no pr"),ye=Qe==="0"?$e==="0"?">="+Qe+"."+$e+"."+Oe+" <"+Qe+"."+$e+"."+(+Oe+1):">="+Qe+"."+$e+"."+Oe+" <"+Qe+"."+(+$e+1)+".0":">="+Qe+"."+$e+"."+Oe+" <"+(+Qe+1)+".0.0"),S("caret return",ye),ye})}(it,nt)}).join(" ")}(We,Ve),S("caret",We),We=function(Ze,nt){return Ze.trim().split(/\s+/).map(function(it){return function(ot,tt){var _e=tt?R[ie]:R[Q];return ot.replace(_e,function(Xe,Qe,$e,Oe,ve){var ye;return S("tilde",ot,Xe,Qe,$e,Oe,ve),Ne(Qe)?ye="":Ne($e)?ye=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":Ne(Oe)?ye=">="+Qe+"."+$e+".0 <"+Qe+"."+(+$e+1)+".0":ve?(S("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),ye=">="+Qe+"."+$e+"."+Oe+ve+" <"+Qe+"."+(+$e+1)+".0"):ye=">="+Qe+"."+$e+"."+Oe+" <"+Qe+"."+(+$e+1)+".0",S("tilde return",ye),ye})}(it,nt)}).join(" ")}(We,Ve),S("tildes",We),We=function(Ze,nt){return S("replaceXRanges",Ze,nt),Ze.split(/\s+/).map(function(it){return function(ot,tt){ot=ot.trim();var _e=tt?R[T]:R[C];return ot.replace(_e,function(Xe,Qe,$e,Oe,ve,ye){S("xRange",ot,Xe,Qe,$e,Oe,ve,ye);var X=Ne($e),_=X||Ne(Oe),we=_||Ne(ve);return Qe==="="&&we&&(Qe=""),X?Xe=Qe===">"||Qe==="<"?"<0.0.0":"*":Qe&&we?(_&&(Oe=0),we&&(ve=0),Qe===">"?(Qe=">=",_?($e=+$e+1,Oe=0,ve=0):we&&(Oe=+Oe+1,ve=0)):Qe==="<="&&(Qe="<",_?$e=+$e+1:Oe=+Oe+1),Xe=Qe+$e+"."+Oe+"."+ve):_?Xe=">="+$e+".0.0 <"+(+$e+1)+".0.0":we&&(Xe=">="+$e+"."+Oe+".0 <"+$e+"."+(+Oe+1)+".0"),S("xRange return",Xe),Xe})}(it,nt)}).join(" ")}(We,Ve),S("xrange",We),We=function(Ze,nt){return S("replaceStars",Ze,nt),Ze.trim().replace(R[le],"")}(We,Ve),S("stars",We),We}(Ke,Ie)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(Ke){return!!Ke.match(Me)})),He=He.map(function(Ke){return new te(Ke,Ie)})},ke.prototype.intersects=function(de,Ie){if(!(de instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(Re){return Re.every(function(Me){return de.set.some(function(He){return He.every(function(Ke){return Me.intersects(Ke,Ie)})})})})},e.toComparators=function(de,Ie){return new ke(de,Ie).set.map(function(Re){return Re.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(de){if(!de)return!1;typeof de=="string"&&(de=new ae(de,this.loose));for(var Ie=0;Ie<this.set.length;Ie++)if(be(this.set[Ie],de))return!0;return!1},e.satisfies=Ae,e.maxSatisfying=function(de,Ie,Re){var Me=null,He=null;try{var Ke=new ke(Ie,Re)}catch{return null}return de.forEach(function(We){Ke.test(We)&&(Me&&He.compare(We)!==-1||(He=new ae(Me=We,Re)))}),Me},e.minSatisfying=function(de,Ie,Re){var Me=null,He=null;try{var Ke=new ke(Ie,Re)}catch{return null}return de.forEach(function(We){Ke.test(We)&&(Me&&He.compare(We)!==1||(He=new ae(Me=We,Re)))}),Me},e.validRange=function(de,Ie){try{return new ke(de,Ie).range||"*"}catch{return null}},e.ltr=function(de,Ie,Re){return Le(de,Ie,"<",Re)},e.gtr=function(de,Ie,Re){return Le(de,Ie,">",Re)},e.outside=Le,e.prerelease=function(de,Ie){var Re=q(de,Ie);return Re&&Re.prerelease.length?Re.prerelease:null},e.intersects=function(de,Ie,Re){return de=new ke(de,Re),Ie=new ke(Ie,Re),de.intersects(Ie)},e.coerce=function(de){if(de instanceof ae)return de;if(typeof de!="string")return null;var Ie=de.match(R[O]);return Ie==null?null:q((Ie[1]||"0")+"."+(Ie[2]||"0")+"."+(Ie[3]||"0"))}}).call(this,n(1))},function(fe,e){var n,r,S=fe.exports={};function D(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(h){if(n===setTimeout)return setTimeout(h,0);if((n===D||!n)&&setTimeout)return n=setTimeout,setTimeout(h,0);try{return n(h,0)}catch{try{return n.call(null,h,0)}catch{return n.call(this,h,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:D}catch{n=D}try{r=typeof clearTimeout=="function"?clearTimeout:A}catch{r=A}})();var v,s=[],E=!1,y=-1;function p(){E&&v&&(E=!1,v.length?s=v.concat(s):y=-1,s.length&&b())}function b(){if(!E){var h=R(p);E=!0;for(var g=s.length;g;){for(v=s,s=[];++y<g;)v&&v[y].run();y=-1,g=s.length}v=null,E=!1,function(w){if(r===clearTimeout)return clearTimeout(w);if((r===A||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(w);try{r(w)}catch{try{return r.call(null,w)}catch{return r.call(this,w)}}}(h)}}function a(h,g){this.fun=h,this.array=g}function f(){}S.nextTick=function(h){var g=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)g[w-1]=arguments[w];s.push(new a(h,g)),s.length!==1||E||R(b)},a.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=f,S.addListener=f,S.once=f,S.off=f,S.removeListener=f,S.removeAllListeners=f,S.emit=f,S.prependListener=f,S.prependOnceListener=f,S.listeners=function(h){return[]},S.binding=function(h){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(h){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Ee[167],Se([1,0]),function(fe,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0;class r{constructor(R,v,s){this.level=R,this.key=v,this.value=s,this.forward=[]}}const S=void 0;class D{constructor(R,v=2**16){this.comparator=R,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new r(this.c,S,S)}get size(){return this.f}clear(){this.e=new r(this.c,S,S),this.f=0}has(R){return!!D.g(this,R,this.comparator)}get(R){return D.g(this,R,this.comparator)?.value}set(R,v){return D.h(this,R,v,this.comparator)&&(this.f+=1),this}delete(R){const v=D.k(this,R,this.comparator);return v&&(this.f-=1),v}forEach(R,v){let s=this.e.forward[0];for(;s;)R.call(v,s.value,s.key,this),s=s.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",v=this.e.forward[0];for(;v;)R+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return R}static g(R,v,s){let E=R.e;for(let y=R.d-1;y>=0;y--)for(;E.forward[y]&&s(E.forward[y].key,v)<0;)E=E.forward[y];if(E=E.forward[0],E&&s(E.key,v)===0)return E}static h(R,v,s,E){const y=[];let p=R.e;for(let b=R.d-1;b>=0;b--){for(;p.forward[b]&&E(p.forward[b].key,v)<0;)p=p.forward[b];y[b]=p}if(p=p.forward[0],p&&E(p.key,v)===0)return p.value=s,!1;{const b=D.j(R);if(b>R.d){for(let a=R.d;a<b;a++)y[a]=R.e;R.d=b}p=new r(b,v,s);for(let a=0;a<b;a++)p.forward[a]=y[a].forward[a],y[a].forward[a]=p;return!0}}static j(R,v=.5){let s=1;for(;Math.random()<v&&s<R.c;)s+=1;return s}static k(R,v,s){const E=[];let y=R.e;for(let p=R.d-1;p>=0;p--){for(;y.forward[p]&&s(y.forward[p].key,v)<0;)y=y.forward[p];E[p]=y}if(y=y.forward[0],!y||s(y.key,v)!==0)return!1;for(let p=0;p<R.d&&E[p].forward[p]===y;p++)E[p].forward[p]=y.forward[p];for(;R.d>0&&R.e.forward[R.d-1]===S;)R.d-=1;return!0}}e.$Hs=D}),define(Ee[55],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(D){return new r(D)}constructor(D){this.c=n&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=r}),define(Ee[6],Se([1,0,10,78,2,79,55]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=b;const R=!1,v=!1,s=!1;var E;(function(ie){ie.None=()=>S.$Uc.None;function re(me){if(s){const{onDidAddListener:be}=me,Ae=f.create();let Le=0;me.onDidAddListener=()=>{++Le===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ae.print()),be?.()}}}function ne(me,be){return q(me,()=>{},0,void 0,!0,void 0,be)}ie.defer=ne;function se(me){return(be,Ae=null,Le)=>{let de=!1,Ie;return Ie=me(Re=>{if(!de)return Ie?Ie.dispose():de=!0,be.call(Ae,Re)},null,Le),de&&Ie.dispose(),Ie}}ie.once=se;function Z(me,be,Ae){return le((Le,de=null,Ie)=>me(Re=>Le.call(de,be(Re)),null,Ie),Ae)}ie.map=Z;function ee(me,be,Ae){return le((Le,de=null,Ie)=>me(Re=>{be(Re),Le.call(de,Re)},null,Ie),Ae)}ie.forEach=ee;function ue(me,be,Ae){return le((Le,de=null,Ie)=>me(Re=>be(Re)&&Le.call(de,Re),null,Ie),Ae)}ie.filter=ue;function j(me){return me}ie.signal=j;function B(...me){return(be,Ae=null,Le)=>{const de=(0,S.$Rc)(...me.map(Ie=>Ie(Re=>be.call(Ae,Re))));return pe(de,Le)}}ie.any=B;function oe(me,be,Ae,Le){let de=Ae;return Z(me,Ie=>(de=be(de,Ie),de),Le)}ie.reduce=oe;function le(me,be){let Ae;const Le={onWillAddFirstListener(){Ae=me(de.fire,de)},onDidRemoveLastListener(){Ae?.dispose()}};be||re(Le);const de=new o(Le);return be?.add(de),de.event}function pe(me,be){return be instanceof Array?be.push(me):be&&be.add(me),me}function q(me,be,Ae=100,Le=!1,de=!1,Ie,Re){let Me,He,Ke,We=0,Ve;const Ze={leakWarningThreshold:Ie,onWillAddFirstListener(){Me=me(it=>{We++,He=be(He,it),Le&&!Ke&&(nt.fire(He),He=void 0),Ve=()=>{const ot=He;He=void 0,Ke=void 0,(!Le||We>1)&&nt.fire(ot),We=0},typeof Ae=="number"?(clearTimeout(Ke),Ke=setTimeout(Ve,Ae)):Ke===void 0&&(Ke=0,queueMicrotask(Ve))})},onWillRemoveListener(){de&&We>0&&Ve?.()},onDidRemoveLastListener(){Ve=void 0,Me.dispose()}};Re||re(Ze);const nt=new o(Ze);return Re?.add(nt),nt.event}ie.debounce=q;function ae(me,be=0,Ae){return ie.debounce(me,(Le,de)=>Le?(Le.push(de),Le):[de],be,void 0,!0,void 0,Ae)}ie.accumulate=ae;function Y(me,be=(Le,de)=>Le===de,Ae){let Le=!0,de;return ue(me,Ie=>{const Re=Le||!be(Ie,de);return Le=!1,de=Ie,Re},Ae)}ie.latch=Y;function H(me,be,Ae){return[ie.filter(me,be,Ae),ie.filter(me,Le=>!be(Le),Ae)]}ie.split=H;function L(me,be=!1,Ae=[],Le){let de=Ae.slice(),Ie=me(He=>{de?de.push(He):Me.fire(He)});Le&&Le.add(Ie);const Re=()=>{de?.forEach(He=>Me.fire(He)),de=null},Me=new o({onWillAddFirstListener(){Ie||(Ie=me(He=>Me.fire(He)),Le&&Le.add(Ie))},onDidAddFirstListener(){de&&(be?setTimeout(Re):Re())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return Le&&Le.add(Me),Me.event}ie.buffer=L;function W(me,be){return(Le,de,Ie)=>{const Re=be(new U);return me(function(Me){const He=Re.evaluate(Me);He!==z&&Le.call(de,He)},void 0,Ie)}}ie.chain=W;const z=Symbol("HaltChainable");class U{constructor(){this.f=[]}map(be){return this.f.push(be),this}forEach(be){return this.f.push(Ae=>(be(Ae),Ae)),this}filter(be){return this.f.push(Ae=>be(Ae)?Ae:z),this}reduce(be,Ae){let Le=Ae;return this.f.push(de=>(Le=be(Le,de),Le)),this}latch(be=(Ae,Le)=>Ae===Le){let Ae=!0,Le;return this.f.push(de=>{const Ie=Ae||!be(de,Le);return Ae=!1,Le=de,Ie?de:z}),this}evaluate(be){for(const Ae of this.f)if(be=Ae(be),be===z)break;return be}}function J(me,be,Ae=Le=>Le){const Le=(...Me)=>Re.fire(Ae(...Me)),de=()=>me.on(be,Le),Ie=()=>me.removeListener(be,Le),Re=new o({onWillAddFirstListener:de,onDidRemoveLastListener:Ie});return Re.event}ie.fromNodeEventEmitter=J;function x(me,be,Ae=Le=>Le){const Le=(...Me)=>Re.fire(Ae(...Me)),de=()=>me.addEventListener(be,Le),Ie=()=>me.removeEventListener(be,Le),Re=new o({onWillAddFirstListener:de,onDidRemoveLastListener:Ie});return Re.event}ie.fromDOMEventEmitter=x;function M(me){return new Promise(be=>se(me)(be))}ie.toPromise=M;function G(me){const be=new o;return me.then(Ae=>{be.fire(Ae)},()=>{be.fire(void 0)}).finally(()=>{be.dispose()}),be.event}ie.fromPromise=G;function te(me,be,Ae){return be(Ae),me(Le=>be(Le))}ie.runAndSubscribe=te;class he{constructor(be,Ae){this._observable=be,this.f=0,this.g=!1;const Le={onWillAddFirstListener:()=>{be.addObserver(this)},onDidRemoveLastListener:()=>{be.removeObserver(this)}};Ae||re(Le),this.emitter=new o(Le),Ae&&Ae.add(this.emitter)}beginUpdate(be){this.f++}handlePossibleChange(be){}handleChange(be,Ae){this.g=!0}endUpdate(be){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ke(me,be){return new he(me,be).emitter.event}ie.fromObservable=ke;function Ne(me){return(be,Ae,Le)=>{let de=0,Ie=!1;const Re={beginUpdate(){de++},endUpdate(){de--,de===0&&(me.reportChanges(),Ie&&(Ie=!1,be.call(Ae)))},handlePossibleChange(){},handleChange(){Ie=!0}};me.addObserver(Re),me.reportChanges();const Me={dispose(){me.removeObserver(Re)}};return Le instanceof S.$Tc?Le.add(Me):Array.isArray(Le)&&Le.push(Me),Me}}ie.fromObservableLight=Ne})(E||(e.Event=E={}));class y{static{this.all=new Set}static{this.f=0}constructor(re){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${re}_${y.f++}`,y.all.add(this)}start(re){this.g=new A.$be,this.listenerCount=re}stop(){if(this.g){const re=this.g.elapsed();this.durations.push(re),this.elapsedOverall+=re,this.invocationCount+=1,this.g=void 0}}}e.$de=y;let p=-1;function b(ie){const re=p;return p=ie,{dispose(){p=re}}}class a{constructor(re,ne,se=Math.random().toString(18).slice(2,5)){this.h=re,this.threshold=ne,this.name=se,this.g=0}dispose(){this.f?.clear()}check(re,ne){const se=this.threshold;if(se<=0||ne<se)return;this.f||(this.f=new Map);const Z=this.f.get(re.value)||0;if(this.f.set(re.value,Z+1),this.g-=1,this.g<=0){this.g=se*.5;const[ee,ue]=this.getMostFrequentStack(),j=`[${this.name}] potential listener LEAK detected, having ${ne} listeners already. MOST frequent listener (${ue}):`;console.warn(j),console.warn(ee);const B=new h(j,ee);this.h(B)}return()=>{const ee=this.f.get(re.value)||0;this.f.set(re.value,ee-1)}}getMostFrequentStack(){if(!this.f)return;let re,ne=0;for(const[se,Z]of this.f)(!re||ne<Z)&&(re=[se,Z],ne=Z);return re}}class f{static create(){const re=new Error;return new f(re.stack??"")}constructor(re){this.value=re}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h extends Error{constructor(re,ne){super(re),this.name="ListenerLeakError",this.stack=ne}}e.$fe=h;class g extends Error{constructor(re,ne){super(re),this.name="ListenerRefusalError",this.stack=ne}}e.$ge=g;let w=0;class m{constructor(re){this.value=re,this.id=w++}}const $=2,l=(ie,re)=>{if(ie instanceof m)re(ie);else for(let ne=0;ne<ie.length;ne++){const se=ie[ne];se&&re(se)}},t=R?new FinalizationRegistry(ie=>{typeof ie=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(ie))}):void 0;class o{constructor(re){this.w=0,this.f=re,this.g=p>0||this.f?.leakWarningThreshold?new a(re?.onListenerError??n.$1,this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(v){const re=this.t;queueMicrotask(()=>{l(re,ne=>ne.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(re,ne,se)=>{if(this.g&&this.w>this.g.threshold**2){const B=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(B);const oe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],le=new g(`${B}. HINT: Stack shows most frequent listener (${oe[1]}-times)`,oe[0]);return(this.f?.onListenerError||n.$1)(le),S.$Uc.None}if(this.m)return S.$Uc.None;ne&&(re=re.bind(ne));const Z=new m(re);let ee,ue;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Z.stack=f.create(),ee=this.g.check(Z.stack,this.w+1)),v&&(Z.stack=ue??f.create()),this.t?this.t instanceof m?(this.u??=new i,this.t=[this.t,Z]):this.t.push(Z):(this.f?.onWillAddFirstListener?.(this),this.t=Z,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,S.$Sc)(()=>{t?.unregister(j),ee?.(),this.x(Z)});if(se instanceof S.$Tc?se.add(j):Array.isArray(se)&&se.push(j),t){const B=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(j,B,j)}return j},this.q}x(re){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const ne=this.t,se=ne.indexOf(re);if(se===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,ne[se]=void 0;const Z=this.u.current===this;if(this.w*$<=ne.length){let ee=0;for(let ue=0;ue<ne.length;ue++)ne[ue]?ne[ee++]=ne[ue]:Z&&(this.u.end--,ee<this.u.i&&this.u.i--);ne.length=ee}}y(re,ne){if(!re)return;const se=this.f?.onListenerError||n.$1;if(!se){re.value(ne);return}try{re.value(ne)}catch(Z){se(Z)}}z(re){const ne=re.current.t;for(;re.i<re.end;)this.y(ne[re.i++],re.value);re.reset()}fire(re){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,re);else{const ne=this.u;ne.enqueue(this,re,this.t.length),this.z(ne)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=o;const d=()=>new i;e.$ie=d;class i{constructor(){this.i=-1,this.end=0}enqueue(re,ne,se){this.i=0,this.end=se,this.current=re,this.value=ne}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends o{async fireAsync(re,ne,se){if(this.t)for(this.h||(this.h=new D.$5c),l(this.t,Z=>this.h.push([Z.value,re]));this.h.size>0&&!ne.isCancellationRequested;){const[Z,ee]=this.h.shift(),ue=[],j={...ee,token:ne,waitUntil:B=>{if(Object.isFrozen(ue))throw new Error("waitUntil can NOT be called asynchronous");se&&(B=se(B,Z)),ue.push(B)}};try{Z(j)}catch(B){(0,n.$1)(B);continue}Object.freeze(ue),await Promise.allSettled(ue).then(B=>{for(const oe of B)oe.status==="rejected"&&(0,n.$1)(oe.reason)})}}}e.$je=c;class u extends o{get isPaused(){return this.h!==0}constructor(re){super(re),this.h=0,this.s=new D.$5c,this.A=re?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const re=Array.from(this.s);this.s.clear(),super.fire(this.A(re))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(re){this.w&&(this.h!==0?this.s.push(re):super.fire(re))}}e.$ke=u;class k extends u{constructor(re){super(re),this.k=re.delay??100}fire(re){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(re)}}e.$le=k;class I extends o{constructor(re){super(re),this.h=[],this.k=re?.merge}fire(re){this.hasListeners()&&(this.h.push(re),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ne=>super.fire(ne)),this.h=[]}))}}e.$me=I;class C{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(re){const ne={event:re,listener:null};this.h.push(ne),this.g&&this.m(ne);const se=()=>{this.g&&this.o(ne);const Z=this.h.indexOf(ne);this.h.splice(Z,1)};return(0,S.$Sc)((0,r.$db)(se))}j(){this.g=!0,this.h.forEach(re=>this.m(re))}k(){this.g=!1,this.h.forEach(re=>this.o(re))}m(re){re.listener=re.event(ne=>this.f.fire(ne))}o(re){re.listener?.dispose(),re.listener=null}dispose(){this.f.dispose();for(const re of this.h)re.listener?.dispose();this.h=[]}}e.$ne=C;class T{constructor(re,ne,se,Z){this.f=new S.$Tc;const ee=this.f.add(new C),ue=this.f.add(new S.$4c);function j(B){ue.set(B,ee.add(Z(B)))}for(const B of re)j(B);this.f.add(ne(B=>{j(B)})),this.f.add(se(B=>{ue.deleteAndDispose(B)})),this.event=ee.event}dispose(){this.f.dispose()}}e.$oe=T;class O{constructor(){this.f=[]}wrapEvent(re,ne,se){return(Z,ee,ue)=>re(j=>{const B=this.f[this.f.length-1];if(!ne){B?B.buffers.push(()=>Z.call(ee,j)):Z.call(ee,j);return}const oe=B;if(!oe){Z.call(ee,ne(se,j));return}oe.items??=[],oe.items.push(j),oe.buffers.length===0&&B.buffers.push(()=>{oe.reducedResult??=se?oe.items.reduce(ne,se):oe.items.reduce(ne),Z.call(ee,oe.reducedResult)})},void 0,ue)}bufferEvents(re){const ne={buffers:new Array};this.f.push(ne);const se=re();return this.f.pop(),ne.buffers.forEach(Z=>Z()),se}}e.$pe=O;class P{constructor(){this.f=!1,this.g=E.None,this.h=S.$Uc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(re){this.g=re,this.f&&(this.h.dispose(),this.h=re(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=P;class V{static const(re){return new Q(re)}constructor(re){this.g=re,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(re){re!==this.g&&(this.g=re,this.f.fire(void 0))}}e.$re=V;class Q{constructor(re){this.value=re,this.onDidChange=E.None}}}),define(Ee[19],Se([1,0,6]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=R;const r=Object.freeze(function(v,s){const E=setTimeout(v.bind(s),0);return{dispose(){clearTimeout(E)}}});var S;(function(v){function s(E){return E===v.None||E===v.Cancelled||E instanceof D?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}v.isCancellationToken=s,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(S||(e.CancellationToken=S={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(s){this.f=void 0,this.g=void 0,this.g=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=S.Cancelled}dispose(s=!1){s&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=S.None}}e.$se=A;function R(v){const s=new A;return v.add({dispose(){s.cancel()}}),s.token}}),define(Ee[168],Se([1,0,19]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=S;class r{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new n.$se,s=this.b(v.token);return this.a={promise:s,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}e.$5e=r;function S(R){return R}class D{constructor(v,s){this.a=void 0,this.b=void 0,typeof v=="function"?(this.c=v,this.d=S):(this.c=s,this.d=v.getCacheKey)}get(v){const s=this.d(v);return this.b!==s&&(this.b=s,this.a=this.c(v)),this.a}}e.$7e=D;class A{get cachedValues(){return this.a}constructor(v,s){this.a=new Map,this.b=new Map,typeof v=="function"?(this.c=v,this.d=S):(this.c=s,this.d=v.getCacheKey)}get(v){const s=this.d(v);if(this.b.has(s))return this.b.get(s);const E=this.c(v);return this.a.set(v,E),this.b.set(s,E),E}}e.$8e=A}),define(Ee[169],Se([1,0,6,2]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iu=e.$hu=e.$gu=e.$fu=e.ScrollbarVisibility=void 0;var S;(function(b){b[b.Auto=1]="Auto",b[b.Hidden=2]="Hidden",b[b.Visible=3]="Visible"})(S||(e.ScrollbarVisibility=S={}));class D{constructor(a,f,h,g,w,m,$){this.c=a,this._scrollStateBrand=void 0,this.c&&(f=f|0,h=h|0,g=g|0,w=w|0,m=m|0,$=$|0),this.rawScrollLeft=g,this.rawScrollTop=$,f<0&&(f=0),g+f>h&&(g=h-f),g<0&&(g=0),w<0&&(w=0),$+w>m&&($=m-w),$<0&&($=0),this.width=f,this.scrollWidth=h,this.scrollLeft=g,this.height=w,this.scrollHeight=m,this.scrollTop=$}equals(a){return this.rawScrollLeft===a.rawScrollLeft&&this.rawScrollTop===a.rawScrollTop&&this.width===a.width&&this.scrollWidth===a.scrollWidth&&this.scrollLeft===a.scrollLeft&&this.height===a.height&&this.scrollHeight===a.scrollHeight&&this.scrollTop===a.scrollTop}withScrollDimensions(a,f){return new D(this.c,typeof a.width<"u"?a.width:this.width,typeof a.scrollWidth<"u"?a.scrollWidth:this.scrollWidth,f?this.rawScrollLeft:this.scrollLeft,typeof a.height<"u"?a.height:this.height,typeof a.scrollHeight<"u"?a.scrollHeight:this.scrollHeight,f?this.rawScrollTop:this.scrollTop)}withScrollPosition(a){return new D(this.c,this.width,this.scrollWidth,typeof a.scrollLeft<"u"?a.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof a.scrollTop<"u"?a.scrollTop:this.rawScrollTop)}createScrollEvent(a,f){const h=this.width!==a.width,g=this.scrollWidth!==a.scrollWidth,w=this.scrollLeft!==a.scrollLeft,m=this.height!==a.height,$=this.scrollHeight!==a.scrollHeight,l=this.scrollTop!==a.scrollTop;return{inSmoothScrolling:f,oldWidth:a.width,oldScrollWidth:a.scrollWidth,oldScrollLeft:a.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:a.height,oldScrollHeight:a.scrollHeight,oldScrollTop:a.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:h,scrollWidthChanged:g,scrollLeftChanged:w,heightChanged:m,scrollHeightChanged:$,scrollTopChanged:l}}}e.$fu=D;class A extends r.$Uc{constructor(a){super(),this._scrollableBrand=void 0,this.j=this.B(new n.$he),this.onScroll=this.j.event,this.c=a.smoothScrollDuration,this.f=a.scheduleAtNextAnimationFrame,this.g=new D(a.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(a){this.c=a}validateScrollPosition(a){return this.g.withScrollPosition(a)}getScrollDimensions(){return this.g}setScrollDimensions(a,f){const h=this.g.withScrollDimensions(a,f);this.n(h,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(a){const f=this.g.withScrollPosition(a);this.h&&(this.h.dispose(),this.h=null),this.n(f,!1)}setScrollPositionSmooth(a,f){if(this.c===0)return this.setScrollPositionNow(a);if(this.h){a={scrollLeft:typeof a.scrollLeft>"u"?this.h.to.scrollLeft:a.scrollLeft,scrollTop:typeof a.scrollTop>"u"?this.h.to.scrollTop:a.scrollTop};const h=this.g.withScrollPosition(a);if(this.h.to.scrollLeft===h.scrollLeft&&this.h.to.scrollTop===h.scrollTop)return;let g;f?g=new E(this.h.from,h,this.h.startTime,this.h.duration):g=this.h.combine(this.g,h,this.c),this.h.dispose(),this.h=g}else{const h=this.g.withScrollPosition(a);this.h=E.start(this.g,h,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const a=this.h.tick(),f=this.g.withScrollPosition(a);if(this.n(f,!0),!!this.h){if(a.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(a,f){const h=this.g;h.equals(a)||(this.g=a,this.j.fire(this.g.createScrollEvent(h,f)))}}e.$gu=A;class R{constructor(a,f,h){this.scrollLeft=a,this.scrollTop=f,this.isDone=h}}e.$hu=R;function v(b,a){const f=a-b;return function(h){return b+f*p(h)}}function s(b,a,f){return function(h){return h<f?b(h/f):a((h-f)/(1-f))}}class E{constructor(a,f,h,g){this.from=a,this.to=f,this.duration=g,this.startTime=h,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(a,f,h){if(Math.abs(a-f)>2.5*h){let w,m;return a<f?(w=a+.75*h,m=f-.75*h):(w=a-.75*h,m=f+.75*h),s(v(a,w),v(m,f),.33)}return v(a,f)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(a){this.to=a.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(a){const f=(a-this.startTime)/this.duration;if(f<1){const h=this.c(f),g=this.d(f);return new R(h,g,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(a,f,h){return E.start(a,f,h)}static start(a,f,h){h=h+10;const g=Date.now()-10;return new E(a,f,g,h)}}e.$iu=E;function y(b){return Math.pow(b,3)}function p(b){return 1-y(1-b)}}),define(Ee[56],Se([1,0,10,2]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=S,e.$ve=D,e.$we=A,e.$xe=R,e.$ye=s,e.$ze=E,e.$Ae=y,e.$Be=p,e.$Ce=b,e.$De=a,e.$Ee=f,e.$Fe=h,e.$Ge=g,e.$He=w,e.$Ie=m;function S($){const l=$;return l?typeof l.read=="function":!1}function D($){const l=$;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}function A($){const l=$;return l?D(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}function R($,l){return new v($,l)}class v{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,n.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let o;switch(l){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const d=o.indexOf(t);d>=0&&o.splice(d,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s($,l){const t=[];let o;for(;(o=$.read())!==null;)t.push(o);return l(t)}function E($,l,t){const o=[];let d;for(;(d=$.read())!==null&&o.length<t;)o.push(d);return d===null&&o.length>0?l(o):{read:()=>{if(o.length>0)return o.shift();if(typeof d<"u"){const i=d;return d=void 0,i}return $.read()}}}function y($,l){return new Promise((t,o)=>{const d=[];p($,{onData:i=>{l&&d.push(i)},onError:i=>{l?o(i):t(void 0)},onEnd:()=>{t(l?l(d):void 0)}})})}function p($,l,t){$.on("error",o=>{t?.isCancellationRequested||l.onError(o)}),$.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),$.on("data",o=>{t?.isCancellationRequested||l.onData(o)})}function b($,l){return new Promise((t,o)=>{const d=new r.$Tc,i=[],c=I=>{if(i.push(I),i.length>l)return d.dispose(),$.pause(),t({stream:$,buffer:i,ended:!1})},u=I=>(d.dispose(),o(I)),k=()=>(d.dispose(),t({stream:$,buffer:i,ended:!0}));d.add((0,r.$Sc)(()=>$.removeListener("error",u))),$.on("error",u),d.add((0,r.$Sc)(()=>$.removeListener("end",k))),$.on("end",k),d.add((0,r.$Sc)(()=>$.removeListener("data",c))),$.on("data",c)})}function a($,l){const t=R(l);return t.end($),t}function f(){const $=R(()=>{throw new Error("not supported")});return $.end(),$}function h($){let l=!1;return{read:()=>l?null:(l=!0,$)}}function g($,l,t){const o=R(t);return p($,{onData:d=>o.write(l.data(d)),onError:d=>o.error(l.error?l.error(d):d),onEnd:()=>o.end()}),o}function w($,l,t){let o=!1;return{read:()=>{const d=l.read();return o?d:(o=!0,d!==null?t([$,d]):$)}}}function m($,l,t){let o=!1;const d=R(t);return p(l,{onData:i=>o?d.write(i):(o=!0,d.write(t([$,i]))),onError:i=>d.error(i),onEnd:()=>{o||(o=!0,d.write($)),d.end()}}),d}}),define(Ee[15],Se([1,0,65,56]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=s,e.$Le=E,e.$Me=y,e.$Ne=p,e.$Oe=b,e.$Pe=a,e.$Qe=f,e.$Re=h,e.$Se=g,e.$Te=w,e.$Ue=m,e.$Ve=$,e.$We=l,e.$Xe=t,e.$Ye=o,e.$Ze=d,e.$1e=i,e.$2e=c,e.$3e=u,e.$4e=C;const S=typeof Buffer<"u",D=new n.$V(()=>new Uint8Array(256));let A,R;class v{static alloc(O){return S?new v(Buffer.allocUnsafe(O)):new v(new Uint8Array(O))}static wrap(O){return S&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new v(O)}static fromString(O,P){return!(P?.dontUseNodeBuffer||!1)&&S?new v(Buffer.from(O)):(A||(A=new TextEncoder),new v(A.encode(O)))}static fromByteArray(O){const P=v.alloc(O.length);for(let V=0,Q=O.length;V<Q;V++)P.buffer[V]=O[V];return P}static concat(O,P){if(typeof P>"u"){P=0;for(let ie=0,re=O.length;ie<re;ie++)P+=O[ie].byteLength}const V=v.alloc(P);let Q=0;for(let ie=0,re=O.length;ie<re;ie++){const ne=O[ie];V.set(ne,Q),Q+=ne.byteLength}return V}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=v.alloc(this.byteLength);return O.set(this),O}toString(){return S?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(O,P){return new v(this.buffer.subarray(O,P))}set(O,P){if(O instanceof v)this.buffer.set(O.buffer,P);else if(O instanceof Uint8Array)this.buffer.set(O,P);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),P);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return p(this.buffer,O)}writeUInt32BE(O,P){b(this.buffer,O,P)}readUInt32LE(O){return a(this.buffer,O)}writeUInt32LE(O,P){f(this.buffer,O,P)}readUInt8(O){return h(this.buffer,O)}writeUInt8(O,P){g(this.buffer,O,P)}indexOf(O,P=0){return s(this.buffer,O instanceof v?O.buffer:O,P)}}e.$Je=v;function s(T,O,P=0){const V=O.byteLength,Q=T.byteLength;if(V===0)return 0;if(V===1)return T.indexOf(O[0]);if(V>Q-P)return-1;const ie=D.value;ie.fill(O.length);for(let Z=0;Z<O.length;Z++)ie[O[Z]]=O.length-Z-1;let re=P+O.length-1,ne=re,se=-1;for(;re<Q;)if(T[re]===O[ne]){if(ne===0){se=re;break}re--,ne--}else re+=Math.max(O.length-ne,ie[T[re]]),ne=O.length-1;return se}function E(T,O){return T[O+0]<<0>>>0|T[O+1]<<8>>>0}function y(T,O,P){T[P+0]=O&255,O=O>>>8,T[P+1]=O&255}function p(T,O){return T[O]*2**24+T[O+1]*2**16+T[O+2]*2**8+T[O+3]}function b(T,O,P){T[P+3]=O,O=O>>>8,T[P+2]=O,O=O>>>8,T[P+1]=O,O=O>>>8,T[P]=O}function a(T,O){return T[O+0]<<0>>>0|T[O+1]<<8>>>0|T[O+2]<<16>>>0|T[O+3]<<24>>>0}function f(T,O,P){T[P+0]=O&255,O=O>>>8,T[P+1]=O&255,O=O>>>8,T[P+2]=O&255,O=O>>>8,T[P+3]=O&255}function h(T,O){return T[O]}function g(T,O,P){T[P]=O}function w(T){return r.$ye(T,O=>v.concat(O))}function m(T){return r.$Fe(T)}function $(T){return r.$Ae(T,O=>v.concat(O))}async function l(T){return T.ended?v.concat(T.buffer):v.concat([...T.buffer,await $(T.stream)])}function t(T){return r.$De(T,O=>v.concat(O))}function o(T){return r.$Ge(T,{data:O=>typeof O=="string"?v.fromString(O):v.wrap(O)},O=>v.concat(O))}function d(T){return r.$xe(O=>v.concat(O),T)}function i(T,O){return r.$He(T,O,P=>v.concat(P))}function c(T,O){return r.$Ie(T,O,P=>v.concat(P))}function u(T){let O=0,P=0,V=0;const Q=new Uint8Array(Math.floor(T.length/4*3)),ie=ne=>{switch(P){case 3:Q[V++]=O|ne,P=0;break;case 2:Q[V++]=O|ne>>>2,O=ne<<6,P=3;break;case 1:Q[V++]=O|ne>>>4,O=ne<<4,P=2;break;default:O=ne<<2,P=1}};for(let ne=0;ne<T.length;ne++){const se=T.charCodeAt(ne);if(se>=65&&se<=90)ie(se-65);else if(se>=97&&se<=122)ie(se-97+26);else if(se>=48&&se<=57)ie(se-48+52);else if(se===43||se===45)ie(62);else if(se===47||se===95)ie(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ne]}`)}}const re=V;for(;P>0;)ie(0);return v.wrap(Q).slice(0,re)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:T},O=!0,P=!1){const V=P?I:k;let Q="";const ie=T.byteLength%3;let re=0;for(;re<T.byteLength-ie;re+=3){const ne=T[re+0],se=T[re+1],Z=T[re+2];Q+=V[ne>>>2],Q+=V[(ne<<4|se>>>4)&63],Q+=V[(se<<2|Z>>>6)&63],Q+=V[Z&63]}if(ie===1){const ne=T[re+0];Q+=V[ne>>>2],Q+=V[ne<<4&63],O&&(Q+="==")}else if(ie===2){const ne=T[re+0],se=T[re+1];Q+=V[ne>>>2],Q+=V[(ne<<4|se>>>4)&63],Q+=V[se<<2&63],O&&(Q+="=")}return Q}}),define(Ee[170],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(Ee[11],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=n,e.$bg=r,e.$cg=S,e.$dg=D,e.$eg=A,e.$fg=R,e.$gg=v,e.$hg=s,e.$ig=E,e.$jg=y,e.$kg=p,e.$lg=b,e.$mg=a,e.$ng=h,e.$og=g,e.$pg=w,e.$qg=m,e.$rg=$;function n(l){return typeof l=="string"}function r(l){return Array.isArray(l)&&l.every(t=>n(t))}function S(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function D(l){const t=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof t}function A(l){return typeof l=="number"&&!isNaN(l)}function R(l){return!!l&&typeof l[Symbol.iterator]=="function"}function v(l){return l===!0||l===!1}function s(l){return typeof l>"u"}function E(l){return!y(l)}function y(l){return s(l)||l===null}function p(l,t){if(!l)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function b(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function a(...l){const t=[];for(let o=0;o<l.length;o++){const d=l[o];if(y(d))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(d)}return t}const f=Object.prototype.hasOwnProperty;function h(l){if(!S(l))return!1;for(const t in l)if(f.call(l,t))return!1;return!0}function g(l){return typeof l=="function"}function w(...l){return l.length>0&&l.every(g)}function m(l,t){const o=Math.min(l.length,t.length);for(let d=0;d<o;d++)$(l[d],t[d])}function $(l,t){if(n(t)){if(typeof l!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(l instanceof t)return}catch{}if(!y(l)&&l.constructor===t||t.length===1&&t.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[108],Se([1,0,11]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=S,e.$Vj=D;const r=Object.create(null);function S(A,R){if((0,n.$ag)(R)){const v=r[R];if(v===void 0)throw new Error(`${A} references an unknown codicon: ${R}`);R=v}return r[A]=R,{id:A}}function D(){return r}}),define(Ee[171],Se([1,0,108]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=void 0,e.$Wj={add:(0,n.$Uj)("add",6e4),plus:(0,n.$Uj)("plus",6e4),gistNew:(0,n.$Uj)("gist-new",6e4),repoCreate:(0,n.$Uj)("repo-create",6e4),lightbulb:(0,n.$Uj)("lightbulb",60001),lightBulb:(0,n.$Uj)("light-bulb",60001),repo:(0,n.$Uj)("repo",60002),repoDelete:(0,n.$Uj)("repo-delete",60002),gistFork:(0,n.$Uj)("gist-fork",60003),repoForked:(0,n.$Uj)("repo-forked",60003),gitPullRequest:(0,n.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Uj)("record-keys",60005),keyboard:(0,n.$Uj)("keyboard",60005),tag:(0,n.$Uj)("tag",60006),gitPullRequestLabel:(0,n.$Uj)("git-pull-request-label",60006),tagAdd:(0,n.$Uj)("tag-add",60006),tagRemove:(0,n.$Uj)("tag-remove",60006),person:(0,n.$Uj)("person",60007),personFollow:(0,n.$Uj)("person-follow",60007),personOutline:(0,n.$Uj)("person-outline",60007),personFilled:(0,n.$Uj)("person-filled",60007),gitBranch:(0,n.$Uj)("git-branch",60008),gitBranchCreate:(0,n.$Uj)("git-branch-create",60008),gitBranchDelete:(0,n.$Uj)("git-branch-delete",60008),sourceControl:(0,n.$Uj)("source-control",60008),mirror:(0,n.$Uj)("mirror",60009),mirrorPublic:(0,n.$Uj)("mirror-public",60009),star:(0,n.$Uj)("star",60010),starAdd:(0,n.$Uj)("star-add",60010),starDelete:(0,n.$Uj)("star-delete",60010),starEmpty:(0,n.$Uj)("star-empty",60010),comment:(0,n.$Uj)("comment",60011),commentAdd:(0,n.$Uj)("comment-add",60011),alert:(0,n.$Uj)("alert",60012),warning:(0,n.$Uj)("warning",60012),search:(0,n.$Uj)("search",60013),searchSave:(0,n.$Uj)("search-save",60013),logOut:(0,n.$Uj)("log-out",60014),signOut:(0,n.$Uj)("sign-out",60014),logIn:(0,n.$Uj)("log-in",60015),signIn:(0,n.$Uj)("sign-in",60015),eye:(0,n.$Uj)("eye",60016),eyeUnwatch:(0,n.$Uj)("eye-unwatch",60016),eyeWatch:(0,n.$Uj)("eye-watch",60016),circleFilled:(0,n.$Uj)("circle-filled",60017),primitiveDot:(0,n.$Uj)("primitive-dot",60017),closeDirty:(0,n.$Uj)("close-dirty",60017),debugBreakpoint:(0,n.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Uj)("primitive-square",60018),edit:(0,n.$Uj)("edit",60019),pencil:(0,n.$Uj)("pencil",60019),info:(0,n.$Uj)("info",60020),issueOpened:(0,n.$Uj)("issue-opened",60020),gistPrivate:(0,n.$Uj)("gist-private",60021),gitForkPrivate:(0,n.$Uj)("git-fork-private",60021),lock:(0,n.$Uj)("lock",60021),mirrorPrivate:(0,n.$Uj)("mirror-private",60021),close:(0,n.$Uj)("close",60022),removeClose:(0,n.$Uj)("remove-close",60022),x:(0,n.$Uj)("x",60022),repoSync:(0,n.$Uj)("repo-sync",60023),sync:(0,n.$Uj)("sync",60023),clone:(0,n.$Uj)("clone",60024),desktopDownload:(0,n.$Uj)("desktop-download",60024),beaker:(0,n.$Uj)("beaker",60025),microscope:(0,n.$Uj)("microscope",60025),vm:(0,n.$Uj)("vm",60026),deviceDesktop:(0,n.$Uj)("device-desktop",60026),file:(0,n.$Uj)("file",60027),fileText:(0,n.$Uj)("file-text",60027),more:(0,n.$Uj)("more",60028),ellipsis:(0,n.$Uj)("ellipsis",60028),kebabHorizontal:(0,n.$Uj)("kebab-horizontal",60028),mailReply:(0,n.$Uj)("mail-reply",60029),reply:(0,n.$Uj)("reply",60029),organization:(0,n.$Uj)("organization",60030),organizationFilled:(0,n.$Uj)("organization-filled",60030),organizationOutline:(0,n.$Uj)("organization-outline",60030),newFile:(0,n.$Uj)("new-file",60031),fileAdd:(0,n.$Uj)("file-add",60031),newFolder:(0,n.$Uj)("new-folder",60032),fileDirectoryCreate:(0,n.$Uj)("file-directory-create",60032),trash:(0,n.$Uj)("trash",60033),trashcan:(0,n.$Uj)("trashcan",60033),history:(0,n.$Uj)("history",60034),clock:(0,n.$Uj)("clock",60034),folder:(0,n.$Uj)("folder",60035),fileDirectory:(0,n.$Uj)("file-directory",60035),symbolFolder:(0,n.$Uj)("symbol-folder",60035),logoGithub:(0,n.$Uj)("logo-github",60036),markGithub:(0,n.$Uj)("mark-github",60036),github:(0,n.$Uj)("github",60036),terminal:(0,n.$Uj)("terminal",60037),console:(0,n.$Uj)("console",60037),repl:(0,n.$Uj)("repl",60037),zap:(0,n.$Uj)("zap",60038),symbolEvent:(0,n.$Uj)("symbol-event",60038),error:(0,n.$Uj)("error",60039),stop:(0,n.$Uj)("stop",60039),variable:(0,n.$Uj)("variable",60040),symbolVariable:(0,n.$Uj)("symbol-variable",60040),array:(0,n.$Uj)("array",60042),symbolArray:(0,n.$Uj)("symbol-array",60042),symbolModule:(0,n.$Uj)("symbol-module",60043),symbolPackage:(0,n.$Uj)("symbol-package",60043),symbolNamespace:(0,n.$Uj)("symbol-namespace",60043),symbolObject:(0,n.$Uj)("symbol-object",60043),symbolMethod:(0,n.$Uj)("symbol-method",60044),symbolFunction:(0,n.$Uj)("symbol-function",60044),symbolConstructor:(0,n.$Uj)("symbol-constructor",60044),symbolBoolean:(0,n.$Uj)("symbol-boolean",60047),symbolNull:(0,n.$Uj)("symbol-null",60047),symbolNumeric:(0,n.$Uj)("symbol-numeric",60048),symbolNumber:(0,n.$Uj)("symbol-number",60048),symbolStructure:(0,n.$Uj)("symbol-structure",60049),symbolStruct:(0,n.$Uj)("symbol-struct",60049),symbolParameter:(0,n.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Uj)("symbol-type-parameter",60050),symbolKey:(0,n.$Uj)("symbol-key",60051),symbolText:(0,n.$Uj)("symbol-text",60051),symbolReference:(0,n.$Uj)("symbol-reference",60052),goToFile:(0,n.$Uj)("go-to-file",60052),symbolEnum:(0,n.$Uj)("symbol-enum",60053),symbolValue:(0,n.$Uj)("symbol-value",60053),symbolRuler:(0,n.$Uj)("symbol-ruler",60054),symbolUnit:(0,n.$Uj)("symbol-unit",60054),activateBreakpoints:(0,n.$Uj)("activate-breakpoints",60055),archive:(0,n.$Uj)("archive",60056),arrowBoth:(0,n.$Uj)("arrow-both",60057),arrowDown:(0,n.$Uj)("arrow-down",60058),arrowLeft:(0,n.$Uj)("arrow-left",60059),arrowRight:(0,n.$Uj)("arrow-right",60060),arrowSmallDown:(0,n.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Uj)("arrow-small-up",60064),arrowUp:(0,n.$Uj)("arrow-up",60065),bell:(0,n.$Uj)("bell",60066),bold:(0,n.$Uj)("bold",60067),book:(0,n.$Uj)("book",60068),bookmark:(0,n.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Uj)("briefcase",60076),broadcast:(0,n.$Uj)("broadcast",60077),browser:(0,n.$Uj)("browser",60078),bug:(0,n.$Uj)("bug",60079),calendar:(0,n.$Uj)("calendar",60080),caseSensitive:(0,n.$Uj)("case-sensitive",60081),check:(0,n.$Uj)("check",60082),checklist:(0,n.$Uj)("checklist",60083),chevronDown:(0,n.$Uj)("chevron-down",60084),chevronLeft:(0,n.$Uj)("chevron-left",60085),chevronRight:(0,n.$Uj)("chevron-right",60086),chevronUp:(0,n.$Uj)("chevron-up",60087),chromeClose:(0,n.$Uj)("chrome-close",60088),chromeMaximize:(0,n.$Uj)("chrome-maximize",60089),chromeMinimize:(0,n.$Uj)("chrome-minimize",60090),chromeRestore:(0,n.$Uj)("chrome-restore",60091),circleOutline:(0,n.$Uj)("circle-outline",60092),circle:(0,n.$Uj)("circle",60092),debugBreakpointUnverified:(0,n.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Uj)("circle-slash",60093),circuitBoard:(0,n.$Uj)("circuit-board",60094),clearAll:(0,n.$Uj)("clear-all",60095),clippy:(0,n.$Uj)("clippy",60096),closeAll:(0,n.$Uj)("close-all",60097),cloudDownload:(0,n.$Uj)("cloud-download",60098),cloudUpload:(0,n.$Uj)("cloud-upload",60099),code:(0,n.$Uj)("code",60100),collapseAll:(0,n.$Uj)("collapse-all",60101),colorMode:(0,n.$Uj)("color-mode",60102),commentDiscussion:(0,n.$Uj)("comment-discussion",60103),creditCard:(0,n.$Uj)("credit-card",60105),dash:(0,n.$Uj)("dash",60108),dashboard:(0,n.$Uj)("dashboard",60109),database:(0,n.$Uj)("database",60110),debugContinue:(0,n.$Uj)("debug-continue",60111),debugDisconnect:(0,n.$Uj)("debug-disconnect",60112),debugPause:(0,n.$Uj)("debug-pause",60113),debugRestart:(0,n.$Uj)("debug-restart",60114),debugStart:(0,n.$Uj)("debug-start",60115),debugStepInto:(0,n.$Uj)("debug-step-into",60116),debugStepOut:(0,n.$Uj)("debug-step-out",60117),debugStepOver:(0,n.$Uj)("debug-step-over",60118),debugStop:(0,n.$Uj)("debug-stop",60119),debug:(0,n.$Uj)("debug",60120),deviceCameraVideo:(0,n.$Uj)("device-camera-video",60121),deviceCamera:(0,n.$Uj)("device-camera",60122),deviceMobile:(0,n.$Uj)("device-mobile",60123),diffAdded:(0,n.$Uj)("diff-added",60124),diffIgnored:(0,n.$Uj)("diff-ignored",60125),diffModified:(0,n.$Uj)("diff-modified",60126),diffRemoved:(0,n.$Uj)("diff-removed",60127),diffRenamed:(0,n.$Uj)("diff-renamed",60128),diff:(0,n.$Uj)("diff",60129),diffSidebyside:(0,n.$Uj)("diff-sidebyside",60129),discard:(0,n.$Uj)("discard",60130),editorLayout:(0,n.$Uj)("editor-layout",60131),emptyWindow:(0,n.$Uj)("empty-window",60132),exclude:(0,n.$Uj)("exclude",60133),extensions:(0,n.$Uj)("extensions",60134),eyeClosed:(0,n.$Uj)("eye-closed",60135),fileBinary:(0,n.$Uj)("file-binary",60136),fileCode:(0,n.$Uj)("file-code",60137),fileMedia:(0,n.$Uj)("file-media",60138),filePdf:(0,n.$Uj)("file-pdf",60139),fileSubmodule:(0,n.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Uj)("file-symlink-file",60142),fileZip:(0,n.$Uj)("file-zip",60143),files:(0,n.$Uj)("files",60144),filter:(0,n.$Uj)("filter",60145),flame:(0,n.$Uj)("flame",60146),foldDown:(0,n.$Uj)("fold-down",60147),foldUp:(0,n.$Uj)("fold-up",60148),fold:(0,n.$Uj)("fold",60149),folderActive:(0,n.$Uj)("folder-active",60150),folderOpened:(0,n.$Uj)("folder-opened",60151),gear:(0,n.$Uj)("gear",60152),gift:(0,n.$Uj)("gift",60153),gistSecret:(0,n.$Uj)("gist-secret",60154),gist:(0,n.$Uj)("gist",60155),gitCommit:(0,n.$Uj)("git-commit",60156),gitCompare:(0,n.$Uj)("git-compare",60157),compareChanges:(0,n.$Uj)("compare-changes",60157),gitMerge:(0,n.$Uj)("git-merge",60158),githubAction:(0,n.$Uj)("github-action",60159),githubAlt:(0,n.$Uj)("github-alt",60160),globe:(0,n.$Uj)("globe",60161),grabber:(0,n.$Uj)("grabber",60162),graph:(0,n.$Uj)("graph",60163),gripper:(0,n.$Uj)("gripper",60164),heart:(0,n.$Uj)("heart",60165),home:(0,n.$Uj)("home",60166),horizontalRule:(0,n.$Uj)("horizontal-rule",60167),hubot:(0,n.$Uj)("hubot",60168),inbox:(0,n.$Uj)("inbox",60169),issueReopened:(0,n.$Uj)("issue-reopened",60171),issues:(0,n.$Uj)("issues",60172),italic:(0,n.$Uj)("italic",60173),jersey:(0,n.$Uj)("jersey",60174),json:(0,n.$Uj)("json",60175),kebabVertical:(0,n.$Uj)("kebab-vertical",60176),key:(0,n.$Uj)("key",60177),law:(0,n.$Uj)("law",60178),lightbulbAutofix:(0,n.$Uj)("lightbulb-autofix",60179),linkExternal:(0,n.$Uj)("link-external",60180),link:(0,n.$Uj)("link",60181),listOrdered:(0,n.$Uj)("list-ordered",60182),listUnordered:(0,n.$Uj)("list-unordered",60183),liveShare:(0,n.$Uj)("live-share",60184),loading:(0,n.$Uj)("loading",60185),location:(0,n.$Uj)("location",60186),mailRead:(0,n.$Uj)("mail-read",60187),mail:(0,n.$Uj)("mail",60188),markdown:(0,n.$Uj)("markdown",60189),megaphone:(0,n.$Uj)("megaphone",60190),mention:(0,n.$Uj)("mention",60191),milestone:(0,n.$Uj)("milestone",60192),gitPullRequestMilestone:(0,n.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Uj)("mortar-board",60193),move:(0,n.$Uj)("move",60194),multipleWindows:(0,n.$Uj)("multiple-windows",60195),mute:(0,n.$Uj)("mute",60196),noNewline:(0,n.$Uj)("no-newline",60197),note:(0,n.$Uj)("note",60198),octoface:(0,n.$Uj)("octoface",60199),openPreview:(0,n.$Uj)("open-preview",60200),package:(0,n.$Uj)("package",60201),paintcan:(0,n.$Uj)("paintcan",60202),pin:(0,n.$Uj)("pin",60203),play:(0,n.$Uj)("play",60204),run:(0,n.$Uj)("run",60204),plug:(0,n.$Uj)("plug",60205),preserveCase:(0,n.$Uj)("preserve-case",60206),preview:(0,n.$Uj)("preview",60207),project:(0,n.$Uj)("project",60208),pulse:(0,n.$Uj)("pulse",60209),question:(0,n.$Uj)("question",60210),quote:(0,n.$Uj)("quote",60211),radioTower:(0,n.$Uj)("radio-tower",60212),reactions:(0,n.$Uj)("reactions",60213),references:(0,n.$Uj)("references",60214),refresh:(0,n.$Uj)("refresh",60215),regex:(0,n.$Uj)("regex",60216),remoteExplorer:(0,n.$Uj)("remote-explorer",60217),remote:(0,n.$Uj)("remote",60218),remove:(0,n.$Uj)("remove",60219),replaceAll:(0,n.$Uj)("replace-all",60220),replace:(0,n.$Uj)("replace",60221),repoClone:(0,n.$Uj)("repo-clone",60222),repoForcePush:(0,n.$Uj)("repo-force-push",60223),repoPull:(0,n.$Uj)("repo-pull",60224),repoPush:(0,n.$Uj)("repo-push",60225),report:(0,n.$Uj)("report",60226),requestChanges:(0,n.$Uj)("request-changes",60227),rocket:(0,n.$Uj)("rocket",60228),rootFolderOpened:(0,n.$Uj)("root-folder-opened",60229),rootFolder:(0,n.$Uj)("root-folder",60230),rss:(0,n.$Uj)("rss",60231),ruby:(0,n.$Uj)("ruby",60232),saveAll:(0,n.$Uj)("save-all",60233),saveAs:(0,n.$Uj)("save-as",60234),save:(0,n.$Uj)("save",60235),screenFull:(0,n.$Uj)("screen-full",60236),screenNormal:(0,n.$Uj)("screen-normal",60237),searchStop:(0,n.$Uj)("search-stop",60238),server:(0,n.$Uj)("server",60240),settingsGear:(0,n.$Uj)("settings-gear",60241),settings:(0,n.$Uj)("settings",60242),shield:(0,n.$Uj)("shield",60243),smiley:(0,n.$Uj)("smiley",60244),sortPrecedence:(0,n.$Uj)("sort-precedence",60245),splitHorizontal:(0,n.$Uj)("split-horizontal",60246),splitVertical:(0,n.$Uj)("split-vertical",60247),squirrel:(0,n.$Uj)("squirrel",60248),starFull:(0,n.$Uj)("star-full",60249),starHalf:(0,n.$Uj)("star-half",60250),symbolClass:(0,n.$Uj)("symbol-class",60251),symbolColor:(0,n.$Uj)("symbol-color",60252),symbolConstant:(0,n.$Uj)("symbol-constant",60253),symbolEnumMember:(0,n.$Uj)("symbol-enum-member",60254),symbolField:(0,n.$Uj)("symbol-field",60255),symbolFile:(0,n.$Uj)("symbol-file",60256),symbolInterface:(0,n.$Uj)("symbol-interface",60257),symbolKeyword:(0,n.$Uj)("symbol-keyword",60258),symbolMisc:(0,n.$Uj)("symbol-misc",60259),symbolOperator:(0,n.$Uj)("symbol-operator",60260),symbolProperty:(0,n.$Uj)("symbol-property",60261),wrench:(0,n.$Uj)("wrench",60261),wrenchSubaction:(0,n.$Uj)("wrench-subaction",60261),symbolSnippet:(0,n.$Uj)("symbol-snippet",60262),tasklist:(0,n.$Uj)("tasklist",60263),telescope:(0,n.$Uj)("telescope",60264),textSize:(0,n.$Uj)("text-size",60265),threeBars:(0,n.$Uj)("three-bars",60266),thumbsdown:(0,n.$Uj)("thumbsdown",60267),thumbsup:(0,n.$Uj)("thumbsup",60268),tools:(0,n.$Uj)("tools",60269),triangleDown:(0,n.$Uj)("triangle-down",60270),triangleLeft:(0,n.$Uj)("triangle-left",60271),triangleRight:(0,n.$Uj)("triangle-right",60272),triangleUp:(0,n.$Uj)("triangle-up",60273),twitter:(0,n.$Uj)("twitter",60274),unfold:(0,n.$Uj)("unfold",60275),unlock:(0,n.$Uj)("unlock",60276),unmute:(0,n.$Uj)("unmute",60277),unverified:(0,n.$Uj)("unverified",60278),verified:(0,n.$Uj)("verified",60279),versions:(0,n.$Uj)("versions",60280),vmActive:(0,n.$Uj)("vm-active",60281),vmOutline:(0,n.$Uj)("vm-outline",60282),vmRunning:(0,n.$Uj)("vm-running",60283),watch:(0,n.$Uj)("watch",60284),whitespace:(0,n.$Uj)("whitespace",60285),wholeWord:(0,n.$Uj)("whole-word",60286),window:(0,n.$Uj)("window",60287),wordWrap:(0,n.$Uj)("word-wrap",60288),zoomIn:(0,n.$Uj)("zoom-in",60289),zoomOut:(0,n.$Uj)("zoom-out",60290),listFilter:(0,n.$Uj)("list-filter",60291),listFlat:(0,n.$Uj)("list-flat",60292),listSelection:(0,n.$Uj)("list-selection",60293),selection:(0,n.$Uj)("selection",60293),listTree:(0,n.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Uj)("symbol-string",60301),debugReverseContinue:(0,n.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Uj)("debug-step-back",60303),debugRestartFrame:(0,n.$Uj)("debug-restart-frame",60304),debugAlt:(0,n.$Uj)("debug-alt",60305),callIncoming:(0,n.$Uj)("call-incoming",60306),callOutgoing:(0,n.$Uj)("call-outgoing",60307),menu:(0,n.$Uj)("menu",60308),expandAll:(0,n.$Uj)("expand-all",60309),feedback:(0,n.$Uj)("feedback",60310),gitPullRequestReviewer:(0,n.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Uj)("ungroup-by-ref-type",60312),account:(0,n.$Uj)("account",60313),gitPullRequestAssignee:(0,n.$Uj)("git-pull-request-assignee",60313),bellDot:(0,n.$Uj)("bell-dot",60314),debugConsole:(0,n.$Uj)("debug-console",60315),library:(0,n.$Uj)("library",60316),output:(0,n.$Uj)("output",60317),runAll:(0,n.$Uj)("run-all",60318),syncIgnored:(0,n.$Uj)("sync-ignored",60319),pinned:(0,n.$Uj)("pinned",60320),githubInverted:(0,n.$Uj)("github-inverted",60321),serverProcess:(0,n.$Uj)("server-process",60322),serverEnvironment:(0,n.$Uj)("server-environment",60323),pass:(0,n.$Uj)("pass",60324),issueClosed:(0,n.$Uj)("issue-closed",60324),stopCircle:(0,n.$Uj)("stop-circle",60325),playCircle:(0,n.$Uj)("play-circle",60326),record:(0,n.$Uj)("record",60327),debugAltSmall:(0,n.$Uj)("debug-alt-small",60328),vmConnect:(0,n.$Uj)("vm-connect",60329),cloud:(0,n.$Uj)("cloud",60330),merge:(0,n.$Uj)("merge",60331),export:(0,n.$Uj)("export",60332),graphLeft:(0,n.$Uj)("graph-left",60333),magnet:(0,n.$Uj)("magnet",60334),notebook:(0,n.$Uj)("notebook",60335),redo:(0,n.$Uj)("redo",60336),checkAll:(0,n.$Uj)("check-all",60337),pinnedDirty:(0,n.$Uj)("pinned-dirty",60338),passFilled:(0,n.$Uj)("pass-filled",60339),circleLargeFilled:(0,n.$Uj)("circle-large-filled",60340),circleLarge:(0,n.$Uj)("circle-large",60341),circleLargeOutline:(0,n.$Uj)("circle-large-outline",60341),combine:(0,n.$Uj)("combine",60342),gather:(0,n.$Uj)("gather",60342),table:(0,n.$Uj)("table",60343),variableGroup:(0,n.$Uj)("variable-group",60344),typeHierarchy:(0,n.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Uj)("git-pull-request-create",60348),runAbove:(0,n.$Uj)("run-above",60349),runBelow:(0,n.$Uj)("run-below",60350),notebookTemplate:(0,n.$Uj)("notebook-template",60351),debugRerun:(0,n.$Uj)("debug-rerun",60352),workspaceTrusted:(0,n.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Uj)("workspace-unknown",60355),terminalCmd:(0,n.$Uj)("terminal-cmd",60356),terminalDebian:(0,n.$Uj)("terminal-debian",60357),terminalLinux:(0,n.$Uj)("terminal-linux",60358),terminalPowershell:(0,n.$Uj)("terminal-powershell",60359),terminalTmux:(0,n.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Uj)("terminal-ubuntu",60361),terminalBash:(0,n.$Uj)("terminal-bash",60362),arrowSwap:(0,n.$Uj)("arrow-swap",60363),copy:(0,n.$Uj)("copy",60364),personAdd:(0,n.$Uj)("person-add",60365),filterFilled:(0,n.$Uj)("filter-filled",60366),wand:(0,n.$Uj)("wand",60367),debugLineByLine:(0,n.$Uj)("debug-line-by-line",60368),inspect:(0,n.$Uj)("inspect",60369),layers:(0,n.$Uj)("layers",60370),layersDot:(0,n.$Uj)("layers-dot",60371),layersActive:(0,n.$Uj)("layers-active",60372),compass:(0,n.$Uj)("compass",60373),compassDot:(0,n.$Uj)("compass-dot",60374),compassActive:(0,n.$Uj)("compass-active",60375),azure:(0,n.$Uj)("azure",60376),issueDraft:(0,n.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Uj)("git-pull-request-draft",60379),debugAll:(0,n.$Uj)("debug-all",60380),debugCoverage:(0,n.$Uj)("debug-coverage",60381),runErrors:(0,n.$Uj)("run-errors",60382),folderLibrary:(0,n.$Uj)("folder-library",60383),debugContinueSmall:(0,n.$Uj)("debug-continue-small",60384),beakerStop:(0,n.$Uj)("beaker-stop",60385),graphLine:(0,n.$Uj)("graph-line",60386),graphScatter:(0,n.$Uj)("graph-scatter",60387),pieChart:(0,n.$Uj)("pie-chart",60388),bracket:(0,n.$Uj)("bracket",60175),bracketDot:(0,n.$Uj)("bracket-dot",60389),bracketError:(0,n.$Uj)("bracket-error",60390),lockSmall:(0,n.$Uj)("lock-small",60391),azureDevops:(0,n.$Uj)("azure-devops",60392),verifiedFilled:(0,n.$Uj)("verified-filled",60393),newline:(0,n.$Uj)("newline",60394),layout:(0,n.$Uj)("layout",60395),layoutActivitybarLeft:(0,n.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Uj)("layout-panel-right",60401),layoutPanel:(0,n.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Uj)("layout-statusbar",60405),layoutMenubar:(0,n.$Uj)("layout-menubar",60406),layoutCentered:(0,n.$Uj)("layout-centered",60407),target:(0,n.$Uj)("target",60408),indent:(0,n.$Uj)("indent",60409),recordSmall:(0,n.$Uj)("record-small",60410),errorSmall:(0,n.$Uj)("error-small",60411),terminalDecorationError:(0,n.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Uj)("layout-sidebar-left-off",60418),blank:(0,n.$Uj)("blank",60419),heartFilled:(0,n.$Uj)("heart-filled",60420),map:(0,n.$Uj)("map",60421),mapHorizontal:(0,n.$Uj)("map-horizontal",60421),foldHorizontal:(0,n.$Uj)("fold-horizontal",60421),mapFilled:(0,n.$Uj)("map-filled",60422),mapHorizontalFilled:(0,n.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Uj)("circle-small",60423),bellSlash:(0,n.$Uj)("bell-slash",60424),bellSlashDot:(0,n.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Uj)("search-fuzzy",60429),commentDraft:(0,n.$Uj)("comment-draft",60430),send:(0,n.$Uj)("send",60431),sparkle:(0,n.$Uj)("sparkle",60432),insert:(0,n.$Uj)("insert",60433),mic:(0,n.$Uj)("mic",60434),thumbsdownFilled:(0,n.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Uj)("thumbsup-filled",60436),coffee:(0,n.$Uj)("coffee",60437),snake:(0,n.$Uj)("snake",60438),game:(0,n.$Uj)("game",60439),vr:(0,n.$Uj)("vr",60440),chip:(0,n.$Uj)("chip",60441),piano:(0,n.$Uj)("piano",60442),music:(0,n.$Uj)("music",60443),micFilled:(0,n.$Uj)("mic-filled",60444),repoFetch:(0,n.$Uj)("repo-fetch",60445),copilot:(0,n.$Uj)("copilot",60446),lightbulbSparkle:(0,n.$Uj)("lightbulb-sparkle",60447),robot:(0,n.$Uj)("robot",60448),sparkleFilled:(0,n.$Uj)("sparkle-filled",60449),diffSingle:(0,n.$Uj)("diff-single",60450),diffMultiple:(0,n.$Uj)("diff-multiple",60451),surroundWith:(0,n.$Uj)("surround-with",60452),share:(0,n.$Uj)("share",60453),gitStash:(0,n.$Uj)("git-stash",60454),gitStashApply:(0,n.$Uj)("git-stash-apply",60455),gitStashPop:(0,n.$Uj)("git-stash-pop",60456),vscode:(0,n.$Uj)("vscode",60457),vscodeInsiders:(0,n.$Uj)("vscode-insiders",60458),codeOss:(0,n.$Uj)("code-oss",60459),runCoverage:(0,n.$Uj)("run-coverage",60460),runAllCoverage:(0,n.$Uj)("run-all-coverage",60461),coverage:(0,n.$Uj)("coverage",60462),githubProject:(0,n.$Uj)("github-project",60463),mapVertical:(0,n.$Uj)("map-vertical",60464),foldVertical:(0,n.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Uj)("fold-vertical-filled",60465),goToSearch:(0,n.$Uj)("go-to-search",60466),percentage:(0,n.$Uj)("percentage",60467),sortPercentage:(0,n.$Uj)("sort-percentage",60467),attach:(0,n.$Uj)("attach",60468)}}),define(Ee[57],Se([1,0,108,171]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=void 0,e.$Xj=S;function S(){return Object.values(e.$Zj)}e.$Yj={dialogError:(0,n.$Uj)("dialog-error","error"),dialogWarning:(0,n.$Uj)("dialog-warning","warning"),dialogInfo:(0,n.$Uj)("dialog-info","info"),dialogClose:(0,n.$Uj)("dialog-close","close"),treeItemExpanded:(0,n.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Uj)("tree-item-loading","loading"),menuSelection:(0,n.$Uj)("menu-selection","check"),menuSubmenu:(0,n.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Uj)("toolbar-more","more"),quickInputBack:(0,n.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Uj)("drop-down-button",60084),symbolCustomColor:(0,n.$Uj)("symbol-customcolor",60252),exportIcon:(0,n.$Uj)("export",60332),workspaceUnspecified:(0,n.$Uj)("workspace-unspecified",60355),newLine:(0,n.$Uj)("newline",60394),thumbsDownFilled:(0,n.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Uj)("thumbsup-filled",60436),gitFetch:(0,n.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Uj)("debug-breakpoint-pending",60377)},e.$Zj={...r.$Wj,...e.$Yj}}),define(Ee[21],Se([1,0,11]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=r,e.$0n=S,e.$$n=A,e.$_n=v,e.$ao=s,e.$bo=E,e.$co=y,e.$do=p,e.$eo=b,e.$fo=a,e.$go=f,e.$ho=h,e.$io=g;function r(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const m=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([$,l])=>{m[$]=l&&typeof l=="object"?r(l):l}),m}function S(w){if(!w||typeof w!="object")return w;const m=[w];for(;m.length>0;){const $=m.shift();Object.freeze($);for(const l in $)if(D.call($,l)){const t=$[l];typeof t=="object"&&!Object.isFrozen(t)&&!(0,n.$dg)(t)&&m.push(t)}}return w}const D=Object.prototype.hasOwnProperty;function A(w,m){return R(w,m,new Set)}function R(w,m,$){if((0,n.$jg)(w))return w;const l=m(w);if(typeof l<"u")return l;if(Array.isArray(w)){const t=[];for(const o of w)t.push(R(o,m,$));return t}if((0,n.$cg)(w)){if($.has(w))throw new Error("Cannot clone recursive data-structure");$.add(w);const t={};for(const o in w)D.call(w,o)&&(t[o]=R(w[o],m,$));return $.delete(w),t}return w}function v(w,m,$=!0){return(0,n.$cg)(w)?((0,n.$cg)(m)&&Object.keys(m).forEach(l=>{l in w?$&&((0,n.$cg)(w[l])&&(0,n.$cg)(m[l])?v(w[l],m[l],$):w[l]=m[l]):w[l]=m[l]}),w):m}function s(w,m){if(w===m)return!0;if(w==null||m===null||m===void 0||typeof w!=typeof m||typeof w!="object"||Array.isArray(w)!==Array.isArray(m))return!1;let $,l;if(Array.isArray(w)){if(w.length!==m.length)return!1;for($=0;$<w.length;$++)if(!s(w[$],m[$]))return!1}else{const t=[];for(l in w)t.push(l);t.sort();const o=[];for(l in m)o.push(l);if(o.sort(),!s(t,o))return!1;for($=0;$<t.length;$++)if(!s(w[t[$]],m[t[$]]))return!1}return!0}function E(w){const m=new Set;return JSON.stringify(w,($,l)=>{if((0,n.$cg)(l)||Array.isArray(l)){if(m.has(l))return"[Circular]";m.add(l)}return typeof l=="bigint"?`[BigInt ${l.toString()}]`:l})}function y(w,m){const $=Object.create(null);return!w||!m||Object.keys(m).forEach(t=>{const o=w[t],d=m[t];s(o,d)||($[t]=d)}),$}function p(w,m){const $=m.toLowerCase(),l=Object.keys(w).find(t=>t.toLowerCase()===$);return l?w[l]:w[m]}function b(w,m){const $=Object.create(null);for(const[l,t]of Object.entries(w))m(l,t)&&($[l]=t);return $}function a(w){let m=[];for(;Object.prototype!==w;)m=m.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return m}function f(w){const m=[];for(const $ of a(w))typeof w[$]=="function"&&m.push($);return m}function h(w,m){const $=t=>function(){const o=Array.prototype.slice.call(arguments,0);return m(t,o)},l={};for(const t of w)l[t]=$(t);return l}function g(w,m){const $={};for(const[l,t]of Object.entries(w))$[l]=m(t,l);return $}}),define(Ee[81],Se([1,0,57]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=S;var r;(function(A){function R(v){return v&&typeof v=="object"&&typeof v.id=="string"}A.isThemeColor=R})(r||(e.ThemeColor=r={}));function S(A){return{id:A}}var D;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function v(w){const m=R.exec(w.id);if(!m)return v(n.$Zj.error);const[,$,l]=m,t=["codicon","codicon-"+$];return l&&t.push("codicon-modifier-"+l.substring(1)),t}A.asClassNameArray=v;function s(w){return v(w).join(" ")}A.asClassName=s;function E(w){return"."+v(w).join(".")}A.asCSSSelector=E;function y(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(typeof w.color>"u"||r.isThemeColor(w.color))}A.isThemeIcon=y;const p=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(w){const m=p.exec(w);if(!m)return;const[,$]=m;return{id:$}}A.fromString=b;function a(w){return{id:w}}A.fromId=a;function f(w,m){let $=w.id;const l=$.lastIndexOf("~");return l!==-1&&($=$.substring(0,l)),m&&($=`${$}~${m}`),{id:$}}A.modify=f;function h(w){const m=w.id.lastIndexOf("~");if(m!==-1)return w.id.substring(m+1)}A.getModifier=h;function g(w,m){return w.id===m.id&&w.color?.id===m.color?.id}A.isEqual=g})(D||(e.ThemeIcon=D={}))}),define(Ee[109],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=r,e.$0e=S;var n;(function(D){D[D.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",D[D.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",D[D.MAX_UINT_8=255]="MAX_UINT_8",D[D.MAX_UINT_16=65535]="MAX_UINT_16",D[D.MAX_UINT_32=4294967295]="MAX_UINT_32",D[D.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(D){return D<0?0:D>n.MAX_UINT_8?n.MAX_UINT_8:D|0}function S(D){return D<0?0:D>n.MAX_UINT_32?n.MAX_UINT_32:D|0}}),define(Ee[17],Se([1,0,168,35,65,109]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=A,e.$_e=v,e.$af=E,e.$bf=y,e.$cf=p,e.$df=b,e.$ef=a,e.$ff=f,e.$gf=h,e.$hf=g,e.$if=w,e.$jf=m,e.$kf=$,e.$lf=l,e.$mf=t,e.$nf=o,e.$of=d,e.$pf=i,e.$qf=c,e.$rf=u,e.$sf=k,e.$tf=I,e.$uf=C,e.$vf=T,e.$wf=O,e.$xf=P,e.$yf=V,e.$zf=Q,e.$Af=ie,e.$Bf=re,e.$Cf=ne,e.$Df=se,e.$Ef=Z,e.$Ff=ee,e.$Gf=ue,e.$Hf=j,e.$If=B,e.$Lf=q,e.$Mf=ae,e.$Nf=Y,e.$Of=H,e.$Pf=z,e.$Qf=J,e.$Sf=x,e.$Tf=M,e.$Uf=G,e.$Vf=te,e.$Wf=ke,e.$Xf=Ne,e.$Yf=be,e.$1f=Ae,e.$2f=Le,e.$3f=de,e.$4f=Ie,e.$5f=Re,e.$6f=Me,e.$7f=He,e.$8f=Ke,e.$9f=it;function A($e){return!$e||typeof $e!="string"?!0:$e.trim().length===0}const R=/{(\d+)}/g;function v($e,...Oe){return Oe.length===0?$e:$e.replace(R,function(ve,ye){const X=parseInt(ye,10);return isNaN(X)||X<0||X>=Oe.length?ve:Oe[X]})}const s=/{([^}]+)}/g;function E($e,Oe){return Object.keys(Oe).length===0?$e:$e.replace(s,(ve,ye)=>Oe[ye]??ve)}function y($e){return $e.replace(/[<>"'&]/g,Oe=>{switch(Oe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Oe})}function p($e){return $e.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}function b($e){return $e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function a($e,Oe){let ve=0,ye=$e.indexOf(Oe);for(;ye!==-1;)ve++,ye=$e.indexOf(Oe,ye+Oe.length);return ve}function f($e,Oe,ve="\u2026"){return $e.length<=Oe?$e:`${$e.substr(0,Oe)}${ve}`}function h($e,Oe,ve="\u2026"){if($e.length<=Oe)return $e;const ye=Math.ceil(Oe/2)-ve.length/2,X=Math.floor(Oe/2)-ve.length/2;return`${$e.substr(0,ye)}${ve}${$e.substr($e.length-X)}`}function g($e,Oe=" "){const ve=w($e,Oe);return m(ve,Oe)}function w($e,Oe){if(!$e||!Oe)return $e;const ve=Oe.length;if(ve===0||$e.length===0)return $e;let ye=0;for(;$e.indexOf(Oe,ye)===ye;)ye=ye+ve;return $e.substring(ye)}function m($e,Oe){if(!$e||!Oe)return $e;const ve=Oe.length,ye=$e.length;if(ve===0||ye===0)return $e;let X=ye,_=-1;for(;_=$e.lastIndexOf(Oe,X-1),!(_===-1||_+ve!==X);){if(_===0)return"";X=_}return $e.substring(0,X)}function $($e){return $e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l($e){return $e.replace(/\*/g,"")}function t($e,Oe,ve={}){if(!$e)throw new Error("Cannot create regex from empty string");Oe||($e=b($e)),ve.wholeWord&&(/\B/.test($e.charAt(0))||($e="\\b"+$e),/\B/.test($e.charAt($e.length-1))||($e=$e+"\\b"));let ye="";return ve.global&&(ye+="g"),ve.matchCase||(ye+="i"),ve.multiline&&(ye+="m"),ve.unicode&&(ye+="u"),new RegExp($e,ye)}function o($e){return $e.source==="^"||$e.source==="^$"||$e.source==="$"||$e.source==="^\\s*$"?!1:!!($e.exec("")&&$e.lastIndex===0)}function d($e){return $e.split(/\r\n|\r|\n/)}function i($e){const Oe=[],ve=$e.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(ve.length/2);ye++)Oe.push(ve[2*ye]+(ve[2*ye+1]??""));return Oe}function c($e){for(let Oe=0,ve=$e.length;Oe<ve;Oe++){const ye=$e.charCodeAt(Oe);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return Oe}return-1}function u($e,Oe=0,ve=$e.length){for(let ye=Oe;ye<ve;ye++){const X=$e.charCodeAt(ye);if(X!==r.CharCode.Space&&X!==r.CharCode.Tab)return $e.substring(Oe,ye)}return $e.substring(Oe,ve)}function k($e,Oe=$e.length-1){for(let ve=Oe;ve>=0;ve--){const ye=$e.charCodeAt(ve);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return ve}return-1}function I($e,Oe,ve){const ye=[];let X=0;for(const _ of $e.matchAll(Oe)){if(ye.push($e.slice(X,_.index)),_.index===void 0)throw new Error("match.index should be defined");X=_.index+_[0].length,ye.push(ve(_[0],..._.slice(1),_.index,$e,_.groups))}return ye.push($e.slice(X)),Promise.all(ye).then(_=>_.join(""))}function C($e,Oe){return $e<Oe?-1:$e>Oe?1:0}function T($e,Oe,ve=0,ye=$e.length,X=0,_=Oe.length){for(;ve<ye&&X<_;ve++,X++){const Ge=$e.charCodeAt(ve),Ye=Oe.charCodeAt(X);if(Ge<Ye)return-1;if(Ge>Ye)return 1}const we=ye-ve,ze=_-X;return we<ze?-1:we>ze?1:0}function O($e,Oe){return P($e,Oe,0,$e.length,0,Oe.length)}function P($e,Oe,ve=0,ye=$e.length,X=0,_=Oe.length){for(;ve<ye&&X<_;ve++,X++){let Ge=$e.charCodeAt(ve),Ye=Oe.charCodeAt(X);if(Ge===Ye)continue;if(Ge>=128||Ye>=128)return T($e.toLowerCase(),Oe.toLowerCase(),ve,ye,X,_);Q(Ge)&&(Ge-=32),Q(Ye)&&(Ye-=32);const et=Ge-Ye;if(et!==0)return et}const we=ye-ve,ze=_-X;return we<ze?-1:we>ze?1:0}function V($e){return $e>=r.CharCode.Digit0&&$e<=r.CharCode.Digit9}function Q($e){return $e>=r.CharCode.a&&$e<=r.CharCode.z}function ie($e){return $e>=r.CharCode.A&&$e<=r.CharCode.Z}function re($e,Oe){return $e.length===Oe.length&&P($e,Oe)===0}function ne($e,Oe){const ve=Oe.length;return Oe.length>$e.length?!1:P($e,Oe,0,ve)===0}function se($e,Oe){const ve=Math.min($e.length,Oe.length);let ye;for(ye=0;ye<ve;ye++)if($e.charCodeAt(ye)!==Oe.charCodeAt(ye))return ye;return ve}function Z($e,Oe){const ve=Math.min($e.length,Oe.length);let ye;const X=$e.length-1,_=Oe.length-1;for(ye=0;ye<ve;ye++)if($e.charCodeAt(X-ye)!==Oe.charCodeAt(_-ye))return ye;return ve}function ee($e){return 55296<=$e&&$e<=56319}function ue($e){return 56320<=$e&&$e<=57343}function j($e,Oe){return($e-55296<<10)+(Oe-56320)+65536}function B($e,Oe,ve){const ye=$e.charCodeAt(ve);if(ee(ye)&&ve+1<Oe){const X=$e.charCodeAt(ve+1);if(ue(X))return j(ye,X)}return ye}function oe($e,Oe){const ve=$e.charCodeAt(Oe-1);if(ue(ve)&&Oe>1){const ye=$e.charCodeAt(Oe-2);if(ee(ye))return j(ye,ve)}return ve}class le{get offset(){return this.e}constructor(Oe,ve=0){this.c=Oe,this.d=Oe.length,this.e=ve}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=oe(this.c,this.e);return this.e-=Oe>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Oe}nextCodePoint(){const Oe=B(this.c,this.d,this.e);return this.e+=Oe>=D.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Oe}eol(){return this.e>=this.d}}e.$Jf=le;class pe{get offset(){return this.c.offset}constructor(Oe,ve=0){this.c=new le(Oe,ve)}nextGraphemeLength(){const Oe=Ze.getInstance(),ve=this.c,ye=ve.offset;let X=Oe.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const _=ve.offset,we=Oe.getGraphemeBreakType(ve.nextCodePoint());if(We(X,we)){ve.setOffset(_);break}X=we}return ve.offset-ye}prevGraphemeLength(){const Oe=Ze.getInstance(),ve=this.c,ye=ve.offset;let X=Oe.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const _=ve.offset,we=Oe.getGraphemeBreakType(ve.prevCodePoint());if(We(we,X)){ve.setOffset(_);break}X=we}return ye-ve.offset}eol(){return this.c.eol()}}e.$Kf=pe;function q($e,Oe){return new pe($e,Oe).nextGraphemeLength()}function ae($e,Oe){return new pe($e,Oe).prevGraphemeLength()}function Y($e,Oe){Oe>0&&ue($e.charCodeAt(Oe))&&Oe--;const ve=Oe+q($e,Oe);return[ve-ae($e,ve),ve]}function H($e){const Oe=new pe($e);let ve=0;for(;!Oe.eol();)ve++,Oe.nextGraphemeLength();return ve}let L;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z($e){return L||(L=W()),L.test($e)}const U=/^[\t\n\r\x20-\x7E]*$/;function J($e){return U.test($e)}e.$Rf=/[\u2028\u2029]/;function x($e){return e.$Rf.test($e)}function M($e){return $e>=11904&&$e<=55215||$e>=63744&&$e<=64255||$e>=65281&&$e<=65374}function G($e){return $e>=127462&&$e<=127487||$e===8986||$e===8987||$e===9200||$e===9203||$e>=9728&&$e<=10175||$e===11088||$e===11093||$e>=127744&&$e<=128591||$e>=128640&&$e<=128764||$e>=128992&&$e<=129008||$e>=129280&&$e<=129535||$e>=129648&&$e<=129782}function te($e,Oe,ve=""){const ye=$e.trimStart();if(ye.length<Oe)return ye;const X=/\b/g;let _=0;for(;X.test(ye)&&!(ye.length-X.lastIndex<Oe);)_=X.lastIndex,X.lastIndex+=1;return _===0?ye:ve+ye.substring(_).trimStart()}const he=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ke($e){let Oe=0;for(const ve of $e.matchAll(he))Oe!==ve.index&&(yield{isCode:!1,str:$e.substring(Oe,ve.index)}),yield{isCode:!0,str:ve[0]},Oe=ve.index+ve[0].length;Oe!==$e.length&&(yield{isCode:!1,str:$e.substring(Oe)})}function Ne($e){return $e&&($e=$e.replace(he,"")),$e}const me=/\\\[.*?\\\]/g;function be($e){return Ne($e).replace(me,"")}e.$Zf=String.fromCharCode(r.CharCode.UTF8_BOM);function Ae($e){return!!($e&&$e.length>0&&$e.charCodeAt(0)===r.CharCode.UTF8_BOM)}function Le($e){return Ae($e)?$e.substr(1):$e}function de($e,Oe){if(!$e||!Oe||$e.length<Oe.length)return!1;const ve=Oe.length,ye=$e.toLowerCase();let X=0,_=-1;for(;X<ve;){const we=ye.indexOf(Oe[X],_+1);if(we<0)return!1;_=we,X++}return!0}function Ie($e,Oe=!1){return $e?(Oe&&($e=$e.replace(/\\./g,"")),$e.toLowerCase()!==$e):!1}function Re($e){return $e.charAt(0).toUpperCase()+$e.slice(1)}function Me($e,Oe=1){if(Oe===0)return"";let ve=-1;do ve=$e.indexOf(`
`,ve+1),Oe--;while(Oe>0&&ve>=0);return ve===-1?$e:($e[ve-1]==="\r"&&ve--,$e.substr(0,ve))}function He($e){const Oe=r.CharCode.Z-r.CharCode.A+1;return $e=$e%(2*Oe),$e<Oe?String.fromCharCode(r.CharCode.a+$e):String.fromCharCode(r.CharCode.A+$e-Oe)}function Ke($e){return Ze.getInstance().getGraphemeBreakType($e)}function We($e,Oe){return $e===Ve.Other?Oe!==Ve.Extend&&Oe!==Ve.SpacingMark:$e===Ve.CR&&Oe===Ve.LF?!1:$e===Ve.Control||$e===Ve.CR||$e===Ve.LF||Oe===Ve.Control||Oe===Ve.CR||Oe===Ve.LF?!0:!($e===Ve.L&&(Oe===Ve.L||Oe===Ve.V||Oe===Ve.LV||Oe===Ve.LVT)||($e===Ve.LV||$e===Ve.V)&&(Oe===Ve.V||Oe===Ve.T)||($e===Ve.LVT||$e===Ve.T)&&Oe===Ve.T||Oe===Ve.Extend||Oe===Ve.ZWJ||Oe===Ve.SpacingMark||$e===Ve.Prepend||$e===Ve.ZWJ&&Oe===Ve.Extended_Pictographic||$e===Ve.Regional_Indicator&&Oe===Ve.Regional_Indicator)}var Ve;(function($e){$e[$e.Other=0]="Other",$e[$e.Prepend=1]="Prepend",$e[$e.CR=2]="CR",$e[$e.LF=3]="LF",$e[$e.Control=4]="Control",$e[$e.Extend=5]="Extend",$e[$e.Regional_Indicator=6]="Regional_Indicator",$e[$e.SpacingMark=7]="SpacingMark",$e[$e.L=8]="L",$e[$e.V=9]="V",$e[$e.T=10]="T",$e[$e.LV=11]="LV",$e[$e.LVT=12]="LVT",$e[$e.ZWJ=13]="ZWJ",$e[$e.Extended_Pictographic=14]="Extended_Pictographic"})(Ve||(e.GraphemeBreakType=Ve={}));class Ze{static{this.c=null}static getInstance(){return Ze.c||(Ze.c=new Ze),Ze.c}constructor(){this.d=nt()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===r.CharCode.LineFeed?Ve.LF:Oe===r.CharCode.CarriageReturn?Ve.CR:Ve.Control;if(Oe<127)return Ve.Other;const ve=this.d,ye=ve.length/3;let X=1;for(;X<=ye;)if(Oe<ve[3*X])X=2*X;else if(Oe>ve[3*X+1])X=2*X+1;else return ve[3*X+2];return Ve.Other}}function nt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function it($e,Oe){if($e===0)return 0;const ve=ot($e,Oe);if(ve!==void 0)return ve;const ye=new le(Oe,$e);return ye.prevCodePoint(),ye.offset}function ot($e,Oe){const ve=new le(Oe,$e);let ye=ve.prevCodePoint();for(;tt(ye)||ye===_e.emojiVariantSelector||ye===_e.enclosingKeyCap;){if(ve.offset===0)return;ye=ve.prevCodePoint()}if(!G(ye))return;let X=ve.offset;return X>0&&ve.prevCodePoint()===_e.zwj&&(X=ve.offset),X}function tt($e){return 127995<=$e&&$e<=127999}var _e;(function($e){$e[$e.zwj=8205]="zwj",$e[$e.emojiVariantSelector=65039]="emojiVariantSelector",$e[$e.enclosingKeyCap=8419]="enclosingKeyCap"})(_e||(_e={})),e.$0f="\xA0";class Xe{static{this.c=new S.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$7e({getCacheKey:JSON.stringify},Oe=>{function ve(et){const lt=new Map;for(let ut=0;ut<et.length;ut+=2)lt.set(et[ut],et[ut+1]);return lt}function ye(et,lt){const ut=new Map(et);for(const[dt,Ct]of lt)ut.set(dt,Ct);return ut}function X(et,lt){if(!et)return lt;const ut=new Map;for(const[dt,Ct]of et)lt.has(dt)&&ut.set(dt,Ct);return ut}const _=this.c.value;let we=Oe.filter(et=>!et.startsWith("_")&&et in _);we.length===0&&(we=["_default"]);let ze;for(const et of we){const lt=ve(_[et]);ze=X(ze,lt)}const Ge=ve(_._common),Ye=ye(Ge,ze);return new Xe(Ye)})}static getInstance(Oe){return Xe.d.get(Array.from(Oe))}static{this.e=new S.$V(()=>Object.keys(Xe.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}containsAmbiguousCharacter(Oe){for(let ve=0;ve<Oe.length;ve++){const ye=Oe.codePointAt(ve);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=Xe;class Qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Qe.c())),this.d}static isInvisibleCharacter(Oe){return Qe.e().has(Oe)}static containsInvisibleCharacter(Oe){for(let ve=0;ve<Oe.length;ve++){const ye=Oe.codePointAt(ve);if(typeof ye=="number"&&Qe.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Qe.e()}}e.$_f=Qe}),define(Ee[172],Se([1,0,35,26,161,17]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.FuzzyScore=e.$Ck=e.$Bk=void 0,e.or=A,e.$Dk=v,e.$Ek=s,e.$Fk=p,e.$Gk=k,e.$Hk=I,e.$Ik=Q,e.$Jk=ie,e.$Kk=re,e.$Lk=ne,e.$Mk=W,e.$Ok=x,e.$Pk=te,e.$Qk=he;function A(...me){return function(be,Ae){for(let Le=0,de=me.length;Le<de;Le++){const Ie=me[Le](be,Ae);if(Ie)return Ie}return null}}e.$Bk=R.bind(void 0,!1),e.$Ck=R.bind(void 0,!0);function R(me,be,Ae){if(!Ae||Ae.length<be.length)return null;let Le;return me?Le=D.$Cf(Ae,be):Le=Ae.indexOf(be)===0,Le?be.length>0?[{start:0,end:be.length}]:[]:null}function v(me,be){const Ae=be.toLowerCase().indexOf(me.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+me.length}]}function s(me,be){return E(me.toLowerCase(),be.toLowerCase(),0,0)}function E(me,be,Ae,Le){if(Ae===me.length)return[];if(Le===be.length)return null;if(me[Ae]===be[Le]){let de=null;return(de=E(me,be,Ae+1,Le+1))?l({start:Le,end:Le+1},de):null}return E(me,be,Ae,Le+1)}function y(me){return n.CharCode.a<=me&&me<=n.CharCode.z}function p(me){return n.CharCode.A<=me&&me<=n.CharCode.Z}function b(me){return n.CharCode.Digit0<=me&&me<=n.CharCode.Digit9}function a(me){return me===n.CharCode.Space||me===n.CharCode.Tab||me===n.CharCode.LineFeed||me===n.CharCode.CarriageReturn}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(me=>f.add(me.charCodeAt(0)));function h(me){return a(me)||f.has(me)}function g(me,be){return me===be||h(me)&&h(be)}const w=new Map;function m(me){if(w.has(me))return w.get(me);let be;const Ae=(0,S.$zk)(me);return Ae&&(be=Ae),w.set(me,be),be}function $(me){return y(me)||p(me)||b(me)}function l(me,be){return be.length===0?be=[me]:me.end===be[0].start?be[0].start=me.start:be.unshift(me),be}function t(me,be){for(let Ae=be;Ae<me.length;Ae++){const Le=me.charCodeAt(Ae);if(p(Le)||b(Le)||Ae>0&&!$(me.charCodeAt(Ae-1)))return Ae}return me.length}function o(me,be,Ae,Le){if(Ae===me.length)return[];if(Le===be.length)return null;if(me[Ae]!==be[Le].toLowerCase())return null;{let de=null,Ie=Le+1;for(de=o(me,be,Ae+1,Le+1);!de&&(Ie=t(be,Ie))<be.length;)de=o(me,be,Ae+1,Ie),Ie++;return de===null?null:l({start:Le,end:Le+1},de)}}function d(me){let be=0,Ae=0,Le=0,de=0,Ie=0;for(let We=0;We<me.length;We++)Ie=me.charCodeAt(We),p(Ie)&&be++,y(Ie)&&Ae++,$(Ie)&&Le++,b(Ie)&&de++;const Re=be/me.length,Me=Ae/me.length,He=Le/me.length,Ke=de/me.length;return{upperPercent:Re,lowerPercent:Me,alphaPercent:He,numericPercent:Ke}}function i(me){const{upperPercent:be,lowerPercent:Ae}=me;return Ae===0&&be>.6}function c(me){const{upperPercent:be,lowerPercent:Ae,alphaPercent:Le,numericPercent:de}=me;return Ae>.2&&be<.8&&Le>.6&&de<.2}function u(me){let be=0,Ae=0,Le=0,de=0;for(let Ie=0;Ie<me.length;Ie++)Le=me.charCodeAt(Ie),p(Le)&&be++,y(Le)&&Ae++,a(Le)&&de++;return(be===0||Ae===0)&&de===0?me.length<=30:be<=5}function k(me,be){if(!be||(be=be.trim(),be.length===0)||!u(me))return null;be.length>60&&(be=be.substring(0,60));const Ae=d(be);if(!c(Ae)){if(!i(Ae))return null;be=be.toLowerCase()}let Le=null,de=0;for(me=me.toLowerCase();de<be.length&&(Le=o(me,be,0,de))===null;)de=t(be,de+1);return Le}function I(me,be,Ae=!1){if(!be||be.length===0)return null;let Le=null,de=0;for(me=me.toLowerCase(),be=be.toLowerCase();de<be.length&&(Le=C(me,be,0,de,Ae),Le===null);)de=T(be,de+1);return Le}function C(me,be,Ae,Le,de){let Ie=0;if(Ae===me.length)return[];if(Le===be.length)return null;if(!g(me.charCodeAt(Ae),be.charCodeAt(Le))){const He=m(me.charCodeAt(Ae));if(!He)return null;for(let Ke=0;Ke<He.length;Ke++)if(!g(He[Ke],be.charCodeAt(Le+Ke)))return null;Ie+=He.length-1}let Re=null,Me=Le+Ie+1;if(Re=C(me,be,Ae+1,Me,de),!de)for(;!Re&&(Me=T(be,Me))<be.length;)Re=C(me,be,Ae+1,Me,de),Me++;if(!Re)return null;if(me.charCodeAt(Ae)!==be.charCodeAt(Le)){const He=m(me.charCodeAt(Ae));if(!He)return Re;for(let Ke=0;Ke<He.length;Ke++)if(He[Ke]!==be.charCodeAt(Le+Ke))return Re}return l({start:Le,end:Le+Ie+1},Re)}function T(me,be){for(let Ae=be;Ae<me.length;Ae++)if(h(me.charCodeAt(Ae))||Ae>0&&h(me.charCodeAt(Ae-1)))return Ae;return me.length}const O=A(e.$Ck,k,v),P=A(e.$Ck,k,s),V=new r.$Dc(1e4);function Q(me,be,Ae=!1){if(typeof me!="string"||typeof be!="string")return null;let Le=V.get(me);Le||(Le=new RegExp(D.$kf(me),"i"),V.set(me,Le));const de=Le.exec(be);return de?[{start:de.index,end:de.index+de[0].length}]:Ae?P(me,be):O(me,be)}function ie(me,be){const Ae=x(me,me.toLowerCase(),0,be,be.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?ne(Ae):null}function re(me,be,Ae,Le,de,Ie){const Re=Math.min(13,me.length);for(;Ae<Re;Ae++){const Me=x(me,be,Ae,Le,de,Ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Me)return Me}return[0,Ie]}function ne(me){if(typeof me>"u")return[];const be=[],Ae=me[1];for(let Le=me.length-1;Le>1;Le--){const de=me[Le]+Ae,Ie=be[be.length-1];Ie&&Ie.end===de?Ie.end=de+1:be.push({start:de,end:de+1})}return be}const se=128;function Z(){const me=[],be=[];for(let Ae=0;Ae<=se;Ae++)be[Ae]=0;for(let Ae=0;Ae<=se;Ae++)me.push(be.slice(0));return me}function ee(me){const be=[];for(let Ae=0;Ae<=me;Ae++)be[Ae]=0;return be}const ue=ee(2*se),j=ee(2*se),B=Z(),oe=Z(),le=Z(),pe=!1;function q(me,be,Ae,Le,de){function Ie(Me,He,Ke=" "){for(;Me.length<He;)Me=Ke+Me;return Me}let Re=` |   |${Le.split("").map(Me=>Ie(Me,3)).join("|")}
`;for(let Me=0;Me<=Ae;Me++)Me===0?Re+=" |":Re+=`${be[Me-1]}|`,Re+=me[Me].slice(0,de+1).map(He=>Ie(He.toString(),3)).join("|")+`
`;return Re}function ae(me,be,Ae,Le){me=me.substr(be),Ae=Ae.substr(Le),console.log(q(oe,me,me.length,Ae,Ae.length)),console.log(q(le,me,me.length,Ae,Ae.length)),console.log(q(B,me,me.length,Ae,Ae.length))}function Y(me,be){if(be<0||be>=me.length)return!1;const Ae=me.codePointAt(be);switch(Ae){case n.CharCode.Underline:case n.CharCode.Dash:case n.CharCode.Period:case n.CharCode.Space:case n.CharCode.Slash:case n.CharCode.Backslash:case n.CharCode.SingleQuote:case n.CharCode.DoubleQuote:case n.CharCode.Colon:case n.CharCode.DollarSign:case n.CharCode.LessThan:case n.CharCode.GreaterThan:case n.CharCode.OpenParen:case n.CharCode.CloseParen:case n.CharCode.OpenSquareBracket:case n.CharCode.CloseSquareBracket:case n.CharCode.OpenCurlyBrace:case n.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!D.$Uf(Ae)}}function H(me,be){if(be<0||be>=me.length)return!1;switch(me.charCodeAt(be)){case n.CharCode.Space:case n.CharCode.Tab:return!0;default:return!1}}function L(me,be,Ae){return be[me]!==Ae[me]}function W(me,be,Ae,Le,de,Ie,Re=!1){for(;be<Ae&&de<Ie;)me[be]===Le[de]&&(Re&&(ue[be]=de),be+=1),de+=1;return be===Ae}var z;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(z||(z={}));var U;(function(me){me.Default=[-100,0];function be(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}me.isDefault=be})(U||(e.FuzzyScore=U={}));class J{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(be,Ae){this.firstMatchCanBeWeak=be,this.boostFullMatch=Ae}}e.$Nk=J;function x(me,be,Ae,Le,de,Ie,Re=J.default){const Me=me.length>se?se:me.length,He=Le.length>se?se:Le.length;if(Ae>=Me||Ie>=He||Me-Ae>He-Ie||!W(be,Ae,Me,de,Ie,He,!0))return;M(Me,He,Ae,Ie,be,de);let Ke=1,We=1,Ve=Ae,Ze=Ie;const nt=[!1];for(Ke=1,Ve=Ae;Ve<Me;Ke++,Ve++){const Xe=ue[Ve],Qe=j[Ve],$e=Ve+1<Me?j[Ve+1]:He;for(We=Xe-Ie+1,Ze=Xe;Ze<$e;We++,Ze++){let Oe=Number.MIN_SAFE_INTEGER,ve=!1;Ze<=Qe&&(Oe=G(me,be,Ve,Ae,Le,de,Ze,He,Ie,B[Ke-1][We-1]===0,nt));let ye=0;Oe!==Number.MAX_SAFE_INTEGER&&(ve=!0,ye=Oe+oe[Ke-1][We-1]);const X=Ze>Xe,_=X?oe[Ke][We-1]+(B[Ke][We-1]>0?-5:0):0,we=Ze>Xe+1&&B[Ke][We-1]>0,ze=we?oe[Ke][We-2]+(B[Ke][We-2]>0?-5:0):0;if(we&&(!X||ze>=_)&&(!ve||ze>=ye))oe[Ke][We]=ze,le[Ke][We]=z.LeftLeft,B[Ke][We]=0;else if(X&&(!ve||_>=ye))oe[Ke][We]=_,le[Ke][We]=z.Left,B[Ke][We]=0;else if(ve)oe[Ke][We]=ye,le[Ke][We]=z.Diag,B[Ke][We]=B[Ke-1][We-1]+1;else throw new Error("not possible")}}if(pe&&ae(me,Ae,Le,Ie),!nt[0]&&!Re.firstMatchCanBeWeak)return;Ke--,We--;const it=[oe[Ke][We],Ie];let ot=0,tt=0;for(;Ke>=1;){let Xe=We;do{const Qe=le[Ke][Xe];if(Qe===z.LeftLeft)Xe=Xe-2;else if(Qe===z.Left)Xe=Xe-1;else break}while(Xe>=1);ot>1&&be[Ae+Ke-1]===de[Ie+We-1]&&!L(Xe+Ie-1,Le,de)&&ot+1>B[Ke][Xe]&&(Xe=We),Xe===We?ot++:ot=1,tt||(tt=Xe),Ke--,We=Xe-1,it.push(We)}He-Ie===Me&&Re.boostFullMatch&&(it[0]+=2);const _e=tt-Me;return it[0]-=_e,it}function M(me,be,Ae,Le,de,Ie){let Re=me-1,Me=be-1;for(;Re>=Ae&&Me>=Le;)de[Re]===Ie[Me]&&(j[Re]=Me,Re--),Me--}function G(me,be,Ae,Le,de,Ie,Re,Me,He,Ke,We){if(be[Ae]!==Ie[Re])return Number.MIN_SAFE_INTEGER;let Ve=1,Ze=!1;return Re===Ae-Le?Ve=me[Ae]===de[Re]?7:5:L(Re,de,Ie)&&(Re===0||!L(Re-1,de,Ie))?(Ve=me[Ae]===de[Re]?7:5,Ze=!0):Y(Ie,Re)&&(Re===0||!Y(Ie,Re-1))?Ve=5:(Y(Ie,Re-1)||H(Ie,Re-1))&&(Ve=5,Ze=!0),Ve>1&&Ae===Le&&(We[0]=!0),Ze||(Ze=L(Re,de,Ie)||Y(Ie,Re-1)||H(Ie,Re-1)),Ae===Le?Re>He&&(Ve-=Ze?3:5):Ke?Ve+=Ze?2:0:Ve+=Ze?0:1,Re+1===Me&&(Ve-=Ze?3:5),Ve}function te(me,be,Ae,Le,de,Ie,Re){return ke(me,be,Ae,Le,de,Ie,!0,Re)}function he(me,be,Ae,Le,de,Ie,Re){return ke(me,be,Ae,Le,de,Ie,!1,Re)}function ke(me,be,Ae,Le,de,Ie,Re,Me){let He=x(me,be,Ae,Le,de,Ie,Me);if(He&&!Re)return He;if(me.length>=3){const Ke=Math.min(7,me.length-1);for(let We=Ae+1;We<Ke;We++){const Ve=Ne(me,We);if(Ve){const Ze=x(Ve,Ve.toLowerCase(),Ae,Le,de,Ie,Me);Ze&&(Ze[0]-=3,(!He||Ze[0]>He[0])&&(He=Ze))}}}return He}function Ne(me,be){if(be+1>=me.length)return;const Ae=me[be],Le=me[be+1];if(Ae!==Le)return me.slice(0,be)+Le+Ae+me.slice(be+2)}}),define(Ee[66],Se([1,0,17]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=r,e.$pj=S,e.$qj=D,e.$rj=R,e.$tj=f;function r(g){return S(g,0)}function S(g,w){switch(typeof g){case"object":return g===null?D(349,w):Array.isArray(g)?v(g,w):s(g,w);case"string":return R(g,w);case"boolean":return A(g,w);case"number":return D(g,w);case"undefined":return D(937,w);default:return D(617,w)}}function D(g,w){return(w<<5)-w+g|0}function A(g,w){return D(g?433:863,w)}function R(g,w){w=D(149417,w);for(let m=0,$=g.length;m<$;m++)w=D(g.charCodeAt(m),w);return w}function v(g,w){return w=D(104579,w),g.reduce((m,$)=>S($,m),w)}function s(g,w){return w=D(181387,w),Object.keys(g).sort().reduce((m,$)=>(m=R($,m),S(g[$],m)),w)}class E{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=S(w,this.g),this.g}}e.$sj=E;var y;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function p(g,w,m=32){const $=m-w,l=~((1<<$)-1);return(g<<w|(l&g)>>>$)>>>0}function b(g,w=0,m=g.byteLength,$=0){for(let l=0;l<m;l++)g[w+l]=$}function a(g,w,m="0"){for(;g.length<w;)g=m+g;return g}function f(g,w=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(m=>m.toString(16).padStart(2,"0")).join(""):a((g>>>0).toString(16),w/4)}class h{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(y.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const m=w.length;if(m===0)return;const $=this.p;let l=this.r,t=this.u,o,d;for(t!==0?(o=t,d=-1,t=0):(o=w.charCodeAt(0),d=0);;){let i=o;if(n.$Ff(o))if(d+1<m){const c=w.charCodeAt(d+1);n.$Gf(c)?(d++,i=n.$Hf(o,c)):i=y.UNICODE_REPLACEMENT}else{t=o;break}else n.$Gf(o)&&(i=y.UNICODE_REPLACEMENT);if(l=this.w($,l,i),d++,d<m)o=w.charCodeAt(d);else break}this.r=l,this.u=t}w(w,m,$){return $<128?w[m++]=$:$<2048?(w[m++]=192|($&1984)>>>6,w[m++]=128|($&63)>>>0):$<65536?(w[m++]=224|($&61440)>>>12,w[m++]=128|($&4032)>>>6,w[m++]=128|($&63)>>>0):(w[m++]=240|($&1835008)>>>18,w[m++]=128|($&258048)>>>12,w[m++]=128|($&4032)>>>6,w[m++]=128|($&63)>>>0),m>=y.BLOCK_SIZE&&(this.y(),m-=y.BLOCK_SIZE,this.t+=y.BLOCK_SIZE,w[0]=w[y.BLOCK_SIZE+0],w[1]=w[y.BLOCK_SIZE+1],w[2]=w[y.BLOCK_SIZE+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,y.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=h.g,m=this.q;for(let k=0;k<64;k+=4)w.setUint32(k,m.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)w.setUint32(k,p(w.getUint32(k-12,!1)^w.getUint32(k-32,!1)^w.getUint32(k-56,!1)^w.getUint32(k-64,!1),1),!1);let $=this.h,l=this.l,t=this.m,o=this.n,d=this.o,i,c,u;for(let k=0;k<80;k++)k<20?(i=l&t|~l&o,c=1518500249):k<40?(i=l^t^o,c=1859775393):k<60?(i=l&t|l&o|t&o,c=2400959708):(i=l^t^o,c=3395469782),u=p($,5)+i+d+c+w.getUint32(k*4,!1)&4294967295,d=o,o=t,t=p(l,30),l=$,$=u;this.h=this.h+$&4294967295,this.l=this.l+l&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+d&4294967295}}e.$uj=h}),define(Ee[173],Se([1,0,172,17,81]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=v,e.$Sk=E,e.$Tk=p,e.$Uk=b,e.$Vk=f,e.$Wk=h;const D="$(",A=new RegExp(`\\$\\(${S.ThemeIcon.iconNameExpression}(?:${S.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${A.source}`,"g");function v(g){return g.replace(R,(w,m)=>m?w:`\\${w}`)}const s=new RegExp(`\\\\${A.source}`,"g");function E(g){return g.replace(s,w=>`\\${w}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function p(g){return g.indexOf(D)===-1?g:g.replace(y,(w,m,$,l)=>$?w:m||l||"")}function b(g){return g?g.replace(/\$\((.*?)\)/g,(w,m)=>` ${m} `).trim():""}const a=new RegExp(`\\$\\(${S.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(g){a.lastIndex=0;let w="";const m=[];let $=0;for(;;){const l=a.lastIndex,t=a.exec(g),o=g.substring(l,t?.index);if(o.length>0){w+=o;for(let d=0;d<o.length;d++)m.push($)}if(!t)break;$+=t[0].length}return{text:w,iconOffsets:m}}function h(g,w,m=!1){const{text:$,iconOffsets:l}=w;if(!l||l.length===0)return(0,n.$Ik)(g,$,m);const t=(0,r.$if)($," "),o=$.length-t.length,d=(0,n.$Ik)(g,t,m);if(d)for(const i of d){const c=l[i.start+o]+o;i.start+=c,i.end+=c}return d}}),define(Ee[58],Se([1,0,17]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var r;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(r||(r={})),function(S){const D="error",A="warning",R="warn",v="info",s="ignore";function E(p){return p?n.$Bf(D,p)?S.Error:n.$Bf(A,p)||n.$Bf(R,p)?S.Warning:n.$Bf(v,p)?S.Info:S.Ignore:S.Ignore}S.fromValue=E;function y(p){switch(p){case S.Error:return D;case S.Warning:return A;case S.Info:return v;default:return s}}S.toString=y}(r||(r={})),e.default=r}),define(Ee[67],Se([1,0,18,35,17]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class D{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const f=a.charCodeAt(0),h=this.b.charCodeAt(this.c);return f-h}value(){return this.b[this.c]}}e.$Ci=D;class A{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,S.$vf)(a,this.b,0,a.length,this.c,this.d):(0,S.$xf)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=A;class R{constructor(a=!0,f=!0){this.f=a,this.g=f}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let f=a.length-1;f>=0;f--,this.c--){const h=this.b.charCodeAt(f);if(!(h===r.CharCode.Slash||this.f&&h===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===r.CharCode.Slash||this.f&&f===r.CharCode.Backslash)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,S.$vf)(a,this.b,0,a.length,this.d,this.e):(0,S.$xf)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=R;var v;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(v||(v={}));class s{constructor(a,f){this.f=a,this.g=f,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(v.Scheme),this.c.authority&&this.d.push(v.Authority),this.c.path&&(this.b=new R(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(v.Path)),this.g(a)||(this.c.query&&this.d.push(v.Query),this.c.fragment&&this.d.push(v.Fragment)),this.e=0,this}next(){return this.d[this.e]===v.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===v.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===v.Scheme)return(0,S.$wf)(a,this.c.scheme);if(this.d[this.e]===v.Authority)return(0,S.$wf)(a,this.c.authority);if(this.d[this.e]===v.Path)return this.b.cmp(a);if(this.d[this.e]===v.Query)return(0,S.$uf)(a,this.c.query);if(this.d[this.e]===v.Fragment)return(0,S.$uf)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===v.Scheme)return this.c.scheme;if(this.d[this.e]===v.Authority)return this.c.authority;if(this.d[this.e]===v.Path)return this.b.value();if(this.d[this.e]===v.Query)return this.c.query;if(this.d[this.e]===v.Fragment)return this.c.fragment;throw new Error}}e.$Fi=s;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(y||(y={}));class p{static forUris(a=()=>!1,f=()=>!1){return new p(new s(a,f))}static forPaths(a=!1){return new p(new R(void 0,!a))}static forStrings(){return new p(new D)}static forConfigKeys(){return new p(new A)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,f){if(f){const h=f.slice(0);(0,n.$Wb)(h);for(const g of h)this.set(g,a)}else{const h=a.slice(0);(0,n.$Wb)(h);for(const g of h)this.set(g[0],g[1])}}set(a,f){const h=this.b.reset(a);let g;this.c||(this.c=new E,this.c.segment=h.value());const w=[];for(g=this.c;;){const $=h.cmp(g.segment);if($>0)g.left||(g.left=new E,g.left.segment=h.value()),w.push([y.Left,g]),g=g.left;else if($<0)g.right||(g.right=new E,g.right.segment=h.value()),w.push([y.Right,g]),g=g.right;else if(h.hasNext())h.next(),g.mid||(g.mid=new E,g.mid.segment=h.value()),w.push([y.Mid,g]),g=g.mid;else break}const m=g.value;g.value=f,g.key=a;for(let $=w.length-1;$>=0;$--){const l=w[$][1];l.updateHeight();const t=l.balanceFactor();if(t<-1||t>1){const o=w[$][0],d=w[$+1][0];if(o===y.Right&&d===y.Right)w[$][1]=l.rotateLeft();else if(o===y.Left&&d===y.Left)w[$][1]=l.rotateRight();else if(o===y.Right&&d===y.Left)l.right=w[$+1][1]=w[$+1][1].rotateRight(),w[$][1]=l.rotateLeft();else if(o===y.Left&&d===y.Right)l.left=w[$+1][1]=w[$+1][1].rotateLeft(),w[$][1]=l.rotateRight();else throw new Error;if($>0)switch(w[$-1][0]){case y.Left:w[$-1][1].left=w[$][1];break;case y.Right:w[$-1][1].right=w[$][1];break;case y.Mid:w[$-1][1].mid=w[$][1];break}else this.c=w[0][1]}}return m}get(a){return this.d(a)?.value}d(a){const f=this.b.reset(a);let h=this.c;for(;h;){const g=f.cmp(h.segment);if(g>0)h=h.left;else if(g<0)h=h.right;else if(f.hasNext())f.next(),h=h.mid;else break}return h}has(a){const f=this.d(a);return!(f?.value===void 0&&f?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,f){const h=this.b.reset(a),g=[];let w=this.c;for(;w;){const m=h.cmp(w.segment);if(m>0)g.push([y.Left,w]),w=w.left;else if(m<0)g.push([y.Right,w]),w=w.right;else if(h.hasNext())h.next(),g.push([y.Mid,w]),w=w.mid;else break}if(w){if(f?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const m=this.f(w.right);if(m.key){const{key:$,value:l,segment:t}=m;this.e(m.key,!1),w.key=$,w.value=l,w.segment=t}}else{const m=w.left??w.right;if(g.length>0){const[$,l]=g[g.length-1];switch($){case y.Left:l.left=m;break;case y.Mid:l.mid=m;break;case y.Right:l.right=m;break}}else this.c=m}for(let m=g.length-1;m>=0;m--){const $=g[m][1];$.updateHeight();const l=$.balanceFactor();if(l>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),g[m][1]=$.rotateLeft()):l<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),g[m][1]=$.rotateRight()),m>0)switch(g[m-1][0]){case y.Left:g[m-1][1].left=g[m][1];break;case y.Right:g[m-1][1].right=g[m][1];break;case y.Mid:g[m-1][1].mid=g[m][1];break}else this.c=g[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const f=this.b.reset(a);let h=this.c,g;for(;h;){const w=f.cmp(h.segment);if(w>0)h=h.left;else if(w<0)h=h.right;else if(f.hasNext())f.next(),g=h.value||g,h=h.mid;else break}return h&&h.value||g}findSuperstr(a){return this.g(a,!1)}g(a,f){const h=this.b.reset(a);let g=this.c;for(;g;){const w=h.cmp(g.segment);if(w>0)g=g.left;else if(w<0)g=g.right;else if(h.hasNext())h.next(),g=g.mid;else return g.mid?this.h(g.mid):f?g.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[f,h]of this)a(h,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const f=[];return this.j(a,f),f[Symbol.iterator]()}j(a,f){a&&(a.left&&this.j(a.left,f),a.value&&f.push([a.key,a.value]),a.mid&&this.j(a.mid,f),a.right&&this.j(a.right,f))}_isBalanced(){const a=f=>{if(!f)return!0;const h=f.balanceFactor();return h<-1||h>1?!1:a(f.left)&&a(f.right)};return a(this.c)}}e.$Gi=p}),define(Ee[22],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(S){return n.test(S)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(R){for(let v=0;v<R.length;v++)R[v]=Math.floor(Math.random()*256);return R};const D=new Uint8Array(16),A=[];for(let R=0;R<256;R++)A.push(R.toString(16).padStart(2,"0"));return function(){S(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let v=0,s="";return s+=A[D[v++]],s+=A[D[v++]],s+=A[D[v++]],s+=A[D[v++]],s+="-",s+=A[D[v++]],s+=A[D[v++]],s+="-",s+=A[D[v++]],s+=A[D[v++]],s+="-",s+=A[D[v++]],s+=A[D[v++]],s+="-",s+=A[D[v++]],s+=A[D[v++]],s+=A[D[v++]],s+=A[D[v++]],s+=A[D[v++]],s+=A[D[v++]],s}}()}),define(Ee[174],Se([1,0,18,40,22]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.$0s=void 0,e.$8s=D,e.$9s=A,e.$$s=s;function D(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,p,b){const a={id:(0,S.$Wg)(),name:y,uri:p,data:b};return{asString:async()=>"",asFile:()=>a,value:void 0}}class R{constructor(){this.a=new Map}get size(){let p=0;for(const b of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const b=[...this.a.keys()];return r.Iterable.some(this,([a,f])=>f.asFile())&&b.push("files"),E(v(p),b)}get(p){return this.a.get(this.b(p))?.[0]}append(p,b){const a=this.a.get(p);a?a.push(b):this.a.set(this.b(p),[b])}replace(p,b){this.a.set(this.b(p),[b])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,b]of this.a)for(const a of b)yield[p,a]}b(p){return v(p)}}e.$0s=R;function v(y){return y.toLowerCase()}function s(y,p){return E(v(y),p.map(v))}function E(y,p){if(y==="*/*")return p.length>0;if(p.includes(y))return!0;const b=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[a,f,h]=b;return h==="*"?p.some(g=>g.startsWith(f+"/")):!1}e.$_s=Object.freeze({create:y=>(0,n.$Mb)(y.map(p=>p.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$_s.split(y).filter(p=>!p.startsWith("#"))})}),function(){"use strict";function fe(e,n,r){function S(b){return new Promise(a=>n.exists(b,a))}function D(b){return new Promise((a,f)=>{const h=new Date;n.utimes(b,h,h,g=>g?f(g):a())})}function A(b){return new Promise((a,f)=>n.mkdir(b,{recursive:!0},h=>h&&h.code!=="EEXIST"?f(h):a(b)))}function R(b){return new Promise((a,f)=>n.rm(b,{recursive:!0,force:!0,maxRetries:3},h=>h?f(h):a()))}function v(b){return new Promise((a,f)=>n.readFile(b,"utf8",(h,g)=>h?f(h):a(g)))}function s(b,a){return new Promise((f,h)=>n.writeFile(b,a,"utf8",g=>g?h(g):f()))}async function E(b){const a=e.join(b,"languagepacks.json");try{return JSON.parse(await v(a))}catch{}}function y(b,a){try{for(;a;){if(b[a])return a;{const f=a.lastIndexOf("-");if(f>0)a=a.substring(0,f);else return}}}catch(f){console.error("Resolving language pack configuration failed.",f)}}function p(b,a,f,h,g){const w=function($){return r.mark("code/didGenerateNls"),Promise.resolve({locale:$,osLocale:g,availableLanguages:{}})};if(r.mark("code/willGenerateNls"),h==="pseudo")return Promise.resolve({locale:h,osLocale:g,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:h,osLocale:g,availableLanguages:{}});if(h&&(h==="en"||h==="en-us"))return Promise.resolve({locale:h,osLocale:g,availableLanguages:{}});const m=h;try{return b?E(a).then($=>{if(!$)return w(m);const l=y($,h);if(!l)return w(m);h=l;const t=$[h];let o;return!t||typeof t.hash!="string"||!t.translations||typeof(o=t.translations.vscode)!="string"?w(m):S(o).then(d=>{if(!d)return w(m);const i=t.hash+"."+h,c=e.join(a,"clp",i),u=e.join(c,b),k=e.join(c,"tcf.json"),I=e.join(c,"corrupted.info"),C={locale:m,osLocale:g,availableLanguages:{"*":h},_languagePackId:i,_translationsConfigFile:k,_cacheRoot:c,_resolvedLanguagePackCoreLocation:u,_corruptedFile:I};return S(I).then(T=>{let O;return T?O=R(c):O=Promise.resolve(void 0),O.then(()=>S(u).then(P=>P?(D(u).catch(()=>{}),r.mark("code/didGenerateNls"),C):A(u).then(()=>Promise.all([v(f),v(o)])).then(V=>{const Q=JSON.parse(V[0]),ie=JSON.parse(V[1]).contents,re=Object.keys(Q.bundles),ne=[];for(const se of re){const Z=Q.bundles[se],ee=Object.create(null);for(const ue of Z){const j=Q.keys[ue],B=Q.messages[ue],oe=ie[ue];let le;if(oe){le=[];for(let pe=0;pe<j.length;pe++){const q=j[pe],ae=typeof q=="string"?q:q.key;let Y=oe[ae];Y===void 0&&(Y=B[pe]),le.push(Y)}}else le=B;ee[ue]=le}ne.push(s(e.join(u,se.replace(/\//g,"!")+".nls.json"),JSON.stringify(ee)))}return ne.push(s(k,JSON.stringify(t.translations))),Promise.all(ne)}).then(()=>(r.mark("code/didGenerateNls"),C)).catch(V=>(console.error("Generating translation files failed.",V),w(h)))))})})}):w(m)}catch($){return console.error("Generating translation files failed.",$),w(h)}}return{getNLSConfiguration:p}}if(typeof define=="function")define(Ee[175],Se([82,31,45]),function(e,n,r){return fe(e,n,r)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("fs"),r=require("../common/performance");module.exports=fe(e,n,r)}else throw new Error("Unknown context")}(),define(Ee[176],Se([1,0,32]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=D;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(A){const R=A.replace(/\-/g,":").toLowerCase();return!r.has(R)}function D(){const A=(0,n.networkInterfaces)();for(const R in A){const v=A[R];if(v){for(const{mac:s}of v)if(S(s))return s}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(Ee[177],Se([1,0,83]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=r,e.$1g=D;function r(R,v,s,E=1){let y=!1;return new Promise(p=>{const b=setTimeout(()=>{if(!y)return y=!0,p(0)},s);S(R,v,E,a=>{if(!y)return y=!0,clearTimeout(b),p(a)})})}function S(R,v,s,E){if(v===0)return E(0);const y=new n.Socket;y.once("connect",()=>(A(y),S(R+s,v-1,s,E))),y.once("data",()=>{}),y.once("error",p=>(A(y),p.code!=="ECONNREFUSED"?S(R+s,v-1,s,E):E(R))),y.connect(R,"127.0.0.1")}e.$Zg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(R,v,s,E="127.0.0.1"){let y=!1,p,b=1;const a=n.createServer({pauseOnConnect:!0});function f(h,g){y||(y=!0,a.removeAllListeners(),a.close(),p&&clearTimeout(p),g(h))}return new Promise(h=>{p=setTimeout(()=>{f(0,h)},s),a.on("listening",()=>{f(R,h)}),a.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&b<v?(R++,b++,a.listen(R,E)):f(0,h)}),a.on("close",()=>{f(0,h)}),a.listen(R,E)})}function A(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(v){console.error(v)}}}),function(){function fe(){function e(){return process.uncHostAllowlist}function n(v){const s=new Set;if(Array.isArray(v))for(const E of v)typeof E=="string"&&s.add(E);return Array.from(s)}function r(){const v=e();return v?Array.from(v):[]}function S(v){if(process.platform!=="win32")return;const s=e();if(s)if(typeof v=="string")s.add(v.toLowerCase());else for(const E of n(v))S(E)}function D(v){if(typeof v!="string")return;const s=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let E;for(const y of s){if(v.indexOf(y)!==0)continue;const b=v.indexOf("\\",y.length);if(b===-1)continue;const a=v.substring(y.length,b);if(a){E=a;break}}return E}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function R(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:S,getUNCHost:D,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:R}}typeof define=="function"?define("vs/base/node/unc",[],function(){return fe()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=fe():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(Ee[84],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=void 0;class n{constructor(S,D){this.lineNumber=S,this.column=D}with(S=this.lineNumber,D=this.column){return S===this.lineNumber&&D===this.column?this:new n(S,D)}delta(S=0,D=0){return this.with(this.lineNumber+S,this.column+D)}equals(S){return n.equals(this,S)}static equals(S,D){return!S&&!D?!0:!!S&&!!D&&S.lineNumber===D.lineNumber&&S.column===D.column}isBefore(S){return n.isBefore(this,S)}static isBefore(S,D){return S.lineNumber<D.lineNumber?!0:D.lineNumber<S.lineNumber?!1:S.column<D.column}isBeforeOrEqual(S){return n.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,D){return S.lineNumber<D.lineNumber?!0:D.lineNumber<S.lineNumber?!1:S.column<=D.column}static compare(S,D){const A=S.lineNumber|0,R=D.lineNumber|0;if(A===R){const v=S.column|0,s=D.column|0;return v-s}return A-R}clone(){return new n(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new n(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$bt=n}),define(Ee[48],Se([1,0,84]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class r{constructor(D,A,R,v){D>R||D===R&&A>v?(this.startLineNumber=R,this.startColumn=v,this.endLineNumber=D,this.endColumn=A):(this.startLineNumber=D,this.startColumn=A,this.endLineNumber=R,this.endColumn=v)}isEmpty(){return r.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return r.containsPosition(this,D)}static containsPosition(D,A){return!(A.lineNumber<D.startLineNumber||A.lineNumber>D.endLineNumber||A.lineNumber===D.startLineNumber&&A.column<D.startColumn||A.lineNumber===D.endLineNumber&&A.column>D.endColumn)}static strictContainsPosition(D,A){return!(A.lineNumber<D.startLineNumber||A.lineNumber>D.endLineNumber||A.lineNumber===D.startLineNumber&&A.column<=D.startColumn||A.lineNumber===D.endLineNumber&&A.column>=D.endColumn)}containsRange(D){return r.containsRange(this,D)}static containsRange(D,A){return!(A.startLineNumber<D.startLineNumber||A.endLineNumber<D.startLineNumber||A.startLineNumber>D.endLineNumber||A.endLineNumber>D.endLineNumber||A.startLineNumber===D.startLineNumber&&A.startColumn<D.startColumn||A.endLineNumber===D.endLineNumber&&A.endColumn>D.endColumn)}strictContainsRange(D){return r.strictContainsRange(this,D)}static strictContainsRange(D,A){return!(A.startLineNumber<D.startLineNumber||A.endLineNumber<D.startLineNumber||A.startLineNumber>D.endLineNumber||A.endLineNumber>D.endLineNumber||A.startLineNumber===D.startLineNumber&&A.startColumn<=D.startColumn||A.endLineNumber===D.endLineNumber&&A.endColumn>=D.endColumn)}plusRange(D){return r.plusRange(this,D)}static plusRange(D,A){let R,v,s,E;return A.startLineNumber<D.startLineNumber?(R=A.startLineNumber,v=A.startColumn):A.startLineNumber===D.startLineNumber?(R=A.startLineNumber,v=Math.min(A.startColumn,D.startColumn)):(R=D.startLineNumber,v=D.startColumn),A.endLineNumber>D.endLineNumber?(s=A.endLineNumber,E=A.endColumn):A.endLineNumber===D.endLineNumber?(s=A.endLineNumber,E=Math.max(A.endColumn,D.endColumn)):(s=D.endLineNumber,E=D.endColumn),new r(R,v,s,E)}intersectRanges(D){return r.intersectRanges(this,D)}static intersectRanges(D,A){let R=D.startLineNumber,v=D.startColumn,s=D.endLineNumber,E=D.endColumn;const y=A.startLineNumber,p=A.startColumn,b=A.endLineNumber,a=A.endColumn;return R<y?(R=y,v=p):R===y&&(v=Math.max(v,p)),s>b?(s=b,E=a):s===b&&(E=Math.min(E,a)),R>s||R===s&&v>E?null:new r(R,v,s,E)}equalsRange(D){return r.equalsRange(this,D)}static equalsRange(D,A){return!D&&!A?!0:!!D&&!!A&&D.startLineNumber===A.startLineNumber&&D.startColumn===A.startColumn&&D.endLineNumber===A.endLineNumber&&D.endColumn===A.endColumn}getEndPosition(){return r.getEndPosition(this)}static getEndPosition(D){return new n.$bt(D.endLineNumber,D.endColumn)}getStartPosition(){return r.getStartPosition(this)}static getStartPosition(D){return new n.$bt(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,A){return new r(this.startLineNumber,this.startColumn,D,A)}setStartPosition(D,A){return new r(D,A,this.endLineNumber,this.endColumn)}collapseToStart(){return r.collapseToStart(this)}static collapseToStart(D){return new r(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}collapseToEnd(){return r.collapseToEnd(this)}static collapseToEnd(D){return new r(D.endLineNumber,D.endColumn,D.endLineNumber,D.endColumn)}delta(D){return new r(this.startLineNumber+D,this.startColumn,this.endLineNumber+D,this.endColumn)}static fromPositions(D,A=D){return new r(D.lineNumber,D.column,A.lineNumber,A.column)}static lift(D){return D?new r(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,A){return!(D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn||A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn)}static areIntersecting(D,A){return!(D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn||A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,A){if(D&&A){const s=D.startLineNumber|0,E=A.startLineNumber|0;if(s===E){const y=D.startColumn|0,p=A.startColumn|0;if(y===p){const b=D.endLineNumber|0,a=A.endLineNumber|0;if(b===a){const f=D.endColumn|0,h=A.endColumn|0;return f-h}return b-a}return y-p}return s-E}return(D?1:0)-(A?1:0)}static compareRangesUsingEnds(D,A){return D.endLineNumber===A.endLineNumber?D.endColumn===A.endColumn?D.startLineNumber===A.startLineNumber?D.startColumn-A.startColumn:D.startLineNumber-A.startLineNumber:D.endColumn-A.endColumn:D.endLineNumber-A.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}toJSON(){return this}}e.$ct=r}),define(Ee[178],Se([1,0,48]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class r{static insert(D,A){return{range:new n.$ct(D.lineNumber,D.column,D.lineNumber,D.column),text:A,forceMoveMarkers:!0}}static delete(D){return{range:D,text:null}}static replace(D,A){return{range:D,text:A}}static replaceMove(D,A){return{range:D,text:A,forceMoveMarkers:!0}}}e.$dt=r}),define(Ee[179],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nu=void 0,e.$nu={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[180],Se([1,0,40,2,79]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.$rt=void 0,e.$tt=A,e.$ut=v,e.$vt=s,e.$rt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function D(y=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const b of e.$rt)y.indexOf(b)>=0||(p+="\\"+b);return p+="\\s]+)",new RegExp(p,"g")}e.$st=D();function A(y){let p=e.$st;if(y&&y instanceof RegExp)if(y.global)p=y;else{let b="g";y.ignoreCase&&(b+="i"),y.multiline&&(b+="m"),y.unicode&&(b+="u"),p=new RegExp(y.source,b)}return p.lastIndex=0,p}const R=new S.$5c;R.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(y){const p=R.unshift(y);return(0,r.$Sc)(p)}function s(y,p,b,a,f){if(p=A(p),f||(f=n.Iterable.first(R)),b.length>f.maxLen){let $=y-f.maxLen/2;return $<0?$=0:a+=$,b=b.substring($,y+f.maxLen/2),s(y,p,b,a,f)}const h=Date.now(),g=y-1-a;let w=-1,m=null;for(let $=1;!(Date.now()-h>=f.timeBudget);$++){const l=g-f.windowSize*$;p.lastIndex=Math.max(0,l);const t=E(p,b,g,w);if(!t&&m||(m=t,l<=0))break;w=l}if(m){const $={word:m[0],startColumn:a+1+m.index,endColumn:a+1+m.index+m[0].length};return p.lastIndex=0,$}return null}function E(y,p,b,a){let f;for(;f=y.exec(p);){const h=f.index||0;if(h<=b&&y.lastIndex>=b)return f;if(a>0&&h>a)return null}return null}}),define(Ee[110],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var n;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(n||(e.LanguageId=n={}));var r;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(r||(e.FontStyle=r={}));var S;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(S||(e.ColorId=S={}));var D;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(D||(e.StandardTokenType=D={}));var A;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",v[v.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(A||(e.MetadataConsts=A={}));class R{static getLanguageId(s){return(s&A.LANGUAGEID_MASK)>>>A.LANGUAGEID_OFFSET}static getTokenType(s){return(s&A.TOKEN_TYPE_MASK)>>>A.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(s){return(s&A.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(s){return(s&A.FONT_STYLE_MASK)>>>A.FONT_STYLE_OFFSET}static getForeground(s){return(s&A.FOREGROUND_MASK)>>>A.FOREGROUND_OFFSET}static getBackground(s){return(s&A.BACKGROUND_MASK)>>>A.BACKGROUND_OFFSET}static getClassNameFromMetadata(s){let y="mtk"+this.getForeground(s);const p=this.getFontStyle(s);return p&r.Italic&&(y+=" mtki"),p&r.Bold&&(y+=" mtkb"),p&r.Underline&&(y+=" mtku"),p&r.Strikethrough&&(y+=" mtks"),y}static getInlineStyleFromMetadata(s,E){const y=this.getForeground(s),p=this.getFontStyle(s);let b=`color: ${E[y]};`;p&r.Italic&&(b+="font-style: italic;"),p&r.Bold&&(b+="font-weight: bold;");let a="";return p&r.Underline&&(a+=" underline"),p&r.Strikethrough&&(a+=" line-through"),a&&(b+=`text-decoration:${a};`),b}static getPresentationFromMetadata(s){const E=this.getForeground(s),y=this.getFontStyle(s);return{foreground:E,italic:!!(y&r.Italic),bold:!!(y&r.Bold),underline:!!(y&r.Underline),strikethrough:!!(y&r.Strikethrough)}}}e.$ft=R}),define(Ee[181],Se([1,0,21]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$rv=e.$qv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$sv=a,e.$wv=$;var r;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(r||(e.OverviewRulerLane=r={}));var S;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=3]="Right"})(S||(e.GlyphMarginLane=S={}));var D;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(D||(e.MinimapPosition=D={}));var A;(function(l){l[l.Normal=1]="Normal",l[l.Underlined=2]="Underlined"})(A||(e.MinimapSectionHeaderStyle=A={}));var R;(function(l){l[l.Both=0]="Both",l[l.Right=1]="Right",l[l.Left=2]="Left",l[l.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var v;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var s;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(s||(e.DefaultEndOfLine=s={}));var E;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(E||(e.EndOfLineSequence=E={}));class y{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,n.$ao)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$qv=y;class p{constructor(t,o){this._findMatchBrand=void 0,this.range=t,this.matches=o}}e.$rv=p;var b;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(e.TrackedRangeStickiness=b={}));function a(l){return l&&typeof l.read=="function"}var f;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None",l[l.LeftOfInjectedText=3]="LeftOfInjectedText",l[l.RightOfInjectedText=4]="RightOfInjectedText"})(f||(e.PositionAffinity=f={}));var h;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(h||(e.ModelConstants=h={}));class g{constructor(t,o,d,i,c,u){this.identifier=t,this.range=o,this.text=d,this.forceMoveMarkers=i,this.isAutoWhitespaceEdit=c,this._isTracked=u}}e.$tv=g;class w{constructor(t,o,d){this.regex=t,this.wordSeparators=o,this.simpleSearch=d}}e.$uv=w;class m{constructor(t,o,d){this.reverseEdits=t,this.changes=o,this.trimAutoWhitespaceLineNumbers=d}}e.$vv=m;function $(l){return!l.isTooLargeForSyncing()&&!l.isForSimpleWidget}}),define(Ee[182],Se([1,0,6,2,110]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=void 0;class D{constructor(){this.a=new Map,this.b=new Map,this.c=new n.$he,this.onDidChange=this.c.event,this.d=null}handleChange(v){this.c.fire({changedLanguages:v,changedColorMap:!1})}register(v,s){return this.a.set(v,s),this.handleChange([v]),(0,r.$Sc)(()=>{this.a.get(v)===s&&(this.a.delete(v),this.handleChange([v]))})}get(v){return this.a.get(v)||null}registerFactory(v,s){this.b.get(v)?.dispose();const E=new A(this,v,s);return this.b.set(v,E),(0,r.$Sc)(()=>{const y=this.b.get(v);!y||y!==E||(this.b.delete(v),y.dispose())})}async getOrCreate(v){const s=this.get(v);if(s)return s;const E=this.b.get(v);return!E||E.isResolved?null:(await E.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const E=this.b.get(v);return!!(!E||E.isResolved)}setColorMap(v){this.d=v,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>S.ColorId.DefaultBackground?this.d[S.ColorId.DefaultBackground]:null}}e.$xv=D;class A extends r.$Uc{get isResolved(){return this.c}constructor(v,s,E){super(),this.f=v,this.g=s,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const v=await this.h.tokenizationSupport;this.c=!0,v&&!this.a&&this.B(this.f.register(this.g,v))}}}),define(Ee[183],Se([7,8]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Ee[184],Se([1,0,6,2,183]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=void 0,e.$kj=E;class D extends r.$Uc{constructor(p,b="",a="",f=!0,h){super(),this.j=this.B(new n.$he),this.onDidChange=this.j.event,this.z=!0,this.m=p,this.n=b,this.w=a,this.z=f,this.D=h}get id(){return this.m}get label(){return this.n}set label(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.j.fire({label:p}))}get tooltip(){return this.u||""}set tooltip(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.j.fire({tooltip:p}))}get class(){return this.w}set class(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.j.fire({class:p}))}get enabled(){return this.z}set enabled(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.j.fire({enabled:p}))}get checked(){return this.C}set checked(p){this.J(p)}J(p){this.C!==p&&(this.C=p,this.j.fire({checked:p}))}async run(p,b){this.D&&await this.D(p)}}e.$fj=D;class A extends r.$Uc{constructor(){super(...arguments),this.f=this.B(new n.$he),this.onWillRun=this.f.event,this.m=this.B(new n.$he),this.onDidRun=this.m.event}async run(p,b){if(!p.enabled)return;this.f.fire({action:p});let a;try{await this.u(p,b)}catch(f){a=f}this.m.fire({action:p,error:a})}async u(p,b){await p.run(b)}}e.$gj=A;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let b=[];for(const a of p)a.length&&(b.length?b=[...b,new R,...a]:b=a);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$hj=R;class v{get actions(){return this.a}constructor(p,b,a,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=b,this.class=f,this.a=a}async run(){}}e.$ij=v;class s extends D{static{this.ID="vs.actions.empty"}constructor(){super(s.ID,S.localize(0,null),void 0,!1)}}e.$jj=s;function E(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...p)=>y.run(...p)}}}),define(Ee[185],Se([7,8]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Ee[186],Se([1,0,185]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=s,e.$8m=E,e.$9m=y;const r=60,S=r*60,D=S*24,A=D*7,R=D*30,v=D*365;function s(p,b,a,f){typeof p!="number"&&(p=p.getTime());const h=Math.round((new Date().getTime()-p)/1e3);if(h<-30)return(0,n.localize)(0,null,s(new Date().getTime()+h*1e3,!1));if(!f&&h<30)return(0,n.localize)(1,null);let g;return h<r?(g=h,b?g===1?a?(0,n.localize)(2,null,g):(0,n.localize)(3,null,g):a?(0,n.localize)(4,null,g):(0,n.localize)(5,null,g):g===1?a?(0,n.localize)(6,null,g):(0,n.localize)(7,null,g):a?(0,n.localize)(8,null,g):(0,n.localize)(9,null,g)):h<S?(g=Math.floor(h/r),b?g===1?a?(0,n.localize)(10,null,g):(0,n.localize)(11,null,g):a?(0,n.localize)(12,null,g):(0,n.localize)(13,null,g):g===1?a?(0,n.localize)(14,null,g):(0,n.localize)(15,null,g):a?(0,n.localize)(16,null,g):(0,n.localize)(17,null,g)):h<D?(g=Math.floor(h/S),b?g===1?a?(0,n.localize)(18,null,g):(0,n.localize)(19,null,g):a?(0,n.localize)(20,null,g):(0,n.localize)(21,null,g):g===1?a?(0,n.localize)(22,null,g):(0,n.localize)(23,null,g):a?(0,n.localize)(24,null,g):(0,n.localize)(25,null,g)):h<A?(g=Math.floor(h/D),b?g===1?(0,n.localize)(26,null,g):(0,n.localize)(27,null,g):g===1?(0,n.localize)(28,null,g):(0,n.localize)(29,null,g)):h<R?(g=Math.floor(h/A),b?g===1?a?(0,n.localize)(30,null,g):(0,n.localize)(31,null,g):a?(0,n.localize)(32,null,g):(0,n.localize)(33,null,g):g===1?a?(0,n.localize)(34,null,g):(0,n.localize)(35,null,g):a?(0,n.localize)(36,null,g):(0,n.localize)(37,null,g)):h<v?(g=Math.floor(h/R),b?g===1?a?(0,n.localize)(38,null,g):(0,n.localize)(39,null,g):a?(0,n.localize)(40,null,g):(0,n.localize)(41,null,g):g===1?a?(0,n.localize)(42,null,g):(0,n.localize)(43,null,g):a?(0,n.localize)(44,null,g):(0,n.localize)(45,null,g)):(g=Math.floor(h/v),b?g===1?a?(0,n.localize)(46,null,g):(0,n.localize)(47,null,g):a?(0,n.localize)(48,null,g):(0,n.localize)(49,null,g):g===1?a?(0,n.localize)(50,null,g):(0,n.localize)(51,null,g):a?(0,n.localize)(52,null,g):(0,n.localize)(53,null,g))}function E(p,b){const a=Math.abs(p/1e3);return a<1?b?(0,n.localize)(54,null,p):(0,n.localize)(55,null,p):a<r?b?(0,n.localize)(56,null,Math.round(p)/1e3):(0,n.localize)(57,null,Math.round(p)/1e3):a<S?b?(0,n.localize)(58,null,Math.round(p/(1e3*r))):(0,n.localize)(59,null,Math.round(p/(1e3*r))):a<D?b?(0,n.localize)(60,null,Math.round(p/(1e3*S))):(0,n.localize)(61,null,Math.round(p/(1e3*S))):(0,n.localize)(62,null,Math.round(p/(1e3*D)))}function y(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[187],Se([7,8]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Ee[42],Se([1,0,18,11,187]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=v,e.$mj=s,e.$nj=E;function D(y,p){return p&&(y.stack||y.stacktrace)?S.localize(0,null,R(y),A(y.stack)||A(y.stacktrace)):R(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function R(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?S.localize(1,null,y.message):y.message||S.localize(2,null)}function v(y=null,p=!1){if(!y)return S.localize(3,null);if(Array.isArray(y)){const b=n.$Hb(y),a=v(b[0],p);return b.length>1?S.localize(4,null,a,b.length):a}if(r.$ag(y))return y;if(y.detail){const b=y.detail;if(b.error)return D(b.error,p);if(b.exception)return D(b.exception,p)}return y.stack?D(y,p):y.message?y.message:S.localize(5,null)}function s(y){const p=y;return p instanceof Error&&Array.isArray(p.actions)}function E(y,p){let b;return typeof y=="string"?b=new Error(y):b=y,b.actions=p,b}}),define(Ee[188],Se([7,8]),function(fe,e){return fe.create("vs/base/common/jsonErrorMessages",e)}),define(Ee[189],Se([1,0,188,44]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=S;function S(D){switch(D){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(0,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(1,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(2,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(3,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(4,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(5,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(6,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(7,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(8,null);default:return""}}}),define(Ee[190],Se([7,8]),function(fe,e){return fe.create("vs/base/common/platform",e)}),define(Ee[3],Se([1,0,190]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=I,e.$J=C,e.$g="en";let r=!1,S=!1,D=!1,A=!1,R=!1,v=!1,s=!1,E=!1,y=!1,p=!1,b,a=e.$g,f=e.$g,h,g;const w=globalThis;let m;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?m=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(m=process);const $=typeof m?.versions?.electron=="string",l=$&&m?.type==="renderer";if(typeof m=="object"){r=m.platform==="win32",S=m.platform==="darwin",D=m.platform==="linux",A=D&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,s=$,y=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=e.$g,a=e.$g;const T=m.env.VSCODE_NLS_CONFIG;if(T)try{const O=JSON.parse(T),P=O.availableLanguages["*"];b=O.locale,f=O.osLocale,a=P||e.$g,h=O._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!l?(g=navigator.userAgent,r=g.indexOf("Windows")>=0,S=g.indexOf("Macintosh")>=0,E=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=g.indexOf("Linux")>=0,p=g?.indexOf("Mobi")>=0,v=!0,b=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,a=b,f=navigator.language):console.error("Unable to resolve platform.");var t;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(T){switch(T){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let d=t.Web;S?d=t.Mac:r?d=t.Windows:D&&(d=t.Linux),e.$i=r,e.$j=S,e.$k=D,e.$l=A,e.$m=R,e.$n=s,e.$o=v,e.$p=v&&typeof w.importScripts=="function",e.$q=e.$p?w.origin:void 0,e.$r=E,e.$s=p,e.$t=y,e.$u=d,e.$v=g,e.$w=a;var i;(function(T){function O(){return e.$w}T.value=O;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}T.isDefaultVariant=P;function V(){return e.$w==="en"}T.isDefault=V})(i||(e.Language=i={})),e.$x=b,e.$y=f,e.$z=h,e.$A=typeof w.postMessage=="function"&&!w.importScripts,e.$B=(()=>{if(e.$A){const T=[];w.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let V=0,Q=T.length;V<Q;V++){const ie=T[V];if(ie.id===P.data.vscodeScheduleAsyncWork){T.splice(V,1),ie.callback();return}}});let O=0;return P=>{const V=++O;T.push({id:V,callback:P}),w.postMessage({vscodeScheduleAsyncWork:V},"*")}}return T=>setTimeout(T)})();var c;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=S||E?c.Macintosh:r?c.Windows:c.Linux;let u=!0,k=!1;function I(){if(!k){k=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,u=new Uint16Array(T.buffer)[0]===513}return u}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function C(T){return parseFloat(T)>=20}}),define(Ee[33],Se([1,0,3]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let r;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const D=S.process;r={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$dc=r.platform,e.$ec=r.arch}),define(Ee[9],Se([1,0,33]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const r=65,S=97,D=90,A=122,R=46,v=47,s=92,E=58,y=63;class p extends Error{constructor(o,d,i){let c;typeof d=="string"&&d.indexOf("not ")===0?(c="must not be",d=d.replace(/^not /,"")):c="must be";const u=o.indexOf(".")!==-1?"property":"argument";let k=`The "${o}" ${u} ${c} of type ${d}`;k+=`. Received type ${typeof i}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function b(t,o){if(t===null||typeof t!="object")throw new p(o,"Object",t)}function a(t,o){if(typeof t!="string")throw new p(o,"string",t)}const f=n.$dc==="win32";function h(t){return t===v||t===s}function g(t){return t===v}function w(t){return t>=r&&t<=D||t>=S&&t<=A}function m(t,o,d,i){let c="",u=0,k=-1,I=0,C=0;for(let T=0;T<=t.length;++T){if(T<t.length)C=t.charCodeAt(T);else{if(i(C))break;C=v}if(i(C)){if(!(k===T-1||I===1))if(I===2){if(c.length<2||u!==2||c.charCodeAt(c.length-1)!==R||c.charCodeAt(c.length-2)!==R){if(c.length>2){const O=c.lastIndexOf(d);O===-1?(c="",u=0):(c=c.slice(0,O),u=c.length-1-c.lastIndexOf(d)),k=T,I=0;continue}else if(c.length!==0){c="",u=0,k=T,I=0;continue}}o&&(c+=c.length>0?`${d}..`:"..",u=2)}else c.length>0?c+=`${d}${t.slice(k+1,T)}`:c=t.slice(k+1,T),u=T-k-1;k=T,I=0}else C===R&&I!==-1?++I:I=-1}return c}function $(t,o){b(o,"pathObject");const d=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return d?d===o.root?`${d}${i}`:`${d}${t}${i}`:i}e.$fc={resolve(...t){let o="",d="",i=!1;for(let c=t.length-1;c>=-1;c--){let u;if(c>=0){if(u=t[c],a(u,"path"),u.length===0)continue}else o.length===0?u=n.cwd():(u=n.env[`=${o}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==o.toLowerCase()&&u.charCodeAt(2)===s)&&(u=`${o}\\`));const k=u.length;let I=0,C="",T=!1;const O=u.charCodeAt(0);if(k===1)h(O)&&(I=1,T=!0);else if(h(O))if(T=!0,h(u.charCodeAt(1))){let P=2,V=P;for(;P<k&&!h(u.charCodeAt(P));)P++;if(P<k&&P!==V){const Q=u.slice(V,P);for(V=P;P<k&&h(u.charCodeAt(P));)P++;if(P<k&&P!==V){for(V=P;P<k&&!h(u.charCodeAt(P));)P++;(P===k||P!==V)&&(C=`\\\\${Q}\\${u.slice(V,P)}`,I=P)}}}else I=1;else w(O)&&u.charCodeAt(1)===E&&(C=u.slice(0,2),I=2,k>2&&h(u.charCodeAt(2))&&(T=!0,I=3));if(C.length>0)if(o.length>0){if(C.toLowerCase()!==o.toLowerCase())continue}else o=C;if(i){if(o.length>0)break}else if(d=`${u.slice(I)}\\${d}`,i=T,T&&o.length>0)break}return d=m(d,!i,"\\",h),i?`${o}\\${d}`:`${o}${d}`||"."},normalize(t){a(t,"path");const o=t.length;if(o===0)return".";let d=0,i,c=!1;const u=t.charCodeAt(0);if(o===1)return g(u)?"\\":t;if(h(u))if(c=!0,h(t.charCodeAt(1))){let I=2,C=I;for(;I<o&&!h(t.charCodeAt(I));)I++;if(I<o&&I!==C){const T=t.slice(C,I);for(C=I;I<o&&h(t.charCodeAt(I));)I++;if(I<o&&I!==C){for(C=I;I<o&&!h(t.charCodeAt(I));)I++;if(I===o)return`\\\\${T}\\${t.slice(C)}\\`;I!==C&&(i=`\\\\${T}\\${t.slice(C,I)}`,d=I)}}}else d=1;else w(u)&&t.charCodeAt(1)===E&&(i=t.slice(0,2),d=2,o>2&&h(t.charCodeAt(2))&&(c=!0,d=3));let k=d<o?m(t.slice(d),!c,"\\",h):"";return k.length===0&&!c&&(k="."),k.length>0&&h(t.charCodeAt(o-1))&&(k+="\\"),i===void 0?c?`\\${k}`:k:c?`${i}\\${k}`:`${i}${k}`},isAbsolute(t){a(t,"path");const o=t.length;if(o===0)return!1;const d=t.charCodeAt(0);return h(d)||o>2&&w(d)&&t.charCodeAt(1)===E&&h(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,d;for(let u=0;u<t.length;++u){const k=t[u];a(k,"path"),k.length>0&&(o===void 0?o=d=k:o+=`\\${k}`)}if(o===void 0)return".";let i=!0,c=0;if(typeof d=="string"&&h(d.charCodeAt(0))){++c;const u=d.length;u>1&&h(d.charCodeAt(1))&&(++c,u>2&&(h(d.charCodeAt(2))?++c:i=!1))}if(i){for(;c<o.length&&h(o.charCodeAt(c));)c++;c>=2&&(o=`\\${o.slice(c)}`)}return e.$fc.normalize(o)},relative(t,o){if(a(t,"from"),a(o,"to"),t===o)return"";const d=e.$fc.resolve(t),i=e.$fc.resolve(o);if(d===i||(t=d.toLowerCase(),o=i.toLowerCase(),t===o))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===s;)c++;let u=t.length;for(;u-1>c&&t.charCodeAt(u-1)===s;)u--;const k=u-c;let I=0;for(;I<o.length&&o.charCodeAt(I)===s;)I++;let C=o.length;for(;C-1>I&&o.charCodeAt(C-1)===s;)C--;const T=C-I,O=k<T?k:T;let P=-1,V=0;for(;V<O;V++){const ie=t.charCodeAt(c+V);if(ie!==o.charCodeAt(I+V))break;ie===s&&(P=V)}if(V!==O){if(P===-1)return i}else{if(T>O){if(o.charCodeAt(I+V)===s)return i.slice(I+V+1);if(V===2)return i.slice(I+V)}k>O&&(t.charCodeAt(c+V)===s?P=V:V===2&&(P=3)),P===-1&&(P=0)}let Q="";for(V=c+P+1;V<=u;++V)(V===u||t.charCodeAt(V)===s)&&(Q+=Q.length===0?"..":"\\..");return I+=P,Q.length>0?`${Q}${i.slice(I,C)}`:(i.charCodeAt(I)===s&&++I,i.slice(I,C))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===s){if(o.charCodeAt(1)===s){const d=o.charCodeAt(2);if(d!==y&&d!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(w(o.charCodeAt(0))&&o.charCodeAt(1)===E&&o.charCodeAt(2)===s)return`\\\\?\\${o}`;return t},dirname(t){a(t,"path");const o=t.length;if(o===0)return".";let d=-1,i=0;const c=t.charCodeAt(0);if(o===1)return h(c)?t:".";if(h(c)){if(d=i=1,h(t.charCodeAt(1))){let I=2,C=I;for(;I<o&&!h(t.charCodeAt(I));)I++;if(I<o&&I!==C){for(C=I;I<o&&h(t.charCodeAt(I));)I++;if(I<o&&I!==C){for(C=I;I<o&&!h(t.charCodeAt(I));)I++;if(I===o)return t;I!==C&&(d=i=I+1)}}}}else w(c)&&t.charCodeAt(1)===E&&(d=o>2&&h(t.charCodeAt(2))?3:2,i=d);let u=-1,k=!0;for(let I=o-1;I>=i;--I)if(h(t.charCodeAt(I))){if(!k){u=I;break}}else k=!1;if(u===-1){if(d===-1)return".";u=d}return t.slice(0,u)},basename(t,o){o!==void 0&&a(o,"ext"),a(t,"path");let d=0,i=-1,c=!0,u;if(t.length>=2&&w(t.charCodeAt(0))&&t.charCodeAt(1)===E&&(d=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let k=o.length-1,I=-1;for(u=t.length-1;u>=d;--u){const C=t.charCodeAt(u);if(h(C)){if(!c){d=u+1;break}}else I===-1&&(c=!1,I=u+1),k>=0&&(C===o.charCodeAt(k)?--k===-1&&(i=u):(k=-1,i=I))}return d===i?i=I:i===-1&&(i=t.length),t.slice(d,i)}for(u=t.length-1;u>=d;--u)if(h(t.charCodeAt(u))){if(!c){d=u+1;break}}else i===-1&&(c=!1,i=u+1);return i===-1?"":t.slice(d,i)},extname(t){a(t,"path");let o=0,d=-1,i=0,c=-1,u=!0,k=0;t.length>=2&&t.charCodeAt(1)===E&&w(t.charCodeAt(0))&&(o=i=2);for(let I=t.length-1;I>=o;--I){const C=t.charCodeAt(I);if(h(C)){if(!u){i=I+1;break}continue}c===-1&&(u=!1,c=I+1),C===R?d===-1?d=I:k!==1&&(k=1):d!==-1&&(k=-1)}return d===-1||c===-1||k===0||k===1&&d===c-1&&d===i+1?"":t.slice(d,c)},format:$.bind(null,"\\"),parse(t){a(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const d=t.length;let i=0,c=t.charCodeAt(0);if(d===1)return h(c)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(h(c)){if(i=1,h(t.charCodeAt(1))){let P=2,V=P;for(;P<d&&!h(t.charCodeAt(P));)P++;if(P<d&&P!==V){for(V=P;P<d&&h(t.charCodeAt(P));)P++;if(P<d&&P!==V){for(V=P;P<d&&!h(t.charCodeAt(P));)P++;P===d?i=P:P!==V&&(i=P+1)}}}}else if(w(c)&&t.charCodeAt(1)===E){if(d<=2)return o.root=o.dir=t,o;if(i=2,h(t.charCodeAt(2))){if(d===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let u=-1,k=i,I=-1,C=!0,T=t.length-1,O=0;for(;T>=i;--T){if(c=t.charCodeAt(T),h(c)){if(!C){k=T+1;break}continue}I===-1&&(C=!1,I=T+1),c===R?u===-1?u=T:O!==1&&(O=1):u!==-1&&(O=-1)}return I!==-1&&(u===-1||O===0||O===1&&u===I-1&&u===k+1?o.base=o.name=t.slice(k,I):(o.name=t.slice(k,u),o.base=t.slice(k,I),o.ext=t.slice(u,I))),k>0&&k!==i?o.dir=t.slice(0,k-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(f){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$gc={resolve(...t){let o="",d=!1;for(let i=t.length-1;i>=-1&&!d;i--){const c=i>=0?t[i]:l();a(c,"path"),c.length!==0&&(o=`${c}/${o}`,d=c.charCodeAt(0)===v)}return o=m(o,!d,"/",g),d?`/${o}`:o.length>0?o:"."},normalize(t){if(a(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===v,d=t.charCodeAt(t.length-1)===v;return t=m(t,!o,"/",g),t.length===0?o?"/":d?"./":".":(d&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return a(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let o;for(let d=0;d<t.length;++d){const i=t[d];a(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(a(t,"from"),a(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const d=1,i=t.length,c=i-d,u=1,k=o.length-u,I=c<k?c:k;let C=-1,T=0;for(;T<I;T++){const P=t.charCodeAt(d+T);if(P!==o.charCodeAt(u+T))break;P===v&&(C=T)}if(T===I)if(k>I){if(o.charCodeAt(u+T)===v)return o.slice(u+T+1);if(T===0)return o.slice(u+T)}else c>I&&(t.charCodeAt(d+T)===v?C=T:T===0&&(C=0));let O="";for(T=d+C+1;T<=i;++T)(T===i||t.charCodeAt(T)===v)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(u+C)}`},toNamespacedPath(t){return t},dirname(t){if(a(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===v;let d=-1,i=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===v){if(!i){d=c;break}}else i=!1;return d===-1?o?"/":".":o&&d===1?"//":t.slice(0,d)},basename(t,o){o!==void 0&&a(o,"ext"),a(t,"path");let d=0,i=-1,c=!0,u;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let k=o.length-1,I=-1;for(u=t.length-1;u>=0;--u){const C=t.charCodeAt(u);if(C===v){if(!c){d=u+1;break}}else I===-1&&(c=!1,I=u+1),k>=0&&(C===o.charCodeAt(k)?--k===-1&&(i=u):(k=-1,i=I))}return d===i?i=I:i===-1&&(i=t.length),t.slice(d,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===v){if(!c){d=u+1;break}}else i===-1&&(c=!1,i=u+1);return i===-1?"":t.slice(d,i)},extname(t){a(t,"path");let o=-1,d=0,i=-1,c=!0,u=0;for(let k=t.length-1;k>=0;--k){const I=t.charCodeAt(k);if(I===v){if(!c){d=k+1;break}continue}i===-1&&(c=!1,i=k+1),I===R?o===-1?o=k:u!==1&&(u=1):o!==-1&&(u=-1)}return o===-1||i===-1||u===0||u===1&&o===i-1&&o===d+1?"":t.slice(o,i)},format:$.bind(null,"/"),parse(t){a(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const d=t.charCodeAt(0)===v;let i;d?(o.root="/",i=1):i=0;let c=-1,u=0,k=-1,I=!0,C=t.length-1,T=0;for(;C>=i;--C){const O=t.charCodeAt(C);if(O===v){if(!I){u=C+1;break}continue}k===-1&&(I=!1,k=C+1),O===R?c===-1?c=C:T!==1&&(T=1):c!==-1&&(T=-1)}if(k!==-1){const O=u===0&&d?1:u;c===-1||T===0||T===1&&c===k-1&&c===u+1?o.base=o.name=t.slice(O,k):(o.name=t.slice(O,c),o.base=t.slice(O,k),o.ext=t.slice(c,k))}return u>0?o.dir=t.slice(0,u-1):d&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=f?e.$fc.normalize:e.$gc.normalize,e.$ic=f?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=f?e.$fc.join:e.$gc.join,e.$kc=f?e.$fc.resolve:e.$gc.resolve,e.$lc=f?e.$fc.relative:e.$gc.relative,e.$mc=f?e.$fc.dirname:e.$gc.dirname,e.$nc=f?e.$fc.basename:e.$gc.basename,e.$oc=f?e.$fc.extname:e.$gc.extname,e.$pc=f?e.$fc.format:e.$gc.format,e.$qc=f?e.$fc.parse:e.$gc.parse,e.$rc=f?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=f?e.$fc.sep:e.$gc.sep,e.$tc=f?e.$fc.delimiter:e.$gc.delimiter}),define(Ee[37],Se([1,0,35,9,3,17,11]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=R,e.$tg=v,e.$ug=s,e.$vg=E,e.$wg=y,e.$xg=f,e.$yg=h,e.$zg=g,e.$Ag=w,e.$Bg=m,e.$Cg=$,e.$Dg=l,e.$Eg=t,e.$Fg=o,e.$Gg=d,e.$Hg=i,e.$Ig=k;function R(I){return I===n.CharCode.Slash||I===n.CharCode.Backslash}function v(I){return I.replace(/[\\/]/g,r.$gc.sep)}function s(I){return I.indexOf("/")===-1&&(I=v(I)),/^[a-zA-Z]:(\/|$)/.test(I)&&(I="/"+I),I}function E(I,C=r.$gc.sep){if(!I)return"";const T=I.length,O=I.charCodeAt(0);if(R(O)){if(R(I.charCodeAt(1))&&!R(I.charCodeAt(2))){let V=3;const Q=V;for(;V<T&&!R(I.charCodeAt(V));V++);if(Q!==V&&!R(I.charCodeAt(V+1))){for(V+=1;V<T;V++)if(R(I.charCodeAt(V)))return I.slice(0,V+1).replace(/[\\/]/g,C)}}return C}else if(w(O)&&I.charCodeAt(1)===n.CharCode.Colon)return R(I.charCodeAt(2))?I.slice(0,2)+C:I.slice(0,2);let P=I.indexOf("://");if(P!==-1){for(P+=3;P<T;P++)if(R(I.charCodeAt(P)))return I.slice(0,P+1)}return""}function y(I){if(!S.$i||!I||I.length<5)return!1;let C=I.charCodeAt(0);if(C!==n.CharCode.Backslash||(C=I.charCodeAt(1),C!==n.CharCode.Backslash))return!1;let T=2;const O=T;for(;T<I.length&&(C=I.charCodeAt(T),C!==n.CharCode.Backslash);T++);return!(O===T||(C=I.charCodeAt(T+1),isNaN(C)||C===n.CharCode.Backslash))}const p=/[\\/:\*\?"<>\|]/g,b=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(I,C=S.$i){const T=C?p:b;return!(!I||I.length===0||/^\s+$/.test(I)||(T.lastIndex=0,T.test(I))||C&&a.test(I)||I==="."||I===".."||C&&I[I.length-1]==="."||C&&I.length!==I.trim().length||I.length>255)}function h(I,C,T){const O=I===C;return!T||O?O:!I||!C?!1:(0,D.$Bf)(I,C)}function g(I,C,T,O=r.sep){if(I===C)return!0;if(!I||!C||C.length>I.length)return!1;if(T){if(!(0,D.$Cf)(I,C))return!1;if(C.length===I.length)return!0;let V=C.length;return C.charAt(C.length-1)===O&&V--,I.charAt(V)===O}return C.charAt(C.length-1)!==O&&(C+=O),I.indexOf(C)===0}function w(I){return I>=n.CharCode.A&&I<=n.CharCode.Z||I>=n.CharCode.a&&I<=n.CharCode.z}function m(I,C){return S.$i&&I.endsWith(":")&&(I+=r.sep),(0,r.$ic)(I)||(I=(0,r.$jc)(C,I)),I=(0,r.$hc)(I),$(I)}function $(I){return S.$i?(I=(0,D.$jf)(I,r.sep),I.endsWith(":")&&(I+=r.sep)):(I=(0,D.$jf)(I,r.sep),I||(I=r.sep)),I}function l(I){const C=(0,r.$hc)(I);return S.$i?I.length>3?!1:t(C)&&(I.length===2||C.charCodeAt(2)===n.CharCode.Backslash):C===r.$gc.sep}function t(I,C=S.$i){return C?w(I.charCodeAt(0))&&I.charCodeAt(1)===n.CharCode.Colon:!1}function o(I,C=S.$i){return t(I,C)?I[0]:void 0}function d(I,C,T){return C.length>I.length?-1:I===C?0:(T&&(I=I.toLowerCase(),C=C.toLowerCase()),I.indexOf(C))}function i(I){const C=I.split(":");let T,O,P;for(const V of C){const Q=Number(V);(0,A.$eg)(Q)?O===void 0?O=Q:P===void 0&&(P=Q):T=T?[T,V].join(":"):V}if(!T)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:T,line:O!==void 0?O:void 0,column:P!==void 0?P:O!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(I,C,T=8){let O="";for(let V=0;V<T;V++){let Q;V===0&&S.$i&&!C&&(T===3||T===4)?Q=u:Q=c,O+=Q.charAt(Math.floor(Math.random()*Q.length))}let P;return C?P=`${C}-${O}`:P=O,I?(0,r.$jc)(I,P):P}}),define(Ee[68],Se([1,0,9]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Zs=D,e.$1s=A,e.$2s=R,e.$3s=s,e.$Ys=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(E){const y=(0,n.$oc)(E),p=r[y.toLowerCase()];return p!==void 0?p:A(E)}function A(E){const y=(0,n.$oc)(E);return S[y.toLowerCase()]}function R(E){for(const y in S)if(S[y]===E)return y}const v=/^(.+)\/(.+?)(;.+)?$/;function s(E,y){const p=v.exec(E);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:y?void 0:E}}),define(Ee[69],Se([1,0,3]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$rm=D,e.$sm=A;var r;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(r||(e.Source=r={}));var S;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function D(R,...v){const s=v.reduce((p,b)=>(p[b]=!0,p),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(p=>!s[p]).forEach(p=>{for(let b=0;b<E.length;b++)if(p.search(E[b])!==-1){delete R[p];break}})}function A(R){R&&(delete R.DEBUG,n.$j&&delete R.DYLD_LIBRARY_PATH,n.$k&&delete R.LD_PRELOAD)}}),define(Ee[4],Se([1,0,35,80,9,3]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=h,e.$wc=t;const A=/^\w[\w\d+.-]*$/,R=/^\//,v=/^\/\//;function s(u,k){if(!u.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!A.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!R.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(u,k){return!u&&!k?"file":u}function y(u,k){switch(u){case"https":case"http":case"file":k?k[0]!==b&&(k=b+k):k=b;break}return k}const p="",b="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(k){return k instanceof f?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,I,C,T,O,P=!1){typeof k=="object"?(this.scheme=k.scheme||p,this.authority=k.authority||p,this.path=k.path||p,this.query=k.query||p,this.fragment=k.fragment||p):(this.scheme=E(k,P),this.authority=I||p,this.path=y(this.scheme,C||p),this.query=T||p,this.fragment=O||p,s(this,P))}get fsPath(){return t(this,!1)}with(k){if(!k)return this;let{scheme:I,authority:C,path:T,query:O,fragment:P}=k;return I===void 0?I=this.scheme:I===null&&(I=p),C===void 0?C=this.authority:C===null&&(C=p),T===void 0?T=this.path:T===null&&(T=p),O===void 0?O=this.query:O===null&&(O=p),P===void 0?P=this.fragment:P===null&&(P=p),I===this.scheme&&C===this.authority&&T===this.path&&O===this.query&&P===this.fragment?this:new w(I,C,T,O,P)}static parse(k,I=!1){const C=a.exec(k);return C?new w(C[2]||p,c(C[4]||p),c(C[5]||p),c(C[7]||p),c(C[9]||p),I):new w(p,p,p,p,p)}static file(k){let I=p;if(D.$i&&(k=k.replace(/\\/g,b)),k[0]===b&&k[1]===b){const C=k.indexOf(b,2);C===-1?(I=k.substring(2),k=b):(I=k.substring(2,C),k=k.substring(C)||b)}return new w("file",I,k,p,p)}static from(k,I){return new w(k.scheme,k.authority,k.path,k.query,k.fragment,I)}static joinPath(k,...I){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return D.$i&&k.scheme==="file"?C=f.file(S.$fc.join(t(k,!0),...I)).path:C=S.$gc.join(k.path,...I),k.with({path:C})}toString(k=!1){return o(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof f)return k;{const I=new w(k);return I._formatted=k.external??null,I._fsPath=k._sep===g?k.fsPath??null:null,I}}else return k}}e.URI=f;function h(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}const g=D.$i?1:void 0;class w extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(k=!1){return k?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const k={$mid:r.MarshalledId.Uri};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=g),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const m={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function $(u,k,I){let C,T=-1;for(let O=0;O<u.length;O++){const P=u.charCodeAt(O);if(P>=n.CharCode.a&&P<=n.CharCode.z||P>=n.CharCode.A&&P<=n.CharCode.Z||P>=n.CharCode.Digit0&&P<=n.CharCode.Digit9||P===n.CharCode.Dash||P===n.CharCode.Period||P===n.CharCode.Underline||P===n.CharCode.Tilde||k&&P===n.CharCode.Slash||I&&P===n.CharCode.OpenSquareBracket||I&&P===n.CharCode.CloseSquareBracket||I&&P===n.CharCode.Colon)T!==-1&&(C+=encodeURIComponent(u.substring(T,O)),T=-1),C!==void 0&&(C+=u.charAt(O));else{C===void 0&&(C=u.substr(0,O));const V=m[P];V!==void 0?(T!==-1&&(C+=encodeURIComponent(u.substring(T,O)),T=-1),C+=V):T===-1&&(T=O)}}return T!==-1&&(C+=encodeURIComponent(u.substring(T))),C!==void 0?C:u}function l(u){let k;for(let I=0;I<u.length;I++){const C=u.charCodeAt(I);C===n.CharCode.Hash||C===n.CharCode.QuestionMark?(k===void 0&&(k=u.substr(0,I)),k+=m[C]):k!==void 0&&(k+=u[I])}return k!==void 0?k:u}function t(u,k){let I;return u.authority&&u.path.length>1&&u.scheme==="file"?I=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===n.CharCode.Slash&&(u.path.charCodeAt(1)>=n.CharCode.A&&u.path.charCodeAt(1)<=n.CharCode.Z||u.path.charCodeAt(1)>=n.CharCode.a&&u.path.charCodeAt(1)<=n.CharCode.z)&&u.path.charCodeAt(2)===n.CharCode.Colon?k?I=u.path.substr(1):I=u.path[1].toLowerCase()+u.path.substr(2):I=u.path,D.$i&&(I=I.replace(/\//g,"\\")),I}function o(u,k){const I=k?l:$;let C="",{scheme:T,authority:O,path:P,query:V,fragment:Q}=u;if(T&&(C+=T,C+=":"),(O||T==="file")&&(C+=b,C+=b),O){let ie=O.indexOf("@");if(ie!==-1){const re=O.substr(0,ie);O=O.substr(ie+1),ie=re.lastIndexOf(":"),ie===-1?C+=I(re,!1,!1):(C+=I(re.substr(0,ie),!1,!1),C+=":",C+=I(re.substr(ie+1),!1,!0)),C+="@"}O=O.toLowerCase(),ie=O.lastIndexOf(":"),ie===-1?C+=I(O,!1,!0):(C+=I(O.substr(0,ie),!1,!0),C+=O.substr(ie))}if(P){if(P.length>=3&&P.charCodeAt(0)===n.CharCode.Slash&&P.charCodeAt(2)===n.CharCode.Colon){const ie=P.charCodeAt(1);ie>=n.CharCode.A&&ie<=n.CharCode.Z&&(P=`/${String.fromCharCode(ie+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===n.CharCode.Colon){const ie=P.charCodeAt(0);ie>=n.CharCode.A&&ie<=n.CharCode.Z&&(P=`${String.fromCharCode(ie+32)}:${P.substr(2)}`)}C+=I(P,!0,!1)}return V&&(C+="?",C+=I(V,!1,!1)),Q&&(C+="#",C+=k?Q:$(Q,!1,!1)),C}function d(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+d(u.substr(3)):u}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(u){return u.match(i)?u.replace(i,k=>d(k)):u}}),define(Ee[191],Se([1,0,4]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=r,e.$5q=S,e.$6q=D,e.log=R;function r(s){const E=s;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function S(s){const E=[];let y;try{const p=JSON.parse(s.arguments),b=p[p.length-1];b&&b.__$stack&&(p.pop(),y=b.__$stack),E.push(...p)}catch{E.push("Unable to log remote console arguments",s.arguments)}return{args:E,stack:y}}function D(s){if(typeof s!="string")return D(S(s).stack);const E=s;if(E){const y=A(E),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(p&&p.length===4)return{uri:n.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function A(s){if(!s)return s;const E=s.indexOf(`
`);return E===-1?s:s.substring(0,E)}function R(s,E){const{args:y,stack:p}=S(s),b=typeof y[0]=="string"&&y.length===1;let a=A(p);a&&(a=`(${a.trim()})`);let f=[];if(typeof y[0]=="string"?a&&b?f=[`%c[${E}] %c${y[0]} %c${a}`,v("blue"),v(""),v("grey")]:f=[`%c[${E}] %c${y[0]}`,v("blue"),v(""),...y.slice(1)]:f=[`%c[${E}]%`,v("blue"),...y],a&&!b&&f.push(a),typeof console[s.severity]!="function")throw new Error("Unknown console method");console[s.severity].apply(console,f)}function v(s){return`color: ${s}`}}),define(Ee[49],Se([1,0,15,4,80]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=D,e.$9h=A,e.$0h=v;function D(s){return JSON.stringify(s,R)}function A(s){let E=JSON.parse(s);return E=v(E),E}function R(s,E){return E instanceof RegExp?{$mid:S.MarshalledId.Regexp,source:E.source,flags:E.flags}:E}function v(s,E=0){if(!s||E>200)return s;if(typeof s=="object"){switch(s.$mid){case S.MarshalledId.Uri:return r.URI.revive(s);case S.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case S.MarshalledId.Date:return new Date(s.source)}if(s instanceof n.$Je||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let y=0;y<s.length;++y)s[y]=v(s[y],E+1);else for(const y in s)Object.hasOwnProperty.call(s,y)&&(s[y]=v(s[y],E+1))}return s}}),define(Ee[13],Se([1,0,10,3,17,4,9]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=v,e.$Kg=s,e.$Og=y;var R;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",a.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(R||(e.Schemas=R={}));function v(a,f){return D.URI.isUri(a)?(0,S.$Bf)(a.scheme,f):(0,S.$Cf)(a,f+":")}function s(a,...f){return f.some(h=>v(a,h))}e.$Lg="vscode-tkn",e.$Mg="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f,h){this.f=y(f,h)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,R.vscodeRemoteResource)}set(f,h,g){this.a[f]=h,this.b[f]=g}setConnectionToken(f,h){this.c[f]=h}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(l){return n.$1(l),f}const h=f.authority;let g=this.a[h];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const w=this.b[h],m=this.c[h];let $=`path=${encodeURIComponent(f.path)}`;return typeof m=="string"&&($+=`&${e.$Mg}=${encodeURIComponent(m)}`),D.URI.from({scheme:r.$o?this.d:R.vscodeRemoteResource,authority:`${g}:${w}`,path:this.g,query:$})}}e.$Ng=new E;function y(a,f){return A.$gc.join(f??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class p{static{this.a=e.$Tg}asBrowserUri(f){const h=this.b(f,fe);return this.uriToBrowserUri(h)}uriToBrowserUri(f){return f.scheme===R.vscodeRemote?e.$Ng.rewrite(f):f.scheme===R.file&&(r.$m||r.$q===`${R.vscodeFileResource}://${p.a}`)?f.with({scheme:R.vscodeFileResource,authority:f.authority||p.a,query:null,fragment:null}):f}asFileUri(f){const h=this.b(f,fe);return this.uriToFileUri(h)}uriToFileUri(f){return f.scheme===R.vscodeFileResource?f.with({scheme:R.file,authority:f.authority!==p.a?f.authority:null,query:null,fragment:null}):f}b(f,h){return D.URI.isUri(f)?f:D.URI.parse(h.toUrl(f))}}e.$Ug=new p;var b;(function(a){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(f.get("3"));const h="vscode-coi";function g(m){let $;typeof m=="string"?$=new URL(m).searchParams:m instanceof URL?$=m.searchParams:D.URI.isUri(m)&&($=new URL(m.toString(!0)).searchParams);const l=$?.get(h);if(l)return f.get(l)}a.getHeadersFromQuery=g;function w(m,$,l){if(!globalThis.crossOriginIsolated)return;const t=$&&l?"3":l?"2":"1";m instanceof URLSearchParams?m.set(h,t):m[h]=t}a.addSearchParam=w})(b||(e.COI=b={}))}),define(Ee[192],Se([1,0,104,13,3,4]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gE=E;class A{constructor(p,b,a){this.id=p,this.dependencies=b,this.callback=a}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,b,a)=>{typeof p!="string"&&(a=b,b=p,p=null),(typeof b!="object"||!Array.isArray(b))&&(a=b,b=null),this.c.push(new A(p,b,a))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const b=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!b)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(b.dependencies)&&b.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${b.dependencies.join(", ")}`);return typeof b.callback=="function"?b.callback([]):b.callback}h(p){return new Promise((b,a)=>{const f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript");const h=()=>{f.removeEventListener("load",g),f.removeEventListener("error",w)},g=m=>{h(),b(this.c.pop())},w=m=>{h(),a(m)};f.addEventListener("load",g),f.addEventListener("error",w),this.f&&(p=this.f.createScriptURL(p)),f.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(f)})}i(p){return new Promise((b,a)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),b(this.c.pop())}catch(f){a(f)}})}async j(p){try{const b=globalThis._VSCODE_NODE_MODULES.fs,a=globalThis._VSCODE_NODE_MODULES.vm,f=globalThis._VSCODE_NODE_MODULES.module,h=D.URI.parse(p).fsPath,g=b.readFileSync(h).toString(),w=f.wrap(g.replace(/^#!.*/,""));return new a.Script(w).runInThisContext().apply(),this.c.pop()}catch(b){throw b}}}const v=new Map;let s={};typeof globalThis.require=="object"&&(s=globalThis.require.paths??{});async function E(y,p,b){if(n.$T){b===void 0&&(b=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),s[y]&&(y=s[y]);const a=`${y}/${p}`;if(v.has(a))return v.get(a);let f;if(/^\w[\w\d+.-]*:\/\//.test(a))f=a;else{const m=`${b&&!S.$o?r.$Rg:r.$Qg}/${a}`;f=r.$Ug.asBrowserUri(m).toString(!0)}const h=R.INSTANCE.load(f);return v.set(a,h),h}else return await new Promise((a,f)=>{fe([y],a,f)})}}),define(Ee[20],Se([1,0,35,37,13,9,3,17,4]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=s,e.$kh=y,e.$lh=b;function s(a){return(0,v.$wc)(a,!0)}class E{constructor(f){this.a=f}compare(f,h,g=!1){return f===h?0:(0,R.$uf)(this.getComparisonKey(f,g),this.getComparisonKey(h,g))}isEqual(f,h,g=!1){return f===h?!0:!f||!h?!1:this.getComparisonKey(f,g)===this.getComparisonKey(h,g)}getComparisonKey(f,h=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,h,g=!1){if(f.scheme===h.scheme){if(f.scheme===S.Schemas.file)return r.$zg(s(f),s(h),this.a(f))&&f.query===h.query&&(g||f.fragment===h.fragment);if((0,e.$gh)(f.authority,h.authority))return r.$zg(f.path,h.path,this.a(f),"/")&&f.query===h.query&&(g||f.fragment===h.fragment)}return!1}joinPath(f,...h){return v.URI.joinPath(f,...h)}basenameOrAuthority(f){return(0,e.$$g)(f)||f.authority}basename(f){return D.$gc.basename(f.path)}extname(f){return D.$gc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let h;return f.scheme===S.Schemas.file?h=v.URI.file(D.$mc(s(f))).path:(h=D.$gc.dirname(f.path),f.authority&&h.length&&h.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${f.toString})) resulted in a relative path`),h="/")),f.with({path:h})}normalizePath(f){if(!f.path.length)return f;let h;return f.scheme===S.Schemas.file?h=v.URI.file(D.$hc(s(f))).path:h=D.$gc.normalize(f.path),f.with({path:h})}relativePath(f,h){if(f.scheme!==h.scheme||!(0,e.$gh)(f.authority,h.authority))return;if(f.scheme===S.Schemas.file){const m=D.$lc(s(f),s(h));return A.$i?r.$tg(m):m}let g=f.path||"/";const w=h.path||"/";if(this.a(f)){let m=0;for(const $=Math.min(g.length,w.length);m<$&&!(g.charCodeAt(m)!==w.charCodeAt(m)&&g.charAt(m).toLowerCase()!==w.charAt(m).toLowerCase());m++);g=w.substr(0,m)+g.substr(m)}return D.$gc.relative(g,w)}resolvePath(f,h){if(f.scheme===S.Schemas.file){const g=v.URI.file(D.$kc(s(f),h));return f.with({authority:g.authority,path:g.path})}return h=r.$ug(h),f.with({path:D.$gc.resolve(f.path,h)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,h){return f===h||f!==void 0&&h!==void 0&&(0,R.$Bf)(f,h)}hasTrailingPathSeparator(f,h=D.sep){if(f.scheme===S.Schemas.file){const g=s(f);return g.length>r.$vg(g).length&&g[g.length-1]===h}else{const g=f.path;return g.length>1&&g.charCodeAt(g.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,h=D.sep){return(0,e.$hh)(f,h)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,h=D.sep){let g=!1;if(f.scheme===S.Schemas.file){const w=s(f);g=w!==void 0&&w.length===r.$vg(w).length&&w[w.length-1]===h}else{h="/";const w=f.path;g=w.length===1&&w.charCodeAt(w.length-1)===n.CharCode.Slash}return!g&&!(0,e.$hh)(f,h)?f.with({path:f.path+"/"}):f}}e.$3g=E,e.$4g=new E(()=>!1),e.$5g=new E(a=>a.scheme===S.Schemas.file?!A.$k:!0),e.$6g=new E(a=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function y(a,f){const h=[];for(let g=0;g<a.length;g++){const w=f(a[g]);a.some((m,$)=>$===g?!1:(0,e.$8g)(w,f(m)))||h.push(a[g])}return h}var p;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function f(h){const g=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach($=>{const[l,t]=$.split(":");l&&t&&g.set(l,t)});const m=h.path.substring(0,h.path.indexOf(";"));return m&&g.set(a.META_DATA_MIME,m),g}a.parseMetaData=f})(p||(e.DataUri=p={}));function b(a,f,h){if(f){let g=a.path;return g&&g[0]!==D.$gc.sep&&(g=D.$gc.sep+g),a.with({scheme:h,authority:f,path:g})}return a.with({scheme:h})}}),define(Ee[14],Se([1,0,19,10,6,2,20,3,170,65]),function(fe,e,n,r,S,D,A,R,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=E,e.$nh=y,e.$oh=p,e.$ph=b,e.$qh=a,e.$rh=f,e.$sh=h,e.$th=g,e.$Bh=u,e.$Ch=k,e.$Dh=I,e.$Eh=C,e.$Fh=T,e.$Uh=B,e.$3h=U;function E(x){return!!x&&typeof x.then=="function"}function y(x){const M=new n.$se,G=x(M.token),te=new Promise((he,ke)=>{const Ne=M.token.onCancellationRequested(()=>{Ne.dispose(),ke(new r.$5)});Promise.resolve(G).then(me=>{Ne.dispose(),M.dispose(),he(me)},me=>{Ne.dispose(),M.dispose(),ke(me)})});return new class{cancel(){M.cancel(),M.dispose()}then(he,ke){return te.then(he,ke)}catch(he){return this.then(void 0,he)}finally(he){return te.finally(he)}}}function p(x,M,G){return new Promise((te,he)=>{const ke=M.onCancellationRequested(()=>{ke.dispose(),te(G)});x.then(te,he).finally(()=>ke.dispose())})}function b(x,M){return new Promise((G,te)=>{const he=M.onCancellationRequested(()=>{he.dispose(),te(new r.$5)});x.then(G,te).finally(()=>he.dispose())})}async function a(x){let M=-1;const G=x.map((te,he)=>te.then(ke=>(M=he,ke)));try{return await Promise.race(G)}finally{x.forEach((te,he)=>{he!==M&&te.cancel()})}}function f(x,M,G){let te;const he=setTimeout(()=>{te?.(void 0),G?.()},M);return Promise.race([x.finally(()=>clearTimeout(he)),new Promise(ke=>te=ke)])}function h(x){return new Promise((M,G)=>{const te=x();E(te)?te.then(M,G):M(te)})}function g(){let x,M;return{promise:new Promise((te,he)=>{x=te,M=he}),resolve:x,reject:M}}class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(M){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=M,!this.b){const G=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(G,G).then(te)})}return new Promise((G,te)=>{this.b.then(G,te)})}return this.a=M(),new Promise((G,te)=>{this.a.then(he=>{this.a=null,G(he)},he=>{this.a=null,te(he)})})}dispose(){this.f=!0}}e.$uh=w;class m{constructor(){this.a=Promise.resolve(null)}queue(M){return this.a=this.a.then(()=>M(),()=>M())}}e.$vh=m;class ${constructor(){this.a=new Map}queue(M,G){const he=(this.a.get(M)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(M)===he&&this.a.delete(M)});return this.a.set(M,he),he}}e.$wh=$;const l=(x,M)=>{let G=!0;const te=setTimeout(()=>{G=!1,M()},x);return{isTriggered:()=>G,dispose:()=>{clearTimeout(te),G=!1}}},t=x=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,x())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class o{constructor(M){this.defaultDelay=M,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(M,G=this.defaultDelay){this.g=M,this.h(),this.b||(this.b=new Promise((he,ke)=>{this.d=he,this.f=ke}).then(()=>{if(this.b=null,this.d=null,this.g){const he=this.g;return this.g=null,he()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=G===v.$ce?t(te):l(G,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=o;class d{constructor(M){this.a=new o(M),this.b=new w}trigger(M,G){return this.a.trigger(()=>this.b.queue(M),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=d;class i{constructor(){this.a=!1,this.b=new Promise((M,G)=>{this.d=M})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=i;class c extends i{constructor(M){super(),this.f=setTimeout(()=>this.open(),M)}open(){clearTimeout(this.f),super.open()}}e.$Ah=c;function u(x,M){return M?new Promise((G,te)=>{const he=setTimeout(()=>{ke.dispose(),G()},x),ke=M.onCancellationRequested(()=>{clearTimeout(he),ke.dispose(),te(new r.$5)})}):y(G=>u(x,G))}function k(x,M=0,G){const te=setTimeout(()=>{x(),G&&he.dispose()},M),he=(0,D.$Sc)(()=>{clearTimeout(te),G?.deleteAndLeak(he)});return G?.add(he),he}function I(x){const M=[];let G=0;const te=x.length;function he(){return G<te?x[G++]():null}function ke(Ne){Ne!=null&&M.push(Ne);const me=he();return me?me.then(ke):Promise.resolve(M)}return Promise.resolve(null).then(ke)}function C(x,M=te=>!!te,G=null){let te=0;const he=x.length,ke=()=>{if(te>=he)return Promise.resolve(G);const Ne=x[te++];return Promise.resolve(Ne()).then(be=>M(be)?Promise.resolve(be):ke())};return ke()}function T(x,M=te=>!!te,G=null){if(x.length===0)return Promise.resolve(G);let te=x.length;const he=()=>{te=-1;for(const ke of x)ke.cancel?.()};return new Promise((ke,Ne)=>{for(const me of x)me.then(be=>{--te>=0&&M(be)?(he(),ke(be)):te===0&&ke(G)}).catch(be=>{--te>=0&&(he(),Ne(be))})})}class O{constructor(M){this.a=0,this.b=!1,this.f=M,this.g=[],this.d=0,this.h=new S.$he}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(M){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((G,te)=>{this.g.push({factory:M,c:G,e:te}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const M=this.g.shift();this.d++;const G=M.factory();G.then(M.c,M.e),G.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=O;class P extends O{constructor(){super(1)}}e.$Hh=P;class V{constructor(){this.a=new oe,this.b=0}queue(M){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,M())):this.a.run(this.b++,M())}}e.$Ih=V;class Q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const M=new q;return this.b.add(M),M.p}g(){for(const[,M]of this.a)if(M.size>0)return!1;return!0}queueSize(M,G=A.$4g){const te=G.getComparisonKey(M);return this.a.get(te)?.size??0}queueFor(M,G,te=A.$4g){const he=te.getComparisonKey(M);let ke=this.a.get(he);if(!ke){ke=new P;const Ne=this.f++,me=S.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.a.delete(he),this.h(),this.d?.deleteAndDispose(Ne),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$4c),this.d.set(Ne,me),this.a.set(he,ke)}return ke.queue(G)}h(){this.g()&&this.j()}j(){for(const M of this.b)M.complete();this.b.clear()}dispose(){for(const[,M]of this.a)M.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=Q;class ie{constructor(M,G){this.b=!1,this.a=-1,typeof M=="function"&&typeof G=="number"&&this.setIfNotSet(M,G)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(M,G){if(this.b)throw new r.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,M()},G)}setIfNotSet(M,G){if(this.b)throw new r.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,M()},G))}}e.$Kh=ie;class re{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(M,G,te=globalThis){if(this.f)throw new r.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const he=te.setInterval(()=>{M()},G);this.d=(0,D.$Sc)(()=>{te.clearInterval(he),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=re;class ne{constructor(M,G){this.b=-1,this.a=M,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(M=this.d){this.cancel(),this.b=setTimeout(this.f,M)}get delay(){return this.d}set delay(M){this.d=M}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=ne;class se{constructor(M,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=M,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(M=this.b){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(M/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=se;class Z extends ne{constructor(M,G){super(M,G),this.j=[]}work(M){this.j.push(M),this.isScheduled()||this.schedule()}h(){const M=this.j;this.j=[],this.a?.(M)}dispose(){this.j=[],super.dispose()}}e.$Oh=Z;class ee extends D.$Uc{constructor(M,G){super(),this.g=M,this.h=G,this.a=[],this.b=this.B(new D.$Vc),this.f=!1}get pending(){return this.a.length}work(M){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+M.length>this.g.maxBufferedWork)return!1}else if(this.pending+M.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of M)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=ee,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(x,M)=>{(0,R.$B)(()=>{if(G)return;const te=Date.now()+15;M(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$Rh=(x,M,G)=>{const te=x.requestIdleCallback(M,typeof G=="number"?{timeout:G}:void 0);let he=!1;return{dispose(){he||(he=!0,x.cancelIdleCallback(te))}}},e.$Qh=x=>(0,e.$Rh)(globalThis,x)}();class ue{constructor(M,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$Rh)(M,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=ue;class j extends ue{constructor(M){super(globalThis,M)}}e.$Th=j;async function B(x,M,G){let te;for(let he=0;he<G;he++)try{return await x()}catch(ke){te=ke,await u(M)}throw te}class oe{isRunning(M){return typeof M=="number"?this.a?.taskId===M:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(M,G,te){return this.a={taskId:M,cancel:()=>te?.(),promise:G},G.then(()=>this.d(M),()=>this.d(M)),G}d(M){this.a&&M===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const M=this.b;this.b=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}queue(M){if(this.b)this.b.run=M;else{const{promise:G,resolve:te,reject:he}=g();this.b={run:M,promise:G,promiseResolve:te,promiseReject:he}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=oe;class le{constructor(M,G=()=>Date.now()){this.d=M,this.f=G,this.a=0,this.b=0}increment(){const M=this.f();return M-this.a>this.d&&(this.a=M,this.b=0),this.b++,this.b}}e.$Wh=le;var pe;(function(x){x[x.Resolved=0]="Resolved",x[x.Rejected=1]="Rejected"})(pe||(pe={}));class q{get isRejected(){return this.d?.outcome===pe.Rejected}get isResolved(){return this.d?.outcome===pe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===pe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((M,G)=>{this.a=M,this.b=G})}complete(M){return new Promise(G=>{this.a(M),this.d={outcome:pe.Resolved,value:M},G()})}error(M){return new Promise(G=>{this.b(M),this.d={outcome:pe.Rejected,value:M},G()})}cancel(){return this.error(new r.$5)}}e.$Xh=q;var ae;(function(x){async function M(te){let he;const ke=await Promise.all(te.map(Ne=>Ne.then(me=>me,me=>{he||(he=me)})));if(typeof he<"u")throw he;return ke}x.settled=M;function G(te){return new Promise(async(he,ke)=>{try{await te(he,ke)}catch(Ne){ke(Ne)}})}x.withAsyncBody=G})(ae||(e.Promises=ae={}));class Y{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(M){this.a=void 0,this.b=void 0,this.d=!1,this.promise=M.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new r.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=Y;class H{constructor(M){this.b=M,this.a=new s.$V(()=>new Y(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=H;var L;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(L||(L={}));class W{static fromArray(M){return new W(G=>{G.emitMany(M)})}static fromPromise(M){return new W(async G=>{G.emitMany(await M)})}static fromPromises(M){return new W(async G=>{await Promise.all(M.map(async te=>G.emitOne(await te)))})}static merge(M){return new W(async G=>{await Promise.all(M.map(async te=>{for await(const he of te)G.emitOne(he)}))})}static{this.EMPTY=W.fromArray([])}constructor(M,G){this.a=L.Initial,this.b=[],this.d=null,this.f=G,this.g=new S.$he,queueMicrotask(async()=>{const te={emitOne:he=>this.h(he),emitMany:he=>this.j(he),reject:he=>this.l(he)};try{await Promise.resolve(M(te)),this.k()}catch(he){this.l(he)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this.a===L.DoneError)throw this.d;if(M<this.b.length)return{done:!1,value:this.b[M++]};if(this.a===L.DoneOK)return{done:!0,value:void 0};await S.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(M,G){return new W(async te=>{for await(const he of M)te.emitOne(G(he))})}map(M){return W.map(this,M)}static filter(M,G){return new W(async te=>{for await(const he of M)G(he)&&te.emitOne(he)})}filter(M){return W.filter(this,M)}static coalesce(M){return W.filter(M,G=>!!G)}coalesce(){return W.coalesce(this)}static async toPromise(M){const G=[];for await(const te of M)G.push(te);return G}toPromise(){return W.toPromise(this)}h(M){this.a===L.Initial&&(this.b.push(M),this.g.fire())}j(M){this.a===L.Initial&&(this.b=this.b.concat(M),this.g.fire())}k(){this.a===L.Initial&&(this.a=L.DoneOK,this.g.fire())}l(M){this.a===L.Initial&&(this.a=L.DoneError,this.d=M,this.g.fire())}}e.$1h=W;class z extends W{constructor(M,G){super(G),this.m=M}cancel(){this.m.cancel()}}e.$2h=z;function U(x){const M=new n.$se,G=x(M.token);return new z(M,async te=>{const he=M.token.onCancellationRequested(()=>{he.dispose(),M.dispose(),te.reject(new r.$5)});try{for await(const ke of G){if(M.token.isCancellationRequested)return;te.emitOne(ke)}he.dispose(),M.dispose()}catch(ke){he.dispose(),M.dispose(),te.reject(ke)}})}class J{constructor(M){this.a=new q,this.b=new W(he=>{if(G){he.reject(G);return}return te&&he.emitMany(te),this.d=ke=>he.reject(ke),this.f=ke=>he.emitOne(ke),this.a.p},M);let G,te;this.f=he=>{te||(te=[]),te.push(he)},this.d=he=>{G||(G=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(M){this.d(M),this.a.complete()}emitOne(M){this.f(M)}}e.$4h=J}),define(Ee[85],Se([1,0,18,14,35,37,26,9,3,17]),function(fe,e,n,r,S,D,A,R,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=E,e.$sk=f,e.$tk=V,e.$uk=Q,e.$vk=ie,e.$wk=re,e.$xk=ne,e.$yk=ue;function E(){return Object.create(null)}e.$qk="**",e.$rk="/";const y="[/\\\\]",p="[^/\\\\]",b=/\//g;function a(j,B){switch(j){case 0:return"";case 1:return`${p}*?`;default:return`(?:${y}|${p}+${y}${B?`|${y}${p}+`:""})*?`}}function f(j,B){if(!j)return[];const oe=[];let le=!1,pe=!1,q="";for(const ae of j){switch(ae){case B:if(!le&&!pe){oe.push(q),q="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}q+=ae}return q&&oe.push(q),oe}function h(j){if(!j)return"";let B="";const oe=f(j,e.$rk);if(oe.every(le=>le===e.$qk))B=".*";else{let le=!1;oe.forEach((pe,q)=>{if(pe===e.$qk){if(le)return;B+=a(2,q===oe.length-1)}else{let ae=!1,Y="",H=!1,L="";for(const W of pe){if(W!=="}"&&ae){Y+=W;continue}if(H&&(W!=="]"||!L)){let z;W==="-"?z=W:(W==="^"||W==="!")&&!L?z="^":W===e.$rk?z="":z=(0,s.$df)(W),L+=z;continue}switch(W){case"{":ae=!0;continue;case"[":H=!0;continue;case"}":{const U=`(?:${f(Y,",").map(J=>h(J)).join("|")})`;B+=U,ae=!1,Y="";break}case"]":{B+="["+L+"]",H=!1,L="";break}case"?":B+=p;continue;case"*":B+=a(1);continue;default:B+=(0,s.$df)(W)}}q<oe.length-1&&(oe[q+1]!==e.$qk||q+2<oe.length)&&(B+=y)}le=pe===e.$qk})}return B}const g=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new A.$Dc(1e4),d=function(){return!1},i=function(){return null};function c(j,B){if(!j)return i;let oe;typeof j!="string"?oe=j.pattern:oe=j,oe=oe.trim();const le=`${oe}_${!!B.trimForExclusions}`;let pe=o.get(le);if(pe)return u(pe,j);let q;return g.test(oe)?pe=I(oe.substr(4),oe):(q=w.exec(k(oe,B)))?pe=C(q[1],oe):(B.trimForExclusions?$:m).test(oe)?pe=T(oe,B):(q=l.exec(k(oe,B)))?pe=O(q[1].substr(1),oe,!0):(q=t.exec(k(oe,B)))?pe=O(q[1],oe,!1):pe=P(oe),o.set(le,pe),u(pe,j)}function u(j,B){if(typeof B=="string")return j;const oe=function(le,pe){return(0,D.$zg)(le,B.base,!v.$k)?j((0,s.$if)(le.substr(B.base.length),R.sep),pe):null};return oe.allBasenames=j.allBasenames,oe.allPaths=j.allPaths,oe.basenames=j.basenames,oe.patterns=j.patterns,oe}function k(j,B){return B.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function I(j,B){return function(oe,le){return typeof oe=="string"&&oe.endsWith(j)?B:null}}function C(j,B){const oe=`/${j}`,le=`\\${j}`,pe=function(ae,Y){return typeof ae!="string"?null:Y?Y===j?B:null:ae===j||ae.endsWith(oe)||ae.endsWith(le)?B:null},q=[j];return pe.basenames=q,pe.patterns=[B],pe.allBasenames=q,pe}function T(j,B){const oe=ee(j.slice(1,-1).split(",").map(Y=>c(Y,B)).filter(Y=>Y!==i),j),le=oe.length;if(!le)return i;if(le===1)return oe[0];const pe=function(Y,H){for(let L=0,W=oe.length;L<W;L++)if(oe[L](Y,H))return j;return null},q=oe.find(Y=>!!Y.allBasenames);q&&(pe.allBasenames=q.allBasenames);const ae=oe.reduce((Y,H)=>H.allPaths?Y.concat(H.allPaths):Y,[]);return ae.length&&(pe.allPaths=ae),pe}function O(j,B,oe){const le=R.sep===R.$gc.sep,pe=le?j:j.replace(b,R.sep),q=R.sep+pe,ae=R.$gc.sep+j;let Y;return oe?Y=function(H,L){return typeof H=="string"&&(H===pe||H.endsWith(q)||!le&&(H===j||H.endsWith(ae)))?B:null}:Y=function(H,L){return typeof H=="string"&&(H===pe||!le&&H===j)?B:null},Y.allPaths=[(oe?"*/":"./")+j],Y}function P(j){try{const B=new RegExp(`^${h(j)}$`);return function(oe){return B.lastIndex=0,typeof oe=="string"&&B.test(oe)?j:null}}catch{return i}}function V(j,B,oe){return!j||typeof B!="string"?!1:Q(j)(B,void 0,oe)}function Q(j,B={}){if(!j)return d;if(typeof j=="string"||ie(j)){const oe=c(j,B);if(oe===i)return d;const le=function(pe,q){return!!oe(pe,q)};return oe.allBasenames&&(le.allBasenames=oe.allBasenames),oe.allPaths&&(le.allPaths=oe.allPaths),le}return se(j,B)}function ie(j){const B=j;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function re(j){return j.allBasenames||[]}function ne(j){return j.allPaths||[]}function se(j,B){const oe=ee(Object.getOwnPropertyNames(j).map(Y=>Z(Y,j[Y],B)).filter(Y=>Y!==i)),le=oe.length;if(!le)return i;if(!oe.some(Y=>!!Y.requiresSiblings)){if(le===1)return oe[0];const Y=function(W,z){let U;for(let J=0,x=oe.length;J<x;J++){const M=oe[J](W,z);if(typeof M=="string")return M;(0,r.$mh)(M)&&(U||(U=[]),U.push(M))}return U?(async()=>{for(const J of U){const x=await J;if(typeof x=="string")return x}return null})():null},H=oe.find(W=>!!W.allBasenames);H&&(Y.allBasenames=H.allBasenames);const L=oe.reduce((W,z)=>z.allPaths?W.concat(z.allPaths):W,[]);return L.length&&(Y.allPaths=L),Y}const pe=function(Y,H,L){let W,z;for(let U=0,J=oe.length;U<J;U++){const x=oe[U];x.requiresSiblings&&L&&(H||(H=(0,R.$nc)(Y)),W||(W=H.substr(0,H.length-(0,R.$oc)(Y).length)));const M=x(Y,H,W,L);if(typeof M=="string")return M;(0,r.$mh)(M)&&(z||(z=[]),z.push(M))}return z?(async()=>{for(const U of z){const J=await U;if(typeof J=="string")return J}return null})():null},q=oe.find(Y=>!!Y.allBasenames);q&&(pe.allBasenames=q.allBasenames);const ae=oe.reduce((Y,H)=>H.allPaths?Y.concat(H.allPaths):Y,[]);return ae.length&&(pe.allPaths=ae),pe}function Z(j,B,oe){if(B===!1)return i;const le=c(j,oe);if(le===i)return i;if(typeof B=="boolean")return le;if(B){const pe=B.when;if(typeof pe=="string"){const q=(ae,Y,H,L)=>{if(!L||!le(ae,Y))return null;const W=pe.replace("$(basename)",()=>H),z=L(W);return(0,r.$mh)(z)?z.then(U=>U?j:null):z?j:null};return q.requiresSiblings=!0,q}}return le}function ee(j,B){const oe=j.filter(Y=>!!Y.basenames);if(oe.length<2)return j;const le=oe.reduce((Y,H)=>{const L=H.basenames;return L?Y.concat(L):Y},[]);let pe;if(B){pe=[];for(let Y=0,H=le.length;Y<H;Y++)pe.push(B)}else pe=oe.reduce((Y,H)=>{const L=H.patterns;return L?Y.concat(L):Y},[]);const q=function(Y,H){if(typeof Y!="string")return null;if(!H){let W;for(W=Y.length;W>0;W--){const z=Y.charCodeAt(W-1);if(z===S.CharCode.Slash||z===S.CharCode.Backslash)break}H=Y.substr(W)}const L=le.indexOf(H);return L!==-1?pe[L]:null};q.basenames=le,q.patterns=pe,q.allBasenames=le;const ae=j.filter(Y=>!Y.basenames);return ae.push(q),ae}function ue(j,B){return(0,n.$ub)(j,B,(oe,le)=>typeof oe=="string"&&typeof le=="string"?oe===le:typeof oe!="string"&&typeof le!="string"?oe.base===le.base&&oe.pattern===le.pattern:!1)}}),define(Ee[111],Se([1,0,10,173,20,17,4]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.MarkdownStringTextNewlineStyle=void 0,e.$Yk=s,e.$Zk=E,e.$1k=y,e.$2k=p,e.$3k=b,e.$4k=a,e.$5k=f,e.$6k=h;var R;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class v{constructor(w="",m=!1){if(this.value=w,typeof this.value!="string")throw(0,n.$7)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(w,m=R.Paragraph){return this.value+=p(this.supportThemeIcons?(0,r.$Rk)(w):w).replace(/([ \t]+)/g,($,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===R.Break?`\\
`:`

`),this}appendMarkdown(w){return this.value+=w,this}appendCodeblock(w,m){return this.value+=`
${b(m,w)}
`,this}appendLink(w,m,$){return this.value+="[",this.value+=this.c(m,"]"),this.value+="](",this.value+=this.c(String(w),")"),$&&(this.value+=` "${this.c(this.c($,'"'),")")}"`),this.value+=")",this}c(w,m){const $=new RegExp((0,D.$df)(m),"g");return w.replace($,(l,t)=>w.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.$Xk=v;function s(g){return E(g)?!g.value:Array.isArray(g)?g.every(s):!0}function E(g){return g instanceof v?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||typeof g.isTrusted=="object"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}function y(g,w){return g===w?!0:!g||!w?!1:g.value===w.value&&g.isTrusted===w.isTrusted&&g.supportThemeIcons===w.supportThemeIcons&&g.supportHtml===w.supportHtml&&(g.baseUri===w.baseUri||!!g.baseUri&&!!w.baseUri&&(0,S.$7g)(A.URI.from(g.baseUri),A.URI.from(w.baseUri)))}function p(g){return g.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(g,w){const m=g.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,$=m>=3?m+1:3;return[`${"`".repeat($)}${w}`,g,`${"`".repeat($)}`].join(`
`)}function a(g){return g.replace(/"/g,"&quot;")}function f(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function h(g){const w=[],m=g.split("|").map(l=>l.trim());g=m[0];const $=m[1];if($){const l=/height=(\d+)/.exec($),t=/width=(\d+)/.exec($),o=l?l[1]:"",d=t?t[1]:"",i=isFinite(parseInt(d)),c=isFinite(parseInt(o));i&&w.push(`width="${d}"`),c&&w.push(`height="${o}"`)}return{href:g,dimensions:w}}}),define(Ee[193],Se([1,0,18,37,9,3,20,17]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=v,e.$Nw=E,e.$Ow=p,e.$Pw=b,e.$Qw=g,e.$Rw=m,e.$Sw=$,e.$Tw=l,e.$Uw=t,e.$Vw=o;function v(i,c){const{os:u,tildify:k,relative:I}=c;if(I){const O=s(i,I,u);if(typeof O=="string")return O}let C=i.fsPath;if(u===D.OperatingSystem.Windows&&!D.$i?C=C.replace(/\//g,"\\"):u!==D.OperatingSystem.Windows&&D.$i&&(C=C.replace(/\\/g,"/")),u!==D.OperatingSystem.Windows&&k?.userHome){const O=k.userHome.fsPath;let P;i.scheme!==k.userHome.scheme&&i.path[0]===S.$gc.sep&&i.path[1]!==S.$gc.sep?P=k.userHome.with({path:i.path}).fsPath:P=C,C=p(P,O,u)}return(u===D.OperatingSystem.Windows?S.$fc:S.$gc).normalize(E(C,u===D.OperatingSystem.Windows))}function s(i,c,u){const k=u===D.OperatingSystem.Windows?S.$fc:S.$gc,I=u===D.OperatingSystem.Linux?A.$4g:A.$6g,C=c.getWorkspace(),T=(0,n.$Ob)(C.folders);if(!T)return;i.scheme!==T.uri.scheme&&i.path[0]===S.$gc.sep&&i.path[1]!==S.$gc.sep&&(i=T.uri.with({path:i.path}));const O=c.getWorkspaceFolder(i);if(!O)return;let P;if(I.isEqual(O.uri,i)?P="":P=I.relativePath(O.uri,i)??"",P&&(P=k.normalize(P)),C.folders.length>1&&!c.noPrefix){const V=O.name?O.name:I.basenameOrAuthority(O.uri);P=P?`${V} \u2022 ${P}`:V}return P}function E(i,c=D.$i){return(0,r.$Eg)(i,c)?i.charAt(0).toUpperCase()+i.slice(1):i}let y=Object.create(null);function p(i,c,u=D.OS){if(u===D.OperatingSystem.Windows||!i||!c)return i;let k=y.original===c?y.normalized:void 0;k||(k=c,D.$i&&(k=(0,r.$tg)(k)),k=`${(0,R.$jf)(k,S.$gc.sep)}${S.$gc.sep}`,y={original:c,normalized:k});let I=i;return D.$i&&(I=(0,r.$tg)(I)),(u===D.OperatingSystem.Linux?I.startsWith(k):(0,R.$Cf)(I,k))?`~/${I.substr(k.length)}`:i}function b(i,c){return i.replace(/^~($|\/|\\)/,`${c}$1`)}const a="\u2026",f="\\\\",h="~";function g(i,c=S.sep){const u=new Array(i.length);let k=!1;for(let I=0;I<i.length;I++){const C=i[I];if(C===""){u[I]=`.${c}`;continue}if(!C){u[I]=C;continue}k=!0;let T="",O=C;O.indexOf(f)===0?(T=O.substr(0,O.indexOf(f)+f.length),O=O.substr(O.indexOf(f)+f.length)):O.indexOf(c)===0?(T=O.substr(0,O.indexOf(c)+c.length),O=O.substr(O.indexOf(c)+c.length)):O.indexOf(h)===0&&(T=O.substr(0,O.indexOf(h)+h.length),O=O.substr(O.indexOf(h)+h.length));const P=O.split(c);for(let V=1;k&&V<=P.length;V++)for(let Q=P.length-V;k&&Q>=0;Q--){k=!1;let ie=P.slice(Q,Q+V).join(c);for(let re=0;!k&&re<i.length;re++)if(re!==I&&i[re]&&i[re].indexOf(ie)>-1){const ne=Q+V===P.length,se=Q>0&&i[re].indexOf(c)>-1?c+ie:ie,Z=i[re].endsWith(se);k=!ne||Z}if(!k){let re="";(P[0].endsWith(":")||T!=="")&&(Q===1&&(Q=0,V++,ie=P[0]+c+ie),Q>0&&(re=P[0]+c),re=T+re),Q>0&&(re=re+a+c),re=re+ie,Q+V<P.length&&(re=re+c+a),u[I]=re}}k&&(u[I]=C)}return u}var w;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function m(i,c=Object.create(null)){const u=[];let k=!1,I="";for(const C of i)if(C==="$"||k&&C==="{")I&&u.push({value:I,type:w.TEXT}),I="",k=!0;else if(C==="}"&&k){const T=c[I];if(typeof T=="string")T.length&&u.push({value:T,type:w.VARIABLE});else if(T){const O=u[u.length-1];(!O||O.type!==w.SEPARATOR)&&u.push({value:T.label,type:w.SEPARATOR})}I="",k=!1}else I+=C;return I&&!k&&u.push({value:I,type:w.TEXT}),u.filter((C,T)=>{if(C.type===w.SEPARATOR){const O=u[T-1],P=u[T+1];return[O,P].every(V=>V&&(V.type===w.VARIABLE||V.type===w.TEXT)&&V.value.length>0)}return!0}).map(C=>C.value).join("")}function $(i,c){return D.$j||c?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$j?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function l(i,c){return D.$j||c?i.replace(/\(&&\w\)|&&/g,""):D.$i?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function o(i){if(i.endsWith("]")){const c=i.lastIndexOf(" [",i.length-2);if(c!==-1){const u=d(i.substring(0,c)),k=i.substring(c);return{name:u.name+k,parentPath:u.parentPath}}}return d(i)}function d(i){const c=i.indexOf("/")!==-1?S.$gc:S.$fc,u=c.basename(i),k=c.dirname(i);return u.length?{name:u,parentPath:k}:{name:k,parentPath:""}}}),define(Ee[59],Se([1,0,15,80,4]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=void 0,e.$Fn=v,e.$Gn=E,e.$Hn=y;function D(p){return p.toJSON()}class A{constructor(b){this.a=b}transformIncoming(b){const a=this.a.transformIncoming(b);return a===b?b:D(S.URI.from(a))}transformOutgoing(b){const a=this.a.transformOutgoing(b);return a===b?b:D(S.URI.from(a))}transformOutgoingURI(b){const a=this.a.transformOutgoing(b);return a===b?b:S.URI.from(a)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Dn=A,e.$En=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function R(p,b,a){if(!p||a>200)return null;if(typeof p=="object"){if(p instanceof S.URI)return b.transformOutgoing(p);for(const f in p)if(Object.hasOwnProperty.call(p,f)){const h=R(p[f],b,a+1);h!==null&&(p[f]=h)}}return null}function v(p,b){const a=R(p,b,0);return a===null?p:a}function s(p,b,a,f){if(!p||f>200)return null;if(typeof p=="object"){if(p.$mid===r.MarshalledId.Uri)return a?S.URI.revive(b.transformIncoming(p)):b.transformIncoming(p);if(p instanceof n.$Je)return null;for(const h in p)if(Object.hasOwnProperty.call(p,h)){const g=s(p[h],b,a,f+1);g!==null&&(p[h]=g)}}return null}function E(p,b){const a=s(p,b,!1,0);return a===null?p:a}function y(p,b){const a=s(p,b,!0,0);return a===null?p:a}}),define(Ee[112],Se([1,0,32,67,22,176,3]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=void 0,e.$Kn=v,e.$Ln=y,e.$Mn=p,e.$Jn=new class{c(b){return this.a||(this.a=r.$Gi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,a=0;const f=(0,n.networkInterfaces)();for(const h in f){const g=f[h];if(g)for(const{mac:w,internal:m}of g)m||(a+=1,this.c(w.toUpperCase())&&(b+=1))}this.b=a>0?b/a:0}return this.b}};let R;async function v(b){return R||(R=(async()=>await s(b)||S.$Wg())()),R}async function s(b){try{const a=await new Promise((h,g)=>{fe(["crypto"],h,g)}),f=(0,D.$In)();return a.createHash("sha256").update(f,"utf8").digest("hex")}catch(a){b(a);return}}const E="Software\\Microsoft\\SQMClient";async function y(b){if(A.$i){const a=await new Promise((f,h)=>{fe(["@vscode/windows-registry"],f,h)});try{return a.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(f){return b(f),""}}return""}async function p(b){try{return await(await new Promise((h,g)=>{fe(["@vscode/deviceid"],h,g)})).getDeviceId()}catch(a){return b(a),""}}}),define(Ee[194],Se([1,0,31,331,332,3]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xg=A;async function A(R){if(D.$j||D.$i)return;let v;for(const s of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{v=await(0,r.open)(s,n.constants.R_OK);break}catch{}if(!v){R("Unable to retrieve release information from known identifier paths.");return}try{const s=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const y of(0,S.createInterface)({input:v.createReadStream(),crlfDelay:1/0})){if(!y.includes("="))continue;const p=y.split("=")[0].toUpperCase().trim();if(s.has(p)){const b=y.split("=")[1].replace(/"/g,"").toLowerCase().trim();p==="ID"||p==="DISTRIB_ID"?E.id=b:p==="ID_LIKE"?E.id_like=b:(p==="VERSION_ID"||p==="DISTRIB_RELEASE")&&(E.version_id=b)}}return E}catch(s){R(s)}}}),define(Ee[25],Se([1,0,31,32,333,14,37,107,9,3,20,4]),function(fe,e,n,r,S,D,A,R,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=h,e.readdirSync=m,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=I;var p;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function b(se,Z=p.UNLINK,ee){if((0,A.$Dg)(se))throw new Error("rimraf - will refuse to recursively delete root");return Z===p.UNLINK?f(se):a(se,ee)}async function a(se,Z=(0,A.$Ig)((0,r.tmpdir)())){try{try{await n.promises.rename(se,Z)}catch(ee){return ee.code==="ENOENT"?void 0:f(se)}f(Z).catch(ee=>{})}catch(ee){if(ee.code!=="ENOENT")throw ee}}async function f(se){return(0,S.promisify)(n.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function h(se){if((0,A.$Dg)(se))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}async function g(se,Z){return $(await(Z?w(se):(0,S.promisify)(n.readdir)(se)))}async function w(se){try{return await(0,S.promisify)(n.readdir)(se,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const Z=[],ee=await g(se);for(const ue of ee){let j=!1,B=!1,oe=!1;try{const le=await e.Promises.lstat((0,v.$jc)(se,ue));j=le.isFile(),B=le.isDirectory(),oe=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}Z.push({name:ue,isFile:()=>j,isDirectory:()=>B,isSymbolicLink:()=>oe})}return Z}function m(se){return $(n.readdirSync(se))}function $(se){return se.map(Z=>typeof Z=="string"?s.$j?(0,R.$gm)(Z):Z:(Z.name=s.$j?(0,R.$gm)(Z.name):Z.name,Z))}async function l(se){const Z=await g(se),ee=[];for(const ue of Z)await o.existsDirectory((0,v.$jc)(se,ue))&&ee.push(ue);return ee}function t(se,Z=1e3){return new Promise(ee=>{let ue=!1;const j=setInterval(()=>{ue||(ue=!0,n.access(se,B=>{ue=!1,B&&(clearInterval(j),ee(void 0))}))},Z)})}var o;(function(se){async function Z(j){let B;try{if(B=await e.Promises.lstat(j),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(j),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(oe){if(oe.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(s.$i&&oe.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw le}throw oe}}se.stat=Z;async function ee(j){try{const{stat:B,symbolicLink:oe}=await se.stat(j);return B.isFile()&&oe?.dangling!==!0}catch{}return!1}se.existsFile=ee;async function ue(j){try{const{stat:B,symbolicLink:oe}=await se.stat(j);return B.isDirectory()&&oe?.dangling!==!0}catch{}return!1}se.existsDirectory=ue})(o||(e.SymlinkSupport=o={}));const d=new D.$Jh;function i(se,Z,ee){return d.queueFor(y.URI.file(se),()=>{const ue=C(ee);return new Promise((j,B)=>k(se,Z,ue,oe=>oe?B(oe):j()))},E.$5g)}let c=!0;function u(se){c=se}function k(se,Z,ee,ue){if(!c)return n.writeFile(se,Z,{mode:ee.mode,flag:ee.flag},ue);n.open(se,ee.flag,ee.mode,(j,B)=>{if(j)return ue(j);n.writeFile(B,Z,oe=>{if(oe)return n.close(B,()=>ue(oe));n.fdatasync(B,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),u(!1)),n.close(B,pe=>ue(pe))))})})}function I(se,Z,ee){const ue=C(ee);if(!c)return n.writeFileSync(se,Z,{mode:ue.mode,flag:ue.flag});const j=n.openSync(se,ue.flag,ue.mode);try{n.writeFileSync(j,Z);try{n.fdatasyncSync(j)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),u(!1)}}finally{n.closeSync(j)}}function C(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,Z,ee=6e4){if(se!==Z)try{s.$i&&typeof ee=="number"?await O(se,Z,Date.now(),ee):await(0,S.promisify)(n.rename)(se,Z)}catch(ue){if(se.toLowerCase()!==Z.toLowerCase()&&ue.code==="EXDEV"||se.endsWith("."))await P(se,Z,{preserveSymlinks:!1}),await b(se,p.MOVE);else throw ue}}async function O(se,Z,ee,ue,j=0){try{return await(0,S.promisify)(n.rename)(se,Z)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-ee>=ue)throw console.error(`[node.js fs] rename failed after ${j} retries with error: ${B}`),B;if(j===0){let oe=!1;try{const{stat:le}=await o.stat(Z);le.isFile()||(oe=!0)}catch{}if(oe)throw B}return await(0,D.$Bh)(Math.min(100,j*10)),O(se,Z,ee,ue,j+1)}}async function P(se,Z,ee){return Q(se,Z,{root:{source:se,target:Z},options:ee,handledSourcePaths:new Set})}const V=511;async function Q(se,Z,ee){if(ee.handledSourcePaths.has(se))return;ee.handledSourcePaths.add(se);const{stat:ue,symbolicLink:j}=await o.stat(se);if(j){if(ee.options.preserveSymlinks)try{return await ne(se,Z,ee)}catch{}if(j.dangling)return}return ue.isDirectory()?ie(se,Z,ue.mode&V,ee):re(se,Z,ue.mode&V)}async function ie(se,Z,ee,ue){await e.Promises.mkdir(Z,{recursive:!0,mode:ee});const j=await g(se);for(const B of j)await Q((0,v.$jc)(se,B),(0,v.$jc)(Z,B),ue)}async function re(se,Z,ee){await e.Promises.copyFile(se,Z),await e.Promises.chmod(Z,ee)}async function ne(se,Z,ee){let ue=await e.Promises.readlink(se);(0,A.$zg)(ue,ee.root.source,!s.$k)&&(ue=(0,v.$jc)(ee.root.target,ue.substr(ee.root.source.length+1))),await e.Promises.symlink(ue,Z)}e.Promises=new class{get access(){return(0,S.promisify)(n.access)}get stat(){return(0,S.promisify)(n.stat)}get lstat(){return(0,S.promisify)(n.lstat)}get utimes(){return(0,S.promisify)(n.utimes)}get read(){return(se,Z,ee,ue,j)=>new Promise((B,oe)=>{n.read(se,Z,ee,ue,j,(le,pe,q)=>le?oe(le):B({bytesRead:pe,buffer:q}))})}get readFile(){return(0,S.promisify)(n.readFile)}get write(){return(se,Z,ee,ue,j)=>new Promise((B,oe)=>{n.write(se,Z,ee,ue,j,(le,pe,q)=>le?oe(le):B({bytesWritten:pe,buffer:q}))})}get appendFile(){return(0,S.promisify)(n.appendFile)}get fdatasync(){return(0,S.promisify)(n.fdatasync)}get truncate(){return(0,S.promisify)(n.truncate)}get copyFile(){return(0,S.promisify)(n.copyFile)}get open(){return(0,S.promisify)(n.open)}get close(){return(0,S.promisify)(n.close)}get symlink(){return(0,S.promisify)(n.symlink)}get readlink(){return(0,S.promisify)(n.readlink)}get chmod(){return(0,S.promisify)(n.chmod)}get mkdir(){return(0,S.promisify)(n.mkdir)}get unlink(){return(0,S.promisify)(n.unlink)}get rmdir(){return(0,S.promisify)(n.rmdir)}get realpath(){return(0,S.promisify)(n.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return l}get writeFile(){return i}get rm(){return b}get rename(){return T}get copy(){return P}}}),define(Ee[195],Se([1,0,31,9,3,17,25]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=R,e.$ar=v,e.$br=s,e.$cr=E;function R(p){if(S.$k)return p;const b=(0,r.$mc)(p);if(p===b)return p;const a=((0,r.$nc)(p)||p).toLowerCase();try{const h=(0,A.readdirSync)(b).filter(g=>g.toLowerCase()===a);if(h.length===1){const g=R(b);if(g)return(0,r.$jc)(g,h[0])}else if(h.length>1){const g=h.indexOf(a);if(g>=0){const w=R(b);if(w)return(0,r.$jc)(w,h[g])}}}catch{}return null}async function v(p,b){if(S.$k)return p;const a=(0,r.$mc)(p);if(p===a)return p;const f=((0,r.$nc)(p)||p).toLowerCase();try{if(b?.isCancellationRequested)return null;const g=(await A.Promises.readdir(a)).filter(w=>w.toLowerCase()===f);if(g.length===1){const w=await v(a,b);if(w)return(0,r.$jc)(w,g[0])}else if(g.length>1){const w=g.indexOf(f);if(w>=0){const m=await v(a,b);if(m)return(0,r.$jc)(m,g[w])}}}catch{}return null}async function s(p){try{return await A.Promises.realpath(p)}catch{const a=y(p);return await A.Promises.access(a,n.constants.R_OK),a}}function E(p){try{return n.realpathSync(p)}catch{const a=y(p);return n.accessSync(a,n.constants.R_OK),a}}function y(p){return(0,D.$jf)((0,r.$hc)(p),r.sep)}}),define(Ee[113],Se([1,0,32,9,25]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=w,e.$qm=m;const D=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var v;(function($){$[$.x64=0]="x64",$[$.x86=1]="x86",$[$.ARM=2]="ARM"})(v||(v={}));let s;switch(process.arch){case"ia32":s=v.x86;break;case"arm":case"arm64":s=v.ARM;break;default:s=v.x64;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?v.ARM:v.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=v.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=v.x86:E=v.x64;class y{constructor(l,t,o){this.exePath=l,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:$=!1}={}){return $?s===v.x64?process.env["ProgramFiles(x86)"]||null:E===v.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:$=!1,findPreview:l=!1}={}){const t=p({useAlternateBitness:$});if(!t)return null;const o=r.$jc(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(o))return null;let d=-1,i=null;for(const k of await S.Promises.readdir(o)){let I=-1;if(l){const T=k.indexOf("-");if(T<0)continue;const O=k.substring(0,T);if(!D.test(O)||k.substring(T+1)!=="preview")continue;I=parseInt(O,10)}else{if(!D.test(k))continue;I=parseInt(k,10)}if(I<=d)continue;const C=r.$jc(o,k,"pwsh.exe");await S.SymlinkSupport.existsFile(C)&&(i=C,d=I)}if(!i)return null;const c=t.includes("x86")?" (x86)":"",u=l?" Preview":"";return new y(i,`PowerShell${u}${c}`,!0)}async function a({findPreview:$}={}){if(!process.env.LOCALAPPDATA)return null;const l=r.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=$?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const d of await S.Promises.readdir(l))if(t.test(d)){const i=r.$jc(l,d,"pwsh.exe");return new y(i,o)}return null}function f(){const $=r.$jc(n.homedir(),".dotnet","tools","pwsh.exe");return new y($,".NET Core PowerShell Global Tool")}function h(){const $=r.$jc(process.env.windir,s===v.x86&&E!==v.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y($,"Windows PowerShell",!0)}async function*g(){let $=await b();$&&(yield $),$=await b({useAlternateBitness:!0}),$&&(yield $),$=await a(),$&&(yield $),$=f(),$&&(yield $),$=await b({findPreview:!0}),$&&(yield $),$=await a({findPreview:!0}),$&&(yield $),$=await b({useAlternateBitness:!0,findPreview:!0}),$&&(yield $),$=h(),$&&(yield $)}async function*w(){for await(const $ of g())await $.exists()&&(yield $)}async function m(){for await(const $ of w())return $;return null}}),define(Ee[114],Se([1,0,9,3,33,69,11,25]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$tm=v,e.$um=s,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function v(y=S.env){return y.comspec||"cmd.exe"}function s(y){let p=[],b=!1;const a=function(f){if(b){p.push(f);return}(!y.send(f,g=>{if(g&&console.error(g),b=!1,p.length>0){const w=p.slice(0);p=[],w.forEach(m=>a(m))}})||r.$i)&&(b=!0)};return{send:a}}var E;(function(y){async function p(b,a,f){if(n.$ic(b))return b;if(a===void 0&&(a=S.cwd()),n.$mc(b)!=="."||(f===void 0&&A.$ag(S.env.PATH)&&(f=S.env.PATH.split(n.$tc)),f===void 0||f.length===0))return n.$jc(a,b);async function g(w){if(await R.Promises.exists(w)){let m;try{m=await R.Promises.stat(w)}catch($){$.message.startsWith("EACCES")&&(m=await R.Promises.lstat(w))}return m?!m.isDirectory():!1}return!1}for(const w of f){let m;if(n.$ic(w)?m=n.$jc(w,b):m=n.$jc(a,w,b),await g(m))return m;let $=m+".com";if(await g($)||($=m+".exe",await g($)))return $}return n.$jc(a,b)}y.findExecutable=p})(E||(e.win32=E={}))}),define(Ee[115],Se([1,0,60,13]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=S;function S(A){return new Promise((R,v)=>{let s;const E=new Map;function y(b,a,f,h,g){const w=E.get(a);if(b===A||w){const m={name:p(f),cmd:f,pid:b,ppid:a,load:h,mem:g};E.set(b,m),b===A&&(s=m),w&&(w.children||(w.children=[]),w.children.push(m),w.children.length>1&&(w.children=w.children.sort(($,l)=>$.pid-l.pid)))}}function p(b){const a=/--utility-sub-type=network/i,f=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,g=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(f.exec(b))return"electron-crash-reporter";if(h.exec(b))return"winpty-agent";if(g.exec(b))return"conpty-agent";let m=w.exec(b);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?a.exec(b)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const $=/[a-zA-Z-]+\.js/g;let l="";do m=$.exec(b),m&&(l+=m+" ");while(m);return l&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron-nodejs (${l})`:b}if(process.platform==="win32"){const b=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,f)=>{fe(["@vscode/windows-process-tree"],a,f)}).then(a=>{a.getProcessList(A,f=>{if(!f){v(new Error(`Root process ${A} not found`));return}a.getProcessCpuUsage(f,h=>{const g=new Map;h.forEach(w=>{const m=b(w.commandLine||"");g.set(w.pid,{name:p(m),cmd:m,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),s=g.get(A),s?(g.forEach(w=>{const m=g.get(w.ppid);m&&(m.children||(m.children=[]),m.children.push(w))}),g.forEach(w=>{w.children&&(w.children=w.children.sort((m,$)=>m.pid-$.pid))}),R(s)):v(new Error(`Root process ${A} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let b=function(){let a=[s];const f=[];for(;a.length;){const g=a.shift();g&&(f.push(g.pid),g.children&&(a=a.concat(g.children)))}let h=JSON.stringify(r.$Ug.asFileUri("vs/base/node/cpuUsage.sh").fsPath);h+=" "+f.join(" "),(0,n.exec)(h,{},(g,w,m)=>{if(g||m)v(g||new Error(m.toString()));else{const $=w.toString().split(`
`);for(let l=0;l<f.length;l++){const t=E.get(f[l]);t.load=parseFloat($[l])}if(!s){v(new Error(`Root process ${A} not found`));return}R(s)}})};(0,n.exec)("which ps",{},(a,f,h)=>{if(a||h)if(process.platform!=="linux")v(a||new Error(h.toString()));else{const g=JSON.stringify(r.$Ug.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(g,{},(w,m,$)=>{w||$?v(w||new Error($.toString())):(D(m,y),b())})}else{const g=f.toString().trim();(0,n.exec)(`${g} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,$,l)=>{m||l&&!l.includes("screen size is bogus")?v(m||new Error(l.toString())):(D($,y),process.platform==="linux"?b():s?R(s):v(new Error(`Root process ${A} not found`)))})}})}})}function D(A,R){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,s=A.toString().split(`
`);for(const E of s){const y=v.exec(E.trim());y&&y.length===6&&R(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Ee[116],Se([1,0,32,3,113,114]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=A;async function A(y,p){return y===r.OperatingSystem.Windows?r.$i?E():D.$tm(p):v(y,p)}let R=null;function v(y,p){if(r.$k&&y===r.OperatingSystem.Macintosh||r.$j&&y===r.OperatingSystem.Linux)return"/bin/bash";if(!R){let b;if(r.$i)b="/bin/bash";else{if(b=p.SHELL,!b)try{b=(0,n.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}R=b}return R}let s=null;async function E(){return s||(s=(await(0,S.$qm)()).exePath),s}});var Ue=this&&this.__decorate||function(fe,e,n,r){var S=arguments.length,D=S<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(fe,e,n,r);else for(var R=fe.length-1;R>=0;R--)(A=fe[R])&&(D=(S<3?A(D):S>3?A(e,n,D):A(e,n))||D);return S>3&&D&&Object.defineProperty(e,n,D),D};define(Ee[50],Se([1,0,18,14,15,19,77,10,6,2,49,17,11]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=u,e.$bi=k,e.$gi=V,e.$hi=Q;var b;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(b||(b={}));function a(j){switch(j){case b.Promise:return"req";case b.PromiseCancel:return"cancel";case b.EventListen:return"subscribe";case b.EventDispose:return"unsubscribe"}}var f;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(f||(f={}));function h(j){switch(j){case f.Initialize:return"init";case f.PromiseSuccess:return"reply:";case f.PromiseError:case f.PromiseErrorObj:return"replyErr:";case f.EventFire:return"event:"}}var g;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(g||(g={}));function w(j){let B=0;for(let oe=0;;oe+=7){const le=j.read(1);if(B|=(le.buffer[0]&127)<<oe,!(le.buffer[0]&128))return B}}const m=d(0);function $(j,B){if(B===0){j.write(m);return}let oe=0;for(let pe=B;pe!==0;pe=pe>>>7)oe++;const le=S.$Je.alloc(oe);for(let pe=0;B!==0;pe++)le.buffer[pe]=B&127,B=B>>>7,B>0&&(le.buffer[pe]|=128);j.write(le)}class l{constructor(B){this.b=B,this.a=0}read(B){const oe=this.b.slice(this.a,this.a+B);return this.a+=oe.byteLength,oe}}e.$$h=l;class t{constructor(){this.a=[]}get buffer(){return S.$Je.concat(this.a)}write(B){this.a.push(B)}}e.$_h=t;var o;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(o||(o={}));function d(j){const B=S.$Je.alloc(1);return B.writeUInt8(j,0),B}const i={Undefined:d(o.Undefined),String:d(o.String),Buffer:d(o.Buffer),VSBuffer:d(o.VSBuffer),Array:d(o.Array),Object:d(o.Object),Uint:d(o.Int)},c=typeof Buffer<"u";function u(j,B){if(typeof B>"u")j.write(i.Undefined);else if(typeof B=="string"){const oe=S.$Je.fromString(B);j.write(i.String),$(j,oe.byteLength),j.write(oe)}else if(c&&Buffer.isBuffer(B)){const oe=S.$Je.wrap(B);j.write(i.Buffer),$(j,oe.byteLength),j.write(oe)}else if(B instanceof S.$Je)j.write(i.VSBuffer),$(j,B.byteLength),j.write(B);else if(Array.isArray(B)){j.write(i.Array),$(j,B.length);for(const oe of B)u(j,oe)}else if(typeof B=="number"&&(B|0)===B)j.write(i.Uint),$(j,B);else{const oe=S.$Je.fromString(JSON.stringify(B));j.write(i.Object),$(j,oe.byteLength),j.write(oe)}}function k(j){switch(j.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return j.read(w(j)).toString();case o.Buffer:return j.read(w(j)).buffer;case o.VSBuffer:return j.read(w(j));case o.Array:{const oe=w(j),le=[];for(let pe=0;pe<oe;pe++)le.push(k(j));return le}case o.Object:return JSON.parse(j.read(w(j)).toString());case o.Int:return w(j)}}class I{constructor(B,oe,le=null,pe=1e3){this.h=B,this.j=oe,this.k=le,this.l=pe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.q(q)),this.m({type:f.Initialize})}registerChannel(B,oe){this.b.set(B,oe),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case f.Initialize:{const oe=this.o([B.type]);this.k?.logOutgoing(oe,0,C.OtherSide,h(B.type));return}case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:{const oe=this.o([B.type,B.id],B.data);this.k?.logOutgoing(oe,B.id,C.OtherSide,h(B.type),B.data);return}}}o(B,oe=void 0){const le=new t;return u(le,B),u(le,oe),this.p(le.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const oe=new l(B),le=k(oe),pe=k(oe),q=le[0];switch(q){case b.Promise:return this.k?.logIncoming(B.byteLength,le[1],C.OtherSide,`${a(q)}: ${le[2]}.${le[3]}`,pe),this.s({type:q,id:le[1],channelName:le[2],name:le[3],arg:pe});case b.EventListen:return this.k?.logIncoming(B.byteLength,le[1],C.OtherSide,`${a(q)}: ${le[2]}.${le[3]}`,pe),this.t({type:q,id:le[1],channelName:le[2],name:le[3],arg:pe});case b.PromiseCancel:return this.k?.logIncoming(B.byteLength,le[1],C.OtherSide,`${a(q)}`),this.u({type:q,id:le[1]});case b.EventDispose:return this.k?.logIncoming(B.byteLength,le[1],C.OtherSide,`${a(q)}`),this.u({type:q,id:le[1]})}}s(B){const oe=this.b.get(B.channelName);if(!oe){this.v(B);return}const le=new D.$se;let pe;try{pe=oe.call(this.j,B.name,B.arg,le.token)}catch(Y){pe=Promise.reject(Y)}const q=B.id;pe.then(Y=>{this.m({id:q,data:Y,type:f.PromiseSuccess})},Y=>{Y instanceof Error?this.m({id:q,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:f.PromiseError}):this.m({id:q,data:Y,type:f.PromiseErrorObj})}).finally(()=>{ae.dispose(),this.d.delete(B.id)});const ae=(0,s.$Sc)(()=>le.cancel());this.d.set(B.id,ae)}t(B){const oe=this.b.get(B.channelName);if(!oe){this.v(B);return}const le=B.id,q=oe.listen(this.j,B.name,B.arg)(ae=>this.m({id:le,data:ae,type:f.EventFire}));this.d.set(B.id,q)}u(B){const oe=this.d.get(B.id);oe&&(oe.dispose(),this.d.delete(B.id))}v(B){let oe=this.g.get(B.channelName);oe||(oe=[],this.g.set(B.channelName,oe));const le=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===b.Promise&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:f.PromiseError})},this.l);oe.push({request:B,timeoutTimer:le})}w(B){const oe=this.g.get(B);if(oe){for(const le of oe)switch(clearTimeout(le.timeoutTimer),le.request.type){case b.Promise:this.s(le.request);break;case b.EventListen:this.t(le.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,s.$Pc)(this.d.values()),this.d.clear()}}e.$ci=I;var C;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class T{constructor(B,oe=null){this.l=B,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=oe}getChannel(B){const oe=this;return{call(le,pe,q){return oe.a?Promise.reject(new R.$5):oe.m(B,le,pe,q)},listen(le,pe){return oe.a?v.Event.None:oe.o(B,le,pe)}}}m(B,oe,le,pe=D.CancellationToken.None){const q=this.g++,ae=b.Promise,Y={id:q,type:ae,channelName:B,name:oe,arg:le};if(pe.isCancellationRequested)return Promise.reject(new R.$5);let H;return new Promise((W,z)=>{if(pe.isCancellationRequested)return z(new R.$5);const U=()=>{const G=te=>{switch(te.type){case f.PromiseSuccess:this.f.delete(q),W(te.data);break;case f.PromiseError:{this.f.delete(q);const he=new Error(te.data.message);he.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,he.name=te.data.name,z(he);break}case f.PromiseErrorObj:this.f.delete(q),z(te.data);break}};this.f.set(q,G),this.p(Y)};let J=null;this.b===g.Idle?U():(J=(0,r.$nh)(G=>this.u()),J.then(()=>{J=null,U()}));const x=()=>{J?(J.cancel(),J=null):this.p({id:q,type:b.PromiseCancel}),z(new R.$5)},M=pe.onCancellationRequested(x);H=(0,s.$Rc)((0,s.$Sc)(x),M),this.d.add(H)}).finally(()=>{H.dispose(),this.d.delete(H)})}o(B,oe,le){const pe=this.g++,q=b.EventListen,ae={id:pe,type:q,channelName:B,name:oe,arg:le};let Y=null;const H=new v.$he({onWillAddFirstListener:()=>{Y=(0,r.$nh)(W=>this.u()),Y.then(()=>{Y=null,this.d.add(H),this.p(ae)})},onDidRemoveLastListener:()=>{Y?(Y.cancel(),Y=null):(this.d.delete(H),this.p({id:pe,type:b.EventDispose}))}}),L=W=>H.fire(W.data);return this.f.set(pe,L),H.event}p(B){switch(B.type){case b.Promise:case b.EventListen:{const oe=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(oe,B.id,C.LocalSide,`${a(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case b.PromiseCancel:case b.EventDispose:{const oe=this.q([B.type,B.id]);this.j?.logOutgoing(oe,B.id,C.LocalSide,a(B.type));return}}}q(B,oe=void 0){const le=new t;return u(le,B),u(le,oe),this.r(le.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const oe=new l(B),le=k(oe),pe=k(oe),q=le[0];switch(q){case f.Initialize:return this.j?.logIncoming(B.byteLength,0,C.LocalSide,h(q)),this.t({type:le[0]});case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:return this.j?.logIncoming(B.byteLength,le[1],C.LocalSide,h(q),pe),this.t({type:le[0],id:le[1],data:pe})}}t(B){if(B.type===f.Initialize){this.b=g.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,s.$Pc)(this.d.values()),this.d.clear()}}e.$di=T,Ue([A.$5h],T.prototype,"onDidInitializePromise",null);class O{get connections(){const B=[];return this.f.forEach(oe=>B.push(oe)),B}constructor(B,oe,le){this.a=new Map,this.f=new Set,this.g=new v.$he,this.onDidAddConnection=this.g.event,this.h=new v.$he,this.onDidRemoveConnection=this.h.event,this.j=new s.$Tc,this.j.add(B(({protocol:pe,onDidClientDisconnect:q})=>{const ae=v.Event.once(pe.onMessage);this.j.add(ae(Y=>{const H=new l(Y),L=k(H),W=new I(pe,L,oe,le),z=new T(pe,oe);this.a.forEach((J,x)=>W.registerChannel(x,J));const U={channelServer:W,channelClient:z,ctx:L};this.f.add(U),this.g.fire(U),this.j.add(q(()=>{W.dispose(),z.dispose(),this.f.delete(U),this.h.fire(U)}))}))}))}getChannel(B,oe){const le=this;return{call(pe,q,ae){let Y;if((0,p.$og)(oe)){const L=(0,n.$3b)(le.connections.filter(oe));Y=L?Promise.resolve(L):v.Event.toPromise(v.Event.filter(le.onDidAddConnection,oe))}else Y=oe.routeCall(le,pe,q);const H=Y.then(L=>L.channelClient.getChannel(B));return V(H).call(pe,q,ae)},listen(pe,q){if((0,p.$og)(oe))return le.k(B,oe,pe,q);const ae=oe.routeEvent(le,pe,q).then(Y=>Y.channelClient.getChannel(B));return V(ae).listen(pe,q)}}}k(B,oe,le,pe){const q=this;let ae;const Y=new v.$he({onWillAddFirstListener:()=>{ae=new s.$Tc;const H=new v.$ne,L=new Map,W=U=>{const x=U.channelClient.getChannel(B).listen(le,pe),M=H.add(x);L.set(U,M)},z=U=>{const J=L.get(U);J&&(J.dispose(),L.delete(U))};q.connections.filter(oe).forEach(W),v.Event.filter(q.onDidAddConnection,oe)(W,void 0,ae),q.onDidRemoveConnection(z,void 0,ae),H.event(Y.fire,Y,ae),ae.add(H)},onDidRemoveLastListener:()=>{ae?.dispose(),ae=void 0}});return Y.event}registerChannel(B,oe){this.a.set(B,oe);for(const le of this.f)le.channelServer.registerChannel(B,oe)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=O;class P{constructor(B,oe,le=null){const pe=new t;u(pe,oe),B.send(pe.buffer),this.a=new T(B,le),this.d=new I(B,oe,le)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,oe){this.d.registerChannel(B,oe)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=P;function V(j){return{call(B,oe,le){return j.then(pe=>pe.call(B,oe,le))},listen(B,oe){const le=new v.$qe;return j.then(pe=>le.input=pe.listen(B,oe)),le.event}}}function Q(j){let B=!1;return{call(oe,le,pe){return B?j.call(oe,le,pe):(0,r.$Bh)(0).then(()=>B=!0).then(()=>j.call(oe,le,pe))},listen(oe,le){if(B)return j.listen(oe,le);const pe=new v.$qe;return(0,r.$Bh)(0).then(()=>B=!0).then(()=>pe.input=j.listen(oe,le)),pe.event}}}class ie{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const oe of B.connections)if(await Promise.resolve(this.a(oe.ctx)))return Promise.resolve(oe);return await v.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$ii=ie;var re;(function(j){function B(q,ae,Y){const H=q,L=Y&&Y.disableMarshalling,W=new Map;for(const z in H)le(z)&&W.set(z,v.Event.buffer(H[z],!0,void 0,ae));return new class{listen(z,U,J){const x=W.get(U);if(x)return x;const M=H[U];if(typeof M=="function"){if(pe(U))return M.call(H,J);if(le(U))return W.set(U,v.Event.buffer(H[U],!0,void 0,ae)),W.get(U)}throw new R.$bb(`Event not found: ${U}`)}call(z,U,J){const x=H[U];if(typeof x=="function"){if(!L&&Array.isArray(J))for(let G=0;G<J.length;G++)J[G]=(0,E.$0h)(J[G]);let M=x.apply(H,J);return M instanceof Promise||(M=Promise.resolve(M)),M}throw new R.$bb(`Method not found: ${U}`)}}}j.fromService=B;function oe(q,ae){const Y=ae&&ae.disableMarshalling;return new Proxy({},{get(H,L){if(typeof L=="string")return ae?.properties?.has(L)?ae.properties.get(L):pe(L)?function(W){return q.listen(L,W)}:le(L)?q.listen(L):async function(...W){let z;ae&&!(0,p.$jg)(ae.context)?z=[ae.context,...W]:z=W;const U=await q.call(L,z);return Y?U:(0,E.$0h)(U)};throw new R.$bb(`Property not found: ${String(L)}`)}})}j.toService=oe;function le(q){return q[0]==="o"&&q[1]==="n"&&y.$Af(q.charCodeAt(2))}function pe(q){return/^onDynamic/.test(q)&&y.$Af(q.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const B=j.toString();if(B!=="[object Object]")return B}return j}function Z(j){return Array.isArray(j)?j.map(se):se(j)}function ee(j,B,oe,le,pe,q,ae){ae=Z(ae);const Y=ne[pe],H=Y[le%Y.length];let L=[`%c[${j}]%c[${String(B).padStart(7," ")}]%c[len: ${String(oe).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(q)?(L=L.concat(ae),L.push(")")):L.push(ae),console.log.apply(console,L)}class ue{constructor(B,oe){this.d=B,this.f=oe,this.a=0,this.b=0}logOutgoing(B,oe,le,pe,q){this.b+=B,ee(this.d,this.b,B,oe,le,pe,q)}logIncoming(B,oe,le,pe,q){this.a+=B,ee(this.f,this.a,B,oe,le,pe,q)}}e.$ji=ue}),define(Ee[61],Se([1,0,15,6,2,50]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.ProtocolConstants=e.$ki=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const c=new WeakMap;let u=0;function k(C,T){if(!c.has(C)){const O=String(++u);c.set(C,O)}return c.get(C)}function I(C,T,O,P){if(!i.enableDiagnostics)return;const V=k(C,T);if(P instanceof n.$Je||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const Q=n.$Je.alloc(P.byteLength);Q.set(P),i.records.push({timestamp:Date.now(),id:V,label:T,type:O,buff:Q})}else i.records.push({timestamp:Date.now(),id:V,label:T,type:O,data:P})}i.traceSocketEvent=I})(R||(e.SocketDiagnostics=R={}));var v;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let s=null;function E(){return s||(s=n.$Je.alloc(0)),s}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,u){if(c===0)return E();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const T=this.a[0];return u&&(this.a.shift(),this.b-=c),T}if(this.a[0].byteLength>c){const T=this.a[0].slice(0,c);return u&&(this.a[0]=this.a[0].slice(c),this.b-=c),T}const k=n.$Je.alloc(c);let I=0,C=0;for(;c>0;){const T=this.a[C];if(T.byteLength>c){const O=T.slice(0,c);k.set(O,I),I+=c,u&&(this.a[C]=T.slice(c),this.b-=c),c-=c}else k.set(T,I),I+=T.byteLength,u?(this.a.shift(),this.b-=T.byteLength):C++,c-=T.byteLength}return k}}e.$ki=y;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function b(i){switch(i){case p.None:return"None";case p.Regular:return"Regular";case p.Control:return"Control";case p.Ack:return"Ack";case p.Disconnect:return"Disconnect";case p.ReplayRequest:return"ReplayRequest";case p.Pause:return"PauseWriting";case p.Resume:return"ResumeWriting";case p.KeepAlive:return"KeepAlive"}}var a;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(a||(e.ProtocolConstants=a={}));class f{constructor(c,u,k,I){this.type=c,this.id=u,this.ack=k,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends S.$Uc{constructor(c){super(),this.f=this.B(new r.$he),this.onMessage=this.f.event,this.g={readHead:!0,readLen:a.HeaderLength,messageType:p.None,id:0,ack:0},this.a=c,this.b=!1,this.c=new y,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent(A.ProtocolHeaderRead,{messageType:b(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,I=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=a.HeaderLength,this.g.messageType=p.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(A.ProtocolMessageRead,u),this.f.fire(new f(k,I,C,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.$Je.alloc(a.HeaderLength);u.writeUInt8(c.type,0),u.writeUInt32BE(c.id,1),u.writeUInt32BE(c.ack,5),u.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent(A.ProtocolHeaderWrite,{messageType:b(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent(A.ProtocolMessageWrite,c.data),this.j(u,c.data)}g(c,u){const k=this.f===0;return this.d.push(c,u),this.f+=c.byteLength+u.byteLength,k}h(){const c=n.$Je.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,u){this.g(c,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent(A.ProtocolWrite,{byteLength:c.byteLength}),this.c.write(c)}}class w extends S.$Uc{constructor(c){super(),this.f=new r.$he,this.onMessage=this.f.event,this.g=new r.$he,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new g(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(u=>{u.type===p.Regular&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new f(p.Regular,0,0,c))}}e.$li=w;class m extends D.$fi{static fromSocket(c,u){return new m(new w(c),u)}get onDidDispose(){return this.b.onDidDispose}constructor(c,u,k=null){super(c,u,k),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$mi=m;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$he({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$ni=$;class l{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,u=this.a;for(;u;)u=u.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let u=0,k=this.a;for(;k;)c[u++]=k.data,k=k.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const u=new l(c);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const c=Date.now();for(let u=0;u<o.a;u++)this.c[u]=c-1e3*u;setInterval(()=>{for(let u=o.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),u=(1+o.a)*1e3;let k=0;for(let I=0;I<o.a;I++)c-this.c[I]<=u&&k++;return 1-k/o.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new $,this.onControlMessage=this.u.event,this.v=new $,this.onMessage=this.v.event,this.w=new $,this.onDidDispose=this.w.event,this.x=new $,this.onSocketClose=this.x.event,this.y=new $,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??o.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Tc,this.o=c.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},a.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new f(p.Disconnect,0,0,E());this.p.write(c),this.p.flush()}sendPause(){const c=new f(p.Pause,0,0,E());this.p.write(c)}sendResume(){const c=new f(p.Resume,0,0,E());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,u){this.a=!0,this.r.dispose(),this.r=new S.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new f(p.Ack,0,this.h,E());this.p.write(c);const u=this.b.toArray();for(let k=0,I=u.length;k<I;k++)this.p.write(u[k]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const u=this.b.peek();if(u&&u.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case p.None:break;case p.Regular:{if(c.id>this.g)if(c.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new f(p.ReplayRequest,0,0,E())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case p.Control:{this.u.fire(c.data);break}case p.Ack:break;case p.Disconnect:{this.w.fire();break}case p.ReplayRequest:{const u=this.b.toArray();for(let k=0,I=u.length;k<I;k++)this.p.write(u[k]);this.B();break}case p.Pause:{this.p.pause();break}case p.Resume:{this.p.resume();break}case p.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const u=++this.c;this.h=this.g;const k=new f(p.Regular,u,this.h,c);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(c){const u=new f(p.Control,0,0,c);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=a.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},a.AcknowledgeTime-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),u=Date.now()-c.writtenTime,k=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(u>=a.TimeoutTime&&k>=a.TimeoutTime&&I>=a.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:k});return}const C=Math.max(a.TimeoutTime-u,a.TimeoutTime-k,a.TimeoutTime-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new f(p.Ack,0,this.h,E());this.p.write(c)}D(){this.h=this.g;const c=new f(p.KeepAlive,0,this.h,E());this.p.write(c)}}e.$oi=d}),define(Ee[117],Se([1,0,60,14,15,19,191,10,6,2,21,114,69,50]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=void 0;class a extends b.$ci{constructor(g){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",w=>S.$Je.wrap(Buffer.from(w,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$8q=a;class f{constructor(g,w){this.i=g,this.j=w,this.c=new Set,this.g=new Map,this.h=new v.$he,this.onDidProcessExit=this.h.event;const m=w&&w.timeout?w.timeout:6e4;this.b=new r.$xh(m),this.d=null,this.f=null}getChannel(g){const w=this;return{call(m,$,l){return w.k(g,m,$,l)},listen(m,$){return w.l(g,m,$)}}}k(g,w,m,$=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const l=this.n(g),t=(0,r.$nh)(i=>l.call(w,m,i)),o=$.onCancellationRequested(()=>t.cancel()),d=(0,s.$Sc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{o.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,w,m){if(!this.b)return v.Event.None;this.b.cancel();let $;const l=new v.$he({onWillAddFirstListener:()=>{$=this.n(g).listen(w,m)(l.fire,l),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,E.$9n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,p.$sm)(w.env),this.d=(0,n.fork)(this.i,g,w);const m=new v.$he,l=v.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,A.$4q)(u)){(0,A.log)(u,`IPC Library: ${this.j.serverName}`);return}m.fire(S.$Je.wrap(Buffer.from(u,"base64")))}),t=this.j.useQueue?(0,y.$um)(this.d):this.d,o=u=>this.d&&this.d.connected&&t.send(u.buffer.toString("base64")),d=m.event,i={send:o,onMessage:d};this.f=new b.$di(i);const c=()=>this.o();process.once("exit",c),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,k)=>{process.removeListener("exit",c),l.dispose(),this.c.forEach(I=>(0,s.$Pc)(I)),this.c.clear(),u!==0&&k!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+k),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:k})})}return this.f}n(g){let w=this.g.get(g);return w||(w=this.m.getChannel(g),this.g.set(g,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9q=f}),define(Ee[196],Se([1,0,14,6,2,49,11]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.StorageState=e.StorageHint=void 0,e.$4p=v;var R;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function v(p){const b=p;return b?.changed instanceof Map||b?.deleted instanceof Set}var s;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(s||(e.StorageState=s={}));class E extends S.$Uc{static{this.a=100}constructor(b,a=Object.create(null)){super(),this.r=b,this.s=a,this.b=this.B(new r.$ke),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new n.$yh(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(b=>this.u(b)))}u(b){this.b.pause();try{b.changed?.forEach((a,f)=>this.w(f,a)),b.deleted?.forEach(a=>this.w(a,void 0))}finally{this.b.resume()}}w(b,a){if(this.c===s.Closed)return;let f=!1;(0,A.$jg)(a)?f=this.f.delete(b):this.f.get(b)!==a&&(this.f.set(b,a),f=!0),f&&this.b.fire({key:b,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(b,a){const f=this.f.get(b);return(0,A.$jg)(f)?a:f}getBoolean(b,a){const f=this.get(b);return(0,A.$jg)(f)?a:f==="true"}getNumber(b,a){const f=this.get(b);return(0,A.$jg)(f)?a:parseInt(f,10)}getObject(b,a){const f=this.get(b);return(0,A.$jg)(f)?a:(0,D.$9h)(f)}async set(b,a,f=!1){if(this.c===s.Closed)return;if((0,A.$jg)(a))return this.delete(b,f);const h=(0,A.$cg)(a)||Array.isArray(a)?(0,D.$8h)(a):String(a);if(this.f.get(b)!==h)return this.f.set(b,h),this.j.set(b,h),this.h.delete(b),this.b.fire({key:b,external:f}),this.D()}async delete(b,a=!1){if(!(this.c===s.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire({key:b,external:a}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(b).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(b){if(!(this.c===s.Closed||this.m))return this.D(b)}async D(b){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),b)}async whenFlushed(){if(this.z)return new Promise(b=>this.n.push(b))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$5p=E;class y{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((a,f)=>this.a.set(f,a)),b.delete?.forEach(a=>this.a.delete(a))}async optimize(){}async close(){}}e.$6p=y}),define(Ee[197],Se([7,8]),function(fe,e){return fe.create("vs/base/node/zip",e)}),define(Ee[86],Se([1,0,31,14,9,11,25,197]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0,e.zip=h,e.$rq=g,e.$sq=m,e.$oq="end of central directory record signature not found";const v=new RegExp(e.$oq);class s extends Error{constructor(l,t){let o=t.message;switch(l){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=l,this.cause=t}}e.$pq=s;function E($){const l=$.externalFileAttributes>>16||33188;return[448,56,7].map(t=>l&t).reduce((t,o)=>t+o,l&61440)}function y($){if($ instanceof s)return $;let l;return v.test($.message)&&(l="CorruptZip"),new s(l,$)}function p($,l,t,o,d,i){const c=S.$mc(l),u=S.$jc(o,c);if(!u.startsWith(o))return Promise.reject(new Error(R.localize(0,null,l)));const k=S.$jc(o,l);let I;return i.onCancellationRequested(()=>{I?.destroy()}),Promise.resolve(A.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((C,T)=>{if(!i.isCancellationRequested)try{I=(0,n.createWriteStream)(k,{mode:t}),I.once("close",()=>C()),I.once("error",T),$.once("error",T),$.pipe(I)}catch(O){T(O)}}))}function b($,l,t,o){let d=(0,r.$nh)(()=>Promise.resolve()),i=0;const c=o.onCancellationRequested(()=>{d.cancel(),$.close()});return new Promise((u,k)=>{const I=new r.$vh,C=T=>{T.isCancellationRequested||(i++,$.readEntry())};$.once("error",k),$.once("close",()=>d.then(()=>{o.isCancellationRequested||$.entryCount===i?u():k(new s("Incomplete",new Error(R.localize(1,null,i,$.entryCount))))},k)),$.readEntry(),$.on("entry",T=>{if(o.isCancellationRequested)return;if(!t.sourcePathRegex.test(T.fileName)){C(o);return}const O=T.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(O)){const Q=S.$jc(l,O);d=(0,r.$nh)(ie=>A.Promises.mkdir(Q,{recursive:!0}).then(()=>C(ie)).then(void 0,k));return}const P=f($,T),V=E(T);d=(0,r.$nh)(Q=>I.queue(()=>P.then(ie=>p(ie,O,V,l,t,Q).then(()=>C(Q)))).then(null,k))})}).finally(()=>c.dispose())}async function a($,l=!1){const{open:t}=await new Promise((o,d)=>{fe(["yauzl"],o,d)});return new Promise((o,d)=>{t($,l?{lazyEntries:!0}:void 0,(i,c)=>{i?d(y(i)):o((0,D.$lg)(c))})})}function f($,l){return new Promise((t,o)=>{$.openReadStream(l,(d,i)=>{d?o(y(d)):t((0,D.$lg)(i))})})}async function h($,l){const{ZipFile:t}=await new Promise((o,d)=>{fe(["yazl"],o,d)});return new Promise((o,d)=>{const i=new t;l.forEach(u=>{u.contents?i.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&i.addFile(u.localPath,u.path)}),i.end();const c=(0,n.createWriteStream)($);i.outputStream.pipe(c),i.outputStream.once("error",d),c.once("error",d),c.once("finish",()=>o($))})}function g($,l,t={},o){const d=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let i=a($,!0);return t.overwrite&&(i=i.then(c=>A.Promises.rm(l).then(()=>c))),i.then(c=>b(c,l,{sourcePathRegex:d},o))}function w($,l){return a($).then(t=>new Promise((o,d)=>{t.on("entry",i=>{i.fileName===l&&f(t,i).then(c=>o(c),c=>d(c))}),t.once("close",()=>d(new Error(R.localize(2,null,l))))}))}function m($,l){return w($,l).then(t=>new Promise((o,d)=>{const i=[];t.once("error",d),t.on("data",c=>i.push(c)),t.on("end",()=>o(Buffer.concat(i)))}))}}),define(Ee[198],Se([7,8]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Ee[199],Se([7,8]),function(fe,e){return fe.create("vs/editor/common/languages",e)}),define(Ee[200],Se([1,0,57,4,178,48,182,199]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Rv=e.$Qv=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Pv=e.$Ov=e.SymbolKinds=e.SymbolTag=e.$Mv=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Kv=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Jv=e.$Iv=e.$Hv=void 0,e.$Lv=d,e.$Nv=c;class v{constructor(B,oe,le){this.offset=B,this.type=oe,this.language=le,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Hv=v;class s{constructor(B,oe){this.tokens=B,this.endState=oe,this._tokenizationResultBrand=void 0}}e.$Iv=s;class E{constructor(B,oe){this.tokens=B,this.endState=oe,this._encodedTokenizationResultBrand=void 0}}e.$Jv=E;var y;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(y||(e.HoverVerbosityAction=y={}));var p;(function(j){j[j.Method=0]="Method",j[j.Function=1]="Function",j[j.Constructor=2]="Constructor",j[j.Field=3]="Field",j[j.Variable=4]="Variable",j[j.Class=5]="Class",j[j.Struct=6]="Struct",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Event=10]="Event",j[j.Operator=11]="Operator",j[j.Unit=12]="Unit",j[j.Value=13]="Value",j[j.Constant=14]="Constant",j[j.Enum=15]="Enum",j[j.EnumMember=16]="EnumMember",j[j.Keyword=17]="Keyword",j[j.Text=18]="Text",j[j.Color=19]="Color",j[j.File=20]="File",j[j.Reference=21]="Reference",j[j.Customcolor=22]="Customcolor",j[j.Folder=23]="Folder",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue",j[j.Snippet=27]="Snippet"})(p||(e.CompletionItemKind=p={}));var b;(function(j){const B=new Map;B.set(p.Method,n.$Zj.symbolMethod),B.set(p.Function,n.$Zj.symbolFunction),B.set(p.Constructor,n.$Zj.symbolConstructor),B.set(p.Field,n.$Zj.symbolField),B.set(p.Variable,n.$Zj.symbolVariable),B.set(p.Class,n.$Zj.symbolClass),B.set(p.Struct,n.$Zj.symbolStruct),B.set(p.Interface,n.$Zj.symbolInterface),B.set(p.Module,n.$Zj.symbolModule),B.set(p.Property,n.$Zj.symbolProperty),B.set(p.Event,n.$Zj.symbolEvent),B.set(p.Operator,n.$Zj.symbolOperator),B.set(p.Unit,n.$Zj.symbolUnit),B.set(p.Value,n.$Zj.symbolValue),B.set(p.Enum,n.$Zj.symbolEnum),B.set(p.Constant,n.$Zj.symbolConstant),B.set(p.Enum,n.$Zj.symbolEnum),B.set(p.EnumMember,n.$Zj.symbolEnumMember),B.set(p.Keyword,n.$Zj.symbolKeyword),B.set(p.Snippet,n.$Zj.symbolSnippet),B.set(p.Text,n.$Zj.symbolText),B.set(p.Color,n.$Zj.symbolColor),B.set(p.File,n.$Zj.symbolFile),B.set(p.Reference,n.$Zj.symbolReference),B.set(p.Customcolor,n.$Zj.symbolCustomColor),B.set(p.Folder,n.$Zj.symbolFolder),B.set(p.TypeParameter,n.$Zj.symbolTypeParameter),B.set(p.User,n.$Zj.account),B.set(p.Issue,n.$Zj.issues);function oe(q){let ae=B.get(q);return ae||(console.info("No codicon found for CompletionItemKind "+q),ae=n.$Zj.symbolProperty),ae}j.toIcon=oe;const le=new Map;le.set("method",p.Method),le.set("function",p.Function),le.set("constructor",p.Constructor),le.set("field",p.Field),le.set("variable",p.Variable),le.set("class",p.Class),le.set("struct",p.Struct),le.set("interface",p.Interface),le.set("module",p.Module),le.set("property",p.Property),le.set("event",p.Event),le.set("operator",p.Operator),le.set("unit",p.Unit),le.set("value",p.Value),le.set("constant",p.Constant),le.set("enum",p.Enum),le.set("enum-member",p.EnumMember),le.set("enumMember",p.EnumMember),le.set("keyword",p.Keyword),le.set("snippet",p.Snippet),le.set("text",p.Text),le.set("color",p.Color),le.set("file",p.File),le.set("reference",p.Reference),le.set("customcolor",p.Customcolor),le.set("folder",p.Folder),le.set("type-parameter",p.TypeParameter),le.set("typeParameter",p.TypeParameter),le.set("account",p.User),le.set("issue",p.Issue);function pe(q,ae){let Y=le.get(q);return typeof Y>"u"&&!ae&&(Y=p.Property),Y}j.fromString=pe})(b||(e.CompletionItemKinds=b={}));var a;(function(j){j[j.Deprecated=1]="Deprecated"})(a||(e.CompletionItemTag=a={}));var f;(function(j){j[j.None=0]="None",j[j.KeepWhitespace=1]="KeepWhitespace",j[j.InsertAsSnippet=4]="InsertAsSnippet"})(f||(e.CompletionItemInsertTextRule=f={}));var h;(function(j){j[j.Word=0]="Word",j[j.Line=1]="Line",j[j.Suggest=2]="Suggest"})(h||(e.PartialAcceptTriggerKind=h={}));var g;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(e.CompletionTriggerKind=g={}));var w;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(w||(e.InlineCompletionTriggerKind=w={}));class m{constructor(B,oe,le,pe){this.range=B,this.text=oe,this.completionKind=le,this.isSnippetText=pe}equals(B){return D.$ct.lift(this.range).equalsRange(B.range)&&this.text===B.text&&this.completionKind===B.completionKind&&this.isSnippetText===B.isSnippetText}}e.$Kv=m;var $;(function(j){j[j.Invoke=1]="Invoke",j[j.Auto=2]="Auto"})($||(e.CodeActionTriggerType=$={}));var l;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(l||(e.DocumentPasteTriggerKind=l={}));var t;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var o;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function d(j){return j&&r.URI.isUri(j.uri)&&D.$ct.isIRange(j.range)&&(D.$ct.isIRange(j.originSelectionRange)||D.$ct.isIRange(j.targetSelectionRange))}var i;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(i||(e.SymbolKind=i={})),e.$Mv={[i.Array]:(0,R.localize)(0,null),[i.Boolean]:(0,R.localize)(1,null),[i.Class]:(0,R.localize)(2,null),[i.Constant]:(0,R.localize)(3,null),[i.Constructor]:(0,R.localize)(4,null),[i.Enum]:(0,R.localize)(5,null),[i.EnumMember]:(0,R.localize)(6,null),[i.Event]:(0,R.localize)(7,null),[i.Field]:(0,R.localize)(8,null),[i.File]:(0,R.localize)(9,null),[i.Function]:(0,R.localize)(10,null),[i.Interface]:(0,R.localize)(11,null),[i.Key]:(0,R.localize)(12,null),[i.Method]:(0,R.localize)(13,null),[i.Module]:(0,R.localize)(14,null),[i.Namespace]:(0,R.localize)(15,null),[i.Null]:(0,R.localize)(16,null),[i.Number]:(0,R.localize)(17,null),[i.Object]:(0,R.localize)(18,null),[i.Operator]:(0,R.localize)(19,null),[i.Package]:(0,R.localize)(20,null),[i.Property]:(0,R.localize)(21,null),[i.String]:(0,R.localize)(22,null),[i.Struct]:(0,R.localize)(23,null),[i.TypeParameter]:(0,R.localize)(24,null),[i.Variable]:(0,R.localize)(25,null)};function c(j,B){return(0,R.localize)(26,null,j,e.$Mv[B])}var u;(function(j){j[j.Deprecated=1]="Deprecated"})(u||(e.SymbolTag=u={}));var k;(function(j){const B=new Map;B.set(i.File,n.$Zj.symbolFile),B.set(i.Module,n.$Zj.symbolModule),B.set(i.Namespace,n.$Zj.symbolNamespace),B.set(i.Package,n.$Zj.symbolPackage),B.set(i.Class,n.$Zj.symbolClass),B.set(i.Method,n.$Zj.symbolMethod),B.set(i.Property,n.$Zj.symbolProperty),B.set(i.Field,n.$Zj.symbolField),B.set(i.Constructor,n.$Zj.symbolConstructor),B.set(i.Enum,n.$Zj.symbolEnum),B.set(i.Interface,n.$Zj.symbolInterface),B.set(i.Function,n.$Zj.symbolFunction),B.set(i.Variable,n.$Zj.symbolVariable),B.set(i.Constant,n.$Zj.symbolConstant),B.set(i.String,n.$Zj.symbolString),B.set(i.Number,n.$Zj.symbolNumber),B.set(i.Boolean,n.$Zj.symbolBoolean),B.set(i.Array,n.$Zj.symbolArray),B.set(i.Object,n.$Zj.symbolObject),B.set(i.Key,n.$Zj.symbolKey),B.set(i.Null,n.$Zj.symbolNull),B.set(i.EnumMember,n.$Zj.symbolEnumMember),B.set(i.Struct,n.$Zj.symbolStruct),B.set(i.Event,n.$Zj.symbolEvent),B.set(i.Operator,n.$Zj.symbolOperator),B.set(i.TypeParameter,n.$Zj.symbolTypeParameter);function oe(le){let pe=B.get(le);return pe||(console.info("No codicon found for SymbolKind "+le),pe=n.$Zj.symbolProperty),pe}j.toIcon=oe})(k||(e.SymbolKinds=k={}));class I{static asEditOperation(B){return S.$dt.replace(D.$ct.lift(B.range),B.text)}}e.$Ov=I;class C{static{this.Comment=new C("comment")}static{this.Imports=new C("imports")}static{this.Region=new C("region")}static fromValue(B){switch(B){case"comment":return C.Comment;case"imports":return C.Imports;case"region":return C.Region}return new C(B)}constructor(B){this.value=B}}e.$Pv=C;var T;(function(j){j[j.AIGenerated=1]="AIGenerated"})(T||(e.NewSymbolNameTag=T={}));var O;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(O||(e.NewSymbolNameTriggerKind=O={}));var P;(function(j){function B(oe){return!oe||typeof oe!="object"?!1:typeof oe.id=="string"&&typeof oe.title=="string"}j.is=B})(P||(e.Command=P={}));var V;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(V||(e.CommentThreadCollapsibleState=V={}));var Q;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Q||(e.CommentThreadState=Q={}));var ie;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(ie||(e.CommentThreadApplicability=ie={}));var re;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(re||(e.CommentMode=re={}));var ne;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ne||(e.CommentState=ne={}));var se;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(se||(e.InlayHintKind=se={}));class Z{constructor(B){this.b=B,this.a=null}dispose(){this.a&&this.a.then(B=>{B&&B.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Qv=Z,e.$Rv=new A.$xv;var ee;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(ee||(e.ExternalUriOpenerPriority=ee={}));var ue;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(ue||(e.InlineEditTriggerKind=ue={}))}),define(Ee[201],Se([7,8]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[202],Se([7,8]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[203],Se([7,8]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[204],Se([7,8]),function(fe,e){return fe.create("vs/platform/environment/node/argv",e)}),define(Ee[205],Se([7,8]),function(fe,e){return fe.create("vs/platform/environment/node/argvHelper",e)}),define(Ee[206],Se([7,8]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Ee[207],Se([7,8]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[208],Se([7,8]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Ee[209],Se([7,8]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Ee[210],Se([7,8]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Ee[211],Se([7,8]),function(fe,e){return fe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Ee[212],Se([7,8]),function(fe,e){return fe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Ee[213],Se([7,8]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[214],Se([7,8]),function(fe,e){return fe.create("vs/platform/files/common/fileService",e)}),define(Ee[215],Se([7,8]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Ee[216],Se([7,8]),function(fe,e){return fe.create("vs/platform/files/common/io",e)}),define(Ee[217],Se([7,8]),function(fe,e){return fe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[218],Se([7,8]),function(fe,e){return fe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Ee[219],Se([7,8]),function(fe,e){return fe.create("vs/platform/log/common/log",e)}),define(Ee[220],Se([7,8]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Ee[221],Se([7,8]),function(fe,e){return fe.create("vs/platform/request/common/request",e)}),define(Ee[222],Se([7,8]),function(fe,e){return fe.create("vs/platform/shell/node/shellEnv",e)}),define(Ee[223],Se([7,8]),function(fe,e){return fe.create("vs/platform/telemetry/common/telemetryService",e)}),define(Ee[224],Se([7,8]),function(fe,e){return fe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Ee[225],Se([7,8]),function(fe,e){return fe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(Ee[226],Se([7,8]),function(fe,e){return fe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[227],Se([7,8]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Ee[228],Se([7,8]),function(fe,e){return fe.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(Ee[229],Se([7,8]),function(fe,e){return fe.create("vs/server/node/serverEnvironmentService",e)}),define(Ee[230],Se([7,8]),function(fe,e){return fe.create("vs/server/node/serverServices",e)}),define(Ee[231],Se([7,8]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[232],Se([7,8]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Ee[233],Se([7,8]),function(fe,e){return fe.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ee[234],Se([7,8]),function(fe,e){return fe.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ee[235],Se([7,8]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[236],Se([7,8]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[237],Se([7,8]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[238],Se([7,8]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(Ee[239],Se([1,0,35,10,203]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var D;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(D||(e.TokenType=D={}));function A(...E){switch(E.length){case 1:return(0,S.localize)(0,null,E[0]);case 2:return(0,S.localize)(1,null,E[0],E[1]);case 3:return(0,S.localize)(2,null,E[0],E[1],E[2]);default:return}}const R=(0,S.localize)(3,null),v=(0,S.localize)(4,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case D.LParen:return"(";case D.RParen:return")";case D.Neg:return"!";case D.Eq:return y.isTripleEq?"===":"==";case D.NotEq:return y.isTripleEq?"!==":"!=";case D.Lt:return"<";case D.LtEq:return"<=";case D.Gt:return">=";case D.GtEq:return">=";case D.RegexOp:return"=~";case D.RegexStr:return y.lexeme;case D.True:return"true";case D.False:return"false";case D.In:return"in";case D.Not:return"not";case D.And:return"&&";case D.Or:return"||";case D.Str:return y.lexeme;case D.QuotedStr:return y.lexeme;case D.Error:return y.lexeme;case D.EOF:return"EOF";default:throw(0,r.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",D.Not],["in",D.In],["false",D.False],["true",D.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(D.LParen);break;case n.CharCode.CloseParen:this.k(D.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const p=this.h(n.CharCode.Equals);this.f.push({type:D.NotEq,offset:this.d,isTripleEq:p})}else this.k(D.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const p=this.h(n.CharCode.Equals);this.f.push({type:D.Eq,offset:this.d,isTripleEq:p})}else this.h(n.CharCode.Tilde)?this.k(D.RegexOp):this.l(A("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?D.LtEq:D.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?D.GtEq:D.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(D.And):this.l(A("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(D.Or):this.l(A("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(D.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const p=this.d,b=this.c.substring(this.d,this.e),a={type:D.Error,offset:this.d,lexeme:b};this.g.push({offset:p,lexeme:b,additionalInfo:y}),this.f.push(a)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const p=this.c.substring(this.d,this.e),b=s.b.get(p);b?this.k(b):this.f.push({type:D.Str,lexeme:p,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:D.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,p=!1,b=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(v);return}const f=this.c.charCodeAt(y);if(p)p=!1;else if(f===n.CharCode.Slash&&!b){y++;break}else f===n.CharCode.OpenSquareBracket?b=!0:f===n.CharCode.Backslash?p=!0:f===n.CharCode.CloseSquareBracket&&(b=!1);y++}for(;y<this.c.length&&s.a.has(this.c.charCodeAt(y));)y++;this.e=y;const a=this.c.substring(this.d,this.e);this.f.push({type:D.RegexStr,lexeme:a,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=s}),define(Ee[240],Se([1,0,6,2]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=void 0;class S{constructor(){this.a=new n.$he,this.b=new n.$he,this.c=new n.$he,this.d=new n.$he}static{this.ChannelName="extensionhostdebugservice"}call(R,v,s){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:s[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:s[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:s[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:s[0],port:s[1],subId:s[2]}))}throw new Error("Method not implemented.")}listen(R,v,s){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Po=S;class D extends r.$Uc{constructor(R){super(),this.b=R}reload(R){this.b.call("reload",[R])}get onReload(){return this.b.listen("reload")}close(R){this.b.call("close",[R])}get onClose(){return this.b.listen("close")}attachSession(R,v,s){this.b.call("attach",[R,v,s])}get onAttachSession(){return this.b.listen("attach")}terminateSession(R,v){this.b.call("terminate",[R,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(R,v){return this.b.call("openExtensionDevelopmentHostWindow",[R,v])}}e.$Qo=D}),define(Ee[241],Se([1,0,4]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=void 0;class r{constructor(A){this.a=A}listen(A,R,v){throw new Error("Invalid listen")}call(A,R,v){switch(R){case"download":return this.a.download(n.URI.revive(v[0]),n.URI.revive(v[1]))}throw new Error("Invalid call")}}e.$So=r;class S{constructor(A,R){this.a=A,this.b=R}async download(A,R){const v=this.b();v&&(A=v.transformOutgoingURI(A),R=v.transformOutgoingURI(R)),await this.a.call("download",[A,R])}}e.$To=S}),define(Ee[242],Se([1,0,186,77,13,9,33,20,4]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=void 0,e.$_m=E,e.$an=y,e.$0m=/^([^.]+\..+)[:=](.+)$/;class s{get appRoot(){return(0,D.$mc)(S.$Ug.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,D.$jc)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,R.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const b=(0,n.$9m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$jc)(this.userDataPath,"logs",b)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$bh)(v.URI.file((0,D.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=A.env.VSCODE_PORTABLE;return b?v.URI.file((0,D.$jc)(b,"argv.json")):(0,R.$bh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,D.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,D.$kc)(b):(0,D.$hc)((0,D.$jc)(S.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const b=this.args["extensions-download-dir"];return b?v.URI.file((0,D.$kc)(b)):v.URI.file((0,D.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,D.$kc)(b);const a=A.env.VSCODE_EXTENSIONS;if(a)return a;const f=A.env.VSCODE_PORTABLE;return f?(0,D.$jc)(f,"extensions"):(0,R.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(a=>/^[^:/?#]+?:\/\//.test(a)?v.URI.parse(a):v.URI.file((0,D.$hc)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?v.URI.parse(b):v.URI.file((0,D.$hc)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(b=>!e.$0m.test(b))}get extensionLogLevel(){const b=[];for(const a of this.args.log||[]){const f=e.$0m.exec(a);f&&f[1]&&f[2]&&b.push([f[1],f[2]])}return b.length?b:void 0}get serviceMachineIdResource(){return(0,R.$bh)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const b=A.env.VSCODE_PORTABLE;return b?v.URI.file((0,D.$jc)(b,"policy.json")):(0,R.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(b){this.args.continueOn=b}get args(){return this.a}constructor(b,a,f){this.a=b,this.b=a,this.c=f,this.editSessionId=this.args.editSessionId}}e.$$m=s,Ue([r.$5h],s.prototype,"appRoot",null),Ue([r.$5h],s.prototype,"userHome",null),Ue([r.$5h],s.prototype,"userDataPath",null),Ue([r.$5h],s.prototype,"appSettingsHome",null),Ue([r.$5h],s.prototype,"tmpDir",null),Ue([r.$5h],s.prototype,"cacheHome",null),Ue([r.$5h],s.prototype,"stateResource",null),Ue([r.$5h],s.prototype,"userRoamingDataHome",null),Ue([r.$5h],s.prototype,"userDataSyncHome",null),Ue([r.$5h],s.prototype,"sync",null),Ue([r.$5h],s.prototype,"machineSettingsResource",null),Ue([r.$5h],s.prototype,"workspaceStorageHome",null),Ue([r.$5h],s.prototype,"localHistoryHome",null),Ue([r.$5h],s.prototype,"keyboardLayoutResource",null),Ue([r.$5h],s.prototype,"argvResource",null),Ue([r.$5h],s.prototype,"isExtensionDevelopment",null),Ue([r.$5h],s.prototype,"untitledWorkspacesHome",null),Ue([r.$5h],s.prototype,"builtinExtensionsPath",null),Ue([r.$5h],s.prototype,"extensionsPath",null),Ue([r.$5h],s.prototype,"extensionDevelopmentLocationURI",null),Ue([r.$5h],s.prototype,"extensionDevelopmentKind",null),Ue([r.$5h],s.prototype,"extensionTestsLocationURI",null),Ue([r.$5h],s.prototype,"debugExtensionHost",null),Ue([r.$5h],s.prototype,"logLevel",null),Ue([r.$5h],s.prototype,"extensionLogLevel",null),Ue([r.$5h],s.prototype,"serviceMachineIdResource",null),Ue([r.$5h],s.prototype,"disableTelemetry",null),Ue([r.$5h],s.prototype,"disableWorkspaceTrust",null),Ue([r.$5h],s.prototype,"useInMemorySecretStorage",null),Ue([r.$5h],s.prototype,"policyFile",null);function E(p,b){return y(p["inspect-extensions"],p["inspect-brk-extensions"],5870,b,p.debugId,p.extensionEnvironment)}function y(p,b,a,f,h,g){const m=Number(b||p)||(f?null:a),$=m?!!b:!1;let l;if(g)try{l=JSON.parse(g)}catch{}return{port:m,break:$,debugId:h,env:l}}}),define(Ee[70],Se([1,0,334,3,204]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=void 0,e.$ym=R,e.$zm=s,e.$Am=b,e.$Bm=a;const D={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$wm=["tunnel","serve-web"],e.$xm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},"use-gl":{type:"string"},"use-angle":{type:"string"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(f,h,g=A){const w=f.find(u=>u.length>0&&u[0]!=="-"),m={},$=["_"],l=[],t={};let o;for(const u in h){const k=h[u];k.type==="subcommand"?u===w&&(o=k):(k.alias&&(m[u]=k.alias),k.type==="string"||k.type==="string[]"?($.push(u),k.deprecates&&$.push(...k.deprecates)):k.type==="boolean"&&(l.push(u),k.deprecates&&l.push(...k.deprecates)),k.global&&(t[u]=k))}if(o&&w){const u=t;for(const T in o.options)u[T]=o.options[T];const k=f.filter(T=>T!==w),I=g.getSubcommandReporter?g.getSubcommandReporter(w):void 0,C=R(k,u,I);return{[w]:C,_:[]}}const d=n(f,{string:$,boolean:l,alias:m}),i={},c=d;i._=d._.map(u=>String(u)).filter(u=>u.length>0),delete c._;for(const u in h){const k=h[u];if(k.type==="subcommand")continue;k.alias&&delete c[k.alias];let I=c[u];if(k.deprecates)for(const C of k.deprecates)c.hasOwnProperty(C)&&(I||(I=c[C],I&&g.onDeprecatedOption(C,k.deprecationMessage||(0,S.localize)(39,null,u))),delete c[C]);if(typeof I<"u"){if(k.type==="string[]"){if(Array.isArray(I)||(I=[I]),!k.allowEmptyValue){const C=I.filter(T=>T.length>0);C.length!==I.length&&(g.onEmptyValue(u),I=C.length>0?C:void 0)}}else k.type==="string"&&(Array.isArray(I)?(I=I.pop(),g.onMultipleValues(u,I)):!I&&!k.allowEmptyValue&&(g.onEmptyValue(u),I=void 0));i[u]=I,k.deprecationMessage&&g.onDeprecatedOption(u,k.deprecationMessage)}delete c[u]}for(const u in c)g.onUnknownOption(u);return i}function v(f,h){let g="";return h.args&&(Array.isArray(h.args)?g=` <${h.args.join("> <")}>`:g=` <${h.args}>`),h.alias?`-${h.alias} --${f}${g}`:`--${f}${g}`}function s(f,h){const g=[];for(const w in f){const m=f[w],$=v(w,m);g.push([$,m.description])}return E(g,h)}function E(f,h){const w=f.reduce((l,t)=>Math.max(l,t[0].length),12)+2+1;if(h-w<25)return f.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const m=h-w-1,$=[];for(const l of f){const t=l[0],o=p(l[1],m),d=y(w-t.length-2);$.push("  "+t+d+o[0]);for(let i=1;i<o.length;i++)$.push(y(w)+o[i])}return $}function y(f){return" ".repeat(f)}function p(f,h){const g=[];for(;f.length;){const w=f.length<h?f.length:f.lastIndexOf(" ",h),m=f.slice(0,w).trim();f=f.slice(w),g.push(m)}return g}function b(f,h,g,w,m){const $=process.stdout.isTTY&&process.stdout.columns||80,l=m?.noInputFiles!==!0?`[${(0,S.localize)(40,null)}...]`:"",t=[`${f} ${g}`];t.push(""),t.push(`${(0,S.localize)(41,null)}: ${h} [${(0,S.localize)(42,null)}]${l}`),t.push(""),m?.noPipe!==!0&&(r.$i?t.push((0,S.localize)(43,null,h)):t.push((0,S.localize)(44,null,h)),t.push(""));const o={},d=[];for(const i in w){const c=w[i];if(c.type==="subcommand")c.description&&d.push({command:i,description:c.description});else if(c.description&&c.cat){let u=o[c.cat];u||(o[c.cat]=u={}),u[i]=c}}for(const i in o){const c=i,u=o[c];u&&(t.push(D[c]),t.push(...s(u,$)),t.push(""))}return d.length&&(t.push((0,S.localize)(45,null)),t.push(...E(d.map(i=>[i.command,i.description]),$)),t.push("")),t.join(`
`)}function a(f,h){return`${f||(0,S.localize)(46,null)}
${h||(0,S.localize)(47,null)}
${process.arch}`}}),define(Ee[243],Se([1,0,335,205,70]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=R,e.$Dm=v,e.$Em=s,e.$Fm=E;function D(y,p){const b=(m,$)=>{console.warn((0,r.localize)(0,null,m,$))},a=m=>{console.warn((0,r.localize)(1,null,m))},f=(m,$)=>{console.warn((0,r.localize)(2,null,m,$))},h=m=>({onUnknownOption:$=>{S.$wm.includes(m)||console.warn((0,r.localize)(3,null,$,m))},onMultipleValues:b,onEmptyValue:a,onDeprecatedOption:f,getSubcommandReporter:S.$wm.includes(m)?h:void 0}),g={onUnknownOption:m=>{console.warn((0,r.localize)(4,null,m))},onMultipleValues:b,onEmptyValue:a,onDeprecatedOption:f,getSubcommandReporter:h},w=(0,S.$ym)(y,S.$xm,p?g:void 0);return w.goto&&w._.forEach(m=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(m),(0,r.localize)(5,null))),w}function A(y){const p=y.findIndex(b=>!/^-/.test(b));if(p>-1)return[...y.slice(0,p),...y.slice(p+1)]}function R(y){let[,...p]=y;process.env.VSCODE_DEV&&(p=A(p)||[]);const b=!E(process.env);return D(p,b)}function v(y){let[,,...p]=y;return process.env.VSCODE_DEV&&(p=A(p)||[]),D(p,!0)}function s(y,...p){const b=y.indexOf("--");return b===-1?y.push(...p):y.splice(b,0,...p),y}function E(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function fe(e,n,r){function S(A,R){const v=D(A,R),s=[v];return e.isAbsolute(v)||s.unshift(r),e.resolve(...s)}function D(A,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let s=process.env.VSCODE_APPDATA;if(s)return e.join(s,R);const E=A["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(s=process.env.APPDATA,!s){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");s=e.join(y,"AppData","Roaming")}break;case"darwin":s=e.join(n.homedir(),"Library","Application Support");break;case"linux":s=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(s,R)}return{getUserDataPath:S}}if(typeof define=="function")define(Ee[244],Se([82,32,33]),function(e,n,r){return fe(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=fe(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Ee[118],Se([1,0,32,242,244]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=void 0,e.$cn=A,e.$dn=R;class D extends r.$$m{constructor(s,E){super(s,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,S.getUserDataPath)(s,E.nameShort)},E)}}e.$bn=D;function A(v,s){return(0,r.$an)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,s,v.extensionEnvironment)}function R(v,s){return(0,r.$an)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,s,v.extensionEnvironment)}}),define(Ee[245],Se([1,0,11,209]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=S;function S(A,R,v,s){try{D(A,R,v,s)}catch(E){A.error(E?.message??E)}return R}function D(A,R,v,s){const E=(y,p,b)=>{const a=y[p];if((0,n.$ag)(a)){const f=a,h=f.length;if(h>1&&f[0]==="%"&&f[h-1]==="%"){const g=f.substr(1,h-2);let w=v[g];w===void 0&&s&&(w=s[g]);const m=typeof w=="string"?w:w?.message,$=s?.[g],l=typeof $=="string"?$:$?.message;if(!m){l||A.warn(`[${R.name}]: ${(0,r.localize)(0,null,g)}`);return}if(b&&(p==="title"||p==="category")&&l&&l!==m){const t={value:m,original:l};y[p]=t}else y[p]=m}}else if((0,n.$cg)(a))for(const f in a)a.hasOwnProperty(f)&&(f==="commands"?E(a,f,!0):E(a,f,b));else if(Array.isArray(a))for(let f=0;f<a.length;f++)E(a,f,b)};for(const y in R)R.hasOwnProperty(y)&&E(R,y)}}),define(Ee[87],Se([1,0,20,58,213,62]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=v,e.$Pp=s,e.$Qp=E,e.$Rp=y,e.$Sp=p,e.$Tp=b,e.$Up=a;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function v(g){return g=g.trim(),g==="*"||A.test(g)}function s(g){if(!v(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=g.match(A);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}function E(g){if(!g)return null;const w=g.majorBase,m=g.majorMustEqual,$=g.minorBase;let l=g.minorMustEqual;const t=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(w===0||(l=!1),o=!1);let d=0;if(g.preRelease){const i=R.exec(g.preRelease);if(i){const[,c,u,k]=i;d=Date.UTC(Number(c),Number(u)-1,Number(k))}}return{majorBase:w,majorMustEqual:m,minorBase:$,minorMustEqual:l,patchBase:t,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:d}}function y(g,w,m){let $;typeof g=="string"?$=E(s(g)):$=g;let l;w instanceof Date?l=w.getTime():typeof w=="string"&&(l=new Date(w).getTime());let t;if(typeof m=="string"?t=E(s(m)):t=m,!$||!t)return!1;const o=$.majorBase,d=$.minorBase,i=$.patchBase;let c=t.majorBase,u=t.minorBase,k=t.patchBase;const I=t.notBefore;let C=t.majorMustEqual,T=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?o>c?!0:o<c?!1:d>u?!0:d<u||l&&l<I?!1:i>=k:(o===1&&c===0&&(!C||!T||!O)&&(c=1,u=0,k=0,C=!0,T=!1,O=!1),o<c?!1:o>c?!C:d<u?!1:d>u?!T:i<k?!1:i>k?!O:!(l&&l<I))}function p(g,w,m,$,l){const t=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return t.push([r.default.Error,S.localize(0,null)]),t;if(typeof $.name!="string")return t.push([r.default.Error,S.localize(1,null,"name")]),t;if(typeof $.version!="string")return t.push([r.default.Error,S.localize(2,null,"version")]),t;if(!$.engines)return t.push([r.default.Error,S.localize(3,null,"engines")]),t;if(typeof $.engines.vscode!="string")return t.push([r.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof $.extensionDependencies<"u"&&!h($.extensionDependencies))return t.push([r.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof $.activationEvents<"u"){if(!h($.activationEvents))return t.push([r.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof $.main>"u"&&typeof $.browser>"u")return t.push([r.default.Error,S.localize(7,null,"activationEvents","main","browser")]),t}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&t.push([r.default.Warning,S.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return t.push([r.default.Error,S.localize(9,null,"main")]),t;{const i=(0,n.$bh)(m,$.main);(0,n.$8g)(i,m)||t.push([r.default.Warning,S.localize(10,null,i.path,m.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return t.push([r.default.Error,S.localize(11,null,"browser")]),t;{const i=(0,n.$bh)(m,$.browser);(0,n.$8g)(i,m)||t.push([r.default.Warning,S.localize(12,null,i.path,m.path)])}}if(!D.valid($.version))return t.push([r.default.Error,S.localize(13,null)]),t;const o=[];if(!b(g,w,$,l,o))for(const i of o)t.push([r.default.Error,i]);return t}function b(g,w,m,$,l){return $||typeof m.main>"u"&&typeof m.browser>"u"?!0:f(g,w,m.engines.vscode,l)}function a(g,w,m){return g==="*"||f(w,m,g)}function f(g,w,m,$=[]){const l=E(s(m));if(!l)return $.push(S.localize(14,null,m)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return $.push(S.localize(15,null,m)),!1}else if(!l.majorMustEqual)return $.push(S.localize(16,null,m)),!1;return y(g,w,l)?!0:($.push(S.localize(17,null,g,m)),!1)}function h(g){if(!Array.isArray(g))return!1;for(let w=0,m=g.length;w<m;w++)if(typeof g[w]!="string")return!1;return!0}}),define(Ee[71],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class n{constructor(S,D=[],A=!1){this.ctor=S,this.staticArguments=D,this.supportsDelayedInstantiation=A}}e.$xi=n}),define(Ee[119],Se([1,0,71]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Fs=D,e.$Gs=A;const r=[];var S;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function D(R,v,s){v instanceof n.$xi||(v=new n.$xi(v,[],!!s)),r.push([R,v])}function A(){return r}}),define(Ee[246],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;class n{constructor(D,A){this.key=D,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$ir=n;class r{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const A of this.a.values())A.outgoing.size===0&&D.push(A);return D}insertEdge(D,A){const R=this.lookupOrInsertNode(D),v=this.lookupOrInsertNode(A);R.outgoing.set(v.key,v),v.incoming.set(R.key,R)}removeNode(D){const A=this.b(D);this.a.delete(A);for(const R of this.a.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(D){const A=this.b(D);let R=this.a.get(A);return R||(R=new n(A,D),this.a.set(A,R)),R}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[A,R]of this.a)D.push(`${A}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,A]of this.a){const R=new Set([D]),v=this.c(A,R);if(v)return v}}c(D,A){for(const[R,v]of D.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const s=this.c(v,A);if(s)return s;A.delete(R)}}}e.$jr=r}),define(Ee[5],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=S,e.$Bi=D;var n;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function R(v){return v[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=R})(n||(e._util=n={})),e.$zi=S("instantiationService");function r(A,R,v){R[n.DI_TARGET]===R?R[n.DI_DEPENDENCIES].push({id:A,index:v}):(R[n.DI_DEPENDENCIES]=[{id:A,index:v}],R[n.DI_TARGET]=R)}function S(A){if(n.serviceIds.has(A))return n.serviceIds.get(A);const R=function(v,s,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(R,v,E)};return R.toString=()=>A,n.serviceIds.set(A,R),R}function D(A){return A}}),define(Ee[27],Se([1,0,11,4,5]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=D,e.$9i=A,e.$0i=v,e.$$i=s,e.$_i=E,e.$aj=y,e.$bj=p,e.$cj=a,e.$dj=f,e.$ej=h,e.$7i=(0,S.$Ai)("configurationService");function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof r.URI)}function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof r.URI)}var R;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function v(g){switch(g){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function s(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}function E(g,w){const m=Object.create(null);for(const $ in g)y(m,$,g[$],w);return m}function y(g,w,m,$){const l=w.split("."),t=l.pop();let o=g;for(let d=0;d<l.length;d++){const i=l[d];let c=o[i];switch(typeof c){case"undefined":c=o[i]=Object.create(null);break;case"object":if(c===null){$(`Ignoring ${w} as ${l.slice(0,d+1).join(".")} is null`);return}break;default:$(`Ignoring ${w} as ${l.slice(0,d+1).join(".")} is ${JSON.stringify(c)}`);return}o=c}if(typeof o=="object"&&o!==null)try{o[t]=m}catch{$(`Ignoring ${w} as ${l.join(".")} is ${JSON.stringify(o)}`)}else $(`Ignoring ${w} as ${l.join(".")} is ${JSON.stringify(o)}`)}function p(g,w){const m=w.split(".");b(g,m)}function b(g,w){const m=w.shift();if(w.length===0){delete g[m];return}if(Object.keys(g).indexOf(m)!==-1){const $=g[m];typeof $=="object"&&!Array.isArray($)&&(b($,w),Object.keys($).length===0&&delete g[m])}}function a(g,w,m){function $(o,d){let i=o;for(const c of d){if(typeof i!="object"||i===null)return;i=i[c]}return i}const l=w.split("."),t=$(g,l);return typeof t>"u"?m:t}function f(g,w,m){Object.keys(w).forEach($=>{$!=="__proto__"&&($ in g?n.$cg(g[$])&&n.$cg(w[$])?f(g[$],w[$],m):m&&(g[$]=w[$]):g[$]=w[$])})}function h(g){return g.replace(/[\[\]]/g,"")}}),define(Ee[43],Se([1,0,35,3,17,239,5,202,10]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=E,e.$zj=d,e.$Aj=i,e.$Tj=q;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",r.$j),s.set("isLinux",r.$k),s.set("isWindows",r.$i),s.set("isWeb",r.$o),s.set("isMacNative",r.$j&&!r.$o),s.set("isEdge",r.$H),s.set("isFirefox",r.$F),s.set("isChrome",r.$E),s.set("isSafari",r.$G);function E(H,L){if(s.get(H)!==void 0)throw(0,v.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(H,L)}const y=Object.prototype.hasOwnProperty;var p;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const b={regexParsingWithErrorRecovery:!0},a=(0,R.localize)(0,null),f=(0,R.localize)(1,null),h=(0,R.localize)(2,null),g=(0,R.localize)(3,null),w=(0,R.localize)(4,null),m=(0,R.localize)(5,null),$=(0,R.localize)(6,null),l=(0,R.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=b){this.k=L,this.d=new D.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:a,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const W=this.l();if(!this.E()){const z=this.D(),U=z.type===D.TokenType.Str?m:void 0;throw this.h.push({message:w,offset:z.offset,lexeme:D.$vj.getLexeme(z),additionalInfo:U}),t.c}return W}catch(W){if(W!==t.c)throw W;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(D.TokenType.Or);){const W=this.o();L.push(W)}return L.length===1?L[0]:o.or(...L)}o(){const L=[this.s()];for(;this.y(D.TokenType.And);){const W=this.s();L.push(W)}return L.length===1?L[0]:o.and(...L)}s(){if(this.y(D.TokenType.Neg)){const L=this.D();switch(L.type){case D.TokenType.True:return this.z(),u.INSTANCE;case D.TokenType.False:return this.z(),k.INSTANCE;case D.TokenType.LParen:{this.z();const W=this.l();return this.A(D.TokenType.RParen,g),W?.negate()}case D.TokenType.Str:return this.z(),V.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case D.TokenType.True:return this.z(),o.true();case D.TokenType.False:return this.z(),o.false();case D.TokenType.LParen:{this.z();const W=this.l();return this.A(D.TokenType.RParen,g),W}case D.TokenType.Str:{const W=L.lexeme;if(this.z(),this.y(D.TokenType.RegexOp)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==D.TokenType.RegexStr)throw this.B("REGEX",U);const J=U.lexeme,x=J.lastIndexOf("/"),M=x===J.length-1?void 0:this.w(J.substring(x+1));let G;try{G=new RegExp(J.substring(1,x),M)}catch{throw this.B("REGEX",U)}return Z.create(W,G)}switch(U.type){case D.TokenType.RegexStr:case D.TokenType.Error:{const J=[U.lexeme];this.z();let x=this.D(),M=0;for(let Ne=0;Ne<U.lexeme.length;Ne++)U.lexeme.charCodeAt(Ne)===n.CharCode.OpenParen?M++:U.lexeme.charCodeAt(Ne)===n.CharCode.CloseParen&&M--;for(;!this.E()&&x.type!==D.TokenType.And&&x.type!==D.TokenType.Or;){switch(x.type){case D.TokenType.LParen:M++;break;case D.TokenType.RParen:M--;break;case D.TokenType.RegexStr:case D.TokenType.QuotedStr:for(let Ne=0;Ne<x.lexeme.length;Ne++)x.lexeme.charCodeAt(Ne)===n.CharCode.OpenParen?M++:U.lexeme.charCodeAt(Ne)===n.CharCode.CloseParen&&M--}if(M<0)break;J.push(D.$vj.getLexeme(x)),this.z(),x=this.D()}const G=J.join(""),te=G.lastIndexOf("/"),he=te===G.length-1?void 0:this.w(G.substring(te+1));let ke;try{ke=new RegExp(G.substring(1,te),he)}catch{throw this.B("REGEX",U)}return o.regex(W,ke)}case D.TokenType.QuotedStr:{const J=U.lexeme;this.z();let x=null;if(!(0,S.$$e)(J)){const M=J.indexOf("/"),G=J.lastIndexOf("/");if(M!==G&&M>=0){const te=J.slice(M+1,G),he=J[G+1]==="i"?"i":"";try{x=new RegExp(te,he)}catch{throw this.B("REGEX",U)}}}if(x===null)throw this.B("REGEX",U);return Z.create(W,x)}default:throw this.B("REGEX",this.D())}}if(this.y(D.TokenType.Not)){this.A(D.TokenType.In,h);const U=this.u();return o.notIn(W,U)}switch(this.D().type){case D.TokenType.Eq:{this.z();const U=this.u();if(this.x().type===D.TokenType.QuotedStr)return o.equals(W,U);switch(U){case"true":return o.has(W);case"false":return o.not(W);default:return o.equals(W,U)}}case D.TokenType.NotEq:{this.z();const U=this.u();if(this.x().type===D.TokenType.QuotedStr)return o.notEquals(W,U);switch(U){case"true":return o.not(W);case"false":return o.has(W);default:return o.notEquals(W,U)}}case D.TokenType.Lt:return this.z(),ne.create(W,this.u());case D.TokenType.LtEq:return this.z(),se.create(W,this.u());case D.TokenType.Gt:return this.z(),ie.create(W,this.u());case D.TokenType.GtEq:return this.z(),re.create(W,this.u());case D.TokenType.In:return this.z(),o.in(W,this.u());default:return o.has(W)}}case D.TokenType.EOF:throw this.h.push({message:$,offset:L.offset,lexeme:"",additionalInfo:l}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case D.TokenType.Str:case D.TokenType.QuotedStr:return this.z(),L.lexeme;case D.TokenType.True:return this.z(),"true";case D.TokenType.False:return this.z(),"false";case D.TokenType.In:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,W){if(this.C(L))return this.z();throw this.B(W,this.D())}B(L,W,z){const U=(0,R.localize)(8,null,L,D.$vj.getLexeme(W)),J=W.offset,x=D.$vj.getLexeme(W);return this.h.push({message:U,offset:J,lexeme:x,additionalInfo:z}),t.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===D.TokenType.EOF}}e.$xj=t;class o{static false(){return u.INSTANCE}static true(){return k.INSTANCE}static has(L){return I.create(L)}static equals(L,W){return C.create(L,W)}static notEquals(L,W){return P.create(L,W)}static regex(L,W){return Z.create(L,W)}static in(L,W){return T.create(L,W)}static notIn(L,W){return O.create(L,W)}static not(L){return V.create(L)}static and(...L){return j.create(L,null,!0)}static or(...L){return B.create(L,null,!0)}static greater(L,W){return ie.create(L,W)}static greaterEquals(L,W){return re.create(L,W)}static smaller(L,W){return ne.create(L,W)}static smallerEquals(L,W){return se.create(L,W)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$yj=o;function d(H){const L=new t({regexParsingWithErrorRecovery:!1});return H.map(W=>(L.parse(W),L.lexingErrors.length>0?L.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,R.localize)(9,null,z.additionalInfo):(0,R.localize)(10,null),offset:z.offset,length:z.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function i(H,L){const W=H?H.substituteConstants():void 0,z=L?L.substituteConstants():void 0;return!W&&!z?!0:!W||!z?!1:W.equals(z)}function c(H,L){return H.cmp(L)}class u{static{this.INSTANCE=new u}constructor(){this.type=p.False}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return k.INSTANCE}}e.$Bj=u;class k{static{this.INSTANCE=new k}constructor(){this.type=p.True}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return u.INSTANCE}}e.$Cj=k;class I{static create(L,W=null){const z=s.get(L);return typeof z=="boolean"?z?k.INSTANCE:u.INSTANCE:new I(L,W)}constructor(L,W){this.key=L,this.c=W,this.type=p.Defined}cmp(L){return L.type!==this.type?this.type-L.type:le(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=s.get(this.key);return typeof L=="boolean"?L?k.INSTANCE:u.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=V.create(this.key,this)),this.c}}e.$Dj=I;class C{static create(L,W,z=null){if(typeof W=="boolean")return W?I.create(L,z):V.create(L,z);const U=s.get(L);return typeof U=="boolean"?W===(U?"true":"false")?k.INSTANCE:u.INSTANCE:new C(L,W,z)}constructor(L,W,z){this.c=L,this.d=W,this.f=z,this.type=p.Equals}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=s.get(this.c);if(typeof L=="boolean"){const W=L?"true":"false";return this.d===W?k.INSTANCE:u.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Ej=C;class T{static create(L,W){return new T(L,W)}constructor(L,W){this.d=L,this.f=W,this.type=p.In,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const W=L.getValue(this.f),z=L.getValue(this.d);return Array.isArray(W)?W.includes(z):typeof z=="string"&&typeof W=="object"&&W!==null?y.call(W,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=O.create(this.d,this.f)),this.c}}e.$Fj=T;class O{static create(L,W){return new O(L,W)}constructor(L,W){this.d=L,this.f=W,this.type=p.NotIn,this.c=T.create(L,W)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=O;class P{static create(L,W,z=null){if(typeof W=="boolean")return W?V.create(L,z):I.create(L,z);const U=s.get(L);return typeof U=="boolean"?W===(U?"true":"false")?u.INSTANCE:k.INSTANCE:new P(L,W,z)}constructor(L,W,z){this.c=L,this.d=W,this.f=z,this.type=p.NotEquals}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=s.get(this.c);if(typeof L=="boolean"){const W=L?"true":"false";return this.d===W?u.INSTANCE:k.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Hj=P;class V{static create(L,W=null){const z=s.get(L);return typeof z=="boolean"?z?u.INSTANCE:k.INSTANCE:new V(L,W)}constructor(L,W){this.c=L,this.d=W,this.type=p.Not}cmp(L){return L.type!==this.type?this.type-L.type:le(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=s.get(this.c);return typeof L=="boolean"?L?u.INSTANCE:k.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Ij=V;function Q(H,L){if(typeof H=="string"){const W=parseFloat(H);isNaN(W)||(H=W)}return typeof H=="string"||typeof H=="number"?L(H):u.INSTANCE}class ie{static create(L,W,z=null){return Q(W,U=>new ie(L,U,z))}constructor(L,W,z){this.c=L,this.d=W,this.f=z,this.type=p.Greater}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$Jj=ie;class re{static create(L,W,z=null){return Q(W,U=>new re(L,U,z))}constructor(L,W,z){this.c=L,this.d=W,this.f=z,this.type=p.GreaterEquals}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Kj=re;class ne{static create(L,W,z=null){return Q(W,U=>new ne(L,U,z))}constructor(L,W,z){this.c=L,this.d=W,this.f=z,this.type=p.Smaller}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Lj=ne;class se{static create(L,W,z=null){return Q(W,U=>new se(L,U,z))}constructor(L,W,z){this.c=L,this.d=W,this.f=z,this.type=p.SmallerEquals}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Mj=se;class Z{static create(L,W){return new Z(L,W)}constructor(L,W){this.d=L,this.f=W,this.type=p.Regex,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const W=this.f?this.f.source:"",z=L.f?L.f.source:"";return W<z?-1:W>z?1:0}equals(L){if(L.type===this.type){const W=this.f?this.f.source:"",z=L.f?L.f.source:"";return this.d===L.d&&W===z}return!1}substituteConstants(){return this}evaluate(L){const W=L.getValue(this.d);return this.f?this.f.test(W):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Nj=Z;class ee{static create(L){return new ee(L)}constructor(L){this.c=L,this.type=p.NotRegex}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new ee(this.c.map(L))}negate(){return this.c}}e.$Oj=ee;function ue(H){let L=null;for(let W=0,z=H.length;W<z;W++){const U=H[W].substituteConstants();if(H[W]!==U&&L===null){L=[];for(let J=0;J<W;J++)L[J]=H[J]}L!==null&&(L[W]=U)}return L===null?H:L}class j{static create(L,W,z){return j.d(L,W,z)}constructor(L,W){this.expr=L,this.c=W,this.type=p.And}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let W=0,z=this.expr.length;W<z;W++){const U=c(this.expr[W],L.expr[W]);if(U!==0)return U}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let W=0,z=this.expr.length;W<z;W++)if(!this.expr[W].equals(L.expr[W]))return!1;return!0}return!1}substituteConstants(){const L=ue(this.expr);return L===this.expr?this:j.create(L,this.c,!1)}evaluate(L){for(let W=0,z=this.expr.length;W<z;W++)if(!this.expr[W].evaluate(L))return!1;return!0}static d(L,W,z){const U=[];let J=!1;for(const x of L)if(x){if(x.type===p.True){J=!0;continue}if(x.type===p.False)return u.INSTANCE;if(x.type===p.And){U.push(...x.expr);continue}U.push(x)}if(U.length===0&&J)return k.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(c);for(let x=1;x<U.length;x++)U[x-1].equals(U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0];for(;U.length>1;){const x=U[U.length-1];if(x.type!==p.Or)break;U.pop();const M=U.pop(),G=U.length===0,te=B.create(x.expr.map(he=>j.create([he,M],null,z)),null,G);te&&(U.push(te),U.sort(c))}if(U.length===1)return U[0];if(z){for(let x=0;x<U.length;x++)for(let M=x+1;M<U.length;M++)if(U[x].negate().equals(U[M]))return u.INSTANCE;if(U.length===1)return U[0]}return new j(U,W)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const W of this.expr)L.push(...W.keys());return L}map(L){return new j(this.expr.map(W=>W.map(L)),null)}negate(){if(!this.c){const L=[];for(const W of this.expr)L.push(W.negate());this.c=B.create(L,this,!0)}return this.c}}e.$Pj=j;class B{static create(L,W,z){return B.d(L,W,z)}constructor(L,W){this.expr=L,this.c=W,this.type=p.Or}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let W=0,z=this.expr.length;W<z;W++){const U=c(this.expr[W],L.expr[W]);if(U!==0)return U}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let W=0,z=this.expr.length;W<z;W++)if(!this.expr[W].equals(L.expr[W]))return!1;return!0}return!1}substituteConstants(){const L=ue(this.expr);return L===this.expr?this:B.create(L,this.c,!1)}evaluate(L){for(let W=0,z=this.expr.length;W<z;W++)if(this.expr[W].evaluate(L))return!0;return!1}static d(L,W,z){let U=[],J=!1;if(L){for(let x=0,M=L.length;x<M;x++){const G=L[x];if(G){if(G.type===p.False){J=!0;continue}if(G.type===p.True)return k.INSTANCE;if(G.type===p.Or){U=U.concat(G.expr);continue}U.push(G)}}if(U.length===0&&J)return u.INSTANCE;U.sort(c)}if(U.length!==0){if(U.length===1)return U[0];for(let x=1;x<U.length;x++)U[x-1].equals(U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0];if(z){for(let x=0;x<U.length;x++)for(let M=x+1;M<U.length;M++)if(U[x].negate().equals(U[M]))return k.INSTANCE;if(U.length===1)return U[0]}return new B(U,W)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const W of this.expr)L.push(...W.keys());return L}map(L){return new B(this.expr.map(W=>W.map(L)),null)}negate(){if(!this.c){const L=[];for(const W of this.expr)L.push(W.negate());for(;L.length>1;){const W=L.shift(),z=L.shift(),U=[];for(const J of Y(W))for(const x of Y(z))U.push(j.create([J,x],null,!1));L.unshift(B.create(U,null,!1))}this.c=B.create(L,this,!0)}return this.c}}e.$Qj=B;class oe extends I{static{this.d=[]}static all(){return oe.d.values()}constructor(L,W,z){super(L,null),this.f=W,typeof z=="object"?oe.d.push({...z,key:L}):z!==!0&&oe.d.push({key:L,description:z,type:W!=null?typeof W:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return C.create(this.key,L)}notEqualsTo(L){return P.create(this.key,L)}}e.$Rj=oe,e.$Sj=(0,A.$Ai)("contextKeyService");function le(H,L){return H<L?-1:H>L?1:0}function pe(H,L,W,z){return H<W?-1:H>W?1:L<z?-1:L>z?1:0}function q(H,L){if(H.type===p.False||L.type===p.True)return!0;if(H.type===p.Or)return L.type===p.Or?ae(H.expr,L.expr):!1;if(L.type===p.Or){for(const W of L.expr)if(q(H,W))return!0;return!1}if(H.type===p.And){if(L.type===p.And)return ae(L.expr,H.expr);for(const W of H.expr)if(q(W,L))return!0;return!1}return H.equals(L)}function ae(H,L){let W=0,z=0;for(;W<H.length&&z<L.length;){const U=H[W].cmp(L[z]);if(U<0)return!1;U===0&&W++,z++}return W===H.length}function Y(H){return H.type===p.Or?H.expr:[H]}}),define(Ee[247],Se([1,0,43,5]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=e.$pu=e.AccessibilitySupport=e.$ou=void 0,e.$qu=D,e.$ou=(0,r.$Ai)("accessibilityService");var S;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(S||(e.AccessibilitySupport=S={})),e.$pu=new n.$Rj("accessibilityModeEnabled",!1);function D(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$ru="ACCESSIBLE_VIEW_SHOWN_"}),define(Ee[248],Se([1,0,18,21,3,169,109,179,180,198,247]),function(fe,e,n,r,S,D,A,R,v,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=l,e.clampedFloat=o,e.stringSet=c,e.cursorStyleToString=Q,e.filterValidationDecorations=me;var y;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class p{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=p;class b{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=b;class a{constructor(_,we,ze,Ge){this.id=_,this.name=we,this.defaultValue=ze,this.schema=Ge}applyUpdate(_,we){return h(_,we)}compute(_,we,ze){return ze}}class f{constructor(_,we){this.newValue=_,this.didChange=we}}e.ApplyUpdateResult=f;function h(X,_){if(typeof X!="object"||typeof _!="object"||!X||!_)return new f(_,X!==_);if(Array.isArray(X)||Array.isArray(_)){const ze=Array.isArray(X)&&Array.isArray(_)&&n.$ub(X,_);return new f(_,!ze)}let we=!1;for(const ze in _)if(_.hasOwnProperty(ze)){const Ge=h(X[ze],_[ze]);Ge.didChange&&(X[ze]=Ge.newValue,we=!0)}return new f(X,we)}class g{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,we){return h(_,we)}validate(_){return this.defaultValue}}class w{constructor(_,we,ze,Ge){this.id=_,this.name=we,this.defaultValue=ze,this.schema=Ge}applyUpdate(_,we){return h(_,we)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,we,ze){return ze}}function m(X,_){return typeof X>"u"?_:X==="false"?!1:!!X}class $ extends w{constructor(_,we,ze,Ge=void 0){typeof Ge<"u"&&(Ge.type="boolean",Ge.default=ze),super(_,we,ze,Ge)}validate(_){return m(_,this.defaultValue)}}function l(X,_,we,ze){if(typeof X>"u")return _;let Ge=parseInt(X,10);return isNaN(Ge)?_:(Ge=Math.max(we,Ge),Ge=Math.min(ze,Ge),Ge|0)}class t extends w{static clampedInt(_,we,ze,Ge){return l(_,we,ze,Ge)}constructor(_,we,ze,Ge,Ye,et=void 0){typeof et<"u"&&(et.type="integer",et.default=ze,et.minimum=Ge,et.maximum=Ye),super(_,we,ze,et),this.minimum=Ge,this.maximum=Ye}validate(_){return t.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function o(X,_,we,ze){if(typeof X>"u")return _;const Ge=d.float(X,_);return d.clamp(Ge,we,ze)}class d extends w{static clamp(_,we,ze){return _<we?we:_>ze?ze:_}static float(_,we){if(typeof _=="number")return _;if(typeof _>"u")return we;const ze=parseFloat(_);return isNaN(ze)?we:ze}constructor(_,we,ze,Ge,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=ze),super(_,we,ze,Ye),this.validationFn=Ge}validate(_){return this.validationFn(d.float(_,this.defaultValue))}}class i extends w{static string(_,we){return typeof _!="string"?we:_}constructor(_,we,ze,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.default=ze),super(_,we,ze,Ge)}validate(_){return i.string(_,this.defaultValue)}}function c(X,_,we,ze){return typeof X!="string"?_:ze&&X in ze?ze[X]:we.indexOf(X)===-1?_:X}class u extends w{constructor(_,we,ze,Ge,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=Ge,Ye.default=ze),super(_,we,ze,Ye),this.c=Ge}validate(_){return c(_,this.defaultValue,this.c)}}class k extends a{constructor(_,we,ze,Ge,Ye,et,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=Ye,lt.default=Ge),super(_,we,ze,lt),this.c=Ye,this.d=et}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function I(X){switch(X){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class C extends a{constructor(){super(ye.accessibilitySupport,"accessibilitySupport",E.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",tags:["accessibility"],description:s.localize(3,null)})}validate(_){switch(_){case"auto":return E.AccessibilitySupport.Unknown;case"off":return E.AccessibilitySupport.Disabled;case"on":return E.AccessibilitySupport.Enabled}return this.defaultValue}compute(_,we,ze){return ze===E.AccessibilitySupport.Unknown?_.accessibilitySupport:ze}}class T extends a{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(ye.comments,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:s.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{insertSpace:m(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var O;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(O||(e.TextEditorCursorBlinkingStyle=O={}));function P(X){switch(X){case"blink":return O.Blink;case"smooth":return O.Smooth;case"phase":return O.Phase;case"expand":return O.Expand;case"solid":return O.Solid}}var V;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(V||(e.TextEditorCursorStyle=V={}));function Q(X){switch(X){case V.Line:return"line";case V.Block:return"block";case V.Underline:return"underline";case V.LineThin:return"line-thin";case V.BlockOutline:return"block-outline";case V.UnderlineThin:return"underline-thin"}}function ie(X){switch(X){case"line":return V.Line;case"block":return V.Block;case"underline":return V.Underline;case"line-thin":return V.LineThin;case"block-outline":return V.BlockOutline;case"underline-thin":return V.UnderlineThin}}class re extends g{constructor(){super(ye.editorClassName)}compute(_,we,ze){const Ge=["monaco-editor"];return we.get(ye.extraEditorClassName)&&Ge.push(we.get(ye.extraEditorClassName)),_.extraEditorClassName&&Ge.push(_.extraEditorClassName),we.get(ye.mouseStyle)==="default"?Ge.push("mouse-default"):we.get(ye.mouseStyle)==="copy"&&Ge.push("mouse-copy"),we.get(ye.showUnused)&&Ge.push("showUnused"),we.get(ye.showDeprecated)&&Ge.push("showDeprecated"),Ge.join(" ")}}class ne extends ${constructor(){super(ye.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(_,we,ze){return ze&&_.emptySelectionClipboard}}class se extends a{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(ye.find,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:s.localize(16,null),included:S.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:s.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{cursorMoveOnType:m(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":c(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":c(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(we.loop,this.defaultValue.loop)}}}class Z extends a{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(ye.fontLigatures,"fontLigatures",Z.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?Z.OFF:_==="true"?Z.ON:_:_?Z.ON:Z.OFF}}e.EditorFontLigatures=Z;class ee extends a{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(ye.fontVariations,"fontVariations",ee.OFF,{anyOf:[{type:"boolean",description:s.localize(22,null)},{type:"string",description:s.localize(23,null)}],description:s.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?ee.OFF:_==="true"?ee.TRANSLATE:_:_?ee.TRANSLATE:ee.OFF}compute(_,we,ze){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=ee;class ue extends g{constructor(){super(ye.fontInfo)}compute(_,we,ze){return _.fontInfo}}class j extends w{constructor(){super(ye.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(25,null)})}validate(_){const we=d.float(_,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(we,6,100)}compute(_,we,ze){return _.fontInfo.fontSize}}class B extends a{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(ye.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:s.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(t.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}class oe extends a{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[s.localize(28,null),s.localize(29,null),s.localize(30,null)]},ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(ye.gotoLocation,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(32,null),...we},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(33,null),...we},"editor.gotoLocation.multipleDeclarations":{description:s.localize(34,null),...we},"editor.gotoLocation.multipleImplementations":{description:s.localize(35,null),...we},"editor.gotoLocation.multipleReferences":{description:s.localize(36,null),...we},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:ze,description:s.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:ze,description:s.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:ze,description:s.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:ze,description:s.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:ze,description:s.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{multiple:c(we.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:we.multipleDefinitions??c(we.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:we.multipleTypeDefinitions??c(we.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:we.multipleDeclarations??c(we.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:we.multipleImplementations??c(we.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:we.multipleReferences??c(we.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(we.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(we.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(we.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(we.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(we.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends a{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(ye.hover,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:s.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:s.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:s.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:s.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:s.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{enabled:m(we.enabled,this.defaultValue.enabled),delay:t.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:m(we.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(we.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(we.above,this.defaultValue.above)}}}var pe;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(pe||(e.RenderMinimap=pe={}));class q extends g{constructor(){super(ye.layoutInfo)}compute(_,we,ze){return q.computeLayout(we,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const we=_.height/_.lineHeight,ze=Math.floor(_.paddingTop/_.lineHeight);let Ge=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Ge=Math.max(Ge,we-1));const Ye=(ze+_.viewLineCount+Ge)/(_.pixelRatio*_.height),et=Math.floor(_.viewLineCount/Ye);return{typicalViewportLineCount:we,extraLinesBeforeFirstLine:ze,extraLinesBeyondLastLine:Ge,desiredRatio:Ye,minimapLineCount:et}}static c(_,we){const ze=_.outerWidth,Ge=_.outerHeight,Ye=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:pe.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const et=we.stableMinimapLayoutInput,lt=et&&_.outerHeight===et.outerHeight&&_.lineHeight===et.lineHeight&&_.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&_.pixelRatio===et.pixelRatio&&_.scrollBeyondLastLine===et.scrollBeyondLastLine&&_.paddingTop===et.paddingTop&&_.paddingBottom===et.paddingBottom&&_.minimap.enabled===et.minimap.enabled&&_.minimap.side===et.minimap.side&&_.minimap.size===et.minimap.size&&_.minimap.showSlider===et.minimap.showSlider&&_.minimap.renderCharacters===et.minimap.renderCharacters&&_.minimap.maxColumn===et.minimap.maxColumn&&_.minimap.scale===et.minimap.scale&&_.verticalScrollbarWidth===et.verticalScrollbarWidth&&_.isViewportWrapping===et.isViewportWrapping,ut=_.lineHeight,dt=_.typicalHalfwidthCharacterWidth,Ct=_.scrollBeyondLastLine,Dt=_.minimap.renderCharacters;let ht=Ye>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const mt=_.minimap.maxColumn,pt=_.minimap.size,Ft=_.minimap.side,yt=_.verticalScrollbarWidth,jt=_.viewLineCount,Tt=_.remainingWidth,ct=_.isViewportWrapping,$t=Dt?2:3;let bt=Math.floor(Ye*Ge);const Et=bt/Ye;let It=!1,Vt=!1,Ot=$t*ht,Pt=ht/Ye,Bt=1;if(pt==="fill"||pt==="fit"){const{typicalViewportLineCount:Kt,extraLinesBeforeFirstLine:Ht,extraLinesBeyondLastLine:Xt,desiredRatio:Jt,minimapLineCount:At}=q.computeContainedMinimapLineCount({viewLineCount:jt,scrollBeyondLastLine:Ct,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Ge,lineHeight:ut,pixelRatio:Ye});if(jt/At>1)It=!0,Vt=!0,ht=1,Ot=1,Pt=ht/Ye;else{let gt=!1,Mt=ht+1;if(pt==="fit"){const qt=Math.ceil((Ht+jt+Xt)*Ot);ct&&lt&&Tt<=we.stableFitRemainingWidth?(gt=!0,Mt=we.stableFitMaxMinimapScale):gt=qt>bt}if(pt==="fill"||gt){It=!0;const qt=ht;Ot=Math.min(ut*Ye,Math.max(1,Math.floor(1/Jt))),ct&&lt&&Tt<=we.stableFitRemainingWidth&&(Mt=we.stableFitMaxMinimapScale),ht=Math.min(Mt,Math.max(1,Math.floor(Ot/$t))),ht>qt&&(Bt=Math.min(2,ht/qt)),Pt=ht/Ye/Bt,bt=Math.ceil(Math.max(Kt,Ht+jt+Xt)*Ot),ct?(we.stableMinimapLayoutInput=_,we.stableFitRemainingWidth=Tt,we.stableFitMaxMinimapScale=ht):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0)}}}const Gt=Math.floor(mt*Pt),wt=Math.min(Gt,Math.max(0,Math.floor((Tt-yt-2)*Pt/(dt+Pt)))+e.MINIMAP_GUTTER_WIDTH);let St=Math.floor(Ye*wt);const Lt=St/Ye;St=Math.floor(St*Bt);const Zt=Dt?pe.Text:pe.Blocks,Nt=Ft==="left"?0:ze-wt-yt;return{renderMinimap:Zt,minimapLeft:Nt,minimapWidth:wt,minimapHeightIsEditorHeight:It,minimapIsSampling:Vt,minimapScale:ht,minimapLineHeight:Ot,minimapCanvasInnerWidth:St,minimapCanvasInnerHeight:bt,minimapCanvasOuterWidth:Lt,minimapCanvasOuterHeight:Et}}static computeLayout(_,we){const ze=we.outerWidth|0,Ge=we.outerHeight|0,Ye=we.lineHeight|0,et=we.lineNumbersDigitCount|0,lt=we.typicalHalfwidthCharacterWidth,ut=we.maxDigitWidth,dt=we.pixelRatio,Ct=we.viewLineCount,Dt=_.get(ye.wordWrapOverride2),ht=Dt==="inherit"?_.get(ye.wordWrapOverride1):Dt,mt=ht==="inherit"?_.get(ye.wordWrap):ht,pt=_.get(ye.wordWrapColumn),Ft=we.isDominatedByLongLines,yt=_.get(ye.glyphMargin),jt=_.get(ye.lineNumbers).renderType!==ke.Off,Tt=_.get(ye.lineNumbersMinChars),ct=_.get(ye.scrollBeyondLastLine),$t=_.get(ye.padding),bt=_.get(ye.minimap),Et=_.get(ye.scrollbar),It=Et.verticalScrollbarSize,Vt=Et.verticalHasArrows,Ot=Et.arrowSize,Pt=Et.horizontalScrollbarSize,Bt=_.get(ye.folding),Gt=_.get(ye.showFoldingControls)!=="never";let wt=_.get(ye.lineDecorationsWidth);Bt&&Gt&&(wt+=16);let St=0;if(jt){const cn=Math.max(et,Tt);St=Math.round(cn*ut)}let Lt=0;yt&&(Lt=Ye*we.glyphMarginDecorationLaneCount);let Zt=0,Nt=Zt+Lt,Kt=Nt+St,Ht=Kt+wt;const Xt=ze-Lt-St-wt;let Jt=!1,At=!1,Rt=-1;ht==="inherit"&&Ft?(Jt=!0,At=!0):mt==="on"||mt==="bounded"?At=!0:mt==="wordWrapColumn"&&(Rt=pt);const gt=q.c({outerWidth:ze,outerHeight:Ge,lineHeight:Ye,typicalHalfwidthCharacterWidth:lt,pixelRatio:dt,scrollBeyondLastLine:ct,paddingTop:$t.top,paddingBottom:$t.bottom,minimap:bt,verticalScrollbarWidth:It,viewLineCount:Ct,remainingWidth:Xt,isViewportWrapping:At},we.memory||new b);gt.renderMinimap!==pe.None&&gt.minimapLeft===0&&(Zt+=gt.minimapWidth,Nt+=gt.minimapWidth,Kt+=gt.minimapWidth,Ht+=gt.minimapWidth);const Mt=Xt-gt.minimapWidth,qt=Math.max(1,Math.floor((Mt-It-2)/lt)),nn=Vt?Ot:0;return At&&(Rt=Math.max(1,qt),mt==="bounded"&&(Rt=Math.min(Rt,pt))),{width:ze,height:Ge,glyphMarginLeft:Zt,glyphMarginWidth:Lt,glyphMarginDecorationLaneCount:we.glyphMarginDecorationLaneCount,lineNumbersLeft:Nt,lineNumbersWidth:St,decorationsLeft:Kt,decorationsWidth:wt,contentLeft:Ht,contentWidth:Mt,minimap:gt,viewportColumn:qt,isWordWrapMinified:Jt,isViewportWrapping:At,wrappingColumn:Rt,verticalScrollbarWidth:It,horizontalScrollbarHeight:Pt,overviewRuler:{top:nn,width:It,height:Ge-2*nn,right:0}}}}e.EditorLayoutInfoComputer=q;class ae extends a{constructor(){super(ye.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(47,null),s.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(49,null)}})}validate(_){return c(_,"simple",["simple","advanced"])}compute(_,we,ze){return we.get(ye.accessibilitySupport)===E.AccessibilitySupport.Enabled?"advanced":ze}}var Y;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(Y||(e.ShowLightbulbIconMode=Y={}));class H extends a{constructor(){const _={enabled:Y.On};super(ye.lightbulb,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Y.Off,Y.OnCode,Y.On],default:_.enabled,enumDescriptions:[s.localize(50,null),s.localize(51,null),s.localize(52,null)],description:s.localize(53,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:c(_.enabled,this.defaultValue.enabled,[Y.Off,Y.OnCode,Y.On])}}}class L extends a{constructor(){const _={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(ye.stickyScroll,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:s.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:20,description:s.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:s.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:s.localize(57,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{enabled:m(we.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(we.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:c(we.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(we.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class W extends a{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(ye.inlayHints,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:s.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(59,null),s.localize(60,null,S.$j?"Ctrl+Option":"Ctrl+Alt"),s.localize(61,null,S.$j?"Ctrl+Option":"Ctrl+Alt"),s.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:s.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:s.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:s.localize(65,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return typeof we.enabled=="boolean"&&(we.enabled=we.enabled?"on":"off"),{enabled:c(we.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(we.fontFamily,this.defaultValue.fontFamily),padding:m(we.padding,this.defaultValue.padding)}}}class z extends a{constructor(){super(ye.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):t.clampedInt(_,this.defaultValue,0,1e3)}compute(_,we,ze){return ze<0?t.clampedInt(-ze*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):ze}}class U extends d{constructor(){super(ye.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>d.clamp(_,0,150),{markdownDescription:s.localize(66,null)})}compute(_,we,ze){return _.fontInfo.lineHeight}}class J extends a{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(ye.minimap,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:s.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:s.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(69,null),s.localize(70,null),s.localize(71,null)],default:_.size,description:s.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:s.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:s.localize(74,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:s.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:s.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:_.showRegionSectionHeaders,description:s.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:_.showMarkSectionHeaders,description:s.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:_.sectionHeaderFontSize,description:s.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:_.sectionHeaderLetterSpacing,description:s.localize(81,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{enabled:m(we.enabled,this.defaultValue.enabled),autohide:m(we.autohide,this.defaultValue.autohide),size:c(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:c(we.side,this.defaultValue.side,["right","left"]),showSlider:c(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(we.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(we.scale,1,1,3),maxColumn:t.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:m(we.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:m(we.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(we.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(we.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function x(X){return X==="ctrlCmd"?S.$j?"metaKey":"ctrlKey":"altKey"}class M extends a{constructor(){super(ye.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(83,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{top:t.clampedInt(we.top,0,0,1e3),bottom:t.clampedInt(we.bottom,0,0,1e3)}}}class G extends a{constructor(){const _={enabled:!0,cycle:!0};super(ye.parameterHints,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:s.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:s.localize(85,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{enabled:m(we.enabled,this.defaultValue.enabled),cycle:m(we.cycle,this.defaultValue.cycle)}}}class te extends g{constructor(){super(ye.pixelRatio)}compute(_,we,ze){return _.pixelRatio}}class he extends a{constructor(){const _={other:"on",comments:"off",strings:"off"},we=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(86,null),s.localize(87,null),s.localize(88,null)]}];super(ye.quickSuggestions,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:we,default:_.strings,description:s.localize(89,null)},comments:{anyOf:we,default:_.comments,description:s.localize(90,null)},other:{anyOf:we,default:_.other,description:s.localize(91,null)}},default:_,markdownDescription:s.localize(92,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const dt=_?"on":"off";return{comments:dt,strings:dt,other:dt}}if(!_||typeof _!="object")return this.defaultValue;const{other:we,comments:ze,strings:Ge}=_,Ye=["on","inline","off"];let et,lt,ut;return typeof we=="boolean"?et=we?"on":"off":et=c(we,this.defaultValue.other,Ye),typeof ze=="boolean"?lt=ze?"on":"off":lt=c(ze,this.defaultValue.comments,Ye),typeof Ge=="boolean"?ut=Ge?"on":"off":ut=c(Ge,this.defaultValue.strings,Ye),{other:et,comments:lt,strings:ut}}}var ke;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ke||(e.RenderLineNumbersType=ke={}));class Ne extends a{constructor(){super(ye.lineNumbers,"lineNumbers",{renderType:ke.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(93,null),s.localize(94,null),s.localize(95,null),s.localize(96,null)],default:"on",description:s.localize(97,null)})}validate(_){let we=this.defaultValue.renderType,ze=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(we=ke.Custom,ze=_):_==="interval"?we=ke.Interval:_==="relative"?we=ke.Relative:_==="on"?we=ke.On:we=ke.Off),{renderType:we,renderFn:ze}}}function me(X){const _=X.get(ye.renderValidationDecorations);return _==="editable"?X.get(ye.readOnly):_!=="on"}class be extends a{constructor(){const _=[],we={type:"number",description:s.localize(98,null)};super(ye.rulers,"rulers",_,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:s.localize(99,null),format:"color-hex"}}}]},default:_,description:s.localize(100,null)})}validate(_){if(Array.isArray(_)){const we=[];for(const ze of _)if(typeof ze=="number")we.push({column:t.clampedInt(ze,0,0,1e4),color:null});else if(ze&&typeof ze=="object"){const Ge=ze;we.push({column:t.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return we.sort((ze,Ge)=>ze.column-Ge.column),we}return this.defaultValue}}class Ae extends a{constructor(){super(ye.readOnlyMessage,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function Le(X,_){if(typeof X!="string")return _;switch(X){case"hidden":return D.ScrollbarVisibility.Hidden;case"visible":return D.ScrollbarVisibility.Visible;default:return D.ScrollbarVisibility.Auto}}class de extends a{constructor(){const _={vertical:D.ScrollbarVisibility.Auto,horizontal:D.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(ye.scrollbar,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(101,null),s.localize(102,null),s.localize(103,null)],default:"auto",description:s.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(105,null),s.localize(106,null),s.localize(107,null)],default:"auto",description:s.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:s.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:s.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:s.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:s.localize(112,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_,ze=t.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=t.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Le(we.vertical,this.defaultValue.vertical),horizontal:Le(we.horizontal,this.defaultValue.horizontal),useShadows:m(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ze,horizontalSliderSize:t.clampedInt(we.horizontalSliderSize,ze,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:t.clampedInt(we.verticalSliderSize,Ge,0,1e3),scrollByPage:m(we.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(we.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Ie extends a{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(ye.unicodeHighlighting,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:s.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:s.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:s.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:s.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:s.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:s.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:s.localize(119,null)}})}applyUpdate(_,we){let ze=!1;we.allowedCharacters&&_&&(r.$ao(_.allowedCharacters,we.allowedCharacters)||(_={..._,allowedCharacters:we.allowedCharacters},ze=!0)),we.allowedLocales&&_&&(r.$ao(_.allowedLocales,we.allowedLocales)||(_={..._,allowedLocales:we.allowedLocales},ze=!0));const Ge=super.applyUpdate(_,we);return ze?new f(Ge.newValue,!0):Ge}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{nonBasicASCII:We(we.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(we.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(we.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:We(we.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:We(we.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,we){if(typeof _!="object"||!_)return we;const ze={};for(const[Ge,Ye]of Object.entries(_))Ye===!0&&(ze[Ge]=!0);return ze}}class Re extends a{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(ye.inlineSuggest,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:s.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(121,null),s.localize(122,null),s.localize(123,null)],description:s.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:s.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:_.fontFamily,description:s.localize(126,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{enabled:m(we.enabled,this.defaultValue.enabled),mode:c(we.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:c(we.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(we.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(we.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string(we.fontFamily,this.defaultValue.fontFamily)}}}class Me extends a{constructor(){const _={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(ye.inlineEdit,"experimentalInlineEdit",_,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:_.enabled,description:s.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(128,null),s.localize(129,null),s.localize(130,null)],description:s.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:_.fontFamily,description:s.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:_.backgroundColoring,description:s.localize(133,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{enabled:m(we.enabled,this.defaultValue.enabled),showToolbar:c(we.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string(we.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(we.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(we.backgroundColoring,this.defaultValue.backgroundColoring)}}}class He extends a{constructor(){const _={enabled:R.$nu.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$nu.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(ye.bracketPairColorization,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:s.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:s.localize(135,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{enabled:m(we.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(we.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ke extends a{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(ye.guides,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(136,null),s.localize(137,null),s.localize(138,null)],default:_.bracketPairs,description:s.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(140,null),s.localize(141,null),s.localize(142,null)],default:_.bracketPairsHorizontal,description:s.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:s.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:s.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(146,null),s.localize(147,null),s.localize(148,null)],default:_.highlightActiveIndentation,description:s.localize(149,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{bracketPairs:We(we.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:We(we.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(we.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(we.indentation,this.defaultValue.indentation),highlightActiveIndentation:We(we.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function We(X,_,we){const ze=we.indexOf(X);return ze===-1?_:we[ze]}class Ve extends a{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(ye.suggest,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(150,null),s.localize(151,null)],default:_.insertMode,description:s.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:s.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:s.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:s.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(156,null),s.localize(157,null),s.localize(158,null),s.localize(159,null)],default:_.selectionMode,markdownDescription:s.localize(160,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:s.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:s.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:s.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:s.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:s.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(197,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{insertMode:c(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:c(we.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(we.showIcons,this.defaultValue.showIcons),showStatusBar:m(we.showStatusBar,this.defaultValue.showStatusBar),preview:m(we.preview,this.defaultValue.preview),previewMode:c(we.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(we.showMethods,this.defaultValue.showMethods),showFunctions:m(we.showFunctions,this.defaultValue.showFunctions),showConstructors:m(we.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(we.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(we.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(we.showFields,this.defaultValue.showFields),showVariables:m(we.showVariables,this.defaultValue.showVariables),showClasses:m(we.showClasses,this.defaultValue.showClasses),showStructs:m(we.showStructs,this.defaultValue.showStructs),showInterfaces:m(we.showInterfaces,this.defaultValue.showInterfaces),showModules:m(we.showModules,this.defaultValue.showModules),showProperties:m(we.showProperties,this.defaultValue.showProperties),showEvents:m(we.showEvents,this.defaultValue.showEvents),showOperators:m(we.showOperators,this.defaultValue.showOperators),showUnits:m(we.showUnits,this.defaultValue.showUnits),showValues:m(we.showValues,this.defaultValue.showValues),showConstants:m(we.showConstants,this.defaultValue.showConstants),showEnums:m(we.showEnums,this.defaultValue.showEnums),showEnumMembers:m(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(we.showKeywords,this.defaultValue.showKeywords),showWords:m(we.showWords,this.defaultValue.showWords),showColors:m(we.showColors,this.defaultValue.showColors),showFiles:m(we.showFiles,this.defaultValue.showFiles),showReferences:m(we.showReferences,this.defaultValue.showReferences),showFolders:m(we.showFolders,this.defaultValue.showFolders),showTypeParameters:m(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(we.showSnippets,this.defaultValue.showSnippets),showUsers:m(we.showUsers,this.defaultValue.showUsers),showIssues:m(we.showIssues,this.defaultValue.showIssues)}}}class Ze extends a{constructor(){super(ye.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(199,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(_.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends a{constructor(){const _=[];super(ye.wordSegmenterLocales,"wordSegmenterLocales",_,{anyOf:[{description:s.localize(200,null),type:"string"},{description:s.localize(201,null),type:"array",items:{type:"string"}}]})}validate(_){if(typeof _=="string"&&(_=[_]),Array.isArray(_)){const we=[];for(const ze of _)if(typeof ze=="string")try{Intl.Segmenter.supportedLocalesOf(ze).length>0&&we.push(ze)}catch{}return we}return this.defaultValue}}var it;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(it||(e.WrappingIndent=it={}));class ot extends a{constructor(){super(ye.wrappingIndent,"wrappingIndent",it.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(202,null),s.localize(203,null),s.localize(204,null),s.localize(205,null)],description:s.localize(206,null),default:"same"}})}validate(_){switch(_){case"none":return it.None;case"same":return it.Same;case"indent":return it.Indent;case"deepIndent":return it.DeepIndent}return it.Same}compute(_,we,ze){return we.get(ye.accessibilitySupport)===E.AccessibilitySupport.Enabled?it.None:ze}}class tt extends g{constructor(){super(ye.wrappingInfo)}compute(_,we,ze){const Ge=we.get(ye.layoutInfo);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}class _e extends a{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(ye.dropIntoEditor,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:s.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(209,null),s.localize(210,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{enabled:m(we.enabled,this.defaultValue.enabled),showDropSelector:c(we.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends a{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(ye.pasteAs,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:s.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(213,null),s.localize(214,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const we=_;return{enabled:m(we.enabled,this.defaultValue.enabled),showPasteSelector:c(we.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Qe="Consolas, 'Courier New', monospace",$e="Menlo, Monaco, 'Courier New', monospace",Oe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:S.$j?$e:S.$k?Oe:Qe,fontWeight:"normal",fontSize:S.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ve(X){return e.editorOptionsRegistry[X.id]=X,X}var ye;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSegmenterLocales=130]="wordSegmenterLocales",X[X.wordSeparators=131]="wordSeparators",X[X.wordWrap=132]="wordWrap",X[X.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=135]="wordWrapColumn",X[X.wordWrapOverride1=136]="wordWrapOverride1",X[X.wordWrapOverride2=137]="wordWrapOverride2",X[X.wrappingIndent=138]="wrappingIndent",X[X.wrappingStrategy=139]="wrappingStrategy",X[X.showDeprecated=140]="showDeprecated",X[X.inlayHints=141]="inlayHints",X[X.editorClassName=142]="editorClassName",X[X.pixelRatio=143]="pixelRatio",X[X.tabFocusMode=144]="tabFocusMode",X[X.layoutInfo=145]="layoutInfo",X[X.wrappingInfo=146]="wrappingInfo",X[X.defaultColorDecorators=147]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(ye||(e.EditorOption=ye={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new $(ye.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(215,null)})),acceptSuggestionOnEnter:ve(new u(ye.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(216,null),""],markdownDescription:s.localize(217,null)})),accessibilitySupport:ve(new C),accessibilityPageSize:ve(new t(ye.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(218,null),tags:["accessibility"]})),ariaLabel:ve(new i(ye.ariaLabel,"ariaLabel",s.localize(219,null))),ariaRequired:ve(new $(ye.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ve(new $(ye.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:ve(new u(ye.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(221,null),s.localize(222,null),""],description:s.localize(223,null)})),autoClosingComments:ve(new u(ye.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(224,null),s.localize(225,null),""],description:s.localize(226,null)})),autoClosingDelete:ve(new u(ye.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(227,null),""],description:s.localize(228,null)})),autoClosingOvertype:ve(new u(ye.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(229,null),""],description:s.localize(230,null)})),autoClosingQuotes:ve(new u(ye.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(231,null),s.localize(232,null),""],description:s.localize(233,null)})),autoIndent:ve(new k(ye.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],I,{enumDescriptions:[s.localize(234,null),s.localize(235,null),s.localize(236,null),s.localize(237,null),s.localize(238,null)],description:s.localize(239,null)})),automaticLayout:ve(new $(ye.automaticLayout,"automaticLayout",!1)),autoSurround:ve(new u(ye.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(240,null),s.localize(241,null),s.localize(242,null),""],description:s.localize(243,null)})),bracketPairColorization:ve(new He),bracketPairGuides:ve(new Ke),stickyTabStops:ve(new $(ye.stickyTabStops,"stickyTabStops",!1,{description:s.localize(244,null)})),codeLens:ve(new $(ye.codeLens,"codeLens",!0,{description:s.localize(245,null)})),codeLensFontFamily:ve(new i(ye.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(246,null)})),codeLensFontSize:ve(new t(ye.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(247,null)})),colorDecorators:ve(new $(ye.colorDecorators,"colorDecorators",!0,{description:s.localize(248,null)})),colorDecoratorActivatedOn:ve(new u(ye.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(249,null),s.localize(250,null),s.localize(251,null)],description:s.localize(252,null)})),colorDecoratorsLimit:ve(new t(ye.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(253,null)})),columnSelection:ve(new $(ye.columnSelection,"columnSelection",!1,{description:s.localize(254,null)})),comments:ve(new T),contextmenu:ve(new $(ye.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new $(ye.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(255,null)})),cursorBlinking:ve(new k(ye.cursorBlinking,"cursorBlinking",O.Blink,"blink",["blink","smooth","phase","expand","solid"],P,{description:s.localize(256,null)})),cursorSmoothCaretAnimation:ve(new u(ye.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(257,null),s.localize(258,null),s.localize(259,null)],description:s.localize(260,null)})),cursorStyle:ve(new k(ye.cursorStyle,"cursorStyle",V.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],ie,{description:s.localize(261,null)})),cursorSurroundingLines:ve(new t(ye.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(262,null)})),cursorSurroundingLinesStyle:ve(new u(ye.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(263,null),s.localize(264,null)],markdownDescription:s.localize(265,null)})),cursorWidth:ve(new t(ye.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(266,null)})),disableLayerHinting:ve(new $(ye.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new $(ye.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new $(ye.domReadOnly,"domReadOnly",!1)),dragAndDrop:ve(new $(ye.dragAndDrop,"dragAndDrop",!0,{description:s.localize(267,null)})),emptySelectionClipboard:ve(new ne),dropIntoEditor:ve(new _e),stickyScroll:ve(new L),experimentalWhitespaceRendering:ve(new u(ye.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(268,null),s.localize(269,null),s.localize(270,null)],description:s.localize(271,null)})),extraEditorClassName:ve(new i(ye.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:ve(new d(ye.fastScrollSensitivity,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:s.localize(272,null)})),find:ve(new se),fixedOverflowWidgets:ve(new $(ye.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:ve(new $(ye.folding,"folding",!0,{description:s.localize(273,null)})),foldingStrategy:ve(new u(ye.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(274,null),s.localize(275,null)],description:s.localize(276,null)})),foldingHighlight:ve(new $(ye.foldingHighlight,"foldingHighlight",!0,{description:s.localize(277,null)})),foldingImportsByDefault:ve(new $(ye.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(278,null)})),foldingMaximumRegions:ve(new t(ye.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(279,null)})),unfoldOnClickAfterEndOfLine:ve(new $(ye.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(280,null)})),fontFamily:ve(new i(ye.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(281,null)})),fontInfo:ve(new ue),fontLigatures2:ve(new Z),fontSize:ve(new j),fontWeight:ve(new B),fontVariations:ve(new ee),formatOnPaste:ve(new $(ye.formatOnPaste,"formatOnPaste",!1,{description:s.localize(282,null)})),formatOnType:ve(new $(ye.formatOnType,"formatOnType",!1,{description:s.localize(283,null)})),glyphMargin:ve(new $(ye.glyphMargin,"glyphMargin",!0,{description:s.localize(284,null)})),gotoLocation:ve(new oe),hideCursorInOverviewRuler:ve(new $(ye.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(285,null)})),hover:ve(new le),inDiffEditor:ve(new $(ye.inDiffEditor,"inDiffEditor",!1)),letterSpacing:ve(new d(ye.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>d.clamp(X,-5,20),{description:s.localize(286,null)})),lightbulb:ve(new H),lineDecorationsWidth:ve(new z),lineHeight:ve(new U),lineNumbers:ve(new Ne),lineNumbersMinChars:ve(new t(ye.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new $(ye.linkedEditing,"linkedEditing",!1,{description:s.localize(287,null)})),links:ve(new $(ye.links,"links",!0,{description:s.localize(288,null)})),matchBrackets:ve(new u(ye.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(289,null)})),minimap:ve(new J),mouseStyle:ve(new u(ye.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new d(ye.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:s.localize(290,null)})),mouseWheelZoom:ve(new $(ye.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:S.$j?s.localize(291,null):s.localize(292,null)})),multiCursorMergeOverlapping:ve(new $(ye.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(293,null)})),multiCursorModifier:ve(new k(ye.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],x,{markdownEnumDescriptions:[s.localize(294,null),s.localize(295,null)],markdownDescription:s.localize(296,null)})),multiCursorPaste:ve(new u(ye.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(297,null),s.localize(298,null)],markdownDescription:s.localize(299,null)})),multiCursorLimit:ve(new t(ye.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(300,null)})),occurrencesHighlight:ve(new u(ye.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(301,null),s.localize(302,null),s.localize(303,null)],markdownDescription:s.localize(304,null)})),overviewRulerBorder:ve(new $(ye.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(305,null)})),overviewRulerLanes:ve(new t(ye.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:ve(new M),pasteAs:ve(new Xe),parameterHints:ve(new G),peekWidgetDefaultFocus:ve(new u(ye.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(306,null),s.localize(307,null)],description:s.localize(308,null)})),definitionLinkOpensInPeek:ve(new $(ye.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(309,null)})),quickSuggestions:ve(new he),quickSuggestionsDelay:ve(new t(ye.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(310,null)})),readOnly:ve(new $(ye.readOnly,"readOnly",!1)),readOnlyMessage:ve(new Ae),renameOnType:ve(new $(ye.renameOnType,"renameOnType",!1,{description:s.localize(311,null),markdownDeprecationMessage:s.localize(312,null)})),renderControlCharacters:ve(new $(ye.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(313,null),restricted:!0})),renderFinalNewline:ve(new u(ye.renderFinalNewline,"renderFinalNewline",S.$k?"dimmed":"on",["off","on","dimmed"],{description:s.localize(314,null)})),renderLineHighlight:ve(new u(ye.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(315,null)],description:s.localize(316,null)})),renderLineHighlightOnlyWhenFocus:ve(new $(ye.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(317,null)})),renderValidationDecorations:ve(new u(ye.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new u(ye.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(318,null),s.localize(319,null),s.localize(320,null),""],description:s.localize(321,null)})),revealHorizontalRightPadding:ve(new t(ye.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ve(new $(ye.roundedSelection,"roundedSelection",!0,{description:s.localize(322,null)})),rulers:ve(new be),scrollbar:ve(new de),scrollBeyondLastColumn:ve(new t(ye.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(323,null)})),scrollBeyondLastLine:ve(new $(ye.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(324,null)})),scrollPredominantAxis:ve(new $(ye.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(325,null)})),selectionClipboard:ve(new $(ye.selectionClipboard,"selectionClipboard",!0,{description:s.localize(326,null),included:S.$k})),selectionHighlight:ve(new $(ye.selectionHighlight,"selectionHighlight",!0,{description:s.localize(327,null)})),selectOnLineNumbers:ve(new $(ye.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:ve(new u(ye.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(328,null),s.localize(329,null),s.localize(330,null)],description:s.localize(331,null)})),showUnused:ve(new $(ye.showUnused,"showUnused",!0,{description:s.localize(332,null)})),showDeprecated:ve(new $(ye.showDeprecated,"showDeprecated",!0,{description:s.localize(333,null)})),inlayHints:ve(new W),snippetSuggestions:ve(new u(ye.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(334,null),s.localize(335,null),s.localize(336,null),s.localize(337,null)],description:s.localize(338,null)})),smartSelect:ve(new Ze),smoothScrolling:ve(new $(ye.smoothScrolling,"smoothScrolling",!1,{description:s.localize(339,null)})),stopRenderingLineAfter:ve(new t(ye.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:ve(new Ve),inlineSuggest:ve(new Re),inlineEdit:ve(new Me),inlineCompletionsAccessibilityVerbose:ve(new $(ye.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(340,null)})),suggestFontSize:ve(new t(ye.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ve(new t(ye.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ve(new $(ye.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(343,null)})),suggestSelection:ve(new u(ye.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(344,null),s.localize(345,null),s.localize(346,null)],description:s.localize(347,null)})),tabCompletion:ve(new u(ye.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(348,null),s.localize(349,null),s.localize(350,null)],description:s.localize(351,null)})),tabIndex:ve(new t(ye.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:ve(new Ie),unusualLineTerminators:ve(new u(ye.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(352,null),s.localize(353,null),s.localize(354,null)],description:s.localize(355,null)})),useShadowDOM:ve(new $(ye.useShadowDOM,"useShadowDOM",!0)),useTabStops:ve(new $(ye.useTabStops,"useTabStops",!0,{description:s.localize(356,null)})),wordBreak:ve(new u(ye.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(357,null),s.localize(358,null)],description:s.localize(359,null)})),wordSegmenterLocales:ve(new nt),wordSeparators:ve(new i(ye.wordSeparators,"wordSeparators",v.$rt,{description:s.localize(360,null)})),wordWrap:ve(new u(ye.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(361,null),s.localize(362,null),s.localize(363,null),s.localize(364,null)],description:s.localize(365,null)})),wordWrapBreakAfterCharacters:ve(new i(ye.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new i(ye.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new t(ye.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(366,null)})),wordWrapOverride1:ve(new u(ye.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new u(ye.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ve(new re),defaultColorDecorators:ve(new $(ye.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(367,null)})),pixelRatio:ve(new te),tabFocusMode:ve(new $(ye.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(368,null)})),layoutInfo:ve(new q),wrappingInfo:ve(new tt),wrappingIndent:ve(new ot),wrappingStrategy:ve(new ae)}}),define(Ee[249],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$in=e.ID=void 0,e.$jn=r,e.ID="diagnosticsService",e.$in=(0,n.$Ai)(e.ID);function r(D){return!!D.hostName&&!!D.errorMessage}class S{async getPerformanceInfo(A,R){return{}}async getSystemInfo(A,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,R){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$kn=S}),define(Ee[88],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=void 0,e.$Ro=(0,n.$Ai)("downloadService")}),define(Ee[28],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,n.$Ai)("environmentService"),e.$Ii=(0,n.$Bi)(e.$Hi)}),define(Ee[16],Se([1,0,67,9,17,11,4,215,5,3,13,65]),function(fe,e,n,r,S,D,A,R,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=p,e.$9k=h,e.$0k=w,e.$$k=m,e.$_k=$,e.$al=l,e.$bl=t,e.$cl=o,e.$dl=d,e.$el=i,e.$fl=c,e.$hl=I,e.$il=C,e.$jl=T,e.$kl=O,e.$ll=P,e.$ol=ne,e.$Al=B,e.$Bl=oe,e.$Dl=pe,e.$7k=(0,v.$Ai)("fileService");function p(q){return q.create===!0}var b;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var a;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var f;(function(q){q[q.UPDATED=2]="UPDATED",q[q.ADDED=4]="ADDED",q[q.DELETED=8]="DELETED"})(f||(e.FileChangeFilter=f={}));function h(q){const ae=q;return!!ae&&typeof ae.onDidChange=="function"}var g;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function w(q){return!!(q.capabilities&g.FileReadWrite)}function m(q){return!!(q.capabilities&g.FileFolderCopy)}function $(q){return!!(q.capabilities&g.FileClone)}function l(q){return!!(q.capabilities&g.FileOpenReadWriteClose)}function t(q){return!!(q.capabilities&g.FileReadStream)}function o(q){return w(q)?!!(q.capabilities&g.FileAtomicRead):!1}function d(q){return w(q)?!!(q.capabilities&g.FileAtomicWrite):!1}function i(q){return!!(q.capabilities&g.FileAtomicDelete)}function c(q){return!!(q.capabilities&g.Readonly)}var u;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class k extends Error{static create(ae,Y){const H=new k(ae.toString(),Y);return T(H,Y),H}constructor(ae,Y){super(ae),this.code=Y}}e.$gl=k;function I(q,ae){return k.create(q,ae)}function C(q){return q||I((0,R.localize)(0,null),u.Unknown)}function T(q,ae){return q.name=ae?`${ae} (FileSystemError)`:"FileSystemError",q}function O(q){if(!q)return u.Unknown;if(q instanceof k)return q.code;const ae=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!ae)return u.Unknown;switch(ae[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function P(q){if(q instanceof se)return q.fileOperationResult;switch(O(q)){case u.FileNotFound:return ue.FILE_NOT_FOUND;case u.FileIsADirectory:return ue.FILE_IS_DIRECTORY;case u.FileNotADirectory:return ue.FILE_NOT_DIRECTORY;case u.FileWriteLocked:return ue.FILE_WRITE_LOCKED;case u.NoPermissions:return ue.FILE_PERMISSION_DENIED;case u.FileExists:return ue.FILE_MOVE_CONFLICT;case u.FileTooLarge:return ue.FILE_TOO_LARGE;default:return ue.FILE_OTHER_ERROR}}var V;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(V||(e.FileOperation=V={}));class Q{constructor(ae,Y,H){this.resource=ae,this.operation=Y,this.target=H}isOperation(ae){return this.operation===ae}}e.$ml=Q;var ie;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(ie||(e.FileChangeType=ie={}));class re{static{this.a=null}constructor(ae,Y){this.c=Y,this.b=void 0,this.d=new y.$V(()=>{const H=n.$Gi.forUris(()=>this.c);return H.fill(this.rawAdded.map(L=>[L,!0])),H}),this.f=new y.$V(()=>{const H=n.$Gi.forUris(()=>this.c);return H.fill(this.rawUpdated.map(L=>[L,!0])),H}),this.g=new y.$V(()=>{const H=n.$Gi.forUris(()=>this.c);return H.fill(this.rawDeleted.map(L=>[L,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of ae){switch(H.type){case ie.ADDED:this.rawAdded.push(H.resource);break;case ie.UPDATED:this.rawUpdated.push(H.resource);break;case ie.DELETED:this.rawDeleted.push(H.resource);break}this.b!==re.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=re.a):this.b!==void 0&&(this.b=re.a))}}contains(ae,...Y){return this.h(ae,{includeChildren:!1},...Y)}affects(ae,...Y){return this.h(ae,{includeChildren:!0},...Y)}h(ae,Y,...H){if(!ae)return!1;const L=H.length>0;return!!((!L||H.includes(ie.ADDED))&&(this.d.value.get(ae)||Y.includeChildren&&this.d.value.findSuperstr(ae))||(!L||H.includes(ie.UPDATED))&&(this.f.value.get(ae)||Y.includeChildren&&this.f.value.findSuperstr(ae))||(!L||H.includes(ie.DELETED))&&(this.g.value.findSubstr(ae)||Y.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$nl=re;function ne(q,ae,Y){return!q||!ae||q===ae||ae.length>q.length?!1:(ae.charAt(ae.length-1)!==r.sep&&(ae+=r.sep),Y?(0,S.$Cf)(q,ae):q.indexOf(ae)===0)}class se extends Error{constructor(ae,Y,H){super(ae),this.fileOperationResult=Y,this.options=H}}e.$pl=se;class Z extends se{constructor(ae,Y,H,L){super(ae,Y,L),this.fileOperationResult=Y,this.size=H}}e.$ql=Z;class ee extends se{constructor(ae,Y,H){super(ae,ue.FILE_NOT_MODIFIED_SINCE,H),this.stat=Y}}e.$rl=ee;var ue;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var j;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(j||(e.FileKind=j={})),e.$zl="";function B(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}async function oe(q,ae){if(!ae.hasProvider(A.URI.from({scheme:q.scheme})))return new Promise(Y=>{const H=ae.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===q.scheme&&L.added&&(H.dispose(),Y())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(ae){return(0,D.$eg)(ae)||(ae=0),ae<le.KB?(0,R.localize)(1,null,ae.toFixed(0)):ae<le.MB?(0,R.localize)(2,null,(ae/le.KB).toFixed(2)):ae<le.GB?(0,R.localize)(3,null,(ae/le.MB).toFixed(2)):ae<le.TB?(0,R.localize)(4,null,(ae/le.GB).toFixed(2)):(0,R.localize)(5,null,(ae/le.TB).toFixed(2))}}e.$Cl=le;function pe(q){const ae=typeof q=="string"||q?.scheme===E.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===E.Schemas.file?1024*le.MB:ae?10*le.MB:s.$o?50*le.MB:1024*le.MB}}),define(Ee[120],Se([1,0,15,10,216,16]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=A;async function A(E,y,p,b,a,f){let h;try{await R(E,y,p,b,a,f)}catch(g){h=g}finally{h&&a.errorTransformer&&(h=a.errorTransformer(h)),typeof h<"u"&&p.error(h),p.end()}}async function R(E,y,p,b,a,f){v(f);const h=await E.open(y,{create:!1});try{v(f);let g=0,w=0,m=a&&typeof a.length=="number"?a.length:void 0,$=n.$Je.alloc(Math.min(a.bufferSize,typeof m=="number"?m:a.bufferSize)),l=a&&typeof a.position=="number"?a.position:0,t=0;do w=await E.read(h,l,$.buffer,t,$.byteLength-t),l+=w,t+=w,g+=w,typeof m=="number"&&(m-=w),t===$.byteLength&&(await p.write(b($)),$=n.$Je.alloc(Math.min(a.bufferSize,typeof m=="number"?m:a.bufferSize)),t=0);while(w>0&&(typeof m!="number"||m>0)&&v(f)&&s(g,a));if(t>0){let o=t;typeof m=="number"&&(o=Math.min(t,m)),p.write(b($.slice(0,o)))}}catch(g){throw(0,D.$il)(g)}finally{await E.close(h)}}function v(E){if(E.isCancellationRequested)throw(0,r.$6)();return!0}function s(E,y){if(typeof y?.limits?.size=="number"&&E>y.limits.size)throw(0,D.$hl)((0,S.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[51],Se([1,0,85,2,9,3,4,16]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=e.$Tq=void 0,e.$Rq=v,e.$Sq=s,e.$Wq=b,e.$Xq=a,e.$Yq=f,e.$Zq=h,e.$1q=w,e.$2q=m;function v($){return typeof $.correlationId=="number"}function s($){return $.recursive===!0}class E extends r.$Uc{static{this.a=3}static{this.b=10}constructor(l,t,o,d){super(),this.m=l,this.n=t,this.r=o,this.s=d,this.f=this.B(new r.$Vc),this.g=void 0,this.h=new Map,this.j=0}u(){const l=new r.$Tc;this.f.value=l,this.c=this.t(l),this.c.setVerboseLogging(this.r),l.add(this.c.onDidChangeFile(t=>this.m(t))),l.add(this.c.onDidLogMessage(t=>this.n(t))),l.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(l,t){if(this.s.restartOnError&&this.g?.length)if(t){const o=this.h.get(t.path)??0;o<E.a?(this.z(`restarting watcher from error in watch request (retrying request): ${l} (${JSON.stringify(t)})`),this.h.set(t.path,o+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${l} (${JSON.stringify(t)})`),this.y(this.g.filter(d=>d.path!==t.path)))}else this.j<E.b?(this.z(`restarting watcher after unknown global error: ${l}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${l}`);else this.z(l)}y(l){this.u(),this.watch(l)}async watch(l){this.g=l,await this.c?.watch(l)}async setVerboseLogging(l){this.r=l,await this.c?.setVerboseLogging(l)}z(l){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${l}`})}C(l){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${l}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Tq=E;class y extends E{constructor(l,t,o){super(l,t,o,{type:"node.js",restartOnError:!1})}}e.$Uq=y;class p extends E{constructor(l,t,o){super(l,t,o,{type:"universal",restartOnError:!0})}}e.$Vq=p;function b($){return $.map(l=>({type:l.type,resource:A.URI.revive(l.resource),cId:l.cId}))}function a($){const l=new g;for(const t of $)l.processEvent(t);return l.coalesce()}function f($,l){return typeof l=="string"&&!l.startsWith(n.$qk)&&!(0,S.$ic)(l)?{base:$,pattern:l}:l}function h($,l){const t=[];for(const o of l)t.push((0,n.$uk)(f($,o)));return t}class g{constructor(){this.a=new Set,this.b=new Map}c(l){return D.$k?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const t=this.b.get(this.c(l));let o=!1;if(t){const d=t.type,i=l.type;t.resource.fsPath!==l.resource.fsPath&&(l.type===R.FileChangeType.DELETED||l.type===R.FileChangeType.ADDED)?o=!0:d===R.FileChangeType.ADDED&&i===R.FileChangeType.DELETED?(this.b.delete(this.c(l)),this.a.delete(t)):d===R.FileChangeType.DELETED&&i===R.FileChangeType.ADDED?t.type=R.FileChangeType.UPDATED:d===R.FileChangeType.ADDED&&i===R.FileChangeType.UPDATED||(t.type=i)}else o=!0;o&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],t=[];return Array.from(this.a).filter(o=>o.type!==R.FileChangeType.DELETED?(l.push(o),!1):!0).sort((o,d)=>o.resource.fsPath.length-d.resource.fsPath.length).filter(o=>t.some(d=>(0,R.$ol)(o.resource.fsPath,d,!D.$k))?!1:(t.push(o.resource.fsPath),!0)).concat(l)}}function w($,l){if(typeof l=="number")switch($.type){case R.FileChangeType.ADDED:return(l&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(l&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(l&R.FileChangeFilter.UPDATED)===0}return!1}function m($){if(typeof $=="number"){const l=[];return $&R.FileChangeFilter.ADDED&&l.push("Added"),$&R.FileChangeFilter.DELETED&&l.push("Deleted"),$&R.FileChangeFilter.UPDATED&&l.push("Updated"),l.length===0?"<all>":`[${l.join(", ")}]`}return"<none>"}}),define(Ee[250],Se([1,0,15,42,10,6,2,56,22,16,51]),function(fe,e,n,r,S,D,A,R,v,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=e.$7P=void 0,e.$7P="localFilesystem";class y extends A.$Uc{constructor(b,a){super(),this.a=b,this.b=a,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$he),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$he),this.onDidWatchError=this.g.event,this.h=(0,v.$Wg)(),this.j()}get capabilities(){return this.c||(this.c=s.FileSystemProviderCapabilities.FileReadWrite|s.FileSystemProviderCapabilities.FileOpenReadWriteClose|s.FileSystemProviderCapabilities.FileReadStream|s.FileSystemProviderCapabilities.FileFolderCopy|s.FileSystemProviderCapabilities.FileWriteUnlock|s.FileSystemProviderCapabilities.FileAtomicRead|s.FileSystemProviderCapabilities.FileAtomicWrite|s.FileSystemProviderCapabilities.FileAtomicDelete|s.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=s.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=s.FileSystemProviderCapabilities.Trash)),this.c}stat(b){return this.a.call("stat",[b])}readdir(b){return this.a.call("readdir",[b])}async readFile(b,a){const{buffer:f}=await this.a.call("readFile",[b,a]);return f}readFileStream(b,a,f){const h=(0,R.$xe)(w=>n.$Je.concat(w.map(m=>n.$Je.wrap(m))).buffer),g=new A.$Tc;return g.add(this.a.listen("readFileStream",[b,a])(w=>{if(w instanceof n.$Je)h.write(w.buffer);else{if(w==="end")h.end();else{let m;if(w instanceof Error)m=w;else{const $=w;m=(0,s.$hl)($.message??(0,r.$lj)($),$.code??s.FileSystemProviderErrorCode.Unknown)}h.error(m),h.end()}g.dispose()}})),g.add(f.onCancellationRequested(()=>{h.error((0,S.$6)()),h.end(),g.dispose()})),h}writeFile(b,a,f){return this.a.call("writeFile",[b,n.$Je.wrap(a),f])}open(b,a){return this.a.call("open",[b,a])}close(b){return this.a.call("close",[b])}async read(b,a,f,h,g){const[w,m]=await this.a.call("read",[b,a,g]);return f.set(w.buffer.slice(0,m),h),m}write(b,a,f,h,g){return this.a.call("write",[b,a,n.$Je.wrap(f),h,g])}mkdir(b){return this.a.call("mkdir",[b])}delete(b,a){return this.a.call("delete",[b,a])}rename(b,a,f){return this.a.call("rename",[b,a,f])}copy(b,a,f){return this.a.call("copy",[b,a,f])}cloneFile(b,a){return this.a.call("cloneFile",[b,a])}j(){this.B(this.a.listen("fileChange",[this.h])(b=>{if(Array.isArray(b)){const a=b;this.f.fire((0,E.$Wq)(a))}else{const a=b;this.g.fire(a)}}))}watch(b,a){const f=(0,v.$Wg)();return this.a.call("watch",[this.h,f,b,a]),(0,A.$Sc)(()=>this.a.call("unwatch",[this.h,f]))}}e.$8P=y}),define(Ee[251],Se([1,0,31,2,51,6,16,4,14]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class s extends r.$Uc{constructor(){super(),this.a=this.B(new D.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$4c),this.m=new Set,this.n=5007,this.r=new v.$Xh,this.P=!1,this.B(this.f(y=>this.s(y)))}s(y){this.t(y)&&this.w(y)}t(y){return(0,S.$Rq)(y)}async watch(y){this.r.isSettled||this.r.complete(),this.r=new v.$Xh;try{this.h.clear(),this.g.clear();for(const p of y)this.t(p)?this.h.set(p.correlationId,p):this.g.add(p);for(const[p]of this.j)this.h.has(p)||(this.j.deleteAndDispose(p),this.m.delete(p));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(y=>!this.j.has(y.correlationId))])}isSuspended(y){return typeof y.correlationId!="number"?!1:this.m.has(y.correlationId)?"polling":this.j.has(y.correlationId)}async w(y){if(this.j.has(y.correlationId))return;const p=new r.$Tc;this.j.set(y.correlationId,p),await this.r.p,!p.isDisposed&&(this.z(y,p),this.u())}y(y){this.j.deleteAndDispose(y.correlationId),this.m.delete(y.correlationId),this.u()}z(y,p){this.C(y,p)?(this.N(`reusing an existing recursive watcher to monitor ${y.path}`),this.m.delete(y.correlationId)):(this.D(y,p),this.m.add(y.correlationId))}C(y,p){const b=this.M?.subscribe(y.path,(a,f)=>{p.isDisposed||(a?this.z(y,p):f?.type===A.FileChangeType.ADDED&&this.F(y))});return b?(p.add(b),!0):!1}D(y,p){let b=!1;const a=(f,h)=>{if(p.isDisposed)return;const g=this.G(f),w=this.G(h),m=b;b=g,!g&&(w||m)&&this.F(y)};this.N(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,n.watchFile)(y.path,{persistent:!1,interval:this.n},a)}catch(f){this.O(`fs.watchFile() failed with error ${f} on path ${y.path} (correlationId: ${y.correlationId})`)}p.add((0,r.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,n.unwatchFile)(y.path,a)}catch(f){this.O(`fs.unwatchFile() failed with error ${f} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}F(y){this.N(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const p={resource:R.URI.file(y.path),type:A.FileChangeType.ADDED,cId:y.correlationId};this.a.fire([p]),this.H(p,y),this.y(y)}G(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(y,p){if(this.P){const b=` >> normalized ${y.type===A.FileChangeType.ADDED?"[ADDED]":y.type===A.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.I(b,p)}}I(y,p){this.P&&this.N(`${y}${typeof p.correlationId=="number"?` <${p.correlationId}> `:""}`)}J(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,S.$2q)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.P=y}}e.$$q=s}),define(Ee[252],Se([1,0,31,14,19,37,2,107,9,3,20,4,195,25,16,51]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0,e.$er=g;class h extends A.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(m,$,l,t,o,d){super(),this.s=m,this.t=$,this.u=l,this.w=t,this.y=o,this.z=d,this.c=this.B(new r.$Ph({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.u(i))),this.f=this.B(new r.$Oh(i=>this.M(i),h.b)),this.g=(0,f.$Zq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,f.$Zq)(this.s.path,this.s.includes):void 0,this.j=(0,f.$Rq)(this.s)?this.s.filter:void 0,this.m=new S.$se,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const m=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const $=await b.Promises.stat(m);if(this.m.token.isCancellationRequested)return;this.B(await this.G(m,$.isDirectory()))}catch(m){m.code!=="ENOENT"?this.O(m):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${m})`),this.D()}}D(){this.r=!0,this.w?.()}async F(m){let $=m.path;try{$=await b.Promises.realpath(m.path),m.path===$&&($=await(0,p.$ar)(m.path,this.m.token)??m.path),m.path!==$&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${$})`)}catch{}return $}async G(m,$){const l=new A.$Tc;return this.H(m,$,l)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(m,$,l)),l}H(m,$,l){if($)return!1;const t=y.URI.file(this.s.path),o=this.t?.subscribe(this.s.path,async(d,i)=>{if(!l.isDisposed)if(d){const c=await this.G(m,$);l.isDisposed?c.dispose():l.add(c)}else i&&(typeof i.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:i.type,cId:this.s.correlationId},!0)});return o?(l.add(o),!0):!1}async I(m,$,l){if(s.$j&&(0,D.$zg)(m,"/Volumes/",!0)){this.O(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new S.$se(this.m.token);l.add((0,A.$Sc)(()=>t.dispose(!0)));const o=new A.$Tc;l.add(o);try{const d=y.URI.file(this.s.path),i=(0,v.$nc)(m),c=(0,n.watch)(m);o.add((0,A.$Sc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${m}'`);const u=new Set;if($)try{for(const I of await b.Promises.readdir(m))u.add(I)}catch(I){this.O(I)}if(t.token.isCancellationRequested)return;const k=new Map;o.add((0,A.$Sc)(()=>{for(const[,I]of k)I.dispose();k.clear()})),c.on("error",(I,C)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${m} for changes using fs.watch() (${I}, ${C})`),this.D())}),c.on("change",(I,C)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${I}"] ${C}`);let T="";if(C&&(T=C.toString(),s.$j&&(T=(0,R.$gm)(T))),!(!T||I!=="change"&&I!=="rename"))if($)if(I==="rename"){k.get(T)?.dispose();const O=setTimeout(async()=>{if(k.delete(T),T===i&&!await b.Promises.exists(m)){this.J(d);return}if(t.token.isCancellationRequested)return;const P=await this.N((0,v.$jc)(m,T));if(t.token.isCancellationRequested)return;let V;P?u.has(T)?V=a.FileChangeType.UPDATED:(V=a.FileChangeType.ADDED,u.add(T)):(u.delete(T),V=a.FileChangeType.DELETED),this.L({resource:(0,E.$bh)(d,T),type:V,cId:this.s.correlationId})},h.a);k.set(T,(0,A.$Sc)(()=>clearTimeout(O)))}else{let O;u.has(T)?O=a.FileChangeType.UPDATED:(O=a.FileChangeType.ADDED,u.add(T)),this.L({resource:(0,E.$bh)(d,T),type:O,cId:this.s.correlationId})}else if(I==="rename"||T!==i){const O=setTimeout(async()=>{const P=await b.Promises.exists(m);t.token.isCancellationRequested||(P?(this.L({resource:d,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0),o.add(await this.G(m,!1))):this.J(d))},h.a);o.clear(),o.add((0,A.$Sc)(()=>clearTimeout(O)))}else this.L({resource:d,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){t.token.isCancellationRequested||this.O(`Failed to watch ${m} for changes using fs.watch() (${d.toString()})`),this.D()}}J(m){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:m,type:a.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(m,$=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${m.type===a.FileChangeType.ADDED?"[ADDED]":m.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`),!$&&this.g.some(l=>l(m.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${m.resource.fsPath}`):!$&&this.h&&this.h.length>0&&!this.h.some(l=>l(m.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${m.resource.fsPath}`):this.f.work(m))}M(m){const $=(0,f.$Xq)(m),l=[];for(const o of $){if((0,f.$1q)(o,this.j)){this.z&&this.R(` >> ignored (filtered) ${o.resource.fsPath}`);continue}l.push(o)}if(l.length===0)return;if(this.z)for(const o of l)this.R(` >> normalized ${o.type===a.FileChangeType.ADDED?"[ADDED]":o.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${o.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(m){if(s.$k)return b.Promises.exists(m);try{const $=(0,v.$nc)(m);return(await b.Promises.readdir((0,v.$mc)(m))).some(t=>t===$)}catch($){return this.Q($),!1}}setVerboseLogging(m){this.z=m}O(m){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}P(m){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}Q(m){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}R(m){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${m}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$dr=h;async function g(w,m,$,l,t=512){const o=await b.Promises.open(w,"r"),d=Buffer.allocUnsafe(t),i=new S.$se(l);let c,u=!1;const k={path:w,excludes:[],recursive:!1},I=new h(k,void 0,C=>{(async()=>{for(const{type:T}of C)if(T===a.FileChangeType.UPDATED){if(u)return;u=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:O}=await b.Promises.read(o,d,0,t,null);if(!O||i.token.isCancellationRequested)break;m(d.slice(0,O))}}catch(O){c=new Error(O),i.dispose(!0)}finally{u=!1}}})()});return await I.ready,$(),new Promise((C,T)=>{i.token.onCancellationRequested(async()=>{I.dispose();try{await b.Promises.close(o)}catch(O){c=new Error(O)}c?T(c):C()})})}}),define(Ee[253],Se([1,0,6,85,251,3,252,37]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class v extends S.$$q{constructor(E){super(),this.M=E,this.onDidError=n.Event.None,this.watchers=new Set}async L(E){E=this.X(E);const y=[],p=new Set(Array.from(this.watchers));for(const b of E){const a=this.S(b);a&&(0,r.$yk)(a.request.excludes,b.excludes)&&(0,r.$yk)(a.request.includes,b.includes)?p.delete(a):y.push(b)}y.length&&this.N(`Request to start watching: ${y.map(b=>this.J(b)).join(",")}`),p.size&&this.N(`Request to stop watching: ${Array.from(p).map(b=>this.J(b.request)).join(",")}`);for(const b of p)this.W(b);for(const b of y)this.U(b)}S(E){for(const y of this.watchers)if(typeof E.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===E.correlationId)return y}else if((0,R.$yg)(y.request.path,E.path,!D.$k))return y}U(E){const y=new A.$dr(E,this.M,b=>this.a.fire(b),()=>this.c.fire(E),b=>this.b.fire(b),this.P),p={request:E,instance:y};this.watchers.add(p)}async stop(){await super.stop();for(const E of this.watchers)this.W(E)}W(E){this.N("stopping file watcher",E),this.watchers.delete(E),E.instance.dispose()}X(E){const y=new Map;for(const p of E){const b=D.$k?p.path:p.path.toLowerCase();let a=y.get(p.correlationId);a||(a=new Map,y.set(p.correlationId,a)),a.has(b)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(p)}`),a.set(b,p)}return Array.from(y.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(E){super.setVerboseLogging(E);for(const y of this.watchers)y.instance.setVerboseLogging(E)}N(E,y){this.P&&this.b.fire({type:"trace",message:this.$(E,y)})}O(E){this.b.fire({type:"warn",message:this.$(E)})}$(E,y){return y?`[File Watcher (node.js)] ${E} (${this.J(y.request)})`:`[File Watcher (node.js)] ${E}`}}e.$fr=v}),define(Ee[254],Se([1,0,51,253]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class S extends n.$Uq{constructor(A,R,v){super(A,R,v),this.u()}t(A){return A.add(new r.$fr(void 0))}}e.$gr=S}),define(Ee[255],Se([1,0,13,50,117,51]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class A extends D.$Vq{constructor(v,s,E){super(v,s,E),this.u()}t(v){const s=v.add(new S.$9q(n.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(s.onDidProcessExit(({code:E,signal:y})=>this.w(`terminated by itself with code ${E}, signal: ${y} (ETERM)`))),r.ProxyChannel.toService((0,r.$hi)(s.getChannel("watcher")))}}e.$0q=A}),define(Ee[89],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class n{constructor(...S){this.a=new Map;for(const[D,A]of S)this.set(D,A)}set(S,D){const A=this.a.get(S);return this.a.set(S,D),A}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$yi=n}),define(Ee[121],Se([1,0,14,10,2,71,246,5,89,79]),function(fe,e,n,r,S,D,A,R,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=void 0;const E=!1;class y extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class p{constructor(h=new v.$yi,g=!1,w,m=E){this.i=h,this.j=g,this.k=w,this.l=m,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(R.$zi,this),this._globalGraph=m?w?._globalGraph??new A.$jr($=>$):void 0}dispose(){if(!this.f){this.f=!0,(0,S.$Pc)(this.h),this.h.clear();for(const h of this.g)(0,S.$Oc)(h)&&h.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(h,g){this.m();const w=this,m=new class extends p{dispose(){w.h.delete(m),super.dispose()}}(h,this.j,this,this.l);return this.h.add(m),g?.add(m),m}invokeFunction(h,...g){this.m();const w=a.traceInvocation(this.l,h);let m=!1;try{return h({get:l=>{if(m)throw(0,r.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(l,w);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...g)}finally{m=!0,w.stop()}}createInstance(h,...g){this.m();let w,m;return h instanceof D.$xi?(w=a.traceCreation(this.l,h.ctor),m=this.o(h.ctor,h.staticArguments.concat(g),w)):(w=a.traceCreation(this.l,h),m=this.o(h,g,w)),w.stop(),m}o(h,g=[],w){const m=R._util.getServiceDependencies(h).sort((t,o)=>t.index-o.index),$=[];for(const t of m){const o=this.s(t.id,w);o||this.y(`[createInstance] ${h.name} depends on UNKNOWN service ${t.id}.`,!1),$.push(o)}const l=m.length>0?m[0].index:g.length;if(g.length!==l){console.trace(`[createInstance] First service dependency of ${h.name} at position ${l+1} conflicts with ${g.length} static arguments`);const t=l-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,l)}return Reflect.construct(h,g.concat($))}q(h,g){if(this.i.get(h)instanceof D.$xi)this.i.set(h,g);else if(this.k)this.k.q(h,g);else throw new Error("illegalState - setting UNKNOWN service instance")}r(h){const g=this.i.get(h);return!g&&this.k?this.k.r(h):g}s(h,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const w=this.r(h);return w instanceof D.$xi?this.u(h,w,g.branch(h,!0)):(g.branch(h,!1),w)}u(h,g,w){if(this.t.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.t.add(h);try{return this.v(h,g,w)}finally{this.t.delete(h)}}v(h,g,w){const m=new A.$jr(t=>t.id.toString());let $=0;const l=[{id:h,desc:g,_trace:w}];for(;l.length;){const t=l.pop();if(m.lookupOrInsertNode(t),$++>1e3)throw new y(m);for(const o of R._util.getServiceDependencies(t.desc.ctor)){const d=this.r(o.id);if(d||this.y(`[createInstance] ${h} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),d instanceof D.$xi){const i={id:o.id,desc:d,_trace:t._trace.branch(o.id,!0)};m.insertEdge(t,i),l.push(i)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new y(m);break}for(const{data:o}of t){if(this.r(o.id)instanceof D.$xi){const i=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,i)}m.removeNode(o)}}return this.r(h)}w(h,g,w=[],m,$){if(this.i.get(h)instanceof D.$xi)return this.x(h,g,w,m,$,this.g);if(this.k)return this.k.w(h,g,w,m,$);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}x(h,g,w=[],m,$,l){if(m){const t=new p(void 0,this.j,this,this.l);t.c=String(h);const o=new Map,d=new n.$Th(()=>{const i=t.o(g,w,$);for(const[c,u]of o){const k=i[c];if(typeof k=="function")for(const I of u)I.disposable=k.apply(i,I.listener)}return o.clear(),l.add(i),i});return new Proxy(Object.create(null),{get(i,c){if(!d.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let I=o.get(c);return I||(I=new s.$5c,o.set(c,I)),(T,O,P)=>{if(d.isInitialized)return d.value[c](T,O,P);{const V={listener:[T,O,P],disposable:void 0},Q=I.push(V);return(0,S.$Sc)(()=>{Q(),V.disposable?.dispose()})}}}if(c in i)return i[c];const u=d.value;let k=u[c];return typeof k!="function"||(k=k.bind(u),i[c]=k),k},set(i,c,u){return d.value[c]=u,!0},getPrototypeOf(i){return g.prototype}})}else{const t=this.o(g,w,$);return l.add(t),t}}y(h,g){if(g&&console.warn(h),this.j)throw new Error(h)}}e.$kr=p;var b;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(b||(b={}));class a{static{this.all=new Set}static{this.c=new class extends a{constructor(){super(b.None,null)}stop(){}branch(){return this}}}static traceInvocation(h,g){return h?new a(b.Invocation,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):a.c}static traceCreation(h,g){return h?new a(b.Creation,g.name):a.c}static{this.f=0}constructor(h,g){this.type=h,this.name=g,this.g=Date.now(),this.h=[]}branch(h,g){const w=new a(b.Branch,h.toString());return this.h.push([h,g,w]),w}stop(){const h=Date.now()-this.g;a.f+=h;let g=!1;function w($,l){const t=[],o=new Array($+1).join("	");for(const[d,i,c]of l.h)if(i&&c){g=!0,t.push(`${o}CREATES -> ${d}`);const u=w($+1,c);u&&t.push(u)}else t.push(`${o}uses -> ${d}`);return t.join(`
`)}const m=[`${this.type===b.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${a.f.toFixed(2)}ms)`];(h>2||g)&&a.all.add(m.join(`
`))}}e.$lr=a}),define(Ee[256],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$fw=void 0,e.$fw=(0,n.$Ai)("labelService");var r;(function(S){S[S.SHORT=0]="SHORT",S[S.MEDIUM=1]="MEDIUM",S[S.LONG=2]="LONG"})(r||(e.Verbosity=r={}))}),define(Ee[12],Se([1,0,219,42,6,66,2,26,3,20,11,4,43,5]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=f,e.log=g,e.$ik=k,e.$jk=I,e.$kk=C,e.$lk=T,e.$7j=(0,b.$Ai)("logService"),e.$8j=(0,b.$Ai)("loggerService");function a(){return new Date().toISOString()}function f(O){return(0,E.$eg)(O)}var h;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(h||(e.LogLevel=h={})),e.$0j=h.Info;function g(O,P,V){switch(P){case h.Trace:O.trace(V);break;case h.Debug:O.debug(V);break;case h.Info:O.info(V);break;case h.Warning:O.warn(V);break;case h.Error:O.error(V);break;case h.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function w(O,P=!1){let V="";for(let Q=0;Q<O.length;Q++){let ie=O[Q];if(ie instanceof Error&&(ie=(0,r.$lj)(ie,P)),typeof ie=="object")try{ie=JSON.stringify(ie)}catch{}V+=(Q>0?" ":"")+ie}return V}class m extends A.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new S.$he),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==h.Off&&this.b<=P}}e.$_j=m;class $ extends m{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...V){this.f(h.Trace)&&this.g(h.Trace,w([P,...V],!0))}debug(P,...V){this.f(h.Debug)&&this.g(h.Debug,w([P,...V]))}info(P,...V){this.f(h.Info)&&this.g(h.Info,w([P,...V]))}warn(P,...V){this.f(h.Warning)&&this.g(h.Warning,w([P,...V]))}error(P,...V){if(this.f(h.Error))if(P instanceof Error){const Q=Array.prototype.slice.call(arguments);Q[0]=P.stack,this.g(h.Error,w(Q))}else this.g(h.Error,w([P,...V]))}flush(){}}e.$ak=$;class l extends m{constructor(P=e.$0j){super(),this.setLevel(P),this.g=!v.$i}trace(P,...V){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...V):console.log(`[main ${a()}]`,P,...V))}debug(P,...V){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...V):console.log(`[main ${a()}]`,P,...V))}info(P,...V){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...V):console.log(`[main ${a()}]`,P,...V))}warn(P,...V){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,P,...V):console.warn(`[main ${a()}]`,P,...V))}error(P,...V){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,P,...V):console.error(`[main ${a()}]`,P,...V))}flush(){}}e.$bk=l;class t extends m{constructor(P=e.$0j,V=!0){super(),this.g=V,this.setLevel(P)}trace(P,...V){this.f(h.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...V):console.log(P,...V))}debug(P,...V){this.f(h.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...V):console.log(P,...V))}info(P,...V){this.f(h.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...V):console.log(P,...V))}warn(P,...V){this.f(h.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...V):console.log(P,...V))}error(P,...V){this.f(h.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...V):console.error(P,...V))}flush(){}}e.$ck=t;class o extends m{constructor(P,V=e.$0j){super(),this.g=P,this.setLevel(V)}trace(P,...V){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(P),...V])}debug(P,...V){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(P),...V])}info(P,...V){this.f(h.Info)&&this.g.log(h.Info,[this.h(P),...V])}warn(P,...V){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(P),...V])}error(P,...V){this.f(h.Error)&&this.g.log(h.Error,[this.h(P),...V])}h(P){return typeof P=="string"?P:(0,r.$lj)(P,this.f(h.Trace))}flush(){}}e.$dk=o;class d extends m{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const V of this.g)V.setLevel(P);super.setLevel(P)}trace(P,...V){for(const Q of this.g)Q.trace(P,...V)}debug(P,...V){for(const Q of this.g)Q.debug(P,...V)}info(P,...V){for(const Q of this.g)Q.info(P,...V)}warn(P,...V){for(const Q of this.g)Q.warn(P,...V)}error(P,...V){for(const Q of this.g)Q.error(P,...V)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$ek=d;class i extends A.$Uc{constructor(P,V,Q){if(super(),this.h=P,this.j=V,this.b=new R.$Ac,this.c=this.B(new S.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$he),this.onDidChangeVisibility=this.g.event,Q)for(const ie of Q)this.b.set(ie.resource,{logger:void 0,info:ie})}m(P){return(0,E.$ag)(P)?[...this.b.values()].find(V=>V.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,V){const Q=this.n(P),ie=(0,E.$ag)(P)?P:V?.id??(0,D.$oj)(Q.toString()).toString(16);let re=this.b.get(Q)?.logger;const ne=V?.logLevel==="always"?h.Trace:V?.logLevel;re||(re=this.s(Q,ne??this.getLogLevel(Q)??this.h,{...V,id:ie}));const se={logger:re,info:{resource:Q,id:ie,logLevel:ne,name:V?.name,hidden:V?.hidden,extensionId:V?.extensionId,when:V?.when}};return this.registerLogger(se.info),this.b.set(Q,se),re}n(P){return(0,E.$ag)(P)?(0,s.$bh)(this.j,`${P}.log`):P}setLogLevel(P,V){if(y.URI.isUri(P)){const Q=P,ie=V,re=this.b.get(Q);re&&ie!==re.info.logLevel&&(re.info.logLevel=ie===this.h?void 0:ie,re.logger?.setLevel(ie),this.b.set(re.info.resource,re),this.f.fire([Q,ie]))}else{this.h=P;for(const[Q,ie]of this.b.entries())this.b.get(Q)?.info.logLevel===void 0&&ie.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,V){const Q=this.m(P);Q&&V!==!Q.info.hidden&&(Q.info.hidden=!V,this.b.set(Q.info.resource,Q),this.g.fire([Q.info.resource,V]))}getLogLevel(P){let V;return P&&(V=this.b.get(P)?.info.logLevel),V??this.h}registerLogger(P){const V=this.b.get(P.resource);V?V.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const V=this.b.get(P);V&&(V.logger&&V.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[V.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=i;class c{constructor(){this.onDidChangeLogLevel=new S.$he().event}setLevel(P){}getLevel(){return h.Info}trace(P,...V){}debug(P,...V){}info(P,...V){}warn(P,...V){}error(P,...V){}critical(P,...V){}dispose(){}flush(){}}e.$gk=c;class u extends c{}e.$hk=u;function k(O){if(O.verbose)return h.Trace;if(typeof O.logLevel=="string"){const P=T(O.logLevel.toLowerCase());if(P!==void 0)return P}return e.$0j}function I(O){switch(O){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}function C(O){switch(O){case h.Trace:return{original:"Trace",value:n.localize(0,null)};case h.Debug:return{original:"Debug",value:n.localize(1,null)};case h.Info:return{original:"Info",value:n.localize(2,null)};case h.Warning:return{original:"Warning",value:n.localize(3,null)};case h.Error:return{original:"Error",value:n.localize(4,null)};case h.Off:return{original:"Off",value:n.localize(5,null)}}}function T(O){switch(O){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.$mk=new p.$Rj("logLevel",I(h.Info))}),define(Ee[257],Se([1,0,18,14,10,6,37,2,9,51,12]),function(fe,e,n,r,S,D,A,R,v,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class y extends R.$Uc{constructor(b,a){super(),this.a=b,this.b=a,this.c=this.B(new D.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$yh(0)),this.w=[],this.y=this.B(new r.$yh(0))}watch(b,a){return a.recursive||this.b?.watcher?.forceUniversal?this.n(b,a):this.z(b,a)}n(b,a){const f={path:this.J(b),excludes:a.excludes,includes:a.includes,recursive:a.recursive,filter:a.filter,correlationId:a.correlationId},h=(0,n.$Tb)(this.j,f);return this.r(),(0,R.$Sc)(()=>{h(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,S.$1)(b))}s(){this.h||(this.h=this.B(this.t(a=>this.c.fire((0,s.$Wq)(a)),a=>this.G(a),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const a of this.j)(0,s.$Sq)(a)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const a of this.j)(0,s.$Sq)(a)&&b.includes(a.path)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,a){const f={path:this.J(b),excludes:a.excludes,includes:a.includes,recursive:!1,filter:a.filter,correlationId:a.correlationId},h=(0,n.$Tb)(this.w,f);return this.C(),(0,R.$Sc)(()=>{h(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,S.$1)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,s.$Wq)(b)),b=>this.G(b),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.H(b)}H(b){this.a[b.type](b.message)}I(b){return(0,v.$hc)(b.fsPath)}J(b){const a=this.I(b);return(0,A.$Cg)(a)}}e.$3q=y});var Fe=this&&this.__param||function(fe,e){return function(n,r){e(n,r,fe)}};define(Ee[122],Se([1,0,18,14,15,19,6,66,40,2,67,13,45,20,56,214,16,120,12,10]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let l=class extends s.$Uc{static{$=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new A.$he),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$he),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$he),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$he),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$he),this.Y=this.B(new A.$he),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$he),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Jh)}registerProvider(o,d){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${o}`);const i=new s.$Tc;return this.h.set(o,d),this.c.fire({added:!0,scheme:o,provider:d}),i.add(d.onDidChangeFile(c=>{const u=new h.$nl(c,!this.S(d));this.X.fire(u),u.hasCorrelation()||this.Y.fire(u)})),typeof d.onDidWatchError=="function"&&i.add(d.onDidWatchError(c=>this.Z.fire(new Error(c)))),i.add(d.onDidChangeCapabilities(()=>this.g.fire({provider:d,scheme:o}))),(0,s.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:d}),this.h.delete(o),(0,s.$Pc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const d=[];this.f.fire({scheme:o,join(i){d.push(i)}}),!this.h.has(o)&&await r.Promises.settled(d)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,d){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&d)}listCapabilities(){return v.Iterable.map(this.h,([o,d])=>({scheme:o,capabilities:d.capabilities}))}async j(o){if(!(0,b.$fh)(o))throw new h.$pl((0,f.localize)(0,null,this.sb(o)),h.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(o.scheme);const d=this.h.get(o.scheme);if(!d){const i=new m.$bb;throw i.message=(0,f.localize)(1,null,o.toString()),i}return d}async m(o){const d=await this.j(o);if((0,h.$al)(d)||(0,h.$0k)(d)||(0,h.$bl)(d))return d;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const d=await this.j(o);if((0,h.$al)(d)||(0,h.$0k)(d))return d;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,d){try{return await this.s(o,d)}catch(i){throw(0,h.$kl)(i)===h.FileSystemProviderErrorCode.FileNotFound?new h.$pl((0,f.localize)(2,null,this.sb(o)),h.FileOperationResult.FILE_NOT_FOUND):(0,h.$il)(i)}}async s(o,d){const i=await this.j(o),c=this.S(i),u=d?.resolveTo,k=d?.resolveSingleChildDescendants,I=d?.resolveMetadata,C=await i.stat(o);let T;return this.t(i,o,C,void 0,!!I,(O,P)=>(T||(T=E.$Gi.forUris(()=>!c),T.set(o,!0),u&&T.fill(!0,u)),T.get(O.resource)||T.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&k?P===1:!1))}async t(o,d,i,c,u,k){const{providerExtUri:I}=this.R(o),C={resource:d,name:I.basename(d),isFile:(i.type&h.FileType.File)!==0,isDirectory:(i.type&h.FileType.Directory)!==0,isSymbolicLink:(i.type&h.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&h.FilePermission.Readonly)||!!(o.capabilities&h.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&h.FilePermission.Locked),etag:(0,h.$Al)({mtime:i.mtime,size:i.size}),children:void 0};if(C.isDirectory&&k(C,c)){try{const T=await o.readdir(d),O=await r.Promises.settled(T.map(async([P,V])=>{try{const Q=I.joinPath(d,P),ie=u?await o.stat(Q):{type:V};return await this.t(o,Q,ie,T.length,u,k)}catch(Q){return this.b.trace(Q),null}}));C.children=(0,n.$Hb)(O)}catch(T){this.b.trace(T),C.children=[]}return C}return C}async resolveAll(o){return r.Promises.settled(o.map(async d=>{try{return{stat:await this.s(d.resource,d.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const d=await this.j(o),i=await d.stat(o);return this.t(d,o,i,void 0,!0,()=>!1)}async exists(o){const d=await this.j(o);try{return!!await d.stat(o)}catch{return!1}}async canCreateFile(o,d){try{await this.u(o,d)}catch(i){return i}return!0}async u(o,d){if(!d?.overwrite&&await this.exists(o))throw new h.$pl((0,f.localize)(3,null,this.sb(o)),h.FileOperationResult.FILE_MODIFIED_SINCE,d)}async createFile(o,d=S.$Je.fromString(""),i){await this.u(o,i);const c=await this.writeFile(o,d);return this.r.fire(new h.$ml(o,h.FileOperation.CREATE,c)),c}async writeFile(o,d,i){const c=this.qb(await this.n(o),o),{providerExtUri:u}=this.R(c);let k=i;if((0,h.$dl)(c)&&!k?.atomic){const I=c.enforceAtomicWriteFile?.(o);I&&(k={...i,atomic:I})}try{await this.w(c,o,k)||await this.U(c,u.dirname(o));let C;if((0,h.$0k)(c)&&!(d instanceof S.$Je))if((0,a.$ve)(d)){const T=await(0,a.$Ce)(d,3);T.ended?C=S.$Je.concat(T.buffer):C=T}else C=(0,a.$ze)(d,T=>S.$Je.concat(T),3);else C=d;!(0,h.$al)(c)||(0,h.$0k)(c)&&C instanceof S.$Je||(0,h.$0k)(c)&&(0,h.$dl)(c)&&k?.atomic?await this.hb(c,o,k,C):await this.db(c,o,k,C instanceof S.$Je?(0,S.$Ue)(C):C),this.r.fire(new h.$ml(o,h.FileOperation.WRITE))}catch(I){throw new h.$pl((0,f.localize)(4,null,this.sb(o),(0,h.$il)(I).toString()),(0,h.$ll)(I),k)}return this.resolve(o,{resolveMetadata:!0})}async w(o,d,i){const c=!!i?.unlock;if(c&&!(o.capabilities&h.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,f.localize)(5,null,this.sb(d)));if(!!i?.atomic){if(!(o.capabilities&h.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,f.localize)(6,null,this.sb(d)));if(!(o.capabilities&h.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,f.localize)(7,null,this.sb(d)));if(c)throw new Error((0,f.localize)(8,null,this.sb(d)))}let k;try{k=await o.stat(d)}catch{return}if(k.type&h.FileType.Directory)throw new h.$pl((0,f.localize)(9,null,this.sb(d)),h.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(d,k),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==h.$zl&&typeof k.mtime=="number"&&typeof k.size=="number"&&i.mtime<k.mtime&&i.etag!==(0,h.$Al)({mtime:i.mtime,size:k.size}))throw new h.$pl((0,f.localize)(10,null),h.FileOperationResult.FILE_MODIFIED_SINCE,i);return k}async readFile(o,d,i){const c=await this.m(o);return d?.atomic?this.z(c,o,d,i):this.C(c,o,d,i)}async z(o,d,i,c){return new Promise((u,k)=>{this.cb.queueFor(d,async()=>{try{const I=await this.C(o,d,i,c);u(I)}catch(I){k(I)}},this.R(o).providerExtUri)})}async C(o,d,i,c){const u=await this.D(o,d,{...i,preferUnbuffered:!0},c);return{...u,value:await(0,S.$Ve)(u.value)}}async readFileStream(o,d,i){const c=await this.m(o);return this.D(c,o,d,i)}async D(o,d,i,c){const u=new D.$se(c);let k=i;(0,h.$cl)(o)&&o.enforceAtomicReadFile?.(d)&&(k={...i,atomic:!0});const I=this.J(d,k).then(T=>T,T=>{throw u.dispose(!0),T});let C;try{return typeof k?.etag=="string"&&k.etag!==h.$zl&&await I,k?.atomic&&(0,h.$cl)(o)||!((0,h.$al)(o)||(0,h.$bl)(o))||(0,h.$0k)(o)&&k?.preferUnbuffered?C=this.I(o,d,k):(0,h.$bl)(o)?C=this.G(o,d,u.token,k):C=this.H(o,d,u.token,k),C.on("end",()=>u.dispose()),C.on("error",()=>u.dispose()),{...await I,value:C}}catch(T){throw C&&await(0,a.$Ae)(C),this.F(T,d,k)}}F(o,d,i){const c=(0,f.localize)(11,null,this.sb(d),(0,h.$il)(o).toString());return o instanceof h.$rl?new h.$rl(c,o.stat,i):o instanceof h.$ql?new h.$ql(c,o.fileOperationResult,o.size,o.options):new h.$pl(c,(0,h.$ll)(o),i)}G(o,d,i,c=Object.create(null)){const u=o.readFileStream(d,c,i);return(0,a.$Ge)(u,{data:k=>k instanceof S.$Je?k:S.$Je.wrap(k),error:k=>this.F(k,d,c)},k=>S.$Je.concat(k))}H(o,d,i,c=Object.create(null)){const u=(0,S.$Ze)();return(0,g.$Pq)(o,d,u,k=>k,{...c,bufferSize:this.a,errorTransformer:k=>this.F(k,d,c)},i),u}I(o,d,i){const c=(0,a.$xe)(u=>S.$Je.concat(u));return(async()=>{try{let u;i?.atomic&&(0,h.$cl)(o)?u=await o.readFile(d,{atomic:!0}):u=await o.readFile(d),typeof i?.position=="number"&&(u=u.slice(i.position)),typeof i?.length=="number"&&(u=u.slice(0,i.length)),this.L(d,u.byteLength,i),c.end(S.$Je.wrap(u))}catch(u){c.error(u),c.end()}})(),c}async J(o,d){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new h.$pl((0,f.localize)(12,null,this.sb(o)),h.FileOperationResult.FILE_IS_DIRECTORY,d);if(typeof d?.etag=="string"&&d.etag!==h.$zl&&d.etag===i.etag)throw new h.$rl((0,f.localize)(13,null),i,d);return this.L(o,i.size,d),i}L(o,d,i){if(typeof i?.limits?.size=="number"&&d>i.limits.size)throw new h.$ql((0,f.localize)(14,null,this.sb(o)),h.FileOperationResult.FILE_TOO_LARGE,d,i)}async canMove(o,d,i){return this.M(o,d,"move",i)}async canCopy(o,d,i){return this.M(o,d,"copy",i)}async M(o,d,i,c){if(o.toString()!==d.toString())try{const u=i==="move"?this.qb(await this.n(o),o):await this.m(o),k=this.qb(await this.n(d),d);await this.Q(u,o,k,d,i,c)}catch(u){return u}return!0}async move(o,d,i){const c=this.qb(await this.n(o),o),u=this.qb(await this.n(d),d),k=await this.N(c,o,u,d,"move",!!i),I=await this.resolve(d,{resolveMetadata:!0});return this.r.fire(new h.$ml(o,k==="move"?h.FileOperation.MOVE:h.FileOperation.COPY,I)),I}async copy(o,d,i){const c=await this.m(o),u=this.qb(await this.n(d),d),k=await this.N(c,o,u,d,"copy",!!i),I=await this.resolve(d,{resolveMetadata:!0});return this.r.fire(new h.$ml(o,k==="copy"?h.FileOperation.COPY:h.FileOperation.MOVE,I)),I}async N(o,d,i,c,u,k){if(d.toString()===c.toString())return u;const{exists:I,isSameResourceWithDifferentPathCase:C}=await this.Q(o,d,i,c,u,k);if(I&&!C&&k&&await this.del(c,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(c)),u==="copy"){if(o===i&&(0,h.$$k)(o))await o.copy(d,c,{overwrite:k});else{const T=await this.resolve(d);T.isDirectory?await this.P(o,T,i,c):await this.O(o,d,i,c)}return u}else return o===i?(await o.rename(d,c,{overwrite:k}),u):(await this.N(o,d,i,c,"copy",k),await this.del(d,{recursive:!0}),"copy")}async O(o,d,i,c){if((0,h.$al)(o)&&(0,h.$al)(i))return this.jb(o,d,i,c);if((0,h.$al)(o)&&(0,h.$0k)(i))return this.pb(o,d,i,c);if((0,h.$0k)(o)&&(0,h.$al)(i))return this.nb(o,d,i,c);if((0,h.$0k)(o)&&(0,h.$0k)(i))return this.lb(o,d,i,c)}async P(o,d,i,c){await i.mkdir(c),Array.isArray(d.children)&&await r.Promises.settled(d.children.map(async u=>{const k=this.R(i).providerExtUri.joinPath(c,u.name);return u.isDirectory?this.P(o,await this.resolve(u.resource),i,k):this.O(o,u.resource,i,k)}))}async Q(o,d,i,c,u,k){let I=!1;if(o===i){const{providerExtUri:T,isPathCaseSensitive:O}=this.R(o);if(O||(I=T.isEqual(d,c)),I&&u==="copy")throw new Error((0,f.localize)(15,null,this.sb(d),this.sb(c)));if(!I&&T.isEqualOrParent(c,d))throw new Error((0,f.localize)(16,null,this.sb(d),this.sb(c)))}const C=await this.exists(c);if(C&&!I){if(!k)throw new h.$pl((0,f.localize)(17,null,this.sb(d),this.sb(c)),h.FileOperationResult.FILE_MOVE_CONFLICT);if(o===i){const{providerExtUri:T}=this.R(o);if(T.isEqualOrParent(d,c))throw new Error((0,f.localize)(18,null,this.sb(d),this.sb(c)))}}return{exists:C,isSameResourceWithDifferentPathCase:I}}R(o){const d=this.S(o);return{providerExtUri:d?b.$4g:b.$6g,isPathCaseSensitive:d}}S(o){return!!(o.capabilities&h.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(o){const d=this.qb(await this.j(o),o);await this.U(d,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new h.$ml(o,h.FileOperation.CREATE,i)),i}async U(o,d){const i=[],{providerExtUri:c}=this.R(o);for(;!c.isEqual(d,c.dirname(d));)try{if(!((await o.stat(d)).type&h.FileType.Directory))throw new Error((0,f.localize)(19,null,this.sb(d)));break}catch(u){if((0,h.$kl)(u)!==h.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(c.basename(d)),d=c.dirname(d)}for(let u=i.length-1;u>=0;u--){d=c.joinPath(d,i[u]);try{await o.mkdir(d)}catch(k){if((0,h.$kl)(k)!==h.FileSystemProviderErrorCode.FileExists)throw k}}}async canDelete(o,d){try{await this.W(o,d)}catch(i){return i}return!0}async W(o,d){const i=this.qb(await this.j(o),o),c=!!d?.useTrash;if(c&&!(i.capabilities&h.FileSystemProviderCapabilities.Trash))throw new Error((0,f.localize)(20,null,this.sb(o)));const u=d?.atomic;if(u&&!(i.capabilities&h.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,f.localize)(21,null,this.sb(o)));if(c&&u)throw new Error((0,f.localize)(22,null,this.sb(o)));let k;try{k=await i.stat(o)}catch{}if(k)this.rb(o,k);else throw new h.$pl((0,f.localize)(23,null,this.sb(o)),h.FileOperationResult.FILE_NOT_FOUND);if(!!!d?.recursive){const C=await this.resolve(o);if(C.isDirectory&&Array.isArray(C.children)&&C.children.length>0)throw new Error((0,f.localize)(24,null,this.sb(o)))}return i}async del(o,d){const i=await this.W(o,d);let c=d;if((0,h.$el)(i)&&!c?.atomic){const C=i.enforceAtomicDelete?.(o);C&&(c={...d,atomic:C})}const u=!!c?.useTrash,k=!!c?.recursive,I=c?.atomic??!1;await i.delete(o,{recursive:k,useTrash:u,atomic:I}),this.r.fire(new h.$ml(o,h.FileOperation.DELETE))}async cloneFile(o,d){const i=await this.j(o),c=this.qb(await this.n(d),d);if(!(i===c&&this.R(i).providerExtUri.isEqual(o,d)))return i===c&&(0,h.$_k)(i)?i.cloneFile(o,d):(await this.U(c,this.R(c).providerExtUri.dirname(d)),i===c&&(0,h.$$k)(i)?this.cb.queueFor(o,()=>i.copy(o,d,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,c,d),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,d){return this.watch(o,{...d,correlationId:$.ab++})}watch(o,d={recursive:!1,excludes:[]}){const i=new s.$Tc;let c=!1,u=()=>{c=!0};i.add((0,s.$Sc)(()=>u())),(async()=>{try{const I=await this.bb(o,d);c?(0,s.$Pc)(I):u=()=>(0,s.$Pc)(I)}catch(I){this.b.error(I)}})();const k=d.correlationId;if(typeof k=="number"){const I=i.add(new A.$he);return i.add(this.X.event(T=>{T.correlates(k)&&I.fire(T)})),{onDidChange:I.event,dispose:()=>i.dispose()}}return i}async bb(o,d){const i=await this.j(o),c=(0,R.$oj)([this.R(i).providerExtUri.getComparisonKey(o),d]);let u=this.$.get(c);return u||(u={count:0,disposable:i.watch(o,d)},this.$.set(c,u)),u.count+=1,(0,s.$Sc)(()=>{u&&(u.count--,u.count===0&&((0,s.$Pc)(u.disposable),this.$.delete(c)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,s.$Pc)(o.disposable);this.$.clear()}async db(o,d,i,c){return this.cb.queueFor(d,async()=>{const u=await o.open(d,{create:!0,unlock:i?.unlock??!1});try{(0,a.$ve)(c)||(0,a.$we)(c)?await this.eb(o,u,c):await this.fb(o,u,c)}catch(k){throw(0,h.$il)(k)}finally{await o.close(u)}},this.R(o).providerExtUri)}async eb(o,d,i){let c=0,u;if((0,a.$we)(i)){if(i.buffer.length>0){const k=S.$Je.concat(i.buffer);await this.gb(o,d,k,k.byteLength,c,0),c+=k.byteLength}if(i.ended)return;u=i.stream}else u=i;return new Promise((k,I)=>{(0,a.$Be)(u,{onData:async C=>{u.pause();try{await this.gb(o,d,C,C.byteLength,c,0)}catch(T){return I(T)}c+=C.byteLength,setTimeout(()=>u.resume())},onError:C=>I(C),onEnd:()=>k()})})}async fb(o,d,i){let c=0,u;for(;(u=i.read())!==null;)await this.gb(o,d,u,u.byteLength,c,0),c+=u.byteLength}async gb(o,d,i,c,u,k){let I=0;for(;I<c;){const C=await o.write(d,u+I,i.buffer,k+I,c-I);I+=C}}async hb(o,d,i,c){return this.cb.queueFor(d,()=>this.ib(o,d,i,c),this.R(o).providerExtUri)}async ib(o,d,i,c){let u;c instanceof S.$Je?u=c:(0,a.$ve)(c)?u=await(0,S.$Ve)(c):(0,a.$we)(c)?u=await(0,S.$We)(c):u=(0,S.$Te)(c),await o.writeFile(d,u.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,d,i,c){return this.cb.queueFor(c,()=>this.kb(o,d,i,c),this.R(i).providerExtUri)}async kb(o,d,i,c){let u,k;try{u=await o.open(d,{create:!1}),k=await i.open(c,{create:!0,unlock:!1});const I=S.$Je.alloc(this.a);let C=0,T=0,O=0;do O=await o.read(u,C,I.buffer,T,I.byteLength-T),await this.gb(i,k,I,O,C,T),C+=O,T+=O,T===I.byteLength&&(T=0);while(O>0)}catch(I){throw(0,h.$il)(I)}finally{await r.Promises.settled([typeof u=="number"?o.close(u):Promise.resolve(),typeof k=="number"?i.close(k):Promise.resolve()])}}async lb(o,d,i,c){return this.cb.queueFor(c,()=>this.mb(o,d,i,c),this.R(i).providerExtUri)}async mb(o,d,i,c){return i.writeFile(c,await o.readFile(d),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,d,i,c){return this.cb.queueFor(c,()=>this.ob(o,d,i,c),this.R(i).providerExtUri)}async ob(o,d,i,c){const u=await i.open(c,{create:!0,unlock:!1});try{const k=await o.readFile(d);await this.gb(i,u,S.$Je.wrap(k),k.byteLength,0,0)}catch(k){throw(0,h.$il)(k)}finally{await i.close(u)}}async pb(o,d,i,c){const u=await(0,S.$Ve)(this.H(o,d,D.CancellationToken.None));await this.hb(i,c,void 0,u)}qb(o,d){if(o.capabilities&h.FileSystemProviderCapabilities.Readonly)throw new h.$pl((0,f.localize)(25,null,this.sb(d)),h.FileOperationResult.FILE_PERMISSION_DENIED);return o}rb(o,d){if((d.permissions??0)&h.FilePermission.Readonly)throw new h.$pl((0,f.localize)(26,null,this.sb(o)),h.FileOperationResult.FILE_PERMISSION_DENIED)}sb(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};e.$Qq=l,e.$Qq=l=$=Ue([Fe(0,w.$7j)],l)}),define(Ee[72],Se([1,0,31,336,14,26,15,6,37,2,9,3,20,56,25,217,16,120,257,42,255,254]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0,(()=>{try{(0,r.gracefulify)(n)}catch(o){console.error(`Error enabling graceful-fs: ${(0,m.$lj)(o)}`)}})();class t extends w.$3q{static{this.L=!1}constructor(d,i){super(d,i),this.onDidChangeCapabilities=R.Event.None,this.P=new D.$Ac(c=>p.$5g.getComparisonKey(c)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=h.FileSystemProviderCapabilities.FileReadWrite|h.FileSystemProviderCapabilities.FileOpenReadWriteClose|h.FileSystemProviderCapabilities.FileReadStream|h.FileSystemProviderCapabilities.FileFolderCopy|h.FileSystemProviderCapabilities.FileWriteUnlock|h.FileSystemProviderCapabilities.FileAtomicRead|h.FileSystemProviderCapabilities.FileAtomicWrite|h.FileSystemProviderCapabilities.FileAtomicDelete|h.FileSystemProviderCapabilities.FileClone,y.$k&&(this.M|=h.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(d){try{const{stat:i,symbolicLink:c}=await a.SymlinkSupport.stat(this.I(d));return{type:this.O(i,c),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:h.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const i=await a.Promises.readdir(this.I(d),{withFileTypes:!0}),c=[];return await Promise.all(i.map(async u=>{try{let k;u.isSymbolicLink()?k=(await this.stat((0,p.$bh)(d,u.name))).type:k=this.O(u),c.push([u.name,k])}catch(k){this.a.trace(k)}})),c}catch(i){throw this.hb(i)}}O(d,i){let c;return i?.dangling?c=h.FileType.Unknown:d.isFile()?c=h.FileType.File:d.isDirectory()?c=h.FileType.Directory:c=h.FileType.Unknown,i&&(c|=h.FileType.SymbolicLink),c}async Q(d){const i=this.I(d);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let c;for(;c=this.P.get(d);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await c.wait();const u=new S.$zh;return this.P.set(d,u),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,s.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(d)===u&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(d)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(d,i){let c;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(d)})`),c=await this.Q(d));const u=this.I(d);return await a.Promises.readFile(u)}catch(u){throw this.hb(u)}finally{c?.dispose()}}R(d){t.L&&this.a.trace(d)}readFileStream(d,i,c){const u=(0,b.$xe)(k=>A.$Je.concat(k.map(I=>A.$Je.wrap(I))).buffer);return(0,g.$Pq)(this,d,u,k=>k.buffer,{...i,bufferSize:256*1024},c),u}async writeFile(d,i,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.S(d)?this.U(d,(0,p.$bh)((0,p.$ah)(d),`${(0,p.$$g)(d)}${c.atomic.postfix}`),i,c):this.W(d,i,c)}async S(d){try{const i=this.I(d),{symbolicLink:c}=await a.SymlinkSupport.stat(i);if(c)return!1}catch{}return!0}async U(d,i,c,u){const k=new s.$Tc;try{k.add(await this.Q(d)),k.add(await this.Q(i)),await this.W(i,c,u,!0);try{await this.rename(i,d,{overwrite:!0})}catch(I){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{k.dispose()}}async W(d,i,c,u){let k;try{const I=this.I(d);if(!c.create||!c.overwrite){if(await a.Promises.exists(I)){if(!c.overwrite)throw(0,h.$hl)((0,f.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,h.$hl)((0,f.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(d,{create:!0,unlock:c.unlock},u),await this.write(k,0,i,0,i.byteLength)}catch(I){throw await this.ib(d,I)}finally{typeof k=="number"&&await this.close(k)}}static{this.$=!0}static configureFlushOnWrite(d){t.$=d}async open(d,i,c){const u=this.I(d);let k;(0,h.$8k)(i)&&!c&&(k=await this.Q(d));let I;try{if((0,h.$8k)(i)&&i.unlock)try{const{stat:T}=await a.SymlinkSupport.stat(u);T.mode&128||await a.Promises.chmod(u,T.mode|128)}catch(T){T.code!=="ENOENT"&&this.a.trace(T)}let C;if((0,h.$8k)(i)){if(y.$i)try{await a.Promises.truncate(u,0),C="r+"}catch(T){T.code!=="ENOENT"&&this.a.trace(T)}C||(C="w")}else C="r";I=await a.Promises.open(u,C)}catch(C){throw k?.dispose(),(0,h.$8k)(i)?await this.ib(d,C):this.hb(C)}if(this.X.set(I,0),(0,h.$8k)(i)&&this.Z.set(I,d),k){const C=this.Y.get(I);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${u})`),this.Y.set(I,k),C&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${u})`),C.dispose())}return I}async close(d){const i=this.Y.get(d);try{if(this.X.delete(d),this.Z.delete(d)&&t.$)try{await a.Promises.fdatasync(d)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await a.Promises.close(d)}catch(c){throw this.hb(c)}finally{i&&(this.Y.get(d)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.Y.delete(d)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),i.dispose())}}async read(d,i,c,u,k){const I=this.ab(d,i);let C=null;try{C=(await a.Promises.read(d,c,u,k,I)).bytesRead}catch(T){throw this.hb(T)}finally{this.bb(d,I,C)}return C}ab(d,i){return i===this.X.get(d)?null:i}bb(d,i,c){const u=this.X.get(d);typeof u=="number"&&(typeof i=="number"||(typeof c=="number"?this.X.set(d,u+c):this.X.delete(d)))}async write(d,i,c,u,k){return(0,S.$Uh)(()=>this.cb(d,i,c,u,k),100,3)}async cb(d,i,c,u,k){const I=this.ab(d,i);let C=null;try{C=(await a.Promises.write(d,c,u,k,I)).bytesWritten}catch(T){throw await this.ib(this.Z.get(d),T)}finally{this.bb(d,I,C)}return C}async mkdir(d){try{await a.Promises.mkdir(this.I(d))}catch(i){throw this.hb(i)}}async delete(d,i){try{const c=this.I(d);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,E.$jc)((0,E.$mc)(c),`${(0,E.$nc)(c)}${i.atomic.postfix}`)),await a.Promises.rm(c,a.RimRafMode.MOVE,u)}else try{await a.Promises.unlink(c)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let k=!1;try{const{stat:I,symbolicLink:C}=await a.SymlinkSupport.stat(c);k=I.isDirectory()&&!C}catch{}if(k)await a.Promises.rmdir(c);else throw u}else throw u}}catch(c){throw this.hb(c)}}async rename(d,i,c){const u=this.I(d),k=this.I(i);if(u!==k)try{await this.db(d,i,"move",c.overwrite),await a.Promises.rename(u,k)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,f.localize)(2,null,(0,E.$nc)(u),(0,E.$nc)((0,E.$mc)(k)),I.toString()))),this.hb(I)}}async copy(d,i,c){const u=this.I(d),k=this.I(i);if(u!==k)try{await this.db(d,i,"copy",c.overwrite),await a.Promises.copy(u,k,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,f.localize)(3,null,(0,E.$nc)(u),(0,E.$nc)((0,E.$mc)(k)),I.toString()))),this.hb(I)}}async db(d,i,c,u){const k=this.I(d),I=this.I(i);let C=!1;if(!!(this.capabilities&h.FileSystemProviderCapabilities.PathCaseSensitive)||(C=(0,v.$yg)(k,I,!0)),C){if(c==="copy")throw(0,h.$hl)((0,f.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const O=await this.N(d);if(!O)throw(0,h.$hl)((0,f.localize)(5,null),h.FileSystemProviderErrorCode.FileNotFound);const P=await this.N(i);if(P){if(!u)throw(0,h.$hl)((0,f.localize)(6,null),h.FileSystemProviderErrorCode.FileExists);O.type&h.FileType.File&&P.type&h.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,i){return this.eb(d,i,!1)}async eb(d,i,c){const u=this.I(d),k=this.I(i),I=!!(this.capabilities&h.FileSystemProviderCapabilities.PathCaseSensitive);if((0,v.$yg)(u,k,!I))return;const C=new s.$Tc;try{C.add(await this.Q(d)),C.add(await this.Q(i)),c&&await a.Promises.mkdir((0,E.$mc)(k),{recursive:!0}),await a.Promises.copyFile(u,k)}catch(T){if(T.code==="ENOENT"&&!c)return this.eb(d,i,!0);throw this.hb(T)}finally{C.dispose()}}t(d,i,c){return new $.$0q(u=>d(u),u=>i(u),c)}F(d,i,c){return new l.$gr(u=>d(u),u=>i(u),c)}hb(d){if(d instanceof h.$gl)return d;let i=d,c;switch(d.code){case"ENOENT":c=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=h.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=h.FileSystemProviderErrorCode.Unknown;break;default:c=h.FileSystemProviderErrorCode.Unknown}return(0,h.$hl)(i,c)}async ib(d,i){let c=this.hb(i);if(d&&c.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await a.SymlinkSupport.stat(this.I(d));u.mode&128||(c=(0,h.$hl)(i,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return c}}e.$hr=t}),define(Ee[258],Se([1,0,6,72,2,15,56,19]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=e.$Rs=void 0;class v extends S.$Uc{constructor(y,p){super(),this.a=y,this.b=p,this.F=new Map,this.G=new Map}call(y,p,b){const a=this.c(y);switch(p){case"stat":return this.g(a,b[0]);case"readdir":return this.h(a,b[0]);case"open":return this.r(a,b[0],b[1]);case"close":return this.s(b[0]);case"read":return this.t(b[0],b[1],b[2]);case"readFile":return this.j(a,b[0],b[1]);case"write":return this.u(b[0],b[1],b[2],b[3],b[4]);case"writeFile":return this.n(a,b[0],b[1],b[2]);case"rename":return this.z(a,b[0],b[1],b[2]);case"copy":return this.C(a,b[0],b[1],b[2]);case"cloneFile":return this.D(a,b[0],b[1]);case"mkdir":return this.w(a,b[0]);case"delete":return this.y(a,b[0],b[1]);case"watch":return this.I(a,b[0],b[1],b[2],b[3]);case"unwatch":return this.J(b[0],b[1])}throw new Error(`IPC Command ${p} not found`)}listen(y,p,b){const a=this.c(y);switch(p){case"fileChange":return this.H(a,b[0]);case"readFileStream":return this.m(a,b[0],b[1])}throw new Error(`Unknown event ${p}`)}g(y,p){const b=this.f(y,p,!0);return this.a.stat(b)}h(y,p){const b=this.f(y,p);return this.a.readdir(b)}async j(y,p,b){const a=this.f(y,p,!0),f=await this.a.readFile(a,b);return D.$Je.wrap(f)}m(y,p,b){const a=this.f(y,p,!0),f=new R.$se,h=new n.$he({onDidRemoveLastListener:()=>{f.cancel()}}),g=this.a.readFileStream(a,b,f.token);return(0,A.$Be)(g,{onData:w=>h.fire(D.$Je.wrap(w)),onError:w=>h.fire(w),onEnd:()=>{h.fire("end"),h.dispose(),f.dispose()}}),h.event}n(y,p,b,a){const f=this.f(y,p);return this.a.writeFile(f,b.buffer,a)}r(y,p,b){const a=this.f(y,p,!0);return this.a.open(a,b)}s(y){return this.a.close(y)}async t(y,p,b){const a=D.$Je.alloc(b),h=await this.a.read(y,p,a.buffer,0,b);return[a,h]}u(y,p,b,a,f){return this.a.write(y,p,b.buffer,a,f)}w(y,p){const b=this.f(y,p);return this.a.mkdir(b)}y(y,p,b){const a=this.f(y,p);return this.a.delete(a,b)}z(y,p,b,a){const f=this.f(y,p),h=this.f(y,b);return this.a.rename(f,h,a)}C(y,p,b,a){const f=this.f(y,p),h=this.f(y,b);return this.a.copy(f,h,a)}D(y,p,b){const a=this.f(y,p),f=this.f(y,b);return this.a.cloneFile(a,f)}H(y,p){const b=new n.$he({onWillAddFirstListener:()=>{this.F.set(p,this.L(y,b))},onDidRemoveLastListener:()=>{(0,S.$Pc)(this.F.get(p)),this.F.delete(p)}});return b.event}async I(y,p,b,a,f){const h=this.F.get(p);if(h){const g=this.f(y,a),w=h.watch(b,g,f);this.G.set(p+b,w)}}async J(y,p){const b=y+p,a=this.G.get(b);a&&((0,S.$Pc)(a),this.G.delete(b))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$Rs=v;class s extends S.$Uc{constructor(y,p,b,a){super(),this.c=y,this.f=b,this.g=a,this.a=new Map,this.b=this.B(new r.$hr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(p)}h(y){const p=this.B(new n.$he);this.B(p.event(b=>{y.fire(b.map(a=>({resource:this.c.transformOutgoingURI(a.resource),type:a.type,cId:a.cId})))})),this.B(this.b.onDidChangeFile(b=>p.fire(b))),this.B(this.b.onDidWatchError(b=>y.fire(b)))}j(y){}m(y){}watch(y,p,b){const a=this.m(this.g);return Array.isArray(a)&&(b.excludes=[...b.excludes,...a]),this.a.set(y,this.b.watch(p,b)),(0,S.$Sc)(()=>{(0,S.$Pc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$Ss=s}),define(Ee[123],Se([1,0,4,6,12,2]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=void 0;class A extends S.$fk{constructor(y,p,b,a,f){super(p,b,a),this.r=y,this.t=f,this.B(f.listen("onDidChangeLogLevel",y)(h=>{(0,S.$9j)(h)?super.setLogLevel(h):super.setLogLevel(n.URI.revive(h[0]),h[1])})),this.B(f.listen("onDidChangeVisibility",y)(([h,g])=>super.setVisibility(n.URI.revive(h),g))),this.B(f.listen("onDidChangeLoggers",y)(({added:h,removed:g})=>{for(const w of h)super.registerLogger({...w,resource:n.URI.revive(w.resource)});for(const w of g)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new S.$dk({log:(y,p)=>{this.t.call("consoleLog",[y,p])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,p){super.setLogLevel(y,p),this.t.call("setLogLevel",[y,p])}setVisibility(y,p){super.setVisibility(y,p),this.t.call("setVisibility",[this.n(y),p])}s(y,p,b){return new R(this.t,y,p,b,this.r)}static setLogLevel(y,p,b){return y.call("setLogLevel",[p,b])}}e.$hs=A;class R extends S.$ak{constructor(y,p,b,a,f){super(a?.logLevel==="always"),this.r=y,this.s=p,this.m=!1,this.n=[],this.setLevel(b),this.r.call("createLogger",[p,a,f]).then(()=>{this.u(this.n),this.m=!0})}g(y,p){const b=[[y,p]];this.m?this.u(b):this.n.push(...b)}u(y){this.r.call("log",[this.s,y])}}class v{constructor(y,p){this.a=y,this.b=p}listen(y,p){const b=this.b(y);switch(p){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,a=>({added:[...a.added].map(f=>this.c(f,b)),removed:[...a.removed].map(f=>this.c(f,b))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,a=>[b.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,a=>(0,S.$9j)(a)?a:[b.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${p}`)}async call(y,p,b){const a=this.b(y);switch(p){case"setLogLevel":return(0,S.$9j)(b[0])?this.a.setLogLevel(b[0]):this.a.setLogLevel(n.URI.revive(a.transformIncoming(b[0][0])),b[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(f=>this.c(f,a)))}throw new Error(`Call not found: ${p}`)}c(y,p){return{...y,resource:p.transformOutgoingURI(y.resource)}}}e.$is=v;class s extends D.$Uc{constructor(y,p){super(),p.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(b=>p.call("setLogLevel",[b]))),p.call("getRegisteredLoggers").then(b=>{for(const a of b)y.registerLogger({...a,resource:n.URI.revive(a.resource)})}),this.B(p.listen("onDidChangeVisibility")(([b,a])=>y.setVisibility(n.URI.revive(b),a))),this.B(p.listen("onDidChangeLoggers")(({added:b,removed:a})=>{for(const f of b)y.registerLogger({...f,resource:n.URI.revive(f.resource)});for(const f of a)y.deregisterLogger(f.resource)}))}}e.$js=s}),define(Ee[124],Se([1,0,2,12]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=void 0;class S extends n.$Uc{constructor(A,R=[]){super(),this.a=new r.$ek([A,...R]),this.B(A.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...R){this.a.trace(A,...R)}debug(A,...R){this.a.debug(A,...R)}info(A,...R){this.a.info(A,...R)}warn(A,...R){this.a.warn(A,...R)}error(A,...R){this.a.error(A,...R)}flush(){this.a.flush()}}e.$mQ=S}),define(Ee[259],Se([1,0,16,12]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;var S;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(S||(S={}));async function D(s,E,y,p,b){try{const a=await new Promise((h,g)=>{fe(["@vscode/spdlog"],h,g)});a.setFlushOn(S.Trace);const f=await a.createAsyncRotatingLogger(s,E,y,p);return b?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(a){console.error(a)}return null}function A(s,E,y){switch(E){case r.LogLevel.Trace:s.trace(y);break;case r.LogLevel.Debug:s.debug(y);break;case r.LogLevel.Info:s.info(y);break;case r.LogLevel.Warning:s.warn(y);break;case r.LogLevel.Error:s.error(y);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function R(s,E){switch(E){case r.LogLevel.Trace:s.setLevel(S.Trace);break;case r.LogLevel.Debug:s.setLevel(S.Debug);break;case r.LogLevel.Info:s.setLevel(S.Info);break;case r.LogLevel.Warning:s.setLevel(S.Warning);break;case r.LogLevel.Error:s.setLevel(S.Error);break;case r.LogLevel.Off:s.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${E}`)}}class v extends r.$ak{constructor(E,y,p,b,a){super(),this.m=[],this.setLevel(a),this.n=this.s(E,y,p,b),this.B(this.onDidChangeLogLevel(f=>{this.r&&R(this.r,f)}))}async s(E,y,p,b){const a=p?6:1,f=30/a*n.$Cl.MB,h=await D(E,y,f,a,b);if(h){this.r=h,R(this.r,this.getLevel());for(const{level:g,message:w}of this.m)A(this.r,g,w);this.m=[]}}g(E,y){this.r?A(this.r,E,y):this.getLevel()<=E&&this.m.push({level:E,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$bQ=v}),define(Ee[125],Se([1,0,22,12,259]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cQ=void 0;class D extends r.$fk{s(R,v,s){return new S.$bQ((0,n.$Wg)(),R.fsPath,!s?.donotRotate,!!s?.donotUseFormatters,v)}}e.$cQ=D}),define(Ee[260],Se([1,0,58,220,5]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(D||(e.MarkerTag=D={}));var A;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(v){function s(a,f){return f-a}v.compare=s;const E=Object.create(null);E[v.Error]=(0,r.localize)(0,null),E[v.Warning]=(0,r.localize)(1,null),E[v.Info]=(0,r.localize)(2,null);function y(a){return E[a]||""}v.toString=y;function p(a){switch(a){case n.default.Error:return v.Error;case n.default.Warning:return v.Warning;case n.default.Info:return v.Info;case n.default.Ignore:return v.Hint}}v.fromSeverity=p;function b(a){switch(a){case v.Error:return n.default.Error;case v.Warning:return n.default.Warning;case v.Info:return n.default.Info;case v.Hint:return n.default.Ignore}}v.toSeverity=b}(A||(e.MarkerSeverity=A={}));var R;(function(v){const s="";function E(p){return y(p,!0)}v.makeKey=E;function y(p,b){const a=[s];return p.source?a.push(p.source.replace("\xA6","\\\xA6")):a.push(s),p.code?typeof p.code=="string"?a.push(p.code.replace("\xA6","\\\xA6")):a.push(p.code.value.replace("\xA6","\\\xA6")):a.push(s),p.severity!==void 0&&p.severity!==null?a.push(A.toString(p.severity)):a.push(s),p.message&&b?a.push(p.message.replace("\xA6","\\\xA6")):a.push(s),p.startLineNumber!==void 0&&p.startLineNumber!==null?a.push(p.startLineNumber.toString()):a.push(s),p.startColumn!==void 0&&p.startColumn!==null?a.push(p.startColumn.toString()):a.push(s),p.endLineNumber!==void 0&&p.endLineNumber!==null?a.push(p.endLineNumber.toString()):a.push(s),p.endColumn!==void 0&&p.endColumn!==null?a.push(p.endColumn.toString()):a.push(s),a.push(s),a.join("\xA6")}v.makeKeyOptionalMessage=y})(R||(e.IMarkerData=R={})),e.$Gv=(0,S.$Ai)("markerService")}),define(Ee[73],Se([1,0,6,40,2,5]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=void 0,e.$lo=(0,D.$Ai)("policy");class A extends S.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$he),this.onDidChange=this.h.event}async updatePolicyDefinitions(s){const E=Object.keys(this.f).length;return this.f={...s,...this.f},E!==Object.keys(this.f).length&&await this.j(s),r.Iterable.reduce(this.g.entries(),(y,[p,b])=>({...y,[p]:b}),{})}getPolicyValue(s){return this.g.get(s)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(s,[E,y])=>({...s,[E]:{definition:y,value:this.g.get(E)}}),{})}}e.$mo=A;class R{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$no=R}),define(Ee[63],Se([1,0,33]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const D=S.context.configuration();if(D)r=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:D.version})}}else r={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-toolsai.prompty":{onFileOpen:[{pathGlob:"{**/*.prompty}",important:!1}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"vmware.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},"vmware.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.1}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","attributableCoverage"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","contribIssueReporter","terminalShellIntegration"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["activeComment","codiconDecoration","codeActionRanges","commentingRangeHint","commentReactor","commentThreadApplicability","contribAccessibilityHelpContent","contribCommentEditorActionsMenu","contribCommentPeekContext","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","contribEditorContentMenu","contribMultiDiffEditorMenus","contribShareMenu","diffCommand","fileComments","quickDiffProvider","shareProvider","tabInputTextMerge","tokenInformation","treeViewMarkdownMessage"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatParticipantAdditions","defaultChatParticipant","embeddings","chatVariableResolver","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","contribSourceControlInputBoxMenu","contribCommentEditorActionsMenu","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","newSymbolNamesProvider","findFiles2","extensionsAny","authLearnMore","testObserver","aiTextSearchProvider","documentFiltersExclusive","chatParticipantPrivate"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes","contribIssueReporter","debugVisualization"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookCellExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-azuretools.vscode-azure-github-copilot":["chatParticipantAdditions","embeddings","languageModelSystem"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"TeamsDevApp.ms-teams-vscode-extension":["chatParticipantAdditions","languageModelSystem"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com","https://raw.githubusercontent.com","https://private-user-images.githubusercontent.com","https://avatars.githubusercontent.com"],trustedExtensionAuthAccess:{github:["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],"github-enterprise":["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],microsoft:["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],"microsoft-sovereign-cloud":["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"]},trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})...",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},chatWelcomeView:{welcomeViewId:"copilot.welcome",welcomeViewTitle:"GitHub Copilot",welcomeViewContent:`You have access to [GitHub Copilot](command:extension.open?%5B%22github.copilot%22%5D), an AI-powered coding assistant, as a part of the Microsoft organization.
 Getting started with Copilot is easy - simply install the Copilot extension. [Learn more](https://aka.ms/copilot-overview)
[Install GitHub Copilot](command:workbench.extensions.installExtension?%5B%22github.copilot%22%5D)`},chatParticipantRegistry:"https://az764295.vo.msecnd.net/extensions/chat.json",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.90.0",sha256:"1317dd7d1ac50641c1534a3e957ecbc94349f4fbd897acb916da11eea3208a66",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.90.1",commit:"611f9bfce64f25108829dd295f54a6894e87339d",date:"2024-06-11T20:15:20.676Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(Ee[29],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,n.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"}),define(Ee[261],Se([1,0,14,19,2,5]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.ProgressLocation=e.$kw=void 0,e.$kw=(0,D.$Ai)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$lw=Object.freeze({total(){},worked(){},done(){}});class R{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$mw=R;class v{get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const b=this.d;this.d=()=>{b?.(),p()}}):Promise.resolve()}}e.$nw=v;let s=class extends S.$Uc{constructor(p,b){super(),this.a=new n.$Xh,b.withProgress(p,a=>(this.b=a,this.c&&a.report(this.c),this.a.p)),this.B((0,S.$Sc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$ow=s,e.$ow=s=Ue([Fe(1,e.$kw)],s);class E extends S.$Uc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new S.$Tc)}start(p){this.stop();const b=++this.a,a=new r.$se;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,S.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,S.$Sc)(()=>a.cancel())),this.b.add((0,S.$Sc)(()=>this.c?this.c.done():void 0)),{id:b,token:a.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$pw=E,e.$qw=(0,D.$Ai)("editorProgressService")}),define(Ee[38],Se([1,0,106,11]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=void 0;class S{constructor(){this.a=new Map}add(A,R){n.ok(r.$ag(A)),n.ok(r.$cg(R)),n.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,R)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$jo=new S}),define(Ee[126],Se([1,0,6,38]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=void 0,e.$ko={JSONContribution:"base.contributions.json"};function S(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class D{constructor(){this.b=new n.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,s){this.a[S(v)]=s,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const A=new D;r.$jo.add(e.$ko.JSONContribution,A)}),define(Ee[46],Se([1,0,18,6,11,201,27,126,38]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.ConfigurationScope=e.$oo=e.EditPresentationTypes=void 0,e.$zo=f,e.$Ao=h,e.$Bo=g,e.$Co=m,e.$Do=$;var s;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$oo={Configuration:"base.contributions.configuration"};var E;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo="vscode://schemas/settings/resourceLanguage",e.$wo="vscode://schemas/settings/configurationDefaults";const y=v.$jo.as(R.$ko.JSONContribution);class p{constructor(){this.h=new Set,this.i=new r.$he,this.onDidSchemaChange=this.i.event,this.j=new r.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$vo,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const d=new Set;this.n(t,o,d),y.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const o=new Set;this.o(t,o),y.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const d=new Set;this.o(o,d),this.n(t,!1,d),y.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const d=[];for(const{overrides:i,source:c}of t)for(const u in i)if(o.add(u),e.$yo.test(u)){const k=this.a.get(u),I=k?.valuesSources??new Map;if(c)for(const P of Object.keys(i[u]))I.set(P,c);const C={...k?.value||{},...i[u]};this.a.set(u,{source:c,value:C,valuesSources:I});const T=(0,A.$ej)(u),O={type:"object",default:C,description:D.localize(1,null,T),$ref:e.$vo,defaultDefaultValue:C,source:S.$ag(c)?void 0:c,defaultValueSource:c};d.push(...f(u)),this.d[u]=O,this.b.properties[u]=O}else{this.a.set(u,{value:i[u],source:c});const k=this.d[u];k&&(this.w(u,k),this.r(u,k))}this.m(d)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:d,source:i}of t)for(const c in d){const u=this.a.get(c),k=S.$ag(i)?i:i?.id,I=S.$ag(u?.source)?u?.source:u?.source?.id;if(k===I)if(o.add(c),this.a.delete(c),e.$yo.test(c))delete this.d[c],delete this.b.properties[c];else{const C=this.d[c];C&&(this.w(c,C),this.r(c,C))}}this.u()}deltaConfiguration(t){let o=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,d){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,d),this.c.push(i),this.q(i)})}o(t,o){const d=i=>{if(i.properties)for(const c in i.properties){o.add(c);const u=this.d[c];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[c],this.s(c,i.properties[c])}i.allOf?.forEach(c=>d(c))};for(const i of t){d(i);const c=this.c.indexOf(i);c!==-1&&this.c.splice(c,1)}}p(t,o=!0,d,i,c=E.WINDOW,u){c=S.$jg(t.scope)?c:t.scope;const k=t.properties;if(k)for(const C in k){const T=k[C];if(o&&m(C,T)){delete k[C];continue}if(T.source=d,T.defaultDefaultValue=k[C].default,this.w(C,T),e.$yo.test(C)?T.scope=void 0:(T.scope=S.$jg(T.scope)?c:T.scope,T.restricted=S.$jg(T.restricted)?!!i?.includes(C):T.restricted),k[C].hasOwnProperty("included")&&!k[C].included){this.f[C]=k[C],delete k[C];continue}else this.d[C]=k[C],k[C].policy?.name&&this.e.set(k[C].policy.name,C);!k[C].deprecationMessage&&k[C].markdownDeprecationMessage&&(k[C].deprecationMessage=k[C].markdownDeprecationMessage),u.add(C)}const I=t.allOf;if(I)for(const C of I)this.p(C,o,d,i,c,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=d=>{const i=d.properties;if(i)for(const u in i)this.r(u,i[u]);d.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$po.properties[t]=o,o.scope){case E.APPLICATION:e.$qo.properties[t]=o;break;case E.MACHINE:e.$ro.properties[t]=o;break;case E.MACHINE_OVERRIDABLE:e.$so.properties[t]=o;break;case E.WINDOW:e.$to.properties[t]=o;break;case E.RESOURCE:e.$uo.properties[t]=o;break;case E.LANGUAGE_OVERRIDABLE:e.$uo.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$po.properties[t],o.scope){case E.APPLICATION:delete e.$qo.properties[t];break;case E.MACHINE:delete e.$ro.properties[t];break;case E.MACHINE_OVERRIDABLE:delete e.$so.properties[t];break;case E.WINDOW:delete e.$to.properties[t];break;case E.RESOURCE:case E.LANGUAGE_OVERRIDABLE:delete e.$uo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,d={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.$vo};this.w(o,d),e.$po.properties[o]=d,e.$qo.properties[o]=d,e.$ro.properties[o]=d,e.$so.properties[o]=d,e.$to.properties[o]=d,e.$uo.properties[o]=d}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.$vo};e.$po.patternProperties[e.$xo]=t,e.$qo.patternProperties[e.$xo]=t,e.$ro.patternProperties[e.$xo]=t,e.$so.patternProperties[e.$xo]=t,e.$to.patternProperties[e.$xo]=t,e.$uo.patternProperties[e.$xo]=t,this.i.fire()}w(t,o){const d=this.a.get(t);let i=d?.value,c=d?.source;S.$hg(i)&&(i=o.defaultDefaultValue,c=void 0),S.$hg(i)&&(i=g(o.type)),o.default=i,o.defaultValueSource=c}}const b="\\[([^\\]]+)\\]",a=new RegExp(b,"g");e.$xo=`^(${b})+$`,e.$yo=new RegExp(e.$xo);function f(l){const t=[];if(e.$yo.test(l)){let o=a.exec(l);for(;o?.length;){const d=o[1].trim();d&&t.push(d),o=a.exec(l)}}return(0,n.$Mb)(t)}function h(l){return l.reduce((t,o)=>`${t}[${o}]`,"")}function g(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new p;v.$jo.add(e.$oo.Configuration,w);function m(l,t){return l.trim()?e.$yo.test(l)?D.localize(7,null,l):w.getConfigurationProperties()[l]!==void 0?D.localize(8,null,l):t.policy?.name&&w.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,l,t.policy?.name,w.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}function $(){const l=[],t=w.getConfigurationProperties();for(const o of Object.keys(t))l.push([o,t[o].scope]);return l.push(["launch",E.RESOURCE]),l.push(["task",E.RESOURCE]),l}}),define(Ee[127],Se([1,0,18,6,44,2,26,21,11,4,27,46,16,38]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Io=$;function a(d){return Object.isFrozen(d)?d:R.$0n(d)}class f{static createEmptyModel(i){return new f({},[],[],void 0,i)}constructor(i,c,u,k,I){this.b=i,this.c=c,this.d=u,this.raw=k,this.f=I,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(c=>{if(c instanceof f)return c;const u=new h("",this.f);return u.parseRaw(c),u.configurationModel});this.g=i.reduce((c,u)=>u===c?u:c.merge(u),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,E.$cj)(this.contents,i):this.contents}inspect(i,c){const u=this;return{get value(){return a(u.rawConfiguration.getValue(i))},get override(){return c?a(u.rawConfiguration.getOverrideValue(i,c)):void 0},get merged(){return a(c?u.rawConfiguration.override(c).getValue(i):u.rawConfiguration.getValue(i))},get overrides(){const k=[];for(const{contents:I,identifiers:C,keys:T}of u.rawConfiguration.overrides){const O=new f(I,T,[],void 0,u.f).getValue(i);O!==void 0&&k.push({identifiers:C,value:O})}return k.length?a(k):void 0}}}getOverrideValue(i,c){const u=this.j(c);return u?i?(0,E.$cj)(u,i):u:void 0}getKeysForOverrideIdentifier(i){const c=[];for(const u of this.overrides)u.identifiers.includes(i)&&c.push(...u.keys);return n.$Mb(c)}getAllOverrideIdentifiers(){const i=[];for(const c of this.overrides)i.push(...c.identifiers);return n.$Mb(i)}override(i){let c=this.a.get(i);return c||(c=this.h(i),this.a.set(i,c)),c}merge(...i){const c=R.$9n(this.contents),u=R.$9n(this.overrides),k=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const C of i)if(I.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(c,C.contents);for(const T of C.overrides){const[O]=u.filter(P=>n.$ub(P.identifiers,T.identifiers));O?(this.i(O.contents,T.contents),O.keys.push(...T.keys),O.keys=n.$Mb(O.keys)):u.push(R.$9n(T))}for(const T of C.keys)k.indexOf(T)===-1&&k.push(T)}return new f(c,k,u,I.every(C=>C instanceof f)?void 0:I,this.f)}h(i){const c=this.j(i);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const u={};for(const k of n.$Mb([...Object.keys(this.contents),...Object.keys(c)])){let I=this.contents[k];const C=c[k];C&&(typeof I=="object"&&typeof C=="object"?(I=R.$9n(I),this.i(I,C)):I=C),u[k]=I}return new f(u,this.keys,this.overrides,void 0,this.f)}i(i,c){for(const u of Object.keys(c)){if(u in i&&v.$cg(i[u])&&v.$cg(c[u])){this.i(i[u],c[u]);continue}i[u]=R.$9n(c[u])}}j(i){let c=null,u=null;const k=I=>{I&&(u?this.i(u,I):u=R.$9n(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===i?c=I.contents:I.identifiers.includes(i)&&k(I.contents);return k(c),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,c){this.k(i,c,!0)}setValue(i,c){this.k(i,c,!1)}removeValue(i){const c=this.keys.indexOf(i);c!==-1&&(this.keys.splice(c,1),(0,E.$bj)(this.contents,i),y.$yo.test(i)&&this.overrides.splice(this.overrides.findIndex(u=>n.$ub(u.identifiers,(0,y.$zo)(i))),1))}k(i,c,u){(0,E.$aj)(this.contents,i,c,k=>this.f.error(k)),u=u||this.keys.indexOf(i)===-1,u&&this.keys.push(i),y.$yo.test(i)&&this.overrides.push({identifiers:(0,y.$zo)(i),keys:Object.keys(this.contents[i]),contents:(0,E.$_i)(this.contents[i],k=>this.f.error(k))})}}e.$Eo=f;class h{constructor(i,c){this.f=i,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,c){if(!v.$jg(i)){const u=this.h(i);this.parseRaw(u,c)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,c){this.a=i;const{contents:u,keys:k,overrides:I,restricted:C,hasExcludedProperties:T}=this.i(i,c);this.b=new f(u,k,I,T?[i]:void 0,this.g),this.c=C||[]}h(i){let c={},u=null,k=[];const I=[],C=[];function T(P){Array.isArray(k)?k.push(P):u!==null&&(k[u]=P)}const O={onObjectBegin:()=>{const P={};T(P),I.push(k),k=P,u=null},onObjectProperty:P=>{u=P},onObjectEnd:()=>{k=I.pop()},onArrayBegin:()=>{const P=[];T(P),I.push(k),k=P,u=null},onArrayEnd:()=>{k=I.pop()},onLiteralValue:T,onError:(P,V,Q)=>{C.push({error:P,offset:V,length:Q})}};if(i)try{S.$Wn(i,O),c=k[0]||{}}catch(P){this.g.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return c}i(i,c){const u=b.$jo.as(y.$oo.Configuration).getConfigurationProperties(),k=this.j(i,u,!0,c);i=k.raw;const I=(0,E.$_i)(i,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`)),C=Object.keys(i),T=this.l(i,O=>this.g.error(`Conflict in settings file ${this.f}: ${O}`));return{contents:I,keys:C,overrides:T,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(i,c,u,k){let I=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:I};const C={},T=[];for(const O in i)if(y.$yo.test(O)&&u){const P=this.j(i[O],c,!1,k);C[O]=P.raw,I=I||P.hasExcludedProperties,T.push(...P.restricted)}else{const P=c[O],V=P?typeof P.scope<"u"?P.scope:y.ConfigurationScope.WINDOW:void 0;P?.restricted&&T.push(O),!k.exclude?.includes(O)&&(k.include?.includes(O)||(V===void 0||k.scopes===void 0||k.scopes.includes(V))&&!(k.skipRestricted&&P?.restricted))?C[O]=i[O]:I=!0}return{raw:C,restricted:T,hasExcludedProperties:I}}l(i,c){const u=[];for(const k of Object.keys(i))if(y.$yo.test(k)){const I={};for(const C in i[k])I[C]=i[k][C];u.push({identifiers:(0,y.$zo)(k),keys:Object.keys(I),contents:(0,E.$_i)(I,c)})}return u}}e.$Fo=h;class g extends D.$Uc{constructor(i,c,u,k,I){super(),this.c=i,this.f=c,this.g=k,this.h=I,this.b=this.B(new r.$he),this.onDidChange=this.b.event,this.a=new h(this.c.toString(),I),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(p.FileOperation.CREATE)||C.isOperation(p.FileOperation.COPY)||C.isOperation(p.FileOperation.DELETE)||C.isOperation(p.FileOperation.WRITE))&&u.isEqual(C.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Go=g;class w{constructor(i,c,u,k,I,C,T,O,P,V,Q,ie,re){this.a=i,this.b=c,this.c=u,this.overrideIdentifiers=k,this.d=I,this.f=C,this.g=T,this.h=O,this.i=P,this.j=V,this.k=Q,this.l=ie,this.m=re}get value(){return a(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class m{constructor(i,c,u,k,I,C,T,O,P,V){this.j=i,this.l=c,this.m=u,this.n=k,this.p=I,this.q=C,this.r=T,this.s=O,this.t=P,this.u=V,this.h=null,this.i=new A.$Ac,this.v=null}getValue(i,c,u){return this.w(i,c,u).getValue(i)}updateValue(i,c,u={}){let k;u.resource?(k=this.t.get(u.resource),k||(k=f.createEmptyModel(this.u),this.t.set(u.resource,k))):k=this.s,c===void 0?k.removeValue(i):k.setValue(i,c),u.resource||(this.h=null)}inspect(i,c,u){const k=this.w(i,c,u),I=this.A(c.resource,u),C=c.resource?this.t.get(c.resource)||this.s:this.s,T=new Set;for(const O of k.overrides)for(const P of O.identifiers)k.getOverrideValue(i,P)!==void 0&&T.add(P);return new w(i,c,k.getValue(i),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,I||void 0,C)}keys(i){const c=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,c){this.r.set(i,c),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,c){const u=[];if(!c){const{added:k,updated:I,removed:C}=t(this.j,i);c=[...k,...I,...C]}for(const k of c)for(const I of(0,y.$zo)(k)){const C=this.j.getKeysForOverrideIdentifier(I),T=i.getKeysForOverrideIdentifier(I),O=[...T.filter(P=>C.indexOf(P)===-1),...C.filter(P=>T.indexOf(P)===-1),...C.filter(P=>!R.$ao(this.j.override(I).getValue(P),i.override(I).getValue(P)))];u.push([I,O])}return this.updateDefaultConfiguration(i),{keys:c,overrides:u}}compareAndUpdatePolicyConfiguration(i){const{added:c,updated:u,removed:k}=t(this.l,i),I=[...c,...u,...k];return I.length&&this.updatePolicyConfiguration(i),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:c,updated:u,removed:k,overrides:I}=t(this.applicationConfiguration,i),C=[...c,...u,...k];return C.length&&this.updateApplicationConfiguration(i),{keys:C,overrides:I}}compareAndUpdateLocalUserConfiguration(i){const{added:c,updated:u,removed:k,overrides:I}=t(this.localUserConfiguration,i),C=[...c,...u,...k];return C.length&&this.updateLocalUserConfiguration(i),{keys:C,overrides:I}}compareAndUpdateRemoteUserConfiguration(i){const{added:c,updated:u,removed:k,overrides:I}=t(this.remoteUserConfiguration,i),C=[...c,...u,...k];return C.length&&this.updateRemoteUserConfiguration(i),{keys:C,overrides:I}}compareAndUpdateWorkspaceConfiguration(i){const{added:c,updated:u,removed:k,overrides:I}=t(this.workspaceConfiguration,i),C=[...c,...u,...k];return C.length&&this.updateWorkspaceConfiguration(i),{keys:C,overrides:I}}compareAndUpdateFolderConfiguration(i,c){const u=this.folderConfigurations.get(i),{added:k,updated:I,removed:C,overrides:T}=t(u,c),O=[...k,...I,...C];return(O.length||!u)&&this.updateFolderConfiguration(i,c),{keys:O,overrides:T}}compareAndDeleteFolderConfiguration(i){const c=this.folderConfigurations.get(i);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:u,updated:k,removed:I,overrides:C}=t(c,void 0);return{keys:[...u,...k,...I],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,c,u){let k=this.x(c,u);return c.overrideIdentifier&&(k=k.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(k=k.merge(this.l)),k}x({resource:i},c){let u=this.y();if(c&&i){const k=c.getFolder(i);k&&(u=this.z(k.uri)||u);const I=this.t.get(i);I&&(u=u.merge(I))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let c=this.i.get(i);if(!c){const u=this.y(),k=this.r.get(i);k?(c=u.merge(k),this.i.set(i,c)):c=u}return c}A(i,c){if(c&&i){const u=c.getFolder(i);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,c)=>{const{contents:u,overrides:k,keys:I}=this.r.get(c);return i.push([c,{contents:u,overrides:k,keys:I}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(c=>i.add(c)),this.userConfiguration.keys.forEach(c=>i.add(c)),this.q.keys.forEach(c=>i.add(c)),this.r.forEach(c=>c.keys.forEach(u=>i.add(u))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>i.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(u=>i.add(u))),[...i.values()]}D(i){const c=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(u=>c.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>c.add(u)),this.q.getKeysForOverrideIdentifier(i).forEach(u=>c.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(i).forEach(k=>c.add(k))),[...c.values()]}static parse(i,c){const u=this.E(i.defaults,c),k=this.E(i.policy,c),I=this.E(i.application,c),C=this.E(i.user,c),T=this.E(i.workspace,c),O=i.folders.reduce((P,V)=>(P.set(s.URI.revive(V[0]),this.E(V[1],c)),P),new A.$Ac);return new m(u,k,I,C,f.createEmptyModel(c),T,O,f.createEmptyModel(c),new A.$Ac,c)}static E(i,c){return new f(i.contents,i.keys,i.overrides,void 0,c)}}e.$Ho=m;function $(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const i=new Set,c=new Map;for(const k of d)k.keys.forEach(I=>i.add(I)),k.overrides.forEach(([I,C])=>{const T=(0,A.$xc)(c,I,new Set);C.forEach(O=>T.add(O))});const u=[];return c.forEach((k,I)=>u.push([I,[...k.values()]])),{keys:[...i.values()],overrides:u}}class l{constructor(i,c,u,k,I){this.change=i,this.f=c,this.g=u,this.h=k,this.i=I,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of i.keys)this.affectedKeys.add(C);for(const[,C]of i.overrides)for(const T of C)this.affectedKeys.add(T);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=m.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,c){const u=this.a+i,k=this.d.indexOf(u);if(k<0)return!1;const I=k+u.length;if(I>=this.d.length)return!1;const C=this.d.charCodeAt(I);if(C!==this.b&&C!==this.c)return!1;if(c){const T=this.previousConfiguration?this.previousConfiguration.getValue(i,c,this.f?.workspace):void 0,O=this.g.getValue(i,c,this.h);return!R.$ao(T,O)}return!0}}e.$Jo=l;function t(d,i){const{added:c,removed:u,updated:k}=o(i?.rawConfiguration,d?.rawConfiguration),I=[],C=d?.getAllOverrideIdentifiers()||[],T=i?.getAllOverrideIdentifiers()||[];if(i){const O=T.filter(P=>!C.includes(P));for(const P of O)I.push([P,i.getKeysForOverrideIdentifier(P)])}if(d){const O=C.filter(P=>!T.includes(P));for(const P of O)I.push([P,d.getKeysForOverrideIdentifier(P)])}if(i&&d){for(const O of C)if(T.includes(O)){const P=o({contents:d.getOverrideValue(void 0,O)||{},keys:d.getKeysForOverrideIdentifier(O)},{contents:i.getOverrideValue(void 0,O)||{},keys:i.getKeysForOverrideIdentifier(O)});I.push([O,[...P.added,...P.removed,...P.updated]])}}return{added:c,removed:u,updated:k,overrides:I}}function o(d,i){const c=d?i?d.keys.filter(I=>i.keys.indexOf(I)===-1):[...d.keys]:[],u=i?d?i.keys.filter(I=>d.keys.indexOf(I)===-1):[...i.keys]:[],k=[];if(d&&i){for(const I of i.keys)if(d.keys.indexOf(I)!==-1){const C=(0,E.$cj)(i.contents,I),T=(0,E.$cj)(d.contents,I);R.$ao(C,T)||k.push(I)}}return{added:c,removed:u,updated:k}}}),define(Ee[262],Se([1,0,18,6,2,21,11,127,46,12,73,38]),function(fe,e,n,r,S,D,A,R,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=void 0;class p extends S.$Uc{get configurationModel(){return this.b}constructor(h){super(),this.c=h,this.a=this.B(new r.$he),this.onDidChangeConfiguration=this.a.event,this.b=R.$Eo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(y.$jo.as(v.$oo.Configuration).onDidUpdateConfiguration(({properties:h,defaultsOverrides:g})=>this.f(Array.from(h),g))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(h,g){this.j(h,y.$jo.as(v.$oo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:h})}g(){return{}}h(){this.b=R.$Eo.createEmptyModel(this.c);const h=y.$jo.as(v.$oo.Configuration).getConfigurationProperties();this.j(Object.keys(h),h)}j(h,g){const w=this.g();for(const m of h){const $=w[m],l=g[m];$!==void 0?this.b.addValue(m,$):l?this.b.addValue(m,l.default):this.b.removeValue(m)}}}e.$Ko=p;class b{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=R.$Eo.createEmptyModel(new s.$hk)}async initialize(){return this.configurationModel}}e.$Lo=b;let a=class extends S.$Uc{get configurationModel(){return this.b}constructor(h,g,w){super(),this.c=h,this.f=g,this.g=w,this.a=this.B(new r.$he),this.onDidChangeConfiguration=this.a.event,this.b=R.$Eo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(h=>this.j(h))),this.B(this.c.onDidChangeConfiguration(async({properties:h})=>this.m(await this.h(h),!0))),this.b}async h(h){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",h);const g={},w=[],m=y.$jo.as(v.$oo.Configuration).getConfigurationProperties();for(const $ of h){const l=m[$];if(!l){w.push($);continue}if(l.policy){if(l.type!=="string"&&l.type!=="number"){this.g.warn(`Policy ${l.policy.name} has unsupported type ${l.type}`);continue}w.push($),g[l.policy.name]={type:l.type}}}return(0,A.$ng)(g)||await this.f.updatePolicyDefinitions(g),w}j(h){this.g.trace("PolicyConfiguration#onDidChangePolicies",h);const g=y.$jo.as(v.$oo.Configuration).getPolicyConfigurations(),w=(0,n.$Hb)(h.map(m=>g.get(m)));this.m(w,!0)}m(h,g){this.g.trace("PolicyConfiguration#update",h);const w=y.$jo.as(v.$oo.Configuration).getConfigurationProperties(),m=[],$=this.b.isEmpty();for(const l of h){const t=w[l]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);($?o!==void 0:!(0,D.$ao)(this.b.getValue(l),o))&&m.push([l,o])}else this.b.getValue(l)!==void 0&&m.push([l,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const l=this.b;this.b=R.$Eo.createEmptyModel(this.g);for(const t of l.keys)this.b.setValue(t,l.getValue(t));for(const[t,o]of m)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);g&&this.a.fire(this.b)}}};e.$Mo=a,e.$Mo=a=Ue([Fe(1,E.$lo),Fe(2,s.$7j)],a)}),define(Ee[128],Se([1,0,18,14,15,6,44,159,2,26,21,3,20,27,127,46,262,16,73]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0;class m extends v.$Uc{constructor(t,o,d,i){super(),this.m=t,this.n=i,this.h=this.B(new D.$he),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$Ko(i)),this.c=d instanceof w.$no?new h.$Lo:this.B(new h.$Mo(this.b,d,i)),this.f=this.B(new a.$Go(this.m,{},p.$5g,o,i)),this.a=new a.$Ho(this.b.configurationModel,this.c.configurationModel,a.$Eo.createEmptyModel(i),a.$Eo.createEmptyModel(i),a.$Eo.createEmptyModel(i),a.$Eo.createEmptyModel(i),new s.$Ac,a.$Eo.createEmptyModel(i),new s.$Ac,i),this.j=new $(t,o,this),this.g=this.B(new r.$Mh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:u})=>this.s(c,u))),this.B(this.c.onDidChangeConfiguration(c=>this.t(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[t,o,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new a.$Ho(t,o,a.$Eo.createEmptyModel(this.n),d,a.$Eo.createEmptyModel(this.n),a.$Eo.createEmptyModel(this.n),new s.$Ac,a.$Eo.createEmptyModel(this.n),new s.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(t,o){const d=typeof t=="string"?t:void 0,i=(0,b.$8i)(t)?t:(0,b.$8i)(o)?o:{};return this.a.getValue(d,i,void 0)}async updateValue(t,o,d,i,c){const u=(0,b.$9i)(d)?d:(0,b.$8i)(d)?{resource:d.resource,overrideIdentifiers:d.overrideIdentifier?[d.overrideIdentifier]:void 0}:void 0,k=u?i:d;if(k!==void 0&&k!==b.ConfigurationTarget.USER_LOCAL&&k!==b.ConfigurationTarget.USER)throw new Error(`Unable to write ${t} to target ${k}.`);u?.overrideIdentifiers&&(u.overrideIdentifiers=(0,n.$Mb)(u.overrideIdentifiers),u.overrideIdentifiers=u.overrideIdentifiers.length?u.overrideIdentifiers:void 0);const I=this.inspect(t,{resource:u?.resource,overrideIdentifier:u?.overrideIdentifiers?u.overrideIdentifiers[0]:void 0});if(I.policyValue!==void 0)throw new Error(`Unable to write ${t} because it is configured in system policy.`);if((0,E.$ao)(o,I.defaultValue)&&(o=void 0),u?.overrideIdentifiers?.length&&u.overrideIdentifiers.length>1){const T=u.overrideIdentifiers.sort(),O=this.a.localUserConfiguration.overrides.find(P=>(0,n.$ub)([...P.identifiers].sort(),T));O&&(u.overrideIdentifiers=O.identifiers)}const C=u?.overrideIdentifiers?.length?[(0,f.$Ao)(u.overrideIdentifiers),t]:[t];await this.j.write(C,o),await this.reloadConfiguration()}inspect(t,o={}){return this.a.inspect(t,o,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const t=await this.f.loadConfiguration();this.r(t)}r(t){const o=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(t);this.u(d,o,b.ConfigurationTarget.USER)}s(t,o){const d=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(t,o);this.u(i,d,b.ConfigurationTarget.DEFAULT)}t(t){const o=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(t);this.u(d,o,b.ConfigurationTarget.DEFAULT)}u(t,o,d){const i=new a.$Jo(t,{data:o},this.a,void 0,this.n);i.source=d,this.h.fire(i)}}e.$No=m;class ${constructor(t,o,d){this.b=t,this.c=o,this.d=d,this.a=new r.$Hh}write(t,o){return this.a.queue(()=>this.e(t,o))}async e(t,o){let d;try{d=(await this.c.readFile(this.b)).value.toString()}catch(u){if(u.fileOperationResult===g.FileOperationResult.FILE_NOT_FOUND)d="{}";else throw u}const i=[];if((0,A.$Pn)(d,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const c=this.f(d,t,o);d=(0,R.$8n)(d,c),await this.c.writeFile(this.b,S.$Je.fromString(d))}f(t,o,d){const{tabSize:i,insertSpaces:c,eol:u}=this.h;if(!o.length){const k=JSON.stringify(d,null,c?" ".repeat(i):"	");return[{content:k,length:k.length,offset:0}]}return(0,R.$5n)(t,o,d,{tabSize:i,insertSpaces:c,eol:u})}get h(){if(!this.g){let t=y.OS===y.OperatingSystem.Linux||y.OS===y.OperatingSystem.Macintosh?`
`:`\r
`;const o=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});o&&typeof o=="string"&&o!=="auto"&&(t=o),this.g={eol:t,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(Ee[90],Se([1,0,10,5]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=s,e.$Ll=(0,r.$Ai)("remoteAuthorityResolverService");var S;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class D{constructor(y){this.id=y,this.type=S.Managed}toString(){return`Managed(${this.id})`}}e.$Ml=D;class A{constructor(y,p){this.host=y,this.port=p,this.type=S.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=A;var R;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class v extends n.$bb{static isNotAvailable(y){return y instanceof v&&y._code===R.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof v&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof v&&y._code===R.NoResolverFound}static isInvalidAuthority(y){return y instanceof v&&y._code===R.InvalidAuthority}static isHandled(y){return y instanceof v&&y.isHandled}constructor(y,p=R.Unknown,b){super(y),this._message=y,this._code=p,this._detail=b,this.isHandled=p===R.NotAvailable&&b===!0,Object.setPrototypeOf(this,v.prototype)}}e.$Ol=v;function s(E){const y=E.indexOf("+");return y===-1?E:E.substring(0,y)}}),define(Ee[263],Se([1,0,14,15,19,10,6,2,13,45,55,22,61,90]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ul=I,e.$Vl=C,e.$Wl=O;const a=30*1e3;var f;(function(Y){Y[Y.Management=1]="Management",Y[Y.ExtensionHost=2]="ExtensionHost",Y[Y.Tunnel=3]="Tunnel"})(f||(e.ConnectionType=f={}));function h(Y){switch(Y){case f.Management:return"Management";case f.ExtensionHost:return"ExtensionHost";case f.Tunnel:return"Tunnel"}}function g(Y){const H=new S.$se;return setTimeout(()=>H.cancel(),Y),H.token}function w(Y,H){if(Y.isCancellationRequested||H.isCancellationRequested)return S.CancellationToken.Cancelled;const L=new S.$se;return Y.onCancellationRequested(()=>L.cancel()),H.onCancellationRequested(()=>L.cancel()),L.token}class m{get didTimeout(){return this.c==="timedout"}constructor(H){this.c="pending",this.d=new R.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$th)(),H.isCancellationRequested?this.h():this.d.add(H.onCancellationRequested(()=>this.h()))}registerDisposable(H){this.c==="pending"?this.d.add(H):H.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(H))}reject(H){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(H))}}function $(Y,H){const L=new m(H);return L.registerDisposable(Y.onControlMessage(W=>{const z=JSON.parse(W.toString()),U=B(z);U?L.reject(U):L.resolve(z)})),L.promise}function l(Y,H,L,W,z,U,J,x){const M=new m(x),G=E.$be.create(!1);return Y.info(`Creating a socket (${J})...`),s.mark(`code/willCreateSocket/${U}`),H.connect(L,W,z,J).then(te=>{M.didTimeout?(s.mark(`code/didCreateSocketError/${U}`),Y.info(`Creating a socket (${J}) finished after ${G.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(s.mark(`code/didCreateSocketOK/${U}`),Y.info(`Creating a socket (${J}) was successful after ${G.elapsed()} ms.`),M.resolve(te))},te=>{s.mark(`code/didCreateSocketError/${U}`),Y.info(`Creating a socket (${J}) returned an error after ${G.elapsed()} ms.`),Y.error(te),M.reject(te)}),M.promise}function t(Y,H){const L=new m(H);return Y.then(W=>{L.didTimeout||L.resolve(W)},W=>{L.didTimeout||L.reject(W)}),L.promise}async function o(Y,H,L,W){const z=q(Y,H);Y.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let U;try{U=await l(Y.logService,Y.remoteSocketFactoryService,Y.connectTo,v.$Ng.getServerRootPath(),`reconnectionToken=${Y.reconnectionToken}&reconnection=${Y.reconnectionProtocol?"true":"false"}`,h(H),`renderer-${h(H)}-${Y.reconnectionToken}`,W)}catch(te){throw Y.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),Y.logService.error(te),te}Y.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let J,x;Y.reconnectionProtocol?(Y.reconnectionProtocol.beginAcceptReconnection(U,null),J=Y.reconnectionProtocol,x=!1):(J=new p.$oi({socket:U}),x=!0),Y.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const M=await t(Y.signService.createNewMessage((0,y.$Wg)()),W),G={type:"auth",auth:Y.connectionToken||"00000000000000000000",data:M.data};J.sendControl(r.$Je.fromString(JSON.stringify(G)));try{const te=await $(J,w(W,g(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const me=new Error("Unexpected handshake message");throw me.code="VSCODE_CONNECTION_ERROR",me}if(Y.logService.trace(`${z} 4/6. received SignRequest control message.`),!await t(Y.signService.validate(M,te.signedData),W)){const me=new Error("Refused to connect to unsupported server");throw me.code="VSCODE_CONNECTION_ERROR",me}const ke=await t(Y.signService.sign(te.data),W),Ne={type:"connectionType",commit:Y.commit,signedData:ke,desiredConnectionType:H};return L&&(Ne.args=L),Y.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(r.$Je.fromString(JSON.stringify(Ne))),{protocol:J,ownsProtocol:x}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(Y.logService.error(`${z} the handshake timed out. Error:`),Y.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(Y.logService.error(`${z} received error control message when negotiating connection. Error:`),Y.logService.error(te)),x&&j(J),te}}async function d(Y,H,L,W){const z=Date.now(),U=q(Y,H),{protocol:J,ownsProtocol:x}=await o(Y,H,L,W),M=new m(W);return M.registerDisposable(J.onControlMessage(G=>{const te=JSON.parse(G.toString()),he=B(te);he?(Y.logService.error(`${U} received error control message when negotiating connection. Error:`),Y.logService.error(he),x&&j(J),M.reject(he)):(Y.reconnectionProtocol?.endAcceptReconnection(),Y.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${ae(z)}!`),M.resolve({protocol:J,firstMessage:te}))})),M.promise}async function i(Y,H){const{protocol:L}=await d(Y,f.Management,void 0,H);return{protocol:L}}async function c(Y,H,L){const{protocol:W,firstMessage:z}=await d(Y,f.ExtensionHost,H,L),U=z&&z.debugPort;return{protocol:W,debugPort:U}}async function u(Y,H,L){const W=Date.now(),z=q(Y,f.Tunnel),{protocol:U}=await o(Y,f.Tunnel,H,L);return Y.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${ae(W)}!`),U}async function k(Y,H,L){const{connectTo:W,connectionToken:z}=await Y.addressProvider.getAddress();return{commit:Y.commit,quality:Y.quality,connectTo:W,connectionToken:z,reconnectionToken:H,reconnectionProtocol:L,remoteSocketFactoryService:Y.remoteSocketFactoryService,signService:Y.signService,logService:Y.logService}}async function I(Y,H,L){return T(Y,async W=>{const{protocol:z}=await i(W,S.CancellationToken.None);return new ee(Y,H,L,W.reconnectionToken,z)})}async function C(Y,H){return T(Y,async L=>{const{protocol:W,debugPort:z}=await c(L,H,S.CancellationToken.None);return new ue(Y,H,L.reconnectionToken,W,z)})}async function T(Y,H){for(let W=1;;W++)try{const z=(0,y.$Wg)(),U=await k(Y,z,null);return await H(U)}catch(z){if(W<5)Y.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),Y.logService.error(z);else throw Y.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Y.logService.error(z),Z.triggerPermanentFailure(0,0,b.$Ol.isHandled(z)),z}}async function O(Y,H,L){const W=await k(Y,(0,y.$Wg)(),null);return await u(W,{host:H,port:L},S.CancellationToken.None)}function P(Y){return(0,n.$nh)(H=>new Promise((L,W)=>{const z=setTimeout(L,Y*1e3);H.onCancellationRequested(()=>{clearTimeout(z),L()})}))}var V;(function(Y){Y[Y.ConnectionLost=0]="ConnectionLost",Y[Y.ReconnectionWait=1]="ReconnectionWait",Y[Y.ReconnectionRunning=2]="ReconnectionRunning",Y[Y.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Y[Y.ConnectionGain=4]="ConnectionGain"})(V||(e.PersistentConnectionEventType=V={}));class Q{constructor(H,L){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.type=V.ConnectionLost}}e.$Xl=Q;class ie{constructor(H,L,W,z){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.durationSeconds=W,this.c=z,this.type=V.ReconnectionWait}skipWait(){this.c.cancel()}}e.$Yl=ie;class re{constructor(H,L,W){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=W,this.type=V.ReconnectionRunning}}e.$Zl=re;class ne{constructor(H,L,W){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=W,this.type=V.ConnectionGain}}e.$1l=ne;class se{constructor(H,L,W,z){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=W,this.handled=z,this.type=V.ReconnectionPermanentFailure}}e.$2l=se;class Z extends R.$Uc{static triggerPermanentFailure(H,L,W){this._permanentFailure=!0,this.f=H,this.g=L,this.h=W,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(H=>H.y())}static debugPauseSocketWriting(){this.j.forEach(H=>H.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Z._permanentFailure}constructor(H,L,W,z,U){super(),this.t=H,this.u=L,this.reconnectionToken=W,this.protocol=z,this.w=U,this.m=this.B(new A.$he),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ne(this.reconnectionToken,0,0)),this.B(z.onSocketClose(J=>{const x=pe(this.t,this.reconnectionToken,!0);J?J.type===p.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${x} received socket close event (hadError: ${J.hadError}).`),J.error&&this.u.logService.error(J.error)):(this.u.logService.info(`${x} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.u.logService.error(J.event)):this.u.logService.info(`${x} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(J=>{const x=pe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${x} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.y()})),Z.j.push(this),this.B((0,R.$Sc)(()=>{const J=Z.j.indexOf(this);J>=0&&Z.j.splice(J,1)})),this.n&&this.D(Z.f,Z.g,Z.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const H=pe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const z=W<L.length?L[W]:L[L.length-1];try{if(z>0){const J=P(z);this.m.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,J)),this.u.logService.info(`${H} waiting for ${z} seconds before reconnecting...`);try{await J}catch{}}if(this.n){this.u.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this.u.logService.info(`${H} resolving connection...`);const U=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${H} connecting to ${U.connectTo}...`),await this.G(U,g(a)),this.u.logService.info(`${H} reconnected!`),this.m.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this.u.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(b.$Ol.isTemporarilyNotAvailable(U)){this.u.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this.u.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(U);continue}if((0,D.$4)(U)){this.u.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(U);continue}if(U instanceof b.$Ol){this.u.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,b.$Ol.isHandled(U));break}this.u.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this.n&&!this.s)}C(H,L,W){this.w?Z.triggerPermanentFailure(H,L,W):this.D(H,L,W)}D(H,L,W){this.m.fire(new se(this.reconnectionToken,H,L,W)),j(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$3l=Z;class ee extends Z{constructor(H,L,W,z,U){super(f.Management,H,z,U,!0),this.client=this.B(new p.$mi(U,{remoteAuthority:L,clientId:W},H.ipcLogger))}async G(H,L){await i(H,L)}}e.$4l=ee;class ue extends Z{constructor(H,L,W,z,U){super(f.ExtensionHost,H,W,z,!1),this.H=L,this.debugPort=U}async G(H,L){await c(H,this.H,L)}}e.$5l=ue;function j(Y){try{Y.acceptDisconnect();const H=Y.getSocket();Y.dispose(),H.dispose()}catch(H){(0,D.$1)(H)}}function B(Y){if(Y&&Y.type==="error"){const H=new Error(`Connection error: ${Y.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function oe(Y,H){for(;Y.length<H;)Y+=" ";return Y}function le(Y,H){return`[remote-connection][${oe(h(Y),13)}][${H.substr(0,5)}\u2026]`}function pe(Y,H,L){return`${le(Y,H)}[${L?"reconnect":"initial"}]`}function q(Y,H){return`${pe(H,Y.reconnectionToken,!!Y.reconnectionProtocol)}[${Y.connectTo}]`}function ae(Y){return`${Date.now()-Y} ms`}}),define(Ee[264],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=e.$oQ=void 0,e.$oQ=(0,n.$Ai)("IRemoteExtensionsScannerService"),e.$pQ="remoteExtensionsScanner"}),define(Ee[91],Se([1,0,13]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=r,e.$Nm=S,e.$Om=D,e.$Pm=A;function r(v){return v.scheme===n.Schemas.vscodeRemote?v.authority:void 0}function S(v){if(!v)return;const s=v.indexOf("+");return s<0?v:v.substr(0,s)}function D(v){const{host:s,port:E}=R(v);if(typeof E>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:E}}function A(v,s){let{host:E,port:y}=R(v);return typeof y>"u"&&(y=s),{host:E,port:y}}function R(v){const s=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const E=v.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=v.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:v,port:void 0}}}),define(Ee[23],Se([1,0,17,5,91]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$Ym=e.$Xm=e.$Wm=e.TargetPlatform=e.ExtensionType=e.$Vm=e.$Tm=e.$Sm=e.$Rm=e.$Qm=void 0,e.$Um=D,e.$Zm=y,e.$1m=p,e.$2m=b,e.$3m=a,e.$Qm="extensions.user.cache",e.$Rm="extensions.builtin.cache",e.$Sm="undefined_publisher",e.$Tm=["ui","workspace","web"];function D(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$Vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A||(e.ExtensionType=A={}));var R;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class v{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,g){if(typeof h>"u"||h===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof h=="string"||typeof g=="string"){const w=typeof h=="string"?h:h.value,m=typeof g=="string"?g:g.value;return n.$Bf(w,m)}return h._lower===g._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.$Wm=v;class s{get size(){return this.c.size}constructor(h){if(this.c=new Set,h)for(const g of h)this.add(g)}add(h){this.c.add(v.toKey(h))}delete(h){return this.c.delete(v.toKey(h))}has(h){return this.c.has(v.toKey(h))}}e.$Xm=s;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete(h){this.c.delete(v.toKey(h))}get(h){return this.c.get(v.toKey(h))}has(h){return this.c.has(v.toKey(h))}set(h,g){this.c.set(v.toKey(h),g)}values(){return this.c.values()}forEach(h){this.c.forEach(h)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Ym=E;function y(f){return p(f)}function p(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}function b(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}function a(f,h){if(h){const g=`onResolveRemoteAuthority:${(0,S.$Nm)(h)}`;return!!f.activationEvents?.includes(g)}return!1}e.$4m=(0,r.$Ai)("IBuiltinExtensionsScannerService")}),define(Ee[30],Se([1,0,3,207,23,5]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.ExtensionManagementErrorCode=e.$cp=e.ExtensionGalleryErrorCode=e.$bp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0,e.$8o=R,e.$9o=v,e.$0o=s,e.$$o=E,e.$_o=y,e.$ap=p,e.$1o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2o=new RegExp(e.$1o),e.$3o="__web_extension",e.$4o="skipWalkthrough",e.$5o="extensionInstallSource",e.$6o="dependecyOrPackExtensionInstall",e.$7o="clientTargetPlatform";var A;(function(l){l.COMMAND="command",l.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function R(l){switch(l){case S.TargetPlatform.WIN32_X64:return"Windows 64 bit";case S.TargetPlatform.WIN32_ARM64:return"Windows ARM";case S.TargetPlatform.LINUX_X64:return"Linux 64 bit";case S.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case S.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case S.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case S.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case S.TargetPlatform.DARWIN_X64:return"Mac";case S.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case S.TargetPlatform.WEB:return"Web";case S.TargetPlatform.UNIVERSAL:return S.TargetPlatform.UNIVERSAL;case S.TargetPlatform.UNKNOWN:return S.TargetPlatform.UNKNOWN;case S.TargetPlatform.UNDEFINED:return S.TargetPlatform.UNDEFINED}}function v(l){switch(l){case S.TargetPlatform.WIN32_X64:return S.TargetPlatform.WIN32_X64;case S.TargetPlatform.WIN32_ARM64:return S.TargetPlatform.WIN32_ARM64;case S.TargetPlatform.LINUX_X64:return S.TargetPlatform.LINUX_X64;case S.TargetPlatform.LINUX_ARM64:return S.TargetPlatform.LINUX_ARM64;case S.TargetPlatform.LINUX_ARMHF:return S.TargetPlatform.LINUX_ARMHF;case S.TargetPlatform.ALPINE_X64:return S.TargetPlatform.ALPINE_X64;case S.TargetPlatform.ALPINE_ARM64:return S.TargetPlatform.ALPINE_ARM64;case S.TargetPlatform.DARWIN_X64:return S.TargetPlatform.DARWIN_X64;case S.TargetPlatform.DARWIN_ARM64:return S.TargetPlatform.DARWIN_ARM64;case S.TargetPlatform.WEB:return S.TargetPlatform.WEB;case S.TargetPlatform.UNIVERSAL:return S.TargetPlatform.UNIVERSAL;default:return S.TargetPlatform.UNKNOWN}}function s(l,t){switch(l){case n.Platform.Windows:return t==="x64"?S.TargetPlatform.WIN32_X64:t==="arm64"?S.TargetPlatform.WIN32_ARM64:S.TargetPlatform.UNKNOWN;case n.Platform.Linux:return t==="x64"?S.TargetPlatform.LINUX_X64:t==="arm64"?S.TargetPlatform.LINUX_ARM64:t==="arm"?S.TargetPlatform.LINUX_ARMHF:S.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?S.TargetPlatform.ALPINE_X64:t==="arm64"?S.TargetPlatform.ALPINE_ARM64:S.TargetPlatform.UNKNOWN;case n.Platform.Mac:return t==="x64"?S.TargetPlatform.DARWIN_X64:t==="arm64"?S.TargetPlatform.DARWIN_ARM64:S.TargetPlatform.UNKNOWN;case n.Platform.Web:return S.TargetPlatform.WEB}}function E(l,t){return t===S.TargetPlatform.WEB&&!l.includes(S.TargetPlatform.WEB)}function y(l,t,o){return E(t,o)?!1:l===S.TargetPlatform.UNDEFINED||l===S.TargetPlatform.UNIVERSAL?!0:l===S.TargetPlatform.UNKNOWN?!1:l===o}function p(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var b;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var a;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var f;(function(l){l.Install="install",l.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var h;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$bp=(0,D.$Ai)("extensionGalleryService");var g;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed",l.DownloadFailedWriting="DownloadFailedWriting"})(g||(e.ExtensionGalleryErrorCode=g={}));class w extends Error{constructor(t,o){super(t),this.code=o,this.name=o}}e.$cp=w;var m;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.DownloadFailedWriting="DownloadFailedWriting",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.ScanningExtension="ScanningExtension",l.ReadUninstalled="ReadUninstalled",l.UnsetUninstalled="UnsetUninstalled",l.Delete="Delete",l.Rename="Rename",l.IntializeDefaultProfile="IntializeDefaultProfile",l.AddToProfile="AddToProfile",l.InstalledExtensionNotFound="InstalledExtensionNotFound",l.PostInstall="PostInstall",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Cancelled="Cancelled",l.Unknown="Unknown",l.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));class $ extends Error{constructor(t,o){super(t),this.code=o,this.name=o}}e.$dp=$,e.$ep=(0,D.$Ai)("extensionManagementService"),e.$fp="extensionsIdentifiers/disabled",e.$gp="extensionsIdentifiers/enabled",e.$hp=(0,D.$Ai)("IGlobalExtensionEnablementService"),e.$ip=(0,D.$Ai)("IExtensionTipsService"),e.$jp=(0,r.localize2)(0,"Extensions"),e.$kp=(0,r.localize2)(1,"Preferences")}),define(Ee[265],Se([1,0,6,2,21,4,59,30]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=e.$lq=void 0;function v(h,g){return h?D.URI.revive(g?g.transformIncoming(h):h):void 0}function s(h,g){return g?g.transformOutgoingURI(h):h}function E(h,g){g=g||A.$En;const w=h.manifest;return{...(0,A.$Hn)({...h,manifest:void 0},g),manifest:w}}function y(h,g){return h?.profileLocation?(0,A.$Hn)(h,g??A.$En):h}function p(h,g){return g?(0,S.$$n)(h,w=>w instanceof D.URI?g.transformOutgoingURI(w):void 0):h}class b{constructor(g,w){this.a=g,this.b=w,this.onInstallExtension=n.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=n.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=n.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=n.Event.buffer(g.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=n.Event.buffer(g.onDidUpdateExtensionMetadata,!0)}listen(g,w){const m=this.b(g);switch(w){case"onInstallExtension":return n.Event.map(this.onInstallExtension,$=>({...$,profileLocation:$.profileLocation?s($.profileLocation,m):$.profileLocation}));case"onDidInstallExtensions":return n.Event.map(this.onDidInstallExtensions,$=>$.map(l=>({...l,local:l.local?p(l.local,m):l.local,profileLocation:l.profileLocation?s(l.profileLocation,m):l.profileLocation})));case"onUninstallExtension":return n.Event.map(this.onUninstallExtension,$=>({...$,profileLocation:$.profileLocation?s($.profileLocation,m):$.profileLocation}));case"onDidUninstallExtension":return n.Event.map(this.onDidUninstallExtension,$=>({...$,profileLocation:$.profileLocation?s($.profileLocation,m):$.profileLocation}));case"onDidUpdateExtensionMetadata":return n.Event.map(this.onDidUpdateExtensionMetadata,$=>p($,m))}throw new Error("Invalid listen")}async call(g,w,m){const $=this.b(g);switch(w){case"zip":{const l=E(m[0],$),t=await this.a.zip(l);return s(t,$)}case"unzip":return this.a.unzip(v(m[0],$));case"install":return this.a.install(v(m[0],$),y(m[1],$));case"installFromLocation":return this.a.installFromLocation(v(m[0],$),v(m[1],$));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(m[0],v(m[1],$),v(m[2],$));case"getManifest":return this.a.getManifest(v(m[0],$));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(m[0]);case"installFromGallery":return this.a.installFromGallery(m[0],y(m[1],$));case"installGalleryExtensions":{const l=m[0];return this.a.installGalleryExtensions(l.map(({extension:t,options:o})=>({extension:t,options:y(o,$)??{}})))}case"uninstall":return this.a.uninstall(E(m[0],$),y(m[1],$));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(m[0],$));case"getInstalled":return(await this.a.getInstalled(m[0],v(m[1],$),m[2])).map(t=>p(t,$));case"toggleAppliationScope":{const l=await this.a.toggleAppliationScope(E(m[0],$),v(m[1],$));return p(l,$)}case"copyExtensions":return this.a.copyExtensions(v(m[0],$),v(m[1],$));case"updateMetadata":{const l=await this.a.updateMetadata(E(m[0],$),m[1],v(m[2],$));return p(l,$)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(m[0],m[1],m[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$lq=b;class a extends r.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(g){super(),this.m=g,this.c=this.B(new n.$he),this.f=this.B(new n.$he),this.g=this.B(new n.$he),this.h=this.B(new n.$he),this.j=this.B(new n.$he),this.B(this.m.listen("onInstallExtension")(w=>this.n(this.c,{...w,source:this.r(w.source)?D.URI.revive(w.source):w.source,profileLocation:D.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(w=>this.n(this.f,w.map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?D.URI.revive(m.source):m.source,profileLocation:D.URI.revive(m.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(w=>this.n(this.g,{...w,profileLocation:D.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(w=>this.n(this.h,{...w,profileLocation:D.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(w=>this.j.fire(E(w,null))))}n(g,w){g.fire(w)}r(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(g){const w=await this.getTargetPlatform();return g.allTargetPlatforms.some(m=>(0,R.$_o)(m,g.allTargetPlatforms,w))}zip(g){return Promise.resolve(this.m.call("zip",[g]).then(w=>D.URI.revive(w)))}unzip(g){return Promise.resolve(this.m.call("unzip",[g]))}install(g,w){return Promise.resolve(this.m.call("install",[g,w])).then(m=>E(m,null))}installFromLocation(g,w){return Promise.resolve(this.m.call("installFromLocation",[g,w])).then(m=>E(m,null))}async installExtensionsFromProfile(g,w,m){return(await this.m.call("installExtensionsFromProfile",[g,w,m])).map(l=>E(l,null))}getManifest(g){return Promise.resolve(this.m.call("getManifest",[g]))}installFromGallery(g,w){return Promise.resolve(this.m.call("installFromGallery",[g,w])).then(m=>E(m,null))}async installGalleryExtensions(g){return(await this.m.call("installGalleryExtensions",[g])).map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?D.URI.revive(m.source):m.source,profileLocation:D.URI.revive(m.profileLocation)}))}uninstall(g,w){if(g.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[g,w]))}reinstallFromGallery(g){return Promise.resolve(this.m.call("reinstallFromGallery",[g])).then(w=>E(w,null))}getInstalled(g=null,w,m){return Promise.resolve(this.m.call("getInstalled",[g,w,m])).then($=>$.map(l=>E(l,null)))}updateMetadata(g,w,m){return Promise.resolve(this.m.call("updateMetadata",[g,w,m])).then($=>E($,null))}toggleAppliationScope(g,w){return this.m.call("toggleAppliationScope",[g,w]).then(m=>E(m,null))}copyExtensions(g,w){return this.m.call("copyExtensions",[g,w])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(g,w,m){const $=await this.m.call("download",[g,w,m]);return D.URI.revive($)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$mq=a;class f{constructor(g){this.a=g}listen(g,w){throw new Error("Invalid listen")}call(g,w,m){switch(w){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$nq=f}),define(Ee[129],Se([1,0,10,23]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zG=e.$yG=void 0;class S{constructor(){this.a=new Map,this.b=new WeakMap}register(A,R){this.a.set(A,R)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const R=Object.create(null);for(const v of A){const s=this.readActivationEvents(v);s.length>0&&(R[r.$Wm.toKey(v.identifier)]=s)}return R}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const R=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let v=0;v<R.length;v++)R[v]==="onUri"&&(R[v]=`onUri:${r.$Wm.toKey(A.identifier)}`);if(!A.contributes)return R;for(const v in A.contributes){const s=this.a.get(v);if(!s)continue;const E=A.contributes[v],y=Array.isArray(E)?E:[E];try{s(y,R)}catch(p){(0,n.$1)(p)}}return R}}e.$yG=S,e.$zG=new S}),define(Ee[266],Se([1,0,2,23,16]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class D extends n.$Uc{constructor(R,v,s,E,y){super(),this.a=R,this.b=v,this.c=s,this.f=y,this.B(E.onDidInstallExtensions(p=>this.g(p))),this.B(E.onDidUninstallExtension(p=>this.h(p)))}g(R){for(const v of R)v.local&&this.invalidate(v.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,R)&&await this.j(v);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,r.$Qm))}catch(v){(0,S.$ll)(v)!==S.FileOperationResult.FILE_NOT_FOUND&&this.f.error(v)}}}e.$Kq=D}),define(Ee[92],Se([1,0,19,2,3,218,30,5]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=void 0,e.$Yr=v;function v(E){return E.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$Zr=(0,R.$Ai)("languagePackService");let s=class extends r.$Uc{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new n.$se;setTimeout(()=>y.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const a=p.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(h=>h.startsWith("lp-"))).map(f=>{const h=f.properties.localizedLanguages?.[0],g=v(f);return{...this.f(g,h,f),extensionId:f.identifier.id,galleryExtension:f}});return a.push(this.f("en","English")),a}f(y,p,b){const a=p??y;let f;if(a!==y&&(f=`(${y})`),y.toLowerCase()===S.$w.toLowerCase()&&(f??="",f+=(0,D.localize)(0,null)),b?.installCount){f??="";const h=b.installCount;let g;h>1e6?g=`${Math.floor(h/1e5)/10}M`:h>1e3?g=`${Math.floor(h/1e3)}K`:g=String(h),f+=` $(cloud-download) ${g}`}return{id:y,label:a,description:f}}};e.$1r=s,e.$1r=s=Ue([Fe(0,A.$bp)],s)}),define(Ee[47],Se([1,0,15,10,2,221,46,5,12,38]),function(fe,e,n,r,S,D,A,R,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Xp=p,e.$Yp=b,e.$Zp=a,e.$1p=f,e.$2p=h,e.$3p=g,e.$Vp=(0,R.$Ai)("requestService");class E{constructor(l){this.b=l}toJSON(){if(!this.a){const l=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?l[t]="*****":l[t]=this.b[t];this.a=l}return this.a}}class y extends S.$Uc{constructor(l){super(),this.b=0,this.a=l.createLogger("network",{name:(0,D.localize)(0,null),when:v.$mk.isEqualTo((0,v.$jk)(v.LogLevel.Trace)).serialize()})}async c(l,t,o){const d=`${l} #${++this.b}: ${t.url}`;this.a.trace(`${d} - begin`,t.type,new E(t.headers??{}));try{const i=await o();return this.a.trace(`${d} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${d} - error`,t.type,(0,r.$0)(i)),i}}}e.$Wp=y;function p($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}function b($){return $.res.statusCode===204}async function a($){return b($)?null:(await(0,n.$Ve)($.stream)).toString()}async function f($){if(!p($))throw new Error("Server returned "+$.res.statusCode);return a($)}async function h($){if(!p($))throw new Error("Server returned "+$.res.statusCode);if(b($))return null;const t=(await(0,n.$Ve)($.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}function g($){m($)}let w;function m($){const l=s.$jo.as(A.$oo.Configuration),t=w;w={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(12,null),restricted:!0}}},l.updateConfigurations({add:[w],remove:t?[t]:[]})}m(A.ConfigurationScope.APPLICATION)}),define(Ee[267],Se([1,0,19,13,16,47]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BQ=void 0;let A=class{constructor(v,s){this.a=v,this.b=s}async download(v,s,E=n.CancellationToken.None){if(v.scheme===r.Schemas.file||v.scheme===r.Schemas.vscodeRemote){await this.b.copy(v,s);return}const y={type:"GET",url:v.toString(!0)},p=await this.a.request(y,E);if(p.res.statusCode===200)await this.b.writeFile(s,p.stream);else{const b=await(0,D.$1p)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${b}`)}}};e.$BQ=A,e.$BQ=A=Ue([Fe(0,D.$Vp),Fe(1,S.$7k)],A)}),define(Ee[268],Se([1,0,15,19]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=void 0;class S{constructor(R){this.a=R}listen(R,v){throw new Error("Invalid listen")}call(R,v,s,E=r.CancellationToken.None){switch(v){case"request":return this.a.request(s[0],E).then(async({res:y,stream:p})=>{const b=await(0,n.$Ve)(p);return[{statusCode:y.statusCode,headers:y.headers},b]});case"resolveProxy":return this.a.resolveProxy(s[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$3r=S;class D{constructor(R){this.a=R}async request(R,v){const[s,E]=await this.a.call("request",[R],v);return{res:s,stream:(0,n.$Xe)(E)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$4r=D}),define(Ee[269],Se([1,0,93,11]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=D;function S(A,R){return A.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:A.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function D(A,R,v={}){const s=(0,n.parse)(A),E=v.proxyUrl||S(s,R);if(!E)return null;const y=(0,n.parse)(E);if(!/^https?:$/.test(y.protocol||""))return null;const p={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,r.$gg)(v.strictSSL)?v.strictSSL:!0};return s.protocol==="http:"?new(await new Promise((b,a)=>{fe(["http-proxy-agent"],b,a)})).HttpProxyAgent(E,p):new(await new Promise((b,a)=>{fe(["https-proxy-agent"],b,a)})).HttpsProxyAgent(E,p)}}),define(Ee[94],Se([1,0,60,9,222,19,42,10,3,22,116,243,14,162]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=f;let a;async function f(g,w,m,$){return m["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.$i?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$Fm)($)&&!m["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$Fm)($)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),a||(a=p.Promises.withAsyncBody(async(l,t)=>{const o=new D.$se;let d=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(d=(0,b.$Gm)(i,1,120)*1e3);const c=setTimeout(()=>{o.dispose(!0),t(new Error((0,S.localize)(0,null)))},d);try{l(await h(w,o.token))}catch(u){!(0,R.$4)(u)&&!o.token.isCancellationRequested?t(new Error((0,S.localize)(1,null,(0,A.$lj)(u)))):l({})}finally{clearTimeout(c),o.dispose()}})),a)}async function h(g,w){const m=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",m);const $=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",$);const l=(0,s.$Wg)().replace(/-/g,"").substr(0,12),t=new RegExp(l+"({.*})"+l),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const d=await(0,E.$vm)(v.OS,o);return g.trace("getUnixShellEnvironment#shell",d),new Promise((i,c)=>{if(w.isCancellationRequested)return c(new R.$5);const u=(0,r.$nc)(d);let k,I;const C="";/^pwsh(-preview)?$/.test(u)?(k=`& '${process.execPath}' ${C} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,I=["-Login","-Command"]):u==="nu"?(k=`^'${process.execPath}' ${C} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,I=["-i","-l","-c"]):u==="xonsh"?(k=`import os, json; print("${l}", json.dumps(dict(os.environ)), "${l}")`,I=["-i","-l","-c"]):(k=`'${process.execPath}' ${C} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,u==="tcsh"||u==="csh"?I=["-ic"]:I=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),k);const T=(0,n.spawn)(d,[...I,k],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});w.onCancellationRequested(()=>(T.kill(),c(new R.$5))),T.on("error",V=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,A.$lj)(V)),c(V)});const O=[];T.stdout.on("data",V=>O.push(V));const P=[];T.stderr.on("data",V=>P.push(V)),T.on("close",(V,Q)=>{const ie=Buffer.concat(O).toString("utf8");g.trace("getUnixShellEnvironment#raw",ie);const re=Buffer.concat(P).toString("utf8");if(re.trim()&&g.trace("getUnixShellEnvironment#stderr",re),V||Q)return c(new Error((0,S.localize)(2,null,V,Q)));const ne=t.exec(ie),se=ne?ne[1]:"{}";try{const Z=JSON.parse(se);m?Z.ELECTRON_RUN_AS_NODE=m:delete Z.ELECTRON_RUN_AS_NODE,$?Z.ELECTRON_NO_ATTACH_CONSOLE=$:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.VSCODE_RESOLVING_ENVIRONMENT,delete Z.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",Z),i(Z)}catch(Z){g.error("getUnixShellEnvironment#errorCaught",(0,A.$lj)(Z)),c(Z)}})})}}),define(Ee[270],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=void 0,e.$dQ=(0,n.$Ai)("stateReadService"),e.$eQ=(0,n.$Ai)("stateService")}),define(Ee[271],Se([1,0,14,15,2,11,28,16,12]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hQ=e.$gQ=e.$fQ=e.SaveStrategy=void 0;var s;(function(b){b[b.IMMEDIATE=0]="IMMEDIATE",b[b.DELAYED=1]="DELAYED"})(s||(e.SaveStrategy=s={}));class E extends S.$Uc{constructor(a,f,h,g){super(),this.h=a,this.j=f,this.m=h,this.n=g,this.a=Object.create(null),this.b="",this.c=this.B(new n.$yh(this.j===s.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(a){a.fileOperationResult!==R.FileOperationResult.FILE_NOT_FOUND&&this.m.error(a)}}getItem(a,f){const h=this.a[a];return(0,D.$jg)(h)?f:h}setItem(a,f){this.setItems([{key:a,data:f}])}setItems(a){let f=!1;for(const{key:h,data:g}of a)this.a[h]!==g&&((0,D.$jg)(g)?(0,D.$hg)(this.a[h])||(this.a[h]=void 0,f=!0):(this.a[h]=g,f=!0));f&&this.s()}removeItem(a){(0,D.$hg)(this.a[a])||(this.a[a]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const a=JSON.stringify(this.a,null,4);if(a!==this.b)try{await this.n.writeFile(this.h,r.$Je.fromString(a),{atomic:{postfix:".vsctmp"}}),this.b=a}catch(f){this.m.error(f)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$fQ=E;let y=class extends S.$Uc{constructor(a,f,h,g){super(),this.a=this.B(new E(f.stateResource,a,h,g))}async init(){await this.a.init()}getItem(a,f){return this.a.getItem(a,f)}};e.$gQ=y,e.$gQ=y=Ue([Fe(1,A.$Hi),Fe(2,v.$7j),Fe(3,R.$7k)],y);class p extends y{setItem(a,f){this.a.setItem(a,f)}setItems(a){this.a.setItems(a)}removeItem(a){this.a.removeItem(a)}close(){return this.a.close()}}e.$hQ=p}),define(Ee[130],Se([1,0,3,33,22]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=A,e.$mp=R;function D(v){if(n.$u===n.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function A(v,s,E,y,p,b,a,f,h,g){const w=Object.create(null);w["common.machineId"]=b,w["common.sqmId"]=a,w["common.devDeviceId"]=f,w.sessionID=(0,S.$Wg)()+Date.now(),w.commitHash=y,w.version=p,w["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,n.$h)(n.$u),w["common.nodePlatform"]=r.$dc,w["common.nodeArch"]=E,w["common.product"]=g||"desktop",h&&(w["common.msftInternal"]=h);let m=0;const $=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),n.$l&&(w["common.snap"]="true");const l=D(s);return l&&(w["common.platformDetail"]=l),w}function R(v){const s=r.env.USERDNSDOMAIN;if(!s)return!1;const E=s.toLowerCase();return v.some(y=>E===y)}}),define(Ee[272],Se([1,0,18,10,2,21,16]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var R;(function(s){function E(y,p){return y.callstack<p.callstack?-1:y.callstack>p.callstack?1:0}s.compare=E})(R||(e.ErrorEvent=R={}));class v{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(E,y=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new S.$Tc,this.c=E,this.d=y;const p=r.$X.addListener(b=>this.j(b));this.h.add((0,S.$Sc)(p)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(E){if(!E||E.code||(E.detail&&E.detail.stack&&(E=E.detail),r.$bb.isErrorNoTelemetry(E)||E instanceof A.$pl||typeof E?.message=="string"&&E.message.includes("Unable to read file")))return;const y=Array.isArray(E.stack)?E.stack.join(`
`):E.stack,p=E.message?E.message:(0,D.$bo)(E);y&&this.k({msg:p,callstack:y})}k(E){const y=(0,n.$wb)(this.g,E,R.compare);y<0?(E.count=1,this.g.splice(~y,0,E)):(this.g[y].count||(this.g[y].count=0),this.g[y].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const E of this.g)this.c.publicLogError2("UnhandledError",E);this.g.length=0}}e.default=v}),define(Ee[24],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,n.$Ai)("telemetryService"),e.$7l=(0,n.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry.devDeviceId",e.$bm="telemetry",e.$cm="telemetry.telemetryLevel",e.$dm="telemetry.enableCrashReporter",e.$em="telemetry.enableTelemetry";var r;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var S;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(Ee[273],Se([1,0,32,14,44,13,9,3,4,112,25,115,249,16,29,24]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0,e.$Ms=g,e.$Ns=m,e.$Os=$;const h=new Map;async function g(t,o){const d=`${t}::${o.join(":")}`,i=h.get(d);if(i)return i;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,k=new Map,I=2e4;function C(O,P,V,Q){const ie=P.substring(O.length+1);return r.Promises.withAsyncBody(async re=>{let ne;try{ne=await E.Promises.readdir(P,{withFileTypes:!0})}catch{re();return}if(Q.count>=I){Q.count+=ne.length,Q.maxReached=!0,re();return}let se=ne.length;if(se===0){re();return}let Z=ne;Q.count+ne.length>I&&(Q.maxReached=!0,se=I-Q.count,Z=ne.slice(0,se)),Q.count+=ne.length;for(const ee of Z)if(ee.isDirectory()){if(V.includes(ee.name)||await C(O,(0,A.$jc)(P,ee.name),V,Q),--se===0){re();return}}else{const ue=ee.name.lastIndexOf(".");if(ue>=0){const j=ee.name.substring(ue+1);j&&u.set(j,(u.get(j)??0)+1)}for(const j of c)j.relativePathPattern?.test(ie)!==!1&&j.filePattern.test(ee.name)&&k.set(j.tag,(k.get(j.tag)??0)+1);if(--se===0){re();return}}})}const T=r.Promises.withAsyncBody(async O=>{const P={count:0,maxReached:!1};await C(t,t,o,P);const V=await $(t);O({configFiles:w(k),fileTypes:w(u),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:V})});return h.set(d,T),T}function w(t){return Array.from(t.entries(),([o,d])=>({name:o,count:d})).sort((o,d)=>d.count-o.count)}function m(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/b.$Cl.GB).toFixed(2)}GB (${(n.freemem()/b.$Cl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(s.$Jn.value()*100)}%`},o=n.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function $(t){try{const o=new Map,d=(0,A.$jc)(t,".vscode","launch.json"),i=await E.Promises.readFile(d),c=[],u=(0,S.$Pn)(i.toString(),c);if(c.length)return console.log(`Unable to parse ${d}`),[];if((0,S.$Yn)(u)==="object"&&u.configurations)for(const k of u.configurations){const I=k.type;I&&(o.has(I)?o.set(I,o.get(I)+1):o.set(I,1))}return w(o)}catch{return[]}}let l=class{constructor(o,d){this.c=o,this.d=d}f(o){const d=[];return d.push(`OS Version:       ${o.os}`),d.push(`CPUs:             ${o.cpus}`),d.push(`Memory (System):  ${o.memory}`),d.push(`VM:               ${o.vmHint}`),d.join(`
`)}g(o){const d=[];d.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),d.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&d.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),d.push(`Memory (System):  ${(n.totalmem()/b.$Cl.GB).toFixed(2)}GB (${(n.freemem()/b.$Cl.GB).toFixed(2)}GB free)`),R.$i||d.push(`Load (avg):       ${n.loadavg().map(c=>Math.round(c)).join(", ")}`),d.push(`VM:               ${Math.round(s.$Jn.value()*100)}%`),d.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),d.push(`Process Argv:     ${o.mainArguments.join(" ")}`),d.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),d.join(`
`)}async getPerformanceInfo(o,d){return Promise.all([(0,y.$Ls)(o.mainPID),this.k(o)]).then(async i=>{let[c,u]=i,k=this.m(o,c);return d.forEach(I=>{if((0,p.$jn)(I))k+=`
${I.errorMessage}`,u+=`
${I.errorMessage}`;else if(k+=`

Remote: ${I.hostName}`,I.processes&&(k+=`
${this.m(o,I.processes)}`),I.workspaceMetadata){u+=`
|  Remote: ${I.hostName}`;for(const C of Object.keys(I.workspaceMetadata)){const T=I.workspaceMetadata[C];let O=`${T.fileCount} files`;T.maxFilesReached&&(O=`more than ${O}`),u+=`|    Folder (${C}): ${O}`,u+=this.h(T)}}}),{processInfo:k,workspaceInfo:u}})}async getSystemInfo(o,d){const{memory:i,vmHint:c,os:u,cpus:k}=m(),I={os:u,memory:i,cpus:k,vmHint:c,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:d};return R.$i||(I.load=`${n.loadavg().map(C=>Math.round(C)).join(", ")}`),R.$k&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(o,d){const i=[];return(0,y.$Ls)(o.mainPID).then(async c=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,c)),o.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),d.forEach(u=>{if((0,p.$jn)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.f(u.machineInfo)),u.processes&&i.push(this.m(o,u.processes)),u.workspaceMetadata)for(const k of Object.keys(u.workspaceMetadata)){const I=u.workspaceMetadata[k];let C=`${I.fileCount} files`;I.maxFilesReached&&(C=`more than ${C}`),i.push(`Folder (${k}): ${C}`),i.push(this.h(I))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const d=[];let c=0;const u=(T,O)=>{const P=` ${T}(${O})`;c+P.length>60?(d.push(k),k="|                 ",c=k.length):c+=P.length,k+=P};let k="|      File types:";const I=10,C=o.fileTypes.length>I?I:o.fileTypes.length;for(let T=0;T<C;T++){const O=o.fileTypes[T];u(O.name,O.count)}if(d.push(k),o.configFiles.length>=0&&(k="|      Conf files:",c=0,o.configFiles.forEach(T=>{u(T.name,T.count)}),d.push(k)),o.launchConfigFiles.length>0){let T="|      Launch Configs:";o.launchConfigFiles.forEach(O=>{const P=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;T+=P}),d.push(T)}return d.join(`
`)}j(o){const d=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(d-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const d=[],i=[];return o.windows.forEach(c=>{c.folderURIs.length===0||c.remoteAuthority||(d.push(`|  Window (${c.title})`),c.folderURIs.forEach(u=>{const k=v.URI.revive(u);if(k.scheme===D.Schemas.file){const I=k.fsPath;i.push(g(I,["node_modules",".git"]).then(C=>{let T=`${C.fileCount} files`;C.maxFilesReached&&(T=`more than ${T}`),d.push(`|    Folder (${(0,A.$nc)(I)}): ${T}`),d.push(this.h(C))}).catch(C=>{d.push(`|      Error: Unable to collect workspace stats for folder ${I} (${C.toString()})`)}))}else d.push(`|    Folder (${k.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(c=>d.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}m(o,d){const i=new Map;o.windows.forEach(u=>i.set(u.pid,`window [${u.id}] (${u.title})`)),o.pidToNames.forEach(({pid:u,name:k})=>i.set(u,k));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),d&&this.n(o.mainPID,i,c,d,0),c.join(`
`)}n(o,d,i,c,u){const k=u===0;let I;k?I=c.pid===o?`${this.d.applicationName} main`:"remote agent":d.has(c.pid)?I=d.get(c.pid):I=`${"  ".repeat(u)} ${c.name}`;const C=process.platform==="win32"?c.mem:n.totalmem()*(c.mem/100);i.push(`${c.load.toFixed(0).padStart(5," ")}	${(C/b.$Cl.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(c.children)&&c.children.forEach(T=>this.n(o,d,i,T,u+1))}async getWorkspaceFileExtensions(o){const d=new Set;for(const{uri:i}of o.folders){const c=v.URI.revive(i);if(c.scheme!==D.Schemas.file)continue;const u=c.fsPath;try{(await g(u,["node_modules",".git"])).fileTypes.forEach(I=>d.add(I.name))}catch{}}return{extensions:[...d]}}async reportWorkspaceStats(o){for(const{uri:d}of o.folders){const i=v.URI.revive(d);if(i.scheme!==D.Schemas.file)continue;const c=i.fsPath;try{const u=await g(c,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),u.fileTypes.forEach(k=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:k.name,count:k.count})}),u.launchConfigFiles.forEach(k=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:k.name,count:k.count})}),u.configFiles.forEach(k=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:k.name,count:k.count})})}catch{}}}};e.$Ps=l,e.$Ps=l=Ue([Fe(0,f.$6l),Fe(1,a.$nk)],l)}),define(Ee[95],Se([1,0,10,5,12,24]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.ExtensionSignatureVerificationCode=e.$hq=void 0,e.$hq=(0,r.$Ai)("IExtensionSignatureVerificationService");var A;(function(s){s.None="None",s.RequiredArgumentMissing="RequiredArgumentMissing",s.InvalidArgument="InvalidArgument",s.PackageIsUnreadable="PackageIsUnreadable",s.UnhandledException="UnhandledException",s.SignatureManifestIsMissing="SignatureManifestIsMissing",s.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",s.SignatureIsMissing="SignatureIsMissing",s.SignatureIsUnreadable="SignatureIsUnreadable",s.CertificateIsUnreadable="CertificateIsUnreadable",s.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",s.FileAlreadyExists="FileAlreadyExists",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",s.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",s.Success="Success",s.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",s.SignatureIsInvalid="SignatureIsInvalid",s.SignatureManifestIsInvalid="SignatureManifestIsInvalid",s.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",s.EntryIsMissing="EntryIsMissing",s.EntryIsTampered="EntryIsTampered",s.Untrusted="Untrusted",s.CertificateRevoked="CertificateRevoked",s.SignatureIsNotValid="SignatureIsNotValid",s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(A||(e.ExtensionSignatureVerificationCode=A={}));class R extends Error{constructor(E){super(E),this.code=E}}e.$iq=R;let v=class{constructor(E,y){this.b=E,this.c=y}d(){return this.a||(this.a=new Promise((E,y)=>fe(["@vscode/vsce-sign"],async p=>E(p),y))),this.a}async verify(E,y,p,b){let a;const f=E.identifier.id;try{a=await this.d()}catch(m){return this.b.error("Could not load vsce-sign module",(0,n.$0)(m)),this.b.info(`Extension signature verification is not done: ${f}`),!1}const h=new Date().getTime();let g;try{this.b.trace(`Verifying extension signature for ${f}...`),g=await a.verify(y,p,this.b.getLevel()===S.LogLevel.Trace)}catch(m){g={code:A.UnknownError,didExecute:!1,output:(0,n.$0)(m)}}const w=new Date().getTime()-h;if(this.b.info(`Extension signature verification result for ${f}: ${g.code}. Executed: ${g.didExecute}. Duration: ${w}ms.`),this.b.trace(`Extension signature verification output for ${f}:
${g.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:f,extensionVersion:E.version,code:g.code,internalCode:g.internalCode,duration:w,didExecute:g.didExecute,clientTargetPlatform:b}),g.code===A.Success)return!0;throw new R(g.code)}};e.$jq=v,e.$jq=v=Ue([Fe(0,S.$7j),Fe(1,D.$6l)],v)}),define(Ee[274],Se([1,0,2,24]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class S extends n.$Uc{constructor(A,R){super(),this.a=A,this.b=R}async call(A,R,v){switch(R){case"updateTelemetryLevel":{const{telemetryLevel:s}=v;return this.a.updateInjectedTelemetryLevel(s)}case"logTelemetry":{const{eventName:s,data:E}=v;return this.b?this.b.log(s,E):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${R} not found`)}listen(A,R,v){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(r.TelemetryLevel.NONE),super.dispose()}}e.$Xs=S}),define(Ee[41],Se([1,0,21,11,91,130,24]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=void 0,e.$up=E,e.$vp=y,e.$wp=p,e.$xp=b,e.$yp=f,e.$zp=g,e.$Ap=w,e.$Bp=l;class R{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$np=R;class v{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$op=v,e.$pp=new v;class s{async publicLog(o,d,i){}async publicLogError(o,d,i){}}e.$qp=s,e.$rp="telemetry",e.$sp="extensionTelemetryLog",e.$tp={log:()=>null,flush:()=>Promise.resolve(null)};function E(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}function y(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function p(t){const o=t.getValue(A.$cm),d=t.getValue(A.$dm);if(t.getValue(A.$em)===!1||d===!1)return A.TelemetryLevel.NONE;switch(o??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function b(t){const o={},d={},i={};h(t,i);for(let c in i){c=c.length>150?c.substr(c.length-149):c;const u=i[c];typeof u=="number"?d[c]=u:typeof u=="boolean"?d[c]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${u.length}`),o[c]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(o[c]=u)}return{properties:o,measurements:d}}const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(t){if(!t)return"none";const o=(0,S.$Nm)(t);return a.has(o)?o:"other"}function h(t,o,d=0,i){if(t)for(const c of Object.getOwnPropertyNames(t)){const u=t[c],k=i?i+c:c;Array.isArray(u)?o[k]=(0,n.$bo)(u):u instanceof Date?o[k]=u.toISOString():(0,r.$cg)(u)?d<2?h(u,o,d+1,k+"."):o[k]=(0,n.$bo)(u):o[k]=u}}function g(t,o){const d=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,D.$mp)(d)||i}function w(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function m(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const i=[];for(const I of o)for(;;){const C=I.exec(t);if(!C)break;i.push([C.index,I.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(d="";;){const I=u.exec(t);if(!I)break;const C=i.some(([T,O])=>I.index<O&&T<u.lastIndex);!c.test(I[0])&&!C&&(d+=t.substring(k,I.index)+"<REDACTED: user-file-path>",k=u.lastIndex)}return k<t.length&&(d+=t.substr(k)),d}function $(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of o)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function l(t,o){return(0,n.$$n)(t,d=>{if(d instanceof R||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let i=d.replaceAll("%20"," ");i=m(i,o);for(const c of o)i=i.replace(c,"");return i=$(i),i}})}}),define(Ee[39],Se([1,0,17,30,23,3,4,10,33,41]),function(fe,e,n,r,S,D,A,R,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Dp=void 0,e.$Cp=E,e.$Ep=a,e.$Fp=f,e.$Gp=h,e.$Hp=g,e.$Ip=w,e.$Jp=m,e.$Kp=$,e.$Mp=l,e.$Np=o;function E(d,i){return d.uuid&&i.uuid?d.uuid===i.uuid:d.id===i.id?!0:(0,n.$wf)(d.id,i.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const c=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,c,u)}static parse(i){const c=y.exec(i);return c&&c[1]&&c[2]?new p({id:c[1]},c[2],c[4]||void 0):null}constructor(i,c,u=S.TargetPlatform.UNDEFINED){this.identifier=i,this.version=c,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==S.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?E(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Dp=p;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function a(d){const i=b.exec(d);return i&&i[1]?[h(i[1]),i[2]]:[h(d),void 0]}function f(d,i){return`${d}.${i}`}function h(d){return d.toLowerCase()}function g(d,i){return h(f(d??S.$Sm,i))}function w(d,i){const c=[],u=k=>{for(const I of c)if(I.some(C=>E(i(C),i(k))))return I;return null};for(const k of d){const I=u(k);I?I.push(k):c.push([k])}return c}function m(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function $(d){return{id:new s.$np(d.identifier.id),name:new s.$np(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Lp=new S.$Wm("pprice.better-merge");function l(d,i){const c=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const k=u.shift();if(k&&c.every(I=>!E(I.identifier,{id:k}))){const I=d.filter(C=>E(C.identifier,{id:k}));I.length===1&&(c.push(I[0]),u.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function t(d,i){if(!D.$k)return!1;let c;try{c=(await d.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await d.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){i.debug("Error while getting the os-release file.",(0,R.$0)(k))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(d,i){const c=await t(d,i),u=(0,r.$0o)(c?"alpine":D.$u,v.$ec);return i.debug("ComputeTargetPlatform:",u),u}}),define(Ee[131],Se([1,0,19,10,13,20,62,4,208,30,39,23]),function(fe,e,n,r,S,D,A,R,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;const p=f=>(0,v.localize)(0,null,f),b=(0,v.localize)(1,null,"ms-dotnettools.csharp");let a=class{constructor(h,g,w){this.a=h,this.b=g,this.d=w}get f(){}async listExtensions(h,g,w){let m=await this.b.getInstalled(y.ExtensionType.User,w);const $=y.$Vm.map(t=>t.toLowerCase());if(g&&g!==""){if($.indexOf(g.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(t=>t.manifest.categories?t.manifest.categories.map(d=>d.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){this.a.info("Possible Categories: "),$.forEach(t=>{this.a.info(t)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),m=m.sort((t,o)=>t.identifier.id.localeCompare(o.identifier.id));let l;for(const t of m)l!==t.identifier.id&&(l=t.identifier.id,this.a.info(h?`${l}@${t.manifest.version}`:l))}async installExtensions(h,g,w,m){const $=[];try{h.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const l=[],t=[],o=(i,c,u)=>{t.push({id:i,version:c!=="prerelease"?c:void 0,installOptions:{...w,isBuiltin:u,installPreReleaseVersion:c==="prerelease"||w.installPreReleaseVersion}})};for(const i of h)if(i instanceof R.URI)l.push({vsix:i,installOptions:w});else{const[c,u]=(0,E.$Ep)(i);o(c,u,!1)}for(const i of g)if(i instanceof R.URI)l.push({vsix:i,installOptions:{...w,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,u]=(0,E.$Ep)(i);o(c,u,!0)}const d=await this.b.getInstalled(void 0,w.profileLocation);if(l.length&&await Promise.all(l.map(async({vsix:i,installOptions:c})=>{try{await this.h(i,c,m,d)}catch(u){this.a.error(u),$.push(i.toString())}})),t.length){const i=await this.g(t,d,m);$.push(...i)}}catch(l){throw this.a.error((0,v.localize)(5,null,(0,r.$0)(l))),l}if($.length)throw new Error((0,v.localize)(6,null,$.join(", ")))}async updateExtensions(h){const g=await this.b.getInstalled(y.ExtensionType.User,h),w=[];for(const t of g)t.identifier.uuid&&w.push({...t.identifier,preRelease:t.preRelease});this.a.trace((0,v.localize)(7,null,w.length));const m=await this.d.getExtensions(w,{compatible:!0},n.CancellationToken.None),$=[];for(const t of m)for(const o of g)(0,E.$Cp)(o.identifier,t.identifier)&&(0,A.gt)(t.version,o.manifest.version)&&$.push({extension:t,options:{operation:s.InstallOperation.Update,installPreReleaseVersion:o.preRelease,profileLocation:h}});if(!$.length){this.a.info((0,v.localize)(8,null));return}this.a.info((0,v.localize)(9,null,$.map(t=>t.extension.identifier.id).join(", ")));const l=await this.b.installGalleryExtensions($);for(const t of l)t.error?this.a.error((0,v.localize)(10,null,t.identifier.id,(0,r.$0)(t.error))):this.a.info((0,v.localize)(11,null,t.identifier.id,t.local?.manifest.version))}async g(h,g,w){if(h=h.filter(({id:t,version:o})=>{const d=g.find(i=>(0,E.$Cp)(i.identifier,{id:t}));if(d){if(!w&&(!o||o==="prerelease"&&d.preRelease))return this.a.info((0,v.localize)(12,null,t,d.manifest.version,t)),!1;if(o&&d.manifest.version===o)return this.a.info((0,v.localize)(13,null,`${t}@${o}`)),!1}return!0}),!h.length)return[];const m=[],$=[],l=await this.j(h);if(await Promise.all(h.map(async({id:t,version:o,installOptions:d})=>{const i=l.get(t.toLowerCase());if(!i){this.a.error(`${p(o?`${t}@${o}`:t)}
${b}`),m.push(t);return}try{const u=await this.d.getManifest(i,n.CancellationToken.None);if(u&&!this.k(u))return}catch(u){this.a.error(u.message||u.stack||u),m.push(t);return}const c=g.find(u=>(0,E.$Cp)(u.identifier,i.identifier));if(c){if(i.version===c.manifest.version){this.a.info((0,v.localize)(14,null,o?`${t}@${o}`:t));return}this.a.info((0,v.localize)(15,null,t,i.version))}d.isBuiltin?this.a.info(o?(0,v.localize)(16,null,t,o):(0,v.localize)(17,null,t)):this.a.info(o?(0,v.localize)(18,null,t,o):(0,v.localize)(19,null,t)),$.push({extension:i,options:{...d,installGivenVersion:!!o}})})),$.length){const t=await this.b.installGalleryExtensions($);for(const o of t)o.error?(this.a.error((0,v.localize)(20,null,o.identifier.id,(0,r.$0)(o.error))),m.push(o.identifier.id)):this.a.info((0,v.localize)(21,null,o.identifier.id,o.local?.manifest.version))}return m}async h(h,g,w,m){const $=await this.b.getManifest(h);if(!$)throw new Error("Invalid vsix");if(await this.l($,w,g.profileLocation,m))try{await this.b.install(h,g),this.a.info((0,v.localize)(22,null,(0,D.$$g)(h)))}catch(t){if((0,r.$4)(t))this.a.info((0,v.localize)(23,null,(0,D.$$g)(h)));else throw t}}async j(h){const g=new Map,w=h.some(l=>l.installOptions.installPreReleaseVersion),m=await this.b.getTargetPlatform(),$=[];for(const l of h)s.$2o.test(l.id)&&$.push({...l,preRelease:w});if($.length){const l=await this.d.getExtensions($,{targetPlatform:m},n.CancellationToken.None);for(const t of l)g.set(t.identifier.id.toLowerCase(),t)}return g}k(h){return!0}async l(h,g,w,m){if(!g){const $={id:(0,E.$Hp)(h.publisher,h.name)},l=m.find(t=>(0,E.$Cp)($,t.identifier)&&(0,A.gt)(t.manifest.version,h.version));if(l)return this.a.info((0,v.localize)(24,null,l.identifier.id,l.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,g,w){const m=async l=>{if(l instanceof R.URI){const t=await this.b.getManifest(l);return(0,E.$Fp)(t.publisher,t.name)}return l},$=[];for(const l of h){const t=await m(l),d=(await this.b.getInstalled(void 0,w)).filter(i=>(0,E.$Cp)(i.identifier,{id:t}));if(!d.length)throw new Error(`${this.m(t)}
${b}`);if(d.some(i=>i.type===y.ExtensionType.System)){this.a.info((0,v.localize)(25,null,t));return}if(!g&&d.some(i=>i.isBuiltin)){this.a.info((0,v.localize)(26,null,t));return}this.a.info((0,v.localize)(27,null,t));for(const i of d)await this.b.uninstall(i,{profileLocation:w}),$.push(i);this.f?this.a.info((0,v.localize)(28,null,t,this.f)):this.a.info((0,v.localize)(29,null,t))}}async locateExtension(h){const g=await this.b.getInstalled();h.forEach(w=>{g.forEach(m=>{if(m.identifier.id===w&&m.location.scheme===S.Schemas.file){this.a.info(m.location.fsPath);return}})})}m(h){return this.f?(0,v.localize)(30,null,h,this.f):(0,v.localize)(31,null,h)}};e.$kq=a,e.$kq=a=Ue([Fe(1,s.$ep),Fe(2,s.$bp)],a)}),define(Ee[275],Se([1,0,6,2,26,39,23,16]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class v extends r.$Uc{constructor(E,y,p,b,a,f,h){super(),this.f=E,this.g=y,this.h=p,this.j=b,this.m=a,this.n=f,this.r=h,this.a=this.B(new n.$he),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new r.$4c),this.s().then(null,g=>h.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(E=>this.u(E.added))),this.B(this.j.onAddExtensions(E=>this.w(E))),this.B(this.j.onDidAddExtensions(E=>this.y(E))),this.B(this.j.onRemoveExtensions(E=>this.z(E))),this.B(this.j.onDidRemoveExtensions(E=>this.C(E))),this.B(this.n.onDidFilesChange(E=>this.D(E)))}async u(E){try{E.length&&await Promise.all(E.map(y=>(this.c.set(y.id,(0,r.$Rc)(this.n.watch(this.m.extUri.dirname(y.extensionsResource)),this.n.watch(y.extensionsResource))),this.G(y.extensionsResource))))}catch(y){throw this.r.error(y),y}}async w(E){for(const y of E.extensions)this.I(this.L(y.identifier,y.version),E.profileLocation)}async y(E){for(const y of E.extensions){const p=this.L(y.identifier,y.version);E.error?this.J(p,E.profileLocation):this.I(p,E.profileLocation)}}async z(E){for(const y of E.extensions)this.J(this.L(y.identifier,y.version),E.profileLocation)}async C(E){const y=[],p=[];for(const b of E.extensions){const a=this.L(b.identifier,b.version);E.error?this.I(a,E.profileLocation):(this.J(a,E.profileLocation),this.b.has(a)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),p.push(this.f.scanInstalledExtensionAtLocation(b.location).then(f=>{f?y.push(f):this.r.info("Extension not found at the location",b.location.toString())},f=>this.r.error(f)))))}try{await Promise.all(p),y.length&&await this.H(y)}catch(b){this.r.error(b)}}D(E){for(const y of this.h.profiles)E.contains(y.extensionsResource,R.FileChangeType.UPDATED,R.FileChangeType.ADDED)&&this.F(y.extensionsResource)}async F(E){const y=[],p=[],b=await this.j.scanProfileExtensions(E),a=new Set,f=new Set;for(const[h,g]of this.b)g.has(E)&&f.add(h);for(const h of b){const g=this.L(h.identifier,h.version);a.add(g),f.has(g)||(y.push(h.identifier),this.I(g,E))}for(const h of f)if(!a.has(h)){const g=this.M(h);g&&(p.push(g.identifier),this.J(h,E))}(y.length||p.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:E}:void 0,removed:p.length?{extensions:p,profileLocation:E}:void 0})}async G(E){const y=await this.j.scanProfileExtensions(E);for(const p of y)this.I(this.L(p.identifier,p.version),E)}async H(E){E||(E=(await this.f.scanAllUserInstalledExtensions()).filter(p=>!this.b.has(this.L(p.identifier,p.manifest.version)))),E.length&&await this.f.markAsUninstalled(...E)}I(E,y){let p=this.b.get(E);p||this.b.set(E,p=new S.$Bc(b=>this.m.extUri.getComparisonKey(b))),p.add(y)}J(E,y){const p=this.b.get(E);p&&p.delete(y),p?.size||this.b.delete(E)}L(E,y){return`${A.$Wm.toKey(E.id)}@${y}`}M(E){const[y,p]=(0,D.$Ep)(E);return p?{identifier:{id:y},version:p}:void 0}}e.$Lq=v}),define(Ee[132],Se([1,0,96,18,14,2,13,9,25,28,30,39,12,92,4]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0;let f=class extends b.$1r{constructor(m,$,l,t){super(l),this.h=m,this.j=t,this.g=this.B(new h($,t)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(m,$){const t=(await this.g.getLanguagePacks())[$];if(!t){this.j.warn(`No language pack found for ${$}`);return}const o=t.translations[m];return o?a.URI.file(o):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),$=Object.keys(m).map(l=>{const t=m[l];return{...this.f(l,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return $.push(this.f("en","English")),$.sort((l,t)=>l.label.localeCompare(t.label)),$}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const $=await this.g.getLanguagePacks();Object.keys($).some(l=>$[l]&&$[l].extensions.some(t=>(0,y.$Cp)(t.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,$]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update($);return!(0,r.$ub)(Object.keys(m),Object.keys(l))}};e.$2r=f,e.$2r=f=Ue([Fe(0,E.$ep),Fe(1,s.$Ii),Fe(2,E.$bp),Fe(3,p.$7j)],f);let h=class extends D.$Uc{constructor(m,$){super(),this.j=$,this.c={},this.f=(0,R.$jc)(m.userDataPath,"languagepacks.json"),this.g=new S.$Hh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s($=>{Object.keys($).forEach(l=>delete $[l]),this.m($,...m)}).then(()=>this.c)}m(m,...$){for(const l of $)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(m,l);Object.keys(m).forEach(l=>this.r(m[l]))}n(m,$){const l=$.identifier,t=$.manifest.contributes&&$.manifest.contributes.localizations?$.manifest.contributes.localizations:[];for(const o of t)if($.location.scheme===A.Schemas.file&&g(o)){let d=m[o.languageId];d||(d={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},m[o.languageId]=d);const i=d.extensions.filter(c=>(0,y.$Cp)(c.extensionIdentifier,l))[0];i?i.version=$.manifest.version:d.extensions.push({extensionIdentifier:l,version:$.manifest.version});for(const c of o.translations)d.translations[c.id]=(0,R.$jc)($.location.fsPath,c.path)}}r(m){if(m){const $=(0,n.createHash)("md5");for(const l of m.extensions)$.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);m.hash=$.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let $=null;return v.Promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>($=m(l),l)).then(l=>{for(const o of Object.keys(l))l[o]||delete l[o];this.c=l,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),v.Promises.writeFile(this.f,t)}).then(()=>$,l=>this.j.error(l))})}};h=Ue([Fe(0,s.$Ii),Fe(1,p.$7j)],h);function g(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const m of w.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(Ee[276],Se([1,0,192,10,21,41]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function v(E,y,p){const b=await(0,n.$gE)("@microsoft/1ds-core-js","dist/ms.core.js"),a=await(0,n.$gE)("@microsoft/1ds-post-js","dist/ms.post.js"),f=new b.AppInsightsCore,h=new a.PostChannel,g={instrumentationKey:E,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(p){g.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:p};g.extensionConfig[h.identifier]=w}return f.initialize(g,[]),f.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',y&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),f}class s{constructor(y,p,b,a,f){this.e=y,this.f=p,this.g=b,this.h=f,this.c=A,this.d=R,this.g||(this.g={}),typeof a=="function"?this.a=a():this.a=a,this.b=null}i(y){if(this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=v(this.a,this.e,this.h)),this.b.then(p=>{y(p)},p=>{(0,r.$1)(p),console.error(p)})}}log(y,p){if(!this.a)return;p=(0,S.$_n)(p,this.g),p=(0,D.$xp)(p);const b=this.f+"/"+y;try{this.i(a=>{a.pluginVersionString=p?.properties.version??"Unknown",a.track({name:b,baseData:{name:b,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.$_P=s}),define(Ee[277],Se([1,0,2,21,3,17,223,27,46,63,29,38,24,41]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=void 0;let a=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,w,m){this.k=w,this.l=m,this.d={},this.i=new n.$Tc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=p.TelemetryLevel.USAGE,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,D.$df)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$df)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(p.$cm)||$.affectsConfiguration(p.$em)||$.affectsConfiguration(p.$dm))&&this.m()}))}setExperimentProperty(g,w){this.d[g]=w}m(){let g=(0,b.$wp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const m=w.usage?p.TelemetryLevel.USAGE:w.error?p.TelemetryLevel.ERROR:p.TelemetryLevel.NONE;g=Math.min(g,m)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,w,m){this.g<w||(m=(0,r.$_n)(m,this.d),m=(0,b.$Bp)(m,this.j),m=(0,r.$_n)(m,this.c),this.b.forEach($=>$.log(g,m)))}publicLog(g,w){this.n(g,p.TelemetryLevel.USAGE,w)}publicLog2(g,w){this.publicLog(g,w)}publicLogError(g,w){this.h&&this.n(g,p.TelemetryLevel.ERROR,w)}publicLogError2(g,w){this.publicLogError(g,w)}};e.$8r=a,e.$8r=a=Ue([Fe(1,R.$7i),Fe(2,E.$nk)],a);function f(){const h=(0,A.localize)(0,null,s.default.nameLong),g=s.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",s.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=S.$o?"":(0,A.localize)(3,null),m=(0,A.localize)(4,null),$=(0,A.localize)(5,null),l=(0,A.localize)(6,null),t=(0,A.localize)(7,null),o=`
|       | ${m} | ${$} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,d=(0,A.localize)(8,null);return`
${h} ${g} ${w}

&nbsp;

${t}
${o}

&nbsp;

${d}
`}y.$jo.as(v.$oo.Configuration).registerConfiguration({id:p.$bm,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[p.$cm]:{type:"string",enum:[p.TelemetryConfiguration.ON,p.TelemetryConfiguration.ERROR,p.TelemetryConfiguration.CRASH,p.TelemetryConfiguration.OFF],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:f(),default:p.TelemetryConfiguration.ON,restricted:!0,scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),y.$jo.as(v.$oo.Configuration).registerConfiguration({id:p.$bm,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[p.$em]:{type:"boolean",markdownDescription:s.default.privacyStatementUrl?(0,A.localize)(16,null,s.default.nameLong,s.default.privacyStatementUrl):(0,A.localize)(15,null,s.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${p.$cm}#\``),scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(Ee[278],Se([1,0,27,5,29,24,277,41]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=e.$Us=void 0;let v=class extends A.$8r{constructor(E,y,p,b){super(E,p,b),this.o=y}publicLog(E,y){if(!(this.o<D.TelemetryLevel.USAGE))return super.publicLog(E,y)}publicLog2(E,y){return this.publicLog(E,y)}publicLogError(E,y){return this.o<D.TelemetryLevel.ERROR?Promise.resolve(void 0):super.publicLogError(E,y)}publicLogError2(E,y){return this.publicLogError(E,y)}async updateInjectedTelemetryLevel(E){if(E===void 0)throw this.o=D.TelemetryLevel.NONE,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,E):E,this.o===D.TelemetryLevel.NONE&&this.dispose()}};e.$Us=v,e.$Us=v=Ue([Fe(2,n.$7i),Fe(3,S.$nk)],v),e.$Vs=new class extends R.$op{async updateInjectedTelemetryLevel(){}},e.$Ws=(0,r.$Bi)(D.$6l)}),define(Ee[279],Se([1,0,15,19,337,276]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0;async function A(E,y){const p=await y.request(E,r.CancellationToken.None),b=(await(0,n.$Ve)(p.stream)).toString(),a=p.res.statusCode??200;return{headers:p.res.headers,statusCode:a,responseData:b}}async function R(E){const y={method:E.type,headers:E.headers};return new Promise((b,a)=>{const f=S.request(E.url??"",y,h=>{h.on("data",function(g){b({headers:h.headers,statusCode:h.statusCode??200,responseData:g.toString()})}),h.on("error",function(g){a(g)})});f.write(E.data,h=>{h&&a(h)}),f.end()})}async function v(E,y,p){const b=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),a={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:b};try{const f=E?await A(a,E):await R(a);p(f.statusCode,f.headers,f.responseData)}catch{p(0,{})}}class s extends D.$_P{constructor(y,p,b,a,f){const h={sendPOST:(g,w)=>{v(y,g,w)}};super(p,b,a,f,h)}}e.$aQ=s}),define(Ee[280],Se([1,0,10,272]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class S extends r.default{i(){(0,n.setUnexpectedErrorHandler)(R=>console.error(R));const A=[];process.on("unhandledRejection",(R,v)=>{A.push(v),setTimeout(()=>{const s=A.indexOf(v);s>=0&&v.catch(E=>{A.splice(s,1),(0,n.$4)(E)||(console.warn(`rejected promise not handled within 1 second: ${E}`),E.stack&&console.warn(`stack trace: ${E.stack}`),R&&(0,n.$1)(R))})},1e3)}),process.on("rejectionHandled",R=>{const v=A.indexOf(R);v>=0&&A.splice(v,1)}),process.on("uncaughtException",R=>{(0,n.$Z)(R)||(0,n.$1)(R)})}}e.default=S}),define(Ee[133],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(Ee[134],Se([1,0,3,133]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;const S=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(E){this.collections=E,this.a=new Map,this.b=new Map,E.forEach((y,p)=>{this.d(y,p);const b=y.map.entries();let a=b.next();for(;!a.done;){const f=a.value[1],h=a.value[0];let g=this.a.get(h);if(g||(g=[],this.a.set(h,g)),g.length>0&&g[0].type===r.EnvironmentVariableMutatorType.Replace){a=b.next();continue}const w={extensionIdentifier:p,value:f.value,type:f.type,scope:f.scope,variable:f.variable,options:f.options};w.scope||delete w.scope,g.unshift(w),a=b.next()}})}async applyToProcessEnvironment(E,y,p){let b;n.$i&&(b={},Object.keys(E).forEach(a=>b[a.toLowerCase()]=a));for(const[a,f]of this.getVariableMap(y)){const h=n.$i&&b[a.toLowerCase()]||a;for(const g of f){const w=p?await p(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case r.EnvironmentVariableMutatorType.Append:E[h]=(E[h]||"")+w;break;case r.EnvironmentVariableMutatorType.Prepend:E[h]=w+(E[h]||"");break;case r.EnvironmentVariableMutatorType.Replace:E[h]=w;break}if(g.options?.applyAtShellIntegration??!1){const m=`VSCODE_ENV_${S.get(g.type)}`;E[m]=(E[m]?E[m]+":":"")+a+"="+this.c(w)}}}}c(E){return E.replaceAll(":","\\x3a")}diff(E,y){const p=new Map,b=new Map,a=new Map;if(E.getVariableMap(y).forEach((f,h)=>{const g=this.getVariableMap(y).get(h),w=R(f,g);w&&p.set(h,w)}),this.getVariableMap(y).forEach((f,h)=>{const g=E.getVariableMap(y).get(h),w=R(f,g);w&&a.set(h,w)}),this.getVariableMap(y).forEach((f,h)=>{const g=E.getVariableMap(y).get(h),w=v(f,g);w&&b.set(h,w)}),!(p.size===0&&b.size===0&&a.size===0))return{added:p,changed:b,removed:a}}getVariableMap(E){const y=new Map;for(const p of this.a.values()){const b=p.filter(a=>A(a,E));b.length>0&&y.set(b[0].variable,b)}return y}getDescriptionMap(E){const y=new Map;for(const p of this.b.values()){const b=p.filter(a=>A(a,E,!0));for(const a of b)y.set(a.extensionIdentifier,a.description)}return y}d(E,y){if(!E.descriptionMap)return;const p=E.descriptionMap.entries();let b=p.next();for(;!b.done;){const a=b.value[1],f=b.value[0];let h=this.b.get(f);h||(h=[],this.b.set(f,h));const g={extensionIdentifier:y,scope:a.scope,description:a.description};g.scope||delete g.scope,h.push(g),b=p.next()}}}e.$zs=D;function A(s,E,y=!1){return s.scope?!!(s.scope.workspaceFolder&&E?.workspaceFolder&&s.scope.workspaceFolder.index===E.workspaceFolder.index):y?E===s.scope:!0}function R(s,E){if(!E)return s;const y=new Set;E.forEach(b=>y.add(b.extensionIdentifier));const p=[];return s.forEach(b=>{y.has(b.extensionIdentifier)||p.push(b)}),p.length===0?void 0:p}function v(s,E){if(!E)return;const y=new Map;E.forEach(b=>y.set(b.extensionIdentifier,b));const p=[];return s.forEach(b=>{const a=y.get(b.extensionIdentifier);a&&(b.type!==a.type||b.value!==a.value||b.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&p.push(a)}),p.length===0?void 0:p}}),define(Ee[97],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=n,e.$us=r,e.$vs=S,e.$ws=D,e.$xs=A,e.$ys=R;function n(v){return[...v.entries()]}function r(v){return v?[...v.entries()]:[]}function S(v){return new Map(v)}function D(v){return new Map(v??[])}function A(v){return Array.from(v.entries()).map(s=>[s[0],n(s[1].map),r(s[1].descriptionMap)])}function R(v){return new Map(v.map(s=>[s[0],{map:S(s[1]),descriptionMap:D(s[2])}]))}}),define(Ee[281],Se([1,0,14,19,6,2,12]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;let R=class extends D.$Uc{constructor(s,E){super(),this.h=E,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$he),this.onCreateRequest=this.g.event,this.b=s===void 0?15e3:s,this.B((0,D.$Sc)(()=>{for(const y of this.f.values())(0,D.$Pc)(y)}))}createRequest(s){return new Promise((E,y)=>{const p=++this.a;this.c.set(p,E),this.g.fire({requestId:p,...s});const b=new r.$se;(0,n.$Bh)(this.b,b.token).then(()=>y(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,D.$Sc)(()=>b.cancel())])})}acceptReply(s,E){const y=this.c.get(s);y?(this.c.delete(s),(0,D.$Pc)(this.f.get(s)||[]),this.f.delete(s),y(E)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${s}`)}};e.$ks=R,e.$ks=R=Ue([Fe(1,A.$7j)],R)}),define(Ee[52],Se([1,0,5,43,38]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=e.$fs=e.$es=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ds=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$cs=void 0,e.$cs=new r.$Rj("terminalTabFocusMode",!1,!0);var D;(function(l){l.AutomationProfile="terminal.integrated.automationProfile.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var A;(function(l){l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.TabStopWidth="terminal.integrated.tabStopWidth",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorStyleInactive="terminal.integrated.cursorStyleInactive",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.MiddleClickBehavior="terminal.integrated.middleClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.EnableVisualBell="terminal.integrated.enableVisualBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.TabFocusMode="terminal.integrated.tabFocusMode",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.HideOnStartup="terminal.integrated.hideOnStartup",l.CustomGlyphs="terminal.integrated.customGlyphs",l.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.EnableImages="terminal.integrated.enableImages",l.SmoothScrolling="terminal.integrated.smoothScrolling",l.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",l.FocusAfterRun="terminal.integrated.focusAfterRun",l.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",l.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",l.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var R;(function(l){l.PowerShell="pwsh",l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh",l.Python="python"})(R||(e.PosixShellType=R={}));var v;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash",l.Python="python"})(v||(e.WindowsShellType=v={}));var s;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(s||(e.TitleEventSource=s={}));var E;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.PtyHostWindow="ptyHostWindow",l.Logger="logger",l.Heartbeat="heartbeat"})(E||(e.TerminalIpcChannels=E={}));var y;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$ds=(0,n.$Ai)("ptyService");var p;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var b;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(b||(e.TerminalLocation=b={}));var a;(function(l){l.TerminalView="view",l.Editor="editor"})(a||(e.TerminalLocationString=a={}));var f;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(f||(e.LocalReconnectConstants=f={}));var h;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(h||(e.FlowControlConstants=h={}));var g;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var w;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(w||(e.ShellIntegrationStatus=w={}));var m;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(m||(e.TerminalExitReason=m={})),e.$es={Backend:"workbench.contributions.terminal.processBackend"};class ${constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}S.$jo.add(e.$es.Backend,new $),e.$fs=(0,n.$Ai)("localPtyService"),e.$gs=(0,n.$Ai)("terminalLogService")}),define(Ee[135],Se([1,0,3]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=r,e.$PP=S,e.$QP=D,e.$RP=A;function r(R){let v=R;v.includes("\\")&&(v=v.replace(/\\/g,"\\\\"));const s=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return v=v.replace(s,""),`'${v}'`}function S(R,v,s){if(!R)return"";if(!v)return R;v.match(/[\/\\]$/)&&(v=v.slice(0,v.length-1));const E=R.replace(/\\/g,"/").toLowerCase(),y=v.replace(/\\/g,"/").toLowerCase();return E.includes(y)?`~${s}${R.slice(v.length+1)}`:R}function D(R){return R.match(/^['"].*['"]$/)&&(R=R.substring(1,R.length-1)),n.OS===n.OperatingSystem.Windows&&R&&R[1]===":"?R[0].toUpperCase()+R.substring(1):R}function A(R){return!R.strictEnv}}),define(Ee[282],Se([1,0,57,4,225,81]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=A,e.$ms=s,e.$ns=E,e.$os=y;function A(p,b){const a=[{name:null,description:(0,S.localize)(0,null)}];return a.push(...p.map(f=>({name:f.profileName,description:R(f)}))),b&&a.push(...b.map(f=>({name:f.title,description:v(f)}))),{values:a.map(f=>f.name),markdownDescriptions:a.map(f=>f.description)}}function R(p){let b=`$(${D.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:n.$Zj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?b+=`
- args: "${p.args}"`:b+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(b+=`
- overrideName: ${p.overrideName}`),p.color&&(b+=`
- color: ${p.color}`),p.env&&(b+=`
- env: ${JSON.stringify(p.env)}`),b}function v(p){return`$(${D.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:n.$Zj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function s(p,b){if(!p&&!b)return!0;if(typeof p=="string"&&typeof b=="string")return p===b;if(Array.isArray(p)&&Array.isArray(b)){if(p.length!==b.length)return!1;for(let a=0;a<p.length;a++)if(p[a]!==b[a])return!1;return!0}return!1}function E(p,b){if(!p&&!b)return!0;if(!p||!b)return!1;if(D.ThemeIcon.isThemeIcon(p)&&D.ThemeIcon.isThemeIcon(b))return p.id===b.id&&p.color===b.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof b=="object"&&"light"in b&&"dark"in b){const a=p,f=b;if((r.URI.isUri(a.light)||y(a.light))&&(r.URI.isUri(a.dark)||y(a.dark))&&(r.URI.isUri(f.light)||y(f.light))&&(r.URI.isUri(f.dark)||y(f.dark)))return a.light.path===f.light.path&&a.dark.path===f.dark.path}if(r.URI.isUri(p)&&r.URI.isUri(b)||y(p)||y(b)){const a=p,f=b;return a.path===f.path&&a.scheme===f.scheme}return!1}function y(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}}),define(Ee[283],Se([1,0,57,3,224,46,38,52,282]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=e.$ps=void 0,e.$rs=a,e.$ss=h,e.$ps={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$qs={type:"string",enum:Array.from((0,n.$Xj)(),g=>g.id),markdownEnumDescriptions:Array.from((0,n.$Xj)(),g=>`$(${g.id})`)};const s={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$qs},color:{description:(0,S.localize)(3,null),...e.$ps},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...s}},y={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...s}};function p(g){const w=g===r.Platform.Linux?"linux":g===r.Platform.Mac?"osx":"windows";return(0,S.localize)(7,null,(0,r.$h)(g),'```json\n"terminal.integrated.profile.'+w+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const b={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{[R.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[R.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:p(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...s}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...s}},{type:"null"},E]}},[R.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:p(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...s}},{type:"null"},E]}},[R.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:p(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...s}},{type:"null"},E]}},[R.TerminalSettingId.UseWslProfiles]:{description:(0,S.localize)(22,null),type:"boolean",default:!0},[R.TerminalSettingId.InheritEnv]:{scope:D.ConfigurationScope.APPLICATION,description:(0,S.localize)(23,null),type:"boolean",default:!0},[R.TerminalSettingId.PersistentSessionScrollback]:{scope:D.ConfigurationScope.APPLICATION,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},[R.TerminalSettingId.ShowLinkHover]:{scope:D.ConfigurationScope.APPLICATION,description:(0,S.localize)(25,null),type:"boolean",default:!0},[R.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function a(){A.$jo.as(D.$oo.Configuration).registerConfiguration(b),h()}let f;function h(g,w){const m=A.$jo.as(D.$oo.Configuration);let $;g&&($=(0,v.$ls)(g?.profiles,w));const l=f;f={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{[R.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:g?.os===r.OperatingSystem.Linux?$?.values:void 0,markdownEnumDescriptions:g?.os===r.OperatingSystem.Linux?$?.markdownDescriptions:void 0},[R.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:g?.os===r.OperatingSystem.Macintosh?$?.values:void 0,markdownEnumDescriptions:g?.os===r.OperatingSystem.Macintosh?$?.markdownDescriptions:void 0},[R.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:g?.os===r.OperatingSystem.Windows?$?.values:void 0,markdownEnumDescriptions:g?.os===r.OperatingSystem.Windows?$?.markdownDescriptions:void 0}}},m.updateConfigurations({add:[f],remove:l?[l]:[]})}}),define(Ee[284],Se([1,0,2,13,117,28,118]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=void 0;let R=class extends n.$Uc{constructor(s,E){super(),this.a=s,this.b=E}start(){const s={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:r.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},E=(0,A.$cn)(this.b.args,this.b.isBuilt);E&&(E.break&&E.port?s.debugBrk=E.port:!E.break&&E.port&&(s.debug=E.port));const y=new S.$9q(r.$Ug.asFileUri("bootstrap-fork").fsPath,s),p=new n.$Tc;return p.add(y),{client:y,store:p,onDidProcessExit:y.onDidProcessExit}}};e.$uQ=R,e.$uQ=R=Ue([Fe(1,D.$Hi)],R)}),define(Ee[285],Se([1,0,32,13,21,9,3,33,17,11,25,133,97,134]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=a,e.$Bs=f,e.$Cs=h;function a(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let k=0;return u&&u.length===4&&(k=parseInt(u[3])),k}async function f(u,k,I,C=R.env,T=E.Promises.exists){if(D.$ic(u))return await T(u)?u:void 0;if(k===void 0&&(k=R.cwd()),D.$mc(u)!=="."){const Q=D.$jc(k,u);return await T(Q)?Q:void 0}const P=(0,S.$do)(C,"PATH");if(I===void 0&&(0,s.$ag)(P)&&(I=P.split(D.$tc)),I===void 0||I.length===0){const Q=D.$jc(k,u);return await T(Q)?Q:void 0}for(const Q of I){let ie;if(D.$ic(Q)?ie=D.$jc(Q,u):ie=D.$jc(k,Q,u),await T(ie))return ie;if(A.$i){let re=ie+".com";if(await T(re)||(re=ie+".exe",await T(re)))return re}}const V=D.$jc(k,u);return await T(V)?V:void 0}function h(u,k,I,C,T){const O=A.$i&&(!k.windowsEnableConpty||a()<18309);if(!k.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||O)return;const P=u.args,V=R.$dc==="win32"?D.$nc(u.executable).toLowerCase():D.$nc(u.executable),Q=D.$mc(r.$Ug.asFileUri("").fsPath);let ie;const re={VSCODE_INJECTION:"1"};if(k.shellIntegration.nonce&&(re.VSCODE_NONCE=k.shellIntegration.nonce),A.$i){if(V==="pwsh.exe"||V==="powershell.exe")return!P||i(P)?ie=m.get(w.WindowsPwsh):d(P)&&(ie=m.get(w.WindowsPwshLogin)),ie?(ie=[...ie],ie[ie.length-1]=(0,v.$_e)(ie[ie.length-1],Q,""),k.shellIntegration.suggestEnabled&&(re.VSCODE_SUGGEST="1"),{newArgs:ie,envMixin:re}):void 0;if(V==="bash.exe")return!P||P.length===0?ie=m.get(w.Bash):c(P)&&(re.VSCODE_SHELL_LOGIN="1",g(k,re),ie=m.get(w.Bash)),ie?(ie=[...ie],ie[ie.length-1]=(0,v.$_e)(ie[ie.length-1],Q),{newArgs:ie,envMixin:re}):void 0;C.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(V){case"bash":return!P||P.length===0?ie=m.get(w.Bash):c(P)&&(re.VSCODE_SHELL_LOGIN="1",g(k,re),ie=m.get(w.Bash)),ie?(ie=[...ie],ie[ie.length-1]=(0,v.$_e)(ie[ie.length-1],Q),{newArgs:ie,envMixin:re}):void 0;case"fish":{const ne=I?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",se=D.$jc(Q,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return re.XDG_DATA_DIRS=`${ne}:${se}`,g(k,re),{newArgs:void 0,envMixin:re}}case"pwsh":return!P||i(P)?ie=m.get(w.Pwsh):d(P)&&(ie=m.get(w.PwshLogin)),ie?(k.shellIntegration.suggestEnabled&&(re.VSCODE_SUGGEST="1"),ie=[...ie],ie[ie.length-1]=(0,v.$_e)(ie[ie.length-1],Q,""),{newArgs:ie,envMixin:re}):void 0;case"zsh":{if(!P||P.length===0?ie=m.get(w.Zsh):c(P)?(ie=m.get(w.ZshLogin),g(k,re)):(P===m.get(w.Zsh)||P===m.get(w.ZshLogin))&&(ie=P),!ie)return;ie=[...ie],ie[ie.length-1]=(0,v.$_e)(ie[ie.length-1],Q);let ne;try{ne=n.userInfo().username}catch{ne="unknown"}const se=D.$jc(n.tmpdir(),`${ne}-${T.applicationName}-zsh`);re.ZDOTDIR=se;const Z=I?.ZDOTDIR??n.homedir()??"~";re.USER_ZDOTDIR=Z;const ee=[];return ee.push({source:D.$jc(Q,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$jc(se,".zshrc")}),ee.push({source:D.$jc(Q,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$jc(se,".zprofile")}),ee.push({source:D.$jc(Q,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$jc(se,".zshenv")}),ee.push({source:D.$jc(Q,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$jc(se,".zlogin")}),{newArgs:ie,envMixin:re,filesToCopy:ee}}}C.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function g(u,k){if(A.$j&&u.environmentVariableCollections){const I=(0,p.$ys)(u.environmentVariableCollections),T=new b.$zs(I).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),O=[];if(T)for(const P of T)P.type===y.EnvironmentVariableMutatorType.Prepend&&O.push(P.value);O.length>0&&(k.VSCODE_PATH_PREFIX=O.join(""))}}var w;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(w||(w={}));const m=new Map;m.set(w.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(w.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(w.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),m.set(w.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),m.set(w.Zsh,["-i"]),m.set(w.ZshLogin,["-il"]),m.set(w.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const $=["-login","-l"],l=["--login","-l"],t=["-i","--interactive"],o=["-nol","-nologo"];function d(u){return typeof u=="string"?$.includes(u.toLowerCase()):u.length===1&&$.includes(u[0].toLowerCase())||u.length===2&&($.includes(u[0].toLowerCase())||$.includes(u[1].toLowerCase()))&&(o.includes(u[0].toLowerCase())||o.includes(u[1].toLowerCase()))}function i(u){return typeof u=="string"?o.includes(u.toLowerCase()):u.length===0||u?.length===1&&o.includes(u[0].toLowerCase())}function c(u){return typeof u!="string"&&(u=u.filter(k=>!t.includes(k.toLowerCase()))),u==="string"&&l.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&l.includes(u[0].toLowerCase())}}),define(Ee[286],Se([1,0,60,57,9,3,11,25,113,52,285,82]),function(fe,e,n,r,S,D,A,R,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=f;var p;(function(k){k.UnixShellsPath="/etc/shells"})(p||(p={}));let b,a=!0;function f(k,I,C,T,O=process.env,P,V,Q,ie){return P=P||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},D.$i?h(C,P,O,V,T.getValue(s.TerminalSettingId.UseWslProfiles)!==!1,k&&typeof k=="object"?{...k}:T.getValue(s.TerminalSettingId.ProfilesWindows),typeof I=="string"?I:T.getValue(s.TerminalSettingId.DefaultProfileWindows),ie,Q):i(P,V,C,k&&typeof k=="object"?{...k}:T.getValue(D.$k?s.TerminalSettingId.ProfilesLinux:s.TerminalSettingId.ProfilesMacOs),typeof I=="string"?I:T.getValue(D.$k?s.TerminalSettingId.DefaultProfileLinux:s.TerminalSettingId.DefaultProfileMacOs),ie,Q,O)}async function h(k,I,C,T,O,P,V,Q,ie){const re=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=`${process.env.windir}\\${re?"Sysnative":"System32"}`;let se=!1;(0,E.$As)()>=16299&&(se=!0),await $(Q);const Z=new Map;if(k){Z.set("PowerShell",{source:s.ProfileSource.Pwsh,icon:r.$Zj.terminalPowershell,isAutoDetected:!0}),Z.set("Windows PowerShell",{path:`${ne}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.$Zj.terminalPowershell,isAutoDetected:!0}),Z.set("Git Bash",{source:s.ProfileSource.GitBash,isAutoDetected:!0}),Z.set("Command Prompt",{path:`${ne}\\cmd.exe`,icon:r.$Zj.terminalCmd,isAutoDetected:!0}),Z.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),Z.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:r.$Zj.terminalBash,isAutoDetected:!0});const ue=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;Z.set("Cmder",{path:`${ne}\\cmd.exe`,args:["/K",ue],requiresPath:process.env.CMDER_ROOT?ue:{path:ue,isUnsafe:!0},isAutoDetected:!0})}c(P,Z);const ee=await g(Z.entries(),V,I,C,T,ie);if(k&&O)try{const ue=await o(`${ne}\\${se?"wsl":"bash"}.exe`,V);for(const j of ue)(!P||!(j.profileName in P))&&ee.push(j)}catch{a&&(T?.trace("WSL is not installed, so could not detect WSL profiles"),a=!1)}return ee}async function g(k,I,C,T=process.env,O,P){const V=[];for(const[Q,ie]of k)V.push(w(Q,ie,I,C,T,O,P));return(await Promise.all(V)).filter(Q=>!!Q)}async function w(k,I,C,T,O=process.env,P,V){if(I===null)return;let Q,ie,re;if("source"in I&&!("path"in I)){const ee=b?.get(I.source);if(!ee)return;Q=ee.paths,ie=I.args||ee.args,I.icon?re=m(I.icon):ee.icon&&(re=ee.icon)}else Q=Array.isArray(I.path)?I.path:[I.path],ie=D.$i||Array.isArray(I.args)?I.args:void 0,re=m(I.icon);let ne;if(V){const ee=Q.map(j=>typeof j=="string"?j:j.path),ue=await V(ee);ne=new Array(Q.length);for(let j=0;j<Q.length;j++)typeof Q[j]=="string"?ne[j]=ue[j]:ne[j]={path:ue[j],isUnsafe:!0}}else ne=Q.slice();let se;if(I.requiresPath){let ee;if((0,A.$ag)(I.requiresPath)?ee=I.requiresPath:(ee=I.requiresPath.path,I.requiresPath.isUnsafe&&(se=ee)),!await T.existsFile(ee))return}const Z=await u(k,C,ne,T,O,ie,I.env,I.overrideName,I.isAutoDetected,se);if(!Z){P?.debug("Terminal profile not validated",k,Q);return}return Z.isAutoDetected=I.isAutoDetected,Z.icon=re,Z.color=I.color,Z}function m(k){return typeof k=="string"?{id:k}:k}async function $(k){if(b&&!k)return;const[I,C]=await Promise.all([l(),k||t()]);b=new Map,b.set(s.ProfileSource.GitBash,{profileName:"Git Bash",paths:I,args:["--login","-i"]}),b.set(s.ProfileSource.Pwsh,{profileName:"PowerShell",paths:C,icon:r.$Zj.terminalPowershell})}async function l(){const k=new Set,I=await(0,E.$Bs)("git.exe");if(I){const O=(0,y.dirname)(I);k.add((0,y.resolve)(O,"../.."))}function C(O,P){P&&O.add(P)}C(k,process.env.ProgramW6432),C(k,process.env.ProgramFiles),C(k,process.env["ProgramFiles(X86)"]),C(k,`${process.env.LocalAppData}\\Program`);const T=[];for(const O of k)T.push(`${O}\\Git\\bin\\bash.exe`,`${O}\\Git\\usr\\bin\\bash.exe`,`${O}\\usr\\bin\\bash.exe`);return T.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),T.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),T}async function t(){const k=[];for await(const I of(0,v.$pm)())k.push(I.exePath);return k}async function o(k,I){const C=[],T=await new Promise((V,Q)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(ie,re)=>{if(ie)return Q("Problem occurred when getting wsl distros");V(re)})});if(!T)return[];const O=new RegExp(/[\r?\n]/),P=T.split(O).filter(V=>V.trim().length>0&&V!=="");for(const V of P){if(V===""||V.startsWith("docker-desktop"))continue;const Q=`${V} (WSL)`,ie={profileName:Q,path:k,args:["-d",`${V}`],isDefault:Q===I,icon:d(V),isAutoDetected:!1};C.push(ie)}return C}function d(k){return k.includes("Ubuntu")?r.$Zj.terminalUbuntu:k.includes("Debian")?r.$Zj.terminalDebian:r.$Zj.terminalLinux}async function i(k,I,C,T,O,P,V,Q){const ie=new Map;if(C&&await k.existsFile(p.UnixShellsPath)){const re=(await k.readFile(p.UnixShellsPath)).toString(),ne=(P||re.split(`
`)).map(Z=>{const ee=Z.indexOf("#");return ee===-1?Z:Z.substring(0,ee)}).filter(Z=>Z.trim().length>0),se=new Map;for(const Z of ne){let ee=(0,S.$nc)(Z),ue=se.get(ee)||0;ue++,ue>1&&(ee=`${ee} (${ue})`),se.set(ee,ue),ie.set(ee,{path:Z,isAutoDetected:!0})}}return c(T,ie),await g(ie.entries(),O,k,Q,I,V)}function c(k,I){if(k)for(const[C,T]of Object.entries(k))T===null||typeof T!="object"||!("path"in T)&&!("source"in T)?I.delete(C):(T.icon=T.icon||I.get(C)?.icon,I.set(C,T))}async function u(k,I,C,T,O,P,V,Q,ie,re){if(C.length===0)return Promise.resolve(void 0);const ne=C.shift();if(ne==="")return u(k,I,C,T,O,P,V,Q,ie);const se=typeof ne!="string"&&ne.isUnsafe,Z=typeof ne=="string"?ne:ne.path,ee={profileName:k,path:Z,args:P,env:V,overrideName:Q,isAutoDetected:ie,isDefault:k===I,isUnsafePath:se,requiresUnsafePath:re};if((0,S.$nc)(Z)===Z){const j=O.PATH?O.PATH.split(S.$tc):void 0,B=await(0,E.$Bs)(Z,void 0,j,void 0,T.existsFile);return B?(ee.path=B,ee.isFromPath=!0,ee):u(k,I,C,T,O,P)}return await T.existsFile((0,S.$hc)(Z))?ee:u(k,I,C,T,O,P,V,Q,ie)}}),define(Ee[287],Se([1,0,6,2,3,50,27,12,123,94,281,52,283,286,116,55]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;var h;(function(w){w[w.MaxRestarts=5]="MaxRestarts"})(h||(h={}));let g=class extends r.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(m,$,l,t){super(),this.M=m,this.N=$,this.O=l,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$he),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$he),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$he),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$he),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$he),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$he),this.onProcessData=this.D.event,this.F=this.B(new n.$he),this.onProcessReady=this.F.event,this.G=this.B(new n.$he),this.onProcessReplay=this.G.event,this.H=this.B(new n.$he),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$he),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$he),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$he),this.onProcessExit=this.L.event,(0,p.$rs)(),this.B(this.M),this.B((0,r.$Sc)(()=>this.W())),this.j=this.B(new E.$ks(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue(y.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$i)return process.env;try{return await(0,s.$Lm)(this.N,this.O,{_:[]},process.env)}catch(m){return this.O.error("ptyHost was unable to resolve shell environment",m),{}}}U(){const m=this.M.start(),$=m.client;this.O.getLevel()===R.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService($.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(m.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=h.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=D.ProxyChannel.toService($.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new v.$js(this.P,$.getChannel(y.TerminalIpcChannels.Logger))),this.a=m,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration(y.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[m,t]}async createProcess(m,$,l,t,o,d,i,c,u,k,I){const C=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),T=await this.f.createProcess(m,$,l,t,o,d,i,c,u,k,I);return clearTimeout(C),T}updateTitle(m,$,l){return this.f.updateTitle(m,$,l)}updateIcon(m,$,l,t){return this.f.updateIcon(m,$,l,t)}attachToProcess(m){return this.f.attachToProcess(m)}detachFromProcess(m,$){return this.f.detachFromProcess(m,$)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(m){return this.f.start(m)}shutdown(m,$){return this.f.shutdown(m,$)}input(m,$){return this.f.input(m,$)}processBinary(m,$){return this.f.processBinary(m,$)}resize(m,$,l){return this.f.resize(m,$,l)}clearBuffer(m){return this.f.clearBuffer(m)}acknowledgeDataEvent(m,$){return this.f.acknowledgeDataEvent(m,$)}setUnicodeVersion(m,$){return this.f.setUnicodeVersion(m,$)}getInitialCwd(m){return this.f.getInitialCwd(m)}getCwd(m){return this.f.getCwd(m)}async getLatency(){const m=new f.$be,$=await this.f.getLatency();return m.stop(),[{label:"ptyhostservice<->ptyhost",latency:m.elapsed()},...$]}orphanQuestionReply(m){return this.f.orphanQuestionReply(m)}installAutoReply(m,$){return this.f.installAutoReply(m,$)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(m){return this.f.uninstallAutoReply(m)}getDefaultSystemShell(m){return this.g?.getDefaultSystemShell(m)??(0,a.$vm)(m??S.OS,process.env)}async getProfiles(m,$,l,t=!1){const o=await this.S();return(0,b.$Ds)($,l,t,this.N,o,void 0,this.O,this.bb.bind(this,m))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(m,$){return this.f.getWslPath(m,$)}getRevivedPtyNewId(m,$){return this.f.getRevivedPtyNewId(m,$)}setTerminalLayoutInfo(m){return this.f.setTerminalLayoutInfo(m)}async getTerminalLayoutInfo(m){return this.g?.getTerminalLayoutInfo(m)}async requestDetachInstance(m,$){return this.f.requestDetachInstance(m,$)}async acceptDetachInstanceReply(m,$){return this.f.acceptDetachInstanceReply(m,$)}async freePortKillProcess(m){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(m)}async serializeTerminalState(m){return this.f.serializeTerminalState(m)}async reviveTerminalProcesses(m,$,l){return this.f.reviveTerminalProcesses(m,$,l)}async refreshProperty(m,$){return this.f.refreshProperty(m,$)}async updateProperty(m,$,l){return this.f.updateProperty(m,$,l)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(m){this.ab(),this.s=setTimeout(()=>this.Y(),m?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(m,$){return this.j.createRequest({workspaceId:m,originalText:$})}async acceptPtyHostResolvedVariables(m,$){this.j.acceptReply(m,$)}};e.$Es=g,e.$Es=g=Ue([Fe(1,A.$7i),Fe(2,R.$7j),Fe(3,R.$8j)],g)}),define(Ee[36],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,n.$Ai)("IUriIdentityService")}),define(Ee[136],Se([1,0,36,119,16,20,167,6,2]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;class s{static{this._clock=0}constructor(p){this.uri=p,this.time=s._clock++}touch(){return this.time=s._clock++,this}}let E=class{constructor(p){this.g=p,this.c=new v.$Tc,this.f=2**16;const b=new Map,a=f=>{let h=b.get(f.scheme);return h===void 0&&(h=p.hasProvider(f)&&!this.g.hasCapability(f,S.FileSystemProviderCapabilities.PathCaseSensitive),b.set(f.scheme,h)),h};this.c.add(R.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(f=>{b.delete(f.scheme)})),this.extUri=new D.$3g(a),this.d=new A.$Hs((f,h)=>this.extUri.compare(f,h,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,D.$ch)(p));const b=this.d.get(p);return b?b.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new s(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((a,f)=>a[1].time<f[1].time?1:a[1].time>f[1].time?-1:0);s._clock=0,this.d.clear();const b=this.f*.5;for(let a=0;a<b;a++)this.d.set(p[a][0],p[a][1].touch())}};e.$Is=E,e.$Is=E=Ue([Fe(0,S.$7k)],E),(0,r.$Fs)(n.$El,E,r.InstantiationType.Delayed)}),define(Ee[98],Se([1,0,227,9,67,20,4,5,13]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=s,e.$Li=E,e.$Oi=y,e.$Pi=p,e.$Qi=b,e.$Ri=f,e.$Si=h,e.$Vi=m,e.$1i=$,e.$2i=l,e.$4i=t,e.$5i=o,e.$6i=d,e.$Ji=(0,R.$Ai)("contextService");function s(i){const c=i;return typeof c?.id=="string"&&A.URI.isUri(c.uri)}function E(i){return typeof i?.id=="string"&&!s(i)&&!p(i)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function y(i,c){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,r.$nc)(i)}:c?e.$Mi:e.$Ni;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function p(i){const c=i;return typeof c?.id=="string"&&A.URI.isUri(c.configPath)}function b(i){const c=i;if(c?.uri)return{id:c.id,uri:A.URI.revive(c.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:A.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}var a;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(a||(e.WorkbenchState=a={}));function f(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function h(i){const c=i;return!!(c&&typeof c=="object"&&A.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class g{constructor(c,u,k,I,C){this.h=c,this.j=k,this.k=I,this.l=C,this.c=S.$Gi.forUris(this.l,()=>!0),this.folders=u}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=S.$Gi.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=g;class w{constructor(c,u){this.raw=u,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,D.$bh)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=w;function m(i){return new w({uri:i,index:0,name:(0,D.$0g)(i)},{uri:i.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,n.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function $(i,c){return D.$5g.isEqualOrParent(i,c.untitledWorkspacesHome)}function l(i){let c;return A.URI.isUri(i)?c=i:c=i.configuration,c?.scheme===v.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$3i}function o(i,c){return!$(i,c)&&!l(i)}function d(i){return(typeof i=="string"?(0,r.$oc)(i):(0,D.$_g)(i))===e.$Xi}}),define(Ee[34],Se([1,0,66,6,2,20,4,226,28,16,5,12,98,26,36,14,22,17,11]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=$,e.$Hl=l,e.$Il=t;var m;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function $(i){const c=i;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&A.URI.isUri(c.location)&&A.URI.isUri(c.globalStorageHome)&&A.URI.isUri(c.settingsResource)&&A.URI.isUri(c.keybindingsResource)&&A.URI.isUri(c.tasksResource)&&A.URI.isUri(c.snippetsHome)&&A.URI.isUri(c.extensionsResource))}e.$Gl=(0,E.$Ai)("IUserDataProfilesService");function l(i,c){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:c}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:c}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:c}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:c}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:c}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:c}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:c}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:c}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,c,u,k,I,C){return{id:i,name:c,location:u,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:C&&I?.useDefaultFlags?.globalState?C.globalStorageHome:(0,D.$bh)(u,"globalStorage"),settingsResource:C&&I?.useDefaultFlags?.settings?C.settingsResource:(0,D.$bh)(u,"settings.json"),keybindingsResource:C&&I?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,D.$bh)(u,"keybindings.json"),tasksResource:C&&I?.useDefaultFlags?.tasks?C.tasksResource:(0,D.$bh)(u,"tasks.json"),snippetsHome:C&&I?.useDefaultFlags?.snippets?C.snippetsHome:(0,D.$bh)(u,"snippets"),extensionsResource:C&&I?.useDefaultFlags?.extensions?C.extensionsResource:(0,D.$bh)(u,"extensions.json"),cacheHome:(0,D.$bh)(k,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}let o=class extends S.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,u,k,I){super(),this.t=c,this.u=u,this.w=k,this.y=I,this.f=!0,this.h=this.B(new r.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new b.$Ac,emptyWindows:new Map},this.profilesHome=(0,D.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),u=[c];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,w.$ag)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}u.push(t((0,D.$$g)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},c))}}catch(C){this.y.error(C)}const k=new b.$Ac,I=new Map;if(u.length)try{const C=this.Q();if(C.workspaces)for(const[T,O]of Object.entries(C.workspaces)){const P=A.URI.parse(T),V=u.find(Q=>Q.id===O);V&&k.set(P,V)}if(C.emptyWindows)for(const[T,O]of Object.entries(C.emptyWindows)){const P=u.find(V=>V.id===O);P&&I.set(T,P)}}catch(C){this.y.error(C)}this.z={profiles:u,workspaces:k,emptyWindows:I}}return this.z}D(){const c=t("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const u="Temp",k=new RegExp(`${(0,g.$df)(u)}\\s(\\d+)`);let I=0;for(const T of this.profiles){const O=k.exec(T.name),P=O?parseInt(O[1]):0;I=P>I?P:I}const C=`${u} ${I+1}`;return this.createProfile((0,n.$oj)((0,h.$Wg)()).toString(16),C,{transient:!0},c)}async createNamedProfile(c,u,k){return this.createProfile((0,n.$oj)((0,h.$Wg)()).toString(16),c,u,k)}async createProfile(c,u,k,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(c,u,k);return I&&await this.setProfileForWorkspace(I,C),C}async F(c,u,k){if(!(0,w.$ag)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(u);return I||(I=(async()=>{try{if(this.profiles.find(P=>P.name===u||P.id===c))throw new Error(`Profile with ${u} name already exists`);const T=t(c,u,(0,D.$bh)(this.profilesHome,c),this.g,k,this.defaultProfile);await this.u.createFolder(T.location);const O=[];return this.j.fire({profile:T,join(P){O.push(P)}}),await f.Promises.settled(O),this.I([T],[],[]),T}finally{this.r.delete(u)}})(),this.r.set(u,I)),I}async updateProfile(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(I=>I.id===c.id);if(!k)throw new Error(`Profile '${c.name}' does not exist`);return k=t(k.id,u.name??k.name,k.location,this.g,{shortName:u.shortName??k.shortName,icon:u.icon===null?void 0:u.icon??k.icon,transient:u.transient??k.isTransient,useDefaultFlags:u.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(I=>I.id===c.id);if(!u)throw new Error(`Profile '${c.name}' does not exist`);const k=[];this.m.fire({profile:u,join(I){k.push(I)}});try{await Promise.allSettled(k)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(I){(0,s.$ll)(I)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(I)}}async setProfileForWorkspace(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(I=>I.id===u.id);if(!k)throw new Error(`Profile '${u.name}' does not exist`);this.L(c,k)}unsetWorkspace(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(u=>u.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(c.map(u=>this.removeProfile(u)))}getProfileForWorkspace(c){const u=this.G(c);return A.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(c){return(0,p.$Ki)(c)?c.uri:(0,p.$Pi)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,c.location)))}I(c,u,k){const I=[...this.profiles,...c],C=[];this.s.profiles=[];for(let T of I)T.isDefault||u.some(O=>T.id===O.id)||(T=k.find(O=>T.id===O.id)??T,T.isTransient?this.s.profiles.push(T):C.push({location:T.location,name:T.name,shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags}));this.P(C),this.z=void 0,this.J(c,u,k)}J(c,u,k){this.h.fire({added:c,removed:u,updated:k,all:this.profiles})}L(c,u,k){k=u?.isTransient?!0:k,k||this.L(c,void 0,!0);const I=this.G(c),C=k?this.s:this.C;A.URI.isUri(I)?(C.workspaces.delete(I),u&&C.workspaces.set(I,u)):(C.emptyWindows.delete(I),u&&C.emptyWindows.set(I,u)),k||this.M()}M(){const c={};for(const[k,I]of this.C.workspaces.entries())c[k.toString()]=I.id;const u={};for(const[k,I]of this.C.emptyWindows.entries())u[k.toString()]=I.id;this.R({workspaces:c,emptyWindows:u}),this.z=void 0}N(c){const u={},k=this.D();if(c.workspaces)for(const[C,T]of Object.entries(c.workspaces)){const O=A.URI.parse(T);u[C]=this.w.extUri.isEqual(O,k.location)?k.id:this.w.extUri.basename(O)}const I={};if(c.emptyWindows)for(const[C,T]of Object.entries(c.emptyWindows)){const O=A.URI.parse(T);I[C]=this.w.extUri.isEqual(O,k.location)?k.id:this.w.extUri.basename(O)}return{workspaces:u,emptyWindows:I}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Jl=o,e.$Jl=o=Ue([Fe(0,v.$Hi),Fe(1,s.$7k),Fe(2,a.$El),Fe(3,y.$7j)],o);class d extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Kl=d}),define(Ee[99],Se([1,0,18,14,19,10,6,2,3,11,4,206,30,39,23,12,29,24,36,34]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$tq=void 0,e.$uq=l;let $=class extends R.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,c,u,k,I,C){super(),this.z=i,this.C=c,this.D=u,this.F=k,this.G=I,this.H=C,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$he),this.s=this.B(new A.$he),this.t=this.B(new A.$he),this.u=this.B(new A.$he),this.w=this.B(new A.$he),this.y=[],this.B((0,R.$Sc)(()=>{this.j.forEach(({task:T})=>T.cancel()),this.m.forEach(T=>T.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const c=await this.getTargetPlatform();return i.allTargetPlatforms.some(u=>(0,p.$_o)(u,i.allTargetPlatforms,c))}async installFromGallery(i,c={}){try{const k=(await this.installGalleryExtensions([{extension:i,options:c}])).find(({identifier:I})=>(0,b.$Cp)(I,i.identifier));if(k?.local)return k?.local;throw k?.error?k.error:new p.$dp(`Unknown error while installing extension ${i.identifier.id}`,p.ExtensionManagementErrorCode.Unknown)}catch(u){throw l(u)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new p.$dp(y.localize(0,null),p.ExtensionManagementErrorCode.NotAllowed);const c=[],u=[];return await Promise.allSettled(i.map(async({extension:k,options:I})=>{try{const C=await this.N(k,!!I?.installGivenVersion,!!I?.installPreReleaseVersion,I.productVersion??{version:this.G.version,date:this.G.date});u.push({...C,options:I})}catch(C){c.push({identifier:k.identifier,operation:p.InstallOperation.Install,source:k,error:C})}})),u.length&&c.push(...await this.I(u)),c}async uninstall(i,c={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,c)}async toggleAppliationScope(i,c){if((0,a.$Zm)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let u=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(c,this.H.defaultProfile.extensionsResource)||(u=await this.$(i,this.H.defaultProfile.extensionsResource,c));for(const k of this.H.profiles){const I=(await this.getInstalled(a.ExtensionType.User,k.extensionsResource)).find(C=>(0,b.$Cp)(C.identifier,i.identifier));I?this.w.fire(I):this.u.fire({identifier:i.identifier,profileLocation:k.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(c,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,c,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:p.InstallOperation.Install,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const c=new Map,u=new Map,k=[],I=(T,O)=>`${b.$Dp.create(T).toString()}-${O.toString()}`,C=(T,O,P,V)=>{const Q=this.Y(T,O,P),ie=`${(0,b.$Hp)(T.publisher,T.name)}-${P.profileLocation.toString()}`;u.set(ie,{task:Q,root:V}),this.n.fire({identifier:Q.identifier,source:O,profileLocation:P.profileLocation}),this.F.info("Installing extension:",Q.identifier.id,P.profileLocation.toString()),E.URI.isUri(O)||this.j.set(I(O,P.profileLocation),{task:Q,waitingTasks:[]})};try{for(const{manifest:T,extension:O,options:P}of i){const V=P.isApplicationScoped||P.isBuiltin||(0,a.$Zm)(T),Q={...P,installOnlyNewlyAddedFromExtensionPack:P.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(O),isApplicationScoped:V,profileLocation:V?this.H.defaultProfile.extensionsResource:P.profileLocation??this.X(),productVersion:P.productVersion??{version:this.G.version,date:this.G.date}},ie=E.URI.isUri(O)?void 0:this.j.get(I(O,Q.profileLocation));ie?(this.F.info("Extension is already requested to install",ie.task.identifier.id,Q.profileLocation.toString()),k.push(ie.task.waitUntilTaskIsFinished())):C(T,O,Q,void 0)}return await Promise.all([...u.values()].map(async({task:T})=>{if(T.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const O=await this.M(T.identifier,T.manifest,!!T.options.installOnlyNewlyAddedFromExtensionPack,!!T.options.installPreReleaseVersion,T.options.profileLocation,T.options.productVersion),P=await this.getInstalled(void 0,T.options.profileLocation,T.options.productVersion),V={...T.options,context:{...T.options.context,[p.$6o]:!0}};for(const{gallery:Q,manifest:ie}of(0,n.$Mb)(O,({gallery:re})=>re.identifier.id)){if(u.has(`${Q.identifier.id.toLowerCase()}-${V.profileLocation.toString()}`))continue;const re=this.j.get(I(Q,V.profileLocation));if(re){if(this.J(T,re.task)){const ne=re.task.identifier;this.F.info("Waiting for already requested installing extension",ne.id,T.identifier.id,V.profileLocation.toString()),re.waitingTasks.push(T),k.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,se=>se.some(Z=>(0,b.$Cp)(Z.identifier,ne)))).then(se=>{if(this.F.info("Finished waiting for already requested installing extension",ne.id,T.identifier.id,V.profileLocation.toString()),!se.find(ee=>(0,b.$Cp)(ee.identifier,ne))?.local)throw new Error(`Extension ${ne.id} is not installed`)}))}}else P.some(({identifier:ne})=>(0,b.$Cp)(ne,Q.identifier))||C(ie,Q,V,T)}}catch(O){if(E.URI.isUri(T.source))(0,n.$Lb)(T.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",T.identifier.id,O.message),(0,n.$Lb)(T.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",T.identifier.id,O.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),O}})),await this.L([...u.entries()].map(async([T,{task:O}])=>{const P=new Date().getTime();let V;try{V=await O.run(),await this.L(this.y.map(Q=>Q.postInstall(V,O.source,O.options,S.CancellationToken.None)),p.ExtensionManagementErrorCode.PostInstall)}catch(Q){const ie=l(Q);throw E.URI.isUri(O.source)||t(this.C,O.operation===p.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,b.$Kp)(O.source),error:ie,source:O.options.context?.[p.$5o]}),c.set(T,{error:ie,identifier:O.identifier,operation:O.operation,source:O.source,context:O.options.context,profileLocation:O.options.profileLocation,applicationScoped:O.options.isApplicationScoped}),this.F.error("Error while installing the extension",O.identifier.id,(0,D.$0)(ie),O.options.profileLocation.toString()),ie}if(!E.URI.isUri(O.source)){const Q=O.operation===p.InstallOperation.Update,ie=Q?void 0:(new Date().getTime()-O.source.lastUpdated)/1e3;if(t(this.C,Q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,b.$Kp)(O.source),verificationStatus:O.verificationStatus,duration:new Date().getTime()-P,durationSinceUpdate:ie,source:O.options.context?.[p.$5o]}),v.$o&&O.operation!==p.InstallOperation.Update)try{await this.z.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,p.StatisticType.Install)}catch{}}c.set(T,{local:V,identifier:O.identifier,operation:O.operation,source:O.source,context:O.options.context,profileLocation:O.options.profileLocation,applicationScoped:V.isApplicationScoped})})),k.length&&await this.L(k),[...c.values()]}catch(T){const O=(Q,ie,re)=>{const ne=[];Q.manifest.extensionDependencies?.length&&ne.push(...Q.manifest.extensionDependencies),Q.manifest.extensionPack?.length&&ne.push(...Q.manifest.extensionPack);for(const se of ne){if(re.includes(se.toLowerCase()))continue;re.push(se.toLowerCase());const Z=c.get(`${se.toLowerCase()}-${ie.toString()}`);Z?.local&&(re=O(Z.local,ie,re))}return re},P=Q=>({identifier:Q.identifier,operation:p.InstallOperation.Install,source:Q.source,context:Q.options.context,profileLocation:Q.options.profileLocation,error:T}),V=[];for(const[Q,{task:ie,root:re}]of u){const ne=c.get(Q);ne?ne.local&&re&&!c.get(`${re.identifier.id.toLowerCase()}-${ie.options.profileLocation.toString()}`)?.local&&(V.push(this.Z(ne.local,{versionOnly:!0,profileLocation:ie.options.profileLocation})),c.set(Q,P(ie))):(ie.cancel(),c.set(Q,P(ie)))}for(const[Q,{task:ie}]of u){const re=c.get(Q);if(!re?.local||ie.options.donotIncludePackAndDependencies)continue;O(re.local,ie.options.profileLocation,[re.local.identifier.id.toLowerCase()]).slice(1).some(se=>u.has(`${se.toLowerCase()}-${ie.options.profileLocation.toString()}`)&&!c.get(`${se.toLowerCase()}-${ie.options.profileLocation.toString()}`)?.local)&&(V.push(this.Z(re.local,{versionOnly:!0,profileLocation:ie.options.profileLocation})),c.set(Q,P(ie)))}throw V.length&&await Promise.allSettled(V.map(async Q=>{try{await Q.run(),this.F.info("Rollback: Uninstalled extension",Q.extension.identifier.id)}catch(ie){this.F.warn("Rollback: Error while uninstalling extension",Q.extension.identifier.id,(0,D.$0)(ie))}})),T}finally{for(const{task:T}of u.values())T.source&&!E.URI.isUri(T.source)&&this.j.delete(I(T.source,T.options.profileLocation));if(c.size){const T=[...c.values()];for(const O of T)O.local&&this.F.info("Extension installed successfully:",O.identifier.id,O.profileLocation.toString());this.s.fire(T)}}}J(i,c){for(const[,{task:u,waitingTasks:k}]of this.j.entries())if(u===i&&(k.includes(c)||k.some(I=>this.J(I,c)))||u===c&&k[0]&&!this.J(i,k[0]))return!1;return!0}async L(i,c){const u=[],k=[],I=await Promise.allSettled(i);for(const T of I)T.status==="fulfilled"?u.push(T.value):k.push(l(T.reason,c));if(!k.length)return u;if(k.length===1)throw k[0];let C=new p.$dp("",p.ExtensionManagementErrorCode.Unknown);for(const T of k)C=new p.$dp(C.message?`${C.message}, ${T.message}`:T.message,T.code!==p.ExtensionManagementErrorCode.Unknown&&T.code!==p.ExtensionManagementErrorCode.Internal?T.code:C.code);throw C}async M(i,c,u,k,I,C){if(!this.z.isEnabled())return[];const T=await this.getInstalled(void 0,I,C),O=[],P=[],V=async(Q,ie)=>{O.push(Q);const re=ie.extensionDependencies||[],ne=[...re];if(ie.extensionPack){const se=u?T.find(Z=>(0,b.$Cp)(Z.identifier,Q)):void 0;for(const Z of ie.extensionPack)se&&se.manifest.extensionPack&&se.manifest.extensionPack.some(ee=>(0,b.$Cp)({id:ee},{id:Z}))||ne.every(ee=>!(0,b.$Cp)({id:ee},{id:Z}))&&ne.push(Z)}if(ne.length){const se=ne.filter(Z=>O.every(ee=>!(0,b.$Cp)(ee,{id:Z})));if(se.length){const Z=await this.z.getExtensions(se.map(ee=>({id:ee,preRelease:k})),S.CancellationToken.None);for(const ee of Z){if(O.find(B=>(0,b.$Cp)(B,ee.identifier)))continue;const ue=re.some(B=>(0,b.$Cp)({id:B},ee.identifier));let j;try{j=await this.N(ee,!1,k,C)}catch(B){if(ue)throw B;this.F.info("Skipping the packed extension as it cannot be installed",ee.identifier.id,(0,D.$0)(B));continue}P.push({gallery:j.extension,manifest:j.manifest}),await V(j.extension.identifier,j.manifest)}}}};return await V(i,c),P}async N(i,c,u,k){let I;const C=await this.getExtensionsControlManifest();if(C.malicious.some(P=>(0,b.$Cp)(i.identifier,P)))throw new p.$dp(y.localize(1,null,i.identifier.id),p.ExtensionManagementErrorCode.Malicious);const T=C.deprecated[i.identifier.id.toLowerCase()];if(T?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${T.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:T.extension.id,preRelease:T.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:k},S.CancellationToken.None))[0],!I)throw new p.$dp(y.localize(2,null,i.identifier.id,T.extension.id),p.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const P=await this.getTargetPlatform();throw new p.$dp(y.localize(3,null,i.identifier.id,this.G.nameLong,(0,p.$8o)(P)),p.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.O(i,c,u,k),!I)throw!u&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],S.CancellationToken.None))[0]?new p.$dp(y.localize(4,null,i.displayName??i.identifier.id),p.ExtensionManagementErrorCode.ReleaseVersionNotFound):new p.$dp(y.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),p.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const O=await this.z.getManifest(I,S.CancellationToken.None);if(O===null)throw new p.$dp(`Missing manifest for extension ${I.identifier.id}`,p.ExtensionManagementErrorCode.Invalid);if(O.version!==I.version)throw new p.$dp(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,p.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:O}}async O(i,c,u,k){const I=await this.getTargetPlatform();let C=null;return!c&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==u&&(C=(await this.z.getExtensions([{...i.identifier,preRelease:u}],{targetPlatform:I,compatible:!0,productVersion:k},S.CancellationToken.None))[0]||null),!C&&await this.z.isExtensionCompatible(i,u,I,k)&&(C=i),C||(c?C=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:I,compatible:!0,productVersion:k},S.CancellationToken.None))[0]||null:C=await this.z.getCompatibleExtension(i,u,I,k)),C}async P(i,c){const u={...c,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:c.profileLocation??this.X()},k=V=>`${V.id.toLowerCase()}${u.versionOnly?`-${i.manifest.version}`:""}${u.profileLocation?`@${u.profileLocation.toString()}`:""}`,I=this.m.get(k(i.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),I.waitUntilTaskIsFinished();const C=V=>{const Q=this.Z(V,u);return this.m.set(k(Q.extension.identifier),Q),u.profileLocation?this.F.info("Uninstalling extension from the profile:",`${V.identifier.id}@${V.manifest.version}`,u.profileLocation.toString()):this.F.info("Uninstalling extension:",`${V.identifier.id}@${V.manifest.version}`),this.t.fire({identifier:V.identifier,profileLocation:u.profileLocation,applicationScoped:V.isApplicationScoped}),Q},T=(V,Q)=>{Q?u.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${V.identifier.id}@${V.manifest.version}`,u.profileLocation.toString(),Q.message):this.F.error("Failed to uninstall extension:",`${V.identifier.id}@${V.manifest.version}`,Q.message):u.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${V.identifier.id}@${V.manifest.version}`,u.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${V.identifier.id}@${V.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,b.$Jp)(V),error:Q}),this.u.fire({identifier:V.identifier,error:Q?.code,profileLocation:u.profileLocation,applicationScoped:V.isApplicationScoped})},O=[],P=[];try{O.push(C(i));const V=await this.getInstalled(a.ExtensionType.User,u.profileLocation);if(u.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const Q=this.S(i,V);for(const ie of Q)this.m.has(k(ie.identifier))?this.F.info("Extensions is already requested to uninstall",ie.identifier.id):O.push(C(ie))}u.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(O.map(Q=>Q.extension),V,i),await this.L(O.map(async Q=>{try{if(await Q.run(),await this.L(this.y.map(ie=>ie.postUninstall(Q.extension,u,S.CancellationToken.None))),Q.extension.identifier.uuid)try{await this.z.reportStatistic(Q.extension.manifest.publisher,Q.extension.manifest.name,Q.extension.manifest.version,p.StatisticType.Uninstall)}catch{}T(Q.extension)}catch(ie){const re=l(ie);throw T(Q.extension,re),re}finally{P.push(Q)}}))}catch(V){const Q=l(V);for(const ie of O){try{ie.cancel()}catch{}P.includes(ie)||T(ie.extension,Q)}throw Q}finally{for(const V of O)this.m.delete(k(V.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",V.extension.identifier.id)}}Q(i,c,u){for(const k of i){const I=this.U(k,c);if(I.length){const C=I.filter(T=>!i.some(O=>(0,b.$Cp)(O.identifier,T.identifier)));if(C.length)throw new Error(this.R(k,C,u))}}}R(i,c,u){return u===i?c.length===1?y.localize(6,null,u.manifest.displayName||u.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?y.localize(7,null,u.manifest.displayName||u.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):y.localize(8,null,u.manifest.displayName||u.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):c.length===1?y.localize(9,null,u.manifest.displayName||u.manifest.name,i.manifest.displayName||i.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?y.localize(10,null,u.manifest.displayName||u.manifest.name,i.manifest.displayName||i.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):y.localize(11,null,u.manifest.displayName||u.manifest.name,i.manifest.displayName||i.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name)}S(i,c,u=[]){if(u.indexOf(i)!==-1)return[];u.push(i);const k=i.manifest.extensionPack?i.manifest.extensionPack:[];if(k.length){const I=c.filter(T=>!T.isBuiltin&&k.some(O=>(0,b.$Cp)({id:O},T.identifier))),C=[];for(const T of I)C.push(...this.S(T,c,u));return[...I,...C]}return[]}U(i,c){return c.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(k=>(0,b.$Cp)({id:k},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,D.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$tq=$,e.$tq=$=Ue([Fe(0,p.$bp),Fe(1,g.$6l),Fe(2,w.$El),Fe(3,f.$7j),Fe(4,h.$nk),Fe(5,m.$Gl)],$);function l(d,i){if(d instanceof p.$dp)return d;let c;return d instanceof p.$cp?c=new p.$dp(d.message,d.code===p.ExtensionGalleryErrorCode.DownloadFailedWriting?p.ExtensionManagementErrorCode.DownloadFailedWriting:p.ExtensionManagementErrorCode.Gallery):c=new p.$dp(d.message,(0,D.$4)(d)?p.ExtensionManagementErrorCode.Cancelled:i??p.ExtensionManagementErrorCode.Internal),c.stack=d.stack,c}function t(d,i,{extensionData:c,verificationStatus:u,duration:k,error:I,source:C,durationSinceUpdate:T}){let O,P;(0,s.$ig)(u)&&(u===!0?u="Verified":(u===!1||(O=p.ExtensionManagementErrorCode.Signature,P=u),u="Unverified")),I&&(O=I.code,I.code===p.ExtensionManagementErrorCode.Signature&&(P=I.message)),d.publicLog(i,{...c,verificationStatus:u,success:!I,duration:k,errorcode:O,errorcodeDetail:P,durationSinceUpdate:T,source:C})}class o{constructor(){this.d=new r.$zh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,r.$nh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,r.$nh)(i=>new Promise((c,u)=>{const k=i.onCancellationRequested(()=>{k.dispose(),u(new D.$5)})})),this.d.open()),this.g.cancel()}}e.$vq=o}),define(Ee[53],Se([1,0,14,15,2,6,26,4,30,39,16,5,12,34,36,11,10,24]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class m extends Error{constructor(d,i){super(d),this.code=i}}e.$wq=m,e.$xq=(0,y.$Ai)("IExtensionsProfileScannerService");let $=class extends S.$Uc{constructor(d,i,c,u,k,I){super(),this.j=d,this.m=i,this.n=c,this.r=u,this.s=k,this.t=I,this.b=this.B(new D.$he),this.onAddExtensions=this.b.event,this.c=this.B(new D.$he),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$he),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$he),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(d,i){return this.u(d,void 0,i)}async addExtensionsToProfile(d,i,c){const u=[],k=[];try{return await this.u(i,I=>{const C=[];if(c)C.push(...I);else for(const T of I)d.some(([O])=>(0,s.$Cp)(O.identifier,T.identifier)&&O.manifest.version!==T.version)?u.push(T):C.push(T);for(const[T,O]of d){const P=C.findIndex(Q=>(0,s.$Cp)(Q.identifier,T.identifier)&&Q.version===T.manifest.version),V={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:O};P===-1?(k.push(V),C.push(V)):C.splice(P,1,V)}return k.length&&this.b.fire({extensions:k,profileLocation:i}),u.length&&this.f.fire({extensions:u,profileLocation:i}),C}),k.length&&this.c.fire({extensions:k,profileLocation:i}),u.length&&this.g.fire({extensions:u,profileLocation:i}),k}catch(I){throw k.length&&this.c.fire({extensions:k,error:I,profileLocation:i}),u.length&&this.g.fire({extensions:u,error:I,profileLocation:i}),I}}async updateMetadata(d,i){const c=[];return await this.u(i,u=>{const k=[];for(const I of u){const C=d.find(([T])=>(0,s.$Cp)(T.identifier,I.identifier)&&T.manifest.version===I.version);C&&(I.metadata={...I.metadata,...C[1]},c.push(I)),k.push(I)}return k}),c}async removeExtensionFromProfile(d,i){const c=[];try{await this.u(i,u=>{const k=[];for(const I of u)(0,s.$Cp)(I.identifier,d.identifier)?c.push(I):k.push(I);return c.length&&this.f.fire({extensions:c,profileLocation:i}),k}),c.length&&this.g.fire({extensions:c,profileLocation:i})}catch(u){throw c.length&&this.g.fire({extensions:c,error:u,profileLocation:i}),u}}async u(d,i,c){return this.F(d).queue(async()=>{let u=[],k;try{const I=await this.m.readFile(d);k=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,E.$ll)(I)!==E.FileOperationResult.FILE_NOT_FOUND)throw I;if(this.r.extUri.isEqual(d,this.n.defaultProfile.extensionsResource)&&(k=await this.D()),!k&&c?.bailOutWhenFileNotFound)throw new m((0,h.$0)(I),w.ERROR_PROFILE_NOT_FOUND)}if(k){Array.isArray(k)||this.w(d);let I=!1;for(const C of k){l(C)||this.w(d);let T;if((0,f.$ag)(C.relativeLocation)&&C.relativeLocation)T=this.z(C.relativeLocation);else if((0,f.$ag)(C.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${C.location}`);continue}else{T=R.URI.revive(C.location);const O=this.y(T);O&&(I=!0,C.relativeLocation=O)}(0,f.$hg)(C.metadata?.hasPreReleaseVersion)&&C.metadata?.preRelease&&(I=!0,C.metadata.hasPreReleaseVersion=!0),u.push({identifier:C.identifier,location:T,version:C.version,metadata:C.metadata})}I&&await this.m.writeFile(d,r.$Je.fromString(JSON.stringify(k)))}if(i){u=i(u);const I=u.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.y(C.location),metadata:C.metadata}));await this.m.writeFile(d,r.$Je.fromString(JSON.stringify(I)))}return u})}w(d){const i=new m(`Invalid extensions content in ${d.toString()}`,w.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(d){return this.r.extUri.isEqual(this.r.extUri.dirname(d),this.j)?this.r.extUri.basename(d):void 0}z(d){return this.r.extUri.joinPath(this.j,d)}async D(){return this.C||(this.C=(async()=>{const d=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let c;try{c=(await this.m.readFile(d)).value.toString()}catch(k){if((0,E.$ll)(k)===E.FileOperationResult.FILE_NOT_FOUND)return;throw k}this.t.info("Migrating extensions from old default profile location",d.toString());let u;try{const k=JSON.parse(c);Array.isArray(k)&&k.every(I=>l(I))?u=k:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",k)}catch(k){this.t.error(k)}if(u)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Je.fromString(JSON.stringify(u)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",d.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(k){if((0,E.$ll)(k)===E.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",d.toString(),this.n.defaultProfile.extensionsResource.toString());else throw k}try{await this.m.del(d)}catch(k){(0,E.$ll)(k)!==E.FileOperationResult.FILE_NOT_FOUND&&this.t.error(k)}try{await this.m.del(i)}catch(k){(0,E.$ll)(k)!==E.FileOperationResult.FILE_NOT_FOUND&&this.t.error(k)}return u})()),this.C}F(d){let i=this.h.get(d);return i||(i=new n.$Hh,this.h.set(d,i)),i}};e.$yq=$,e.$yq=$=Ue([Fe(1,E.$7k),Fe(2,b.$Gl),Fe(3,a.$El),Fe(4,g.$6l),Fe(5,p.$7j)],$);function l(o){return(0,f.$cg)(o)&&(0,v.$ap)(o.identifier)&&(t(o.location)||(0,f.$ag)(o.location)&&o.location)&&((0,f.$hg)(o.relativeLocation)||(0,f.$ag)(o.relativeLocation))&&o.version&&(0,f.$ag)(o.version)}function t(o){return o?(0,f.$ag)(o.path)&&(0,f.$ag)(o.scheme):!1}}),define(Ee[64],Se([1,0,18,14,21,15,10,44,189,2,13,9,3,20,62,58,11,4,210,28,39,23,87,16,5,12,29,6,49,53,34,36,245]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m,$,l,t,o,d,i,c,u,k,I,C,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Dq=e.$Cq=e.$Bq=e.Translations=void 0,e.$Eq=ne;var P;(function(Z){function ee(ue,j){if(ue===j)return!0;const B=Object.keys(ue),oe=new Set;for(const le of Object.keys(j))oe.add(le);if(B.length!==oe.size)return!1;for(const le of B){if(ue[le]!==j[le])return!1;oe.delete(le)}return oe.size===0}Z.equals=ee})(P||(e.Translations=P={})),e.$Bq=(0,d.$Ai)("IExtensionsScannerService");let V=class extends s.$Uc{constructor(ee,ue,j,B,oe,le,pe,q,ae,Y,H,L){super(),this.systemExtensionsLocation=ee,this.userExtensionsLocation=ue,this.r=j,this.s=B,this.t=oe,this.u=le,this.w=pe,this.y=q,this.z=ae,this.C=Y,this.D=H,this.F=L,this.g=this.B(new u.$he),this.onDidChangeCache=this.g.event,this.h=(0,b.$bh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(ie,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(l.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(l.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,$.$Np)(this.w,this.y)),this.G}async scanAllExtensions(ee,ue,j){const[B,oe]=await Promise.all([this.scanSystemExtensions(ee),this.scanUserExtensions(ue)]),le=j?await this.scanExtensionsUnderDevelopment(ee,[...B,...oe]):[];return this.L(B,oe,le,await this.getTargetPlatform(),!0)}async scanSystemExtensions(ee){const ue=[];ue.push(this.M(!!ee.useCache,ee.language)),ue.push(this.N(ee.language,!!ee.checkControlFile));const[j,B]=await Promise.all(ue);return this.J([...j,...B],l.ExtensionType.System,ee,!1)}async scanUserExtensions(ee){const ue=ee.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ue);const j=this.D.extUri.isEqual(ee.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(ue,!!ee.profileLocation,l.ExtensionType.User,!ee.includeUninstalled,ee.language,!0,j,ee.productVersion??this.R()),oe=ee.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let le;try{le=await oe.scanExtensions(B)}catch(pe){if(pe instanceof I.$wq&&pe.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),le=await oe.scanExtensions(B);else throw pe}return le=await this.J(le,l.ExtensionType.User,ee,!0),this.y.trace("Scanned user extensions:",le.length),le}async scanExtensionsUnderDevelopment(ee,ue){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const j=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===E.Schemas.file).map(async B=>{const oe=await this.P(B,!1,l.ExtensionType.User,!0,ee.language,!1,void 0,ee.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(oe)).map(pe=>(pe.type=ue.find(q=>(0,$.$Cp)(q.identifier,pe.identifier))?.type??pe.type,this.n.validate(pe,oe)))}))).flat();return this.J(j,"development",ee,!0)}return[]}async scanExistingExtension(ee,ue,j){const B=await this.P(ee,!1,ue,!0,j.language,!0,void 0,j.productVersion??this.R()),oe=await this.n.scanExtension(B);return!oe||!j.includeInvalid&&!oe.isValid?null:oe}async scanOneOrMultipleExtensions(ee,ue,j){const B=await this.P(ee,!1,ue,!0,j.language,!0,void 0,j.productVersion??this.R()),oe=await this.n.scanOneOrMultipleExtensions(B);return this.J(oe,ue,j,!0)}async scanMultipleExtensions(ee,ue,j){const B=[];return await Promise.all(ee.map(async oe=>{const le=await this.scanOneOrMultipleExtensions(oe,ue,j);B.push(...le)})),this.J(B,ue,j,!0)}async scanMetadata(ee){const ue=(0,b.$bh)(ee,"package.json"),j=(await this.w.readFile(ue)).value.toString();return JSON.parse(j).__metadata}async updateMetadata(ee,ue){const j=(0,b.$bh)(ee,"package.json"),B=(await this.w.readFile(j)).value.toString(),oe=JSON.parse(B);ue.isMachineScoped===!1&&delete ue.isMachineScoped,ue.isBuiltin===!1&&delete ue.isBuiltin,oe.__metadata={...oe.__metadata,...ue},await this.w.writeFile((0,b.$bh)(ee,"package.json"),D.$Je.fromString(JSON.stringify(oe,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(ee){if(ee instanceof I.$wq&&ee.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw ee}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const ee=await this.scanUserExtensions({includeInvalid:!0});if(ee.length)await this.u.addExtensionsToProfile(ee.map(ue=>[ue,ue.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Je.fromString(JSON.stringify([])))}catch(ue){(0,o.$ll)(ue)!==o.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(ue))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(ee){this.y.error(ee)}finally{this.H=void 0}})()),this.H}async J(ee,ue,j,B){return j.includeAllVersions||(ee=this.L(ue===l.ExtensionType.System?ee:void 0,ue===l.ExtensionType.User?ee:void 0,ue==="development"?ee:void 0,await this.getTargetPlatform(),B)),j.includeInvalid||(ee=ee.filter(oe=>oe.isValid)),ee.sort((oe,le)=>{const pe=y.$nc(oe.location.fsPath),q=y.$nc(le.location.fsPath);return pe<q?-1:pe>q?1:0})}L(ee,ue,j,B,oe){const le=(q,ae,Y)=>{if(q.isValid&&!ae.isValid)return!1;if(q.isValid===ae.isValid){if(oe&&a.gt(q.manifest.version,ae.manifest.version))return this.y.debug(`Skipping extension ${ae.location.path} with lower version ${ae.manifest.version} in favour of ${q.location.path} with version ${q.manifest.version}`),!1;if(a.eq(q.manifest.version,ae.manifest.version)){if(q.type===l.ExtensionType.System)return this.y.debug(`Skipping extension ${ae.location.path} in favour of system extension ${q.location.path} with same version`),!1;if(q.targetPlatform===B)return this.y.debug(`Skipping extension ${ae.location.path} from different target platform ${ae.targetPlatform}`),!1}}return Y?this.y.warn(`Overwriting user extension ${q.location.path} with ${ae.location.path}.`):this.y.debug(`Overwriting user extension ${q.location.path} with ${ae.location.path}.`),!0},pe=new l.$Ym;return ee?.forEach(q=>{const ae=pe.get(q.identifier.id);(!ae||le(ae,q,!1))&&pe.set(q.identifier.id,q)}),ue?.forEach(q=>{const ae=pe.get(q.identifier.id);if(!ae&&ee&&q.type===l.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${q.location.path}.`);return}(!ae||le(ae,q,!1))&&pe.set(q.identifier.id,q)}),j?.forEach(q=>{const ae=pe.get(q.identifier.id);(!ae||le(ae,q,!0))&&pe.set(q.identifier.id,q),pe.set(q.identifier.id,q)}),[...pe.values()]}async M(ee,ue){this.y.trace("Started scanning system extensions");const j=await this.P(this.systemExtensionsLocation,!1,l.ExtensionType.System,!0,ue,!0,void 0,this.R()),oe=await(ee&&!j.devMode?this.j:this.n).scanExtensions(j);return this.y.trace("Scanned system extensions:",oe.length),oe}async N(ee,ue){const j=this.z.isBuilt?[]:this.C.builtInExtensions;if(!j?.length)return[];this.y.trace("Started scanning dev system extensions");const B=ue?await this.O():{},oe=[],le=g.URI.file(y.$hc(y.$jc(E.$Ug.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const q of j){const ae=B[q.name]||"marketplace";switch(ae){case"disabled":break;case"marketplace":oe.push((0,b.$bh)(le,q.name));break;default:oe.push(g.URI.file(ae));break}}const pe=await Promise.all(oe.map(async q=>this.n.scanExtension(await this.P(q,!1,l.ExtensionType.System,!0,ee,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",pe.length),(0,n.$Hb)(pe)}async O(){try{const ee=await this.w.readFile(this.r);return JSON.parse(ee.value.toString())}catch{return{}}}async P(ee,ue,j,B,oe,le,pe,q){const ae=await this.f(oe??p.$w),Y=await this.Q(ee),H=ue&&!this.D.extUri.isEqual(ee,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,L=H?await this.Q(H):void 0;return new Q(ee,Y,H,L,ue,pe,j,B,le,q.version,q.date,this.C.commit,!this.z.isBuilt,oe,ae)}async Q(ee){try{const ue=await this.w.stat(ee);if(typeof ue.mtime=="number")return ue.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Cq=V,e.$Cq=V=Ue([Fe(4,C.$Gl),Fe(5,I.$xq),Fe(6,o.$7k),Fe(7,i.$7j),Fe(8,m.$Hi),Fe(9,c.$nk),Fe(10,T.$El),Fe(11,d.$zi)],V);class Q{constructor(ee,ue,j,B,oe,le,pe,q,ae,Y,H,L,W,z,U){this.location=ee,this.mtime=ue,this.applicationExtensionslocation=j,this.applicationExtensionslocationMtime=B,this.profile=oe,this.profileScanOptions=le,this.type=pe,this.excludeObsolete=q,this.validate=ae,this.productVersion=Y,this.productDate=H,this.productCommit=L,this.devMode=W,this.language=z,this.translations=U}static createNlsConfiguration(ee){return{language:ee.language,pseudo:ee.language==="pseudo",devMode:ee.devMode,translations:ee.translations}}static equals(ee,ue){return(0,b.$7g)(ee.location,ue.location)&&ee.mtime===ue.mtime&&(0,b.$7g)(ee.applicationExtensionslocation,ue.applicationExtensionslocation)&&ee.applicationExtensionslocationMtime===ue.applicationExtensionslocationMtime&&ee.profile===ue.profile&&S.$ao(ee.profileScanOptions,ue.profileScanOptions)&&ee.type===ue.type&&ee.excludeObsolete===ue.excludeObsolete&&ee.validate===ue.validate&&ee.productVersion===ue.productVersion&&ee.productDate===ue.productDate&&ee.productCommit===ue.productCommit&&ee.devMode===ue.devMode&&ee.language===ue.language&&P.equals(ee.translations,ue.translations)}}e.$Dq=Q;let ie=class extends s.$Uc{constructor(ee,ue,j,B,oe){super(),this.f=ee,this.g=ue,this.h=j,this.j=B,this.m=oe}async scanExtensions(ee){const ue=ee.profile?await this.r(ee):await this.n(ee);let j={};if(ee.excludeObsolete&&ee.type===l.ExtensionType.User)try{const B=(await this.j.readFile(this.f)).value.toString();j=JSON.parse(B)}catch{}return(0,h.$ng)(j)?ue:ue.filter(B=>!j[$.$Dp.create(B).toString()])}async n(ee){const ue=await this.j.resolve(ee.location);if(!ue.children?.length)return[];const j=await Promise.all(ue.children.map(async B=>{if(!B.isDirectory||ee.type===l.ExtensionType.User&&(0,b.$$g)(B.resource).indexOf(".")===0)return null;const oe=new Q(B.resource,ee.mtime,ee.applicationExtensionslocation,ee.applicationExtensionslocationMtime,ee.profile,ee.profileScanOptions,ee.type,ee.excludeObsolete,ee.validate,ee.productVersion,ee.productDate,ee.productCommit,ee.devMode,ee.language,ee.translations);return this.scanExtension(oe)}));return(0,n.$Hb)(j).sort((B,oe)=>B.location.path<oe.location.path?-1:1)}async r(ee){let ue=await this.s(ee.location,()=>!0,ee);if(ee.applicationExtensionslocation&&!this.h.extUri.isEqual(ee.location,ee.applicationExtensionslocation)){ue=ue.filter(B=>!B.metadata?.isApplicationScoped);const j=await this.s(ee.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,ee);ue.push(...j)}return ue}async s(ee,ue,j){const B=await this.g.scanProfileExtensions(ee,j.profileScanOptions);if(!B.length)return[];const oe=await Promise.all(B.map(async le=>{if(ue(le)){const pe=new Q(le.location,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.profileScanOptions,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(pe,le.metadata)}return null}));return(0,n.$Hb)(oe)}async scanOneOrMultipleExtensions(ee){try{if(await this.j.exists((0,b.$bh)(ee.location,"package.json"))){const ue=await this.scanExtension(ee);return ue?[ue]:[]}else return await this.scanExtensions(ee)}catch(ue){return this.m.error(`Error scanning extensions at ${ee.location.path}:`,(0,A.$0)(ue)),[]}}async scanExtension(ee,ue){try{let j=await this.scanExtensionManifest(ee.location);if(j){j.publisher||(j.publisher=l.$Sm),ue=ue??j.__metadata,delete j.__metadata;const B=(0,$.$Hp)(j.publisher,j.name),oe=ue?.id?{id:B,uuid:ue.id}:{id:B},le=ue?.isSystem?l.ExtensionType.System:ee.type,pe=le===l.ExtensionType.System||!!ue?.isBuiltin;j=await this.t(ee.location,j,Q.createNlsConfiguration(ee));const q={type:le,identifier:oe,manifest:j,location:ee.location,isBuiltin:pe,targetPlatform:ue?.targetPlatform??l.TargetPlatform.UNDEFINED,publisherDisplayName:ue?.publisherDisplayName,metadata:ue,isValid:!0,validations:[]};return ee.validate?this.validate(q,ee):q}}catch(j){ee.type!==l.ExtensionType.System&&this.m.error(j)}return null}validate(ee,ue){let j=!0;const B=(0,t.$Sp)(ue.productVersion,ue.productDate,ue.location,ee.manifest,ee.isBuiltin);for(const[oe,le]of B)oe===f.default.Error&&(j=!1,this.m.error(this.z(ue.location,le)));return ee.isValid=j,ee.validations=B,ee}async scanExtensionManifest(ee){const ue=(0,b.$bh)(ee,"package.json");let j;try{j=(await this.j.readFile(ue)).value.toString()}catch(oe){return(0,o.$ll)(oe)!==o.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(ee,(0,w.localize)(0,null,ue.path,oe.message))),null}let B;try{B=JSON.parse(j)}catch{const le=[];(0,R.$Pn)(j,le);for(const pe of le)this.m.error(this.z(ee,(0,w.localize)(1,null,ue.path,pe.offset,pe.length,(0,v.$zq)(pe.error))));return null}return(0,R.$Yn)(B)!=="object"?(this.m.error(this.z(ee,(0,w.localize)(2,null,ue.path))),null):B}async t(ee,ue,j){const B=await this.u(ee,ue,j);if(B)try{const oe=[],le=await this.w(B.default,oe);if(oe.length>0)return oe.forEach(q=>{this.m.error(this.z(ee,(0,w.localize)(3,null,B.default?.path,(0,v.$zq)(q.error))))}),ue;if((0,R.$Yn)(B)!=="object")return this.m.error(this.z(ee,(0,w.localize)(4,null,B.default?.path))),ue;const pe=B.values||Object.create(null);return(0,O.$Aq)(this.m,ue,pe,le)}catch{}return ue}async u(ee,ue,j){const B=(0,b.$bh)(ee,"package.nls.json"),oe=(ae,Y)=>{Y.forEach(H=>{this.m.error(this.z(ee,(0,w.localize)(5,null,ae?.path,(0,v.$zq)(H.error))))})},le=ae=>{this.m.error(this.z(ee,(0,w.localize)(6,null,ae?.path)))},pe=`${ue.publisher}.${ue.name}`,q=j.translations[pe];if(q)try{const ae=g.URI.file(q),Y=(await this.j.readFile(ae)).value.toString(),H=[],L=(0,R.$Pn)(Y,H);return H.length>0?(oe(ae,H),{values:void 0,default:B}):(0,R.$Yn)(L)!=="object"?(le(ae),{values:void 0,default:B}):{values:L.contents?L.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let Y;try{Y=await this.y(ee,j)}catch{return}if(!Y.localized)return{values:void 0,default:Y.original};try{const H=(await this.j.readFile(Y.localized)).value.toString(),L=[],W=(0,R.$Pn)(H,L);return L.length>0?(oe(Y.localized,L),{values:void 0,default:Y.original}):(0,R.$Yn)(W)!=="object"?(le(Y.localized),{values:void 0,default:Y.original}):{values:W,default:Y.original}}catch{return{values:void 0,default:Y.original}}}}async w(ee,ue){if(ee)try{const j=(await this.j.readFile(ee)).value.toString();return(0,R.$Pn)(j,ue)}catch{}}y(ee,ue){return new Promise((j,B)=>{const oe=le=>{const pe=(0,b.$bh)(ee,`package.nls.${le}.json`);this.j.exists(pe).then(q=>{q&&j({localized:pe,original:(0,b.$bh)(ee,"package.nls.json")});const ae=le.lastIndexOf("-");ae===-1?j({localized:(0,b.$bh)(ee,"package.nls.json"),original:null}):(le=le.substring(0,ae),oe(le))})};if(ue.devMode||ue.pseudo||!ue.language)return j({localized:(0,b.$bh)(ee,"package.nls.json"),original:null});oe(ue.language)})}z(ee,ue){return`[${ee.path}]: ${ue}`}};ie=Ue([Fe(1,I.$xq),Fe(2,T.$El),Fe(3,o.$7k),Fe(4,i.$7j)],ie);let re=class extends ie{constructor(ee,ue,j,B,oe,le,pe){super(ue,B,oe,le,pe),this.G=ee,this.H=j,this.D=this.B(new r.$yh(3e3)),this.F=this.B(new u.$he),this.onDidChangeCache=this.F.event}async scanExtensions(ee){const ue=this.M(ee),j=await this.I(ue);if(this.C=ee,j&&j.input&&Q.equals(j.input,this.C))return this.m.debug("Using cached extensions scan result",ee.location.toString()),this.D.trigger(()=>this.L()),j.result.map(oe=>(oe.location=g.URI.revive(oe.location),oe));const B=await super.scanExtensions(ee);return await this.J(ue,{input:ee,result:B}),B}async I(ee){try{const ue=await this.j.readFile(ee),j=JSON.parse(ue.value.toString());return{result:j.result,input:(0,k.$0h)(j.input)}}catch(ue){this.m.debug("Error while reading the extension cache file:",ee.path,(0,A.$0)(ue))}return null}async J(ee,ue){try{await this.j.writeFile(ee,D.$Je.fromString(JSON.stringify(ue)))}catch(j){this.m.debug("Error while writing the extension cache file:",ee.path,(0,A.$0)(j))}}async L(){if(!this.C)return;const ee=this.M(this.C),ue=await this.I(ee);if(!ue)return;const j=ue.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$ao(B,j))try{this.m.info("Invalidating Cache",j,B),await this.j.del(ee),this.F.fire()}catch(oe){this.m.error(oe)}}M(ee){const ue=this.N(ee);return this.h.extUri.joinPath(ue.cacheHome,ee.type===l.ExtensionType.System?l.$Rm:l.$Qm)}N(ee){return ee.type===l.ExtensionType.System?this.H.defaultProfile:ee.profile?this.h.extUri.isEqual(ee.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ue=>this.h.extUri.isEqual(ee.location,ue.extensionsResource))??this.G:this.H.defaultProfile}};re=Ue([Fe(2,C.$Gl),Fe(3,I.$xq),Fe(4,T.$El),Fe(5,o.$7k),Fe(6,i.$7j)],re);function ne(Z,ee){const ue=(0,$.$Fp)(Z.manifest.publisher,Z.manifest.name);return{id:ue,identifier:new l.$Wm(ue),isBuiltin:Z.type===l.ExtensionType.System,isUserBuiltin:Z.type===l.ExtensionType.User&&Z.isBuiltin,isUnderDevelopment:ee,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,publisherDisplayName:Z.publisherDisplayName,...Z.manifest}}class se extends V{constructor(ee,ue,j,B,oe,le,pe,q,ae,Y,H,L){super(ee,ue,(0,b.$bh)(j,".vscode-oss-dev","extensions","control.json"),B,oe,le,pe,q,ae,Y,H,L),this.S=(async()=>{if(p.$z)try{const W=await this.w.readFile(g.URI.file(p.$z));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}f(ee){return this.S}}e.$Fq=se}),define(Ee[288],Se([1,0,60,14,42,6,2,13,9,25,12,34]),function(fe,e,n,r,S,D,A,R,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;let p=class extends A.$Uc{constructor(a,f){super(),this.b=a,this.f=f,this.a=new r.$Gh(5)}async postUninstall(a){const f=this.g(a,"uninstall");f&&(this.f.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(f.script,"uninstall",f.args,!0,a),this.f.info("Finished running post uninstall script",a.identifier.id,a.manifest.version)}catch(h){this.f.error("Failed to run post uninstall script",a.identifier.id,a.manifest.version),this.f.error(h)}}));try{await s.Promises.rm(this.m(a))}catch(h){this.f.error("Error while removing extension storage path",a.identifier.id),this.f.error(h)}}g(a,f){const h=`vscode:${f}`;if(a.location.scheme===R.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[h]=="string"){const g=a.manifest.scripts[h].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.f.warn(a.identifier.id,a.manifest.version,`${h} should be a node script`),null):{script:(0,v.$jc)(a.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}h(a,f,h,g,w){return new Promise((m,$)=>{const l=this.j(a,f,h,w);let t;const o=d=>{t&&(clearTimeout(t),t=null),d?$(d):m(void 0)};l.on("error",d=>{o((0,S.$lj)(d)||"Unknown")}),l.on("exit",(d,i)=>{o(d?`post-${f} process exited with code ${d}`:void 0)}),g&&(t=setTimeout(()=>{t=null,l.kill(),$("timed out")},5e3))})}j(a,f,h,g){const w={silent:!0,execArgv:void 0},m=(0,n.fork)(a,[`--type=extension-post-${f}`,...h],w);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const $=D.Event.fromNodeEventEmitter(m.stdout,"data"),l=D.Event.fromNodeEventEmitter(m.stderr,"data");this.B($(d=>this.f.info(g.identifier.id,g.manifest.version,`post-${f}`,d))),this.B(l(d=>this.f.error(g.identifier.id,g.manifest.version,`post-${f}`,d)));const t=D.Event.any(D.Event.map($,d=>({data:`%c${d}`,format:[""]}),this.q),D.Event.map(l,d=>({data:`%c${d}`,format:["color: red"]}),this.q));return D.Event.debounce(t,(d,i)=>d?{data:d.data+i.data,format:[...d.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(d=>{console.group(g.identifier.id),console.log(d.data,...d.format),console.groupEnd()}),m}m(a){return(0,v.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};e.$Jq=p,e.$Jq=p=Ue([Fe(0,y.$Gl),Fe(1,E.$7j)],p)}),define(Ee[137],Se([1,0,86,212,99,30]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=A,e.$Hq=R;function A(v){let s=D.ExtensionManagementErrorCode.Extract;return v instanceof n.$pq&&(v.type==="CorruptZip"?s=D.ExtensionManagementErrorCode.CorruptZip:v.type==="Incomplete"&&(s=D.ExtensionManagementErrorCode.IncompleteZip)),(0,S.$uq)(v,s)}async function R(v){let s;try{s=await(0,n.$sq)(v,"extension/package.json")}catch(E){throw A(E)}try{return JSON.parse(s.toString("utf8"))}catch{throw new D.$dp((0,r.localize)(0,null),D.ExtensionManagementErrorCode.Invalid)}}}),define(Ee[289],Se([1,0,14,10,2,13,20,62,11,22,25,86,27,28,99,30,39,137,95,16,12,24]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m,$,l){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;let o=class extends S.$Uc{static{t=this}static{this.c=".sigzip"}constructor(i,c,u,k,I,C,T){super(),this.h=c,this.j=u,this.m=k,this.n=I,this.r=C,this.t=T,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,c,u,k){await this.g;const I=await this.w(i,c);let C=!1;if(u&&this.u(i)){let T;try{T=await this.y(i)}catch(O){try{await this.delete(I)}catch(P){this.t.error(P)}throw O}try{C=await this.n.verify(i,I.fsPath,T.fsPath,k)}catch(O){if(C=O.code,C===w.ExtensionSignatureVerificationCode.PackageIsInvalidZip||C===w.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(I)}catch(P){this.t.error(P)}throw new f.$dp(y.$oq,f.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(O){this.t.error(O)}}}return{location:I,verificationStatus:C}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const c=this.m.getValue("extensions.verifySignature");return(0,v.$gg)(c)?c:!0}async w(i,c){try{const u=(0,A.$bh)(this.extensionsDownloadDir,this.G(i)),k=await this.C(i,"vsix",async()=>{await this.z(i,u,I=>this.j.download(i,I,c));try{await this.D(u.fsPath,"extension/package.json")}catch(I){try{await this.h.del(u)}catch(C){this.t.warn(`Error while deleting: ${u.path}`,(0,r.$0)(C))}throw I}},2);return k>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:k}),u}catch(u){throw(0,a.$uq)(u,f.ExtensionManagementErrorCode.Download)}}async y(i){try{const c=(0,A.$bh)(this.extensionsDownloadDir,`.${(0,s.$Wg)()}`),u=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,c);try{await this.D(c.fsPath,".signature.p7s")}catch(k){try{await this.h.del(c)}catch(I){this.t.warn(`Error while deleting: ${c.path}`,(0,r.$0)(I))}throw k}},2);return u>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:u}),c}catch(c){throw(0,a.$uq)(c,f.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,c,u){if(await this.h.exists(c))return;if(c.scheme!==D.Schemas.file){await u(c);return}const k=(0,A.$bh)(this.extensionsDownloadDir,`.${(0,s.$Wg)()}`);try{await u(k)}catch(I){try{await this.h.del(k)}catch{}throw I}try{await E.Promises.rename(k.fsPath,c.fsPath,2*60*1e3)}catch(I){try{await this.h.del(k)}catch{}let C=!1;try{C=await this.h.exists(c)}catch{}if(C)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,c.path);else throw this.t.info(`Rename failed because of ${(0,r.$0)(I)}. Deleted the file from downloaded location`,k.path),I}}async C(i,c,u,k){let I=1;for(;;)try{return await u(),I}catch(C){if(I++>k)throw C;this.t.warn(`Failed downloading ${c}. ${(0,r.$0)(C)}. Retry again...`,i.identifier.id)}}async D(i,c){try{await(0,y.$sq)(i,c)}catch(u){throw(0,g.$Gq)(u)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const c=[],u=[],k=[];for(const T of i.children)if(T.name.endsWith(t.c))k.push(T.resource);else{const O=h.$Dp.parse(T.name);O&&u.push([O,T])}const I=(0,h.$Ip)(u,([T])=>T),C=[];for(const T of I)T.sort((O,P)=>R.rcompare(O[0].version,P[0].version)),c.push(...T.slice(1).map(O=>O[1].resource)),C.push(T[0][1]);C.sort((T,O)=>T.mtime-O.mtime),c.push(...C.slice(0,Math.max(0,C.length-this.f)).map(T=>T.resource)),c.push(...k),await n.Promises.settled(c.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(i){this.t.error(i)}}G(i){return this.f?h.$Dp.create(i).toString().toLowerCase():(0,s.$Wg)()}};e.$Iq=o,e.$Iq=o=t=Ue([Fe(0,b.$Ii),Fe(1,m.$7k),Fe(2,f.$bp),Fe(3,p.$7i),Fe(4,w.$hq),Fe(5,l.$6l),Fe(6,$.$7j)],o)}),define(Ee[138],Se([1,0,14,15,19,42,10,6,66,2,26,13,9,20,62,11,4,22,25,86,211,88,28,99,30,39,53,64,289,288,137,266,275,23,87,16,5,12,29,24,36,34]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m,$,l,t,o,d,i,c,u,k,I,C,T,O,P,V,Q,ie,re,ne,se,Z,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=e.$Mq=void 0,e.$Mq=(0,ie.$Bi)(d.$ep);const ue=".vsctmp";let j=class extends o.$tq{constructor(q,ae,Y,H,L,W,z,U,J,x,M,G){super(q,ae,M,Y,x,G),this.eb=L,this.fb=W,this.gb=z,this.hb=U,this.ib=J,this.db=new Map,this.tb=new E.$Bc;const te=this.B(U.createInstance(I.$Jq));this.ab=this.B(U.createInstance(B,ke=>te.postUninstall(ke))),this.bb=this.B(new T.$Kq(G,J,M,this,this.F)),this.cb=this.B(U.createInstance(k.$Iq));const he=this.B(new O.$Lq(this,this.eb,G,W,M,J,Y));this.B(he.onDidChangeExtensionsByAnotherSource(ke=>this.sb(ke))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Np)(this.ib,this.F)),this.jb}async zip(q){this.F.trace("ExtensionManagementService#zip",q.identifier.id);const ae=await this.rb(q),Y=await(0,m.zip)((0,b.$bh)(this.cb.extensionsDownloadDir,(0,g.$Wg)()).fsPath,ae);return h.URI.file(Y)}async unzip(q){return this.F.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:ae,cleanup:Y}=await this.lb(q),H=p.$kc(ae.fsPath);try{return await(0,C.$Hq)(H)}finally{await Y()}}getInstalled(q,ae=this.H.defaultProfile.extensionsResource,Y={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(q??null,ae,Y)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.ab.scanUserExtensionAtLocation(q)}async install(q,ae={}){this.F.trace("ExtensionManagementService#install",q.toString());const{location:Y,cleanup:H}=await this.lb(q);try{const L=await(0,C.$Hq)(p.$kc(Y.fsPath)),W=(0,i.$Hp)(L.publisher,L.name);if(L.engines&&L.engines.vscode&&!(0,V.$Up)(L.engines.vscode,this.G.version,this.G.date))throw new Error($.localize(0,null,W,this.G.version));const U=(await this.I([{manifest:L,extension:Y,options:ae}])).find(({identifier:J})=>(0,i.$Cp)(J,{id:W}));if(U?.local)return U.local;throw U?.error?U.error:(0,o.$uq)(new Error(`Unknown error while installing extension ${W}`))}finally{await H()}}async installFromLocation(q,ae){this.F.trace("ExtensionManagementService#installFromLocation",q.toString());const Y=await this.ab.scanUserExtensionAtLocation(q);if(!Y||!Y.manifest.name||!Y.manifest.version)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.wb([[Y,{source:"resource"}]],ae),this.F.info("Successfully installed extension",Y.identifier.id,ae.toString()),Y}async installExtensionsFromProfile(q,ae,Y){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",q,ae.toString(),Y.toString());const H=(await this.getInstalled(P.ExtensionType.User,ae)).filter(L=>q.some(W=>(0,i.$Cp)(W,L.identifier)));if(H.length){const L=await Promise.all(H.map(W=>this.ab.scanMetadata(W,ae)));await this.wb(H.map((W,z)=>[W,L[z]]),Y),this.F.info("Successfully installed extensions",H.map(W=>W.identifier.id),Y.toString())}return H}async updateMetadata(q,ae,Y=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",q.identifier.id),ae.isPreReleaseVersion&&(ae.preRelease=!0,ae.hasPreReleaseVersion=!0),ae.isMachineScoped===!1&&(ae.isMachineScoped=void 0),ae.isBuiltin===!1&&(ae.isBuiltin=void 0),ae.pinned===!1&&(ae.pinned=void 0),q=await this.ab.updateMetadata(q,ae,Y),this.bb.invalidate(Y),this.w.fire(q),q}async reinstallFromGallery(q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.z.isEnabled())throw new Error($.localize(1,null));const ae=await this.getTargetPlatform(),[Y]=await this.z.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:ae,compatible:!0},S.CancellationToken.None);if(!Y)throw new Error($.localize(2,null));await this.ab.setUninstalled(q);try{await this.ab.removeUninstalledExtension(q)}catch(H){throw new Error($.localize(3,null,(0,D.$lj)(H)))}return this.installFromGallery(Y)}$(q,ae,Y,H){return this.ab.copyExtension(q,ae,Y,H)}copyExtensions(q,ae){return this.ab.copyExtensions(q,ae,{version:this.G.version,date:this.G.date})}markAsUninstalled(...q){return this.ab.setUninstalled(...q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(q){this.F.error(q)}}async download(q,ae,Y){const{location:H}=await this.cb.download(q,ae,!Y);return H}async lb(q){if(q.scheme===y.Schemas.file)return{location:q,async cleanup(){}};this.F.trace("Downloading extension from",q.toString());const ae=(0,b.$bh)(this.cb.extensionsDownloadDir,(0,g.$Wg)());return await this.gb.download(q,ae),this.F.info("Downloaded extension to",ae.toString()),{location:ae,cleanup:async()=>{try{await this.ib.del(ae)}catch(H){this.F.error(H)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(q,ae,Y){const H=ae instanceof h.URI?new i.$Dp({id:(0,i.$Hp)(q.publisher,q.name)},q.version):i.$Dp.create(ae);return this.hb.createInstance(oe,H,q,ae,Y,(L,W)=>{if(ae instanceof h.URI)return this.qb(H,ae,Y,W);let z=this.db.get(H.toString());return z||(this.db.set(H.toString(),z=this.pb(H,ae,L,Y,W)),z.finally(()=>this.db.delete(H.toString()))),z},this.ab)}Z(q,ae){return new le(q,ae.profileLocation,this.fb)}async pb(q,ae,Y,H,L){const{verificationStatus:W,location:z}=await this.cb.download(ae,Y,!H.donotVerifySignature,H.context?.[d.$7o]);try{if(L.isCancellationRequested)throw new A.$5;return await(0,C.$Hq)(z.fsPath),{local:await this.ab.extractUserExtension(q,z.fsPath,{id:ae.identifier.uuid,publisherId:ae.publisherId,publisherDisplayName:ae.publisherDisplayName,targetPlatform:ae.properties.targetPlatform,isApplicationScoped:H.isApplicationScoped,isMachineScoped:H.isMachineScoped,isBuiltin:H.isBuiltin,isPreReleaseVersion:ae.properties.isPreReleaseVersion,hasPreReleaseVersion:ae.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:H.installGivenVersion?!0:!!H.pinned,preRelease:(0,f.$gg)(H.preRelease)?H.preRelease:H.installPreReleaseVersion||ae.properties.isPreReleaseVersion,source:"gallery"},!1,L),verificationStatus:W}}catch(U){try{await this.cb.delete(z)}catch(J){this.F.warn("Error while deleting the downloaded file",z.toString(),(0,A.$0)(J))}throw(0,o.$uq)(U)}}async qb(q,ae,Y,H){return{local:await this.ab.extractUserExtension(q,p.$kc(ae.fsPath),{isApplicationScoped:Y.isApplicationScoped,isMachineScoped:Y.isMachineScoped,isBuiltin:Y.isBuiltin,installedTimestamp:Date.now(),pinned:Y.installGivenVersion?!0:!!Y.pinned,source:"vsix"},!0,H)}}async rb(q){const ae=async H=>{let L=await w.Promises.readdir(H);L=L.map(U=>p.$jc(H,U));const W=await Promise.all(L.map(U=>w.Promises.stat(U)));let z=Promise.resolve([]);return W.forEach((U,J)=>{const x=L[J];U.isFile()&&(z=z.then(M=>[...M,x])),U.isDirectory()&&(z=z.then(M=>ae(x).then(G=>[...M,...G])))}),z};return(await ae(q.location.fsPath)).map(H=>({path:`extension/${p.$lc(q.location.fsPath,H)}`,localPath:H}))}async sb({added:q,removed:ae}){if(ae){const Y=q&&this.D.extUri.isEqual(ae.profileLocation,q.profileLocation)?ae.extensions.filter(H=>q.extensions.every(L=>!(0,i.$Cp)(L,H))):ae.extensions;for(const H of Y)this.F.info("Extensions removed from another source",H.id,ae.profileLocation.toString()),this.u.fire({identifier:H,profileLocation:ae.profileLocation})}if(q){const H=(await this.getInstalled(P.ExtensionType.User,q.profileLocation)).filter(L=>q.extensions.some(W=>(0,i.$Cp)(W,L.identifier)));this.s.fire(H.map(L=>(this.F.info("Extensions added from another source",L.identifier.id,q.profileLocation.toString()),{identifier:L.identifier,local:L,profileLocation:q.profileLocation,operation:d.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(ae=>this.tb.add(ae)));const q=await this.ib.resolve(this.eb.userExtensionsLocation);for(const ae of q.children??[])ae.isDirectory&&this.tb.add(ae.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(ae=>this.vb(ae)))}async vb(q){if(!q.affects(this.eb.userExtensionsLocation,Q.FileChangeType.ADDED))return;const ae=[];for(const Y of q.rawAdded){if(this.tb.has(Y)||!this.D.extUri.isEqual(this.D.extUri.dirname(Y),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(Y,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(Y).startsWith(".")||!(await this.ib.stat(Y)).isDirectory)continue;const H=await this.ab.scanUserExtensionAtLocation(Y);H&&H.installedTimestamp===void 0&&(this.tb.add(Y),ae.push(H))}ae.length&&(await this.wb(ae.map(Y=>[Y,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",ae.map(Y=>Y.identifier.id)))}async wb(q,ae){const Y=q.map(H=>H[0]);await this.xb(Y),await this.fb.addExtensionsToProfile(q,ae),this.s.fire(Y.map(H=>({local:H,identifier:H.identifier,operation:d.InstallOperation.None,profileLocation:ae})))}async xb(q){const ae=await this.ab.getUninstalledExtensions();for(const Y of q){const H=i.$Dp.create(Y);ae[H.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",H.id),await this.ab.setInstalled(H),this.F.info("Removed the extension from uninstalled list:",H.id))}}};e.$Nq=j,e.$Nq=j=Ue([Fe(0,d.$bp),Fe(1,se.$6l),Fe(2,re.$7j),Fe(3,t.$Ii),Fe(4,u.$Bq),Fe(5,c.$xq),Fe(6,l.$Ro),Fe(7,ie.$zi),Fe(8,Q.$7k),Fe(9,ne.$nk),Fe(10,Z.$El),Fe(11,ee.$Gl)],j);let B=class extends s.$Uc{constructor(q,ae,Y,H,L,W){super(),this.j=q,this.m=ae,this.n=Y,this.s=H,this.t=L,this.u=W,this.h=this.B(new R.$he),this.onExtract=this.h.event,this.c=(0,b.$bh)(this.n.userExtensionsLocation,".obsolete"),this.g=new n.$Hh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(q,ae,Y){try{const H={includeInvalid:!0,profileLocation:ae,productVersion:Y};let L=[];return q===null||q===P.ExtensionType.System?L.push(...await this.n.scanAllExtensions({includeInvalid:!0},H,!1)):q===P.ExtensionType.User&&L.push(...await this.n.scanUserExtensions(H)),L=q!==null?L.filter(W=>W.type===q):L,await Promise.all(L.map(W=>this.F(W)))}catch(H){throw(0,o.$uq)(H,d.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(q){try{const ae=await this.n.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return await Promise.all(ae.map(Y=>this.F(Y)))}catch(ae){throw(0,o.$uq)(ae,d.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(q){try{const ae=await this.n.scanExistingExtension(q,P.ExtensionType.User,{includeInvalid:!0});if(ae)return await this.F(ae)}catch(ae){this.u.error(ae)}return null}async extractUserExtension(q,ae,Y,H,L){const W=q.toString(),z=h.URI.file(p.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,g.$Wg)()}`)),U=h.URI.file(p.$jc(this.n.userExtensionsLocation.fsPath,W));let J=await this.m.exists(U);if(J&&H){try{await this.y(q.id,U,"removeExisting")}catch{throw new d.$dp($.localize(4,null,U.fsPath,q.id),d.ExtensionManagementErrorCode.Delete)}J=!1}if(J)try{await this.n.updateMetadata(U,Y)}catch(x){throw(0,o.$uq)(x,d.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(L.isCancellationRequested)throw new A.$5;try{this.u.trace(`Started extracting the extension from ${ae} to ${U.fsPath}`),await(0,m.$rq)(ae,z.fsPath,{sourcePath:"extension",overwrite:!0},L),this.u.info(`Extracted extension to ${U}:`,q.id)}catch(x){throw(0,C.$Gq)(x)}try{await this.n.updateMetadata(z,Y)}catch(x){throw(0,o.$uq)(x,d.ExtensionManagementErrorCode.UpdateMetadata)}if(L.isCancellationRequested)throw new A.$5;try{this.u.trace(`Started renaming the extension from ${z.fsPath} to ${U.fsPath}`),await this.C(z.fsPath,U.fsPath),this.u.info("Renamed to",U.fsPath)}catch(x){if(x.code==="ENOTEMPTY"){this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);try{await this.m.del(z,{recursive:!0})}catch{}}else throw this.u.info(`Rename failed because of ${(0,A.$0)(x)}. Deleted from extracted location`,z),x}this.h.fire(U)}catch(x){try{await this.m.del(z,{recursive:!0})}catch{}throw x}return this.D(U,P.ExtensionType.User)}async scanMetadata(q,ae){return ae?(await this.w(q,ae))?.metadata:this.n.scanMetadata(q.location)}async w(q,ae){return(await this.s.scanProfileExtensions(ae)).find(H=>(0,i.$Cp)(H.identifier,q.identifier))}async updateMetadata(q,ae,Y){try{Y?await this.s.updateMetadata([[q,ae]],Y):await this.n.updateMetadata(q.location,ae)}catch(H){throw(0,o.$uq)(H,d.ExtensionManagementErrorCode.UpdateMetadata)}return this.D(q.location,q.type,Y)}async getUninstalledExtensions(){try{return await this.z()}catch(q){throw(0,o.$uq)(q,d.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...q){const ae=q.map(Y=>i.$Dp.create(Y));await this.z(Y=>ae.forEach(H=>{Y[H.toString()]=!0,this.u.info("Marked extension as uninstalled",H.toString())}))}async setInstalled(q){try{await this.z(ae=>delete ae[q.toString()])}catch(ae){throw(0,o.$uq)(ae,d.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(q,ae){if(this.t.extUri.isEqualOrParent(q.location,this.n.userExtensionsLocation))return this.y(q.identifier.id,q.location,ae)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.z(ae=>delete ae[i.$Dp.create(q).toString()])}async copyExtension(q,ae,Y,H){const L=await this.w(q,ae),W=await this.w(q,Y);if(H={...L?.metadata,...H},W)if(this.t.extUri.isEqual(W.location,q.location))await this.s.updateMetadata([[q,{...W.metadata,...H}]],Y);else{const z=await this.D(W.location,q.type,Y);await this.s.removeExtensionFromProfile(z,Y),await this.s.addExtensionsToProfile([[q,{...W.metadata,...H}]],Y)}else await this.s.addExtensionsToProfile([[q,H]],Y);return this.D(q.location,q.type,Y)}async copyExtensions(q,ae,Y){const H=await this.scanExtensions(P.ExtensionType.User,q,Y),L=await Promise.all(H.filter(W=>!W.isApplicationScoped).map(async W=>[W,await this.scanMetadata(W,q)]));await this.s.addExtensionsToProfile(L,ae)}async y(q,ae,Y){this.u.trace(`Deleting ${Y} extension from disk`,q,ae.fsPath);const H=this.t.extUri.joinPath(this.t.extUri.dirname(ae),`${this.t.extUri.basename(ae)}.${(0,v.$oj)((0,g.$Wg)()).toString(16)}${ue}`);await this.C(ae.fsPath,H.fsPath),await this.m.del(H,{recursive:!0}),this.u.info(`Deleted ${Y} extension from disk`,q,ae.fsPath)}z(q){return this.g.queue(async()=>{let ae;try{ae=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(H){if((0,Q.$ll)(H)!==Q.FileOperationResult.FILE_NOT_FOUND)throw H}let Y={};if(ae)try{Y=JSON.parse(ae)}catch{}return q&&(q(Y),Object.keys(Y).length?await this.m.writeFile(this.c,r.$Je.fromString(JSON.stringify(Y))):await this.m.del(this.c)),Y})}async C(q,ae){try{await w.Promises.rename(q,ae,2*60*1e3)}catch(Y){throw(0,o.$uq)(Y,d.ExtensionManagementErrorCode.Rename)}}async D(q,ae,Y){try{if(Y){const L=(await this.n.scanUserExtensions({profileLocation:Y})).find(W=>this.t.extUri.isEqual(W.location,q));if(L)return await this.F(L)}else{const H=await this.n.scanExistingExtension(q,ae,{includeInvalid:!0});if(H)return await this.F(H)}throw new d.$dp($.localize(5,null,q.path),d.ExtensionManagementErrorCode.ScanningExtension)}catch(H){throw(0,o.$uq)(H,d.ExtensionManagementErrorCode.ScanningExtension)}}async F(q){const ae=await this.m.resolve(q.location);let Y,H;return ae.children&&(Y=ae.children.find(({name:L})=>/^readme(\.txt|\.md|)$/i.test(L))?.resource,H=ae.children.find(({name:L})=>/^changelog(\.txt|\.md|)$/i.test(L))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:Y,changelogUrl:H,publisherDisplayName:q.metadata?.publisherDisplayName,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!q.metadata?.hasPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned,isWorkspaceScoped:!1,source:q.metadata?.source??(q.identifier.uuid?"gallery":"vsix")}}async G(){const q=await this.getUninstalledExtensions();if(Object.keys(q).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(q));const ae=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),Y=new Set;for(const L of ae)q[i.$Dp.create(L).toString()]||Y.add(L.identifier.id.toLowerCase());try{const L=(0,i.$Ip)(ae,W=>W.identifier);await n.Promises.settled(L.map(async W=>{const z=W.sort((U,J)=>a.rcompare(U.manifest.version,J.manifest.version))[0];Y.has(z.identifier.id.toLowerCase())||await this.j(await this.F(z))}))}catch(L){this.u.error(L)}const H=ae.filter(L=>L.metadata&&q[i.$Dp.create(L).toString()]);await Promise.allSettled(H.map(L=>this.removeUninstalledExtension(L)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let q;try{q=await this.m.resolve(this.n.userExtensionsLocation)}catch(ae){(0,Q.$ll)(ae)!==Q.FileOperationResult.FILE_NOT_FOUND&&this.u.error(ae);return}if(q?.children)try{await Promise.allSettled(q.children.map(async ae=>{if(!(!ae.isDirectory||!ae.name.endsWith(ue))){this.u.trace("Deleting the temporarily deleted folder",ae.resource.toString());try{await this.m.del(ae.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",ae.resource.toString())}catch(Y){(0,Q.$ll)(Y)!==Q.FileOperationResult.FILE_NOT_FOUND&&this.u.error(Y)}}}))}catch{}}};e.$Oq=B,e.$Oq=B=Ue([Fe(1,Q.$7k),Fe(2,u.$Bq),Fe(3,c.$xq),Fe(4,Z.$El),Fe(5,re.$7j)],B);let oe=class extends o.$vq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(q,ae,Y,H,L,W,z,U,J,x,M,G){super(),this.l=q,this.manifest=ae,this.source=Y,this.options=H,this.m=L,this.n=W,this.o=z,this.p=U,this.q=J,this.s=x,this.t=M,this.u=G,this.j=d.InstallOperation.Install,this.identifier=this.l.identifier}async v(){return(await this.n.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(ae=>(0,i.$Cp)(ae.identifier,this.identifier))}async h(q){const ae=await this.v();ae&&(this.j=d.InstallOperation.Update);const Y={isApplicationScoped:this.options.isApplicationScoped||ae?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||ae?.isMachineScoped,isBuiltin:this.options.isBuiltin||ae?.isBuiltin,isSystem:ae?.type===P.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??ae?.pinned,source:this.source instanceof h.URI?"vsix":"gallery"};let H;if(this.source instanceof h.URI)if(ae){if(this.l.equals(new i.$Dp(ae.identifier,ae.manifest.version)))try{await this.n.removeExtension(ae,"existing")}catch{throw new Error($.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const W=await this.x(this.l);if(W)try{await this.n.removeExtension(W,"existing")}catch{throw new Error($.localize(7,null,this.manifest.displayName||this.manifest.name))}}else Y.id=this.source.identifier.uuid,Y.publisherId=this.source.publisherId,Y.publisherDisplayName=this.source.publisherDisplayName,Y.targetPlatform=this.source.properties.targetPlatform,Y.updated=!!ae,Y.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,Y.hasPreReleaseVersion=ae?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,Y.preRelease=(0,f.$gg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||ae?.preRelease,ae&&ae.type!==P.ExtensionType.System&&ae.manifest.version===this.source.version?H=await this.n.updateMetadata(ae,Y):H=await this.x(this.l);if(q.isCancellationRequested)throw(0,o.$uq)(new A.$5);if(!H){const W=await this.m(this.operation,q);H=W.local,this.k=W.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(W){throw(0,o.$uq)(W,d.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(q.isCancellationRequested)throw(0,o.$uq)(new A.$5);try{await this.t.addExtensionsToProfile([[H,Y]],this.options.profileLocation,!H.isValid)}catch(W){throw(0,o.$uq)(W,d.ExtensionManagementErrorCode.AddToProfile)}const L=await this.v();if(!L)throw new d.$dp("Cannot find the installed extension",d.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof h.URI&&this.y(H,q),L}async x(q){return(await this.n.getUninstalledExtensions())[q.toString()]?(this.u.trace("Removing the extension from uninstalled list:",q.id),await this.n.setInstalled(q),this.u.info("Removed the extension from uninstalled list:",q.id),(await this.n.scanAllUserExtensions(!0)).find(H=>i.$Dp.create(H).equals(q))):void 0}async y(q,ae){try{let[Y]=await this.p.getExtensions([{id:q.identifier.id,version:q.manifest.version}],ae);if(Y||([Y]=await this.p.getExtensions([{id:q.identifier.id}],ae)),Y){const H={id:Y.identifier.uuid,publisherDisplayName:Y.publisherDisplayName,publisherId:Y.publisherId,isPreReleaseVersion:Y.properties.isPreReleaseVersion,hasPreReleaseVersion:q.hasPreReleaseVersion||Y.properties.isPreReleaseVersion,preRelease:Y.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(q,H,this.options.profileLocation)}}catch{}}};oe=Ue([Fe(6,Z.$El),Fe(7,d.$bp),Fe(8,ee.$Gl),Fe(9,u.$Bq),Fe(10,c.$xq),Fe(11,re.$7j)],oe);class le extends o.$vq{constructor(q,ae,Y){super(),this.extension=q,this.j=ae,this.k=Y}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Ee[139],Se([1,0,12,34,36,24,53,16,28,4]),function(fe,e,n,r,S,D,A,R,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=void 0;let E=class extends A.$yq{constructor(p,b,a,f,h,g){super(s.URI.file(p.extensionsPath),b,a,f,h,g)}};e.$lQ=E,e.$lQ=E=Ue([Fe(0,v.$Ii),Fe(1,R.$7k),Fe(2,r.$Gl),Fe(3,S.$El),Fe(4,D.$6l),Fe(5,n.$7j)],E)}),define(Ee[100],Se([1,0,14,6,2,45,11,196,5,34]),function(fe,e,n,r,S,D,A,R,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$$p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9p=e.$8p=e.$7p=void 0,e.$0p=b,e.$_p=f,e.$bq=g,e.$7p="__$__isNewStorageMarker",e.$8p="__$__targetStorageMarker",e.$9p=(0,v.$Ai)("storageService");var E;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var y;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var p;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function b(w){const m=w.get(e.$8p);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}class a extends S.$Uc{static{this.a=60*1e3}constructor(m={flushInterval:a.a}){super(),this.m=m,this.b=this.B(new r.$ke),this.c=this.B(new r.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$he),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,$,l){return r.Event.filter(this.b.event,t=>t.scope===m&&($===void 0||t.key===$),l)}n(){this.j.value=(0,n.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,$){const{key:l,external:t}=$;if(l===e.$8p){switch(m){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:l,target:this.J(m)[l],external:t})}w(m){this.f.fire({reason:m})}get(m,$,l){return this.P($)?.get(m,l)}getBoolean(m,$,l){return this.P($)?.getBoolean(m,l)}getNumber(m,$,l){return this.P($)?.getNumber(m,l)}getObject(m,$,l){return this.P($)?.getObject(m,l)}storeAll(m,$){this.y(()=>{for(const l of m)this.store(l.key,l.value,l.scope,l.target,$)})}store(m,$,l,t,o=!1){if((0,A.$jg)($)){this.remove(m,l,o);return}this.y(()=>{this.z(m,l,t),this.P(l)?.set(m,$,o)})}remove(m,$,l=!1){this.y(()=>{this.z(m,$,void 0),this.P($)?.delete(m,l)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,$){const l=[],t=this.J(m);for(const o of Object.keys(t))t[o]===$&&l.push(o);return l}z(m,$,l,t=!1){const o=this.J($);typeof l=="number"?o[m]!==l&&(o[m]=l,this.P($)?.set(e.$8p,JSON.stringify(o),t)):typeof o[m]=="number"&&(delete o[m],this.P($)?.set(e.$8p,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(m){switch(m){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(m){const $=this.P(m);return $?b($):Object.create(null)}isNew(m){return this.getBoolean(e.$7p,m)===!0}async flush(m=E.NONE){this.f.fire({reason:m});const $=this.P(y.APPLICATION),l=this.P(y.PROFILE),t=this.P(y.WORKSPACE);switch(m){case E.NONE:await n.Promises.settled([$?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await n.Promises.settled([$?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(y.APPLICATION)?.items??new Map,$=this.P(y.PROFILE)?.items??new Map,l=this.P(y.WORKSPACE)?.items??new Map;return g(m,$,l,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,$){return this.w(E.NONE),(0,s.$Fl)(m)?this.R(m,$):this.S(m,$)}M(m,$){return!(m.id===$.id||f($)&&f(m))}N(m,$,l){this.y(()=>{const t=new Set;for(const[o,d]of m)t.add(o),$.get(o)!==d&&this.u(l,{key:o,external:!0});for(const[o]of $.items)t.has(o)||this.u(l,{key:o,external:!0})})}}e.$$p=a;function f(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class h extends a{constructor(){super(),this.U=this.B(new R.$5p(new R.$6p,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$5p(new R.$6p,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$5p(new R.$6p,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(y.WORKSPACE,m))),this.B(this.W.onDidChangeStorage(m=>this.u(y.PROFILE,m))),this.B(this.U.onDidChangeStorage(m=>this.u(y.APPLICATION,m)))}P(m){switch(m){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(m){switch(m){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$aq=h;async function g(w,m,$,l,t,o){const d=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,c=new Map;w.forEach((P,V)=>{i.set(V,P),c.set(V,d(P))});const u=new Map,k=new Map;m.forEach((P,V)=>{u.set(V,P),k.set(V,d(P))});const I=new Map,C=new Map;$.forEach((P,V)=>{I.set(V,P),C.set(V,d(P))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const T=[];if(i.forEach((P,V)=>{T.push({key:V,value:P})}),console.table(T),console.groupEnd(),console.log(c),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];u.forEach((V,Q)=>{P.push({key:Q,value:V})}),console.table(P),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${o})`);const O=[];I.forEach((P,V)=>{O.push({key:V,value:P})}),console.table(O),console.groupEnd(),console.log(C)}}),define(Ee[290],Se([1,0,15,22,100]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=D;async function D(A,R,v){let s=v&&v.get("storage.serviceMachineId",S.StorageScope.APPLICATION)||null;if(s)return s;try{const y=(await R.readFile(A.serviceMachineIdResource)).value.toString();s=(0,r.$Vg)(y)?y:null}catch{s=null}if(!s){s=(0,r.$Wg)();try{await R.writeFile(A.serviceMachineIdResource,n.$Je.fromString(s))}catch{}}return v?.store("storage.serviceMachineId",s,S.StorageScope.APPLICATION,S.StorageTarget.MACHINE),s}}),define(Ee[291],Se([1,0,290,24,41]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=D;async function D(A,R,v,s,E,y,p){const b={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${R.nameShort})`};if((0,S.$up)(R,v)&&(0,S.$wp)(s)===r.TelemetryLevel.USAGE){const a=await(0,n.$cq)(v,E,y);b["X-Market-User-Id"]=a,b["VSCode-SessionId"]=p.machineId||a}return b}}),define(Ee[140],Se([1,0,18,19,10,3,33,11,4,27,28,30,39,23,87,16,12,29,47,291,100,24,55]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m,$,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0,e.$eq=pe;const o=D.$o?b.TargetPlatform.WEB:(0,y.$0o)(D.$u,A.$ec),d="X-Market-Search-Activity-Id";var i;(function(W){W[W.None=0]="None",W[W.IncludeVersions=1]="IncludeVersions",W[W.IncludeFiles=2]="IncludeFiles",W[W.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",W[W.IncludeSharedAccounts=8]="IncludeSharedAccounts",W[W.IncludeVersionProperties=16]="IncludeVersionProperties",W[W.ExcludeNonValidated=32]="ExcludeNonValidated",W[W.IncludeInstallationTargets=64]="IncludeInstallationTargets",W[W.IncludeAssetUri=128]="IncludeAssetUri",W[W.IncludeStatistics=256]="IncludeStatistics",W[W.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",W[W.Unpublished=4096]="Unpublished",W[W.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function c(...W){return String(W.reduce((z,U)=>z|U,0))}var u;(function(W){W[W.Tag=1]="Tag",W[W.ExtensionId=4]="ExtensionId",W[W.Category=5]="Category",W[W.ExtensionName=7]="ExtensionName",W[W.Target=8]="Target",W[W.Featured=9]="Featured",W[W.SearchText=10]="SearchText",W[W.ExcludeWithFlags=12]="ExcludeWithFlags"})(u||(u={}));const k={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},I={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},T={pageNumber:1,pageSize:10,sortBy:y.SortBy.NoneOrRelevance,sortOrder:y.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class O{constructor(z=T){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,U=this.d.pageSize){return new O({...this.d,pageNumber:z,pageSize:U})}withFilter(z,...U){const J=[...this.d.criteria,...U.length?U.map(x=>({filterType:z,value:x})):[{filterType:z}]];return new O({...this.d,criteria:J})}withSortBy(z){return new O({...this.d,sortBy:z})}withSortOrder(z){return new O({...this.d,sortOrder:z})}withFlags(...z){return new O({...this.d,flags:z.reduce((U,J)=>U|J,0)})}withAssetTypes(...z){return new O({...this.d,assetTypes:z})}withSource(z){return new O({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:U,pageSize:J,sortBy:x,sortOrder:M,flags:G,assetTypes:te}=this.d;return{filters:[{criteria:z,pageNumber:U,pageSize:J,sortBy:x,sortOrder:M}],assetTypes:te,flags:G}}get searchText(){const z=this.d.criteria.filter(U=>U.filterType===u.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function P(W,z){const U=(W||[]).filter(J=>J.statisticName===z)[0];return U?U.value:0}function V(W){const z="Microsoft.VisualStudio.Code.Translation.";return W.files.filter(J=>J.assetType.indexOf(z)===0).reduce((J,x)=>{const M=re(W,x.assetType);return M&&J.push([x.assetType.substring(z.length),M]),J},[])}function Q(W){if(W.properties){const z=W.properties.filter(x=>x.key===k.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=z.filter(x=>U.test(x.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return re(W,k.Repository)}function ie(W){return{uri:`${W.fallbackAssetUri}/${k.VSIX}?redirect=true${W.targetPlatform?`&targetPlatform=${W.targetPlatform}`:""}`,fallbackUri:`${W.fallbackAssetUri}/${k.VSIX}${W.targetPlatform?`?targetPlatform=${W.targetPlatform}`:""}`}}function re(W,z){return W.files.filter(J=>J.assetType===z)[0]?{uri:`${W.assetUri}/${z}${W.targetPlatform?`?targetPlatform=${W.targetPlatform}`:""}`,fallbackUri:`${W.fallbackAssetUri}/${z}${W.targetPlatform?`?targetPlatform=${W.targetPlatform}`:""}`}:null}function ne(W,z){const U=W.properties?W.properties.filter(x=>x.key===z):[],J=U.length>0&&U[0].value;return J?J.split(",").map(x=>(0,p.$Gp)(x)):[]}function se(W){const z=W.properties?W.properties.filter(U=>U.key===I.Engine):[];return z.length>0&&z[0].value||""}function Z(W){const z=W.properties?W.properties.filter(U=>U.key===I.PreRelease):[];return z.length>0&&z[0].value==="true"}function ee(W){const z=W.properties?W.properties.filter(J=>J.key===I.LocalizedLanguages):[],U=z.length>0&&z[0].value||"";return U?U.split(","):[]}function ue(W){return W.properties?.find(z=>z.key===I.SponsorLink)?.value}function j(W){return W.properties?.find(z=>z.key===I.SupportLink)?.value}function B(W){return W.indexOf("preview")!==-1}function oe(W){return W.targetPlatform?(0,y.$9o)(W.targetPlatform):b.TargetPlatform.UNDEFINED}function le(W){const z=(0,n.$Mb)(W.versions.map(oe)),U=!!W.tags?.includes(y.$3o),J=z.indexOf(b.TargetPlatform.WEB);return U?J===-1&&z.push(b.TargetPlatform.WEB):J!==-1&&z.splice(J,1),z}function pe(W,z){for(let U=0;U<W.length;U++){const J=W[U];if(J.version===W[U-1]?.version){let x=U;if(oe(J)===z)for(;x>0&&W[x-1].version===J.version;)x--;x!==U&&(W.splice(U,1),W.splice(x,0,J))}}return W}function q(W,z,U){W.telemetryData={index:z,querySource:U,queryActivityId:W.queryContext?.[d]}}function ae(W,z,U,J){const x=W.versions[0],M={manifest:re(z,k.Manifest),readme:re(z,k.Details),changelog:re(z,k.Changelog),license:re(z,k.License),repository:Q(z),download:ie(z),icon:re(z,k.Icon),signature:re(z,k.Signature),coreTranslations:V(z)};return{type:"gallery",identifier:{id:(0,p.$Hp)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},name:W.extensionName,version:z.version,displayName:W.displayName,publisherId:W.publisher.publisherId,publisher:W.publisher.publisherName,publisherDisplayName:W.publisher.displayName,publisherDomain:W.publisher.domain?{link:W.publisher.domain,verified:!!W.publisher.isDomainVerified}:void 0,publisherSponsorLink:ue(x),description:W.shortDescription??"",installCount:P(W.statistics,"install"),rating:P(W.statistics,"averagerating"),ratingCount:P(W.statistics,"ratingcount"),categories:W.categories||[],tags:W.tags||[],releaseDate:Date.parse(W.releaseDate),lastUpdated:Date.parse(W.lastUpdated),allTargetPlatforms:U,assets:M,properties:{dependencies:ne(z,I.Dependency),extensionPack:ne(z,I.ExtensionPack),engine:se(z),localizedLanguages:ee(z),targetPlatform:oe(z),isPreReleaseVersion:Z(z)},hasPreReleaseVersion:Z(x),hasReleaseVersion:!0,preview:B(W.flags),isSigned:!!M.signature,queryContext:J,supportLink:j(x)}}let Y=class{constructor(z,U,J,x,M,G,te,he){this.k=U,this.l=J,this.n=x,this.o=M,this.q=G,this.u=te,this.w=he;const ke=te.extensionsGallery,Ne=ke?.servicePPEUrl&&he.getValue("_extensionsGallery.enablePPE");this.d=Ne?ke.servicePPEUrl:ke?.serviceUrl,this.g=Ne?void 0:ke?.searchUrl,this.h=ke?.controlUrl,this.j=(0,m.$dq)(te.version,te,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,U,J){const x=r.CancellationToken.isCancellationToken(U)?{}:U,M=r.CancellationToken.isCancellationToken(U)?U:J,G=[],te=[],he=[],ke=[];let Ne=!0;for(const Ae of z){Ae.uuid?te.push(Ae.uuid):G.push(Ae.id);const Le=!!(Ae.version||Ae.preRelease);he.push({id:Ae.id,uuid:Ae.uuid,includePreRelease:Le}),Ae.version&&ke.push({id:Ae.id,uuid:Ae.uuid,version:Ae.version}),Ne=Ne&&!!Ae.hasPreRelease&&!Le}if(!te.length&&!G.length)return[];let me=new O().withPage(1,z.length);te.length&&(me=me.withFilter(u.ExtensionId,...te)),G.length&&(me=me.withFilter(u.ExtensionName,...G)),(x.queryAllVersions||Ne)&&(me=me.withFlags(me.flags,i.IncludeVersions)),x.source&&(me=me.withSource(x.source));const{extensions:be}=await this.z(me,{targetPlatform:x.targetPlatform??o,includePreRelease:he,versions:ke,compatible:!!x.compatible,productVersion:x.productVersion??{version:this.u.version,date:this.u.date}},M);return x.source&&be.forEach((Ae,Le)=>q(Ae,Le,x.source)),be}async getCompatibleExtension(z,U,J,x={version:this.u.version,date:this.u.date}){if((0,y.$$o)(z.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(z,U,J))return z;const M=new O().withFlags(i.IncludeVersions).withPage(1,1).withFilter(u.ExtensionId,z.identifier.uuid),{extensions:G}=await this.z(M,{targetPlatform:J,compatible:!0,includePreRelease:U,productVersion:x},r.CancellationToken.None);return G[0]||null}async isExtensionCompatible(z,U,J,x={version:this.u.version,date:this.u.date}){if(!(0,y.$_o)(z.properties.targetPlatform,z.allTargetPlatforms,J)||!U&&z.properties.isPreReleaseVersion)return!1;let M=z.properties.engine;if(!M){const G=await this.getManifest(z,r.CancellationToken.None);if(!G)throw new Error("Manifest was not found");M=G.engines.vscode}return(0,a.$Up)(M,x.version,x.date)}async y(z,U,J,x,M,G,te={version:this.u.version,date:this.u.date}){if(!(0,y.$_o)(oe(U),M,G)||J!=="any"&&Z(U)!==(J==="prerelease"))return!1;if(x)try{const he=await this.E(z,U);if(!(0,a.$Up)(he,te.version,te.date))return!1}catch(he){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,S.$0)(he)),!1}return!0}async query(z,U){let J=z.text||"";const x=z.pageSize??50;let M=new O().withPage(1,x);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ne,me,be)=>(M=M.withFilter(u.Category,be||me),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ne,me,be)=>(M=M.withFilter(u.Tag,be||me),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(M=M.withFilter(u.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),M=M.withFilter(u.SearchText,J)),M=M.withSortBy(y.SortBy.NoneOrRelevance)):z.ids?M=M.withFilter(u.ExtensionId,...z.ids):z.names?M=M.withFilter(u.ExtensionName,...z.names):M=M.withSortBy(y.SortBy.InstallCount),typeof z.sortBy=="number"&&(M=M.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(M=M.withSortOrder(z.sortOrder)),z.source&&(M=M.withSource(z.source));const G=async(Ne,me)=>{const{extensions:be,total:Ae}=await this.z(Ne,{targetPlatform:o,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},me);return be.forEach((Le,de)=>q(Le,(Ne.pageNumber-1)*Ne.pageSize+de,z.source)),{extensions:be,total:Ae}},{extensions:te,total:he}=await G(M,U),ke=async(Ne,me)=>{if(me.isCancellationRequested)throw new S.$5;const{extensions:be}=await G(M.withPage(Ne+1),me);return be};return{firstPage:te,total:he,pageSize:M.pageSize,getPage:ke}}async z(z,U,J){const x=z.flags;z.flags&i.IncludeLatestVersionOnly&&z.flags&i.IncludeVersions&&(z=z.withFlags(z.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(z.flags&i.IncludeLatestVersionOnly)&&!(z.flags&i.IncludeVersions)&&(z=z.withFlags(z.flags,i.IncludeLatestVersionOnly)),U.versions?.length&&(z=z.withFlags(z.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),z=z.withFlags(z.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:M,total:G,context:te}=await this.B(z,J);if(!(z.flags&i.IncludeLatestVersionOnly)){const me=[];for(const be of M){const Ae=await this.A(be,U,te);Ae&&me.push(Ae)}return{extensions:me,total:G}}const ke=[],Ne=new Map;for(let me=0;me<M.length;me++){const be=M[me],Ae={id:(0,p.$Hp)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Le=(0,R.$gg)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Ie=>(0,p.$Cp)(Ie,Ae))?.includePreRelease;if(U.compatible&&(0,y.$$o)(le(be),U.targetPlatform))continue;const de=await this.A(be,U,te);!de||de.properties.isPreReleaseVersion&&(!Le||!de.hasReleaseVersion)||!de.properties.isPreReleaseVersion&&de.properties.targetPlatform!==U.targetPlatform&&de.hasPreReleaseVersion?Ne.set(be.extensionId,me):ke.push([me,de])}if(Ne.size){const me=new t.$be,be=new O().withFlags(x&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Ne.size).withFilter(u.ExtensionId,...Ne.keys()),{extensions:Ae}=await this.z(be,U,J);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:Ne.size});for(const Le of Ae){const de=Ne.get(Le.identifier.uuid);ke.push([de,Le])}}return{extensions:ke.sort((me,be)=>me[0]-be[0]).map(([,me])=>me),total:G}}async A(z,U,J){const x={id:(0,p.$Hp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},M=U.versions?.find(ke=>(0,p.$Cp)(ke,x))?.version,G=(0,R.$gg)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ke=>(0,p.$Cp)(ke,x))?.includePreRelease,te=le(z),he=pe(z.versions,U.targetPlatform);if(U.compatible&&(0,y.$$o)(te,U.targetPlatform))return null;for(let ke=0;ke<he.length;ke++){const Ne=he[ke];if(!(M&&Ne.version!==M)){if(await this.y((0,p.$Hp)(z.publisher.publisherName,z.extensionName),Ne,G?"any":"release",U.compatible,te,U.targetPlatform,U.productVersion))return ae(z,Ne,te,J);if(M&&Ne.version===M)return null}}return M||U.compatible?null:ae(z,z.versions[0],te)}async B(z,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,i.ExcludeNonValidated).withFilter(u.Target,"Microsoft.VisualStudio.Code").withFilter(u.ExcludeWithFlags,c(i.Unpublished));const J=await this.j,x=JSON.stringify(z.raw),M={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},G=new t.$be;let te,he,ke=0;try{if(te=await this.k.request({type:"POST",url:this.g&&z.criteria.some(me=>me.filterType===u.SearchText)?this.g:this.x("/extensionquery"),data:x,headers:M},U),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:ke};const Ne=await(0,w.$2p)(te);if(Ne){const me=Ne.results[0],be=me.extensions,Ae=me.resultMetadata&&me.resultMetadata.filter(Le=>Le.metadataType==="ResultCount")[0];return ke=Ae&&Ae.metadataItems.filter(Le=>Le.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:ke,context:{[d]:te.res.headers.activityid}}}return{galleryExtensions:[],total:ke}}catch(Ne){if((0,S.$4)(Ne))throw he=y.ExtensionGalleryErrorCode.Cancelled,Ne;{const me=(0,S.$0)(Ne);throw he=me.startsWith("XHR timeout")?y.ExtensionGalleryErrorCode.Timeout:y.ExtensionGalleryErrorCode.Failed,new y.$cp(me,he)}}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(x.length),duration:G.elapsed(),success:!!te&&(0,w.$Xp)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:he,count:String(ke)})}}async reportStatistic(z,U,J,x){if(!this.isEnabled())return;const M=D.$o?this.x(`/itemName/${z}.${U}/version/${J}/statType/${x===y.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${U}/${J}/stats?statType=${x}`),G=D.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.j,Accept:G};try{await this.k.request({type:"POST",url:M,headers:he},r.CancellationToken.None)}catch{}}async download(z,U,J){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const x=(0,p.$Kp)(z),M=new Date().getTime(),G=J===y.InstallOperation.Install?"install":J===y.InstallOperation.Update?"update":"",te=G?{uri:`${z.assets.download.uri}${v.URI.parse(z.assets.download.uri).query?"&":"?"}${G}=true`,fallbackUri:`${z.assets.download.fallbackUri}${v.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${G}=true`}:z.assets.download,he=z.queryContext?.[d]?{[d]:z.queryContext[d]}:void 0,ke=await this.D(z.identifier.id,te,k.VSIX,he?{headers:he}:void 0);try{await this.q.writeFile(U,ke.stream)}catch(Ne){try{await this.q.del(U)}catch(me){this.l.warn(`Error while deleting the file ${U.toString()}`,(0,S.$0)(me))}throw new y.$cp((0,S.$0)(Ne),y.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{...x,duration:new Date().getTime()-M})}async downloadSignatureArchive(z,U){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const J=await this.D(z.identifier.id,z.assets.signature,k.Signature);try{await this.q.writeFile(U,J.stream)}catch(x){try{await this.q.del(U)}catch(M){this.l.warn(`Error while deleting the file ${U.toString()}`,(0,S.$0)(M))}throw new y.$cp((0,S.$0)(x),y.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(z,U){if(z.assets.readme){const J=await this.D(z.identifier.id,z.assets.readme,k.Details,{},U);return await(0,w.$1p)(J)||""}return""}async getManifest(z,U){if(z.assets.manifest){const J=await this.D(z.identifier.id,z.assets.manifest,k.Manifest,{},U),x=await(0,w.$1p)(J);return x?JSON.parse(x):null}return null}async C(z,U,J){const x=re(U,k.Manifest);if(!x)throw new Error("Manifest was not found");const M={"Accept-Encoding":"gzip"},G=await this.D(z,x,k.Manifest,{headers:M});return await(0,w.$2p)(G)}async getCoreTranslation(z,U){const J=z.assets.coreTranslations.filter(x=>x[0]===U.toUpperCase())[0];if(J){const x=await this.D(z.identifier.id,J[1],J[0]),M=await(0,w.$1p)(x);return M?JSON.parse(M):null}return null}async getChangelog(z,U){if(z.assets.changelog){const J=await this.D(z.identifier.id,z.assets.changelog,k.Changelog,{},U);return await(0,w.$1p)(J)||""}return""}async getAllCompatibleVersions(z,U,J){let x=new O().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?x=x.withFilter(u.ExtensionId,z.identifier.uuid):x=x.withFilter(u.ExtensionName,z.identifier.id);const{galleryExtensions:M}=await this.B(x,r.CancellationToken.None);if(!M.length)return[];const G=le(M[0]);if((0,y.$$o)(G,J))return[];const te=[];await Promise.all(M[0].versions.map(async Ne=>{try{await this.y(z.identifier.id,Ne,U?"any":"release",!0,G,J)&&te.push(Ne)}catch{}}));const he=[],ke=new Set;for(const Ne of pe(te,J))ke.has(Ne.version)||(ke.add(Ne.version),he.push({version:Ne.version,date:Ne.lastUpdated,isPreReleaseVersion:Z(Ne)}));return he}async D(z,U,J,x={},M=r.CancellationToken.None){const G=await this.j,te={type:"GET"},he={...G,...x.headers||{}};x={...x,...te,headers:he};const ke=U.uri,Ne=U.fallbackUri,me={...x,url:ke};try{const be=await this.k.request(me,M);if(be.res.statusCode===200)return be;const Ae=await(0,w.$1p)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Ae}`)}catch(be){if((0,S.$4)(be))throw be;const Ae=(0,S.$0)(be);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:J,message:Ae});const Le={...x,url:Ne};return this.k.request(Le,M)}}async E(z,U){let J=se(U);if(!J){this.o.publicLog2("galleryService:engineFallback",{extension:z,version:U.version});const x=await this.C(z,U,r.CancellationToken.None);if(!x)throw new Error("Manifest was not found");J=x.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},r.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,w.$2p)(z),J=[],x={},M=[];if(U){for(const G of U.malicious)J.push({id:G});if(U.migrateToPreRelease)for(const[G,te]of Object.entries(U.migrateToPreRelease))(!te.engine||(0,a.$Up)(te.engine,this.u.version,this.u.date))&&(x[G.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[G,te]of Object.entries(U.deprecated))te&&(x[G.toLowerCase()]=(0,R.$gg)(te)?{}:te);if(U.search)for(const G of U.search)M.push(G)}return{malicious:J,deprecated:x,search:M}}};Y=Ue([Fe(1,w.$Vp),Fe(2,h.$7j),Fe(3,E.$Hi),Fe(4,l.$6l),Fe(5,f.$7k),Fe(6,g.$nk),Fe(7,s.$7i)],Y);let H=class extends Y{constructor(z,U,J,x,M,G,te,he){super(z,U,J,x,M,G,te,he)}};e.$fq=H,e.$fq=H=Ue([Fe(0,$.$9p),Fe(1,w.$Vp),Fe(2,h.$7j),Fe(3,E.$Hi),Fe(4,l.$6l),Fe(5,f.$7k),Fe(6,g.$nk),Fe(7,s.$7i)],H);let L=class extends Y{constructor(z,U,J,x,M,G,te){super(void 0,z,U,J,x,M,G,te)}};e.$gq=L,e.$gq=L=Ue([Fe(0,w.$Vp),Fe(1,h.$7j),Fe(2,E.$Hi),Fe(3,l.$6l),Fe(4,f.$7k),Fe(5,g.$nk),Fe(6,s.$7i)],L)}),define(Ee[292],Se([1,0,6,2,34,59]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=e.$sQ=void 0;class A{constructor(s,E){this.a=s,this.b=E}listen(s,E){const y=this.b(s);switch(E){case"onDidChangeProfiles":return n.Event.map(this.a.onDidChangeProfiles,p=>({all:p.all.map(b=>(0,D.$Fn)({...b},y)),added:p.added.map(b=>(0,D.$Fn)({...b},y)),removed:p.removed.map(b=>(0,D.$Fn)({...b},y)),updated:p.updated.map(b=>(0,D.$Fn)({...b},y))}))}throw new Error(`Invalid listen ${E}`)}async call(s,E,y){const p=this.b(s);switch(E){case"createProfile":{const b=await this.a.createProfile(y[0],y[1],y[2]);return(0,D.$Fn)({...b},p)}case"updateProfile":{let b=(0,S.$Hl)((0,D.$Gn)(y[0],p),this.a.profilesHome.scheme);return b=await this.a.updateProfile(b,y[1]),(0,D.$Fn)({...b},p)}case"removeProfile":{const b=(0,S.$Hl)((0,D.$Gn)(y[0],p),this.a.profilesHome.scheme);return this.a.removeProfile(b)}}throw new Error(`Invalid call ${E}`)}}e.$sQ=A;class R extends r.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(s,E,y){super(),this.profilesHome=E,this.f=y,this.a=[],this.b=this.B(new n.$he),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=s.map(p=>(0,S.$Hl)(p,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(p=>{const b=p.added.map(h=>(0,S.$Hl)(h,this.profilesHome.scheme)),a=p.removed.map(h=>(0,S.$Hl)(h,this.profilesHome.scheme)),f=p.updated.map(h=>(0,S.$Hl)(h,this.profilesHome.scheme));this.a=p.all.map(h=>(0,S.$Hl)(h,this.profilesHome.scheme)),this.b.fire({added:b,removed:a,updated:f,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(s){this.c=s}isEnabled(){return this.c}async createNamedProfile(s,E,y){const p=await this.f.call("createNamedProfile",[s,E,y]);return(0,S.$Hl)(p,this.profilesHome.scheme)}async createProfile(s,E,y,p){const b=await this.f.call("createProfile",[s,E,y,p]);return(0,S.$Hl)(b,this.profilesHome.scheme)}async createTransientProfile(s){const E=await this.f.call("createTransientProfile",[s]);return(0,S.$Hl)(E,this.profilesHome.scheme)}async setProfileForWorkspace(s,E){await this.f.call("setProfileForWorkspace",[s,E])}removeProfile(s){return this.f.call("removeProfile",[s])}async updateProfile(s,E){const y=await this.f.call("updateProfile",[s,E]);return(0,S.$Hl)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$tQ=R}),define(Ee[141],Se([1,0,4,28,16,12,270,36,34,11,271]),function(fe,e,n,r,S,D,A,R,v,s,E){"use strict";var y,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.$jQ=e.$iQ=void 0;let b=class extends v.$Jl{static{y=this}static{this.a="profileAssociationsMigration"}constructor(g,w,m,$,l){super(m,$,w,l),this.U=g,this.W=m}O(){return this.U.getItem(y.b,[]).map(w=>({...w,location:(0,s.$ag)(w.location)?this.w.extUri.joinPath(this.profilesHome,w.location):n.URI.revive(w.location)}))}Q(){const g=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$iQ=b,e.$iQ=b=y=Ue([Fe(0,A.$dQ),Fe(1,R.$El),Fe(2,r.$Ii),Fe(3,S.$7k),Fe(4,D.$7j)],b);let a=p=class extends b{constructor(g,w,m,$,l){super(g,w,m,$,l),this.$=g}P(g){g.length?this.$.setItem(p.b,g.map(w=>({...w,location:this.w.extUri.basename(w.location)}))):this.$.removeItem(p.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(p.c,g):this.$.removeItem(p.c)}Q(){const g="workspaceAndProfileInfo",w=this.$.getItem(g,void 0);if(w){this.$.removeItem(g);const $=w.reduce((l,{workspace:t,profile:o})=>(l[n.URI.revive(t).toString()]=n.URI.revive(o).toString(),l),{});this.$.setItem(p.c,{workspaces:$})}const m=super.Q();return this.$.getItem(p.a,!1)||(this.R(m),this.$.setItem(p.a,!0)),m}};e.$jQ=a,e.$jQ=a=p=Ue([Fe(0,A.$eQ),Fe(1,R.$El),Fe(2,r.$Ii),Fe(3,S.$7k),Fe(4,D.$7j)],a);let f=class extends a{constructor(g,w,m,$){super(new E.$hQ(E.SaveStrategy.IMMEDIATE,w,$,m),g,w,m,$)}async init(){return await this.$.init(),super.init()}};e.$kQ=f,e.$kQ=f=Ue([Fe(0,R.$El),Fe(1,r.$Ii),Fe(2,S.$7k),Fe(3,D.$7j)],f)}),define(Ee[142],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=void 0,e.$nn=(0,n.$Ai)("extensionHostStatusService");class r{constructor(){this.a=new Map}setExitInfo(D,A){this.a.set(D,A)}getExitInfo(D){return this.a.get(D)||null}}e.$on=r}),define(Ee[293],Se([1,0,61,6,14]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=void 0;function D(R){let v=0,s=0,E=0;R>=1e3&&(E=Math.floor(R/1e3),R-=E*1e3),E>=60&&(s=Math.floor(E/60),E-=s*60),s>=60&&(v=Math.floor(s/60),s-=v*60);const y=v?`${v}h`:"",p=s?`${s}m`:"",b=E?`${E}s`:"",a=R?`${R}ms`:"";return`${y}${p}${b}${a}`}class A{constructor(v,s,E,y){this.i=v,this.j=s,this.a=new r.$he,this.onClose=this.a.event,this.b=n.ProtocolConstants.ReconnectionGraceTime,this.c=n.ProtocolConstants.ReconnectionShortGraceTime,this.d=E,this.protocol=y,this.e=!1,this.f=new S.$Nh(()=>{this.k(`The reconnection grace time of ${D(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new S.$Nh(()=>{this.k(`The reconnection short grace time of ${D(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${D(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(v){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${v}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${D(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const v=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),v.end(),this.a.fire(void 0)}acceptReconnection(v,s,E){this.d=v,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(s,E),this.protocol.endAcceptReconnection()}}e.$wn=A}),define(Ee[143],Se([1,0,31,13,9,175,63]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=void 0,e.$fm=E;const R=S.$jc(r.$Ug.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function s(p){return new Promise(b=>n.exists(p,b))}function E(p,b){return s(R).then(a=>{if(!a||!A.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const f=`${p}||${b}`;let h=v.get(f);return h||(h=D.getNLSConfiguration(A.default.commit,b,R,p,p).then(g=>(y.is(g)&&(g._languagePackSupport=!0),g)),v.set(f,h)),h})}var y;(function(p){function b(a){const f=a;return f&&typeof f._languagePackId=="string"}p.is=b})(y||(e.InternalNLSConfiguration=y={}))}),define(Ee[144],Se([1,0,20,4,28,53,64,16,5,12,29,36,34,143]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=void 0;let a=class extends A.$Cq{constructor(h,g,w,m,$,l,t,o){super(r.URI.file($.builtinExtensionsPath),r.URI.file($.extensionsPath),(0,n.$bh)($.userHome,".vscode-oss-dev","extensions","control.json"),h.defaultProfile,h,g,w,m,$,l,t,o),this.S=$}async f(h){const g=await(0,b.$fm)(h,this.S.userDataPath);if(b.InternalNLSConfiguration.is(g))try{const w=await this.w.readFile(r.URI.file(g._translationsConfigFile));return JSON.parse(w.value.toString())}catch{}return Object.create(null)}};e.$$P=a,e.$$P=a=Ue([Fe(0,p.$Gl),Fe(1,D.$xq),Fe(2,R.$7k),Fe(3,s.$7j),Fe(4,S.$Ii),Fe(5,E.$nk),Fe(6,y.$El),Fe(7,v.$zi)],a)}),define(Ee[101],Se([1,0,294,31,9,22,13,25]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=e.$xn=e.ServerConnectionTokenType=void 0,e.$An=b,e.$Bn=a,e.$Cn=f;const v=/^[0-9A-Za-z_-]+$/;var s;(function(h){h[h.None=0]="None",h[h.Optional=1]="Optional",h[h.Mandatory=2]="Mandatory"})(s||(e.ServerConnectionTokenType=s={}));class E{constructor(){this.type=s.None}validate(g){return!0}}e.$xn=E;class y{constructor(g){this.value=g,this.type=s.Mandatory}validate(g){return g===this.value}}e.$yn=y;class p{constructor(g){this.message=g}}e.$zn=p;async function b(h,g){const w=h["without-connection-token"],m=h["connection-token"],$=h["connection-token-file"];if(w)return typeof m<"u"||typeof $<"u"?new p("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new E;if(typeof $<"u"){if(typeof m<"u")return new p("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let l;try{l=r.readFileSync($).toString().replace(/\r?\n$/,"")}catch{return new p(`Unable to read the connection token file at '${$}'.`)}return v.test(l)?new y(l):new p(`The connection token defined in '${$} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof m<"u"?v.test(m)?new y(m):new p(`The connection token '${m} does not adhere to the characters 0-9, a-z, A-Z or -.`):new y(await g())}async function a(h){return b(h,async()=>{if(!h["user-data-dir"])return(0,D.$Wg)();const w=S.$jc(h["user-data-dir"],"token");try{const l=(await R.Promises.readFile(w)).toString().replace(/\r?\n$/,"");if(v.test(l))return l}catch{}const m=(0,D.$Wg)();try{await R.Promises.writeFile(w,m,{mode:384})}catch{}return m})}function f(h,g,w){if(h.validate(w.query[A.$Mg]))return!0;const m=n.parse(g.headers.cookie||"");return h.validate(m[A.$Lg])}}),define(Ee[54],Se([1,0,229,118,70,5,28,77]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=void 0,e.$en={host:{type:"string",cat:"o",args:"ip-address",description:n.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:n.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:n.localize(2,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:n.localize(3,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:n.localize(4,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:n.localize(5,null)},"without-connection-token":{type:"boolean",cat:"o",description:n.localize(6,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:n.localize(7,null)},"server-data-dir":{type:"string",cat:"o",description:n.localize(8,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:n.localize(9,null)},"user-data-dir":S.$xm["user-data-dir"],"enable-smoke-test-driver":S.$xm["enable-smoke-test-driver"],"disable-telemetry":S.$xm["disable-telemetry"],"disable-workspace-trust":S.$xm["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:S.$xm.log,logsPath:S.$xm.logsPath,"force-disable-user-env":S.$xm["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:n.localize(10,null)},"default-workspace":{type:"string",description:n.localize(11,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":S.$xm["extensions-dir"],"extensions-download-dir":S.$xm["extensions-download-dir"],"builtin-extensions-dir":S.$xm["builtin-extensions-dir"],"install-extension":S.$xm["install-extension"],"install-builtin-extension":S.$xm["install-builtin-extension"],"update-extensions":S.$xm["update-extensions"],"uninstall-extension":S.$xm["uninstall-extension"],"list-extensions":S.$xm["list-extensions"],"locate-extension":S.$xm["locate-extension"],"show-versions":S.$xm["show-versions"],category:S.$xm.category,force:S.$xm.force,"do-not-sync":S.$xm["do-not-sync"],"pre-release":S.$xm["pre-release"],"start-server":{type:"boolean",cat:"e",description:n.localize(12,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:S.$xm.help,version:S.$xm.version,"locate-shell-integration-path":S.$xm["locate-shell-integration-path"],compatibility:{type:"string"},_:S.$xm._},e.$fn=(0,D.$Bi)(A.$Hi);class v extends r.$bn{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$gn=v,Ue([R.$5h],v.prototype,"userRoamingDataHome",null)}),define(Ee[295],Se([1,0,31,25,82,93,294,96,37,68,3,12,54,9,13,22,29,101,47,19,4,15,11,35]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m,$,l,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=e.CacheControl=void 0,e.$xQ=i,e.$yQ=u;const d={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function i(C,T,O,P){T.writeHead(O,{"Content-Type":"text/plain"}),T.end(P)}var c;(function(C){C[C.NO_CACHING=0]="NO_CACHING",C[C.ETAG=1]="ETAG",C[C.NO_EXPIRY=2]="NO_EXPIRY"})(c||(e.CacheControl=c={}));async function u(C,T,O,P,V,Q){try{const ie=await r.Promises.stat(C);if(T===c.ETAG){const re=`W/"${[ie.ino,ie.size,ie.mtime.getTime()].join("-")}"`;if(P.headers["if-none-match"]===re)return V.writeHead(304),void V.end();Q.Etag=re}else T===c.NO_EXPIRY?Q["Cache-Control"]="public, max-age=31536000":T===c.NO_CACHING&&(Q["Cache-Control"]="no-store");Q["Content-Type"]=d[(0,b.$oc)(C)]||(0,s.$1s)(C)||"text/plain",V.writeHead(200,Q),(0,n.createReadStream)(C).pipe(V)}catch(ie){return ie.code!=="ENOENT"?(O.error(ie),console.error(ie.toString())):console.error(`File not found: ${C}`),V.writeHead(404,{"Content-Type":"text/plain"}),void V.end("Not found")}}const k=(0,b.$mc)(a.$Ug.asFileUri("").fsPath);let I=class{constructor(T,O,P,V,Q,ie,re){this.f=T,this.g=O,this.serverRootPath=P,this.h=V,this.i=Q,this.j=ie,this.k=re,this.a=this.k.extensionsGallery?.resourceUrlTemplate?$.URI.parse(this.k.extensionsGallery.resourceUrlTemplate):void 0,this.b=`${P}/static`,this.c=`${P}/callback`,this.d=`${P}/web-extension-resource`}async handle(T,O,P){try{const V=P.pathname;return V.startsWith(this.b)&&V.charCodeAt(this.b.length)===o.CharCode.Slash?this.l(T,O,P):V===this.g?this.o(T,O,P):V===this.c?this.q(O):V.startsWith(this.d)&&V.charCodeAt(this.d.length)===o.CharCode.Slash?this.n(T,O,P):i(T,O,404,"Not found.")}catch(V){return this.i.error(V),console.error(V.toString()),i(T,O,500,"Internal Server Error.")}}async l(T,O,P){const V=Object.create(null),ie=decodeURIComponent(P.pathname).substring(this.b.length+1),re=(0,b.$jc)(k,ie);return(0,v.$zg)(re,k,!E.$k)?u(re,this.h.isBuilt?c.NO_EXPIRY:c.ETAG,this.i,T,O,V):i(T,O,400,"Bad request.")}m(T){const O=T.authority.indexOf(".");return O!==-1?T.authority.substring(O+1):void 0}async n(T,O,P){if(!this.a)return i(T,O,500,"No extension gallery service configured.");const V=decodeURIComponent(P.pathname),Q=(0,b.$hc)(V.substring(this.d.length+1)),ie=$.URI.parse(Q).with({scheme:this.a.scheme,authority:Q.substring(0,Q.indexOf("/")),path:Q.substring(Q.indexOf("/")+1)});if(this.m(this.a)!==this.m(ie))return i(T,O,403,"Request Forbidden");const re={},ne=B=>{const oe=T.headers[B];oe&&((0,t.$ag)(oe)||oe[0])?re[B]=(0,t.$ag)(oe)?oe:oe[0]:B!==B.toLowerCase()&&ne(B.toLowerCase())};ne("X-Client-Name"),ne("X-Client-Version"),ne("X-Machine-Id"),ne("X-Client-Commit");const se=await this.j.request({type:"GET",url:ie.toString(!0),headers:re},m.CancellationToken.None),Z=se.res.statusCode||500;if(Z!==200){let B=null;try{B=await(0,w.$1p)(se)}catch{}return i(T,O,Z,B||`Request failed with status ${Z}`)}const ee=Object.create(null),ue=B=>{const oe=se.res.headers[B];oe?ee[B]=oe:B!==B.toLowerCase()&&ue(B.toLowerCase())};ue("Cache-Control"),ue("Content-Type"),O.writeHead(200,ee);const j=await(0,l.$Ve)(se.stream);return void O.end(j.buffer)}async o(T,O,P){const V=P.query[a.$Mg];if(typeof V=="string"){const H=Object.create(null);H["Set-Cookie"]=A.serialize(a.$Lg,V,{sameSite:"lax",maxAge:60*60*24*7});const L=Object.create(null);for(const z in P.query)z!==a.$Mg&&(L[z]=P.query[z]);const W=D.format({pathname:P.pathname,query:L});return H.Location=W,O.writeHead(302,H),void O.end()}const Q=H=>{const L=T.headers[H];return Array.isArray(L)?L[0]:L},ie=!this.h.isBuilt&&this.h.args["use-test-resolver"],re=ie?"test+test":Q("x-original-host")||Q("x-forwarded-host")||T.headers.host;if(!re)return i(T,O,400,"Bad request.");function ne(H){return JSON.stringify(H).replace(/"/g,"&quot;")}let se;this.h.args["enable-smoke-test-driver"]&&(se=!1);const Z=H=>H&&$.URI.file(S.resolve(H)).with({scheme:a.Schemas.vscodeRemote,authority:re}),ee=a.$Ug.asFileUri(this.h.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,ue=!this.h.isBuilt&&this.h.args["github-auth"]?{id:(0,f.$Wg)(),providerId:"github",accessToken:this.h.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,j={embedderIdentifier:"server-distro",extensionsGallery:this.a&&this.k.extensionsGallery?{...this.k.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:re,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.h.isBuilt)try{const H=JSON.parse((await r.Promises.readFile((0,b.$jc)(k,"product.overrides.json"))).toString());Object.assign(j,H)}catch{}const B={remoteAuthority:re,serverBasePath:this.g,_wrapWebWorkerExtHostInIframe:se,developmentOptions:{enableSmokeTestDriver:this.h.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.i.getLevel()},settingsSyncOptions:!this.h.isBuilt&&this.h.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.h.args["disable-workspace-trust"],folderUri:Z(this.h.args["default-folder"]),workspaceUri:Z(this.h.args["default-workspace"]),productConfiguration:j,callbackRoute:this.c},oe=this.k.extensionsGallery?.nlsBaseUrl,le={WORKBENCH_WEB_CONFIGURATION:ne(B),WORKBENCH_AUTH_SESSION:ue?ne(ue):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:oe?`${oe}${oe.endsWith("/")?"":"/"}${this.k.commit}/${this.k.version}/`:""};if(ie){const H=[];for(const L of["vscode-test-resolver","github-authentication"]){const W=JSON.parse((await r.Promises.readFile(a.$Ug.asFileUri(`${a.$Pg}/${L}/package.json`).fsPath)).toString());H.push({extensionPath:L,packageJSON:W})}le.WORKBENCH_BUILTIN_EXTENSIONS=ne(H)}let pe;try{pe=(await r.Promises.readFile(ee)).toString().replace(/\{\{([^}]+)\}\}/g,(L,W)=>le[W]??"undefined")}catch{return O.writeHead(404,{"Content-Type":"text/plain"}),void O.end("Not found")}const Y={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.p(pe).join(" ")} 'sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=' ${ie?"":`http://${re}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==g.ServerConnectionTokenType.None&&(Y["Set-Cookie"]=A.serialize(a.$Lg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),O.writeHead(200,Y),void O.end(pe)}p(T){const O=/<script>([\s\S]+?)<\/script>/img,P=[];let V;for(;V=O.exec(T);){const Q=R.createHash("sha256"),ie=V[1].replace(/\r\n/g,`
`),re=Q.update(Buffer.from(ie)).digest().toString("base64");P.push(`'sha256-${re}'`)}return P}async q(T){const O=a.$Ug.asFileUri("vs/code/browser/workbench/callback.html").fsPath,P=(await r.Promises.readFile(O)).toString(),V=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.p(P).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return T.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":V}),void T.end(P)}};e.$zQ=I,e.$zQ=I=Ue([Fe(3,p.$fn),Fe(4,y.$7j),Fe(5,w.$Vp),Fe(6,h.$nk)],I)}),define(Ee[296],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=void 0,e.$cP=(0,n.$Ai)("IExtHostInitDataService")}),define(Ee[297],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=e.$YO=void 0,e.$YO=(0,n.$Ai)("IExtHostRpcService");class r{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.dispose=D.dispose.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.$ZO=r}),define(Ee[74],Se([1,0,59]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=S;function r(D){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:D,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function S(D){return new n.$Dn(r(D))}}),define(Ee[298],Se([1,0,3,45,4,74,59,115,273,9,101,20]),function(fe,e,n,r,S,D,A,R,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class p{static{this.a=1}constructor(a,f,h,g){this.b=a,this.c=f,this.d=h,this.e=g}async call(a,f,h){switch(f){case"getEnvironmentData":{const g=h,w=(0,D.$Js)(g.remoteAuthority);let m=await this.f(g.profile);return m=(0,A.$Fn)(m,w),m}case"getExtensionHostExitInfo":{const g=h;return this.e.getExitInfo(g.reconnectionToken)}case"getDiagnosticInfo":{const g=h,w={machineInfo:(0,v.$Ns)()},m=g.includeProcesses?(0,R.$Ls)(process.pid):Promise.resolve();let $=[];const l={};if(g.folders){const t=(0,D.$Js)("");$=g.folders.map(d=>S.URI.revive(t.transformIncoming(d))).filter(d=>d.scheme==="file").map(d=>(0,v.$Ms)(d.fsPath,["node_modules",".git"]).then(i=>{l[(0,s.$nc)(d.fsPath)]=i}))}return Promise.all([m,...$]).then(([t,o])=>(w.processes=t||void 0,w.workspaceMetadata=g.folders?l:void 0,w))}}throw new Error(`IPC Command ${f} not found`)}listen(a,f,h){throw new Error("Not supported")}async f(a){a&&!this.d.profiles.some(h=>h.id===a)&&await this.d.createProfile(a,a);let f=!1;if(process.platform==="linux"){const h=process.glibcVersion;f=(h?parseInt(h.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==E.ServerConnectionTokenType.None?this.b.value:"",appRoot:S.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,y.$bh)(this.c.logsHome,`exthost${p.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:n.OS,arch:process.arch,marks:r.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(h=>({...h}))},isUnsupportedGlibc:f}}}e.$Qs=p}),define(Ee[299],Se([1,0,4,74,72,9,258]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class R extends A.$Rs{constructor(E,y){super(new S.$hr(E),E),this.N=y,this.M=new Map,this.B(this.a)}c(E){let y=this.M.get(E.remoteAuthority);return y||(y=(0,r.$Js)(E.remoteAuthority),this.M.set(E.remoteAuthority,y)),y}f(E,y,p=!1){if(p&&y.path==="/vscode-resource"&&y.query){const b=JSON.parse(y.query).requestResourcePath;return n.URI.from({scheme:"file",path:b})}return n.URI.revive(E.transformIncoming(y))}L(E,y){return new v(E,y,this.b,this.N)}}e.$Ts=R;class v extends A.$Ss{constructor(E,y,p,b){super(E,y,p,b)}j(E){const y=E.args["file-watcher-polling"];if(y){const p=y.split(D.$tc),b=Number(p[0]);if(b>0)return{usePolling:p.length>1?p.slice(1):!0,pollingInterval:b}}}m(E){if(E.extensionsPath)return[D.$gc.join(E.extensionsPath,"**")]}}}),define(Ee[102],Se([1,0,232,11,4,2,5,38,16,13,42,184,58]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$4F=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$TF=e.EditorInputCapabilities=e.$SF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=void 0,e.$JF=f,e.$KF=h,e.$LF=g,e.$MF=w,e.$NF=m,e.$OF=$,e.$PF=l,e.$QF=t,e.$RF=o,e.$UF=I,e.$VF=T,e.$WF=O,e.$XF=P,e.$YF=V,e.$ZF=Q,e.$1F=ie,e.$2F=re,e.$3F=j,e.$5F=le,e.$6F=q,e.$7F=ae,e.$8F=Y,e.$EF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$FF={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.$GF="workbench.editor.sidebysideEditor",e.$HF="workbench.editors.textDiffEditor",e.$IF="workbench.editors.binaryResourceDiffEditor";var b;(function(H){H[H.PROGRAMMATIC=1]="PROGRAMMATIC",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION",H[H.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var a;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(a||(e.EditorPaneSelectionCompareResult=a={}));function f(H){const L=H;return!!L&&typeof L.getSelection=="function"&&!!L.onDidChangeSelection}function h(H){const L=H;return!!L&&typeof L.getScrollPosition=="function"&&typeof L.setScrollPosition=="function"&&!!L.onDidChangeScroll}function g(H,L,W){for(const z of W.visibleEditorPanes)if(z.group.id===L&&H.matches(z.input))return z.getViewState()}function w(H){if(I(H))return!1;const L=H;return S.URI.isUri(L?.resource)}function m(H){if(I(H))return!1;const L=H;return L?.original!==void 0&&L.modified!==void 0}function $(H){if(I(H))return!1;const L=H;return!L||L.resources&&!Array.isArray(L.resources)?!1:!!L.resources||!!L.multiDiffSource}function l(H){if(I(H)||m(H))return!1;const L=H;return L?.primary!==void 0&&L.secondary!==void 0}function t(H){if(I(H))return!1;const L=H;return L?L.resource===void 0||L.resource.scheme===s.Schemas.untitled||L.forceUntitled===!0:!1}function o(H){if(I(H))return!1;const L=H;return S.URI.isUri(L?.base?.resource)&&S.URI.isUri(L?.input1?.resource)&&S.URI.isUri(L?.input2?.resource)&&S.URI.isUri(L?.result?.resource)}var d;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var i;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class c{constructor(){this.a=new Map}registerSource(L,W){let z=this.a.get(L);return z||(z={source:L,label:W},this.a.set(L,z)),z.source}getSourceLabel(L){return this.a.get(L)?.label??L}}e.$SF=new c;var u;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription",H[H.CanDropIntoEditor=128]="CanDropIntoEditor",H[H.MultipleEditors=256]="MultipleEditors",H[H.Scratchpad=512]="Scratchpad"})(u||(e.EditorInputCapabilities=u={}));class k extends D.$Uc{}e.$TF=k;function I(H){return H instanceof k}function C(H){const L=H;return S.URI.isUri(L?.preferredResource)}function T(H){const L=H;return I(L?.primary)&&I(L?.secondary)}function O(H){const L=H;return I(L?.modified)&&I(L?.original)}function P(H,L,W,z,U){return Y(z,[(0,y.$kj)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const J={...W,limits:{size:Number.MAX_VALUE}};H.openEditor(L,J)}}),(0,y.$kj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>U.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}function V(H){return I(H?.editor)}function Q(H){const L=H;return V(H)&&L?.group!==void 0}function ie(H){const L=H;return typeof L?.groupId=="number"&&I(L.editor)}function re(H){return typeof H?.groupId=="number"}var ne;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(ne||(e.EditorCloseContext=ne={}));var se;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LABEL=2]="GROUP_LABEL",H[H.GROUP_LOCKED=3]="GROUP_LOCKED",H[H.EDITORS_SELECTION=4]="EDITORS_SELECTION",H[H.EDITOR_OPEN=5]="EDITOR_OPEN",H[H.EDITOR_CLOSE=6]="EDITOR_CLOSE",H[H.EDITOR_MOVE=7]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=9]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=11]="EDITOR_PIN",H[H.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",H[H.EDITOR_STICKY=13]="EDITOR_STICKY",H[H.EDITOR_DIRTY=14]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(se||(e.GroupModelChangeKind=se={}));var Z;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})(Z||(e.SideBySideEditor=Z={}));class ee{getOriginalUri(L,W){if(!L)return;if(o(L))return e.$4F.getOriginalUri(L.result,W);if(W?.supportSideBySide){const{primary:U,secondary:J}=this.a(L);if(U&&J){if(W?.supportSideBySide===Z.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(J,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===Z.ANY)return this.getOriginalUri(U,{filterByScheme:W.filterByScheme})??this.getOriginalUri(J,{filterByScheme:W.filterByScheme});L=W.supportSideBySide===Z.PRIMARY?U:J}}if(m(L)||$(L)||l(L)||o(L))return;const z=C(L)?L.preferredResource:L.resource;return!z||!W||!W.filterByScheme?z:this.b(z,W.filterByScheme)}a(L){return T(L)||l(L)?{primary:L.primary,secondary:L.secondary}:O(L)||m(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,W){if(!L)return;if(o(L))return e.$4F.getCanonicalUri(L.result,W);if(W?.supportSideBySide){const{primary:U,secondary:J}=this.a(L);if(U&&J){if(W?.supportSideBySide===Z.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(J,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===Z.ANY)return this.getCanonicalUri(U,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(J,{filterByScheme:W.filterByScheme});L=W.supportSideBySide===Z.PRIMARY?U:J}}if(m(L)||$(L)||l(L)||o(L))return;const z=L.resource;return!z||!W||!W.filterByScheme?z:this.b(z,W.filterByScheme)}b(L,W){if(Array.isArray(W)){if(W.some(z=>L.scheme===z))return L}else if(W===L.scheme)return L}}var ue;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.KEYBOARD=1]="KEYBOARD",H[H.MOUSE=2]="MOUSE"})(ue||(e.EditorCloseMethod=ue={}));function j(H,L,W,z){if(!H.isSticky(L))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return W===ue.MOUSE||W===ue.KEYBOARD;case"mouse":return W===ue.MOUSE;case"keyboard":return W===ue.KEYBOARD}return!1}e.$4F=new ee;var B;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(B||(e.CloseDirection=B={}));class oe{constructor(){this.c=new Map,this.d=new Map}start(L){const W=this.a=L.get(A.$zi);for(const[z,U]of this.c)this.e(z,U,W);this.c.clear()}e(L,W,z){const U=z.createInstance(W);this.d.set(L,U)}registerFileEditorFactory(L){if(this.b)throw new Error("Can only register one file editor factory.");this.b=L}getFileEditorFactory(){return(0,r.$lg)(this.b)}registerEditorSerializer(L,W){if(this.c.has(L)||this.d.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.a?this.e(L,W,this.a):this.c.set(L,W),(0,D.$Sc)(()=>{this.c.delete(L),this.d.delete(L)})}getEditorSerializer(L){return this.d.get(typeof L=="string"?L:L.typeId)}}R.$jo.add(e.$EF.EditorFactory,new oe);async function le(H,L,W){return!H||!H.length?[]:await Promise.all(H.map(async z=>{const U=S.URI.revive(z.fileUri);if(!U){W.info("Cannot resolve the path because it is not valid.",z);return}if(!await L.canHandleResource(U)){W.info("Cannot resolve the path because it cannot be handled",z);return}let x=z.exists,M=z.type;if(typeof x!="boolean"||typeof M!="number")try{M=(await L.stat(U)).isDirectory?v.FileType.Directory:v.FileType.Unknown,x=!0}catch(te){W.error(te),x=!1}if(!x&&z.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",z);return}if(M===v.FileType.Directory){W.info("Cannot resolve the path because it is a directory",z);return}const G={...z.options,pinned:!0};return x?{resource:U,options:G}:{resource:U,options:G,forceUntitled:!0}}))}var pe;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(pe||(e.EditorsOrder=pe={}));function q(H){const L=H;if(!L)return!1;const W=L;if(W.modified)return q(W.modified);const z=L;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}function ae(H){return(0,E.$mj)(H)}function Y(H,L,W){const z=(0,E.$nj)(H,L);return z.forceMessage=W?.forceMessage,z.forceSeverity=W?.forceSeverity,z.allowDialog=W?.allowDialog,z}}),define(Ee[300],Se([1,0,233,43]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=void 0,e.$hG=new r.$Rj("chatSessionResponseVote","",{type:"string",description:(0,n.localize)(0,null)}),e.$iG=new r.$Rj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,n.localize)(1,null)}),e.$jG=new r.$Rj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,n.localize)(2,null)}),e.$kG=new r.$Rj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,n.localize)(3,null)}),e.$lG=new r.$Rj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,n.localize)(4,null)}),e.$mG=new r.$Rj("chatResponse",!1,{type:"boolean",description:(0,n.localize)(5,null)}),e.$nG=new r.$Rj("chatRequest",!1,{type:"boolean",description:(0,n.localize)(6,null)}),e.$oG=new r.$Rj("chatEditApplied",!1,{type:"boolean",description:(0,n.localize)(7,null)}),e.$pG=new r.$Rj("chatInputHasText",!1,{type:"boolean",description:(0,n.localize)(8,null)}),e.$qG=new r.$Rj("chatInputHasFocus",!1,{type:"boolean",description:(0,n.localize)(9,null)}),e.$rG=new r.$Rj("inChatInput",!1,{type:"boolean",description:(0,n.localize)(10,null)}),e.$sG=new r.$Rj("inChat",!1,{type:"boolean",description:(0,n.localize)(11,null)}),e.$tG=new r.$Rj("chatIsEnabled",!1,{type:"boolean",description:(0,n.localize)(12,null)}),e.$uG=new r.$Rj("chatCursorAtTop",!1),e.$vG=new r.$Rj("chatInputHasAgent",!1),e.$wG=new r.$Rj("chatLocation",void 0),e.$xG=new r.$Rj("quickChatHasFocus",!1,{type:"boolean",description:(0,n.localize)(13,null)})}),define(Ee[301],Se([1,0,105,14,19,6,40,2,49,165,17,43,23,5,12,29,47,100,300]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.ChatAgentLocation=void 0,e.$CH=d,e.$DH=i;var $;(function(c){c.Panel="panel",c.Terminal="terminal",c.Notebook="notebook",c.Editor="editor"})($||(e.ChatAgentLocation=$={})),function(c){function u(k){switch(k){case"panel":return c.Panel;case"terminal":return c.Terminal;case"notebook":return c.Notebook;case"editor":return c.Editor}return c.Panel}c.fromRaw=u}($||(e.ChatAgentLocation=$={})),e.$xH=(0,b.$Ai)("chatAgentService");let l=class{static{this.AGENT_LEADER="@"}constructor(u){this.f=u,this.b=new Map,this.d=new D.$he,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=w.$tG.bindTo(this.f)}registerAgent(u,k){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const C=this,T=k.slashCommands;k={...k,get slashCommands(){return T.filter(P=>!P.when||C.f.contextMatchesRules(y.$yj.deserialize(P.when)))}};const O={data:k};return this.b.set(u,O),(0,R.$Sc)(()=>{this.b.delete(u),this.d.fire(void 0)})}registerAgentImplementation(u,k){const I=this.b.get(u);if(!I)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(I.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return I.data.isDefault&&this.e.set(!0),I.impl=k,this.d.fire(new t(I.data,k)),(0,R.$Sc)(()=>{I.impl=void 0,this.d.fire(void 0),I.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(u,k){u.isDynamic=!0;const I={data:u,impl:k};return this.b.set(u.id,I),this.d.fire(new t(u,k)),(0,R.$Sc)(()=>{this.b.delete(u.id),this.d.fire(void 0)})}registerAgentCompletionProvider(u,k){return this.g.set(u,k),{dispose:()=>{this.g.delete(u)}}}async getAgentCompletionItems(u,k,I){return await this.g.get(u)?.(k,I)??[]}updateAgent(u,k){const I=this.b.get(u);if(!I?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);I.data.metadata={...I.data.metadata,...k},this.d.fire(new t(I.data,I.impl))}getDefaultAgent(u){return(0,n.$fb)(this.getActivatedAgents(),k=>!!k.isDefault&&k.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes(u))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),u=>!!u.data.metadata.isSecondary)?.data}getAgent(u){if(this.h(u))return this.b.get(u)?.data}h(u){const k=this.b.get(u);return!k?.data.when||this.f.contextMatchesRules(y.$yj.deserialize(k.data.when))}getAgentByFullyQualifiedId(u){const k=A.Iterable.find(this.b.values(),I=>d(I.data)===u)?.data;if(!(k&&!this.h(k.id)))return k}getAgents(){return Array.from(this.b.values()).map(u=>u.data).filter(u=>this.h(u.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(u=>!!u.impl).filter(u=>this.h(u.data.id)).map(u=>new t(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(k=>k.name===u)}async invokeAgent(u,k,I,C,T){const O=this.b.get(u);if(!O?.impl)throw new Error(`No activated agent with id "${u}"`);return await O.impl.invoke(k,I,C,T)}async getFollowups(u,k,I,C,T){const O=this.b.get(u);if(!O?.impl)throw new Error(`No activated agent with id "${u}"`);return O.impl?.provideFollowups?O.impl.provideFollowups(k,I,C,T):[]}};e.$yH=l,e.$yH=l=Ue([Fe(0,y.$Sj)],l);class t{constructor(u,k){this.b=u,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(u,k,I,C){return this.d.invoke(u,k,I,C)}async provideFollowups(u,k,I,C){return this.d.provideFollowups?this.d.provideFollowups(u,k,I,C):[]}provideWelcomeMessage(u,k){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(u,k)}provideSampleQuestions(u,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(u,k)}}e.$zH=t,e.$AH=(0,b.$Ai)("chatAgentNameService");let o=class{static{m=this}static{this.b="chat.participantNameRegistry"}constructor(u,k,I,C){if(this.g=k,this.h=I,this.i=C,this.e=(0,s.$3d)(this,Object.create(null)),this.f=!1,!u.chatParticipantRegistry)return;this.d=u.chatParticipantRegistry;const T=C.get(m.b,g.StorageScope.APPLICATION);try{this.e.set(JSON.parse(T??"{}"),void 0)}catch{C.remove(m.b,g.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(u=>this.h.warn("Failed to fetch chat participant registry",u)).then(()=>(0,r.$Bh)(5*60*1e3)).then(()=>this.j())}async k(){const u=await this.g.request({type:"GET",url:this.d},S.CancellationToken.None);if(u.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,h.$2p)(u);if(!k||k.version!==1)throw new Error("Unexpected chat participant registry response.");const I=k.restrictedChatParticipants;this.e.set(I,void 0),this.i.store(m.b,JSON.stringify(I),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE)}getAgentNameRestriction(u){const k=this.l(u.name,u).get(),I=!u.fullName||this.l(u.fullName.replace(/\s/g,""),u).get();return k&&I}l(u,k){return this.e.map(C=>C[u.toLowerCase()]).map(C=>C?C.some(T=>(0,E.$Bf)(T,T.includes(".")?k.extensionId.value:k.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$BH=o,e.$BH=o=m=Ue([Fe(0,f.$nk),Fe(1,h.$Vp),Fe(2,a.$7j),Fe(3,g.$9p)],o);function d(c){return`${c.extensionId.value}.${c.id}`}function i(c){const u="name"in c?c:{...c,name:c.id};return"extensionPublisherId"in u||(u.extensionPublisherId=u.extensionPublisher??""),"extensionDisplayName"in u||(u.extensionDisplayName=""),"extensionId"in u||(u.extensionId=new p.$Wm("")),(0,v.$0h)(u)}}),define(Ee[302],Se([1,0,4,235,43,5]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$TJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$RJ=e.MemoryRangeType=e.State=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=void 0,e.$QJ=v,e.$SJ=E,e.$EI="workbench.view.debug",e.$FI="workbench.debug.variablesView",e.$GI="workbench.debug.watchExpressionsView",e.$HI="workbench.debug.callStackView",e.$II="workbench.debug.loadedScriptsView",e.$JI="workbench.debug.breakPointsView",e.$KI="workbench.debug.disassemblyView",e.$LI="workbench.panel.repl",e.$MI="workbench.panel.repl.view",e.$NI=new S.$Rj("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.$OI=new S.$Rj("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.$PI=new S.$Rj("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.$QI="debugUx",e.$RI=new S.$Rj(e.$QI,"default",{type:"string",description:r.localize(3,null)}),e.$SI=new S.$Rj("hasDebugged",!1,{type:"boolean",description:r.localize(4,null)}),e.$TI=new S.$Rj("inDebugMode",!1,{type:"boolean",description:r.localize(5,null)}),e.$UI=new S.$Rj("inDebugRepl",!1,{type:"boolean",description:r.localize(6,null)}),e.$VI=new S.$Rj("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(7,null)}),e.$WI=new S.$Rj("inBreakpointWidget",!1,{type:"boolean",description:r.localize(8,null)}),e.$XI=new S.$Rj("breakpointsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.$YI=new S.$Rj("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(10,null)}),e.$ZI=new S.$Rj("watchExpressionsExist",!1,{type:"boolean",description:r.localize(11,null)}),e.$1I=new S.$Rj("variablesFocused",!0,{type:"boolean",description:r.localize(12,null)}),e.$2I=new S.$Rj("expressionSelected",!1,{type:"boolean",description:r.localize(13,null)}),e.$3I=new S.$Rj("breakpointInputFocused",!1,{type:"boolean",description:r.localize(14,null)}),e.$4I=new S.$Rj("callStackItemType",void 0,{type:"string",description:r.localize(15,null)}),e.$5I=new S.$Rj("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(16,null)}),e.$6I=new S.$Rj("callStackItemStopped",!1,{type:"boolean",description:r.localize(17,null)}),e.$7I=new S.$Rj("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(18,null)}),e.$8I=new S.$Rj("watchItemType",void 0,{type:"string",description:r.localize(19,null)}),e.$9I=new S.$Rj("canViewMemory",void 0,{type:"boolean",description:r.localize(20,null)}),e.$0I=new S.$Rj("breakpointItemType",void 0,{type:"string",description:r.localize(21,null)}),e.$$I=new S.$Rj("breakpointItemBytes",void 0,{type:"boolean",description:r.localize(22,null)}),e.$_I=new S.$Rj("breakpointHasModes",!1,{type:"boolean",description:r.localize(23,null)}),e.$aJ=new S.$Rj("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(24,null)}),e.$bJ=new S.$Rj("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(25,null)}),e.$cJ=new S.$Rj("loadedScriptsItemType",void 0,{type:"string",description:r.localize(26,null)}),e.$dJ=new S.$Rj("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(27,null)}),e.$eJ=new S.$Rj("focusedSessionIsNoDebug",!1,{type:"boolean",description:r.localize(28,null)}),e.$fJ=new S.$Rj("stepBackSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.$gJ=new S.$Rj("restartFrameSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.$hJ=new S.$Rj("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(31,null)}),e.$iJ=new S.$Rj("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(32,null)}),e.$jJ=new S.$Rj("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(33,null)}),e.$kJ=new S.$Rj("breakpointsExist",!1,{type:"boolean",description:r.localize(34,null)}),e.$lJ=new S.$Rj("debuggersAvailable",!1,{type:"boolean",description:r.localize(35,null)}),e.$mJ=new S.$Rj("debugExtensionAvailable",!0,{type:"boolean",description:r.localize(36,null)}),e.$nJ=new S.$Rj("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(37,null)}),e.$oJ=new S.$Rj("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.$pJ=new S.$Rj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.$qJ=new S.$Rj("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.$rJ=new S.$Rj("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.$sJ=new S.$Rj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(42,null)}),e.$tJ=new S.$Rj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(43,null)}),e.$uJ=new S.$Rj("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(44,null)}),e.$vJ=new S.$Rj("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(45,null)}),e.$wJ=new S.$Rj("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(46,null)}),e.$xJ=new S.$Rj("variableIsReadonly",!1,{type:"boolean",description:r.localize(47,null)}),e.$yJ=new S.$Rj("variableValue",!1,{type:"string",description:r.localize(48,null)}),e.$zJ=new S.$Rj("variableType",!1,{type:"string",description:r.localize(49,null)}),e.$AJ=new S.$Rj("variableInterfaces",!1,{type:"array",description:r.localize(50,null)}),e.$BJ=new S.$Rj("variableName",!1,{type:"string",description:r.localize(51,null)}),e.$CJ=new S.$Rj("variableLanguage",!1,{type:"string",description:r.localize(52,null)}),e.$DJ=new S.$Rj("variableExtensionId",!1,{type:"string",description:r.localize(53,null)}),e.$EJ=new S.$Rj("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(54,null)}),e.$FJ=new S.$Rj("multiSessionRepl",!1,{type:"boolean",description:r.localize(55,null)}),e.$GJ=new S.$Rj("multiSessionDebug",!1,{type:"boolean",description:r.localize(56,null)}),e.$HJ=new S.$Rj("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(57,null)}),e.$IJ=new S.$Rj("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(58,null)}),e.$JJ=new S.$Rj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(59,null)}),e.$KJ=new S.$Rj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(60,null)});const A=m=>r.localize(61,null,m);e.$LJ=A,e.$MJ="editor.contrib.debug",e.$NJ="editor.contrib.breakpoint",e.$OJ="debug",e.$PJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(62,null)};var R;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(R||(e.State=R={}));function v(m){switch(m){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var s;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$RJ="vscode-debug-memory";function E(m){return m.source.presentationHint==="deemphasize"||m.presentationHint==="deemphasize"||m.presentationHint==="subtle"}var y;(function(m){m[m.Variable=0]="Variable",m[m.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var p;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var b;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(b||(e.DebuggerString=b={})),e.$TJ=(0,D.$Ai)("debugService");var a;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE",m[m.TRIGGER_POINT=3]="TRIGGER_POINT"})(a||(e.BreakpointWidgetContext=a={}));var f;(function(m){m[m.Command=0]="Command",m[m.Tree=1]="Tree"})(f||(e.DebugVisualizationType=f={}));var h;(function(m){m[m.None=0]="None",m[m.Collapsed=1]="Collapsed",m[m.Expanded=2]="Expanded"})(h||(e.DebugTreeItemCollapsibleState=h={}));var g;(function(m){m.deserialize=$=>$,m.serialize=$=>$})(g||(e.IDebugVisualizationTreeItem=g={}));var w;(function(m){m.deserialize=$=>({id:$.id,name:$.name,iconPath:$.iconPath&&{light:n.URI.revive($.iconPath.light),dark:n.URI.revive($.iconPath.dark)},iconClass:$.iconClass,visualization:$.visualization}),m.serialize=$=>$})(w||(e.IDebugVisualization=w={}))}),define(Ee[303],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=void 0,e.$pP=(0,n.$Ai)("environmentVariableService")}),define(Ee[145],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelRequest=e.RemoteTerminalChannelEvent=e.$LP=void 0,e.$LP="remoteterminal";var n;(function(S){S.OnPtyHostExitEvent="$onPtyHostExitEvent",S.OnPtyHostStartEvent="$onPtyHostStartEvent",S.OnPtyHostUnresponsiveEvent="$onPtyHostUnresponsiveEvent",S.OnPtyHostResponsiveEvent="$onPtyHostResponsiveEvent",S.OnPtyHostRequestResolveVariablesEvent="$onPtyHostRequestResolveVariablesEvent",S.OnProcessDataEvent="$onProcessDataEvent",S.OnProcessReadyEvent="$onProcessReadyEvent",S.OnProcessExitEvent="$onProcessExitEvent",S.OnProcessReplayEvent="$onProcessReplayEvent",S.OnProcessOrphanQuestion="$onProcessOrphanQuestion",S.OnExecuteCommand="$onExecuteCommand",S.OnDidRequestDetach="$onDidRequestDetach",S.OnDidChangeProperty="$onDidChangeProperty"})(n||(e.RemoteTerminalChannelEvent=n={}));var r;(function(S){S.RestartPtyHost="$restartPtyHost",S.CreateProcess="$createProcess",S.AttachToProcess="$attachToProcess",S.DetachFromProcess="$detachFromProcess",S.ListProcesses="$listProcesses",S.GetLatency="$getLatency",S.GetPerformanceMarks="$getPerformanceMarks",S.OrphanQuestionReply="$orphanQuestionReply",S.AcceptPtyHostResolvedVariables="$acceptPtyHostResolvedVariables",S.Start="$start",S.Input="$input",S.AcknowledgeDataEvent="$acknowledgeDataEvent",S.Shutdown="$shutdown",S.Resize="$resize",S.ClearBuffer="$clearBuffer",S.GetInitialCwd="$getInitialCwd",S.GetCwd="$getCwd",S.ProcessBinary="$processBinary",S.SendCommandResult="$sendCommandResult",S.InstallAutoReply="$installAutoReply",S.UninstallAllAutoReplies="$uninstallAllAutoReplies",S.GetDefaultSystemShell="$getDefaultSystemShell",S.GetProfiles="$getProfiles",S.GetEnvironment="$getEnvironment",S.GetWslPath="$getWslPath",S.GetTerminalLayoutInfo="$getTerminalLayoutInfo",S.SetTerminalLayoutInfo="$setTerminalLayoutInfo",S.SerializeTerminalState="$serializeTerminalState",S.ReviveTerminalProcesses="$reviveTerminalProcesses",S.GetRevivedPtyNewId="$getRevivedPtyNewId",S.SetUnicodeVersion="$setUnicodeVersion",S.ReduceConnectionGraceTime="$reduceConnectionGraceTime",S.UpdateIcon="$updateIcon",S.UpdateTitle="$updateTitle",S.UpdateProperty="$updateProperty",S.RefreshProperty="$refreshProperty",S.RequestDetachInstance="$requestDetachInstance",S.AcceptDetachInstanceReply="$acceptDetachInstanceReply",S.AcceptDetachedInstance="$acceptDetachedInstance",S.FreePortKillProcess="$freePortKillProcess"})(r||(e.RemoteTerminalChannelRequest=r={}))}),define(Ee[304],Se([1,0,9,4,69,52,3,135,11]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=s,e.$UP=y,e.$VP=a,e.$WP=f,e.$XP=h,e.$YP=w,e.$ZP=m,e.$1P=$,e.$2P=l;function s(t,o){if(o)if(A.$i)for(const d in o){let i=d;for(const u in t)if(d.toLowerCase()===u.toLowerCase()){i=u;break}const c=o[d];c!==void 0&&E(t,i,c)}else Object.keys(o).forEach(d=>{const i=o[d];i!==void 0&&E(t,d,i)})}function E(t,o,d){typeof d=="string"?t[o]=d:delete t[o]}function y(t,o,d,i){t.TERM_PROGRAM="vscode",o&&(t.TERM_PROGRAM_VERSION=o),a(t,i)&&(t.LANG=f(d)),t.COLORTERM="truecolor"}function p(t,o){if(o)for(const d of Object.keys(o)){const i=o[d];i!=null&&(t[d]=i)}}async function b(t,o){return await Promise.all(Object.entries(o).map(async([d,i])=>{if(typeof i=="string")try{o[d]=await t(i)}catch{o[d]=i}})),o}function a(t,o){if(o==="on")return!0;if(o==="auto"){const d=t.LANG;return!d||d.search(/\.UTF\-8$/)===-1&&d.search(/\.utf8$/)===-1&&d.search(/\.euc.+/)===-1}return!1}function f(t){const o=t?t.split("-"):[],d=o.length;if(d===0)return"en_US.UTF-8";if(d===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};o[0]in i&&o.push(i[o[0]])}else o[1]=o[1].toUpperCase();return o.join("_")+".UTF-8"}async function h(t,o,d,i,c,u){if(t.cwd){const I=typeof t.cwd=="object"?t.cwd.fsPath:t.cwd,C=await g(I,d);return(0,R.$QP)(C||I)}let k;return!t.ignoreConfigurationCwd&&c&&(d&&(c=await g(c,d,u)),c&&(n.$ic(c)?k=c:i&&(k=n.$jc(i.fsPath,c)))),k||(k=i?i.fsPath:o||""),(0,R.$QP)(k)}async function g(t,o,d){if(o)try{return await o(t)}catch(i){d?.error("Could not resolve terminal cwd",i);return}return t}function w(t,o,d){if(d)return i=>d.resolveWithEnvironment(o,t,i)}async function m(t,o,d,i,c,u){const k={};if(t.strictEnv)p(k,t.env);else{p(k,u);const I={...o};d&&(I&&await b(d,I),t.env&&await b(d,t.env)),A.$j&&(k.VSCODE_NODE_OPTIONS&&(k.NODE_OPTIONS=k.VSCODE_NODE_OPTIONS,delete k.VSCODE_NODE_OPTIONS),k.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(k.NODE_REPL_EXTERNAL_MODULE=k.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete k.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,S.$rm)(k,"VSCODE_IPC_HOOK_CLI"),s(k,I),s(k,t.env),y(k,i,A.$w,c)}return k}async function $(t,o,d,i,c,u,k=A.$i){let I;if((0,v.$ag)(t)?I=t:(I=t.fsPath,k&&u!==A.OperatingSystem.Windows?I=I.replace(/\\/g,"/"):!k&&u===A.OperatingSystem.Windows&&(I=I.replace(/\//g,"\\"))),!o)return I;const C=I.includes(" "),T=I.includes("(")||I.includes(")"),O=n.$nc(o,".exe"),P=O==="pwsh"||d==="pwsh"||O==="powershell"||d==="powershell";if(P&&(C||I.includes("'")))return`& '${I.replace(/'/g,"''")}'`;if(T&&P)return`& '${I}'`;if(u===A.OperatingSystem.Windows){if(i!==void 0)return i===D.WindowsShellType.GitBash?(0,R.$OP)(I.replace(/\\/g,"/")):i===D.WindowsShellType.Wsl?c?.getWslPath(I,"win-to-unix")||I:C?`"${I}"`:I;const V=o.toLowerCase();return V.includes("wsl")||V.includes("bash.exe")&&!V.toLowerCase().includes("git")?c?.getWslPath(I,"win-to-unix")||I:C?`"${I}"`:I}return(0,R.$OP)(I)}function l(t,o,d){const i=typeof t=="string"?r.URI.parse(t):t;let c=i?o.getWorkspaceFolder(i)??void 0:void 0;if(!c){const u=d.getLastActiveWorkspaceRoot();c=u?o.getWorkspaceFolder(u)??void 0:void 0}return c}}),define(Ee[75],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(D){D.Delimiter="\0"})(n||(e.TestIdPathParts=n={}));var r;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(r||(e.TestPosition=r={}));class S{static fromExtHostTestItem(A,R,v=A.parent){if(A._isRoot)return new S([R]);const s=[A.id];for(let E=v;E&&E.id!==R;E=E.parent)s.push(E.id);return s.push(R),new S(s.reverse())}static isRoot(A){return!A.includes(n.Delimiter)}static root(A){const R=A.indexOf(n.Delimiter);return R===-1?A:A.slice(0,R)}static fromString(A){return new S(A.split(n.Delimiter))}static join(A,R){return new S([...A.path,R])}static joinToString(A,R){return A.toString()+n.Delimiter+R}static parentId(A){const R=A.lastIndexOf(n.Delimiter);return R===-1?void 0:A.slice(0,R)}static localId(A){const R=A.lastIndexOf(n.Delimiter);return R===-1?A:A.slice(R+n.Delimiter.length)}static isChild(A,R){return R.startsWith(A)&&R[A.length]===n.Delimiter}static compare(A,R){return A===R?r.IsSame:S.isChild(A,R)?r.IsChild:S.isChild(R,A)?r.IsParent:r.Disconnected}static getLengthOfCommonPrefix(A,R){if(A===0)return 0;let v=0;for(;v<A-1;){for(let s=1;s<A;s++){const E=R(s-1),y=R(s);if(E.path[v]!==y.path[v])return v}v++}return v}constructor(A,R=A.length){if(this.path=A,this.d=R,A.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new S(this.path,1)}get parentId(){return this.d>1?new S(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new S(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new S(this.path,A)}compare(A){if(typeof A=="string")return S.compare(this.toString(),A);for(let R=0;R<A.d&&R<this.d;R++)if(A.path[R]!==this.path[R])return r.Disconnected;return A.d>this.d?r.IsChild:A.d<this.d?r.IsParent:r.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=n.Delimiter,this.c+=this.path[A]}return this.c}}e.$gL=S}),define(Ee[103],Se([1,0,4,84,48,75]),function(fe,e,n,r,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$oL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$nL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$mL=e.$lL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$kL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$jL=e.$iL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$hL=e.TestResultState=void 0;var A;(function(ne){ne[ne.Unset=0]="Unset",ne[ne.Queued=1]="Queued",ne[ne.Running=2]="Running",ne[ne.Passed=3]="Passed",ne[ne.Failed=4]="Failed",ne[ne.Skipped=5]="Skipped",ne[ne.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$hL={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var R;(function(ne){ne[ne.Run=1]="Run",ne[ne.Debug=2]="Debug",ne[ne.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var v;(function(ne){ne[ne.Run=2]="Run",ne[ne.Debug=4]="Debug",ne[ne.Coverage=8]="Coverage",ne[ne.HasNonDefaultProfile=16]="HasNonDefaultProfile",ne[ne.HasConfigurable=32]="HasConfigurable",ne[ne.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.$iL=[v.Run,v.Debug,v.Coverage,v.HasNonDefaultProfile,v.HasConfigurable,v.SupportsContinuousRun];const s=ne=>"runId"in ne;e.$jL=s;var E;(function(ne){ne.serialize=se=>({range:se.range.toJSON(),uri:se.uri.toJSON()}),ne.deserialize=(se,Z)=>({range:S.$ct.lift(Z.range),uri:se.asCanonicalUri(n.URI.revive(Z.uri))})})(E||(e.IRichLocation=E={}));var y;(function(ne){ne[ne.Error=0]="Error",ne[ne.Output=1]="Output"})(y||(e.TestMessageType=y={}));var p;(function(ne){ne.serialize=se=>({message:se.message,type:y.Error,expected:se.expected,actual:se.actual,contextValue:se.contextValue,location:se.location&&E.serialize(se.location)}),ne.deserialize=(se,Z)=>({message:Z.message,type:y.Error,expected:Z.expected,actual:Z.actual,contextValue:Z.contextValue,location:Z.location&&E.deserialize(se,Z.location)})})(p||(e.ITestErrorMessage=p={}));const b=(ne,se)=>`${se?"s":"e"}${ne}`;e.$kL=b;var a;(function(ne){ne.serialize=se=>({message:se.message,type:y.Output,offset:se.offset,length:se.length,location:se.location&&E.serialize(se.location)}),ne.deserialize=(se,Z)=>({message:Z.message,type:y.Output,offset:Z.offset,length:Z.length,location:Z.location&&E.deserialize(se,Z.location)})})(a||(e.ITestOutputMessage=a={}));var f;(function(ne){ne.serialize=se=>se.type===y.Error?p.serialize(se):a.serialize(se),ne.deserialize=(se,Z)=>Z.type===y.Error?p.deserialize(se,Z):a.deserialize(se,Z)})(f||(e.ITestMessage=f={}));var h;(function(ne){ne.serializeWithoutMessages=se=>({state:se.state,duration:se.duration,messages:[]}),ne.serialize=se=>({state:se.state,duration:se.duration,messages:se.messages.map(f.serialize)}),ne.deserialize=(se,Z)=>({state:Z.state,duration:Z.duration,messages:Z.messages.map(ee=>f.deserialize(se,ee))})})(h||(e.ITestTaskState=h={}));const g="\0",w=(ne,se)=>ne+g+se;e.$lL=w;const m=ne=>{const se=ne.indexOf(g);return{ctrlId:ne.slice(0,se),tagId:ne.slice(se+1)}};e.$mL=m;var $;(function(ne){ne.serialize=se=>({extId:se.extId,label:se.label,tags:se.tags,busy:se.busy,children:void 0,uri:se.uri?.toJSON(),range:se.range?.toJSON()||null,description:se.description,error:se.error,sortText:se.sortText}),ne.deserialize=(se,Z)=>({extId:Z.extId,label:Z.label,tags:Z.tags,busy:Z.busy,children:void 0,uri:Z.uri?se.asCanonicalUri(n.URI.revive(Z.uri)):void 0,range:Z.range?S.$ct.lift(Z.range):null,description:Z.description,error:Z.error,sortText:Z.sortText})})($||(e.ITestItem=$={}));var l;(function(ne){ne[ne.NotExpandable=0]="NotExpandable",ne[ne.Expandable=1]="Expandable",ne[ne.BusyExpanding=2]="BusyExpanding",ne[ne.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(ne){ne.serialize=se=>({expand:se.expand,item:$.serialize(se.item)}),ne.deserialize=(se,Z)=>({controllerId:D.$gL.root(Z.item.extId),expand:Z.expand,item:$.deserialize(se,Z.item)})})(t||(e.InternalTestItem=t={}));var o;(function(ne){ne.serialize=se=>{let Z;return se.item&&(Z={},se.item.label!==void 0&&(Z.label=se.item.label),se.item.tags!==void 0&&(Z.tags=se.item.tags),se.item.busy!==void 0&&(Z.busy=se.item.busy),se.item.uri!==void 0&&(Z.uri=se.item.uri?.toJSON()),se.item.range!==void 0&&(Z.range=se.item.range?.toJSON()),se.item.description!==void 0&&(Z.description=se.item.description),se.item.error!==void 0&&(Z.error=se.item.error),se.item.sortText!==void 0&&(Z.sortText=se.item.sortText)),{extId:se.extId,expand:se.expand,item:Z}},ne.deserialize=se=>{let Z;return se.item&&(Z={},se.item.label!==void 0&&(Z.label=se.item.label),se.item.tags!==void 0&&(Z.tags=se.item.tags),se.item.busy!==void 0&&(Z.busy=se.item.busy),se.item.range!==void 0&&(Z.range=se.item.range?S.$ct.lift(se.item.range):null),se.item.description!==void 0&&(Z.description=se.item.description),se.item.error!==void 0&&(Z.error=se.item.error),se.item.sortText!==void 0&&(Z.sortText=se.item.sortText)),{extId:se.extId,expand:se.expand,item:Z}}})(o||(e.ITestItemUpdate=o={}));const d=(ne,se)=>{se.expand!==void 0&&(ne.expand=se.expand),se.item!==void 0&&(ne.item=ne.item?Object.assign(ne.item,se.item):se.item)};e.$nL=d;var i;(function(ne){ne.serializeWithoutMessages=se=>({...t.serialize(se),ownComputedState:se.ownComputedState,computedState:se.computedState,tasks:se.tasks.map(h.serializeWithoutMessages)}),ne.serialize=se=>({...t.serialize(se),ownComputedState:se.ownComputedState,computedState:se.computedState,tasks:se.tasks.map(h.serialize)}),ne.deserialize=(se,Z)=>({...t.deserialize(se,Z),ownComputedState:Z.ownComputedState,computedState:Z.computedState,tasks:Z.tasks.map(ee=>h.deserialize(se,ee)),retired:!0})})(i||(e.TestResultItem=i={}));var c;(function(ne){ne.empty=()=>({covered:0,total:0}),ne.sum=(se,Z)=>{se.covered+=Z.covered,se.total+=Z.total}})(c||(e.ICoverageCount=c={}));var u;(function(ne){ne.serialize=se=>({id:se.id,statement:se.statement,branch:se.branch,declaration:se.declaration,testId:se.testId?.toString(),uri:se.uri.toJSON()}),ne.deserialize=(se,Z)=>({id:Z.id,statement:Z.statement,branch:Z.branch,declaration:Z.declaration,testId:Z.testId?D.$gL.fromString(Z.testId):void 0,uri:se.asCanonicalUri(n.URI.revive(Z.uri))}),ne.empty=(se,Z)=>({id:se,uri:Z,testId:void 0,statement:c.empty()})})(u||(e.IFileCoverage=u={}));function k(ne){return{...ne,location:ne.location?.toJSON()}}function I(ne){return ne.location=ne.location?r.$bt.isIPosition(ne.location)?r.$bt.lift(ne.location):S.$ct.lift(ne.location):void 0,ne}e.$oL=3;var C;(function(ne){ne[ne.Declaration=0]="Declaration",ne[ne.Statement=1]="Statement",ne[ne.Branch=2]="Branch"})(C||(e.DetailType=C={}));var T;(function(ne){ne.serialize=se=>se.type===C.Declaration?P.serialize(se):V.serialize(se),ne.deserialize=se=>se.type===C.Declaration?P.deserialize(se):V.deserialize(se)})(T||(e.CoverageDetails=T={}));var O;(function(ne){ne.serialize=k,ne.deserialize=I})(O||(e.IBranchCoverage=O={}));var P;(function(ne){ne.serialize=k,ne.deserialize=I})(P||(e.IDeclarationCoverage=P={}));var V;(function(ne){ne.serialize=se=>({...k(se),branches:se.branches?.map(O.serialize)}),ne.deserialize=se=>({...I(se),branches:se.branches?.map(O.deserialize)})})(V||(e.IStatementCoverage=V={}));var Q;(function(ne){ne[ne.Add=0]="Add",ne[ne.Update=1]="Update",ne[ne.DocumentSynced=2]="DocumentSynced",ne[ne.Remove=3]="Remove",ne[ne.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",ne[ne.Retire=5]="Retire",ne[ne.AddTag=6]="AddTag",ne[ne.RemoveTag=7]="RemoveTag"})(Q||(e.TestDiffOpType=Q={}));var ie;(function(ne){ne.deserialize=(se,Z)=>Z.op===Q.Add?{op:Z.op,item:t.deserialize(se,Z.item)}:Z.op===Q.Update?{op:Z.op,item:o.deserialize(Z.item)}:Z.op===Q.DocumentSynced?{op:Z.op,uri:se.asCanonicalUri(n.URI.revive(Z.uri)),docv:Z.docv}:Z,ne.serialize=se=>se.op===Q.Add?{op:se.op,item:t.serialize(se.item)}:se.op===Q.Update?{op:se.op,item:o.serialize(se.item)}:se})(ie||(e.TestsDiffOp=ie={}));class re{constructor(se){this.k=se,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(se){const Z=this.w();for(const ee of se)switch(ee.op){case Q.Add:this.l(t.deserialize(this.k,ee.item),Z);break;case Q.Update:this.p(o.deserialize(ee.item),Z);break;case Q.Remove:this.q(ee.itemId,Z);break;case Q.Retire:this.v(ee.itemId);break;case Q.IncrementPendingExtHosts:this.updatePendingRoots(ee.amount);break;case Q.AddTag:this.c.set(ee.tag.id,ee.tag);break;case Q.RemoveTag:this.c.delete(ee.id);break}Z.complete?.()}l(se,Z){const ee=D.$gL.parentId(se.item.extId)?.toString();let ue;if(!ee)ue=this.x(se),this.g.add(ue),this.f.set(se.item.extId,ue);else if(this.f.has(ee)){const j=this.f.get(ee);j.children.add(se.item.extId),ue=this.x(se,j),this.f.set(se.item.extId,ue)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(se)}`);return}return Z.add?.(ue),se.expand===l.BusyExpanding&&this.h++,ue}p(se,Z){const ee=this.f.get(se.extId);if(ee)return se.expand!==void 0&&(ee.expand===l.BusyExpanding&&this.h--,se.expand===l.BusyExpanding&&this.h++),(0,e.$nL)(ee,se),Z.update?.(ee),ee}q(se,Z){const ee=this.f.get(se);if(!ee)return;const ue=D.$gL.parentId(ee.item.extId)?.toString();ue?this.f.get(ue).children.delete(ee.item.extId):this.g.delete(ee);const j=[[se]];for(;j.length;)for(const B of j.pop()){const oe=this.f.get(B);oe&&(j.push(oe.children),this.f.delete(B),Z.remove?.(oe,oe!==ee),oe.expand===l.BusyExpanding&&this.h--)}}v(se){}updatePendingRoots(se){this.j+=se}w(){return{}}}e.$pL=re}),define(Ee[146],Se([1,0,14,6,2,106,103,75]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.TestItemEventOp=void 0;var v;(function(w){w[w.Upsert=0]="Upsert",w[w.SetTags=1]="SetTags",w[w.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",w[w.RemoveChild=3]="RemoveChild",w[w.SetProp=4]="SetProp",w[w.Bulk=5]="Bulk",w[w.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const s=(w,m)=>w===m,y=Object.entries({range:(w,m)=>w===m?!0:!w||!m?!1:w.equalsRange(m),busy:s,label:s,description:s,error:s,sortText:s,tags:(w,m)=>!(w.length!==m.length||w.some($=>!m.includes($)))}),p=(w,m)=>{let $;for(const[l,t]of y)t(w[l],m[l])||($?$[l]=m[l]:$={[l]:m[l]});return $};class b extends S.$Uc{get root(){return this.s.root}constructor(m){super(),this.s=m,this.f=this.B(new n.$Mh(()=>this.flushDiff(),200)),this.g=this.B(new r.$he),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(m){this.h=m;for(const $ of this.tree.values())this.J($)}get resolveHandler(){return this.h}collectDiff(){const m=this.m;return this.m=[],m}pushDiff(m){switch(m.op){case A.TestDiffOpType.DocumentSynced:{for(const $ of this.m)if($.op===A.TestDiffOpType.DocumentSynced&&$.uri===m.uri){$.docv=m.docv;return}break}case A.TestDiffOpType.Update:{const $=this.m[this.m.length-1];if($){if($.op===A.TestDiffOpType.Update&&$.item.extId===m.item.extId){(0,A.$nL)($.item,m.item);return}if($.op===A.TestDiffOpType.Add&&$.item.item.extId===m.item.extId){(0,A.$nL)($.item,m.item);return}}break}}this.m.push(m),this.f.isScheduled()||this.f.schedule()}expand(m,$){const l=this.tree.get(m);if(l){if((l.expandLevels===void 0||$>l.expandLevels)&&(l.expandLevels=$),l.expand===A.TestItemExpandState.Expandable){const t=this.M(l);return t.isOpen()?this.L(l,$-1):t.wait().then(()=>this.L(l,$-1))}else if(l.expand===A.TestItemExpandState.Expanded)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,$-1)):this.L(l,$-1)}}dispose(){for(const m of this.tree.values())this.s.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(m,$){switch($.op){case v.RemoveChild:this.O(R.$gL.joinToString(m.fullId,$.id));break;case v.Upsert:this.z($.item,m);break;case v.Bulk:for(const l of $.ops)this.w(m,l);break;case v.SetTags:this.C($.new,$.old,m.fullId.toString());break;case v.UpdateCanResolveChildren:this.J(m);break;case v.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:m.fullId.toString(),item:$.update}});break;case v.DocumentSynced:this.y(m.actual.uri);break;default:(0,D.$ed)($)}}y(m){m&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:m,docv:this.s.getDocumentVersion(m)})}z(m,$){const l=R.$gL.fromExtHostTestItem(m,this.root.id,$?.actual),t=this.s.getApiFor(m);t.parent&&t.parent!==$?.actual&&this.s.getChildren(t.parent).delete(m.id);let o=this.tree.get(l.toString());if(!o){o={fullId:l,actual:m,expandLevels:$?.expandLevels?$.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},m.tags.forEach(this.D,this),this.tree.set(o.fullId.toString(),o),this.G(m,$),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:o.expand,item:this.s.toITestItem(m)}}),this.I(m,o,$);return}if(o.actual===m){this.H(m,o,$);return}if(o.actual.uri?.toString()!==m.uri?.toString())return this.O(l.toString()),this.z(m,$);const d=this.s.getChildren(o.actual),i=o.actual,c=p(this.s.toITestItem(i),this.s.toITestItem(m));this.s.getApiFor(i).listener=void 0,o.actual=m,o.resolveBarrier=void 0,o.expand=A.TestItemExpandState.NotExpandable,c&&(c.hasOwnProperty("tags")&&(this.C(m.tags,i.tags,l.toString()),delete c.tags),this.w(o,{op:v.SetProp,update:c})),this.I(m,o,$);for(const[k,I]of d)this.s.getChildren(m).get(I.id)||this.O(R.$gL.joinToString(l,I.id));const u=o.expandLevels;u!==void 0&&queueMicrotask(()=>{o.expand===A.TestItemExpandState.Expandable&&(o.expandLevels=void 0,this.expand(l.toString(),u))}),this.y(o.actual.uri)}C(m,$,l){const t=new Set($.map(o=>o.id));for(const o of m)t.delete(o.id)||this.D(o);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:l,item:{tags:m.map(o=>(0,A.$lL)(this.s.controllerId,o.id))}}}),t.forEach(this.F,this)}D(m){const $=this.j.get(m.id);$?$.refCount++:(this.j.set(m.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$lL)(this.s.controllerId,m.id)}}))}F(m){const $=this.j.get(m);$&&!--$.refCount&&(this.j.delete(m),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$lL)(this.s.controllerId,m)}))}G(m,$){this.s.getApiFor(m).parent=$&&$.actual!==this.root?$.actual:void 0}H(m,$,l){this.G(m,l);const t=this.s.getApiFor(m);t.parent=l?.actual,t.listener=o=>this.w($,o),this.J($)}I(m,$,l){this.H(m,$,l);for(const[t,o]of this.s.getChildren(m))this.z(o,$)}J(m){let $;this.h?m.resolveBarrier?$=m.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:$=m.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:$=A.TestItemExpandState.NotExpandable,$!==m.expand&&(m.expand=$,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:m.fullId.toString(),expand:$}}),$===A.TestItemExpandState.Expandable&&m.expandLevels!==void 0&&this.M(m))}L(m,$){if($<0)return;const l=[];for(const[t,o]of this.s.getChildren(m.actual)){const d=this.expand(R.$gL.joinToString(m.fullId,o.id),$);(0,n.$mh)(d)&&l.push(d)}if(l.length)return Promise.all(l).then(()=>{})}M(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this.h){const o=new n.$zh;return o.open(),o}m.expand=A.TestItemExpandState.BusyExpanding,this.N(m);const $=m.resolveBarrier=new n.$zh,l=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,o)};let t;try{t=this.h(m.actual===this.root?void 0:m.actual)}catch(o){l(o)}return(0,n.$mh)(t)?t.catch(l).then(()=>{$.open(),this.J(m)}):($.open(),this.J(m)),m.resolveBarrier}N(m){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:m.fullId.toString(),expand:m.expand}})}O(m){const $=this.tree.get(m);if(!$)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:m});const l=[$];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.F(o.id);this.tree.delete(t.fullId.toString());for(const[o,d]of this.s.getChildren(t.actual))l.push(this.tree.get(R.$gL.joinToString(t.fullId,d.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.g.fire(m)}}e.$OO=b;class a extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.$PO=a;class f extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$QO=f;class h extends Error{constructor(m,$,l){super(`TestItem with ID "${m}" is from controller "${$}" and cannot be added as a child of an item from controller "${l}".`)}}e.$RO=h;const g=(w,m,$)=>{let l=new Map;return{get size(){return l.size},forEach(t,o){for(const d of l.values())t.call(o,d,this)},[Symbol.iterator](){return l.entries()},replace(t){const o=new Map,d=new Set(l.keys()),i={op:v.Bulk,ops:[]};for(const c of t){if(!(c instanceof $))throw new f(c.id);const u=m(c).controllerId;if(u!==w.controllerId)throw new h(c.id,u,w.controllerId);if(o.has(c.id))throw new a(c.id);o.set(c.id,c),d.delete(c.id),i.ops.push({op:v.Upsert,item:c})}for(const c of d.keys())i.ops.push({op:v.RemoveChild,id:c});w.listener?.(i),l=o},add(t){if(!(t instanceof $))throw new f(t.id);l.set(t.id,t),w.listener?.({op:v.Upsert,item:t})},delete(t){l.delete(t)&&w.listener?.({op:v.RemoveChild,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$SO=g}),define(Ee[147],Se([1,0,146]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=void 0;const r=new WeakMap,S=(A,R)=>{const v={controllerId:R};return r.set(A,v),v};e.$TO=S;const D=A=>{const R=r.get(A);if(!R)throw new n.$QO(A?.id||"<unknown>");return R};e.$UO=D}),define(Ee[305],Se([1,0,46,27,5]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=void 0,e.$1E=".vscode",e.$2E="settings",e.$3E=`${e.$1E}/${e.$2E}.json`,e.$4E="vscode://schemas/settings/default",e.$5E="vscode://schemas/settings/user",e.$6E="vscode://schemas/settings/profile",e.$7E="vscode://schemas/settings/machine",e.$8E="vscode://schemas/settings/workspace",e.$9E="vscode://schemas/settings/folder",e.$0E="vscode://schemas/launch",e.$$E="vscode://schemas/tasks",e.$_E=[n.ConfigurationScope.APPLICATION],e.$aF=[n.ConfigurationScope.MACHINE,n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$bF=[n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE],e.$cF=[n.ConfigurationScope.APPLICATION,...e.$bF],e.$dF=[n.ConfigurationScope.MACHINE,n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$eF=[n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$fF=[n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$gF="tasks",e.$hF="launch",e.$iF=Object.create(null),e.$iF[e.$gF]=`${e.$1E}/${e.$gF}.json`,e.$iF[e.$hF]=`${e.$1E}/${e.$hF}.json`,e.$jF=Object.create(null),e.$jF[e.$gF]=`${e.$gF}.json`,e.$kF=(0,S.$Bi)(r.$7i),e.$lF=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$mF="workbench.settings.applyToAllProfiles"}),define(Ee[148],Se([1,0,5]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=e.VariableKind=e.$MP=void 0,e.$MP=(0,n.$Ai)("configurationResolverService");var r;(function(D){D.Unknown="unknown",D.Env="env",D.Config="config",D.Command="command",D.Input="input",D.ExtensionInstallFolder="extensionInstallFolder",D.WorkspaceFolder="workspaceFolder",D.Cwd="cwd",D.WorkspaceFolderBasename="workspaceFolderBasename",D.UserHome="userHome",D.LineNumber="lineNumber",D.SelectedText="selectedText",D.File="file",D.FileWorkspaceFolder="fileWorkspaceFolder",D.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",D.RelativeFile="relativeFile",D.RelativeFileDirname="relativeFileDirname",D.FileDirname="fileDirname",D.FileExtname="fileExtname",D.FileBasename="fileBasename",D.FileBasenameNoExtension="fileBasenameNoExtension",D.FileDirnameBasename="fileDirnameBasename",D.ExecPath="execPath",D.ExecInstallFolder="execInstallFolder",D.PathSeparator="pathSeparator",D.PathSeparatorAlias="/"})(r||(e.VariableKind=r={}));class S extends Error{constructor(A,R){super(R),this.variable=A}}e.$NP=S}),define(Ee[306],Se([1,0,9,33,11,21,3,193,236,148,17]),function(fe,e,n,r,S,D,A,R,v,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,a,f,h){this.h=new Map,this.a=b,this.b=a,this.g=f,h&&(this.c=h.then(g=>this.i(g)))}i(b){if(A.$i){const a=Object.create(null);return Object.keys(b).forEach(f=>{a[f.toLowerCase()]=b[f]}),a}return b}resolveWithEnvironment(b,a,f){return this.l({env:this.i(b),userHome:void 0},a?a.uri:void 0,f)}async resolveAsync(b,a){const f={env:await this.c,userHome:await this.g};return this.l(f,b?b.uri:void 0,a)}async j(b,a,f,h){const g=D.$9n(a);A.$i&&g.windows?Object.keys(g.windows).forEach(m=>g[m]=g.windows[m]):A.$j&&g.osx?Object.keys(g.osx).forEach(m=>g[m]=g.osx[m]):A.$k&&g.linux&&Object.keys(g.linux).forEach(m=>g[m]=g.linux[m]),delete g.windows,delete g.osx,delete g.linux;const w={env:await this.c,userHome:await this.g};return this.l(w,b?b.uri:void 0,g,f,h)}async resolveAnyAsync(b,a,f){return this.j(b,a,f)}async resolveAnyMap(b,a,f){const h=new Map;return{newConfig:await this.j(b,a,f,h),resolvedVariables:h}}resolveWithInteractionReplace(b,a,f,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,a,f,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,a){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,a)}async l(b,a,f,h,g){if(S.$ag(f))return this.m(b,a,f,h,g);if(Array.isArray(f))return Promise.all(f.map(w=>this.l(b,a,w,h,g)));if(S.$cg(f)){const w=Object.create(null),m=await Promise.all(Object.keys(f).map(async $=>[await this.m(b,a,$,h,g),await this.l(b,a,f[$],h,g)]));for(const[$,l]of m)w[$]=l;return w}return f}m(b,a,f,h,g){return(0,E.$tf)(f,y.VARIABLE_REGEXP,async(w,m)=>{if(m.includes(y.VARIABLE_LHS))return w;let $=await this.o(b,w,m,a,h);return g?.set(m,$),$!==w&&S.$ag($)&&$.match(y.VARIABLE_REGEXP)&&($=await this.m(b,a,$,h,g)),$})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,a,f,h,g){let w;const m=f.split(":");m.length>1&&(f=m[0],w=m[1]);const $=o=>{const d=this.a.getFilePath();if(d)return(0,R.$Nw)(d);throw new s.$NP(o,(0,v.localize)(0,null,a))},l=o=>{const d=$(o);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,R.$Nw)(i)}throw new s.$NP(o,(0,v.localize)(1,null,a,n.$nc(d)))},t=o=>{if(w){const d=this.a.getFolderUri(w);if(d)return d;throw new s.$NP(o,(0,v.localize)(2,null,a,w))}if(h)return h;throw this.a.getWorkspaceFolderCount()>1?new s.$NP(o,(0,v.localize)(3,null,a)):new s.$NP(o,(0,v.localize)(4,null,a))};switch(f){case"env":if(w){if(b.env){const o=b.env[A.$i?w.toLowerCase():w];if(S.$ag(o))return o}return""}throw new s.$NP(s.VariableKind.Env,(0,v.localize)(5,null,a));case"config":if(w){const o=this.a.getConfigurationValue(h,w);if(S.$jg(o))throw new s.$NP(s.VariableKind.Config,(0,v.localize)(6,null,a,w));if(S.$cg(o))throw new s.$NP(s.VariableKind.Config,(0,v.localize)(7,null,a,w));return o}throw new s.$NP(s.VariableKind.Config,(0,v.localize)(8,null,a));case"command":return this.p(s.VariableKind.Command,a,w,g,"command");case"input":return this.p(s.VariableKind.Input,a,w,g,"input");case"extensionInstallFolder":if(w){const o=await this.a.getExtension(w);if(!o)throw new s.$NP(s.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,a,w));return this.n(o.extensionLocation)}throw new s.$NP(s.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,a));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,R.$Nw)(this.n(t(s.VariableKind.WorkspaceFolder)));case"cwd":return h||w?(0,R.$Nw)(this.n(t(s.VariableKind.Cwd))):r.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.$Nw)(n.$nc(this.n(t(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new s.$NP(s.VariableKind.UserHome,(0,v.localize)(11,null,a))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new s.$NP(s.VariableKind.LineNumber,(0,v.localize)(12,null,a))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new s.$NP(s.VariableKind.SelectedText,(0,v.localize)(13,null,a))}case"file":return $(s.VariableKind.File);case"fileWorkspaceFolder":return l(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return n.$nc(l(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return h||w?n.$lc(this.n(t(s.VariableKind.RelativeFile)),$(s.VariableKind.RelativeFile)):$(s.VariableKind.RelativeFile);case"relativeFileDirname":{const o=n.$mc($(s.VariableKind.RelativeFileDirname));if(h||w){const d=n.$lc(this.n(t(s.VariableKind.RelativeFileDirname)),o);return d.length===0?".":d}return o}case"fileDirname":return n.$mc($(s.VariableKind.FileDirname));case"fileExtname":return n.$oc($(s.VariableKind.FileExtname));case"fileBasename":return n.$nc($(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=n.$nc($(s.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-n.$oc(o).length)}case"fileDirnameBasename":return n.$nc(n.$mc($(s.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||a}case"execInstallFolder":{const o=this.a.getAppRoot();return o||a}case"pathSeparator":case"/":return n.sep;default:try{const o=w?`${f}:${w}`:f;return this.p(s.VariableKind.Unknown,a,o,g,void 0)}catch{return a}}}}p(b,a,f,h,g){if(f&&h){const w=g===void 0?h[f]:h[g+":"+f];if(typeof w=="string")return w;throw new s.$NP(b,(0,v.localize)(14,null,a))}return a}}e.$3P=y}),define(Ee[307],Se([1,0,5,102]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$0D=void 0,e.$$D=s,e.$_D=p,e.$aE=b,e.$0D=(0,n.$Ai)("editorGroupsService");var S;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(S||(e.GroupDirection=S={}));var D;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(D||(e.GroupOrientation=D={}));var A;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var R;(function(a){a[a.MAXIMIZE=0]="MAXIMIZE",a[a.EXPAND=1]="EXPAND",a[a.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var v;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function s(a){const f=a;return(0,r.$UF)(f?.editor)&&(0,r.$UF)(f?.replacement)}var E;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(E||(e.GroupsOrder=E={}));var y;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function p(a){const f=a;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}function b(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?S.DOWN:S.RIGHT}}),define(Ee[149],Se([1,0,5,307]),function(fe,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eE=e.$dE=e.$cE=e.$bE=void 0,e.$fE=S,e.$bE=(0,n.$Ai)("editorService"),e.$cE=-1,e.$dE=-2,e.$eE=-3;function S(D){const A=D;return typeof D=="number"||(0,r.$_D)(A)}}),define(Ee[308],Se([1,0,305,90,98,97,148,102,149,13,256,303,52,145]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=e.$5P=void 0,e.$5P="remoteterminal";let a=class{get onPtyHostExit(){return this.b.listen(b.RemoteTerminalChannelEvent.OnPtyHostExitEvent)}get onPtyHostStart(){return this.b.listen(b.RemoteTerminalChannelEvent.OnPtyHostStartEvent)}get onPtyHostUnresponsive(){return this.b.listen(b.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent)}get onPtyHostResponsive(){return this.b.listen(b.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent)}get onPtyHostRequestResolveVariables(){return this.b.listen(b.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent)}get onProcessData(){return this.b.listen(b.RemoteTerminalChannelEvent.OnProcessDataEvent)}get onProcessExit(){return this.b.listen(b.RemoteTerminalChannelEvent.OnProcessExitEvent)}get onProcessReady(){return this.b.listen(b.RemoteTerminalChannelEvent.OnProcessReadyEvent)}get onProcessReplay(){return this.b.listen(b.RemoteTerminalChannelEvent.OnProcessReplayEvent)}get onProcessOrphanQuestion(){return this.b.listen(b.RemoteTerminalChannelEvent.OnProcessOrphanQuestion)}get onExecuteCommand(){return this.b.listen(b.RemoteTerminalChannelEvent.OnExecuteCommand)}get onDidRequestDetach(){return this.b.listen(b.RemoteTerminalChannelEvent.OnDidRequestDetach)}get onDidChangeProperty(){return this.b.listen(b.RemoteTerminalChannelEvent.OnDidChangeProperty)}constructor(h,g,w,m,$,l,t,o,d,i){this.a=h,this.b=g,this.c=w,this.d=m,this.e=$,this.f=l,this.g=t,this.h=o,this.i=d,this.j=i}restartPtyHost(){return this.b.call(b.RemoteTerminalChannelRequest.RestartPtyHost,[])}async createProcess(h,g,w,m,$,l,t,o){await this.c.whenRemoteConfigurationLoaded();const d=Object.create(null),i=w?this.d.getWorkspaceFolder(w)??void 0:void 0;let c;try{c=(await this.e.resolveAnyMap(i,{shellLaunchConfig:h,configuration:g})).resolvedVariables}catch(Q){this.h.error(Q)}if(c)for(const[Q,ie]of c.entries())(/^config:/.test(Q)||Q==="selectedText"||Q==="lineNumber")&&(d[Q]=ie);const u=[];for(const[Q,ie]of this.f.collections.entries())u.push([Q,(0,D.$ts)(ie.map),(0,D.$us)(ie.descriptionMap)]);const k=await this.g.resolveAuthority(this.a),I=k.options&&k.options.extensionHostEnv,C=this.d.getWorkspace(),T=C.folders,O=w?this.d.getWorkspaceFolder(w):null,P=R.$4F.getOriginalUri(this.i.activeEditor,{supportSideBySide:R.SideBySideEditor.PRIMARY,filterByScheme:[s.Schemas.file,s.Schemas.vscodeUserData,s.Schemas.vscodeRemote]}),V={configuration:g,resolvedVariables:d,envVariableCollections:u,shellLaunchConfig:h,workspaceId:C.id,workspaceName:this.j.getWorkspaceLabel(C),workspaceFolders:T,activeWorkspaceFolder:O,activeFileResource:P,shouldPersistTerminal:$,options:m,cols:l,rows:t,unicodeVersion:o,resolverEnv:I};return await this.b.call(b.RemoteTerminalChannelRequest.CreateProcess,V)}requestDetachInstance(h,g){return this.b.call(b.RemoteTerminalChannelRequest.RequestDetachInstance,[h,g])}acceptDetachInstanceReply(h,g){return this.b.call(b.RemoteTerminalChannelRequest.AcceptDetachInstanceReply,[h,g])}attachToProcess(h){return this.b.call(b.RemoteTerminalChannelRequest.AttachToProcess,[h])}detachFromProcess(h,g){return this.b.call(b.RemoteTerminalChannelRequest.DetachFromProcess,[h,g])}listProcesses(){return this.b.call(b.RemoteTerminalChannelRequest.ListProcesses)}getLatency(){return this.b.call(b.RemoteTerminalChannelRequest.GetLatency)}getPerformanceMarks(){return this.b.call(b.RemoteTerminalChannelRequest.GetPerformanceMarks)}reduceConnectionGraceTime(){return this.b.call(b.RemoteTerminalChannelRequest.ReduceConnectionGraceTime)}processBinary(h,g){return this.b.call(b.RemoteTerminalChannelRequest.ProcessBinary,[h,g])}start(h){return this.b.call(b.RemoteTerminalChannelRequest.Start,[h])}input(h,g){return this.b.call(b.RemoteTerminalChannelRequest.Input,[h,g])}acknowledgeDataEvent(h,g){return this.b.call(b.RemoteTerminalChannelRequest.AcknowledgeDataEvent,[h,g])}setUnicodeVersion(h,g){return this.b.call(b.RemoteTerminalChannelRequest.SetUnicodeVersion,[h,g])}shutdown(h,g){return this.b.call(b.RemoteTerminalChannelRequest.Shutdown,[h,g])}resize(h,g,w){return this.b.call(b.RemoteTerminalChannelRequest.Resize,[h,g,w])}clearBuffer(h){return this.b.call(b.RemoteTerminalChannelRequest.ClearBuffer,[h])}getInitialCwd(h){return this.b.call(b.RemoteTerminalChannelRequest.GetInitialCwd,[h])}getCwd(h){return this.b.call(b.RemoteTerminalChannelRequest.GetCwd,[h])}orphanQuestionReply(h){return this.b.call(b.RemoteTerminalChannelRequest.OrphanQuestionReply,[h])}sendCommandResult(h,g,w){return this.b.call(b.RemoteTerminalChannelRequest.SendCommandResult,[h,g,w])}freePortKillProcess(h){return this.b.call(b.RemoteTerminalChannelRequest.FreePortKillProcess,[h])}installAutoReply(h,g){return this.b.call(b.RemoteTerminalChannelRequest.InstallAutoReply,[h,g])}uninstallAllAutoReplies(){return this.b.call(b.RemoteTerminalChannelRequest.UninstallAllAutoReplies,[])}getDefaultSystemShell(h){return this.b.call(b.RemoteTerminalChannelRequest.GetDefaultSystemShell,[h])}getProfiles(h,g,w){return this.b.call(b.RemoteTerminalChannelRequest.GetProfiles,[this.d.getWorkspace().id,h,g,w])}acceptPtyHostResolvedVariables(h,g){return this.b.call(b.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables,[h,g])}getEnvironment(){return this.b.call(b.RemoteTerminalChannelRequest.GetEnvironment)}getWslPath(h,g){return this.b.call(b.RemoteTerminalChannelRequest.GetWslPath,[h,g])}setTerminalLayoutInfo(h){const w={workspaceId:this.d.getWorkspace().id,tabs:h?h.tabs:[]};return this.b.call(b.RemoteTerminalChannelRequest.SetTerminalLayoutInfo,w)}updateTitle(h,g,w){return this.b.call(b.RemoteTerminalChannelRequest.UpdateTitle,[h,g,w])}updateIcon(h,g,w,m){return this.b.call(b.RemoteTerminalChannelRequest.UpdateIcon,[h,g,w,m])}refreshProperty(h,g){return this.b.call(b.RemoteTerminalChannelRequest.RefreshProperty,[h,g])}updateProperty(h,g,w){return this.b.call(b.RemoteTerminalChannelRequest.UpdateProperty,[h,g,w])}getTerminalLayoutInfo(){const g={workspaceId:this.d.getWorkspace().id};return this.b.call(b.RemoteTerminalChannelRequest.GetTerminalLayoutInfo,g)}reviveTerminalProcesses(h,g,w){return this.b.call(b.RemoteTerminalChannelRequest.ReviveTerminalProcesses,[h,g,w])}getRevivedPtyNewId(h){return this.b.call(b.RemoteTerminalChannelRequest.GetRevivedPtyNewId,[h])}serializeTerminalState(h){return this.b.call(b.RemoteTerminalChannelRequest.SerializeTerminalState,[h])}};e.$6P=a,e.$6P=a=Ue([Fe(2,n.$kF),Fe(3,S.$Ji),Fe(4,A.$MP),Fe(5,y.$pP),Fe(6,r.$Ll),Fe(7,p.$gs),Fe(8,v.$bE),Fe(9,E.$fw)],a)}),define(Ee[309],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.ExtHostConnectionType=void 0,e.$sn=R,e.$tn=v;var n;(function(E){E[E.IPC=1]="IPC",E[E.Socket=2]="Socket",E[E.MessagePort=3]="MessagePort"})(n||(e.ExtHostConnectionType=n={}));class r{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(y){this.pipeName=y,this.type=n.IPC}serialize(y){y[r.ENV_KEY]=this.pipeName}}e.$pn=r;class S{constructor(){this.type=n.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(y){y[S.ENV_KEY]="1"}}e.$qn=S;class D{constructor(){this.type=n.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(y){y[D.ENV_KEY]="1"}}e.$rn=D;function A(E){delete E[r.ENV_KEY],delete E[S.ENV_KEY],delete E[D.ENV_KEY]}function R(E,y){A(y),E.serialize(y)}function v(E){if(E[r.ENV_KEY])return s(E,new r(E[r.ENV_KEY]));if(E[S.ENV_KEY])return s(E,new S);if(E[D.ENV_KEY])return s(E,new D);throw new Error("No connection information defined in environment!")}function s(E,y){return A(E),y}}),define(Ee[310],Se([1,0,15]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$5m=A,e.$6m=R;var r;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(r||(e.UIKind=r={}));var S;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(S||(e.ExtensionHostExitCode=S={}));var D;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(D||(e.MessageType=D={}));function A(s){const E=n.$Je.alloc(1);switch(s){case D.Initialized:E.writeUInt8(1,0);break;case D.Ready:E.writeUInt8(2,0);break;case D.Terminate:E.writeUInt8(3,0);break}return E}function R(s,E){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return E===D.Initialized;case 2:return E===D.Ready;case 3:return E===D.Terminate;default:return!1}}var v;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(Ee[311],Se([1,0,5,6,24,12,296,310,91,41,21,4,2,231]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$eP=e.$dP=void 0,e.$fP=h;let a=class extends p.$Uc{constructor(w,m){super(),this.s=w,this.t=m,this.a=this.B(new r.$he),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new r.$he),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=S.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=m.createLogger(this.m,{id:s.$sp,name:(0,b.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(m.onDidChangeLogLevel($=>{(0,D.$9j)($)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===S.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=S.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=S.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=S.TelemetryLevel.USAGE:!1}}instantiateLogger(w,m,$){const l=this.getTelemetryDetails(),t=new f(m,$,w,this.n,this.j,this.getBuiltInCommonProperties(w),{isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}),o=this.r.get(w.identifier.value)??[];return this.r.set(w.identifier.value,[...o,t]),t.apiTelemetryLogger}$initializeTelemetryLevel(w,m,$){this.f=w,this.g=m,this.c=$??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(w){const m=Object.create(null);switch(m["common.extname"]=`${w.publisher}.${w.name}`,m["common.extversion"]=w.version,m["common.vscodemachineid"]=this.s.telemetryInfo.machineId,m["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,m["common.sqmid"]=this.s.telemetryInfo.sqmId,m["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,m["common.vscodeversion"]=this.s.version,m["common.isnewappinstall"]=h(this.s.telemetryInfo.firstSessionDate),m["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:m["common.uikind"]="web";break;case R.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,v.$Nm)((0,s.$yp)(this.s.remote.authority)),m}$onDidChangeTelemetryLevel(w){this.h=this.getTelemetryConfiguration(),this.f=w;const m=this.getTelemetryDetails();this.r.forEach(($,l)=>{const t=$.filter(o=>!o.isDisposed);t.length===0?this.r.delete(l):this.r.set(l,t)}),this.r.forEach($=>{for(const l of $)l.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(w,m){const l=this.r.get(w.value)?.filter(o=>!o.isDisposed);if(!l)return this.r.delete(w.value),!1;let t=!1;for(const o of l)o.ignoreUnhandledExtHostErrors||(o.logError(m),t=!0);return t}};e.$dP=a,e.$dP=a=Ue([Fe(0,A.$cP),Fe(1,D.$8j)],a);class f{static validateSender(w){if(typeof w!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof w.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof w.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof w.flush<"u"&&typeof w.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(w,m,$,l,t,o,d){this.g=$,this.h=l,this.i=t,this.j=o,this.a=new r.$he,this.ignoreUnhandledExtHostErrors=m?.ignoreUnhandledErrors??!1,this.b=m?.ignoreBuiltInCommonProperties??!1,this.c=m?.additionalCommonProperties,this.f=w,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(w,m){this.e&&(this.d={isUsageEnabled:w,isErrorsEnabled:m},this.a.fire(this.e))}mixInCommonPropsAndCleanData(w){let m="properties"in w?w.properties??{}:w;return m=(0,s.$Bp)(m,[]),this.c&&(m=(0,E.$_n)(m,this.c)),this.b||(m=(0,E.$_n)(m,this.j)),"properties"in w?w.properties=m:w=m,w}k(w,m){this.f&&(this.g.publisher==="vscode"?w=this.g.name+"/"+w:w=this.g.identifier.value+"/"+w,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f?.sendEventData(w,m),this.h.trace(w,m))}logUsage(w,m){this.d.isUsageEnabled&&this.k(w,m)}logError(w,m){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof w=="string")this.k(w,m);else{const $={name:w.name,message:w.message,stack:w.stack,cause:w.cause},l=(0,s.$Bp)($,[]),t=new Error(l.message,{cause:l.cause});t.stack=l.stack,t.name=l.name,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f.sendErrorData(t,m),this.h.trace("exception",m)}}get apiTelemetryLogger(){if(!this.e){const w=this,m={logUsage:w.logUsage.bind(w),get isUsageEnabled(){return w.d.isUsageEnabled},get isErrorsEnabled(){return w.d.isErrorsEnabled},logError:w.logError.bind(w),dispose:w.dispose.bind(w),onDidChangeEnableStates:w.a.event.bind(w)};this.e=Object.freeze(m)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let w=this.f;this.f=void 0,Promise.resolve(w.flush()).then(w=void 0),this.e=void 0}else this.f=void 0}}e.$eP=f;function h(g){const w=Date.now()-new Date(g).getTime();return isNaN(w)?!1:w<1e3*60*60*24}e.$gP=(0,n.$Ai)("IExtHostTelemetry")}),define(Ee[312],Se([1,0,6,4,39,129,23,5]),function(fe,e,n,r,S,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.ActivationKind=e.$WG=e.$VG=e.$SG=e.ExtensionHostStartup=e.$RG=e.$QG=e.$PG=e.$OG=void 0,e.$TG=p,e.$UG=b,e.$XG=g,e.$YG=w,e.$OG=Object.freeze({identifier:new A.$Wm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:r.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$PG="extensions.webWorker",e.$QG=(0,R.$Ai)("extensionService");class v{constructor(l){this.dependency=l}}e.$RG=v;var s;(function($){$[$.EagerAutoStart=1]="EagerAutoStart",$[$.EagerManualStart=2]="EagerManualStart",$[$.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class E{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,o){this.c=l,this.d=t.slice(0),this.e=o.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:D.$zG.createActivationEventsMap(this.d)}}set(l,t,o){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const d=[],i=[],c=[],u=[],k=y(this.d),I=y(t),C=(Q,ie)=>Q.extensionLocation.toString()===ie.extensionLocation.toString()||Q.isBuiltin===ie.isBuiltin||Q.isUserBuiltin===ie.isUserBuiltin||Q.isUnderDevelopment===ie.isUnderDevelopment;for(const Q of this.d){const ie=I.get(Q.identifier);if(!ie){d.push(Q.identifier),k.delete(Q.identifier);continue}if(!C(Q,ie)){d.push(Q.identifier),k.delete(Q.identifier);continue}}for(const Q of t){const ie=k.get(Q.identifier);if(!ie){i.push(Q);continue}if(!C(ie,Q)){d.push(ie.identifier),k.delete(ie.identifier);continue}}const T=new A.$Xm(this.e),O=new A.$Xm(o);for(const Q of this.e)O.has(Q)||c.push(Q);for(const Q of o)T.has(Q)||u.push(Q);const P=D.$zG.createActivationEventsMap(i),V={versionId:l,toRemove:d,toAdd:i,addActivationEvents:P,myToRemove:c,myToAdd:u};return this.delta(V),V}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:o,myToRemove:d,myToAdd:i}=l,c=new A.$Xm(t),u=new A.$Xm(d);for(let k=0;k<this.d.length;k++)c.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)u.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of o)this.d.push(k);for(const k of i)this.e.push(k);return this.f=null,l}containsExtension(l){for(const t of this.e)if(A.$Wm.equals(t,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const o=D.$zG.readActivationEvents(t);for(const d of o)l.add(d)}return l}}e.$SG=E;function y($){const l=new A.$Ym;for(const t of $)l.set(t.identifier,t);return l}function p($,l){return $.enabledApiProposals?$.enabledApiProposals.includes(l):!1}function b($,l){if(!p($,l))throw new Error(`Extension '${$.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${$.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${$.identifier.value}`)}class a{constructor(l,t,o,d){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=o,this.activationReason=d}}e.$VG=a;class f{constructor(l,t){this.description=l,this.value=t}}e.$WG=f;var h;(function($){$[$.Normal=0]="Normal",$[$.Immediate=1]="Immediate"})(h||(e.ActivationKind=h={}));function g($){return{type:$.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:$.isBuiltin||$.isUserBuiltin,identifier:{id:(0,S.$Hp)($.publisher,$.name),uuid:$.uuid},manifest:$,location:$.extensionLocation,targetPlatform:$.targetPlatform,validations:[],isValid:!0}}function w($,l){return{identifier:new A.$Wm((0,S.$Fp)($.manifest.publisher,$.manifest.name)),isBuiltin:$.type===A.ExtensionType.System,isUserBuiltin:$.type===A.ExtensionType.User&&$.isBuiltin,isUnderDevelopment:!!l,extensionLocation:$.location,...$.manifest,uuid:$.identifier.uuid,targetPlatform:$.targetPlatform,publisherDisplayName:$.publisherDisplayName}}class m{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.onWillStop=n.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$ZG=m}),define(Ee[313],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ee[314],Se([1,0,237,10,58,30,126,38,23,313,29,129]),function(fe,e,n,r,S,D,A,R,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0;const p=R.$jo.as(A.$ko.JSONContribution);class b{constructor(l,t,o){this.a=l,this.b=t,this.c=o}d(l,t){this.a({type:l,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(S.default.Error,l)}warn(l){this.d(S.default.Warning,l)}info(l){this.d(S.default.Info,l)}}e.$IG=b;class a{static a(l){const t=new v.$Xm;for(let o=0,d=l.length;o<d;o++)t.add(l[o].description.identifier);return t}static compute(l,t){if(!l||!l.length)return new a(t,[]);if(!t||!t.length)return new a([],l);const o=this.a(l),d=this.a(t),i=t.filter(u=>!o.has(u.description.identifier)),c=l.filter(u=>!d.has(u.description.identifier));return new a(i,c)}constructor(l,t){this.added=l,this.removed=t}}e.$JG=a;class f{constructor(l,t){this.name=l,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");return this.a=l,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(l){this.c=a.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,r.$1)(l)}}}e.$KG=f;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},g="vscode://schemas/vscode-extensions";e.$LG={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.$Vm},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(s.allApiProposals),markdownEnumDescriptions:Object.values(s.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:n.localize(42,null)},{label:"*",description:n.localize(43,null),body:"*"}]}},badges:{type:"array",description:n.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(45,null)},href:{type:"string",description:n.localize(46,null)},description:{type:"string",description:n.localize(47,null)}}}},markdown:{type:"string",description:n.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:D.$1o}},extensionPack:{description:n.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:D.$1o}},extensionKind:{description:n.localize(52,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(53,null)},{body:["workspace"],description:n.localize(54,null)},{body:["ui","workspace"],description:n.localize(55,null)},{body:["workspace","ui"],description:n.localize(56,null)},{body:[],description:n.localize(57,null)}]},capabilities:{description:n.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(61,null),n.localize(62,null),n.localize(63,null)]},description:{type:"string",markdownDescription:n.localize(64,null)}}},untrustedWorkspaces:{description:n.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(67,null),n.localize(68,null),n.localize(69,null)]},restrictedConfigurations:{description:n.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(71,null)}}}}},sponsor:{description:n.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(74,null),type:"string"},"vscode:uninstall":{description:n.localize(75,null),type:"string"}}},icon:{type:"string",description:n.localize(76,null)},l10n:{type:"string",description:n.localize(77,null)},pricing:{type:"string",markdownDescription:n.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class w{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const t=new f(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,t),l.activationEventsGenerator&&y.$zG.register(l.extensionPoint,l.activationEventsGenerator),e.$LG.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,p.registerSchema(g,e.$LG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$MG=w;const m={ExtensionsRegistry:"ExtensionsRegistry"};R.$jo.add(m.ExtensionsRegistry,new w),e.$NG=R.$jo.as(m.ExtensionsRegistry),p.registerSchema(g,e.$LG),p.registerSchema(E.$ok,{properties:{extensionEnabledApiProposals:{description:n.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(s.allApiProposals),markdownEnumDescriptions:Object.values(s.allApiProposals)}}]}}}})}),define(Ee[315],Se([1,0,6,40,2,17,234,23,5,12,312,314]),function(fe,e,n,r,S,D,A,R,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3G=e.$2G=e.$1G=e.ChatMessageRole=void 0;var p;(function(f){f[f.System=0]="System",f[f.User=1]="User",f[f.Assistant=2]="Assistant"})(p||(e.ChatMessageRole=p={})),e.$1G=(0,v.$Ai)("ILanguageModelsService");const b={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.$2G=y.$NG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[b,{type:"array",items:b}]},activationEventsGenerator:(f,h)=>{for(const g of f)h.push(`onLanguageModelChat:${g.vendor}`)}});let a=class{constructor(h,g){this.e=h,this.f=g,this.a=new S.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new n.$he),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$2G.setHandler(w=>{this.c.clear();for(const $ of w){if(!(0,E.$TG)($.description,"chatProvider")){$.collector.error((0,A.localize)(2,null));continue}for(const l of r.Iterable.wrap($.value)){if(this.c.has(l.vendor)){$.collector.error((0,A.localize)(3,null,l.vendor));continue}if((0,D.$$e)(l.vendor)){$.collector.error((0,A.localize)(4,null));continue}if(l.vendor.trim()!==l.vendor){$.collector.error((0,A.localize)(5,null));continue}this.c.add(l.vendor)}}const m=[];for(const[$,l]of this.b)this.c.has(l.metadata.vendor)||(this.b.delete($),m.push($));m.length>0&&this.d.fire({removed:m})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(h){return this.b.get(h)?.metadata}async selectLanguageModels(h){if(h.vendor)await this.e.activateByEvent(`onLanguageModelChat:${h.vendor}}`);else{const w=Array.from(this.c).map(m=>this.e.activateByEvent(`onLanguageModelChat:${m}`));await Promise.all(w)}const g=[];for(const[w,m]of this.b)(h.vendor===void 0||m.metadata.vendor===h.vendor)&&(h.family===void 0||m.metadata.family===h.family)&&(h.version===void 0||m.metadata.version===h.version)&&(h.identifier===void 0||m.metadata.id===h.identifier)&&(!m.metadata.targetExtensions||m.metadata.targetExtensions.some($=>R.$Wm.equals($,h.extension)))&&g.push(w);return this.f.trace("[LM] selected language models",h,g),g}registerLanguageModelChat(h,g){if(this.f.trace("[LM] registering language model chat",h,g.metadata),!this.c.has(g.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${g.metadata.vendor}.`);if(this.b.has(h))throw new Error(`Chat response provider with identifier ${h} is already registered.`);return this.b.set(h,g),this.d.fire({added:[{identifier:h,metadata:g.metadata}]}),(0,S.$Sc)(()=>{this.b.delete(h)&&(this.d.fire({removed:[h]}),this.f.trace("[LM] UNregistered language model chat",h,g.metadata))})}makeLanguageModelChatRequest(h,g,w,m,$,l){const t=this.b.get(h);if(!t)throw new Error(`Chat response provider with identifier ${h} is not registered.`);return t.provideChatResponse(w,g,m,$,l)}computeTokenLength(h,g,w){const m=this.b.get(h);if(!m)throw new Error(`Chat response provider with identifier ${h} is not registered.`);return m.provideTokenCount(g,w)}};e.$3G=a,e.$3G=a=Ue([Fe(0,E.$QG),Fe(1,s.$7j)],a)}),define(Ee[316],Se([1,0,23,238,62]),function(fe,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=D;function D(A,R,v,s,E){const y=new n.$Ym;return A.forEach(p=>{const b=y.get(p.identifier);b&&E.warn((0,r.localize)(0,null,b.extensionLocation.fsPath,p.extensionLocation.fsPath)),y.set(p.identifier,p)}),R.forEach(p=>{const b=y.get(p.identifier);if(b)if(b.isBuiltin){if(S.gte(b.version,p.version)){E.warn(`Skipping extension ${p.extensionLocation.path} in favour of the builtin extension ${b.extensionLocation.path}.`);return}p.isBuiltin=!0}else E.warn((0,r.localize)(1,null,b.extensionLocation.fsPath,p.extensionLocation.fsPath));else if(p.isBuiltin){E.warn(`Skipping obsolete builtin extension ${p.extensionLocation.path}`);return}y.set(p.identifier,p)}),v.forEach(p=>{const b=y.get(p.identifier);b&&E.warn((0,r.localize)(2,null,b.extensionLocation.fsPath,p.extensionLocation.fsPath)),y.set(p.identifier,p)}),s.forEach(p=>{E.info((0,r.localize)(3,null,p.extensionLocation.fsPath));const b=y.get(p.identifier);b&&b.isBuiltin&&(p.isBuiltin=!0),y.set(p.identifier,p)}),Array.from(y.values())}}),define(Ee[317],Se([1,0,9,3,33,4,45,59,43,64,23,316,13]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rQ=e.$qQ=void 0;class b{constructor(h,g,w,m,$,l,t){this.c=h,this.d=w,this.f=m,this.g=$,this.h=l,this.i=t,this.a=Promise.resolve(),this.b=Promise.resolve();const o=g.args["install-builtin-extension"];if(o){$.trace("Installing builtin extensions passed via args...");const i={isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"]};A.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=h.installExtensions([],this.j(o),i,!!g.args.force).then(()=>{A.mark("code/server/didInstallBuiltinExtensions"),$.trace("Finished installing builtin extensions")},c=>{$.error(c)})}const d=g.args["install-extension"];d&&($.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>h.installExtensions(this.j(d),[],{isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"],isApplicationScoped:!0},!!g.args.force)).then(()=>{$.trace("Finished installing extensions")},i=>{$.error(i)}))}j(h){return h.map(g=>/\.vsix$/i.test(g)?D.URI.file((0,n.$ic)(g)?g:(0,n.$jc)((0,S.cwd)(),g)):g)}whenExtensionsReady(){return this.b}async scanExtensions(h,g,w,m,$){A.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${h}`),await this.a;const l=m?m.filter(o=>o.scheme===p.Schemas.file).map(o=>o.fsPath):void 0;g=g??this.d.defaultProfile.extensionsResource;const t=await this.k(g,h??r.$w,w,l,$);return this.g.trace("Scanned Extensions",t),this.s(t),A.mark("code/server/didScanExtensions"),t}async scanSingleExtension(h,g,w){await this.a;const m=h.scheme===p.Schemas.file?h.fsPath:null;if(!m)return null;const $=await this.q(m,g,w??r.$w);return $?(this.s([$]),$):null}async k(h,g,w,m,$){await this.r(g,$);const[l,t,o,d]=await Promise.all([this.n(g),this.o(h,g),this.m(g,w),this.l(g,m)]);return(0,y.$nQ)(l,t,o,d,this.g)}async l(h,g){return g?(await Promise.all(g.map(w=>this.f.scanOneOrMultipleExtensions(D.URI.file((0,n.$kc)(w)),E.ExtensionType.User,{language:h})))).flat().map(w=>(0,s.$Eq)(w,!0)):[]}async m(h,g){const w=[];if(g?.length){const m=await Promise.all(g.map($=>this.f.scanExistingExtension($,E.ExtensionType.User,{language:h})));for(const $ of m)$&&w.push((0,s.$Eq)($,!1))}return w}async n(h){return(await this.f.scanSystemExtensions({language:h,useCache:!0})).map(w=>(0,s.$Eq)(w,!1))}async o(h,g){return(await this.f.scanUserExtensions({profileLocation:h,language:g,useCache:!0})).map(m=>(0,s.$Eq)(m,!1))}async q(h,g,w){const m=D.URI.file((0,n.$kc)(h)),$=g?E.ExtensionType.System:E.ExtensionType.User,l=await this.f.scanExistingExtension(m,$,{language:w});return l?(0,s.$Eq)(l,!1):null}async r(h,g){if(!(h===r.$g||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(m=>m.id===h)){this.g.trace(`Language Pack ${h} is already installed. Skipping language pack installation.`);return}}catch(w){this.g.error(w)}if(!g){this.g.trace(`No language pack id provided for language ${h}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${g} for language ${h} is not installed. It will be installed now.`);try{await this.c.installExtensions([g],[],{isMachineScoped:!0},!0)}catch(w){this.g.error(w)}}}s(h){const g=(o,d)=>o.replace(/file/g,"vscode-remote"),w=o=>{let d="";return d+=o.global?"g":"",d+=o.ignoreCase?"i":"",d+=o.multiline?"m":"",new RegExp(g(o.source,!0),d)},m=new class{mapDefined(o){return v.$Dj.create(o)}mapNot(o){return v.$Ij.create(o)}mapEquals(o,d){return o==="resourceScheme"&&typeof d=="string"?v.$Ej.create(o,g(d,!1)):v.$Ej.create(o,d)}mapNotEquals(o,d){return o==="resourceScheme"&&typeof d=="string"?v.$Hj.create(o,g(d,!1)):v.$Hj.create(o,d)}mapGreater(o,d){return v.$Jj.create(o,d)}mapGreaterEquals(o,d){return v.$Kj.create(o,d)}mapSmaller(o,d){return v.$Lj.create(o,d)}mapSmallerEquals(o,d){return v.$Mj.create(o,d)}mapRegex(o,d){return o==="resourceScheme"&&d?v.$Nj.create(o,w(d)):v.$Nj.create(o,d)}mapIn(o,d){return v.$Fj.create(o,d)}mapNotIn(o,d){return v.$Gj.create(o,d)}},$=o=>{if(!o||!o.when||!/resourceScheme/.test(o.when))return;const d=v.$yj.deserialize(o.when);if(!d)return;const i=d.map(m);o.when=i.serialize()},l=o=>{if(Array.isArray(o))for(const d of o)$(d);else $(o)},t=o=>{for(const d in o)l(o[d])};h.forEach(o=>{o.contributes&&(o.contributes.menus&&t(o.contributes.menus),o.contributes.keybindings&&l(o.contributes.keybindings),o.contributes.views&&t(o.contributes.views))})}}e.$qQ=b;class a{constructor(h,g){this.a=h,this.b=g}listen(h,g){throw new Error("Invalid listen")}async call(h,g,w){const m=this.b(h);switch(g){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const $=w[0],l=w[1]?D.URI.revive(m.transformIncoming(w[1])):void 0,t=Array.isArray(w[2])?w[2].map(c=>D.URI.revive(m.transformIncoming(c))):void 0,o=Array.isArray(w[3])?w[3].map(c=>D.URI.revive(m.transformIncoming(c))):void 0,d=w[4];return(await this.a.scanExtensions($,l,t,o,d)).map(c=>(0,R.$Fn)(c,m))}case"scanSingleExtension":{const $=await this.a.scanSingleExtension(D.URI.revive(m.transformIncoming(w[0])),w[1],w[2]);return $?(0,R.$Fn)($,m):null}}throw new Error("Invalid call")}}e.$rQ=a}),define(Ee[150],Se([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kw=e.$Hw=void 0,e.$Iw=S,e.$Jw=D;class n{static{this.count=0}constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++n.count}}e.$Hw=n;const r=[];function S(R){const v=new n(R);return r[v.nid]=v,v}function D(R){return r[R].sid}class A{constructor(v){this.value=v}}e.$Kw=A}),define(Ee[318],Se([1,0,150]),function(fe,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$tM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var r;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(r||(e.TextEditorRevealType=r={}));var S;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput",f[f.ChatEditorInput=10]="ChatEditorInput",f[f.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(S||(e.TabInputKind=S={}));var D;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(D||(e.TabModelOperationKind=D={}));var A;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var R;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var v;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var s;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var E;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output",f[f.Hybrid=3]="Hybrid"})(E||(e.CandidatePortSource=E={}));class y{static{this.a=0}static mixin(h){return h._id=y.a++,h}}e.$tM=y;var p;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var b;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var a;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(a||(e.ExtHostTestingResource=a={})),e.$uM={MainThreadAuthentication:(0,n.$Iw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.$Iw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,n.$Iw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,n.$Iw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,n.$Iw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,n.$Iw)("MainThreadChatVariables"),MainThreadClipboard:(0,n.$Iw)("MainThreadClipboard"),MainThreadCommands:(0,n.$Iw)("MainThreadCommands"),MainThreadComments:(0,n.$Iw)("MainThreadComments"),MainThreadConfiguration:(0,n.$Iw)("MainThreadConfiguration"),MainThreadConsole:(0,n.$Iw)("MainThreadConsole"),MainThreadDebugService:(0,n.$Iw)("MainThreadDebugService"),MainThreadDecorations:(0,n.$Iw)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.$Iw)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.$Iw)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.$Iw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.$Iw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.$Iw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.$Iw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.$Iw)("MainThreadEditorTabs"),MainThreadErrors:(0,n.$Iw)("MainThreadErrors"),MainThreadTreeViews:(0,n.$Iw)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.$Iw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,n.$Iw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.$Iw)("MainThreadLanguages"),MainThreadLogger:(0,n.$Iw)("MainThreadLogger"),MainThreadMessageService:(0,n.$Iw)("MainThreadMessageService"),MainThreadOutputService:(0,n.$Iw)("MainThreadOutputService"),MainThreadProgress:(0,n.$Iw)("MainThreadProgress"),MainThreadQuickDiff:(0,n.$Iw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.$Iw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.$Iw)("MainThreadStatusBar"),MainThreadSecretState:(0,n.$Iw)("MainThreadSecretState"),MainThreadStorage:(0,n.$Iw)("MainThreadStorage"),MainThreadSpeech:(0,n.$Iw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,n.$Iw)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.$Iw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,n.$Iw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,n.$Iw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.$Iw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.$Iw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.$Iw)("MainThreadCustomEditors"),MainThreadUrls:(0,n.$Iw)("MainThreadUrls"),MainThreadUriOpeners:(0,n.$Iw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.$Iw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.$Iw)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.$Iw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,n.$Iw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,n.$Iw)("MainThreadExtensionService"),MainThreadSCM:(0,n.$Iw)("MainThreadSCM"),MainThreadSearch:(0,n.$Iw)("MainThreadSearch"),MainThreadShare:(0,n.$Iw)("MainThreadShare"),MainThreadTask:(0,n.$Iw)("MainThreadTask"),MainThreadWindow:(0,n.$Iw)("MainThreadWindow"),MainThreadLabelService:(0,n.$Iw)("MainThreadLabelService"),MainThreadNotebook:(0,n.$Iw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.$Iw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.$Iw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.$Iw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.$Iw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.$Iw)("MainThreadInteractive"),MainThreadTheming:(0,n.$Iw)("MainThreadTheming"),MainThreadTunnelService:(0,n.$Iw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,n.$Iw)("MainThreadManagedSockets"),MainThreadTimeline:(0,n.$Iw)("MainThreadTimeline"),MainThreadTesting:(0,n.$Iw)("MainThreadTesting"),MainThreadLocalization:(0,n.$Iw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,n.$Iw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,n.$Iw)("MainThreadAiEmbeddingVector")},e.$vM={ExtHostCommands:(0,n.$Iw)("ExtHostCommands"),ExtHostConfiguration:(0,n.$Iw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.$Iw)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.$Iw)("ExtHostDebugService"),ExtHostDecorations:(0,n.$Iw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.$Iw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.$Iw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.$Iw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.$Iw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.$Iw)("ExtHostEditors"),ExtHostTreeViews:(0,n.$Iw)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.$Iw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.$Iw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.$Iw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.$Iw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.$Iw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.$Iw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.$Iw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,n.$Iw)("ExtHostStatusBar"),ExtHostShare:(0,n.$Iw)("ExtHostShare"),ExtHostExtensionService:(0,n.$Iw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.$Iw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.$Iw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,n.$Iw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,n.$Iw)("ExtHostSCM"),ExtHostSearch:(0,n.$Iw)("ExtHostSearch"),ExtHostTask:(0,n.$Iw)("ExtHostTask"),ExtHostWorkspace:(0,n.$Iw)("ExtHostWorkspace"),ExtHostWindow:(0,n.$Iw)("ExtHostWindow"),ExtHostWebviews:(0,n.$Iw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.$Iw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.$Iw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.$Iw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.$Iw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.$Iw)("ExtHostEditorTabs"),ExtHostProgress:(0,n.$Iw)("ExtHostProgress"),ExtHostComments:(0,n.$Iw)("ExtHostComments"),ExtHostSecretState:(0,n.$Iw)("ExtHostSecretState"),ExtHostStorage:(0,n.$Iw)("ExtHostStorage"),ExtHostUrls:(0,n.$Iw)("ExtHostUrls"),ExtHostUriOpeners:(0,n.$Iw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.$Iw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.$Iw)("ExtHostOutputService"),ExtHostLabelService:(0,n.$Iw)("ExtHostLabelService"),ExtHostNotebook:(0,n.$Iw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.$Iw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.$Iw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.$Iw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.$Iw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,n.$Iw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,n.$Iw)("ExtHostInteractive"),ExtHostChatAgents2:(0,n.$Iw)("ExtHostChatAgents"),ExtHostChatVariables:(0,n.$Iw)("ExtHostChatVariables"),ExtHostChatProvider:(0,n.$Iw)("ExtHostChatProvider"),ExtHostSpeech:(0,n.$Iw)("ExtHostSpeech"),ExtHostEmbeddings:(0,n.$Iw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,n.$Iw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,n.$Iw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,n.$Iw)("ExtHostTheming"),ExtHostTunnelService:(0,n.$Iw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,n.$Iw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,n.$Iw)("ExtHostAuthentication"),ExtHostTimeline:(0,n.$Iw)("ExtHostTimeline"),ExtHostTesting:(0,n.$Iw)("ExtHostTesting"),ExtHostTelemetry:(0,n.$Iw)("ExtHostTelemetry"),ExtHostLocalization:(0,n.$Iw)("ExtHostLocalization")}}),define(Ee[319],Se([1,0,15,26,13,119,5]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$8J=void 0,e.$9J=E,e.$0J=y,e.$8J=(0,A.$Ai)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${R.join("")}]+`),s=7;function E(b){if(b.scheme!==S.Schemas.vscodeNotebookCell)return;const a=b.fragment.indexOf("s");if(a<0)return;const f=parseInt(b.fragment.substring(0,a).replace(v,""),s),h=(0,n.$3e)(b.fragment.substring(a+1)).toString();if(!isNaN(f))return{handle:f,notebook:b.with({scheme:h,fragment:null})}}function y(b,a){const f=a.toString(s),g=`${f.length<R.length?R[f.length-1]:"z"}${f}s${(0,n.$4e)(n.$Je.fromString(b.scheme),!0,!0)}`;return b.with({scheme:S.Schemas.vscodeNotebookCell,fragment:g})}class p{constructor(){this.a=new r.$Ac}getNotebook(a){if(a.scheme===S.Schemas.vscodeNotebookCell){const f=E(a);if(f){const h=this.a.get(f.notebook);if(h)return h}}return this.a.get(a)}addNotebookDocument(a){this.a.set(a.uri,a)}removeNotebookDocument(a){this.a.delete(a.uri)}}e.$$J=p,(0,D.$Fs)(e.$8J,p,D.InstantiationType.Delayed)}),define(Ee[151],Se([1,0,15,85,40,68,13,9,3,43,319]),function(fe,e,n,r,S,D,A,R,v,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sK=e.$pK=e.CellStatusbarAlignment=e.$oK=e.NotebookEditorPriority=e.$lK=e.$kK=e.$iK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$hK=e.$gK=e.$fK=e.$eK=e.CellKind=e.$dK=e.$cK=e.$bK=void 0,e.$jK=o,e.$mK=i,e.$nK=c,e.$qK=I,e.$rK=T,e.$bK="workbench.editor.notebook",e.$cK="workbench.editor.notebookTextDiffEditor",e.$dK="workbench.editor.interactive";var y;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(y||(e.CellKind=y={})),e.$eK=["application/json","application/javascript","text/html","image/svg+xml",D.$Ys.latex,D.$Ys.markdown,"image/png","image/jpeg",D.$Ys.text],e.$fK=[D.$Ys.latex,D.$Ys.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",D.$Ys.text],e.$gK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$hK="_notAvailable";var p;(function(Z){Z[Z.Running=1]="Running",Z[Z.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var b;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var a;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(a||(e.NotebookExecutionState=a={}));var f;(function(Z){Z[Z.WithHardKernelDependency=0]="WithHardKernelDependency",Z[Z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Z[Z.Pure=2]="Pure",Z[Z.Never=3]="Never"})(f||(e.NotebookRendererMatch=f={}));var h;(function(Z){Z.Always="always",Z.Never="never",Z.Optional="optional"})(h||(e.RendererMessagingSpec=h={}));var g;(function(Z){Z[Z.ModelChange=1]="ModelChange",Z[Z.Move=2]="Move",Z[Z.ChangeCellLanguage=5]="ChangeCellLanguage",Z[Z.Initialize=6]="Initialize",Z[Z.ChangeCellMetadata=7]="ChangeCellMetadata",Z[Z.Output=8]="Output",Z[Z.OutputItem=9]="OutputItem",Z[Z.ChangeCellContent=10]="ChangeCellContent",Z[Z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Z[Z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Z[Z.ChangeCellMime=13]="ChangeCellMime",Z[Z.Unknown=100]="Unknown"})(g||(e.NotebookCellsChangeType=g={}));var w;(function(Z){Z[Z.Handle=0]="Handle",Z[Z.Index=1]="Index"})(w||(e.SelectionStateType=w={}));var m;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Output=2]="Output",Z[Z.Metadata=3]="Metadata",Z[Z.CellLanguage=4]="CellLanguage",Z[Z.DocumentMetadata=5]="DocumentMetadata",Z[Z.Move=6]="Move",Z[Z.OutputItems=7]="OutputItems",Z[Z.PartialMetadata=8]="PartialMetadata",Z[Z.PartialInternalMetadata=9]="PartialInternalMetadata"})(m||(e.CellEditType=m={}));var $;(function(Z){Z.scheme=A.Schemas.vscodeNotebookCell;function ee(pe,q){return(0,E.$0J)(pe,q)}Z.generate=ee;function ue(pe){return(0,E.$9J)(pe)}Z.parse=ue;function j(pe,q){return pe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${q??""},${pe.scheme!==A.Schemas.file?pe.scheme:""}`})}Z.generateCellOutputUri=j;function B(pe){if(pe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(pe.fragment);if(!q)return;const ae=q[1]&&q[1]!==""?q[1]:void 0,Y=q[2];return{outputId:ae,notebook:pe.with({scheme:Y||A.Schemas.file,fragment:null})}}Z.parseCellOutputUri=B;function oe(pe,q,ae){return Z.generate(pe,q).with({scheme:ae})}Z.generateCellPropertyUri=oe;function le(pe,q){if(pe.scheme===q)return Z.parse(pe.with({scheme:Z.scheme}))}Z.parseCellPropertyUri=le})($||(e.CellUri=$={}));const l=Z=>v.$i?Z.replace(/\//g,"\\"):Z;class t{constructor(ee=[],ue=e.$eK){this.e=ue,this.d=[...new Set(ee)].map(j=>({pattern:j,matches:r.$uk(l(j))}))}sort(ee){const ue=new Map(S.Iterable.map(ee,B=>[B,l(B)]));let j=[];for(const{matches:B}of this.d)for(const[oe,le]of ue)if(B(le)){j.push(oe),ue.delete(oe);break}return ue.size&&(j=j.concat([...ue.keys()].sort((B,oe)=>this.e.indexOf(B)-this.e.indexOf(oe)))),j}prioritize(ee,ue){const j=this.f(ee);if(j===-1){this.d.unshift({pattern:ee,matches:r.$uk(l(ee))});return}const B=new Set(ue.map(le=>this.f(le,j)));B.delete(-1);const oe=Array.from(B).sort();this.d.splice(j+1,0,...oe.map(le=>this.d[le]));for(let le=oe.length-1;le>=0;le--)this.d.splice(oe[le],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,ue=this.d.length){const j=l(ee);for(let B=0;B<ue;B++)if(this.d[B].matches(j))return B;return-1}}e.$iK=t;function o(Z,ee,ue,j=(B,oe)=>B===oe){const B=[];function oe(q,ae,Y){if(ae===0&&Y.length===0)return;const H=B[B.length-1];H&&H.start+H.deleteCount===q?(H.deleteCount+=ae,H.toInsert.push(...Y)):B.push({start:q,deleteCount:ae,toInsert:Y})}let le=0,pe=0;for(;;){if(le===Z.length){oe(le,0,ee.slice(pe));break}if(pe===ee.length){oe(le,Z.length-le,[]);break}const q=Z[le],ae=ee[pe];if(j(q,ae)){le+=1,pe+=1;continue}ue(ae)?(oe(le,1,[]),le+=1):(oe(le,0,[ae]),pe+=1)}return B}e.$kK=new s.$Rj("notebookEditorCursorAtBoundary","none"),e.$lK=new s.$Rj("notebookEditorCursorAtLineBoundary","none");var d;(function(Z){Z.default="default",Z.option="option"})(d||(e.NotebookEditorPriority=d={}));function i(Z){const ee=Z;return!!((typeof ee.include=="string"||r.$vk(ee.include))&&(typeof ee.exclude=="string"||r.$vk(ee.exclude)))}function c(Z,ee,ue){if(Array.isArray(Z.viewType)&&Z.viewType.indexOf(ee)>=0||Z.viewType===ee)return!0;if(Z.filenamePattern){const j=i(Z.filenamePattern)?Z.filenamePattern.include:Z.filenamePattern,B=i(Z.filenamePattern)?Z.filenamePattern.exclude:void 0;if(r.$tk(j,(0,R.$nc)(ue.fsPath).toLowerCase()))return!(B&&r.$tk(B,(0,R.$nc)(ue.fsPath).toLowerCase()))}return!1}e.$oK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var u;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(u||(e.CellStatusbarAlignment=u={}));class k{static{this.d="notebook/"}static create(ee){return`${k.d}${ee}`}static parse(ee){if(ee.startsWith(k.d))return ee.substring(k.d.length)}}e.$pK=k;function I(Z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Z)}const C=new TextDecoder;function T(Z){const ee=[];let ue=!1;for(const le of Z)(ee.length===0||ue)&&(ee.push(le),ue=!0);let j=V(ee);const B=n.$Je.concat(ee.map(le=>n.$Je.wrap(le))),oe=se(B);return j=j||oe.byteLength!==B.byteLength,{data:oe,didCompression:j}}e.$sK="\x1B[A";const O=e.$sK.split("").map(Z=>Z.charCodeAt(0)),P=10;function V(Z){let ee=!1;return Z.forEach((ue,j)=>{if(j===0||ue.length<e.$sK.length)return;const B=Z[j-1],oe=ue.subarray(0,e.$sK.length);if(oe[0]===O[0]&&oe[1]===O[1]&&oe[2]===O[2]){const le=B.lastIndexOf(P);if(le===-1)return;ee=!0,Z[j-1]=B.subarray(0,le),Z[j]=ue.subarray(e.$sK.length)}}),ee}function Q(Z){let ee=Z;do Z=ee,ee=Z.replace(/[^\n]\x08/gm,"");while(ee.length<Z.length);return Z}function ie(Z){for(Z=Z.replace(/\r+\n/gm,`
`);Z.search(/\r[^$]/g)>-1;){const ee=Z.match(/^(.*)\r+/m)[1];let ue=Z.match(/\r+(.*)$/m)[1];ue=ue+ee.slice(ue.length,ee.length),Z=Z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return Z}const re=8,ne=13;function se(Z){return!Z.buffer.includes(re)&&!Z.buffer.includes(ne)?Z:n.$Je.fromString(ie(Q(C.decode(Z.buffer))))}}),define(Ee[152],Se([1,0,18,10,111,26,68,17,11,4,22,23,16,90,151]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a){"use strict";var f,h,g,w,m,$,l,t,o,d,i,c,u,k,I,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$MO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$sO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$fO=e.$eO=e.$dO=e.$cO=e.$aO=e.$_N=e.$$N=e.$0N=e.TestRunProfileKind=e.TestResultState=e.$9N=e.$8N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7N=e.NotebookVariablesRequestKind=e.$6N=e.$5N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.ColorThemeKind=e.$XN=e.$WN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VN=e.$UN=e.DebugConsoleMode=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$ON=e.$NN=e.FileChangeType=e.$MN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$LN=e.$KN=e.$JN=e.$IN=e.InlineCompletionTriggerKind=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$vN=e.ConfigurationTarget=e.$uN=e.$tN=e.$sN=e.$rN=e.DocumentPasteTriggerKind=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$kN=e.ViewBadge=e.ProgressLocation=e.$jN=e.$iN=e.TaskScope=e.ShellQuoting=e.$hN=e.$gN=e.$fN=e.TaskPanelKind=e.TaskRevealKind=e.$eN=e.TerminalLocation=e.$dN=e.$cN=e.$bN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$aN=e.$_M=e.$$M=e.$0M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$8M=e.$7M=e.$6M=e.$5M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$4M=e.$3M=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.LanguageStatusSeverity=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.CodeActionTriggerKind=e.$QM=e.$PM=e.SymbolTag=e.SymbolKind=e.$OM=e.$NM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.DiagnosticSeverity=e.DiagnosticTag=e.$HM=e.$GM=e.FileEditType=e.$FM=e.$EM=e.$DM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9M=Ye,e.$wN=$n,e.$bO=ci;function O(F){return Object.assign(F,{apply:function(...ce){if(ce.length===0)return Reflect.construct(F,[]);{const Pe=ce.length===1?[]:ce[1];return Reflect.construct(F,Pe,ce[0].constructor)}},call:function(...ce){if(ce.length===0)return Reflect.construct(F,[]);{const[Pe,...qe]=ce;return Reflect.construct(F,qe,Pe.constructor)}}})}var P;(function(F){F[F.Top=0]="Top",F[F.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var V;(function(F){F[F.TerminalCommand=0]="TerminalCommand",F[F.Opener=1]="Opener",F[F.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let Q=f=class{static from(...N){let ce=N;return new f(function(){if(ce){for(const Pe of ce)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ce=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$wM=Q,e.$wM=Q=f=Ue([O],Q);let ie=h=class{static Min(...N){if(N.length===0)throw new TypeError;let ce=N[0];for(let Pe=1;Pe<N.length;Pe++){const qe=N[Pe];qe.isBefore(ce)&&(ce=qe)}return ce}static Max(...N){if(N.length===0)throw new TypeError;let ce=N[0];for(let Pe=1;Pe<N.length;Pe++){const qe=N[Pe];qe.isAfter(ce)&&(ce=qe)}return ce}static isPosition(N){if(!N)return!1;if(N instanceof h)return!0;const{line:ce,character:Pe}=N;return typeof ce=="number"&&typeof Pe=="number"}static of(N){if(N instanceof h)return N;if(this.isPosition(N))return new h(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ce){if(N<0)throw(0,r.$7)("line must be non-negative");if(ce<0)throw(0,r.$7)("character must be non-negative");this.c=N,this.e=ce}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ce=0){if(N===null||ce===null)throw(0,r.$7)();let Pe;return typeof N>"u"?Pe=0:typeof N=="number"?Pe=N:(Pe=typeof N.lineDelta=="number"?N.lineDelta:0,ce=typeof N.characterDelta=="number"?N.characterDelta:0),Pe===0&&ce===0?this:new h(this.line+Pe,this.character+ce)}with(N,ce=this.character){if(N===null||ce===null)throw(0,r.$7)();let Pe;return typeof N>"u"?Pe=this.line:typeof N=="number"?Pe=N:(Pe=typeof N.line=="number"?N.line:this.line,ce=typeof N.character=="number"?N.character:this.character),Pe===this.line&&ce===this.character?this:new h(Pe,ce)}toJSON(){return{line:this.line,character:this.character}}};e.$xM=ie,e.$xM=ie=h=Ue([O],ie);let re=g=class{static isRange(N){return N instanceof g?!0:N?ie.isPosition(N.start)&&ie.isPosition(N.end):!1}static of(N){if(N instanceof g)return N;if(this.isRange(N))return new g(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ce,Pe,qe){let xe,st;if(typeof N=="number"&&typeof ce=="number"&&typeof Pe=="number"&&typeof qe=="number"?(xe=new ie(N,ce),st=new ie(Pe,qe)):ie.isPosition(N)&&ie.isPosition(ce)&&(xe=ie.of(N),st=ie.of(ce)),!xe||!st)throw new Error("Invalid arguments");xe.isBefore(st)?(this.c=xe,this.e=st):(this.c=st,this.e=xe)}contains(N){return g.isRange(N)?this.contains(N.start)&&this.contains(N.end):ie.isPosition(N)?!(ie.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ce=ie.Max(N.start,this.c),Pe=ie.Min(N.end,this.e);if(!ce.isAfter(Pe))return new g(ce,Pe)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ce=ie.Min(N.start,this.c),Pe=ie.Max(N.end,this.end);return new g(ce,Pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ce=this.end){if(N===null||ce===null)throw(0,r.$7)();let Pe;return N?ie.isPosition(N)?Pe=N:(Pe=N.start||this.start,ce=N.end||this.end):Pe=this.start,Pe.isEqual(this.c)&&ce.isEqual(this.end)?this:new g(Pe,ce)}toJSON(){return[this.start,this.end]}};e.$yM=re,e.$yM=re=g=Ue([O],re);let ne=w=class extends re{static isSelection(N){return N instanceof w?!0:N?re.isRange(N)&&ie.isPosition(N.anchor)&&ie.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ce,Pe,qe){let xe,st;if(typeof N=="number"&&typeof ce=="number"&&typeof Pe=="number"&&typeof qe=="number"?(xe=new ie(N,ce),st=new ie(Pe,qe)):ie.isPosition(N)&&ie.isPosition(ce)&&(xe=ie.of(N),st=ie.of(ce)),!xe||!st)throw new Error("Invalid arguments");super(xe,st),this.f=xe,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$zM=ne,e.$zM=ne=w=Ue([O],ne);const se=F=>{if(typeof F!="string"||F.length===0||!/^[0-9A-Za-z_\-]+$/.test(F))throw(0,r.$7)("connectionToken")};class Z{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ce,Pe){if(typeof N!="string"||N.length===0)throw(0,r.$7)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,r.$7)("port");typeof Pe<"u"&&se(Pe),this.host=N,this.port=Math.round(ce),this.connectionToken=Pe}}e.$AM=Z;class ee{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ce){this.makeConnection=N,this.connectionToken=ce,typeof ce<"u"&&se(ce)}}e.$BM=ee;class ue extends Error{static NotAvailable(N,ce){return new ue(N,b.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(N){return new ue(N,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ce=b.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(N),this._message=N,this._code=ce,this._detail=Pe,Object.setPrototypeOf(this,ue.prototype)}}e.$CM=ue;var j;(function(F){F[F.LF=1]="LF",F[F.CRLF=2]="CRLF"})(j||(e.EndOfLine=j={}));var B;(function(F){F[F.Replace=1]="Replace",F[F.Append=2]="Append",F[F.Prepend=3]="Prepend"})(B||(e.EnvironmentVariableMutatorType=B={}));let oe=m=class{static isTextEdit(N){return N instanceof m?!0:N?re.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ce){return new m(N,ce)}static insert(N,ce){return m.replace(new re(N,N),ce)}static delete(N){return m.replace(N,"")}static setEndOfLine(N){const ce=new m(new re(new ie(0,0),new ie(0,0)),"");return ce.newEol=N,ce}get range(){return this.c}set range(N){if(N&&!re.isRange(N))throw(0,r.$7)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,r.$7)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,r.$7)("newEol");this.f=N}constructor(N,ce){this.c=N,this.e=ce}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$DM=oe,e.$DM=oe=m=Ue([O],oe);let le=$=class{static isNotebookCellEdit(N){return N instanceof $?!0:N?an.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ce){return new $(N,ce)}static insertCells(N,ce){return new $(new an(N,N),ce)}static deleteCells(N){return new $(N,[])}static updateCellMetadata(N,ce){const Pe=new $(new an(N,N),[]);return Pe.newCellMetadata=ce,Pe}static updateNotebookMetadata(N){const ce=new $(new an(0,0),[]);return ce.newNotebookMetadata=N,ce}constructor(N,ce){this.range=N,this.newCells=ce}};e.$EM=le,e.$EM=le=$=Ue([O],le);class pe{static isSnippetTextEdit(N){return N instanceof pe?!0:N?re.isRange(N.range)&&Y.isSnippetString(N.snippet):!1}static replace(N,ce){return new pe(N,ce)}static insert(N,ce){return pe.replace(new re(N,N),ce)}constructor(N,ce){this.range=N,this.snippet=ce}}e.$FM=pe;var q;(function(F){F[F.File=1]="File",F[F.Text=2]="Text",F[F.Cell=3]="Cell",F[F.CellReplace=5]="CellReplace",F[F.Snippet=6]="Snippet"})(q||(e.FileEditType=q={}));let ae=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ce,Pe,qe){this.c.push({_type:q.File,from:N,to:ce,options:Pe,metadata:qe})}createFile(N,ce,Pe){this.c.push({_type:q.File,from:void 0,to:N,options:ce,metadata:Pe})}deleteFile(N,ce,Pe){this.c.push({_type:q.File,from:N,to:void 0,options:ce,metadata:Pe})}e(N,ce,Pe){this.c.push({_type:q.Cell,metadata:Pe,uri:N,edit:{editType:a.CellEditType.DocumentMetadata,metadata:ce},notebookMetadata:ce})}f(N,ce,Pe,qe){const xe=ce.start,st=ce.end;(xe!==st||Pe.length>0)&&this.c.push({_type:q.CellReplace,uri:N,index:xe,count:st-xe,cells:Pe,metadata:qe})}g(N,ce,Pe,qe){this.c.push({_type:q.Cell,metadata:qe,uri:N,edit:{editType:a.CellEditType.Metadata,index:ce,metadata:Pe}})}replace(N,ce,Pe,qe){this.c.push({_type:q.Text,uri:N,edit:new oe(ce,Pe),metadata:qe})}insert(N,ce,Pe,qe){this.replace(N,new re(ce,ce),Pe,qe)}delete(N,ce,Pe){this.replace(N,ce,"",Pe)}has(N){return this.c.some(ce=>ce._type===q.Text&&ce.uri.toString()===N.toString())}set(N,ce){if(ce)for(const Pe of ce){if(!Pe)continue;let qe,xe;Array.isArray(Pe)?(qe=Pe[0],xe=Pe[1]):qe=Pe,le.isNotebookCellEdit(qe)?qe.newCellMetadata?this.g(N,qe.range.start,qe.newCellMetadata,xe):qe.newNotebookMetadata?this.e(N,qe.newNotebookMetadata,xe):this.f(N,qe.range,qe.newCells,xe):pe.isSnippetTextEdit(qe)?this.c.push({_type:q.Snippet,uri:N,range:qe.range,edit:qe.snippet,metadata:xe}):this.c.push({_type:q.Text,uri:N,edit:qe,metadata:xe})}else{for(let Pe=0;Pe<this.c.length;Pe++){const qe=this.c[Pe];switch(qe._type){case q.Text:case q.Snippet:case q.Cell:case q.CellReplace:qe.uri.toString()===N.toString()&&(this.c[Pe]=void 0);break}}(0,n.$Ib)(this.c)}}get(N){const ce=[];for(const Pe of this.c)Pe._type===q.Text&&Pe.uri.toString()===N.toString()&&ce.push(Pe.edit);return ce}entries(){const N=new D.$Ac;for(const ce of this.c)if(ce._type===q.Text){let Pe=N.get(ce.uri);Pe||(Pe=[ce.uri,[]],N.set(ce.uri,Pe)),Pe[1].push(ce.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$GM=ae,e.$GM=ae=Ue([O],ae);let Y=l=class{static isSnippetString(N){return N instanceof l?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=l.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ce=this.e++){if(typeof N=="function"){const Pe=new l;Pe.e=this.e,N(Pe),this.e=Pe.e,N=Pe.value}else N=l.c(N);return this.value+="${",this.value+=ce,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ce=this.e++){const Pe=N.map(qe=>qe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(N,ce){if(typeof ce=="function"){const Pe=new l;Pe.e=this.e,ce(Pe),this.e=Pe.e,ce=Pe.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};e.$HM=Y,e.$HM=Y=l=Ue([O],Y);var H;(function(F){F[F.Unnecessary=1]="Unnecessary",F[F.Deprecated=2]="Deprecated"})(H||(e.DiagnosticTag=H={}));var L;(function(F){F[F.Hint=3]="Hint",F[F.Information=2]="Information",F[F.Warning=1]="Warning",F[F.Error=0]="Error"})(L||(e.DiagnosticSeverity=L={}));let W=t=class{static isLocation(N){return N instanceof t?!0:N?re.isRange(N.range)&&s.URI.isUri(N.uri):!1}constructor(N,ce){if(this.uri=N,ce)if(re.isRange(ce))this.range=re.of(ce);else if(ie.isPosition(ce))this.range=new re(ce,ce);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$IM=W,e.$IM=W=t=Ue([O],W);let z=class{static is(N){return N?typeof N.message=="string"&&N.location&&re.isRange(N.location.range)&&s.URI.isUri(N.location.uri):!1}constructor(N,ce){this.location=N,this.message=ce}static isEqual(N,ce){return N===ce?!0:!N||!ce?!1:N.message===ce.message&&N.location.range.isEqual(ce.location.range)&&N.location.uri.toString()===ce.location.uri.toString()}};e.$JM=z,e.$JM=z=Ue([O],z);let U=class{constructor(N,ce,Pe=L.Error){if(!re.isRange(N))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=N,this.message=ce,this.severity=Pe}toJSON(){return{severity:L[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ce){return N===ce?!0:!N||!ce?!1:N.message===ce.message&&N.severity===ce.severity&&N.code===ce.code&&N.severity===ce.severity&&N.source===ce.source&&N.range.isEqual(ce.range)&&(0,n.$ub)(N.tags,ce.tags)&&(0,n.$ub)(N.relatedInformation,ce.relatedInformation,z.isEqual)}};e.$KM=U,e.$KM=U=Ue([O],U);let J=class{constructor(N,ce){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ce}};e.$LM=J,e.$LM=J=Ue([O],J);let x=class extends J{constructor(N,ce,Pe,qe){super(N,ce),this.canIncreaseHover=Pe,this.canDecreaseHover=qe}};e.$MM=x,e.$MM=x=Ue([O],x);var M;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})(M||(e.HoverVerbosityAction=M={}));var G;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(G||(e.DocumentHighlightKind=G={}));let te=class{constructor(N,ce=G.Text){this.range=N,this.kind=ce}toJSON(){return{range:this.range,kind:G[this.kind]}}};e.$NM=te,e.$NM=te=Ue([O],te);let he=class{constructor(N,ce){this.uri=N,this.highlights=ce}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.$OM=he,e.$OM=he=Ue([O],he);var ke;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(ke||(e.SymbolKind=ke={}));var Ne;(function(F){F[F.Deprecated=1]="Deprecated"})(Ne||(e.SymbolTag=Ne={}));let me=o=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ce,Pe,qe,xe){this.name=N,this.kind=ce,this.containerName=xe,typeof Pe=="string"&&(this.containerName=Pe),qe instanceof W?this.location=qe:Pe instanceof re&&(this.location=new W(qe,Pe)),o.validate(this)}toJSON(){return{name:this.name,kind:ke[this.kind],location:this.location,containerName:this.containerName}}};e.$PM=me,e.$PM=me=o=Ue([O],me);let be=d=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(d.validate)}constructor(N,ce,Pe,qe,xe){this.name=N,this.detail=ce,this.kind=Pe,this.range=qe,this.selectionRange=xe,this.children=[],d.validate(this)}};e.$QM=be,e.$QM=be=d=Ue([O],be);var Ae;(function(F){F[F.Invoke=1]="Invoke",F[F.Automatic=2]="Automatic"})(Ae||(e.CodeActionTriggerKind=Ae={}));let Le=class{constructor(N,ce){this.title=N,this.kind=ce}};e.$RM=Le,e.$RM=Le=Ue([O],Le);let de=class{static{i=this}static{this.c="."}constructor(N){this.value=N}append(N){return new i(this.value?this.value+i.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+i.c)}};e.$SM=de,e.$SM=de=i=Ue([O],de),de.Empty=new de(""),de.QuickFix=de.Empty.append("quickfix"),de.Refactor=de.Empty.append("refactor"),de.RefactorExtract=de.Refactor.append("extract"),de.RefactorInline=de.Refactor.append("inline"),de.RefactorMove=de.Refactor.append("move"),de.RefactorRewrite=de.Refactor.append("rewrite"),de.Source=de.Empty.append("source"),de.SourceOrganizeImports=de.Source.append("organizeImports"),de.SourceFixAll=de.Source.append("fixAll"),de.Notebook=de.Empty.append("notebook");let Ie=class{constructor(N,ce){if(this.range=N,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$TM=Ie,e.$TM=Ie=Ue([O],Ie);class Re{constructor(N,ce,Pe,qe,xe,st){this.kind=N,this.name=ce,this.detail=Pe,this.uri=qe,this.range=xe,this.selectionRange=st}}e.$UM=Re;class Me{constructor(N,ce){this.fromRanges=ce,this.from=N}}e.$VM=Me;class He{constructor(N,ce){this.fromRanges=ce,this.to=N}}e.$WM=He;var Ke;(function(F){F[F.Information=0]="Information",F[F.Warning=1]="Warning",F[F.Error=2]="Error"})(Ke||(e.LanguageStatusSeverity=Ke={}));let We=class{constructor(N,ce){this.range=N,this.command=ce}get isResolved(){return!!this.command}};e.$XM=We,e.$XM=We=Ue([O],We);let Ve=c=class{#e;static isMarkdownString(N){return N instanceof c?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ce=!1){this.#e=new S.$Xk(N,{supportThemeIcons:ce})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,ce){return this.#e.appendCodeblock(ce??"",N),this}};e.$YM=Ve,e.$YM=Ve=c=Ue([O],Ve);let Ze=class{constructor(N,ce){this.label=N,this.documentation=ce}};e.$ZM=Ze,e.$ZM=Ze=Ue([O],Ze);let nt=class{constructor(N,ce){this.label=N,this.documentation=ce,this.parameters=[]}};e.$1M=nt,e.$1M=nt=Ue([O],nt);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$2M=it,e.$2M=it=Ue([O],it);var ot;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var tt;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let _e=class{constructor(N){this.value=N}};e.$3M=_e,e.$3M=_e=Ue([O],_e);let Xe=class{constructor(N,ce,Pe){this.position=N,this.label=ce,this.kind=Pe}};e.$4M=Xe,e.$4M=Xe=Ue([O],Xe);var Qe;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Qe||(e.CompletionTriggerKind=Qe={}));var $e;(function(F){F[F.Text=0]="Text",F[F.Method=1]="Method",F[F.Function=2]="Function",F[F.Constructor=3]="Constructor",F[F.Field=4]="Field",F[F.Variable=5]="Variable",F[F.Class=6]="Class",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Unit=10]="Unit",F[F.Value=11]="Value",F[F.Enum=12]="Enum",F[F.Keyword=13]="Keyword",F[F.Snippet=14]="Snippet",F[F.Color=15]="Color",F[F.File=16]="File",F[F.Reference=17]="Reference",F[F.Folder=18]="Folder",F[F.EnumMember=19]="EnumMember",F[F.Constant=20]="Constant",F[F.Struct=21]="Struct",F[F.Event=22]="Event",F[F.Operator=23]="Operator",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue"})($e||(e.CompletionItemKind=$e={}));var Oe;(function(F){F[F.Deprecated=1]="Deprecated"})(Oe||(e.CompletionItemTag=Oe={}));let ve=class{constructor(N,ce){this.label=N,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$5M=ve,e.$5M=ve=Ue([O],ve);let ye=class{constructor(N=[],ce=!1){this.items=N,this.isIncomplete=ce}};e.$6M=ye,e.$6M=ye=Ue([O],ye);let X=class{constructor(N,ce,Pe){this.insertText=N,this.range=ce,this.command=Pe}};e.$7M=X,e.$7M=X=Ue([O],X);let _=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$8M=_,e.$8M=_=Ue([O],_);var we;(function(F){F[F.Unknown=0]="Unknown",F[F.Word=1]="Word",F[F.Line=2]="Line",F[F.Suggest=3]="Suggest"})(we||(e.PartialAcceptTriggerKind=we={}));var ze;(function(F){F[F.Active=-1]="Active",F[F.Beside=-2]="Beside",F[F.One=1]="One",F[F.Two=2]="Two",F[F.Three=3]="Three",F[F.Four=4]="Four",F[F.Five=5]="Five",F[F.Six=6]="Six",F[F.Seven=7]="Seven",F[F.Eight=8]="Eight",F[F.Nine=9]="Nine"})(ze||(e.ViewColumn=ze={}));var Ge;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(Ge||(e.StatusBarAlignment=Ge={}));function Ye(F,N){return`${y.$Wm.toKey(F)}.${N}`}var et;(function(F){F[F.Off=0]="Off",F[F.On=1]="On",F[F.Relative=2]="Relative",F[F.Interval=3]="Interval"})(et||(e.TextEditorLineNumbersStyle=et={}));var lt;(function(F){F[F.Manual=1]="Manual",F[F.AfterDelay=2]="AfterDelay",F[F.FocusOut=3]="FocusOut"})(lt||(e.TextDocumentSaveReason=lt={}));var ut;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(ut||(e.TextEditorRevealType=ut={}));var dt;(function(F){F[F.Keyboard=1]="Keyboard",F[F.Mouse=2]="Mouse",F[F.Command=3]="Command"})(dt||(e.TextEditorSelectionChangeKind=dt={}));var Ct;(function(F){F[F.Undo=1]="Undo",F[F.Redo=2]="Redo"})(Ct||(e.TextDocumentChangeReason=Ct={}));var Dt;(function(F){F[F.OpenOpen=0]="OpenOpen",F[F.ClosedClosed=1]="ClosedClosed",F[F.OpenClosed=2]="OpenClosed",F[F.ClosedOpen=3]="ClosedOpen"})(Dt||(e.DecorationRangeBehavior=Dt={})),function(F){function N(ce){switch(ce){case"keyboard":return F.Keyboard;case"mouse":return F.Mouse;case"api":return F.Command}}F.fromValue=N}(dt||(e.TextEditorSelectionChangeKind=dt={}));var ht;(function(F){F[F.Other=0]="Other",F[F.Comment=1]="Comment",F[F.String=2]="String",F[F.RegEx=3]="RegEx"})(ht||(e.SyntaxTokenType=ht={})),function(F){function N(ce){switch(ce){case F.Other:return"other";case F.Comment:return"comment";case F.String:return"string";case F.RegEx:return"regex"}return"other"}F.toString=N}(ht||(e.SyntaxTokenType=ht={}));let mt=class{constructor(N,ce){if(ce&&!s.URI.isUri(ce))throw(0,r.$7)("target");if(!re.isRange(N)||N.isEmpty)throw(0,r.$7)("range");this.range=N,this.target=ce}};e.$0M=mt,e.$0M=mt=Ue([O],mt);let pt=class{constructor(N,ce,Pe,qe){this.red=N,this.green=ce,this.blue=Pe,this.alpha=qe}};e.$$M=pt,e.$$M=pt=Ue([O],pt);let Ft=class{constructor(N,ce){if(ce&&!(ce instanceof pt))throw(0,r.$7)("color");if(!re.isRange(N)||N.isEmpty)throw(0,r.$7)("range");this.range=N,this.color=ce}};e.$_M=Ft,e.$_M=Ft=Ue([O],Ft);let yt=class{constructor(N){if(!N||typeof N!="string")throw(0,r.$7)("label");this.label=N}};e.$aN=yt,e.$aN=yt=Ue([O],yt);var jt;(function(F){F[F.RGB=0]="RGB",F[F.HEX=1]="HEX",F[F.HSL=2]="HSL"})(jt||(e.ColorFormat=jt={}));var Tt;(function(F){F[F.Error=0]="Error",F[F.Warning=1]="Warning",F[F.Information=2]="Information"})(Tt||(e.SourceControlInputBoxValidationType=Tt={}));var ct;(function(F){F[F.Unknown=0]="Unknown",F[F.Shutdown=1]="Shutdown",F[F.Process=2]="Process",F[F.User=3]="User",F[F.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));var $t;(function(F){F[F.Low=0]="Low",F[F.Medium=1]="Medium",F[F.High=2]="High"})($t||(e.TerminalShellExecutionCommandLineConfidence=$t={}));class bt{constructor(N,ce,Pe){if(this.startIndex=N,this.length=ce,this.tooltip=Pe,typeof N!="number"||N<0)throw(0,r.$7)("startIndex");if(typeof ce!="number"||ce<1)throw(0,r.$7)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,r.$7)("tooltip")}}e.$bN=bt;class Et{constructor(N){this.uri=N}}e.$cN=Et;class It{constructor(N){this.terminalCommand=N}}e.$dN=It;var Vt;(function(F){F[F.Panel=1]="Panel",F[F.Editor=2]="Editor"})(Vt||(e.TerminalLocation=Vt={}));class Ot{constructor(N){if(this.options=N,typeof N!="object")throw(0,r.$7)("options")}}e.$eN=Ot;var Pt;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var Bt;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(Bt||(e.TaskPanelKind=Bt={}));let Gt=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from(N){switch(N){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor(N,ce){if(this.label=ce,typeof N!="string"||typeof ce!="string")throw(0,r.$7)("name");this.c=N}get id(){return this.c}};e.$fN=Gt,e.$fN=Gt=u=Ue([O],Gt);function wt(F){let N="";for(let ce=0;ce<F.length;ce++)N+=F[ce].replace(/,/g,",,")+",";return N}let St=class{constructor(N,ce,Pe){if(typeof N!="string")throw(0,r.$7)("process");this.e=[],this.c=N,ce!==void 0&&(Array.isArray(ce)?(this.e=ce,this.f=Pe):this.f=ce)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,r.$7)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ce of this.e)N.push(ce);return wt(N)}};e.$gN=St,e.$gN=St=Ue([O],St);let Lt=class{constructor(N,ce,Pe){if(this.f=[],Array.isArray(ce)){if(!N)throw(0,r.$7)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,r.$7)("command");this.e=N,this.f=ce,this.g=Pe}else{if(typeof N!="string")throw(0,r.$7)("commandLine");this.c=N,this.g=ce}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,r.$7)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,r.$7)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ce of this.f)N.push(typeof ce=="string"?ce:ce.value);return wt(N)}};e.$hN=Lt,e.$hN=Lt=Ue([O],Lt);var Zt;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(Zt||(e.ShellQuoting=Zt={}));var Nt;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace"})(Nt||(e.TaskScope=Nt={}));class Kt{constructor(N){this.c=N}computeId(){return"customExecution"+(0,E.$Wg)()}set callback(N){this.c=N}get callback(){return this.c}}e.$iN=Kt;let Ht=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,ce,Pe,qe,xe,st){this.k=!1,this.l=this.definition=N;let at;typeof ce=="string"?(this.o=this.name=ce,this.w=this.source=Pe,this.execution=qe,at=xe,this.k=!0):ce===Nt.Global||ce===Nt.Workspace?(this.target=ce,this.o=this.name=Pe,this.w=this.source=qe,this.execution=xe,at=st):(this.target=ce,this.o=this.name=Pe,this.w=this.source=qe,this.execution=xe,at=st),typeof at=="string"?(this.r=[at],this.t=!0):Array.isArray(at)?(this.r=at,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(N){this.j=N}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof St?this.l={type:k.e,id:this.q.computeId()}:this.q instanceof Lt?this.l={type:k.f,id:this.q.computeId()}:this.q instanceof Kt?this.l={type:k.c,id:this.q.computeId()}:this.l={type:k.g,id:(0,E.$Wg)()}}get definition(){return this.l}set definition(N){if(N==null)throw(0,r.$7)("Kind can't be undefined or null");this.B(),this.l=N}get scope(){return this.m}set target(N){this.B(),this.m=N}get name(){return this.o}set name(N){if(typeof N!="string")throw(0,r.$7)("name");this.B(),this.o=N}get execution(){return this.q}set execution(N){N===null&&(N=void 0),this.B(),this.q=N;const ce=this.l.type;(k.g===ce||k.e===ce||k.f===ce||k.c===ce)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(N){if(Array.isArray(N))this.B(),this.r=N,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.B(),this.u=N}get source(){return this.w}set source(N){if(typeof N!="string"||N.length===0)throw(0,r.$7)("source must be a string of length > 0");this.B(),this.w=N}get group(){return this.x}set group(N){N===null&&(N=void 0),this.B(),this.x=N}get detail(){return this.A}set detail(N){N===null&&(N=void 0),this.A=N}get presentationOptions(){return this.y}set presentationOptions(N){N==null&&(N=Object.create(null)),this.B(),this.y=N}get runOptions(){return this.z}set runOptions(N){N==null&&(N=Object.create(null)),this.B(),this.z=N}};e.$jN=Ht,e.$jN=Ht=k=Ue([O],Ht);var Xt;(function(F){F[F.SourceControl=1]="SourceControl",F[F.Window=10]="Window",F[F.Notification=15]="Notification"})(Xt||(e.ProgressLocation=Xt={}));var Jt;(function(F){function N(ce){const Pe=ce;return(0,v.$eg)(Pe.value)?Pe.tooltip&&!(0,v.$ag)(Pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Pe.value),!1)}F.isViewBadge=N})(Jt||(e.ViewBadge=Jt={}));let At=I=class{static isTreeItem(N,ce){const Pe=N;if(Pe.checkboxState!==void 0){const qe=(0,v.$eg)(Pe.checkboxState)?Pe.checkboxState:(0,v.$cg)(Pe.checkboxState)&&(0,v.$eg)(Pe.checkboxState.state)?Pe.checkboxState.state:void 0,xe=!(0,v.$eg)(Pe.checkboxState)&&(0,v.$cg)(Pe.checkboxState)?Pe.checkboxState.tooltip:void 0;if(qe===void 0||qe!==gt.Checked&&qe!==gt.Unchecked||xe!==void 0&&!(0,v.$ag)(xe))return console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1}if(N instanceof I)return!0;if(Pe.label!==void 0&&!(0,v.$ag)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,v.$ag)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,v.$ag)(Pe.iconPath)&&!s.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,v.$ag)(Pe.iconPath.id))){const qe=Pe.iconPath;if(!qe||!(0,v.$ag)(qe.light)&&!s.URI.isUri(qe.light)&&!(0,v.$ag)(qe.dark)&&!s.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}return Pe.description!==void 0&&!(0,v.$ag)(Pe.description)&&typeof Pe.description!="boolean"?(console.log("INVALID tree item, invalid description",Pe.description),!1):Pe.resourceUri!==void 0&&!s.URI.isUri(Pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1):Pe.tooltip!==void 0&&!(0,v.$ag)(Pe.tooltip)&&!(Pe.tooltip instanceof Ve)?(console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1):Pe.command!==void 0&&!Pe.command.command?(console.log("INVALID tree item, invalid command",Pe.command),!1):Pe.collapsibleState!==void 0&&Pe.collapsibleState<Rt.None&&Pe.collapsibleState>Rt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1):Pe.contextValue!==void 0&&!(0,v.$ag)(Pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1):Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1):!0}constructor(N,ce=Rt.None){this.collapsibleState=ce,s.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$kN=At,e.$kN=At=I=Ue([O],At);var Rt;(function(F){F[F.None=0]="None",F[F.Collapsed=1]="Collapsed",F[F.Expanded=2]="Expanded"})(Rt||(e.TreeItemCollapsibleState=Rt={}));var gt;(function(F){F[F.Unchecked=0]="Unchecked",F[F.Checked=1]="Checked"})(gt||(e.TreeItemCheckboxState=gt={}));let Mt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$lN=Mt,e.$lN=Mt=Ue([O],Mt);class qt extends Mt{}e.$mN=qt;class nn extends qt{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$nN=nn;class cn{constructor(N,ce,Pe,qe){this.name=N,this.uri=ce,this._itemId=Pe,this.c=qe}data(){return this.c()}}e.$oN=cn;let on=class{#e=new Map;constructor(N){for(const[ce,Pe]of N??[]){const qe=this.#e.get(this.#t(ce));qe?qe.push(Pe):this.#e.set(this.#t(ce),[Pe])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,ce){this.#e.set(this.#t(N),[ce])}forEach(N,ce){for(const[Pe,qe]of this.#e)for(const xe of qe)N.call(ce,xe,Pe,this)}*[Symbol.iterator](){for(const[N,ce]of this.#e)for(const Pe of ce)yield[N,Pe]}#t(N){return N.toLowerCase()}};e.$pN=on,e.$pN=on=Ue([O],on);let hn=class{constructor(N,ce,Pe){this.insertText=N,this.title=ce,this.kind=Pe}};e.$qN=hn,e.$qN=hn=Ue([O],hn);var dn;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(dn||(e.DocumentPasteTriggerKind=dn={}));class Yt{static{this.c="."}constructor(N){this.value=N}append(...N){return new Yt((this.value?[this.value,...N]:N).join(Yt.c))}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+Yt.c)}}e.$rN=Yt,Yt.Empty=new Yt("");class mn{constructor(N,ce,Pe){this.title=ce,this.insertText=N,this.kind=Pe}}e.$sN=mn;let xt=class{constructor(N,ce){this.id=N,this.color=ce}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$tN=xt,e.$tN=xt=Ue([O],xt),xt.File=new xt("file"),xt.Folder=new xt("folder");let un=class{constructor(N){this.id=N}};e.$uN=un,e.$uN=un=Ue([O],un);var gn;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.WorkspaceFolder=3]="WorkspaceFolder"})(gn||(e.ConfigurationTarget=gn={}));let fn=class{get base(){return this.c}set base(N){this.c=N,this.e=s.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ce){if(typeof N!="string"&&(!N||!s.URI.isUri(N)&&!s.URI.isUri(N.uri)))throw(0,r.$7)("base");if(typeof ce!="string")throw(0,r.$7)("pattern");typeof N=="string"?this.baseUri=s.URI.file(N):s.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ce}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vN=fn,e.$vN=fn=Ue([O],fn);const pn=new WeakMap;function $n(F,N){pn.set(F,N)}let rn=class{constructor(N,ce,Pe,qe,xe){this.enabled=typeof N=="boolean"?N:!0,typeof ce=="string"&&(this.condition=ce),typeof Pe=="string"&&(this.hitCondition=Pe),typeof qe=="string"&&(this.logMessage=qe),typeof xe=="string"&&(this.mode=xe)}get id(){return this.c||(this.c=pn.get(this)??(0,E.$Wg)()),this.c}};e.$xN=rn,e.$xN=rn=Ue([O],rn);let De=class extends rn{constructor(N,ce,Pe,qe,xe,st){if(super(ce,Pe,qe,xe,st),N===null)throw(0,r.$7)("location");this.location=N}};e.$yN=De,e.$yN=De=Ue([O],De);let Te=class extends rn{constructor(N,ce,Pe,qe,xe,st){super(ce,Pe,qe,xe,st),this.functionName=N}};e.$zN=Te,e.$zN=Te=Ue([O],Te);let ge=class extends rn{constructor(N,ce,Pe,qe,xe,st,at,kt){if(super(qe,xe,st,at,kt),!ce)throw(0,r.$7)("dataId");this.label=N,this.dataId=ce,this.canPersist=Pe}};e.$AN=ge,e.$AN=ge=Ue([O],ge);let K=class{constructor(N,ce,Pe){this.command=N,this.args=ce||[],this.options=Pe}};e.$BN=K,e.$BN=K=Ue([O],K);let Ce=class{constructor(N,ce){this.port=N,this.host=ce}};e.$CN=Ce,e.$CN=Ce=Ue([O],Ce);let je=class{constructor(N){this.path=N}};e.$DN=je,e.$DN=je=Ue([O],je);let Je=class{constructor(N){this.implementation=N}};e.$EN=Je,e.$EN=Je=Ue([O],Je);class Be{constructor(N,ce,Pe){this.session=N,this.threadId=ce,this.frameId=Pe}}e.$FN=Be;class rt{constructor(N,ce){this.session=N,this.threadId=ce}}e.$GN=rt;let ft=class{constructor(N,ce){this.range=N,this.expression=ce}};e.$HN=ft,e.$HN=ft=Ue([O],ft);var Ut;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Ut||(e.InlineCompletionTriggerKind=Ut={}));let Wt=class{constructor(N,ce){this.range=N,this.text=ce}};e.$IN=Wt,e.$IN=Wt=Ue([O],Wt);let vt=class{constructor(N,ce,Pe=!0){this.range=N,this.variableName=ce,this.caseSensitiveLookup=Pe}};e.$JN=vt,e.$JN=vt=Ue([O],vt);let zt=class{constructor(N,ce){this.range=N,this.expression=ce}};e.$KN=zt,e.$KN=zt=Ue([O],zt);let Dn=class{constructor(N,ce){this.frameId=N,this.stoppedLocation=ce}};e.$LN=Dn,e.$LN=Dn=Ue([O],Dn);var Mn;(function(F){F[F.AIGenerated=1]="AIGenerated"})(Mn||(e.NewSymbolNameTag=Mn={}));var Un;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Un||(e.NewSymbolNameTriggerKind=Un={}));class Di{constructor(N,ce){this.newSymbolName=N,this.tags=ce}}e.$MN=Di;var zn;(function(F){F[F.Changed=1]="Changed",F[F.Created=2]="Created",F[F.Deleted=3]="Deleted"})(zn||(e.FileChangeType=zn={}));let In=C=class extends Error{static FileExists(N){return new C(N,p.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(N){return new C(N,p.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(N){return new C(N,p.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(N){return new C(N,p.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(N){return new C(N,p.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(N){return new C(N,p.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(N,ce=p.FileSystemProviderErrorCode.Unknown,Pe){super(s.URI.isUri(N)?N.toString(!0):N),this.code=Pe?.name??"Unknown",(0,p.$jl)(this,ce),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}};e.$NN=In,e.$NN=In=C=Ue([O],In);let Pn=class{constructor(N,ce,Pe){this.start=N,this.end=ce,this.kind=Pe}};e.$ON=Pn,e.$ON=Pn=Ue([O],Pn);var Bn;(function(F){F[F.Comment=1]="Comment",F[F.Imports=2]="Imports",F[F.Region=3]="Region"})(Bn||(e.FoldingRangeKind=Bn={}));var Hn;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(Hn||(e.CommentThreadCollapsibleState=Hn={}));var qn;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(qn||(e.CommentMode=qn={}));var Wn;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(Wn||(e.CommentState=Wn={}));var Vn;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(Vn||(e.CommentThreadState=Vn={}));var Gn;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(Gn||(e.CommentThreadApplicability=Gn={}));class Ii{constructor(N,ce=[]){this.tokenTypes=N,this.tokenModifiers=ce}}e.$PN=Ii;function Pi(F){return typeof F>"u"||(0,v.$bg)(F)}class An{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,N){this.m=!0;for(let ce=0,Pe=N.tokenTypes.length;ce<Pe;ce++)this.k.set(N.tokenTypes[ce],ce);for(let ce=0,Pe=N.tokenModifiers.length;ce<Pe;ce++)this.l.set(N.tokenModifiers[ce],ce)}}push(N,ce,Pe,qe,xe){if(typeof N=="number"&&typeof ce=="number"&&typeof Pe=="number"&&typeof qe=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.q(N,ce,Pe,qe,xe);if(re.isRange(N)&&typeof ce=="string"&&Pi(Pe))return this.o(N,ce,Pe);throw(0,r.$7)()}o(N,ce,Pe){if(!this.m)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ce))throw new Error("`tokenType` is not in the provided legend");const qe=N.start.line,xe=N.start.character,st=N.end.character-N.start.character,at=this.k.get(ce);let kt=0;if(Pe)for(const Qt of Pe){if(!this.l.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this.l.get(Qt);kt|=1<<_t>>>0}this.q(qe,xe,st,at,kt)}q(N,ce,Pe,qe,xe){if(this.f&&(N<this.c||N===this.c&&ce<this.e)){this.f=!1;const kt=this.g.length/5|0;let Qt=0,_t=0;for(let tn=0;tn<kt;tn++){let sn=this.g[5*tn],bn=this.g[5*tn+1];sn===0?(sn=Qt,bn+=_t):sn+=Qt,this.g[5*tn]=sn,this.g[5*tn+1]=bn,Qt=sn,_t=bn}}let st=N,at=ce;this.f&&this.j>0&&(st-=this.c,st===0&&(at-=this.e)),this.g[this.j++]=st,this.g[this.j++]=at,this.g[this.j++]=Pe,this.g[this.j++]=qe,this.g[this.j++]=xe,this.c=N,this.e=ce}static r(N){const ce=[],Pe=N.length/5|0;for(let at=0;at<Pe;at++)ce[at]=at;ce.sort((at,kt)=>{const Qt=N[5*at],_t=N[5*kt];if(Qt===_t){const tn=N[5*at+1],sn=N[5*kt+1];return tn-sn}return Qt-_t});const qe=new Uint32Array(N.length);let xe=0,st=0;for(let at=0;at<Pe;at++){const kt=5*ce[at],Qt=N[kt+0],_t=N[kt+1],tn=N[kt+2],sn=N[kt+3],bn=N[kt+4],ki=Qt-xe,br=ki===0?_t-st:_t,wn=5*at;qe[wn+0]=ki,qe[wn+1]=br,qe[wn+2]=tn,qe[wn+3]=sn,qe[wn+4]=bn,xe=Qt,st=_t}return qe}build(N){return this.f?new Rn(new Uint32Array(this.g),N):new Rn(An.r(this.g),N)}}e.$QN=An;class Rn{constructor(N,ce){this.resultId=ce,this.data=N}}e.$RN=Rn;class Ai{constructor(N,ce,Pe){this.start=N,this.deleteCount=ce,this.data=Pe}}e.$SN=Ai;class Ri{constructor(N,ce){this.resultId=ce,this.edits=N}}e.$TN=Ri;var Kn;(function(F){F[F.Separate=0]="Separate",F[F.MergeWithParent=1]="MergeWithParent"})(Kn||(e.DebugConsoleMode=Kn={}));class Ci{constructor(N){this.name=N}}e.$UN=Ci;let Cn=class{static{this.Back={iconPath:new xt("arrow-left")}}constructor(){}};e.$VN=Cn,e.$VN=Cn=Ue([O],Cn);var Jn;(function(F){F[F.Separator=-1]="Separator",F[F.Default=0]="Default"})(Jn||(e.QuickPickItemKind=Jn={}));var xn;(function(F){F[F.Info=1]="Info",F[F.Warning=2]="Warning",F[F.Error=3]="Error"})(xn||(e.InputBoxValidationSeverity=xn={}));var Qn;(function(F){F[F.UI=1]="UI",F[F.Workspace=2]="Workspace"})(Qn||(e.ExtensionKind=Qn={}));class Ti{static validate(N){if(typeof N.badge=="string"){let ce=(0,R.$Lf)(N.badge,0);if(ce<N.badge.length&&(ce+=(0,R.$Lf)(N.badge,ce)),N.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!xt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ce,Pe){this.badge=N,this.tooltip=ce,this.color=Pe}}e.$WN=Ti;let Tn=class{constructor(N){this.kind=N}};e.$XN=Tn,e.$XN=Tn=Ue([O],Tn);var Zn;(function(F){F[F.Light=1]="Light",F[F.Dark=2]="Dark",F[F.HighContrast=3]="HighContrast",F[F.HighContrastLight=4]="HighContrastLight"})(Zn||(e.ColorThemeKind=Zn={}));class an{static isNotebookRange(N){return N instanceof an?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ce){if(N<0)throw(0,r.$7)("start must be positive");if(ce<0)throw(0,r.$7)("end must be positive");N<=ce?(this.c=N,this.e=ce):(this.c=ce,this.e=N)}with(N){let ce=this.c,Pe=this.e;return N.start!==void 0&&(ce=N.start),N.end!==void 0&&(Pe=N.end),ce===this.c&&Pe===this.e?this:new an(ce,Pe)}}e.$YN=an;class vn{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ce=>vn.isNotebookCellData(ce))}static isNotebookCellData(N){return!0}constructor(N,ce,Pe,qe,xe,st,at){this.kind=N,this.value=ce,this.languageId=Pe,this.mime=qe,this.outputs=xe??[],this.metadata=st,this.executionSummary=at,vn.validate(this)}}e.$ZN=vn;class Oi{constructor(N){this.cells=N}}e.$1N=Oi;class en{static isNotebookCellOutputItem(N){return N instanceof en?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ce={name:N.name,message:N.message,stack:N.stack};return en.json(ce,"application/vnd.code.notebook.error")}static stdout(N){return en.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return en.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ce="application/octet-stream"){return new en(N,ce)}static#e=new TextEncoder;static text(N,ce=A.$Ys.text){const Pe=en.#e.encode(String(N));return new en(Pe,ce)}static json(N,ce="text/x-json"){const Pe=JSON.stringify(N,void 0,"	");return en.text(Pe,ce)}constructor(N,ce){this.data=N,this.mime=ce;const Pe=(0,A.$3s)(ce,!0);if(!Pe)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}}e.$2N=en;class yn{static isNotebookCellOutput(N){return N instanceof yn?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ce=!1){const Pe=new Set,qe=new Set;for(let xe=0;xe<N.length;xe++){const st=N[xe],at=(0,A.$3s)(st.mime);if(!Pe.has(at)||(0,a.$qK)(at)){Pe.add(at);continue}qe.add(xe),ce&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return qe.size===0?N:N.filter((xe,st)=>!qe.has(st))}constructor(N,ce,Pe){this.items=yn.ensureUniqueMimeTypes(N,!0),typeof ce=="string"?(this.id=ce,this.metadata=Pe):(this.id=(0,E.$Wg)(),this.metadata=ce??Pe)}}e.$3N=yn;var Xn;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(Xn||(e.NotebookCellKind=Xn={}));var Yn;(function(F){F[F.Idle=1]="Idle",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(Yn||(e.NotebookCellExecutionState=Yn={}));var _n;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(_n||(e.NotebookCellStatusBarAlignment=_n={}));var ei;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Li{constructor(N,ce){this.text=N,this.alignment=ce}}e.$4N=Li;var ti;(function(F){F[F.Default=1]="Default",F[F.Preferred=2]="Preferred"})(ti||(e.NotebookControllerAffinity=ti={}));var ni;(function(F){F[F.Default=1]="Default",F[F.Preferred=2]="Preferred",F[F.Hidden=-1]="Hidden"})(ni||(e.NotebookControllerAffinity2=ni={}));class Ni{constructor(N,ce=[]){this.uri=N,this.provides=(0,n.$2b)(ce)}}e.$5N=Ni;class Fi{constructor(N){this.label=N}}e.$6N=Fi;var ii;(function(F){F[F.Named=1]="Named",F[F.Indexed=2]="Indexed"})(ii||(e.NotebookVariablesRequestKind=ii={}));let On=class{constructor(N,ce){this.label=N,this.timestamp=ce}};e.$7N=On,e.$7N=On=Ue([O],On);var ri;(function(F){F[F.Production=1]="Production",F[F.Development=2]="Development",F[F.Test=3]="Test"})(ri||(e.ExtensionMode=ri={}));var si;(function(F){F[F.Node=1]="Node",F[F.Webworker=2]="Webworker"})(si||(e.ExtensionRuntime=si={}));var oi;(function(F){F[F.Other=0]="Other",F[F.Comment=1]="Comment",F[F.String=2]="String",F[F.RegEx=3]="RegEx"})(oi||(e.StandardTokenType=oi={}));class ji{constructor(N,ce){this.ranges=N,this.wordPattern=ce}}e.$8N=ji;class Mi{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$9N=Mi;var ai;(function(F){F[F.Queued=1]="Queued",F[F.Running=2]="Running",F[F.Passed=3]="Passed",F[F.Failed=4]="Failed",F[F.Skipped=5]="Skipped",F[F.Errored=6]="Errored"})(ai||(e.TestResultState=ai={}));var li;(function(F){F[F.Run=1]="Run",F[F.Debug=2]="Debug",F[F.Coverage=3]="Coverage"})(li||(e.TestRunProfileKind=li={}));let Ln=class{constructor(N=void 0,ce=void 0,Pe=void 0,qe=!1,xe=!0){this.include=N,this.exclude=ce,this.profile=Pe,this.continuous=qe,this.preserveFocus=xe}};e.$0N=Ln,e.$0N=Ln=Ue([O],Ln);let Nn=T=class{static diff(N,ce,Pe){const qe=new T(N);return qe.expectedOutput=ce,qe.actualOutput=Pe,qe}constructor(N){this.message=N}};e.$$N=Nn,e.$$N=Nn=T=Ue([O],Nn);let Fn=class{constructor(N){this.id=N}};e.$_N=Fn,e.$_N=Fn=Ue([O],Fn);class En{constructor(N,ce){this.covered=N,this.total=ce,ci(this)}}e.$aO=En;function ci(F){if(F){if(F.covered>F.total)throw new Error(`The total number of covered items (${F.covered}) cannot be greater than the total (${F.total})`);if(F.total<0)throw new Error(`The number of covered items (${F.total}) cannot be negative`)}}class jn{static fromDetails(N,ce){const Pe=new En(0,0),qe=new En(0,0),xe=new En(0,0);for(const at of ce)if("branches"in at){Pe.total+=1,Pe.covered+=at.executed?1:0;for(const kt of at.branches)qe.total+=1,qe.covered+=kt.executed?1:0}else xe.total+=1,xe.covered+=at.executed?1:0;const st=new jn(N,Pe,qe.total>0?qe:void 0,xe.total>0?xe:void 0);return st.detailedCoverage=ce,st}constructor(N,ce,Pe,qe,xe){this.uri=N,this.statementCoverage=ce,this.branchCoverage=Pe,this.declarationCoverage=qe,this.testItem=xe}}e.$cO=jn;class Ui{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ce,Pe=[]){this.executed=N,this.location=ce,this.branches=Pe}}e.$dO=Ui;class zi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ce,Pe){this.executed=N,this.location=ce,this.label=Pe}}e.$eO=zi;class Bi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ce,Pe){this.name=N,this.executed=ce,this.location=Pe}}e.$fO=Bi;var ui;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(ui||(e.ExternalUriOpenerPriority=ui={}));var hi;(function(F){F[F.Untrusted=0]="Untrusted",F[F.Trusted=1]="Trusted",F[F.Unspecified=2]="Unspecified"})(hi||(e.WorkspaceTrustState=hi={}));var fi;(function(F){F[F.Notify=1]="Notify",F[F.OpenBrowser=2]="OpenBrowser",F[F.OpenPreview=3]="OpenPreview",F[F.Silent=4]="Silent",F[F.Ignore=5]="Ignore",F[F.OpenBrowserOnce=6]="OpenBrowserOnce"})(fi||(e.PortAutoForwardAction=fi={}));class Hi{constructor(N,ce,Pe,qe,xe,st){this.kind=N,this.name=ce,this.detail=Pe,this.uri=qe,this.range=xe,this.selectionRange=st}}e.$gO=Hi;class qi{constructor(N){this.uri=N}}e.$hO=qi;class Wi{constructor(N,ce){this.original=N,this.modified=ce}}e.$iO=Wi;class Vi{constructor(N,ce,Pe,qe){this.base=N,this.input1=ce,this.input2=Pe,this.result=qe}}e.$jO=Vi;class Gi{constructor(N,ce){this.uri=N,this.viewType=ce}}e.$kO=Gi;class Ki{constructor(N){this.viewType=N}}e.$lO=Ki;class Ji{constructor(N,ce){this.uri=N,this.notebookType=ce}}e.$mO=Ji;class xi{constructor(N,ce,Pe){this.original=N,this.modified=ce,this.notebookType=Pe}}e.$nO=xi;class Qi{constructor(){}}e.$oO=Qi;class Zi{constructor(N,ce){this.uri=N,this.inputBoxUri=ce}}e.$pO=Zi;class Xi{constructor(){}}e.$qO=Xi;class Yi{constructor(N){this.textDiffs=N}}e.$rO=Yi;var di;(function(F){F[F.Down=0]="Down",F[F.Up=1]="Up"})(di||(e.InteractiveSessionVoteDirection=di={}));var mi;(function(F){F[F.Action=1]="Action",F[F.Toolbar=2]="Toolbar"})(mi||(e.ChatCopyKind=mi={}));var gi;(function(F){F[F.Short=1]="Short",F[F.Medium=2]="Medium",F[F.Full=3]="Full"})(gi||(e.ChatVariableLevel=gi={}));class _i{constructor(N,ce,Pe){this.id=N,this.label=ce,this.values=Pe}}e.$sO=_i;var pi;(function(F){F[F.Unhelpful=0]="Unhelpful",F[F.Helpful=1]="Helpful",F[F.Undone=2]="Undone",F[F.Accepted=3]="Accepted",F[F.Bug=4]="Bug"})(pi||(e.InteractiveEditorResponseFeedbackKind=pi={}));var $i;(function(F){F[F.Unhelpful=0]="Unhelpful",F[F.Helpful=1]="Helpful"})($i||(e.ChatResultFeedbackKind=$i={}));class er{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new Ve(N):N}}e.$tO=er;class tr{constructor(N,ce){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new Ve(N):N,this.vulnerabilities=ce}}e.$uO=tr;class nr{constructor(N,ce){this.participant=N,this.command=ce}}e.$vO=nr;class ir{constructor(N,ce,Pe){this.title=N,this.message=ce,this.data=Pe}}e.$wO=ir;class rr{constructor(N,ce){this.value=N,this.baseUri=ce}}e.$xO=rr;class sr{constructor(N,ce){this.value=N,this.title=ce}}e.$yO=sr;class or{constructor(N){this.value=N}}e.$zO=or;class ar{constructor(N,ce){this.value=N,this.task=ce}}e.$AO=ar;class lr{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new Ve(N):N}}e.$BO=lr;class cr{constructor(N){this.value=N}}e.$CO=cr;class ur{constructor(N,ce){this.value=N,this.iconPath=ce}}e.$DO=ur;class hr{constructor(N,ce){this.uri=N,this.edits=Array.isArray(ce)?ce:[ce]}}e.$EO=hr;class fr{constructor(N,ce,Pe,qe){this.prompt=N,this.command=ce,this.references=Pe,this.participant=qe}}e.$FO=fr;class dr{constructor(N,ce,Pe,qe){this.response=N,this.result=ce,this.participant=Pe,this.command=qe}}e.$GO=dr;var bi;(function(F){F[F.Panel=1]="Panel",F[F.Terminal=2]="Terminal",F[F.Notebook=3]="Notebook",F[F.Editor=4]="Editor"})(bi||(e.ChatLocation=bi={}));var Sn;(function(F){F[F.User=1]="User",F[F.Assistant=2]="Assistant",F[F.System=3]="System"})(Sn||(e.LanguageModelChatMessageRole=Sn={}));class kn{static User(N,ce){return new kn(Sn.User,N,ce)}static Assistant(N,ce){return new kn(Sn.Assistant,N,ce)}constructor(N,ce,Pe){this.role=N,this.content=ce,this.name=Pe}}e.$HO=kn;class mr{constructor(N){this.content=N}}e.$IO=mr;class gr{constructor(N,ce){this.content=N,this.name=ce}}e.$JO=gr;class pr{constructor(N,ce){this.content=N,this.name=ce}}e.$KO=pr;class ln extends Error{static NotFound(N){return new ln(N,ln.NotFound.name)}static NoPermissions(N){return new ln(N,ln.NoPermissions.name)}static Blocked(N){return new ln(N,ln.Blocked.name)}constructor(N,ce,Pe){super(N,{cause:Pe}),this.name="LanguageModelError",this.code=ce??""}}e.$LO=ln;var wi;(function(F){F[F.SymbolInformation=1]="SymbolInformation",F[F.CommandInformation=2]="CommandInformation",F[F.SearchInformation=3]="SearchInformation",F[F.SettingInformation=4]="SettingInformation"})(wi||(e.RelatedInformationType=wi={}));var vi;(function(F){F[F.Started=1]="Started",F[F.Recognizing=2]="Recognizing",F[F.Recognized=3]="Recognized",F[F.Stopped=4]="Stopped",F[F.Error=5]="Error"})(vi||(e.SpeechToTextStatus=vi={}));var yi;(function(F){F[F.Started=1]="Started",F[F.Stopped=2]="Stopped",F[F.Error=3]="Error"})(yi||(e.TextToSpeechStatus=yi={}));var Ei;(function(F){F[F.Recognized=1]="Recognized",F[F.Stopped=2]="Stopped"})(Ei||(e.KeywordRecognitionStatus=Ei={}));class $r{constructor(N,ce){this.text=N,this.range=ce}}e.$MO=$r;var Si;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Si||(e.InlineEditTriggerKind=Si={}))}),define(Ee[153],Se([1,0,18,15,174,78,111,26,160,49,68,21,166,20,81,11,4,248,48,110,200,181,260,261,147,102,301,315,302,151,75,103,149,152]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m,$,l,t,o,d,i,c,u,k,I,C,T,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$VO=le,e.$WO=q,e.$XO=ae;var V;(function(De){function Te(K){const{selectionStartLineNumber:Ce,selectionStartColumn:je,positionLineNumber:Je,positionColumn:Be}=K,rt=new P.$xM(Ce-1,je-1),ft=new P.$xM(Je-1,Be-1);return new P.$zM(rt,ft)}De.to=Te;function ge(K){const{anchor:Ce,active:je}=K;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}De.from=ge})(V||(e.Selection=V={}));var Q;(function(De){function Te(K){if(!K)return;const{start:Ce,end:je}=K;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}De.from=Te;function ge(K){if(!K)return;const{startLineNumber:Ce,startColumn:je,endLineNumber:Je,endColumn:Be}=K;return new P.$yM(Ce-1,je-1,Je-1,Be-1)}De.to=ge})(Q||(e.Range=Q={}));var ie;(function(De){function Te(K){return{uri:K.uri,range:Q.from(K.range)}}De.from=Te;function ge(K){return new P.$IM(h.URI.revive(K.uri),Q.to(K.range))}De.to=ge})(ie||(e.Location=ie={}));var re;(function(De){function Te(ge){switch(ge){case m.StandardTokenType.Comment:return P.StandardTokenType.Comment;case m.StandardTokenType.Other:return P.StandardTokenType.Other;case m.StandardTokenType.RegEx:return P.StandardTokenType.RegEx;case m.StandardTokenType.String:return P.StandardTokenType.String}}De.to=Te})(re||(e.TokenType=re={}));var ne;(function(De){function Te(K){return new P.$xM(K.lineNumber-1,K.column-1)}De.to=Te;function ge(K){return{lineNumber:K.line+1,column:K.character+1}}De.from=ge})(ne||(e.Position=ne={}));var se;(function(De){function Te(Ce,je,Je){return(0,n.$Hb)((0,n.$2b)(Ce).map(Be=>ge(Be,je,Je)))}De.from=Te;function ge(Ce,je,Je){if(typeof Ce=="string")return{$serialized:!0,language:Ce,isBuiltin:Je?.isBuiltin};if(Ce)return{$serialized:!0,language:Ce.language,scheme:K(Ce.scheme,je),pattern:Ye.from(Ce.pattern)??void 0,exclusive:Ce.exclusive,notebookType:Ce.notebookType,isBuiltin:Je?.isBuiltin}}function K(Ce,je){return je&&typeof Ce=="string"?je.transformOutgoingScheme(Ce):Ce}})(se||(e.DocumentSelector=se={}));var Z;(function(De){function Te(K){switch(K){case P.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case P.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}De.from=Te;function ge(K){switch(K){case t.MarkerTag.Unnecessary:return P.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return P.DiagnosticTag.Deprecated;default:return}}De.to=ge})(Z||(e.DiagnosticTag=Z={}));var ee;(function(De){function Te(K){let Ce;return K.code&&((0,f.$ag)(K.code)||(0,f.$eg)(K.code)?Ce=String(K.code):Ce={value:String(K.code.value),target:K.code.target}),{...Q.from(K.range),message:K.message,source:K.source,code:Ce,severity:j.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(ue.from),tags:Array.isArray(K.tags)?(0,n.$Hb)(K.tags.map(Z.from)):void 0}}De.from=Te;function ge(K){const Ce=new P.$KM(Q.to(K),K.message,j.to(K.severity));return Ce.source=K.source,Ce.code=(0,f.$ag)(K.code)?K.code:K.code?.value,Ce.relatedInformation=K.relatedInformation&&K.relatedInformation.map(ue.to),Ce.tags=K.tags&&(0,n.$Hb)(K.tags.map(Z.to)),Ce}De.to=ge})(ee||(e.Diagnostic=ee={}));var ue;(function(De){function Te(K){return{...Q.from(K.location.range),message:K.message,resource:K.location.uri}}De.from=Te;function ge(K){return new P.$JM(new P.$IM(K.resource,Q.to(K)),K.message)}De.to=ge})(ue||(e.DiagnosticRelatedInformation=ue={}));var j;(function(De){function Te(K){switch(K){case P.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case P.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case P.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case P.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}De.from=Te;function ge(K){switch(K){case t.MarkerSeverity.Info:return P.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return P.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return P.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return P.DiagnosticSeverity.Hint;default:return P.DiagnosticSeverity.Error}}De.to=ge})(j||(e.DiagnosticSeverity=j={}));var B;(function(De){function Te(K){return typeof K=="number"&&K>=P.ViewColumn.One?K-1:K===P.ViewColumn.Beside?O.$dE:O.$cE}De.from=Te;function ge(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=ge})(B||(e.ViewColumn=B={}));function oe(De){return typeof De.range<"u"}function le(De){return De.length===0?!0:!!oe(De[0])}var pe;(function(De){function Te(Be){return Be.map(De.from)}De.fromMany=Te;function ge(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function K(Be){let rt;if(ge(Be)){const{language:vt,value:zt}=Be;rt={value:"```"+vt+`
`+zt+"\n```\n"}}else P.$YM.isMarkdownString(Be)?rt={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?rt={value:Be}:rt={value:""};const ft=Object.create(null);rt.uris=ft;const Ut=vt=>{try{let zt=h.URI.parse(vt,!0);zt=zt.with({query:Ce(zt.query,ft)}),ft[vt]=zt}catch{}return""},Wt=new v.marked.Renderer;return Wt.link=Ut,Wt.image=vt=>typeof vt=="string"?Ut(A.$6k(vt).href):"",(0,v.marked)(rt.value,{renderer:Wt}),rt}De.from=K;function Ce(Be,rt){if(!Be)return Be;let ft;try{ft=(0,s.$9h)(Be)}catch{}if(!ft)return Be;let Ut=!1;return ft=(0,y.$$n)(ft,Wt=>{if(h.URI.isUri(Wt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[vt]=Wt,Ut=!0,vt}else return}),Ut?JSON.stringify(ft):Be}function je(Be){const rt=new P.$YM(Be.value,Be.supportThemeIcons);return rt.isTrusted=Be.isTrusted,rt.supportHtml=Be.supportHtml,rt.baseUri=Be.baseUri?h.URI.from(Be.baseUri):void 0,rt}De.to=je;function Je(Be){if(Be)return typeof Be=="string"?Be:De.from(Be)}De.fromStrict=Je})(pe||(e.MarkdownString=pe={}));function q(De){return le(De)?De.map(Te=>({range:Q.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?pe.fromMany(Te.hoverMessage):Te.hoverMessage?pe.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):De.map(Te=>({range:Q.from(Te)}))}function ae(De){return typeof De>"u"?De:typeof De=="string"?h.URI.file(De):De}var Y;(function(De){function Te(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?ae(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}De.from=Te})(Y||(e.ThemableDecorationAttachmentRenderOptions=Y={}));var H;(function(De){function Te(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?ae(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?Y.from(ge.before):void 0,after:ge.after?Y.from(ge.after):void 0}}De.from=Te})(H||(e.ThemableDecorationRenderOptions=H={}));var L;(function(De){function Te(ge){if(typeof ge>"u")return ge;switch(ge){case P.DecorationRangeBehavior.OpenOpen:return l.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case P.DecorationRangeBehavior.ClosedClosed:return l.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case P.DecorationRangeBehavior.OpenClosed:return l.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case P.DecorationRangeBehavior.ClosedOpen:return l.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}De.from=Te})(L||(e.DecorationRangeBehavior=L={}));var W;(function(De){function Te(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?L.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?H.from(ge.light):void 0,dark:ge.dark?H.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?ae(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?Y.from(ge.before):void 0,after:ge.after?Y.from(ge.after):void 0}}De.from=Te})(W||(e.DecorationRenderOptions=W={}));var z;(function(De){function Te(K){return{text:K.newText,eol:K.newEol&&X.from(K.newEol),range:Q.from(K.range)}}De.from=Te;function ge(K){const Ce=new P.$DM(Q.to(K.range),K.text);return Ce.newEol=typeof K.eol>"u"?void 0:X.to(K.eol),Ce}De.to=ge})(z||(e.TextEdit=z={}));var U;(function(De){function Te(K,Ce){const je={edits:[]};if(K instanceof P.$GM){const Je=new R.$Bc;for(const Be of K._allEntries())Be._type===P.FileEditType.File&&h.URI.isUri(Be.to)&&Be.from===void 0&&Je.add(Be.to);for(const Be of K._allEntries())if(Be._type===P.FileEditType.File){let rt;Be.options?.contents&&(ArrayBuffer.isView(Be.options.contents)?rt={type:"base64",value:(0,r.$4e)(r.$Je.wrap(Be.options.contents))}:rt={type:"dataTransferItem",id:Be.options.contents._itemId}),je.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contents:rt},metadata:Be.metadata})}else Be._type===P.FileEditType.Text?je.edits.push({resource:Be.uri,textEdit:z.from(Be.edit),versionId:Je.has(Be.uri)?void 0:Ce?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===P.FileEditType.Snippet?je.edits.push({resource:Be.uri,textEdit:{range:Q.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:Je.has(Be.uri)?void 0:Ce?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===P.FileEditType.Cell?je.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Ce?.getNotebookDocumentVersion(Be.uri)}):Be._type===P.FileEditType.CellReplace&&je.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Ce?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:I.CellEditType.Replace,index:Be.index,count:Be.count,cells:Be.cells.map(mt.from)}})}return je}De.from=Te;function ge(K){const Ce=new P.$GM,je=new R.$Ac;for(const Je of K.edits)if(Je.textEdit){const Be=Je,rt=h.URI.revive(Be.resource),ft=Q.to(Be.textEdit.range),Ut=Be.textEdit.text,Wt=Be.textEdit.insertAsSnippet;let vt;Wt?vt=P.$FM.replace(ft,new P.$HM(Ut)):vt=P.$DM.replace(ft,Ut);const zt=je.get(rt);zt?zt.push(vt):je.set(rt,[vt])}else Ce.renameFile(h.URI.revive(Je.oldResource),h.URI.revive(Je.newResource),Je.options);for(const[Je,Be]of je)Ce.set(Je,Be);return Ce}De.to=ge})(U||(e.WorkspaceEdit=U={}));var J;(function(De){const Te=Object.create(null);Te[P.SymbolKind.File]=$.SymbolKind.File,Te[P.SymbolKind.Module]=$.SymbolKind.Module,Te[P.SymbolKind.Namespace]=$.SymbolKind.Namespace,Te[P.SymbolKind.Package]=$.SymbolKind.Package,Te[P.SymbolKind.Class]=$.SymbolKind.Class,Te[P.SymbolKind.Method]=$.SymbolKind.Method,Te[P.SymbolKind.Property]=$.SymbolKind.Property,Te[P.SymbolKind.Field]=$.SymbolKind.Field,Te[P.SymbolKind.Constructor]=$.SymbolKind.Constructor,Te[P.SymbolKind.Enum]=$.SymbolKind.Enum,Te[P.SymbolKind.Interface]=$.SymbolKind.Interface,Te[P.SymbolKind.Function]=$.SymbolKind.Function,Te[P.SymbolKind.Variable]=$.SymbolKind.Variable,Te[P.SymbolKind.Constant]=$.SymbolKind.Constant,Te[P.SymbolKind.String]=$.SymbolKind.String,Te[P.SymbolKind.Number]=$.SymbolKind.Number,Te[P.SymbolKind.Boolean]=$.SymbolKind.Boolean,Te[P.SymbolKind.Array]=$.SymbolKind.Array,Te[P.SymbolKind.Object]=$.SymbolKind.Object,Te[P.SymbolKind.Key]=$.SymbolKind.Key,Te[P.SymbolKind.Null]=$.SymbolKind.Null,Te[P.SymbolKind.EnumMember]=$.SymbolKind.EnumMember,Te[P.SymbolKind.Struct]=$.SymbolKind.Struct,Te[P.SymbolKind.Event]=$.SymbolKind.Event,Te[P.SymbolKind.Operator]=$.SymbolKind.Operator,Te[P.SymbolKind.TypeParameter]=$.SymbolKind.TypeParameter;function ge(Ce){return typeof Te[Ce]=="number"?Te[Ce]:$.SymbolKind.Property}De.from=ge;function K(Ce){for(const je in Te)if(Te[je]===Ce)return Number(je);return P.SymbolKind.Property}De.to=K})(J||(e.SymbolKind=J={}));var x;(function(De){function Te(K){switch(K){case P.SymbolTag.Deprecated:return $.SymbolTag.Deprecated}}De.from=Te;function ge(K){switch(K){case $.SymbolTag.Deprecated:return P.SymbolTag.Deprecated}}De.to=ge})(x||(e.SymbolTag=x={}));var M;(function(De){function Te(K){return{name:K.name,kind:J.from(K.kind),tags:K.tags&&K.tags.map(x.from),containerName:K.containerName,location:Ne.from(K.location)}}De.from=Te;function ge(K){const Ce=new P.$PM(K.name,J.to(K.kind),K.containerName,Ne.to(K.location));return Ce.tags=K.tags&&K.tags.map(x.to),Ce}De.to=ge})(M||(e.WorkspaceSymbol=M={}));var G;(function(De){function Te(K){const Ce={name:K.name||"!!MISSING: name!!",detail:K.detail,range:Q.from(K.range),selectionRange:Q.from(K.selectionRange),kind:J.from(K.kind),tags:K.tags?.map(x.from)??[]};return K.children&&(Ce.children=K.children.map(Te)),Ce}De.from=Te;function ge(K){const Ce=new P.$QM(K.name,K.detail,J.to(K.kind),Q.to(K.range),Q.to(K.selectionRange));return(0,n.$Lb)(K.tags)&&(Ce.tags=K.tags.map(x.to)),K.children&&(Ce.children=K.children.map(ge)),Ce}De.to=ge})(G||(e.DocumentSymbol=G={}));var te;(function(De){function Te(K){const Ce=new P.$UM(J.to(K.kind),K.name,K.detail||"",h.URI.revive(K.uri),Q.to(K.range),Q.to(K.selectionRange));return Ce._sessionId=K._sessionId,Ce._itemId=K._itemId,Ce}De.to=Te;function ge(K,Ce,je){if(Ce=Ce??K._sessionId,je=je??K._itemId,Ce===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:je,name:K.name,detail:K.detail,kind:J.from(K.kind),uri:K.uri,range:Q.from(K.range),selectionRange:Q.from(K.selectionRange),tags:K.tags?.map(x.from)}}De.from=ge})(te||(e.CallHierarchyItem=te={}));var he;(function(De){function Te(ge){return new P.$VM(te.to(ge.from),ge.fromRanges.map(K=>Q.to(K)))}De.to=Te})(he||(e.CallHierarchyIncomingCall=he={}));var ke;(function(De){function Te(ge){return new P.$WM(te.to(ge.to),ge.fromRanges.map(K=>Q.to(K)))}De.to=Te})(ke||(e.CallHierarchyOutgoingCall=ke={}));var Ne;(function(De){function Te(K){return{range:K.range&&Q.from(K.range),uri:K.uri}}De.from=Te;function ge(K){return new P.$IM(h.URI.revive(K.uri),Q.to(K.range))}De.to=ge})(Ne||(e.location=Ne={}));var me;(function(De){function Te(K){const Ce=K,je=K;return{originSelectionRange:Ce.originSelectionRange?Q.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:je.uri,range:Q.from(Ce.targetRange?Ce.targetRange:je.range),targetSelectionRange:Ce.targetSelectionRange?Q.from(Ce.targetSelectionRange):void 0}}De.from=Te;function ge(K){return{targetUri:h.URI.revive(K.uri),targetRange:Q.to(K.range),targetSelectionRange:K.targetSelectionRange?Q.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?Q.to(K.originSelectionRange):void 0}}De.to=ge})(me||(e.DefinitionLink=me={}));var be;(function(De){function Te(K){return{range:Q.from(K.range),contents:pe.fromMany(K.contents),canIncreaseVerbosity:K.canIncreaseVerbosity,canDecreaseVerbosity:K.canDecreaseVerbosity}}De.from=Te;function ge(K){const Ce=K.contents.map(pe.to),je=Q.to(K.range),Je=K.canIncreaseVerbosity,Be=K.canDecreaseVerbosity;return new P.$MM(Ce,je,Je,Be)}De.to=ge})(be||(e.Hover=be={}));var Ae;(function(De){function Te(K){return{range:Q.from(K.range),expression:K.expression}}De.from=Te;function ge(K){return new P.$HN(Q.to(K.range),K.expression)}De.to=ge})(Ae||(e.EvaluatableExpression=Ae={}));var Le;(function(De){function Te(K){if(K instanceof P.$IN)return{type:"text",range:Q.from(K.range),text:K.text};if(K instanceof P.$JN)return{type:"variable",range:Q.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof P.$KN)return{type:"expression",range:Q.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Te;function ge(K){switch(K.type){case"text":return{range:Q.to(K.range),text:K.text};case"variable":return{range:Q.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:Q.to(K.range),expression:K.expression}}}De.to=ge})(Le||(e.InlineValue=Le={}));var de;(function(De){function Te(K){return{frameId:K.frameId,stoppedLocation:Q.from(K.stoppedLocation)}}De.from=Te;function ge(K){return new P.$LN(K.frameId,Q.to(K.stoppedLocation))}De.to=ge})(de||(e.InlineValueContext=de={}));var Ie;(function(De){function Te(K){return{range:Q.from(K.range),kind:K.kind}}De.from=Te;function ge(K){return new P.$NM(Q.to(K.range),K.kind)}De.to=ge})(Ie||(e.DocumentHighlight=Ie={}));var Re;(function(De){function Te(K){return{uri:K.uri,highlights:K.highlights.map(Ie.from)}}De.from=Te;function ge(K){return new P.$OM(h.URI.revive(K.uri),K.highlights.map(Ie.to))}De.to=ge})(Re||(e.MultiDocumentHighlight=Re={}));var Me;(function(De){function Te(ge){switch(ge){case $.CompletionTriggerKind.TriggerCharacter:return P.CompletionTriggerKind.TriggerCharacter;case $.CompletionTriggerKind.TriggerForIncompleteCompletions:return P.CompletionTriggerKind.TriggerForIncompleteCompletions;case $.CompletionTriggerKind.Invoke:default:return P.CompletionTriggerKind.Invoke}}De.to=Te})(Me||(e.CompletionTriggerKind=Me={}));var He;(function(De){function Te(ge){return{triggerKind:Me.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}De.to=Te})(He||(e.CompletionContext=He={}));var Ke;(function(De){function Te(K){switch(K){case P.CompletionItemTag.Deprecated:return $.CompletionItemTag.Deprecated}}De.from=Te;function ge(K){switch(K){case $.CompletionItemTag.Deprecated:return P.CompletionItemTag.Deprecated}}De.to=ge})(Ke||(e.CompletionItemTag=Ke={}));var We;(function(De){const Te=new Map([[P.CompletionItemKind.Method,$.CompletionItemKind.Method],[P.CompletionItemKind.Function,$.CompletionItemKind.Function],[P.CompletionItemKind.Constructor,$.CompletionItemKind.Constructor],[P.CompletionItemKind.Field,$.CompletionItemKind.Field],[P.CompletionItemKind.Variable,$.CompletionItemKind.Variable],[P.CompletionItemKind.Class,$.CompletionItemKind.Class],[P.CompletionItemKind.Interface,$.CompletionItemKind.Interface],[P.CompletionItemKind.Struct,$.CompletionItemKind.Struct],[P.CompletionItemKind.Module,$.CompletionItemKind.Module],[P.CompletionItemKind.Property,$.CompletionItemKind.Property],[P.CompletionItemKind.Unit,$.CompletionItemKind.Unit],[P.CompletionItemKind.Value,$.CompletionItemKind.Value],[P.CompletionItemKind.Constant,$.CompletionItemKind.Constant],[P.CompletionItemKind.Enum,$.CompletionItemKind.Enum],[P.CompletionItemKind.EnumMember,$.CompletionItemKind.EnumMember],[P.CompletionItemKind.Keyword,$.CompletionItemKind.Keyword],[P.CompletionItemKind.Snippet,$.CompletionItemKind.Snippet],[P.CompletionItemKind.Text,$.CompletionItemKind.Text],[P.CompletionItemKind.Color,$.CompletionItemKind.Color],[P.CompletionItemKind.File,$.CompletionItemKind.File],[P.CompletionItemKind.Reference,$.CompletionItemKind.Reference],[P.CompletionItemKind.Folder,$.CompletionItemKind.Folder],[P.CompletionItemKind.Event,$.CompletionItemKind.Event],[P.CompletionItemKind.Operator,$.CompletionItemKind.Operator],[P.CompletionItemKind.TypeParameter,$.CompletionItemKind.TypeParameter],[P.CompletionItemKind.Issue,$.CompletionItemKind.Issue],[P.CompletionItemKind.User,$.CompletionItemKind.User]]);function ge(je){return Te.get(je)??$.CompletionItemKind.Property}De.from=ge;const K=new Map([[$.CompletionItemKind.Method,P.CompletionItemKind.Method],[$.CompletionItemKind.Function,P.CompletionItemKind.Function],[$.CompletionItemKind.Constructor,P.CompletionItemKind.Constructor],[$.CompletionItemKind.Field,P.CompletionItemKind.Field],[$.CompletionItemKind.Variable,P.CompletionItemKind.Variable],[$.CompletionItemKind.Class,P.CompletionItemKind.Class],[$.CompletionItemKind.Interface,P.CompletionItemKind.Interface],[$.CompletionItemKind.Struct,P.CompletionItemKind.Struct],[$.CompletionItemKind.Module,P.CompletionItemKind.Module],[$.CompletionItemKind.Property,P.CompletionItemKind.Property],[$.CompletionItemKind.Unit,P.CompletionItemKind.Unit],[$.CompletionItemKind.Value,P.CompletionItemKind.Value],[$.CompletionItemKind.Constant,P.CompletionItemKind.Constant],[$.CompletionItemKind.Enum,P.CompletionItemKind.Enum],[$.CompletionItemKind.EnumMember,P.CompletionItemKind.EnumMember],[$.CompletionItemKind.Keyword,P.CompletionItemKind.Keyword],[$.CompletionItemKind.Snippet,P.CompletionItemKind.Snippet],[$.CompletionItemKind.Text,P.CompletionItemKind.Text],[$.CompletionItemKind.Color,P.CompletionItemKind.Color],[$.CompletionItemKind.File,P.CompletionItemKind.File],[$.CompletionItemKind.Reference,P.CompletionItemKind.Reference],[$.CompletionItemKind.Folder,P.CompletionItemKind.Folder],[$.CompletionItemKind.Event,P.CompletionItemKind.Event],[$.CompletionItemKind.Operator,P.CompletionItemKind.Operator],[$.CompletionItemKind.TypeParameter,P.CompletionItemKind.TypeParameter],[$.CompletionItemKind.User,P.CompletionItemKind.User],[$.CompletionItemKind.Issue,P.CompletionItemKind.Issue]]);function Ce(je){return K.get(je)??P.CompletionItemKind.Property}De.to=Ce})(We||(e.CompletionItemKind=We={}));var Ve;(function(De){function Te(ge,K){const Ce=new P.$5M(ge.label);return Ce.insertText=ge.insertText,Ce.kind=We.to(ge.kind),Ce.tags=ge.tags?.map(Ke.to),Ce.detail=ge.detail,Ce.documentation=A.$Zk(ge.documentation)?pe.to(ge.documentation):ge.documentation,Ce.sortText=ge.sortText,Ce.filterText=ge.filterText,Ce.preselect=ge.preselect,Ce.commitCharacters=ge.commitCharacters,w.$ct.isIRange(ge.range)?Ce.range=Q.to(ge.range):typeof ge.range=="object"&&(Ce.range={inserting:Q.to(ge.range.insert),replacing:Q.to(ge.range.replace)}),Ce.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&$.CompletionItemInsertTextRule.KeepWhitespace),typeof ge.insertTextRules<"u"&&ge.insertTextRules&$.CompletionItemInsertTextRule.InsertAsSnippet?Ce.insertText=new P.$HM(ge.insertText):(Ce.insertText=ge.insertText,Ce.textEdit=Ce.range instanceof P.$yM?new P.$DM(Ce.range,Ce.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Ce.additionalTextEdits=ge.additionalTextEdits.map(je=>z.to(je))),Ce.command=K&&ge.command?K.fromInternal(ge.command):void 0,Ce}De.to=Te})(Ve||(e.CompletionItem=Ve={}));var Ze;(function(De){function Te(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:pe.fromStrict(K.documentation)}}De.from=Te;function ge(K){return{label:K.label,documentation:A.$Zk(K.documentation)?pe.to(K.documentation):K.documentation}}De.to=ge})(Ze||(e.ParameterInformation=Ze={}));var nt;(function(De){function Te(K){return{label:K.label,documentation:pe.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(Ze.from):[],activeParameter:K.activeParameter}}De.from=Te;function ge(K){return{label:K.label,documentation:A.$Zk(K.documentation)?pe.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Ze.to):[],activeParameter:K.activeParameter}}De.to=ge})(nt||(e.SignatureInformation=nt={}));var it;(function(De){function Te(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(nt.from):[]}}De.from=Te;function ge(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(nt.to):[]}}De.to=ge})(it||(e.SignatureHelp=it={}));var ot;(function(De){function Te(ge,K){const Ce=new P.$4M(ne.to(K.position),typeof K.label=="string"?K.label:K.label.map(tt.to.bind(void 0,ge)),K.kind&&_e.to(K.kind));return Ce.textEdits=K.textEdits&&K.textEdits.map(z.to),Ce.tooltip=A.$Zk(K.tooltip)?pe.to(K.tooltip):K.tooltip,Ce.paddingLeft=K.paddingLeft,Ce.paddingRight=K.paddingRight,Ce}De.to=Te})(ot||(e.InlayHint=ot={}));var tt;(function(De){function Te(ge,K){const Ce=new P.$3M(K.label);return Ce.tooltip=A.$Zk(K.tooltip)?pe.to(K.tooltip):K.tooltip,$.Command.is(K.command)&&(Ce.command=ge.fromInternal(K.command)),K.location&&(Ce.location=Ne.to(K.location)),Ce}De.to=Te})(tt||(e.InlayHintLabelPart=tt={}));var _e;(function(De){function Te(K){return K}De.from=Te;function ge(K){return K}De.to=ge})(_e||(e.InlayHintKind=_e={}));var Xe;(function(De){function Te(K){return{range:Q.from(K.range),url:K.target,tooltip:K.tooltip}}De.from=Te;function ge(K){let Ce;if(K.url)try{Ce=typeof K.url=="string"?h.URI.parse(K.url,!0):h.URI.revive(K.url)}catch{}return new P.$0M(Q.to(K.range),Ce)}De.to=ge})(Xe||(e.DocumentLink=Xe={}));var Qe;(function(De){function Te(K){const Ce=new P.$aN(K.label);return K.textEdit&&(Ce.textEdit=z.to(K.textEdit)),K.additionalTextEdits&&(Ce.additionalTextEdits=K.additionalTextEdits.map(je=>z.to(je))),Ce}De.to=Te;function ge(K){return{label:K.label,textEdit:K.textEdit?z.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ce=>z.from(Ce)):void 0}}De.from=ge})(Qe||(e.ColorPresentation=Qe={}));var $e;(function(De){function Te(K){return new P.$$M(K[0],K[1],K[2],K[3])}De.to=Te;function ge(K){return[K.red,K.green,K.blue,K.alpha]}De.from=ge})($e||(e.Color=$e={}));var Oe;(function(De){function Te(K){return{range:Q.from(K.range)}}De.from=Te;function ge(K){return new P.$TM(Q.to(K.range))}De.to=ge})(Oe||(e.SelectionRange=Oe={}));var ve;(function(De){function Te(ge){switch(ge){case i.SaveReason.AUTO:return P.TextDocumentSaveReason.AfterDelay;case i.SaveReason.EXPLICIT:return P.TextDocumentSaveReason.Manual;case i.SaveReason.FOCUS_CHANGE:case i.SaveReason.WINDOW_CHANGE:return P.TextDocumentSaveReason.FocusOut}}De.to=Te})(ve||(e.TextDocumentSaveReason=ve={}));var ye;(function(De){function Te(K){switch(K){case P.TextEditorLineNumbersStyle.Off:return g.RenderLineNumbersType.Off;case P.TextEditorLineNumbersStyle.Relative:return g.RenderLineNumbersType.Relative;case P.TextEditorLineNumbersStyle.Interval:return g.RenderLineNumbersType.Interval;case P.TextEditorLineNumbersStyle.On:default:return g.RenderLineNumbersType.On}}De.from=Te;function ge(K){switch(K){case g.RenderLineNumbersType.Off:return P.TextEditorLineNumbersStyle.Off;case g.RenderLineNumbersType.Relative:return P.TextEditorLineNumbersStyle.Relative;case g.RenderLineNumbersType.Interval:return P.TextEditorLineNumbersStyle.Interval;case g.RenderLineNumbersType.On:default:return P.TextEditorLineNumbersStyle.On}}De.to=ge})(ye||(e.TextEditorLineNumbersStyle=ye={}));var X;(function(De){function Te(K){if(K===P.EndOfLine.CRLF)return l.EndOfLineSequence.CRLF;if(K===P.EndOfLine.LF)return l.EndOfLineSequence.LF}De.from=Te;function ge(K){if(K===l.EndOfLineSequence.CRLF)return P.EndOfLine.CRLF;if(K===l.EndOfLineSequence.LF)return P.EndOfLine.LF}De.to=ge})(X||(e.EndOfLine=X={}));var _;(function(De){function Te(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case P.ProgressLocation.SourceControl:return o.ProgressLocation.Scm;case P.ProgressLocation.Window:return o.ProgressLocation.Window;case P.ProgressLocation.Notification:return o.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}De.from=Te})(_||(e.ProgressLocation=_={}));var we;(function(De){function Te(K){const Ce={start:K.start+1,end:K.end+1};return K.kind&&(Ce.kind=ze.from(K.kind)),Ce}De.from=Te;function ge(K){const Ce={start:K.start-1,end:K.end-1};return K.kind&&(Ce.kind=ze.to(K.kind)),Ce}De.to=ge})(we||(e.FoldingRange=we={}));var ze;(function(De){function Te(K){if(K)switch(K){case P.FoldingRangeKind.Comment:return $.$Pv.Comment;case P.FoldingRangeKind.Imports:return $.$Pv.Imports;case P.FoldingRangeKind.Region:return $.$Pv.Region}}De.from=Te;function ge(K){if(K)switch(K.value){case $.$Pv.Comment.value:return P.FoldingRangeKind.Comment;case $.$Pv.Imports.value:return P.FoldingRangeKind.Imports;case $.$Pv.Region.value:return P.FoldingRangeKind.Region}}De.to=ge})(ze||(e.FoldingRangeKind=ze={}));var Ge;(function(De){function Te(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?Q.from(ge.selection):void 0,override:typeof ge.override=="boolean"?i.$FF.id:void 0}}De.from=Te})(Ge||(e.TextEditorOpenOptions=Ge={}));var Ye;(function(De){function Te(je){return je instanceof P.$vN?je.toJSON():typeof je=="string"?je:ge(je)||K(je)?new P.$vN(je.baseUri??je.base,je.pattern).toJSON():je}De.from=Te;function ge(je){const Je=je;return Je?h.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function K(je){const Je=je;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Ce(je){return typeof je=="string"?je:new P.$vN(h.URI.revive(je.baseUri),je.pattern)}De.to=Ce})(Ye||(e.GlobPattern=Ye={}));var et;(function(De){function Te(ge){if(ge){if(Array.isArray(ge))return ge.map(Te);if(typeof ge=="string")return ge;{const K=ge;return{language:K.language,scheme:K.scheme,pattern:Ye.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}De.from=Te})(et||(e.LanguageSelector=et={}));var lt;(function(De){function Te(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Ce=>Array.isArray(Ce)&&Ce.every(je=>je&&typeof je=="object"&&"uri"in je&&h.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Je=>Je instanceof P.$yM)))}De.is=Te;function ge(K){return{documents:K.documents.map(Ce=>Ce.map(je=>({uri:h.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Je=>Q.from(Je))})))}}De.from=ge})(lt||(e.MappedEditsContext=lt={}));var ut;(function(De){function Te(K){return{start:K.start,end:K.end}}De.from=Te;function ge(K){return new P.$YN(K.start,K.end)}De.to=ge})(ut||(e.NotebookRange=ut={}));var dt;(function(De){function Te(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}De.to=Te;function ge(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}De.from=ge})(dt||(e.NotebookCellExecutionSummary=dt={}));var Ct;(function(De){function Te(ge){if(ge===I.NotebookCellExecutionState.Unconfirmed)return P.NotebookCellExecutionState.Pending;if(ge===I.NotebookCellExecutionState.Pending)return;if(ge===I.NotebookCellExecutionState.Executing)return P.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}De.to=Te})(Ct||(e.NotebookCellExecutionState=Ct={}));var Dt;(function(De){function Te(K){switch(K){case P.NotebookCellKind.Markup:return I.CellKind.Markup;case P.NotebookCellKind.Code:default:return I.CellKind.Code}}De.from=Te;function ge(K){switch(K){case I.CellKind.Markup:return P.NotebookCellKind.Markup;case I.CellKind.Code:default:return P.NotebookCellKind.Code}}De.to=ge})(Dt||(e.NotebookCellKind=Dt={}));var ht;(function(De){function Te(K){const Ce={metadata:K.metadata??Object.create(null),cells:[]};for(const je of K.cells)P.$ZN.validate(je),Ce.cells.push(mt.from(je));return Ce}De.from=Te;function ge(K){const Ce=new P.$1N(K.cells.map(mt.to));return(0,f.$ng)(K.metadata)||(Ce.metadata=K.metadata),Ce}De.to=ge})(ht||(e.NotebookData=ht={}));var mt;(function(De){function Te(K){return{cellKind:Dt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:dt.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Ft.from):[]}}De.from=Te;function ge(K){return new P.$ZN(Dt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Ft.to):void 0,K.metadata,K.internalMetadata?dt.to(K.internalMetadata):void 0)}De.to=ge})(mt||(e.NotebookCellData=mt={}));var pt;(function(De){function Te(K){return{mime:K.mime,valueBytes:r.$Je.wrap(K.data)}}De.from=Te;function ge(K){return new P.$2N(K.valueBytes.buffer,K.mime)}De.to=ge})(pt||(e.NotebookCellOutputItem=pt={}));var Ft;(function(De){function Te(K){return{outputId:K.id,items:K.items.map(pt.from),metadata:K.metadata}}De.from=Te;function ge(K){const Ce=K.items.map(pt.to);return new P.$3N(Ce,K.outputId,K.metadata)}De.to=ge})(Ft||(e.NotebookCellOutput=Ft={}));var yt;(function(De){function Te(Ce){return K(Ce)?{include:Ye.from(Ce.include)??void 0,exclude:Ye.from(Ce.exclude)??void 0}:Ye.from(Ce)??void 0}De.from=Te;function ge(Ce){return K(Ce)?{include:Ye.to(Ce.include),exclude:Ye.to(Ce.exclude)}:Ye.to(Ce)}De.to=ge;function K(Ce){const je=Ce;return je?!(0,f.$jg)(je.include)&&!(0,f.$jg)(je.exclude):!1}})(yt||(e.NotebookExclusiveDocumentPattern=yt={}));var jt;(function(De){function Te(ge,K,Ce){const je=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===P.NotebookCellStatusBarAlignment.Left?I.CellStatusbarAlignment.Left:I.CellStatusbarAlignment.Right,command:K.toInternal(je,Ce),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}De.from=Te})(jt||(e.NotebookStatusBarItem=jt={}));var Tt;(function(De){function Te(ge,K,Ce){const je=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:K.toInternal(je,Ce),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}De.from=Te})(Tt||(e.NotebookKernelSourceAction=Tt={}));var ct;(function(De){function Te(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}De.from=Te})(ct||(e.NotebookDocumentContentOptions=ct={}));var $t;(function(De){function Te(K){return{uri:K.uri,provides:K.provides}}De.from=Te;function ge(K){return new P.$5N(h.URI.revive(K.uri),K.provides)}De.to=ge})($t||(e.NotebookRendererScript=$t={}));var bt;(function(De){function Te(K){return{message:pe.fromStrict(K.message)||"",type:T.TestMessageType.Error,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:Q.from(K.location.range),uri:K.location.uri}}}De.from=Te;function ge(K){const Ce=new P.$$N(typeof K.message=="string"?K.message:pe.to(K.message));return Ce.actualOutput=K.actual,Ce.expectedOutput=K.expected,Ce.contextValue=K.contextValue,Ce.location=K.location?Ne.to(K.location):void 0,Ce}De.to=ge})(bt||(e.TestMessage=bt={}));var Et;(function(De){De.namespace=T.$lL,De.denamespace=T.$mL})(Et||(e.TestTag=Et={}));var It;(function(De){function Te(K){const Ce=(0,d.$UO)(K).controllerId;return{extId:C.$gL.fromExtHostTestItem(K,Ce).toString(),label:K.label,uri:h.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(je=>Et.namespace(Ce,je.id)),range:w.$ct.lift(Q.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&pe.fromStrict(K.error)||null}}De.from=Te;function ge(K){return{parent:void 0,error:void 0,id:C.$gL.fromString(K.extId).localId,label:K.label,uri:h.URI.revive(K.uri),tags:(K.tags||[]).map(Ce=>{const{tagId:je}=Et.denamespace(Ce);return new P.$_N(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:Q.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}De.toPlain=ge})(It||(e.TestItem=It={})),function(De){function Te(K){return{id:K.id}}De.from=Te;function ge(K){return new P.$_N(K.id)}De.to=ge}(Et||(e.TestTag=Et={}));var Vt;(function(De){const Te=(K,Ce)=>{const je=K.value;if(!je)return;const Je={...It.toPlain(je.item),parent:Ce,taskStates:je.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(rt=>rt.type===T.TestMessageType.Error).map(bt.to)})),children:[]};if(K.children)for(const Be of K.children.values()){const rt=Te(Be,Je);rt&&Je.children.push(rt)}return Je};function ge(K){const Ce=new p.$NO;for(const Be of K.items)Ce.insert(C.$gL.fromString(Be.item.extId).path,Be);const je=[Ce.nodes],Je=[];for(;je.length;)for(const Be of je.pop())Be.value?Je.push(Be):Be.children&&je.push(Be.children.values());return{completedAt:K.completedAt,results:Je.map(Be=>Te(Be)).filter(f.$ig)}}De.to=ge})(Vt||(e.TestResults=Vt={}));var Ot;(function(De){function Te(je){return{covered:je.covered,total:je.total}}function ge(je){return"line"in je?ne.from(je):Q.from(je)}function K(je){if(typeof je.executed=="number"&&je.executed<0)throw new Error(`Invalid coverage count ${je.executed}`);return"branches"in je?{count:je.executed,location:ge(je.location),type:T.DetailType.Statement,branches:je.branches.length?je.branches.map(Je=>({count:Je.executed,location:Je.location&&ge(Je.location),label:Je.label})):void 0}:{type:T.DetailType.Declaration,name:je.name,count:je.executed,location:ge(je.location)}}De.fromDetails=K;function Ce(je,Je,Be){return P.$bO(Be.statementCoverage),P.$bO(Be.branchCoverage),P.$bO(Be.declarationCoverage),{id:Je,uri:Be.uri,statement:Te(Be.statementCoverage),branch:Be.branchCoverage&&Te(Be.branchCoverage),declaration:Be.declarationCoverage&&Te(Be.declarationCoverage),testId:Be instanceof P.$cO&&Be.testItem?C.$gL.fromExtHostTestItem(Be.testItem,je).toString():void 0}}De.fromFile=Ce})(Ot||(e.TestCoverage=Ot={}));var Pt;(function(De){function Te(ge){switch(ge){case $.CodeActionTriggerType.Invoke:return P.CodeActionTriggerKind.Invoke;case $.CodeActionTriggerType.Auto:return P.CodeActionTriggerKind.Automatic}}De.to=Te})(Pt||(e.CodeActionTriggerKind=Pt={}));var Bt;(function(De){function Te(K){const Ce=new P.$gO(J.to(K.kind),K.name,K.detail||"",h.URI.revive(K.uri),Q.to(K.range),Q.to(K.selectionRange));return Ce._sessionId=K._sessionId,Ce._itemId=K._itemId,Ce}De.to=Te;function ge(K,Ce,je){if(Ce=Ce??K._sessionId,je=je??K._itemId,Ce===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:je,kind:J.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:Q.from(K.range),selectionRange:Q.from(K.selectionRange),tags:K.tags?.map(x.from)}}De.from=ge})(Bt||(e.TypeHierarchyItem=Bt={}));var Gt;(function(De){function Te(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}De.from=Te})(Gt||(e.ViewBadge=Gt={}));var wt;(function(De){function Te(je,Je,Be){const rt=Je.fileData;return rt?new P.$nN(new P.$oN(rt.name,h.URI.revive(rt.uri),rt.id,(0,D.$db)(()=>Be(rt.id)))):je===E.$Ys.uriList&&Je.uriListData?new P.$mN(Ce(Je.uriListData)):new P.$mN(Je.asString)}De.to=Te;async function ge(je,Je){const Be=await Je.asString();if(je===E.$Ys.uriList)return{asString:Be,fileData:void 0,uriListData:K(Be)};const rt=Je.asFile();return{asString:Be,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}De.from=ge;function K(je){return S.$_s.split(je).map(Je=>{if(Je.startsWith("#"))return Je;try{return h.URI.parse(Je)}catch{}return Je})}function Ce(je){return S.$_s.create(je.map(Je=>typeof Je=="string"?Je:h.URI.revive(Je)))}})(wt||(e.DataTransferItem=wt={}));var St;(function(De){function Te(K,Ce){const je=K.items.map(([Je,Be])=>[Je,wt.to(Je,Be,Ce)]);return new P.$pN(je)}De.toDataTransfer=Te;async function ge(K){const Ce={items:[]},je=[];for(const[Je,Be]of K)je.push((async()=>{Ce.items.push([Je,await wt.from(Je,Be)])})());return await Promise.all(je),Ce}De.from=ge})(St||(e.DataTransfer=St={}));var Lt;(function(De){function Te(K,Ce){return{kind:"reply",agentId:K.participant??Ce?.agentId??"",subCommand:K.command??Ce?.command,message:K.prompt,title:K.label}}De.from=Te;function ge(K){return{prompt:K.message,label:K.title,participant:K.agentId,command:K.subCommand}}De.to=ge})(Lt||(e.ChatFollowup=Lt={}));var Zt;(function(De){function Te(K){switch(K.role){case u.ChatMessageRole.System:return new P.$HO(P.LanguageModelChatMessageRole.System,K.content);case u.ChatMessageRole.User:return new P.$HO(P.LanguageModelChatMessageRole.User,K.content);case u.ChatMessageRole.Assistant:return new P.$HO(P.LanguageModelChatMessageRole.Assistant,K.content)}}De.to=Te;function ge(K){switch(K.role){case P.LanguageModelChatMessageRole.System:return{role:u.ChatMessageRole.System,content:K.content};case P.LanguageModelChatMessageRole.User:return{role:u.ChatMessageRole.User,content:K.content};case P.LanguageModelChatMessageRole.Assistant:return{role:u.ChatMessageRole.Assistant,content:K.content}}}De.from=ge})(Zt||(e.LanguageModelChatMessage=Zt={}));var Nt;(function(De){function Te(K){return{kind:"markdownContent",content:pe.from(K.value)}}De.from=Te;function ge(K){return new P.$tO(pe.to(K.content))}De.to=ge})(Nt||(e.ChatResponseMarkdownPart=Nt={}));var Kt;(function(De){function Te(K){return{kind:"markdownVuln",content:pe.from(K.value),vulnerabilities:K.vulnerabilities}}De.from=Te;function ge(K){return new P.$uO(pe.to(K.content),K.vulnerabilities)}De.to=ge})(Kt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Kt={}));var Ht;(function(De){function Te(K){return{kind:"agentDetection",agentId:K.participant,command:K.command}}De.from=Te;function ge(K){return new P.$vO(K.agentId,K.command)}De.to=ge})(Ht||(e.ChatResponseDetectedParticipantPart=Ht={}));var Xt;(function(De){function Te(ge){return{kind:"confirmation",title:ge.title,message:ge.message,data:ge.data}}De.from=Te})(Xt||(e.ChatResponseConfirmationPart=Xt={}));var Jt;(function(De){function Te(K){const{value:Ce,baseUri:je}=K;function Je(Be,rt){return Be.map(ft=>{const Ut=h.URI.joinPath(rt,ft.name);return{label:ft.name,uri:Ut,children:ft.children&&Je(ft.children,Ut)}})}return{kind:"treeData",treeData:{label:(0,b.$$g)(je),uri:je,children:Je(Ce,je)}}}De.from=Te;function ge(K){const Ce=(0,s.$0h)(K.treeData);function je(rt){return rt.map(ft=>({name:ft.label,children:ft.children&&je(ft.children)}))}const Je=Ce.uri,Be=Ce.children?je(Ce.children):[];return new P.$xO(Be,Je)}De.to=ge})(Jt||(e.ChatResponseFilesPart=Jt={}));var At;(function(De){function Te(K){const Ce=je=>h.URI.isUri(je);return{kind:"inlineReference",name:K.title,inlineReference:Ce(K.value)?K.value:ie.from(K.value)}}De.from=Te;function ge(K){const Ce=(0,s.$0h)(K);return new P.$yO(h.URI.isUri(Ce.inlineReference)?Ce.inlineReference:ie.to(Ce.inlineReference),K.name)}De.to=ge})(At||(e.ChatResponseAnchorPart=At={}));var Rt;(function(De){function Te(K){return{kind:"progressMessage",content:pe.from(K.value)}}De.from=Te;function ge(K){return new P.$zO(K.content.value)}De.to=ge})(Rt||(e.ChatResponseProgressPart=Rt={}));var gt;(function(De){function Te(K){return{kind:"warning",content:pe.from(K.value)}}De.from=Te;function ge(K){return new P.$BO(K.content.value)}De.to=ge})(gt||(e.ChatResponseWarningPart=gt={}));var Mt;(function(De){function Te(ge){return{kind:"progressTask",content:pe.from(ge.value)}}De.from=Te})(Mt||(e.ChatTask=Mt={}));var qt;(function(De){function Te(ge){return{kind:"progressTaskResult",content:typeof ge=="string"?pe.from(ge):void 0}}De.from=Te})(qt||(e.ChatTaskResult=qt={}));var nn;(function(De){function Te(K,Ce,je){return{kind:"command",command:Ce.toInternal(K.value,je)??{command:K.value.command,title:K.value.title}}}De.from=Te;function ge(K,Ce){return new P.$CO(Ce.fromInternal(K.command)??{command:K.command.id,title:K.command.title})}De.to=ge})(nn||(e.ChatResponseCommandButtonPart=nn={}));var cn;(function(De){function Te(K){return{kind:"textEdit",uri:K.uri,edits:K.edits.map(Ce=>z.from(Ce))}}De.from=Te;function ge(K){return new P.$EO(h.URI.revive(K.uri),K.edits.map(Ce=>z.to(Ce)))}De.to=ge})(cn||(e.ChatResponseTextEditPart=cn={}));var on;(function(De){function Te(K){const Ce=a.ThemeIcon.isThemeIcon(K.iconPath)?K.iconPath:h.URI.isUri(K.iconPath)?{light:h.URI.revive(K.iconPath)}:K.iconPath&&"light"in K.iconPath&&"dark"in K.iconPath&&h.URI.isUri(K.iconPath.light)&&h.URI.isUri(K.iconPath.dark)?{light:h.URI.revive(K.iconPath.light),dark:h.URI.revive(K.iconPath.dark)}:void 0;return"variableName"in K.value?{kind:"reference",reference:{variableName:K.value.variableName,value:h.URI.isUri(K.value.value)||!K.value.value?K.value.value:ie.from(K.value.value)},iconPath:Ce}:{kind:"reference",reference:h.URI.isUri(K.value)?K.value:ie.from(K.value),iconPath:Ce}}De.from=Te;function ge(K){const Ce=(0,s.$0h)(K),je=Je=>h.URI.isUri(Je)?Je:ie.to(Je);return new P.$DO("variableName"in Ce.reference?{variableName:Ce.reference.variableName,value:Ce.reference.value&&je(Ce.reference.value)}:je(Ce.reference))}De.to=ge})(on||(e.ChatResponseReferencePart=on={}));var hn;(function(De){function Te(Ce,je,Je){return Ce instanceof P.$tO?Nt.from(Ce):Ce instanceof P.$yO?At.from(Ce):Ce instanceof P.$DO?on.from(Ce):Ce instanceof P.$zO?Rt.from(Ce):Ce instanceof P.$xO?Jt.from(Ce):Ce instanceof P.$CO?nn.from(Ce,je,Je):Ce instanceof P.$EO?cn.from(Ce):Ce instanceof P.$uO?Kt.from(Ce):Ce instanceof P.$vO?Ht.from(Ce):Ce instanceof P.$BO?gt.from(Ce):{kind:"markdownContent",content:pe.from("")}}De.from=Te;function ge(Ce,je){switch(Ce.kind){case"reference":return on.to(Ce);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return K(Ce,je)}}De.to=ge;function K(Ce,je){switch(Ce.kind){case"markdownContent":return Nt.to(Ce);case"inlineReference":return At.to(Ce);case"progressMessage":return;case"treeData":return Jt.to(Ce);case"command":return nn.to(Ce,je)}}De.toContent=K})(hn||(e.ChatResponsePart=hn={}));var dn;(function(De){function Te(ge){return{prompt:ge.message,command:ge.command,attempt:ge.attempt??0,enableCommandDetection:ge.enableCommandDetection??!0,references:ge.variables.variables.map(mn.to),location:Yt.to(ge.location),acceptedConfirmationData:ge.acceptedConfirmationData,rejectedConfirmationData:ge.rejectedConfirmationData}}De.to=Te})(dn||(e.ChatAgentRequest=dn={}));var Yt;(function(De){function Te(K){switch(K){case c.ChatAgentLocation.Notebook:return P.ChatLocation.Notebook;case c.ChatAgentLocation.Terminal:return P.ChatLocation.Terminal;case c.ChatAgentLocation.Panel:return P.ChatLocation.Panel;case c.ChatAgentLocation.Editor:return P.ChatLocation.Editor}}De.to=Te;function ge(K){switch(K){case P.ChatLocation.Notebook:return c.ChatAgentLocation.Notebook;case P.ChatLocation.Terminal:return c.ChatAgentLocation.Terminal;case P.ChatLocation.Panel:return c.ChatAgentLocation.Panel;case P.ChatLocation.Editor:return c.ChatAgentLocation.Editor}}De.from=ge})(Yt||(e.ChatLocation=Yt={}));var mn;(function(De){function Te(ge){const K=ge.value;if(!K)throw new Error("Invalid value reference");return{id:ge.id,name:ge.name,range:ge.range&&[ge.range.start,ge.range.endExclusive],value:(0,h.$vc)(K)?h.URI.revive(K):K&&typeof K=="object"&&"uri"in K&&"range"in K&&(0,h.$vc)(K.uri)?ie.to((0,s.$0h)(K)):K,modelDescription:ge.modelDescription}}De.to=Te})(mn||(e.ChatAgentValueReference=mn={}));var xt;(function(De){function Te(ge,K,Ce){return{id:ge.id,label:ge.label,fullName:ge.fullName,icon:ge.icon?.id,value:ge.values[0].value,insertText:ge.insertText,detail:ge.detail,documentation:ge.documentation,command:K.toInternal(ge.command,Ce)}}De.from=Te})(xt||(e.ChatAgentCompletionItem=xt={}));var un;(function(De){function Te(ge){return{errorDetails:ge.errorDetails,metadata:ge.metadata}}De.to=Te})(un||(e.ChatAgentResult=un={}));var gn;(function(De){function Te(ge,K,Ce){if(K.action.kind==="vote")return;const je=un.to(ge);if(K.action.kind==="command"){const Je=K.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ce.fromInternal(Je)??{command:Je.id,title:Je.title}}},result:je}}else return K.action.kind==="followUp"?{action:{kind:"followUp",followup:Lt.to(K.action.followup)},result:je}:K.action.kind==="inlineChat"?{action:{kind:"editor",accepted:K.action.action==="accepted"},result:je}:{action:K.action,result:je}}De.to=Te})(gn||(e.ChatAgentUserActionEvent=gn={}));var fn;(function(De){function Te(ge,K,Ce){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand,shouldExecute:ge.shouldExecute}:"uri"in ge?{uri:ge.uri}:K.toInternal(ge,Ce)}De.from=Te})(fn||(e.TerminalQuickFix=fn={}));var pn;(function(De){function Te(ge){return{kind:$n.to(ge.kind)}}De.to=Te})(pn||(e.PartialAcceptInfo=pn={}));var $n;(function(De){function Te(ge){switch(ge){case $.PartialAcceptTriggerKind.Word:return P.PartialAcceptTriggerKind.Word;case $.PartialAcceptTriggerKind.Line:return P.PartialAcceptTriggerKind.Line;case $.PartialAcceptTriggerKind.Suggest:return P.PartialAcceptTriggerKind.Suggest;default:return P.PartialAcceptTriggerKind.Unknown}}De.to=Te})($n||(e.PartialAcceptTriggerKind=$n={}));var rn;(function(De){function Te(ge,K){return{id:K,label:ge.label,description:ge.description,canEdit:ge.canEdit,collapsibleState:ge.collapsibleState||k.DebugTreeItemCollapsibleState.None,contextValue:ge.contextValue}}De.from=Te})(rn||(e.DebugTreeItem=rn={}))}),define(Ee[320],Se([1,0,48,147,75,146,103,153,4]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=e.$_O=e.$$O=void 0;const s=(m,$,l,t)=>{let o=$;return{enumerable:!0,configurable:!1,get(){return o},set(d){if(!l(o,d)){const i=o;o=d,m.listener?.(t(d,i))}}}},E=(m,$)=>m===$,y={range:(m,$)=>m===$?!0:!m||!$?!1:m.isEqual($),label:E,description:E,sortText:E,busy:E,error:E,canResolveChildren:E,tags:(m,$)=>!(m.length!==$.length||m.some(l=>!$.find(t=>l.id===t.id)))},p=m=>$=>({op:D.TestItemEventOp.SetProp,update:m($)}),b=(m,$)=>({range:(()=>{let l;const t=p(o=>({range:n.$ct.lift(R.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return l},set(o){m.listener?.({op:D.TestItemEventOp.DocumentSynced}),y.range(l,o)||(l=o,m.listener?.(t(o)))}}})(),label:s(m,$,y.label,p(l=>({label:l}))),description:s(m,void 0,y.description,p(l=>({description:l}))),sortText:s(m,void 0,y.sortText,p(l=>({sortText:l}))),canResolveChildren:s(m,!1,y.canResolveChildren,l=>({op:D.TestItemEventOp.UpdateCanResolveChildren,state:l})),busy:s(m,!1,y.busy,p(l=>({busy:l}))),error:s(m,void 0,y.error,p(l=>({error:R.MarkdownString.fromStrict(l)||null}))),tags:s(m,[],y.tags,(l,t)=>({op:D.TestItemEventOp.SetTags,new:l.map(R.TestTag.from),old:t.map(R.TestTag.from)}))}),a=m=>{const $=S.$gL.fromString(m.extId),l=new h($.controllerId,$.localId,m.label,v.URI.revive(m.uri)||void 0);return l.range=R.Range.to(m.range||void 0),l.description=m.description||void 0,l.sortText=m.sortText||void 0,l.tags=m.tags.map(t=>R.TestTag.to({id:(0,A.$mL)(t).tagId})),l},f=m=>{let $;for(const l of m.tests){const t=a(l.item);(0,r.$UO)(t).parent=$,$=t}return $};e.$$O=f;class h{constructor($,l,t,o){if(l.includes(S.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const d=(0,r.$TO)(this,$);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof g?void 0:d.parent}},children:{value:(0,D.$SO)(d,r.$UO,h),enumerable:!0,writable:!1},...b(d,t)})}}e.$_O=h;class g extends h{constructor($,l){super($,$,l,void 0),this._isRoot=!0}}e.$aP=g;class w extends D.$OO{constructor($,l,t){super({controllerId:$,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:r.$UO,getChildren:o=>o.children,root:new g($,l),toITestItem:R.TestItem.from})}}e.$bP=w}),define(Ee[321],Se([1,0,11,152,153,21,318,18,12,49,48,84,4,2,5,297,320,15,150,42,55,41,311,22]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m,$,l,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=void 0;let d=class{#e;#t;#n;constructor(C,T,O){this.b=new Map,this.c=new Map,this.#e=C.getProxy(A.$uM.MainThreadCommands),this.d=T,this.#n=O,this.#t=C.getProxy(A.$uM.MainThreadTelemetry),this.converter=new i(this,P=>{const V=this.c.get(P);return V?.result===u.Void?V:void 0},T),this.f=[{processArgument(P){return(0,s.$0h)(P)}},{processArgument(P){return(0,D.$$n)(P,function(V){if(E.$ct.isIRange(V))return S.Range.to(V);if(y.$bt.isIPosition(V))return S.Position.to(V);if(E.$ct.isIRange(V.range)&&p.URI.isUri(V.uri))return S.location.to(V);if(V instanceof g.$Je)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const T=this.registerCommand(!1,C.id,async(...O)=>{const P=C.args.map((Q,ie)=>{if(!Q.validate(O[ie]))throw new Error(`Invalid argument '${Q.name}' when running '${C.id}', received: ${typeof O[ie]=="object"?JSON.stringify(O[ie],null,"	"):O[ie]} `);return Q.convert(O[ie])}),V=await this.executeCommand(C.internalId,...P);return C.result.convert(V,O,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new r.$wM(()=>{T.dispose(),this.c.delete(C.id)})}registerCommand(C,T,O,P,V,Q){if(this.d.trace("ExtHostCommands#registerCommand",T),!T.trim().length)throw new Error("invalid id");if(this.b.has(T))throw new Error(`command '${T}' already exists`);return this.b.set(T,{callback:O,thisArg:P,metadata:V,extension:Q}),C&&this.#e.$registerCommand(T),new r.$wM(()=>{this.b.delete(T)&&C&&this.#e.$unregisterCommand(T)})}executeCommand(C,...T){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,T,!0)}async g(C,T,O){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,T,!1);{let P=!1;const V=(0,D.$$n)(T,function(Q){if(Q instanceof r.$xM)return S.Position.from(Q);if(Q instanceof r.$yM)return S.Range.from(Q);if(Q instanceof r.$IM)return S.location.from(Q);if(r.$YN.isNotebookRange(Q))return S.NotebookRange.from(Q);if(Q instanceof ArrayBuffer)return P=!0,g.$Je.wrap(new Uint8Array(Q));if(Q instanceof Uint8Array)return P=!0,g.$Je.wrap(Q);if(Q instanceof g.$Je)return P=!0,Q;if(!Array.isArray(Q))return Q});try{const Q=await this.#e.$executeCommand(C,P?new w.$Kw(V):V,O);return(0,s.$0h)(Q)}catch(Q){if(Q instanceof Error&&Q.message==="$executeCommand:retry")return this.g(C,T,!1);throw Q}}}async h(C,T,O){const P=this.b.get(C);if(!P)throw new Error("Unknown command");const{callback:V,thisArg:Q,metadata:ie}=P;if(ie?.args)for(let ne=0;ne<ie.args.length;ne++)try{(0,n.$rg)(T[ne],ie.args[ne].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${ie.args[ne].name}' - ${ie.args[ne].description}`)}const re=$.$be.create();try{return await V.apply(Q,T)}catch(ne){if(C===this.converter.delegatingCommandId){const se=this.converter.getActualCommand(...T);se&&(C=se.command)}if(this.d.error(ne,C,P.extension?.identifier),!O)throw ne;if(P.extension?.identifier){const se=this.#n.onExtensionError(P.extension.identifier,ne);this.d.trace("forwarded error to extension?",se,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,m.$lj)(ne)),this.id=C,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,C,re.elapsed())}}j(C,T,O){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new l.$np(T),duration:O})}$executeContributedCommand(C,...T){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const O=this.b.get(C);return O?(T=T.map(P=>this.f.reduce((V,Q)=>Q.processArgument(V,O.extension?.identifier),P)),this.h(C,T,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(T=>(C&&(T=T.filter(O=>O[0]!=="_")),T))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[T,O]of this.b){const{metadata:P}=O;P&&(C[T]=P)}return Promise.resolve(C)}};e.$hP=d,e.$hP=d=Ue([Fe(0,f.$YO),Fe(1,v.$7j),Fe(2,t.$gP)],d),e.$iP=(0,a.$Ai)("IExtHostCommands");class i{constructor(C,T,O){this.d=C,this.f=T,this.g=O,this.delegatingCommandId=`__vsc${(0,o.$Wg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,T){if(!C)return;const O={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return O;const P=this.f(C.command);if(P)O.id=P.internalId,O.arguments=P.args.map((V,Q)=>V.convert(C.arguments&&C.arguments[Q]));else if((0,R.$Lb)(C.arguments)){const V=`${C.command} /${++this.c}`;this.b.set(V,C),T.add((0,b.$Sc)(()=>{this.b.delete(V),this.g.trace("CommandsConverter#DISPOSE",V)})),O.$ident=V,O.id=this.delegatingCommandId,O.arguments=[V],this.g.trace("CommandsConverter#CREATE",C.command,V)}return O}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const T=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],T?T.command:"MISSING"),T?this.d.executeCommand(T.command,...T.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$jP=i;class c{static{this.Uri=new c("uri","Uri of a text document",C=>p.URI.isUri(C),C=>C)}static{this.Position=new c("position","A position in a text document",C=>r.$xM.isPosition(C),S.Position.from)}static{this.Range=new c("range","A range in a text document",C=>r.$yM.isRange(C),S.Range.from)}static{this.Selection=new c("selection","A selection in a text document",C=>r.$zM.isSelection(C),S.Selection.from)}static{this.Number=new c("number","",C=>typeof C=="number",C=>C)}static{this.String=new c("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=c.Arr(c.String)}static Arr(C){return new c(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,T=>Array.isArray(T)&&T.every(O=>C.validate(O)),T=>T.map(O=>C.convert(O)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",C=>C instanceof r.$UM,S.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",C=>C instanceof r.$gO,S.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",C=>C instanceof h.$_O,S.TestItem.from)}constructor(C,T,O,P){this.name=C,this.description=T,this.validate=O,this.convert=P}optional(){return new c(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,T){return new c(C??this.name,T??this.description,this.validate,this.convert)}}e.$kP=c;class u{static{this.Void=new u("no result",C=>C)}constructor(C,T){this.description=C,this.convert=T}}e.$lP=u;class k{constructor(C,T,O,P,V){this.id=C,this.internalId=T,this.description=O,this.args=P,this.result=V}}e.$mP=k}),define(Ee[322],Se([1,0,10,2,13,3,250]),function(fe,e,n,r,S,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=void 0,e.$9P="remoteFilesystem";class R extends A.$8P{static register(s,E,y){const p=s.getConnection();if(!p)return r.$Uc.None;const b=new r.$Tc,a=(async()=>{try{const f=await s.getRawEnvironment();f?E.registerProvider(S.Schemas.vscodeRemote,b.add(new R(f,p))):y.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(f){y.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,n.$0)(f))}})();return b.add(E.onWillActivateFileSystemProvider(f=>{f.scheme===S.Schemas.vscodeRemote&&f.join(a)})),b}constructor(s,E){super(E.getChannel(e.$9P),{pathCaseSensitive:s.os===D.OperatingSystem.Linux})}}e.$0P=R}),define(Ee[76],Se([1,0,96,83,32,323,15,10,6,2,9,3,22,50,61]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ri=e.$qi=e.$pi=void 0,e.$si=d,e.$ti=i,e.$vi=k,e.$wi=I;class f{traceSocketEvent(T,O){a.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,T,O)}constructor(T,O=""){this.f=!0,this.debugLabel=O,this.socket=T,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent(a.SocketDiagnosticsEventType.Error,{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,R.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Close,{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(T){const O=P=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Read,P),T(A.$Je.wrap(P))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(T){const O=P=>{T({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:P,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(T){const O=()=>{T()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(T){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(a.SocketDiagnosticsEventType.Write,T),this.socket.write(T.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,R.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,R.$1)(O)}}end(){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((T,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),T();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),T()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$pi=f;var h;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(h||(h={}));var g;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(g||(g={}));class w extends s.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(T,O){this.socket.traceSocketEvent(T,O)}constructor(T,O,P,V){super(),this.f=this.B(new v.$he),this.g=this.B(new v.$he),this.h=!1,this.j={state:g.PeekHeader,readLen:h.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=T,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:P?.byteLength||0,recordInflateBytes:V}),this.a=this.B(new m(this,O,P,V,this.f,(Q,ie)=>this.m(Q,ie))),this.B(this.a.onError(Q=>{console.error(Q),(0,R.$1)(Q),this.g.fire({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:Q})})),this.b=new a.$ki,this.B(this.socket.onData(Q=>this.n(Q))),this.B(this.socket.onClose(async Q=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(Q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(T){return this.f.event(T)}onClose(T){return this.g.event(T)}onEnd(T){return this.socket.onEnd(T)}write(T){let O=0;for(;O<T.byteLength;)this.a.writeMessage(T.slice(O,Math.min(O+h.MaxWebSocketMessageLength,T.byteLength)),{compressed:!0,opcode:2}),O+=h.MaxWebSocketMessageLength}m(T,{compressed:O,opcode:P}){if(this.h)return;this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,T);let V=h.MinHeaderByteSize;T.byteLength<126?V+=0:T.byteLength<2**16?V+=2:V+=8;const Q=A.$Je.alloc(V),ie=O?64:0,re=P&15;if(Q.writeUInt8(128|ie|re,0),T.byteLength<126)Q.writeUInt8(T.byteLength,1);else if(T.byteLength<2**16){Q.writeUInt8(126,1);let ne=1;Q.writeUInt8(T.byteLength>>>8&255,++ne),Q.writeUInt8(T.byteLength>>>0&255,++ne)}else{Q.writeUInt8(127,1);let ne=1;Q.writeUInt8(0,++ne),Q.writeUInt8(0,++ne),Q.writeUInt8(0,++ne),Q.writeUInt8(0,++ne),Q.writeUInt8(T.byteLength>>>24&255,++ne),Q.writeUInt8(T.byteLength>>>16&255,++ne),Q.writeUInt8(T.byteLength>>>8&255,++ne),Q.writeUInt8(T.byteLength>>>0&255,++ne)}this.socket.write(A.$Je.concat([Q,T]))}end(){this.h=!0,this.socket.end()}n(T){if(T.byteLength!==0){for(this.b.acceptChunk(T);this.b.byteLength>=this.j.readLen;)if(this.j.state===g.PeekHeader){const O=this.b.peek(this.j.readLen),P=O.readUInt8(0),V=(P&128)>>>7,Q=(P&64)>>>6,ie=P&15,re=O.readUInt8(1),ne=(re&128)>>>7,se=re&127;this.j.state=g.ReadHeader,this.j.readLen=h.MinHeaderByteSize+(ne?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=V,this.j.firstFrameOfMessage&&(this.j.compressed=!!Q),this.j.firstFrameOfMessage=!!V,this.j.mask=0,this.j.opcode=ie,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===g.ReadHeader){const O=this.b.read(this.j.readLen),P=O.readUInt8(1),V=(P&128)>>>7;let Q=P&127,ie=1;Q===126?Q=O.readUInt8(++ie)*2**8+O.readUInt8(++ie):Q===127&&(Q=O.readUInt8(++ie)*0+O.readUInt8(++ie)*0+O.readUInt8(++ie)*0+O.readUInt8(++ie)*0+O.readUInt8(++ie)*2**24+O.readUInt8(++ie)*2**16+O.readUInt8(++ie)*2**8+O.readUInt8(++ie));let re=0;V&&(re=O.readUInt8(++ie)*2**24+O.readUInt8(++ie)*2**16+O.readUInt8(++ie)*2**8+O.readUInt8(++ie)),this.j.state=g.ReadBody,this.j.readLen=Q,this.j.mask=re,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===g.ReadBody){const O=this.b.read(this.j.readLen);this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,O),t(O,this.j.mask),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,O),this.j.state=g.PeekHeader,this.j.readLen=h.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$qi=w;class m extends s.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Je.alloc(0)}constructor(T,O,P,V,Q,ie){super(),this.n=T,this.r=Q,this.s=ie,this.a=this.B(new v.$he),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.$he),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new v.$he),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new $(this.n,V,P,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(re=>this.a.fire(re))),this.B(this.f.onError(re=>this.a.fire(re)))):(this.b=null,this.f=null)}writeMessage(T,O){this.g.push({data:T,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:T,options:O}=this.g.shift();if(this.f&&O.compressed){const P=await this.w(this.f,T);this.s(P,O)}else this.s(T,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(T,O){return new Promise((P,V)=>{T.write(O),T.flush(Q=>P(Q))})}acceptFrame(T,O,P){this.h.push({data:T,isCompressed:O,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const T=this.h.shift();if(this.b&&T.isCompressed){const O=await this.C(this.b,T.data,T.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(T.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(T,O,P){return new Promise((V,Q)=>{T.write(O),P&&T.write(A.$Je.fromByteArray([0,0,255,255])),T.flush(ie=>V(ie))})}}class $ extends s.$Uc{get recordedInflateBytes(){return this.j?A.$Je.concat(this.f):A.$Je.alloc(0)}constructor(T,O,P,V){super(),this.h=T,this.j=O,this.a=this.B(new v.$he),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(V),this.b.on("error",Q=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateError,{message:Q?.message,code:Q?.code}),this.a.fire(Q)}),this.b.on("data",Q=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateData,Q),this.g.push(A.$Je.wrap(Q))}),P&&(this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialWrite,P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(T){this.j&&this.f.push(T.clone()),this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateWrite,T),this.b.write(T.buffer)}flush(T){this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateFlushFired);const O=A.$Je.concat(this.g);this.g.length=0,T(O)})}}class l extends s.$Uc{constructor(T,O){super(),this.g=T,this.a=this.B(new v.$he),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateError,{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateData,P),this.f.push(A.$Je.wrap(P))})}write(T){this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateWrite,T.buffer),this.b.write(T.buffer)}flush(T){this.b.flush(2,()=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateFlushFired);let O=A.$Je.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),T(O)})}}function t(C,T){if(T===0)return;const O=C.byteLength>>>2;for(let ne=0;ne<O;ne++){const se=C.readUInt32BE(ne*4);C.writeUInt32BE(se^T,ne*4)}const P=O*4,V=C.byteLength-P,Q=T>>>24&255,ie=T>>>16&255,re=T>>>8&255;V>=1&&C.writeUInt8(C.readUInt8(P)^Q,P),V>=2&&C.writeUInt8(C.readUInt8(P+1)^ie,P+1),V>=3&&C.writeUInt8(C.readUInt8(P+2)^re,P+2)}e.$ri=process.env.XDG_RUNTIME_DIR;const o={[y.Platform.Linux]:107,[y.Platform.Mac]:103};function d(){const C=(0,p.$Wg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const T=process.platform!=="darwin"&&e.$ri?e.$ri:(0,S.tmpdir)(),O=(0,E.$jc)(T,`vscode-ipc-${C}.sock`);return c(O),O}function i(C,T,O){const V=(0,n.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${V}-${O}-${T}-sock`;const Q=O.substr(0,4),ie=T.substr(0,6);let re;return process.platform!=="darwin"&&e.$ri&&!process.env.VSCODE_PORTABLE?re=(0,E.$jc)(e.$ri,`vscode-${V}-${Q}-${ie}.sock`):re=(0,E.$jc)(C,`${Q}-${ie}.sock`),c(re),re}function c(C){const T=o[y.$u];typeof T=="number"&&C.length>=T&&console.warn(`WARNING: IPC handle "${C}" is longer than ${T} chars, try a shorter --user-data-dir`)}class u extends b.$ei{static b(T){const O=v.Event.fromNodeEventEmitter(T,"connection");return v.Event.map(O,P=>({protocol:new a.$li(new f(P,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(P,"close"))}))}constructor(T){super(u.b(T)),this.d=T}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ui=u;function k(C){return new Promise((T,O)=>{const P=(0,r.createServer)();P.on("error",O),P.listen(C,()=>{P.removeListener("error",O),T(new u(P))})})}function I(C,T){return new Promise((O,P)=>{const V=(0,r.createConnection)(C,()=>{V.removeListener("error",P),O(a.$mi.fromSocket(new f(V,`ipc-client${T}`),T))});V.once("error",P)})}}),define(Ee[154],Se([1,0,93,14,15,10,11,27,28,94,12,47,269,323]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0,e.$7r=h;let a=class extends y.$Wp{constructor(w,m,$,l){super(l),this.m=w,this.n=m,this.r=$,this.s(),this.B(w.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const w=this.m.getValue("http");this.f=w?.proxy,this.g=!!w?.proxyStrictSSL,this.h=w?.proxyAuthorization}async request(w,m){const{f:$,g:l}=this;let t;try{t=await(0,s.$Lm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$0)(i)))}const o={...process.env,...t},d=w.agent?w.agent:await(0,p.$5r)(w.url||"",o,{proxyUrl:$,strictSSL:l});return w.agent=d,w.strictSSL=l,this.h&&(w.headers={...w.headers||{},"Proxy-Authorization":this.h}),this.c(w.isChromiumNetwork?"electron":"node",w,()=>h(w,m))}async resolveProxy(w){}async loadCertificates(){return(await new Promise((m,$)=>{fe(["@vscode/proxy-agent"],m,$)})).loadSystemCertificates({log:this.r})}};e.$6r=a,e.$6r=a=Ue([Fe(0,R.$7i),Fe(1,v.$Ii),Fe(2,E.$7j),Fe(3,E.$8j)],a);async function f(g){return((0,n.parse)(g.url).protocol==="https:"?await new Promise(($,l)=>{fe(["https"],$,l)}):await new Promise(($,l)=>{fe(["http"],$,l)})).request}async function h(g,w){return r.Promises.withAsyncBody(async(m,$)=>{const l=(0,n.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await f(g),o={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,A.$gg)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const d=t(o,i=>{const c=(0,A.$eg)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&c>0&&i.headers.location)h({...g,url:i.headers.location,followRedirects:c-1},w).then(m,$);else{let u=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(u=i.pipe((0,b.createGunzip)())),m({res:i,stream:(0,S.$Ye)(u)})}});d.on("error",$),g.timeout&&d.setTimeout(g.timeout),g.isChromiumNetwork&&d.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&d.write(g.data),d.end(),w.onCancellationRequested(()=>{d.abort(),$(new D.$5)})})}}),define(Ee[155],Se([1,0,60,83,143,13,9,15,6,76,94,12,54,3,69,142,2,309,27]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$un=m;async function m(i={},c,u,k,I,C){const T=await(0,S.$fm)(u,k.userDataPath);let O={};if(c)try{O=await(0,E.$Lm)(C,I,k.args,process.env)}catch(ne){I.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ne)}const V={...process.env,...O,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(T,void 0,0),...i},Q=k.isBuilt?(0,A.$jc)(k.appRoot,"bin"):(0,A.$jc)(k.appRoot,"resources","server","bin-dev"),ie=(0,A.$jc)(Q,"remote-cli");let re=t(V,"PATH");return re?re=ie+A.$tc+re:re=ie,o(V,"PATH",re),k.args["without-browser-env-var"]||(V.BROWSER=(0,A.$jc)(Q,"helpers",b.$i?"browser.cmd":"browser.sh")),d(V),V}class ${constructor(c,u){this.socket=c,this.initialDataChunk=u}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let c,u,k;return this.socket instanceof s.$pi?(c=!0,u=!1,k=R.$Je.alloc(0)):(c=!1,u=this.socket.permessageDeflate,k=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:c,permessageDeflate:u,inflateBytes:k.buffer.toString("base64")}}}let l=class{constructor(c,u,k,I,C,T,O,P){this.i=c,this.j=C,this.l=T,this.m=O,this.n=P,this.b=new v.$he,this.onClose=this.b.event,this.c=!b.$i||!this.j.args["socket-path"],this.d=!1,this.f=u,this.g=null,this.h=new $(k,I),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(c){this.l.info(`${this.o}${c}`)}q(c){this.l.error(`${this.o}${c}`)}async r(c,u){const k=new h.$Tc;k.add(u.socket),k.add((0,h.$Sc)(()=>{c.destroy()}));const I=()=>{k.dispose()};k.add(u.socket.onEnd(I)),k.add(u.socket.onClose(I)),k.add(v.Event.fromNodeEventEmitter(c,"end")(I)),k.add(v.Event.fromNodeEventEmitter(c,"close")(I)),k.add(v.Event.fromNodeEventEmitter(c,"error")(I)),k.add(u.socket.onData(C=>c.write(C.buffer))),k.add(v.Event.fromNodeEventEmitter(c,"data")(C=>{u.socket.write(R.$Je.wrap(C))})),u.initialDataChunk.byteLength>0&&c.write(u.initialDataChunk.buffer)}async s(c,u){await u.socketDrain();const k=u.toIExtHostSocketMessage();let I;u.socket instanceof s.$pi?I=u.socket.socket:I=u.socket.socket.socket,c.send(k,I)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const c={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(c)}acceptReconnection(c,u,k){this.f=c,this.p("The client has reconnected.");const I=new $(u,k);if(!this.g){this.h=I;return}this.s(this.g,I)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(c){try{let u=process.execArgv?process.execArgv.filter(ie=>!/^--inspect(-brk)?=/.test(ie)):[];c.port&&!process.pkg&&(u=[`--inspect${c.break?"-brk":""}=${c.port}`]);const k=await m(c.env,!0,c.language,this.j,this.l,this.n);(0,a.$sm)(k);let I;if(this.c)(0,g.$sn)(new g.$qn,k),I=null;else{const{namedPipeServer:ie,pipeName:re}=await this.u();(0,g.$sn)(new g.$pn(re),k),I=ie}const C={env:k,execArgv:u,silent:!0};C.execArgv.unshift("--dns-result-order=ipv4first");const T=["--type=extensionHost","--transformURIs"],O=this.j.args["use-host-proxy"];T.push(`--useHostProxy=${O?"true":"false"}`),this.g=n.fork(D.$Ug.asFileUri("bootstrap-fork").fsPath,T,C);const P=this.g.pid;this.p(`<${P}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const V=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),Q=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if(V(ie=>this.p(`<${P}> ${ie}`)),Q(ie=>this.p(`<${P}><stderr> ${ie}`)),this.g.on("error",ie=>{this.q(`<${P}> Extension Host Process had an error`),this.l.error(ie),this.t()}),this.g.on("exit",(ie,re)=>{this.m.setExitInfo(this.i,{code:ie,signal:re}),this.p(`<${P}> Extension Host Process exited with code: ${ie}, signal: ${re}.`),this.t()}),I)I.on("connection",ie=>{I.close(),this.r(ie,this.h)});else{const ie=re=>{re.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",ie),this.s(this.g,this.h),this.h=null)};this.g.on("message",ie)}}catch(u){console.error("ExtensionHostConnection errored"),u&&console.error(u)}}u(){return new Promise((c,u)=>{const k=(0,s.$si)(),I=r.createServer();I.on("error",u),I.listen(k,()=>{I?.removeListener("error",u),c({pipeName:k,namedPipeServer:I})})})}};e.$vn=l,e.$vn=l=Ue([Fe(4,p.$fn),Fe(5,y.$7j),Fe(6,f.$nn),Fe(7,w.$7i)],l);function t(i,c){const u=Object.keys(i).filter(I=>I.toLowerCase()===c.toLowerCase()),k=u.length>0?u[0]:c;return i[k]}function o(i,c,u){const k=Object.keys(i).filter(C=>C.toLowerCase()===c.toLowerCase()),I=k.length>0?k[0]:c;i[I]=u}function d(i){for(const c of Object.keys(i))i[c]===null&&delete i[c]}}),define(Ee[324],Se([1,0,89,12,71,128,27,47,154,41,24,30,140,138,95,121,63,2,122,72,13,16,29,54,131,92,132,10,4,9,33,267,88,36,136,70,3,64,144,34,53,73,141,139,124,125,228,325]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m,$,l,t,o,d,i,c,u,k,I,C,T,O,P,V,Q,ie,re,ne,se,Z,ee,ue,j,B,oe,le,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=Y;class q extends g.$Uc{constructor(L,W){super(),this.a=L,this.b=W,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const L=await this.f();await L.invokeFunction(async W=>{const z=W.get(A.$7i),U=W.get(r.$7j);ie.$i&&(z.getValue("security.restrictUNCAccess")===!1?(0,pe.disableUNCAccessRestrictions)():(0,pe.addUNCHostToAllowlist)(z.getValue("security.allowedUNCHosts")));try{await this.g(L.createInstance(d.$kq,new r.$ck(U.getLevel(),!1)))}catch(J){throw U.error(J),console.error((0,u.$0)(J)),J}})}async f(){const L=new n.$yi,W={_serviceBrand:void 0,...h.default};L.set(t.$nk,W);const z=new o.$gn(this.a,W);L.set(o.$fn,z);const U=new oe.$cQ((0,r.$ik)(z),z.logsHome);L.set(r.$8j,U);const J=new B.$mQ(this.B(U.createLogger("remoteCLI",{name:(0,le.localize)(0,null)})));L.set(r.$7j,J),J.trace(`Remote configuration data at ${this.b}`),J.trace("process arguments:",this.a);const x=this.B(new w.$Qq(J));L.set(l.$7k,x),x.registerProvider($.Schemas.file,this.B(new m.$hr(J)));const M=new V.$Is(x);L.set(P.$El,M);const G=this.B(new ue.$kQ(M,z,x,J));L.set(se.$Gl,G);const te=this.B(new D.$No(G.defaultProfile.settingsResource,x,new ee.$no,J));return L.set(A.$7i,te),await Promise.all([te.initialize(),G.init()]),L.set(R.$Vp,new S.$xi(v.$6r)),L.set(O.$Ro,new S.$xi(T.$BQ)),L.set(E.$6l,s.$pp),L.set(y.$bp,new S.$xi(p.$gq)),L.set(Z.$xq,new S.$xi(j.$lQ)),L.set(re.$Bq,new S.$xi(ne.$$P)),L.set(a.$hq,new S.$xi(a.$jq)),L.set(b.$Mq,new S.$xi(b.$Nq)),L.set(i.$Zr,new S.$xi(c.$2r)),new f.$kr(L)}async g(L){if(this.a["list-extensions"])return L.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const W={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return L.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),W,!!this.a.force)}else{if(this.a["uninstall-extension"])return L.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return L.updateExtensions();if(this.a["locate-extension"])return L.locateExtension(this.a["locate-extension"])}}h(L){return L.map(W=>/\.vsix$/i.test(W)?k.URI.file((0,I.$ic)(W)?W:(0,I.$jc)((0,C.cwd)(),W)):W)}}function ae(H){setTimeout(()=>process.exit(H),0)}async function Y(H,L,W){if(H.help){const U=h.default.serverApplicationName+(ie.$i?".cmd":"");console.log((0,Q.$Am)(h.default.nameLong,U,h.default.version,W,{noInputFiles:!0,noPipe:!0}));return}if(H.version){console.log((0,Q.$Bm)(h.default.version,h.default.commit));return}const z=new q(H,L);try{await z.run(),ae(0)}catch{ae(1)}finally{z.dispose()}}}),define(Ee[326],Se([1,0,76,338,31,321,4,12,98]),function(fe,e,n,r,S,D,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=e.$nP=void 0;class s{constructor(p,b,a){this.b=p,this.c=b,this.f=a,this.a=r.createServer((f,h)=>this.h(f,h)),this.g().catch(f=>(b.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,b){const a=(h,g)=>{b.writeHead(h,{"content-type":"application/json"}),b.end(JSON.stringify(g||null),w=>w&&this.c.error(w))},f=[];p.setEncoding("utf8"),p.on("data",h=>f.push(h)),p.on("end",async()=>{try{const h=JSON.parse(f.join(""));let g;switch(h.type){case"open":g=await this.i(h);break;case"openExternal":g=await this.j(h);break;case"status":g=await this.l(h);break;case"extensionManagement":g=await this.k(h);break;default:a(404,`Unknown message type: ${h.type}`);break}a(200,g)}catch(h){const g=h instanceof Error?h.message:JSON.stringify(h);a(500,g),this.c.error("Error while processing pipe request",h)}})}async i(p){const{fileURIs:b,folderURIs:a,forceNewWindow:f,diffMode:h,mergeMode:g,addMode:w,forceReuseWindow:m,gotoLineMode:$,waitMarkerFilePath:l,remoteAuthority:t}=p,o=[];if(Array.isArray(a))for(const u of a)try{o.push({folderUri:A.URI.parse(u)})}catch{}if(Array.isArray(b))for(const u of b)try{(0,v.$6i)(u)?o.push({workspaceUri:A.URI.parse(u)}):o.push({fileUri:A.URI.parse(u)})}catch{}const d=l?A.URI.file(l):void 0,c={forceNewWindow:f,diffMode:h,mergeMode:g,addMode:w,gotoLineMode:$,forceReuseWindow:m,preferNewWindow:!m&&!d&&!w,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",o,c)}async j(p){for(const b of p.uris){const a=A.URI.parse(b),f=a.scheme==="file"?a:b;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k(p){const b=f=>f?.map(h=>/\.vsix$/i.test(h)?A.URI.parse(h):h),a={list:p.list,install:b(p.install),uninstall:b(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",a)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&S.existsSync(this.f)&&S.unlinkSync(this.f)}}e.$nP=s;let E=class extends s{constructor(p,b){super(p,b,(0,n.$si)())}};e.$oP=E,e.$oP=E=Ue([Fe(0,D.$iP),Fe(1,R.$7j)],E)}),define(Ee[327],Se([1,0,32,6,21,2,9,3,4,76,74,326,134,97,145,304,306,155,14,135]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;class $ extends h.$3P{constructor(o,d,i,c,u){super({getFolderUri:k=>{const I=d.filter(C=>C.name===k);if(I&&I.length>0)return I[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(k,I)=>c[`config:${I}`],getExecPath:()=>o.VSCODE_EXEC_PATH,getAppRoot:()=>o.VSCODE_CWD,getFilePath:()=>{if(i)return A.$hc(i.fsPath)},getSelectedText:()=>c.selectedText,getLineNumber:()=>c.lineNumber,getExtension:async k=>{const C=(await u.getInstalled()).find(T=>T.identifier.id===k);return C&&{extensionLocation:C.location}}},void 0,Promise.resolve(n.homedir()),Promise.resolve(o))}}class l extends D.$Uc{constructor(o,d,i,c,u,k){super(),this.g=o,this.h=d,this.j=i,this.m=c,this.n=u,this.r=k,this.a=0,this.b=new Map,this.c=this.B(new r.$he),this.onExecuteCommand=this.c.event}async call(o,d,i){switch(d){case a.RemoteTerminalChannelRequest.RestartPtyHost:return this.j.restartPtyHost.apply(this.j,i);case a.RemoteTerminalChannelRequest.CreateProcess:{const c=(0,E.$Js)(o.remoteAuthority);return this.s(c,i)}case a.RemoteTerminalChannelRequest.AttachToProcess:return this.j.attachToProcess.apply(this.j,i);case a.RemoteTerminalChannelRequest.DetachFromProcess:return this.j.detachFromProcess.apply(this.j,i);case a.RemoteTerminalChannelRequest.ListProcesses:return this.j.listProcesses.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetLatency:return this.j.getLatency.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetPerformanceMarks:return this.j.getPerformanceMarks.apply(this.j,i);case a.RemoteTerminalChannelRequest.OrphanQuestionReply:return this.j.orphanQuestionReply.apply(this.j,i);case a.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables:return this.j.acceptPtyHostResolvedVariables.apply(this.j,i);case a.RemoteTerminalChannelRequest.Start:return this.j.start.apply(this.j,i);case a.RemoteTerminalChannelRequest.Input:return this.j.input.apply(this.j,i);case a.RemoteTerminalChannelRequest.AcknowledgeDataEvent:return this.j.acknowledgeDataEvent.apply(this.j,i);case a.RemoteTerminalChannelRequest.Shutdown:return this.j.shutdown.apply(this.j,i);case a.RemoteTerminalChannelRequest.Resize:return this.j.resize.apply(this.j,i);case a.RemoteTerminalChannelRequest.ClearBuffer:return this.j.clearBuffer.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetInitialCwd:return this.j.getInitialCwd.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetCwd:return this.j.getCwd.apply(this.j,i);case a.RemoteTerminalChannelRequest.ProcessBinary:return this.j.processBinary.apply(this.j,i);case a.RemoteTerminalChannelRequest.SendCommandResult:return this.u(i[0],i[1],i[2]);case a.RemoteTerminalChannelRequest.InstallAutoReply:return this.j.installAutoReply.apply(this.j,i);case a.RemoteTerminalChannelRequest.UninstallAllAutoReplies:return this.j.uninstallAllAutoReplies.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetDefaultSystemShell:return this.w.apply(this,i);case a.RemoteTerminalChannelRequest.GetProfiles:return this.y.apply(this,i);case a.RemoteTerminalChannelRequest.GetEnvironment:return this.z();case a.RemoteTerminalChannelRequest.GetWslPath:return this.C(i[0],i[1]);case a.RemoteTerminalChannelRequest.GetTerminalLayoutInfo:return this.j.getTerminalLayoutInfo(i);case a.RemoteTerminalChannelRequest.SetTerminalLayoutInfo:return this.j.setTerminalLayoutInfo(i);case a.RemoteTerminalChannelRequest.SerializeTerminalState:return this.j.serializeTerminalState.apply(this.j,i);case a.RemoteTerminalChannelRequest.ReviveTerminalProcesses:return this.j.reviveTerminalProcesses.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetRevivedPtyNewId:return this.j.getRevivedPtyNewId.apply(this.j,i);case a.RemoteTerminalChannelRequest.SetUnicodeVersion:return this.j.setUnicodeVersion.apply(this.j,i);case a.RemoteTerminalChannelRequest.ReduceConnectionGraceTime:return this.D();case a.RemoteTerminalChannelRequest.UpdateIcon:return this.j.updateIcon.apply(this.j,i);case a.RemoteTerminalChannelRequest.UpdateTitle:return this.j.updateTitle.apply(this.j,i);case a.RemoteTerminalChannelRequest.UpdateProperty:return this.j.updateProperty.apply(this.j,i);case a.RemoteTerminalChannelRequest.RefreshProperty:return this.j.refreshProperty.apply(this.j,i);case a.RemoteTerminalChannelRequest.RequestDetachInstance:return this.j.requestDetachInstance(i[0],i[1]);case a.RemoteTerminalChannelRequest.AcceptDetachedInstance:return this.j.acceptDetachInstanceReply(i[0],i[1]);case a.RemoteTerminalChannelRequest.FreePortKillProcess:return this.j.freePortKillProcess.apply(this.j,i);case a.RemoteTerminalChannelRequest.AcceptDetachInstanceReply:return this.j.acceptDetachInstanceReply.apply(this.j,i)}throw new Error(`IPC Command ${d} not found`)}listen(o,d,i){switch(d){case a.RemoteTerminalChannelEvent.OnPtyHostExitEvent:return this.j.onPtyHostExit||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostStartEvent:return this.j.onPtyHostStart||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent:return this.j.onPtyHostUnresponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent:return this.j.onPtyHostResponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent:return this.j.onPtyHostRequestResolveVariables||r.Event.None;case a.RemoteTerminalChannelEvent.OnProcessDataEvent:return this.j.onProcessData;case a.RemoteTerminalChannelEvent.OnProcessReadyEvent:return this.j.onProcessReady;case a.RemoteTerminalChannelEvent.OnProcessExitEvent:return this.j.onProcessExit;case a.RemoteTerminalChannelEvent.OnProcessReplayEvent:return this.j.onProcessReplay;case a.RemoteTerminalChannelEvent.OnProcessOrphanQuestion:return this.j.onProcessOrphanQuestion;case a.RemoteTerminalChannelEvent.OnExecuteCommand:return this.onExecuteCommand;case a.RemoteTerminalChannelEvent.OnDidRequestDetach:return this.j.onDidRequestDetach||r.Event.None;case a.RemoteTerminalChannelEvent.OnDidChangeProperty:return this.j.onDidChangeProperty}throw new Error(`IPC Command ${d} not found`)}async s(o,d){const i={name:d.shellLaunchConfig.name,executable:d.shellLaunchConfig.executable,args:d.shellLaunchConfig.args,cwd:typeof d.shellLaunchConfig.cwd=="string"||typeof d.shellLaunchConfig.cwd>"u"?d.shellLaunchConfig.cwd:v.URI.revive(o.transformIncoming(d.shellLaunchConfig.cwd)),env:d.shellLaunchConfig.env,useShellEnvironment:d.shellLaunchConfig.useShellEnvironment,reconnectionProperties:d.shellLaunchConfig.reconnectionProperties,type:d.shellLaunchConfig.type,isFeatureTerminal:d.shellLaunchConfig.isFeatureTerminal},c=await(0,g.$un)(d.resolverEnv,!!d.shellLaunchConfig.useShellEnvironment,R.$w,this.g,this.h,this.r);this.h.trace("baseEnv",c);const u=ee=>({uri:v.URI.revive(o.transformIncoming(ee.uri)),name:ee.name,index:ee.index,toResource:()=>{throw new Error("Not implemented")}}),k=d.workspaceFolders.map(u),I=d.activeWorkspaceFolder?u(d.activeWorkspaceFolder):void 0,C=d.activeFileResource?v.URI.revive(o.transformIncoming(d.activeFileResource)):void 0,T=new $(c,k,C,d.resolvedVariables,this.n),O=f.$YP(I,process.env,T),P=await f.$XP(i,n.homedir(),O,I?.uri,d.configuration["terminal.integrated.cwd"],this.h);i.cwd=P;const V=R.$i?"terminal.integrated.env.windows":R.$j?"terminal.integrated.env.osx":"terminal.integrated.env.linux",Q=d.configuration[V],ie=await f.$ZP(i,Q,O,this.m.version,d.configuration["terminal.integrated.detectLocale"],c);if((0,m.$RP)(i)){const ee=[];for(const[oe,le,pe]of d.envVariableCollections)ee.push([oe,{map:(0,b.$vs)(le),descriptionMap:(0,b.$ws)(pe)}]);const ue=new Map(ee),j=new p.$zs(ue),B=I?I??void 0:void 0;await j.applyToProcessEnvironment(ie,{workspaceFolder:B},O)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:i,initialCwd:P,cols:d.cols,rows:d.rows,env:ie});const re=(0,s.$si)();ie.VSCODE_IPC_HOOK_CLI=re;const ne=await this.j.createProcess(i,P,d.cols,d.rows,d.unicodeVersion,ie,c,d.options,d.shouldPersistTerminal,d.workspaceId,d.workspaceName),se={executeCommand:(ee,...ue)=>this.t(ne,ee,ue,o)},Z=new y.$nP(se,this.h,re);return this.j.onProcessExit(ee=>ee.id===ne&&Z.dispose()),{persistentTerminalId:ne,resolvedShellLaunchConfig:i}}t(o,d,i,c){const{resolve:u,reject:k,promise:I}=(0,w.$th)(),C=++this.a;this.b.set(C,{resolve:u,reject:k,uriTransformer:c});const T=(0,S.$$n)(i,O=>{if(O&&O.$mid===1)return c.transformOutgoing(O);if(O&&O instanceof v.URI)return c.transformOutgoingURI(O)});return this.c.fire({reqId:C,persistentProcessId:o,commandId:d,commandArgs:T}),I}u(o,d,i){const c=this.b.get(o);if(!c)return;this.b.delete(o);const u=(0,S.$$n)(i,k=>{if(k&&k.$mid===1)return c.uriTransformer.transformIncoming(k)});d?c.reject(u):c.resolve(u)}w(o){return this.j.getDefaultSystemShell(o)}async y(o,d,i,c){return this.j.getProfiles(o,d,i,c)||[]}z(){return{...process.env}}C(o,d){return this.j.getWslPath(o,d)}D(){return this.j.reduceConnectionGraceTime()}}e.$4P=l}),define(Ee[328],Se([1,0,32,6,2,13,9,112,25,50,61,27,128,240,88,241,28,140,30,95,131,265,138,16,122,72,71,121,89,92,132,12,63,29,47,268,154,130,24,41,280,52,287,36,136,298,299,274,278,327,74,54,308,322,142,64,144,53,34,73,279,125,141,139,124,123,230,317,264,292,284]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m,$,l,t,o,d,i,c,u,k,I,C,T,O,P,V,Q,ie,re,ne,se,Z,ee,ue,j,B,oe,le,pe,q,ae,Y,H,L,W,z,U,J,x,M,G,te,he,ke,Ne,me,be,Ae,Le,de,Ie,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wQ=void 0,e.$vQ=He;const Me="monacoworkbench";async function He(tt,_e,Xe,Qe){const $e=new k.$yi,Oe=new Ve,ve={_serviceBrand:void 0,...O.default};$e.set(P.$nk,ve);const ye=new H.$gn(_e,ve);$e.set(h.$Hi,ye),$e.set(h.$Ii,ye);const X=new he.$cQ((0,T.$ik)(ye),ye.logsHome);$e.set(T.$8j,X),Oe.registerChannel("logger",new be.$is(X,ct=>We(ct.remoteAuthority)));const _=X.createLogger("remoteagent",{name:(0,Ae.localize)(0,null)}),we=new me.$mQ(_,[new Ze((0,T.$ik)(ye))]);$e.set(T.$7j,we),setTimeout(()=>ot(ye.logsHome.with({scheme:D.Schemas.file}).fsPath).then(null,ct=>we.error(ct)),1e4),we.onDidChangeLogLevel(ct=>(0,T.log)(we,ct,`Log level changed to ${(0,T.$jk)(we.getLevel())}`)),we.trace(`Remote configuration data at ${Xe}`),we.trace("process arguments:",ye.args),Array.isArray(ve.serverGreeting)&&we.info(`

${ve.serverGreeting.join(`
`)}

`),Oe.registerChannel(b.$Po.ChannelName,new b.$Po);const ze=new s.$ii(ct=>ct.clientId==="renderer"),Ge=Qe.add(new d.$Qq(we));$e.set(o.$7k,Ge),Ge.registerProvider(D.Schemas.file,Qe.add(new i.$hr(we)));const Ye=new B.$Is(Ge);$e.set(j.$El,Ye);const et=new p.$No(ye.machineSettingsResource,Ge,new G.$no,we);$e.set(y.$7i,et);const lt=new ke.$kQ(Ye,ye,Ge,we);$e.set(M.$Gl,lt),Oe.registerChannel("userDataProfiles",new Ie.$sQ(lt,ct=>We(ct.remoteAuthority)));const[,,ut,dt,Ct]=await Promise.all([et.initialize(),lt.init(),(0,R.$Kn)(we.error.bind(we)),(0,R.$Ln)(we.error.bind(we)),(0,R.$Mn)(we.error.bind(we))]),Dt=new z.$on;$e.set(z.$nn,Dt);const ht=new ie.$6r(et,ye,we,X);$e.set(V.$Vp,ht);let mt=se.$tp;const pt=(0,se.$zp)(ve,et);if((0,se.$up)(ve,ye)){!(0,se.$vp)(ve,ye)&&ve.aiConfig?.ariaKey&&(mt=new te.$aQ(ht,pt,Me,null,ve.aiConfig.ariaKey),Qe.add((0,S.$Sc)(()=>mt?.flush())));const ct={appenders:[mt],commonProperties:(0,re.$lp)((0,n.release)(),(0,n.hostname)(),process.arch,ve.commit,ve.version+"-remote",ut,dt,Ct,pt,"remoteAgent"),piiPaths:(0,se.$Ap)(ye)},$t=ye.args["telemetry-level"];let bt=ne.TelemetryLevel.USAGE;$t==="all"?bt=ne.TelemetryLevel.USAGE:$t==="error"?bt=ne.TelemetryLevel.ERROR:$t==="crash"?bt=ne.TelemetryLevel.CRASH:$t!==void 0&&(bt=ne.TelemetryLevel.NONE),$e.set(q.$Ws,new c.$xi(q.$Us,[ct,bt]))}else $e.set(q.$Ws,q.$Vs);$e.set(w.$bp,new c.$xi(g.$gq));const Ft=Oe.getChannel("download",ze);$e.set(a.$Ro,new f.$To(Ft,()=>We("renderer"))),$e.set(x.$xq,new c.$xi(Ne.$lQ)),$e.set(U.$Bq,new c.$xi(J.$$P)),$e.set(m.$hq,new c.$xi(m.$jq)),$e.set(t.$Mq,new c.$xi(t.$Nq));const yt=new u.$kr($e);$e.set(I.$Zr,yt.createInstance(C.$2r));const jt=yt.createInstance(Re.$uQ,{graceTime:E.ProtocolConstants.ReconnectionGraceTime,shortGraceTime:E.ProtocolConstants.ReconnectionShortGraceTime,scrollback:et.getValue(ee.TerminalSettingId.PersistentSessionScrollback)??100}),Tt=yt.createInstance(ue.$Es,jt);return $e.set(ee.$ds,Tt),yt.invokeFunction(ct=>{const $t=ct.get(t.$Mq),bt=ct.get(U.$Bq),Et=ct.get(w.$bp),It=ct.get(I.$Zr),Vt=new oe.$Qs(tt,ye,lt,Dt);Oe.registerChannel("remoteextensionsenvironment",Vt);const Ot=new pe.$Xs(ct.get(q.$Ws),mt);Oe.registerChannel("telemetry",Ot),Oe.registerChannel(L.$5P,new ae.$4P(ye,we,Tt,ve,$t,et));const Pt=new Le.$qQ(yt.createInstance($.$kq,we),ye,lt,bt,we,Et,It);Oe.registerChannel(de.$pQ,new Le.$rQ(Pt,wt=>We(wt.remoteAuthority)));const Bt=Qe.add(new le.$Ts(we,ye));Oe.registerChannel(W.$9P,Bt),Oe.registerChannel("request",new Q.$3r(ct.get(V.$Vp)));const Gt=new l.$lq($t,wt=>We(wt.remoteAuthority));return Oe.registerChannel("extensions",Gt),Pt.whenExtensionsReady().then(()=>$t.cleanUp()),Qe.add(new Z.default(ct.get(ne.$6l))),{telemetryService:ct.get(ne.$6l)}}),{socketServer:Oe,instantiationService:yt}}const Ke=Object.create(null);function We(tt){return Ke[tt]||(Ke[tt]=(0,Y.$Js)(tt)),Ke[tt]}class Ve extends s.$ei{constructor(){const _e=new r.$he;super(_e.event),this.b=_e}acceptConnection(_e,Xe){this.b.fire({protocol:_e,onDidClientDisconnect:Xe})}}e.$wQ=Ve;class Ze extends T.$_j{constructor(_e=T.$0j){super(),this.setLevel(_e),this.g=!!process.stdout.isTTY}trace(_e,...Xe){this.f(T.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${nt()}]\x1B[0m`,_e,...Xe):console.log(`[${nt()}]`,_e,...Xe))}debug(_e,...Xe){this.f(T.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${nt()}]\x1B[0m`,_e,...Xe):console.log(`[${nt()}]`,_e,...Xe))}info(_e,...Xe){this.f(T.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${nt()}]\x1B[0m`,_e,...Xe):console.log(`[${nt()}]`,_e,...Xe))}warn(_e,...Xe){this.f(T.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${nt()}]\x1B[0m`,_e,...Xe):console.warn(`[${nt()}]`,_e,...Xe))}error(_e,...Xe){this.f(T.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${nt()}]\x1B[0m`,_e,...Xe):console.error(`[${nt()}]`,_e,...Xe))}flush(){}}function nt(){const tt=new Date;return`${it(tt.getHours())}:${it(tt.getMinutes())}:${it(tt.getSeconds())}`}function it(tt){return tt<10?`0${tt}`:String(tt)}async function ot(tt){const _e=A.$nc(tt),Xe=A.$mc(tt),Oe=(await v.Promises.readdir(Xe)).filter(ye=>/^\d{8}T\d{6}$/.test(ye)).sort().filter(ye=>ye!==_e),ve=Oe.slice(0,Math.max(0,Oe.length-9));await Promise.all(ve.map(ye=>v.Promises.rm(A.$jc(Xe,ye))))}}),define(Ee[329],Se([1,0,96,31,83,330,93,104,15,35,10,37,2,13,9,45,3,17,4,22,194,177,325,61,76,27,5,12,29,263,24,155,293,101,54,328,295]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p,b,a,f,h,g,w,m,$,l,t,o,d,i,c,u,k,I,C,T,O,P,V,Q,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AQ=se;const re=5*60*1e3;let ne=class extends p.$Uc{constructor(ue,j,B,oe,le,pe,q,ae,Y){super(),this.n=ue,this.r=j,this.s=B,this.t=pe,this.u=q,this.w=ae,this.y=Y,this.h=Z.create(this.u),this.j=(0,b.$Og)(q,le),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=oe?this.y.createInstance(ie.$zQ,this.r,le??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(ue,j){if(ue.method!=="GET")return(0,ie.$xQ)(ue,j,405,`Unsupported method ${ue.method}`);if(!ue.url)return(0,ie.$xQ)(ue,j,400,"Bad request.");const B=A.parse(ue.url,!0);let oe=B.pathname;if(!oe)return(0,ie.$xQ)(ue,j,400,"Bad request.");if(oe.startsWith(this.j)&&oe.charCodeAt(this.j.length)===s.CharCode.Slash&&(oe=oe.substring(this.j.length)),oe==="/version")return j.writeHead(200,{"Content-Type":"text/plain"}),void j.end(this.u.commit||"");if(oe==="/delay-shutdown")return this.N(),j.writeHead(200),void j.end("OK");if(!(0,P.$Cn)(this.r,ue,B))return(0,ie.$xQ)(ue,j,403,"Forbidden.");if(oe==="/vscode-remote-resource"){const le=B.query.path;if(typeof le!="string")return(0,ie.$xQ)(ue,j,400,"Bad request.");let pe;try{pe=w.URI.from({scheme:b.Schemas.file,path:le}).fsPath}catch{return(0,ie.$xQ)(ue,j,400,"Bad request.")}const q=Object.create(null);this.t.isBuilt&&((0,y.$zg)(pe,this.t.builtinExtensionsPath,!h.$k)||(0,y.$zg)(pe,this.t.extensionsPath,!h.$k))&&(q["Cache-Control"]="public, max-age=31536000"),q.Vary="Origin";const ae=ue.headers.origin;return ae&&this.h.matches(ae)&&(q["Access-Control-Allow-Origin"]=ae),(0,ie.$yQ)(pe,ie.CacheControl.ETAG,this.w,ue,j,q)}if(this.g){this.g.handle(ue,j,B);return}return j.writeHead(404,{"Content-Type":"text/plain"}),void j.end("Not found")}handleUpgrade(ue,j){let B=(0,m.$Wg)(),oe=!1,le=!1;if(ue.url){const L=A.parse(ue.url,!0).query;typeof L.reconnectionToken=="string"&&(B=L.reconnectionToken),L.reconnection==="true"&&(oe=!0),L.skipWebSocketFrames==="true"&&(le=!0)}if(ue.headers.upgrade===void 0||ue.headers.upgrade.toLowerCase()!=="websocket"){j.end("HTTP/1.1 400 Bad Request");return}const pe=ue.headers["sec-websocket-key"],q=n.createHash("sha1");q.update(pe+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const Y=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${q.digest("base64")}`];let H=!1;if(!le&&!this.t.args["disable-websocket-compression"]&&ue.headers["sec-websocket-extensions"]){const L=Array.isArray(ue.headers["sec-websocket-extensions"])?ue.headers["sec-websocket-extensions"]:[ue.headers["sec-websocket-extensions"]];for(const W of L)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(W)){if(/\b(permessage-deflate)\b/.test(W)){H=!0,Y.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(W)){H=!0,Y.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}j.write(Y.join(`\r
`)+`\r
\r
`),j.setTimeout(0),j.setNoDelay(!0),le?this.D(new d.$pi(j,`server-connection-${B}`),oe,B):this.D(new d.$qi(new d.$pi(j,`server-connection-${B}`),H,null,!0),oe,B)}handleServerError(ue){this.w.error("Error occurred in server"),this.w.error(ue)}z(ue){let j;return ue instanceof d.$pi?j=ue.socket:j=ue.socket.socket,j.remoteAddress||"<unknown>"}async C(ue,j,B){const oe=j.getSocket();this.w.error(`${ue} ${B}.`);const le={type:"error",reason:B};j.sendControl(v.$Je.fromString(JSON.stringify(le))),j.dispose(),await oe.drain(),oe.dispose()}D(ue,j,B){const oe=this.z(ue),le=`[${oe}][${B.substr(0,8)}]`,pe=new o.$oi({socket:ue}),q=this.s?new this.s.validator:null,ae=this.s?new this.s.signer:null;let Y;(function(z){z[z.WaitingForAuth=0]="WaitingForAuth",z[z.WaitingForConnectionType=1]="WaitingForConnectionType",z[z.Done=2]="Done",z[z.Error=3]="Error"})(Y||(Y={}));let H=Y.WaitingForAuth;const L=z=>{H=Y.Error,W.dispose(),this.C(le,pe,z)},W=pe.onControlMessage(z=>{if(H===Y.WaitingForAuth){let U;try{U=JSON.parse(z.toString())}catch{return L("Malformed first message")}if(U.type!=="auth")return L("Invalid first message");if(this.r.type===P.ServerConnectionTokenType.Mandatory&&!this.r.validate(U.auth))return L("Unauthorized client refused: auth mismatch");let J=(0,m.$Wg)();if(ae)try{J=ae.sign(U.data)}catch{}let x=(0,m.$Wg)();if(q)try{x=q.createNewMessage(x)}catch{}const M={type:"sign",data:x,signedData:J};pe.sendControl(v.$Je.fromString(JSON.stringify(M))),H=Y.WaitingForConnectionType}else if(H===Y.WaitingForConnectionType){let U;try{U=JSON.parse(z.toString())}catch{return L("Malformed second message")}if(U.type!=="connectionType")return L("Invalid second message");if(typeof U.signedData!="string")return L("Invalid second message field type");const J=U.commit,x=this.u.commit;if(J&&x&&J!==x)return L("Client refused: version mismatch");let M=!1;if(!q)M=!0;else if(this.r.validate(U.signedData))M=!0;else try{M=q.validate(U.signedData)==="ok"}catch{}if(!M){if(this.t.isBuilt)return L("Unauthorized client refused");this.w.error(`${le} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const G in this.b)this.b[G].shortenReconnectionGraceTimeIfNecessary();for(const G in this.a)this.a[G].shortenReconnectionGraceTimeIfNecessary();H=Y.Done,W.dispose(),this.F(oe,le,pe,ue,j,B,U)}})}async F(ue,j,B,oe,le,pe,q){const ae=q.desiredConnectionType===I.ConnectionType.Management?`${j}[ManagementConnection]`:q.desiredConnectionType===I.ConnectionType.ExtensionHost?`${j}[ExtensionHostConnection]`:j;if(q.desiredConnectionType===I.ConnectionType.Management)if(le){if(!this.b[pe])return this.f.has(pe)?this.C(ae,B,"Unknown reconnection token (seen before)"):this.C(ae,B,"Unknown reconnection token (never seen)");B.sendControl(v.$Je.fromString(JSON.stringify({type:"ok"})));const Y=B.readEntireBuffer();B.dispose(),this.b[pe].acceptReconnection(ue,oe,Y)}else{if(this.b[pe])return this.C(ae,B,"Duplicate reconnection token");B.sendControl(v.$Je.fromString(JSON.stringify({type:"ok"})));const Y=new O.$wn(this.w,pe,ue,B);this.n.acceptConnection(Y.protocol,Y.onClose),this.b[pe]=Y,this.f.add(pe),Y.onClose(()=>{delete this.b[pe]})}else if(q.desiredConnectionType===I.ConnectionType.ExtensionHost){const Y=q.args||{language:"en"},H=await this.I(Y);if(H.port&&this.w.trace(`${ae} - startParams debug port ${H.port}`),this.w.trace(`${ae} - startParams language: ${H.language}`),this.w.trace(`${ae} - startParams env: ${JSON.stringify(H.env)}`),le){if(!this.a[pe])return this.f.has(pe)?this.C(ae,B,"Unknown reconnection token (seen before)"):this.C(ae,B,"Unknown reconnection token (never seen)");B.sendPause(),B.sendControl(v.$Je.fromString(JSON.stringify(H.port?{debugPort:H.port}:{})));const L=B.readEntireBuffer();B.dispose(),this.a[pe].acceptReconnection(ue,oe,L)}else{if(this.a[pe])return this.C(ae,B,"Duplicate reconnection token");B.sendPause(),B.sendControl(v.$Je.fromString(JSON.stringify(H.port?{debugPort:H.port}:{})));const L=B.readEntireBuffer();B.dispose();const W=this.y.createInstance(T.$vn,pe,ue,oe,L);this.a[pe]=W,this.f.add(pe),W.onClose(()=>{delete this.a[pe],this.J()}),W.start(H)}}else if(q.desiredConnectionType===I.ConnectionType.Tunnel){const Y=q.args;this.G(B,Y)}else return this.C(ae,B,"Unknown initial data received")}async G(ue,j){const B=ue.getSocket().socket,oe=ue.readEntireBuffer();ue.dispose(),B.pause();const le=await this.H(j.host,j.port);oe.byteLength>0&&le.write(oe.buffer),le.on("end",()=>B.end()),le.on("close",()=>B.end()),le.on("error",()=>B.destroy()),B.on("end",()=>le.end()),B.on("close",()=>le.end()),B.on("error",()=>le.destroy()),le.pipe(B),B.pipe(le)}H(ue,j){return new Promise((B,oe)=>{const le=S.createConnection({host:ue,port:j,autoSelectFamily:!0},()=>{le.removeListener("error",oe),le.pause(),B(le)});le.once("error",oe)})}I(ue){return typeof ue.port=="number"?(0,l.$Yg)(ue.port,10,5e3).then(j=>(ue.port=j,ue)):(ue.debugId=void 0,ue.port=void 0,ue.break=void 0,Promise.resolve(ue))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(ue=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!ue?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},re))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};ne=Ue([Fe(5,V.$fn),Fe(6,k.$nk),Fe(7,u.$7j),Fe(8,c.$zi)],ne);async function se(ee,ue,j){const B=await(0,P.$Bn)(ue);B instanceof P.$zn&&(console.warn(B.message),process.exit(1));function oe(G){(0,E.setUnexpectedErrorHandler)(te=>{(0,E.$Z)(te)&&te.stack&&/unexpectedErrorHandler/.test(te.stack)||G(te)})}const le=[];oe(G=>{le.push(G),console.error(G)});let pe=!1;process.on("SIGPIPE",()=>{pe||(pe=!0,(0,E.$1)(new Error("Unexpected SIGPIPE")))});const q=new p.$Tc,{socketServer:ae,instantiationService:Y}=await(0,Q.$vQ)(B,ue,j,q);Y.invokeFunction(G=>{const te=G.get(u.$7j);le.forEach(he=>te.error(he)),le.length=0,oe(he=>te.error(he))}),Y.invokeFunction(G=>{const te=G.get(i.$7i);h.$i&&(te.getValue("security.restrictUNCAccess")===!1?(0,t.disableUNCAccessRestrictions)():(0,t.addUNCHostToAllowlist)(te.getValue("security.allowedUNCHosts")))}),Y.invokeFunction(G=>{const te=G.get(u.$7j);if(h.$i&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const he=(0,a.$jc)(process.env.HOMEDRIVE,"node_modules"),ke=(0,a.$mc)((0,a.$jc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Ne=(0,a.$jc)(ke,"node_modules");if(r.existsSync(he)||r.existsSync(Ne)){const me=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${he}
* ${Ne}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;te.warn(me),console.warn(me),process.exit(0)}}});const H=Y.invokeFunction(G=>{const te=G.get(u.$7j);if(r.existsSync((0,a.$jc)(b.$Ug.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(ke){te.error(ke)}return null});let L=ue["server-base-path"];L&&!L.startsWith("/")&&(L=`/${L}`);const W=r.existsSync(b.$Ug.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(W&&ee&&typeof ee!="string"){const G=B.type!==P.ServerConnectionTokenType.None?`?${b.$Mg}=${B.value}`:"";console.log(`Web UI available at http://localhost${ee.port===80?"":`:${ee.port}`}${L??""}${G}`)}const z=Y.createInstance(ne,ae,B,H,W,L);f.mark("code/server/ready");const U=D.performance.now(),J=global.vscodeServerStartTime,x=global.vscodeServerListenTime,M=global.vscodeServerCodeLoadedTime;if(Y.invokeFunction(async G=>{const te=G.get(C.$6l);if(te.publicLog2("serverStart",{startTime:J,startedTime:x,codeLoadedTime:M,readyTime:U}),h.$k){const he=G.get(u.$7j),ke=await(0,$.$Xg)(he.error.bind(he));ke&&te.publicLog2("serverPlatformInfo",{platformId:ke.id,platformVersionId:ke.version_id,platformIdLike:ke.id_like})}}),ue["print-startup-performance"]){const G=R.$U.get();let te="";te+=`

### Load AMD-module
`,te+=R.$U.toMarkdownTable(["Module","Duration"],G.amdLoad),te+=`

### Load commonjs-module
`,te+=R.$U.toMarkdownTable(["Module","Duration"],G.nodeRequire),te+=`

### Invoke AMD-module factory
`,te+=R.$U.toMarkdownTable(["Module","Duration"],G.amdInvoke),te+=`

### Invoke commonjs-module
`,te+=R.$U.toMarkdownTable(["Module","Duration"],G.nodeEval),te+=`Start-up time: ${x-J}
`,te+=`Code loading time: ${M-J}
`,te+=`Initialized time: ${U-J}
`,te+=`
`,console.log(te)}return z}class Z{static create(ue){const j=ue.webEndpointUrlTemplate,B=ue.commit,oe=ue.quality;if(!j||!B||!oe)return new Z(null);const le=(0,m.$Wg)(),q=new URL(j.replace("{{uuid}}",le).replace("{{commit}}",B).replace("{{quality}}",oe)).origin,ae=(0,g.$df)(q).replace(le,"[a-zA-Z0-9\\-]+");try{const Y=(0,g.$mf)(`^${ae}$`,!0,{matchCase:!1});return new Z(Y)}catch{return new Z(null)}}constructor(ue){this.a=ue}matches(ue){return this.a?this.a.test(ue):!1}}}),define(Ee[339],Se([1,0,32,31,13,324,329,70,9,330,54,63,45]),function(fe,e,n,r,S,D,A,R,v,s,E,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=o,e.createServer=d,p.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=s.performance.now();const b={onMultipleValues:(i,c)=>{console.error(`Option '${i}' can only be defined once. Using value ${c}.`)},onEmptyValue:i=>{console.error(`Ignoring option '${i}': Value must not be empty.`)},onUnknownOption:i=>{console.error(`Ignoring option '${i}': not supported for server.`)},onDeprecatedOption:(i,c)=>{console.warn(`Option '${i}' is deprecated: ${c}`)}},a=(0,R.$ym)(process.argv.slice(2),E.$en,b),f=a["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.$jc)(n.homedir(),y.default.serverDataFolderName||".vscode-remote"),h=(0,v.$jc)(f,"data"),g=(0,v.$jc)(h,"User"),w=(0,v.$jc)(g,"globalStorage"),m=(0,v.$jc)(g,"History"),$=(0,v.$jc)(h,"Machine");a["user-data-dir"]=h;const l=(0,v.$mc)(S.$Ug.asFileUri("").fsPath),t=(0,v.$jc)(l,"extensions");a["builtin-extensions-dir"]=t,a["extensions-dir"]=a["extensions-dir"]||(0,v.$jc)(f,"extensions"),[f,a["extensions-dir"],h,g,$,w,m].forEach(i=>{try{r.existsSync(i)||r.mkdirSync(i,{mode:448})}catch(c){console.error(c)}});function o(){(0,D.run)(a,f,E.$en)}function d(i){return(0,A.$AQ)(i,a,f)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/611f9bfce64f25108829dd295f54a6894e87339d/core/vs/server/node/server.main.js.map
