/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/process","vs/base/common/marshalling","fs","child_process","vs/base/common/decorators","vs/base/common/hash","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(de){for(var e=[],r=0,m=de.length;r<m;r++)e[r]=ye[de[r]];return e};define(ye[172],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.LoaderEventType=e.$T=void 0,e.$T=!1;var r;(function(A){A[A.LoaderAvailable=1]="LoaderAvailable",A[A.BeginLoadingScript=10]="BeginLoadingScript",A[A.EndLoadingScriptOK=11]="EndLoadingScriptOK",A[A.EndLoadingScriptError=12]="EndLoadingScriptError",A[A.BeginInvokeFactory=21]="BeginInvokeFactory",A[A.EndInvokeFactory=22]="EndInvokeFactory",A[A.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",A[A.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",A[A.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",A[A.NodeEndNativeRequire=34]="NodeEndNativeRequire",A[A.CachedDataFound=60]="CachedDataFound",A[A.CachedDataMissed=61]="CachedDataMissed",A[A.CachedDataRejected=62]="CachedDataRejected",A[A.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class m{static get(){const R=new Map,L=new Map,T=new Map,p=new Map;function c(b,a){b.has(a.detail)||b.set(a.detail,-a.timestamp)}function C(b,a){const u=b.get(a.detail);u&&(u>=0||b.set(a.detail,u+a.timestamp))}let S=[];typeof de=="function"&&typeof de.getStats=="function"&&(S=de.getStats().slice(0).sort((b,a)=>b.timestamp-a.timestamp));for(const b of S)switch(b.type){case r.BeginLoadingScript:c(R,b);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:C(R,b);break;case r.BeginInvokeFactory:c(L,b);break;case r.EndInvokeFactory:C(L,b);break;case r.NodeBeginNativeRequire:c(T,b);break;case r.NodeEndNativeRequire:C(T,b);break;case r.NodeBeginEvaluatingScript:c(p,b);break;case r.NodeEndEvaluatingScript:C(p,b);break}let d=0;T.forEach(b=>d+=b);function P(b){const a=[];return b.forEach((u,f)=>a.push([f,u])),a}return{amdLoad:P(R),amdInvoke:P(L),nodeRequire:P(T),nodeEval:P(p),nodeRequireTotal:d}}static toMarkdownTable(R,L){let T="";const p=[];return R.forEach((c,C)=>{p[C]=c.length}),L.forEach(c=>{c.forEach((C,S)=>{typeof C>"u"&&(C=c[S]="-");const d=C.toString().length;p[S]=Math.max(d,p[S])})}),R.forEach((c,C)=>{T+=`| ${c+" ".repeat(p[C]-c.toString().length)} `}),T+=`|
`,R.forEach((c,C)=>{T+=`| ${"-".repeat(p[C])} `}),T+=`|
`,L.forEach(c=>{c.forEach((C,S)=>{typeof C<"u"&&(T+=`| ${C+" ".repeat(p[S]-C.toString().length)} `)}),T+=`|
`}),T}}e.$U=m}),define(ye[131],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=r,e.$gb=m,e.$hb=A,e.$ib=R,e.$jb=L,e.$kb=T,e.$lb=p,e.$nb=C,e.$ob=S,e.$pb=d,e.$qb=P,e.$rb=b;function r(a,u){const f=m(a,u);if(f!==-1)return a[f]}function m(a,u,f=a.length-1){for(let g=f;g>=0;g--){const n=a[g];if(u(n))return g}return-1}function A(a,u){const f=R(a,u);return f===-1?void 0:a[f]}function R(a,u,f=0,g=a.length){let n=f,s=g;for(;n<s;){const i=Math.floor((n+s)/2);u(a[i])?n=i+1:s=i}return n-1}function L(a,u){const f=T(a,u);return f===a.length?void 0:a[f]}function T(a,u,f=0,g=a.length){let n=f,s=g;for(;n<s;){const i=Math.floor((n+s)/2);u(a[i])?s=i:n=i+1}return n}function p(a,u,f=0,g=a.length){const n=T(a,u,f,g);return n===a.length?-1:n}class c{static{this.assertInvariants=!1}constructor(u){this.e=u,this.c=0}findLastMonotonous(u){if(c.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!u(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=u}const f=R(this.e,u,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$mb=c;function C(a,u){if(a.length===0)return;let f=a[0];for(let g=1;g<a.length;g++){const n=a[g];u(n,f)>0&&(f=n)}return f}function S(a,u){if(a.length===0)return;let f=a[0];for(let g=1;g<a.length;g++){const n=a[g];u(n,f)>=0&&(f=n)}return f}function d(a,u){return C(a,(f,g)=>-u(f,g))}function P(a,u){if(a.length===0)return-1;let f=0;for(let g=1;g<a.length;g++){const n=a[g];u(n,a[f])>0&&(f=g)}return f}function b(a,u){for(const f of a){const g=u(f);if(g!==void 0)return g}}}),define(ye[27],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(m){m[m.Null=0]="Null",m[m.Backspace=8]="Backspace",m[m.Tab=9]="Tab",m[m.LineFeed=10]="LineFeed",m[m.CarriageReturn=13]="CarriageReturn",m[m.Space=32]="Space",m[m.ExclamationMark=33]="ExclamationMark",m[m.DoubleQuote=34]="DoubleQuote",m[m.Hash=35]="Hash",m[m.DollarSign=36]="DollarSign",m[m.PercentSign=37]="PercentSign",m[m.Ampersand=38]="Ampersand",m[m.SingleQuote=39]="SingleQuote",m[m.OpenParen=40]="OpenParen",m[m.CloseParen=41]="CloseParen",m[m.Asterisk=42]="Asterisk",m[m.Plus=43]="Plus",m[m.Comma=44]="Comma",m[m.Dash=45]="Dash",m[m.Period=46]="Period",m[m.Slash=47]="Slash",m[m.Digit0=48]="Digit0",m[m.Digit1=49]="Digit1",m[m.Digit2=50]="Digit2",m[m.Digit3=51]="Digit3",m[m.Digit4=52]="Digit4",m[m.Digit5=53]="Digit5",m[m.Digit6=54]="Digit6",m[m.Digit7=55]="Digit7",m[m.Digit8=56]="Digit8",m[m.Digit9=57]="Digit9",m[m.Colon=58]="Colon",m[m.Semicolon=59]="Semicolon",m[m.LessThan=60]="LessThan",m[m.Equals=61]="Equals",m[m.GreaterThan=62]="GreaterThan",m[m.QuestionMark=63]="QuestionMark",m[m.AtSign=64]="AtSign",m[m.A=65]="A",m[m.B=66]="B",m[m.C=67]="C",m[m.D=68]="D",m[m.E=69]="E",m[m.F=70]="F",m[m.G=71]="G",m[m.H=72]="H",m[m.I=73]="I",m[m.J=74]="J",m[m.K=75]="K",m[m.L=76]="L",m[m.M=77]="M",m[m.N=78]="N",m[m.O=79]="O",m[m.P=80]="P",m[m.Q=81]="Q",m[m.R=82]="R",m[m.S=83]="S",m[m.T=84]="T",m[m.U=85]="U",m[m.V=86]="V",m[m.W=87]="W",m[m.X=88]="X",m[m.Y=89]="Y",m[m.Z=90]="Z",m[m.OpenSquareBracket=91]="OpenSquareBracket",m[m.Backslash=92]="Backslash",m[m.CloseSquareBracket=93]="CloseSquareBracket",m[m.Caret=94]="Caret",m[m.Underline=95]="Underline",m[m.BackTick=96]="BackTick",m[m.a=97]="a",m[m.b=98]="b",m[m.c=99]="c",m[m.d=100]="d",m[m.e=101]="e",m[m.f=102]="f",m[m.g=103]="g",m[m.h=104]="h",m[m.i=105]="i",m[m.j=106]="j",m[m.k=107]="k",m[m.l=108]="l",m[m.m=109]="m",m[m.n=110]="n",m[m.o=111]="o",m[m.p=112]="p",m[m.q=113]="q",m[m.r=114]="r",m[m.s=115]="s",m[m.t=116]="t",m[m.u=117]="u",m[m.v=118]="v",m[m.w=119]="w",m[m.x=120]="x",m[m.y=121]="y",m[m.z=122]="z",m[m.OpenCurlyBrace=123]="OpenCurlyBrace",m[m.Pipe=124]="Pipe",m[m.CloseCurlyBrace=125]="CloseCurlyBrace",m[m.Tilde=126]="Tilde",m[m.NoBreakSpace=160]="NoBreakSpace",m[m.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",m[m.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",m[m.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",m[m.U_Combining_Tilde=771]="U_Combining_Tilde",m[m.U_Combining_Macron=772]="U_Combining_Macron",m[m.U_Combining_Overline=773]="U_Combining_Overline",m[m.U_Combining_Breve=774]="U_Combining_Breve",m[m.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",m[m.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",m[m.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",m[m.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",m[m.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",m[m.U_Combining_Caron=780]="U_Combining_Caron",m[m.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",m[m.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",m[m.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",m[m.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",m[m.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",m[m.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",m[m.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",m[m.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",m[m.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",m[m.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",m[m.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",m[m.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",m[m.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",m[m.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",m[m.U_Combining_Horn=795]="U_Combining_Horn",m[m.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",m[m.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",m[m.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",m[m.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",m[m.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",m[m.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",m[m.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",m[m.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",m[m.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",m[m.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",m[m.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",m[m.U_Combining_Cedilla=807]="U_Combining_Cedilla",m[m.U_Combining_Ogonek=808]="U_Combining_Ogonek",m[m.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",m[m.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",m[m.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",m[m.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",m[m.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",m[m.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",m[m.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",m[m.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",m[m.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",m[m.U_Combining_Low_Line=818]="U_Combining_Low_Line",m[m.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",m[m.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",m[m.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",m[m.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",m[m.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",m[m.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",m[m.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",m[m.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",m[m.U_Combining_Square_Below=827]="U_Combining_Square_Below",m[m.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",m[m.U_Combining_X_Above=829]="U_Combining_X_Above",m[m.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",m[m.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",m[m.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",m[m.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",m[m.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",m[m.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",m[m.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",m[m.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",m[m.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",m[m.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",m[m.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",m[m.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",m[m.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",m[m.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",m[m.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",m[m.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",m[m.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",m[m.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",m[m.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",m[m.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",m[m.U_Combining_Fermata=850]="U_Combining_Fermata",m[m.U_Combining_X_Below=851]="U_Combining_X_Below",m[m.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",m[m.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",m[m.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",m[m.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",m[m.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",m[m.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",m[m.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",m[m.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",m[m.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",m[m.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",m[m.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",m[m.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",m[m.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",m[m.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",m[m.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",m[m.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",m[m.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",m[m.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",m[m.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",m[m.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",m[m.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",m[m.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",m[m.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",m[m.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",m[m.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",m[m.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",m[m.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",m[m.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",m[m.LINE_SEPARATOR=8232]="LINE_SEPARATOR",m[m.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",m[m.NEXT_LINE=133]="NEXT_LINE",m[m.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",m[m.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",m[m.U_DIAERESIS=168]="U_DIAERESIS",m[m.U_MACRON=175]="U_MACRON",m[m.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",m[m.U_CEDILLA=184]="U_CEDILLA",m[m.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",m[m.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",m[m.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",m[m.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",m[m.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",m[m.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",m[m.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",m[m.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",m[m.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",m[m.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",m[m.U_BREVE=728]="U_BREVE",m[m.U_DOT_ABOVE=729]="U_DOT_ABOVE",m[m.U_RING_ABOVE=730]="U_RING_ABOVE",m[m.U_OGONEK=731]="U_OGONEK",m[m.U_SMALL_TILDE=732]="U_SMALL_TILDE",m[m.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",m[m.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",m[m.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",m[m.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",m[m.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",m[m.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",m[m.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",m[m.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",m[m.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",m[m.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",m[m.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",m[m.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",m[m.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",m[m.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",m[m.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",m[m.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",m[m.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",m[m.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",m[m.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",m[m.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",m[m.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",m[m.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",m[m.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",m[m.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",m[m.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",m[m.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",m[m.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",m[m.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",m[m.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",m[m.U_GREEK_TONOS=900]="U_GREEK_TONOS",m[m.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",m[m.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",m[m.U_GREEK_PSILI=8127]="U_GREEK_PSILI",m[m.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",m[m.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",m[m.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",m[m.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",m[m.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",m[m.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",m[m.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",m[m.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",m[m.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",m[m.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",m[m.U_GREEK_VARIA=8175]="U_GREEK_VARIA",m[m.U_GREEK_OXIA=8189]="U_GREEK_OXIA",m[m.U_GREEK_DASIA=8190]="U_GREEK_DASIA",m[m.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",m[m.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",m[m.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",m[m.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",m[m.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",m[m.U_OVERLINE=8254]="U_OVERLINE",m[m.UTF8_BOM=65279]="UTF8_BOM",m[m.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",m[m.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(ye[79],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=r,e.$L=m,e.$M=A,e.$N=R;function r(L,T){const p=Object.create(null);for(const c of L){const C=T(c);let S=p[C];S||(S=p[C]=[]),S.push(c)}return p}function m(L,T){const p=[],c=[];for(const C of L)T.has(C)||p.push(C);for(const C of T)L.has(C)||c.push(C);return{removed:p,added:c}}function A(L,T){const p=[],c=[];for(const[C,S]of L)T.has(C)||p.push(S);for(const[C,S]of T)L.has(C)||c.push(S);return{removed:p,added:c}}function R(L,T){const p=new Set;for(const c of T)L.has(c)&&p.add(c);return p}}),define(ye[60],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=m,e.$6h=A,e.$7h=R;function r(L){return(T,p,c)=>{let C=null,S=null;if(typeof c.value=="function"?(C="value",S=c.value):typeof c.get=="function"&&(C="get",S=c.get),!S)throw new Error("not supported");c[C]=L(S,p)}}function m(L,T,p){let c=null,C=null;if(typeof p.value=="function"?(c="value",C=p.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",C=p.get),!C)throw new Error("not supported");const S=`$memoize$${T}`;p[c]=function(...d){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,d)}),this[S]}}function A(L,T,p){return r((c,C)=>{const S=`$debounce$${C}`,d=`$debounce$result$${C}`;return function(...P){this[d]||(this[d]=p?p():void 0),clearTimeout(this[S]),T&&(this[d]=T(this[d],...P),P=[this[d]]),this[S]=setTimeout(()=>{c.apply(this,P),this[d]=p?p():void 0},L)}})}function R(L,T,p){return r((c,C)=>{const S=`$throttle$timer$${C}`,d=`$throttle$result$${C}`,P=`$throttle$lastRun$${C}`,b=`$throttle$pending$${C}`;return function(...a){if(this[d]||(this[d]=p?p():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),T&&(this[d]=T(this[d],...a)),this[b])return;const u=this[P]+L;u<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[d]]),this[d]=p?p():void 0):(this[b]=!0,this[S]=setTimeout(()=>{this[b]=!1,this[P]=Date.now(),c.apply(this,[this[d]]),this[d]=p?p():void 0},u-Date.now()))}})}}),define(ye[14],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=m,e.$Z=A,e.$1=R,e.$2=L,e.$3=T,e.$4=c,e.$6=S,e.$7=d,e.$8=P,e.$0=a;class r{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(l=>{l(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=r,e.$X=new r;function m(i){e.$X.setUnexpectedErrorHandler(i)}function A(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(i){c(i)||e.$X.onUnexpectedError(i)}function L(i){c(i)||e.$X.onUnexpectedExternalError(i)}function T(i){if(i instanceof Error){const{name:t,message:l}=i,h=i.stacktrace||i.stack;return{$isError:!0,name:t,message:l,stack:h,noTelemetry:n.isErrorNoTelemetry(i)}}return i}const p="Canceled";function c(i){return i instanceof C?!0:i instanceof Error&&i.name===p&&i.message===p}class C extends Error{constructor(){super(p),this.name=this.message}}e.$5=C;function S(){const i=new Error(p);return i.name=i.message,i}function d(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function P(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class b extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=b;function a(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class u extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=u;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=f;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=g;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const l=new n;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$cb=s}),define(ye[19],Se([1,0,14,131]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=A,e.$tb=R,e.$ub=L,e.$vb=T,e.$wb=p,e.$xb=c,e.$yb=C,e.$zb=S,e.$Ab=d,e.$Bb=P,e.$Cb=b,e.$Db=a,e.$Eb=u,e.top=f,e.$Gb=g,e.$Hb=s,e.$Ib=i,e.$Jb=t,e.$Kb=l,e.$Lb=h,e.$Mb=o,e.$Nb=$,e.$Ob=E,e.$Pb=k,e.$Qb=D,e.$Rb=v,e.$Sb=I,e.$Tb=w,e.$Ub=y,e.$Vb=N,e.$Wb=O,e.$Xb=U,e.$Yb=j,e.$Zb=z,e.$1b=M,e.$2b=F,e.$3b=J,e.$4b=ee,e.$5b=V,e.$6b=ne,e.$7b=he,e.$0b=pe;function A(ae,ie=0){return ae[ae.length-(1+ie)]}function R(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function L(ae,ie,ce=(ue,Z)=>ue===Z){if(ae===ie)return!0;if(!ae||!ie||ae.length!==ie.length)return!1;for(let ue=0,Z=ae.length;ue<Z;ue++)if(!ce(ae[ue],ie[ue]))return!1;return!0}function T(ae,ie){const ce=ae.length-1;ie<ce&&(ae[ie]=ae[ce]),ae.pop()}function p(ae,ie,ce){return c(ae.length,ue=>ce(ae[ue],ie))}function c(ae,ie){let ce=0,ue=ae-1;for(;ce<=ue;){const Z=(ce+ue)/2|0,oe=ie(Z);if(oe<0)ce=Z+1;else if(oe>0)ue=Z-1;else return Z}return-(ce+1)}function C(ae,ie,ce){if(ae=ae|0,ae>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],Z=[],oe=[],$e=[];for(const be of ie){const Ne=ce(be,ue);Ne<0?Z.push(be):Ne>0?oe.push(be):$e.push(be)}return ae<Z.length?C(ae,Z,ce):ae<Z.length+$e.length?$e[0]:C(ae-(Z.length+$e.length),oe,ce)}function S(ae,ie){const ce=[];let ue;for(const Z of ae.slice(0).sort(ie))!ue||ie(ue[0],Z)!==0?(ue=[Z],ce.push(ue)):ue.push(Z);return ce}function*d(ae,ie){let ce,ue;for(const Z of ae)ue!==void 0&&ie(ue,Z)?ce.push(Z):(ce&&(yield ce),ce=[Z]),ue=Z;ce&&(yield ce)}function P(ae,ie){for(let ce=0;ce<=ae.length;ce++)ie(ce===0?void 0:ae[ce-1],ce===ae.length?void 0:ae[ce])}function b(ae,ie){for(let ce=0;ce<ae.length;ce++)ie(ce===0?void 0:ae[ce-1],ae[ce],ce+1===ae.length?void 0:ae[ce+1])}function a(ae,ie,ce){const ue=[];function Z(be,Ne,Be){if(Ne===0&&Be.length===0)return;const De=ue[ue.length-1];De&&De.start+De.deleteCount===be?(De.deleteCount+=Ne,De.toInsert.push(...Be)):ue.push({start:be,deleteCount:Ne,toInsert:Be})}let oe=0,$e=0;for(;;){if(oe===ae.length){Z(oe,0,ie.slice($e));break}if($e===ie.length){Z(oe,ae.length-oe,[]);break}const be=ae[oe],Ne=ie[$e],Be=ce(be,Ne);Be===0?(oe+=1,$e+=1):Be<0?(Z(oe,1,[]),oe+=1):Be>0&&(Z(oe,0,[Ne]),$e+=1)}return ue}function u(ae,ie,ce){const ue=a(ae,ie,ce),Z=[],oe=[];for(const $e of ue)Z.push(...ae.slice($e.start,$e.start+$e.deleteCount)),oe.push(...$e.toInsert);return{removed:Z,added:oe}}function f(ae,ie,ce){if(ce===0)return[];const ue=ae.slice(0,ce).sort(ie);return n(ae,ie,ue,ce,ae.length),ue}function g(ae,ie,ce,ue,Z){return ce===0?Promise.resolve([]):new Promise((oe,$e)=>{(async()=>{const be=ae.length,Ne=ae.slice(0,ce).sort(ie);for(let Be=ce,De=Math.min(ce+ue,be);Be<be;Be=De,De=Math.min(De+ue,be)){if(Be>ce&&await new Promise(Ie=>setTimeout(Ie)),Z&&Z.isCancellationRequested)throw new r.$5;n(ae,ie,Ne,Be,De)}return Ne})().then(oe,$e)})}function n(ae,ie,ce,ue,Z){for(const oe=ce.length;ue<Z;ue++){const $e=ae[ue];if(ie($e,ce[oe-1])<0){ce.pop();const be=(0,m.$kb)(ce,Ne=>ie($e,Ne)<0);ce.splice(be,0,$e)}}}function s(ae){return ae.filter(ie=>!!ie)}function i(ae){let ie=0;for(let ce=0;ce<ae.length;ce++)ae[ce]&&(ae[ie]=ae[ce],ie+=1);ae.length=ie}function t(ae,ie,ce){ae.splice(ce,0,ae.splice(ie,1)[0])}function l(ae){return!Array.isArray(ae)||ae.length===0}function h(ae){return Array.isArray(ae)&&ae.length>0}function o(ae,ie=ce=>ce){const ce=new Set;return ae.filter(ue=>{const Z=ie(ue);return ce.has(Z)?!1:(ce.add(Z),!0)})}function $(ae){const ie=new Set;return ce=>{const ue=ae(ce);return ie.has(ue)?!1:(ie.add(ue),!0)}}function E(ae,ie){return ae.length>0?ae[0]:ie}function k(ae,ie){return ae.length>0?ae[ae.length-1]:ie}function D(ae,ie,ce=(ue,Z)=>ue===Z){let ue=0;for(let Z=0,oe=Math.min(ae.length,ie.length);Z<oe&&ce(ae[Z],ie[Z]);Z++)ue++;return ue}function v(ae,ie){let ce=typeof ie=="number"?ae:0;typeof ie=="number"?ce=ae:(ce=0,ie=ae);const ue=[];if(ce<=ie)for(let Z=ce;Z<ie;Z++)ue.push(Z);else for(let Z=ce;Z>ie;Z--)ue.push(Z);return ue}function I(ae,ie,ce){return ae.reduce((ue,Z)=>(ue[ie(Z)]=ce?ce(Z):Z,ue),Object.create(null))}function w(ae,ie){return ae.push(ie),()=>y(ae,ie)}function y(ae,ie){const ce=ae.indexOf(ie);if(ce>-1)return ae.splice(ce,1),ie}function N(ae,ie,ce){const ue=ae.slice(0,ie),Z=ae.slice(ie);return ue.concat(ce,Z)}function O(ae,ie){let ce;if(typeof ie=="number"){let ue=ie;ce=()=>{const Z=Math.sin(ue++)*179426549;return Z-Math.floor(Z)}}else ce=Math.random;for(let ue=ae.length-1;ue>0;ue-=1){const Z=Math.floor(ce()*(ue+1)),oe=ae[ue];ae[ue]=ae[Z],ae[Z]=oe}}function U(ae,ie){const ce=ae.indexOf(ie);ce>-1&&(ae.splice(ce,1),ae.unshift(ie))}function j(ae,ie){const ce=ae.indexOf(ie);ce>-1&&(ae.splice(ce,1),ae.push(ie))}function z(ae,ie){for(const ce of ie)ae.push(ce)}function M(ae,ie){return Array.isArray(ae)?ae.map(ie):ie(ae)}function F(ae){return Array.isArray(ae)?ae:[ae]}function J(ae){return ae[Math.floor(Math.random()*ae.length)]}function ee(ae,ie,ce){const ue=H(ae,ie),Z=ae.length,oe=ce.length;ae.length=Z+oe;for(let $e=Z-1;$e>=ue;$e--)ae[$e+oe]=ae[$e];for(let $e=0;$e<oe;$e++)ae[$e+ue]=ce[$e]}function V(ae,ie,ce,ue){const Z=H(ae,ie);let oe=ae.splice(Z,ce);return oe===void 0&&(oe=[]),ee(ae,Z,ue),oe}function H(ae,ie){return ie<0?Math.max(ie+ae.length,0):Math.min(ie,ae.length)}var _;(function(ae){function ie(oe){return oe<0}ae.isLessThan=ie;function ce(oe){return oe<=0}ae.isLessThanOrEqual=ce;function ue(oe){return oe>0}ae.isGreaterThan=ue;function Z(oe){return oe===0}ae.isNeitherLessOrGreaterThan=Z,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function ne(ae,ie){return(ce,ue)=>ie(ae(ce),ae(ue))}function he(...ae){return(ie,ce)=>{for(const ue of ae){const Z=ue(ie,ce);if(!_.isNeitherLessOrGreaterThan(Z))return Z}return _.neitherLessOrGreaterThan}}const re=(ae,ie)=>ae-ie;e.$8b=re;const ve=(ae,ie)=>(0,e.$8b)(ae?1:0,ie?1:0);e.$9b=ve;function pe(ae){return(ie,ce)=>-ae(ie,ce)}class Q{constructor(ie){this.g=ie,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let ce=this.c;for(;ce<this.g.length&&ie(this.g[ce]);)ce++;const ue=ce===this.c?null:this.g.slice(this.c,ce);return this.c=ce,ue}takeFromEndWhile(ie){let ce=this.d;for(;ce>=0&&ie(this.g[ce]);)ce--;const ue=ce===this.d?null:this.g.slice(ce+1,this.d+1);return this.d=ce,ue}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ie=this.g[this.c];return this.c++,ie}removeLast(){const ie=this.g[this.d];return this.d--,ie}takeCount(ie){const ce=this.g.slice(this.c,this.c+ie);return this.c+=ie,ce}}e.$$b=Q;class B{static{this.empty=new B(ie=>{})}constructor(ie){this.iterate=ie}forEach(ie){this.iterate(ce=>(ie(ce),!0))}toArray(){const ie=[];return this.iterate(ce=>(ie.push(ce),!0)),ie}filter(ie){return new B(ce=>this.iterate(ue=>ie(ue)?ce(ue):!0))}map(ie){return new B(ce=>this.iterate(ue=>ce(ie(ue))))}some(ie){let ce=!1;return this.iterate(ue=>(ce=ie(ue),!ce)),ce}findFirst(ie){let ce;return this.iterate(ue=>ie(ue)?(ce=ue,!1):!0),ce}findLast(ie){let ce;return this.iterate(ue=>(ie(ue)&&(ce=ue),!0)),ce}findLastMaxBy(ie){let ce,ue=!0;return this.iterate(Z=>((ue||_.isGreaterThan(ie(Z,ce)))&&(ue=!1,ce=Z),!0)),ce}}e.$_b=B;class se{constructor(ie){this.c=ie}static createSortPermutation(ie,ce){const ue=Array.from(ie.keys()).sort((Z,oe)=>ce(ie[Z],ie[oe]));return new se(ue)}apply(ie){return ie.map((ce,ue)=>ie[this.c[ue]])}inverse(){const ie=this.c.slice();for(let ce=0;ce<this.c.length;ce++)ie[this.c[ce]]=ce;return new se(ie)}}e.$ac=se}),define(ye[65],Se([1,0,14]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=m,e.$ed=A,e.$fd=R,e.$gd=L,e.$hd=T,e.$id=p;function m(c,C){if(!c)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}function A(c,C="Unreachable"){throw new Error(C)}function R(c,C="unexpected state"){if(!c)throw new r.$cb(`Assertion Failed: ${C}`)}function L(c){c||(0,r.$1)(new r.$cb("Soft Assertion Failed"))}function T(c){if(!c()){debugger;c(),(0,r.$1)(new r.$cb("Assertion Failed"))}}function p(c,C){let S=0;for(;S<c.length-1;){const d=c[S],P=c[S+1];if(!C(d,P))return!1;S++}return!0}}),define(ye[173],Se([1,0,19]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=A,e.$8c=R,e.$9c=L,e.$0c=T,e.$$c=p,e.$_c=c;const m=(P,b)=>P===b;e.$6c=m;function A(P=e.$6c){return(b,a)=>r.$ub(b,a,P)}function R(){return(P,b)=>JSON.stringify(P)===JSON.stringify(b)}function L(){return(P,b)=>P.equals(b)}function T(P,b,a){return!P||!b?P===b:a(P,b)}function p(P,b){if(P===b)return!0;if(Array.isArray(P)&&Array.isArray(b)){if(P.length!==b.length)return!1;for(let a=0;a<P.length;a++)if(!p(P[a],b[a]))return!1;return!0}if(P&&typeof P=="object"&&b&&typeof b=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(b)===Object.prototype){const a=P,u=b,f=Object.keys(a),g=Object.keys(u),n=new Set(g);if(f.length!==g.length)return!1;for(const s of f)if(!n.has(s)||!p(a[s],u[s]))return!1;return!0}return!1}function c(P){return JSON.stringify(d(P))}let C=0;const S=new WeakMap;function d(P){if(Array.isArray(P))return P.map(d);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const b=P,a=Object.create(null);for(const u of Object.keys(b).sort())a[u]=d(b[u]);return a}else{let b=S.get(P);return b===void 0&&(b=C++,S.set(P,b)),b+"----2b76a038c20c4bcc"}return P}}),define(ye[80],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=r;function r(m,A){const R=this;let L=!1,T;return function(){if(L)return T;if(L=!0,A)try{T=m.apply(R,arguments)}finally{A()}else T=m.apply(R,arguments);return T}}}),define(ye[132],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=e.$4O=void 0;class r{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$4O=r,e.$5O=new r("id#")}),define(ye[40],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(m){function A(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}m.is=A;const R=Object.freeze([]);function L(){return R}m.empty=L;function*T(t){yield t}m.single=T;function p(t){return A(t)?t:T(t)}m.wrap=p;function c(t){return t||R}m.from=c;function*C(t){for(let l=t.length-1;l>=0;l--)yield t[l]}m.reverse=C;function S(t){return!t||t[Symbol.iterator]().next().done===!0}m.isEmpty=S;function d(t){return t[Symbol.iterator]().next().value}m.first=d;function P(t,l){for(const h of t)if(l(h))return!0;return!1}m.some=P;function b(t,l){for(const h of t)if(l(h))return h}m.find=b;function*a(t,l){for(const h of t)l(h)&&(yield h)}m.filter=a;function*u(t,l){let h=0;for(const o of t)yield l(o,h++)}m.map=u;function*f(...t){for(const l of t)yield*l}m.concat=f;function g(t,l,h){let o=h;for(const $ of t)o=l(o,$);return o}m.reduce=g;function*n(t,l,h=t.length){for(l<0&&(l+=t.length),h<0?h+=t.length:h>t.length&&(h=t.length);l<h;l++)yield t[l]}m.slice=n;function s(t,l=Number.POSITIVE_INFINITY){const h=[];if(l===0)return[h,t];const o=t[Symbol.iterator]();for(let $=0;$<l;$++){const E=o.next();if(E.done)return[h,m.empty()];h.push(E.value)}return[h,{[Symbol.iterator](){return o}}]}m.consume=s;async function i(t){const l=[];for await(const h of t)l.push(h);return Promise.resolve(l)}m.asyncToArray=i})(r||(e.Iterable=r={}))}),define(ye[174],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Nn=L,e.$On=S,e.$Pn=d,e.$Qn=P,e.$Rn=b,e.$Sn=a,e.$Tn=u,e.$Un=f,e.$Vn=g,e.$Wn=n,e.$Xn=s,e.$Yn=i;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var m;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(m||(e.SyntaxKind=m={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,l=!1){let h=0;const o=t.length;let $="",E=0,k=m.Unknown,D=r.None;function v(j){let z=0,M=0;for(;z<j;){const F=t.charCodeAt(h);if(F>=C._0&&F<=C._9)M=M*16+F-C._0;else if(F>=C.A&&F<=C.F)M=M*16+F-C.A+10;else if(F>=C.a&&F<=C.f)M=M*16+F-C.a+10;else break;h++,z++}return z<j&&(M=-1),M}function I(j){h=j,$="",E=0,k=m.Unknown,D=r.None}function w(){const j=h;if(t.charCodeAt(h)===C._0)h++;else for(h++;h<t.length&&c(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===C.dot)if(h++,h<t.length&&c(t.charCodeAt(h)))for(h++;h<t.length&&c(t.charCodeAt(h));)h++;else return D=r.UnexpectedEndOfNumber,t.substring(j,h);let z=h;if(h<t.length&&(t.charCodeAt(h)===C.E||t.charCodeAt(h)===C.e))if(h++,(h<t.length&&t.charCodeAt(h)===C.plus||t.charCodeAt(h)===C.minus)&&h++,h<t.length&&c(t.charCodeAt(h))){for(h++;h<t.length&&c(t.charCodeAt(h));)h++;z=h}else D=r.UnexpectedEndOfNumber;return t.substring(j,z)}function y(){let j="",z=h;for(;;){if(h>=o){j+=t.substring(z,h),D=r.UnexpectedEndOfString;break}const M=t.charCodeAt(h);if(M===C.doubleQuote){j+=t.substring(z,h),h++;break}if(M===C.backslash){if(j+=t.substring(z,h),h++,h>=o){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(h++)){case C.doubleQuote:j+='"';break;case C.backslash:j+="\\";break;case C.slash:j+="/";break;case C.b:j+="\b";break;case C.f:j+="\f";break;case C.n:j+=`
`;break;case C.r:j+="\r";break;case C.t:j+="	";break;case C.u:{const J=v(4);J>=0?j+=String.fromCharCode(J):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}z=h;continue}if(M>=0&&M<=31)if(p(M)){j+=t.substring(z,h),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;h++}return j}function N(){if($="",D=r.None,E=h,h>=o)return E=o,k=m.EOF;let j=t.charCodeAt(h);if(T(j)){do h++,$+=String.fromCharCode(j),j=t.charCodeAt(h);while(T(j));return k=m.Trivia}if(p(j))return h++,$+=String.fromCharCode(j),j===C.carriageReturn&&t.charCodeAt(h)===C.lineFeed&&(h++,$+=`
`),k=m.LineBreakTrivia;switch(j){case C.openBrace:return h++,k=m.OpenBraceToken;case C.closeBrace:return h++,k=m.CloseBraceToken;case C.openBracket:return h++,k=m.OpenBracketToken;case C.closeBracket:return h++,k=m.CloseBracketToken;case C.colon:return h++,k=m.ColonToken;case C.comma:return h++,k=m.CommaToken;case C.doubleQuote:return h++,$=y(),k=m.StringLiteral;case C.slash:{const z=h-1;if(t.charCodeAt(h+1)===C.slash){for(h+=2;h<o&&!p(t.charCodeAt(h));)h++;return $=t.substring(z,h),k=m.LineCommentTrivia}if(t.charCodeAt(h+1)===C.asterisk){h+=2;const M=o-1;let F=!1;for(;h<M;){if(t.charCodeAt(h)===C.asterisk&&t.charCodeAt(h+1)===C.slash){h+=2,F=!0;break}h++}return F||(h++,D=r.UnexpectedEndOfComment),$=t.substring(z,h),k=m.BlockCommentTrivia}return $+=String.fromCharCode(j),h++,k=m.Unknown}case C.minus:if($+=String.fromCharCode(j),h++,h===o||!c(t.charCodeAt(h)))return k=m.Unknown;case C._0:case C._1:case C._2:case C._3:case C._4:case C._5:case C._6:case C._7:case C._8:case C._9:return $+=w(),k=m.NumericLiteral;default:for(;h<o&&O(j);)h++,j=t.charCodeAt(h);if(E!==h){switch($=t.substring(E,h),$){case"true":return k=m.TrueKeyword;case"false":return k=m.FalseKeyword;case"null":return k=m.NullKeyword}return k=m.Unknown}return $+=String.fromCharCode(j),h++,k=m.Unknown}}function O(j){if(T(j)||p(j))return!1;switch(j){case C.closeBrace:case C.closeBracket:case C.openBrace:case C.openBracket:case C.doubleQuote:case C.colon:case C.comma:case C.slash:return!1}return!0}function U(){let j;do j=N();while(j>=m.LineCommentTrivia&&j<=m.Trivia);return j}return{setPosition:I,getPosition:()=>h,scan:l?U:N,getToken:()=>k,getTokenValue:()=>$,getTokenOffset:()=>E,getTokenLength:()=>h-E,getTokenError:()=>D}}function T(t){return t===C.space||t===C.tab||t===C.verticalTab||t===C.formFeed||t===C.nonBreakingSpace||t===C.ogham||t>=C.enQuad&&t<=C.zeroWidthSpace||t===C.narrowNoBreakSpace||t===C.mathematicalSpace||t===C.ideographicSpace||t===C.byteOrderMark}function p(t){return t===C.lineFeed||t===C.carriageReturn||t===C.lineSeparator||t===C.paragraphSeparator}function c(t){return t>=C._0&&t<=C._9}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function S(t,l){const h=[],o=new Object;let $;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function D(v,I,w,y){E.value=v,E.offset=I,E.length=w,E.type=y,E.colonOffset=void 0,$=E}try{n(t,{onObjectBegin:(v,I)=>{if(l<=v)throw o;$=void 0,k=l>v,h.push("")},onObjectProperty:(v,I,w)=>{if(l<I||(D(v,I,w,"property"),h[h.length-1]=v,l<=I+w))throw o},onObjectEnd:(v,I)=>{if(l<=v)throw o;$=void 0,h.pop()},onArrayBegin:(v,I)=>{if(l<=v)throw o;$=void 0,h.push(0)},onArrayEnd:(v,I)=>{if(l<=v)throw o;$=void 0,h.pop()},onLiteralValue:(v,I,w)=>{if(l<I||(D(v,I,w,i(v)),l<=I+w))throw o},onSeparator:(v,I,w)=>{if(l<=I)throw o;if(v===":"&&$&&$.type==="property")$.colonOffset=I,k=!1,$=void 0;else if(v===","){const y=h[h.length-1];typeof y=="number"?h[h.length-1]=y+1:(k=!0,h[h.length-1]=""),$=void 0}}})}catch(v){if(v!==o)throw v}return{path:h,previousNode:$,isAtPropertyKey:k,matches:v=>{let I=0;for(let w=0;I<v.length&&w<h.length;w++)if(v[I]===h[w]||v[I]==="*")I++;else if(v[I]!=="**")return!1;return I===v.length}}}function d(t,l=[],h=R.DEFAULT){let o=null,$=[];const E=[];function k(v){Array.isArray($)?$.push(v):o!==null&&($[o]=v)}return n(t,{onObjectBegin:()=>{const v={};k(v),E.push($),$=v,o=null},onObjectProperty:v=>{o=v},onObjectEnd:()=>{$=E.pop()},onArrayBegin:()=>{const v=[];k(v),E.push($),$=v,o=null},onArrayEnd:()=>{$=E.pop()},onLiteralValue:k,onError:(v,I,w)=>{l.push({error:v,offset:I,length:w})}},h),$[0]}function P(t,l=[],h=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function $(v){o.type==="property"&&(o.length=v-o.offset,o=o.parent)}function E(v){return o.children.push(v),v}n(t,{onObjectBegin:v=>{o=E({type:"object",offset:v,length:-1,parent:o,children:[]})},onObjectProperty:(v,I,w)=>{o=E({type:"property",offset:I,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:v,offset:I,length:w,parent:o})},onObjectEnd:(v,I)=>{o.length=v+I-o.offset,o=o.parent,$(v+I)},onArrayBegin:(v,I)=>{o=E({type:"array",offset:v,length:-1,parent:o,children:[]})},onArrayEnd:(v,I)=>{o.length=v+I-o.offset,o=o.parent,$(v+I)},onLiteralValue:(v,I,w)=>{E({type:i(v),offset:I,length:w,parent:o,value:v}),$(I+w)},onSeparator:(v,I,w)=>{o.type==="property"&&(v===":"?o.colonOffset=I:v===","&&$(I))},onError:(v,I,w)=>{l.push({error:v,offset:I,length:w})}},h);const D=o.children[0];return D&&delete D.parent,D}function b(t,l){if(!t)return;let h=t;for(const o of l)if(typeof o=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let $=!1;for(const E of h.children)if(Array.isArray(E.children)&&E.children[0].value===o){h=E.children[1],$=!0;break}if(!$)return}else{const $=o;if(h.type!=="array"||$<0||!Array.isArray(h.children)||$>=h.children.length)return;h=h.children[$]}return h}function a(t){if(!t.parent||!t.parent.children)return[];const l=a(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;l.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&l.push(h)}return l}function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const l=Object.create(null);for(const h of t.children){const o=h.children[1];o&&(l[h.children[0].value]=u(o))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function f(t,l,h=!1){return l>=t.offset&&l<t.offset+t.length||h&&l===t.offset+t.length}function g(t,l,h=!1){if(f(t,l,h)){const o=t.children;if(Array.isArray(o))for(let $=0;$<o.length&&o[$].offset<=l;$++){const E=g(o[$],l,h);if(E)return E}return t}}function n(t,l,h=R.DEFAULT){const o=L(t,!1);function $(he){return he?()=>he(o.getTokenOffset(),o.getTokenLength()):()=>!0}function E(he){return he?re=>he(re,o.getTokenOffset(),o.getTokenLength()):()=>!0}const k=$(l.onObjectBegin),D=E(l.onObjectProperty),v=$(l.onObjectEnd),I=$(l.onArrayBegin),w=$(l.onArrayEnd),y=E(l.onLiteralValue),N=E(l.onSeparator),O=$(l.onComment),U=E(l.onError),j=h&&h.disallowComments,z=h&&h.allowTrailingComma;function M(){for(;;){const he=o.scan();switch(o.getTokenError()){case r.InvalidUnicode:F(A.InvalidUnicode);break;case r.InvalidEscapeCharacter:F(A.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:F(A.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:j||F(A.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:F(A.UnexpectedEndOfString);break;case r.InvalidCharacter:F(A.InvalidCharacter);break}switch(he){case m.LineCommentTrivia:case m.BlockCommentTrivia:j?F(A.InvalidCommentToken):O();break;case m.Unknown:F(A.InvalidSymbol);break;case m.Trivia:case m.LineBreakTrivia:break;default:return he}}}function F(he,re=[],ve=[]){if(U(he),re.length+ve.length>0){let pe=o.getToken();for(;pe!==m.EOF;){if(re.indexOf(pe)!==-1){M();break}else if(ve.indexOf(pe)!==-1)break;pe=M()}}}function J(he){const re=o.getTokenValue();return he?y(re):D(re),M(),!0}function ee(){switch(o.getToken()){case m.NumericLiteral:{let he=0;try{he=JSON.parse(o.getTokenValue()),typeof he!="number"&&(F(A.InvalidNumberFormat),he=0)}catch{F(A.InvalidNumberFormat)}y(he);break}case m.NullKeyword:y(null);break;case m.TrueKeyword:y(!0);break;case m.FalseKeyword:y(!1);break;default:return!1}return M(),!0}function V(){return o.getToken()!==m.StringLiteral?(F(A.PropertyNameExpected,[],[m.CloseBraceToken,m.CommaToken]),!1):(J(!1),o.getToken()===m.ColonToken?(N(":"),M(),ne()||F(A.ValueExpected,[],[m.CloseBraceToken,m.CommaToken])):F(A.ColonExpected,[],[m.CloseBraceToken,m.CommaToken]),!0)}function H(){k(),M();let he=!1;for(;o.getToken()!==m.CloseBraceToken&&o.getToken()!==m.EOF;){if(o.getToken()===m.CommaToken){if(he||F(A.ValueExpected,[],[]),N(","),M(),o.getToken()===m.CloseBraceToken&&z)break}else he&&F(A.CommaExpected,[],[]);V()||F(A.ValueExpected,[],[m.CloseBraceToken,m.CommaToken]),he=!0}return v(),o.getToken()!==m.CloseBraceToken?F(A.CloseBraceExpected,[m.CloseBraceToken],[]):M(),!0}function _(){I(),M();let he=!1;for(;o.getToken()!==m.CloseBracketToken&&o.getToken()!==m.EOF;){if(o.getToken()===m.CommaToken){if(he||F(A.ValueExpected,[],[]),N(","),M(),o.getToken()===m.CloseBracketToken&&z)break}else he&&F(A.CommaExpected,[],[]);ne()||F(A.ValueExpected,[],[m.CloseBracketToken,m.CommaToken]),he=!0}return w(),o.getToken()!==m.CloseBracketToken?F(A.CloseBracketExpected,[m.CloseBracketToken],[]):M(),!0}function ne(){switch(o.getToken()){case m.OpenBracketToken:return _();case m.OpenBraceToken:return H();case m.StringLiteral:return J(!0);default:return ee()}}return M(),o.getToken()===m.EOF?h.allowEmptyContent?!0:(F(A.ValueExpected,[],[]),!1):ne()?(o.getToken()!==m.EOF&&F(A.EndOfFileExpected,[],[]),!0):(F(A.ValueExpected,[],[]),!1)}function s(t,l){const h=L(t),o=[];let $,E=0,k;do switch(k=h.getPosition(),$=h.scan(),$){case m.LineCommentTrivia:case m.BlockCommentTrivia:case m.EOF:E!==k&&o.push(t.substring(E,k)),l!==void 0&&o.push(h.getTokenValue().replace(/[^\r\n]/g,l)),E=h.getPosition();break}while($!==m.EOF);return o.join("")}function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ye[49],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class r{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=r}),define(ye[81],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(R){this.element=R,this.next=r.Undefined,this.prev=r.Undefined}}class m{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let R=this.a;for(;R!==r.Undefined;){const L=R.next;R.prev=r.Undefined,R.next=r.Undefined,R=L}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const T=new r(R);if(this.a===r.Undefined)this.a=T,this.b=T;else if(L){const c=this.b;this.b=T,T.prev=c,c.next=T}else{const c=this.a;this.a=T,T.next=c,c.prev=T}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(T))}}shift(){if(this.a!==r.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==r.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==r.Undefined&&R.next!==r.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===r.Undefined&&R.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):R.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):R.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==r.Undefined;)yield R.element,R=R.next}}e.$5c=m}),define(ye[29],Se([1,0]),function(de,e){"use strict";var r,m,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=R,e.$yc=L,e.$zc=T,e.$Ic=s;function R(i,t,l){let h=i.get(t);return h===void 0&&(h=l,i.set(t,h)),h}function L(i){const t=[];return i.forEach((l,h)=>{t.push(`${h} => ${l}`)}),`Map(${i.size}) {${t.join(", ")}}`}function T(i){const t=[];return i.forEach(l=>{t.push(l)}),`Set(${i.size}) {${t.join(", ")}}`}class p{constructor(t,l){this.uri=t,this.value=l}}function c(i){return Array.isArray(i)}class C{static{this.c=t=>t.toString()}constructor(t,l){if(this[r]="ResourceMap",t instanceof C)this.d=new Map(t.d),this.e=l??C.c;else if(c(t)){this.d=new Map,this.e=l??C.c;for(const[h,o]of t)this.set(h,o)}else this.d=new Map,this.e=t??C.c}set(t,l){return this.d.set(this.e(t),new p(t,l)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,l){typeof l<"u"&&(t=t.bind(l));for(const[h,o]of this.d)t(o.value,o.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=C;class S{constructor(t,l){this[m]="ResourceSet",!t||typeof t=="function"?this.c=new C(t):(this.c=new C(l),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,l){this.c.forEach((h,o)=>t.call(l,o,o,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(m=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var d;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class P{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,l=d.None){const h=this.c.get(t);if(h)return l!==d.None&&this.m(h,l),h.value}set(t,l,h=d.None){let o=this.c.get(t);if(o)o.value=l,h!==d.None&&this.m(o,h);else{switch(o={key:t,value:l,next:void 0,previous:void 0},h){case d.None:this.k(o);break;case d.AsOld:this.j(o);break;case d.AsNew:this.k(o);break;default:this.k(o);break}this.c.set(t,o),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const l=this.c.get(t);if(l)return this.c.delete(t),this.l(l),this.f--,l.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,l){const h=this.g;let o=this.d;for(;o;){if(l?t.bind(l)(o.value,o.key,this):t(o.value,o.key,this),this.g!==h)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const t=this,l=this.g;let h=this.d;const o={[Symbol.iterator](){return o},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(h){const $={value:h.key,done:!1};return h=h.next,$}else return{value:void 0,done:!0}}};return o}values(){const t=this,l=this.g;let h=this.d;const o={[Symbol.iterator](){return o},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(h){const $={value:h.value,done:!1};return h=h.next,$}else return{value:void 0,done:!0}}};return o}entries(){const t=this,l=this.g;let h=this.d;const o={[Symbol.iterator](){return o},next(){if(t.g!==l)throw new Error("LinkedMap got modified during iteration.");if(h){const $={value:[h.key,h.value],done:!1};return h=h.next,$}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this.d,h=this.size;for(;l&&h>t;)this.c.delete(l.key),l=l.next,h--;this.d=l,this.f=h,l&&(l.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this.e,h=this.size;for(;l&&h>t;)this.c.delete(l.key),l=l.previous,h--;this.e=l,this.f=h,l&&(l.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const l=t.next,h=t.previous;if(!l||!h)throw new Error("Invalid list");l.previous=h,h.next=l}t.next=void 0,t.previous=void 0,this.g++}m(t,l){if(!this.d||!this.e)throw new Error("Invalid list");if(!(l!==d.AsOld&&l!==d.AsNew)){if(l===d.AsOld){if(t===this.d)return;const h=t.next,o=t.previous;t===this.e?(o.next=void 0,this.e=o):(h.previous=o,o.next=h),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(l===d.AsNew){if(t===this.e)return;const h=t.next,o=t.previous;t===this.d?(h.previous=void 0,this.d=h):(h.previous=o,o.next=h),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((l,h)=>{t.push([h,l])}),t}fromJSON(t){this.clear();for(const[l,h]of t)this.set(l,h)}}e.$Cc=P;class b extends P{constructor(t,l=1){super(),this.n=t,this.o=Math.min(Math.max(0,l),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,l=d.AsNew){return super.get(t,l)}peek(t){return super.get(t,d.None)}set(t,l){return super.set(t,l,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends b{constructor(t,l=1){super(t,l)}q(t){this.h(t)}set(t,l){return super.set(t,l),this.p(),this}}e.$Dc=a;class u extends b{constructor(t,l=1){super(t,l)}q(t){this.i(t)}set(t,l){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,l),this}}e.$Ec=u;class f{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let l=this.c.get(t)||0;return l===0?!1:(l--,l===0?this.c.delete(t):this.c.set(t,l),!0)}has(t){return this.c.has(t)}}e.$Fc=f;class g{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[l,h]of t)this.set(l,h)}clear(){this.c.clear(),this.d.clear()}set(t,l){this.c.set(t,l),this.d.set(l,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const l=this.c.get(t);return l===void 0?!1:(this.c.delete(t),this.d.delete(l),!0)}forEach(t,l){this.c.forEach((h,o)=>{t.call(l,h,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=g;class n{constructor(){this.c=new Map}add(t,l){let h=this.c.get(t);h||(h=new Set,this.c.set(t,h)),h.add(l)}delete(t,l){const h=this.c.get(t);h&&(h.delete(l),h.size===0&&this.c.delete(t))}forEach(t,l){const h=this.c.get(t);h&&h.forEach(l)}get(t){const l=this.c.get(t);return l||new Set}}e.$Hc=n;function s(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[l,h]of i)if(!t.has(l)||t.get(l)!==h)return!1;for(const[l]of t)if(!i.has(l))return!1;return!0}}),define(ye[3],Se([1,0,19,79,29,80,40]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=C,e.$Lc=S,e.$Mc=d,e.$Nc=a,e.$Oc=u,e.$Pc=f,e.$Qc=g,e.$Rc=n,e.$Sc=s,e.$3c=v;const T=!1;let p=null;class c{constructor(){this.b=new Map}static{this.a=0}c(y){let N=this.b.get(y);return N||(N={parent:null,source:null,isSingleton:!1,value:y,idx:c.a++},this.b.set(y,N)),N}trackDisposable(y){const N=this.c(y);N.source||(N.source=new Error().stack)}setParent(y,N){const O=this.c(y);O.parent=N}markAsDisposed(y){this.b.delete(y)}markAsSingleton(y){this.c(y).isSingleton=!0}f(y,N){const O=N.get(y);if(O)return O;const U=y.parent?this.f(this.c(y.parent),N):y;return N.set(y,U),U}getTrackedDisposables(){const y=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,y).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(y=10,N){let O;if(N)O=N;else{const F=new Map,J=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,F).isSingleton);if(J.length===0)return;const ee=new Set(J.map(V=>V.value));if(O=J.filter(V=>!(V.parent&&ee.has(V.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function U(F){function J(V,H){for(;V.length>0&&H.some(_=>typeof _=="string"?_===V[0]:V[0].match(_));)V.shift()}const ee=F.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return J(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const j=new A.$Hc;for(const F of O){const J=U(F);for(let ee=0;ee<=J.length;ee++)j.add(J.slice(0,ee).join(`
`),F)}O.sort((0,r.$6b)(F=>F.idx,r.$8b));let z="",M=0;for(const F of O.slice(0,y)){M++;const J=U(F),ee=[];for(let V=0;V<J.length;V++){let H=J[V];H=`(shared with ${j.get(J.slice(0,V+1).join(`
`)).size}/${O.length} leaks) at ${H}`;const ne=j.get(J.slice(0,V).join(`
`)),he=(0,m.$K)([...ne].map(re=>U(re)[V]),re=>re);delete he[J[V]];for(const[re,ve]of Object.entries(he))ee.unshift(`    - stacktraces of ${ve.length} other leaks continue with ${re}`);ee.unshift(H)}z+=`


==================== Leaking disposable ${M}/${O.length}: ${F.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return O.length>y&&(z+=`


... and ${O.length-y} more leaking disposables

`),{leaks:O,details:z}}}e.$Jc=c;function C(w){p=w}if(T){const w="__is_disposable_tracked__";C(new class{trackDisposable(y){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[w]||console.log(N)},3e3)}setParent(y,N){if(y&&y!==t.None)try{y[w]=!0}catch{}}markAsDisposed(y){if(y&&y!==t.None)try{y[w]=!0}catch{}}markAsSingleton(y){}})}function S(w){return p?.trackDisposable(w),w}function d(w){p?.markAsDisposed(w)}function P(w,y){p?.setParent(w,y)}function b(w,y){if(p)for(const N of w)p.setParent(N,y)}function a(w){return p?.markAsSingleton(w),w}function u(w){return typeof w=="object"&&w!==null&&typeof w.dispose=="function"&&w.dispose.length===0}function f(w){if(L.Iterable.is(w)){const y=[];for(const N of w)if(N)try{N.dispose()}catch(O){y.push(O)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(w)?[]:w}else if(w)return w.dispose(),w}function g(w){for(const y of w)u(y)&&y.dispose();return[]}function n(...w){const y=s(()=>f(w));return b(w,y),y}function s(w){const y=S({dispose:(0,R.$db)(()=>{d(y),w()})});return y}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return P(y,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(y),y.dispose()}}deleteAndLeak(y){y&&this.f.has(y)&&(this.f.delete(y),P(y,null))}}e.$Tc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,S(this),P(this.q,this)}dispose(){d(this),this.q.dispose()}B(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(y)}}e.$Uc=t;class l{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(y){this.b||y===this.a||(this.a?.dispose(),y&&P(y,this),this.a=y)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const y=this.a;return this.a=void 0,y&&P(y,null),y}}e.$Vc=l;class h{constructor(y){this.a=new l,this.b=!1,this.a.value=y}get value(){return this.a.value}set value(y){this.b||y===this.a.value||(this.a.value=y)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=h;class o{constructor(y){this.b=y,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=o;class ${constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(y){let N=y;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,d(this))},this}}e.$Yc=$;class E{constructor(){this.a=new Map}acquire(y,...N){let O=this.a.get(y);O||(O={counter:0,object:this.b(y,...N)},this.a.set(y,O));const{object:U}=O,j=(0,R.$db)(()=>{--O.counter===0&&(this.c(y,O.object),this.a.delete(y))});return O.counter++,{object:U,dispose:j}}}e.$Zc=E;class k{constructor(y){this.a=y}async acquire(y,...N){const O=this.a.acquire(y,...N);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(U){throw O.dispose(),U}}}e.$1c=k;class D{constructor(y){this.object=y}dispose(){}}e.$2c=D;function v(w){const y=new i;try{w(y)}finally{y.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(y){return this.a.has(y)}get size(){return this.a.size}get(y){return this.a.get(y)}set(y,N,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(y)?.dispose(),this.a.set(y,N)}deleteAndDispose(y){this.a.get(y)?.dispose(),this.a.delete(y)}deleteAndLeak(y){const N=this.a.get(y);return this.a.delete(y),N}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=I}),function(de,e){typeof define=="function"&&define.amd?define(ye[175],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(de=typeof globalThis<"u"?globalThis:de||self,e(de.marked={}))}(this,function(de){"use strict";function e(ie,ce){for(var ue=0;ue<ce.length;ue++){var Z=ce[ue];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(ie,Z.key,Z)}}function r(ie,ce,ue){return ce&&e(ie.prototype,ce),ue&&e(ie,ue),Object.defineProperty(ie,"prototype",{writable:!1}),ie}function m(ie,ce){if(ie){if(typeof ie=="string")return A(ie,ce);var ue=Object.prototype.toString.call(ie).slice(8,-1);if(ue==="Object"&&ie.constructor&&(ue=ie.constructor.name),ue==="Map"||ue==="Set")return Array.from(ie);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return A(ie,ce)}}function A(ie,ce){(ce==null||ce>ie.length)&&(ce=ie.length);for(var ue=0,Z=new Array(ce);ue<ce;ue++)Z[ue]=ie[ue];return Z}function R(ie,ce){var ue=typeof Symbol<"u"&&ie[Symbol.iterator]||ie["@@iterator"];if(ue)return(ue=ue.call(ie)).next.bind(ue);if(Array.isArray(ie)||(ue=m(ie))||ce&&ie&&typeof ie.length=="number"){ue&&(ie=ue);var Z=0;return function(){return Z>=ie.length?{done:!0}:{done:!1,value:ie[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}de.defaults=L();function T(ie){de.defaults=ie}var p=/[&<>"']/,c=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(ce){return d[ce]};function b(ie,ce){if(ce){if(p.test(ie))return ie.replace(c,P)}else if(C.test(ie))return ie.replace(S,P);return ie}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(ie){return ie.replace(a,function(ce,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var f=/(^|[^\[])\^/g;function g(ie,ce){ie=typeof ie=="string"?ie:ie.source,ce=ce||"";var ue={replace:function(oe,$e){return $e=$e.source||$e,$e=$e.replace(f,"$1"),ie=ie.replace(oe,$e),ue},getRegex:function(){return new RegExp(ie,ce)}};return ue}var n=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function i(ie,ce,ue){if(ie){var Z;try{Z=decodeURIComponent(u(ue)).replace(n,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ce&&!s.test(ue)&&(ue=$(ce,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var t={},l=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(ie,ce){t[" "+ie]||(l.test(ie)?t[" "+ie]=ie+"/":t[" "+ie]=v(ie,"/",!0)),ie=t[" "+ie];var ue=ie.indexOf(":")===-1;return ce.substring(0,2)==="//"?ue?ce:ie.replace(h,"$1")+ce:ce.charAt(0)==="/"?ue?ce:ie.replace(o,"$1")+ce:ie+ce}var E={exec:function(){}};function k(ie){for(var ce=1,ue,Z;ce<arguments.length;ce++){ue=arguments[ce];for(Z in ue)Object.prototype.hasOwnProperty.call(ue,Z)&&(ie[Z]=ue[Z])}return ie}function D(ie,ce){var ue=ie.replace(/\|/g,function($e,be,Ne){for(var Be=!1,De=be;--De>=0&&Ne[De]==="\\";)Be=!Be;return Be?"|":" |"}),Z=ue.split(/ \|/),oe=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>ce)Z.splice(ce);else for(;Z.length<ce;)Z.push("");for(;oe<Z.length;oe++)Z[oe]=Z[oe].trim().replace(/\\\|/g,"|");return Z}function v(ie,ce,ue){var Z=ie.length;if(Z===0)return"";for(var oe=0;oe<Z;){var $e=ie.charAt(Z-oe-1);if($e===ce&&!ue)oe++;else if($e!==ce&&ue)oe++;else break}return ie.slice(0,Z-oe)}function I(ie,ce){if(ie.indexOf(ce[1])===-1)return-1;for(var ue=ie.length,Z=0,oe=0;oe<ue;oe++)if(ie[oe]==="\\")oe++;else if(ie[oe]===ce[0])Z++;else if(ie[oe]===ce[1]&&(Z--,Z<0))return oe;return-1}function w(ie){ie&&ie.sanitize&&!ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function y(ie,ce){if(ce<1)return"";for(var ue="";ce>1;)ce&1&&(ue+=ie),ce>>=1,ie+=ie;return ue+ie}function N(ie,ce,ue,Z){var oe=ce.href,$e=ce.title?b(ce.title):null,be=ie[1].replace(/\\([\[\]])/g,"$1");if(ie[0].charAt(0)!=="!"){Z.state.inLink=!0;var Ne={type:"link",raw:ue,href:oe,title:$e,text:be,tokens:Z.inlineTokens(be)};return Z.state.inLink=!1,Ne}return{type:"image",raw:ue,href:oe,title:$e,text:b(be)}}function O(ie,ce){var ue=ie.match(/^(\s+)(?:```)/);if(ue===null)return ce;var Z=ue[1];return ce.split(`
`).map(function(oe){var $e=oe.match(/^\s+/);if($e===null)return oe;var be=$e[0];return be.length>=Z.length?oe.slice(Z.length):oe}).join(`
`)}var U=function(){function ie(ue){this.options=ue||de.defaults}var ce=ie.prototype;return ce.space=function(Z){var oe=this.rules.block.newline.exec(Z);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},ce.code=function(Z){var oe=this.rules.block.code.exec(Z);if(oe){var $e=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:v($e,`
`)}}},ce.fences=function(Z){var oe=this.rules.block.fences.exec(Z);if(oe){var $e=oe[0],be=O($e,oe[3]||"");return{type:"code",raw:$e,lang:oe[2]?oe[2].trim():oe[2],text:be}}},ce.heading=function(Z){var oe=this.rules.block.heading.exec(Z);if(oe){var $e=oe[2].trim();if(/#$/.test($e)){var be=v($e,"#");(this.options.pedantic||!be||/ $/.test(be))&&($e=be.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:$e,tokens:this.lexer.inline($e)}}},ce.hr=function(Z){var oe=this.rules.block.hr.exec(Z);if(oe)return{type:"hr",raw:oe[0]}},ce.blockquote=function(Z){var oe=this.rules.block.blockquote.exec(Z);if(oe){var $e=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},ce.list=function(Z){var oe=this.rules.block.list.exec(Z);if(oe){var $e,be,Ne,Be,De,Ie,Le,W,q,Y,x,fe,we=oe[1].trim(),Me=we.length>1,qe={type:"list",raw:"",ordered:Me,start:Me?+we.slice(0,-1):"",loose:!1,items:[]};we=Me?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Me?we:"[*+-]");for(var He=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(fe=!1,!(!(oe=He.exec(Z))||this.rules.block.hr.test(Z)));){if($e=oe[0],Z=Z.substring($e.length),W=oe[2].split(`
`,1)[0],q=Z.split(`
`,1)[0],this.options.pedantic?(Be=2,x=W.trimLeft()):(Be=oe[2].search(/[^ ]/),Be=Be>4?1:Be,x=W.slice(Be),Be+=oe[1].length),Ie=!1,!W&&/^ *$/.test(q)&&($e+=q+`
`,Z=Z.substring(q.length+1),fe=!0),!fe)for(var Ze=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,Be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}#");Z&&(Y=Z.split(`
`,1)[0],W=Y,this.options.pedantic&&(W=W.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(W)||rt.test(W)||Ze.test(W)||it.test(Z)));){if(W.search(/[^ ]/)>=Be||!W.trim())x+=`
`+W.slice(Be);else if(!Ie)x+=`
`+W;else break;!Ie&&!W.trim()&&(Ie=!0),$e+=Y+`
`,Z=Z.substring(Y.length+1)}qe.loose||(Le?qe.loose=!0:/\n *\n *$/.test($e)&&(Le=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(x),be&&(Ne=be[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:$e,task:!!be,checked:Ne,loose:!1,text:x}),qe.raw+=$e}qe.items[qe.items.length-1].raw=$e.trimRight(),qe.items[qe.items.length-1].text=x.trimRight(),qe.raw=qe.raw.trimRight();var ot=qe.items.length;for(De=0;De<ot;De++){this.lexer.state.top=!1,qe.items[De].tokens=this.lexer.blockTokens(qe.items[De].text,[]);var ft=qe.items[De].tokens.filter(function(st){return st.type==="space"}),ut=ft.every(function(st){for(var Pe=st.raw.split(""),Ue=0,Ae=R(Pe),Te;!(Te=Ae()).done;){var le=Te.value;if(le===`
`&&(Ue+=1),Ue>1)return!0}return!1});!qe.loose&&ft.length&&ut&&(qe.loose=!0,qe.items[De].loose=!0)}return qe}},ce.html=function(Z){var oe=this.rules.block.html.exec(Z);if(oe){var $e={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(oe[0]):b(oe[0]);$e.type="paragraph",$e.text=be,$e.tokens=this.lexer.inline(be)}return $e}},ce.def=function(Z){var oe=this.rules.block.def.exec(Z);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var $e=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:oe[0],href:oe[2],title:oe[3]}}},ce.table=function(Z){var oe=this.rules.block.table.exec(Z);if(oe){var $e={type:"table",header:D(oe[1]).map(function(Le){return{text:Le}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=oe[0];var be=$e.align.length,Ne,Be,De,Ie;for(Ne=0;Ne<be;Ne++)/^ *-+: *$/.test($e.align[Ne])?$e.align[Ne]="right":/^ *:-+: *$/.test($e.align[Ne])?$e.align[Ne]="center":/^ *:-+ *$/.test($e.align[Ne])?$e.align[Ne]="left":$e.align[Ne]=null;for(be=$e.rows.length,Ne=0;Ne<be;Ne++)$e.rows[Ne]=D($e.rows[Ne],$e.header.length).map(function(Le){return{text:Le}});for(be=$e.header.length,Be=0;Be<be;Be++)$e.header[Be].tokens=this.lexer.inline($e.header[Be].text);for(be=$e.rows.length,Be=0;Be<be;Be++)for(Ie=$e.rows[Be],De=0;De<Ie.length;De++)Ie[De].tokens=this.lexer.inline(Ie[De].text);return $e}}},ce.lheading=function(Z){var oe=this.rules.block.lheading.exec(Z);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},ce.paragraph=function(Z){var oe=this.rules.block.paragraph.exec(Z);if(oe){var $e=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:$e,tokens:this.lexer.inline($e)}}},ce.text=function(Z){var oe=this.rules.block.text.exec(Z);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},ce.escape=function(Z){var oe=this.rules.inline.escape.exec(Z);if(oe)return{type:"escape",raw:oe[0],text:b(oe[1])}},ce.tag=function(Z){var oe=this.rules.inline.tag.exec(Z);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):b(oe[0]):oe[0]}},ce.link=function(Z){var oe=this.rules.inline.link.exec(Z);if(oe){var $e=oe[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var be=v($e.slice(0,-1),"\\");if(($e.length-be.length)%2===0)return}else{var Ne=I(oe[2],"()");if(Ne>-1){var Be=oe[0].indexOf("!")===0?5:4,De=Be+oe[1].length+Ne;oe[2]=oe[2].substring(0,Ne),oe[0]=oe[0].substring(0,De).trim(),oe[3]=""}}var Ie=oe[2],Le="";if(this.options.pedantic){var W=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);W&&(Ie=W[1],Le=W[3])}else Le=oe[3]?oe[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test($e)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),N(oe,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Le&&Le.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ce.reflink=function(Z,oe){var $e;if(($e=this.rules.inline.reflink.exec(Z))||($e=this.rules.inline.nolink.exec(Z))){var be=($e[2]||$e[1]).replace(/\s+/g," ");if(be=oe[be.toLowerCase()],!be||!be.href){var Ne=$e[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return N($e,be,$e[0],this.lexer)}},ce.emStrong=function(Z,oe,$e){$e===void 0&&($e="");var be=this.rules.inline.emStrong.lDelim.exec(Z);if(be&&!(be[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=be[1]||be[2]||"";if(!Ne||Ne&&($e===""||this.rules.inline.punctuation.exec($e))){var Be=be[0].length-1,De,Ie,Le=Be,W=0,q=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,oe=oe.slice(-1*Z.length+Be);(be=q.exec(oe))!=null;)if(De=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!De){if(Ie=De.length,be[3]||be[4]){Le+=Ie;continue}else if((be[5]||be[6])&&Be%3&&!((Be+Ie)%3)){W+=Ie;continue}if(Le-=Ie,!(Le>0)){if(Ie=Math.min(Ie,Ie+Le+W),Math.min(Be,Ie)%2){var Y=Z.slice(1,Be+be.index+Ie);return{type:"em",raw:Z.slice(0,Be+be.index+Ie+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}var x=Z.slice(2,Be+be.index+Ie-1);return{type:"strong",raw:Z.slice(0,Be+be.index+Ie+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},ce.codespan=function(Z){var oe=this.rules.inline.code.exec(Z);if(oe){var $e=oe[2].replace(/\n/g," "),be=/[^ ]/.test($e),Ne=/^ /.test($e)&&/ $/.test($e);return be&&Ne&&($e=$e.substring(1,$e.length-1)),$e=b($e,!0),{type:"codespan",raw:oe[0],text:$e}}},ce.br=function(Z){var oe=this.rules.inline.br.exec(Z);if(oe)return{type:"br",raw:oe[0]}},ce.del=function(Z){var oe=this.rules.inline.del.exec(Z);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},ce.autolink=function(Z,oe){var $e=this.rules.inline.autolink.exec(Z);if($e){var be,Ne;return $e[2]==="@"?(be=b(this.options.mangle?oe($e[1]):$e[1]),Ne="mailto:"+be):(be=b($e[1]),Ne=be),{type:"link",raw:$e[0],text:be,href:Ne,tokens:[{type:"text",raw:be,text:be}]}}},ce.url=function(Z,oe){var $e;if($e=this.rules.inline.url.exec(Z)){var be,Ne;if($e[2]==="@")be=b(this.options.mangle?oe($e[0]):$e[0]),Ne="mailto:"+be;else{var Be;do Be=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(Be!==$e[0]);be=b($e[0]),$e[1]==="www."?Ne="http://"+be:Ne=be}return{type:"link",raw:$e[0],text:be,href:Ne,tokens:[{type:"text",raw:be,text:be}]}}},ce.inlineText=function(Z,oe){var $e=this.rules.inline.text.exec(Z);if($e){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):b($e[0]):$e[0]:be=b(this.options.smartypants?oe($e[0]):$e[0]),{type:"text",raw:$e[0],text:be}}},ie}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=g(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=g(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=g(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=g(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=g(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=g(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=k({},j),j.gfm=k({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=g(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=g(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=k({},j.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:g(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=g(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=g(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=g(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=g(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=g(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=g(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=g(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=g(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=g(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=g(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=g(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=k({},z),z.pedantic=k({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=k({},z.normal,{escape:g(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=g(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=k({},z.gfm,{br:g(z.br).replace("{2,}","*").getRegex(),text:g(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(ie){return ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(ie){var ce="",ue,Z,oe=ie.length;for(ue=0;ue<oe;ue++)Z=ie.charCodeAt(ue),Math.random()>.5&&(Z="x"+Z.toString(16)),ce+="&#"+Z+";";return ce}var J=function(){function ie(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||de.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:j.normal,inline:z.normal};this.options.pedantic?(Z.block=j.pedantic,Z.inline=z.pedantic):this.options.gfm&&(Z.block=j.gfm,this.options.breaks?Z.inline=z.breaks:Z.inline=z.gfm),this.tokenizer.rules=Z}ie.lex=function(Z,oe){var $e=new ie(oe);return $e.lex(Z)},ie.lexInline=function(Z,oe){var $e=new ie(oe);return $e.inlineTokens(Z)};var ce=ie.prototype;return ce.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ce.blockTokens=function(Z,oe){var $e=this;oe===void 0&&(oe=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(Le,W,q){return W+"    ".repeat(q.length)});for(var be,Ne,Be,De;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Le){return(be=Le.call({lexer:$e},Z,oe))?(Z=Z.substring(be.raw.length),oe.push(be),!0):!1}))){if(be=this.tokenizer.space(Z)){Z=Z.substring(be.raw.length),be.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(be);continue}if(be=this.tokenizer.code(Z)){Z=Z.substring(be.raw.length),Ne=oe[oe.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+be.raw,Ne.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):oe.push(be);continue}if(be=this.tokenizer.fences(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.heading(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.hr(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.blockquote(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.list(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.html(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.def(Z)){Z=Z.substring(be.raw.length),Ne=oe[oe.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+be.raw,Ne.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.lheading(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Le=1/0,W=Z.slice(1),q=void 0;$e.options.extensions.startBlock.forEach(function(Y){q=Y.call({lexer:this},W),typeof q=="number"&&q>=0&&(Le=Math.min(Le,q))}),Le<1/0&&Le>=0&&(Be=Z.substring(0,Le+1))}(),this.state.top&&(be=this.tokenizer.paragraph(Be))){Ne=oe[oe.length-1],De&&Ne.type==="paragraph"?(Ne.raw+=`
`+be.raw,Ne.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):oe.push(be),De=Be.length!==Z.length,Z=Z.substring(be.raw.length);continue}if(be=this.tokenizer.text(Z)){Z=Z.substring(be.raw.length),Ne=oe[oe.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+be.raw,Ne.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):oe.push(be);continue}if(Z){var Ie="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,oe},ce.inline=function(Z,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:Z,tokens:oe}),oe},ce.inlineTokens=function(Z,oe){var $e=this;oe===void 0&&(oe=[]);var be,Ne,Be,De=Z,Ie,Le,W;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)q.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Ie.index)+"["+y("a",Ie[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Ie.index)+"["+y("a",Ie[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Ie.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Le||(W=""),Le=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(be=x.call({lexer:$e},Z,oe))?(Z=Z.substring(be.raw.length),oe.push(be),!0):!1}))){if(be=this.tokenizer.escape(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.tag(Z)){Z=Z.substring(be.raw.length),Ne=oe[oe.length-1],Ne&&be.type==="text"&&Ne.type==="text"?(Ne.raw+=be.raw,Ne.text+=be.text):oe.push(be);continue}if(be=this.tokenizer.link(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(be.raw.length),Ne=oe[oe.length-1],Ne&&be.type==="text"&&Ne.type==="text"?(Ne.raw+=be.raw,Ne.text+=be.text):oe.push(be);continue}if(be=this.tokenizer.emStrong(Z,De,W)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.codespan(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.br(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.del(Z)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(be=this.tokenizer.autolink(Z,F)){Z=Z.substring(be.raw.length),oe.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(Z,F))){Z=Z.substring(be.raw.length),oe.push(be);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,fe=Z.slice(1),we=void 0;$e.options.extensions.startInline.forEach(function(Me){we=Me.call({lexer:this},fe),typeof we=="number"&&we>=0&&(x=Math.min(x,we))}),x<1/0&&x>=0&&(Be=Z.substring(0,x+1))}(),be=this.tokenizer.inlineText(Be,M)){Z=Z.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(W=be.raw.slice(-1)),Le=!0,Ne=oe[oe.length-1],Ne&&Ne.type==="text"?(Ne.raw+=be.raw,Ne.text+=be.text):oe.push(be);continue}if(Z){var Y="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return oe},r(ie,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),ie}(),ee=function(){function ie(ue){this.options=ue||de.defaults}var ce=ie.prototype;return ce.code=function(Z,oe,$e){var be=(oe||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(Z,be);Ne!=null&&Ne!==Z&&($e=!0,Z=Ne)}return Z=Z.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+b(be,!0)+'">'+($e?Z:b(Z,!0))+`</code></pre>
`:"<pre><code>"+($e?Z:b(Z,!0))+`</code></pre>
`},ce.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ce.html=function(Z){return Z},ce.heading=function(Z,oe,$e,be){if(this.options.headerIds){var Ne=this.options.headerPrefix+be.slug($e);return"<h"+oe+' id="'+Ne+'">'+Z+"</h"+oe+`>
`}return"<h"+oe+">"+Z+"</h"+oe+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(Z,oe,$e){var be=oe?"ol":"ul",Ne=oe&&$e!==1?' start="'+$e+'"':"";return"<"+be+Ne+`>
`+Z+"</"+be+`>
`},ce.listitem=function(Z){return"<li>"+Z+`</li>
`},ce.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(Z){return"<p>"+Z+`</p>
`},ce.table=function(Z,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+oe+`</table>
`},ce.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ce.tablecell=function(Z,oe){var $e=oe.header?"th":"td",be=oe.align?"<"+$e+' align="'+oe.align+'">':"<"+$e+">";return be+Z+("</"+$e+`>
`)},ce.strong=function(Z){return"<strong>"+Z+"</strong>"},ce.em=function(Z){return"<em>"+Z+"</em>"},ce.codespan=function(Z){return"<code>"+Z+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(Z){return"<del>"+Z+"</del>"},ce.link=function(Z,oe,$e){if(Z=i(this.options.sanitize,this.options.baseUrl,Z),Z===null)return $e;var be='<a href="'+b(Z)+'"';return oe&&(be+=' title="'+oe+'"'),be+=">"+$e+"</a>",be},ce.image=function(Z,oe,$e){if(Z=i(this.options.sanitize,this.options.baseUrl,Z),Z===null)return $e;var be='<img src="'+Z+'" alt="'+$e+'"';return oe&&(be+=' title="'+oe+'"'),be+=this.options.xhtml?"/>":">",be},ce.text=function(Z){return Z},ie}(),V=function(){function ie(){}var ce=ie.prototype;return ce.strong=function(Z){return Z},ce.em=function(Z){return Z},ce.codespan=function(Z){return Z},ce.del=function(Z){return Z},ce.html=function(Z){return Z},ce.text=function(Z){return Z},ce.link=function(Z,oe,$e){return""+$e},ce.image=function(Z,oe,$e){return""+$e},ce.br=function(){return""},ie}(),H=function(){function ie(){this.seen={}}var ce=ie.prototype;return ce.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(Z,oe){var $e=Z,be=0;if(this.seen.hasOwnProperty($e)){be=this.seen[Z];do be++,$e=Z+"-"+be;while(this.seen.hasOwnProperty($e))}return oe||(this.seen[Z]=be,this.seen[$e]=0),$e},ce.slug=function(Z,oe){oe===void 0&&(oe={});var $e=this.serialize(Z);return this.getNextSafeSlug($e,oe.dryrun)},ie}(),_=function(){function ie(ue){this.options=ue||de.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new H}ie.parse=function(Z,oe){var $e=new ie(oe);return $e.parse(Z)},ie.parseInline=function(Z,oe){var $e=new ie(oe);return $e.parseInline(Z)};var ce=ie.prototype;return ce.parse=function(Z,oe){oe===void 0&&(oe=!0);var $e="",be,Ne,Be,De,Ie,Le,W,q,Y,x,fe,we,Me,qe,He,Ze,it,tt,rt,ot=Z.length;for(be=0;be<ot;be++){if(x=Z[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(rt=this.options.extensions.renderers[x.type].call({parser:this},x),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){$e+=rt||"";continue}switch(x.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(x.tokens),x.depth,u(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(q="",W="",De=x.header.length,Ne=0;Ne<De;Ne++)W+=this.renderer.tablecell(this.parseInline(x.header[Ne].tokens),{header:!0,align:x.align[Ne]});for(q+=this.renderer.tablerow(W),Y="",De=x.rows.length,Ne=0;Ne<De;Ne++){for(Le=x.rows[Ne],W="",Ie=Le.length,Be=0;Be<Ie;Be++)W+=this.renderer.tablecell(this.parseInline(Le[Be].tokens),{header:!1,align:x.align[Be]});Y+=this.renderer.tablerow(W)}$e+=this.renderer.table(q,Y);continue}case"blockquote":{Y=this.parse(x.tokens),$e+=this.renderer.blockquote(Y);continue}case"list":{for(fe=x.ordered,we=x.start,Me=x.loose,De=x.items.length,Y="",Ne=0;Ne<De;Ne++)He=x.items[Ne],Ze=He.checked,it=He.task,qe="",He.task&&(tt=this.renderer.checkbox(Ze),Me?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=tt+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=tt+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:tt}):qe+=tt),qe+=this.parse(He.tokens,Me),Y+=this.renderer.listitem(qe,it,Ze);$e+=this.renderer.list(Y,fe,we);continue}case"html":{$e+=this.renderer.html(x.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(Y=x.tokens?this.parseInline(x.tokens):x.text;be+1<ot&&Z[be+1].type==="text";)x=Z[++be],Y+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);$e+=oe?this.renderer.paragraph(Y):Y;continue}default:{var ft='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return $e},ce.parseInline=function(Z,oe){oe=oe||this.renderer;var $e="",be,Ne,Be,De=Z.length;for(be=0;be<De;be++){if(Ne=Z[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(Be=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){$e+=Be||"";continue}switch(Ne.type){case"escape":{$e+=oe.text(Ne.text);break}case"html":{$e+=oe.html(Ne.text);break}case"link":{$e+=oe.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,oe));break}case"image":{$e+=oe.image(Ne.href,Ne.title,Ne.text);break}case"strong":{$e+=oe.strong(this.parseInline(Ne.tokens,oe));break}case"em":{$e+=oe.em(this.parseInline(Ne.tokens,oe));break}case"codespan":{$e+=oe.codespan(Ne.text);break}case"br":{$e+=oe.br();break}case"del":{$e+=oe.del(this.parseInline(Ne.tokens,oe));break}case"text":{$e+=oe.text(Ne.text);break}default:{var Ie='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return $e},ie}();function ne(ie,ce,ue){if(typeof ie>"u"||ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");if(typeof ce=="function"&&(ue=ce,ce=null),ce=k({},ne.defaults,ce||{}),w(ce),ue){var Z=ce.highlight,oe;try{oe=J.lex(ie,ce)}catch(De){return ue(De)}var $e=function(Ie){var Le;if(!Ie)try{ce.walkTokens&&ne.walkTokens(oe,ce.walkTokens),Le=_.parse(oe,ce)}catch(W){Ie=W}return ce.highlight=Z,Ie?ue(Ie):ue(null,Le)};if(!Z||Z.length<3||(delete ce.highlight,!oe.length))return $e();var be=0;ne.walkTokens(oe,function(De){De.type==="code"&&(be++,setTimeout(function(){Z(De.text,De.lang,function(Ie,Le){if(Ie)return $e(Ie);Le!=null&&Le!==De.text&&(De.text=Le,De.escaped=!0),be--,be===0&&$e()})},0))}),be===0&&$e();return}function Ne(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+b(De.message+"",!0)+"</pre>";throw De}try{var Be=J.lex(ie,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ne.walkTokens(Be,ce.walkTokens)).then(function(){return _.parse(Be,ce)}).catch(Ne);ne.walkTokens(Be,ce.walkTokens)}return _.parse(Be,ce)}catch(De){Ne(De)}}ne.options=ne.setOptions=function(ie){return k(ne.defaults,ie),T(ne.defaults),ne},ne.getDefaults=L,ne.defaults=de.defaults,ne.use=function(){for(var ie=arguments.length,ce=new Array(ie),ue=0;ue<ie;ue++)ce[ue]=arguments[ue];var Z=k.apply(void 0,[{}].concat(ce)),oe=ne.defaults.extensions||{renderers:{},childTokens:{}},$e;ce.forEach(function(be){if(be.extensions&&($e=!0,be.extensions.forEach(function(Be){if(!Be.name)throw new Error("extension name required");if(Be.renderer){var De=oe.renderers?oe.renderers[Be.name]:null;De?oe.renderers[Be.name]=function(){for(var Ie=arguments.length,Le=new Array(Ie),W=0;W<Ie;W++)Le[W]=arguments[W];var q=Be.renderer.apply(this,Le);return q===!1&&(q=De.apply(this,Le)),q}:oe.renderers[Be.name]=Be.renderer}if(Be.tokenizer){if(!Be.level||Be.level!=="block"&&Be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[Be.level]?oe[Be.level].unshift(Be.tokenizer):oe[Be.level]=[Be.tokenizer],Be.start&&(Be.level==="block"?oe.startBlock?oe.startBlock.push(Be.start):oe.startBlock=[Be.start]:Be.level==="inline"&&(oe.startInline?oe.startInline.push(Be.start):oe.startInline=[Be.start]))}Be.childTokens&&(oe.childTokens[Be.name]=Be.childTokens)})),be.renderer&&function(){var Be=ne.defaults.renderer||new ee,De=function(W){var q=Be[W];Be[W]=function(){for(var Y=arguments.length,x=new Array(Y),fe=0;fe<Y;fe++)x[fe]=arguments[fe];var we=be.renderer[W].apply(Be,x);return we===!1&&(we=q.apply(Be,x)),we}};for(var Ie in be.renderer)De(Ie);Z.renderer=Be}(),be.tokenizer&&function(){var Be=ne.defaults.tokenizer||new U,De=function(W){var q=Be[W];Be[W]=function(){for(var Y=arguments.length,x=new Array(Y),fe=0;fe<Y;fe++)x[fe]=arguments[fe];var we=be.tokenizer[W].apply(Be,x);return we===!1&&(we=q.apply(Be,x)),we}};for(var Ie in be.tokenizer)De(Ie);Z.tokenizer=Be}(),be.walkTokens){var Ne=ne.defaults.walkTokens;Z.walkTokens=function(Be){var De=[];return De.push(be.walkTokens.call(this,Be)),Ne&&(De=De.concat(Ne.call(this,Be))),De}}$e&&(Z.extensions=oe),ne.setOptions(Z)})},ne.walkTokens=function(ie,ce){for(var ue=[],Z=function(){var Ne=$e.value;switch(ue=ue.concat(ce.call(ne,Ne)),Ne.type){case"table":{for(var Be=R(Ne.header),De;!(De=Be()).done;){var Ie=De.value;ue=ue.concat(ne.walkTokens(Ie.tokens,ce))}for(var Le=R(Ne.rows),W;!(W=Le()).done;)for(var q=W.value,Y=R(q),x;!(x=Y()).done;){var fe=x.value;ue=ue.concat(ne.walkTokens(fe.tokens,ce))}break}case"list":{ue=ue.concat(ne.walkTokens(Ne.items,ce));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[Ne.type]?ne.defaults.extensions.childTokens[Ne.type].forEach(function(we){ue=ue.concat(ne.walkTokens(Ne[we],ce))}):Ne.tokens&&(ue=ue.concat(ne.walkTokens(Ne.tokens,ce)))}},oe=R(ie),$e;!($e=oe()).done;)Z();return ue},ne.parseInline=function(ie,ce){if(typeof ie>"u"||ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ie)+", string expected");ce=k({},ne.defaults,ce||{}),w(ce);try{var ue=J.lexInline(ie,ce);return ce.walkTokens&&ne.walkTokens(ue,ce.walkTokens),_.parseInline(ue,ce)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+b(Z.message+"",!0)+"</pre>";throw Z}},ne.Parser=_,ne.parser=_.parse,ne.Renderer=ee,ne.TextRenderer=V,ne.Lexer=J,ne.lexer=J.lex,ne.Tokenizer=U,ne.Slugger=H,ne.parse=ne;var he=ne.options,re=ne.setOptions,ve=ne.use,pe=ne.walkTokens,Q=ne.parseInline,B=ne,se=_.parse,ae=J.lex;de.Lexer=J,de.Parser=_,de.Renderer=ee,de.Slugger=H,de.TextRenderer=V,de.Tokenizer=U,de.getDefaults=L,de.lexer=ae,de.marked=ne,de.options=he,de.parse=B,de.parseInline=Q,de.parser=se,de.setOptions=re,de.use=ve,de.walkTokens=pe,Object.defineProperty(de,"__esModule",{value:!0})}),define(ye[41],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(m){m[m.Uri=1]="Uri",m[m.Regexp=2]="Regexp",m[m.ScmResource=3]="ScmResource",m[m.ScmResourceGroup=4]="ScmResourceGroup",m[m.ScmProvider=5]="ScmProvider",m[m.CommentController=6]="CommentController",m[m.CommentThread=7]="CommentThread",m[m.CommentThreadInstance=8]="CommentThreadInstance",m[m.CommentThreadReply=9]="CommentThreadReply",m[m.CommentNode=10]="CommentNode",m[m.CommentThreadNode=11]="CommentThreadNode",m[m.TimelineActionContext=12]="TimelineActionContext",m[m.NotebookCellActionContext=13]="NotebookCellActionContext",m[m.NotebookActionContext=14]="NotebookActionContext",m[m.TerminalContext=15]="TerminalContext",m[m.TestItemContext=16]="TestItemContext",m[m.Date=17]="Date",m[m.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(ye[176],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=r;function r(a){const u=R(a);if(u&&u.length>0)return new Uint32Array(u)}let m=0;const A=new Uint32Array(10);function R(a){if(m=0,L(a,S,p.InitialConsonant),m>0||(L(a,d,p.Vowel),m>0)||(L(a,P,p.FinalConsonant),m>0)||(L(a,b,p.CompatibilityJamo),m))return A.subarray(0,m);if(a>=44032&&a<=55203){const u=a-44032,f=u%588,g=Math.floor(u/588),n=Math.floor(f/28),s=f%28-1;if(g<S.length?L(g,S,0):p.InitialConsonant+g-p.CompatibilityJamo<b.length&&L(p.InitialConsonant+g,b,p.CompatibilityJamo),n<d.length?L(n,d,0):p.Vowel+n-p.CompatibilityJamo<b.length&&L(p.Vowel+n-p.CompatibilityJamo,b,p.CompatibilityJamo),s>=0&&(s<P.length?L(s,P,0):p.FinalConsonant+s-p.CompatibilityJamo<b.length&&L(p.FinalConsonant+s-p.CompatibilityJamo,b,p.CompatibilityJamo)),m>0)return A.subarray(0,m)}}function L(a,u,f){a>=f&&a<f+u.length&&T(u[a-f])}function T(a){a!==c.NUL&&(A[m++]=a&255,a>>8&&(A[m++]=a>>8&255),a>>16&&(A[m++]=a>>16&255))}var p;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var c;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(c||(c={}));var C;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(C||(C={}));const S=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),d=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,C.hk,C.ho,C.hl,c.y,c.n,C.nj,C.np,C.nl,c.b,c.m,C.ml,c.l]),P=new Uint16Array([c.r,c.R,C.rt,c.s,C.sw,C.sg,c.e,c.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,c.a,c.q,C.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),b=new Uint16Array([c.r,c.R,C.rt,c.s,C.sw,C.sg,c.e,c.E,c.f,C.fr,C.fa,C.fq,C.ft,C.fx,C.fv,C.fg,c.a,c.q,c.Q,C.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,C.hk,C.ho,C.hl,c.y,c.n,C.nj,C.np,C.nl,c.b,c.m,C.ml,c.l])}),define(ye[82],Se([1,0,29]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=void 0,e.$gm=A,e.$hm=L;const m=new r.$Dc(1e4);function A(c){return p(c,"NFC",m)}const R=new r.$Dc(1e4);function L(c){return p(c,"NFD",R)}const T=/[^\u0000-\u0080]/;function p(c,C,S){if(!c)return c;const d=S.get(c);if(d)return d;let P;return T.test(c)?P=c.normalize(C):P=c,S.set(c,P),P}e.$im=function(){const c=/[\u0300-\u036f]/g;return function(C){return L(C).replace(c,"")}}()}),define(ye[133],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=e.$Im=void 0,e.$Gm=r,e.rot=m;function r(T,p,c){return Math.min(Math.max(T,p),c)}function m(T,p){return(p+T%p)%p}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Im=A;class R{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jm=R;class L{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const c=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Km=L}),define(ye[177],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=R,e.$cd=d;class r{constructor(b,a,u){this.owner=b,this.debugNameSource=a,this.referenceFn=u}getDebugName(b){return R(b,this)}}e.$ad=r;const m=new Map,A=new WeakMap;function R(P,b){const a=A.get(P);if(a)return a;const u=L(P,b);if(u){let f=m.get(u)??0;f++,m.set(u,f);const g=f===1?u:`${u}#${f}`;return A.set(P,g),g}}function L(P,b){const a=A.get(P);if(a)return a;const u=b.owner?C(b.owner)+".":"";let f;const g=b.debugNameSource;if(g!==void 0)if(typeof g=="function"){if(f=g(),f!==void 0)return u+f}else return u+g;const n=b.referenceFn;if(n!==void 0&&(f=d(n),f!==void 0))return u+f;if(b.owner!==void 0){const s=T(b.owner,P);if(s!==void 0)return u+s}}function T(P,b){for(const a in P)if(P[a]===b)return a}const p=new Map,c=new WeakMap;function C(P){const b=c.get(P);if(b)return b;const a=S(P);let u=p.get(a)??0;u++,p.set(a,u);const f=u===1?a:`${a}#${u}`;return c.set(P,f),f}function S(P){const b=P.constructor;return b?b.name:"Object"}function d(P){const b=P.toString(),u=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(u?u[1]:void 0)?.trim()}}),define(ye[178],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=m,e.$Id=A;let r;function m(a){r=a}function A(){return r}class R{constructor(){this.a=0,this.d=new WeakMap}b(u){return L([T(P("|  ",this.a)),u])}c(u){return u.hadValue?u.didChange?[T(" "),c(C(u.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),c(C(u.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),c(C(u.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(u,f){console.log(...this.b([p("observable value changed"),c(u.debugName,{color:"BlueViolet"}),...this.c(f)]))}formatChanges(u){if(u.size!==0)return c(" (changed deps: "+[...u].map(f=>f.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(u){const f=u.handleChange;this.d.set(u,new Set),u.handleChange=(g,n)=>(this.d.get(u).add(g),f.apply(u,[g,n]))}handleDerivedRecomputed(u,f){const g=this.d.get(u);console.log(...this.b([p("derived recomputed"),c(u.debugName,{color:"BlueViolet"}),...this.c(f),this.formatChanges(g),{data:[{fn:u._computeFn}]}])),g.clear()}handleFromEventObservableTriggered(u,f){console.log(...this.b([p("observable from event triggered"),c(u.debugName,{color:"BlueViolet"}),...this.c(f),{data:[{fn:u._getValue}]}]))}handleAutorunCreated(u){const f=u.handleChange;this.d.set(u,new Set),u.handleChange=(g,n)=>(this.d.get(u).add(g),f.apply(u,[g,n]))}handleAutorunTriggered(u){const f=this.d.get(u);console.log(...this.b([p("autorun"),c(u.debugName,{color:"BlueViolet"}),this.formatChanges(f),{data:[{fn:u._runFn}]}])),f.clear(),this.a++}handleAutorunFinished(u){this.a--}handleBeginTransaction(u){let f=u.getDebugName();f===void 0&&(f=""),console.log(...this.b([p("transaction"),c(f,{color:"BlueViolet"}),{data:[{fn:u._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=R;function L(a){const u=new Array,f=[];let g="";function n(i){if("length"in i)for(const t of i)t&&n(t);else"text"in i?(g+=`%c${i.text}`,u.push(i.style),i.data&&f.push(...i.data)):"data"in i&&f.push(...i.data)}n(a);const s=[g,...u];return s.push(...f),s}function T(a){return c(a,{color:"black"})}function p(a){return c(b(`${a}: `,10),{color:"black",bold:!0})}function c(a,u={color:"black"}){function f(n){return Object.entries(n).reduce((s,[i,t])=>`${s}${i}:${t};`,"")}const g={color:u.color};return u.strikeThrough&&(g["text-decoration"]="line-through"),u.bold&&(g["font-weight"]="bold"),{text:a,style:f(g)}}function C(a,u){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=u?`"${a}"`:`"${a.substr(0,u-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?S(a,u):d(a,u);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function S(a,u){let f="[ ",g=!0;for(const n of a){if(g||(f+=", "),f.length-5>u){f+="...";break}g=!1,f+=`${C(n,u-f.length)}`}return f+=" ]",f}function d(a,u){let f="{ ",g=!0;for(const[n,s]of Object.entries(a)){if(g||(f+=", "),f.length-5>u){f+="...";break}g=!1,f+=`${n}: ${C(s,u-f.length)}`}return f+=" }",f}function P(a,u){let f="";for(let g=1;g<=u;g++)f+=a;return f}function b(a,u){for(;a.length<u;)a+=" ";return a}}),define(ye[179],Se([1,0,173,177,178]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=L,e.$Td=p,e.$Ud=C,e.$Xd=P,e.$Yd=a,e.$Zd=u,e.$1d=f,e.$3d=n,e.$4d=s,e.$6d=t;let R;function L(h){R=h}let T;function p(h){T=h}let c;function C(h){c=h}class S{get TChange(){return null}reportChanges(){this.get()}read(o){return o?o.readObservable(this):this.get()}map(o,$){const E=$===void 0?void 0:o,k=$===void 0?o:$;return c({owner:E,debugName:()=>{const D=(0,m.$cd)(k);if(D!==void 0)return D;const I=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(k.toString());if(I)return`${this.debugName}.${I[2]}`;if(!E)return`${this.debugName} (mapped)`},debugReferenceFn:k},D=>k(this.read(D),D))}recomputeInitiallyAndOnChange(o,$){return o.add(R(this,$)),this}keepObserved(o){return o.add(T(this)),this}get a(){return this.get()}}e.$Vd=S;class d extends S{constructor(){super(...arguments),this.b=new Set}addObserver(o){const $=this.b.size;this.b.add(o),$===0&&this.c()}removeObserver(o){this.b.delete(o)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=d;function P(h,o){const $=new g(h,o);try{h($)}finally{$.finish()}}let b;function a(h){if(b)h(b);else{const o=new g(h,void 0);b=o;try{h(o)}finally{o.finish(),b=void 0}}}async function u(h,o){const $=new g(h,o);try{await h($)}finally{$.finish()}}function f(h,o,$){h?o(h):P(o,$)}class g{constructor(o,$){this._fn=o,this.b=$,this.a=[],(0,A.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,m.$cd)(this._fn)}updateObserver(o,$){this.a.push({observer:o,observable:$}),o.beginUpdate($)}finish(){const o=this.a;for(let $=0;$<o.length;$++){const{observer:E,observable:k}=o[$];E.endUpdate(k)}this.a=null,(0,A.$Id)()?.handleEndTransaction()}}e.$2d=g;function n(h,o){let $;return typeof h=="string"?$=new m.$ad(void 0,h,void 0):$=new m.$ad(h,void 0,void 0),new i($,o,r.$6c)}function s(h,o){return new i(new m.$ad(h.owner,h.debugName,void 0),o,h.equalsFn??r.$6c)}class i extends d{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(o,$,E){super(),this.e=o,this.g=E,this.d=$}get(){return this.d}set(o,$,E){if(E===void 0&&this.g(this.d,o))return;let k;$||($=k=new g(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(o),(0,A.$Id)()?.handleObservableChanged(this,{oldValue:D,newValue:o,change:E,didChange:!0,hadValue:!0});for(const v of this.b)$.updateObserver(v,this),v.handleChange(this,E)}finally{k&&k.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(o){this.d=o}}e.$5d=i;function t(h,o){let $;return typeof h=="string"?$=new m.$ad(void 0,h,void 0):$=new m.$ad(h,void 0,void 0),new l($,o,r.$6c)}class l extends i{h(o){this.d!==o&&(this.d&&this.d.dispose(),this.d=o)}dispose(){this.d?.dispose()}}e.$7d=l}),function(){function de(A){const R=[];typeof A=="number"&&R.push("code/timeOrigin",A);function L(p){R.push(p,Date.now())}function T(){const p=[];for(let c=0;c<R.length;c+=2)p.push({name:R[c],startTime:R[c+1]});return p}return{mark:L,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?de():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(A+L.startTime)});return R}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return de(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),de()}function r(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var m;typeof global=="object"?m=global:typeof self=="object"?m=self:m={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(m)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(m):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),m.perf=r(m))}(),define(ye[180],Se([1,0,40]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=void 0;const m=Symbol("unset");class A{constructor(){this.a=new L,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}insert(p,c,C){this.d(p,S=>S._value=c,C)}mutate(p,c){this.d(p,C=>C._value=c(C._value===m?void 0:C._value))}mutatePath(p,c){this.d(p,()=>{},C=>c(C))}delete(p){const c=this.c(p);if(!c)return;let C=c.length-1;const S=c[C].node._value;if(S!==m){for(this.b--,c[C].node._value=m;C>0;C--){const{node:d,part:P}=c[C];if(d.children?.size||d._value!==m)break;c[C-1].node.children.delete(P)}return S}}*deleteRecursive(p){const c=this.c(p);if(!c)return;const C=c[c.length-1].node;for(let S=c.length-1;S>0;S--){const d=c[S-1];if(d.node.children.delete(c[S].part),d.node.children.size>0||d.node._value!==m)break}for(const S of R(C))S._value!==m&&(this.b--,yield S._value)}find(p){let c=this.a;for(const C of p){const S=c.children?.get(C);if(!S)return;c=S}return c._value===m?void 0:c._value}hasKeyOrParent(p){let c=this.a;for(const C of p){const S=c.children?.get(C);if(!S)return!1;if(S._value!==m)return!0;c=S}return!1}hasKeyOrChildren(p){let c=this.a;for(const C of p){const S=c.children?.get(C);if(!S)return!1;c=S}return!0}hasKey(p){let c=this.a;for(const C of p){const S=c.children?.get(C);if(!S)return!1;c=S}return c._value!==m}c(p){const c=[{part:"",node:this.a}];let C=0;for(const S of p){const d=c[C].node.children?.get(S);if(!d)return;c.push({part:S,node:d}),C++}return c}d(p,c,C){let S=this.a;for(const b of p){if(S.children)if(S.children.has(b))S=S.children.get(b);else{const a=new L;S.children.set(b,a),S=a}else{const a=new L;S.children=new Map([[b,a]]),S=a}C?.(S)}const d=S._value===m?0:1;c(S);const P=S._value===m?0:1;this.b+=P-d}*values(){for(const{_value:p}of R(this.a))p!==m&&(yield p)}}e.$NO=A;function*R(T){const p=[T];for(;p.length>0;){const c=p.pop();if(yield c,c.children)for(const C of c.children.values())p.push(C)}}class L{constructor(){this._value=m}get value(){return this._value===m?void 0:this._value}set value(p){this._value=p===void 0?m:p}}}),function(de,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var m in r)(typeof exports=="object"?exports:de)[m]=r[m]}}(typeof self<"u"?self:this,function(){return function(de){var e={};function r(m){if(e[m])return e[m].exports;var A=e[m]={i:m,l:!1,exports:{}};return de[m].call(A.exports,A,A.exports,r),A.l=!0,A.exports}return r.m=de,r.c=e,r.d=function(m,A,R){r.o(m,A)||Object.defineProperty(m,A,{enumerable:!0,get:R})},r.r=function(m){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(m,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(m,"__esModule",{value:!0})},r.t=function(m,A){if(1&A&&(m=r(m)),8&A||4&A&&typeof m=="object"&&m&&m.__esModule)return m;var R=Object.create(null);if(r.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:m}),2&A&&typeof m!="string")for(var L in m)r.d(R,L,function(T){return m[T]}.bind(null,L));return R},r.n=function(m){var A=m&&m.__esModule?function(){return m.default}:function(){return m};return r.d(A,"a",A),A},r.o=function(m,A){return Object.prototype.hasOwnProperty.call(m,A)},r.p="",r(r.s=0)}([function(de,e,r){(function(m){var A;e=de.exports=ve,A=typeof m=="object"&&m.env&&m.env.NODE_DEBUG&&/\bsemver\b/i.test(m.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],p=e.src=[],c=0,C=c++;p[C]="0|[1-9]\\d*";var S=c++;p[S]="[0-9]+";var d=c++;p[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;p[P]="("+p[C]+")\\.("+p[C]+")\\.("+p[C]+")";var b=c++;p[b]="("+p[S]+")\\.("+p[S]+")\\.("+p[S]+")";var a=c++;p[a]="(?:"+p[C]+"|"+p[d]+")";var u=c++;p[u]="(?:"+p[S]+"|"+p[d]+")";var f=c++;p[f]="(?:-("+p[a]+"(?:\\."+p[a]+")*))";var g=c++;p[g]="(?:-?("+p[u]+"(?:\\."+p[u]+")*))";var n=c++;p[n]="[0-9A-Za-z-]+";var s=c++;p[s]="(?:\\+("+p[n]+"(?:\\."+p[n]+")*))";var i=c++,t="v?"+p[P]+p[f]+"?"+p[s]+"?";p[i]="^"+t+"$";var l="[v=\\s]*"+p[b]+p[g]+"?"+p[s]+"?",h=c++;p[h]="^"+l+"$";var o=c++;p[o]="((?:<|>)?=?)";var $=c++;p[$]=p[S]+"|x|X|\\*";var E=c++;p[E]=p[C]+"|x|X|\\*";var k=c++;p[k]="[v=\\s]*("+p[E]+")(?:\\.("+p[E]+")(?:\\.("+p[E]+")(?:"+p[f]+")?"+p[s]+"?)?)?";var D=c++;p[D]="[v=\\s]*("+p[$]+")(?:\\.("+p[$]+")(?:\\.("+p[$]+")(?:"+p[g]+")?"+p[s]+"?)?)?";var v=c++;p[v]="^"+p[o]+"\\s*"+p[k]+"$";var I=c++;p[I]="^"+p[o]+"\\s*"+p[D]+"$";var w=c++;p[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var y=c++;p[y]="(?:~>?)";var N=c++;p[N]="(\\s*)"+p[y]+"\\s+",T[N]=new RegExp(p[N],"g");var O=c++;p[O]="^"+p[y]+p[k]+"$";var U=c++;p[U]="^"+p[y]+p[D]+"$";var j=c++;p[j]="(?:\\^)";var z=c++;p[z]="(\\s*)"+p[j]+"\\s+",T[z]=new RegExp(p[z],"g");var M=c++;p[M]="^"+p[j]+p[k]+"$";var F=c++;p[F]="^"+p[j]+p[D]+"$";var J=c++;p[J]="^"+p[o]+"\\s*("+l+")$|^$";var ee=c++;p[ee]="^"+p[o]+"\\s*("+t+")$|^$";var V=c++;p[V]="(\\s*)"+p[o]+"\\s*("+l+"|"+p[k]+")",T[V]=new RegExp(p[V],"g");var H=c++;p[H]="^\\s*("+p[k]+")\\s+-\\s+("+p[k]+")\\s*$";var _=c++;p[_]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var ne=c++;p[ne]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)A(he,p[he]),T[he]||(T[he]=new RegExp(p[he]));function re(q,Y){if(q instanceof ve)return q;if(typeof q!="string"||q.length>R||!(Y?T[h]:T[i]).test(q))return null;try{return new ve(q,Y)}catch{return null}}function ve(q,Y){if(q instanceof ve){if(q.loose===Y)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ve))return new ve(q,Y);A("SemVer",q,Y),this.loose=Y;var x=q.trim().match(Y?T[h]:T[i]);if(!x)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<L)return we}return fe}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=re,e.valid=function(q,Y){var x=re(q,Y);return x?x.version:null},e.clean=function(q,Y){var x=re(q.trim().replace(/^[=v]+/,""),Y);return x?x.version:null},e.SemVer=ve,ve.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ve.prototype.toString=function(){return this.version},ve.prototype.compare=function(q){return A("SemVer.compare",this.version,this.loose,q),q instanceof ve||(q=new ve(q,this.loose)),this.compareMain(q)||this.comparePre(q)},ve.prototype.compareMain=function(q){return q instanceof ve||(q=new ve(q,this.loose)),Q(this.major,q.major)||Q(this.minor,q.minor)||Q(this.patch,q.patch)},ve.prototype.comparePre=function(q){if(q instanceof ve||(q=new ve(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Y=0;do{var x=this.prerelease[Y],fe=q.prerelease[Y];if(A("prerelease compare",Y,x,fe),x===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(x===void 0)return-1;if(x!==fe)return Q(x,fe)}while(++Y)},ve.prototype.inc=function(q,Y){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Y,x,fe){typeof x=="string"&&(fe=x,x=void 0);try{return new ve(q,x).inc(Y,fe).version}catch{return null}},e.diff=function(q,Y){if(ie(q,Y))return null;var x=re(q),fe=re(Y);if(x.prerelease.length||fe.prerelease.length){for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return we},e.compareIdentifiers=Q;var pe=/^[0-9]+$/;function Q(q,Y){var x=pe.test(q),fe=pe.test(Y);return x&&fe&&(q=+q,Y=+Y),x&&!fe?-1:fe&&!x?1:q<Y?-1:q>Y?1:0}function B(q,Y,x){return new ve(q,x).compare(new ve(Y,x))}function se(q,Y,x){return B(q,Y,x)>0}function ae(q,Y,x){return B(q,Y,x)<0}function ie(q,Y,x){return B(q,Y,x)===0}function ce(q,Y,x){return B(q,Y,x)!==0}function ue(q,Y,x){return B(q,Y,x)>=0}function Z(q,Y,x){return B(q,Y,x)<=0}function oe(q,Y,x,fe){var we;switch(Y){case"===":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),we=q===x;break;case"!==":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),we=q!==x;break;case"":case"=":case"==":we=ie(q,x,fe);break;case"!=":we=ce(q,x,fe);break;case">":we=se(q,x,fe);break;case">=":we=ue(q,x,fe);break;case"<":we=ae(q,x,fe);break;case"<=":we=Z(q,x,fe);break;default:throw new TypeError("Invalid operator: "+Y)}return we}function $e(q,Y){if(q instanceof $e){if(q.loose===Y)return q;q=q.value}if(!(this instanceof $e))return new $e(q,Y);A("comparator",q,Y),this.loose=Y,this.parse(q),this.semver===be?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(q,Y){return Q(Y,q)},e.major=function(q,Y){return new ve(q,Y).major},e.minor=function(q,Y){return new ve(q,Y).minor},e.patch=function(q,Y){return new ve(q,Y).patch},e.compare=B,e.compareLoose=function(q,Y){return B(q,Y,!0)},e.rcompare=function(q,Y,x){return B(Y,q,x)},e.sort=function(q,Y){return q.sort(function(x,fe){return e.compare(x,fe,Y)})},e.rsort=function(q,Y){return q.sort(function(x,fe){return e.rcompare(x,fe,Y)})},e.gt=se,e.lt=ae,e.eq=ie,e.neq=ce,e.gte=ue,e.lte=Z,e.cmp=oe,e.Comparator=$e;var be={};function Ne(q,Y){if(q instanceof Ne)return q.loose===Y?q:new Ne(q.raw,Y);if(q instanceof $e)return new Ne(q.value,Y);if(!(this instanceof Ne))return new Ne(q,Y);if(this.loose=Y,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Be(q){return!q||q.toLowerCase()==="x"||q==="*"}function De(q,Y,x,fe,we,Me,qe,He,Ze,it,tt,rt,ot){return((Y=Be(x)?"":Be(fe)?">="+x+".0.0":Be(we)?">="+x+"."+fe+".0":">="+Y)+" "+(He=Be(Ze)?"":Be(it)?"<"+(+Ze+1)+".0.0":Be(tt)?"<"+Ze+"."+(+it+1)+".0":rt?"<="+Ze+"."+it+"."+tt+"-"+rt:"<="+He)).trim()}function Ie(q,Y){for(var x=0;x<q.length;x++)if(!q[x].test(Y))return!1;if(Y.prerelease.length){for(x=0;x<q.length;x++)if(A(q[x].semver),q[x].semver!==be&&q[x].semver.prerelease.length>0){var fe=q[x].semver;if(fe.major===Y.major&&fe.minor===Y.minor&&fe.patch===Y.patch)return!0}return!1}return!0}function Le(q,Y,x){try{Y=new Ne(Y,x)}catch{return!1}return Y.test(q)}function W(q,Y,x,fe){var we,Me,qe,He,Ze;switch(q=new ve(q,fe),Y=new Ne(Y,fe),x){case">":we=se,Me=Z,qe=ae,He=">",Ze=">=";break;case"<":we=ae,Me=ue,qe=se,He="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(q,Y,fe))return!1;for(var it=0;it<Y.set.length;++it){var tt=Y.set[it],rt=null,ot=null;if(tt.forEach(function(ft){ft.semver===be&&(ft=new $e(">=0.0.0")),rt=rt||ft,ot=ot||ft,we(ft.semver,rt.semver,fe)?rt=ft:qe(ft.semver,ot.semver,fe)&&(ot=ft)}),rt.operator===He||rt.operator===Ze||(!ot.operator||ot.operator===He)&&Me(q,ot.semver)||ot.operator===Ze&&qe(q,ot.semver))return!1}return!0}$e.prototype.parse=function(q){var Y=this.loose?T[J]:T[ee],x=q.match(Y);if(!x)throw new TypeError("Invalid comparator: "+q);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new ve(x[2],this.loose):this.semver=be},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(q){return A("Comparator.test",q,this.loose),this.semver===be||(typeof q=="string"&&(q=new ve(q,this.loose)),oe(q,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(q,Y){if(!(q instanceof $e))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Ne(q.value,Y),Le(this.value,x,Y);if(q.operator==="")return x=new Ne(this.value,Y),Le(q.semver,x,Y);var fe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Me=this.semver.version===q.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),He=oe(this.semver,"<",q.semver,Y)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ze=oe(this.semver,">",q.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return fe||we||Me&&qe||He||Ze},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(q){var Y=this.loose;q=q.trim(),A("range",q,Y);var x=Y?T[_]:T[H];q=q.replace(x,De),A("hyphen replace",q),q=q.replace(T[V],"$1$2$3"),A("comparator trim",q,T[V]),q=(q=(q=q.replace(T[N],"$1~")).replace(T[z],"$1^")).split(/\s+/).join(" ");var fe=Y?T[J]:T[ee],we=q.split(" ").map(function(Me){return function(qe,He){return A("comp",qe),qe=function(Ze,it){return Ze.trim().split(/\s+/).map(function(tt){return function(rt,ot){A("caret",rt,ot);var ft=ot?T[F]:T[M];return rt.replace(ft,function(ut,st,Pe,Ue,Ae){var Te;return A("caret",rt,ut,st,Pe,Ue,Ae),Be(st)?Te="":Be(Pe)?Te=">="+st+".0.0 <"+(+st+1)+".0.0":Be(Ue)?Te=st==="0"?">="+st+"."+Pe+".0 <"+st+"."+(+Pe+1)+".0":">="+st+"."+Pe+".0 <"+(+st+1)+".0.0":Ae?(A("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=st==="0"?Pe==="0"?">="+st+"."+Pe+"."+Ue+Ae+" <"+st+"."+Pe+"."+(+Ue+1):">="+st+"."+Pe+"."+Ue+Ae+" <"+st+"."+(+Pe+1)+".0":">="+st+"."+Pe+"."+Ue+Ae+" <"+(+st+1)+".0.0"):(A("no pr"),Te=st==="0"?Pe==="0"?">="+st+"."+Pe+"."+Ue+" <"+st+"."+Pe+"."+(+Ue+1):">="+st+"."+Pe+"."+Ue+" <"+st+"."+(+Pe+1)+".0":">="+st+"."+Pe+"."+Ue+" <"+(+st+1)+".0.0"),A("caret return",Te),Te})}(tt,it)}).join(" ")}(qe,He),A("caret",qe),qe=function(Ze,it){return Ze.trim().split(/\s+/).map(function(tt){return function(rt,ot){var ft=ot?T[U]:T[O];return rt.replace(ft,function(ut,st,Pe,Ue,Ae){var Te;return A("tilde",rt,ut,st,Pe,Ue,Ae),Be(st)?Te="":Be(Pe)?Te=">="+st+".0.0 <"+(+st+1)+".0.0":Be(Ue)?Te=">="+st+"."+Pe+".0 <"+st+"."+(+Pe+1)+".0":Ae?(A("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=">="+st+"."+Pe+"."+Ue+Ae+" <"+st+"."+(+Pe+1)+".0"):Te=">="+st+"."+Pe+"."+Ue+" <"+st+"."+(+Pe+1)+".0",A("tilde return",Te),Te})}(tt,it)}).join(" ")}(qe,He),A("tildes",qe),qe=function(Ze,it){return A("replaceXRanges",Ze,it),Ze.split(/\s+/).map(function(tt){return function(rt,ot){rt=rt.trim();var ft=ot?T[I]:T[v];return rt.replace(ft,function(ut,st,Pe,Ue,Ae,Te){A("xRange",rt,ut,st,Pe,Ue,Ae,Te);var le=Be(Pe),X=le||Be(Ue),Ce=X||Be(Ae);return st==="="&&Ce&&(st=""),le?ut=st===">"||st==="<"?"<0.0.0":"*":st&&Ce?(X&&(Ue=0),Ce&&(Ae=0),st===">"?(st=">=",X?(Pe=+Pe+1,Ue=0,Ae=0):Ce&&(Ue=+Ue+1,Ae=0)):st==="<="&&(st="<",X?Pe=+Pe+1:Ue=+Ue+1),ut=st+Pe+"."+Ue+"."+Ae):X?ut=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ce&&(ut=">="+Pe+"."+Ue+".0 <"+Pe+"."+(+Ue+1)+".0"),A("xRange return",ut),ut})}(tt,it)}).join(" ")}(qe,He),A("xrange",qe),qe=function(Ze,it){return A("replaceStars",Ze,it),Ze.trim().replace(T[ne],"")}(qe,He),A("stars",qe),qe}(Me,Y)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Me){return!!Me.match(fe)})),we=we.map(function(Me){return new $e(Me,Y)})},Ne.prototype.intersects=function(q,Y){if(!(q instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(fe){return q.set.some(function(we){return we.every(function(Me){return fe.intersects(Me,Y)})})})})},e.toComparators=function(q,Y){return new Ne(q,Y).set.map(function(x){return x.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new ve(q,this.loose));for(var Y=0;Y<this.set.length;Y++)if(Ie(this.set[Y],q))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(q,Y,x){var fe=null,we=null;try{var Me=new Ne(Y,x)}catch{return null}return q.forEach(function(qe){Me.test(qe)&&(fe&&we.compare(qe)!==-1||(we=new ve(fe=qe,x)))}),fe},e.minSatisfying=function(q,Y,x){var fe=null,we=null;try{var Me=new Ne(Y,x)}catch{return null}return q.forEach(function(qe){Me.test(qe)&&(fe&&we.compare(qe)!==1||(we=new ve(fe=qe,x)))}),fe},e.validRange=function(q,Y){try{return new Ne(q,Y).range||"*"}catch{return null}},e.ltr=function(q,Y,x){return W(q,Y,"<",x)},e.gtr=function(q,Y,x){return W(q,Y,">",x)},e.outside=W,e.prerelease=function(q,Y){var x=re(q,Y);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(q,Y,x){return q=new Ne(q,x),Y=new Ne(Y,x),q.intersects(Y)},e.coerce=function(q){if(q instanceof ve)return q;if(typeof q!="string")return null;var Y=q.match(T[w]);return Y==null?null:re((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,r(1))},function(de,e){var r,m,A=de.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function T(u){if(r===setTimeout)return setTimeout(u,0);if((r===R||!r)&&setTimeout)return r=setTimeout,setTimeout(u,0);try{return r(u,0)}catch{try{return r.call(null,u,0)}catch{return r.call(this,u,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:R}catch{r=R}try{m=typeof clearTimeout=="function"?clearTimeout:L}catch{m=L}})();var p,c=[],C=!1,S=-1;function d(){C&&p&&(C=!1,p.length?c=p.concat(c):S=-1,c.length&&P())}function P(){if(!C){var u=T(d);C=!0;for(var f=c.length;f;){for(p=c,c=[];++S<f;)p&&p[S].run();S=-1,f=c.length}p=null,C=!1,function(g){if(m===clearTimeout)return clearTimeout(g);if((m===L||!m)&&clearTimeout)return m=clearTimeout,clearTimeout(g);try{m(g)}catch{try{return m.call(null,g)}catch{return m.call(this,g)}}}(u)}}function b(u,f){this.fun=u,this.array=f}function a(){}A.nextTick=function(u){var f=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)f[g-1]=arguments[g];c.push(new b(u,f)),c.length!==1||C||T(P)},b.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=a,A.addListener=a,A.once=a,A.off=a,A.removeListener=a,A.removeAllListeners=a,A.emit=a,A.prependListener=a,A.prependOnceListener=a,A.listeners=function(u){return[]},A.binding=function(u){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(u){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(ye[42],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class m{static create(R){return new m(R)}constructor(R){this.c=r&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=m}),define(ye[4],Se([1,0,14,80,3,81,42]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=P;const T=!1,p=!1,c=!1;var C;(function(U){U.None=()=>A.$Uc.None;function j(De){if(c){const{onDidAddListener:Ie}=De,Le=a.create();let W=0;De.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Le.print()),Ie?.()}}}function z(De,Ie){return re(De,()=>{},0,void 0,!0,void 0,Ie)}U.defer=z;function M(De){return(Ie,Le=null,W)=>{let q=!1,Y;return Y=De(x=>{if(!q)return Y?Y.dispose():q=!0,Ie.call(Le,x)},null,W),q&&Y.dispose(),Y}}U.once=M;function F(De,Ie,Le){return ne((W,q=null,Y)=>De(x=>W.call(q,Ie(x)),null,Y),Le)}U.map=F;function J(De,Ie,Le){return ne((W,q=null,Y)=>De(x=>{Ie(x),W.call(q,x)},null,Y),Le)}U.forEach=J;function ee(De,Ie,Le){return ne((W,q=null,Y)=>De(x=>Ie(x)&&W.call(q,x),null,Y),Le)}U.filter=ee;function V(De){return De}U.signal=V;function H(...De){return(Ie,Le=null,W)=>{const q=(0,A.$Rc)(...De.map(Y=>Y(x=>Ie.call(Le,x))));return he(q,W)}}U.any=H;function _(De,Ie,Le,W){let q=Le;return F(De,Y=>(q=Ie(q,Y),q),W)}U.reduce=_;function ne(De,Ie){let Le;const W={onWillAddFirstListener(){Le=De(q.fire,q)},onDidRemoveLastListener(){Le?.dispose()}};Ie||j(W);const q=new l(W);return Ie?.add(q),q.event}function he(De,Ie){return Ie instanceof Array?Ie.push(De):Ie&&Ie.add(De),De}function re(De,Ie,Le=100,W=!1,q=!1,Y,x){let fe,we,Me,qe=0,He;const Ze={leakWarningThreshold:Y,onWillAddFirstListener(){fe=De(tt=>{qe++,we=Ie(we,tt),W&&!Me&&(it.fire(we),we=void 0),He=()=>{const rt=we;we=void 0,Me=void 0,(!W||qe>1)&&it.fire(rt),qe=0},typeof Le=="number"?(clearTimeout(Me),Me=setTimeout(He,Le)):Me===void 0&&(Me=0,queueMicrotask(He))})},onWillRemoveListener(){q&&qe>0&&He?.()},onDidRemoveLastListener(){He=void 0,fe.dispose()}};x||j(Ze);const it=new l(Ze);return x?.add(it),it.event}U.debounce=re;function ve(De,Ie=0,Le){return U.debounce(De,(W,q)=>W?(W.push(q),W):[q],Ie,void 0,!0,void 0,Le)}U.accumulate=ve;function pe(De,Ie=(W,q)=>W===q,Le){let W=!0,q;return ee(De,Y=>{const x=W||!Ie(Y,q);return W=!1,q=Y,x},Le)}U.latch=pe;function Q(De,Ie,Le){return[U.filter(De,Ie,Le),U.filter(De,W=>!Ie(W),Le)]}U.split=Q;function B(De,Ie=!1,Le=[],W){let q=Le.slice(),Y=De(we=>{q?q.push(we):fe.fire(we)});W&&W.add(Y);const x=()=>{q?.forEach(we=>fe.fire(we)),q=null},fe=new l({onWillAddFirstListener(){Y||(Y=De(we=>fe.fire(we)),W&&W.add(Y))},onDidAddFirstListener(){q&&(Ie?setTimeout(x):x())},onDidRemoveLastListener(){Y&&Y.dispose(),Y=null}});return W&&W.add(fe),fe.event}U.buffer=B;function se(De,Ie){return(W,q,Y)=>{const x=Ie(new ie);return De(function(fe){const we=x.evaluate(fe);we!==ae&&W.call(q,we)},void 0,Y)}}U.chain=se;const ae=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(Ie){return this.f.push(Ie),this}forEach(Ie){return this.f.push(Le=>(Ie(Le),Le)),this}filter(Ie){return this.f.push(Le=>Ie(Le)?Le:ae),this}reduce(Ie,Le){let W=Le;return this.f.push(q=>(W=Ie(W,q),W)),this}latch(Ie=(Le,W)=>Le===W){let Le=!0,W;return this.f.push(q=>{const Y=Le||!Ie(q,W);return Le=!1,W=q,Y?q:ae}),this}evaluate(Ie){for(const Le of this.f)if(Ie=Le(Ie),Ie===ae)break;return Ie}}function ce(De,Ie,Le=W=>W){const W=(...fe)=>x.fire(Le(...fe)),q=()=>De.on(Ie,W),Y=()=>De.removeListener(Ie,W),x=new l({onWillAddFirstListener:q,onDidRemoveLastListener:Y});return x.event}U.fromNodeEventEmitter=ce;function ue(De,Ie,Le=W=>W){const W=(...fe)=>x.fire(Le(...fe)),q=()=>De.addEventListener(Ie,W),Y=()=>De.removeEventListener(Ie,W),x=new l({onWillAddFirstListener:q,onDidRemoveLastListener:Y});return x.event}U.fromDOMEventEmitter=ue;function Z(De){return new Promise(Ie=>M(De)(Ie))}U.toPromise=Z;function oe(De){const Ie=new l;return De.then(Le=>{Ie.fire(Le)},()=>{Ie.fire(void 0)}).finally(()=>{Ie.dispose()}),Ie.event}U.fromPromise=oe;function $e(De,Ie,Le){return Ie(Le),De(W=>Ie(W))}U.runAndSubscribe=$e;class be{constructor(Ie,Le){this._observable=Ie,this.f=0,this.g=!1;const W={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Le||j(W),this.emitter=new l(W),Le&&Le.add(this.emitter)}beginUpdate(Ie){this.f++}handlePossibleChange(Ie){}handleChange(Ie,Le){this.g=!0}endUpdate(Ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ne(De,Ie){return new be(De,Ie).emitter.event}U.fromObservable=Ne;function Be(De){return(Ie,Le,W)=>{let q=0,Y=!1;const x={beginUpdate(){q++},endUpdate(){q--,q===0&&(De.reportChanges(),Y&&(Y=!1,Ie.call(Le)))},handlePossibleChange(){},handleChange(){Y=!0}};De.addObserver(x),De.reportChanges();const fe={dispose(){De.removeObserver(x)}};return W instanceof A.$Tc?W.add(fe):Array.isArray(W)&&W.push(fe),fe}}U.fromObservableLight=Be})(C||(e.Event=C={}));class S{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${S.f++}`,S.all.add(this)}start(j){this.g=new L.$be,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$de=S;let d=-1;function P(U){const j=d;return d=U,{dispose(){d=j}}}class b{constructor(j,z,M=Math.random().toString(18).slice(2,5)){this.h=j,this.threshold=z,this.name=M,this.g=0}dispose(){this.f?.clear()}check(j,z){const M=this.threshold;if(M<=0||z<M)return;this.f||(this.f=new Map);const F=this.f.get(j.value)||0;if(this.f.set(j.value,F+1),this.g-=1,this.g<=0){this.g=M*.5;const[J,ee]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${ee}):`;console.warn(V),console.warn(J);const H=new u(V,J);this.h(H)}return()=>{const J=this.f.get(j.value)||0;this.f.set(j.value,J-1)}}getMostFrequentStack(){if(!this.f)return;let j,z=0;for(const[M,F]of this.f)(!j||z<F)&&(j=[M,F],z=F);return j}}class a{static create(){const j=new Error;return new a(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u extends Error{constructor(j,z){super(j),this.name="ListenerLeakError",this.stack=z}}e.$fe=u;class f extends Error{constructor(j,z){super(j),this.name="ListenerRefusalError",this.stack=z}}e.$ge=f;let g=0;class n{constructor(j){this.value=j,this.id=g++}}const s=2,i=(U,j)=>{if(U instanceof n)j(U);else for(let z=0;z<U.length;z++){const M=U[z];M&&j(M)}},t=T?new FinalizationRegistry(U=>{typeof U=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(U))}):void 0;class l{constructor(j){this.w=0,this.f=j,this.g=d>0||this.f?.leakWarningThreshold?new b(j?.onListenerError??r.$1,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new S(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(p){const j=this.t;queueMicrotask(()=>{i(j,z=>z.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,z,M)=>{if(this.g&&this.w>this.g.threshold**2){const H=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(H);const _=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new f(`${H}. HINT: Stack shows most frequent listener (${_[1]}-times)`,_[0]);return(this.f?.onListenerError||r.$1)(ne),A.$Uc.None}if(this.m)return A.$Uc.None;z&&(j=j.bind(z));const F=new n(j);let J,ee;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=a.create(),J=this.g.check(F.stack,this.w+1)),p&&(F.stack=ee??a.create()),this.t?this.t instanceof n?(this.u??=new o,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const V=(0,A.$Sc)(()=>{t?.unregister(V),J?.(),this.x(F)});if(M instanceof A.$Tc?M.add(V):Array.isArray(M)&&M.push(V),t){const H=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(V,H,V)}return V},this.q}x(j){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const z=this.t,M=z.indexOf(j);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,z[M]=void 0;const F=this.u.current===this;if(this.w*s<=z.length){let J=0;for(let ee=0;ee<z.length;ee++)z[ee]?z[J++]=z[ee]:F&&(this.u.end--,J<this.u.i&&this.u.i--);z.length=J}}y(j,z){if(!j)return;const M=this.f?.onListenerError||r.$1;if(!M){j.value(z);return}try{j.value(z)}catch(F){M(F)}}z(j){const z=j.current.t;for(;j.i<j.end;)this.y(z[j.i++],j.value);j.reset()}fire(j){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof n)this.y(this.t,j);else{const z=this.u;z.enqueue(this,j,this.t.length),this.z(z)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=l;const h=()=>new o;e.$ie=h;class o{constructor(){this.i=-1,this.end=0}enqueue(j,z,M){this.i=0,this.end=M,this.current=j,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class $ extends l{async fireAsync(j,z,M){if(this.t)for(this.h||(this.h=new R.$5c),i(this.t,F=>this.h.push([F.value,j]));this.h.size>0&&!z.isCancellationRequested;){const[F,J]=this.h.shift(),ee=[],V={...J,token:z,waitUntil:H=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");M&&(H=M(H,F)),ee.push(H)}};try{F(V)}catch(H){(0,r.$1)(H);continue}Object.freeze(ee),await Promise.allSettled(ee).then(H=>{for(const _ of H)_.status==="rejected"&&(0,r.$1)(_.reason)})}}}e.$je=$;class E extends l{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new R.$5c,this.A=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.A(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.w&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$ke=E;class k extends E{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$le=k;class D extends l{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}e.$me=D;class v{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const z={event:j,listener:null};this.h.push(z),this.g&&this.m(z);const M=()=>{this.g&&this.o(z);const F=this.h.indexOf(z);this.h.splice(F,1)};return(0,A.$Sc)((0,m.$db)(M))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(z=>this.f.fire(z))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$ne=v;class I{constructor(j,z,M,F){this.f=new A.$Tc;const J=this.f.add(new v),ee=this.f.add(new A.$4c);function V(H){ee.set(H,J.add(F(H)))}for(const H of j)V(H);this.f.add(z(H=>{V(H)})),this.f.add(M(H=>{ee.deleteAndDispose(H)})),this.event=J.event}dispose(){this.f.dispose()}}e.$oe=I;class w{constructor(){this.f=[]}wrapEvent(j,z,M){return(F,J,ee)=>j(V=>{const H=this.f[this.f.length-1];if(!z){H?H.buffers.push(()=>F.call(J,V)):F.call(J,V);return}const _=H;if(!_){F.call(J,z(M,V));return}_.items??=[],_.items.push(V),_.buffers.length===0&&H.buffers.push(()=>{_.reducedResult??=M?_.items.reduce(z,M):_.items.reduce(z),F.call(J,_.reducedResult)})},void 0,ee)}bufferEvents(j){const z={buffers:new Array};this.f.push(z);const M=j();return this.f.pop(),z.buffers.forEach(F=>F()),M}}e.$pe=w;class y{constructor(){this.f=!1,this.g=C.None,this.h=A.$Uc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=y;class N{static const(j){return new O(j)}constructor(j){this.g=j,this.f=new l,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$re=N;class O{constructor(j){this.value=j,this.onDidChange=C.None}}}),define(ye[21],Se([1,0,4]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=T;const m=Object.freeze(function(p,c){const C=setTimeout(p.bind(c),0);return{dispose(){clearTimeout(C)}}});var A;(function(p){function c(C){return C===p.None||C===p.Cancelled||C instanceof R?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}p.isCancellationToken=c,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:m})})(A||(e.CancellationToken=A={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?m:(this.b||(this.b=new r.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=A.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=A.None}}e.$se=L;function T(p){const c=new L;return p.add({dispose(){c.cancel()}}),c.token}}),define(ye[181],Se([1,0,21]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=A;class m{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new r.$se,c=this.b(p.token);return this.a={promise:c,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$5e=m;function A(T){return T}class R{constructor(p,c){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=A):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);return this.b!==c&&(this.b=c,this.a=this.c(p)),this.a}}e.$7e=R;class L{get cachedValues(){return this.a}constructor(p,c){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=A):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);if(this.b.has(c))return this.b.get(c);const C=this.c(p);return this.a.set(p,C),this.b.set(c,C),C}}e.$8e=L}),define(ye[182],Se([1,0,4,3]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iu=e.$hu=e.$gu=e.$fu=e.ScrollbarVisibility=void 0;var A;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(A||(e.ScrollbarVisibility=A={}));class R{constructor(b,a,u,f,g,n,s){this.c=b,this._scrollStateBrand=void 0,this.c&&(a=a|0,u=u|0,f=f|0,g=g|0,n=n|0,s=s|0),this.rawScrollLeft=f,this.rawScrollTop=s,a<0&&(a=0),f+a>u&&(f=u-a),f<0&&(f=0),g<0&&(g=0),s+g>n&&(s=n-g),s<0&&(s=0),this.width=a,this.scrollWidth=u,this.scrollLeft=f,this.height=g,this.scrollHeight=n,this.scrollTop=s}equals(b){return this.rawScrollLeft===b.rawScrollLeft&&this.rawScrollTop===b.rawScrollTop&&this.width===b.width&&this.scrollWidth===b.scrollWidth&&this.scrollLeft===b.scrollLeft&&this.height===b.height&&this.scrollHeight===b.scrollHeight&&this.scrollTop===b.scrollTop}withScrollDimensions(b,a){return new R(this.c,typeof b.width<"u"?b.width:this.width,typeof b.scrollWidth<"u"?b.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof b.height<"u"?b.height:this.height,typeof b.scrollHeight<"u"?b.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(b){return new R(this.c,this.width,this.scrollWidth,typeof b.scrollLeft<"u"?b.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof b.scrollTop<"u"?b.scrollTop:this.rawScrollTop)}createScrollEvent(b,a){const u=this.width!==b.width,f=this.scrollWidth!==b.scrollWidth,g=this.scrollLeft!==b.scrollLeft,n=this.height!==b.height,s=this.scrollHeight!==b.scrollHeight,i=this.scrollTop!==b.scrollTop;return{inSmoothScrolling:a,oldWidth:b.width,oldScrollWidth:b.scrollWidth,oldScrollLeft:b.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:b.height,oldScrollHeight:b.scrollHeight,oldScrollTop:b.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:u,scrollWidthChanged:f,scrollLeftChanged:g,heightChanged:n,scrollHeightChanged:s,scrollTopChanged:i}}}e.$fu=R;class L extends m.$Uc{constructor(b){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$he),this.onScroll=this.j.event,this.c=b.smoothScrollDuration,this.f=b.scheduleAtNextAnimationFrame,this.g=new R(b.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(b){this.c=b}validateScrollPosition(b){return this.g.withScrollPosition(b)}getScrollDimensions(){return this.g}setScrollDimensions(b,a){const u=this.g.withScrollDimensions(b,a);this.n(u,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(b){const a=this.g.withScrollPosition(b);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(b,a){if(this.c===0)return this.setScrollPositionNow(b);if(this.h){b={scrollLeft:typeof b.scrollLeft>"u"?this.h.to.scrollLeft:b.scrollLeft,scrollTop:typeof b.scrollTop>"u"?this.h.to.scrollTop:b.scrollTop};const u=this.g.withScrollPosition(b);if(this.h.to.scrollLeft===u.scrollLeft&&this.h.to.scrollTop===u.scrollTop)return;let f;a?f=new C(this.h.from,u,this.h.startTime,this.h.duration):f=this.h.combine(this.g,u,this.c),this.h.dispose(),this.h=f}else{const u=this.g.withScrollPosition(b);this.h=C.start(this.g,u,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const b=this.h.tick(),a=this.g.withScrollPosition(b);if(this.n(a,!0),!!this.h){if(b.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(b,a){const u=this.g;u.equals(b)||(this.g=b,this.j.fire(this.g.createScrollEvent(u,a)))}}e.$gu=L;class T{constructor(b,a,u){this.scrollLeft=b,this.scrollTop=a,this.isDone=u}}e.$hu=T;function p(P,b){const a=b-P;return function(u){return P+a*d(u)}}function c(P,b,a){return function(u){return u<a?P(u/a):b((u-a)/(1-a))}}class C{constructor(b,a,u,f){this.from=b,this.to=a,this.duration=f,this.startTime=u,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(b,a,u){if(Math.abs(b-a)>2.5*u){let g,n;return b<a?(g=b+.75*u,n=a-.75*u):(g=b-.75*u,n=a+.75*u),c(p(b,g),p(n,a),.33)}return p(b,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(b){this.to=b.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(b){const a=(b-this.startTime)/this.duration;if(a<1){const u=this.c(a),f=this.d(a);return new T(u,f,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(b,a,u){return C.start(b,a,u)}static start(b,a,u){u=u+10;const f=Date.now()-10;return new C(b,a,f,u)}}e.$iu=C;function S(P){return Math.pow(P,3)}function d(P){return 1-S(1-P)}}),define(ye[103],Se([1,0,14,3]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=A,e.$ve=R,e.$we=L,e.$xe=T,e.$ye=c,e.$ze=C,e.$Ae=S,e.$Be=d,e.$Ce=P,e.$De=b,e.$Ee=a,e.$Fe=u,e.$Ge=f,e.$He=g,e.$Ie=n;function A(s){const i=s;return i?typeof i.read=="function":!1}function R(s){const i=s;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function L(s){const i=s;return i?R(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function T(s,i){return new p(s,i)}class p{constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,r.$1)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let l;switch(i){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const h=l.indexOf(t);h>=0&&l.splice(h,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,i){const t=[];let l;for(;(l=s.read())!==null;)t.push(l);return i(t)}function C(s,i,t){const l=[];let h;for(;(h=s.read())!==null&&l.length<t;)l.push(h);return h===null&&l.length>0?i(l):{read:()=>{if(l.length>0)return l.shift();if(typeof h<"u"){const o=h;return h=void 0,o}return s.read()}}}function S(s,i){return new Promise((t,l)=>{const h=[];d(s,{onData:o=>{i&&h.push(o)},onError:o=>{i?l(o):t(void 0)},onEnd:()=>{t(i?i(h):void 0)}})})}function d(s,i,t){s.on("error",l=>{t?.isCancellationRequested||i.onError(l)}),s.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),s.on("data",l=>{t?.isCancellationRequested||i.onData(l)})}function P(s,i){return new Promise((t,l)=>{const h=new m.$Tc,o=[],$=D=>{if(o.push(D),o.length>i)return h.dispose(),s.pause(),t({stream:s,buffer:o,ended:!1})},E=D=>(h.dispose(),l(D)),k=()=>(h.dispose(),t({stream:s,buffer:o,ended:!0}));h.add((0,m.$Sc)(()=>s.removeListener("error",E))),s.on("error",E),h.add((0,m.$Sc)(()=>s.removeListener("end",k))),s.on("end",k),h.add((0,m.$Sc)(()=>s.removeListener("data",$))),s.on("data",$)})}function b(s,i){const t=T(i);return t.end(s),t}function a(){const s=T(()=>{throw new Error("not supported")});return s.end(),s}function u(s){let i=!1;return{read:()=>i?null:(i=!0,s)}}function f(s,i,t){const l=T(t);return d(s,{onData:h=>l.write(i.data(h)),onError:h=>l.error(i.error?i.error(h):h),onEnd:()=>l.end()}),l}function g(s,i,t){let l=!1;return{read:()=>{const h=i.read();return l?h:(l=!0,h!==null?t([s,h]):s)}}}function n(s,i,t){let l=!1;const h=T(t);return d(i,{onData:o=>l?h.write(o):(l=!0,h.write(t([s,o]))),onError:o=>h.error(o),onEnd:()=>{l||(l=!0,h.write(s)),h.end()}}),h}}),define(ye[22],Se([1,0,49,103]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=c,e.$Le=C,e.$Me=S,e.$Ne=d,e.$Oe=P,e.$Pe=b,e.$Qe=a,e.$Re=u,e.$Se=f,e.$Te=g,e.$Ue=n,e.$Ve=s,e.$We=i,e.$Xe=t,e.$Ye=l,e.$Ze=h,e.$1e=o,e.$2e=$,e.$3e=E,e.$4e=v;const A=typeof Buffer<"u",R=new r.$V(()=>new Uint8Array(256));let L,T;class p{static alloc(w){return A?new p(Buffer.allocUnsafe(w)):new p(new Uint8Array(w))}static wrap(w){return A&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new p(w)}static fromString(w,y){return!(y?.dontUseNodeBuffer||!1)&&A?new p(Buffer.from(w)):(L||(L=new TextEncoder),new p(L.encode(w)))}static fromByteArray(w){const y=p.alloc(w.length);for(let N=0,O=w.length;N<O;N++)y.buffer[N]=w[N];return y}static concat(w,y){if(typeof y>"u"){y=0;for(let U=0,j=w.length;U<j;U++)y+=w[U].byteLength}const N=p.alloc(y);let O=0;for(let U=0,j=w.length;U<j;U++){const z=w[U];N.set(z,O),O+=z.byteLength}return N}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=p.alloc(this.byteLength);return w.set(this),w}toString(){return A?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(w,y){return new p(this.buffer.subarray(w,y))}set(w,y){if(w instanceof p)this.buffer.set(w.buffer,y);else if(w instanceof Uint8Array)this.buffer.set(w,y);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),y);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return d(this.buffer,w)}writeUInt32BE(w,y){P(this.buffer,w,y)}readUInt32LE(w){return b(this.buffer,w)}writeUInt32LE(w,y){a(this.buffer,w,y)}readUInt8(w){return u(this.buffer,w)}writeUInt8(w,y){f(this.buffer,w,y)}indexOf(w,y=0){return c(this.buffer,w instanceof p?w.buffer:w,y)}}e.$Je=p;function c(I,w,y=0){const N=w.byteLength,O=I.byteLength;if(N===0)return 0;if(N===1)return I.indexOf(w[0]);if(N>O-y)return-1;const U=R.value;U.fill(w.length);for(let F=0;F<w.length;F++)U[w[F]]=w.length-F-1;let j=y+w.length-1,z=j,M=-1;for(;j<O;)if(I[j]===w[z]){if(z===0){M=j;break}j--,z--}else j+=Math.max(w.length-z,U[I[j]]),z=w.length-1;return M}function C(I,w){return I[w+0]<<0>>>0|I[w+1]<<8>>>0}function S(I,w,y){I[y+0]=w&255,w=w>>>8,I[y+1]=w&255}function d(I,w){return I[w]*2**24+I[w+1]*2**16+I[w+2]*2**8+I[w+3]}function P(I,w,y){I[y+3]=w,w=w>>>8,I[y+2]=w,w=w>>>8,I[y+1]=w,w=w>>>8,I[y]=w}function b(I,w){return I[w+0]<<0>>>0|I[w+1]<<8>>>0|I[w+2]<<16>>>0|I[w+3]<<24>>>0}function a(I,w,y){I[y+0]=w&255,w=w>>>8,I[y+1]=w&255,w=w>>>8,I[y+2]=w&255,w=w>>>8,I[y+3]=w&255}function u(I,w){return I[w]}function f(I,w,y){I[y]=w}function g(I){return m.$ye(I,w=>p.concat(w))}function n(I){return m.$Fe(I)}function s(I){return m.$Ae(I,w=>p.concat(w))}async function i(I){return I.ended?p.concat(I.buffer):p.concat([...I.buffer,await s(I.stream)])}function t(I){return m.$De(I,w=>p.concat(w))}function l(I){return m.$Ge(I,{data:w=>typeof w=="string"?p.fromString(w):p.wrap(w)},w=>p.concat(w))}function h(I){return m.$xe(w=>p.concat(w),I)}function o(I,w){return m.$He(I,w,y=>p.concat(y))}function $(I,w){return m.$Ie(I,w,y=>p.concat(y))}function E(I){let w=0,y=0,N=0;const O=new Uint8Array(Math.floor(I.length/4*3)),U=z=>{switch(y){case 3:O[N++]=w|z,y=0;break;case 2:O[N++]=w|z>>>2,w=z<<6,y=3;break;case 1:O[N++]=w|z>>>4,w=z<<4,y=2;break;default:w=z<<2,y=1}};for(let z=0;z<I.length;z++){const M=I.charCodeAt(z);if(M>=65&&M<=90)U(M-65);else if(M>=97&&M<=122)U(M-97+26);else if(M>=48&&M<=57)U(M-48+52);else if(M===43||M===45)U(62);else if(M===47||M===95)U(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${I[z]}`)}}const j=N;for(;y>0;)U(0);return p.wrap(O).slice(0,j)}const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:I},w=!0,y=!1){const N=y?D:k;let O="";const U=I.byteLength%3;let j=0;for(;j<I.byteLength-U;j+=3){const z=I[j+0],M=I[j+1],F=I[j+2];O+=N[z>>>2],O+=N[(z<<4|M>>>4)&63],O+=N[(M<<2|F>>>6)&63],O+=N[F&63]}if(U===1){const z=I[j+0];O+=N[z>>>2],O+=N[z<<4&63],w&&(O+="==")}else if(U===2){const z=I[j+0],M=I[j+1];O+=N[z>>>2],O+=N[(z<<4|M>>>4)&63],O+=N[M<<2&63],w&&(O+="=")}return O}}),define(ye[183],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ye[18],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=r,e.$bg=m,e.$cg=A,e.$dg=R,e.$eg=L,e.$fg=T,e.$gg=p,e.$hg=c,e.$ig=C,e.$jg=S,e.$kg=d,e.$lg=P,e.$mg=b,e.$ng=u,e.$og=f,e.$pg=g,e.$qg=n,e.$rg=s;function r(i){return typeof i=="string"}function m(i){return Array.isArray(i)&&i.every(t=>r(t))}function A(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function R(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function L(i){return typeof i=="number"&&!isNaN(i)}function T(i){return!!i&&typeof i[Symbol.iterator]=="function"}function p(i){return i===!0||i===!1}function c(i){return typeof i>"u"}function C(i){return!S(i)}function S(i){return c(i)||i===null}function d(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function P(i){if(S(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function b(...i){const t=[];for(let l=0;l<i.length;l++){const h=i[l];if(S(h))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(h)}return t}const a=Object.prototype.hasOwnProperty;function u(i){if(!A(i))return!1;for(const t in i)if(a.call(i,t))return!1;return!0}function f(i){return typeof i=="function"}function g(...i){return i.length>0&&i.every(f)}function n(i,t){const l=Math.min(i.length,t.length);for(let h=0;h<l;h++)s(i[h],t[h])}function s(i,t){if(r(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(i instanceof t)return}catch{}if(!S(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ye[104],Se([1,0,18]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=A,e.$Vj=R;const m=Object.create(null);function A(L,T){if((0,r.$ag)(T)){const p=m[T];if(p===void 0)throw new Error(`${L} references an unknown codicon: ${T}`);T=p}return m[L]=T,{id:L}}function R(){return m}}),define(ye[184],Se([1,0,104]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=void 0,e.$Wj={add:(0,r.$Uj)("add",6e4),plus:(0,r.$Uj)("plus",6e4),gistNew:(0,r.$Uj)("gist-new",6e4),repoCreate:(0,r.$Uj)("repo-create",6e4),lightbulb:(0,r.$Uj)("lightbulb",60001),lightBulb:(0,r.$Uj)("light-bulb",60001),repo:(0,r.$Uj)("repo",60002),repoDelete:(0,r.$Uj)("repo-delete",60002),gistFork:(0,r.$Uj)("gist-fork",60003),repoForked:(0,r.$Uj)("repo-forked",60003),gitPullRequest:(0,r.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Uj)("record-keys",60005),keyboard:(0,r.$Uj)("keyboard",60005),tag:(0,r.$Uj)("tag",60006),gitPullRequestLabel:(0,r.$Uj)("git-pull-request-label",60006),tagAdd:(0,r.$Uj)("tag-add",60006),tagRemove:(0,r.$Uj)("tag-remove",60006),person:(0,r.$Uj)("person",60007),personFollow:(0,r.$Uj)("person-follow",60007),personOutline:(0,r.$Uj)("person-outline",60007),personFilled:(0,r.$Uj)("person-filled",60007),gitBranch:(0,r.$Uj)("git-branch",60008),gitBranchCreate:(0,r.$Uj)("git-branch-create",60008),gitBranchDelete:(0,r.$Uj)("git-branch-delete",60008),sourceControl:(0,r.$Uj)("source-control",60008),mirror:(0,r.$Uj)("mirror",60009),mirrorPublic:(0,r.$Uj)("mirror-public",60009),star:(0,r.$Uj)("star",60010),starAdd:(0,r.$Uj)("star-add",60010),starDelete:(0,r.$Uj)("star-delete",60010),starEmpty:(0,r.$Uj)("star-empty",60010),comment:(0,r.$Uj)("comment",60011),commentAdd:(0,r.$Uj)("comment-add",60011),alert:(0,r.$Uj)("alert",60012),warning:(0,r.$Uj)("warning",60012),search:(0,r.$Uj)("search",60013),searchSave:(0,r.$Uj)("search-save",60013),logOut:(0,r.$Uj)("log-out",60014),signOut:(0,r.$Uj)("sign-out",60014),logIn:(0,r.$Uj)("log-in",60015),signIn:(0,r.$Uj)("sign-in",60015),eye:(0,r.$Uj)("eye",60016),eyeUnwatch:(0,r.$Uj)("eye-unwatch",60016),eyeWatch:(0,r.$Uj)("eye-watch",60016),circleFilled:(0,r.$Uj)("circle-filled",60017),primitiveDot:(0,r.$Uj)("primitive-dot",60017),closeDirty:(0,r.$Uj)("close-dirty",60017),debugBreakpoint:(0,r.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Uj)("primitive-square",60018),edit:(0,r.$Uj)("edit",60019),pencil:(0,r.$Uj)("pencil",60019),info:(0,r.$Uj)("info",60020),issueOpened:(0,r.$Uj)("issue-opened",60020),gistPrivate:(0,r.$Uj)("gist-private",60021),gitForkPrivate:(0,r.$Uj)("git-fork-private",60021),lock:(0,r.$Uj)("lock",60021),mirrorPrivate:(0,r.$Uj)("mirror-private",60021),close:(0,r.$Uj)("close",60022),removeClose:(0,r.$Uj)("remove-close",60022),x:(0,r.$Uj)("x",60022),repoSync:(0,r.$Uj)("repo-sync",60023),sync:(0,r.$Uj)("sync",60023),clone:(0,r.$Uj)("clone",60024),desktopDownload:(0,r.$Uj)("desktop-download",60024),beaker:(0,r.$Uj)("beaker",60025),microscope:(0,r.$Uj)("microscope",60025),vm:(0,r.$Uj)("vm",60026),deviceDesktop:(0,r.$Uj)("device-desktop",60026),file:(0,r.$Uj)("file",60027),fileText:(0,r.$Uj)("file-text",60027),more:(0,r.$Uj)("more",60028),ellipsis:(0,r.$Uj)("ellipsis",60028),kebabHorizontal:(0,r.$Uj)("kebab-horizontal",60028),mailReply:(0,r.$Uj)("mail-reply",60029),reply:(0,r.$Uj)("reply",60029),organization:(0,r.$Uj)("organization",60030),organizationFilled:(0,r.$Uj)("organization-filled",60030),organizationOutline:(0,r.$Uj)("organization-outline",60030),newFile:(0,r.$Uj)("new-file",60031),fileAdd:(0,r.$Uj)("file-add",60031),newFolder:(0,r.$Uj)("new-folder",60032),fileDirectoryCreate:(0,r.$Uj)("file-directory-create",60032),trash:(0,r.$Uj)("trash",60033),trashcan:(0,r.$Uj)("trashcan",60033),history:(0,r.$Uj)("history",60034),clock:(0,r.$Uj)("clock",60034),folder:(0,r.$Uj)("folder",60035),fileDirectory:(0,r.$Uj)("file-directory",60035),symbolFolder:(0,r.$Uj)("symbol-folder",60035),logoGithub:(0,r.$Uj)("logo-github",60036),markGithub:(0,r.$Uj)("mark-github",60036),github:(0,r.$Uj)("github",60036),terminal:(0,r.$Uj)("terminal",60037),console:(0,r.$Uj)("console",60037),repl:(0,r.$Uj)("repl",60037),zap:(0,r.$Uj)("zap",60038),symbolEvent:(0,r.$Uj)("symbol-event",60038),error:(0,r.$Uj)("error",60039),stop:(0,r.$Uj)("stop",60039),variable:(0,r.$Uj)("variable",60040),symbolVariable:(0,r.$Uj)("symbol-variable",60040),array:(0,r.$Uj)("array",60042),symbolArray:(0,r.$Uj)("symbol-array",60042),symbolModule:(0,r.$Uj)("symbol-module",60043),symbolPackage:(0,r.$Uj)("symbol-package",60043),symbolNamespace:(0,r.$Uj)("symbol-namespace",60043),symbolObject:(0,r.$Uj)("symbol-object",60043),symbolMethod:(0,r.$Uj)("symbol-method",60044),symbolFunction:(0,r.$Uj)("symbol-function",60044),symbolConstructor:(0,r.$Uj)("symbol-constructor",60044),symbolBoolean:(0,r.$Uj)("symbol-boolean",60047),symbolNull:(0,r.$Uj)("symbol-null",60047),symbolNumeric:(0,r.$Uj)("symbol-numeric",60048),symbolNumber:(0,r.$Uj)("symbol-number",60048),symbolStructure:(0,r.$Uj)("symbol-structure",60049),symbolStruct:(0,r.$Uj)("symbol-struct",60049),symbolParameter:(0,r.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Uj)("symbol-type-parameter",60050),symbolKey:(0,r.$Uj)("symbol-key",60051),symbolText:(0,r.$Uj)("symbol-text",60051),symbolReference:(0,r.$Uj)("symbol-reference",60052),goToFile:(0,r.$Uj)("go-to-file",60052),symbolEnum:(0,r.$Uj)("symbol-enum",60053),symbolValue:(0,r.$Uj)("symbol-value",60053),symbolRuler:(0,r.$Uj)("symbol-ruler",60054),symbolUnit:(0,r.$Uj)("symbol-unit",60054),activateBreakpoints:(0,r.$Uj)("activate-breakpoints",60055),archive:(0,r.$Uj)("archive",60056),arrowBoth:(0,r.$Uj)("arrow-both",60057),arrowDown:(0,r.$Uj)("arrow-down",60058),arrowLeft:(0,r.$Uj)("arrow-left",60059),arrowRight:(0,r.$Uj)("arrow-right",60060),arrowSmallDown:(0,r.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Uj)("arrow-small-up",60064),arrowUp:(0,r.$Uj)("arrow-up",60065),bell:(0,r.$Uj)("bell",60066),bold:(0,r.$Uj)("bold",60067),book:(0,r.$Uj)("book",60068),bookmark:(0,r.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Uj)("briefcase",60076),broadcast:(0,r.$Uj)("broadcast",60077),browser:(0,r.$Uj)("browser",60078),bug:(0,r.$Uj)("bug",60079),calendar:(0,r.$Uj)("calendar",60080),caseSensitive:(0,r.$Uj)("case-sensitive",60081),check:(0,r.$Uj)("check",60082),checklist:(0,r.$Uj)("checklist",60083),chevronDown:(0,r.$Uj)("chevron-down",60084),chevronLeft:(0,r.$Uj)("chevron-left",60085),chevronRight:(0,r.$Uj)("chevron-right",60086),chevronUp:(0,r.$Uj)("chevron-up",60087),chromeClose:(0,r.$Uj)("chrome-close",60088),chromeMaximize:(0,r.$Uj)("chrome-maximize",60089),chromeMinimize:(0,r.$Uj)("chrome-minimize",60090),chromeRestore:(0,r.$Uj)("chrome-restore",60091),circleOutline:(0,r.$Uj)("circle-outline",60092),circle:(0,r.$Uj)("circle",60092),debugBreakpointUnverified:(0,r.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Uj)("circle-slash",60093),circuitBoard:(0,r.$Uj)("circuit-board",60094),clearAll:(0,r.$Uj)("clear-all",60095),clippy:(0,r.$Uj)("clippy",60096),closeAll:(0,r.$Uj)("close-all",60097),cloudDownload:(0,r.$Uj)("cloud-download",60098),cloudUpload:(0,r.$Uj)("cloud-upload",60099),code:(0,r.$Uj)("code",60100),collapseAll:(0,r.$Uj)("collapse-all",60101),colorMode:(0,r.$Uj)("color-mode",60102),commentDiscussion:(0,r.$Uj)("comment-discussion",60103),creditCard:(0,r.$Uj)("credit-card",60105),dash:(0,r.$Uj)("dash",60108),dashboard:(0,r.$Uj)("dashboard",60109),database:(0,r.$Uj)("database",60110),debugContinue:(0,r.$Uj)("debug-continue",60111),debugDisconnect:(0,r.$Uj)("debug-disconnect",60112),debugPause:(0,r.$Uj)("debug-pause",60113),debugRestart:(0,r.$Uj)("debug-restart",60114),debugStart:(0,r.$Uj)("debug-start",60115),debugStepInto:(0,r.$Uj)("debug-step-into",60116),debugStepOut:(0,r.$Uj)("debug-step-out",60117),debugStepOver:(0,r.$Uj)("debug-step-over",60118),debugStop:(0,r.$Uj)("debug-stop",60119),debug:(0,r.$Uj)("debug",60120),deviceCameraVideo:(0,r.$Uj)("device-camera-video",60121),deviceCamera:(0,r.$Uj)("device-camera",60122),deviceMobile:(0,r.$Uj)("device-mobile",60123),diffAdded:(0,r.$Uj)("diff-added",60124),diffIgnored:(0,r.$Uj)("diff-ignored",60125),diffModified:(0,r.$Uj)("diff-modified",60126),diffRemoved:(0,r.$Uj)("diff-removed",60127),diffRenamed:(0,r.$Uj)("diff-renamed",60128),diff:(0,r.$Uj)("diff",60129),diffSidebyside:(0,r.$Uj)("diff-sidebyside",60129),discard:(0,r.$Uj)("discard",60130),editorLayout:(0,r.$Uj)("editor-layout",60131),emptyWindow:(0,r.$Uj)("empty-window",60132),exclude:(0,r.$Uj)("exclude",60133),extensions:(0,r.$Uj)("extensions",60134),eyeClosed:(0,r.$Uj)("eye-closed",60135),fileBinary:(0,r.$Uj)("file-binary",60136),fileCode:(0,r.$Uj)("file-code",60137),fileMedia:(0,r.$Uj)("file-media",60138),filePdf:(0,r.$Uj)("file-pdf",60139),fileSubmodule:(0,r.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Uj)("file-symlink-file",60142),fileZip:(0,r.$Uj)("file-zip",60143),files:(0,r.$Uj)("files",60144),filter:(0,r.$Uj)("filter",60145),flame:(0,r.$Uj)("flame",60146),foldDown:(0,r.$Uj)("fold-down",60147),foldUp:(0,r.$Uj)("fold-up",60148),fold:(0,r.$Uj)("fold",60149),folderActive:(0,r.$Uj)("folder-active",60150),folderOpened:(0,r.$Uj)("folder-opened",60151),gear:(0,r.$Uj)("gear",60152),gift:(0,r.$Uj)("gift",60153),gistSecret:(0,r.$Uj)("gist-secret",60154),gist:(0,r.$Uj)("gist",60155),gitCommit:(0,r.$Uj)("git-commit",60156),gitCompare:(0,r.$Uj)("git-compare",60157),compareChanges:(0,r.$Uj)("compare-changes",60157),gitMerge:(0,r.$Uj)("git-merge",60158),githubAction:(0,r.$Uj)("github-action",60159),githubAlt:(0,r.$Uj)("github-alt",60160),globe:(0,r.$Uj)("globe",60161),grabber:(0,r.$Uj)("grabber",60162),graph:(0,r.$Uj)("graph",60163),gripper:(0,r.$Uj)("gripper",60164),heart:(0,r.$Uj)("heart",60165),home:(0,r.$Uj)("home",60166),horizontalRule:(0,r.$Uj)("horizontal-rule",60167),hubot:(0,r.$Uj)("hubot",60168),inbox:(0,r.$Uj)("inbox",60169),issueReopened:(0,r.$Uj)("issue-reopened",60171),issues:(0,r.$Uj)("issues",60172),italic:(0,r.$Uj)("italic",60173),jersey:(0,r.$Uj)("jersey",60174),json:(0,r.$Uj)("json",60175),kebabVertical:(0,r.$Uj)("kebab-vertical",60176),key:(0,r.$Uj)("key",60177),law:(0,r.$Uj)("law",60178),lightbulbAutofix:(0,r.$Uj)("lightbulb-autofix",60179),linkExternal:(0,r.$Uj)("link-external",60180),link:(0,r.$Uj)("link",60181),listOrdered:(0,r.$Uj)("list-ordered",60182),listUnordered:(0,r.$Uj)("list-unordered",60183),liveShare:(0,r.$Uj)("live-share",60184),loading:(0,r.$Uj)("loading",60185),location:(0,r.$Uj)("location",60186),mailRead:(0,r.$Uj)("mail-read",60187),mail:(0,r.$Uj)("mail",60188),markdown:(0,r.$Uj)("markdown",60189),megaphone:(0,r.$Uj)("megaphone",60190),mention:(0,r.$Uj)("mention",60191),milestone:(0,r.$Uj)("milestone",60192),gitPullRequestMilestone:(0,r.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Uj)("mortar-board",60193),move:(0,r.$Uj)("move",60194),multipleWindows:(0,r.$Uj)("multiple-windows",60195),mute:(0,r.$Uj)("mute",60196),noNewline:(0,r.$Uj)("no-newline",60197),note:(0,r.$Uj)("note",60198),octoface:(0,r.$Uj)("octoface",60199),openPreview:(0,r.$Uj)("open-preview",60200),package:(0,r.$Uj)("package",60201),paintcan:(0,r.$Uj)("paintcan",60202),pin:(0,r.$Uj)("pin",60203),play:(0,r.$Uj)("play",60204),run:(0,r.$Uj)("run",60204),plug:(0,r.$Uj)("plug",60205),preserveCase:(0,r.$Uj)("preserve-case",60206),preview:(0,r.$Uj)("preview",60207),project:(0,r.$Uj)("project",60208),pulse:(0,r.$Uj)("pulse",60209),question:(0,r.$Uj)("question",60210),quote:(0,r.$Uj)("quote",60211),radioTower:(0,r.$Uj)("radio-tower",60212),reactions:(0,r.$Uj)("reactions",60213),references:(0,r.$Uj)("references",60214),refresh:(0,r.$Uj)("refresh",60215),regex:(0,r.$Uj)("regex",60216),remoteExplorer:(0,r.$Uj)("remote-explorer",60217),remote:(0,r.$Uj)("remote",60218),remove:(0,r.$Uj)("remove",60219),replaceAll:(0,r.$Uj)("replace-all",60220),replace:(0,r.$Uj)("replace",60221),repoClone:(0,r.$Uj)("repo-clone",60222),repoForcePush:(0,r.$Uj)("repo-force-push",60223),repoPull:(0,r.$Uj)("repo-pull",60224),repoPush:(0,r.$Uj)("repo-push",60225),report:(0,r.$Uj)("report",60226),requestChanges:(0,r.$Uj)("request-changes",60227),rocket:(0,r.$Uj)("rocket",60228),rootFolderOpened:(0,r.$Uj)("root-folder-opened",60229),rootFolder:(0,r.$Uj)("root-folder",60230),rss:(0,r.$Uj)("rss",60231),ruby:(0,r.$Uj)("ruby",60232),saveAll:(0,r.$Uj)("save-all",60233),saveAs:(0,r.$Uj)("save-as",60234),save:(0,r.$Uj)("save",60235),screenFull:(0,r.$Uj)("screen-full",60236),screenNormal:(0,r.$Uj)("screen-normal",60237),searchStop:(0,r.$Uj)("search-stop",60238),server:(0,r.$Uj)("server",60240),settingsGear:(0,r.$Uj)("settings-gear",60241),settings:(0,r.$Uj)("settings",60242),shield:(0,r.$Uj)("shield",60243),smiley:(0,r.$Uj)("smiley",60244),sortPrecedence:(0,r.$Uj)("sort-precedence",60245),splitHorizontal:(0,r.$Uj)("split-horizontal",60246),splitVertical:(0,r.$Uj)("split-vertical",60247),squirrel:(0,r.$Uj)("squirrel",60248),starFull:(0,r.$Uj)("star-full",60249),starHalf:(0,r.$Uj)("star-half",60250),symbolClass:(0,r.$Uj)("symbol-class",60251),symbolColor:(0,r.$Uj)("symbol-color",60252),symbolConstant:(0,r.$Uj)("symbol-constant",60253),symbolEnumMember:(0,r.$Uj)("symbol-enum-member",60254),symbolField:(0,r.$Uj)("symbol-field",60255),symbolFile:(0,r.$Uj)("symbol-file",60256),symbolInterface:(0,r.$Uj)("symbol-interface",60257),symbolKeyword:(0,r.$Uj)("symbol-keyword",60258),symbolMisc:(0,r.$Uj)("symbol-misc",60259),symbolOperator:(0,r.$Uj)("symbol-operator",60260),symbolProperty:(0,r.$Uj)("symbol-property",60261),wrench:(0,r.$Uj)("wrench",60261),wrenchSubaction:(0,r.$Uj)("wrench-subaction",60261),symbolSnippet:(0,r.$Uj)("symbol-snippet",60262),tasklist:(0,r.$Uj)("tasklist",60263),telescope:(0,r.$Uj)("telescope",60264),textSize:(0,r.$Uj)("text-size",60265),threeBars:(0,r.$Uj)("three-bars",60266),thumbsdown:(0,r.$Uj)("thumbsdown",60267),thumbsup:(0,r.$Uj)("thumbsup",60268),tools:(0,r.$Uj)("tools",60269),triangleDown:(0,r.$Uj)("triangle-down",60270),triangleLeft:(0,r.$Uj)("triangle-left",60271),triangleRight:(0,r.$Uj)("triangle-right",60272),triangleUp:(0,r.$Uj)("triangle-up",60273),twitter:(0,r.$Uj)("twitter",60274),unfold:(0,r.$Uj)("unfold",60275),unlock:(0,r.$Uj)("unlock",60276),unmute:(0,r.$Uj)("unmute",60277),unverified:(0,r.$Uj)("unverified",60278),verified:(0,r.$Uj)("verified",60279),versions:(0,r.$Uj)("versions",60280),vmActive:(0,r.$Uj)("vm-active",60281),vmOutline:(0,r.$Uj)("vm-outline",60282),vmRunning:(0,r.$Uj)("vm-running",60283),watch:(0,r.$Uj)("watch",60284),whitespace:(0,r.$Uj)("whitespace",60285),wholeWord:(0,r.$Uj)("whole-word",60286),window:(0,r.$Uj)("window",60287),wordWrap:(0,r.$Uj)("word-wrap",60288),zoomIn:(0,r.$Uj)("zoom-in",60289),zoomOut:(0,r.$Uj)("zoom-out",60290),listFilter:(0,r.$Uj)("list-filter",60291),listFlat:(0,r.$Uj)("list-flat",60292),listSelection:(0,r.$Uj)("list-selection",60293),selection:(0,r.$Uj)("selection",60293),listTree:(0,r.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Uj)("symbol-string",60301),debugReverseContinue:(0,r.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Uj)("debug-step-back",60303),debugRestartFrame:(0,r.$Uj)("debug-restart-frame",60304),debugAlt:(0,r.$Uj)("debug-alt",60305),callIncoming:(0,r.$Uj)("call-incoming",60306),callOutgoing:(0,r.$Uj)("call-outgoing",60307),menu:(0,r.$Uj)("menu",60308),expandAll:(0,r.$Uj)("expand-all",60309),feedback:(0,r.$Uj)("feedback",60310),gitPullRequestReviewer:(0,r.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Uj)("ungroup-by-ref-type",60312),account:(0,r.$Uj)("account",60313),gitPullRequestAssignee:(0,r.$Uj)("git-pull-request-assignee",60313),bellDot:(0,r.$Uj)("bell-dot",60314),debugConsole:(0,r.$Uj)("debug-console",60315),library:(0,r.$Uj)("library",60316),output:(0,r.$Uj)("output",60317),runAll:(0,r.$Uj)("run-all",60318),syncIgnored:(0,r.$Uj)("sync-ignored",60319),pinned:(0,r.$Uj)("pinned",60320),githubInverted:(0,r.$Uj)("github-inverted",60321),serverProcess:(0,r.$Uj)("server-process",60322),serverEnvironment:(0,r.$Uj)("server-environment",60323),pass:(0,r.$Uj)("pass",60324),issueClosed:(0,r.$Uj)("issue-closed",60324),stopCircle:(0,r.$Uj)("stop-circle",60325),playCircle:(0,r.$Uj)("play-circle",60326),record:(0,r.$Uj)("record",60327),debugAltSmall:(0,r.$Uj)("debug-alt-small",60328),vmConnect:(0,r.$Uj)("vm-connect",60329),cloud:(0,r.$Uj)("cloud",60330),merge:(0,r.$Uj)("merge",60331),export:(0,r.$Uj)("export",60332),graphLeft:(0,r.$Uj)("graph-left",60333),magnet:(0,r.$Uj)("magnet",60334),notebook:(0,r.$Uj)("notebook",60335),redo:(0,r.$Uj)("redo",60336),checkAll:(0,r.$Uj)("check-all",60337),pinnedDirty:(0,r.$Uj)("pinned-dirty",60338),passFilled:(0,r.$Uj)("pass-filled",60339),circleLargeFilled:(0,r.$Uj)("circle-large-filled",60340),circleLarge:(0,r.$Uj)("circle-large",60341),circleLargeOutline:(0,r.$Uj)("circle-large-outline",60341),combine:(0,r.$Uj)("combine",60342),gather:(0,r.$Uj)("gather",60342),table:(0,r.$Uj)("table",60343),variableGroup:(0,r.$Uj)("variable-group",60344),typeHierarchy:(0,r.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Uj)("git-pull-request-create",60348),runAbove:(0,r.$Uj)("run-above",60349),runBelow:(0,r.$Uj)("run-below",60350),notebookTemplate:(0,r.$Uj)("notebook-template",60351),debugRerun:(0,r.$Uj)("debug-rerun",60352),workspaceTrusted:(0,r.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Uj)("workspace-unknown",60355),terminalCmd:(0,r.$Uj)("terminal-cmd",60356),terminalDebian:(0,r.$Uj)("terminal-debian",60357),terminalLinux:(0,r.$Uj)("terminal-linux",60358),terminalPowershell:(0,r.$Uj)("terminal-powershell",60359),terminalTmux:(0,r.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Uj)("terminal-ubuntu",60361),terminalBash:(0,r.$Uj)("terminal-bash",60362),arrowSwap:(0,r.$Uj)("arrow-swap",60363),copy:(0,r.$Uj)("copy",60364),personAdd:(0,r.$Uj)("person-add",60365),filterFilled:(0,r.$Uj)("filter-filled",60366),wand:(0,r.$Uj)("wand",60367),debugLineByLine:(0,r.$Uj)("debug-line-by-line",60368),inspect:(0,r.$Uj)("inspect",60369),layers:(0,r.$Uj)("layers",60370),layersDot:(0,r.$Uj)("layers-dot",60371),layersActive:(0,r.$Uj)("layers-active",60372),compass:(0,r.$Uj)("compass",60373),compassDot:(0,r.$Uj)("compass-dot",60374),compassActive:(0,r.$Uj)("compass-active",60375),azure:(0,r.$Uj)("azure",60376),issueDraft:(0,r.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Uj)("git-pull-request-draft",60379),debugAll:(0,r.$Uj)("debug-all",60380),debugCoverage:(0,r.$Uj)("debug-coverage",60381),runErrors:(0,r.$Uj)("run-errors",60382),folderLibrary:(0,r.$Uj)("folder-library",60383),debugContinueSmall:(0,r.$Uj)("debug-continue-small",60384),beakerStop:(0,r.$Uj)("beaker-stop",60385),graphLine:(0,r.$Uj)("graph-line",60386),graphScatter:(0,r.$Uj)("graph-scatter",60387),pieChart:(0,r.$Uj)("pie-chart",60388),bracket:(0,r.$Uj)("bracket",60175),bracketDot:(0,r.$Uj)("bracket-dot",60389),bracketError:(0,r.$Uj)("bracket-error",60390),lockSmall:(0,r.$Uj)("lock-small",60391),azureDevops:(0,r.$Uj)("azure-devops",60392),verifiedFilled:(0,r.$Uj)("verified-filled",60393),newline:(0,r.$Uj)("newline",60394),layout:(0,r.$Uj)("layout",60395),layoutActivitybarLeft:(0,r.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Uj)("layout-panel-right",60401),layoutPanel:(0,r.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Uj)("layout-statusbar",60405),layoutMenubar:(0,r.$Uj)("layout-menubar",60406),layoutCentered:(0,r.$Uj)("layout-centered",60407),target:(0,r.$Uj)("target",60408),indent:(0,r.$Uj)("indent",60409),recordSmall:(0,r.$Uj)("record-small",60410),errorSmall:(0,r.$Uj)("error-small",60411),terminalDecorationError:(0,r.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Uj)("layout-sidebar-left-off",60418),blank:(0,r.$Uj)("blank",60419),heartFilled:(0,r.$Uj)("heart-filled",60420),map:(0,r.$Uj)("map",60421),mapHorizontal:(0,r.$Uj)("map-horizontal",60421),foldHorizontal:(0,r.$Uj)("fold-horizontal",60421),mapFilled:(0,r.$Uj)("map-filled",60422),mapHorizontalFilled:(0,r.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Uj)("circle-small",60423),bellSlash:(0,r.$Uj)("bell-slash",60424),bellSlashDot:(0,r.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Uj)("search-fuzzy",60429),commentDraft:(0,r.$Uj)("comment-draft",60430),send:(0,r.$Uj)("send",60431),sparkle:(0,r.$Uj)("sparkle",60432),insert:(0,r.$Uj)("insert",60433),mic:(0,r.$Uj)("mic",60434),thumbsdownFilled:(0,r.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Uj)("thumbsup-filled",60436),coffee:(0,r.$Uj)("coffee",60437),snake:(0,r.$Uj)("snake",60438),game:(0,r.$Uj)("game",60439),vr:(0,r.$Uj)("vr",60440),chip:(0,r.$Uj)("chip",60441),piano:(0,r.$Uj)("piano",60442),music:(0,r.$Uj)("music",60443),micFilled:(0,r.$Uj)("mic-filled",60444),repoFetch:(0,r.$Uj)("repo-fetch",60445),copilot:(0,r.$Uj)("copilot",60446),lightbulbSparkle:(0,r.$Uj)("lightbulb-sparkle",60447),robot:(0,r.$Uj)("robot",60448),sparkleFilled:(0,r.$Uj)("sparkle-filled",60449),diffSingle:(0,r.$Uj)("diff-single",60450),diffMultiple:(0,r.$Uj)("diff-multiple",60451),surroundWith:(0,r.$Uj)("surround-with",60452),share:(0,r.$Uj)("share",60453),gitStash:(0,r.$Uj)("git-stash",60454),gitStashApply:(0,r.$Uj)("git-stash-apply",60455),gitStashPop:(0,r.$Uj)("git-stash-pop",60456),vscode:(0,r.$Uj)("vscode",60457),vscodeInsiders:(0,r.$Uj)("vscode-insiders",60458),codeOss:(0,r.$Uj)("code-oss",60459),runCoverage:(0,r.$Uj)("run-coverage",60460),runAllCoverage:(0,r.$Uj)("run-all-coverage",60461),coverage:(0,r.$Uj)("coverage",60462),githubProject:(0,r.$Uj)("github-project",60463),mapVertical:(0,r.$Uj)("map-vertical",60464),foldVertical:(0,r.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Uj)("fold-vertical-filled",60465),goToSearch:(0,r.$Uj)("go-to-search",60466),percentage:(0,r.$Uj)("percentage",60467),sortPercentage:(0,r.$Uj)("sort-percentage",60467),attach:(0,r.$Uj)("attach",60468)}}),define(ye[83],Se([1,0,104,184]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=void 0,e.$Xj=A;function A(){return Object.values(e.$Zj)}e.$Yj={dialogError:(0,r.$Uj)("dialog-error","error"),dialogWarning:(0,r.$Uj)("dialog-warning","warning"),dialogInfo:(0,r.$Uj)("dialog-info","info"),dialogClose:(0,r.$Uj)("dialog-close","close"),treeItemExpanded:(0,r.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Uj)("tree-item-loading","loading"),menuSelection:(0,r.$Uj)("menu-selection","check"),menuSubmenu:(0,r.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Uj)("toolbar-more","more"),quickInputBack:(0,r.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Uj)("drop-down-button",60084),symbolCustomColor:(0,r.$Uj)("symbol-customcolor",60252),exportIcon:(0,r.$Uj)("export",60332),workspaceUnspecified:(0,r.$Uj)("workspace-unspecified",60355),newLine:(0,r.$Uj)("newline",60394),thumbsDownFilled:(0,r.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Uj)("thumbsup-filled",60436),gitFetch:(0,r.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Uj)("debug-breakpoint-pending",60377)},e.$Zj={...m.$Wj,...e.$Yj}}),define(ye[25],Se([1,0,18]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=m,e.$0n=A,e.$$n=L,e.$_n=p,e.$ao=c,e.$bo=C,e.$co=S,e.$do=d,e.$eo=P,e.$fo=b,e.$go=a,e.$ho=u,e.$io=f;function m(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const n=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([s,i])=>{n[s]=i&&typeof i=="object"?m(i):i}),n}function A(g){if(!g||typeof g!="object")return g;const n=[g];for(;n.length>0;){const s=n.shift();Object.freeze(s);for(const i in s)if(R.call(s,i)){const t=s[i];typeof t=="object"&&!Object.isFrozen(t)&&!(0,r.$dg)(t)&&n.push(t)}}return g}const R=Object.prototype.hasOwnProperty;function L(g,n){return T(g,n,new Set)}function T(g,n,s){if((0,r.$jg)(g))return g;const i=n(g);if(typeof i<"u")return i;if(Array.isArray(g)){const t=[];for(const l of g)t.push(T(l,n,s));return t}if((0,r.$cg)(g)){if(s.has(g))throw new Error("Cannot clone recursive data-structure");s.add(g);const t={};for(const l in g)R.call(g,l)&&(t[l]=T(g[l],n,s));return s.delete(g),t}return g}function p(g,n,s=!0){return(0,r.$cg)(g)?((0,r.$cg)(n)&&Object.keys(n).forEach(i=>{i in g?s&&((0,r.$cg)(g[i])&&(0,r.$cg)(n[i])?p(g[i],n[i],s):g[i]=n[i]):g[i]=n[i]}),g):n}function c(g,n){if(g===n)return!0;if(g==null||n===null||n===void 0||typeof g!=typeof n||typeof g!="object"||Array.isArray(g)!==Array.isArray(n))return!1;let s,i;if(Array.isArray(g)){if(g.length!==n.length)return!1;for(s=0;s<g.length;s++)if(!c(g[s],n[s]))return!1}else{const t=[];for(i in g)t.push(i);t.sort();const l=[];for(i in n)l.push(i);if(l.sort(),!c(t,l))return!1;for(s=0;s<t.length;s++)if(!c(g[t[s]],n[t[s]]))return!1}return!0}function C(g){const n=new Set;return JSON.stringify(g,(s,i)=>{if((0,r.$cg)(i)||Array.isArray(i)){if(n.has(i))return"[Circular]";n.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function S(g,n){const s=Object.create(null);return!g||!n||Object.keys(n).forEach(t=>{const l=g[t],h=n[t];c(l,h)||(s[t]=h)}),s}function d(g,n){const s=n.toLowerCase(),i=Object.keys(g).find(t=>t.toLowerCase()===s);return i?g[i]:g[n]}function P(g,n){const s=Object.create(null);for(const[i,t]of Object.entries(g))n(i,t)&&(s[i]=t);return s}function b(g){let n=[];for(;Object.prototype!==g;)n=n.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return n}function a(g){const n=[];for(const s of b(g))typeof g[s]=="function"&&n.push(s);return n}function u(g,n){const s=t=>function(){const l=Array.prototype.slice.call(arguments,0);return n(t,l)},i={};for(const t of g)i[t]=s(t);return i}function f(g,n){const s={};for(const[i,t]of Object.entries(g))s[i]=n(t,i);return s}}),define(ye[50],Se([1,0,83]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=A;var m;(function(L){function T(p){return p&&typeof p=="object"&&typeof p.id=="string"}L.isThemeColor=T})(m||(e.ThemeColor=m={}));function A(L){return{id:L}}var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function p(g){const n=T.exec(g.id);if(!n)return p(r.$Zj.error);const[,s,i]=n,t=["codicon","codicon-"+s];return i&&t.push("codicon-modifier-"+i.substring(1)),t}L.asClassNameArray=p;function c(g){return p(g).join(" ")}L.asClassName=c;function C(g){return"."+p(g).join(".")}L.asCSSSelector=C;function S(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||m.isThemeColor(g.color))}L.isThemeIcon=S;const d=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function P(g){const n=d.exec(g);if(!n)return;const[,s]=n;return{id:s}}L.fromString=P;function b(g){return{id:g}}L.fromId=b;function a(g,n){let s=g.id;const i=s.lastIndexOf("~");return i!==-1&&(s=s.substring(0,i)),n&&(s=`${s}~${n}`),{id:s}}L.modify=a;function u(g){const n=g.id.lastIndexOf("~");if(n!==-1)return g.id.substring(n+1)}L.getModifier=u;function f(g,n){return g.id===n.id&&g.color?.id===n.color?.id}L.isEqual=f})(R||(e.ThemeIcon=R={}))}),define(ye[84],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=m,e.$0e=A;var r;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function m(R){return R<0?0:R>r.MAX_UINT_8?r.MAX_UINT_8:R|0}function A(R){return R<0?0:R>r.MAX_UINT_32?r.MAX_UINT_32:R|0}}),define(ye[13],Se([1,0,181,27,49,84]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=L,e.$_e=p,e.$af=C,e.$bf=S,e.$cf=d,e.$df=P,e.$ef=b,e.$ff=a,e.$gf=u,e.$hf=f,e.$if=g,e.$jf=n,e.$kf=s,e.$lf=i,e.$mf=t,e.$nf=l,e.$of=h,e.$pf=o,e.$qf=$,e.$rf=E,e.$sf=k,e.$tf=D,e.$uf=v,e.$vf=I,e.$wf=w,e.$xf=y,e.$yf=N,e.$zf=O,e.$Af=U,e.$Bf=j,e.$Cf=z,e.$Df=M,e.$Ef=F,e.$Ff=J,e.$Gf=ee,e.$Hf=V,e.$If=H,e.$Lf=re,e.$Mf=ve,e.$Nf=pe,e.$Of=Q,e.$Pf=ae,e.$Qf=ce,e.$Sf=ue,e.$Tf=Z,e.$Uf=oe,e.$Vf=$e,e.$Wf=Ne,e.$Xf=Be,e.$Yf=Ie,e.$1f=Le,e.$2f=W,e.$3f=q,e.$4f=Y,e.$5f=x,e.$6f=fe,e.$7f=we,e.$8f=Me,e.$9f=tt;function L(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const T=/{(\d+)}/g;function p(Pe,...Ue){return Ue.length===0?Pe:Pe.replace(T,function(Ae,Te){const le=parseInt(Te,10);return isNaN(le)||le<0||le>=Ue.length?Ae:Ue[le]})}const c=/{([^}]+)}/g;function C(Pe,Ue){return Object.keys(Ue).length===0?Pe:Pe.replace(c,(Ae,Te)=>Ue[Te]??Ae)}function S(Pe){return Pe.replace(/[<>"'&]/g,Ue=>{switch(Ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ue})}function d(Pe){return Pe.replace(/[<>&]/g,function(Ue){switch(Ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ue}})}function P(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(Pe,Ue){let Ae=0,Te=Pe.indexOf(Ue);for(;Te!==-1;)Ae++,Te=Pe.indexOf(Ue,Te+Ue.length);return Ae}function a(Pe,Ue,Ae="\u2026"){return Pe.length<=Ue?Pe:`${Pe.substr(0,Ue)}${Ae}`}function u(Pe,Ue,Ae="\u2026"){if(Pe.length<=Ue)return Pe;const Te=Math.ceil(Ue/2)-Ae.length/2,le=Math.floor(Ue/2)-Ae.length/2;return`${Pe.substr(0,Te)}${Ae}${Pe.substr(Pe.length-le)}`}function f(Pe,Ue=" "){const Ae=g(Pe,Ue);return n(Ae,Ue)}function g(Pe,Ue){if(!Pe||!Ue)return Pe;const Ae=Ue.length;if(Ae===0||Pe.length===0)return Pe;let Te=0;for(;Pe.indexOf(Ue,Te)===Te;)Te=Te+Ae;return Pe.substring(Te)}function n(Pe,Ue){if(!Pe||!Ue)return Pe;const Ae=Ue.length,Te=Pe.length;if(Ae===0||Te===0)return Pe;let le=Te,X=-1;for(;X=Pe.lastIndexOf(Ue,le-1),!(X===-1||X+Ae!==le);){if(X===0)return"";le=X}return Pe.substring(0,le)}function s(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Pe){return Pe.replace(/\*/g,"")}function t(Pe,Ue,Ae={}){if(!Pe)throw new Error("Cannot create regex from empty string");Ue||(Pe=P(Pe)),Ae.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Te="";return Ae.global&&(Te+="g"),Ae.matchCase||(Te+="i"),Ae.multiline&&(Te+="m"),Ae.unicode&&(Te+="u"),new RegExp(Pe,Te)}function l(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function h(Pe){return Pe.split(/\r\n|\r|\n/)}function o(Pe){const Ue=[],Ae=Pe.split(/(\r\n|\r|\n)/);for(let Te=0;Te<Math.ceil(Ae.length/2);Te++)Ue.push(Ae[2*Te]+(Ae[2*Te+1]??""));return Ue}function $(Pe){for(let Ue=0,Ae=Pe.length;Ue<Ae;Ue++){const Te=Pe.charCodeAt(Ue);if(Te!==m.CharCode.Space&&Te!==m.CharCode.Tab)return Ue}return-1}function E(Pe,Ue=0,Ae=Pe.length){for(let Te=Ue;Te<Ae;Te++){const le=Pe.charCodeAt(Te);if(le!==m.CharCode.Space&&le!==m.CharCode.Tab)return Pe.substring(Ue,Te)}return Pe.substring(Ue,Ae)}function k(Pe,Ue=Pe.length-1){for(let Ae=Ue;Ae>=0;Ae--){const Te=Pe.charCodeAt(Ae);if(Te!==m.CharCode.Space&&Te!==m.CharCode.Tab)return Ae}return-1}function D(Pe,Ue,Ae){const Te=[];let le=0;for(const X of Pe.matchAll(Ue)){if(Te.push(Pe.slice(le,X.index)),X.index===void 0)throw new Error("match.index should be defined");le=X.index+X[0].length,Te.push(Ae(X[0],...X.slice(1),X.index,Pe,X.groups))}return Te.push(Pe.slice(le)),Promise.all(Te).then(X=>X.join(""))}function v(Pe,Ue){return Pe<Ue?-1:Pe>Ue?1:0}function I(Pe,Ue,Ae=0,Te=Pe.length,le=0,X=Ue.length){for(;Ae<Te&&le<X;Ae++,le++){const _e=Pe.charCodeAt(Ae),at=Ue.charCodeAt(le);if(_e<at)return-1;if(_e>at)return 1}const Ce=Te-Ae,Qe=X-le;return Ce<Qe?-1:Ce>Qe?1:0}function w(Pe,Ue){return y(Pe,Ue,0,Pe.length,0,Ue.length)}function y(Pe,Ue,Ae=0,Te=Pe.length,le=0,X=Ue.length){for(;Ae<Te&&le<X;Ae++,le++){let _e=Pe.charCodeAt(Ae),at=Ue.charCodeAt(le);if(_e===at)continue;if(_e>=128||at>=128)return I(Pe.toLowerCase(),Ue.toLowerCase(),Ae,Te,le,X);O(_e)&&(_e-=32),O(at)&&(at-=32);const lt=_e-at;if(lt!==0)return lt}const Ce=Te-Ae,Qe=X-le;return Ce<Qe?-1:Ce>Qe?1:0}function N(Pe){return Pe>=m.CharCode.Digit0&&Pe<=m.CharCode.Digit9}function O(Pe){return Pe>=m.CharCode.a&&Pe<=m.CharCode.z}function U(Pe){return Pe>=m.CharCode.A&&Pe<=m.CharCode.Z}function j(Pe,Ue){return Pe.length===Ue.length&&y(Pe,Ue)===0}function z(Pe,Ue){const Ae=Ue.length;return Ue.length>Pe.length?!1:y(Pe,Ue,0,Ae)===0}function M(Pe,Ue){const Ae=Math.min(Pe.length,Ue.length);let Te;for(Te=0;Te<Ae;Te++)if(Pe.charCodeAt(Te)!==Ue.charCodeAt(Te))return Te;return Ae}function F(Pe,Ue){const Ae=Math.min(Pe.length,Ue.length);let Te;const le=Pe.length-1,X=Ue.length-1;for(Te=0;Te<Ae;Te++)if(Pe.charCodeAt(le-Te)!==Ue.charCodeAt(X-Te))return Te;return Ae}function J(Pe){return 55296<=Pe&&Pe<=56319}function ee(Pe){return 56320<=Pe&&Pe<=57343}function V(Pe,Ue){return(Pe-55296<<10)+(Ue-56320)+65536}function H(Pe,Ue,Ae){const Te=Pe.charCodeAt(Ae);if(J(Te)&&Ae+1<Ue){const le=Pe.charCodeAt(Ae+1);if(ee(le))return V(Te,le)}return Te}function _(Pe,Ue){const Ae=Pe.charCodeAt(Ue-1);if(ee(Ae)&&Ue>1){const Te=Pe.charCodeAt(Ue-2);if(J(Te))return V(Te,Ae)}return Ae}class ne{get offset(){return this.e}constructor(Ue,Ae=0){this.c=Ue,this.d=Ue.length,this.e=Ae}setOffset(Ue){this.e=Ue}prevCodePoint(){const Ue=_(this.c,this.e);return this.e-=Ue>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ue}nextCodePoint(){const Ue=H(this.c,this.d,this.e);return this.e+=Ue>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ue}eol(){return this.e>=this.d}}e.$Jf=ne;class he{get offset(){return this.c.offset}constructor(Ue,Ae=0){this.c=new ne(Ue,Ae)}nextGraphemeLength(){const Ue=Ze.getInstance(),Ae=this.c,Te=Ae.offset;let le=Ue.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const X=Ae.offset,Ce=Ue.getGraphemeBreakType(Ae.nextCodePoint());if(qe(le,Ce)){Ae.setOffset(X);break}le=Ce}return Ae.offset-Te}prevGraphemeLength(){const Ue=Ze.getInstance(),Ae=this.c,Te=Ae.offset;let le=Ue.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const X=Ae.offset,Ce=Ue.getGraphemeBreakType(Ae.prevCodePoint());if(qe(Ce,le)){Ae.setOffset(X);break}le=Ce}return Te-Ae.offset}eol(){return this.c.eol()}}e.$Kf=he;function re(Pe,Ue){return new he(Pe,Ue).nextGraphemeLength()}function ve(Pe,Ue){return new he(Pe,Ue).prevGraphemeLength()}function pe(Pe,Ue){Ue>0&&ee(Pe.charCodeAt(Ue))&&Ue--;const Ae=Ue+re(Pe,Ue);return[Ae-ve(Pe,Ae),Ae]}function Q(Pe){const Ue=new he(Pe);let Ae=0;for(;!Ue.eol();)Ae++,Ue.nextGraphemeLength();return Ae}let B;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(Pe){return B||(B=se()),B.test(Pe)}const ie=/^[\t\n\r\x20-\x7E]*$/;function ce(Pe){return ie.test(Pe)}e.$Rf=/[\u2028\u2029]/;function ue(Pe){return e.$Rf.test(Pe)}function Z(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function oe(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function $e(Pe,Ue,Ae=""){const Te=Pe.trimStart();if(Te.length<Ue)return Te;const le=/\b/g;let X=0;for(;le.test(Te)&&!(Te.length-le.lastIndex<Ue);)X=le.lastIndex,le.lastIndex+=1;return X===0?Te:Ae+Te.substring(X).trimStart()}const be=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Ne(Pe){let Ue=0;for(const Ae of Pe.matchAll(be))Ue!==Ae.index&&(yield{isCode:!1,str:Pe.substring(Ue,Ae.index)}),yield{isCode:!0,str:Ae[0]},Ue=Ae.index+Ae[0].length;Ue!==Pe.length&&(yield{isCode:!1,str:Pe.substring(Ue)})}function Be(Pe){return Pe&&(Pe=Pe.replace(be,"")),Pe}const De=/\\\[.*?\\\]/g;function Ie(Pe){return Be(Pe).replace(De,"")}e.$Zf=String.fromCharCode(m.CharCode.UTF8_BOM);function Le(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===m.CharCode.UTF8_BOM)}function W(Pe){return Le(Pe)?Pe.substr(1):Pe}function q(Pe,Ue){if(!Pe||!Ue||Pe.length<Ue.length)return!1;const Ae=Ue.length,Te=Pe.toLowerCase();let le=0,X=-1;for(;le<Ae;){const Ce=Te.indexOf(Ue[le],X+1);if(Ce<0)return!1;X=Ce,le++}return!0}function Y(Pe,Ue=!1){return Pe?(Ue&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function x(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function fe(Pe,Ue=1){if(Ue===0)return"";let Ae=-1;do Ae=Pe.indexOf(`
`,Ae+1),Ue--;while(Ue>0&&Ae>=0);return Ae===-1?Pe:(Pe[Ae-1]==="\r"&&Ae--,Pe.substr(0,Ae))}function we(Pe){const Ue=m.CharCode.Z-m.CharCode.A+1;return Pe=Pe%(2*Ue),Pe<Ue?String.fromCharCode(m.CharCode.a+Pe):String.fromCharCode(m.CharCode.A+Pe-Ue)}function Me(Pe){return Ze.getInstance().getGraphemeBreakType(Pe)}function qe(Pe,Ue){return Pe===He.Other?Ue!==He.Extend&&Ue!==He.SpacingMark:Pe===He.CR&&Ue===He.LF?!1:Pe===He.Control||Pe===He.CR||Pe===He.LF||Ue===He.Control||Ue===He.CR||Ue===He.LF?!0:!(Pe===He.L&&(Ue===He.L||Ue===He.V||Ue===He.LV||Ue===He.LVT)||(Pe===He.LV||Pe===He.V)&&(Ue===He.V||Ue===He.T)||(Pe===He.LVT||Pe===He.T)&&Ue===He.T||Ue===He.Extend||Ue===He.ZWJ||Ue===He.SpacingMark||Pe===He.Prepend||Pe===He.ZWJ&&Ue===He.Extended_Pictographic||Pe===He.Regional_Indicator&&Ue===He.Regional_Indicator)}var He;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(He||(e.GraphemeBreakType=He={}));class Ze{static{this.c=null}static getInstance(){return Ze.c||(Ze.c=new Ze),Ze.c}constructor(){this.d=it()}getGraphemeBreakType(Ue){if(Ue<32)return Ue===m.CharCode.LineFeed?He.LF:Ue===m.CharCode.CarriageReturn?He.CR:He.Control;if(Ue<127)return He.Other;const Ae=this.d,Te=Ae.length/3;let le=1;for(;le<=Te;)if(Ue<Ae[3*le])le=2*le;else if(Ue>Ae[3*le+1])le=2*le+1;else return Ae[3*le+2];return He.Other}}function it(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(Pe,Ue){if(Pe===0)return 0;const Ae=rt(Pe,Ue);if(Ae!==void 0)return Ae;const Te=new ne(Ue,Pe);return Te.prevCodePoint(),Te.offset}function rt(Pe,Ue){const Ae=new ne(Ue,Pe);let Te=Ae.prevCodePoint();for(;ot(Te)||Te===ft.emojiVariantSelector||Te===ft.enclosingKeyCap;){if(Ae.offset===0)return;Te=Ae.prevCodePoint()}if(!oe(Te))return;let le=Ae.offset;return le>0&&Ae.prevCodePoint()===ft.zwj&&(le=Ae.offset),le}function ot(Pe){return 127995<=Pe&&Pe<=127999}var ft;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(ft||(ft={})),e.$0f="\xA0";class ut{static{this.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$7e({getCacheKey:JSON.stringify},Ue=>{function Ae(lt){const Dt=new Map;for(let Ct=0;Ct<lt.length;Ct+=2)Dt.set(lt[Ct],lt[Ct+1]);return Dt}function Te(lt,Dt){const Ct=new Map(lt);for(const[Ot,Yt]of Dt)Ct.set(Ot,Yt);return Ct}function le(lt,Dt){if(!lt)return Dt;const Ct=new Map;for(const[Ot,Yt]of lt)Dt.has(Ot)&&Ct.set(Ot,Yt);return Ct}const X=this.c.value;let Ce=Ue.filter(lt=>!lt.startsWith("_")&&lt in X);Ce.length===0&&(Ce=["_default"]);let Qe;for(const lt of Ce){const Dt=Ae(X[lt]);Qe=le(Qe,Dt)}const _e=Ae(X._common),at=Te(_e,Qe);return new ut(at)})}static getInstance(Ue){return ut.d.get(Array.from(Ue))}static{this.e=new A.$V(()=>Object.keys(ut.c.value).filter(Ue=>!Ue.startsWith("_")))}static getLocales(){return ut.e.value}constructor(Ue){this.f=Ue}isAmbiguous(Ue){return this.f.has(Ue)}containsAmbiguousCharacter(Ue){for(let Ae=0;Ae<Ue.length;Ae++){const Te=Ue.codePointAt(Ae);if(typeof Te=="number"&&this.isAmbiguous(Te))return!0}return!1}getPrimaryConfusable(Ue){return this.f.get(Ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=ut;class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(Ue){return st.e().has(Ue)}static containsInvisibleCharacter(Ue){for(let Ae=0;Ae<Ue.length;Ae++){const Te=Ue.codePointAt(Ae);if(typeof Te=="number"&&st.isInvisibleCharacter(Te))return!0}return!1}static get codePoints(){return st.e()}}e.$_f=st}),define(ye[134],Se([1,0,27,29,176,13]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.FuzzyScore=e.$Ck=e.$Bk=void 0,e.or=L,e.$Dk=p,e.$Ek=c,e.$Fk=d,e.$Gk=k,e.$Hk=D,e.$Ik=O,e.$Jk=U,e.$Kk=j,e.$Lk=z,e.$Mk=se,e.$Ok=ue,e.$Pk=$e,e.$Qk=be;function L(...De){return function(Ie,Le){for(let W=0,q=De.length;W<q;W++){const Y=De[W](Ie,Le);if(Y)return Y}return null}}e.$Bk=T.bind(void 0,!1),e.$Ck=T.bind(void 0,!0);function T(De,Ie,Le){if(!Le||Le.length<Ie.length)return null;let W;return De?W=R.$Cf(Le,Ie):W=Le.indexOf(Ie)===0,W?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function p(De,Ie){const Le=Ie.toLowerCase().indexOf(De.toLowerCase());return Le===-1?null:[{start:Le,end:Le+De.length}]}function c(De,Ie){return C(De.toLowerCase(),Ie.toLowerCase(),0,0)}function C(De,Ie,Le,W){if(Le===De.length)return[];if(W===Ie.length)return null;if(De[Le]===Ie[W]){let q=null;return(q=C(De,Ie,Le+1,W+1))?i({start:W,end:W+1},q):null}return C(De,Ie,Le,W+1)}function S(De){return r.CharCode.a<=De&&De<=r.CharCode.z}function d(De){return r.CharCode.A<=De&&De<=r.CharCode.Z}function P(De){return r.CharCode.Digit0<=De&&De<=r.CharCode.Digit9}function b(De){return De===r.CharCode.Space||De===r.CharCode.Tab||De===r.CharCode.LineFeed||De===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(De=>a.add(De.charCodeAt(0)));function u(De){return b(De)||a.has(De)}function f(De,Ie){return De===Ie||u(De)&&u(Ie)}const g=new Map;function n(De){if(g.has(De))return g.get(De);let Ie;const Le=(0,A.$zk)(De);return Le&&(Ie=Le),g.set(De,Ie),Ie}function s(De){return S(De)||d(De)||P(De)}function i(De,Ie){return Ie.length===0?Ie=[De]:De.end===Ie[0].start?Ie[0].start=De.start:Ie.unshift(De),Ie}function t(De,Ie){for(let Le=Ie;Le<De.length;Le++){const W=De.charCodeAt(Le);if(d(W)||P(W)||Le>0&&!s(De.charCodeAt(Le-1)))return Le}return De.length}function l(De,Ie,Le,W){if(Le===De.length)return[];if(W===Ie.length)return null;if(De[Le]!==Ie[W].toLowerCase())return null;{let q=null,Y=W+1;for(q=l(De,Ie,Le+1,W+1);!q&&(Y=t(Ie,Y))<Ie.length;)q=l(De,Ie,Le+1,Y),Y++;return q===null?null:i({start:W,end:W+1},q)}}function h(De){let Ie=0,Le=0,W=0,q=0,Y=0;for(let qe=0;qe<De.length;qe++)Y=De.charCodeAt(qe),d(Y)&&Ie++,S(Y)&&Le++,s(Y)&&W++,P(Y)&&q++;const x=Ie/De.length,fe=Le/De.length,we=W/De.length,Me=q/De.length;return{upperPercent:x,lowerPercent:fe,alphaPercent:we,numericPercent:Me}}function o(De){const{upperPercent:Ie,lowerPercent:Le}=De;return Le===0&&Ie>.6}function $(De){const{upperPercent:Ie,lowerPercent:Le,alphaPercent:W,numericPercent:q}=De;return Le>.2&&Ie<.8&&W>.6&&q<.2}function E(De){let Ie=0,Le=0,W=0,q=0;for(let Y=0;Y<De.length;Y++)W=De.charCodeAt(Y),d(W)&&Ie++,S(W)&&Le++,b(W)&&q++;return(Ie===0||Le===0)&&q===0?De.length<=30:Ie<=5}function k(De,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!E(De))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Le=h(Ie);if(!$(Le)){if(!o(Le))return null;Ie=Ie.toLowerCase()}let W=null,q=0;for(De=De.toLowerCase();q<Ie.length&&(W=l(De,Ie,0,q))===null;)q=t(Ie,q+1);return W}function D(De,Ie,Le=!1){if(!Ie||Ie.length===0)return null;let W=null,q=0;for(De=De.toLowerCase(),Ie=Ie.toLowerCase();q<Ie.length&&(W=v(De,Ie,0,q,Le),W===null);)q=I(Ie,q+1);return W}function v(De,Ie,Le,W,q){let Y=0;if(Le===De.length)return[];if(W===Ie.length)return null;if(!f(De.charCodeAt(Le),Ie.charCodeAt(W))){const we=n(De.charCodeAt(Le));if(!we)return null;for(let Me=0;Me<we.length;Me++)if(!f(we[Me],Ie.charCodeAt(W+Me)))return null;Y+=we.length-1}let x=null,fe=W+Y+1;if(x=v(De,Ie,Le+1,fe,q),!q)for(;!x&&(fe=I(Ie,fe))<Ie.length;)x=v(De,Ie,Le+1,fe,q),fe++;if(!x)return null;if(De.charCodeAt(Le)!==Ie.charCodeAt(W)){const we=n(De.charCodeAt(Le));if(!we)return x;for(let Me=0;Me<we.length;Me++)if(we[Me]!==Ie.charCodeAt(W+Me))return x}return i({start:W,end:W+Y+1},x)}function I(De,Ie){for(let Le=Ie;Le<De.length;Le++)if(u(De.charCodeAt(Le))||Le>0&&u(De.charCodeAt(Le-1)))return Le;return De.length}const w=L(e.$Ck,k,p),y=L(e.$Ck,k,c),N=new m.$Dc(1e4);function O(De,Ie,Le=!1){if(typeof De!="string"||typeof Ie!="string")return null;let W=N.get(De);W||(W=new RegExp(R.$kf(De),"i"),N.set(De,W));const q=W.exec(Ie);return q?[{start:q.index,end:q.index+q[0].length}]:Le?y(De,Ie):w(De,Ie)}function U(De,Ie){const Le=ue(De,De.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Le?z(Le):null}function j(De,Ie,Le,W,q,Y){const x=Math.min(13,De.length);for(;Le<x;Le++){const fe=ue(De,Ie,Le,W,q,Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,Y]}function z(De){if(typeof De>"u")return[];const Ie=[],Le=De[1];for(let W=De.length-1;W>1;W--){const q=De[W]+Le,Y=Ie[Ie.length-1];Y&&Y.end===q?Y.end=q+1:Ie.push({start:q,end:q+1})}return Ie}const M=128;function F(){const De=[],Ie=[];for(let Le=0;Le<=M;Le++)Ie[Le]=0;for(let Le=0;Le<=M;Le++)De.push(Ie.slice(0));return De}function J(De){const Ie=[];for(let Le=0;Le<=De;Le++)Ie[Le]=0;return Ie}const ee=J(2*M),V=J(2*M),H=F(),_=F(),ne=F(),he=!1;function re(De,Ie,Le,W,q){function Y(fe,we,Me=" "){for(;fe.length<we;)fe=Me+fe;return fe}let x=` |   |${W.split("").map(fe=>Y(fe,3)).join("|")}
`;for(let fe=0;fe<=Le;fe++)fe===0?x+=" |":x+=`${Ie[fe-1]}|`,x+=De[fe].slice(0,q+1).map(we=>Y(we.toString(),3)).join("|")+`
`;return x}function ve(De,Ie,Le,W){De=De.substr(Ie),Le=Le.substr(W),console.log(re(_,De,De.length,Le,Le.length)),console.log(re(ne,De,De.length,Le,Le.length)),console.log(re(H,De,De.length,Le,Le.length))}function pe(De,Ie){if(Ie<0||Ie>=De.length)return!1;const Le=De.codePointAt(Ie);switch(Le){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Uf(Le)}}function Q(De,Ie){if(Ie<0||Ie>=De.length)return!1;switch(De.charCodeAt(Ie)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function B(De,Ie,Le){return Ie[De]!==Le[De]}function se(De,Ie,Le,W,q,Y,x=!1){for(;Ie<Le&&q<Y;)De[Ie]===W[q]&&(x&&(ee[Ie]=q),Ie+=1),q+=1;return Ie===Le}var ae;(function(De){De[De.Diag=1]="Diag",De[De.Left=2]="Left",De[De.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var ie;(function(De){De.Default=[-100,0];function Ie(Le){return!Le||Le.length===2&&Le[0]===-100&&Le[1]===0}De.isDefault=Ie})(ie||(e.FuzzyScore=ie={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Le){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Le}}e.$Nk=ce;function ue(De,Ie,Le,W,q,Y,x=ce.default){const fe=De.length>M?M:De.length,we=W.length>M?M:W.length;if(Le>=fe||Y>=we||fe-Le>we-Y||!se(Ie,Le,fe,q,Y,we,!0))return;Z(fe,we,Le,Y,Ie,q);let Me=1,qe=1,He=Le,Ze=Y;const it=[!1];for(Me=1,He=Le;He<fe;Me++,He++){const ut=ee[He],st=V[He],Pe=He+1<fe?V[He+1]:we;for(qe=ut-Y+1,Ze=ut;Ze<Pe;qe++,Ze++){let Ue=Number.MIN_SAFE_INTEGER,Ae=!1;Ze<=st&&(Ue=oe(De,Ie,He,Le,W,q,Ze,we,Y,H[Me-1][qe-1]===0,it));let Te=0;Ue!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Te=Ue+_[Me-1][qe-1]);const le=Ze>ut,X=le?_[Me][qe-1]+(H[Me][qe-1]>0?-5:0):0,Ce=Ze>ut+1&&H[Me][qe-1]>0,Qe=Ce?_[Me][qe-2]+(H[Me][qe-2]>0?-5:0):0;if(Ce&&(!le||Qe>=X)&&(!Ae||Qe>=Te))_[Me][qe]=Qe,ne[Me][qe]=ae.LeftLeft,H[Me][qe]=0;else if(le&&(!Ae||X>=Te))_[Me][qe]=X,ne[Me][qe]=ae.Left,H[Me][qe]=0;else if(Ae)_[Me][qe]=Te,ne[Me][qe]=ae.Diag,H[Me][qe]=H[Me-1][qe-1]+1;else throw new Error("not possible")}}if(he&&ve(De,Le,W,Y),!it[0]&&!x.firstMatchCanBeWeak)return;Me--,qe--;const tt=[_[Me][qe],Y];let rt=0,ot=0;for(;Me>=1;){let ut=qe;do{const st=ne[Me][ut];if(st===ae.LeftLeft)ut=ut-2;else if(st===ae.Left)ut=ut-1;else break}while(ut>=1);rt>1&&Ie[Le+Me-1]===q[Y+qe-1]&&!B(ut+Y-1,W,q)&&rt+1>H[Me][ut]&&(ut=qe),ut===qe?rt++:rt=1,ot||(ot=ut),Me--,qe=ut-1,tt.push(qe)}we-Y===fe&&x.boostFullMatch&&(tt[0]+=2);const ft=ot-fe;return tt[0]-=ft,tt}function Z(De,Ie,Le,W,q,Y){let x=De-1,fe=Ie-1;for(;x>=Le&&fe>=W;)q[x]===Y[fe]&&(V[x]=fe,x--),fe--}function oe(De,Ie,Le,W,q,Y,x,fe,we,Me,qe){if(Ie[Le]!==Y[x])return Number.MIN_SAFE_INTEGER;let He=1,Ze=!1;return x===Le-W?He=De[Le]===q[x]?7:5:B(x,q,Y)&&(x===0||!B(x-1,q,Y))?(He=De[Le]===q[x]?7:5,Ze=!0):pe(Y,x)&&(x===0||!pe(Y,x-1))?He=5:(pe(Y,x-1)||Q(Y,x-1))&&(He=5,Ze=!0),He>1&&Le===W&&(qe[0]=!0),Ze||(Ze=B(x,q,Y)||pe(Y,x-1)||Q(Y,x-1)),Le===W?x>we&&(He-=Ze?3:5):Me?He+=Ze?2:0:He+=Ze?0:1,x+1===fe&&(He-=Ze?3:5),He}function $e(De,Ie,Le,W,q,Y,x){return Ne(De,Ie,Le,W,q,Y,!0,x)}function be(De,Ie,Le,W,q,Y,x){return Ne(De,Ie,Le,W,q,Y,!1,x)}function Ne(De,Ie,Le,W,q,Y,x,fe){let we=ue(De,Ie,Le,W,q,Y,fe);if(we&&!x)return we;if(De.length>=3){const Me=Math.min(7,De.length-1);for(let qe=Le+1;qe<Me;qe++){const He=Be(De,qe);if(He){const Ze=ue(He,He.toLowerCase(),Le,W,q,Y,fe);Ze&&(Ze[0]-=3,(!we||Ze[0]>we[0])&&(we=Ze))}}}return we}function Be(De,Ie){if(Ie+1>=De.length)return;const Le=De[Ie],W=De[Ie+1];if(Le!==W)return De.slice(0,Ie)+W+Le+De.slice(Ie+2)}}),define(ye[61],Se([1,0,13]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=m,e.$pj=A,e.$qj=R,e.$rj=T,e.$tj=a;function m(f){return A(f,0)}function A(f,g){switch(typeof f){case"object":return f===null?R(349,g):Array.isArray(f)?p(f,g):c(f,g);case"string":return T(f,g);case"boolean":return L(f,g);case"number":return R(f,g);case"undefined":return R(937,g);default:return R(617,g)}}function R(f,g){return(g<<5)-g+f|0}function L(f,g){return R(f?433:863,g)}function T(f,g){g=R(149417,g);for(let n=0,s=f.length;n<s;n++)g=R(f.charCodeAt(n),g);return g}function p(f,g){return g=R(104579,g),f.reduce((n,s)=>A(s,n),g)}function c(f,g){return g=R(181387,g),Object.keys(f).sort().reduce((n,s)=>(n=T(s,n),A(f[s],n)),g)}class C{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=A(g,this.g),this.g}}e.$sj=C;var S;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function d(f,g,n=32){const s=n-g,i=~((1<<s)-1);return(f<<g|(i&f)>>>s)>>>0}function P(f,g=0,n=f.byteLength,s=0){for(let i=0;i<n;i++)f[g+i]=s}function b(f,g,n="0"){for(;f.length<g;)f=n+f;return f}function a(f,g=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(n=>n.toString(16).padStart(2,"0")).join(""):b((f>>>0).toString(16),g/4)}class u{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(S.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const n=g.length;if(n===0)return;const s=this.p;let i=this.r,t=this.u,l,h;for(t!==0?(l=t,h=-1,t=0):(l=g.charCodeAt(0),h=0);;){let o=l;if(r.$Ff(l))if(h+1<n){const $=g.charCodeAt(h+1);r.$Gf($)?(h++,o=r.$Hf(l,$)):o=S.UNICODE_REPLACEMENT}else{t=l;break}else r.$Gf(l)&&(o=S.UNICODE_REPLACEMENT);if(i=this.w(s,i,o),h++,h<n)l=g.charCodeAt(h);else break}this.r=i,this.u=t}w(g,n,s){return s<128?g[n++]=s:s<2048?(g[n++]=192|(s&1984)>>>6,g[n++]=128|(s&63)>>>0):s<65536?(g[n++]=224|(s&61440)>>>12,g[n++]=128|(s&4032)>>>6,g[n++]=128|(s&63)>>>0):(g[n++]=240|(s&1835008)>>>18,g[n++]=128|(s&258048)>>>12,g[n++]=128|(s&4032)>>>6,g[n++]=128|(s&63)>>>0),n>=S.BLOCK_SIZE&&(this.y(),n-=S.BLOCK_SIZE,this.t+=S.BLOCK_SIZE,g[0]=g[S.BLOCK_SIZE+0],g[1]=g[S.BLOCK_SIZE+1],g[2]=g[S.BLOCK_SIZE+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,S.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=u.g,n=this.q;for(let k=0;k<64;k+=4)g.setUint32(k,n.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)g.setUint32(k,d(g.getUint32(k-12,!1)^g.getUint32(k-32,!1)^g.getUint32(k-56,!1)^g.getUint32(k-64,!1),1),!1);let s=this.h,i=this.l,t=this.m,l=this.n,h=this.o,o,$,E;for(let k=0;k<80;k++)k<20?(o=i&t|~i&l,$=1518500249):k<40?(o=i^t^l,$=1859775393):k<60?(o=i&t|i&l|t&l,$=2400959708):(o=i^t^l,$=3395469782),E=d(s,5)+o+h+$+g.getUint32(k*4,!1)&4294967295,h=l,l=t,t=d(i,30),i=s,s=E;this.h=this.h+s&4294967295,this.l=this.l+i&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+h&4294967295}}e.$uj=u}),define(ye[135],Se([1,0,134,13,50]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=p,e.$Sk=C,e.$Tk=d,e.$Uk=P,e.$Vk=a,e.$Wk=u;const R="$(",L=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${L.source}`,"g");function p(f){return f.replace(T,(g,n)=>n?g:`\\${g}`)}const c=new RegExp(`\\\\${L.source}`,"g");function C(f){return f.replace(c,g=>`\\${g}`)}const S=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function d(f){return f.indexOf(R)===-1?f:f.replace(S,(g,n,s,i)=>s?g:n||i||"")}function P(f){return f?f.replace(/\$\((.*?)\)/g,(g,n)=>` ${n} `).trim():""}const b=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(f){b.lastIndex=0;let g="";const n=[];let s=0;for(;;){const i=b.lastIndex,t=b.exec(f),l=f.substring(i,t?.index);if(l.length>0){g+=l;for(let h=0;h<l.length;h++)n.push(s)}if(!t)break;s+=t[0].length}return{text:g,iconOffsets:n}}function u(f,g,n=!1){const{text:s,iconOffsets:i}=g;if(!i||i.length===0)return(0,r.$Ik)(f,s,n);const t=(0,m.$if)(s," "),l=s.length-t.length,h=(0,r.$Ik)(f,t,n);if(h)for(const o of h){const $=i[o.start+l]+l;o.start+=$,o.end+=$}return h}}),define(ye[43],Se([1,0,13]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var m;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(m||(m={})),function(A){const R="error",L="warning",T="warn",p="info",c="ignore";function C(d){return d?r.$Bf(R,d)?A.Error:r.$Bf(L,d)||r.$Bf(T,d)?A.Warning:r.$Bf(p,d)?A.Info:A.Ignore:A.Ignore}A.fromValue=C;function S(d){switch(d){case A.Error:return R;case A.Warning:return L;case A.Info:return p;default:return c}}A.toString=S}(m||(m={})),e.default=m}),define(ye[85],Se([1,0,19,27,13]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class R{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const a=b.charCodeAt(0),u=this.b.charCodeAt(this.c);return a-u}value(){return this.b[this.c]}}e.$Ci=R;class L{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===m.CharCode.Period)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,A.$vf)(b,this.b,0,b.length,this.c,this.d):(0,A.$xf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=L;class T{constructor(b=!0,a=!0){this.f=b,this.g=a}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let a=b.length-1;a>=0;a--,this.c--){const u=this.b.charCodeAt(a);if(!(u===m.CharCode.Slash||this.f&&u===m.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===m.CharCode.Slash||this.f&&a===m.CharCode.Backslash)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,A.$vf)(b,this.b,0,b.length,this.d,this.e):(0,A.$xf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=T;var p;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(b,a){this.f=b,this.g=a,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new T(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(p.Path)),this.g(b)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===p.Scheme)return(0,A.$wf)(b,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,A.$wf)(b,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(b);if(this.d[this.e]===p.Query)return(0,A.$uf)(b,this.c.query);if(this.d[this.e]===p.Fragment)return(0,A.$uf)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Fi=c;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(S||(S={}));class d{static forUris(b=()=>!1,a=()=>!1){return new d(new c(b,a))}static forPaths(b=!1){return new d(new T(void 0,!b))}static forStrings(){return new d(new R)}static forConfigKeys(){return new d(new L)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,a){if(a){const u=a.slice(0);(0,r.$Wb)(u);for(const f of u)this.set(f,b)}else{const u=b.slice(0);(0,r.$Wb)(u);for(const f of u)this.set(f[0],f[1])}}set(b,a){const u=this.b.reset(b);let f;this.c||(this.c=new C,this.c.segment=u.value());const g=[];for(f=this.c;;){const s=u.cmp(f.segment);if(s>0)f.left||(f.left=new C,f.left.segment=u.value()),g.push([S.Left,f]),f=f.left;else if(s<0)f.right||(f.right=new C,f.right.segment=u.value()),g.push([S.Right,f]),f=f.right;else if(u.hasNext())u.next(),f.mid||(f.mid=new C,f.mid.segment=u.value()),g.push([S.Mid,f]),f=f.mid;else break}const n=f.value;f.value=a,f.key=b;for(let s=g.length-1;s>=0;s--){const i=g[s][1];i.updateHeight();const t=i.balanceFactor();if(t<-1||t>1){const l=g[s][0],h=g[s+1][0];if(l===S.Right&&h===S.Right)g[s][1]=i.rotateLeft();else if(l===S.Left&&h===S.Left)g[s][1]=i.rotateRight();else if(l===S.Right&&h===S.Left)i.right=g[s+1][1]=g[s+1][1].rotateRight(),g[s][1]=i.rotateLeft();else if(l===S.Left&&h===S.Right)i.left=g[s+1][1]=g[s+1][1].rotateLeft(),g[s][1]=i.rotateRight();else throw new Error;if(s>0)switch(g[s-1][0]){case S.Left:g[s-1][1].left=g[s][1];break;case S.Right:g[s-1][1].right=g[s][1];break;case S.Mid:g[s-1][1].mid=g[s][1];break}else this.c=g[0][1]}}return n}get(b){return this.d(b)?.value}d(b){const a=this.b.reset(b);let u=this.c;for(;u;){const f=a.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(a.hasNext())a.next(),u=u.mid;else break}return u}has(b){const a=this.d(b);return!(a?.value===void 0&&a?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,a){const u=this.b.reset(b),f=[];let g=this.c;for(;g;){const n=u.cmp(g.segment);if(n>0)f.push([S.Left,g]),g=g.left;else if(n<0)f.push([S.Right,g]),g=g.right;else if(u.hasNext())u.next(),f.push([S.Mid,g]),g=g.mid;else break}if(g){if(a?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const n=this.f(g.right);if(n.key){const{key:s,value:i,segment:t}=n;this.e(n.key,!1),g.key=s,g.value=i,g.segment=t}}else{const n=g.left??g.right;if(f.length>0){const[s,i]=f[f.length-1];switch(s){case S.Left:i.left=n;break;case S.Mid:i.mid=n;break;case S.Right:i.right=n;break}}else this.c=n}for(let n=f.length-1;n>=0;n--){const s=f[n][1];s.updateHeight();const i=s.balanceFactor();if(i>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),f[n][1]=s.rotateLeft()):i<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),f[n][1]=s.rotateRight()),n>0)switch(f[n-1][0]){case S.Left:f[n-1][1].left=f[n][1];break;case S.Right:f[n-1][1].right=f[n][1];break;case S.Mid:f[n-1][1].mid=f[n][1];break}else this.c=f[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const a=this.b.reset(b);let u=this.c,f;for(;u;){const g=a.cmp(u.segment);if(g>0)u=u.left;else if(g<0)u=u.right;else if(a.hasNext())a.next(),f=u.value||f,u=u.mid;else break}return u&&u.value||f}findSuperstr(b){return this.g(b,!1)}g(b,a){const u=this.b.reset(b);let f=this.c;for(;f;){const g=u.cmp(f.segment);if(g>0)f=f.left;else if(g<0)f=f.right;else if(u.hasNext())u.next(),f=f.mid;else return f.mid?this.h(f.mid):a?f.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[a,u]of this)b(u,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const a=[];return this.j(b,a),a[Symbol.iterator]()}j(b,a){b&&(b.left&&this.j(b.left,a),b.value&&a.push([b.key,b.value]),b.mid&&this.j(b.mid,a),b.right&&this.j(b.right,a))}_isBalanced(){const b=a=>{if(!a)return!0;const u=a.balanceFactor();return u<-1||u>1?!1:b(a.left)&&b(a.right)};return b(this.c)}}e.$Gi=d}),define(ye[32],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=m;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function m(A){return r.test(A)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(T){for(let p=0;p<T.length;p++)T[p]=Math.floor(Math.random()*256);return T};const R=new Uint8Array(16),L=[];for(let T=0;T<256;T++)L.push(T.toString(16).padStart(2,"0"));return function(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let p=0,c="";return c+=L[R[p++]],c+=L[R[p++]],c+=L[R[p++]],c+=L[R[p++]],c+="-",c+=L[R[p++]],c+=L[R[p++]],c+="-",c+=L[R[p++]],c+=L[R[p++]],c+="-",c+=L[R[p++]],c+=L[R[p++]],c+="-",c+=L[R[p++]],c+=L[R[p++]],c+=L[R[p++]],c+=L[R[p++]],c+=L[R[p++]],c+=L[R[p++]],c}}()}),define(ye[185],Se([1,0,19,40,32]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.$0s=void 0,e.$8s=R,e.$9s=L,e.$$s=c;function R(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function L(S,d,P){const b={id:(0,A.$Wg)(),name:S,uri:d,data:P};return{asString:async()=>"",asFile:()=>b,value:void 0}}class T{constructor(){this.a=new Map}get size(){let d=0;for(const P of this.a)d++;return d}has(d){return this.a.has(this.b(d))}matches(d){const P=[...this.a.keys()];return m.Iterable.some(this,([b,a])=>a.asFile())&&P.push("files"),C(p(d),P)}get(d){return this.a.get(this.b(d))?.[0]}append(d,P){const b=this.a.get(d);b?b.push(P):this.a.set(this.b(d),[P])}replace(d,P){this.a.set(this.b(d),[P])}delete(d){this.a.delete(this.b(d))}*[Symbol.iterator](){for(const[d,P]of this.a)for(const b of P)yield[d,b]}b(d){return p(d)}}e.$0s=T;function p(S){return S.toLowerCase()}function c(S,d){return C(p(S),d.map(p))}function C(S,d){if(S==="*/*")return d.length>0;if(d.includes(S))return!0;const P=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[b,a,u]=P;return u==="*"?d.some(f=>f.startsWith(a+"/")):!1}e.$_s=Object.freeze({create:S=>(0,r.$Mb)(S.map(d=>d.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$_s.split(S).filter(d=>!d.startsWith("#"))})}),define(ye[186],Se([1,0,66]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=m,e.$1g=R;function m(T,p,c,C=1){let S=!1;return new Promise(d=>{const P=setTimeout(()=>{if(!S)return S=!0,d(0)},c);A(T,p,C,b=>{if(!S)return S=!0,clearTimeout(P),d(b)})})}function A(T,p,c,C){if(p===0)return C(0);const S=new r.Socket;S.once("connect",()=>(L(S),A(T+c,p-1,c,C))),S.once("data",()=>{}),S.once("error",d=>(L(S),d.code!=="ECONNREFUSED"?A(T+c,p-1,c,C):C(T))),S.connect(T,"127.0.0.1")}e.$Zg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(T,p,c,C="127.0.0.1"){let S=!1,d,P=1;const b=r.createServer({pauseOnConnect:!0});function a(u,f){S||(S=!0,b.removeAllListeners(),b.close(),d&&clearTimeout(d),f(u))}return new Promise(u=>{d=setTimeout(()=>{a(0,u)},c),b.on("listening",()=>{a(T,u)}),b.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&P<p?(T++,P++,b.listen(T,C)):a(0,u)}),b.on("close",()=>{a(0,u)}),b.listen(T,C)})}function L(T){try{T.removeAllListeners("connect"),T.removeAllListeners("error"),T.end(),T.destroy(),T.unref()}catch(p){console.error(p)}}}),define(ye[136],Se([1,0,84]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$nt=void 0;class m{constructor(T){const p=(0,r.$9e)(T);this.c=p,this.a=m.d(p),this.b=new Map}static d(T){const p=new Uint8Array(256);return p.fill(T),p}set(T,p){const c=(0,r.$9e)(p);T>=0&&T<256?this.a[T]=c:this.b.set(T,c)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$nt=m;var A;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(A||(A={}));class R{constructor(){this.a=new m(A.False)}add(T){this.a.set(T,A.True)}has(T){return this.a.get(T)===A.True}clear(){return this.a.clear()}}e.$ot=R}),define(ye[187],Se([1,0,27]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$jv=A;var m;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(m||(e.StringEOL=m={}));function A(R){let L=0,T=0,p=0,c=m.Unknown;for(let C=0,S=R.length;C<S;C++){const d=R.charCodeAt(C);d===r.CharCode.CarriageReturn?(L===0&&(T=C),L++,C+1<S&&R.charCodeAt(C+1)===r.CharCode.LineFeed?(c|=m.CRLF,C++):c|=m.Invalid,p=C+1):d===r.CharCode.LineFeed&&(c|=m.LF,L===0&&(T=C),L++,p=C+1)}return L===0&&(T=R.length),[L,T,R.length-p,c]}}),define(ye[54],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=void 0;class r{constructor(A,R){this.lineNumber=A,this.column=R}with(A=this.lineNumber,R=this.column){return A===this.lineNumber&&R===this.column?this:new r(A,R)}delta(A=0,R=0){return this.with(this.lineNumber+A,this.column+R)}equals(A){return r.equals(this,A)}static equals(A,R){return!A&&!R?!0:!!A&&!!R&&A.lineNumber===R.lineNumber&&A.column===R.column}isBefore(A){return r.isBefore(this,A)}static isBefore(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<R.column}isBeforeOrEqual(A){return r.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<=R.column}static compare(A,R){const L=A.lineNumber|0,T=R.lineNumber|0;if(L===T){const p=A.column|0,c=R.column|0;return p-c}return L-T}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new r(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$bt=r}),define(ye[31],Se([1,0,54]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class m{constructor(R,L,T,p){R>T||R===T&&L>p?(this.startLineNumber=T,this.startColumn=p,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=T,this.endColumn=p)}isEmpty(){return m.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return m.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return m.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return m.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return m.plusRange(this,R)}static plusRange(R,L){let T,p,c,C;return L.startLineNumber<R.startLineNumber?(T=L.startLineNumber,p=L.startColumn):L.startLineNumber===R.startLineNumber?(T=L.startLineNumber,p=Math.min(L.startColumn,R.startColumn)):(T=R.startLineNumber,p=R.startColumn),L.endLineNumber>R.endLineNumber?(c=L.endLineNumber,C=L.endColumn):L.endLineNumber===R.endLineNumber?(c=L.endLineNumber,C=Math.max(L.endColumn,R.endColumn)):(c=R.endLineNumber,C=R.endColumn),new m(T,p,c,C)}intersectRanges(R){return m.intersectRanges(this,R)}static intersectRanges(R,L){let T=R.startLineNumber,p=R.startColumn,c=R.endLineNumber,C=R.endColumn;const S=L.startLineNumber,d=L.startColumn,P=L.endLineNumber,b=L.endColumn;return T<S?(T=S,p=d):T===S&&(p=Math.max(p,d)),c>P?(c=P,C=b):c===P&&(C=Math.min(C,b)),T>c||T===c&&p>C?null:new m(T,p,c,C)}equalsRange(R){return m.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return m.getEndPosition(this)}static getEndPosition(R){return new r.$bt(R.endLineNumber,R.endColumn)}getStartPosition(){return m.getStartPosition(this)}static getStartPosition(R){return new r.$bt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new m(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new m(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return m.collapseToStart(this)}static collapseToStart(R){return new m(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return m.collapseToEnd(this)}static collapseToEnd(R){return new m(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new m(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new m(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new m(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const c=R.startLineNumber|0,C=L.startLineNumber|0;if(c===C){const S=R.startColumn|0,d=L.startColumn|0;if(S===d){const P=R.endLineNumber|0,b=L.endLineNumber|0;if(P===b){const a=R.endColumn|0,u=L.endColumn|0;return a-u}return P-b}return S-d}return c-C}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$ct=m}),define(ye[188],Se([1,0,31]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class m{static insert(R,L){return{range:new r.$ct(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.$dt=m}),define(ye[189],Se([1,0,54,31]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.SelectionDirection=void 0;var A;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(A||(e.SelectionDirection=A={}));class R extends m.$ct{constructor(T,p,c,C){super(T,p,c,C),this.selectionStartLineNumber=T,this.selectionStartColumn=p,this.positionLineNumber=c,this.positionColumn=C}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return R.selectionsEqual(this,T)}static selectionsEqual(T,p){return T.selectionStartLineNumber===p.selectionStartLineNumber&&T.selectionStartColumn===p.selectionStartColumn&&T.positionLineNumber===p.positionLineNumber&&T.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?A.LTR:A.RTL}setEndPosition(T,p){return this.getDirection()===A.LTR?new R(this.startLineNumber,this.startColumn,T,p):new R(T,p,this.startLineNumber,this.startColumn)}getPosition(){return new r.$bt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$bt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,p){return this.getDirection()===A.LTR?new R(T,p,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,T,p)}static fromPositions(T,p=T){return new R(T.lineNumber,T.column,p.lineNumber,p.column)}static fromRange(T,p){return p===A.LTR?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new R(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new R(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,p){if(T&&!p||!T&&p)return!1;if(!T&&!p)return!0;if(T.length!==p.length)return!1;for(let c=0,C=T.length;c<C;c++)if(!this.selectionsEqual(T[c],p[c]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,p,c,C,S){return S===A.LTR?new R(T,p,c,C):new R(c,C,T,p)}}e.$et=R}),define(ye[190],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nu=void 0,e.$nu={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[191],Se([1,0,27,29,136]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pt=e.WordCharacterClass=void 0,e.$qt=p;var R;(function(c){c[c.Regular=0]="Regular",c[c.Whitespace=1]="Whitespace",c[c.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class L extends A.$nt{constructor(C,S){super(R.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=S,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let d=0,P=C.length;d<P;d++)this.set(C.charCodeAt(d),R.WordSeparator);this.set(r.CharCode.Space,R.Whitespace),this.set(r.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(C,S){let d=null;for(const P of this.h(C)){if(P.index>S)break;d=P}return d}findNextIntlWordAtOrAfterOffset(C,S){for(const d of this.h(C))if(!(d.index<S))return d;return null}h(C){return this.e?this.f===C?this.g:(this.f=C,this.g=this.j(this.e.segment(C)),this.g):[]}j(C){const S=[];for(const d of C)this.k(d)&&S.push(d);return S}k(C){return!!C.isWordLike}}e.$pt=L;const T=new m.$Dc(10);function p(c,C){const S=`${c}/${C.join(",")}`;let d=T.get(S);return d||(d=new L(c,C),T.set(S,d)),d}}),define(ye[137],Se([1,0,40,3,81]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.$rt=void 0,e.$tt=L,e.$ut=p,e.$vt=c,e.$rt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(S=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$rt)S.indexOf(P)>=0||(d+="\\"+P);return d+="\\s]+)",new RegExp(d,"g")}e.$st=R();function L(S){let d=e.$st;if(S&&S instanceof RegExp)if(S.global)d=S;else{let P="g";S.ignoreCase&&(P+="i"),S.multiline&&(P+="m"),S.unicode&&(P+="u"),d=new RegExp(S.source,P)}return d.lastIndex=0,d}const T=new A.$5c;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(S){const d=T.unshift(S);return(0,m.$Sc)(d)}function c(S,d,P,b,a){if(d=L(d),a||(a=r.Iterable.first(T)),P.length>a.maxLen){let s=S-a.maxLen/2;return s<0?s=0:b+=s,P=P.substring(s,S+a.maxLen/2),c(S,d,P,b,a)}const u=Date.now(),f=S-1-b;let g=-1,n=null;for(let s=1;!(Date.now()-u>=a.timeBudget);s++){const i=f-a.windowSize*s;d.lastIndex=Math.max(0,i);const t=C(d,P,f,g);if(!t&&n||(n=t,i<=0))break;g=i}if(n){const s={word:n[0],startColumn:b+1+n.index,endColumn:b+1+n.index+n[0].length};return d.lastIndex=0,s}return null}function C(S,d,P,b){let a;for(;a=S.exec(d);){const u=a.index||0;if(u<=P&&S.lastIndex>=P)return a;if(b>0&&u>b)return null}return null}}),define(ye[105],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var m;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline",p[p.Strikethrough=8]="Strikethrough"})(m||(e.FontStyle=m={}));var A;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(A||(e.ColorId=A={}));var R;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var L;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",p[p.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",p[p.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",p[p.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class T{static getLanguageId(c){return(c&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(c){return(c&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(c){return(c&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(c){return(c&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(c){return(c&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(c){return(c&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(c){let S="mtk"+this.getForeground(c);const d=this.getFontStyle(c);return d&m.Italic&&(S+=" mtki"),d&m.Bold&&(S+=" mtkb"),d&m.Underline&&(S+=" mtku"),d&m.Strikethrough&&(S+=" mtks"),S}static getInlineStyleFromMetadata(c,C){const S=this.getForeground(c),d=this.getFontStyle(c);let P=`color: ${C[S]};`;d&m.Italic&&(P+="font-style: italic;"),d&m.Bold&&(P+="font-weight: bold;");let b="";return d&m.Underline&&(b+=" underline"),d&m.Strikethrough&&(b+=" line-through"),b&&(P+=`text-decoration:${b};`),P}static getPresentationFromMetadata(c){const C=this.getForeground(c),S=this.getFontStyle(c);return{foreground:C,italic:!!(S&m.Italic),bold:!!(S&m.Bold),underline:!!(S&m.Underline),strikethrough:!!(S&m.Strikethrough)}}}e.$ft=T}),define(ye[192],Se([1,0,27,105]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.$Ct=e.IndentAction=void 0;var A;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(A||(e.IndentAction=A={}));class R{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let C=0,S=c.notIn.length;C<S;C++)switch(c.notIn[C]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case m.StandardTokenType.Other:return!0;case m.StandardTokenType.Comment:return this.c;case m.StandardTokenType.String:return this.b;case m.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,C){if(c.getTokenCount()===0)return!0;const S=c.findTokenIndexAtOffset(C-2),d=c.getStandardTokenType(S);return this.isOK(d)}g(c,C){for(let S=c;S<=C;S++){const d=String.fromCharCode(S);if(!this.open.includes(d)&&!this.close.includes(d))return d}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Ct=R;class L{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of c)T(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),T(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),T(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),T(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&T(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.$Dt=L;function T(p,c,C){p.has(c)?p.get(c).push(C):p.set(c,[C])}}),define(ye[193],Se([1,0,27,136]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$62=e.$52=e.State=void 0,e.$72=P;var A;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(A||(e.State=A={}));class R{constructor(a,u,f){const g=new Uint8Array(a*u);for(let n=0,s=a*u;n<s;n++)g[n]=f;this.a=g,this.rows=a,this.cols=u}get(a,u){return this.a[a*this.cols+u]}set(a,u,f){this.a[a*this.cols+u]=f}}class L{constructor(a){let u=0,f=A.Invalid;for(let n=0,s=a.length;n<s;n++){const[i,t,l]=a[n];t>u&&(u=t),i>f&&(f=i),l>f&&(f=l)}u++,f++;const g=new R(f,u,A.Invalid);for(let n=0,s=a.length;n<s;n++){const[i,t,l]=a[n];g.set(i,t,l)}this.a=g,this.b=u}nextState(a,u){return u<0||u>=this.b?A.Invalid:this.a.get(a,u)}}e.$52=L;let T=null;function p(){return T===null&&(T=new L([[A.Start,r.CharCode.h,A.H],[A.Start,r.CharCode.H,A.H],[A.Start,r.CharCode.f,A.F],[A.Start,r.CharCode.F,A.F],[A.H,r.CharCode.t,A.HT],[A.H,r.CharCode.T,A.HT],[A.HT,r.CharCode.t,A.HTT],[A.HT,r.CharCode.T,A.HTT],[A.HTT,r.CharCode.p,A.HTTP],[A.HTT,r.CharCode.P,A.HTTP],[A.HTTP,r.CharCode.s,A.BeforeColon],[A.HTTP,r.CharCode.S,A.BeforeColon],[A.HTTP,r.CharCode.Colon,A.AfterColon],[A.F,r.CharCode.i,A.FI],[A.F,r.CharCode.I,A.FI],[A.FI,r.CharCode.l,A.FIL],[A.FI,r.CharCode.L,A.FIL],[A.FIL,r.CharCode.e,A.BeforeColon],[A.FIL,r.CharCode.E,A.BeforeColon],[A.BeforeColon,r.CharCode.Colon,A.AfterColon],[A.AfterColon,r.CharCode.Slash,A.AlmostThere],[A.AlmostThere,r.CharCode.Slash,A.End]])),T}var c;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(c||(c={}));let C=null;function S(){if(C===null){C=new m.$nt(c.None);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<b.length;u++)C.set(b.charCodeAt(u),c.ForceTermination);const a=".,;:";for(let u=0;u<a.length;u++)C.set(a.charCodeAt(u),c.CannotEndIn)}return C}class d{static a(a,u,f,g,n){let s=n-1;do{const i=u.charCodeAt(s);if(a.get(i)!==c.CannotEndIn)break;s--}while(s>g);if(g>0){const i=u.charCodeAt(g-1),t=u.charCodeAt(s);(i===r.CharCode.OpenParen&&t===r.CharCode.CloseParen||i===r.CharCode.OpenSquareBracket&&t===r.CharCode.CloseSquareBracket||i===r.CharCode.OpenCurlyBrace&&t===r.CharCode.CloseCurlyBrace)&&s--}return{range:{startLineNumber:f,startColumn:g+1,endLineNumber:f,endColumn:s+2},url:u.substring(g,s+1)}}static computeLinks(a,u=p()){const f=S(),g=[];for(let n=1,s=a.getLineCount();n<=s;n++){const i=a.getLineContent(n),t=i.length;let l=0,h=0,o=0,$=A.Start,E=!1,k=!1,D=!1,v=!1;for(;l<t;){let I=!1;const w=i.charCodeAt(l);if($===A.Accept){let y;switch(w){case r.CharCode.OpenParen:E=!0,y=c.None;break;case r.CharCode.CloseParen:y=E?c.None:c.ForceTermination;break;case r.CharCode.OpenSquareBracket:D=!0,k=!0,y=c.None;break;case r.CharCode.CloseSquareBracket:D=!1,y=k?c.None:c.ForceTermination;break;case r.CharCode.OpenCurlyBrace:v=!0,y=c.None;break;case r.CharCode.CloseCurlyBrace:y=v?c.None:c.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:o===w?y=c.ForceTermination:o===r.CharCode.SingleQuote||o===r.CharCode.DoubleQuote||o===r.CharCode.BackTick?y=c.None:y=c.ForceTermination;break;case r.CharCode.Asterisk:y=o===r.CharCode.Asterisk?c.ForceTermination:c.None;break;case r.CharCode.Pipe:y=o===r.CharCode.Pipe?c.ForceTermination:c.None;break;case r.CharCode.Space:y=D?c.None:c.ForceTermination;break;default:y=f.get(w)}y===c.ForceTermination&&(g.push(d.a(f,i,n,h,l)),I=!0)}else if($===A.End){let y;w===r.CharCode.OpenSquareBracket?(k=!0,y=c.None):y=f.get(w),y===c.ForceTermination?I=!0:$=A.Accept}else $=u.nextState($,w),$===A.Invalid&&(I=!0);I&&($=A.Start,E=!1,k=!1,v=!1,h=l+1,o=w),l++}$===A.Accept&&g.push(d.a(f,i,n,h,t))}return g}}e.$62=d;function P(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:d.computeLinks(b)}}),define(ye[55],Se([1,0,25]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$rv=e.$qv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$sv=b,e.$wv=s;var m;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(m||(e.OverviewRulerLane=m={}));var A;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=3]="Right"})(A||(e.GlyphMarginLane=A={}));var R;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(i){i[i.Normal=1]="Normal",i[i.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var T;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(T||(e.InjectedTextCursorStops=T={}));var p;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var c;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(c||(e.DefaultEndOfLine=c={}));var C;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(C||(e.EndOfLineSequence=C={}));class S{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,r.$ao)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$qv=S;class d{constructor(t,l){this._findMatchBrand=void 0,this.range=t,this.matches=l}}e.$rv=d;var P;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function b(i){return i&&typeof i.read=="function"}var a;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var u;(function(i){i[i.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u||(e.ModelConstants=u={}));class f{constructor(t,l,h,o,$,E){this.identifier=t,this.range=l,this.text=h,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=$,this._isTracked=E}}e.$tv=f;class g{constructor(t,l,h){this.regex=t,this.wordSeparators=l,this.simpleSearch=h}}e.$uv=g;class n{constructor(t,l,h){this.reverseEdits=t,this.changes=l,this.trimAutoWhitespaceLineNumbers=h}}e.$vv=n;function s(i){return!i.isTooLargeForSyncing()&&!i.isForSimpleWidget}}),define(ye[194],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RC=e.NodeColor=e.$QC=void 0,e.$SC=A,e.$TC=R,e.$UC=c,e.$VC=C,e.$WC=S,e.$XC=d,e.$YC=P,e.$ZC=b;class r{constructor(u,f){this.piece=u,this.color=f,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$RC)return A(this.right);let u=this;for(;u.parent!==e.$RC&&u.parent.left!==u;)u=u.parent;return u.parent===e.$RC?e.$RC:u.parent}prev(){if(this.left!==e.$RC)return R(this.left);let u=this;for(;u.parent!==e.$RC&&u.parent.right!==u;)u=u.parent;return u.parent===e.$RC?e.$RC:u.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$QC=r;var m;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(m||(e.NodeColor=m={})),e.$RC=new r(null,m.Black),e.$RC.parent=e.$RC,e.$RC.left=e.$RC,e.$RC.right=e.$RC,e.$RC.color=m.Black;function A(a){for(;a.left!==e.$RC;)a=a.left;return a}function R(a){for(;a.right!==e.$RC;)a=a.right;return a}function L(a){return a===e.$RC?0:a.size_left+a.piece.length+L(a.right)}function T(a){return a===e.$RC?0:a.lf_left+a.piece.lineFeedCnt+T(a.right)}function p(){e.$RC.parent=e.$RC}function c(a,u){const f=u.right;f.size_left+=u.size_left+(u.piece?u.piece.length:0),f.lf_left+=u.lf_left+(u.piece?u.piece.lineFeedCnt:0),u.right=f.left,f.left!==e.$RC&&(f.left.parent=u),f.parent=u.parent,u.parent===e.$RC?a.root=f:u.parent.left===u?u.parent.left=f:u.parent.right=f,f.left=u,u.parent=f}function C(a,u){const f=u.left;u.left=f.right,f.right!==e.$RC&&(f.right.parent=u),f.parent=u.parent,u.size_left-=f.size_left+(f.piece?f.piece.length:0),u.lf_left-=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),u.parent===e.$RC?a.root=f:u===u.parent.right?u.parent.right=f:u.parent.left=f,f.right=u,u.parent=f}function S(a,u){let f,g;if(u.left===e.$RC?(g=u,f=g.right):u.right===e.$RC?(g=u,f=g.left):(g=A(u.right),f=g.right),g===a.root){a.root=f,f.color=m.Black,u.detach(),p(),a.root.parent=e.$RC;return}const n=g.color===m.Red;if(g===g.parent.left?g.parent.left=f:g.parent.right=f,g===u?(f.parent=g.parent,b(a,f)):(g.parent===u?f.parent=g:f.parent=g.parent,b(a,f),g.left=u.left,g.right=u.right,g.parent=u.parent,g.color=u.color,u===a.root?a.root=g:u===u.parent.left?u.parent.left=g:u.parent.right=g,g.left!==e.$RC&&(g.left.parent=g),g.right!==e.$RC&&(g.right.parent=g),g.size_left=u.size_left,g.lf_left=u.lf_left,b(a,g)),u.detach(),f.parent.left===f){const i=L(f),t=T(f);if(i!==f.parent.size_left||t!==f.parent.lf_left){const l=i-f.parent.size_left,h=t-f.parent.lf_left;f.parent.size_left=i,f.parent.lf_left=t,P(a,f.parent,l,h)}}if(b(a,f.parent),n){p();return}let s;for(;f!==a.root&&f.color===m.Black;)f===f.parent.left?(s=f.parent.right,s.color===m.Red&&(s.color=m.Black,f.parent.color=m.Red,c(a,f.parent),s=f.parent.right),s.left.color===m.Black&&s.right.color===m.Black?(s.color=m.Red,f=f.parent):(s.right.color===m.Black&&(s.left.color=m.Black,s.color=m.Red,C(a,s),s=f.parent.right),s.color=f.parent.color,f.parent.color=m.Black,s.right.color=m.Black,c(a,f.parent),f=a.root)):(s=f.parent.left,s.color===m.Red&&(s.color=m.Black,f.parent.color=m.Red,C(a,f.parent),s=f.parent.left),s.left.color===m.Black&&s.right.color===m.Black?(s.color=m.Red,f=f.parent):(s.left.color===m.Black&&(s.right.color=m.Black,s.color=m.Red,c(a,s),s=f.parent.left),s.color=f.parent.color,f.parent.color=m.Black,s.left.color=m.Black,C(a,f.parent),f=a.root));f.color=m.Black,p()}function d(a,u){for(b(a,u);u!==a.root&&u.parent.color===m.Red;)if(u.parent===u.parent.parent.left){const f=u.parent.parent.right;f.color===m.Red?(u.parent.color=m.Black,f.color=m.Black,u.parent.parent.color=m.Red,u=u.parent.parent):(u===u.parent.right&&(u=u.parent,c(a,u)),u.parent.color=m.Black,u.parent.parent.color=m.Red,C(a,u.parent.parent))}else{const f=u.parent.parent.left;f.color===m.Red?(u.parent.color=m.Black,f.color=m.Black,u.parent.parent.color=m.Red,u=u.parent.parent):(u===u.parent.left&&(u=u.parent,C(a,u)),u.parent.color=m.Black,u.parent.parent.color=m.Red,c(a,u.parent.parent))}a.root.color=m.Black}function P(a,u,f,g){for(;u!==a.root&&u!==e.$RC;)u.parent.left===u&&(u.parent.size_left+=f,u.parent.lf_left+=g),u=u.parent}function b(a,u){let f=0,g=0;if(u!==a.root){for(;u!==a.root&&u===u.parent.right;)u=u.parent;if(u!==a.root)for(u=u.parent,f=L(u.left)-u.size_left,g=T(u.left)-u.lf_left,u.size_left+=f,u.lf_left+=g;u!==a.root&&(f!==0||g!==0);)u.parent.left===u&&(u.parent.size_left+=f,u.parent.lf_left+=g),u=u.parent}}}),define(ye[195],Se([1,0,19,84]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bw=e.$aw=e.$_v=void 0;class A{constructor(p){this.a=p,this.b=new Uint32Array(p.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(p,c){p=(0,m.$0e)(p);const C=this.a,S=this.b,d=c.length;return d===0?!1:(this.a=new Uint32Array(C.length+d),this.a.set(C.subarray(0,p),0),this.a.set(C.subarray(p),p+d),this.a.set(c,p),p-1<this.c[0]&&(this.c[0]=p-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(S.subarray(0,this.c[0]+1)),!0)}setValue(p,c){return p=(0,m.$0e)(p),c=(0,m.$0e)(c),this.a[p]===c?!1:(this.a[p]=c,p-1<this.c[0]&&(this.c[0]=p-1),!0)}removeValues(p,c){p=(0,m.$0e)(p),c=(0,m.$0e)(c);const C=this.a,S=this.b;if(p>=C.length)return!1;const d=C.length-p;return c>=d&&(c=d),c===0?!1:(this.a=new Uint32Array(C.length-c),this.a.set(C.subarray(0,p),0),this.a.set(C.subarray(p+c),p),this.b=new Uint32Array(this.a.length),p-1<this.c[0]&&(this.c[0]=p-1),this.c[0]>=0&&this.b.set(S.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(p){return p<0?0:(p=(0,m.$0e)(p),this.d(p))}d(p){if(p<=this.c[0])return this.b[p];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),p>=this.a.length&&(p=this.a.length-1);for(let C=c;C<=p;C++)this.b[C]=this.b[C-1]+this.a[C];return this.c[0]=Math.max(this.c[0],p),this.b[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let c=0,C=this.a.length-1,S=0,d=0,P=0;for(;c<=C;)if(S=c+(C-c)/2|0,d=this.b[S],P=d-this.a[S],p<P)C=S-1;else if(p>=d)c=S+1;else break;return new L(S,p-P)}}e.$_v=A;class R{constructor(p){this.a=p,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(p){return this.g(),p===0?0:this.d[p-1]}getIndexOf(p){this.g();const c=this.e[p],C=c>0?this.d[c-1]:0;return new L(c,p-C)}removeValues(p,c){this.a.splice(p,c),this.f(p)}insertValues(p,c){this.a=(0,r.$Vb)(this.a,p,c),this.f(p)}f(p){this.b=!1,this.c=Math.min(this.c,p-1)}g(){if(!this.b){for(let p=this.c+1,c=this.a.length;p<c;p++){const C=this.a[p],S=p>0?this.d[p-1]:0;this.d[p]=S+C;for(let d=0;d<C;d++)this.e[S+d]=p}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(p,c){this.a[p]!==c&&(this.a[p]=c,this.f(p))}}e.$aw=R;class L{constructor(p,c){this.index=p,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=c}}e.$bw=L}),define(ye[196],Se([1,0,13,54,195]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cw=void 0;class R{constructor(T,p,c,C){this.d=T,this.f=p,this.g=c,this.h=C,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(T){T.eol&&T.eol!==this.g&&(this.g=T.eol,this.j=null);const p=T.changes;for(const c of p)this.o(c.range),this.p(new m.$bt(c.range.startLineNumber,c.range.startColumn),c.text);this.h=T.versionId,this.k=null}l(){if(!this.j){const T=this.g.length,p=this.f.length,c=new Uint32Array(p);for(let C=0;C<p;C++)c[C]=this.f[C].length+T;this.j=new A.$_v(c)}}n(T,p){this.f[T]=p,this.j&&this.j.setValue(T,this.f[T].length+this.g.length)}o(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.startLineNumber-1].substring(T.endColumn-1));return}this.n(T.startLineNumber-1,this.f[T.startLineNumber-1].substring(0,T.startColumn-1)+this.f[T.endLineNumber-1].substring(T.endColumn-1)),this.f.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.j&&this.j.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}p(T,p){if(p.length===0)return;const c=(0,r.$of)(p);if(c.length===1){this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+c[0]+this.f[T.lineNumber-1].substring(T.column-1));return}c[c.length-1]+=this.f[T.lineNumber-1].substring(T.column-1),this.n(T.lineNumber-1,this.f[T.lineNumber-1].substring(0,T.column-1)+c[0]);const C=new Uint32Array(c.length-1);for(let S=1;S<c.length;S++)this.f.splice(T.lineNumber+S-1,0,c[S]),C[S-1]=c[S].length+this.g.length;this.j&&this.j.insertValues(T.lineNumber,C)}}e.$cw=R}),define(ye[106],Se([1,0,27,13,191,54,31,55]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6C=e.$4C=e.$1C=void 0,e.$2C=C,e.$3C=S,e.$5C=u;const p=999;class c{constructor(n,s,i,t){this.searchString=n,this.isRegex=s,this.matchCase=i,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=C(this.searchString):n=this.searchString.indexOf(`
`)>=0;let s=null;try{s=m.$mf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!s)return null;let i=!this.isRegex&&!n;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new T.$uv(s,this.wordSeparators?(0,A.$qt)(this.wordSeparators,[]):null,i?this.searchString:null)}}e.$1C=c;function C(g){if(!g||g.length===0)return!1;for(let n=0,s=g.length;n<s;n++){const i=g.charCodeAt(n);if(i===r.CharCode.LineFeed)return!0;if(i===r.CharCode.Backslash){if(n++,n>=s)break;const t=g.charCodeAt(n);if(t===r.CharCode.n||t===r.CharCode.r||t===r.CharCode.W)return!0}}return!1}function S(g,n,s){if(!s)return new T.$rv(g,null);const i=[];for(let t=0,l=n.length;t<l;t++)i[t]=n[t];return new T.$rv(g,i)}class d{constructor(n){const s=[];let i=0;for(let t=0,l=n.length;t<l;t++)n.charCodeAt(t)===r.CharCode.LineFeed&&(s[i++]=t);this.a=s}findLineFeedCountBeforeOffset(n){const s=this.a;let i=0,t=s.length-1;if(t===-1||n<=s[0])return 0;for(;i<t;){const l=i+((t-i)/2>>0);s[l]>=n?t=l-1:s[l+1]>=n?(i=l,t=l):i=l+1}return i+1}}class P{static findMatches(n,s,i,t,l){const h=s.parseSearchRequest();return h?h.regex.multiline?this.b(n,i,new f(h.wordSeparators,h.regex),t,l):this.c(n,i,h,t,l):[]}static a(n,s,i,t,l,h){let o,$=0;t?($=t.findLineFeedCountBeforeOffset(l),o=s+l+$):o=s+l;let E;if(t){const I=t.findLineFeedCountBeforeOffset(l+h.length)-$;E=o+h.length+I}else E=o+h.length;const k=n.getPositionAt(o),D=n.getPositionAt(E);return new L.$ct(k.lineNumber,k.column,D.lineNumber,D.column)}static b(n,s,i,t,l){const h=n.getOffsetAt(s.getStartPosition()),o=n.getValueInRange(s,T.EndOfLinePreference.LF),$=n.getEOL()===`\r
`?new d(o):null,E=[];let k=0,D;for(i.reset(0);D=i.next(o);)if(E[k++]=S(this.a(n,h,o,$,D.index,D[0]),D,t),k>=l)return E;return E}static c(n,s,i,t,l){const h=[];let o=0;if(s.startLineNumber===s.endLineNumber){const E=n.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return o=this.d(i,E,s.startLineNumber,s.startColumn-1,o,h,t,l),h}const $=n.getLineContent(s.startLineNumber).substring(s.startColumn-1);o=this.d(i,$,s.startLineNumber,s.startColumn-1,o,h,t,l);for(let E=s.startLineNumber+1;E<s.endLineNumber&&o<l;E++)o=this.d(i,n.getLineContent(E),E,0,o,h,t,l);if(o<l){const E=n.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);o=this.d(i,E,s.endLineNumber,0,o,h,t,l)}return h}static d(n,s,i,t,l,h,o,$){const E=n.wordSeparators;if(!o&&n.simpleSearch){const v=n.simpleSearch,I=v.length,w=s.length;let y=-I;for(;(y=s.indexOf(v,y+I))!==-1;)if((!E||u(E,s,w,y,I))&&(h[l++]=new T.$rv(new L.$ct(i,y+1+t,i,y+1+I+t),null),l>=$))return l;return l}const k=new f(n.wordSeparators,n.regex);let D;k.reset(0);do if(D=k.next(s),D&&(h[l++]=S(new L.$ct(i,D.index+1+t,i,D.index+1+D[0].length+t),D,o),l>=$))return l;while(D);return l}static findNextMatch(n,s,i,t){const l=s.parseSearchRequest();if(!l)return null;const h=new f(l.wordSeparators,l.regex);return l.regex.multiline?this.e(n,i,h,t):this.f(n,i,h,t)}static e(n,s,i,t){const l=new R.$bt(s.lineNumber,1),h=n.getOffsetAt(l),o=n.getLineCount(),$=n.getValueInRange(new L.$ct(l.lineNumber,l.column,o,n.getLineMaxColumn(o)),T.EndOfLinePreference.LF),E=n.getEOL()===`\r
`?new d($):null;i.reset(s.column-1);const k=i.next($);return k?S(this.a(n,h,$,E,k.index,k[0]),k,t):s.lineNumber!==1||s.column!==1?this.e(n,new R.$bt(1,1),i,t):null}static f(n,s,i,t){const l=n.getLineCount(),h=s.lineNumber,o=n.getLineContent(h),$=this.g(i,o,h,s.column,t);if($)return $;for(let E=1;E<=l;E++){const k=(h+E-1)%l,D=n.getLineContent(k+1),v=this.g(i,D,k+1,1,t);if(v)return v}return null}static g(n,s,i,t,l){n.reset(t-1);const h=n.next(s);return h?S(new L.$ct(i,h.index+1,i,h.index+1+h[0].length),h,l):null}static findPreviousMatch(n,s,i,t){const l=s.parseSearchRequest();if(!l)return null;const h=new f(l.wordSeparators,l.regex);return l.regex.multiline?this.h(n,i,h,t):this.j(n,i,h,t)}static h(n,s,i,t){const l=this.b(n,new L.$ct(1,1,s.lineNumber,s.column),i,t,10*p);if(l.length>0)return l[l.length-1];const h=n.getLineCount();return s.lineNumber!==h||s.column!==n.getLineMaxColumn(h)?this.h(n,new R.$bt(h,n.getLineMaxColumn(h)),i,t):null}static j(n,s,i,t){const l=n.getLineCount(),h=s.lineNumber,o=n.getLineContent(h).substring(0,s.column-1),$=this.k(i,o,h,t);if($)return $;for(let E=1;E<=l;E++){const k=(l+h-E-1)%l,D=n.getLineContent(k+1),v=this.k(i,D,k+1,t);if(v)return v}return null}static k(n,s,i,t){let l=null,h;for(n.reset(0);h=n.next(s);)l=S(new L.$ct(i,h.index+1,i,h.index+1+h[0].length),h,t);return l}}e.$4C=P;function b(g,n,s,i,t){if(i===0)return!0;const l=n.charCodeAt(i-1);if(g.get(l)!==A.WordCharacterClass.Regular||l===r.CharCode.CarriageReturn||l===r.CharCode.LineFeed)return!0;if(t>0){const h=n.charCodeAt(i);if(g.get(h)!==A.WordCharacterClass.Regular)return!0}return!1}function a(g,n,s,i,t){if(i+t===s)return!0;const l=n.charCodeAt(i+t);if(g.get(l)!==A.WordCharacterClass.Regular||l===r.CharCode.CarriageReturn||l===r.CharCode.LineFeed)return!0;if(t>0){const h=n.charCodeAt(i+t-1);if(g.get(h)!==A.WordCharacterClass.Regular)return!0}return!1}function u(g,n,s,i,t){return b(g,n,s,i,t)&&a(g,n,s,i,t)}class f{constructor(n,s){this._wordSeparators=n,this.a=s,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const s=n.length;let i;do{if(this.b+this.c===s||(i=this.a.exec(n),!i))return null;const t=i.index,l=i[0].length;if(t===this.b&&l===this.c){if(l===0){m.$If(n,s,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=t,this.c=l,!this._wordSeparators||u(this._wordSeparators,n,s,t,l))return i}while(i);return null}}e.$6C=f}),define(ye[138],Se([1,0,27,54,31,55,194,106]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=e.$0C=e.$9C=void 0,e.$7C=S,e.$8C=d;const p=65535;function c(g){let n;return g[g.length-1]<65536?n=new Uint16Array(g.length):n=new Uint32Array(g.length),n.set(g,0),n}class C{constructor(n,s,i,t,l){this.lineStarts=n,this.cr=s,this.lf=i,this.crlf=t,this.isBasicASCII=l}}function S(g,n=!0){const s=[0];let i=1;for(let t=0,l=g.length;t<l;t++){const h=g.charCodeAt(t);h===r.CharCode.CarriageReturn?t+1<l&&g.charCodeAt(t+1)===r.CharCode.LineFeed?(s[i++]=t+2,t++):s[i++]=t+1:h===r.CharCode.LineFeed&&(s[i++]=t+1)}return n?c(s):s}function d(g,n){g.length=0,g[0]=0;let s=1,i=0,t=0,l=0,h=!0;for(let $=0,E=n.length;$<E;$++){const k=n.charCodeAt($);k===r.CharCode.CarriageReturn?$+1<E&&n.charCodeAt($+1)===r.CharCode.LineFeed?(l++,g[s++]=$+2,$++):(i++,g[s++]=$+1):k===r.CharCode.LineFeed?(t++,g[s++]=$+1):h&&k!==r.CharCode.Tab&&(k<32||k>126)&&(h=!1)}const o=new C(c(g),i,t,l,h);return g.length=0,o}class P{constructor(n,s,i,t,l){this.bufferIndex=n,this.start=s,this.end=i,this.lineFeedCnt=t,this.length=l}}e.$9C=P;class b{constructor(n,s){this.buffer=n,this.lineStarts=s}}e.$0C=b;class a{constructor(n,s){this.a=[],this.c=n,this.d=s,this.b=0,n.root!==L.$RC&&n.iterate(n.root,i=>(i!==L.$RC&&this.a.push(i.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class u{constructor(n){this.a=n,this.b=[]}get(n){for(let s=this.b.length-1;s>=0;s--){const i=this.b[s];if(i.nodeStartOffset<=n&&i.nodeStartOffset+i.node.piece.length>=n)return i}return null}get2(n){for(let s=this.b.length-1;s>=0;s--){const i=this.b[s];if(i.nodeStartLineNumber&&i.nodeStartLineNumber<n&&i.nodeStartLineNumber+i.node.piece.lineFeedCnt>=n)return i}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let s=!1;const i=this.b;for(let t=0;t<i.length;t++){const l=i[t];if(l.node.parent===null||l.nodeStartOffset>=n){i[t]=null,s=!0;continue}}if(s){const t=[];for(const l of i)l!==null&&t.push(l);this.b=t}}}class f{constructor(n,s,i){this.create(n,s,i)}create(n,s,i){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=L.$RC,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=i;let t=null;for(let l=0,h=n.length;l<h;l++)if(n[l].buffer.length>0){n[l].lineStarts||(n[l].lineStarts=S(n[l].buffer));const o=new P(l+1,{line:0,column:0},{line:n[l].lineStarts.length-1,column:n[l].buffer.length-n[l].lineStarts[n[l].lineStarts.length-1]},n[l].lineStarts.length-1,n[l].buffer.length);this.a.push(n[l]),t=this.S(t,o)}this.h=new u(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const s=p,i=s-Math.floor(s/3),t=i*2;let l="",h=0;const o=[];if(this.iterate(this.root,$=>{const E=this.R($),k=E.length;if(h<=i||h+k<t)return l+=E,h+=k,!0;const D=l.replace(/\r\n|\r|\n/g,n);return o.push(new b(D,S(D))),l=E,h=k,!0}),h>0){const $=l.replace(/\r\n|\r|\n/g,n);o.push(new b($,S($)))}this.create(o,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new a(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let s=0;return this.iterate(this.root,t=>{if(t===L.$RC)return!0;const l=this.R(t),h=l.length,o=n.G(s),$=n.G(s+h),E=n.getValueInRange2(o,$);return s+=h,l===E})}getOffsetAt(n,s){let i=0,t=this.root;for(;t!==L.$RC;)if(t.left!==L.$RC&&t.lf_left+1>=n)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt+1>=n){i+=t.size_left;const l=this.B(t,n-t.lf_left-2);return i+=l+s-1}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;return i}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let s=this.root,i=0;const t=n;for(;s!==L.$RC;)if(s.size_left!==0&&s.size_left>=n)s=s.left;else if(s.size_left+s.piece.length>=n){const l=this.A(s,n-s.size_left);if(i+=s.lf_left+l.index,l.index===0){const h=this.getOffsetAt(i+1,1),o=t-h;return new m.$bt(i+1,o+1)}return new m.$bt(i+1,l.remainder+1)}else if(n-=s.size_left+s.piece.length,i+=s.lf_left+s.piece.lineFeedCnt,s.right===L.$RC){const l=this.getOffsetAt(i+1,1),h=t-n-l;return new m.$bt(i+1,h+1)}else s=s.right;return new m.$bt(1,1)}getValueInRange(n,s){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const i=this.H(n.startLineNumber,n.startColumn),t=this.H(n.endLineNumber,n.endColumn),l=this.getValueInRange2(i,t);return s?s!==this.d||!this.f?l.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?l:l.replace(/\r\n|\r|\n/g,s):l}getValueInRange2(n,s){if(n.node===s.node){const o=n.node,$=this.a[o.piece.bufferIndex].buffer,E=this.u(o.piece.bufferIndex,o.piece.start);return $.substring(E+n.remainder,E+s.remainder)}let i=n.node;const t=this.a[i.piece.bufferIndex].buffer,l=this.u(i.piece.bufferIndex,i.piece.start);let h=t.substring(l+n.remainder,l+i.piece.length);for(i=i.next();i!==L.$RC;){const o=this.a[i.piece.bufferIndex].buffer,$=this.u(i.piece.bufferIndex,i.piece.start);if(i===s.node){h+=o.substring($,$+s.remainder);break}else h+=o.substr($,i.piece.length);i=i.next()}return h}getLinesContent(){const n=[];let s=0,i="",t=!1;return this.iterate(this.root,l=>{if(l===L.$RC)return!0;const h=l.piece;let o=h.length;if(o===0)return!0;const $=this.a[h.bufferIndex].buffer,E=this.a[h.bufferIndex].lineStarts,k=h.start.line,D=h.end.line;let v=E[k]+h.start.column;if(t&&($.charCodeAt(v)===r.CharCode.LineFeed&&(v++,o--),n[s++]=i,i="",t=!1,o===0))return!0;if(k===D)return!this.f&&$.charCodeAt(v+o-1)===r.CharCode.CarriageReturn?(t=!0,i+=$.substr(v,o-1)):i+=$.substr(v,o),!0;i+=this.f?$.substring(v,Math.max(v,E[k+1]-this.e)):$.substring(v,E[k+1]).replace(/(\r\n|\r|\n)$/,""),n[s++]=i;for(let I=k+1;I<D;I++)i=this.f?$.substring(E[I],E[I+1]-this.e):$.substring(E[I],E[I+1]).replace(/(\r\n|\r|\n)$/,""),n[s++]=i;return!this.f&&$.charCodeAt(E[D]+h.end.column-1)===r.CharCode.CarriageReturn?(t=!0,h.end.column===0?s--:i=$.substr(E[D],h.end.column-1)):i=$.substr(E[D],h.end.column),!0}),t&&(n[s++]=i,i=""),n[s++]=i,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const s=n.node.next();if(!s)return 0;const i=this.a[s.piece.bufferIndex],t=this.u(s.piece.bufferIndex,s.piece.start);return i.buffer.charCodeAt(t)}else{const s=this.a[n.node.piece.bufferIndex],t=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return s.buffer.charCodeAt(t)}}getLineCharCode(n,s){const i=this.H(n,s+1);return this.l(i)}getLineLength(n){if(n===this.getLineCount()){const s=this.getOffsetAt(n,1);return this.getLength()-s}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const s=this.G(n);return this.l(s)}findMatchesInNode(n,s,i,t,l,h,o,$,E,k,D){const v=this.a[n.piece.bufferIndex],I=this.u(n.piece.bufferIndex,n.piece.start),w=this.u(n.piece.bufferIndex,l),y=this.u(n.piece.bufferIndex,h);let N;const O={line:0,column:0};let U,j;s._wordSeparators?(U=v.buffer.substring(w,y),j=z=>z+w,s.reset(0)):(U=v.buffer,j=z=>z,s.reset(w));do if(N=s.next(U),N){if(j(N.index)>=y)return k;this.s(n,j(N.index)-I,O);const z=this.t(n.piece.bufferIndex,l,O),M=O.line===l.line?O.column-l.column+t:O.column+1,F=M+N[0].length;if(D[k++]=(0,T.$3C)(new A.$ct(i+z,M,i+z,F),N,$),j(N.index)+N[0].length>=y||k>=E)return k}while(N);return k}findMatchesLineByLine(n,s,i,t){const l=[];let h=0;const o=new T.$6C(s.wordSeparators,s.regex);let $=this.H(n.startLineNumber,n.startColumn);if($===null)return[];const E=this.H(n.endLineNumber,n.endColumn);if(E===null)return[];let k=this.s($.node,$.remainder);const D=this.s(E.node,E.remainder);if($.node===E.node)return this.findMatchesInNode($.node,o,n.startLineNumber,n.startColumn,k,D,s,i,t,h,l),l;let v=n.startLineNumber,I=$.node;for(;I!==E.node;){const y=this.t(I.piece.bufferIndex,k,I.piece.end);if(y>=1){const O=this.a[I.piece.bufferIndex].lineStarts,U=this.u(I.piece.bufferIndex,I.piece.start),j=O[k.line+y],z=v===n.startLineNumber?n.startColumn:1;if(h=this.findMatchesInNode(I,o,v,z,k,this.s(I,j-U),s,i,t,h,l),h>=t)return l;v+=y}const N=v===n.startLineNumber?n.startColumn-1:0;if(v===n.endLineNumber){const O=this.getLineContent(v).substring(N,n.endColumn-1);return h=this.n(s,o,O,n.endLineNumber,N,h,l,i,t),l}if(h=this.n(s,o,this.getLineContent(v).substr(N),v,N,h,l,i,t),h>=t)return l;v++,$=this.H(v,1),I=$.node,k=this.s($.node,$.remainder)}if(v===n.endLineNumber){const y=v===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(v).substring(y,n.endColumn-1);return h=this.n(s,o,N,n.endLineNumber,y,h,l,i,t),l}const w=v===n.startLineNumber?n.startColumn:1;return h=this.findMatchesInNode(E.node,o,v,w,k,D,s,i,t,h,l),l}n(n,s,i,t,l,h,o,$,E){const k=n.wordSeparators;if(!$&&n.simpleSearch){const v=n.simpleSearch,I=v.length,w=i.length;let y=-I;for(;(y=i.indexOf(v,y+I))!==-1;)if((!k||(0,T.$5C)(k,i,w,y,I))&&(o[h++]=new R.$rv(new A.$ct(t,y+1+l,t,y+1+I+l),null),h>=E))return h;return h}let D;s.reset(0);do if(D=s.next(i),D&&(o[h++]=(0,T.$3C)(new A.$ct(t,D.index+1+l,t,D.index+1+D[0].length+l),D,$),h>=E))return h;while(D);return h}insert(n,s,i=!1){if(this.f=this.f&&i,this.j.lineNumber=0,this.j.value="",this.root!==L.$RC){const{node:t,remainder:l,nodeStartOffset:h}=this.G(n),o=t.piece,$=o.bufferIndex,E=this.s(t,l);if(t.piece.bufferIndex===0&&o.end.line===this.g.line&&o.end.column===this.g.column&&h+o.length===n&&s.length<p){this.F(t,s),this.y();return}if(h===n)this.o(s,t),this.h.validate(n);else if(h+t.piece.length>n){const k=[];let D=new P(o.bufferIndex,E,o.end,this.t(o.bufferIndex,E,o.end),this.u($,o.end)-this.u($,E));if(this.K()&&this.M(s)&&this.I(t,l)===10){const y={line:D.start.line+1,column:0};D=new P(D.bufferIndex,y,D.end,this.t(D.bufferIndex,y,D.end),D.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(t,l-1)===13){const y=this.s(t,l-1);this.C(t,y),s="\r"+s,t.piece.length===0&&k.push(t)}else this.C(t,E);else this.C(t,E);const v=this.w(s);D.length>0&&this.S(t,D);let I=t;for(let w=0;w<v.length;w++)I=this.S(I,v[w]);this.v(k)}else this.q(s,t)}else{const t=this.w(s);let l=this.T(null,t[0]);for(let h=1;h<t.length;h++)l=this.S(l,t[h])}this.y()}delete(n,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===L.$RC)return;const i=this.G(n),t=this.G(n+s),l=i.node,h=t.node;if(l===h){const v=this.s(l,i.remainder),I=this.s(l,t.remainder);if(i.nodeStartOffset===n){if(s===l.piece.length){const w=l.next();(0,L.$WC)(this,l),this.N(w),this.y();return}this.D(l,I),this.h.validate(n),this.N(l),this.y();return}if(i.nodeStartOffset+l.piece.length===n+s){this.C(l,v),this.O(l),this.y();return}this.E(l,v,I),this.y();return}const o=[],$=this.s(l,i.remainder);this.C(l,$),this.h.validate(n),l.piece.length===0&&o.push(l);const E=this.s(h,t.remainder);this.D(h,E),h.piece.length===0&&o.push(h);const k=l.next();for(let v=k;v!==L.$RC&&v!==h;v=v.next())o.push(v);const D=l.piece.length===0?l.prev():l;this.v(o),this.O(D),this.y()}o(n,s){const i=[];if(this.K()&&this.M(n)&&this.L(s)){const h=s.piece,o={line:h.start.line+1,column:0},$=new P(h.bufferIndex,o,h.end,this.t(h.bufferIndex,o,h.end),h.length-1);s.piece=$,n+=`
`,(0,L.$YC)(this,s,-1,-1),s.piece.length===0&&i.push(s)}const t=this.w(n);let l=this.T(s,t[t.length-1]);for(let h=t.length-2;h>=0;h--)l=this.T(l,t[h]);this.N(l),this.v(i)}q(n,s){this.Q(n,s)&&(n+=`
`);const i=this.w(n),t=this.S(s,i[0]);let l=t;for(let h=1;h<i.length;h++)l=this.S(l,i[h]);this.N(t)}s(n,s,i){const t=n.piece,l=n.piece.bufferIndex,h=this.a[l].lineStarts,$=h[t.start.line]+t.start.column+s;let E=t.start.line,k=t.end.line,D=0,v=0,I=0;for(;E<=k&&(D=E+(k-E)/2|0,I=h[D],D!==k);)if(v=h[D+1],$<I)k=D-1;else if($>=v)E=D+1;else break;return i?(i.line=D,i.column=$-I,null):{line:D,column:$-I}}t(n,s,i){if(i.column===0)return i.line-s.line;const t=this.a[n].lineStarts;if(i.line===t.length-1)return i.line-s.line;const l=t[i.line+1],h=t[i.line]+i.column;if(l>h+1)return i.line-s.line;const o=h-1;return this.a[n].buffer.charCodeAt(o)===13?i.line-s.line+1:i.line-s.line}u(n,s){return this.a[n].lineStarts[s.line]+s.column}v(n){for(let s=0;s<n.length;s++)(0,L.$WC)(this,n[s])}w(n){if(n.length>p){const k=[];for(;n.length>p;){const v=n.charCodeAt(p-1);let I;v===r.CharCode.CarriageReturn||v>=55296&&v<=56319?(I=n.substring(0,p-1),n=n.substring(p-1)):(I=n.substring(0,p),n=n.substring(p));const w=S(I);k.push(new P(this.a.length,{line:0,column:0},{line:w.length-1,column:I.length-w[w.length-1]},w.length-1,I.length)),this.a.push(new b(I,w))}const D=S(n);return k.push(new P(this.a.length,{line:0,column:0},{line:D.length-1,column:n.length-D[D.length-1]},D.length-1,n.length)),this.a.push(new b(n,D)),k}let s=this.a[0].buffer.length;const i=S(n,!1);let t=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},t=this.g;for(let k=0;k<i.length;k++)i[k]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+="_"+n,s+=1}else{if(s!==0)for(let k=0;k<i.length;k++)i[k]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+=n}const l=this.a[0].buffer.length,h=this.a[0].lineStarts.length-1,o=l-this.a[0].lineStarts[h],$={line:h,column:o},E=new P(0,t,$,this.t(0,t,$),l-s);return this.g=$,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,s=0){let i=this.root,t="";const l=this.h.get2(n);if(l){i=l.node;const h=this.B(i,n-l.nodeStartLineNumber-1),o=this.a[i.piece.bufferIndex].buffer,$=this.u(i.piece.bufferIndex,i.piece.start);if(l.nodeStartLineNumber+i.piece.lineFeedCnt===n)t=o.substring($+h,$+i.piece.length);else{const E=this.B(i,n-l.nodeStartLineNumber);return o.substring($+h,$+E-s)}}else{let h=0;const o=n;for(;i!==L.$RC;)if(i.left!==L.$RC&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const $=this.B(i,n-i.lf_left-2),E=this.B(i,n-i.lf_left-1),k=this.a[i.piece.bufferIndex].buffer,D=this.u(i.piece.bufferIndex,i.piece.start);return h+=i.size_left,this.h.set({node:i,nodeStartOffset:h,nodeStartLineNumber:o-(n-1-i.lf_left)}),k.substring(D+$,D+E-s)}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const $=this.B(i,n-i.lf_left-2),E=this.a[i.piece.bufferIndex].buffer,k=this.u(i.piece.bufferIndex,i.piece.start);t=E.substring(k+$,k+i.piece.length);break}else n-=i.lf_left+i.piece.lineFeedCnt,h+=i.size_left+i.piece.length,i=i.right}for(i=i.next();i!==L.$RC;){const h=this.a[i.piece.bufferIndex].buffer;if(i.piece.lineFeedCnt>0){const o=this.B(i,0),$=this.u(i.piece.bufferIndex,i.piece.start);return t+=h.substring($,$+o-s),t}else{const o=this.u(i.piece.bufferIndex,i.piece.start);t+=h.substr(o,i.piece.length)}i=i.next()}return t}y(){let n=this.root,s=1,i=0;for(;n!==L.$RC;)s+=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;this.b=s,this.c=i,this.h.validate(this.c)}A(n,s){const i=n.piece,t=this.s(n,s),l=t.line-i.start.line;if(this.u(i.bufferIndex,i.end)-this.u(i.bufferIndex,i.start)===s){const h=this.t(n.piece.bufferIndex,i.start,t);if(h!==l)return{index:h,remainder:0}}return{index:l,remainder:t.column}}B(n,s){if(s<0)return 0;const i=n.piece,t=this.a[i.bufferIndex].lineStarts,l=i.start.line+s+1;return l>i.end.line?t[i.end.line]+i.end.column-t[i.start.line]-i.start.column:t[l]-t[i.start.line]-i.start.column}C(n,s){const i=n.piece,t=i.lineFeedCnt,l=this.u(i.bufferIndex,i.end),h=s,o=this.u(i.bufferIndex,h),$=this.t(i.bufferIndex,i.start,h),E=$-t,k=o-l,D=i.length+k;n.piece=new P(i.bufferIndex,i.start,h,$,D),(0,L.$YC)(this,n,k,E)}D(n,s){const i=n.piece,t=i.lineFeedCnt,l=this.u(i.bufferIndex,i.start),h=s,o=this.t(i.bufferIndex,h,i.end),$=this.u(i.bufferIndex,h),E=o-t,k=l-$,D=i.length+k;n.piece=new P(i.bufferIndex,h,i.end,o,D),(0,L.$YC)(this,n,k,E)}E(n,s,i){const t=n.piece,l=t.start,h=t.end,o=t.length,$=t.lineFeedCnt,E=s,k=this.t(t.bufferIndex,t.start,E),D=this.u(t.bufferIndex,s)-this.u(t.bufferIndex,l);n.piece=new P(t.bufferIndex,t.start,E,k,D),(0,L.$YC)(this,n,D-o,k-$);const v=new P(t.bufferIndex,i,h,this.t(t.bufferIndex,i,h),this.u(t.bufferIndex,h)-this.u(t.bufferIndex,i)),I=this.S(n,v);this.N(I)}F(n,s){this.Q(s,n)&&(s+=`
`);const i=this.K()&&this.L(s)&&this.M(n),t=this.a[0].buffer.length;this.a[0].buffer+=s;const l=S(s,!1);for(let I=0;I<l.length;I++)l[I]+=t;if(i){const I=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:t-I}}this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1));const h=this.a[0].lineStarts.length-1,o=this.a[0].buffer.length-this.a[0].lineStarts[h],$={line:h,column:o},E=n.piece.length+s.length,k=n.piece.lineFeedCnt,D=this.t(0,n.piece.start,$),v=D-k;n.piece=new P(n.piece.bufferIndex,n.piece.start,$,D,E),this.g=$,(0,L.$YC)(this,n,s.length,v)}G(n){let s=this.root;const i=this.h.get(n);if(i)return{node:i.node,nodeStartOffset:i.nodeStartOffset,remainder:n-i.nodeStartOffset};let t=0;for(;s!==L.$RC;)if(s.size_left>n)s=s.left;else if(s.size_left+s.piece.length>=n){t+=s.size_left;const l={node:s,remainder:n-s.size_left,nodeStartOffset:t};return this.h.set(l),l}else n-=s.size_left+s.piece.length,t+=s.size_left+s.piece.length,s=s.right;return null}H(n,s){let i=this.root,t=0;for(;i!==L.$RC;)if(i.left!==L.$RC&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const l=this.B(i,n-i.lf_left-2),h=this.B(i,n-i.lf_left-1);return t+=i.size_left,{node:i,remainder:Math.min(l+s-1,h),nodeStartOffset:t}}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const l=this.B(i,n-i.lf_left-2);if(l+s-1<=i.piece.length)return{node:i,remainder:l+s-1,nodeStartOffset:t};s-=i.piece.length-l;break}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;for(i=i.next();i!==L.$RC;){if(i.piece.lineFeedCnt>0){const l=this.B(i,0),h=this.J(i);return{node:i,remainder:Math.min(s-1,l),nodeStartOffset:h}}else if(i.piece.length>=s-1){const l=this.J(i);return{node:i,remainder:s-1,nodeStartOffset:l}}else s-=i.piece.length;i=i.next()}return null}I(n,s){if(n.piece.lineFeedCnt<1)return-1;const i=this.a[n.piece.bufferIndex],t=this.u(n.piece.bufferIndex,n.piece.start)+s;return i.buffer.charCodeAt(t)}J(n){if(!n)return 0;let s=n.size_left;for(;n!==this.root;)n.parent.right===n&&(s+=n.parent.size_left+n.parent.piece.length),n=n.parent;return s}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===L.$RC||n.piece.lineFeedCnt===0)return!1;const s=n.piece,i=this.a[s.bufferIndex].lineStarts,t=s.start.line,l=i[t]+s.start.column;return t===i.length-1||i[t+1]>l+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(l)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===L.$RC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const s=n.prev();this.M(s)&&this.P(s,n)}}O(n){if(this.K()&&this.M(n)){const s=n.next();this.L(s)&&this.P(n,s)}}P(n,s){const i=[],t=this.a[n.piece.bufferIndex].lineStarts;let l;n.piece.end.column===0?l={line:n.piece.end.line-1,column:t[n.piece.end.line]-t[n.piece.end.line-1]-1}:l={line:n.piece.end.line,column:n.piece.end.column-1};const h=n.piece.length-1,o=n.piece.lineFeedCnt-1;n.piece=new P(n.piece.bufferIndex,n.piece.start,l,o,h),(0,L.$YC)(this,n,-1,-1),n.piece.length===0&&i.push(n);const $={line:s.piece.start.line+1,column:0},E=s.piece.length-1,k=this.t(s.piece.bufferIndex,$,s.piece.end);s.piece=new P(s.piece.bufferIndex,$,s.piece.end,k,E),(0,L.$YC)(this,s,-1,-1),s.piece.length===0&&i.push(s);const D=this.w(`\r
`);this.S(n,D[0]);for(let v=0;v<i.length;v++)(0,L.$WC)(this,i[v])}Q(n,s){if(this.K()&&this.M(n)){const i=s.next();if(this.L(i)){if(n+=`
`,i.piece.length===1)(0,L.$WC)(this,i);else{const t=i.piece,l={line:t.start.line+1,column:0},h=t.length-1,o=this.t(t.bufferIndex,l,t.end);i.piece=new P(t.bufferIndex,l,t.end,o,h),(0,L.$YC)(this,i,-1,-1)}return!0}}return!1}iterate(n,s){if(n===L.$RC)return s(L.$RC);const i=this.iterate(n.left,s);return i&&s(n)&&this.iterate(n.right,s)}R(n){if(n===L.$RC)return"";const s=this.a[n.piece.bufferIndex],i=n.piece,t=this.u(i.bufferIndex,i.start),l=this.u(i.bufferIndex,i.end);return s.buffer.substring(t,l)}getPieceContent(n){const s=this.a[n.bufferIndex],i=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return s.buffer.substring(i,t)}S(n,s){const i=new L.$QC(s,L.NodeColor.Red);if(i.left=L.$RC,i.right=L.$RC,i.parent=L.$RC,i.size_left=0,i.lf_left=0,this.root===L.$RC)this.root=i,i.color=L.NodeColor.Black;else if(n.right===L.$RC)n.right=i,i.parent=n;else{const l=(0,L.$SC)(n.right);l.left=i,i.parent=l}return(0,L.$XC)(this,i),i}T(n,s){const i=new L.$QC(s,L.NodeColor.Red);if(i.left=L.$RC,i.right=L.$RC,i.parent=L.$RC,i.size_left=0,i.lf_left=0,this.root===L.$RC)this.root=i,i.color=L.NodeColor.Black;else if(n.left===L.$RC)n.left=i,i.parent=n;else{const t=(0,L.$TC)(n.left);t.right=i,i.parent=t}return(0,L.$XC)(this,i),i}U(n){let s="";return this.iterate(n,i=>(s+=this.R(i),!0)),s}}e.$$C=f}),define(ye[197],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$0=e.$00=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$00=r;class m{constructor(R){this.identifier=R}}e.$$0=m}),define(ye[198],Se([1,0,4,3,105]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$he,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,c){return this.a.set(p,c),this.handleChange([p]),(0,m.$Sc)(()=>{this.a.get(p)===c&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,c){this.b.get(p)?.dispose();const C=new L(this,p,c);return this.b.set(p,C),(0,m.$Sc)(()=>{const S=this.b.get(p);!S||S!==C||(this.b.delete(p),S.dispose())})}async getOrCreate(p){const c=this.get(p);if(c)return c;const C=this.b.get(p);return!C||C.isResolved?null:(await C.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const C=this.b.get(p);return!!(!C||C.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>A.ColorId.DefaultBackground?this.d[A.ColorId.DefaultBackground]:null}}e.$xv=R;class L extends m.$Uc{get isResolved(){return this.c}constructor(p,c,C){super(),this.f=p,this.g=c,this.h=C,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(ye[199],Se([7,8]),function(de,e){return de.create("vs/base/common/actions",e)}),define(ye[200],Se([1,0,4,3,199]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=void 0,e.$kj=C;class R extends m.$Uc{constructor(d,P="",b="",a=!0,u){super(),this.j=this.B(new r.$he),this.onDidChange=this.j.event,this.z=!0,this.m=d,this.n=P,this.w=b,this.z=a,this.D=u}get id(){return this.m}get label(){return this.n}set label(d){this.F(d)}F(d){this.n!==d&&(this.n=d,this.j.fire({label:d}))}get tooltip(){return this.u||""}set tooltip(d){this.G(d)}G(d){this.u!==d&&(this.u=d,this.j.fire({tooltip:d}))}get class(){return this.w}set class(d){this.H(d)}H(d){this.w!==d&&(this.w=d,this.j.fire({class:d}))}get enabled(){return this.z}set enabled(d){this.I(d)}I(d){this.z!==d&&(this.z=d,this.j.fire({enabled:d}))}get checked(){return this.C}set checked(d){this.J(d)}J(d){this.C!==d&&(this.C=d,this.j.fire({checked:d}))}async run(d,P){this.D&&await this.D(d)}}e.$fj=R;class L extends m.$Uc{constructor(){super(...arguments),this.f=this.B(new r.$he),this.onWillRun=this.f.event,this.m=this.B(new r.$he),this.onDidRun=this.m.event}async run(d,P){if(!d.enabled)return;this.f.fire({action:d});let b;try{await this.u(d,P)}catch(a){b=a}this.m.fire({action:d,error:b})}async u(d,P){await d.run(P)}}e.$gj=L;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...d){let P=[];for(const b of d)b.length&&(P.length?P=[...P,new T,...b]:P=b);return P}static{this.ID="vs.actions.separator"}async run(){}}e.$hj=T;class p{get actions(){return this.a}constructor(d,P,b,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=d,this.label=P,this.class=a,this.a=b}async run(){}}e.$ij=p;class c extends R{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,A.localize(0,null),void 0,!1)}}e.$jj=c;function C(S){return{id:S.id,label:S.label,tooltip:S.tooltip??S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...d)=>S.run(...d)}}}),define(ye[201],Se([7,8]),function(de,e){return de.create("vs/base/common/date",e)}),define(ye[202],Se([1,0,201]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=c,e.$8m=C,e.$9m=S;const m=60,A=m*60,R=A*24,L=R*7,T=R*30,p=R*365;function c(d,P,b,a){typeof d!="number"&&(d=d.getTime());const u=Math.round((new Date().getTime()-d)/1e3);if(u<-30)return(0,r.localize)(0,null,c(new Date().getTime()+u*1e3,!1));if(!a&&u<30)return(0,r.localize)(1,null);let f;return u<m?(f=u,P?f===1?b?(0,r.localize)(2,null,f):(0,r.localize)(3,null,f):b?(0,r.localize)(4,null,f):(0,r.localize)(5,null,f):f===1?b?(0,r.localize)(6,null,f):(0,r.localize)(7,null,f):b?(0,r.localize)(8,null,f):(0,r.localize)(9,null,f)):u<A?(f=Math.floor(u/m),P?f===1?b?(0,r.localize)(10,null,f):(0,r.localize)(11,null,f):b?(0,r.localize)(12,null,f):(0,r.localize)(13,null,f):f===1?b?(0,r.localize)(14,null,f):(0,r.localize)(15,null,f):b?(0,r.localize)(16,null,f):(0,r.localize)(17,null,f)):u<R?(f=Math.floor(u/A),P?f===1?b?(0,r.localize)(18,null,f):(0,r.localize)(19,null,f):b?(0,r.localize)(20,null,f):(0,r.localize)(21,null,f):f===1?b?(0,r.localize)(22,null,f):(0,r.localize)(23,null,f):b?(0,r.localize)(24,null,f):(0,r.localize)(25,null,f)):u<L?(f=Math.floor(u/R),P?f===1?(0,r.localize)(26,null,f):(0,r.localize)(27,null,f):f===1?(0,r.localize)(28,null,f):(0,r.localize)(29,null,f)):u<T?(f=Math.floor(u/L),P?f===1?b?(0,r.localize)(30,null,f):(0,r.localize)(31,null,f):b?(0,r.localize)(32,null,f):(0,r.localize)(33,null,f):f===1?b?(0,r.localize)(34,null,f):(0,r.localize)(35,null,f):b?(0,r.localize)(36,null,f):(0,r.localize)(37,null,f)):u<p?(f=Math.floor(u/T),P?f===1?b?(0,r.localize)(38,null,f):(0,r.localize)(39,null,f):b?(0,r.localize)(40,null,f):(0,r.localize)(41,null,f):f===1?b?(0,r.localize)(42,null,f):(0,r.localize)(43,null,f):b?(0,r.localize)(44,null,f):(0,r.localize)(45,null,f)):(f=Math.floor(u/p),P?f===1?b?(0,r.localize)(46,null,f):(0,r.localize)(47,null,f):b?(0,r.localize)(48,null,f):(0,r.localize)(49,null,f):f===1?b?(0,r.localize)(50,null,f):(0,r.localize)(51,null,f):b?(0,r.localize)(52,null,f):(0,r.localize)(53,null,f))}function C(d,P){const b=Math.abs(d/1e3);return b<1?P?(0,r.localize)(54,null,d):(0,r.localize)(55,null,d):b<m?P?(0,r.localize)(56,null,Math.round(d)/1e3):(0,r.localize)(57,null,Math.round(d)/1e3):b<A?P?(0,r.localize)(58,null,Math.round(d/(1e3*m))):(0,r.localize)(59,null,Math.round(d/(1e3*m))):b<R?P?(0,r.localize)(60,null,Math.round(d/(1e3*A))):(0,r.localize)(61,null,Math.round(d/(1e3*A))):(0,r.localize)(62,null,Math.round(d/(1e3*R)))}function S(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ye[203],Se([7,8]),function(de,e){return de.create("vs/base/common/errorMessage",e)}),define(ye[51],Se([1,0,19,18,203]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=p,e.$mj=c,e.$nj=C;function R(S,d){return d&&(S.stack||S.stacktrace)?A.localize(0,null,T(S),L(S.stack)||L(S.stacktrace)):T(S)}function L(S){return Array.isArray(S)?S.join(`
`):S}function T(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?A.localize(1,null,S.message):S.message||A.localize(2,null)}function p(S=null,d=!1){if(!S)return A.localize(3,null);if(Array.isArray(S)){const P=r.$Hb(S),b=p(P[0],d);return P.length>1?A.localize(4,null,b,P.length):b}if(m.$ag(S))return S;if(S.detail){const P=S.detail;if(P.error)return R(P.error,d);if(P.exception)return R(P.exception,d)}return S.stack?R(S,d):S.message?S.message:A.localize(5,null)}function c(S){const d=S;return d instanceof Error&&Array.isArray(d.actions)}function C(S,d){let P;return typeof S=="string"?P=new Error(S):P=S,P.actions=d,P}}),define(ye[204],Se([7,8]),function(de,e){return de.create("vs/base/common/platform",e)}),define(ye[11],Se([1,0,204]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=l,e.$D=D,e.$J=v,e.$g="en";let m=!1,A=!1,R=!1,L=!1,T=!1,p=!1,c=!1,C=!1,S=!1,d=!1,P,b=e.$g,a=e.$g,u,f;const g=globalThis;let n;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?n=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const s=typeof n?.versions?.electron=="string",i=s&&n?.type==="renderer";if(typeof n=="object"){m=n.platform==="win32",A=n.platform==="darwin",R=n.platform==="linux",L=R&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,c=s,S=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,P=e.$g,b=e.$g;const I=n.env.VSCODE_NLS_CONFIG;if(I)try{const w=JSON.parse(I),y=w.availableLanguages["*"];P=w.locale,a=w.osLocale,b=y||e.$g,u=w._translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!i?(f=navigator.userAgent,m=f.indexOf("Windows")>=0,A=f.indexOf("Macintosh")>=0,C=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=f.indexOf("Linux")>=0,d=f?.indexOf("Mobi")>=0,p=!0,P=r.getConfiguredDefaultLocale(r.localize(0,null))||e.$g,b=P,a=navigator.language):console.error("Unable to resolve platform.");var t;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(t||(e.Platform=t={}));function l(I){switch(I){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let h=t.Web;A?h=t.Mac:m?h=t.Windows:R&&(h=t.Linux),e.$i=m,e.$j=A,e.$k=R,e.$l=L,e.$m=T,e.$n=c,e.$o=p,e.$p=p&&typeof g.importScripts=="function",e.$q=e.$p?g.origin:void 0,e.$r=C,e.$s=d,e.$t=S,e.$u=h,e.$v=f,e.$w=b;var o;(function(I){function w(){return e.$w}I.value=w;function y(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}I.isDefaultVariant=y;function N(){return e.$w==="en"}I.isDefault=N})(o||(e.Language=o={})),e.$x=P,e.$y=a,e.$z=u,e.$A=typeof g.postMessage=="function"&&!g.importScripts,e.$B=(()=>{if(e.$A){const I=[];g.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let N=0,O=I.length;N<O;N++){const U=I[N];if(U.id===y.data.vscodeScheduleAsyncWork){I.splice(N,1),U.callback();return}}});let w=0;return y=>{const N=++w;I.push({id:N,callback:y}),g.postMessage({vscodeScheduleAsyncWork:N},"*")}}return I=>setTimeout(I)})();var $;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})($||(e.OperatingSystem=$={})),e.OS=A||C?$.Macintosh:m?$.Windows:$.Linux;let E=!0,k=!1;function D(){if(!k){k=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,E=new Uint16Array(I.buffer)[0]===513}return E}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function v(I){return parseFloat(I)>=20}}),define(ye[56],Se([1,0,11]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let m;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const R=A.process;m={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?m={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:m={get platform(){return r.$i?"win32":r.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=m.cwd,e.env=m.env,e.$dc=m.platform,e.$ec=m.arch}),define(ye[16],Se([1,0,56]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const m=65,A=97,R=90,L=122,T=46,p=47,c=92,C=58,S=63;class d extends Error{constructor(l,h,o){let $;typeof h=="string"&&h.indexOf("not ")===0?($="must not be",h=h.replace(/^not /,"")):$="must be";const E=l.indexOf(".")!==-1?"property":"argument";let k=`The "${l}" ${E} ${$} of type ${h}`;k+=`. Received type ${typeof o}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function P(t,l){if(t===null||typeof t!="object")throw new d(l,"Object",t)}function b(t,l){if(typeof t!="string")throw new d(l,"string",t)}const a=r.$dc==="win32";function u(t){return t===p||t===c}function f(t){return t===p}function g(t){return t>=m&&t<=R||t>=A&&t<=L}function n(t,l,h,o){let $="",E=0,k=-1,D=0,v=0;for(let I=0;I<=t.length;++I){if(I<t.length)v=t.charCodeAt(I);else{if(o(v))break;v=p}if(o(v)){if(!(k===I-1||D===1))if(D===2){if($.length<2||E!==2||$.charCodeAt($.length-1)!==T||$.charCodeAt($.length-2)!==T){if($.length>2){const w=$.lastIndexOf(h);w===-1?($="",E=0):($=$.slice(0,w),E=$.length-1-$.lastIndexOf(h)),k=I,D=0;continue}else if($.length!==0){$="",E=0,k=I,D=0;continue}}l&&($+=$.length>0?`${h}..`:"..",E=2)}else $.length>0?$+=`${h}${t.slice(k+1,I)}`:$=t.slice(k+1,I),E=I-k-1;k=I,D=0}else v===T&&D!==-1?++D:D=-1}return $}function s(t,l){P(l,"pathObject");const h=l.dir||l.root,o=l.base||`${l.name||""}${l.ext||""}`;return h?h===l.root?`${h}${o}`:`${h}${t}${o}`:o}e.$fc={resolve(...t){let l="",h="",o=!1;for(let $=t.length-1;$>=-1;$--){let E;if($>=0){if(E=t[$],b(E,"path"),E.length===0)continue}else l.length===0?E=r.cwd():(E=r.env[`=${l}`]||r.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==l.toLowerCase()&&E.charCodeAt(2)===c)&&(E=`${l}\\`));const k=E.length;let D=0,v="",I=!1;const w=E.charCodeAt(0);if(k===1)u(w)&&(D=1,I=!0);else if(u(w))if(I=!0,u(E.charCodeAt(1))){let y=2,N=y;for(;y<k&&!u(E.charCodeAt(y));)y++;if(y<k&&y!==N){const O=E.slice(N,y);for(N=y;y<k&&u(E.charCodeAt(y));)y++;if(y<k&&y!==N){for(N=y;y<k&&!u(E.charCodeAt(y));)y++;(y===k||y!==N)&&(v=`\\\\${O}\\${E.slice(N,y)}`,D=y)}}}else D=1;else g(w)&&E.charCodeAt(1)===C&&(v=E.slice(0,2),D=2,k>2&&u(E.charCodeAt(2))&&(I=!0,D=3));if(v.length>0)if(l.length>0){if(v.toLowerCase()!==l.toLowerCase())continue}else l=v;if(o){if(l.length>0)break}else if(h=`${E.slice(D)}\\${h}`,o=I,I&&l.length>0)break}return h=n(h,!o,"\\",u),o?`${l}\\${h}`:`${l}${h}`||"."},normalize(t){b(t,"path");const l=t.length;if(l===0)return".";let h=0,o,$=!1;const E=t.charCodeAt(0);if(l===1)return f(E)?"\\":t;if(u(E))if($=!0,u(t.charCodeAt(1))){let D=2,v=D;for(;D<l&&!u(t.charCodeAt(D));)D++;if(D<l&&D!==v){const I=t.slice(v,D);for(v=D;D<l&&u(t.charCodeAt(D));)D++;if(D<l&&D!==v){for(v=D;D<l&&!u(t.charCodeAt(D));)D++;if(D===l)return`\\\\${I}\\${t.slice(v)}\\`;D!==v&&(o=`\\\\${I}\\${t.slice(v,D)}`,h=D)}}}else h=1;else g(E)&&t.charCodeAt(1)===C&&(o=t.slice(0,2),h=2,l>2&&u(t.charCodeAt(2))&&($=!0,h=3));let k=h<l?n(t.slice(h),!$,"\\",u):"";return k.length===0&&!$&&(k="."),k.length>0&&u(t.charCodeAt(l-1))&&(k+="\\"),o===void 0?$?`\\${k}`:k:$?`${o}\\${k}`:`${o}${k}`},isAbsolute(t){b(t,"path");const l=t.length;if(l===0)return!1;const h=t.charCodeAt(0);return u(h)||l>2&&g(h)&&t.charCodeAt(1)===C&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,h;for(let E=0;E<t.length;++E){const k=t[E];b(k,"path"),k.length>0&&(l===void 0?l=h=k:l+=`\\${k}`)}if(l===void 0)return".";let o=!0,$=0;if(typeof h=="string"&&u(h.charCodeAt(0))){++$;const E=h.length;E>1&&u(h.charCodeAt(1))&&(++$,E>2&&(u(h.charCodeAt(2))?++$:o=!1))}if(o){for(;$<l.length&&u(l.charCodeAt($));)$++;$>=2&&(l=`\\${l.slice($)}`)}return e.$fc.normalize(l)},relative(t,l){if(b(t,"from"),b(l,"to"),t===l)return"";const h=e.$fc.resolve(t),o=e.$fc.resolve(l);if(h===o||(t=h.toLowerCase(),l=o.toLowerCase(),t===l))return"";let $=0;for(;$<t.length&&t.charCodeAt($)===c;)$++;let E=t.length;for(;E-1>$&&t.charCodeAt(E-1)===c;)E--;const k=E-$;let D=0;for(;D<l.length&&l.charCodeAt(D)===c;)D++;let v=l.length;for(;v-1>D&&l.charCodeAt(v-1)===c;)v--;const I=v-D,w=k<I?k:I;let y=-1,N=0;for(;N<w;N++){const U=t.charCodeAt($+N);if(U!==l.charCodeAt(D+N))break;U===c&&(y=N)}if(N!==w){if(y===-1)return o}else{if(I>w){if(l.charCodeAt(D+N)===c)return o.slice(D+N+1);if(N===2)return o.slice(D+N)}k>w&&(t.charCodeAt($+N)===c?y=N:N===2&&(y=3)),y===-1&&(y=0)}let O="";for(N=$+y+1;N<=E;++N)(N===E||t.charCodeAt(N)===c)&&(O+=O.length===0?"..":"\\..");return D+=y,O.length>0?`${O}${o.slice(D,v)}`:(o.charCodeAt(D)===c&&++D,o.slice(D,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$fc.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===c){if(l.charCodeAt(1)===c){const h=l.charCodeAt(2);if(h!==S&&h!==T)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(g(l.charCodeAt(0))&&l.charCodeAt(1)===C&&l.charCodeAt(2)===c)return`\\\\?\\${l}`;return t},dirname(t){b(t,"path");const l=t.length;if(l===0)return".";let h=-1,o=0;const $=t.charCodeAt(0);if(l===1)return u($)?t:".";if(u($)){if(h=o=1,u(t.charCodeAt(1))){let D=2,v=D;for(;D<l&&!u(t.charCodeAt(D));)D++;if(D<l&&D!==v){for(v=D;D<l&&u(t.charCodeAt(D));)D++;if(D<l&&D!==v){for(v=D;D<l&&!u(t.charCodeAt(D));)D++;if(D===l)return t;D!==v&&(h=o=D+1)}}}}else g($)&&t.charCodeAt(1)===C&&(h=l>2&&u(t.charCodeAt(2))?3:2,o=h);let E=-1,k=!0;for(let D=l-1;D>=o;--D)if(u(t.charCodeAt(D))){if(!k){E=D;break}}else k=!1;if(E===-1){if(h===-1)return".";E=h}return t.slice(0,E)},basename(t,l){l!==void 0&&b(l,"ext"),b(t,"path");let h=0,o=-1,$=!0,E;if(t.length>=2&&g(t.charCodeAt(0))&&t.charCodeAt(1)===C&&(h=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let k=l.length-1,D=-1;for(E=t.length-1;E>=h;--E){const v=t.charCodeAt(E);if(u(v)){if(!$){h=E+1;break}}else D===-1&&($=!1,D=E+1),k>=0&&(v===l.charCodeAt(k)?--k===-1&&(o=E):(k=-1,o=D))}return h===o?o=D:o===-1&&(o=t.length),t.slice(h,o)}for(E=t.length-1;E>=h;--E)if(u(t.charCodeAt(E))){if(!$){h=E+1;break}}else o===-1&&($=!1,o=E+1);return o===-1?"":t.slice(h,o)},extname(t){b(t,"path");let l=0,h=-1,o=0,$=-1,E=!0,k=0;t.length>=2&&t.charCodeAt(1)===C&&g(t.charCodeAt(0))&&(l=o=2);for(let D=t.length-1;D>=l;--D){const v=t.charCodeAt(D);if(u(v)){if(!E){o=D+1;break}continue}$===-1&&(E=!1,$=D+1),v===T?h===-1?h=D:k!==1&&(k=1):h!==-1&&(k=-1)}return h===-1||$===-1||k===0||k===1&&h===$-1&&h===o+1?"":t.slice(h,$)},format:s.bind(null,"\\"),parse(t){b(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const h=t.length;let o=0,$=t.charCodeAt(0);if(h===1)return u($)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(u($)){if(o=1,u(t.charCodeAt(1))){let y=2,N=y;for(;y<h&&!u(t.charCodeAt(y));)y++;if(y<h&&y!==N){for(N=y;y<h&&u(t.charCodeAt(y));)y++;if(y<h&&y!==N){for(N=y;y<h&&!u(t.charCodeAt(y));)y++;y===h?o=y:y!==N&&(o=y+1)}}}}else if(g($)&&t.charCodeAt(1)===C){if(h<=2)return l.root=l.dir=t,l;if(o=2,u(t.charCodeAt(2))){if(h===3)return l.root=l.dir=t,l;o=3}}o>0&&(l.root=t.slice(0,o));let E=-1,k=o,D=-1,v=!0,I=t.length-1,w=0;for(;I>=o;--I){if($=t.charCodeAt(I),u($)){if(!v){k=I+1;break}continue}D===-1&&(v=!1,D=I+1),$===T?E===-1?E=I:w!==1&&(w=1):E!==-1&&(w=-1)}return D!==-1&&(E===-1||w===0||w===1&&E===D-1&&E===k+1?l.base=l.name=t.slice(k,D):(l.name=t.slice(k,E),l.base=t.slice(k,D),l.ext=t.slice(E,D))),k>0&&k!==o?l.dir=t.slice(0,k-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(a){const t=/\\/g;return()=>{const l=r.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>r.cwd()})();e.$gc={resolve(...t){let l="",h=!1;for(let o=t.length-1;o>=-1&&!h;o--){const $=o>=0?t[o]:i();b($,"path"),$.length!==0&&(l=`${$}/${l}`,h=$.charCodeAt(0)===p)}return l=n(l,!h,"/",f),h?`/${l}`:l.length>0?l:"."},normalize(t){if(b(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===p,h=t.charCodeAt(t.length-1)===p;return t=n(t,!l,"/",f),t.length===0?l?"/":h?"./":".":(h&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return b(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let l;for(let h=0;h<t.length;++h){const o=t[h];b(o,"path"),o.length>0&&(l===void 0?l=o:l+=`/${o}`)}return l===void 0?".":e.$gc.normalize(l)},relative(t,l){if(b(t,"from"),b(l,"to"),t===l||(t=e.$gc.resolve(t),l=e.$gc.resolve(l),t===l))return"";const h=1,o=t.length,$=o-h,E=1,k=l.length-E,D=$<k?$:k;let v=-1,I=0;for(;I<D;I++){const y=t.charCodeAt(h+I);if(y!==l.charCodeAt(E+I))break;y===p&&(v=I)}if(I===D)if(k>D){if(l.charCodeAt(E+I)===p)return l.slice(E+I+1);if(I===0)return l.slice(E+I)}else $>D&&(t.charCodeAt(h+I)===p?v=I:I===0&&(v=0));let w="";for(I=h+v+1;I<=o;++I)(I===o||t.charCodeAt(I)===p)&&(w+=w.length===0?"..":"/..");return`${w}${l.slice(E+v)}`},toNamespacedPath(t){return t},dirname(t){if(b(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===p;let h=-1,o=!0;for(let $=t.length-1;$>=1;--$)if(t.charCodeAt($)===p){if(!o){h=$;break}}else o=!1;return h===-1?l?"/":".":l&&h===1?"//":t.slice(0,h)},basename(t,l){l!==void 0&&b(l,"ext"),b(t,"path");let h=0,o=-1,$=!0,E;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let k=l.length-1,D=-1;for(E=t.length-1;E>=0;--E){const v=t.charCodeAt(E);if(v===p){if(!$){h=E+1;break}}else D===-1&&($=!1,D=E+1),k>=0&&(v===l.charCodeAt(k)?--k===-1&&(o=E):(k=-1,o=D))}return h===o?o=D:o===-1&&(o=t.length),t.slice(h,o)}for(E=t.length-1;E>=0;--E)if(t.charCodeAt(E)===p){if(!$){h=E+1;break}}else o===-1&&($=!1,o=E+1);return o===-1?"":t.slice(h,o)},extname(t){b(t,"path");let l=-1,h=0,o=-1,$=!0,E=0;for(let k=t.length-1;k>=0;--k){const D=t.charCodeAt(k);if(D===p){if(!$){h=k+1;break}continue}o===-1&&($=!1,o=k+1),D===T?l===-1?l=k:E!==1&&(E=1):l!==-1&&(E=-1)}return l===-1||o===-1||E===0||E===1&&l===o-1&&l===h+1?"":t.slice(l,o)},format:s.bind(null,"/"),parse(t){b(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const h=t.charCodeAt(0)===p;let o;h?(l.root="/",o=1):o=0;let $=-1,E=0,k=-1,D=!0,v=t.length-1,I=0;for(;v>=o;--v){const w=t.charCodeAt(v);if(w===p){if(!D){E=v+1;break}continue}k===-1&&(D=!1,k=v+1),w===T?$===-1?$=v:I!==1&&(I=1):$!==-1&&(I=-1)}if(k!==-1){const w=E===0&&h?1:E;$===-1||I===0||I===1&&$===k-1&&$===E+1?l.base=l.name=t.slice(w,k):(l.name=t.slice(w,$),l.base=t.slice(w,k),l.ext=t.slice($,k))}return E>0?l.dir=t.slice(0,E-1):h&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=a?e.$fc.normalize:e.$gc.normalize,e.$ic=a?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=a?e.$fc.join:e.$gc.join,e.$kc=a?e.$fc.resolve:e.$gc.resolve,e.$lc=a?e.$fc.relative:e.$gc.relative,e.$mc=a?e.$fc.dirname:e.$gc.dirname,e.$nc=a?e.$fc.basename:e.$gc.basename,e.$oc=a?e.$fc.extname:e.$gc.extname,e.$pc=a?e.$fc.format:e.$gc.format,e.$qc=a?e.$fc.parse:e.$gc.parse,e.$rc=a?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=a?e.$fc.sep:e.$gc.sep,e.$tc=a?e.$fc.delimiter:e.$gc.delimiter}),define(ye[139],Se([1,0,49,16]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=T,e.$pr=p,e.$qr=c,e.$rr=C,e.$sr=S,e.$tr=d,e.$ur=P,e.$vr=b,e.$wr=a,e.$xr=u,e.$yr=$,e.$zr=E,e.$Ar=k;const A=new r.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new r.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new r.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(D,v,I=!1){const w=D||"",y=v||"",N=A.value.collator.compare(w,y);return A.value.collatorIsNumeric&&N===0&&w!==y?w<y?-1:1:N}function p(D,v){const I=R.value.collator;return D=D||"",v=v||"",s(I,D,v)}function c(D,v){const I=R.value.collator;return D=D||"",v=v||"",h(D,v)||s(I,D,v)}function C(D,v){const I=R.value.collator;return D=D||"",v=v||"",l(D,v)||s(I,D,v)}function S(D,v){return D=D||"",v=v||"",D===v?0:D<v?-1:1}function d(D,v){const[I,w]=g(D),[y,N]=g(v);let O=A.value.collator.compare(w,N);if(O===0){if(A.value.collatorIsNumeric&&w!==N)return w<N?-1:1;if(O=A.value.collator.compare(I,y),A.value.collatorIsNumeric&&O===0&&I!==y)return I<y?-1:1}return O}function P(D,v){D=D||"",v=v||"";const I=n(D),w=n(v),y=R.value.collator,N=L.value.collator;return s(N,I,w)||s(y,D,v)}function b(D,v){D=D||"",v=v||"";const I=n(D),w=n(v),y=R.value.collator,N=L.value.collator;return s(N,I,w)||h(D,v)||s(y,D,v)}function a(D,v){D=D||"",v=v||"";const I=n(D),w=n(v),y=R.value.collator,N=L.value.collator;return s(N,I,w)||l(D,v)||s(y,D,v)}function u(D,v){D=D||"",v=v||"";const I=n(D).toLowerCase(),w=n(v).toLowerCase();return I!==w?I<w?-1:1:D!==v?D<v?-1:1:0}const f=/^(.*?)(\.([^.]*))?$/;function g(D,v=!1){const I=D?f.exec(D):[];let w=[I&&I[1]||"",I&&I[3]||""];return v&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function n(D){const v=D?f.exec(D):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function s(D,v,I){const w=D.compare(v,I);return w!==0?w:v.length!==I.length?v.length<I.length?-1:1:0}function i(D){const v=D.charAt(0);return v.toLocaleUpperCase()!==v}function t(D){const v=D.charAt(0);return v.toLocaleLowerCase()!==v}function l(D,v){return i(D)&&t(v)?-1:t(D)&&i(v)?1:0}function h(D,v){return t(D)&&i(v)?-1:i(D)&&t(v)?1:0}function o(D,v,I=!1){return I||(D=D&&D.toLowerCase(),v=v&&v.toLowerCase()),D===v?0:D<v?-1:1}function $(D,v,I=!1){const w=D.split(m.sep),y=v.split(m.sep),N=w.length-1,O=y.length-1;let U,j;for(let z=0;;z++){if(U=N===z,j=O===z,U&&j)return T(w[z],y[z],I);if(U)return-1;if(j)return 1;const M=o(w[z],y[z],I);if(M!==0)return M}}function E(D,v,I){const w=D.toLowerCase(),y=v.toLowerCase(),N=k(D,v,I);if(N)return N;const O=w.endsWith(I),U=y.endsWith(I);if(O!==U)return O?-1:1;const j=T(w,y);return j!==0?j:w.localeCompare(y)}function k(D,v,I){const w=D.toLowerCase(),y=v.toLowerCase(),N=w.startsWith(I),O=y.startsWith(I);if(N!==O)return N?-1:1;if(N&&O){if(w.length<y.length)return-1;if(w.length>y.length)return 1}return 0}}),define(ye[33],Se([1,0,27,16,11,13,18]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=T,e.$tg=p,e.$ug=c,e.$vg=C,e.$wg=S,e.$xg=a,e.$yg=u,e.$zg=f,e.$Ag=g,e.$Bg=n,e.$Cg=s,e.$Dg=i,e.$Eg=t,e.$Fg=l,e.$Gg=h,e.$Hg=o,e.$Ig=k;function T(D){return D===r.CharCode.Slash||D===r.CharCode.Backslash}function p(D){return D.replace(/[\\/]/g,m.$gc.sep)}function c(D){return D.indexOf("/")===-1&&(D=p(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}function C(D,v=m.$gc.sep){if(!D)return"";const I=D.length,w=D.charCodeAt(0);if(T(w)){if(T(D.charCodeAt(1))&&!T(D.charCodeAt(2))){let N=3;const O=N;for(;N<I&&!T(D.charCodeAt(N));N++);if(O!==N&&!T(D.charCodeAt(N+1))){for(N+=1;N<I;N++)if(T(D.charCodeAt(N)))return D.slice(0,N+1).replace(/[\\/]/g,v)}}return v}else if(g(w)&&D.charCodeAt(1)===r.CharCode.Colon)return T(D.charCodeAt(2))?D.slice(0,2)+v:D.slice(0,2);let y=D.indexOf("://");if(y!==-1){for(y+=3;y<I;y++)if(T(D.charCodeAt(y)))return D.slice(0,y+1)}return""}function S(D){if(!A.$i||!D||D.length<5)return!1;let v=D.charCodeAt(0);if(v!==r.CharCode.Backslash||(v=D.charCodeAt(1),v!==r.CharCode.Backslash))return!1;let I=2;const w=I;for(;I<D.length&&(v=D.charCodeAt(I),v!==r.CharCode.Backslash);I++);return!(w===I||(v=D.charCodeAt(I+1),isNaN(v)||v===r.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,P=/[/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(D,v=A.$i){const I=v?d:P;return!(!D||D.length===0||/^\s+$/.test(D)||(I.lastIndex=0,I.test(D))||v&&b.test(D)||D==="."||D===".."||v&&D[D.length-1]==="."||v&&D.length!==D.trim().length||D.length>255)}function u(D,v,I){const w=D===v;return!I||w?w:!D||!v?!1:(0,R.$Bf)(D,v)}function f(D,v,I,w=m.sep){if(D===v)return!0;if(!D||!v||v.length>D.length)return!1;if(I){if(!(0,R.$Cf)(D,v))return!1;if(v.length===D.length)return!0;let N=v.length;return v.charAt(v.length-1)===w&&N--,D.charAt(N)===w}return v.charAt(v.length-1)!==w&&(v+=w),D.indexOf(v)===0}function g(D){return D>=r.CharCode.A&&D<=r.CharCode.Z||D>=r.CharCode.a&&D<=r.CharCode.z}function n(D,v){return A.$i&&D.endsWith(":")&&(D+=m.sep),(0,m.$ic)(D)||(D=(0,m.$jc)(v,D)),D=(0,m.$hc)(D),s(D)}function s(D){return A.$i?(D=(0,R.$jf)(D,m.sep),D.endsWith(":")&&(D+=m.sep)):(D=(0,R.$jf)(D,m.sep),D||(D=m.sep)),D}function i(D){const v=(0,m.$hc)(D);return A.$i?D.length>3?!1:t(v)&&(D.length===2||v.charCodeAt(2)===r.CharCode.Backslash):v===m.$gc.sep}function t(D,v=A.$i){return v?g(D.charCodeAt(0))&&D.charCodeAt(1)===r.CharCode.Colon:!1}function l(D,v=A.$i){return t(D,v)?D[0]:void 0}function h(D,v,I){return v.length>D.length?-1:D===v?0:(I&&(D=D.toLowerCase(),v=v.toLowerCase()),D.indexOf(v))}function o(D){const v=D.split(":");let I,w,y;for(const N of v){const O=Number(N);(0,L.$eg)(O)?w===void 0?w=O:y===void 0&&(y=O):I=I?[I,N].join(":"):N}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:w!==void 0?w:void 0,column:y!==void 0?y:w!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(D,v,I=8){let w="";for(let N=0;N<I;N++){let O;N===0&&A.$i&&!v&&(I===3||I===4)?O=E:O=$,w+=O.charAt(Math.floor(Math.random()*O.length))}let y;return v?y=`${v}-${w}`:y=w,D?(0,m.$jc)(D,y):y}}),define(ye[140],Se([1,0,27,139,134,61,16,11,13]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=S,e.$Cr=f,e.$Dr=o,e.$Er=w,e.$Fr=z,e.$Gr=F;const c=0,C=[c,[]];function S(J,ee,V,H){if(!J||!ee)return C;const _=J.length,ne=ee.length;if(_<ne)return C;const he=J.toLowerCase();return d(ee,V,ne,J,he,_,H)}function d(J,ee,V,H,_,ne,he){const re=[],ve=[];for(let se=0;se<V;se++){const ae=se*ne,ie=ae-ne,ce=se>0,ue=J[se],Z=ee[se];for(let oe=0;oe<ne;oe++){const $e=oe>0,be=ae+oe,Ne=be-1,Be=ie+oe-1,De=$e?re[Ne]:0,Ie=ce&&$e?re[Be]:0,Le=ce&&$e?ve[Be]:0;let W;!Ie&&ce?W=0:W=P(ue,Z,H,_,oe,Le),W&&Ie+W>=De&&(he||ce||_.startsWith(ee,oe))?(ve[be]=Le+1,re[be]=Ie+W):(ve[be]=c,re[be]=De)}}const pe=[];let Q=V-1,B=ne-1;for(;Q>=0&&B>=0;){const se=Q*ne+B;ve[se]===c||(pe.push(B),Q--),B--}return[re[V*ne-1],pe.reverse()]}function P(J,ee,V,H,_,ne){let he=0;if(!b(ee,H[_]))return he;if(he+=1,ne>0&&(he+=ne*5),J===V[_]&&(he+=1),_===0)he+=8;else{const re=a(V.charCodeAt(_-1));re?he+=re:(0,A.$Fk)(V.charCodeAt(_))&&ne===0&&(he+=2)}return he}function b(J,ee){return J===ee?!0:J==="/"||J==="\\"?ee==="/"||ee==="\\":!1}function a(J){switch(J){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const u=[void 0,[]];function f(J,ee,V=0,H=0){const _=ee;return _.values&&_.values.length>1?g(J,_.values,V,H):n(J,ee,V,H)}function g(J,ee,V,H){let _=0;const ne=[];for(const he of ee){const[re,ve]=n(J,he,V,H);if(typeof re!="number")return u;_+=re,ne.push(...ve)}return[_,v(ne)]}function n(J,ee,V,H){const _=(0,A.$Ok)(ee.original,ee.originalLowercase,V,J,J.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?[_[0],(0,A.$Lk)(_)]:u}const s=Object.freeze({score:0}),i=1<<18,t=1<<17,l=65536;function h(J,ee,V,H){const _=H.values?H.values:[H];return(0,R.$oj)({[H.normalized]:{values:_.map(he=>({value:he.normalized,expectContiguousMatch:he.expectContiguousMatch})),label:J,description:ee,allowNonContiguousMatches:V}})}function o(J,ee,V,H,_){if(!J||!ee.normalized)return s;const ne=H.getItemLabel(J);if(!ne)return s;const he=H.getItemDescription(J),re=h(ne,he,V,ee),ve=_[re];if(ve)return ve;const pe=$(ne,he,H.getItemPath(J),ee,V);return _[re]=pe,pe}function $(J,ee,V,H,_){const ne=!V||!H.containsPathSeparator;return V&&(T.$k?H.pathNormalized===V:(0,p.$Bf)(H.pathNormalized,V))?{score:i,labelMatch:[{start:0,end:J.length}],descriptionMatch:ee?[{start:0,end:ee.length}]:void 0}:H.values&&H.values.length>1?E(J,ee,V,H.values,ne,_):k(J,ee,V,H,ne,_)}function E(J,ee,V,H,_,ne){let he=0;const re=[],ve=[];for(const pe of H){const{score:Q,labelMatch:B,descriptionMatch:se}=k(J,ee,V,pe,_,ne);if(Q===c)return s;he+=Q,B&&re.push(...B),se&&ve.push(...se)}return{score:he,labelMatch:v(re),descriptionMatch:v(ve)}}function k(J,ee,V,H,_,ne){if(_||!ee){const[he,re]=S(J,H.normalized,H.normalizedLowercase,ne&&!H.expectContiguousMatch);if(he){const ve=(0,A.$Ck)(H.normalized,J);let pe;if(ve){pe=t;const Q=Math.round(H.normalized.length/J.length*100);pe+=Q}else pe=l;return{score:pe+he,labelMatch:ve||D(re)}}}if(ee){let he=ee;V&&(he=`${ee}${L.sep}`);const re=he.length,ve=`${he}${J}`,[pe,Q]=S(ve,H.normalized,H.normalizedLowercase,ne&&!H.expectContiguousMatch);if(pe){const B=D(Q),se=[],ae=[];return B.forEach(ie=>{ie.start<re&&ie.end>re?(se.push({start:0,end:ie.end-re}),ae.push({start:ie.start,end:re})):ie.start>=re?se.push({start:ie.start-re,end:ie.end-re}):ae.push(ie)}),{score:pe,labelMatch:se,descriptionMatch:ae}}}return s}function D(J){const ee=[];if(!J)return ee;let V;for(const H of J)V&&V.end===H?V.end+=1:(V={start:H,end:H+1},ee.push(V));return ee}function v(J){const ee=J.sort((_,ne)=>_.start-ne.start),V=[];let H;for(const _ of ee)!H||!I(H,_)?(H=_,V.push(_)):(H.start=Math.min(H.start,_.start),H.end=Math.max(H.end,_.end));return V}function I(J,ee){return!(J.end<ee.start||ee.end<J.start)}function w(J,ee,V,H,_,ne){const he=o(J,V,H,_,ne),re=o(ee,V,H,_,ne),ve=he.score,pe=re.score;if((ve===i||pe===i)&&ve!==pe)return ve===i?-1:1;if(ve>l||pe>l){if(ve!==pe)return ve>pe?-1:1;if(ve<t&&pe<t){const ue=N(he.labelMatch,re.labelMatch);if(ue!==0)return ue}const ie=_.getItemLabel(J)||"",ce=_.getItemLabel(ee)||"";if(ie.length!==ce.length)return ie.length-ce.length}if(ve!==pe)return ve>pe?-1:1;const Q=Array.isArray(he.labelMatch)&&he.labelMatch.length>0,B=Array.isArray(re.labelMatch)&&re.labelMatch.length>0;if(Q&&!B)return-1;if(B&&!Q)return 1;const se=y(J,he,_),ae=y(ee,re,_);return se&&ae&&se!==ae?ae>se?-1:1:O(J,ee,V,_)}function y(J,ee,V){let H=-1,_=-1;if(ee.descriptionMatch&&ee.descriptionMatch.length?H=ee.descriptionMatch[0].start:ee.labelMatch&&ee.labelMatch.length&&(H=ee.labelMatch[0].start),ee.labelMatch&&ee.labelMatch.length){if(_=ee.labelMatch[ee.labelMatch.length-1].end,ee.descriptionMatch&&ee.descriptionMatch.length){const ne=V.getItemDescription(J);ne&&(_+=ne.length)}}else ee.descriptionMatch&&ee.descriptionMatch.length&&(_=ee.descriptionMatch[ee.descriptionMatch.length-1].end);return _-H}function N(J,ee){if(!J&&!ee||(!J||!J.length)&&(!ee||!ee.length))return 0;if(!ee||!ee.length)return-1;if(!J||!J.length)return 1;const V=J[0].start,_=J[J.length-1].end-V,ne=ee[0].start,re=ee[ee.length-1].end-ne;return _===re?0:re<_?1:-1}function O(J,ee,V,H){const _=H.getItemLabel(J)||"",ne=H.getItemLabel(ee)||"",he=H.getItemDescription(J),re=H.getItemDescription(ee),ve=_.length+(he?he.length:0),pe=ne.length+(re?re.length:0);if(ve!==pe)return ve-pe;const Q=H.getItemPath(J),B=H.getItemPath(ee);return Q&&B&&Q.length!==B.length?Q.length-B.length:_!==ne?(0,m.$zr)(_,ne,V.normalized):he&&re&&he!==re?(0,m.$zr)(he,re,V.normalized):Q&&B&&Q!==B?(0,m.$zr)(Q,B,V.normalized):0}function U(J){return J.startsWith('"')&&J.endsWith('"')}const j=" ";function z(J){typeof J!="string"&&(J="");const ee=J.toLowerCase(),{pathNormalized:V,normalized:H,normalizedLowercase:_}=M(J),ne=V.indexOf(L.sep)>=0,he=U(J);let re;const ve=J.split(j);if(ve.length>1)for(const pe of ve){const Q=U(pe),{pathNormalized:B,normalized:se,normalizedLowercase:ae}=M(pe);se&&(re||(re=[]),re.push({original:pe,originalLowercase:pe.toLowerCase(),pathNormalized:B,normalized:se,normalizedLowercase:ae,expectContiguousMatch:Q}))}return{original:J,originalLowercase:ee,pathNormalized:V,normalized:H,normalizedLowercase:_,values:re,containsPathSeparator:ne,expectContiguousMatch:he}}function M(J){let ee;T.$i?ee=J.replace(/\//g,L.sep):ee=J.replace(/\\/g,L.sep);const V=(0,p.$lf)(ee).replace(/\s|"/g,"");return{pathNormalized:ee,normalized:V,normalizedLowercase:V.toLowerCase()}}function F(J){return Array.isArray(J)?z(J.map(ee=>ee.original).join(j)):z(J.original)}}),define(ye[107],Se([1,0,16]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Zs=R,e.$1s=L,e.$2s=T,e.$3s=c,e.$Ys=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const m={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(C){const S=(0,r.$oc)(C),d=m[S.toLowerCase()];return d!==void 0?d:L(C)}function L(C){const S=(0,r.$oc)(C);return A[S.toLowerCase()]}function T(C){for(const S in A)if(A[S]===C)return S}const p=/^(.+)\/(.+?)(;.+)?$/;function c(C,S){const d=p.exec(C);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:S?void 0:C}}),define(ye[108],Se([1,0,11]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$rm=R,e.$sm=L;var m;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(m||(e.Source=m={}));var A;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function R(T,...p){const c=p.reduce((d,P)=>(d[P]=!0,d),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(d=>!c[d]).forEach(d=>{for(let P=0;P<C.length;P++)if(d.search(C[P])!==-1){delete T[d];break}})}function L(T){T&&(delete T.DEBUG,r.$j&&delete T.DYLD_LIBRARY_PATH,r.$k&&delete T.LD_PRELOAD)}}),define(ye[2],Se([1,0,27,41,16,11]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=u,e.$wc=t;const L=/^\w[\w\d+.-]*$/,T=/^\//,p=/^\/\//;function c(E,k){if(!E.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${E.authority}", path: "${E.path}", query: "${E.query}", fragment: "${E.fragment}"}`);if(E.scheme&&!L.test(E.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(E.path){if(E.authority){if(!T.test(E.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(E.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(E,k){return!E&&!k?"file":E}function S(E,k){switch(E){case"https":case"http":case"file":k?k[0]!==P&&(k=P+k):k=P;break}return k}const d="",P="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(k){return k instanceof a?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,D,v,I,w,y=!1){typeof k=="object"?(this.scheme=k.scheme||d,this.authority=k.authority||d,this.path=k.path||d,this.query=k.query||d,this.fragment=k.fragment||d):(this.scheme=C(k,y),this.authority=D||d,this.path=S(this.scheme,v||d),this.query=I||d,this.fragment=w||d,c(this,y))}get fsPath(){return t(this,!1)}with(k){if(!k)return this;let{scheme:D,authority:v,path:I,query:w,fragment:y}=k;return D===void 0?D=this.scheme:D===null&&(D=d),v===void 0?v=this.authority:v===null&&(v=d),I===void 0?I=this.path:I===null&&(I=d),w===void 0?w=this.query:w===null&&(w=d),y===void 0?y=this.fragment:y===null&&(y=d),D===this.scheme&&v===this.authority&&I===this.path&&w===this.query&&y===this.fragment?this:new g(D,v,I,w,y)}static parse(k,D=!1){const v=b.exec(k);return v?new g(v[2]||d,$(v[4]||d),$(v[5]||d),$(v[7]||d),$(v[9]||d),D):new g(d,d,d,d,d)}static file(k){let D=d;if(R.$i&&(k=k.replace(/\\/g,P)),k[0]===P&&k[1]===P){const v=k.indexOf(P,2);v===-1?(D=k.substring(2),k=P):(D=k.substring(2,v),k=k.substring(v)||P)}return new g("file",D,k,d,d)}static from(k,D){return new g(k.scheme,k.authority,k.path,k.query,k.fragment,D)}static joinPath(k,...D){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return R.$i&&k.scheme==="file"?v=a.file(A.$fc.join(t(k,!0),...D)).path:v=A.$gc.join(k.path,...D),k.with({path:v})}toString(k=!1){return l(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof a)return k;{const D=new g(k);return D._formatted=k.external??null,D._fsPath=k._sep===f?k.fsPath??null:null,D}}else return k}}e.URI=a;function u(E){return!E||typeof E!="object"?!1:typeof E.scheme=="string"&&(typeof E.authority=="string"||typeof E.authority>"u")&&(typeof E.path=="string"||typeof E.path>"u")&&(typeof E.query=="string"||typeof E.query>"u")&&(typeof E.fragment=="string"||typeof E.fragment>"u")}const f=R.$i?1:void 0;class g extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(k=!1){return k?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const k={$mid:m.MarshalledId.Uri};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=f),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const n={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function s(E,k,D){let v,I=-1;for(let w=0;w<E.length;w++){const y=E.charCodeAt(w);if(y>=r.CharCode.a&&y<=r.CharCode.z||y>=r.CharCode.A&&y<=r.CharCode.Z||y>=r.CharCode.Digit0&&y<=r.CharCode.Digit9||y===r.CharCode.Dash||y===r.CharCode.Period||y===r.CharCode.Underline||y===r.CharCode.Tilde||k&&y===r.CharCode.Slash||D&&y===r.CharCode.OpenSquareBracket||D&&y===r.CharCode.CloseSquareBracket||D&&y===r.CharCode.Colon)I!==-1&&(v+=encodeURIComponent(E.substring(I,w)),I=-1),v!==void 0&&(v+=E.charAt(w));else{v===void 0&&(v=E.substr(0,w));const N=n[y];N!==void 0?(I!==-1&&(v+=encodeURIComponent(E.substring(I,w)),I=-1),v+=N):I===-1&&(I=w)}}return I!==-1&&(v+=encodeURIComponent(E.substring(I))),v!==void 0?v:E}function i(E){let k;for(let D=0;D<E.length;D++){const v=E.charCodeAt(D);v===r.CharCode.Hash||v===r.CharCode.QuestionMark?(k===void 0&&(k=E.substr(0,D)),k+=n[v]):k!==void 0&&(k+=E[D])}return k!==void 0?k:E}function t(E,k){let D;return E.authority&&E.path.length>1&&E.scheme==="file"?D=`//${E.authority}${E.path}`:E.path.charCodeAt(0)===r.CharCode.Slash&&(E.path.charCodeAt(1)>=r.CharCode.A&&E.path.charCodeAt(1)<=r.CharCode.Z||E.path.charCodeAt(1)>=r.CharCode.a&&E.path.charCodeAt(1)<=r.CharCode.z)&&E.path.charCodeAt(2)===r.CharCode.Colon?k?D=E.path.substr(1):D=E.path[1].toLowerCase()+E.path.substr(2):D=E.path,R.$i&&(D=D.replace(/\//g,"\\")),D}function l(E,k){const D=k?i:s;let v="",{scheme:I,authority:w,path:y,query:N,fragment:O}=E;if(I&&(v+=I,v+=":"),(w||I==="file")&&(v+=P,v+=P),w){let U=w.indexOf("@");if(U!==-1){const j=w.substr(0,U);w=w.substr(U+1),U=j.lastIndexOf(":"),U===-1?v+=D(j,!1,!1):(v+=D(j.substr(0,U),!1,!1),v+=":",v+=D(j.substr(U+1),!1,!0)),v+="@"}w=w.toLowerCase(),U=w.lastIndexOf(":"),U===-1?v+=D(w,!1,!0):(v+=D(w.substr(0,U),!1,!0),v+=w.substr(U))}if(y){if(y.length>=3&&y.charCodeAt(0)===r.CharCode.Slash&&y.charCodeAt(2)===r.CharCode.Colon){const U=y.charCodeAt(1);U>=r.CharCode.A&&U<=r.CharCode.Z&&(y=`/${String.fromCharCode(U+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===r.CharCode.Colon){const U=y.charCodeAt(0);U>=r.CharCode.A&&U<=r.CharCode.Z&&(y=`${String.fromCharCode(U+32)}:${y.substr(2)}`)}v+=D(y,!0,!1)}return N&&(v+="?",v+=D(N,!1,!1)),O&&(v+="#",v+=k?O:s(O,!1,!1)),v}function h(E){try{return decodeURIComponent(E)}catch{return E.length>3?E.substr(0,3)+h(E.substr(3)):E}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function $(E){return E.match(o)?E.replace(o,k=>h(k)):E}}),define(ye[205],Se([1,0,2]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=m,e.$5q=A,e.$6q=R,e.log=T;function m(c){const C=c;return C&&typeof C.type=="string"&&typeof C.severity=="string"}function A(c){const C=[];let S;try{const d=JSON.parse(c.arguments),P=d[d.length-1];P&&P.__$stack&&(d.pop(),S=P.__$stack),C.push(...d)}catch{C.push("Unable to log remote console arguments",c.arguments)}return{args:C,stack:S}}function R(c){if(typeof c!="string")return R(A(c).stack);const C=c;if(C){const S=L(C),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(d&&d.length===4)return{uri:r.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function L(c){if(!c)return c;const C=c.indexOf(`
`);return C===-1?c:c.substring(0,C)}function T(c,C){const{args:S,stack:d}=A(c),P=typeof S[0]=="string"&&S.length===1;let b=L(d);b&&(b=`(${b.trim()})`);let a=[];if(typeof S[0]=="string"?b&&P?a=[`%c[${C}] %c${S[0]} %c${b}`,p("blue"),p(""),p("grey")]:a=[`%c[${C}] %c${S[0]}`,p("blue"),p(""),...S.slice(1)]:a=[`%c[${C}]%`,p("blue"),...S],b&&!P&&a.push(b),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,a)}function p(c){return`color: ${c}`}}),define(ye[57],Se([1,0,22,2,41]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=R,e.$9h=L,e.$0h=p;function R(c){return JSON.stringify(c,T)}function L(c){let C=JSON.parse(c);return C=p(C),C}function T(c,C){return C instanceof RegExp?{$mid:A.MarshalledId.Regexp,source:C.source,flags:C.flags}:C}function p(c,C=0){if(!c||C>200)return c;if(typeof c=="object"){switch(c.$mid){case A.MarshalledId.Uri:return m.URI.revive(c);case A.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case A.MarshalledId.Date:return new Date(c.source)}if(c instanceof r.$Je||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let S=0;S<c.length;++S)c[S]=p(c[S],C+1);else for(const S in c)Object.hasOwnProperty.call(c,S)&&(c[S]=p(c[S],C+1))}return c}}),define(ye[15],Se([1,0,14,11,13,2,16]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=p,e.$Kg=c,e.$Og=S;var T;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatCodeBlock="vscode-chat-code-block",b.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",b.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm",b.commentsInput="comment",b.codeSetting="code-setting"})(T||(e.Schemas=T={}));function p(b,a){return R.URI.isUri(b)?(0,A.$Bf)(b.scheme,a):(0,A.$Cf)(b,a+":")}function c(b,...a){return a.some(u=>p(b,u))}e.$Lg="vscode-tkn",e.$Mg="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,u){this.f=S(a,u)}getServerRootPath(){return this.f}get g(){return L.$gc.join(this.f,T.vscodeRemoteResource)}set(a,u,f){this.a[a]=u,this.b[a]=f}setConnectionToken(a,u){this.c[a]=u}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(i){return r.$1(i),a}const u=a.authority;let f=this.a[u];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const g=this.b[u],n=this.c[u];let s=`path=${encodeURIComponent(a.path)}`;return typeof n=="string"&&(s+=`&${e.$Mg}=${encodeURIComponent(n)}`),R.URI.from({scheme:m.$o?this.d:T.vscodeRemoteResource,authority:`${f}:${g}`,path:this.g,query:s})}}e.$Ng=new C;function S(b,a){return L.$gc.join(a??"/",`${b.quality??"oss"}-${b.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class d{static{this.a=e.$Tg}asBrowserUri(a){const u=this.b(a,de);return this.uriToBrowserUri(u)}uriToBrowserUri(a){return a.scheme===T.vscodeRemote?e.$Ng.rewrite(a):a.scheme===T.file&&(m.$m||m.$q===`${T.vscodeFileResource}://${d.a}`)?a.with({scheme:T.vscodeFileResource,authority:a.authority||d.a,query:null,fragment:null}):a}asFileUri(a){const u=this.b(a,de);return this.uriToFileUri(u)}uriToFileUri(a){return a.scheme===T.vscodeFileResource?a.with({scheme:T.file,authority:a.authority!==d.a?a.authority:null,query:null,fragment:null}):a}b(a,u){return R.URI.isUri(a)?a:R.URI.parse(u.toUrl(a))}}e.$Ug=new d;var P;(function(b){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(a.get("3"));const u="vscode-coi";function f(n){let s;typeof n=="string"?s=new URL(n).searchParams:n instanceof URL?s=n.searchParams:R.URI.isUri(n)&&(s=new URL(n.toString(!0)).searchParams);const i=s?.get(u);if(i)return a.get(i)}b.getHeadersFromQuery=f;function g(n,s,i){if(!globalThis.crossOriginIsolated)return;const t=s&&i?"3":i?"2":"1";n instanceof URLSearchParams?n.set(u,t):n[u]=t}b.addSearchParam=g})(P||(e.COI=P={}))}),define(ye[206],Se([1,0,172,15,11,2]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gE=C;class L{constructor(d,P,b){this.id=d,this.dependencies=P,this.callback=b}}class T{static{this.INSTANCE=new T}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,P,b)=>{typeof d!="string"&&(b=P,P=d,d=null),(typeof P!="object"||!Array.isArray(P))&&(b=P,P=null),this.c.push(new L(d,P,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const P=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!P)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(P.dependencies)&&P.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${P.dependencies.join(", ")}`);return typeof P.callback=="function"?P.callback([]):P.callback}h(d){return new Promise((P,b)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const u=()=>{a.removeEventListener("load",f),a.removeEventListener("error",g)},f=n=>{u(),P(this.c.pop())},g=n=>{u(),b(n)};a.addEventListener("load",f),a.addEventListener("error",g),this.f&&(d=this.f.createScriptURL(d)),a.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(a)})}i(d){return new Promise((P,b)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),P(this.c.pop())}catch(a){b(a)}})}async j(d){try{const P=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,u=R.URI.parse(d).fsPath,f=P.readFileSync(u).toString(),g=a.wrap(f.replace(/^#!.*/,""));return new b.Script(g).runInThisContext().apply(),this.c.pop()}catch(P){throw P}}}const p=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function C(S,d,P){if(r.$T){P===void 0&&(P=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[S]&&(S=c[S]);const b=`${S}/${d}`;if(p.has(b))return p.get(b);let a;if(/^\w[\w\d+.-]*:\/\//.test(b))a=b;else{const n=`${P&&!A.$o?m.$Rg:m.$Qg}/${b}`;a=m.$Ug.asBrowserUri(n).toString(!0)}const u=T.INSTANCE.load(a);return p.set(b,u),u}else return await new Promise((b,a)=>{de([S],b,a)})}}),define(ye[23],Se([1,0,27,33,15,16,11,13,2]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=c,e.$kh=S,e.$lh=P;function c(b){return(0,p.$wc)(b,!0)}class C{constructor(a){this.a=a}compare(a,u,f=!1){return a===u?0:(0,T.$uf)(this.getComparisonKey(a,f),this.getComparisonKey(u,f))}isEqual(a,u,f=!1){return a===u?!0:!a||!u?!1:this.getComparisonKey(a,f)===this.getComparisonKey(u,f)}getComparisonKey(a,u=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,u,f=!1){if(a.scheme===u.scheme){if(a.scheme===A.Schemas.file)return m.$zg(c(a),c(u),this.a(a))&&a.query===u.query&&(f||a.fragment===u.fragment);if((0,e.$gh)(a.authority,u.authority))return m.$zg(a.path,u.path,this.a(a),"/")&&a.query===u.query&&(f||a.fragment===u.fragment)}return!1}joinPath(a,...u){return p.URI.joinPath(a,...u)}basenameOrAuthority(a){return(0,e.$$g)(a)||a.authority}basename(a){return R.$gc.basename(a.path)}extname(a){return R.$gc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let u;return a.scheme===A.Schemas.file?u=p.URI.file(R.$mc(c(a))).path:(u=R.$gc.dirname(a.path),a.authority&&u.length&&u.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),u="/")),a.with({path:u})}normalizePath(a){if(!a.path.length)return a;let u;return a.scheme===A.Schemas.file?u=p.URI.file(R.$hc(c(a))).path:u=R.$gc.normalize(a.path),a.with({path:u})}relativePath(a,u){if(a.scheme!==u.scheme||!(0,e.$gh)(a.authority,u.authority))return;if(a.scheme===A.Schemas.file){const n=R.$lc(c(a),c(u));return L.$i?m.$tg(n):n}let f=a.path||"/";const g=u.path||"/";if(this.a(a)){let n=0;for(const s=Math.min(f.length,g.length);n<s&&!(f.charCodeAt(n)!==g.charCodeAt(n)&&f.charAt(n).toLowerCase()!==g.charAt(n).toLowerCase());n++);f=g.substr(0,n)+f.substr(n)}return R.$gc.relative(f,g)}resolvePath(a,u){if(a.scheme===A.Schemas.file){const f=p.URI.file(R.$kc(c(a),u));return a.with({authority:f.authority,path:f.path})}return u=m.$ug(u),a.with({path:R.$gc.resolve(a.path,u)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,u){return a===u||a!==void 0&&u!==void 0&&(0,T.$Bf)(a,u)}hasTrailingPathSeparator(a,u=R.sep){if(a.scheme===A.Schemas.file){const f=c(a);return f.length>m.$vg(f).length&&f[f.length-1]===u}else{const f=a.path;return f.length>1&&f.charCodeAt(f.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,u=R.sep){return(0,e.$hh)(a,u)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,u=R.sep){let f=!1;if(a.scheme===A.Schemas.file){const g=c(a);f=g!==void 0&&g.length===m.$vg(g).length&&g[g.length-1]===u}else{u="/";const g=a.path;f=g.length===1&&g.charCodeAt(g.length-1)===r.CharCode.Slash}return!f&&!(0,e.$hh)(a,u)?a.with({path:a.path+"/"}):a}}e.$3g=C,e.$4g=new C(()=>!1),e.$5g=new C(b=>b.scheme===A.Schemas.file?!L.$k:!0),e.$6g=new C(b=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function S(b,a){const u=[];for(let f=0;f<b.length;f++){const g=a(b[f]);b.some((n,s)=>s===f?!1:(0,e.$8g)(g,a(n)))||u.push(b[f])}return u}var d;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function a(u){const f=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(s=>{const[i,t]=s.split(":");i&&t&&f.set(i,t)});const n=u.path.substring(0,u.path.indexOf(";"));return n&&f.set(b.META_DATA_MIME,n),f}b.parseMetaData=a})(d||(e.DataUri=d={}));function P(b,a,u){if(a){let f=b.path;return f&&f[0]!==R.$gc.sep&&(f=R.$gc.sep+f),b.with({scheme:u,authority:a,path:f})}return b.with({scheme:u})}}),define(ye[9],Se([1,0,21,14,4,3,23,11,183,49]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=C,e.$nh=S,e.$oh=d,e.$ph=P,e.$qh=b,e.$rh=a,e.$sh=u,e.$th=f,e.$Bh=E,e.$Ch=k,e.$Dh=D,e.$Eh=v,e.$Fh=I,e.$Uh=H,e.$3h=ie;function C(ue){return!!ue&&typeof ue.then=="function"}function S(ue){const Z=new r.$se,oe=ue(Z.token),$e=new Promise((be,Ne)=>{const Be=Z.token.onCancellationRequested(()=>{Be.dispose(),Ne(new m.$5)});Promise.resolve(oe).then(De=>{Be.dispose(),Z.dispose(),be(De)},De=>{Be.dispose(),Z.dispose(),Ne(De)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(be,Ne){return $e.then(be,Ne)}catch(be){return this.then(void 0,be)}finally(be){return $e.finally(be)}}}function d(ue,Z,oe){return new Promise(($e,be)=>{const Ne=Z.onCancellationRequested(()=>{Ne.dispose(),$e(oe)});ue.then($e,be).finally(()=>Ne.dispose())})}function P(ue,Z){return new Promise((oe,$e)=>{const be=Z.onCancellationRequested(()=>{be.dispose(),$e(new m.$5)});ue.then(oe,$e).finally(()=>be.dispose())})}async function b(ue){let Z=-1;const oe=ue.map(($e,be)=>$e.then(Ne=>(Z=be,Ne)));try{return await Promise.race(oe)}finally{ue.forEach(($e,be)=>{be!==Z&&$e.cancel()})}}function a(ue,Z,oe){let $e;const be=setTimeout(()=>{$e?.(void 0),oe?.()},Z);return Promise.race([ue.finally(()=>clearTimeout(be)),new Promise(Ne=>$e=Ne)])}function u(ue){return new Promise((Z,oe)=>{const $e=ue();C($e)?$e.then(Z,oe):Z($e)})}function f(){let ue,Z;return{promise:new Promise(($e,be)=>{ue=$e,Z=be}),resolve:ue,reject:Z}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const oe=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(oe,oe).then($e)})}return new Promise((oe,$e)=>{this.b.then(oe,$e)})}return this.a=Z(),new Promise((oe,$e)=>{this.a.then(be=>{this.a=null,oe(be)},be=>{this.a=null,$e(be)})})}dispose(){this.f=!0}}e.$uh=g;class n{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$vh=n;class s{constructor(){this.a=new Map}queue(Z,oe){const be=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(Z)===be&&this.a.delete(Z)});return this.a.set(Z,be),be}}e.$wh=s;const i=(ue,Z)=>{let oe=!0;const $e=setTimeout(()=>{oe=!1,Z()},ue);return{isTriggered:()=>oe,dispose:()=>{clearTimeout($e),oe=!1}}},t=ue=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,ue())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class l{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,oe=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((be,Ne)=>{this.d=be,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=oe===p.$ce?t($e):i(oe,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new m.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=l;class h{constructor(Z){this.a=new l(Z),this.b=new g}trigger(Z,oe){return this.a.trigger(()=>this.b.queue(Z),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=h;class o{constructor(){this.a=!1,this.b=new Promise((Z,oe)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=o;class $ extends o{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Ah=$;function E(ue,Z){return Z?new Promise((oe,$e)=>{const be=setTimeout(()=>{Ne.dispose(),oe()},ue),Ne=Z.onCancellationRequested(()=>{clearTimeout(be),Ne.dispose(),$e(new m.$5)})}):S(oe=>E(ue,oe))}function k(ue,Z=0,oe){const $e=setTimeout(()=>{ue(),oe&&be.dispose()},Z),be=(0,R.$Sc)(()=>{clearTimeout($e),oe?.deleteAndLeak(be)});return oe?.add(be),be}function D(ue){const Z=[];let oe=0;const $e=ue.length;function be(){return oe<$e?ue[oe++]():null}function Ne(Be){Be!=null&&Z.push(Be);const De=be();return De?De.then(Ne):Promise.resolve(Z)}return Promise.resolve(null).then(Ne)}function v(ue,Z=$e=>!!$e,oe=null){let $e=0;const be=ue.length,Ne=()=>{if($e>=be)return Promise.resolve(oe);const Be=ue[$e++];return Promise.resolve(Be()).then(Ie=>Z(Ie)?Promise.resolve(Ie):Ne())};return Ne()}function I(ue,Z=$e=>!!$e,oe=null){if(ue.length===0)return Promise.resolve(oe);let $e=ue.length;const be=()=>{$e=-1;for(const Ne of ue)Ne.cancel?.()};return new Promise((Ne,Be)=>{for(const De of ue)De.then(Ie=>{--$e>=0&&Z(Ie)?(be(),Ne(Ie)):$e===0&&Ne(oe)}).catch(Ie=>{--$e>=0&&(be(),Be(Ie))})})}class w{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new A.$he}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((oe,$e)=>{this.g.push({factory:Z,c:oe,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const oe=Z.factory();oe.then(Z.c,Z.e),oe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=w;class y extends w{constructor(){super(1)}}e.$Hh=y;class N{constructor(){this.a=new _,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Ih=N;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new re;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,oe=L.$4g){const $e=oe.getComparisonKey(Z);return this.a.get($e)?.size??0}queueFor(Z,oe,$e=L.$4g){const be=$e.getComparisonKey(Z);let Ne=this.a.get(be);if(!Ne){Ne=new y;const Be=this.f++,De=A.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(Be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(Be,De),this.a.set(be,Ne)}return Ne.queue(oe)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=O;class U{constructor(Z,oe){this.b=!1,this.a=-1,typeof Z=="function"&&typeof oe=="number"&&this.setIfNotSet(Z,oe)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,oe){if(this.b)throw new m.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},oe)}setIfNotSet(Z,oe){if(this.b)throw new m.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},oe))}}e.$Kh=U;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,oe,$e=globalThis){if(this.f)throw new m.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const be=$e.setInterval(()=>{Z()},oe);this.d=(0,R.$Sc)(()=>{$e.clearInterval(be),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=j;class z{constructor(Z,oe){this.b=-1,this.a=Z,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=z;class M{constructor(Z,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=Z,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=M;class F extends z{constructor(Z,oe){super(Z,oe),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Oh=F;class J extends R.$Uc{constructor(Z,oe){super(),this.g=Z,this.h=oe,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of Z)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(ue,Z)=>{(0,T.$B)(()=>{if(oe)return;const $e=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.$Rh=(ue,Z,oe)=>{const $e=ue.requestIdleCallback(Z,typeof oe=="number"?{timeout:oe}:void 0);let be=!1;return{dispose(){be||(be=!0,ue.cancelIdleCallback($e))}}},e.$Qh=ue=>(0,e.$Rh)(globalThis,ue)}();class ee{constructor(Z,oe){this.g=!1,this.d=()=>{try{this.j=oe()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Rh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=ee;class V extends ee{constructor(Z){super(globalThis,Z)}}e.$Th=V;async function H(ue,Z,oe){let $e;for(let be=0;be<oe;be++)try{return await ue()}catch(Ne){$e=Ne,await E(Z)}throw $e}class _{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,oe,$e){return this.a={taskId:Z,cancel:()=>$e?.(),promise:oe},oe.then(()=>this.d(Z),()=>this.d(Z)),oe}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:oe,resolve:$e,reject:be}=f();this.b={run:Z,promise:oe,promiseResolve:$e,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=_;class ne{constructor(Z,oe=()=>Date.now()){this.d=Z,this.f=oe,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$Wh=ne;var he;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})(he||(he={}));class re{get isRejected(){return this.d?.outcome===he.Rejected}get isResolved(){return this.d?.outcome===he.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===he.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,oe)=>{this.a=Z,this.b=oe})}complete(Z){return new Promise(oe=>{this.a(Z),this.d={outcome:he.Resolved,value:Z},oe()})}error(Z){return new Promise(oe=>{this.b(Z),this.d={outcome:he.Rejected,value:Z},oe()})}cancel(){return this.error(new m.$5)}}e.$Xh=re;var ve;(function(ue){async function Z($e){let be;const Ne=await Promise.all($e.map(Be=>Be.then(De=>De,De=>{be||(be=De)})));if(typeof be<"u")throw be;return Ne}ue.settled=Z;function oe($e){return new Promise(async(be,Ne)=>{try{await $e(be,Ne)}catch(Be){Ne(Be)}})}ue.withAsyncBody=oe})(ve||(e.Promises=ve={}));class pe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(oe=>(this.a=oe,this.d=!0,oe),oe=>{throw this.b=oe,this.d=!0,oe})}requireValue(){if(!this.d)throw new m.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=pe;class Q{constructor(Z){this.b=Z,this.a=new c.$V(()=>new pe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=Q;var B;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(B||(B={}));class se{static fromArray(Z){return new se(oe=>{oe.emitMany(Z)})}static fromPromise(Z){return new se(async oe=>{oe.emitMany(await Z)})}static fromPromises(Z){return new se(async oe=>{await Promise.all(Z.map(async $e=>oe.emitOne(await $e)))})}static merge(Z){return new se(async oe=>{await Promise.all(Z.map(async $e=>{for await(const be of $e)oe.emitOne(be)}))})}static{this.EMPTY=se.fromArray([])}constructor(Z,oe){this.a=B.Initial,this.b=[],this.d=null,this.f=oe,this.g=new A.$he,queueMicrotask(async()=>{const $e={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(Z($e)),this.k()}catch(be){this.l(be)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===B.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===B.DoneOK)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,oe){return new se(async $e=>{for await(const be of Z)$e.emitOne(oe(be))})}map(Z){return se.map(this,Z)}static filter(Z,oe){return new se(async $e=>{for await(const be of Z)oe(be)&&$e.emitOne(be)})}filter(Z){return se.filter(this,Z)}static coalesce(Z){return se.filter(Z,oe=>!!oe)}coalesce(){return se.coalesce(this)}static async toPromise(Z){const oe=[];for await(const $e of Z)oe.push($e);return oe}toPromise(){return se.toPromise(this)}h(Z){this.a===B.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===B.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===B.Initial&&(this.a=B.DoneOK,this.g.fire())}l(Z){this.a===B.Initial&&(this.a=B.DoneError,this.d=Z,this.g.fire())}}e.$1h=se;class ae extends se{constructor(Z,oe){super(oe),this.m=Z}cancel(){this.m.cancel()}}e.$2h=ae;function ie(ue){const Z=new r.$se,oe=ue(Z.token);return new ae(Z,async $e=>{const be=Z.token.onCancellationRequested(()=>{be.dispose(),Z.dispose(),$e.reject(new m.$5)});try{for await(const Ne of oe){if(Z.token.isCancellationRequested)return;$e.emitOne(Ne)}be.dispose(),Z.dispose()}catch(Ne){be.dispose(),Z.dispose(),$e.reject(Ne)}})}class ce{constructor(Z){this.a=new re,this.b=new se(be=>{if(oe){be.reject(oe);return}return $e&&be.emitMany($e),this.d=Ne=>be.reject(Ne),this.f=Ne=>be.emitOne(Ne),this.a.p},Z);let oe,$e;this.f=be=>{$e||($e=[]),$e.push(be)},this.d=be=>{oe||(oe=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$4h=ce}),define(ye[39],Se([1,0,19,9,27,33,29,16,11,13]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=C,e.$sk=a,e.$tk=N,e.$uk=O,e.$vk=U,e.$wk=j,e.$xk=z,e.$yk=ee;function C(){return Object.create(null)}e.$qk="**",e.$rk="/";const S="[/\\\\]",d="[^/\\\\]",P=/\//g;function b(V,H){switch(V){case 0:return"";case 1:return`${d}*?`;default:return`(?:${S}|${d}+${S}${H?`|${S}${d}+`:""})*?`}}function a(V,H){if(!V)return[];const _=[];let ne=!1,he=!1,re="";for(const ve of V){switch(ve){case H:if(!ne&&!he){_.push(re),re="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":he=!0;break;case"]":he=!1;break}re+=ve}return re&&_.push(re),_}function u(V){if(!V)return"";let H="";const _=a(V,e.$rk);if(_.every(ne=>ne===e.$qk))H=".*";else{let ne=!1;_.forEach((he,re)=>{if(he===e.$qk){if(ne)return;H+=b(2,re===_.length-1)}else{let ve=!1,pe="",Q=!1,B="";for(const se of he){if(se!=="}"&&ve){pe+=se;continue}if(Q&&(se!=="]"||!B)){let ae;se==="-"?ae=se:(se==="^"||se==="!")&&!B?ae="^":se===e.$rk?ae="":ae=(0,c.$df)(se),B+=ae;continue}switch(se){case"{":ve=!0;continue;case"[":Q=!0;continue;case"}":{const ie=`(?:${a(pe,",").map(ce=>u(ce)).join("|")})`;H+=ie,ve=!1,pe="";break}case"]":{H+="["+B+"]",Q=!1,B="";break}case"?":H+=d;continue;case"*":H+=b(1);continue;default:H+=(0,c.$df)(se)}}re<_.length-1&&(_[re+1]!==e.$qk||re+2<_.length)&&(H+=S)}ne=he===e.$qk})}return H}const f=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new L.$Dc(1e4),h=function(){return!1},o=function(){return null};function $(V,H){if(!V)return o;let _;typeof V!="string"?_=V.pattern:_=V,_=_.trim();const ne=`${_}_${!!H.trimForExclusions}`;let he=l.get(ne);if(he)return E(he,V);let re;return f.test(_)?he=D(_.substr(4),_):(re=g.exec(k(_,H)))?he=v(re[1],_):(H.trimForExclusions?s:n).test(_)?he=I(_,H):(re=i.exec(k(_,H)))?he=w(re[1].substr(1),_,!0):(re=t.exec(k(_,H)))?he=w(re[1],_,!1):he=y(_),l.set(ne,he),E(he,V)}function E(V,H){if(typeof H=="string")return V;const _=function(ne,he){return(0,R.$zg)(ne,H.base,!p.$k)?V((0,c.$if)(ne.substr(H.base.length),T.sep),he):null};return _.allBasenames=V.allBasenames,_.allPaths=V.allPaths,_.basenames=V.basenames,_.patterns=V.patterns,_}function k(V,H){return H.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function D(V,H){return function(_,ne){return typeof _=="string"&&_.endsWith(V)?H:null}}function v(V,H){const _=`/${V}`,ne=`\\${V}`,he=function(ve,pe){return typeof ve!="string"?null:pe?pe===V?H:null:ve===V||ve.endsWith(_)||ve.endsWith(ne)?H:null},re=[V];return he.basenames=re,he.patterns=[H],he.allBasenames=re,he}function I(V,H){const _=J(V.slice(1,-1).split(",").map(pe=>$(pe,H)).filter(pe=>pe!==o),V),ne=_.length;if(!ne)return o;if(ne===1)return _[0];const he=function(pe,Q){for(let B=0,se=_.length;B<se;B++)if(_[B](pe,Q))return V;return null},re=_.find(pe=>!!pe.allBasenames);re&&(he.allBasenames=re.allBasenames);const ve=_.reduce((pe,Q)=>Q.allPaths?pe.concat(Q.allPaths):pe,[]);return ve.length&&(he.allPaths=ve),he}function w(V,H,_){const ne=T.sep===T.$gc.sep,he=ne?V:V.replace(P,T.sep),re=T.sep+he,ve=T.$gc.sep+V;let pe;return _?pe=function(Q,B){return typeof Q=="string"&&(Q===he||Q.endsWith(re)||!ne&&(Q===V||Q.endsWith(ve)))?H:null}:pe=function(Q,B){return typeof Q=="string"&&(Q===he||!ne&&Q===V)?H:null},pe.allPaths=[(_?"*/":"./")+V],pe}function y(V){try{const H=new RegExp(`^${u(V)}$`);return function(_){return H.lastIndex=0,typeof _=="string"&&H.test(_)?V:null}}catch{return o}}function N(V,H,_){return!V||typeof H!="string"?!1:O(V)(H,void 0,_)}function O(V,H={}){if(!V)return h;if(typeof V=="string"||U(V)){const _=$(V,H);if(_===o)return h;const ne=function(he,re){return!!_(he,re)};return _.allBasenames&&(ne.allBasenames=_.allBasenames),_.allPaths&&(ne.allPaths=_.allPaths),ne}return M(V,H)}function U(V){const H=V;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}function j(V){return V.allBasenames||[]}function z(V){return V.allPaths||[]}function M(V,H){const _=J(Object.getOwnPropertyNames(V).map(pe=>F(pe,V[pe],H)).filter(pe=>pe!==o)),ne=_.length;if(!ne)return o;if(!_.some(pe=>!!pe.requiresSiblings)){if(ne===1)return _[0];const pe=function(se,ae){let ie;for(let ce=0,ue=_.length;ce<ue;ce++){const Z=_[ce](se,ae);if(typeof Z=="string")return Z;(0,m.$mh)(Z)&&(ie||(ie=[]),ie.push(Z))}return ie?(async()=>{for(const ce of ie){const ue=await ce;if(typeof ue=="string")return ue}return null})():null},Q=_.find(se=>!!se.allBasenames);Q&&(pe.allBasenames=Q.allBasenames);const B=_.reduce((se,ae)=>ae.allPaths?se.concat(ae.allPaths):se,[]);return B.length&&(pe.allPaths=B),pe}const he=function(pe,Q,B){let se,ae;for(let ie=0,ce=_.length;ie<ce;ie++){const ue=_[ie];ue.requiresSiblings&&B&&(Q||(Q=(0,T.$nc)(pe)),se||(se=Q.substr(0,Q.length-(0,T.$oc)(pe).length)));const Z=ue(pe,Q,se,B);if(typeof Z=="string")return Z;(0,m.$mh)(Z)&&(ae||(ae=[]),ae.push(Z))}return ae?(async()=>{for(const ie of ae){const ce=await ie;if(typeof ce=="string")return ce}return null})():null},re=_.find(pe=>!!pe.allBasenames);re&&(he.allBasenames=re.allBasenames);const ve=_.reduce((pe,Q)=>Q.allPaths?pe.concat(Q.allPaths):pe,[]);return ve.length&&(he.allPaths=ve),he}function F(V,H,_){if(H===!1)return o;const ne=$(V,_);if(ne===o)return o;if(typeof H=="boolean")return ne;if(H){const he=H.when;if(typeof he=="string"){const re=(ve,pe,Q,B)=>{if(!B||!ne(ve,pe))return null;const se=he.replace("$(basename)",()=>Q),ae=B(se);return(0,m.$mh)(ae)?ae.then(ie=>ie?V:null):ae?V:null};return re.requiresSiblings=!0,re}}return ne}function J(V,H){const _=V.filter(pe=>!!pe.basenames);if(_.length<2)return V;const ne=_.reduce((pe,Q)=>{const B=Q.basenames;return B?pe.concat(B):pe},[]);let he;if(H){he=[];for(let pe=0,Q=ne.length;pe<Q;pe++)he.push(H)}else he=_.reduce((pe,Q)=>{const B=Q.patterns;return B?pe.concat(B):pe},[]);const re=function(pe,Q){if(typeof pe!="string")return null;if(!Q){let se;for(se=pe.length;se>0;se--){const ae=pe.charCodeAt(se-1);if(ae===A.CharCode.Slash||ae===A.CharCode.Backslash)break}Q=pe.substr(se)}const B=ne.indexOf(Q);return B!==-1?he[B]:null};re.basenames=ne,re.patterns=he,re.allBasenames=ne;const ve=V.filter(pe=>!pe.basenames);return ve.push(re),ve}function ee(V,H){return(0,r.$ub)(V,H,(_,ne)=>typeof _=="string"&&typeof ne=="string"?_===ne:typeof _!="string"&&typeof ne!="string"?_.base===ne.base&&_.pattern===ne.pattern:!1)}}),define(ye[86],Se([1,0,14,135,23,13,2]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.MarkdownStringTextNewlineStyle=void 0,e.$Yk=c,e.$Zk=C,e.$1k=S,e.$2k=d,e.$3k=P,e.$4k=b,e.$5k=a,e.$6k=u;var T;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class p{constructor(g="",n=!1){if(this.value=g,typeof this.value!="string")throw(0,r.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(g,n=T.Paragraph){return this.value+=d(this.supportThemeIcons?(0,m.$Rk)(g):g).replace(/([ \t]+)/g,(s,i)=>"&nbsp;".repeat(i.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===T.Break?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,n){return this.value+=`
${P(n,g)}
`,this}appendLink(g,n,s){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(g),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(g,n){const s=new RegExp((0,R.$df)(n),"g");return g.replace(s,(i,t)=>g.charAt(t-1)!=="\\"?`\\${i}`:i)}}e.$Xk=p;function c(f){return C(f)?!f.value:Array.isArray(f)?f.every(c):!0}function C(f){return f instanceof p?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||typeof f.isTrusted=="object"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}function S(f,g){return f===g?!0:!f||!g?!1:f.value===g.value&&f.isTrusted===g.isTrusted&&f.supportThemeIcons===g.supportThemeIcons&&f.supportHtml===g.supportHtml&&(f.baseUri===g.baseUri||!!f.baseUri&&!!g.baseUri&&(0,A.$7g)(L.URI.from(f.baseUri),L.URI.from(g.baseUri)))}function d(f){return f.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P(f,g){const n=f.match(/^`+/gm)?.reduce((i,t)=>i.length>t.length?i:t).length??0,s=n>=3?n+1:3;return[`${"`".repeat(s)}${g}`,f,`${"`".repeat(s)}`].join(`
`)}function b(f){return f.replace(/"/g,"&quot;")}function a(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function u(f){const g=[],n=f.split("|").map(i=>i.trim());f=n[0];const s=n[1];if(s){const i=/height=(\d+)/.exec(s),t=/width=(\d+)/.exec(s),l=i?i[1]:"",h=t?t[1]:"",o=isFinite(parseInt(h)),$=isFinite(parseInt(l));o&&g.push(`width="${h}"`),$&&g.push(`height="${l}"`)}return{href:f,dimensions:g}}}),define(ye[109],Se([1,0,19,33,16,11,23,13]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=p,e.$Nw=C,e.$Ow=d,e.$Pw=P,e.$Qw=f,e.$Rw=n,e.$Sw=s,e.$Tw=i,e.$Uw=t,e.$Vw=l;function p(o,$){const{os:E,tildify:k,relative:D}=$;if(D){const w=c(o,D,E);if(typeof w=="string")return w}let v=o.fsPath;if(E===R.OperatingSystem.Windows&&!R.$i?v=v.replace(/\//g,"\\"):E!==R.OperatingSystem.Windows&&R.$i&&(v=v.replace(/\\/g,"/")),E!==R.OperatingSystem.Windows&&k?.userHome){const w=k.userHome.fsPath;let y;o.scheme!==k.userHome.scheme&&o.path[0]===A.$gc.sep&&o.path[1]!==A.$gc.sep?y=k.userHome.with({path:o.path}).fsPath:y=v,v=d(y,w,E)}return(E===R.OperatingSystem.Windows?A.$fc:A.$gc).normalize(C(v,E===R.OperatingSystem.Windows))}function c(o,$,E){const k=E===R.OperatingSystem.Windows?A.$fc:A.$gc,D=E===R.OperatingSystem.Linux?L.$4g:L.$6g,v=$.getWorkspace(),I=(0,r.$Ob)(v.folders);if(!I)return;o.scheme!==I.uri.scheme&&o.path[0]===A.$gc.sep&&o.path[1]!==A.$gc.sep&&(o=I.uri.with({path:o.path}));const w=$.getWorkspaceFolder(o);if(!w)return;let y;if(D.isEqual(w.uri,o)?y="":y=D.relativePath(w.uri,o)??"",y&&(y=k.normalize(y)),v.folders.length>1&&!$.noPrefix){const N=w.name?w.name:D.basenameOrAuthority(w.uri);y=y?`${N} \u2022 ${y}`:N}return y}function C(o,$=R.$i){return(0,m.$Eg)(o,$)?o.charAt(0).toUpperCase()+o.slice(1):o}let S=Object.create(null);function d(o,$,E=R.OS){if(E===R.OperatingSystem.Windows||!o||!$)return o;let k=S.original===$?S.normalized:void 0;k||(k=$,R.$i&&(k=(0,m.$tg)(k)),k=`${(0,T.$jf)(k,A.$gc.sep)}${A.$gc.sep}`,S={original:$,normalized:k});let D=o;return R.$i&&(D=(0,m.$tg)(D)),(E===R.OperatingSystem.Linux?D.startsWith(k):(0,T.$Cf)(D,k))?`~/${D.substr(k.length)}`:o}function P(o,$){return o.replace(/^~($|\/|\\)/,`${$}$1`)}const b="\u2026",a="\\\\",u="~";function f(o,$=A.sep){const E=new Array(o.length);let k=!1;for(let D=0;D<o.length;D++){const v=o[D];if(v===""){E[D]=`.${$}`;continue}if(!v){E[D]=v;continue}k=!0;let I="",w=v;w.indexOf(a)===0?(I=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length)):w.indexOf($)===0?(I=w.substr(0,w.indexOf($)+$.length),w=w.substr(w.indexOf($)+$.length)):w.indexOf(u)===0&&(I=w.substr(0,w.indexOf(u)+u.length),w=w.substr(w.indexOf(u)+u.length));const y=w.split($);for(let N=1;k&&N<=y.length;N++)for(let O=y.length-N;k&&O>=0;O--){k=!1;let U=y.slice(O,O+N).join($);for(let j=0;!k&&j<o.length;j++)if(j!==D&&o[j]&&o[j].indexOf(U)>-1){const z=O+N===y.length,M=O>0&&o[j].indexOf($)>-1?$+U:U,F=o[j].endsWith(M);k=!z||F}if(!k){let j="";(y[0].endsWith(":")||I!=="")&&(O===1&&(O=0,N++,U=y[0]+$+U),O>0&&(j=y[0]+$),j=I+j),O>0&&(j=j+b+$),j=j+U,O+N<y.length&&(j=j+$+b),E[D]=j}}k&&(E[D]=v)}return E}var g;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function n(o,$=Object.create(null)){const E=[];let k=!1,D="";for(const v of o)if(v==="$"||k&&v==="{")D&&E.push({value:D,type:g.TEXT}),D="",k=!0;else if(v==="}"&&k){const I=$[D];if(typeof I=="string")I.length&&E.push({value:I,type:g.VARIABLE});else if(I){const w=E[E.length-1];(!w||w.type!==g.SEPARATOR)&&E.push({value:I.label,type:g.SEPARATOR})}D="",k=!1}else D+=v;return D&&!k&&E.push({value:D,type:g.TEXT}),E.filter((v,I)=>{if(v.type===g.SEPARATOR){const w=E[I-1],y=E[I+1];return[w,y].every(N=>N&&(N.type===g.VARIABLE||N.type===g.TEXT)&&N.value.length>0)}return!0}).map(v=>v.value).join("")}function s(o,$){return R.$j||$?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):o.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function i(o,$){return R.$j||$?o.replace(/\(&&\w\)|&&/g,""):R.$i?o.replace(/&&|&/g,E=>E==="&"?"&&":"&"):o.replace(/&&/g,"_")}function t(o){return o.replace(/&/g,"&&")}function l(o){if(o.endsWith("]")){const $=o.lastIndexOf(" [",o.length-2);if($!==-1){const E=h(o.substring(0,$)),k=o.substring($);return{name:E.name+k,parentPath:E.parentPath}}}return h(o)}function h(o){const $=o.indexOf("/")!==-1?A.$gc:A.$fc,E=$.basename(o),k=$.dirname(o);return E.length?{name:E,parentPath:k}:{name:k,parentPath:""}}}),define(ye[141],Se([1,0,22,41,2]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=void 0,e.$Fn=p,e.$Gn=C,e.$Hn=S;function R(d){return d.toJSON()}class L{constructor(P){this.a=P}transformIncoming(P){const b=this.a.transformIncoming(P);return b===P?P:R(A.URI.from(b))}transformOutgoing(P){const b=this.a.transformOutgoing(P);return b===P?P:R(A.URI.from(b))}transformOutgoingURI(P){const b=this.a.transformOutgoing(P);return b===P?P:A.URI.from(b)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$Dn=L,e.$En=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function T(d,P,b){if(!d||b>200)return null;if(typeof d=="object"){if(d instanceof A.URI)return P.transformOutgoing(d);for(const a in d)if(Object.hasOwnProperty.call(d,a)){const u=T(d[a],P,b+1);u!==null&&(d[a]=u)}}return null}function p(d,P){const b=T(d,P,0);return b===null?d:b}function c(d,P,b,a){if(!d||a>200)return null;if(typeof d=="object"){if(d.$mid===m.MarshalledId.Uri)return b?A.URI.revive(P.transformIncoming(d)):P.transformIncoming(d);if(d instanceof r.$Je)return null;for(const u in d)if(Object.hasOwnProperty.call(d,u)){const f=c(d[u],P,b,a+1);f!==null&&(d[u]=f)}}return null}function C(d,P){const b=c(d,P,!1,0);return b===null?d:b}function S(d,P){const b=c(d,P,!0,0);return b===null?d:b}}),define(ye[34],Se([1,0,58,67,410,9,33,82,16,11,23,2]),function(de,e,r,m,A,R,L,T,p,c,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=u,e.readdirSync=n,e.whenDeleted=t,e.configureFlushOnWrite=E,e.writeFileSync=D;var d;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function P(M,F=d.UNLINK,J){if((0,L.$Dg)(M))throw new Error("rimraf - will refuse to recursively delete root");return F===d.UNLINK?a(M):b(M,J)}async function b(M,F=(0,L.$Ig)((0,m.tmpdir)())){try{try{await r.promises.rename(M,F)}catch(J){return J.code==="ENOENT"?void 0:a(M)}a(F).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function a(M){return(0,A.promisify)(r.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function u(M){if((0,L.$Dg)(M))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}async function f(M,F){return s(await(F?g(M):(0,A.promisify)(r.readdir)(M)))}async function g(M){try{return await(0,A.promisify)(r.readdir)(M,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const F=[],J=await f(M);for(const ee of J){let V=!1,H=!1,_=!1;try{const ne=await e.Promises.lstat((0,p.$jc)(M,ee));V=ne.isFile(),H=ne.isDirectory(),_=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}F.push({name:ee,isFile:()=>V,isDirectory:()=>H,isSymbolicLink:()=>_})}return F}function n(M){return s(r.readdirSync(M))}function s(M){return M.map(F=>typeof F=="string"?c.$j?(0,T.$gm)(F):F:(F.name=c.$j?(0,T.$gm)(F.name):F.name,F))}async function i(M){const F=await f(M),J=[];for(const ee of F)await l.existsDirectory((0,p.$jc)(M,ee))&&J.push(ee);return J}function t(M,F=1e3){return new Promise(J=>{let ee=!1;const V=setInterval(()=>{ee||(ee=!0,r.access(M,H=>{ee=!1,H&&(clearInterval(V),J(void 0))}))},F)})}var l;(function(M){async function F(V){let H;try{if(H=await e.Promises.lstat(V),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(c.$i&&_.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw ne}throw _}}M.stat=F;async function J(V){try{const{stat:H,symbolicLink:_}=await M.stat(V);return H.isFile()&&_?.dangling!==!0}catch{}return!1}M.existsFile=J;async function ee(V){try{const{stat:H,symbolicLink:_}=await M.stat(V);return H.isDirectory()&&_?.dangling!==!0}catch{}return!1}M.existsDirectory=ee})(l||(e.SymlinkSupport=l={}));const h=new R.$Jh;function o(M,F,J){return h.queueFor(S.URI.file(M),()=>{const ee=v(J);return new Promise((V,H)=>k(M,F,ee,_=>_?H(_):V()))},C.$5g)}let $=!0;function E(M){$=M}function k(M,F,J,ee){if(!$)return r.writeFile(M,F,{mode:J.mode,flag:J.flag},ee);r.open(M,J.flag,J.mode,(V,H)=>{if(V)return ee(V);r.writeFile(H,F,_=>{if(_)return r.close(H,()=>ee(_));r.fdatasync(H,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),E(!1)),r.close(H,he=>ee(he))))})})}function D(M,F,J){const ee=v(J);if(!$)return r.writeFileSync(M,F,{mode:ee.mode,flag:ee.flag});const V=r.openSync(M,ee.flag,ee.mode);try{r.writeFileSync(V,F);try{r.fdatasyncSync(V)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),E(!1)}}finally{r.closeSync(V)}}function v(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function I(M,F,J=6e4){if(M!==F)try{c.$i&&typeof J=="number"?await w(M,F,Date.now(),J):await(0,A.promisify)(r.rename)(M,F)}catch(ee){if(M.toLowerCase()!==F.toLowerCase()&&ee.code==="EXDEV"||M.endsWith("."))await y(M,F,{preserveSymlinks:!1}),await P(M,d.MOVE);else throw ee}}async function w(M,F,J,ee,V=0){try{return await(0,A.promisify)(r.rename)(M,F)}catch(H){if(H.code!=="EACCES"&&H.code!=="EPERM"&&H.code!=="EBUSY")throw H;if(Date.now()-J>=ee)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${H}`),H;if(V===0){let _=!1;try{const{stat:ne}=await l.stat(F);ne.isFile()||(_=!0)}catch{}if(_)throw H}return await(0,R.$Bh)(Math.min(100,V*10)),w(M,F,J,ee,V+1)}}async function y(M,F,J){return O(M,F,{root:{source:M,target:F},options:J,handledSourcePaths:new Set})}const N=511;async function O(M,F,J){if(J.handledSourcePaths.has(M))return;J.handledSourcePaths.add(M);const{stat:ee,symbolicLink:V}=await l.stat(M);if(V){if(J.options.preserveSymlinks)try{return await z(M,F,J)}catch{}if(V.dangling)return}return ee.isDirectory()?U(M,F,ee.mode&N,J):j(M,F,ee.mode&N)}async function U(M,F,J,ee){await e.Promises.mkdir(F,{recursive:!0,mode:J});const V=await f(M);for(const H of V)await O((0,p.$jc)(M,H),(0,p.$jc)(F,H),ee)}async function j(M,F,J){await e.Promises.copyFile(M,F),await e.Promises.chmod(F,J)}async function z(M,F,J){let ee=await e.Promises.readlink(M);(0,L.$zg)(ee,J.root.source,!c.$k)&&(ee=(0,p.$jc)(J.root.target,ee.substr(J.root.source.length+1))),await e.Promises.symlink(ee,F)}e.Promises=new class{get access(){return(0,A.promisify)(r.access)}get stat(){return(0,A.promisify)(r.stat)}get lstat(){return(0,A.promisify)(r.lstat)}get utimes(){return(0,A.promisify)(r.utimes)}get read(){return(M,F,J,ee,V)=>new Promise((H,_)=>{r.read(M,F,J,ee,V,(ne,he,re)=>ne?_(ne):H({bytesRead:he,buffer:re}))})}get readFile(){return(0,A.promisify)(r.readFile)}get write(){return(M,F,J,ee,V)=>new Promise((H,_)=>{r.write(M,F,J,ee,V,(ne,he,re)=>ne?_(ne):H({bytesWritten:he,buffer:re}))})}get appendFile(){return(0,A.promisify)(r.appendFile)}get fdatasync(){return(0,A.promisify)(r.fdatasync)}get truncate(){return(0,A.promisify)(r.truncate)}get copyFile(){return(0,A.promisify)(r.copyFile)}get open(){return(0,A.promisify)(r.open)}get close(){return(0,A.promisify)(r.close)}get symlink(){return(0,A.promisify)(r.symlink)}get readlink(){return(0,A.promisify)(r.readlink)}get chmod(){return(0,A.promisify)(r.chmod)}get mkdir(){return(0,A.promisify)(r.mkdir)}get unlink(){return(0,A.promisify)(r.unlink)}get rmdir(){return(0,A.promisify)(r.rmdir)}get realpath(){return(0,A.promisify)(r.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return i}get writeFile(){return o}get rm(){return P}get rename(){return I}get copy(){return y}}}),define(ye[110],Se([1,0,58,16,11,13,34]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=T,e.$ar=p,e.$br=c,e.$cr=C;function T(d){if(A.$k)return d;const P=(0,m.$mc)(d);if(d===P)return d;const b=((0,m.$nc)(d)||d).toLowerCase();try{const u=(0,L.readdirSync)(P).filter(f=>f.toLowerCase()===b);if(u.length===1){const f=T(P);if(f)return(0,m.$jc)(f,u[0])}else if(u.length>1){const f=u.indexOf(b);if(f>=0){const g=T(P);if(g)return(0,m.$jc)(g,u[f])}}}catch{}return null}async function p(d,P){if(A.$k)return d;const b=(0,m.$mc)(d);if(d===b)return d;const a=((0,m.$nc)(d)||d).toLowerCase();try{if(P?.isCancellationRequested)return null;const f=(await L.Promises.readdir(b)).filter(g=>g.toLowerCase()===a);if(f.length===1){const g=await p(b,P);if(g)return(0,m.$jc)(g,f[0])}else if(f.length>1){const g=f.indexOf(a);if(g>=0){const n=await p(b,P);if(n)return(0,m.$jc)(n,f[g])}}}catch{}return null}async function c(d){try{return await L.Promises.realpath(d)}catch{const b=S(d);return await L.Promises.access(b,r.constants.R_OK),b}}function C(d){try{return r.realpathSync(d)}catch{const b=S(d);return r.accessSync(b,r.constants.R_OK),b}}function S(d){return(0,R.$jf)((0,m.$hc)(d),m.sep)}}),define(ye[111],Se([1,0,16,11,56,108,18,34]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$tm=p,e.$um=c,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function p(S=A.env){return S.comspec||"cmd.exe"}function c(S){let d=[],P=!1;const b=function(a){if(P){d.push(a);return}(!S.send(a,f=>{if(f&&console.error(f),P=!1,d.length>0){const g=d.slice(0);d=[],g.forEach(n=>b(n))}})||m.$i)&&(P=!0)};return{send:b}}var C;(function(S){async function d(P,b,a){if(r.$ic(P))return P;if(b===void 0&&(b=A.cwd()),r.$mc(P)!=="."||(a===void 0&&L.$ag(A.env.PATH)&&(a=A.env.PATH.split(r.$tc)),a===void 0||a.length===0))return r.$jc(b,P);async function f(g){if(await T.Promises.exists(g)){let n;try{n=await T.Promises.stat(g)}catch(s){s.message.startsWith("EACCES")&&(n=await T.Promises.lstat(g))}return n?!n.isDirectory():!1}return!1}for(const g of a){let n;if(r.$ic(g)?n=r.$jc(g,P):n=r.$jc(b,g,P),await f(n))return n;let s=n+".com";if(await f(s)||(s=n+".exe",await f(s)))return s}return r.$jc(b,P)}S.findExecutable=d})(C||(e.win32=C={}))});var Je=this&&this.__decorate||function(de,e,r,m){var A=arguments.length,R=A<3?e:m===null?m=Object.getOwnPropertyDescriptor(e,r):m,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(de,e,r,m);else for(var T=de.length-1;T>=0;T--)(L=de[T])&&(R=(A<3?L(R):A>3?L(e,r,R):L(e,r))||R);return A>3&&R&&Object.defineProperty(e,r,R),R};define(ye[87],Se([1,0,19,9,22,21,60,14,4,3,57,13,18]),function(de,e,r,m,A,R,L,T,p,c,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=E,e.$bi=k,e.$gi=N,e.$hi=O;var P;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(P||(P={}));function b(V){switch(V){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var a;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(a||(a={}));function u(V){switch(V){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function g(V){let H=0;for(let _=0;;_+=7){const ne=V.read(1);if(H|=(ne.buffer[0]&127)<<_,!(ne.buffer[0]&128))return H}}const n=h(0);function s(V,H){if(H===0){V.write(n);return}let _=0;for(let he=H;he!==0;he=he>>>7)_++;const ne=A.$Je.alloc(_);for(let he=0;H!==0;he++)ne.buffer[he]=H&127,H=H>>>7,H>0&&(ne.buffer[he]|=128);V.write(ne)}class i{constructor(H){this.b=H,this.a=0}read(H){const _=this.b.slice(this.a,this.a+H);return this.a+=_.byteLength,_}}e.$$h=i;class t{constructor(){this.a=[]}get buffer(){return A.$Je.concat(this.a)}write(H){this.a.push(H)}}e.$_h=t;var l;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(l||(l={}));function h(V){const H=A.$Je.alloc(1);return H.writeUInt8(V,0),H}const o={Undefined:h(l.Undefined),String:h(l.String),Buffer:h(l.Buffer),VSBuffer:h(l.VSBuffer),Array:h(l.Array),Object:h(l.Object),Uint:h(l.Int)},$=typeof Buffer<"u";function E(V,H){if(typeof H>"u")V.write(o.Undefined);else if(typeof H=="string"){const _=A.$Je.fromString(H);V.write(o.String),s(V,_.byteLength),V.write(_)}else if($&&Buffer.isBuffer(H)){const _=A.$Je.wrap(H);V.write(o.Buffer),s(V,_.byteLength),V.write(_)}else if(H instanceof A.$Je)V.write(o.VSBuffer),s(V,H.byteLength),V.write(H);else if(Array.isArray(H)){V.write(o.Array),s(V,H.length);for(const _ of H)E(V,_)}else if(typeof H=="number"&&(H|0)===H)V.write(o.Uint),s(V,H);else{const _=A.$Je.fromString(JSON.stringify(H));V.write(o.Object),s(V,_.byteLength),V.write(_)}}function k(V){switch(V.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return V.read(g(V)).toString();case l.Buffer:return V.read(g(V)).buffer;case l.VSBuffer:return V.read(g(V));case l.Array:{const _=g(V),ne=[];for(let he=0;he<_;he++)ne.push(k(V));return ne}case l.Object:return JSON.parse(V.read(g(V)).toString());case l.Int:return g(V)}}class D{constructor(H,_,ne=null,he=1e3){this.h=H,this.j=_,this.k=ne,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:a.Initialize})}registerChannel(H,_){this.b.set(H,_),setTimeout(()=>this.w(H),0)}m(H){switch(H.type){case a.Initialize:{const _=this.o([H.type]);this.k?.logOutgoing(_,0,v.OtherSide,u(H.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const _=this.o([H.type,H.id],H.data);this.k?.logOutgoing(_,H.id,v.OtherSide,u(H.type),H.data);return}}}o(H,_=void 0){const ne=new t;return E(ne,H),E(ne,_),this.p(ne.buffer)}p(H){try{return this.h.send(H),H.byteLength}catch{return 0}}q(H){const _=new i(H),ne=k(_),he=k(_),re=ne[0];switch(re){case P.Promise:return this.k?.logIncoming(H.byteLength,ne[1],v.OtherSide,`${b(re)}: ${ne[2]}.${ne[3]}`,he),this.s({type:re,id:ne[1],channelName:ne[2],name:ne[3],arg:he});case P.EventListen:return this.k?.logIncoming(H.byteLength,ne[1],v.OtherSide,`${b(re)}: ${ne[2]}.${ne[3]}`,he),this.t({type:re,id:ne[1],channelName:ne[2],name:ne[3],arg:he});case P.PromiseCancel:return this.k?.logIncoming(H.byteLength,ne[1],v.OtherSide,`${b(re)}`),this.u({type:re,id:ne[1]});case P.EventDispose:return this.k?.logIncoming(H.byteLength,ne[1],v.OtherSide,`${b(re)}`),this.u({type:re,id:ne[1]})}}s(H){const _=this.b.get(H.channelName);if(!_){this.v(H);return}const ne=new R.$se;let he;try{he=_.call(this.j,H.name,H.arg,ne.token)}catch(pe){he=Promise.reject(pe)}const re=H.id;he.then(pe=>{this.m({id:re,data:pe,type:a.PromiseSuccess})},pe=>{pe instanceof Error?this.m({id:re,data:{message:pe.message,name:pe.name,stack:pe.stack?pe.stack.split?pe.stack.split(`
`):pe.stack:void 0},type:a.PromiseError}):this.m({id:re,data:pe,type:a.PromiseErrorObj})}).finally(()=>{ve.dispose(),this.d.delete(H.id)});const ve=(0,c.$Sc)(()=>ne.cancel());this.d.set(H.id,ve)}t(H){const _=this.b.get(H.channelName);if(!_){this.v(H);return}const ne=H.id,re=_.listen(this.j,H.name,H.arg)(ve=>this.m({id:ne,data:ve,type:a.EventFire}));this.d.set(H.id,re)}u(H){const _=this.d.get(H.id);_&&(_.dispose(),this.d.delete(H.id))}v(H){let _=this.g.get(H.channelName);_||(_=[],this.g.set(H.channelName,_));const ne=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===P.Promise&&this.m({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.l}ms`,stack:void 0},type:a.PromiseError})},this.l);_.push({request:H,timeoutTimer:ne})}w(H){const _=this.g.get(H);if(_){for(const ne of _)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case P.Promise:this.s(ne.request);break;case P.EventListen:this.t(ne.request);break}this.g.delete(H)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$ci=D;var v;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class I{constructor(H,_=null){this.l=H,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=_}getChannel(H){const _=this;return{call(ne,he,re){return _.a?Promise.reject(new T.$5):_.m(H,ne,he,re)},listen(ne,he){return _.a?p.Event.None:_.o(H,ne,he)}}}m(H,_,ne,he=R.CancellationToken.None){const re=this.g++,ve=P.Promise,pe={id:re,type:ve,channelName:H,name:_,arg:ne};if(he.isCancellationRequested)return Promise.reject(new T.$5);let Q;return new Promise((se,ae)=>{if(he.isCancellationRequested)return ae(new T.$5);const ie=()=>{const oe=$e=>{switch($e.type){case a.PromiseSuccess:this.f.delete(re),se($e.data);break;case a.PromiseError:{this.f.delete(re);const be=new Error($e.data.message);be.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,be.name=$e.data.name,ae(be);break}case a.PromiseErrorObj:this.f.delete(re),ae($e.data);break}};this.f.set(re,oe),this.p(pe)};let ce=null;this.b===f.Idle?ie():(ce=(0,m.$nh)(oe=>this.u()),ce.then(()=>{ce=null,ie()}));const ue=()=>{ce?(ce.cancel(),ce=null):this.p({id:re,type:P.PromiseCancel}),ae(new T.$5)},Z=he.onCancellationRequested(ue);Q=(0,c.$Rc)((0,c.$Sc)(ue),Z),this.d.add(Q)}).finally(()=>{Q.dispose(),this.d.delete(Q)})}o(H,_,ne){const he=this.g++,re=P.EventListen,ve={id:he,type:re,channelName:H,name:_,arg:ne};let pe=null;const Q=new p.$he({onWillAddFirstListener:()=>{pe=(0,m.$nh)(se=>this.u()),pe.then(()=>{pe=null,this.d.add(Q),this.p(ve)})},onDidRemoveLastListener:()=>{pe?(pe.cancel(),pe=null):(this.d.delete(Q),this.p({id:he,type:P.EventDispose}))}}),B=se=>Q.fire(se.data);return this.f.set(he,B),Q.event}p(H){switch(H.type){case P.Promise:case P.EventListen:{const _=this.q([H.type,H.id,H.channelName,H.name],H.arg);this.j?.logOutgoing(_,H.id,v.LocalSide,`${b(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case P.PromiseCancel:case P.EventDispose:{const _=this.q([H.type,H.id]);this.j?.logOutgoing(_,H.id,v.LocalSide,b(H.type));return}}}q(H,_=void 0){const ne=new t;return E(ne,H),E(ne,_),this.r(ne.buffer)}r(H){try{return this.l.send(H),H.byteLength}catch{return 0}}s(H){const _=new i(H),ne=k(_),he=k(_),re=ne[0];switch(re){case a.Initialize:return this.j?.logIncoming(H.byteLength,0,v.LocalSide,u(re)),this.t({type:ne[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.j?.logIncoming(H.byteLength,ne[1],v.LocalSide,u(re),he),this.t({type:ne[0],id:ne[1],data:he})}}t(H){if(H.type===a.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(H.id)?.(H)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$di=I,Je([L.$5h],I.prototype,"onDidInitializePromise",null);class w{get connections(){const H=[];return this.f.forEach(_=>H.push(_)),H}constructor(H,_,ne){this.a=new Map,this.f=new Set,this.g=new p.$he,this.onDidAddConnection=this.g.event,this.h=new p.$he,this.onDidRemoveConnection=this.h.event,this.j=new c.$Tc,this.j.add(H(({protocol:he,onDidClientDisconnect:re})=>{const ve=p.Event.once(he.onMessage);this.j.add(ve(pe=>{const Q=new i(pe),B=k(Q),se=new D(he,B,_,ne),ae=new I(he,_);this.a.forEach((ce,ue)=>se.registerChannel(ue,ce));const ie={channelServer:se,channelClient:ae,ctx:B};this.f.add(ie),this.g.fire(ie),this.j.add(re(()=>{se.dispose(),ae.dispose(),this.f.delete(ie),this.h.fire(ie)}))}))}))}getChannel(H,_){const ne=this;return{call(he,re,ve){let pe;if((0,d.$og)(_)){const B=(0,r.$3b)(ne.connections.filter(_));pe=B?Promise.resolve(B):p.Event.toPromise(p.Event.filter(ne.onDidAddConnection,_))}else pe=_.routeCall(ne,he,re);const Q=pe.then(B=>B.channelClient.getChannel(H));return N(Q).call(he,re,ve)},listen(he,re){if((0,d.$og)(_))return ne.k(H,_,he,re);const ve=_.routeEvent(ne,he,re).then(pe=>pe.channelClient.getChannel(H));return N(ve).listen(he,re)}}}k(H,_,ne,he){const re=this;let ve;const pe=new p.$he({onWillAddFirstListener:()=>{ve=new c.$Tc;const Q=new p.$ne,B=new Map,se=ie=>{const ue=ie.channelClient.getChannel(H).listen(ne,he),Z=Q.add(ue);B.set(ie,Z)},ae=ie=>{const ce=B.get(ie);ce&&(ce.dispose(),B.delete(ie))};re.connections.filter(_).forEach(se),p.Event.filter(re.onDidAddConnection,_)(se,void 0,ve),re.onDidRemoveConnection(ae,void 0,ve),Q.event(pe.fire,pe,ve),ve.add(Q)},onDidRemoveLastListener:()=>{ve?.dispose(),ve=void 0}});return pe.event}registerChannel(H,_){this.a.set(H,_);for(const ne of this.f)ne.channelServer.registerChannel(H,_)}dispose(){this.j.dispose();for(const H of this.f)H.channelClient.dispose(),H.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=w;class y{constructor(H,_,ne=null){const he=new t;E(he,_),H.send(he.buffer),this.a=new I(H,ne),this.d=new D(H,_,ne)}getChannel(H){return this.a.getChannel(H)}registerChannel(H,_){this.d.registerChannel(H,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=y;function N(V){return{call(H,_,ne){return V.then(he=>he.call(H,_,ne))},listen(H,_){const ne=new p.$qe;return V.then(he=>ne.input=he.listen(H,_)),ne.event}}}function O(V){let H=!1;return{call(_,ne,he){return H?V.call(_,ne,he):(0,m.$Bh)(0).then(()=>H=!0).then(()=>V.call(_,ne,he))},listen(_,ne){if(H)return V.listen(_,ne);const he=new p.$qe;return(0,m.$Bh)(0).then(()=>H=!0).then(()=>he.input=V.listen(_,ne)),he.event}}}class U{constructor(H){this.a=H}routeCall(H){return this.b(H)}routeEvent(H){return this.b(H)}async b(H){for(const _ of H.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await p.Event.toPromise(H.onDidAddConnection),await this.b(H)}}e.$ii=U;var j;(function(V){function H(re,ve,pe){const Q=re,B=pe&&pe.disableMarshalling,se=new Map;for(const ae in Q)ne(ae)&&se.set(ae,p.Event.buffer(Q[ae],!0,void 0,ve));return new class{listen(ae,ie,ce){const ue=se.get(ie);if(ue)return ue;const Z=Q[ie];if(typeof Z=="function"){if(he(ie))return Z.call(Q,ce);if(ne(ie))return se.set(ie,p.Event.buffer(Q[ie],!0,void 0,ve)),se.get(ie)}throw new T.$bb(`Event not found: ${ie}`)}call(ae,ie,ce){const ue=Q[ie];if(typeof ue=="function"){if(!B&&Array.isArray(ce))for(let oe=0;oe<ce.length;oe++)ce[oe]=(0,C.$0h)(ce[oe]);let Z=ue.apply(Q,ce);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new T.$bb(`Method not found: ${ie}`)}}}V.fromService=H;function _(re,ve){const pe=ve&&ve.disableMarshalling;return new Proxy({},{get(Q,B){if(typeof B=="string")return ve?.properties?.has(B)?ve.properties.get(B):he(B)?function(se){return re.listen(B,se)}:ne(B)?re.listen(B):async function(...se){let ae;ve&&!(0,d.$jg)(ve.context)?ae=[ve.context,...se]:ae=se;const ie=await re.call(B,ae);return pe?ie:(0,C.$0h)(ie)};throw new T.$bb(`Property not found: ${String(B)}`)}})}V.toService=_;function ne(re){return re[0]==="o"&&re[1]==="n"&&S.$Af(re.charCodeAt(2))}function he(re){return/^onDynamic/.test(re)&&S.$Af(re.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const H=V.toString();if(H!=="[object Object]")return H}return V}function F(V){return Array.isArray(V)?V.map(M):M(V)}function J(V,H,_,ne,he,re,ve){ve=F(ve);const pe=z[he],Q=pe[ne%pe.length];let B=[`%c[${V}]%c[${String(H).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${Q}`];/\($/.test(re)?(B=B.concat(ve),B.push(")")):B.push(ve),console.log.apply(console,B)}class ee{constructor(H,_){this.d=H,this.f=_,this.a=0,this.b=0}logOutgoing(H,_,ne,he,re){this.b+=H,J(this.d,this.b,H,_,ne,he,re)}logIncoming(H,_,ne,he,re){this.a+=H,J(this.f,this.a,H,_,ne,he,re)}}e.$ji=ee}),define(ye[68],Se([1,0,22,4,3,87]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.ProtocolConstants=e.$ki=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var T;(function(o){o.enableDiagnostics=!1,o.records=[];const $=new WeakMap;let E=0;function k(v,I){if(!$.has(v)){const w=String(++E);$.set(v,w)}return $.get(v)}function D(v,I,w,y){if(!o.enableDiagnostics)return;const N=k(v,I);if(y instanceof r.$Je||y instanceof Uint8Array||y instanceof ArrayBuffer||ArrayBuffer.isView(y)){const O=r.$Je.alloc(y.byteLength);O.set(y),o.records.push({timestamp:Date.now(),id:N,label:I,type:w,buff:O})}else o.records.push({timestamp:Date.now(),id:N,label:I,type:w,data:y})}o.traceSocketEvent=D})(T||(e.SocketDiagnostics=T={}));var p;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let c=null;function C(){return c||(c=r.$Je.alloc(0)),c}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk($){this.a.push($),this.b+=$.byteLength}read($){return this.c($,!0)}peek($){return this.c($,!1)}c($,E){if($===0)return C();if($>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===$){const I=this.a[0];return E&&(this.a.shift(),this.b-=$),I}if(this.a[0].byteLength>$){const I=this.a[0].slice(0,$);return E&&(this.a[0]=this.a[0].slice($),this.b-=$),I}const k=r.$Je.alloc($);let D=0,v=0;for(;$>0;){const I=this.a[v];if(I.byteLength>$){const w=I.slice(0,$);k.set(w,D),D+=$,E&&(this.a[v]=I.slice($),this.b-=$),$-=$}else k.set(I,D),D+=I.byteLength,E?(this.a.shift(),this.b-=I.byteLength):v++,$-=I.byteLength}return k}}e.$ki=S;var d;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(d||(d={}));function P(o){switch(o){case d.None:return"None";case d.Regular:return"Regular";case d.Control:return"Control";case d.Ack:return"Ack";case d.Disconnect:return"Disconnect";case d.ReplayRequest:return"ReplayRequest";case d.Pause:return"PauseWriting";case d.Resume:return"ResumeWriting";case d.KeepAlive:return"KeepAlive"}}var b;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",o[o.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(b||(e.ProtocolConstants=b={}));class a{constructor($,E,k,D){this.type=$,this.id=E,this.ack=k,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends A.$Uc{constructor($){super(),this.f=this.B(new m.$he),this.onMessage=this.f.event,this.g={readHead:!0,readLen:b.HeaderLength,messageType:d.None,id:0,ack:0},this.a=$,this.b=!1,this.c=new S,this.B(this.a.onData(E=>this.acceptChunk(E))),this.lastReadTime=Date.now()}acceptChunk($){if(!(!$||$.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk($);this.c.byteLength>=this.g.readLen;){const E=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=E.readUInt32BE(9),this.g.messageType=E.readUInt8(0),this.g.id=E.readUInt32BE(1),this.g.ack=E.readUInt32BE(5),this.a.traceSocketEvent(L.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,D=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=b.HeaderLength,this.g.messageType=d.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(L.ProtocolMessageRead,E),this.f.fire(new a(k,D,v,E)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor($){this.k=null,this.a=!1,this.b=!1,this.c=$,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write($){if(this.a)return;$.writtenTime=Date.now(),this.lastWriteTime=Date.now();const E=r.$Je.alloc(b.HeaderLength);E.writeUInt8($.type,0),E.writeUInt32BE($.id,1),E.writeUInt32BE($.ack,5),E.writeUInt32BE($.data.byteLength,9),this.c.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:P($.type),id:$.id,ack:$.ack,messageSize:$.data.byteLength}),this.c.traceSocketEvent(L.ProtocolMessageWrite,$.data),this.j(E,$.data)}g($,E){const k=this.f===0;return this.d.push($,E),this.f+=$.byteLength+E.byteLength,k}h(){const $=r.$Je.concat(this.d,this.f);return this.d.length=0,this.f=0,$}j($,E){this.g($,E)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const $=this.h();this.c.traceSocketEvent(L.ProtocolWrite,{byteLength:$.byteLength}),this.c.write($)}}class g extends A.$Uc{constructor($){super(),this.f=new m.$he,this.onMessage=this.f.event,this.g=new m.$he,this.onDidDispose=this.g.event,this.a=$,this.b=this.B(new f(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(E=>{E.type===d.Regular&&this.f.fire(E.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send($){this.b.write(new a(d.Regular,0,0,$))}}e.$li=g;class n extends R.$fi{static fromSocket($,E){return new n(new g($),E)}get onDidDispose(){return this.b.onDidDispose}constructor($,E,k=null){super($,E,k),this.b=$}dispose(){super.dispose();const $=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),$.end()}}e.$mi=n;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new m.$he({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire($){this.b?this.d.length>0?this.d.push($):this.a.fire($):this.d.push($)}flushBuffer(){this.d=[]}}e.$ni=s;class i{constructor($){this.data=$,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let $=0,E=this.a;for(;E;)E=E.next,$++;return $}peek(){return this.a?this.a.data:null}toArray(){const $=[];let E=0,k=this.a;for(;k;)$[E++]=k.data,k=k.next;return $}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push($){const E=new i($);if(!this.a){this.a=E,this.b=E;return}this.b.next=E,this.b=E}}class l{static{this.a=10}static{this.b=null}static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const $=Date.now();for(let E=0;E<l.a;E++)this.c[E]=$-1e3*E;setInterval(()=>{for(let E=l.a;E>=1;E--)this.c[E]=this.c[E-1];this.c[0]=Date.now()},1e3)}d(){const $=Date.now(),E=(1+l.a)*1e3;let k=0;for(let D=0;D<l.a;D++)$-this.c[D]<=E&&k++;return 1-k/l.a}hasHighLoad(){return this.d()>=.5}}class h{get unacknowledgedCount(){return this.c-this.d}constructor($){this.u=new s,this.onControlMessage=this.u.event,this.v=new s,this.onMessage=this.v.event,this.w=new s,this.onDidDispose=this.w.event,this.x=new s,this.onSocketClose=this.x.event,this.y=new s,this.onSocketTimeout=this.y.event,this.s=$.loadEstimator??l.getInstance(),this.t=$.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Tc,this.o=$.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(E=>this.z(E))),this.r.add(this.o.onClose(E=>this.x.fire(E))),$.initialChunk&&this.q.acceptChunk($.initialChunk),this.t?this.l=setInterval(()=>{this.D()},b.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const $=new a(d.Disconnect,0,0,C());this.p.write($),this.p.flush()}sendPause(){const $=new a(d.Pause,0,0,C());this.p.write($)}sendResume(){const $=new a(d.Resume,0,0,C());this.p.write($)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection($,E){this.a=!0,this.r.dispose(),this.r=new A.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=$,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(E)}endAcceptReconnection(){this.a=!1,this.h=this.g;const $=new a(d.Ack,0,this.h,C());this.p.write($);const E=this.b.toArray();for(let k=0,D=E.length;k<D;k++)this.p.write(E[k]);this.B()}acceptDisconnect(){this.w.fire()}z($){if($.ack>this.d){this.d=$.ack;do{const E=this.b.peek();if(E&&E.id<=$.ack)this.b.pop();else break}while(!0)}switch($.type){case d.None:break;case d.Regular:{if($.id>this.g)if($.id!==this.g+1){const E=Date.now();E-this.m>1e4&&(this.m=E,this.p.write(new a(d.ReplayRequest,0,0,C())))}else this.g=$.id,this.j=Date.now(),this.A(),this.v.fire($.data);break}case d.Control:{this.u.fire($.data);break}case d.Ack:break;case d.Disconnect:{this.w.fire();break}case d.ReplayRequest:{const E=this.b.toArray();for(let k=0,D=E.length;k<D;k++)this.p.write(E[k]);this.B();break}case d.Pause:{this.p.pause();break}case d.Resume:{this.p.resume();break}case d.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send($){const E=++this.c;this.h=this.g;const k=new a(d.Regular,E,this.h,$);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl($){const E=new a(d.Control,0,0,$);this.p.write(E)}A(){if(this.g<=this.h||this.k)return;const $=Date.now()-this.j;if($>=b.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},b.AcknowledgeTime-$+5)}B(){if(this.c<=this.d||this.f||this.a)return;const $=this.b.peek(),E=Date.now()-$.writtenTime,k=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(E>=b.TimeoutTime&&k>=b.TimeoutTime&&D>=b.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:E,timeSinceLastReceivedSomeData:k});return}const v=Math.max(b.TimeoutTime-E,b.TimeoutTime-k,b.TimeoutTime-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const $=new a(d.Ack,0,this.h,C());this.p.write($)}D(){this.h=this.g;const $=new a(d.KeepAlive,0,this.h,C());this.p.write($)}}e.$oi=h}),define(ye[207],Se([1,0,59,9,22,21,205,14,4,3,25,111,108,87]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=void 0;class b extends P.$ci{constructor(f){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",g=>A.$Je.wrap(Buffer.from(g,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$8q=b;class a{constructor(f,g){this.i=f,this.j=g,this.c=new Set,this.g=new Map,this.h=new p.$he,this.onDidProcessExit=this.h.event;const n=g&&g.timeout?g.timeout:6e4;this.b=new m.$xh(n),this.d=null,this.f=null}getChannel(f){const g=this;return{call(n,s,i){return g.k(f,n,s,i)},listen(n,s){return g.l(f,n,s)}}}k(f,g,n,s=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(T.$6());this.b.cancel();const i=this.n(f),t=(0,m.$nh)(o=>i.call(g,n,o)),l=s.onCancellationRequested(()=>t.cancel()),h=(0,c.$Sc)(()=>t.cancel());return this.c.add(h),t.finally(()=>{l.dispose(),this.c.delete(h),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,g,n){if(!this.b)return p.Event.None;this.b.cancel();let s;const i=new p.$he({onWillAddFirstListener:()=>{s=this.n(f).listen(g,n)(i.fire,i),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,C.$9n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(E=>!/^--inspect(-brk)?=/.test(E)).filter(E=>!E.startsWith("--vscode-"))),(0,d.$sm)(g.env),this.d=(0,r.fork)(this.i,f,g);const n=new p.$he,i=p.Event.fromNodeEventEmitter(this.d,"message",E=>E)(E=>{if((0,L.$4q)(E)){(0,L.log)(E,`IPC Library: ${this.j.serverName}`);return}n.fire(A.$Je.wrap(Buffer.from(E,"base64")))}),t=this.j.useQueue?(0,S.$um)(this.d):this.d,l=E=>this.d&&this.d.connected&&t.send(E.buffer.toString("base64")),h=n.event,o={send:l,onMessage:h};this.f=new P.$di(o);const $=()=>this.o();process.once("exit",$),this.d.on("error",E=>console.warn('IPC "'+this.j.serverName+'" errored with '+E)),this.d.on("exit",(E,k)=>{process.removeListener("exit",$),i.dispose(),this.c.forEach(D=>(0,c.$Pc)(D)),this.c.clear(),E!==0&&k!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+E+" and signal "+k),this.b?.cancel(),this.o(),this.h.fire({code:E,signal:k})})}return this.f}n(f){let g=this.g.get(f);return g||(g=this.m.getChannel(f),this.g.set(f,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9q=a}),define(ye[208],Se([1,0,9,4,3,57,18]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.StorageState=e.StorageHint=void 0,e.$4p=p;var T;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function p(d){const P=d;return P?.changed instanceof Map||P?.deleted instanceof Set}var c;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(c||(e.StorageState=c={}));class C extends A.$Uc{static{this.a=100}constructor(P,b=Object.create(null)){super(),this.r=P,this.s=b,this.b=this.B(new m.$ke),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new r.$yh(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((b,a)=>this.w(a,b)),P.deleted?.forEach(b=>this.w(b,void 0))}finally{this.b.resume()}}w(P,b){if(this.c===c.Closed)return;let a=!1;(0,L.$jg)(b)?a=this.f.delete(P):this.f.get(P)!==b&&(this.f.set(P,b),a=!0),a&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,b){const a=this.f.get(P);return(0,L.$jg)(a)?b:a}getBoolean(P,b){const a=this.get(P);return(0,L.$jg)(a)?b:a==="true"}getNumber(P,b){const a=this.get(P);return(0,L.$jg)(a)?b:parseInt(a,10)}getObject(P,b){const a=this.get(P);return(0,L.$jg)(a)?b:(0,R.$9h)(a)}async set(P,b,a=!1){if(this.c===c.Closed)return;if((0,L.$jg)(b))return this.delete(P,a);const u=(0,L.$cg)(b)||Array.isArray(b)?(0,R.$8h)(b):String(b);if(this.f.get(P)!==u)return this.f.set(P,u),this.j.set(P,u),this.h.delete(P),this.b.fire({key:P,external:a}),this.D()}async delete(P,b=!1){if(!(this.c===c.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:b}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===c.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$5p=C;class S{constructor(){this.onDidChangeItemsExternal=m.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((b,a)=>this.a.set(a,b)),P.delete?.forEach(b=>this.a.delete(b))}async optimize(){}async close(){}}e.$6p=S}),define(ye[209],Se([1,0,13,11,22]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0,e.$it=C,e.$jt=S;let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let T;function p(){return T||(T=new TextDecoder("UTF-16BE")),T}let c;function C(){return c||(c=m.$D()?L():p()),c}function S(b,a,u){const f=new Uint16Array(b.buffer,a,u);return u>0&&(f[0]===65279||f[0]===65534)?d(b,a,u):L().decode(f)}function d(b,a,u){const f=[];let g=0;for(let n=0;n<u;n++){const s=A.$Le(b,a);a+=2,f[g++]=String.fromCharCode(s)}return f.join("")}class P{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return C().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const u=this.a-this.d;u<=1&&(u===0||r.$Ff(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const u=a.length;if(this.d+u>=this.a){this.f(),this.c[this.c.length]=a;return}for(let f=0;f<u;f++)this.b[this.d++]=a.charCodeAt(f)}}e.$kt=P}),define(ye[210],Se([1,0,22,209]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0,e.$mt=L;function A(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,C,S,d){this.oldPosition=c,this.oldText=C,this.newPosition=S,this.newText=d}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,C,S){const d=C.length;r.$Oe(c,d,S),S+=4;for(let P=0;P<d;P++)r.$Me(c,C.charCodeAt(P),S),S+=2;return S}static d(c,C){const S=r.$Ne(c,C);return C+=4,(0,m.$jt)(c,C,S)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(c,C){return r.$Oe(c,this.oldPosition,C),C+=4,r.$Oe(c,this.newPosition,C),C+=4,C=R.c(c,this.oldText,C),C=R.c(c,this.newText,C),C}static read(c,C,S){const d=r.$Ne(c,C);C+=4;const P=r.$Ne(c,C);C+=4;const b=R.d(c,C);C+=R.a(b);const a=R.d(c,C);return C+=R.a(a),S.push(new R(d,b,P,a)),C}}e.$lt=R;function L(p,c){return p===null||p.length===0?c:new T(p,c).compress()}class T{constructor(c,C){this.a=c,this.c=C,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,C=0,S=this.n(c),d=this.l(C);for(;c<this.f||C<this.h;){if(S===null){this.k(d),d=this.l(++C);continue}if(d===null){this.m(S),S=this.n(++c);continue}if(d.oldEnd<=S.newPosition){this.k(d),d=this.l(++C);continue}if(S.newEnd<=d.oldPosition){this.m(S),S=this.n(++c);continue}if(d.oldPosition<S.newPosition){const[f,g]=T.r(d,S.newPosition-d.oldPosition);this.k(f),d=g;continue}if(S.newPosition<d.oldPosition){const[f,g]=T.q(S,d.oldPosition-S.newPosition);this.m(f),S=g;continue}let a,u;if(d.oldEnd===S.newEnd)a=S,u=d,S=this.n(++c),d=this.l(++C);else if(d.oldEnd<S.newEnd){const[f,g]=T.q(S,d.oldLength);a=f,u=d,S=g,d=this.l(++C)}else{const[f,g]=T.r(d,S.newLength);a=S,u=f,S=this.n(++c),d=g}this.d[this.e++]=new R(a.oldPosition,a.oldText,u.newPosition,u.newText),this.g+=a.newLength-a.oldLength,this.j+=u.newLength-u.oldLength}const P=T.s(this.d);return T.t(P)}k(c){this.d[this.e++]=T.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=T.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,C){return new R(C.oldPosition-c,C.oldText,C.newPosition,C.newText)}static p(c,C){return new R(C.oldPosition,C.oldText,C.newPosition+c,C.newText)}static q(c,C){const S=c.newText.substr(0,C),d=c.newText.substr(C);return[new R(c.oldPosition,c.oldText,c.newPosition,S),new R(c.oldEnd,"",c.newPosition+C,d)]}static r(c,C){const S=c.oldText.substr(0,C),d=c.oldText.substr(C);return[new R(c.oldPosition,S,c.newPosition,c.newText),new R(c.oldPosition+C,d,c.newEnd,"")]}static s(c){if(c.length===0)return c;const C=[];let S=0,d=c[0];for(let P=1;P<c.length;P++){const b=c[P];d.oldEnd===b.oldPosition?d=new R(d.oldPosition,d.oldText+b.oldText,d.newPosition,d.newText+b.newText):(C[S++]=d,d=b)}return C[S++]=d,C}static t(c){if(c.length===0)return c;const C=[];let S=0;for(let d=0;d<c.length;d++){const P=c[d];P.oldText!==P.newText&&(C[S++]=P)}return C}}}),define(ye[211],Se([1,0,39,16]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=A,e.$ht=R;function A(L,T,p,c,C,S){if(Array.isArray(L)){let d=0;for(const P of L){const b=A(P,T,p,c,C,S);if(b===10)return b;b>d&&(d=b)}return d}else{if(typeof L=="string")return c?L==="*"?5:L===p?10:0:0;if(L){const{language:d,pattern:P,scheme:b,hasAccessToAllModels:a,notebookType:u}=L;if(!c&&!a)return 0;u&&C&&(T=C);let f=0;if(b)if(b===T.scheme)f=10;else if(b==="*")f=5;else return 0;if(d)if(d===p)f=10;else if(d==="*")f=Math.max(f,5);else return 0;if(u)if(u===S)f=10;else if(u==="*"&&S!==void 0)f=Math.max(f,5);else return 0;if(P){let g;if(typeof P=="string"?g=P:g={...P,base:(0,m.$hc)(P.base)},g===T.fsPath||(0,r.$tk)(g,T.fsPath))f=10;else return 0}return f}else return 0}}function R(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(R):!!L.notebookType}}),define(ye[212],Se([1,0,4,13,31,55,138,187,210,3]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=void 0;class C extends c.$Uc{constructor(d,P,b,a,u,f,g){super(),this.m=this.B(new r.$he),this.onDidChangeContent=this.m.event,this.f=P,this.j=!f,this.g=a,this.h=u,this.c=new L.$$C(d,b,g)}equals(d){return!(d instanceof C)||this.f!==d.f||this.getEOL()!==d.getEOL()?!1:this.c.equal(d.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(d){return this.c.createSnapshot(d?this.f:"")}getOffsetAt(d,P){return this.c.getOffsetAt(d,P)}getPositionAt(d){return this.c.getPositionAt(d)}getRangeAt(d,P){const b=d+P,a=this.getPositionAt(d),u=this.getPositionAt(b);return new A.$ct(a.lineNumber,a.column,u.lineNumber,u.column)}getValueInRange(d,P=R.EndOfLinePreference.TextDefined){if(d.isEmpty())return"";const b=this.n(P);return this.c.getValueInRange(d,b)}getValueLengthInRange(d,P=R.EndOfLinePreference.TextDefined){if(d.isEmpty())return 0;if(d.startLineNumber===d.endLineNumber)return d.endColumn-d.startColumn;const b=this.getOffsetAt(d.startLineNumber,d.startColumn),a=this.getOffsetAt(d.endLineNumber,d.endColumn);let u=0;const f=this.n(P),g=this.getEOL();if(f.length!==g.length){const n=f.length-g.length,s=d.endLineNumber-d.startLineNumber;u=n*s}return a-b+u}getCharacterCountInRange(d,P=R.EndOfLinePreference.TextDefined){if(this.j){let b=0;const a=d.startLineNumber,u=d.endLineNumber;for(let f=a;f<=u;f++){const g=this.getLineContent(f),n=f===a?d.startColumn-1:0,s=f===u?d.endColumn-1:g.length;for(let i=n;i<s;i++)m.$Ff(g.charCodeAt(i))?(b=b+1,i=i+1):b=b+1}return b+=this.n(P).length*(u-a),b}return this.getValueLengthInRange(d,P)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(d){return this.c.getLineContent(d)}getLineCharCode(d,P){return this.c.getLineCharCode(d,P)}getCharCode(d){return this.c.getCharCode(d)}getLineLength(d){return this.c.getLineLength(d)}getLineMinColumn(d){return 1}getLineMaxColumn(d){return this.getLineLength(d)+1}getLineFirstNonWhitespaceColumn(d){const P=m.$qf(this.getLineContent(d));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(d){const P=m.$sf(this.getLineContent(d));return P===-1?0:P+2}n(d){switch(d){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(d){this.c.setEOL(d)}applyEdits(d,P,b){let a=this.g,u=this.h,f=this.j,g=!0,n=[];for(let $=0;$<d.length;$++){const E=d[$];g&&E._isTracked&&(g=!1);const k=E.range;if(E.text){let y=!0;f||(y=!m.$Qf(E.text),f=y),!a&&y&&(a=m.$Pf(E.text)),!u&&y&&(u=m.$Sf(E.text))}let D="",v=0,I=0,w=0;if(E.text){let y;[v,I,w,y]=(0,T.$jv)(E.text);const N=this.getEOL(),O=N===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;y===T.StringEOL.Unknown||y===O?D=E.text:D=E.text.replace(/\r\n|\r|\n/g,N)}n[$]={sortIndex:$,identifier:E.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:D,eolCount:v,firstLineLength:I,lastLineLength:w,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}n.sort(C.u);let s=!1;for(let $=0,E=n.length-1;$<E;$++){const k=n[$].range.getEndPosition(),D=n[$+1].range.getStartPosition();if(D.isBeforeOrEqual(k)){if(D.isBefore(k))throw new Error("Overlapping ranges are not allowed!");s=!0}}g&&(n=this.s(n));const i=b||P?C._getInverseEditRanges(n):[],t=[];if(P)for(let $=0;$<n.length;$++){const E=n[$],k=i[$];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let D=k.startLineNumber;D<=k.endLineNumber;D++){let v="";D===k.startLineNumber&&(v=this.getLineContent(E.range.startLineNumber),m.$qf(v)!==-1)||t.push({lineNumber:D,oldContent:v})}}let l=null;if(b){let $=0;l=[];for(let E=0;E<n.length;E++){const k=n[E],D=i[E],v=this.getValueInRange(k.range),I=k.rangeOffset+$;$+=k.text.length-v.length,l[E]={sortIndex:k.sortIndex,identifier:k.identifier,range:D,text:v,textChange:new p.$lt(k.rangeOffset,v,I,k.text)}}s||l.sort((E,k)=>E.sortIndex-k.sortIndex)}this.g=a,this.h=u,this.j=f;const h=this.t(n);let o=null;if(P&&t.length>0){t.sort(($,E)=>E.lineNumber-$.lineNumber),o=[];for(let $=0,E=t.length;$<E;$++){const k=t[$].lineNumber;if($>0&&t[$-1].lineNumber===k)continue;const D=t[$].oldContent,v=this.getLineContent(k);v.length===0||v===D||m.$qf(v)!==-1||o.push(k)}}return this.m.fire(),new R.$vv(l,h,o)}s(d){return d.length<1e3?d:[this._toSingleEditOperation(d)]}_toSingleEditOperation(d){let P=!1;const b=d[0].range,a=d[d.length-1].range,u=new A.$ct(b.startLineNumber,b.startColumn,a.endLineNumber,a.endColumn);let f=b.startLineNumber,g=b.startColumn;const n=[];for(let h=0,o=d.length;h<o;h++){const $=d[h],E=$.range;P=P||$.forceMoveMarkers,n.push(this.getValueInRange(new A.$ct(f,g,E.startLineNumber,E.startColumn))),$.text.length>0&&n.push($.text),f=E.endLineNumber,g=E.endColumn}const s=n.join(""),[i,t,l]=(0,T.$jv)(s);return{sortIndex:0,identifier:d[0].identifier,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u,R.EndOfLinePreference.TextDefined),text:s,eolCount:i,firstLineLength:t,lastLineLength:l,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(d){d.sort(C.w);const P=[];for(let b=0;b<d.length;b++){const a=d[b],u=a.range.startLineNumber,f=a.range.startColumn,g=a.range.endLineNumber,n=a.range.endColumn;if(u===g&&f===n&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const s=new A.$ct(u,f,g,n);P.push({range:s,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return P}findMatchesLineByLine(d,P,b,a){return this.c.findMatchesLineByLine(d,P,b,a)}getPieceTree(){return this.c}static _getInverseEditRange(d,P){const b=d.startLineNumber,a=d.startColumn,[u,f,g]=(0,T.$jv)(P);let n;if(P.length>0){const s=u+1;s===1?n=new A.$ct(b,a,b,a+f):n=new A.$ct(b,a,b+s-1,g+1)}else n=new A.$ct(b,a,b,a);return n}static _getInverseEditRanges(d){const P=[];let b=0,a=0,u=null;for(let f=0,g=d.length;f<g;f++){const n=d[f];let s,i;u?u.range.endLineNumber===n.range.startLineNumber?(s=b,i=a+(n.range.startColumn-u.range.endColumn)):(s=b+(n.range.startLineNumber-u.range.endLineNumber),i=n.range.startColumn):(s=n.range.startLineNumber,i=n.range.startColumn);let t;if(n.text.length>0){const l=n.eolCount+1;l===1?t=new A.$ct(s,i,s,i+n.firstLineLength):t=new A.$ct(s,i,s+l-1,n.lastLineLength+1)}else t=new A.$ct(s,i,s,i);b=t.endLineNumber,a=t.endColumn,P.push(t),u=n}return P}static u(d,P){const b=A.$ct.compareRangesUsingEnds(d.range,P.range);return b===0?d.sortIndex-P.sortIndex:b}static w(d,P){const b=A.$ct.compareRangesUsingEnds(d.range,P.range);return b===0?P.sortIndex-d.sortIndex:-b}}e.$_C=C}),define(ye[213],Se([1,0,27,13,55,138,212]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=void 0;class T{constructor(C,S,d,P,b,a,u,f,g){this.a=C,this.b=S,this.c=d,this.d=P,this.e=b,this.f=a,this.g=u,this.h=f,this.j=g}k(C){const S=this.c+this.d+this.e,d=this.c+this.e;return S===0?C===A.DefaultEndOfLine.LF?`
`:`\r
`:d>S/2?`\r
`:`
`}create(C){const S=this.k(C),d=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let b=0,a=d.length;b<a;b++){const u=d[b].buffer.replace(/\r\n|\r|\n/g,S),f=(0,R.$7C)(u);d[b]=new R.$0C(u,f)}const P=new L.$_C(d,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(C){return this.a[0].buffer.substr(0,C).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(C){if(C.length===0)return;this.a.length===0&&m.$1f(C)&&(this.b=m.$Zf,C=C.substr(1));const S=C.charCodeAt(C.length-1);S===r.CharCode.CarriageReturn||S>=55296&&S<=56319?(this.m(C.substr(0,C.length-1),!1),this.c=!0,this.d=S):(this.m(C,!1),this.c=!1,this.d=S)}m(C,S){!S&&C.length===0||(this.c?this.n(String.fromCharCode(this.d)+C):this.n(C))}n(C){const S=(0,R.$8C)(this.e,C);this.a.push(new R.$0C(C,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=m.$Pf(C)),this.k||(this.k=m.$Sf(C)))}finish(C=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,C)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const C=this.a[this.a.length-1];C.buffer+=String.fromCharCode(this.d);const S=(0,R.$7C)(C.buffer);C.lineStarts=S,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$aD=p}),define(ye[142],Se([1,0,22,11]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bb=p,e.$6bb=C;var A;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(A||(A={}));function R(S){for(let d=0,P=S.length;d<P;d+=4){const b=S[d+0],a=S[d+1],u=S[d+2],f=S[d+3];S[d+0]=f,S[d+1]=u,S[d+2]=a,S[d+3]=b}}function L(S){const d=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return m.$D()||R(d),r.$Je.wrap(d)}function T(S){const d=S.buffer;if(m.$D()||R(d),d.byteOffset%4===0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const P=new Uint8Array(d.byteLength);return P.set(d),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function p(S){const d=new Uint32Array(c(S));let P=0;if(d[P++]=S.id,S.type==="full")d[P++]=A.Full,d[P++]=S.data.length,d.set(S.data,P),P+=S.data.length;else{d[P++]=A.Delta,d[P++]=S.deltas.length;for(const b of S.deltas)d[P++]=b.start,d[P++]=b.deleteCount,b.data?(d[P++]=b.data.length,d.set(b.data,P),P+=b.data.length):d[P++]=0}return L(d)}function c(S){let d=0;if(d+=2,S.type==="full")d+=1+S.data.length;else{d+=1,d+=3*S.deltas.length;for(const P of S.deltas)P.data&&(d+=P.data.length)}return d}function C(S){const d=T(S);let P=0;const b=d[P++];if(d[P++]===A.Full){const g=d[P++],n=d.subarray(P,P+g);return P+=g,{id:b,type:"full",data:n}}const u=d[P++],f=[];for(let g=0;g<u;g++){const n=d[P++],s=d[P++],i=d[P++];let t;i>0&&(t=d.subarray(P,P+i),P+=i),f[g]={start:n,deleteCount:s,data:t}}return{id:b,type:"delta",deltas:f}}}),define(ye[214],Se([7,8]),function(de,e){return de.create("vs/editor/common/config/editorOptions",e)}),define(ye[215],Se([7,8]),function(de,e){return de.create("vs/editor/common/languages",e)}),define(ye[88],Se([1,0,83,2,188,31,198,215]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Rv=e.$Qv=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Pv=e.$Ov=e.SymbolKinds=e.SymbolTag=e.$Mv=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Kv=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Jv=e.$Iv=e.$Hv=void 0,e.$Lv=h,e.$Nv=$;class p{constructor(H,_,ne){this.offset=H,this.type=_,this.language=ne,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Hv=p;class c{constructor(H,_){this.tokens=H,this.endState=_,this._tokenizationResultBrand=void 0}}e.$Iv=c;class C{constructor(H,_){this.tokens=H,this.endState=_,this._encodedTokenizationResultBrand=void 0}}e.$Jv=C;var S;(function(V){V[V.Increase=0]="Increase",V[V.Decrease=1]="Decrease"})(S||(e.HoverVerbosityAction=S={}));var d;(function(V){V[V.Method=0]="Method",V[V.Function=1]="Function",V[V.Constructor=2]="Constructor",V[V.Field=3]="Field",V[V.Variable=4]="Variable",V[V.Class=5]="Class",V[V.Struct=6]="Struct",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Event=10]="Event",V[V.Operator=11]="Operator",V[V.Unit=12]="Unit",V[V.Value=13]="Value",V[V.Constant=14]="Constant",V[V.Enum=15]="Enum",V[V.EnumMember=16]="EnumMember",V[V.Keyword=17]="Keyword",V[V.Text=18]="Text",V[V.Color=19]="Color",V[V.File=20]="File",V[V.Reference=21]="Reference",V[V.Customcolor=22]="Customcolor",V[V.Folder=23]="Folder",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue",V[V.Snippet=27]="Snippet"})(d||(e.CompletionItemKind=d={}));var P;(function(V){const H=new Map;H.set(d.Method,r.$Zj.symbolMethod),H.set(d.Function,r.$Zj.symbolFunction),H.set(d.Constructor,r.$Zj.symbolConstructor),H.set(d.Field,r.$Zj.symbolField),H.set(d.Variable,r.$Zj.symbolVariable),H.set(d.Class,r.$Zj.symbolClass),H.set(d.Struct,r.$Zj.symbolStruct),H.set(d.Interface,r.$Zj.symbolInterface),H.set(d.Module,r.$Zj.symbolModule),H.set(d.Property,r.$Zj.symbolProperty),H.set(d.Event,r.$Zj.symbolEvent),H.set(d.Operator,r.$Zj.symbolOperator),H.set(d.Unit,r.$Zj.symbolUnit),H.set(d.Value,r.$Zj.symbolValue),H.set(d.Enum,r.$Zj.symbolEnum),H.set(d.Constant,r.$Zj.symbolConstant),H.set(d.Enum,r.$Zj.symbolEnum),H.set(d.EnumMember,r.$Zj.symbolEnumMember),H.set(d.Keyword,r.$Zj.symbolKeyword),H.set(d.Snippet,r.$Zj.symbolSnippet),H.set(d.Text,r.$Zj.symbolText),H.set(d.Color,r.$Zj.symbolColor),H.set(d.File,r.$Zj.symbolFile),H.set(d.Reference,r.$Zj.symbolReference),H.set(d.Customcolor,r.$Zj.symbolCustomColor),H.set(d.Folder,r.$Zj.symbolFolder),H.set(d.TypeParameter,r.$Zj.symbolTypeParameter),H.set(d.User,r.$Zj.account),H.set(d.Issue,r.$Zj.issues);function _(re){let ve=H.get(re);return ve||(console.info("No codicon found for CompletionItemKind "+re),ve=r.$Zj.symbolProperty),ve}V.toIcon=_;const ne=new Map;ne.set("method",d.Method),ne.set("function",d.Function),ne.set("constructor",d.Constructor),ne.set("field",d.Field),ne.set("variable",d.Variable),ne.set("class",d.Class),ne.set("struct",d.Struct),ne.set("interface",d.Interface),ne.set("module",d.Module),ne.set("property",d.Property),ne.set("event",d.Event),ne.set("operator",d.Operator),ne.set("unit",d.Unit),ne.set("value",d.Value),ne.set("constant",d.Constant),ne.set("enum",d.Enum),ne.set("enum-member",d.EnumMember),ne.set("enumMember",d.EnumMember),ne.set("keyword",d.Keyword),ne.set("snippet",d.Snippet),ne.set("text",d.Text),ne.set("color",d.Color),ne.set("file",d.File),ne.set("reference",d.Reference),ne.set("customcolor",d.Customcolor),ne.set("folder",d.Folder),ne.set("type-parameter",d.TypeParameter),ne.set("typeParameter",d.TypeParameter),ne.set("account",d.User),ne.set("issue",d.Issue);function he(re,ve){let pe=ne.get(re);return typeof pe>"u"&&!ve&&(pe=d.Property),pe}V.fromString=he})(P||(e.CompletionItemKinds=P={}));var b;(function(V){V[V.Deprecated=1]="Deprecated"})(b||(e.CompletionItemTag=b={}));var a;(function(V){V[V.None=0]="None",V[V.KeepWhitespace=1]="KeepWhitespace",V[V.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var u;(function(V){V[V.Word=0]="Word",V[V.Line=1]="Line",V[V.Suggest=2]="Suggest"})(u||(e.PartialAcceptTriggerKind=u={}));var f;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(e.CompletionTriggerKind=f={}));var g;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class n{constructor(H,_,ne,he){this.range=H,this.text=_,this.completionKind=ne,this.isSnippetText=he}equals(H){return R.$ct.lift(this.range).equalsRange(H.range)&&this.text===H.text&&this.completionKind===H.completionKind&&this.isSnippetText===H.isSnippetText}}e.$Kv=n;var s;(function(V){V[V.Invoke=1]="Invoke",V[V.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var i;(function(V){V[V.Automatic=0]="Automatic",V[V.PasteAs=1]="PasteAs"})(i||(e.DocumentPasteTriggerKind=i={}));var t;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var l;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(l||(e.DocumentHighlightKind=l={}));function h(V){return V&&m.URI.isUri(V.uri)&&R.$ct.isIRange(V.range)&&(R.$ct.isIRange(V.originSelectionRange)||R.$ct.isIRange(V.targetSelectionRange))}var o;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(o||(e.SymbolKind=o={})),e.$Mv={[o.Array]:(0,T.localize)(0,null),[o.Boolean]:(0,T.localize)(1,null),[o.Class]:(0,T.localize)(2,null),[o.Constant]:(0,T.localize)(3,null),[o.Constructor]:(0,T.localize)(4,null),[o.Enum]:(0,T.localize)(5,null),[o.EnumMember]:(0,T.localize)(6,null),[o.Event]:(0,T.localize)(7,null),[o.Field]:(0,T.localize)(8,null),[o.File]:(0,T.localize)(9,null),[o.Function]:(0,T.localize)(10,null),[o.Interface]:(0,T.localize)(11,null),[o.Key]:(0,T.localize)(12,null),[o.Method]:(0,T.localize)(13,null),[o.Module]:(0,T.localize)(14,null),[o.Namespace]:(0,T.localize)(15,null),[o.Null]:(0,T.localize)(16,null),[o.Number]:(0,T.localize)(17,null),[o.Object]:(0,T.localize)(18,null),[o.Operator]:(0,T.localize)(19,null),[o.Package]:(0,T.localize)(20,null),[o.Property]:(0,T.localize)(21,null),[o.String]:(0,T.localize)(22,null),[o.Struct]:(0,T.localize)(23,null),[o.TypeParameter]:(0,T.localize)(24,null),[o.Variable]:(0,T.localize)(25,null)};function $(V,H){return(0,T.localize)(26,null,V,e.$Mv[H])}var E;(function(V){V[V.Deprecated=1]="Deprecated"})(E||(e.SymbolTag=E={}));var k;(function(V){const H=new Map;H.set(o.File,r.$Zj.symbolFile),H.set(o.Module,r.$Zj.symbolModule),H.set(o.Namespace,r.$Zj.symbolNamespace),H.set(o.Package,r.$Zj.symbolPackage),H.set(o.Class,r.$Zj.symbolClass),H.set(o.Method,r.$Zj.symbolMethod),H.set(o.Property,r.$Zj.symbolProperty),H.set(o.Field,r.$Zj.symbolField),H.set(o.Constructor,r.$Zj.symbolConstructor),H.set(o.Enum,r.$Zj.symbolEnum),H.set(o.Interface,r.$Zj.symbolInterface),H.set(o.Function,r.$Zj.symbolFunction),H.set(o.Variable,r.$Zj.symbolVariable),H.set(o.Constant,r.$Zj.symbolConstant),H.set(o.String,r.$Zj.symbolString),H.set(o.Number,r.$Zj.symbolNumber),H.set(o.Boolean,r.$Zj.symbolBoolean),H.set(o.Array,r.$Zj.symbolArray),H.set(o.Object,r.$Zj.symbolObject),H.set(o.Key,r.$Zj.symbolKey),H.set(o.Null,r.$Zj.symbolNull),H.set(o.EnumMember,r.$Zj.symbolEnumMember),H.set(o.Struct,r.$Zj.symbolStruct),H.set(o.Event,r.$Zj.symbolEvent),H.set(o.Operator,r.$Zj.symbolOperator),H.set(o.TypeParameter,r.$Zj.symbolTypeParameter);function _(ne){let he=H.get(ne);return he||(console.info("No codicon found for SymbolKind "+ne),he=r.$Zj.symbolProperty),he}V.toIcon=_})(k||(e.SymbolKinds=k={}));class D{static asEditOperation(H){return A.$dt.replace(R.$ct.lift(H.range),H.text)}}e.$Ov=D;class v{static{this.Comment=new v("comment")}static{this.Imports=new v("imports")}static{this.Region=new v("region")}static fromValue(H){switch(H){case"comment":return v.Comment;case"imports":return v.Imports;case"region":return v.Region}return new v(H)}constructor(H){this.value=H}}e.$Pv=v;var I;(function(V){V[V.AIGenerated=1]="AIGenerated"})(I||(e.NewSymbolNameTag=I={}));var w;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(w||(e.NewSymbolNameTriggerKind=w={}));var y;(function(V){function H(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}V.is=H})(y||(e.Command=y={}));var N;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(N||(e.CommentThreadCollapsibleState=N={}));var O;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(O||(e.CommentThreadState=O={}));var U;(function(V){V[V.Current=0]="Current",V[V.Outdated=1]="Outdated"})(U||(e.CommentThreadApplicability=U={}));var j;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var z;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(z||(e.CommentState=z={}));var M;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(M||(e.InlayHintKind=M={}));class F{constructor(H){this.b=H,this.a=null}dispose(){this.a&&this.a.then(H=>{H&&H.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Qv=F,e.$Rv=new L.$xv;var J;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(J||(e.ExternalUriOpenerPriority=J={}));var ee;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(ee||(e.InlineEditTriggerKind=ee={}))}),define(ye[216],Se([7,8]),function(de,e){return de.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[217],Se([7,8]),function(de,e){return de.create("vs/platform/contextkey/common/contextkey",e)}),define(ye[218],Se([7,8]),function(de,e){return de.create("vs/platform/contextkey/common/scanner",e)}),define(ye[219],Se([7,8]),function(de,e){return de.create("vs/platform/dialogs/common/dialogs",e)}),define(ye[220],Se([7,8]),function(de,e){return de.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[221],Se([7,8]),function(de,e){return de.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[222],Se([7,8]),function(de,e){return de.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[223],Se([7,8]),function(de,e){return de.create("vs/platform/files/common/files",e)}),define(ye[224],Se([7,8]),function(de,e){return de.create("vs/platform/files/common/io",e)}),define(ye[225],Se([7,8]),function(de,e){return de.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ye[226],Se([7,8]),function(de,e){return de.create("vs/platform/log/common/log",e)}),define(ye[227],Se([7,8]),function(de,e){return de.create("vs/platform/markers/common/markers",e)}),define(ye[228],Se([7,8]),function(de,e){return de.create("vs/platform/request/common/request",e)}),define(ye[229],Se([7,8]),function(de,e){return de.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[230],Se([7,8]),function(de,e){return de.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ye[231],Se([7,8]),function(de,e){return de.create("vs/platform/workspace/common/workspace",e)}),define(ye[232],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[233],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[234],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ye[235],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ye[236],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostLogService",e)}),define(ye[237],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostNotebook",e)}),define(ye[238],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[239],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[240],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[241],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[242],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ye[243],Se([7,8]),function(de,e){return de.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[244],Se([7,8]),function(de,e){return de.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[245],Se([7,8]),function(de,e){return de.create("vs/workbench/common/configuration",e)}),define(ye[246],Se([7,8]),function(de,e){return de.create("vs/workbench/common/editor",e)}),define(ye[247],Se([7,8]),function(de,e){return de.create("vs/workbench/common/views",e)}),define(ye[248],Se([7,8]),function(de,e){return de.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ye[249],Se([7,8]),function(de,e){return de.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(ye[250],Se([7,8]),function(de,e){return de.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[251],Se([7,8]),function(de,e){return de.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[252],Se([7,8]),function(de,e){return de.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[253],Se([7,8]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[254],Se([7,8]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[255],Se([7,8]),function(de,e){return de.create("vs/workbench/contrib/testing/common/constants",e)}),define(ye[256],Se([7,8]),function(de,e){return de.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[257],Se([7,8]),function(de,e){return de.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ye[258],Se([7,8]),function(de,e){return de.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[259],Se([7,8]),function(de,e){return de.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ye[260],Se([7,8]),function(de,e){return de.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[261],Se([1,0,27,14,218]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var R;(function(C){C[C.LParen=0]="LParen",C[C.RParen=1]="RParen",C[C.Neg=2]="Neg",C[C.Eq=3]="Eq",C[C.NotEq=4]="NotEq",C[C.Lt=5]="Lt",C[C.LtEq=6]="LtEq",C[C.Gt=7]="Gt",C[C.GtEq=8]="GtEq",C[C.RegexOp=9]="RegexOp",C[C.RegexStr=10]="RegexStr",C[C.True=11]="True",C[C.False=12]="False",C[C.In=13]="In",C[C.Not=14]="Not",C[C.And=15]="And",C[C.Or=16]="Or",C[C.Str=17]="Str",C[C.QuotedStr=18]="QuotedStr",C[C.Error=19]="Error",C[C.EOF=20]="EOF"})(R||(e.TokenType=R={}));function L(...C){switch(C.length){case 1:return(0,A.localize)(0,null,C[0]);case 2:return(0,A.localize)(1,null,C[0],C[1]);case 3:return(0,A.localize)(2,null,C[0],C[1],C[2]);default:return}}const T=(0,A.localize)(3,null),p=(0,A.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return S.isTripleEq?"===":"==";case R.NotEq:return S.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return S.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return S.lexeme;case R.QuotedStr:return S.lexeme;case R.Error:return S.lexeme;case R.EOF:return"EOF";default:throw(0,m.$8)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(R.LParen);break;case r.CharCode.CloseParen:this.k(R.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const d=this.h(r.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:d})}else this.k(R.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const d=this.h(r.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:d})}else this.h(r.CharCode.Tilde)?this.k(R.RegexOp):this.l(L("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?R.LtEq:R.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?R.GtEq:R.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(R.And):this.l(L("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(R.Or):this.l(L("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(S){const d=this.d,P=this.c.substring(this.d,this.e),b={type:R.Error,offset:this.d,lexeme:P};this.g.push({offset:d,lexeme:P,additionalInfo:S}),this.f.push(b)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const d=this.c.substring(this.d,this.e),P=c.b.get(d);P?this.k(P):this.f.push({type:R.Str,lexeme:d,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,d=!1,P=!1;for(;;){if(S>=this.c.length){this.e=S,this.l(p);return}const a=this.c.charCodeAt(S);if(d)d=!1;else if(a===r.CharCode.Slash&&!P){S++;break}else a===r.CharCode.OpenSquareBracket?P=!0:a===r.CharCode.Backslash?d=!0:a===r.CharCode.CloseSquareBracket&&(P=!1);S++}for(;S<this.c.length&&c.a.has(this.c.charCodeAt(S));)S++;this.e=S;const b=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=c}),define(ye[262],Se([1,0,23,43,221,411]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=p,e.$Pp=c,e.$Qp=C,e.$Rp=S,e.$Sp=d,e.$Tp=P,e.$Up=b;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function p(f){return f=f.trim(),f==="*"||L.test(f)}function c(f){if(!p(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=f.match(L);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}function C(f){if(!f)return null;const g=f.majorBase,n=f.majorMustEqual,s=f.minorBase;let i=f.minorMustEqual;const t=f.patchBase;let l=f.patchMustEqual;f.hasCaret&&(g===0||(i=!1),l=!1);let h=0;if(f.preRelease){const o=T.exec(f.preRelease);if(o){const[,$,E,k]=o;h=Date.UTC(Number($),Number(E)-1,Number(k))}}return{majorBase:g,majorMustEqual:n,minorBase:s,minorMustEqual:i,patchBase:t,patchMustEqual:l,isMinimum:f.hasGreaterEquals,notBefore:h}}function S(f,g,n){let s;typeof f=="string"?s=C(c(f)):s=f;let i;g instanceof Date?i=g.getTime():typeof g=="string"&&(i=new Date(g).getTime());let t;if(typeof n=="string"?t=C(c(n)):t=n,!s||!t)return!1;const l=s.majorBase,h=s.minorBase,o=s.patchBase;let $=t.majorBase,E=t.minorBase,k=t.patchBase;const D=t.notBefore;let v=t.majorMustEqual,I=t.minorMustEqual,w=t.patchMustEqual;return t.isMinimum?l>$?!0:l<$?!1:h>E?!0:h<E||i&&i<D?!1:o>=k:(l===1&&$===0&&(!v||!I||!w)&&($=1,E=0,k=0,v=!0,I=!1,w=!1),l<$?!1:l>$?!v:h<E?!1:h>E?!I:o<k?!1:o>k?!w:!(i&&i<D))}function d(f,g,n,s,i){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([m.default.Error,A.localize(0,null)]),t;if(typeof s.name!="string")return t.push([m.default.Error,A.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([m.default.Error,A.localize(2,null,"version")]),t;if(!s.engines)return t.push([m.default.Error,A.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([m.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!u(s.extensionDependencies))return t.push([m.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!u(s.activationEvents))return t.push([m.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([m.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([m.default.Warning,A.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([m.default.Error,A.localize(9,null,"main")]),t;{const o=(0,r.$bh)(n,s.main);(0,r.$8g)(o,n)||t.push([m.default.Warning,A.localize(10,null,o.path,n.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([m.default.Error,A.localize(11,null,"browser")]),t;{const o=(0,r.$bh)(n,s.browser);(0,r.$8g)(o,n)||t.push([m.default.Warning,A.localize(12,null,o.path,n.path)])}}if(!R.valid(s.version))return t.push([m.default.Error,A.localize(13,null)]),t;const l=[];if(!P(f,g,s,i,l))for(const o of l)t.push([m.default.Error,o]);return t}function P(f,g,n,s,i){return s||typeof n.main>"u"&&typeof n.browser>"u"?!0:a(f,g,n.engines.vscode,i)}function b(f,g,n){return f==="*"||a(g,n,f)}function a(f,g,n,s=[]){const i=C(c(n));if(!i)return s.push(A.localize(14,null,n)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return s.push(A.localize(15,null,n)),!1}else if(!i.majorMustEqual)return s.push(A.localize(16,null,n)),!1;return S(f,g,i)?!0:(s.push(A.localize(17,null,f,n)),!1)}function u(f){if(!Array.isArray(f))return!1;for(let g=0,n=f.length;g<n;g++)if(typeof f[g]!="string")return!1;return!0}}),define(ye[112],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class r{constructor(A,R=[],L=!1){this.ctor=A,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$xi=r}),define(ye[89],Se([1,0,112]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Fs=R,e.$Gs=L;const m=[];var A;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function R(T,p,c){p instanceof r.$xi||(p=new r.$xi(p,[],!!c)),m.push([T,p])}function L(){return m}}),define(ye[263],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;class r{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$ir=r;class m{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const T=this.lookupOrInsertNode(R),p=this.lookupOrInsertNode(L);T.outgoing.set(p.key,p),p.incoming.set(T.key,T)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const T of this.a.values())T.outgoing.delete(L),T.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let T=this.a.get(L);return T||(T=new r(L,R),this.a.set(L,T)),T}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,T]of this.a)R.push(`${L}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const T=new Set([R]),p=this.c(L,T);if(p)return p}}c(R,L){for(const[T,p]of R.outgoing){if(L.has(T))return[...L,T].join(" -> ");L.add(T);const c=this.c(p,L);if(c)return c;L.delete(T)}}}e.$jr=m}),define(ye[5],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=A,e.$Bi=R;var r;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function T(p){return p[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=T})(r||(e._util=r={})),e.$zi=A("instantiationService");function m(L,T,p){T[r.DI_TARGET]===T?T[r.DI_DEPENDENCIES].push({id:L,index:p}):(T[r.DI_DEPENDENCIES]=[{id:L,index:p}],T[r.DI_TARGET]=T)}function A(L){if(r.serviceIds.has(L))return r.serviceIds.get(L);const T=function(p,c,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");m(T,p,C)};return T.toString=()=>L,r.serviceIds.set(L,T),T}function R(L){return L}}),define(ye[44],Se([1,0,18,2,5]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=R,e.$9i=L,e.$0i=p,e.$$i=c,e.$_i=C,e.$aj=S,e.$bj=d,e.$cj=b,e.$dj=a,e.$ej=u,e.$7i=(0,A.$Ai)("configurationService");function R(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof m.URI)}function L(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof m.URI)}var T;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function p(f){switch(f){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function c(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function C(f,g){const n=Object.create(null);for(const s in f)S(n,s,f[s],g);return n}function S(f,g,n,s){const i=g.split("."),t=i.pop();let l=f;for(let h=0;h<i.length;h++){const o=i[h];let $=l[o];switch(typeof $){case"undefined":$=l[o]=Object.create(null);break;case"object":if($===null){s(`Ignoring ${g} as ${i.slice(0,h+1).join(".")} is null`);return}break;default:s(`Ignoring ${g} as ${i.slice(0,h+1).join(".")} is ${JSON.stringify($)}`);return}l=$}if(typeof l=="object"&&l!==null)try{l[t]=n}catch{s(`Ignoring ${g} as ${i.join(".")} is ${JSON.stringify(l)}`)}else s(`Ignoring ${g} as ${i.join(".")} is ${JSON.stringify(l)}`)}function d(f,g){const n=g.split(".");P(f,n)}function P(f,g){const n=g.shift();if(g.length===0){delete f[n];return}if(Object.keys(f).indexOf(n)!==-1){const s=f[n];typeof s=="object"&&!Array.isArray(s)&&(P(s,g),Object.keys(s).length===0&&delete f[n])}}function b(f,g,n){function s(l,h){let o=l;for(const $ of h){if(typeof o!="object"||o===null)return;o=o[$]}return o}const i=g.split("."),t=s(f,i);return typeof t>"u"?n:t}function a(f,g,n){Object.keys(g).forEach(s=>{s!=="__proto__"&&(s in f?r.$cg(f[s])&&r.$cg(g[s])?a(f[s],g[s],n):n&&(f[s]=g[s]):f[s]=g[s])})}function u(f){return f.replace(/[\[\]]/g,"")}}),define(ye[35],Se([1,0,27,11,13,261,5,217,14]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=C,e.$zj=h,e.$Aj=o,e.$Tj=re;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",m.$j),c.set("isLinux",m.$k),c.set("isWindows",m.$i),c.set("isWeb",m.$o),c.set("isMacNative",m.$j&&!m.$o),c.set("isEdge",m.$H),c.set("isFirefox",m.$F),c.set("isChrome",m.$E),c.set("isSafari",m.$G);function C(Q,B){if(c.get(Q)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Q,B)}const S=Object.prototype.hasOwnProperty;var d;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const P={regexParsingWithErrorRecovery:!0},b=(0,T.localize)(0,null),a=(0,T.localize)(1,null),u=(0,T.localize)(2,null),f=(0,T.localize)(3,null),g=(0,T.localize)(4,null),n=(0,T.localize)(5,null),s=(0,T.localize)(6,null),i=(0,T.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=P){this.k=B,this.d=new R.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const ae=this.D(),ie=ae.type===R.TokenType.Str?n:void 0;throw this.h.push({message:g,offset:ae.offset,lexeme:R.$vj.getLexeme(ae),additionalInfo:ie}),t.c}return se}catch(se){if(se!==t.c)throw se;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(R.TokenType.Or);){const se=this.o();B.push(se)}return B.length===1?B[0]:l.or(...B)}o(){const B=[this.s()];for(;this.y(R.TokenType.And);){const se=this.s();B.push(se)}return B.length===1?B[0]:l.and(...B)}s(){if(this.y(R.TokenType.Neg)){const B=this.D();switch(B.type){case R.TokenType.True:return this.z(),E.INSTANCE;case R.TokenType.False:return this.z(),k.INSTANCE;case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,f),se?.negate()}case R.TokenType.Str:return this.z(),N.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case R.TokenType.True:return this.z(),l.true();case R.TokenType.False:return this.z(),l.false();case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,f),se}case R.TokenType.Str:{const se=B.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const ie=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ie.type!==R.TokenType.RegexStr)throw this.B("REGEX",ie);const ce=ie.lexeme,ue=ce.lastIndexOf("/"),Z=ue===ce.length-1?void 0:this.w(ce.substring(ue+1));let oe;try{oe=new RegExp(ce.substring(1,ue),Z)}catch{throw this.B("REGEX",ie)}return F.create(se,oe)}switch(ie.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const ce=[ie.lexeme];this.z();let ue=this.D(),Z=0;for(let Be=0;Be<ie.lexeme.length;Be++)ie.lexeme.charCodeAt(Be)===r.CharCode.OpenParen?Z++:ie.lexeme.charCodeAt(Be)===r.CharCode.CloseParen&&Z--;for(;!this.E()&&ue.type!==R.TokenType.And&&ue.type!==R.TokenType.Or;){switch(ue.type){case R.TokenType.LParen:Z++;break;case R.TokenType.RParen:Z--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let Be=0;Be<ue.lexeme.length;Be++)ue.lexeme.charCodeAt(Be)===r.CharCode.OpenParen?Z++:ie.lexeme.charCodeAt(Be)===r.CharCode.CloseParen&&Z--}if(Z<0)break;ce.push(R.$vj.getLexeme(ue)),this.z(),ue=this.D()}const oe=ce.join(""),$e=oe.lastIndexOf("/"),be=$e===oe.length-1?void 0:this.w(oe.substring($e+1));let Ne;try{Ne=new RegExp(oe.substring(1,$e),be)}catch{throw this.B("REGEX",ie)}return l.regex(se,Ne)}case R.TokenType.QuotedStr:{const ce=ie.lexeme;this.z();let ue=null;if(!(0,A.$$e)(ce)){const Z=ce.indexOf("/"),oe=ce.lastIndexOf("/");if(Z!==oe&&Z>=0){const $e=ce.slice(Z+1,oe),be=ce[oe+1]==="i"?"i":"";try{ue=new RegExp($e,be)}catch{throw this.B("REGEX",ie)}}}if(ue===null)throw this.B("REGEX",ie);return F.create(se,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,u);const ie=this.u();return l.notIn(se,ie)}switch(this.D().type){case R.TokenType.Eq:{this.z();const ie=this.u();if(this.x().type===R.TokenType.QuotedStr)return l.equals(se,ie);switch(ie){case"true":return l.has(se);case"false":return l.not(se);default:return l.equals(se,ie)}}case R.TokenType.NotEq:{this.z();const ie=this.u();if(this.x().type===R.TokenType.QuotedStr)return l.notEquals(se,ie);switch(ie){case"true":return l.not(se);case"false":return l.has(se);default:return l.notEquals(se,ie)}}case R.TokenType.Lt:return this.z(),z.create(se,this.u());case R.TokenType.LtEq:return this.z(),M.create(se,this.u());case R.TokenType.Gt:return this.z(),U.create(se,this.u());case R.TokenType.GtEq:return this.z(),j.create(se,this.u());case R.TokenType.In:return this.z(),l.in(se,this.u());default:return l.has(se)}}case R.TokenType.EOF:throw this.h.push({message:s,offset:B.offset,lexeme:"",additionalInfo:i}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),B.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,se){if(this.C(B))return this.z();throw this.B(se,this.D())}B(B,se,ae){const ie=(0,T.localize)(8,null,B,R.$vj.getLexeme(se)),ce=se.offset,ue=R.$vj.getLexeme(se);return this.h.push({message:ie,offset:ce,lexeme:ue,additionalInfo:ae}),t.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$xj=t;class l{static false(){return E.INSTANCE}static true(){return k.INSTANCE}static has(B){return D.create(B)}static equals(B,se){return v.create(B,se)}static notEquals(B,se){return y.create(B,se)}static regex(B,se){return F.create(B,se)}static in(B,se){return I.create(B,se)}static notIn(B,se){return w.create(B,se)}static not(B){return N.create(B)}static and(...B){return V.create(B,null,!0)}static or(...B){return H.create(B,null,!0)}static greater(B,se){return U.create(B,se)}static greaterEquals(B,se){return j.create(B,se)}static smaller(B,se){return z.create(B,se)}static smallerEquals(B,se){return M.create(B,se)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$yj=l;function h(Q){const B=new t({regexParsingWithErrorRecovery:!1});return Q.map(se=>(B.parse(se),B.lexingErrors.length>0?B.lexingErrors.map(ae=>({errorMessage:ae.additionalInfo?(0,T.localize)(9,null,ae.additionalInfo):(0,T.localize)(10,null),offset:ae.offset,length:ae.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ae=>({errorMessage:ae.additionalInfo?`${ae.message}. ${ae.additionalInfo}`:ae.message,offset:ae.offset,length:ae.lexeme.length})):[]))}function o(Q,B){const se=Q?Q.substituteConstants():void 0,ae=B?B.substituteConstants():void 0;return!se&&!ae?!0:!se||!ae?!1:se.equals(ae)}function $(Q,B){return Q.cmp(B)}class E{static{this.INSTANCE=new E}constructor(){this.type=d.False}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return k.INSTANCE}}e.$Bj=E;class k{static{this.INSTANCE=new k}constructor(){this.type=d.True}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return E.INSTANCE}}e.$Cj=k;class D{static create(B,se=null){const ae=c.get(B);return typeof ae=="boolean"?ae?k.INSTANCE:E.INSTANCE:new D(B,se)}constructor(B,se){this.key=B,this.c=se,this.type=d.Defined}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=c.get(this.key);return typeof B=="boolean"?B?k.INSTANCE:E.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Dj=D;class v{static create(B,se,ae=null){if(typeof se=="boolean")return se?D.create(B,ae):N.create(B,ae);const ie=c.get(B);return typeof ie=="boolean"?se===(ie?"true":"false")?k.INSTANCE:E.INSTANCE:new v(B,se,ae)}constructor(B,se,ae){this.c=B,this.d=se,this.f=ae,this.type=d.Equals}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=c.get(this.c);if(typeof B=="boolean"){const se=B?"true":"false";return this.d===se?k.INSTANCE:E.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Ej=v;class I{static create(B,se){return new I(B,se)}constructor(B,se){this.d=B,this.f=se,this.type=d.In,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:he(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const se=B.getValue(this.f),ae=B.getValue(this.d);return Array.isArray(se)?se.includes(ae):typeof ae=="string"&&typeof se=="object"&&se!==null?S.call(se,ae):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Fj=I;class w{static create(B,se){return new w(B,se)}constructor(B,se){this.d=B,this.f=se,this.type=d.NotIn,this.c=I.create(B,se)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=w;class y{static create(B,se,ae=null){if(typeof se=="boolean")return se?N.create(B,ae):D.create(B,ae);const ie=c.get(B);return typeof ie=="boolean"?se===(ie?"true":"false")?E.INSTANCE:k.INSTANCE:new y(B,se,ae)}constructor(B,se,ae){this.c=B,this.d=se,this.f=ae,this.type=d.NotEquals}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=c.get(this.c);if(typeof B=="boolean"){const se=B?"true":"false";return this.d===se?E.INSTANCE:k.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Hj=y;class N{static create(B,se=null){const ae=c.get(B);return typeof ae=="boolean"?ae?E.INSTANCE:k.INSTANCE:new N(B,se)}constructor(B,se){this.c=B,this.d=se,this.type=d.Not}cmp(B){return B.type!==this.type?this.type-B.type:ne(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=c.get(this.c);return typeof B=="boolean"?B?E.INSTANCE:k.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$Ij=N;function O(Q,B){if(typeof Q=="string"){const se=parseFloat(Q);isNaN(se)||(Q=se)}return typeof Q=="string"||typeof Q=="number"?B(Q):E.INSTANCE}class U{static create(B,se,ae=null){return O(se,ie=>new U(B,ie,ae))}constructor(B,se,ae){this.c=B,this.d=se,this.f=ae,this.type=d.Greater}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Jj=U;class j{static create(B,se,ae=null){return O(se,ie=>new j(B,ie,ae))}constructor(B,se,ae){this.c=B,this.d=se,this.f=ae,this.type=d.GreaterEquals}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Kj=j;class z{static create(B,se,ae=null){return O(se,ie=>new z(B,ie,ae))}constructor(B,se,ae){this.c=B,this.d=se,this.f=ae,this.type=d.Smaller}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Lj=z;class M{static create(B,se,ae=null){return O(se,ie=>new M(B,ie,ae))}constructor(B,se,ae){this.c=B,this.d=se,this.f=ae,this.type=d.SmallerEquals}cmp(B){return B.type!==this.type?this.type-B.type:he(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Mj=M;class F{static create(B,se){return new F(B,se)}constructor(B,se){this.d=B,this.f=se,this.type=d.Regex,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const se=this.f?this.f.source:"",ae=B.f?B.f.source:"";return se<ae?-1:se>ae?1:0}equals(B){if(B.type===this.type){const se=this.f?this.f.source:"",ae=B.f?B.f.source:"";return this.d===B.d&&se===ae}return!1}substituteConstants(){return this}evaluate(B){const se=B.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=J.create(this)),this.c}}e.$Nj=F;class J{static create(B){return new J(B)}constructor(B){this.c=B,this.type=d.NotRegex}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new J(this.c.map(B))}negate(){return this.c}}e.$Oj=J;function ee(Q){let B=null;for(let se=0,ae=Q.length;se<ae;se++){const ie=Q[se].substituteConstants();if(Q[se]!==ie&&B===null){B=[];for(let ce=0;ce<se;ce++)B[ce]=Q[ce]}B!==null&&(B[se]=ie)}return B===null?Q:B}class V{static create(B,se,ae){return V.d(B,se,ae)}constructor(B,se){this.expr=B,this.c=se,this.type=d.And}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const ie=$(this.expr[se],B.expr[se]);if(ie!==0)return ie}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(B.expr[se]))return!1;return!0}return!1}substituteConstants(){const B=ee(this.expr);return B===this.expr?this:V.create(B,this.c,!1)}evaluate(B){for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].evaluate(B))return!1;return!0}static d(B,se,ae){const ie=[];let ce=!1;for(const ue of B)if(ue){if(ue.type===d.True){ce=!0;continue}if(ue.type===d.False)return E.INSTANCE;if(ue.type===d.And){ie.push(...ue.expr);continue}ie.push(ue)}if(ie.length===0&&ce)return k.INSTANCE;if(ie.length!==0){if(ie.length===1)return ie[0];ie.sort($);for(let ue=1;ue<ie.length;ue++)ie[ue-1].equals(ie[ue])&&(ie.splice(ue,1),ue--);if(ie.length===1)return ie[0];for(;ie.length>1;){const ue=ie[ie.length-1];if(ue.type!==d.Or)break;ie.pop();const Z=ie.pop(),oe=ie.length===0,$e=H.create(ue.expr.map(be=>V.create([be,Z],null,ae)),null,oe);$e&&(ie.push($e),ie.sort($))}if(ie.length===1)return ie[0];if(ae){for(let ue=0;ue<ie.length;ue++)for(let Z=ue+1;Z<ie.length;Z++)if(ie[ue].negate().equals(ie[Z]))return E.INSTANCE;if(ie.length===1)return ie[0]}return new V(ie,se)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const se of this.expr)B.push(...se.keys());return B}map(B){return new V(this.expr.map(se=>se.map(B)),null)}negate(){if(!this.c){const B=[];for(const se of this.expr)B.push(se.negate());this.c=H.create(B,this,!0)}return this.c}}e.$Pj=V;class H{static create(B,se,ae){return H.d(B,se,ae)}constructor(B,se){this.expr=B,this.c=se,this.type=d.Or}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let se=0,ae=this.expr.length;se<ae;se++){const ie=$(this.expr[se],B.expr[se]);if(ie!==0)return ie}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let se=0,ae=this.expr.length;se<ae;se++)if(!this.expr[se].equals(B.expr[se]))return!1;return!0}return!1}substituteConstants(){const B=ee(this.expr);return B===this.expr?this:H.create(B,this.c,!1)}evaluate(B){for(let se=0,ae=this.expr.length;se<ae;se++)if(this.expr[se].evaluate(B))return!0;return!1}static d(B,se,ae){let ie=[],ce=!1;if(B){for(let ue=0,Z=B.length;ue<Z;ue++){const oe=B[ue];if(oe){if(oe.type===d.False){ce=!0;continue}if(oe.type===d.True)return k.INSTANCE;if(oe.type===d.Or){ie=ie.concat(oe.expr);continue}ie.push(oe)}}if(ie.length===0&&ce)return E.INSTANCE;ie.sort($)}if(ie.length!==0){if(ie.length===1)return ie[0];for(let ue=1;ue<ie.length;ue++)ie[ue-1].equals(ie[ue])&&(ie.splice(ue,1),ue--);if(ie.length===1)return ie[0];if(ae){for(let ue=0;ue<ie.length;ue++)for(let Z=ue+1;Z<ie.length;Z++)if(ie[ue].negate().equals(ie[Z]))return k.INSTANCE;if(ie.length===1)return ie[0]}return new H(ie,se)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const se of this.expr)B.push(...se.keys());return B}map(B){return new H(this.expr.map(se=>se.map(B)),null)}negate(){if(!this.c){const B=[];for(const se of this.expr)B.push(se.negate());for(;B.length>1;){const se=B.shift(),ae=B.shift(),ie=[];for(const ce of pe(se))for(const ue of pe(ae))ie.push(V.create([ce,ue],null,!1));B.unshift(H.create(ie,null,!1))}this.c=H.create(B,this,!0)}return this.c}}e.$Qj=H;class _ extends D{static{this.d=[]}static all(){return _.d.values()}constructor(B,se,ae){super(B,null),this.f=se,typeof ae=="object"?_.d.push({...ae,key:B}):ae!==!0&&_.d.push({key:B,description:ae,type:se!=null?typeof se:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return v.create(this.key,B)}notEqualsTo(B){return y.create(this.key,B)}}e.$Rj=_,e.$Sj=(0,L.$Ai)("contextKeyService");function ne(Q,B){return Q<B?-1:Q>B?1:0}function he(Q,B,se,ae){return Q<se?-1:Q>se?1:B<ae?-1:B>ae?1:0}function re(Q,B){if(Q.type===d.False||B.type===d.True)return!0;if(Q.type===d.Or)return B.type===d.Or?ve(Q.expr,B.expr):!1;if(B.type===d.Or){for(const se of B.expr)if(re(Q,se))return!0;return!1}if(Q.type===d.And){if(B.type===d.And)return ve(B.expr,Q.expr);for(const se of Q.expr)if(re(se,B))return!0;return!1}return Q.equals(B)}function ve(Q,B){let se=0,ae=0;for(;se<Q.length&&ae<B.length;){const ie=Q[se].cmp(B[ae]);if(ie<0)return!1;ie===0&&se++,ae++}return se===Q.length}function pe(Q){return Q.type===d.Or?Q.expr:[Q]}}),define(ye[264],Se([1,0,35,5]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=e.$pu=e.AccessibilitySupport=e.$ou=void 0,e.$qu=R,e.$ou=(0,m.$Ai)("accessibilityService");var A;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(A||(e.AccessibilitySupport=A={})),e.$pu=new r.$Rj("accessibilityModeEnabled",!1);function R(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.$ru="ACCESSIBLE_VIEW_SHOWN_"}),define(ye[113],Se([1,0,19,25,11,182,84,190,137,214,264]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=i,e.clampedFloat=l,e.stringSet=$,e.cursorStyleToString=O,e.filterValidationDecorations=De;var S;(function(le){le[le.None=0]="None",le[le.Keep=1]="Keep",le[le.Brackets=2]="Brackets",le[le.Advanced=3]="Advanced",le[le.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class d{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=d;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class b{constructor(X,Ce,Qe,_e){this.id=X,this.name=Ce,this.defaultValue=Qe,this.schema=_e}applyUpdate(X,Ce){return u(X,Ce)}compute(X,Ce,Qe){return Qe}}class a{constructor(X,Ce){this.newValue=X,this.didChange=Ce}}e.ApplyUpdateResult=a;function u(le,X){if(typeof le!="object"||typeof X!="object"||!le||!X)return new a(X,le!==X);if(Array.isArray(le)||Array.isArray(X)){const Qe=Array.isArray(le)&&Array.isArray(X)&&r.$ub(le,X);return new a(X,!Qe)}let Ce=!1;for(const Qe in X)if(X.hasOwnProperty(Qe)){const _e=u(le[Qe],X[Qe]);_e.didChange&&(le[Qe]=_e.newValue,Ce=!0)}return new a(le,Ce)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,Ce){return u(X,Ce)}validate(X){return this.defaultValue}}class g{constructor(X,Ce,Qe,_e){this.id=X,this.name=Ce,this.defaultValue=Qe,this.schema=_e}applyUpdate(X,Ce){return u(X,Ce)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,Ce,Qe){return Qe}}function n(le,X){return typeof le>"u"?X:le==="false"?!1:!!le}class s extends g{constructor(X,Ce,Qe,_e=void 0){typeof _e<"u"&&(_e.type="boolean",_e.default=Qe),super(X,Ce,Qe,_e)}validate(X){return n(X,this.defaultValue)}}function i(le,X,Ce,Qe){if(typeof le>"u")return X;let _e=parseInt(le,10);return isNaN(_e)?X:(_e=Math.max(Ce,_e),_e=Math.min(Qe,_e),_e|0)}class t extends g{static clampedInt(X,Ce,Qe,_e){return i(X,Ce,Qe,_e)}constructor(X,Ce,Qe,_e,at,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=Qe,lt.minimum=_e,lt.maximum=at),super(X,Ce,Qe,lt),this.minimum=_e,this.maximum=at}validate(X){return t.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function l(le,X,Ce,Qe){if(typeof le>"u")return X;const _e=h.float(le,X);return h.clamp(_e,Ce,Qe)}class h extends g{static clamp(X,Ce,Qe){return X<Ce?Ce:X>Qe?Qe:X}static float(X,Ce){if(typeof X=="number")return X;if(typeof X>"u")return Ce;const Qe=parseFloat(X);return isNaN(Qe)?Ce:Qe}constructor(X,Ce,Qe,_e,at){typeof at<"u"&&(at.type="number",at.default=Qe),super(X,Ce,Qe,at),this.validationFn=_e}validate(X){return this.validationFn(h.float(X,this.defaultValue))}}class o extends g{static string(X,Ce){return typeof X!="string"?Ce:X}constructor(X,Ce,Qe,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.default=Qe),super(X,Ce,Qe,_e)}validate(X){return o.string(X,this.defaultValue)}}function $(le,X,Ce,Qe){return typeof le!="string"?X:Qe&&le in Qe?Qe[le]:Ce.indexOf(le)===-1?X:le}class E extends g{constructor(X,Ce,Qe,_e,at=void 0){typeof at<"u"&&(at.type="string",at.enum=_e,at.default=Qe),super(X,Ce,Qe,at),this.c=_e}validate(X){return $(X,this.defaultValue,this.c)}}class k extends b{constructor(X,Ce,Qe,_e,at,lt,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=at,Dt.default=_e),super(X,Ce,Qe,Dt),this.c=at,this.d=lt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function D(le){switch(le){case"none":return S.None;case"keep":return S.Keep;case"brackets":return S.Brackets;case"advanced":return S.Advanced;case"full":return S.Full}}class v extends b{constructor(){super(Te.accessibilitySupport,"accessibilitySupport",C.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(X){switch(X){case"auto":return C.AccessibilitySupport.Unknown;case"off":return C.AccessibilitySupport.Disabled;case"on":return C.AccessibilitySupport.Enabled}return this.defaultValue}compute(X,Ce,Qe){return Qe===C.AccessibilitySupport.Unknown?X.accessibilitySupport:Qe}}class I extends b{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(Te.comments,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:c.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{insertSpace:n(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var w;(function(le){le[le.Hidden=0]="Hidden",le[le.Blink=1]="Blink",le[le.Smooth=2]="Smooth",le[le.Phase=3]="Phase",le[le.Expand=4]="Expand",le[le.Solid=5]="Solid"})(w||(e.TextEditorCursorBlinkingStyle=w={}));function y(le){switch(le){case"blink":return w.Blink;case"smooth":return w.Smooth;case"phase":return w.Phase;case"expand":return w.Expand;case"solid":return w.Solid}}var N;(function(le){le[le.Line=1]="Line",le[le.Block=2]="Block",le[le.Underline=3]="Underline",le[le.LineThin=4]="LineThin",le[le.BlockOutline=5]="BlockOutline",le[le.UnderlineThin=6]="UnderlineThin"})(N||(e.TextEditorCursorStyle=N={}));function O(le){switch(le){case N.Line:return"line";case N.Block:return"block";case N.Underline:return"underline";case N.LineThin:return"line-thin";case N.BlockOutline:return"block-outline";case N.UnderlineThin:return"underline-thin"}}function U(le){switch(le){case"line":return N.Line;case"block":return N.Block;case"underline":return N.Underline;case"line-thin":return N.LineThin;case"block-outline":return N.BlockOutline;case"underline-thin":return N.UnderlineThin}}class j extends f{constructor(){super(Te.editorClassName)}compute(X,Ce,Qe){const _e=["monaco-editor"];return Ce.get(Te.extraEditorClassName)&&_e.push(Ce.get(Te.extraEditorClassName)),X.extraEditorClassName&&_e.push(X.extraEditorClassName),Ce.get(Te.mouseStyle)==="default"?_e.push("mouse-default"):Ce.get(Te.mouseStyle)==="copy"&&_e.push("mouse-copy"),Ce.get(Te.showUnused)&&_e.push("showUnused"),Ce.get(Te.showDeprecated)&&_e.push("showDeprecated"),_e.join(" ")}}class z extends s{constructor(){super(Te.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(X,Ce,Qe){return Qe&&X.emptySelectionClipboard}}class M extends b{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Te.find,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:c.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:c.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{cursorMoveOnType:n(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":$(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":$(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Ce.loop,this.defaultValue.loop)}}}class F extends b{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Te.fontLigatures,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?F.OFF:X==="true"?F.ON:X:X?F.ON:F.OFF}}e.EditorFontLigatures=F;class J extends b{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Te.fontVariations,"fontVariations",J.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?J.OFF:X==="true"?J.TRANSLATE:X:X?J.TRANSLATE:J.OFF}compute(X,Ce,Qe){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=J;class ee extends f{constructor(){super(Te.fontInfo)}compute(X,Ce,Qe){return X.fontInfo}}class V extends g{constructor(){super(Te.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(X){const Ce=h.float(X,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ce,6,100)}compute(X,Ce,Qe){return X.fontInfo.fontSize}}class H extends b{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Te.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(t.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}class _ extends b{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Te.gotoLocation,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Qe,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Qe,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Qe,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Qe,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Qe,description:c.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{multiple:$(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??$(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??$(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??$(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??$(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??$(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:o.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:o.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:o.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:o.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:o.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ne extends b{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Te.hover,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:c.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:c.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:c.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{enabled:n(Ce.enabled,this.defaultValue.enabled),delay:t.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:n(Ce.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(Ce.above,this.defaultValue.above)}}}var he;(function(le){le[le.None=0]="None",le[le.Text=1]="Text",le[le.Blocks=2]="Blocks"})(he||(e.RenderMinimap=he={}));class re extends f{constructor(){super(Te.layoutInfo)}compute(X,Ce,Qe){return re.computeLayout(Ce,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const Ce=X.height/X.lineHeight,Qe=Math.floor(X.paddingTop/X.lineHeight);let _e=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(_e=Math.max(_e,Ce-1));const at=(Qe+X.viewLineCount+_e)/(X.pixelRatio*X.height),lt=Math.floor(X.viewLineCount/at);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Qe,extraLinesBeyondLastLine:_e,desiredRatio:at,minimapLineCount:lt}}static c(X,Ce){const Qe=X.outerWidth,_e=X.outerHeight,at=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:he.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(at*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const lt=Ce.stableMinimapLayoutInput,Dt=lt&&X.outerHeight===lt.outerHeight&&X.lineHeight===lt.lineHeight&&X.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&X.pixelRatio===lt.pixelRatio&&X.scrollBeyondLastLine===lt.scrollBeyondLastLine&&X.paddingTop===lt.paddingTop&&X.paddingBottom===lt.paddingBottom&&X.minimap.enabled===lt.minimap.enabled&&X.minimap.side===lt.minimap.side&&X.minimap.size===lt.minimap.size&&X.minimap.showSlider===lt.minimap.showSlider&&X.minimap.renderCharacters===lt.minimap.renderCharacters&&X.minimap.maxColumn===lt.minimap.maxColumn&&X.minimap.scale===lt.minimap.scale&&X.verticalScrollbarWidth===lt.verticalScrollbarWidth&&X.isViewportWrapping===lt.isViewportWrapping,Ct=X.lineHeight,Ot=X.typicalHalfwidthCharacterWidth,Yt=X.scrollBeyondLastLine,_t=X.minimap.renderCharacters;let xe=at>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Vt=X.minimap.maxColumn,zt=X.minimap.size,gt=X.minimap.side,$t=X.verticalScrollbarWidth,ei=X.viewLineCount,Xt=X.remainingWidth,Bt=X.isViewportWrapping,bt=_t?2:3;let Mt=Math.floor(at*_e);const Ht=Mt/at;let Wt=!1,Xe=!1,ti=bt*xe,ii=xe/at,li=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:si,extraLinesBeforeFirstLine:Ut,extraLinesBeyondLastLine:Zt,desiredRatio:oi,minimapLineCount:At}=re.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Yt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:_e,lineHeight:Ct,pixelRatio:at});if(ei/At>1)Wt=!0,Xe=!0,xe=1,ti=1,ii=xe/at;else{let pt=!1,Gt=xe+1;if(zt==="fit"){const St=Math.ceil((Ut+ei+Zt)*ti);Bt&&Dt&&Xt<=Ce.stableFitRemainingWidth?(pt=!0,Gt=Ce.stableFitMaxMinimapScale):pt=St>Mt}if(zt==="fill"||pt){Wt=!0;const St=xe;ti=Math.min(Ct*at,Math.max(1,Math.floor(1/oi))),Bt&&Dt&&Xt<=Ce.stableFitRemainingWidth&&(Gt=Ce.stableFitMaxMinimapScale),xe=Math.min(Gt,Math.max(1,Math.floor(ti/bt))),xe>St&&(li=Math.min(2,xe/St)),ii=xe/at/li,Mt=Math.ceil(Math.max(si,Ut+ei+Zt)*ti),Bt?(Ce.stableMinimapLayoutInput=X,Ce.stableFitRemainingWidth=Xt,Ce.stableFitMaxMinimapScale=xe):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const kt=Math.floor(Vt*ii),Nt=Math.min(kt,Math.max(0,Math.floor((Xt-$t-2)*ii/(Ot+ii)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(at*Nt);const Ft=Rt/at;Rt=Math.floor(Rt*li);const ui=_t?he.Text:he.Blocks,qt=gt==="left"?0:Qe-Nt-$t;return{renderMinimap:ui,minimapLeft:qt,minimapWidth:Nt,minimapHeightIsEditorHeight:Wt,minimapIsSampling:Xe,minimapScale:xe,minimapLineHeight:ti,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:Ht}}static computeLayout(X,Ce){const Qe=Ce.outerWidth|0,_e=Ce.outerHeight|0,at=Ce.lineHeight|0,lt=Ce.lineNumbersDigitCount|0,Dt=Ce.typicalHalfwidthCharacterWidth,Ct=Ce.maxDigitWidth,Ot=Ce.pixelRatio,Yt=Ce.viewLineCount,_t=X.get(Te.wordWrapOverride2),xe=_t==="inherit"?X.get(Te.wordWrapOverride1):_t,Vt=xe==="inherit"?X.get(Te.wordWrap):xe,zt=X.get(Te.wordWrapColumn),gt=Ce.isDominatedByLongLines,$t=X.get(Te.glyphMargin),ei=X.get(Te.lineNumbers).renderType!==Ne.Off,Xt=X.get(Te.lineNumbersMinChars),Bt=X.get(Te.scrollBeyondLastLine),bt=X.get(Te.padding),Mt=X.get(Te.minimap),Ht=X.get(Te.scrollbar),Wt=Ht.verticalScrollbarSize,Xe=Ht.verticalHasArrows,ti=Ht.arrowSize,ii=Ht.horizontalScrollbarSize,li=X.get(Te.folding),kt=X.get(Te.showFoldingControls)!=="never";let Nt=X.get(Te.lineDecorationsWidth);li&&kt&&(Nt+=16);let Rt=0;if(ei){const Kt=Math.max(lt,Xt);Rt=Math.round(Kt*Ct)}let Ft=0;$t&&(Ft=at*Ce.glyphMarginDecorationLaneCount);let ui=0,qt=ui+Ft,si=qt+Rt,Ut=si+Nt;const Zt=Qe-Ft-Rt-Nt;let oi=!1,At=!1,vt=-1;xe==="inherit"&&gt?(oi=!0,At=!0):Vt==="on"||Vt==="bounded"?At=!0:Vt==="wordWrapColumn"&&(vt=zt);const pt=re.c({outerWidth:Qe,outerHeight:_e,lineHeight:at,typicalHalfwidthCharacterWidth:Dt,pixelRatio:Ot,scrollBeyondLastLine:Bt,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:Mt,verticalScrollbarWidth:Wt,viewLineCount:Yt,remainingWidth:Zt,isViewportWrapping:At},Ce.memory||new P);pt.renderMinimap!==he.None&&pt.minimapLeft===0&&(ui+=pt.minimapWidth,qt+=pt.minimapWidth,si+=pt.minimapWidth,Ut+=pt.minimapWidth);const Gt=Zt-pt.minimapWidth,St=Math.max(1,Math.floor((Gt-Wt-2)/Dt)),ai=Xe?ti:0;return At&&(vt=Math.max(1,St),Vt==="bounded"&&(vt=Math.min(vt,zt))),{width:Qe,height:_e,glyphMarginLeft:ui,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:qt,lineNumbersWidth:Rt,decorationsLeft:si,decorationsWidth:Nt,contentLeft:Ut,contentWidth:Gt,minimap:pt,viewportColumn:St,isWordWrapMinified:oi,isViewportWrapping:At,wrappingColumn:vt,verticalScrollbarWidth:Wt,horizontalScrollbarHeight:ii,overviewRuler:{top:ai,width:Wt,height:_e-2*ai,right:0}}}}e.EditorLayoutInfoComputer=re;class ve extends b{constructor(){super(Te.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(47,null),c.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(49,null)}})}validate(X){return $(X,"simple",["simple","advanced"])}compute(X,Ce,Qe){return Ce.get(Te.accessibilitySupport)===C.AccessibilitySupport.Enabled?"advanced":Qe}}var pe;(function(le){le.Off="off",le.OnCode="onCode",le.On="on"})(pe||(e.ShowLightbulbIconMode=pe={}));class Q extends b{constructor(){const X={enabled:pe.On};super(Te.lightbulb,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[pe.Off,pe.OnCode,pe.On],default:X.enabled,enumDescriptions:[c.localize(50,null),c.localize(51,null),c.localize(52,null)],description:c.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:$(X.enabled,this.defaultValue.enabled,[pe.Off,pe.OnCode,pe.On])}}}class B extends b{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Te.stickyScroll,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:c.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:c.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:c.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:c.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{enabled:n(Ce.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends b{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Te.inlayHints,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:c.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(59,null),c.localize(60,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(61,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:c.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:c.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:c.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:$(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:o.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:n(Ce.padding,this.defaultValue.padding)}}}class ae extends b{constructor(){super(Te.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):t.clampedInt(X,this.defaultValue,0,1e3)}compute(X,Ce,Qe){return Qe<0?t.clampedInt(-Qe*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Qe}}class ie extends h{constructor(){super(Te.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>h.clamp(X,0,150),{markdownDescription:c.localize(66,null)})}compute(X,Ce,Qe){return X.fontInfo.lineHeight}}class ce extends b{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Te.minimap,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:c.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:c.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(69,null),c.localize(70,null),c.localize(71,null)],default:X.size,description:c.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:c.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:c.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:c.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:c.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:c.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:c.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:c.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:X.sectionHeaderLetterSpacing,description:c.localize(81,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{enabled:n(Ce.enabled,this.defaultValue.enabled),autohide:n(Ce.autohide,this.defaultValue.autohide),size:$(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(Ce.side,this.defaultValue.side,["right","left"]),showSlider:$(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(Ce.scale,1,1,3),maxColumn:t.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:h.clamp(Ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function ue(le){return le==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class Z extends b{constructor(){super(Te.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(83,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{top:t.clampedInt(Ce.top,0,0,1e3),bottom:t.clampedInt(Ce.bottom,0,0,1e3)}}}class oe extends b{constructor(){const X={enabled:!0,cycle:!0};super(Te.parameterHints,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:c.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:c.localize(85,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{enabled:n(Ce.enabled,this.defaultValue.enabled),cycle:n(Ce.cycle,this.defaultValue.cycle)}}}class $e extends f{constructor(){super(Te.pixelRatio)}compute(X,Ce,Qe){return X.pixelRatio}}class be extends b{constructor(){const X={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(86,null),c.localize(87,null),c.localize(88,null)]}];super(Te.quickSuggestions,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:X.strings,description:c.localize(89,null)},comments:{anyOf:Ce,default:X.comments,description:c.localize(90,null)},other:{anyOf:Ce,default:X.other,description:c.localize(91,null)}},default:X,markdownDescription:c.localize(92,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Ot=X?"on":"off";return{comments:Ot,strings:Ot,other:Ot}}if(!X||typeof X!="object")return this.defaultValue;const{other:Ce,comments:Qe,strings:_e}=X,at=["on","inline","off"];let lt,Dt,Ct;return typeof Ce=="boolean"?lt=Ce?"on":"off":lt=$(Ce,this.defaultValue.other,at),typeof Qe=="boolean"?Dt=Qe?"on":"off":Dt=$(Qe,this.defaultValue.comments,at),typeof _e=="boolean"?Ct=_e?"on":"off":Ct=$(_e,this.defaultValue.strings,at),{other:lt,comments:Dt,strings:Ct}}}var Ne;(function(le){le[le.Off=0]="Off",le[le.On=1]="On",le[le.Relative=2]="Relative",le[le.Interval=3]="Interval",le[le.Custom=4]="Custom"})(Ne||(e.RenderLineNumbersType=Ne={}));class Be extends b{constructor(){super(Te.lineNumbers,"lineNumbers",{renderType:Ne.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(93,null),c.localize(94,null),c.localize(95,null),c.localize(96,null)],default:"on",description:c.localize(97,null)})}validate(X){let Ce=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(Ce=Ne.Custom,Qe=X):X==="interval"?Ce=Ne.Interval:X==="relative"?Ce=Ne.Relative:X==="on"?Ce=Ne.On:Ce=Ne.Off),{renderType:Ce,renderFn:Qe}}}function De(le){const X=le.get(Te.renderValidationDecorations);return X==="editable"?le.get(Te.readOnly):X!=="on"}class Ie extends b{constructor(){const X=[],Ce={type:"number",description:c.localize(98,null)};super(Te.rulers,"rulers",X,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:c.localize(99,null),format:"color-hex"}}}]},default:X,description:c.localize(100,null)})}validate(X){if(Array.isArray(X)){const Ce=[];for(const Qe of X)if(typeof Qe=="number")Ce.push({column:t.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const _e=Qe;Ce.push({column:t.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Ce.sort((Qe,_e)=>Qe.column-_e.column),Ce}return this.defaultValue}}class Le extends b{constructor(){super(Te.readOnlyMessage,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function W(le,X){if(typeof le!="string")return X;switch(le){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class q extends b{constructor(){const X={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Te.scrollbar,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(101,null),c.localize(102,null),c.localize(103,null)],default:"auto",description:c.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(105,null),c.localize(106,null),c.localize(107,null)],default:"auto",description:c.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:c.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:c.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:c.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:c.localize(112,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X,Qe=t.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=t.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:W(Ce.vertical,this.defaultValue.vertical),horizontal:W(Ce.horizontal,this.defaultValue.horizontal),useShadows:n(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:t.clampedInt(Ce.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:t.clampedInt(Ce.verticalSliderSize,_e,0,1e3),scrollByPage:n(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Y extends b{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Te.unicodeHighlighting,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:c.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:c.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:c.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:c.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:c.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:c.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:c.localize(119,null)}})}applyUpdate(X,Ce){let Qe=!1;Ce.allowedCharacters&&X&&(m.$ao(X.allowedCharacters,Ce.allowedCharacters)||(X={...X,allowedCharacters:Ce.allowedCharacters},Qe=!0)),Ce.allowedLocales&&X&&(m.$ao(X.allowedLocales,Ce.allowedLocales)||(X={...X,allowedLocales:Ce.allowedLocales},Qe=!0));const _e=super.applyUpdate(X,Ce);return Qe?new a(_e.newValue,!0):_e}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{nonBasicASCII:qe(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:qe(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:qe(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,Ce){if(typeof X!="object"||!X)return Ce;const Qe={};for(const[_e,at]of Object.entries(X))at===!0&&(Qe[_e]=!0);return Qe}}class x extends b{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Te.inlineSuggest,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:c.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(121,null),c.localize(122,null),c.localize(123,null)],description:c.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:c.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:c.localize(126,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{enabled:n(Ce.enabled,this.defaultValue.enabled),mode:$(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:o.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class fe extends b{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Te.inlineEdit,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:c.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(128,null),c.localize(129,null),c.localize(130,null)],description:c.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:c.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:c.localize(133,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showToolbar:$(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:o.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class we extends b{constructor(){const X={enabled:T.$nu.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$nu.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Te.bracketPairColorization,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:c.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:c.localize(135,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{enabled:n(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Me extends b{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Te.guides,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:X.bracketPairs,description:c.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(140,null),c.localize(141,null),c.localize(142,null)],default:X.bracketPairsHorizontal,description:c.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:c.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:c.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(146,null),c.localize(147,null),c.localize(148,null)],default:X.highlightActiveIndentation,description:c.localize(149,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{bracketPairs:qe(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:qe(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:qe(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function qe(le,X,Ce){const Qe=Ce.indexOf(le);return Qe===-1?X:Ce[Qe]}class He extends b{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Te.suggest,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(150,null),c.localize(151,null)],default:X.insertMode,description:c.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:c.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:c.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:c.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(156,null),c.localize(157,null),c.localize(158,null),c.localize(159,null)],default:X.selectionMode,markdownDescription:c.localize(160,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:c.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:c.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:c.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:c.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:c.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(197,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{insertMode:$(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:n(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:n(Ce.preview,this.defaultValue.preview),previewMode:$(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Ce.showMethods,this.defaultValue.showMethods),showFunctions:n(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Ce.showFields,this.defaultValue.showFields),showVariables:n(Ce.showVariables,this.defaultValue.showVariables),showClasses:n(Ce.showClasses,this.defaultValue.showClasses),showStructs:n(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:n(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Ce.showModules,this.defaultValue.showModules),showProperties:n(Ce.showProperties,this.defaultValue.showProperties),showEvents:n(Ce.showEvents,this.defaultValue.showEvents),showOperators:n(Ce.showOperators,this.defaultValue.showOperators),showUnits:n(Ce.showUnits,this.defaultValue.showUnits),showValues:n(Ce.showValues,this.defaultValue.showValues),showConstants:n(Ce.showConstants,this.defaultValue.showConstants),showEnums:n(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Ce.showKeywords,this.defaultValue.showKeywords),showWords:n(Ce.showWords,this.defaultValue.showWords),showColors:n(Ce.showColors,this.defaultValue.showColors),showFiles:n(Ce.showFiles,this.defaultValue.showFiles),showReferences:n(Ce.showReferences,this.defaultValue.showReferences),showFolders:n(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:n(Ce.showUsers,this.defaultValue.showUsers),showIssues:n(Ce.showIssues,this.defaultValue.showIssues)}}}class Ze extends b{constructor(){super(Te.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(199,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(X.selectSubwords,this.defaultValue.selectSubwords)}}}class it extends b{constructor(){const X=[];super(Te.wordSegmenterLocales,"wordSegmenterLocales",X,{anyOf:[{description:c.localize(200,null),type:"string"},{description:c.localize(201,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const Ce=[];for(const Qe of X)if(typeof Qe=="string")try{Intl.Segmenter.supportedLocalesOf(Qe).length>0&&Ce.push(Qe)}catch{}return Ce}return this.defaultValue}}var tt;(function(le){le[le.None=0]="None",le[le.Same=1]="Same",le[le.Indent=2]="Indent",le[le.DeepIndent=3]="DeepIndent"})(tt||(e.WrappingIndent=tt={}));class rt extends b{constructor(){super(Te.wrappingIndent,"wrappingIndent",tt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(202,null),c.localize(203,null),c.localize(204,null),c.localize(205,null)],description:c.localize(206,null),default:"same"}})}validate(X){switch(X){case"none":return tt.None;case"same":return tt.Same;case"indent":return tt.Indent;case"deepIndent":return tt.DeepIndent}return tt.Same}compute(X,Ce,Qe){return Ce.get(Te.accessibilitySupport)===C.AccessibilitySupport.Enabled?tt.None:Qe}}class ot extends f{constructor(){super(Te.wrappingInfo)}compute(X,Ce,Qe){const _e=Ce.get(Te.layoutInfo);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}class ft extends b{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(Te.dropIntoEditor,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:c.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(209,null),c.localize(210,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showDropSelector:$(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ut extends b{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(Te.pasteAs,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:c.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(213,null),c.localize(214,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const Ce=X;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showPasteSelector:$(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?Pe:A.$k?Ue:st,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ae(le){return e.editorOptionsRegistry[le.id]=le,le}var Te;(function(le){le[le.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",le[le.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",le[le.accessibilitySupport=2]="accessibilitySupport",le[le.accessibilityPageSize=3]="accessibilityPageSize",le[le.ariaLabel=4]="ariaLabel",le[le.ariaRequired=5]="ariaRequired",le[le.autoClosingBrackets=6]="autoClosingBrackets",le[le.autoClosingComments=7]="autoClosingComments",le[le.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",le[le.autoClosingDelete=9]="autoClosingDelete",le[le.autoClosingOvertype=10]="autoClosingOvertype",le[le.autoClosingQuotes=11]="autoClosingQuotes",le[le.autoIndent=12]="autoIndent",le[le.automaticLayout=13]="automaticLayout",le[le.autoSurround=14]="autoSurround",le[le.bracketPairColorization=15]="bracketPairColorization",le[le.guides=16]="guides",le[le.codeLens=17]="codeLens",le[le.codeLensFontFamily=18]="codeLensFontFamily",le[le.codeLensFontSize=19]="codeLensFontSize",le[le.colorDecorators=20]="colorDecorators",le[le.colorDecoratorsLimit=21]="colorDecoratorsLimit",le[le.columnSelection=22]="columnSelection",le[le.comments=23]="comments",le[le.contextmenu=24]="contextmenu",le[le.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",le[le.cursorBlinking=26]="cursorBlinking",le[le.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",le[le.cursorStyle=28]="cursorStyle",le[le.cursorSurroundingLines=29]="cursorSurroundingLines",le[le.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",le[le.cursorWidth=31]="cursorWidth",le[le.disableLayerHinting=32]="disableLayerHinting",le[le.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",le[le.domReadOnly=34]="domReadOnly",le[le.dragAndDrop=35]="dragAndDrop",le[le.dropIntoEditor=36]="dropIntoEditor",le[le.emptySelectionClipboard=37]="emptySelectionClipboard",le[le.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",le[le.extraEditorClassName=39]="extraEditorClassName",le[le.fastScrollSensitivity=40]="fastScrollSensitivity",le[le.find=41]="find",le[le.fixedOverflowWidgets=42]="fixedOverflowWidgets",le[le.folding=43]="folding",le[le.foldingStrategy=44]="foldingStrategy",le[le.foldingHighlight=45]="foldingHighlight",le[le.foldingImportsByDefault=46]="foldingImportsByDefault",le[le.foldingMaximumRegions=47]="foldingMaximumRegions",le[le.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",le[le.fontFamily=49]="fontFamily",le[le.fontInfo=50]="fontInfo",le[le.fontLigatures=51]="fontLigatures",le[le.fontSize=52]="fontSize",le[le.fontWeight=53]="fontWeight",le[le.fontVariations=54]="fontVariations",le[le.formatOnPaste=55]="formatOnPaste",le[le.formatOnType=56]="formatOnType",le[le.glyphMargin=57]="glyphMargin",le[le.gotoLocation=58]="gotoLocation",le[le.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",le[le.hover=60]="hover",le[le.inDiffEditor=61]="inDiffEditor",le[le.inlineSuggest=62]="inlineSuggest",le[le.inlineEdit=63]="inlineEdit",le[le.letterSpacing=64]="letterSpacing",le[le.lightbulb=65]="lightbulb",le[le.lineDecorationsWidth=66]="lineDecorationsWidth",le[le.lineHeight=67]="lineHeight",le[le.lineNumbers=68]="lineNumbers",le[le.lineNumbersMinChars=69]="lineNumbersMinChars",le[le.linkedEditing=70]="linkedEditing",le[le.links=71]="links",le[le.matchBrackets=72]="matchBrackets",le[le.minimap=73]="minimap",le[le.mouseStyle=74]="mouseStyle",le[le.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",le[le.mouseWheelZoom=76]="mouseWheelZoom",le[le.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",le[le.multiCursorModifier=78]="multiCursorModifier",le[le.multiCursorPaste=79]="multiCursorPaste",le[le.multiCursorLimit=80]="multiCursorLimit",le[le.occurrencesHighlight=81]="occurrencesHighlight",le[le.overviewRulerBorder=82]="overviewRulerBorder",le[le.overviewRulerLanes=83]="overviewRulerLanes",le[le.padding=84]="padding",le[le.pasteAs=85]="pasteAs",le[le.parameterHints=86]="parameterHints",le[le.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",le[le.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",le[le.quickSuggestions=89]="quickSuggestions",le[le.quickSuggestionsDelay=90]="quickSuggestionsDelay",le[le.readOnly=91]="readOnly",le[le.readOnlyMessage=92]="readOnlyMessage",le[le.renameOnType=93]="renameOnType",le[le.renderControlCharacters=94]="renderControlCharacters",le[le.renderFinalNewline=95]="renderFinalNewline",le[le.renderLineHighlight=96]="renderLineHighlight",le[le.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",le[le.renderValidationDecorations=98]="renderValidationDecorations",le[le.renderWhitespace=99]="renderWhitespace",le[le.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",le[le.roundedSelection=101]="roundedSelection",le[le.rulers=102]="rulers",le[le.scrollbar=103]="scrollbar",le[le.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",le[le.scrollBeyondLastLine=105]="scrollBeyondLastLine",le[le.scrollPredominantAxis=106]="scrollPredominantAxis",le[le.selectionClipboard=107]="selectionClipboard",le[le.selectionHighlight=108]="selectionHighlight",le[le.selectOnLineNumbers=109]="selectOnLineNumbers",le[le.showFoldingControls=110]="showFoldingControls",le[le.showUnused=111]="showUnused",le[le.snippetSuggestions=112]="snippetSuggestions",le[le.smartSelect=113]="smartSelect",le[le.smoothScrolling=114]="smoothScrolling",le[le.stickyScroll=115]="stickyScroll",le[le.stickyTabStops=116]="stickyTabStops",le[le.stopRenderingLineAfter=117]="stopRenderingLineAfter",le[le.suggest=118]="suggest",le[le.suggestFontSize=119]="suggestFontSize",le[le.suggestLineHeight=120]="suggestLineHeight",le[le.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",le[le.suggestSelection=122]="suggestSelection",le[le.tabCompletion=123]="tabCompletion",le[le.tabIndex=124]="tabIndex",le[le.unicodeHighlighting=125]="unicodeHighlighting",le[le.unusualLineTerminators=126]="unusualLineTerminators",le[le.useShadowDOM=127]="useShadowDOM",le[le.useTabStops=128]="useTabStops",le[le.wordBreak=129]="wordBreak",le[le.wordSegmenterLocales=130]="wordSegmenterLocales",le[le.wordSeparators=131]="wordSeparators",le[le.wordWrap=132]="wordWrap",le[le.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",le[le.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",le[le.wordWrapColumn=135]="wordWrapColumn",le[le.wordWrapOverride1=136]="wordWrapOverride1",le[le.wordWrapOverride2=137]="wordWrapOverride2",le[le.wrappingIndent=138]="wrappingIndent",le[le.wrappingStrategy=139]="wrappingStrategy",le[le.showDeprecated=140]="showDeprecated",le[le.inlayHints=141]="inlayHints",le[le.editorClassName=142]="editorClassName",le[le.pixelRatio=143]="pixelRatio",le[le.tabFocusMode=144]="tabFocusMode",le[le.layoutInfo=145]="layoutInfo",le[le.wrappingInfo=146]="wrappingInfo",le[le.defaultColorDecorators=147]="defaultColorDecorators",le[le.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",le[le.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Te||(e.EditorOption=Te={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new s(Te.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(215,null)})),acceptSuggestionOnEnter:Ae(new E(Te.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(216,null),""],markdownDescription:c.localize(217,null)})),accessibilitySupport:Ae(new v),accessibilityPageSize:Ae(new t(Te.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(218,null),tags:["accessibility"]})),ariaLabel:Ae(new o(Te.ariaLabel,"ariaLabel",c.localize(219,null))),ariaRequired:Ae(new s(Te.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ae(new s(Te.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Ae(new E(Te.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),autoClosingComments:Ae(new E(Te.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(224,null),c.localize(225,null),""],description:c.localize(226,null)})),autoClosingDelete:Ae(new E(Te.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(227,null),""],description:c.localize(228,null)})),autoClosingOvertype:Ae(new E(Te.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(229,null),""],description:c.localize(230,null)})),autoClosingQuotes:Ae(new E(Te.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(231,null),c.localize(232,null),""],description:c.localize(233,null)})),autoIndent:Ae(new k(Te.autoIndent,"autoIndent",S.Full,"full",["none","keep","brackets","advanced","full"],D,{enumDescriptions:[c.localize(234,null),c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),automaticLayout:Ae(new s(Te.automaticLayout,"automaticLayout",!1)),autoSurround:Ae(new E(Te.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(240,null),c.localize(241,null),c.localize(242,null),""],description:c.localize(243,null)})),bracketPairColorization:Ae(new we),bracketPairGuides:Ae(new Me),stickyTabStops:Ae(new s(Te.stickyTabStops,"stickyTabStops",!1,{description:c.localize(244,null)})),codeLens:Ae(new s(Te.codeLens,"codeLens",!0,{description:c.localize(245,null)})),codeLensFontFamily:Ae(new o(Te.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(246,null)})),codeLensFontSize:Ae(new t(Te.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(247,null)})),colorDecorators:Ae(new s(Te.colorDecorators,"colorDecorators",!0,{description:c.localize(248,null)})),colorDecoratorActivatedOn:Ae(new E(Te.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(249,null),c.localize(250,null),c.localize(251,null)],description:c.localize(252,null)})),colorDecoratorsLimit:Ae(new t(Te.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(253,null)})),columnSelection:Ae(new s(Te.columnSelection,"columnSelection",!1,{description:c.localize(254,null)})),comments:Ae(new I),contextmenu:Ae(new s(Te.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new s(Te.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(255,null)})),cursorBlinking:Ae(new k(Te.cursorBlinking,"cursorBlinking",w.Blink,"blink",["blink","smooth","phase","expand","solid"],y,{description:c.localize(256,null)})),cursorSmoothCaretAnimation:Ae(new E(Te.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null)],description:c.localize(260,null)})),cursorStyle:Ae(new k(Te.cursorStyle,"cursorStyle",N.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],U,{description:c.localize(261,null)})),cursorSurroundingLines:Ae(new t(Te.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(262,null)})),cursorSurroundingLinesStyle:Ae(new E(Te.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],markdownDescription:c.localize(265,null)})),cursorWidth:Ae(new t(Te.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(266,null)})),disableLayerHinting:Ae(new s(Te.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new s(Te.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new s(Te.domReadOnly,"domReadOnly",!1)),dragAndDrop:Ae(new s(Te.dragAndDrop,"dragAndDrop",!0,{description:c.localize(267,null)})),emptySelectionClipboard:Ae(new z),dropIntoEditor:Ae(new ft),stickyScroll:Ae(new B),experimentalWhitespaceRendering:Ae(new E(Te.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(268,null),c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),extraEditorClassName:Ae(new o(Te.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Ae(new h(Te.fastScrollSensitivity,"fastScrollSensitivity",5,le=>le<=0?5:le,{markdownDescription:c.localize(272,null)})),find:Ae(new M),fixedOverflowWidgets:Ae(new s(Te.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Ae(new s(Te.folding,"folding",!0,{description:c.localize(273,null)})),foldingStrategy:Ae(new E(Te.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(274,null),c.localize(275,null)],description:c.localize(276,null)})),foldingHighlight:Ae(new s(Te.foldingHighlight,"foldingHighlight",!0,{description:c.localize(277,null)})),foldingImportsByDefault:Ae(new s(Te.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(278,null)})),foldingMaximumRegions:Ae(new t(Te.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(279,null)})),unfoldOnClickAfterEndOfLine:Ae(new s(Te.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(280,null)})),fontFamily:Ae(new o(Te.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(281,null)})),fontInfo:Ae(new ee),fontLigatures2:Ae(new F),fontSize:Ae(new V),fontWeight:Ae(new H),fontVariations:Ae(new J),formatOnPaste:Ae(new s(Te.formatOnPaste,"formatOnPaste",!1,{description:c.localize(282,null)})),formatOnType:Ae(new s(Te.formatOnType,"formatOnType",!1,{description:c.localize(283,null)})),glyphMargin:Ae(new s(Te.glyphMargin,"glyphMargin",!0,{description:c.localize(284,null)})),gotoLocation:Ae(new _),hideCursorInOverviewRuler:Ae(new s(Te.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(285,null)})),hover:Ae(new ne),inDiffEditor:Ae(new s(Te.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Ae(new h(Te.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,le=>h.clamp(le,-5,20),{description:c.localize(286,null)})),lightbulb:Ae(new Q),lineDecorationsWidth:Ae(new ae),lineHeight:Ae(new ie),lineNumbers:Ae(new Be),lineNumbersMinChars:Ae(new t(Te.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new s(Te.linkedEditing,"linkedEditing",!1,{description:c.localize(287,null)})),links:Ae(new s(Te.links,"links",!0,{description:c.localize(288,null)})),matchBrackets:Ae(new E(Te.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(289,null)})),minimap:Ae(new ce),mouseStyle:Ae(new E(Te.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new h(Te.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,le=>le===0?1:le,{markdownDescription:c.localize(290,null)})),mouseWheelZoom:Ae(new s(Te.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:A.$j?c.localize(291,null):c.localize(292,null)})),multiCursorMergeOverlapping:Ae(new s(Te.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(293,null)})),multiCursorModifier:Ae(new k(Te.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null)],markdownDescription:c.localize(296,null)})),multiCursorPaste:Ae(new E(Te.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null)],markdownDescription:c.localize(299,null)})),multiCursorLimit:Ae(new t(Te.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(300,null)})),occurrencesHighlight:Ae(new E(Te.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],markdownDescription:c.localize(304,null)})),overviewRulerBorder:Ae(new s(Te.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(305,null)})),overviewRulerLanes:Ae(new t(Te.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Ae(new Z),pasteAs:Ae(new ut),parameterHints:Ae(new oe),peekWidgetDefaultFocus:Ae(new E(Te.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),definitionLinkOpensInPeek:Ae(new s(Te.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(309,null)})),quickSuggestions:Ae(new be),quickSuggestionsDelay:Ae(new t(Te.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(310,null)})),readOnly:Ae(new s(Te.readOnly,"readOnly",!1)),readOnlyMessage:Ae(new Le),renameOnType:Ae(new s(Te.renameOnType,"renameOnType",!1,{description:c.localize(311,null),markdownDeprecationMessage:c.localize(312,null)})),renderControlCharacters:Ae(new s(Te.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(313,null),restricted:!0})),renderFinalNewline:Ae(new E(Te.renderFinalNewline,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:c.localize(314,null)})),renderLineHighlight:Ae(new E(Te.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(315,null)],description:c.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Ae(new s(Te.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(317,null)})),renderValidationDecorations:Ae(new E(Te.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new E(Te.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(318,null),c.localize(319,null),c.localize(320,null),""],description:c.localize(321,null)})),revealHorizontalRightPadding:Ae(new t(Te.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ae(new s(Te.roundedSelection,"roundedSelection",!0,{description:c.localize(322,null)})),rulers:Ae(new Ie),scrollbar:Ae(new q),scrollBeyondLastColumn:Ae(new t(Te.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(323,null)})),scrollBeyondLastLine:Ae(new s(Te.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(324,null)})),scrollPredominantAxis:Ae(new s(Te.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(325,null)})),selectionClipboard:Ae(new s(Te.selectionClipboard,"selectionClipboard",!0,{description:c.localize(326,null),included:A.$k})),selectionHighlight:Ae(new s(Te.selectionHighlight,"selectionHighlight",!0,{description:c.localize(327,null)})),selectOnLineNumbers:Ae(new s(Te.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new E(Te.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(328,null),c.localize(329,null),c.localize(330,null)],description:c.localize(331,null)})),showUnused:Ae(new s(Te.showUnused,"showUnused",!0,{description:c.localize(332,null)})),showDeprecated:Ae(new s(Te.showDeprecated,"showDeprecated",!0,{description:c.localize(333,null)})),inlayHints:Ae(new se),snippetSuggestions:Ae(new E(Te.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(334,null),c.localize(335,null),c.localize(336,null),c.localize(337,null)],description:c.localize(338,null)})),smartSelect:Ae(new Ze),smoothScrolling:Ae(new s(Te.smoothScrolling,"smoothScrolling",!1,{description:c.localize(339,null)})),stopRenderingLineAfter:Ae(new t(Te.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Ae(new He),inlineSuggest:Ae(new x),inlineEdit:Ae(new fe),inlineCompletionsAccessibilityVerbose:Ae(new s(Te.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(340,null)})),suggestFontSize:Ae(new t(Te.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ae(new t(Te.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ae(new s(Te.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(343,null)})),suggestSelection:Ae(new E(Te.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(344,null),c.localize(345,null),c.localize(346,null)],description:c.localize(347,null)})),tabCompletion:Ae(new E(Te.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(348,null),c.localize(349,null),c.localize(350,null)],description:c.localize(351,null)})),tabIndex:Ae(new t(Te.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Ae(new Y),unusualLineTerminators:Ae(new E(Te.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(352,null),c.localize(353,null),c.localize(354,null)],description:c.localize(355,null)})),useShadowDOM:Ae(new s(Te.useShadowDOM,"useShadowDOM",!0)),useTabStops:Ae(new s(Te.useTabStops,"useTabStops",!0,{description:c.localize(356,null)})),wordBreak:Ae(new E(Te.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(357,null),c.localize(358,null)],description:c.localize(359,null)})),wordSegmenterLocales:Ae(new it),wordSeparators:Ae(new o(Te.wordSeparators,"wordSeparators",p.$rt,{description:c.localize(360,null)})),wordWrap:Ae(new E(Te.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(361,null),c.localize(362,null),c.localize(363,null),c.localize(364,null)],description:c.localize(365,null)})),wordWrapBreakAfterCharacters:Ae(new o(Te.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new o(Te.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new t(Te.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(366,null)})),wordWrapOverride1:Ae(new E(Te.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new E(Te.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ae(new j),defaultColorDecorators:Ae(new s(Te.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(367,null)})),pixelRatio:Ae(new $e),tabFocusMode:Ae(new s(Te.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(368,null)})),layoutInfo:Ae(new re),wrappingInfo:Ae(new ot),wrappingIndent:Ae(new rt),wrappingStrategy:Ae(new ve)}}),define(ye[265],Se([1,0,23,43,219,5,109,11,25]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Yw=e.$Xw=e.$Ww=void 0,e.$Zw=P,e.$1w=b,e.$Ww=(0,R.$Ai)("dialogService");var c;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(c||(c={}));class C{a(u){return this.d(u,c.Confirmation)}b(u){return this.d(u,c.Prompt)}c(u){return this.d(u,c.Input)}d(u,f){const g=[];switch(f){case c.Confirmation:{const n=u;n.primaryButton?g.push(n.primaryButton):g.push((0,A.localize)(0,null)),n.cancelButton?g.push(n.cancelButton):g.push((0,A.localize)(1,null));break}case c.Prompt:{const n=u;Array.isArray(n.buttons)&&n.buttons.length>0&&g.push(...n.buttons.map(s=>s.label)),n.cancelButton&&(n.cancelButton===!0?g.push((0,A.localize)(2,null)):typeof n.cancelButton=="string"?g.push(n.cancelButton):n.cancelButton.label?g.push(n.cancelButton.label):g.push((0,A.localize)(3,null))),g.length===0&&g.push((0,A.localize)(4,null));break}case c.Input:{const n=u;n.primaryButton?g.push(n.primaryButton):g.push((0,A.localize)(5,null)),n.cancelButton?g.push(n.cancelButton):g.push((0,A.localize)(6,null));break}}return g}e(u){if(typeof u=="string")return u;if(typeof u=="number")return u===m.default.Info?"info":u===m.default.Error?"error":u===m.default.Warning?"warning":"none"}f(u,f,g){const n=[...u.buttons??[]];u.cancelButton&&typeof u.cancelButton!="string"&&typeof u.cancelButton!="boolean"&&n.push(u.cancelButton);let s=n[f]?.run({checkboxChecked:g});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:g}}}e.$Xw=C,e.$Yw=(0,R.$Ai)("fileDialogService");var S;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(S||(e.ConfirmResult=S={}));const d=10;function P(a){const u=[];return u.push(...a.slice(0,d).map(f=>typeof f=="string"?f:(0,r.$$g)(f))),a.length>d&&(a.length-d===1?u.push((0,A.localize)(7,null)):u.push((0,A.localize)(8,null,a.length-d))),u.push(""),u.join(`
`)}function b(a,u){const f=(0,p.$9n)(a);let g=(f.buttons??[]).map(t=>(0,L.$Tw)(t)),n=(a.buttons||[]).map((t,l)=>l),s=0,i=f.cancelId??g.length-1;if(g.length>1){const t=typeof i=="number"?g[i]:void 0;if(T.$k||T.$j){if(typeof t=="string"&&g.length>1&&i!==1){g.splice(i,1),g.splice(1,0,t);const l=n[i];n.splice(i,1),n.splice(1,0,l),i=1}T.$k&&g.length>1&&(g=g.reverse(),n=n.reverse(),s=g.length-1,typeof t=="string"&&(i=s-1))}else if(T.$i&&typeof t=="string"&&g.length>1&&i!==g.length-1){g.splice(i,1),g.push(t);const l=n[i];n.splice(i,1),n.push(l),i=g.length-1}}return f.buttons=g,f.defaultId=s,f.cancelId=i,f.noLink=!0,f.title=f.title||u.nameLong,{options:f,buttonIndeces:n}}}),define(ye[143],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,r.$Ai)("environmentService"),e.$Ii=(0,r.$Bi)(e.$Hi)}),define(ye[266],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j8b=e.$i8b=void 0,e.$i8b=(0,r.$Ai)("externalTerminal"),e.$j8b="Terminal.app"}),define(ye[267],Se([1,0,59,60,15,16,11,108,34,111,222,266]),function(de,e,r,m,A,R,L,T,p,c,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=e.$3dc=e.$2dc=void 0;const d=C.localize(0,null);class P{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await u.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends P{static{this.b="cmd.exe"}openTerminal(i,t){return this.spawnTerminal(r,i,c.$tm(),t)}spawnTerminal(i,t,l,h){const o=t.windowsExec||b.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const $=R.$nc(o,".exe").toLowerCase();if($==="cmder")return i.spawn(o,h?[h]:void 0),Promise.resolve(void 0);const E=["/c","start","/wait"];return o.indexOf(" ")>=0&&E.push('""'),E.push(o),$==="wt"&&E.push("-d ."),new Promise((k,D)=>{const v=f(process),I=i.spawn(l,E,{cwd:h,env:v,detached:!0});I.on("error",D),I.on("exit",()=>k())})}async runInTerminal(i,t,l,h,o){const $="windowsExec"in o&&o.windowsExec?o.windowsExec:b.getDefaultTerminalWindows(),E=await b.f();return new Promise((k,D)=>{const v=`"${t} - ${d}"`,I=`"${l.join('" "')}" & pause`,w=Object.assign({},f(process),h);Object.keys(w).filter(j=>w[j]===null).forEach(j=>delete w[j]);const y={cwd:t,env:w,windowsVerbatimArguments:!0};let N,O;R.$nc($,".exe")==="wt"?(N=$,O=["-d",".",b.b,"/c",I]):E?(N=E,O=["-d",".",$,"/c",I]):(N=b.b,O=["/c","start",v,"/wait",$,"/c",`"${I}"`]),r.spawn(N,O,y).on("error",j=>{D(g(j))}),k(void 0)})}static getDefaultTerminalWindows(){if(!b.d){const i=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${i?"Sysnative":"System32"}\\cmd.exe`}return b.d}static async f(){try{const i=await c.win32.findExecutable("wt");return await p.Promises.exists(i)?i:void 0}catch{return}}}e.$2dc=b,Je([m.$5h],b,"f",null);class a extends P{static{this.b="/usr/bin/osascript"}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,l,h,o){const $=o.osxExec||S.$j8b;return new Promise((E,k)=>{if($===S.$j8b||$==="iTerm.app"){const D=$===S.$j8b?"TerminalHelper":"iTermHelper",I=[A.$Ug.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",i||d,"-w",t];for(const N of l)I.push("-a"),I.push(N);if(h){const N=Object.assign({},f(process),h);for(const O in N){const U=N[O];U===null?(I.push("-u"),I.push(O)):(I.push("-e"),I.push(`${O}=${U}`))}}let w="";const y=r.spawn(a.b,I);y.on("error",N=>{k(g(N))}),y.stderr.on("data",N=>{w+=N.toString()}),y.on("exit",N=>{if(N===0)E(void 0);else if(w){const O=w.split(`
`,1);k(new Error(O[0]))}else k(new Error(C.localize(1,null,D,N)))})}else k(new Error(C.localize(2,null,$)))})}spawnTerminal(i,t,l){const h=t.osxExec||S.$j8b;return new Promise((o,$)=>{const E=["-a",h];l&&E.push(l);const k=f(process),D=i.spawn("/usr/bin/open",E,{cwd:l,env:k});D.on("error",$),D.on("exit",()=>o())})}}e.$3dc=a;class u extends P{static{this.b=C.localize(3,null)}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,l,h,o){const $=o.linuxExec?Promise.resolve(o.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((E,k)=>{const D=[];$.then(v=>{v.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const I=`${n(l)}; echo; read -p "${u.b}" -n1;`;D.push(`''${I}''`);const w=Object.assign({},f(process),h);Object.keys(w).filter(U=>w[U]===null).forEach(U=>delete w[U]);const y={cwd:t,env:w};let N="";const O=r.spawn(v,D,y);O.on("error",U=>{k(g(U))}),O.stderr.on("data",U=>{N+=U.toString()}),O.on("exit",U=>{if(U===0)E(void 0);else if(N){const j=N.split(`
`,1);k(new Error(j[0]))}else k(new Error(C.localize(4,null,v,U)))})})})}static async getDefaultTerminalLinuxReady(){if(!u.d)if(!L.$k)u.d=Promise.resolve("xterm");else{const i=await p.Promises.exists("/etc/debian_version");u.d=new Promise(t=>{i?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return u.d}spawnTerminal(i,t,l){const h=t.linuxExec?Promise.resolve(t.linuxExec):u.getDefaultTerminalLinuxReady();return new Promise((o,$)=>{h.then(E=>{const k=f(process),D=i.spawn(E,[],{cwd:l,env:k});D.on("error",$),D.on("exit",()=>o())})})}}e.$4dc=u;function f(s){const i={...s.env};return(0,T.$rm)(i),i}function g(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(C.localize(5,null,s.path)):s}function n(s){let i="";for(const t of s)t.indexOf(" ")>=0?i+='"'+t+'"':i+=t,i+=" ";return i}}),define(ye[28],Se([1,0,85,16,13,18,2,223,5,11,15,49]),function(de,e,r,m,A,R,L,T,p,c,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=d,e.$9k=u,e.$0k=g,e.$$k=n,e.$_k=s,e.$al=i,e.$bl=t,e.$cl=l,e.$dl=h,e.$el=o,e.$fl=$,e.$hl=D,e.$il=v,e.$jl=I,e.$kl=w,e.$ll=y,e.$ol=z,e.$Al=H,e.$Bl=_,e.$Dl=he,e.$7k=(0,p.$Ai)("fileService");function d(re){return re.create===!0}var P;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var b;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var a;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function u(re){const ve=re;return!!ve&&typeof ve.onDidChange=="function"}var f;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function g(re){return!!(re.capabilities&f.FileReadWrite)}function n(re){return!!(re.capabilities&f.FileFolderCopy)}function s(re){return!!(re.capabilities&f.FileClone)}function i(re){return!!(re.capabilities&f.FileOpenReadWriteClose)}function t(re){return!!(re.capabilities&f.FileReadStream)}function l(re){return g(re)?!!(re.capabilities&f.FileAtomicRead):!1}function h(re){return g(re)?!!(re.capabilities&f.FileAtomicWrite):!1}function o(re){return!!(re.capabilities&f.FileAtomicDelete)}function $(re){return!!(re.capabilities&f.Readonly)}var E;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class k extends Error{static create(ve,pe){const Q=new k(ve.toString(),pe);return I(Q,pe),Q}constructor(ve,pe){super(ve),this.code=pe}}e.$gl=k;function D(re,ve){return k.create(re,ve)}function v(re){return re||D((0,T.localize)(0,null),E.Unknown)}function I(re,ve){return re.name=ve?`${ve} (FileSystemError)`:"FileSystemError",re}function w(re){if(!re)return E.Unknown;if(re instanceof k)return re.code;const ve=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!ve)return E.Unknown;switch(ve[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function y(re){if(re instanceof M)return re.fileOperationResult;switch(w(re)){case E.FileNotFound:return ee.FILE_NOT_FOUND;case E.FileIsADirectory:return ee.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ee.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ee.FILE_WRITE_LOCKED;case E.NoPermissions:return ee.FILE_PERMISSION_DENIED;case E.FileExists:return ee.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ee.FILE_TOO_LARGE;default:return ee.FILE_OTHER_ERROR}}var N;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class O{constructor(ve,pe,Q){this.resource=ve,this.operation=pe,this.target=Q}isOperation(ve){return this.operation===ve}}e.$ml=O;var U;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class j{static{this.a=null}constructor(ve,pe){this.c=pe,this.b=void 0,this.d=new S.$V(()=>{const Q=r.$Gi.forUris(()=>this.c);return Q.fill(this.rawAdded.map(B=>[B,!0])),Q}),this.f=new S.$V(()=>{const Q=r.$Gi.forUris(()=>this.c);return Q.fill(this.rawUpdated.map(B=>[B,!0])),Q}),this.g=new S.$V(()=>{const Q=r.$Gi.forUris(()=>this.c);return Q.fill(this.rawDeleted.map(B=>[B,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of ve){switch(Q.type){case U.ADDED:this.rawAdded.push(Q.resource);break;case U.UPDATED:this.rawUpdated.push(Q.resource);break;case U.DELETED:this.rawDeleted.push(Q.resource);break}this.b!==j.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(ve,...pe){return this.h(ve,{includeChildren:!1},...pe)}affects(ve,...pe){return this.h(ve,{includeChildren:!0},...pe)}h(ve,pe,...Q){if(!ve)return!1;const B=Q.length>0;return!!((!B||Q.includes(U.ADDED))&&(this.d.value.get(ve)||pe.includeChildren&&this.d.value.findSuperstr(ve))||(!B||Q.includes(U.UPDATED))&&(this.f.value.get(ve)||pe.includeChildren&&this.f.value.findSuperstr(ve))||(!B||Q.includes(U.DELETED))&&(this.g.value.findSubstr(ve)||pe.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$nl=j;function z(re,ve,pe){return!re||!ve||re===ve||ve.length>re.length?!1:(ve.charAt(ve.length-1)!==m.sep&&(ve+=m.sep),pe?(0,A.$Cf)(re,ve):re.indexOf(ve)===0)}class M extends Error{constructor(ve,pe,Q){super(ve),this.fileOperationResult=pe,this.options=Q}}e.$pl=M;class F extends M{constructor(ve,pe,Q,B){super(ve,pe,B),this.fileOperationResult=pe,this.size=Q}}e.$ql=F;class J extends M{constructor(ve,pe,Q){super(ve,ee.FILE_NOT_MODIFIED_SINCE,Q),this.stat=pe}}e.$rl=J;var ee;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ee||(e.FileOperationResult=ee={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var V;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$zl="";function H(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function _(re,ve){if(!ve.hasProvider(L.URI.from({scheme:re.scheme})))return new Promise(pe=>{const Q=ve.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===re.scheme&&B.added&&(Q.dispose(),pe())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(ve){return(0,R.$eg)(ve)||(ve=0),ve<ne.KB?(0,T.localize)(1,null,ve.toFixed(0)):ve<ne.MB?(0,T.localize)(2,null,(ve/ne.KB).toFixed(2)):ve<ne.GB?(0,T.localize)(3,null,(ve/ne.MB).toFixed(2)):ve<ne.TB?(0,T.localize)(4,null,(ve/ne.GB).toFixed(2)):(0,T.localize)(5,null,(ve/ne.TB).toFixed(2))}}e.$Cl=ne;function he(re){const ve=typeof re=="string"||re?.scheme===C.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===C.Schemas.file?1024*ne.MB:ve?10*ne.MB:c.$o?50*ne.MB:1024*ne.MB}}),define(ye[268],Se([1,0,22,14,224,28]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=L;async function L(C,S,d,P,b,a){let u;try{await T(C,S,d,P,b,a)}catch(f){u=f}finally{u&&b.errorTransformer&&(u=b.errorTransformer(u)),typeof u<"u"&&d.error(u),d.end()}}async function T(C,S,d,P,b,a){p(a);const u=await C.open(S,{create:!1});try{p(a);let f=0,g=0,n=b&&typeof b.length=="number"?b.length:void 0,s=r.$Je.alloc(Math.min(b.bufferSize,typeof n=="number"?n:b.bufferSize)),i=b&&typeof b.position=="number"?b.position:0,t=0;do g=await C.read(u,i,s.buffer,t,s.byteLength-t),i+=g,t+=g,f+=g,typeof n=="number"&&(n-=g),t===s.byteLength&&(await d.write(P(s)),s=r.$Je.alloc(Math.min(b.bufferSize,typeof n=="number"?n:b.bufferSize)),t=0);while(g>0&&(typeof n!="number"||n>0)&&p(a)&&c(f,b));if(t>0){let l=t;typeof n=="number"&&(l=Math.min(t,n)),d.write(P(s.slice(0,l)))}}catch(f){throw(0,R.$il)(f)}finally{await C.close(u)}}function p(C){if(C.isCancellationRequested)throw(0,m.$6)();return!0}function c(C,S){if(typeof S?.limits?.size=="number"&&C>S.limits.size)throw(0,R.$hl)((0,A.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ye[69],Se([1,0,39,3,16,11,2,28]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=e.$Tq=void 0,e.$Rq=p,e.$Sq=c,e.$Wq=P,e.$Xq=b,e.$Yq=a,e.$Zq=u,e.$1q=g,e.$2q=n;function p(s){return typeof s.correlationId=="number"}function c(s){return s.recursive===!0}class C extends m.$Uc{static{this.a=3}static{this.b=10}constructor(i,t,l,h){super(),this.m=i,this.n=t,this.r=l,this.s=h,this.f=this.B(new m.$Vc),this.g=void 0,this.h=new Map,this.j=0}u(){const i=new m.$Tc;this.f.value=i,this.c=this.t(i),this.c.setVerboseLogging(this.r),i.add(this.c.onDidChangeFile(t=>this.m(t))),i.add(this.c.onDidLogMessage(t=>this.n(t))),i.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(i,t){if(this.s.restartOnError&&this.g?.length)if(t){const l=this.h.get(t.path)??0;l<C.a?(this.z(`restarting watcher from error in watch request (retrying request): ${i} (${JSON.stringify(t)})`),this.h.set(t.path,l+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${i} (${JSON.stringify(t)})`),this.y(this.g.filter(h=>h.path!==t.path)))}else this.j<C.b?(this.z(`restarting watcher after unknown global error: ${i}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${i}`);else this.z(i)}y(i){this.u(),this.watch(i)}async watch(i){this.g=i,await this.c?.watch(i)}async setVerboseLogging(i){this.r=i,await this.c?.setVerboseLogging(i)}z(i){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${i}`})}C(i){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${i}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Tq=C;class S extends C{constructor(i,t,l){super(i,t,l,{type:"node.js",restartOnError:!1})}}e.$Uq=S;class d extends C{constructor(i,t,l){super(i,t,l,{type:"universal",restartOnError:!0})}}e.$Vq=d;function P(s){return s.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}function b(s){const i=new f;for(const t of s)i.processEvent(t);return i.coalesce()}function a(s,i){return typeof i=="string"&&!i.startsWith(r.$qk)&&!(0,A.$ic)(i)?{base:s,pattern:i}:i}function u(s,i){const t=[];for(const l of i)t.push((0,r.$uk)(a(s,l)));return t}class f{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const t=this.b.get(this.c(i));let l=!1;if(t){const h=t.type,o=i.type;t.resource.fsPath!==i.resource.fsPath&&(i.type===T.FileChangeType.DELETED||i.type===T.FileChangeType.ADDED)?l=!0:h===T.FileChangeType.ADDED&&o===T.FileChangeType.DELETED?(this.b.delete(this.c(i)),this.a.delete(t)):h===T.FileChangeType.DELETED&&o===T.FileChangeType.ADDED?t.type=T.FileChangeType.UPDATED:h===T.FileChangeType.ADDED&&o===T.FileChangeType.UPDATED||(t.type=o)}else l=!0;l&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],t=[];return Array.from(this.a).filter(l=>l.type!==T.FileChangeType.DELETED?(i.push(l),!1):!0).sort((l,h)=>l.resource.fsPath.length-h.resource.fsPath.length).filter(l=>t.some(h=>(0,T.$ol)(l.resource.fsPath,h,!R.$k))?!1:(t.push(l.resource.fsPath),!0)).concat(i)}}function g(s,i){if(typeof i=="number")switch(s.type){case T.FileChangeType.ADDED:return(i&T.FileChangeFilter.ADDED)===0;case T.FileChangeType.DELETED:return(i&T.FileChangeFilter.DELETED)===0;case T.FileChangeType.UPDATED:return(i&T.FileChangeFilter.UPDATED)===0}return!1}function n(s){if(typeof s=="number"){const i=[];return s&T.FileChangeFilter.ADDED&&i.push("Added"),s&T.FileChangeFilter.DELETED&&i.push("Deleted"),s&T.FileChangeFilter.UPDATED&&i.push("Updated"),i.length===0?"<all>":`[${i.join(", ")}]`}return"<none>"}}),define(ye[269],Se([1,0,58,3,69,4,28,2,9]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class c extends m.$Uc{constructor(){super(),this.a=this.B(new R.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new m.$4c),this.m=new Set,this.n=5007,this.r=new p.$Xh,this.P=!1,this.B(this.f(S=>this.s(S)))}s(S){this.t(S)&&this.w(S)}t(S){return(0,A.$Rq)(S)}async watch(S){this.r.isSettled||this.r.complete(),this.r=new p.$Xh;try{this.h.clear(),this.g.clear();for(const d of S)this.t(d)?this.h.set(d.correlationId,d):this.g.add(d);for(const[d]of this.j)this.h.has(d)||(this.j.deleteAndDispose(d),this.m.delete(d));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(S=>!this.j.has(S.correlationId))])}isSuspended(S){return typeof S.correlationId!="number"?!1:this.m.has(S.correlationId)?"polling":this.j.has(S.correlationId)}async w(S){if(this.j.has(S.correlationId))return;const d=new m.$Tc;this.j.set(S.correlationId,d),await this.r.p,!d.isDisposed&&(this.z(S,d),this.u())}y(S){this.j.deleteAndDispose(S.correlationId),this.m.delete(S.correlationId),this.u()}z(S,d){this.C(S,d)?(this.N(`reusing an existing recursive watcher to monitor ${S.path}`),this.m.delete(S.correlationId)):(this.D(S,d),this.m.add(S.correlationId))}C(S,d){const P=this.M?.subscribe(S.path,(b,a)=>{d.isDisposed||(b?this.z(S,d):a?.type===L.FileChangeType.ADDED&&this.F(S))});return P?(d.add(P),!0):!1}D(S,d){let P=!1;const b=(a,u)=>{if(d.isDisposed)return;const f=this.G(a),g=this.G(u),n=P;P=f,!f&&(g||n)&&this.F(S)};this.N(`starting fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,r.watchFile)(S.path,{persistent:!1,interval:this.n},b)}catch(a){this.O(`fs.watchFile() failed with error ${a} on path ${S.path} (correlationId: ${S.correlationId})`)}d.add((0,m.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,r.unwatchFile)(S.path,b)}catch(a){this.O(`fs.unwatchFile() failed with error ${a} on path ${S.path} (correlationId: ${S.correlationId})`)}}))}F(S){this.N(`detected ${S.path} exists again, resuming watcher (correlationId: ${S.correlationId})`);const d={resource:T.URI.file(S.path),type:L.FileChangeType.ADDED,cId:S.correlationId};this.a.fire([d]),this.H(d,S),this.y(S)}G(S){return S.ctimeMs===0&&S.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(S,d){if(this.P){const P=` >> normalized ${S.type===L.FileChangeType.ADDED?"[ADDED]":S.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`;this.I(P,d)}}I(S,d){this.P&&this.N(`${S}${typeof d.correlationId=="number"?` <${d.correlationId}> `:""}`)}J(S){return`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, filter: ${(0,A.$2q)(S.filter)}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`}async setVerboseLogging(S){this.P=S}}e.$$q=c}),define(ye[270],Se([1,0,58,9,21,33,3,82,16,11,23,2,110,34,28,69]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0,e.$er=f;class u extends L.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,s,i,t,l,h){super(),this.s=n,this.t=s,this.u=i,this.w=t,this.y=l,this.z=h,this.c=this.B(new m.$Ph({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.u(o))),this.f=this.B(new m.$Oh(o=>this.M(o),u.b)),this.g=(0,a.$Zq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,a.$Zq)(this.s.path,this.s.includes):void 0,this.j=(0,a.$Rq)(this.s)?this.s.filter:void 0,this.m=new A.$se,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const s=await P.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,s.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let s=n.path;try{s=await P.Promises.realpath(n.path),n.path===s&&(s=await(0,d.$ar)(n.path,this.m.token)??n.path),n.path!==s&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${s})`)}catch{}return s}async G(n,s){const i=new L.$Tc;return this.H(n,s,i)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,s,i)),i}H(n,s,i){if(s)return!1;const t=S.URI.file(this.s.path),l=this.t?.subscribe(this.s.path,async(h,o)=>{if(!i.isDisposed)if(h){const $=await this.G(n,s);i.isDisposed?$.dispose():i.add($)}else o&&(typeof o.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:o.type,cId:this.s.correlationId},!0)});return l?(i.add(l),!0):!1}async I(n,s,i){if(c.$j&&(0,R.$zg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new A.$se(this.m.token);i.add((0,L.$Sc)(()=>t.dispose(!0)));const l=new L.$Tc;i.add(l);try{const h=S.URI.file(this.s.path),o=(0,p.$nc)(n),$=(0,r.watch)(n);l.add((0,L.$Sc)(()=>{$.removeAllListeners(),$.close()})),this.Q(`Started watching: '${n}'`);const E=new Set;if(s)try{for(const D of await P.Promises.readdir(n))E.add(D)}catch(D){this.O(D)}if(t.token.isCancellationRequested)return;const k=new Map;l.add((0,L.$Sc)(()=>{for(const[,D]of k)D.dispose();k.clear()})),$.on("error",(D,v)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${D}, ${v})`),this.D())}),$.on("change",(D,v)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${D}"] ${v}`);let I="";if(v&&(I=v.toString(),c.$j&&(I=(0,T.$gm)(I))),!(!I||D!=="change"&&D!=="rename"))if(s)if(D==="rename"){k.get(I)?.dispose();const w=setTimeout(async()=>{if(k.delete(I),I===o&&!await P.Promises.exists(n)){this.J(h);return}if(t.token.isCancellationRequested)return;const y=await this.N((0,p.$jc)(n,I));if(t.token.isCancellationRequested)return;let N;y?E.has(I)?N=b.FileChangeType.UPDATED:(N=b.FileChangeType.ADDED,E.add(I)):(E.delete(I),N=b.FileChangeType.DELETED),this.L({resource:(0,C.$bh)(h,I),type:N,cId:this.s.correlationId})},u.a);k.set(I,(0,L.$Sc)(()=>clearTimeout(w)))}else{let w;E.has(I)?w=b.FileChangeType.UPDATED:(w=b.FileChangeType.ADDED,E.add(I)),this.L({resource:(0,C.$bh)(h,I),type:w,cId:this.s.correlationId})}else if(D==="rename"||I!==o){const w=setTimeout(async()=>{const y=await P.Promises.exists(n);t.token.isCancellationRequested||(y?(this.L({resource:h,type:b.FileChangeType.UPDATED,cId:this.s.correlationId},!0),l.add(await this.G(n,!1))):this.J(h))},u.a);l.clear(),l.add((0,L.$Sc)(()=>clearTimeout(w)))}else this.L({resource:h,type:b.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(h){t.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${h.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:b.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,s=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===b.FileChangeType.ADDED?"[ADDED]":n.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!s&&this.g.some(i=>i(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!s&&this.h&&this.h.length>0&&!this.h.some(i=>i(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const s=(0,a.$Xq)(n),i=[];for(const l of s){if((0,a.$1q)(l,this.j)){this.z&&this.R(` >> ignored (filtered) ${l.resource.fsPath}`);continue}i.push(l)}if(i.length===0)return;if(this.z)for(const l of i)this.R(` >> normalized ${l.type===b.FileChangeType.ADDED?"[ADDED]":l.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(c.$k)return P.Promises.exists(n);try{const s=(0,p.$nc)(n);return(await P.Promises.readdir((0,p.$mc)(n))).some(t=>t===s)}catch(s){return this.Q(s),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$dr=u;async function f(g,n,s,i,t=512){const l=await P.Promises.open(g,"r"),h=Buffer.allocUnsafe(t),o=new A.$se(i);let $,E=!1;const k={path:g,excludes:[],recursive:!1},D=new u(k,void 0,v=>{(async()=>{for(const{type:I}of v)if(I===b.FileChangeType.UPDATED){if(E)return;E=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:w}=await P.Promises.read(l,h,0,t,null);if(!w||o.token.isCancellationRequested)break;n(h.slice(0,w))}}catch(w){$=new Error(w),o.dispose(!0)}finally{E=!1}}})()});return await D.ready,s(),new Promise((v,I)=>{o.token.onCancellationRequested(async()=>{D.dispose();try{await P.Promises.close(l)}catch(w){$=new Error(w)}$?I($):v()})})}}),define(ye[271],Se([1,0,4,39,269,11,270,33]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class p extends A.$$q{constructor(C){super(),this.M=C,this.onDidError=r.Event.None,this.watchers=new Set}async L(C){C=this.X(C);const S=[],d=new Set(Array.from(this.watchers));for(const P of C){const b=this.S(P);b&&(0,m.$yk)(b.request.excludes,P.excludes)&&(0,m.$yk)(b.request.includes,P.includes)?d.delete(b):S.push(P)}S.length&&this.N(`Request to start watching: ${S.map(P=>this.J(P)).join(",")}`),d.size&&this.N(`Request to stop watching: ${Array.from(d).map(P=>this.J(P.request)).join(",")}`);for(const P of d)this.W(P);for(const P of S)this.U(P)}S(C){for(const S of this.watchers)if(typeof C.correlationId=="number"||typeof S.request.correlationId=="number"){if(S.request.correlationId===C.correlationId)return S}else if((0,T.$yg)(S.request.path,C.path,!R.$k))return S}U(C){const S=new L.$dr(C,this.M,P=>this.a.fire(P),()=>this.c.fire(C),P=>this.b.fire(P),this.P),d={request:C,instance:S};this.watchers.add(d)}async stop(){await super.stop();for(const C of this.watchers)this.W(C)}W(C){this.N("stopping file watcher",C),this.watchers.delete(C),C.instance.dispose()}X(C){const S=new Map;for(const d of C){const P=R.$k?d.path:d.path.toLowerCase();let b=S.get(d.correlationId);b||(b=new Map,S.set(d.correlationId,b)),b.has(P)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(d)}`),b.set(P,d)}return Array.from(S.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(C){super.setVerboseLogging(C);for(const S of this.watchers)S.instance.setVerboseLogging(C)}N(C,S){this.P&&this.b.fire({type:"trace",message:this.$(C,S)})}O(C){this.b.fire({type:"warn",message:this.$(C)})}$(C,S){return S?`[File Watcher (node.js)] ${C} (${this.J(S.request)})`:`[File Watcher (node.js)] ${C}`}}e.$fr=p}),define(ye[272],Se([1,0,69,271]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class A extends r.$Uq{constructor(L,T,p){super(L,T,p),this.u()}t(L){return L.add(new m.$fr(void 0))}}e.$gr=A}),define(ye[273],Se([1,0,15,87,207,69]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class L extends R.$Vq{constructor(p,c,C){super(p,c,C),this.u()}t(p){const c=p.add(new A.$9q(r.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(c.onDidProcessExit(({code:C,signal:S})=>this.w(`terminated by itself with code ${C}, signal: ${S} (ETERM)`))),m.ProxyChannel.toService((0,m.$hi)(c.getChannel("watcher")))}}e.$0q=L}),define(ye[114],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class r{constructor(...A){this.a=new Map;for(const[R,L]of A)this.set(R,L)}set(A,R){const L=this.a.get(A);return this.a.set(A,R),L}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$yi=r}),define(ye[274],Se([1,0,9,14,3,112,263,5,114,81]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=void 0;const C=!1;class S extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class d{constructor(u=new p.$yi,f=!1,g,n=C){this.i=u,this.j=f,this.k=g,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$zi,this),this._globalGraph=n?g?._globalGraph??new L.$jr(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Pc)(this.h),this.h.clear();for(const u of this.g)(0,A.$Oc)(u)&&u.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(u,f){this.m();const g=this,n=new class extends d{dispose(){g.h.delete(n),super.dispose()}}(u,this.j,this,this.l);return this.h.add(n),f?.add(n),n}invokeFunction(u,...f){this.m();const g=b.traceInvocation(this.l,u);let n=!1;try{return u({get:i=>{if(n)throw(0,m.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(i,g);if(!t)throw new Error(`[invokeFunction] unknown service '${i}'`);return t}},...f)}finally{n=!0,g.stop()}}createInstance(u,...f){this.m();let g,n;return u instanceof R.$xi?(g=b.traceCreation(this.l,u.ctor),n=this.o(u.ctor,u.staticArguments.concat(f),g)):(g=b.traceCreation(this.l,u),n=this.o(u,f,g)),g.stop(),n}o(u,f=[],g){const n=T._util.getServiceDependencies(u).sort((t,l)=>t.index-l.index),s=[];for(const t of n){const l=this.s(t.id,g);l||this.y(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(l)}const i=n.length>0?n[0].index:f.length;if(f.length!==i){console.trace(`[createInstance] First service dependency of ${u.name} at position ${i+1} conflicts with ${f.length} static arguments`);const t=i-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,i)}return Reflect.construct(u,f.concat(s))}q(u,f){if(this.i.get(u)instanceof R.$xi)this.i.set(u,f);else if(this.k)this.k.q(u,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(u){const f=this.i.get(u);return!f&&this.k?this.k.r(u):f}s(u,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const g=this.r(u);return g instanceof R.$xi?this.u(u,g,f.branch(u,!0)):(f.branch(u,!1),g)}u(u,f,g){if(this.t.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.t.add(u);try{return this.v(u,f,g)}finally{this.t.delete(u)}}v(u,f,g){const n=new L.$jr(t=>t.id.toString());let s=0;const i=[{id:u,desc:f,_trace:g}];for(;i.length;){const t=i.pop();if(n.lookupOrInsertNode(t),s++>1e3)throw new S(n);for(const l of T._util.getServiceDependencies(t.desc.ctor)){const h=this.r(l.id);if(h||this.y(`[createInstance] ${u} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),h instanceof R.$xi){const o={id:l.id,desc:h,_trace:t._trace.branch(l.id,!0)};n.insertEdge(t,o),i.push(o)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new S(n);break}for(const{data:l}of t){if(this.r(l.id)instanceof R.$xi){const o=this.w(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.q(l.id,o)}n.removeNode(l)}}return this.r(u)}w(u,f,g=[],n,s){if(this.i.get(u)instanceof R.$xi)return this.x(u,f,g,n,s,this.g);if(this.k)return this.k.w(u,f,g,n,s);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(u,f,g=[],n,s,i){if(n){const t=new d(void 0,this.j,this,this.l);t.c=String(u);const l=new Map,h=new r.$Th(()=>{const o=t.o(f,g,s);for(const[$,E]of l){const k=o[$];if(typeof k=="function")for(const D of E)D.disposable=k.apply(o,D.listener)}return l.clear(),i.add(o),o});return new Proxy(Object.create(null),{get(o,$){if(!h.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let D=l.get($);return D||(D=new c.$5c,l.set($,D)),(I,w,y)=>{if(h.isInitialized)return h.value[$](I,w,y);{const N={listener:[I,w,y],disposable:void 0},O=D.push(N);return(0,A.$Sc)(()=>{O(),N.disposable?.dispose()})}}}if($ in o)return o[$];const E=h.value;let k=E[$];return typeof k!="function"||(k=k.bind(E),o[$]=k),k},set(o,$,E){return h.value[$]=E,!0},getPrototypeOf(o){return f.prototype}})}else{const t=this.o(f,g,s);return i.add(t),t}}y(u,f){if(f&&console.warn(u),this.j)throw new Error(u)}}e.$kr=d;var P;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(P||(P={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(P.None,null)}stop(){}branch(){return this}}}static traceInvocation(u,f){return u?new b(P.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(u,f){return u?new b(P.Creation,f.name):b.c}static{this.f=0}constructor(u,f){this.type=u,this.name=f,this.g=Date.now(),this.h=[]}branch(u,f){const g=new b(P.Branch,u.toString());return this.h.push([u,f,g]),g}stop(){const u=Date.now()-this.g;b.f+=u;let f=!1;function g(s,i){const t=[],l=new Array(s+1).join("	");for(const[h,o,$]of i.h)if(o&&$){f=!0,t.push(`${l}CREATES -> ${h}`);const E=g(s+1,$);E&&t.push(E)}else t.push(`${l}uses -> ${h}`);return t.join(`
`)}const n=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(u>2||f)&&b.all.add(n.join(`
`))}}e.$lr=b}),define(ye[12],Se([1,0,226,51,4,61,3,29,11,23,18,2,35,5]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=a,e.log=f,e.$ik=k,e.$jk=D,e.$kk=v,e.$lk=I,e.$7j=(0,P.$Ai)("logService"),e.$8j=(0,P.$Ai)("loggerService");function b(){return new Date().toISOString()}function a(w){return(0,C.$eg)(w)}var u;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(u||(e.LogLevel=u={})),e.$0j=u.Info;function f(w,y,N){switch(y){case u.Trace:w.trace(N);break;case u.Debug:w.debug(N);break;case u.Info:w.info(N);break;case u.Warning:w.warn(N);break;case u.Error:w.error(N);break;case u.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function g(w,y=!1){let N="";for(let O=0;O<w.length;O++){let U=w[O];if(U instanceof Error&&(U=(0,m.$lj)(U,y)),typeof U=="object")try{U=JSON.stringify(U)}catch{}N+=(O>0?" ":"")+U}return N}class n extends L.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new A.$he),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==u.Off&&this.b<=y}}e.$_j=n;class s extends n{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...N){this.f(u.Trace)&&this.g(u.Trace,g([y,...N],!0))}debug(y,...N){this.f(u.Debug)&&this.g(u.Debug,g([y,...N]))}info(y,...N){this.f(u.Info)&&this.g(u.Info,g([y,...N]))}warn(y,...N){this.f(u.Warning)&&this.g(u.Warning,g([y,...N]))}error(y,...N){if(this.f(u.Error))if(y instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=y.stack,this.g(u.Error,g(O))}else this.g(u.Error,g([y,...N]))}flush(){}}e.$ak=s;class i extends n{constructor(y=e.$0j){super(),this.setLevel(y),this.g=!p.$i}trace(y,...N){this.f(u.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,y,...N):console.log(`[main ${b()}]`,y,...N))}debug(y,...N){this.f(u.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,y,...N):console.log(`[main ${b()}]`,y,...N))}info(y,...N){this.f(u.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,y,...N):console.log(`[main ${b()}]`,y,...N))}warn(y,...N){this.f(u.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,y,...N):console.warn(`[main ${b()}]`,y,...N))}error(y,...N){this.f(u.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,y,...N):console.error(`[main ${b()}]`,y,...N))}flush(){}}e.$bk=i;class t extends n{constructor(y=e.$0j,N=!0){super(),this.g=N,this.setLevel(y)}trace(y,...N){this.f(u.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...N):console.log(y,...N))}debug(y,...N){this.f(u.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...N):console.log(y,...N))}info(y,...N){this.f(u.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...N):console.log(y,...N))}warn(y,...N){this.f(u.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...N):console.log(y,...N))}error(y,...N){this.f(u.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...N):console.error(y,...N))}flush(){}}e.$ck=t;class l extends n{constructor(y,N=e.$0j){super(),this.g=y,this.setLevel(N)}trace(y,...N){this.f(u.Trace)&&this.g.log(u.Trace,[this.h(y),...N])}debug(y,...N){this.f(u.Debug)&&this.g.log(u.Debug,[this.h(y),...N])}info(y,...N){this.f(u.Info)&&this.g.log(u.Info,[this.h(y),...N])}warn(y,...N){this.f(u.Warning)&&this.g.log(u.Warning,[this.h(y),...N])}error(y,...N){this.f(u.Error)&&this.g.log(u.Error,[this.h(y),...N])}h(y){return typeof y=="string"?y:(0,m.$lj)(y,this.f(u.Trace))}flush(){}}e.$dk=l;class h extends n{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const N of this.g)N.setLevel(y);super.setLevel(y)}trace(y,...N){for(const O of this.g)O.trace(y,...N)}debug(y,...N){for(const O of this.g)O.debug(y,...N)}info(y,...N){for(const O of this.g)O.info(y,...N)}warn(y,...N){for(const O of this.g)O.warn(y,...N)}error(y,...N){for(const O of this.g)O.error(y,...N)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$ek=h;class o extends L.$Uc{constructor(y,N,O){if(super(),this.h=y,this.j=N,this.b=new T.$Ac,this.c=this.B(new A.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$he),this.onDidChangeVisibility=this.g.event,O)for(const U of O)this.b.set(U.resource,{logger:void 0,info:U})}m(y){return(0,C.$ag)(y)?[...this.b.values()].find(N=>N.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,N){const O=this.n(y),U=(0,C.$ag)(y)?y:N?.id??(0,R.$oj)(O.toString()).toString(16);let j=this.b.get(O)?.logger;const z=N?.logLevel==="always"?u.Trace:N?.logLevel;j||(j=this.s(O,z??this.getLogLevel(O)??this.h,{...N,id:U}));const M={logger:j,info:{resource:O,id:U,logLevel:z,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(M.info),this.b.set(O,M),j}n(y){return(0,C.$ag)(y)?(0,c.$bh)(this.j,`${y}.log`):y}setLogLevel(y,N){if(S.URI.isUri(y)){const O=y,U=N,j=this.b.get(O);j&&U!==j.info.logLevel&&(j.info.logLevel=U===this.h?void 0:U,j.logger?.setLevel(U),this.b.set(j.info.resource,j),this.f.fire([O,U]))}else{this.h=y;for(const[O,U]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,N){const O=this.m(y);O&&N!==!O.info.hidden&&(O.info.hidden=!N,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,N]))}getLogLevel(y){let N;return y&&(N=this.b.get(y)?.info.logLevel),N??this.h}registerLogger(y){const N=this.b.get(y.resource);N?N.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const N=this.b.get(y);N&&(N.logger&&N.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=o;class ${constructor(){this.onDidChangeLogLevel=new A.$he().event}setLevel(y){}getLevel(){return u.Info}trace(y,...N){}debug(y,...N){}info(y,...N){}warn(y,...N){}error(y,...N){}critical(y,...N){}dispose(){}flush(){}}e.$gk=$;class E extends ${}e.$hk=E;function k(w){if(w.verbose)return u.Trace;if(typeof w.logLevel=="string"){const y=I(w.logLevel.toLowerCase());if(y!==void 0)return y}return e.$0j}function D(w){switch(w){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}function v(w){switch(w){case u.Trace:return{original:"Trace",value:r.localize(0,null)};case u.Debug:return{original:"Debug",value:r.localize(1,null)};case u.Info:return{original:"Info",value:r.localize(2,null)};case u.Warning:return{original:"Warning",value:r.localize(3,null)};case u.Error:return{original:"Error",value:r.localize(4,null)};case u.Off:return{original:"Off",value:r.localize(5,null)}}}function I(w){switch(w){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.$mk=new d.$Rj("logLevel",D(u.Info))}),define(ye[275],Se([1,0,19,9,14,4,33,3,16,69,12]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class S extends T.$Uc{constructor(P,b){super(),this.a=P,this.b=b,this.c=this.B(new R.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new m.$yh(0)),this.w=[],this.y=this.B(new m.$yh(0))}watch(P,b){return b.recursive||this.b?.watcher?.forceUniversal?this.n(P,b):this.z(P,b)}n(P,b){const a={path:this.J(P),excludes:b.excludes,includes:b.includes,recursive:b.recursive,filter:b.filter,correlationId:b.correlationId},u=(0,r.$Tb)(this.j,a);return this.r(),(0,T.$Sc)(()=>{u(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,A.$1)(P))}s(){this.h||(this.h=this.B(this.t(b=>this.c.fire((0,c.$Wq)(b)),b=>this.G(b),this.a.getLevel()===C.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===C.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const b of this.j)(0,c.$Sq)(b)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const b of this.j)(0,c.$Sq)(b)&&P.includes(b.path)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,b){const a={path:this.J(P),excludes:b.excludes,includes:b.includes,recursive:!1,filter:b.filter,correlationId:b.correlationId},u=(0,r.$Tb)(this.w,a);return this.C(),(0,T.$Sc)(()=>{u(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,A.$1)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,c.$Wq)(P)),P=>this.G(P),this.a.getLevel()===C.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===C.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,p.$hc)(P.fsPath)}J(P){const b=this.I(P);return(0,L.$Cg)(b)}}e.$3q=S}),define(ye[276],Se([1,0,58,412,9,29,22,4,33,3,16,11,23,103,34,225,28,268,275,51,273,272]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0,(()=>{try{(0,m.gracefulify)(r)}catch(l){console.error(`Error enabling graceful-fs: ${(0,n.$lj)(l)}`)}})();class t extends g.$3q{static{this.L=!1}constructor(h,o){super(h,o),this.onDidChangeCapabilities=T.Event.None,this.P=new R.$Ac($=>d.$5g.getComparisonKey($)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=u.FileSystemProviderCapabilities.FileReadWrite|u.FileSystemProviderCapabilities.FileOpenReadWriteClose|u.FileSystemProviderCapabilities.FileReadStream|u.FileSystemProviderCapabilities.FileFolderCopy|u.FileSystemProviderCapabilities.FileWriteUnlock|u.FileSystemProviderCapabilities.FileAtomicRead|u.FileSystemProviderCapabilities.FileAtomicWrite|u.FileSystemProviderCapabilities.FileAtomicDelete|u.FileSystemProviderCapabilities.FileClone,S.$k&&(this.M|=u.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(h){try{const{stat:o,symbolicLink:$}=await b.SymlinkSupport.stat(this.I(h));return{type:this.O(o,$),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size,permissions:o.mode&128?void 0:u.FilePermission.Locked}}catch(o){throw this.hb(o)}}async N(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const o=await b.Promises.readdir(this.I(h),{withFileTypes:!0}),$=[];return await Promise.all(o.map(async E=>{try{let k;E.isSymbolicLink()?k=(await this.stat((0,d.$bh)(h,E.name))).type:k=this.O(E),$.push([E.name,k])}catch(k){this.a.trace(k)}})),$}catch(o){throw this.hb(o)}}O(h,o){let $;return o?.dangling?$=u.FileType.Unknown:h.isFile()?$=u.FileType.File:h.isDirectory()?$=u.FileType.Directory:$=u.FileType.Unknown,o&&($|=u.FileType.SymbolicLink),$}async Q(h){const o=this.I(h);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let $;for(;$=this.P.get(h);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await $.wait();const E=new A.$zh;return this.P.set(h,E),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,c.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.P.get(h)===E&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.P.delete(h)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),E.open()})}async readFile(h,o){let $;try{o?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),$=await this.Q(h));const E=this.I(h);return await b.Promises.readFile(E)}catch(E){throw this.hb(E)}finally{$?.dispose()}}R(h){t.L&&this.a.trace(h)}readFileStream(h,o,$){const E=(0,P.$xe)(k=>L.$Je.concat(k.map(D=>L.$Je.wrap(D))).buffer);return(0,f.$Pq)(this,h,E,k=>k.buffer,{...o,bufferSize:256*1024},$),E}async writeFile(h,o,$){return $?.atomic!==!1&&$?.atomic?.postfix&&await this.S(h)?this.U(h,(0,d.$bh)((0,d.$ah)(h),`${(0,d.$$g)(h)}${$.atomic.postfix}`),o,$):this.W(h,o,$)}async S(h){try{const o=this.I(h),{symbolicLink:$}=await b.SymlinkSupport.stat(o);if($)return!1}catch{}return!0}async U(h,o,$,E){const k=new c.$Tc;try{k.add(await this.Q(h)),k.add(await this.Q(o)),await this.W(o,$,E,!0);try{await this.rename(o,h,{overwrite:!0})}catch(D){try{await this.delete(o,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{k.dispose()}}async W(h,o,$,E){let k;try{const D=this.I(h);if(!$.create||!$.overwrite){if(await b.Promises.exists(D)){if(!$.overwrite)throw(0,u.$hl)((0,a.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!$.create)throw(0,u.$hl)((0,a.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(h,{create:!0,unlock:$.unlock},E),await this.write(k,0,o,0,o.byteLength)}catch(D){throw await this.ib(h,D)}finally{typeof k=="number"&&await this.close(k)}}static{this.$=!0}static configureFlushOnWrite(h){t.$=h}async open(h,o,$){const E=this.I(h);let k;(0,u.$8k)(o)&&!$&&(k=await this.Q(h));let D;try{if((0,u.$8k)(o)&&o.unlock)try{const{stat:I}=await b.SymlinkSupport.stat(E);I.mode&128||await b.Promises.chmod(E,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let v;if((0,u.$8k)(o)){if(S.$i)try{await b.Promises.truncate(E,0),v="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}v||(v="w")}else v="r";D=await b.Promises.open(E,v)}catch(v){throw k?.dispose(),(0,u.$8k)(o)?await this.ib(h,v):this.hb(v)}if(this.X.set(D,0),(0,u.$8k)(o)&&this.Z.set(D,h),k){const v=this.Y.get(D);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${E})`),this.Y.set(D,k),v&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${E})`),v.dispose())}return D}async close(h){const o=this.Y.get(h);try{if(this.X.delete(h),this.Z.delete(h)&&t.$)try{await b.Promises.fdatasync(h)}catch($){t.configureFlushOnWrite(!1),this.a.error($)}return await b.Promises.close(h)}catch($){throw this.hb($)}finally{o&&(this.Y.get(h)===o&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.Y.delete(h)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),o.dispose())}}async read(h,o,$,E,k){const D=this.ab(h,o);let v=null;try{v=(await b.Promises.read(h,$,E,k,D)).bytesRead}catch(I){throw this.hb(I)}finally{this.bb(h,D,v)}return v}ab(h,o){return o===this.X.get(h)?null:o}bb(h,o,$){const E=this.X.get(h);typeof E=="number"&&(typeof o=="number"||(typeof $=="number"?this.X.set(h,E+$):this.X.delete(h)))}async write(h,o,$,E,k){return(0,A.$Uh)(()=>this.cb(h,o,$,E,k),100,3)}async cb(h,o,$,E,k){const D=this.ab(h,o);let v=null;try{v=(await b.Promises.write(h,$,E,k,D)).bytesWritten}catch(I){throw await this.ib(this.Z.get(h),I)}finally{this.bb(h,D,v)}return v}async mkdir(h){try{await b.Promises.mkdir(this.I(h))}catch(o){throw this.hb(o)}}async delete(h,o){try{const $=this.I(h);if(o.recursive){let E;o?.atomic!==!1&&o.atomic.postfix&&(E=(0,C.$jc)((0,C.$mc)($),`${(0,C.$nc)($)}${o.atomic.postfix}`)),await b.Promises.rm($,b.RimRafMode.MOVE,E)}else try{await b.Promises.unlink($)}catch(E){if(E.code==="EPERM"||E.code==="EISDIR"){let k=!1;try{const{stat:D,symbolicLink:v}=await b.SymlinkSupport.stat($);k=D.isDirectory()&&!v}catch{}if(k)await b.Promises.rmdir($);else throw E}else throw E}}catch($){throw this.hb($)}}async rename(h,o,$){const E=this.I(h),k=this.I(o);if(E!==k)try{await this.db(h,o,"move",$.overwrite),await b.Promises.rename(E,k)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,a.localize)(2,null,(0,C.$nc)(E),(0,C.$nc)((0,C.$mc)(k)),D.toString()))),this.hb(D)}}async copy(h,o,$){const E=this.I(h),k=this.I(o);if(E!==k)try{await this.db(h,o,"copy",$.overwrite),await b.Promises.copy(E,k,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,a.localize)(3,null,(0,C.$nc)(E),(0,C.$nc)((0,C.$mc)(k)),D.toString()))),this.hb(D)}}async db(h,o,$,E){const k=this.I(h),D=this.I(o);let v=!1;if(!!(this.capabilities&u.FileSystemProviderCapabilities.PathCaseSensitive)||(v=(0,p.$yg)(k,D,!0)),v){if($==="copy")throw(0,u.$hl)((0,a.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if($==="move")return}const w=await this.N(h);if(!w)throw(0,u.$hl)((0,a.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const y=await this.N(o);if(y){if(!E)throw(0,u.$hl)((0,a.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);w.type&u.FileType.File&&y.type&u.FileType.File||await this.delete(o,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,o){return this.eb(h,o,!1)}async eb(h,o,$){const E=this.I(h),k=this.I(o),D=!!(this.capabilities&u.FileSystemProviderCapabilities.PathCaseSensitive);if((0,p.$yg)(E,k,!D))return;const v=new c.$Tc;try{v.add(await this.Q(h)),v.add(await this.Q(o)),$&&await b.Promises.mkdir((0,C.$mc)(k),{recursive:!0}),await b.Promises.copyFile(E,k)}catch(I){if(I.code==="ENOENT"&&!$)return this.eb(h,o,!0);throw this.hb(I)}finally{v.dispose()}}t(h,o,$){return new s.$0q(E=>h(E),E=>o(E),$)}F(h,o,$){return new i.$gr(E=>h(E),E=>o(E),$)}hb(h){if(h instanceof u.$gl)return h;let o=h,$;switch(h.code){case"ENOENT":$=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":$=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":$=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":$=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":$=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":o=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,$=u.FileSystemProviderErrorCode.Unknown;break;default:$=u.FileSystemProviderErrorCode.Unknown}return(0,u.$hl)(o,$)}async ib(h,o){let $=this.hb(o);if(h&&$.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:E}=await b.SymlinkSupport.stat(this.I(h));E.mode&128||($=(0,u.$hl)(o,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(E){this.a.trace(E)}return $}}e.$hr=t}),define(ye[277],Se([1,0,3,12]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=void 0;class A extends r.$Uc{constructor(L,T=[]){super(),this.a=new m.$ek([L,...T]),this.B(L.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...T){this.a.trace(L,...T)}debug(L,...T){this.a.debug(L,...T)}info(L,...T){this.a.info(L,...T)}warn(L,...T){this.a.warn(L,...T)}error(L,...T){this.a.error(L,...T)}flush(){this.a.flush()}}e.$mQ=A}),define(ye[278],Se([1,0,28,12]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;var A;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(A||(A={}));async function R(c,C,S,d,P){try{const b=await new Promise((u,f)=>{de(["@vscode/spdlog"],u,f)});b.setFlushOn(A.Trace);const a=await b.createAsyncRotatingLogger(c,C,S,d);return P?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(b){console.error(b)}return null}function L(c,C,S){switch(C){case m.LogLevel.Trace:c.trace(S);break;case m.LogLevel.Debug:c.debug(S);break;case m.LogLevel.Info:c.info(S);break;case m.LogLevel.Warning:c.warn(S);break;case m.LogLevel.Error:c.error(S);break;case m.LogLevel.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function T(c,C){switch(C){case m.LogLevel.Trace:c.setLevel(A.Trace);break;case m.LogLevel.Debug:c.setLevel(A.Debug);break;case m.LogLevel.Info:c.setLevel(A.Info);break;case m.LogLevel.Warning:c.setLevel(A.Warning);break;case m.LogLevel.Error:c.setLevel(A.Error);break;case m.LogLevel.Off:c.setLevel(A.Off);break;default:throw new Error(`Invalid log level ${C}`)}}class p extends m.$ak{constructor(C,S,d,P,b){super(),this.m=[],this.setLevel(b),this.n=this.s(C,S,d,P),this.B(this.onDidChangeLogLevel(a=>{this.r&&T(this.r,a)}))}async s(C,S,d,P){const b=d?6:1,a=30/b*r.$Cl.MB,u=await R(C,S,a,b,P);if(u){this.r=u,T(this.r,this.getLevel());for(const{level:f,message:g}of this.m)L(this.r,f,g);this.m=[]}}g(C,S){this.r?L(this.r,C,S):this.getLevel()<=C&&this.m.push({level:C,message:S})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$bQ=p}),define(ye[144],Se([1,0,43,227,5]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(p){function c(b,a){return a-b}p.compare=c;const C=Object.create(null);C[p.Error]=(0,m.localize)(0,null),C[p.Warning]=(0,m.localize)(1,null),C[p.Info]=(0,m.localize)(2,null);function S(b){return C[b]||""}p.toString=S;function d(b){switch(b){case r.default.Error:return p.Error;case r.default.Warning:return p.Warning;case r.default.Info:return p.Info;case r.default.Ignore:return p.Hint}}p.fromSeverity=d;function P(b){switch(b){case p.Error:return r.default.Error;case p.Warning:return r.default.Warning;case p.Info:return r.default.Info;case p.Hint:return r.default.Ignore}}p.toSeverity=P}(L||(e.MarkerSeverity=L={}));var T;(function(p){const c="";function C(d){return S(d,!0)}p.makeKey=C;function S(d,P){const b=[c];return d.source?b.push(d.source.replace("\xA6","\\\xA6")):b.push(c),d.code?typeof d.code=="string"?b.push(d.code.replace("\xA6","\\\xA6")):b.push(d.code.value.replace("\xA6","\\\xA6")):b.push(c),d.severity!==void 0&&d.severity!==null?b.push(L.toString(d.severity)):b.push(c),d.message&&P?b.push(d.message.replace("\xA6","\\\xA6")):b.push(c),d.startLineNumber!==void 0&&d.startLineNumber!==null?b.push(d.startLineNumber.toString()):b.push(c),d.startColumn!==void 0&&d.startColumn!==null?b.push(d.startColumn.toString()):b.push(c),d.endLineNumber!==void 0&&d.endLineNumber!==null?b.push(d.endLineNumber.toString()):b.push(c),d.endColumn!==void 0&&d.endColumn!==null?b.push(d.endColumn.toString()):b.push(c),b.push(c),b.join("\xA6")}p.makeKeyOptionalMessage=S})(T||(e.IMarkerData=T={})),e.$Gv=(0,A.$Ai)("markerService")}),define(ye[279],Se([1,0,4,43,5]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jw=e.$iw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$gw=e.Severity=void 0,e.$hw=T,e.Severity=m.default,e.$gw=(0,A.$Ai)("notificationService");var R;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function T(S){if(S){const d=S;return typeof d.id=="string"&&typeof d.label=="string"}return!1}var p;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class c{constructor(){this.progress=new C,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(d){}updateMessage(d){}updateActions(d){}close(){}}e.$iw=c;class C{infinite(){}done(){}total(d){}worked(d){}}e.$jw=C}),define(ye[280],Se([1,0,56]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let m;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const R=A.context.configuration();if(R)m=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(m=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(m,{nameShort:`${m.nameShort} Dev`,nameLong:`${m.nameLong} Dev`,dataFolderName:`${m.dataFolderName}-dev`,serverDataFolderName:m.serverDataFolderName?`${m.serverDataFolderName}-dev`:void 0}),!m.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(m,{version:R.version})}}else m={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-toolsai.prompty":{onFileOpen:[{pathGlob:"{**/*.prompty}",important:!1}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"vmware.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},"vmware.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.1}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","attributableCoverage"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","contribIssueReporter","terminalShellIntegration"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["activeComment","codiconDecoration","codeActionRanges","commentingRangeHint","commentReactor","commentThreadApplicability","contribAccessibilityHelpContent","contribCommentEditorActionsMenu","contribCommentPeekContext","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","contribEditorContentMenu","contribMultiDiffEditorMenus","contribShareMenu","diffCommand","fileComments","quickDiffProvider","shareProvider","tabInputTextMerge","tokenInformation","treeViewMarkdownMessage"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatParticipantAdditions","defaultChatParticipant","embeddings","chatVariableResolver","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","contribSourceControlInputBoxMenu","contribCommentEditorActionsMenu","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","newSymbolNamesProvider","findFiles2","extensionsAny","authLearnMore","testObserver","aiTextSearchProvider","documentFiltersExclusive","chatParticipantPrivate"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes","contribIssueReporter","debugVisualization"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookCellExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-azuretools.vscode-azure-github-copilot":["chatParticipantAdditions","embeddings","languageModelSystem"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"TeamsDevApp.ms-teams-vscode-extension":["chatParticipantAdditions","languageModelSystem"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com","https://raw.githubusercontent.com","https://private-user-images.githubusercontent.com","https://avatars.githubusercontent.com"],trustedExtensionAuthAccess:{github:["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],"github-enterprise":["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],microsoft:["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],"microsoft-sovereign-cloud":["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"]},trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})...",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},chatWelcomeView:{welcomeViewId:"copilot.welcome",welcomeViewTitle:"GitHub Copilot",welcomeViewContent:`You have access to [GitHub Copilot](command:extension.open?%5B%22github.copilot%22%5D), an AI-powered coding assistant, as a part of the Microsoft organization.
 Getting started with Copilot is easy - simply install the Copilot extension. [Learn more](https://aka.ms/copilot-overview)
[Install GitHub Copilot](command:workbench.extensions.installExtension?%5B%22github.copilot%22%5D)`},chatParticipantRegistry:"https://az764295.vo.msecnd.net/extensions/chat.json",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.90.0",sha256:"1317dd7d1ac50641c1534a3e957ecbc94349f4fbd897acb916da11eea3208a66",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.90.1",commit:"611f9bfce64f25108829dd295f54a6894e87339d",date:"2024-06-11T20:15:20.676Z"},Object.keys(m).length===0&&Object.assign(m,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=m}),define(ye[115],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,r.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"});var Ge=this&&this.__param||function(de,e){return function(r,m){e(r,m,de)}};define(ye[90],Se([1,0,9,21,3,5]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.ProgressLocation=e.$kw=void 0,e.$kw=(0,R.$Ai)("progressService");var L;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$lw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(d){this.b=d}report(d){this.a=d,this.b(this.a)}}e.$mw=T;class p{get value(){return this.a}constructor(d){this.e=d}report(d){this.b?this.b.push(d):this.b=[d],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const d=this.b.shift();this.a=d,await this.e(this.a)}}finally{this.c=!1;const d=this.d;this.d=void 0,d?.()}}drain(){return this.c?new Promise(d=>{const P=this.d;this.d=()=>{P?.(),d()}}):Promise.resolve()}}e.$nw=p;let c=class extends A.$Uc{constructor(d,P){super(),this.a=new r.$Xh,P.withProgress(d,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,A.$Sc)(()=>this.a.complete()))}report(d){this.b?this.b.report(d):this.c=d}};e.$ow=c,e.$ow=c=Je([Ge(1,e.$kw)],c);class C extends A.$Uc{constructor(d){super(),this.g=d,this.a=0,this.b=this.B(new A.$Tc)}start(d){this.stop();const P=++this.a,b=new m.$se;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},d),this.b.add((0,A.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Sc)(()=>b.cancel())),this.b.add((0,A.$Sc)(()=>this.c?this.c.done():void 0)),{id:P,token:b.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(d){this.a===d&&this.b.clear()}}e.$pw=C,e.$qw=(0,R.$Ai)("editorProgressService")}),define(ye[36],Se([1,0,65,18]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=void 0;class A{constructor(){this.a=new Map}add(L,T){r.ok(m.$ag(L)),r.ok(m.$cg(T)),r.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,T)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$jo=new A}),define(ye[116],Se([1,0,4,36]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=void 0,e.$ko={JSONContribution:"base.contributions.json"};function A(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class R{constructor(){this.b=new r.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,c){this.a[A(p)]=c,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;m.$jo.add(e.$ko.JSONContribution,L)}),define(ye[70],Se([1,0,19,4,18,216,44,116,36]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.ConfigurationScope=e.$oo=e.EditPresentationTypes=void 0,e.$zo=a,e.$Ao=u,e.$Bo=f,e.$Co=n,e.$Do=s;var c;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$oo={Configuration:"base.contributions.configuration"};var C;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo="vscode://schemas/settings/resourceLanguage",e.$wo="vscode://schemas/settings/configurationDefaults";const S=p.$jo.as(T.$ko.JSONContribution);class d{constructor(){this.h=new Set,this.i=new m.$he,this.onDidSchemaChange=this.i.event,this.j=new m.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$vo,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const h=new Set;this.n(t,l,h),S.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:h})}deregisterConfigurations(t){const l=new Set;this.o(t,l),S.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const h=new Set;this.o(l,h),this.n(t,!1,h),S.registerSchema(e.$vo,this.g),this.i.fire(),this.j.fire({properties:h})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const h=[];for(const{overrides:o,source:$}of t)for(const E in o)if(l.add(E),e.$yo.test(E)){const k=this.a.get(E),D=k?.valuesSources??new Map;if($)for(const y of Object.keys(o[E]))D.set(y,$);const v={...k?.value||{},...o[E]};this.a.set(E,{source:$,value:v,valuesSources:D});const I=(0,L.$ej)(E),w={type:"object",default:v,description:R.localize(1,null,I),$ref:e.$vo,defaultDefaultValue:v,source:A.$ag($)?void 0:$,defaultValueSource:$};h.push(...a(E)),this.d[E]=w,this.b.properties[E]=w}else{this.a.set(E,{value:o[E],source:$});const k=this.d[E];k&&(this.w(E,k),this.r(E,k))}this.m(h)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:h,source:o}of t)for(const $ in h){const E=this.a.get($),k=A.$ag(o)?o:o?.id,D=A.$ag(E?.source)?E?.source:E?.source?.id;if(k===D)if(l.add($),this.a.delete($),e.$yo.test($))delete this.d[$],delete this.b.properties[$];else{const v=this.d[$];v&&(this.w($,v),this.r($,v))}}this.u()}deltaConfiguration(t){let l=!1;const h=new Set;t.removedDefaults&&(this.l(t.removedDefaults,h),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,h),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,h),t.addedConfigurations&&this.n(t.addedConfigurations,!1,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,h){t.forEach(o=>{this.p(o,l,o.extensionInfo,o.restrictedProperties,void 0,h),this.c.push(o),this.q(o)})}o(t,l){const h=o=>{if(o.properties)for(const $ in o.properties){l.add($);const E=this.d[$];E?.policy?.name&&this.e.delete(E.policy.name),delete this.d[$],this.s($,o.properties[$])}o.allOf?.forEach($=>h($))};for(const o of t){h(o);const $=this.c.indexOf(o);$!==-1&&this.c.splice($,1)}}p(t,l=!0,h,o,$=C.WINDOW,E){$=A.$jg(t.scope)?$:t.scope;const k=t.properties;if(k)for(const v in k){const I=k[v];if(l&&n(v,I)){delete k[v];continue}if(I.source=h,I.defaultDefaultValue=k[v].default,this.w(v,I),e.$yo.test(v)?I.scope=void 0:(I.scope=A.$jg(I.scope)?$:I.scope,I.restricted=A.$jg(I.restricted)?!!o?.includes(v):I.restricted),k[v].hasOwnProperty("included")&&!k[v].included){this.f[v]=k[v],delete k[v];continue}else this.d[v]=k[v],k[v].policy?.name&&this.e.set(k[v].policy.name,v);!k[v].deprecationMessage&&k[v].markdownDeprecationMessage&&(k[v].deprecationMessage=k[v].markdownDeprecationMessage),E.add(v)}const D=t.allOf;if(D)for(const v of D)this.p(v,l,h,o,$,E)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=h=>{const o=h.properties;if(o)for(const E in o)this.r(E,o[E]);h.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$po.properties[t]=l,l.scope){case C.APPLICATION:e.$qo.properties[t]=l;break;case C.MACHINE:e.$ro.properties[t]=l;break;case C.MACHINE_OVERRIDABLE:e.$so.properties[t]=l;break;case C.WINDOW:e.$to.properties[t]=l;break;case C.RESOURCE:e.$uo.properties[t]=l;break;case C.LANGUAGE_OVERRIDABLE:e.$uo.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$po.properties[t],l.scope){case C.APPLICATION:delete e.$qo.properties[t];break;case C.MACHINE:delete e.$ro.properties[t];break;case C.MACHINE_OVERRIDABLE:delete e.$so.properties[t];break;case C.WINDOW:delete e.$to.properties[t];break;case C.RESOURCE:case C.LANGUAGE_OVERRIDABLE:delete e.$uo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,h={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$vo};this.w(l,h),e.$po.properties[l]=h,e.$qo.properties[l]=h,e.$ro.properties[l]=h,e.$so.properties[l]=h,e.$to.properties[l]=h,e.$uo.properties[l]=h}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$vo};e.$po.patternProperties[e.$xo]=t,e.$qo.patternProperties[e.$xo]=t,e.$ro.patternProperties[e.$xo]=t,e.$so.patternProperties[e.$xo]=t,e.$to.patternProperties[e.$xo]=t,e.$uo.patternProperties[e.$xo]=t,this.i.fire()}w(t,l){const h=this.a.get(t);let o=h?.value,$=h?.source;A.$hg(o)&&(o=l.defaultDefaultValue,$=void 0),A.$hg(o)&&(o=f(l.type)),l.default=o,l.defaultValueSource=$}}const P="\\[([^\\]]+)\\]",b=new RegExp(P,"g");e.$xo=`^(${P})+$`,e.$yo=new RegExp(e.$xo);function a(i){const t=[];if(e.$yo.test(i)){let l=b.exec(i);for(;l?.length;){const h=l[1].trim();h&&t.push(h),l=b.exec(i)}}return(0,r.$Mb)(t)}function u(i){return i.reduce((t,l)=>`${t}[${l}]`,"")}function f(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new d;p.$jo.add(e.$oo.Configuration,g);function n(i,t){return i.trim()?e.$yo.test(i)?R.localize(7,null,i):g.getConfigurationProperties()[i]!==void 0?R.localize(8,null,i):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,i,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function s(){const i=[],t=g.getConfigurationProperties();for(const l of Object.keys(t))i.push([l,t[l].scope]);return i.push(["launch",C.RESOURCE]),i.push(["task",C.RESOURCE]),i}}),define(ye[281],Se([1,0,19,4,174,3,29,25,18,2,44,70,28,36]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Io=s;function b(h){return Object.isFrozen(h)?h:T.$0n(h)}class a{static createEmptyModel(o){return new a({},[],[],void 0,o)}constructor(o,$,E,k,D){this.b=o,this.c=$,this.d=E,this.raw=k,this.f=D,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const o=this.raw.map($=>{if($ instanceof a)return $;const E=new u("",this.f);return E.parseRaw($),E.configurationModel});this.g=o.reduce(($,E)=>E===$?E:$.merge(E),o[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,C.$cj)(this.contents,o):this.contents}inspect(o,$){const E=this;return{get value(){return b(E.rawConfiguration.getValue(o))},get override(){return $?b(E.rawConfiguration.getOverrideValue(o,$)):void 0},get merged(){return b($?E.rawConfiguration.override($).getValue(o):E.rawConfiguration.getValue(o))},get overrides(){const k=[];for(const{contents:D,identifiers:v,keys:I}of E.rawConfiguration.overrides){const w=new a(D,I,[],void 0,E.f).getValue(o);w!==void 0&&k.push({identifiers:v,value:w})}return k.length?b(k):void 0}}}getOverrideValue(o,$){const E=this.j($);return E?o?(0,C.$cj)(E,o):E:void 0}getKeysForOverrideIdentifier(o){const $=[];for(const E of this.overrides)E.identifiers.includes(o)&&$.push(...E.keys);return r.$Mb($)}getAllOverrideIdentifiers(){const o=[];for(const $ of this.overrides)o.push(...$.identifiers);return r.$Mb(o)}override(o){let $=this.a.get(o);return $||($=this.h(o),this.a.set(o,$)),$}merge(...o){const $=T.$9n(this.contents),E=T.$9n(this.overrides),k=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const v of o)if(D.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.i($,v.contents);for(const I of v.overrides){const[w]=E.filter(y=>r.$ub(y.identifiers,I.identifiers));w?(this.i(w.contents,I.contents),w.keys.push(...I.keys),w.keys=r.$Mb(w.keys)):E.push(T.$9n(I))}for(const I of v.keys)k.indexOf(I)===-1&&k.push(I)}return new a($,k,E,D.every(v=>v instanceof a)?void 0:D,this.f)}h(o){const $=this.j(o);if(!$||typeof $!="object"||!Object.keys($).length)return this;const E={};for(const k of r.$Mb([...Object.keys(this.contents),...Object.keys($)])){let D=this.contents[k];const v=$[k];v&&(typeof D=="object"&&typeof v=="object"?(D=T.$9n(D),this.i(D,v)):D=v),E[k]=D}return new a(E,this.keys,this.overrides,void 0,this.f)}i(o,$){for(const E of Object.keys($)){if(E in o&&p.$cg(o[E])&&p.$cg($[E])){this.i(o[E],$[E]);continue}o[E]=T.$9n($[E])}}j(o){let $=null,E=null;const k=D=>{D&&(E?this.i(E,D):E=T.$9n(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===o?$=D.contents:D.identifiers.includes(o)&&k(D.contents);return k($),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,$){this.k(o,$,!0)}setValue(o,$){this.k(o,$,!1)}removeValue(o){const $=this.keys.indexOf(o);$!==-1&&(this.keys.splice($,1),(0,C.$bj)(this.contents,o),S.$yo.test(o)&&this.overrides.splice(this.overrides.findIndex(E=>r.$ub(E.identifiers,(0,S.$zo)(o))),1))}k(o,$,E){(0,C.$aj)(this.contents,o,$,k=>this.f.error(k)),E=E||this.keys.indexOf(o)===-1,E&&this.keys.push(o),S.$yo.test(o)&&this.overrides.push({identifiers:(0,S.$zo)(o),keys:Object.keys(this.contents[o]),contents:(0,C.$_i)(this.contents[o],k=>this.f.error(k))})}}e.$Eo=a;class u{constructor(o,$){this.f=o,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||a.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,$){if(!p.$jg(o)){const E=this.h(o);this.parseRaw(E,$)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,$){this.a=o;const{contents:E,keys:k,overrides:D,restricted:v,hasExcludedProperties:I}=this.i(o,$);this.b=new a(E,k,D,I?[o]:void 0,this.g),this.c=v||[]}h(o){let $={},E=null,k=[];const D=[],v=[];function I(y){Array.isArray(k)?k.push(y):E!==null&&(k[E]=y)}const w={onObjectBegin:()=>{const y={};I(y),D.push(k),k=y,E=null},onObjectProperty:y=>{E=y},onObjectEnd:()=>{k=D.pop()},onArrayBegin:()=>{const y=[];I(y),D.push(k),k=y,E=null},onArrayEnd:()=>{k=D.pop()},onLiteralValue:I,onError:(y,N,O)=>{v.push({error:y,offset:N,length:O})}};if(o)try{A.$Wn(o,w),$=k[0]||{}}catch(y){this.g.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return $}i(o,$){const E=P.$jo.as(S.$oo.Configuration).getConfigurationProperties(),k=this.j(o,E,!0,$);o=k.raw;const D=(0,C.$_i)(o,w=>this.g.error(`Conflict in settings file ${this.f}: ${w}`)),v=Object.keys(o),I=this.l(o,w=>this.g.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:D,keys:v,overrides:I,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}j(o,$,E,k){let D=!1;if(!k?.scopes&&!k?.skipRestricted&&!k?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:D};const v={},I=[];for(const w in o)if(S.$yo.test(w)&&E){const y=this.j(o[w],$,!1,k);v[w]=y.raw,D=D||y.hasExcludedProperties,I.push(...y.restricted)}else{const y=$[w],N=y?typeof y.scope<"u"?y.scope:S.ConfigurationScope.WINDOW:void 0;y?.restricted&&I.push(w),!k.exclude?.includes(w)&&(k.include?.includes(w)||(N===void 0||k.scopes===void 0||k.scopes.includes(N))&&!(k.skipRestricted&&y?.restricted))?v[w]=o[w]:D=!0}return{raw:v,restricted:I,hasExcludedProperties:D}}l(o,$){const E=[];for(const k of Object.keys(o))if(S.$yo.test(k)){const D={};for(const v in o[k])D[v]=o[k][v];E.push({identifiers:(0,S.$zo)(k),keys:Object.keys(D),contents:(0,C.$_i)(D,$)})}return E}}e.$Fo=u;class f extends R.$Uc{constructor(o,$,E,k,D){super(),this.c=o,this.f=$,this.g=k,this.h=D,this.b=this.B(new m.$he),this.onDidChange=this.b.event,this.a=new u(this.c.toString(),D),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(m.Event.any(m.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),m.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(d.FileOperation.CREATE)||v.isOperation(d.FileOperation.COPY)||v.isOperation(d.FileOperation.DELETE)||v.isOperation(d.FileOperation.WRITE))&&E.isEqual(v.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return a.createEmptyModel(this.h)}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Go=f;class g{constructor(o,$,E,k,D,v,I,w,y,N,O,U,j){this.a=o,this.b=$,this.c=E,this.overrideIdentifiers=k,this.d=D,this.f=v,this.g=I,this.h=w,this.i=y,this.j=N,this.k=O,this.l=U,this.m=j}get value(){return b(this.c)}n(o){return o?.value!==void 0||o?.override!==void 0||o?.overrides!==void 0?o:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(o,$,E,k,D,v,I,w,y,N){this.j=o,this.l=$,this.m=E,this.n=k,this.p=D,this.q=v,this.r=I,this.s=w,this.t=y,this.u=N,this.h=null,this.i=new L.$Ac,this.v=null}getValue(o,$,E){return this.w(o,$,E).getValue(o)}updateValue(o,$,E={}){let k;E.resource?(k=this.t.get(E.resource),k||(k=a.createEmptyModel(this.u),this.t.set(E.resource,k))):k=this.s,$===void 0?k.removeValue(o):k.setValue(o,$),E.resource||(this.h=null)}inspect(o,$,E){const k=this.w(o,$,E),D=this.A($.resource,E),v=$.resource?this.t.get($.resource)||this.s:this.s,I=new Set;for(const w of k.overrides)for(const y of w.identifiers)k.getOverrideValue(o,y)!==void 0&&I.add(y);return new g(o,$,k.getValue(o),I.size?[...I]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,D||void 0,v)}keys(o){const $=this.A(void 0,o);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(o){this.j=o,this.h=null,this.i.clear()}updatePolicyConfiguration(o){this.l=o}updateApplicationConfiguration(o){this.m=o,this.h=null,this.i.clear()}updateLocalUserConfiguration(o){this.n=o,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(o){this.p=o,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(o){this.q=o,this.h=null,this.i.clear()}updateFolderConfiguration(o,$){this.r.set(o,$),this.i.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this.i.delete(o)}compareAndUpdateDefaultConfiguration(o,$){const E=[];if(!$){const{added:k,updated:D,removed:v}=t(this.j,o);$=[...k,...D,...v]}for(const k of $)for(const D of(0,S.$zo)(k)){const v=this.j.getKeysForOverrideIdentifier(D),I=o.getKeysForOverrideIdentifier(D),w=[...I.filter(y=>v.indexOf(y)===-1),...v.filter(y=>I.indexOf(y)===-1),...v.filter(y=>!T.$ao(this.j.override(D).getValue(y),o.override(D).getValue(y)))];E.push([D,w])}return this.updateDefaultConfiguration(o),{keys:$,overrides:E}}compareAndUpdatePolicyConfiguration(o){const{added:$,updated:E,removed:k}=t(this.l,o),D=[...$,...E,...k];return D.length&&this.updatePolicyConfiguration(o),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:$,updated:E,removed:k,overrides:D}=t(this.applicationConfiguration,o),v=[...$,...E,...k];return v.length&&this.updateApplicationConfiguration(o),{keys:v,overrides:D}}compareAndUpdateLocalUserConfiguration(o){const{added:$,updated:E,removed:k,overrides:D}=t(this.localUserConfiguration,o),v=[...$,...E,...k];return v.length&&this.updateLocalUserConfiguration(o),{keys:v,overrides:D}}compareAndUpdateRemoteUserConfiguration(o){const{added:$,updated:E,removed:k,overrides:D}=t(this.remoteUserConfiguration,o),v=[...$,...E,...k];return v.length&&this.updateRemoteUserConfiguration(o),{keys:v,overrides:D}}compareAndUpdateWorkspaceConfiguration(o){const{added:$,updated:E,removed:k,overrides:D}=t(this.workspaceConfiguration,o),v=[...$,...E,...k];return v.length&&this.updateWorkspaceConfiguration(o),{keys:v,overrides:D}}compareAndUpdateFolderConfiguration(o,$){const E=this.folderConfigurations.get(o),{added:k,updated:D,removed:v,overrides:I}=t(E,$),w=[...k,...D,...v];return(w.length||!E)&&this.updateFolderConfiguration(o,$),{keys:w,overrides:I}}compareAndDeleteFolderConfiguration(o){const $=this.folderConfigurations.get(o);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:E,updated:k,removed:D,overrides:v}=t($,void 0);return{keys:[...E,...k,...D],overrides:v}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(o,$,E){let k=this.x($,E);return $.overrideIdentifier&&(k=k.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(o)!==void 0&&(k=k.merge(this.l)),k}x({resource:o},$){let E=this.y();if($&&o){const k=$.getFolder(o);k&&(E=this.z(k.uri)||E);const D=this.t.get(o);D&&(E=E.merge(D))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(o){let $=this.i.get(o);if(!$){const E=this.y(),k=this.r.get(o);k?($=E.merge(k),this.i.set(o,$)):$=E}return $}A(o,$){if($&&o){const E=$.getFolder(o);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((o,$)=>{const{contents:E,overrides:k,keys:D}=this.r.get($);return o.push([$,{contents:E,overrides:k,keys:D}]),o},[])}}allKeys(){const o=new Set;return this.j.keys.forEach($=>o.add($)),this.userConfiguration.keys.forEach($=>o.add($)),this.q.keys.forEach($=>o.add($)),this.r.forEach($=>$.keys.forEach(E=>o.add(E))),[...o.values()]}B(){const o=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>o.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>o.add($)),this.q.getAllOverrideIdentifiers().forEach($=>o.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(E=>o.add(E))),[...o.values()]}D(o){const $=new Set;return this.j.getKeysForOverrideIdentifier(o).forEach(E=>$.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(E=>$.add(E)),this.q.getKeysForOverrideIdentifier(o).forEach(E=>$.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(o).forEach(k=>$.add(k))),[...$.values()]}static parse(o,$){const E=this.E(o.defaults,$),k=this.E(o.policy,$),D=this.E(o.application,$),v=this.E(o.user,$),I=this.E(o.workspace,$),w=o.folders.reduce((y,N)=>(y.set(c.URI.revive(N[0]),this.E(N[1],$)),y),new L.$Ac);return new n(E,k,D,v,a.createEmptyModel($),I,w,a.createEmptyModel($),new L.$Ac,$)}static E(o,$){return new a(o.contents,o.keys,o.overrides,void 0,$)}}e.$Ho=n;function s(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const o=new Set,$=new Map;for(const k of h)k.keys.forEach(D=>o.add(D)),k.overrides.forEach(([D,v])=>{const I=(0,L.$xc)($,D,new Set);v.forEach(w=>I.add(w))});const E=[];return $.forEach((k,D)=>E.push([D,[...k.values()]])),{keys:[...o.values()],overrides:E}}class i{constructor(o,$,E,k,D){this.change=o,this.f=$,this.g=E,this.h=k,this.i=D,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const v of o.keys)this.affectedKeys.add(v);for(const[,v]of o.overrides)for(const I of v)this.affectedKeys.add(I);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(o,$){const E=this.a+o,k=this.d.indexOf(E);if(k<0)return!1;const D=k+E.length;if(D>=this.d.length)return!1;const v=this.d.charCodeAt(D);if(v!==this.b&&v!==this.c)return!1;if($){const I=this.previousConfiguration?this.previousConfiguration.getValue(o,$,this.f?.workspace):void 0,w=this.g.getValue(o,$,this.h);return!T.$ao(I,w)}return!0}}e.$Jo=i;function t(h,o){const{added:$,removed:E,updated:k}=l(o?.rawConfiguration,h?.rawConfiguration),D=[],v=h?.getAllOverrideIdentifiers()||[],I=o?.getAllOverrideIdentifiers()||[];if(o){const w=I.filter(y=>!v.includes(y));for(const y of w)D.push([y,o.getKeysForOverrideIdentifier(y)])}if(h){const w=v.filter(y=>!I.includes(y));for(const y of w)D.push([y,h.getKeysForOverrideIdentifier(y)])}if(o&&h){for(const w of v)if(I.includes(w)){const y=l({contents:h.getOverrideValue(void 0,w)||{},keys:h.getKeysForOverrideIdentifier(w)},{contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)});D.push([w,[...y.added,...y.removed,...y.updated]])}}return{added:$,removed:E,updated:k,overrides:D}}function l(h,o){const $=h?o?h.keys.filter(D=>o.keys.indexOf(D)===-1):[...h.keys]:[],E=o?h?o.keys.filter(D=>h.keys.indexOf(D)===-1):[...o.keys]:[],k=[];if(h&&o){for(const D of o.keys)if(h.keys.indexOf(D)!==-1){const v=(0,C.$cj)(o.contents,D),I=(0,C.$cj)(h.contents,D);T.$ao(v,I)||k.push(D)}}return{added:$,removed:E,updated:k}}}),define(ye[282],Se([1,0,22,4,3,68]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mvb=e.$Kvb=e.$Jvb=void 0,e.$Lvb=T;const L=(c,C,S)=>{const d=new Uint8Array(16);for(let a=0;a<16;a++)d[a]=Math.round(Math.random()*256);const P=(0,r.$4e)(r.$Je.wrap(d));return[`GET ws://localhost${c}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$Jvb=L,e.$Kvb=r.$Je.fromString(`\r
\r
`);async function T(c,C,S,d,P){c.write(r.$Je.fromString((0,e.$Jvb)(C,S,d)));const b=new A.$Tc;try{return await new Promise((a,u)=>{let f;b.add(c.onData(g=>{f?f=r.$Je.concat([f,g],f.byteLength+g.byteLength):f=g;const n=f.indexOf(e.$Kvb);if(n===-1)return;a(c),c.pauseData();const s=f.slice(n+e.$Kvb.byteLength);s.byteLength&&P.onData.fire(s)})),b.add(c.onClose(g=>u(g??new Error("socket closed")))),b.add(c.onEnd(()=>u(new Error("socket ended"))))})}catch(a){throw c.dispose(),a}finally{b.dispose()}}class p extends A.$Uc{constructor(C,S){super(),this.g=C,this.a=this.B(new m.$ke),this.onData=(...d)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...d)),this.b=this.B(new m.$he),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event(d=>this.a.fire(d))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,S){R.SocketDiagnostics.traceSocketEvent(this,this.g,C,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Mvb=p}),define(ye[71],Se([1,0,14,5]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=c,e.$Ll=(0,m.$Ai)("remoteAuthorityResolverService");var A;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class R{constructor(S){this.id=S,this.type=A.Managed}toString(){return`Managed(${this.id})`}}e.$Ml=R;class L{constructor(S,d){this.host=S,this.port=d,this.type=A.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=L;var T;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class p extends r.$bb{static isNotAvailable(S){return S instanceof p&&S._code===T.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof p&&S._code===T.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof p&&S._code===T.NoResolverFound}static isInvalidAuthority(S){return S instanceof p&&S._code===T.InvalidAuthority}static isHandled(S){return S instanceof p&&S.isHandled}constructor(S,d=T.Unknown,P){super(S),this._message=S,this._code=d,this._detail=P,this.isHandled=d===T.NotAvailable&&P===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Ol=p;function c(C){const S=C.indexOf("+");return S===-1?C:C.substring(0,S)}}),define(ye[283],Se([1,0,9,22,21,14,4,3,15,62,42,32,68,71]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ul=D,e.$Vl=v,e.$Wl=w;const b=30*1e3;var a;(function(pe){pe[pe.Management=1]="Management",pe[pe.ExtensionHost=2]="ExtensionHost",pe[pe.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function u(pe){switch(pe){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function f(pe){const Q=new A.$se;return setTimeout(()=>Q.cancel(),pe),Q.token}function g(pe,Q){if(pe.isCancellationRequested||Q.isCancellationRequested)return A.CancellationToken.Cancelled;const B=new A.$se;return pe.onCancellationRequested(()=>B.cancel()),Q.onCancellationRequested(()=>B.cancel()),B.token}class n{get didTimeout(){return this.c==="timedout"}constructor(Q){this.c="pending",this.d=new T.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$th)(),Q.isCancellationRequested?this.h():this.d.add(Q.onCancellationRequested(()=>this.h()))}registerDisposable(Q){this.c==="pending"?this.d.add(Q):Q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Q))}reject(Q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Q))}}function s(pe,Q){const B=new n(Q);return B.registerDisposable(pe.onControlMessage(se=>{const ae=JSON.parse(se.toString()),ie=H(ae);ie?B.reject(ie):B.resolve(ae)})),B.promise}function i(pe,Q,B,se,ae,ie,ce,ue){const Z=new n(ue),oe=C.$be.create(!1);return pe.info(`Creating a socket (${ce})...`),c.mark(`code/willCreateSocket/${ie}`),Q.connect(B,se,ae,ce).then($e=>{Z.didTimeout?(c.mark(`code/didCreateSocketError/${ie}`),pe.info(`Creating a socket (${ce}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(c.mark(`code/didCreateSocketOK/${ie}`),pe.info(`Creating a socket (${ce}) was successful after ${oe.elapsed()} ms.`),Z.resolve($e))},$e=>{c.mark(`code/didCreateSocketError/${ie}`),pe.info(`Creating a socket (${ce}) returned an error after ${oe.elapsed()} ms.`),pe.error($e),Z.reject($e)}),Z.promise}function t(pe,Q){const B=new n(Q);return pe.then(se=>{B.didTimeout||B.resolve(se)},se=>{B.didTimeout||B.reject(se)}),B.promise}async function l(pe,Q,B,se){const ae=re(pe,Q);pe.logService.trace(`${ae} 1/6. invoking socketFactory.connect().`);let ie;try{ie=await i(pe.logService,pe.remoteSocketFactoryService,pe.connectTo,p.$Ng.getServerRootPath(),`reconnectionToken=${pe.reconnectionToken}&reconnection=${pe.reconnectionProtocol?"true":"false"}`,u(Q),`renderer-${u(Q)}-${pe.reconnectionToken}`,se)}catch($e){throw pe.logService.error(`${ae} socketFactory.connect() failed or timed out. Error:`),pe.logService.error($e),$e}pe.logService.trace(`${ae} 2/6. socketFactory.connect() was successful.`);let ce,ue;pe.reconnectionProtocol?(pe.reconnectionProtocol.beginAcceptReconnection(ie,null),ce=pe.reconnectionProtocol,ue=!1):(ce=new d.$oi({socket:ie}),ue=!0),pe.logService.trace(`${ae} 3/6. sending AuthRequest control message.`);const Z=await t(pe.signService.createNewMessage((0,S.$Wg)()),se),oe={type:"auth",auth:pe.connectionToken||"00000000000000000000",data:Z.data};ce.sendControl(m.$Je.fromString(JSON.stringify(oe)));try{const $e=await s(ce,g(se,f(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(pe.logService.trace(`${ae} 4/6. received SignRequest control message.`),!await t(pe.signService.validate(Z,$e.signedData),se)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Ne=await t(pe.signService.sign($e.data),se),Be={type:"connectionType",commit:pe.commit,signedData:Ne,desiredConnectionType:Q};return B&&(Be.args=B),pe.logService.trace(`${ae} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(m.$Je.fromString(JSON.stringify(Be))),{protocol:ce,ownsProtocol:ue}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(pe.logService.error(`${ae} the handshake timed out. Error:`),pe.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(pe.logService.error(`${ae} received error control message when negotiating connection. Error:`),pe.logService.error($e)),ue&&V(ce),$e}}async function h(pe,Q,B,se){const ae=Date.now(),ie=re(pe,Q),{protocol:ce,ownsProtocol:ue}=await l(pe,Q,B,se),Z=new n(se);return Z.registerDisposable(ce.onControlMessage(oe=>{const $e=JSON.parse(oe.toString()),be=H($e);be?(pe.logService.error(`${ie} received error control message when negotiating connection. Error:`),pe.logService.error(be),ue&&V(ce),Z.reject(be)):(pe.reconnectionProtocol?.endAcceptReconnection(),pe.logService.trace(`${ie} 6/6. handshake finished, connection is up and running after ${ve(ae)}!`),Z.resolve({protocol:ce,firstMessage:$e}))})),Z.promise}async function o(pe,Q){const{protocol:B}=await h(pe,a.Management,void 0,Q);return{protocol:B}}async function $(pe,Q,B){const{protocol:se,firstMessage:ae}=await h(pe,a.ExtensionHost,Q,B),ie=ae&&ae.debugPort;return{protocol:se,debugPort:ie}}async function E(pe,Q,B){const se=Date.now(),ae=re(pe,a.Tunnel),{protocol:ie}=await l(pe,a.Tunnel,Q,B);return pe.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${ve(se)}!`),ie}async function k(pe,Q,B){const{connectTo:se,connectionToken:ae}=await pe.addressProvider.getAddress();return{commit:pe.commit,quality:pe.quality,connectTo:se,connectionToken:ae,reconnectionToken:Q,reconnectionProtocol:B,remoteSocketFactoryService:pe.remoteSocketFactoryService,signService:pe.signService,logService:pe.logService}}async function D(pe,Q,B){return I(pe,async se=>{const{protocol:ae}=await o(se,A.CancellationToken.None);return new J(pe,Q,B,se.reconnectionToken,ae)})}async function v(pe,Q){return I(pe,async B=>{const{protocol:se,debugPort:ae}=await $(B,Q,A.CancellationToken.None);return new ee(pe,Q,B.reconnectionToken,se,ae)})}async function I(pe,Q){for(let se=1;;se++)try{const ae=(0,S.$Wg)(),ie=await k(pe,ae,null);return await Q(ie)}catch(ae){if(se<5)pe.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),pe.logService.error(ae);else throw pe.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),pe.logService.error(ae),F.triggerPermanentFailure(0,0,P.$Ol.isHandled(ae)),ae}}async function w(pe,Q,B){const se=await k(pe,(0,S.$Wg)(),null);return await E(se,{host:Q,port:B},A.CancellationToken.None)}function y(pe){return(0,r.$nh)(Q=>new Promise((B,se)=>{const ae=setTimeout(B,pe*1e3);Q.onCancellationRequested(()=>{clearTimeout(ae),B()})}))}var N;(function(pe){pe[pe.ConnectionLost=0]="ConnectionLost",pe[pe.ReconnectionWait=1]="ReconnectionWait",pe[pe.ReconnectionRunning=2]="ReconnectionRunning",pe[pe.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",pe[pe.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class O{constructor(Q,B){this.reconnectionToken=Q,this.millisSinceLastIncomingData=B,this.type=N.ConnectionLost}}e.$Xl=O;class U{constructor(Q,B,se,ae){this.reconnectionToken=Q,this.millisSinceLastIncomingData=B,this.durationSeconds=se,this.c=ae,this.type=N.ReconnectionWait}skipWait(){this.c.cancel()}}e.$Yl=U;class j{constructor(Q,B,se){this.reconnectionToken=Q,this.millisSinceLastIncomingData=B,this.attempt=se,this.type=N.ReconnectionRunning}}e.$Zl=j;class z{constructor(Q,B,se){this.reconnectionToken=Q,this.millisSinceLastIncomingData=B,this.attempt=se,this.type=N.ConnectionGain}}e.$1l=z;class M{constructor(Q,B,se,ae){this.reconnectionToken=Q,this.millisSinceLastIncomingData=B,this.attempt=se,this.handled=ae,this.type=N.ReconnectionPermanentFailure}}e.$2l=M;class F extends T.$Uc{static triggerPermanentFailure(Q,B,se){this._permanentFailure=!0,this.f=Q,this.g=B,this.h=se,this.j.forEach(ae=>ae.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(Q=>Q.y())}static debugPauseSocketWriting(){this.j.forEach(Q=>Q.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||F._permanentFailure}constructor(Q,B,se,ae,ie){super(),this.t=Q,this.u=B,this.reconnectionToken=se,this.protocol=ae,this.w=ie,this.m=this.B(new L.$he),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(ae.onSocketClose(ce=>{const ue=he(this.t,this.reconnectionToken,!0);ce?ce.type===d.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${ue} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this.u.logService.error(ce.error)):(this.u.logService.info(`${ue} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this.u.logService.error(ce.event)):this.u.logService.info(`${ue} received socket close event.`),this.y()})),this.B(ae.onSocketTimeout(ce=>{const ue=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ue} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this.y()})),F.j.push(this),this.B((0,T.$Sc)(()=>{const ce=F.j.indexOf(this);ce>=0&&F.j.splice(ce,1)})),this.n&&this.D(F.f,F.g,F.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const Q=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const ae=se<B.length?B[se]:B[B.length-1];try{if(ae>0){const ce=y(ae);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ae,ce)),this.u.logService.info(`${Q} waiting for ${ae} seconds before reconnecting...`);try{await ce}catch{}}if(this.n){this.u.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${Q} resolving connection...`);const ie=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${Q} connecting to ${ie.connectTo}...`),await this.G(ie,f(b)),this.u.logService.info(`${Q} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(ie){if(ie.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(P.$Ol.isTemporarilyNotAvailable(ie)){this.u.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((ie.code==="ETIMEDOUT"||ie.code==="ENETUNREACH"||ie.code==="ECONNREFUSED"||ie.code==="ECONNRESET")&&ie.syscall==="connect"){this.u.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if((0,R.$4)(ie)){this.u.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ie);continue}if(ie instanceof P.$Ol){this.u.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,P.$Ol.isHandled(ie));break}this.u.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ie),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(Q,B,se){this.w?F.triggerPermanentFailure(Q,B,se):this.D(Q,B,se)}D(Q,B,se){this.m.fire(new M(this.reconnectionToken,Q,B,se)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$3l=F;class J extends F{constructor(Q,B,se,ae,ie){super(a.Management,Q,ae,ie,!0),this.client=this.B(new d.$mi(ie,{remoteAuthority:B,clientId:se},Q.ipcLogger))}async G(Q,B){await o(Q,B)}}e.$4l=J;class ee extends F{constructor(Q,B,se,ae,ie){super(a.ExtensionHost,Q,se,ae,!1),this.H=B,this.debugPort=ie}async G(Q,B){await $(Q,this.H,B)}}e.$5l=ee;function V(pe){try{pe.acceptDisconnect();const Q=pe.getSocket();pe.dispose(),Q.dispose()}catch(Q){(0,R.$1)(Q)}}function H(pe){if(pe&&pe.type==="error"){const Q=new Error(`Connection error: ${pe.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function _(pe,Q){for(;pe.length<Q;)pe+=" ";return pe}function ne(pe,Q){return`[remote-connection][${_(u(pe),13)}][${Q.substr(0,5)}\u2026]`}function he(pe,Q,B){return`${ne(pe,Q)}[${B?"reconnect":"initial"}]`}function re(pe,Q){return`${he(Q,pe.reconnectionToken,!!pe.reconnectionProtocol)}[${pe.connectTo}]`}function ve(pe){return`${Date.now()-pe} ms`}}),define(ye[91],Se([1,0,15]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=m,e.$Nm=A,e.$Om=R,e.$Pm=L;function m(p){return p.scheme===r.Schemas.vscodeRemote?p.authority:void 0}function A(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function R(p){const{host:c,port:C}=T(p);if(typeof C>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:C}}function L(p,c){let{host:C,port:S}=T(p);return typeof S>"u"&&(S=c),{host:C,port:S}}function T(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const C=p.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const S=p.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:p,port:void 0}}}),define(ye[24],Se([1,0,13,5,91]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$Ym=e.$Xm=e.$Wm=e.TargetPlatform=e.ExtensionType=e.$Vm=e.$Tm=e.$Sm=e.$Rm=e.$Qm=void 0,e.$Um=R,e.$Zm=S,e.$1m=d,e.$2m=P,e.$3m=b,e.$Qm="extensions.user.cache",e.$Rm="extensions.builtin.cache",e.$Sm="undefined_publisher",e.$Tm=["ui","workspace","web"];function R(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$Vm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var L;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(L||(e.ExtensionType=L={}));var T;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class p{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,f){if(typeof u>"u"||u===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof u=="string"||typeof f=="string"){const g=typeof u=="string"?u:u.value,n=typeof f=="string"?f:f.value;return r.$Bf(g,n)}return u._lower===f._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$Wm=p;class c{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const f of u)this.add(f)}add(u){this.c.add(p.toKey(u))}delete(u){return this.c.delete(p.toKey(u))}has(u){return this.c.has(p.toKey(u))}}e.$Xm=c;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(p.toKey(u))}get(u){return this.c.get(p.toKey(u))}has(u){return this.c.has(p.toKey(u))}set(u,f){this.c.set(p.toKey(u),f)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Ym=C;function S(a){return d(a)}function d(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function P(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function b(a,u){if(u){const f=`onResolveRemoteAuthority:${(0,A.$Nm)(u)}`;return!!a.activationEvents?.includes(f)}return!1}e.$4m=(0,m.$Ai)("IBuiltinExtensionsScannerService")}),define(ye[145],Se([1,0,11,220,24,5]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.ExtensionManagementErrorCode=e.$cp=e.ExtensionGalleryErrorCode=e.$bp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0,e.$8o=T,e.$9o=p,e.$0o=c,e.$$o=C,e.$_o=S,e.$ap=d,e.$1o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$2o=new RegExp(e.$1o),e.$3o="__web_extension",e.$4o="skipWalkthrough",e.$5o="extensionInstallSource",e.$6o="dependecyOrPackExtensionInstall",e.$7o="clientTargetPlatform";var L;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function T(i){switch(i){case A.TargetPlatform.WIN32_X64:return"Windows 64 bit";case A.TargetPlatform.WIN32_ARM64:return"Windows ARM";case A.TargetPlatform.LINUX_X64:return"Linux 64 bit";case A.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case A.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case A.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case A.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case A.TargetPlatform.DARWIN_X64:return"Mac";case A.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case A.TargetPlatform.WEB:return"Web";case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;case A.TargetPlatform.UNKNOWN:return A.TargetPlatform.UNKNOWN;case A.TargetPlatform.UNDEFINED:return A.TargetPlatform.UNDEFINED}}function p(i){switch(i){case A.TargetPlatform.WIN32_X64:return A.TargetPlatform.WIN32_X64;case A.TargetPlatform.WIN32_ARM64:return A.TargetPlatform.WIN32_ARM64;case A.TargetPlatform.LINUX_X64:return A.TargetPlatform.LINUX_X64;case A.TargetPlatform.LINUX_ARM64:return A.TargetPlatform.LINUX_ARM64;case A.TargetPlatform.LINUX_ARMHF:return A.TargetPlatform.LINUX_ARMHF;case A.TargetPlatform.ALPINE_X64:return A.TargetPlatform.ALPINE_X64;case A.TargetPlatform.ALPINE_ARM64:return A.TargetPlatform.ALPINE_ARM64;case A.TargetPlatform.DARWIN_X64:return A.TargetPlatform.DARWIN_X64;case A.TargetPlatform.DARWIN_ARM64:return A.TargetPlatform.DARWIN_ARM64;case A.TargetPlatform.WEB:return A.TargetPlatform.WEB;case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;default:return A.TargetPlatform.UNKNOWN}}function c(i,t){switch(i){case r.Platform.Windows:return t==="x64"?A.TargetPlatform.WIN32_X64:t==="arm64"?A.TargetPlatform.WIN32_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Linux:return t==="x64"?A.TargetPlatform.LINUX_X64:t==="arm64"?A.TargetPlatform.LINUX_ARM64:t==="arm"?A.TargetPlatform.LINUX_ARMHF:A.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?A.TargetPlatform.ALPINE_X64:t==="arm64"?A.TargetPlatform.ALPINE_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Mac:return t==="x64"?A.TargetPlatform.DARWIN_X64:t==="arm64"?A.TargetPlatform.DARWIN_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Web:return A.TargetPlatform.WEB}}function C(i,t){return t===A.TargetPlatform.WEB&&!i.includes(A.TargetPlatform.WEB)}function S(i,t,l){return C(t,l)?!1:i===A.TargetPlatform.UNDEFINED||i===A.TargetPlatform.UNIVERSAL?!0:i===A.TargetPlatform.UNKNOWN?!1:i===l}function d(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var P;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var b;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var a;(function(i){i.Install="install",i.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var u;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(u||(e.InstallOperation=u={})),e.$bp=(0,R.$Ai)("extensionGalleryService");var f;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class g extends Error{constructor(t,l){super(t),this.code=l,this.name=l}}e.$cp=g;var n;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class s extends Error{constructor(t,l){super(t),this.code=l,this.name=l}}e.$dp=s,e.$ep=(0,R.$Ai)("extensionManagementService"),e.$fp="extensionsIdentifiers/disabled",e.$gp="extensionsIdentifiers/enabled",e.$hp=(0,R.$Ai)("IGlobalExtensionEnablementService"),e.$ip=(0,R.$Ai)("IExtensionTipsService"),e.$jp=(0,m.localize2)(0,"Extensions"),e.$kp=(0,m.localize2)(1,"Preferences")}),define(ye[146],Se([1,0,14,24]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zG=e.$yG=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(L,T){this.a.set(L,T)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const T=Object.create(null);for(const p of L){const c=this.readActivationEvents(p);c.length>0&&(T[m.$Wm.toKey(p.identifier)]=c)}return T}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const T=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let p=0;p<T.length;p++)T[p]==="onUri"&&(T[p]=`onUri:${m.$Wm.toKey(L.identifier)}`);if(!L.contributes)return T;for(const p in L.contributes){const c=this.a.get(p);if(!c)continue;const C=L.contributes[p],S=Array.isArray(C)?C:[C];try{c(S,T)}catch(d){(0,r.$1)(d)}}return T}}e.$yG=A,e.$zG=new A}),define(ye[284],Se([1,0,3,5]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql=(0,m.$Ai)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(L,T){return this.a[L]??=[],this.a[L].push(T),(0,r.$Sc)(()=>{const p=this.a[L]?.indexOf(T);typeof p=="number"&&p>=0&&this.a[L]?.splice(p,1)})}b(L){return(this.a[L.type]||[]).find(p=>p.supports(L))}connect(L,T,p,c){const C=this.b(L);if(!C)throw new Error(`No socket factory found for ${L}`);return C.connect(L,T,p,c)}}e.$Rl=A}),define(ye[285],Se([1,0,22,14,3,228,70,5,12,36]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Xp=d,e.$Yp=P,e.$Zp=b,e.$1p=a,e.$2p=u,e.$3p=f,e.$Vp=(0,T.$Ai)("requestService");class C{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?i[t]="*****":i[t]=this.b[t];this.a=i}return this.a}}class S extends A.$Uc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,R.localize)(0,null),when:p.$mk.isEqualTo((0,p.$jk)(p.LogLevel.Trace)).serialize()})}async c(i,t,l){const h=`${i} #${++this.b}: ${t.url}`;this.a.trace(`${h} - begin`,t.type,new C(t.headers??{}));try{const o=await l();return this.a.trace(`${h} - end`,t.type,o.res.statusCode,o.res.headers),o}catch(o){throw this.a.error(`${h} - error`,t.type,(0,m.$0)(o)),o}}}e.$Wp=S;function d(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function P(s){return s.res.statusCode===204}async function b(s){return P(s)?null:(await(0,r.$Ve)(s.stream)).toString()}async function a(s){if(!d(s))throw new Error("Server returned "+s.res.statusCode);return b(s)}async function u(s){if(!d(s))throw new Error("Server returned "+s.res.statusCode);if(P(s))return null;const t=(await(0,r.$Ve)(s.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}function f(s){n(s)}let g;function n(s){const i=c.$jo.as(L.$oo.Configuration),t=g;g={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},i.updateConfigurations({add:[g],remove:t?[t]:[]})}n(L.ConfigurationScope.APPLICATION)}),define(ye[286],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bac=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const R=await this.c();if(R){const L=String(r.a++);return this.b.set(L,R),{id:L,data:R.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,R){if(!A.id)return!0;const L=this.b.get(A.id);if(!L)return!1;this.b.delete(A.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$bac=r}),define(ye[117],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl="signService",e.$Tl=(0,r.$Ai)(e.$Sl)}),define(ye[147],Se([1,0,286]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;class m extends r.$bac{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(L=>new L.signer().sign(R))}h(){return new Promise((R,L)=>de(["vsda"],R,L))}}e.$gfc=m}),define(ye[287],Se([1,0,11,56,32]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=L,e.$mp=T;function R(p){if(r.$u===r.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function L(p,c,C,S,d,P,b,a,u,f){const g=Object.create(null);g["common.machineId"]=P,g["common.sqmId"]=b,g["common.devDeviceId"]=a,g.sessionID=(0,A.$Wg)()+Date.now(),g.commitHash=S,g.version=d,g["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,r.$h)(r.$u),g["common.nodePlatform"]=m.$dc,g["common.nodeArch"]=C,g["common.product"]=f||"desktop",u&&(g["common.msftInternal"]=u);let n=0;const s=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),r.$l&&(g["common.snap"]="true");const i=R(c);return i&&(g["common.platformDetail"]=i),g}function T(p){const c=m.env.USERDNSDOMAIN;if(!c)return!1;const C=c.toLowerCase();return p.some(S=>C===S)}}),define(ye[148],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,r.$Ai)("telemetryService"),e.$7l=(0,r.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry.devDeviceId",e.$bm="telemetry",e.$cm="telemetry.telemetryLevel",e.$dm="telemetry.enableCrashReporter",e.$em="telemetry.enableTelemetry";var m;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(m||(e.TelemetryLevel=m={}));var A;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(ye[92],Se([1,0,25,18,91,287,148]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=void 0,e.$up=C,e.$vp=S,e.$wp=d,e.$xp=P,e.$yp=a,e.$zp=f,e.$Ap=g,e.$Bp=i;class T{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$np=T;class p{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$op=p,e.$pp=new p;class c{async publicLog(l,h,o){}async publicLogError(l,h,o){}}e.$qp=c,e.$rp="telemetry",e.$sp="extensionTelemetryLog",e.$tp={log:()=>null,flush:()=>Promise.resolve(null)};function C(t,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!t.enableTelemetry)}function S(t,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function d(t){const l=t.getValue(L.$cm),h=t.getValue(L.$dm);if(t.getValue(L.$em)===!1||h===!1)return L.TelemetryLevel.NONE;switch(l??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function P(t){const l={},h={},o={};u(t,o);for(let $ in o){$=$.length>150?$.substr($.length-149):$;const E=o[$];typeof E=="number"?h[$]=E:typeof E=="boolean"?h[$]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${E.length}`),l[$]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(l[$]=E)}return{properties:l,measurements:h}}const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const l=(0,A.$Nm)(t);return b.has(l)?l:"other"}function u(t,l,h=0,o){if(t)for(const $ of Object.getOwnPropertyNames(t)){const E=t[$],k=o?o+$:$;Array.isArray(E)?l[k]=(0,r.$bo)(E):E instanceof Date?l[k]=E.toISOString():(0,m.$cg)(E)?h<2?u(E,l,h+1,k+"."):l[k]=(0,r.$bo)(E):l[k]=E}}function f(t,l){const h=t.msftInternalDomains||[],o=l.getValue("telemetry.internalTesting");return(0,R.$mp)(h)||o}function g(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,l){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let h=t;const o=[];for(const D of l)for(;;){const v=D.exec(t);if(!v)break;o.push([v.index,D.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(h="";;){const D=E.exec(t);if(!D)break;const v=o.some(([I,w])=>D.index<w&&I<E.lastIndex);!$.test(D[0])&&!v&&(h+=t.substring(k,D.index)+"<REDACTED: user-file-path>",k=E.lastIndex)}return k<t.length&&(h+=t.substr(k)),h}function s(t){if(!t)return t;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of l)if(h.regex.test(t))return`<REDACTED: ${h.label}>`;return t}function i(t,l){return(0,r.$$n)(t,h=>{if(h instanceof T||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let o=h.replaceAll("%20"," ");o=n(o,l);for(const $ of l)o=o.replace($,"");return o=s(o),o}})}}),define(ye[288],Se([1,0,13,145,24,11,2,14,56,92]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Dp=void 0,e.$Cp=C,e.$Ep=b,e.$Fp=a,e.$Gp=u,e.$Hp=f,e.$Ip=g,e.$Jp=n,e.$Kp=s,e.$Mp=i,e.$Np=l;function C(h,o){return h.uuid&&o.uuid?h.uuid===o.uuid:h.id===o.id?!0:(0,r.$wf)(h.id,o.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(o){const $=o.manifest?o.manifest.version:o.version,E=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new d(o.identifier,$,E)}static parse(o){const $=S.exec(o);return $&&$[1]&&$[2]?new d({id:$[1]},$[2],$[4]||void 0):null}constructor(o,$,E=A.TargetPlatform.UNDEFINED){this.identifier=o,this.version=$,this.targetPlatform=E,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==A.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof d?C(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$Dp=d;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(h){const o=P.exec(h);return o&&o[1]?[u(o[1]),o[2]]:[u(h),void 0]}function a(h,o){return`${h}.${o}`}function u(h){return h.toLowerCase()}function f(h,o){return u(a(h??A.$Sm,o))}function g(h,o){const $=[],E=k=>{for(const D of $)if(D.some(v=>C(o(v),o(k))))return D;return null};for(const k of h){const D=E(k);D?D.push(k):$.push([k])}return $}function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}function s(h){return{id:new c.$np(h.identifier.id),name:new c.$np(h.name),version:h.version,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.$Lp=new A.$Wm("pprice.better-merge");function i(h,o){const $=[],E=o.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const k=E.shift();if(k&&$.every(D=>!C(D.identifier,{id:k}))){const D=h.filter(v=>C(v.identifier,{id:k}));D.length===1&&($.push(D[0]),E.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function t(h,o){if(!R.$k)return!1;let $;try{$=(await h.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await h.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){o.debug("Error while getting the os-release file.",(0,T.$0)(k))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(h,o){const $=await t(h,o),E=(0,m.$0o)($?"alpine":R.$u,p.$ec);return o.debug("ComputeTargetPlatform:",E),E}}),define(ye[289],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=r,e.$us=m,e.$vs=A,e.$ws=R,e.$xs=L,e.$ys=T;function r(p){return[...p.entries()]}function m(p){return p?[...p.entries()]:[]}function A(p){return new Map(p)}function R(p){return new Map(p??[])}function L(p){return Array.from(p.entries()).map(c=>[c[0],r(c[1].map),m(c[1].descriptionMap)])}function T(p){return new Map(p.map(c=>[c[0],{map:A(c[1]),descriptionMap:R(c[2])}]))}}),define(ye[290],Se([1,0,5,35,36]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=e.$fs=e.$es=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ds=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$cs=void 0,e.$cs=new m.$Rj("terminalTabFocusMode",!1,!0);var R;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var L;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var T;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(T||(e.PosixShellType=T={}));var p;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var C;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(C||(e.TerminalIpcChannels=C={}));var S;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(S||(e.ProcessPropertyType=S={})),e.$ds=(0,r.$Ai)("ptyService");var d;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(d||(e.HeartbeatConstants=d={}));var P;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(P||(e.TerminalLocation=P={}));var b;(function(i){i.TerminalView="view",i.Editor="editor"})(b||(e.TerminalLocationString=b={}));var a;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var u;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(u||(e.FlowControlConstants=u={}));var f;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(f||(e.ProfileSource=f={}));var g;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(g||(e.ShellIntegrationStatus=g={}));var n;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$es={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const l=this.b(t.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}A.$jo.add(e.$es.Backend,new s),e.$fs=(0,r.$Ai)("localPtyService"),e.$gs=(0,r.$Ai)("terminalLogService")}),define(ye[291],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5vb=void 0;class r{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,R,L=5){const T=R(p=>{const c=typeof p=="string"?p:p.data;let C=this.a.get(A);if(C){C.data.push(c);return}const S=setTimeout(()=>this.flushBuffer(A),L);C={data:[c],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(A),T.dispose()}},this.a.set(A,C)});return T}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const R=this.a.get(A);R&&(this.a.delete(A),this.b(A,R.data.join("")))}}e.$5vb=r}),define(ye[292],Se([1,0,9,83,104,50,4,18,2,229,116,36]),function(de,e,r,m,A,R,L,T,p,c,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vx=e.$ux=e.$tx=e.$sx=e.$rx=e.$qx=e.IconFontDefinition=e.IconContribution=e.$nx=void 0,e.$ox=u,e.$px=f,e.$nx={IconContribution:"base.contributions.icons"};var d;(function(i){function t(l,h){let o=l.defaults;for(;R.ThemeIcon.isThemeIcon(o);){const $=a.getIcon(o.id);if(!$)return;o=$.defaults}return o}i.getDefinition=t})(d||(e.IconContribution=d={}));var P;(function(i){function t(h){return{weight:h.weight,style:h.style,src:h.src.map(o=>({format:o.format,location:o.location.toString()}))}}i.toJSONObject=t;function l(h){const o=$=>(0,T.$ag)($)?$:void 0;if(h&&Array.isArray(h.src)&&h.src.every($=>(0,T.$ag)($.format)&&(0,T.$ag)($.location)))return{weight:o(h.weight),style:o(h.style),src:h.src.map($=>({format:$.format,location:p.URI.parse($.location)}))}}i.fromJSONObject=l})(P||(e.IconFontDefinition=P={}));class b{constructor(){this.a=new L.$he,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,l,h,o){const $=this.b[t];if($){if(h&&!$.description){$.description=h,this.d.properties[t].markdownDescription=`${h} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=h),this.a.fire()}return $}const E={id:t,description:h,defaults:l,deprecationMessage:o};this.b[t]=E;const k={$ref:"#/definitions/icons"};return o&&(k.deprecationMessage=o),h&&(k.markdownDescription=`${h}: $(${t})`),this.d.properties[t]=k,this.e.enum.push(t),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const l=this.e.enum.indexOf(t);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,l){const h=this.f[t];return h||(this.f[t]=l,this.a.fire(),l)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=($,E)=>$.id.localeCompare(E.id),l=$=>{for(;R.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map($=>this.b[$]);for(const $ of o.filter(E=>!!E.description).sort(t))h.push(`|<i class="${l($)}"></i>|${$.id}|${R.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const $ of o.filter(E=>!R.ThemeIcon.isThemeIcon(E.defaults)).sort(t))h.push(`|<i class="${l($)}"></i>|${$.id}|`);return h.join(`
`)}}const a=new b;S.$jo.add(e.$nx.IconContribution,a);function u(i,t,l,h){return a.registerIcon(i,t,l,h)}function f(){return a}function g(){const i=(0,A.$Vj)();for(const t in i){const l="\\"+i[t].toString(16);a.registerIcon(t,{fontCharacter:l})}}g(),e.$qx="vscode://schemas/icons";const n=S.$jo.as(C.$ko.JSONContribution);n.registerSchema(e.$qx,a.getIconSchema());const s=new r.$Mh(()=>n.notifySchemaChanged(e.$qx),200);a.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$rx=u("widget-close",m.$Zj.close,(0,c.localize)(2,null)),e.$sx=u("goto-previous-location",m.$Zj.arrowUp,(0,c.localize)(3,null)),e.$tx=u("goto-next-location",m.$Zj.arrowDown,(0,c.localize)(4,null)),e.$ux=R.ThemeIcon.modify(m.$Zj.sync,"spin"),e.$vx=R.ThemeIcon.modify(m.$Zj.loading,"spin")}),define(ye[93],Se([1,0,4,11,2,44,5,12]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$Bw=e.$yw=e.$ww=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$sw=e.$rw=void 0,e.$tw=C,e.$uw=d,e.$vw=P,e.$xw=b,e.$zw=a,e.$Aw=u,e.$rw=(0,L.$Ai)("tunnelService"),e.$sw=(0,L.$Ai)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var c;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(c||(e.TunnelPrivacyId=c={}));function C(n){return!!n.forwardPort}var S;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(S||(e.ProvidedOnAutoForward=S={}));function d(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(s)return{address:s[1],port:+s[2]}}function P(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const s=n.query.split("&");for(const i of s){const t=i.split("=")[1];if(/^https?:/.exec(t)){const l=d(A.URI.parse(t));if(l)return l}}}e.$ww=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(n){return e.$ww.indexOf(n)>=0}e.$yw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(n){return e.$yw.indexOf(n)>=0}function u(n,s,i,t){if(i===m.OperatingSystem.Windows)return!1;if(i===m.OperatingSystem.Macintosh&&a(s)){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(l?.length===4&&parseInt(l[1])>=18)return!1}return n<1024}class f{constructor(s,i,t){this.remoteAddress=s,this.localAddress=i,this.b=t,this.a=new r.$he,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Bw=f;let g=class{constructor(s,i){this.k=s,this.l=i,this.a=new r.$he,this.onTunnelOpened=this.a.event,this.b=new r.$he,this.onTunnelClosed=this.b.event,this.c=new r.$he,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const s=this.l.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.i=s.privacyOptions,this.h=s.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const s=[],i=Array.from(this.e.values());for(const t of i){const l=Array.from(t.values());for(const h of l){const o=await h.value;o&&typeof o!="string"&&s.push(o)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:i}of s.values())await i.then(t=>typeof t!="string"?t?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,i,t,l,h){this.q(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:t,privacy:l,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(a(s)||b(s))&&(s=e.$ww[0]);const t=this.s(s,i);if(t)return++t.refcount,t.value}openTunnel(s,i,t,l,h,o=!1,$,E){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${t} on local port ${h}.`);const k=this.f??s;if(!k)return;if(i||(i="localhost"),l||(l=this.m),this.f&&this.j.has(t)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const D=this.t(k,i,t,l,h,o,$,E);return D?D.then(v=>{if(v){if(typeof v=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,t),v}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,t);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.o(v);return(v.tunnelRemoteHost!==i||v.tunnelRemotePort!==t)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&v.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),D)}o(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this.e.get(s.tunnelRemoteHost);if(i){const t=i.get(s.tunnelRemotePort);t&&(t.refcount--,await this.p(s.tunnelRemoteHost,s.tunnelRemotePort,t))}}}}async p(s,i,t){if(t.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const l=t.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(i),l}}async closeTunnel(s,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const t=this.e.get(s);if(t&&t.has(i)){const l=t.get(i);l.refcount=0,await this.p(s,i,l)}}q(s,i,t){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(i,{refcount:1,value:t})}async r(s,i){const t=this.e.get(s);if(t){const l=t.get(i),h=l?await l.value:void 0;(!h||typeof h=="string")&&t.delete(i),t.size===0&&this.e.delete(s)}}s(s,i){const t=[s];b(s)?(t.push(...e.$ww),t.push(...e.$yw)):a(s)&&t.push(...e.$yw);const l=t.map(h=>this.e.get(h));for(const h of l){const o=h?.get(i);if(o)return o}}canTunnel(s){return!!d(s)}u(s,i,t,l,h,o,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${t} on local port ${l}.`);const E=t;this.j.add(E);const k=l===void 0?t:l,D={elevationRequired:h?this.isPortPrivileged(k):!1},v={remoteAddress:{host:i,port:t},localAddressPort:l,privacy:o,public:o?o!==c.Private:void 0,protocol:$},I=s.forwardPort(v,D);return I?(this.q(i,t,I),I.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(E)})):this.j.delete(E),I}};e.$Cw=g,e.$Cw=g=Je([Ge(0,T.$7j),Ge(1,R.$7i)],g)}),define(ye[293],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,r.$Ai)("IUriIdentityService")}),define(ye[294],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Dw=void 0,e.$Dw=(0,r.$Ai)("editSessionIdentityService");var m;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(m||(e.EditSessionIdentityMatch=m={}))}),define(ye[295],Se([1,0,15]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=m,e.$5L=A,e.$6L=R,e.$7L=L,e.$8L=T;function m(p){return p.scheme!==r.Schemas.file&&p.scheme!==r.Schemas.vscodeRemote}function A(p){if(p.folders.length)return p.folders.every(c=>m(c.uri))?p.folders[0].uri:void 0;if(p.configuration&&m(p.configuration))return p.configuration}function R(p){return A(p)?.scheme}function L(p){return A(p)?.authority}function T(p){return A(p)!==void 0}}),define(ye[45],Se([1,0,231,16,85,23,2,5,15]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=c,e.$Li=C,e.$Oi=S,e.$Pi=d,e.$Qi=P,e.$Ri=a,e.$Si=u,e.$Vi=n,e.$1i=s,e.$2i=i,e.$4i=t,e.$5i=l,e.$6i=h,e.$Ji=(0,T.$Ai)("contextService");function c(o){const $=o;return typeof $?.id=="string"&&L.URI.isUri($.uri)}function C(o){return typeof o?.id=="string"&&!c(o)&&!d(o)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function S(o,$){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,m.$nc)(o)}:$?e.$Mi:e.$Ni;const E=o;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function d(o){const $=o;return typeof $?.id=="string"&&L.URI.isUri($.configPath)}function P(o){const $=o;if($?.uri)return{id:$.id,uri:L.URI.revive($.uri)};const E=o;if(E?.configPath)return{id:E.id,configPath:L.URI.revive(E.configPath)};if(o?.id)return{id:o.id}}var b;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function a(o){const $=o;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function u(o){const $=o;return!!($&&typeof $=="object"&&L.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class f{constructor($,E,k,D,v){this.h=$,this.j=k,this.k=D,this.l=v,this.c=A.$Gi.forUris(this.l,()=>!0),this.folders=E}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=A.$Gi.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=f;class g{constructor($,E){this.raw=E,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,R.$bh)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=g;function n(o){return new g({uri:o,index:0,name:(0,R.$0g)(o)},{uri:o.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,r.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function s(o,$){return R.$5g.isEqualOrParent(o,$.untitledWorkspacesHome)}function i(o){let $;return L.URI.isUri(o)?$=o:$=o.configuration,$?.scheme===p.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(o){return o.id===e.$3i}function l(o,$){return!s(o,$)&&!i(o)}function h(o){return(typeof o=="string"?(0,m.$oc)(o):(0,R.$_g)(o))===e.$Xi}}),define(ye[149],Se([1,0,61,4,3,23,2,230,143,28,5,12,45,29,293,9,32,13,18]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=s,e.$Hl=i,e.$Il=t;var n;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function s(o){const $=o;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&L.URI.isUri($.location)&&L.URI.isUri($.globalStorageHome)&&L.URI.isUri($.settingsResource)&&L.URI.isUri($.keybindingsResource)&&L.URI.isUri($.tasksResource)&&L.URI.isUri($.snippetsHome)&&L.URI.isUri($.extensionsResource))}e.$Gl=(0,C.$Ai)("IUserDataProfilesService");function i(o,$){return{id:o.id,isDefault:o.isDefault,name:o.name,shortName:o.shortName,icon:o.icon,location:L.URI.revive(o.location).with({scheme:$}),globalStorageHome:L.URI.revive(o.globalStorageHome).with({scheme:$}),settingsResource:L.URI.revive(o.settingsResource).with({scheme:$}),keybindingsResource:L.URI.revive(o.keybindingsResource).with({scheme:$}),tasksResource:L.URI.revive(o.tasksResource).with({scheme:$}),snippetsHome:L.URI.revive(o.snippetsHome).with({scheme:$}),extensionsResource:L.URI.revive(o.extensionsResource).with({scheme:$}),cacheHome:L.URI.revive(o.cacheHome).with({scheme:$}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}function t(o,$,E,k,D,v){return{id:o,name:$,location:E,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:v&&D?.useDefaultFlags?.globalState?v.globalStorageHome:(0,R.$bh)(E,"globalStorage"),settingsResource:v&&D?.useDefaultFlags?.settings?v.settingsResource:(0,R.$bh)(E,"settings.json"),keybindingsResource:v&&D?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,R.$bh)(E,"keybindings.json"),tasksResource:v&&D?.useDefaultFlags?.tasks?v.tasksResource:(0,R.$bh)(E,"tasks.json"),snippetsHome:v&&D?.useDefaultFlags?.snippets?v.snippetsHome:(0,R.$bh)(E,"snippets"),extensionsResource:v&&D?.useDefaultFlags?.extensions?v.extensionsResource:(0,R.$bh)(E,"extensions.json"),cacheHome:(0,R.$bh)(k,o),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let l=class extends A.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,E,k,D){super(),this.t=$,this.u=E,this.w=k,this.y=D,this.f=!0,this.h=this.B(new m.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new m.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new m.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new m.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new P.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),E=[$];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,g.$ag)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}E.push(t((0,R.$$g)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},$))}}catch(v){this.y.error(v)}const k=new P.$Ac,D=new Map;if(E.length)try{const v=this.Q();if(v.workspaces)for(const[I,w]of Object.entries(v.workspaces)){const y=L.URI.parse(I),N=E.find(O=>O.id===w);N&&k.set(y,N)}if(v.emptyWindows)for(const[I,w]of Object.entries(v.emptyWindows)){const y=E.find(N=>N.id===w);y&&D.set(I,y)}}catch(v){this.y.error(v)}this.z={profiles:E,workspaces:k,emptyWindows:D}}return this.z}D(){const $=t("__default__profile__",(0,T.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const E="Temp",k=new RegExp(`${(0,f.$df)(E)}\\s(\\d+)`);let D=0;for(const I of this.profiles){const w=k.exec(I.name),y=w?parseInt(w[1]):0;D=y>D?y:D}const v=`${E} ${D+1}`;return this.createProfile((0,r.$oj)((0,u.$Wg)()).toString(16),v,{transient:!0},$)}async createNamedProfile($,E,k){return this.createProfile((0,r.$oj)((0,u.$Wg)()).toString(16),$,E,k)}async createProfile($,E,k,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F($,E,k);return D&&await this.setProfileForWorkspace(D,v),v}async F($,E,k){if(!(0,g.$ag)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(E);return D||(D=(async()=>{try{if(this.profiles.find(y=>y.name===E||y.id===$))throw new Error(`Profile with ${E} name already exists`);const I=t($,E,(0,R.$bh)(this.profilesHome,$),this.g,k,this.defaultProfile);await this.u.createFolder(I.location);const w=[];return this.j.fire({profile:I,join(y){w.push(y)}}),await a.Promises.settled(w),this.I([I],[],[]),I}finally{this.r.delete(E)}})(),this.r.set(E,D)),D}async updateProfile($,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(D=>D.id===$.id);if(!k)throw new Error(`Profile '${$.name}' does not exist`);return k=t(k.id,E.name??k.name,k.location,this.g,{shortName:E.shortName??k.shortName,icon:E.icon===null?void 0:E.icon??k.icon,transient:E.transient??k.isTransient,useDefaultFlags:E.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(D=>D.id===$.id);if(!E)throw new Error(`Profile '${$.name}' does not exist`);const k=[];this.m.fire({profile:E,join(D){k.push(D)}});try{await Promise.allSettled(k)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(D){(0,c.$ll)(D)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(D)}}async setProfileForWorkspace($,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(D=>D.id===E.id);if(!k)throw new Error(`Profile '${E.name}' does not exist`);this.L($,k)}unsetWorkspace($,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,E)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(E=>E.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled($.map(E=>this.removeProfile(E)))}getProfileForWorkspace($){const E=this.G($);return L.URI.isUri(E)?this.s.workspaces.get(E)??this.C.workspaces.get(E):this.s.emptyWindows.get(E)??this.C.emptyWindows.get(E)}G($){return(0,d.$Ki)($)?$.uri:(0,d.$Pi)($)?$.configPath:$.id}H($){return!!([...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,$.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,$.location))||[...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,$.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,$.location)))}I($,E,k){const D=[...this.profiles,...$],v=[];this.s.profiles=[];for(let I of D)I.isDefault||E.some(w=>I.id===w.id)||(I=k.find(w=>I.id===w.id)??I,I.isTransient?this.s.profiles.push(I):v.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags}));this.P(v),this.z=void 0,this.J($,E,k)}J($,E,k){this.h.fire({added:$,removed:E,updated:k,all:this.profiles})}L($,E,k){k=E?.isTransient?!0:k,k||this.L($,void 0,!0);const D=this.G($),v=k?this.s:this.C;L.URI.isUri(D)?(v.workspaces.delete(D),E&&v.workspaces.set(D,E)):(v.emptyWindows.delete(D),E&&v.emptyWindows.set(D,E)),k||this.M()}M(){const $={};for(const[k,D]of this.C.workspaces.entries())$[k.toString()]=D.id;const E={};for(const[k,D]of this.C.emptyWindows.entries())E[k.toString()]=D.id;this.R({workspaces:$,emptyWindows:E}),this.z=void 0}N($){const E={},k=this.D();if($.workspaces)for(const[v,I]of Object.entries($.workspaces)){const w=L.URI.parse(I);E[v]=this.w.extUri.isEqual(w,k.location)?k.id:this.w.extUri.basename(w)}const D={};if($.emptyWindows)for(const[v,I]of Object.entries($.emptyWindows)){const w=L.URI.parse(I);D[v]=this.w.extUri.isEqual(w,k.location)?k.id:this.w.extUri.basename(w)}return{workspaces:E,emptyWindows:D}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Jl=l,e.$Jl=l=Je([Ge(0,p.$Hi),Ge(1,c.$7k),Ge(2,b.$El),Ge(3,S.$7j)],l);class h extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Kl=h}),define(ye[150],Se([1,0,9,4,3,62,18,208,5,149]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$$p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$9p=e.$8p=e.$7p=void 0,e.$0p=P,e.$_p=a,e.$bq=f,e.$7p="__$__isNewStorageMarker",e.$8p="__$__targetStorageMarker",e.$9p=(0,p.$Ai)("storageService");var C;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var S;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var d;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function P(g){const n=g.get(e.$8p);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class b extends A.$Uc{static{this.a=60*1e3}constructor(n={flushInterval:b.a}){super(),this.m=n,this.b=this.B(new m.$ke),this.c=this.B(new m.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new m.$he),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,s,i){return m.Event.filter(this.b.event,t=>t.scope===n&&(s===void 0||t.key===s),i)}n(){this.j.value=(0,r.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,s){const{key:i,external:t}=s;if(i===e.$8p){switch(n){case S.APPLICATION:this.H=void 0;break;case S.PROFILE:this.F=void 0;break;case S.WORKSPACE:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:i,target:this.J(n)[i],external:t})}w(n){this.f.fire({reason:n})}get(n,s,i){return this.P(s)?.get(n,i)}getBoolean(n,s,i){return this.P(s)?.getBoolean(n,i)}getNumber(n,s,i){return this.P(s)?.getNumber(n,i)}getObject(n,s,i){return this.P(s)?.getObject(n,i)}storeAll(n,s){this.y(()=>{for(const i of n)this.store(i.key,i.value,i.scope,i.target,s)})}store(n,s,i,t,l=!1){if((0,L.$jg)(s)){this.remove(n,i,l);return}this.y(()=>{this.z(n,i,t),this.P(i)?.set(n,s,l)})}remove(n,s,i=!1){this.y(()=>{this.z(n,s,void 0),this.P(s)?.delete(n,i)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,s){const i=[],t=this.J(n);for(const l of Object.keys(t))t[l]===s&&i.push(l);return i}z(n,s,i,t=!1){const l=this.J(s);typeof i=="number"?l[n]!==i&&(l[n]=i,this.P(s)?.set(e.$8p,JSON.stringify(l),t)):typeof l[n]=="number"&&(delete l[n],this.P(s)?.set(e.$8p,JSON.stringify(l),t))}get D(){return this.C||(this.C=this.L(S.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(S.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(S.APPLICATION)),this.H}J(n){switch(n){case S.APPLICATION:return this.I;case S.PROFILE:return this.G;default:return this.D}}L(n){const s=this.P(n);return s?P(s):Object.create(null)}isNew(n){return this.getBoolean(e.$7p,n)===!0}async flush(n=C.NONE){this.f.fire({reason:n});const s=this.P(S.APPLICATION),i=this.P(S.PROFILE),t=this.P(S.WORKSPACE);switch(n){case C.NONE:await r.Promises.settled([s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await r.Promises.settled([s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(S.APPLICATION)?.items??new Map,s=this.P(S.PROFILE)?.items??new Map,i=this.P(S.WORKSPACE)?.items??new Map;return f(n,s,i,this.Q(S.APPLICATION)??"",this.Q(S.PROFILE)??"",this.Q(S.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,s){return this.w(C.NONE),(0,c.$Fl)(n)?this.R(n,s):this.S(n,s)}M(n,s){return!(n.id===s.id||a(s)&&a(n))}N(n,s,i){this.y(()=>{const t=new Set;for(const[l,h]of n)t.add(l),s.get(l)!==h&&this.u(i,{key:l,external:!0});for(const[l]of s.items)t.has(l)||this.u(i,{key:l,external:!0})})}}e.$$p=b;function a(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class u extends b{constructor(){super(),this.U=this.B(new T.$5p(new T.$6p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$5p(new T.$6p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$5p(new T.$6p,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(S.WORKSPACE,n))),this.B(this.W.onDidChangeStorage(n=>this.u(S.PROFILE,n))),this.B(this.U.onDidChangeStorage(n=>this.u(S.APPLICATION,n)))}P(n){switch(n){case S.APPLICATION:return this.U;case S.PROFILE:return this.W;default:return this.X}}Q(n){switch(n){case S.APPLICATION:return"inMemory (application)";case S.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$aq=u;async function f(g,n,s,i,t,l){const h=y=>{try{return JSON.parse(y)}catch{return y}},o=new Map,$=new Map;g.forEach((y,N)=>{o.set(N,y),$.set(N,h(y))});const E=new Map,k=new Map;n.forEach((y,N)=>{E.set(N,y),k.set(N,h(y))});const D=new Map,v=new Map;s.forEach((y,N)=>{D.set(N,y),v.set(N,h(y))}),console.group(i!==t?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const I=[];if(o.forEach((y,N)=>{I.push({key:N,value:y})}),console.table(I),console.groupEnd(),console.log($),i!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const y=[];E.forEach((N,O)=>{y.push({key:O,value:N})}),console.table(y),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${l})`);const w=[];D.forEach((y,N)=>{w.push({key:N,value:y})}),console.table(w),console.groupEnd(),console.log(v)}}),define(ye[118],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class r{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const R=this.c++;return this.b.set(R,A),this.e(),R}get(A,R){return this.b.has(A)?this.b.get(A)[R]:void 0}delete(A){this.b.delete(A),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Imc=r}),define(ye[63],Se([1,0,15,23,28,5]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=e.$Nmc=void 0;class L{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new m.$3g(p=>{const c=this.b.get(p.scheme);return!(c===void 0||c&A.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,c){c===null?this.b.delete(p.scheme):this.b.set(p.scheme,c)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Nmc=L,e.$Omc=(0,R.$Ai)("IExtHostFileSystemInfo")}),define(ye[30],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=void 0,e.$cP=(0,r.$Ai)("IExtHostInitDataService")}),define(ye[296],Se([1,0,236,12,277,30]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uoc=void 0;let L=class extends A.$mQ{constructor(p,c,C){const S=C.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",d=C.remote.isRemote?(0,r.localize)(0,null):p?(0,r.localize)(1,null):(0,r.localize)(2,null);super(c.createLogger(S,{name:d}))}};e.$Uoc=L,e.$Uoc=L=Je([Ge(1,m.$8j),Ge(2,R.$cP)],L)}),define(ye[297],Se([1,0,9]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=e.$tnc=void 0;class m{constructor(L,T,p){this.h=new Map,this.a=L,this.b=T,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new r.$Mh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const C of c.values())C.complete()}catch(C){for(const S of c.values())S.error(C)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,T){let p=this.f[L];return typeof p>"u"&&(p=T),p}update(L,T){this.f[L]=T;const p=this.h.get(L);if(p!==void 0)return p.p;const c=new r.$Xh;return this.h.set(L,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$tnc=m;class A extends m{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,T){super(L.identifier.value,!0,T),this.j=L}}e.$unc=A}),define(ye[298],Se([1,0,4,2]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=void 0;class A{constructor(L){this.c=L,this.a=new r.$he,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$he,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,T,p,c){const S=this.c.getNotebookDocument(m.URI.revive(L)).acceptModelChanged(T.value,p,c);this.b.fire(S)}$acceptDirtyStateChanged(L,T){this.c.getNotebookDocument(m.URI.revive(L)).acceptDirty(T)}$acceptModelSaved(L){const T=this.c.getNotebookDocument(m.URI.revive(L));this.a.fire(T.apiNotebook)}}e.$ioc=A}),define(ye[20],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=e.$YO=void 0,e.$YO=(0,r.$Ai)("IExtHostRpcService");class m{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$ZO=m}),define(ye[299],Se([1,0,24,4]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnc=void 0;class A{#e;constructor(L,T){this.b=new m.$he,this.onDidChange=this.b.event,this.a=r.$Wm.toKey(L.identifier),this.#e=T,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(L){return this.#e.get(this.a,L)}store(L,T){return this.#e.store(this.a,L,T)}delete(L){return this.#e.delete(this.a,L)}}e.$Dnc=A}),define(ye[72],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=e.$4mc=void 0,e.$4mc=(0,r.$Ai)("IURITransformerService");class m{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$5mc=m}),define(ye[300],Se([1,0,301,413,414,66,2,12,415]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qpc=C;const c=!1;function C(n,s,i,t,l,h){const o=h.environment.useHostProxy,$=typeof o=="boolean"?o:!h.remote.isRemote,E={resolveProxy:v=>n.resolveProxy(v),lookupProxyAuthorization:u.bind(void 0,t,l,s,{},h.remote.isRemote),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>d(s),addCertificatesV2:()=>P(s),log:t,getLogLevel:()=>{const v=t.getLevel();switch(v){case T.LogLevel.Trace:return p.LogLevel.Trace;case T.LogLevel.Debug:return p.LogLevel.Debug;case T.LogLevel.Info:return p.LogLevel.Info;case T.LogLevel.Warning:return p.LogLevel.Warning;case T.LogLevel.Error:return p.LogLevel.Error;case T.LogLevel.Off:return p.LogLevel.Off;default:return I(v)}function I(w){return t.error("Unknown log level",w),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:$,loadAdditionalCertificates:async()=>{const v=[];if(h.remote.isRemote&&v.push((0,p.loadSystemCertificates)({log:t})),$){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const I=n.loadCertificates();I.then(w=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",w.length)),v.push(I)}return(await Promise.all(v)).flat()},env:process.env},k=(0,p.createProxyResolver)(E),D=S(E,k);return a(i,D)}function S(n,s){return{http:Object.assign(r,(0,p.createHttpPatch)(n,r,s)),https:Object.assign(m,(0,p.createHttpPatch)(n,m,s)),net:Object.assign(R,(0,p.createNetPatch)(n,R)),tls:Object.assign(A,(0,p.createTlsPatch)(n,A))}}function d(n){const s=n.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}function P(n){const s=n.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",c)&&!!s.get("systemCertificates")}const b=new Map;function a(n,s){return n.getExtensionPathIndex().then(i=>{const t=globalThis._VSCODE_NODE_MODULES.module,l=t._load;t._load=function(o,$,E){if(o==="net")return s.net;if(o==="tls")return s.tls;if(o!=="http"&&o!=="https")return l.apply(this,arguments);const k=i.findSubstr(L.URI.file($.filename));let D=b.get(k);if(D||b.set(k,D={}),!D[o]){const v=s[o];D[o]={...v}}return D[o]}})}async function u(n,s,i,t,l,h,o,$){const E=t[h];o&&(t[h]=o),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${o}`,`proxyAuthenticateCache:${E}`);const k=o||E,D=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(g(s,D,l),D.some(v=>/^(Negotiate|Kerberos)( |$)/i.test(v))&&!$.kerberosRequested)try{$.kerberosRequested=!0;const v=await new Promise((O,U)=>{de(["kerberos"],O,U)}),I=new URL(h),w=i.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${I.hostname}`:`HTTP@${I.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${w}`),"Negotiate "+await(await v.initializeClient(w)).step("")}catch(v){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",v)}}let f=!1;function g(n,s,i){f||!s.length||(f=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(t=>t.split(" ")[0]).join(","),extensionHostType:i?"remote":"local"}))}}),define(ye[302],Se([1,0,141]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=A;function m(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function A(R){return new r.$Dn(m(R))}}),define(ye[151],Se([1,0,246,18,2,3,5,36,28,15,51,200,43]),function(de,e,r,m,A,R,L,T,p,c,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$4F=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$TF=e.EditorInputCapabilities=e.$SF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=void 0,e.$JF=a,e.$KF=u,e.$LF=f,e.$MF=g,e.$NF=n,e.$OF=s,e.$PF=i,e.$QF=t,e.$RF=l,e.$UF=D,e.$VF=I,e.$WF=w,e.$XF=y,e.$YF=N,e.$ZF=O,e.$1F=U,e.$2F=j,e.$3F=V,e.$5F=ne,e.$6F=re,e.$7F=ve,e.$8F=pe,e.$EF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$FF={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.$GF="workbench.editor.sidebysideEditor",e.$HF="workbench.editors.textDiffEditor",e.$IF="workbench.editors.binaryResourceDiffEditor";var P;(function(Q){Q[Q.PROGRAMMATIC=1]="PROGRAMMATIC",Q[Q.USER=2]="USER",Q[Q.EDIT=3]="EDIT",Q[Q.NAVIGATION=4]="NAVIGATION",Q[Q.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var b;(function(Q){Q[Q.IDENTICAL=1]="IDENTICAL",Q[Q.SIMILAR=2]="SIMILAR",Q[Q.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function a(Q){const B=Q;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function u(Q){const B=Q;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function f(Q,B,se){for(const ae of se.visibleEditorPanes)if(ae.group.id===B&&Q.matches(ae.input))return ae.getViewState()}function g(Q){if(D(Q))return!1;const B=Q;return A.URI.isUri(B?.resource)}function n(Q){if(D(Q))return!1;const B=Q;return B?.original!==void 0&&B.modified!==void 0}function s(Q){if(D(Q))return!1;const B=Q;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function i(Q){if(D(Q)||n(Q))return!1;const B=Q;return B?.primary!==void 0&&B.secondary!==void 0}function t(Q){if(D(Q))return!1;const B=Q;return B?B.resource===void 0||B.resource.scheme===c.Schemas.untitled||B.forceUntitled===!0:!1}function l(Q){if(D(Q))return!1;const B=Q;return A.URI.isUri(B?.base?.resource)&&A.URI.isUri(B?.input1?.resource)&&A.URI.isUri(B?.input2?.resource)&&A.URI.isUri(B?.result?.resource)}var h;(function(Q){Q[Q.SHORT=0]="SHORT",Q[Q.MEDIUM=1]="MEDIUM",Q[Q.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var o;(function(Q){Q[Q.EXPLICIT=1]="EXPLICIT",Q[Q.AUTO=2]="AUTO",Q[Q.FOCUS_CHANGE=3]="FOCUS_CHANGE",Q[Q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class ${constructor(){this.a=new Map}registerSource(B,se){let ae=this.a.get(B);return ae||(ae={source:B,label:se},this.a.set(B,ae)),ae.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$SF=new $;var E;(function(Q){Q[Q.None=0]="None",Q[Q.Readonly=2]="Readonly",Q[Q.Untitled=4]="Untitled",Q[Q.Singleton=8]="Singleton",Q[Q.RequiresTrust=16]="RequiresTrust",Q[Q.CanSplitInGroup=32]="CanSplitInGroup",Q[Q.ForceDescription=64]="ForceDescription",Q[Q.CanDropIntoEditor=128]="CanDropIntoEditor",Q[Q.MultipleEditors=256]="MultipleEditors",Q[Q.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class k extends R.$Uc{}e.$TF=k;function D(Q){return Q instanceof k}function v(Q){const B=Q;return A.URI.isUri(B?.preferredResource)}function I(Q){const B=Q;return D(B?.primary)&&D(B?.secondary)}function w(Q){const B=Q;return D(B?.modified)&&D(B?.original)}function y(Q,B,se,ae,ie){return pe(ae,[(0,S.$kj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const ce={...se,limits:{size:Number.MAX_VALUE}};Q.openEditor(B,ce)}}),(0,S.$kj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:d.default.Warning})}function N(Q){return D(Q?.editor)}function O(Q){const B=Q;return N(Q)&&B?.group!==void 0}function U(Q){const B=Q;return typeof B?.groupId=="number"&&D(B.editor)}function j(Q){return typeof Q?.groupId=="number"}var z;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.REPLACE=1]="REPLACE",Q[Q.MOVE=2]="MOVE",Q[Q.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var M;(function(Q){Q[Q.GROUP_ACTIVE=0]="GROUP_ACTIVE",Q[Q.GROUP_INDEX=1]="GROUP_INDEX",Q[Q.GROUP_LABEL=2]="GROUP_LABEL",Q[Q.GROUP_LOCKED=3]="GROUP_LOCKED",Q[Q.EDITORS_SELECTION=4]="EDITORS_SELECTION",Q[Q.EDITOR_OPEN=5]="EDITOR_OPEN",Q[Q.EDITOR_CLOSE=6]="EDITOR_CLOSE",Q[Q.EDITOR_MOVE=7]="EDITOR_MOVE",Q[Q.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Q[Q.EDITOR_LABEL=9]="EDITOR_LABEL",Q[Q.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Q[Q.EDITOR_PIN=11]="EDITOR_PIN",Q[Q.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Q[Q.EDITOR_STICKY=13]="EDITOR_STICKY",Q[Q.EDITOR_DIRTY=14]="EDITOR_DIRTY",Q[Q.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var F;(function(Q){Q[Q.PRIMARY=1]="PRIMARY",Q[Q.SECONDARY=2]="SECONDARY",Q[Q.BOTH=3]="BOTH",Q[Q.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class J{getOriginalUri(B,se){if(!B)return;if(l(B))return e.$4F.getOriginalUri(B.result,se);if(se?.supportSideBySide){const{primary:ie,secondary:ce}=this.a(B);if(ie&&ce){if(se?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(ie,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===F.ANY)return this.getOriginalUri(ie,{filterByScheme:se.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:se.filterByScheme});B=se.supportSideBySide===F.PRIMARY?ie:ce}}if(n(B)||s(B)||i(B)||l(B))return;const ae=v(B)?B.preferredResource:B.resource;return!ae||!se||!se.filterByScheme?ae:this.b(ae,se.filterByScheme)}a(B){return I(B)||i(B)?{primary:B.primary,secondary:B.secondary}:w(B)||n(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,se){if(!B)return;if(l(B))return e.$4F.getCanonicalUri(B.result,se);if(se?.supportSideBySide){const{primary:ie,secondary:ce}=this.a(B);if(ie&&ce){if(se?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(ie,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===F.ANY)return this.getCanonicalUri(ie,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:se.filterByScheme});B=se.supportSideBySide===F.PRIMARY?ie:ce}}if(n(B)||s(B)||i(B)||l(B))return;const ae=B.resource;return!ae||!se||!se.filterByScheme?ae:this.b(ae,se.filterByScheme)}b(B,se){if(Array.isArray(se)){if(se.some(ae=>B.scheme===ae))return B}else if(se===B.scheme)return B}}var ee;(function(Q){Q[Q.UNKNOWN=0]="UNKNOWN",Q[Q.KEYBOARD=1]="KEYBOARD",Q[Q.MOUSE=2]="MOUSE"})(ee||(e.EditorCloseMethod=ee={}));function V(Q,B,se,ae){if(!Q.isSticky(B))return!1;switch(ae.preventPinnedEditorClose){case"keyboardAndMouse":return se===ee.MOUSE||se===ee.KEYBOARD;case"mouse":return se===ee.MOUSE;case"keyboard":return se===ee.KEYBOARD}return!1}e.$4F=new J;var H;(function(Q){Q[Q.LEFT=0]="LEFT",Q[Q.RIGHT=1]="RIGHT"})(H||(e.CloseDirection=H={}));class _{constructor(){this.c=new Map,this.d=new Map}start(B){const se=this.a=B.get(L.$zi);for(const[ae,ie]of this.c)this.e(ae,ie,se);this.c.clear()}e(B,se,ae){const ie=ae.createInstance(se);this.d.set(B,ie)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,m.$lg)(this.b)}registerEditorSerializer(B,se){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,se,this.a):this.c.set(B,se),(0,R.$Sc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}T.$jo.add(e.$EF.EditorFactory,new _);async function ne(Q,B,se){return!Q||!Q.length?[]:await Promise.all(Q.map(async ae=>{const ie=A.URI.revive(ae.fileUri);if(!ie){se.info("Cannot resolve the path because it is not valid.",ae);return}if(!await B.canHandleResource(ie)){se.info("Cannot resolve the path because it cannot be handled",ae);return}let ue=ae.exists,Z=ae.type;if(typeof ue!="boolean"||typeof Z!="number")try{Z=(await B.stat(ie)).isDirectory?p.FileType.Directory:p.FileType.Unknown,ue=!0}catch($e){se.error($e),ue=!1}if(!ue&&ae.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",ae);return}if(Z===p.FileType.Directory){se.info("Cannot resolve the path because it is a directory",ae);return}const oe={...ae.options,pinned:!0};return ue?{resource:ie,options:oe}:{resource:ie,options:oe,forceUntitled:!0}}))}var he;(function(Q){Q[Q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Q[Q.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function re(Q){const B=Q;if(!B)return!1;const se=B;if(se.modified)return re(se.modified);const ae=B;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}function ve(Q){return(0,C.$mj)(Q)}function pe(Q,B,se){const ae=(0,C.$nj)(Q,B);return ae.forceMessage=se?.forceMessage,ae.forceSeverity=se?.forceSeverity,ae.allowDialog=se?.allowDialog,ae}}),define(ye[303],Se([1,0,4,247,5,3,29,36,25,83,292]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$bG=e.ViewContentGroups=e.$_F=e.ViewContainerLocation=e.Extensions=e.$$F=e.$0F=e.$9F=void 0,e.$aG=P,e.$9F="views",e.$0F=(0,m.localize)(0,null),e.$$F=(0,C.$ox)("default-view-icon",c.$Zj.window,(0,m.localize)(1,null));var S;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var d;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(d||(e.ViewContainerLocation=d={})),e.$_F=[d.Sidebar,d.Panel,d.AuxiliaryBar];function P(t){switch(t){case d.Sidebar:return"sidebar";case d.Panel:return"panel";case d.AuxiliaryBar:return"auxiliarybar"}}class b extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new r.$he),this.onDidRegister=this.c.event,this.f=this.B(new r.$he),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(l,h,o){const $=this.get(l.id);if($)return $;const E=l;return E.openCommandActionDescriptor=o?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,L.$xc)(this.g,h,[]).push(E),o?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:h}),E}deregisterViewContainer(l){for(const h of this.g.keys()){const o=this.g.get(h),$=o?.indexOf(l);if($!==-1){o?.splice($,1),o.length===0&&this.g.delete(h),this.f.fire({viewContainer:l,viewContainerLocation:h});return}}}get(l){return this.all.filter(h=>h.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(o=>o?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(h=>this.getViewContainerLocation(h)===l)}}T.$jo.add(S.ViewContainersRegistry,new b);var a;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(a||(e.ViewContentGroups=a={}));function u(t,l){const h=t.group??a.More,o=l.group??a.More;return h!==o?h.localeCompare(o):(t.order??5)-(l.order??5)}class f extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new r.$he),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$he),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$he),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$he),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Hc}registerViews(l,h){this.registerViews2([{views:l,viewContainer:h}])}registerViews2(l){l.forEach(({views:h,viewContainer:o})=>this.r(h,o)),this.c.fire(l)}deregisterViews(l,h){const o=this.s(l,h);o.length&&this.f.fire({views:o,viewContainer:h})}moveViews(l,h){for(const o of this.m.keys())if(o!==h){const $=this.s(l,o);$.length&&(this.r($,h),this.g.fire({views:$,from:o,to:h}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const h of this.j){const o=(this.m.get(h)||[]).filter($=>$.id===l)[0];if(o)return o}return null}getViewContainer(l){for(const h of this.j)if((this.m.get(h)||[]).filter($=>$.id===l)[0])return h;return null}registerViewWelcomeContent(l,h){return this.n.add(l,h),this.h.fire(l),(0,R.$Sc)(()=>{this.n.delete(l,h),this.h.fire(l)})}registerViewWelcomeContent2(l,h){const o=new Map;for(const[$,E]of h)this.n.add(l,E),o.set($,(0,R.$Sc)(()=>{this.n.delete(l,E),this.h.fire(l)}));return this.h.fire(l),o}getViewWelcomeContent(l){const h=[];return this.n.forEach(l,o=>h.push(o)),h.sort(u)}r(l,h){let o=this.m.get(h);o||(o=[],this.m.set(h,o),this.j.push(h));for(const $ of l){if(this.getView($.id)!==null)throw new Error((0,m.localize)(2,null,$.id));o.push($)}}s(l,h){const o=this.m.get(h);if(!o)return[];const $=[],E=[];for(const k of o)l.includes(k)?$.push(k):E.push(k);return $.length&&(E.length?this.m.set(h,E):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),$}}T.$jo.add(S.ViewsRegistry,new f),e.$bG=(0,A.$Ai)("viewDescriptorService");var g;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(g||(e.ViewVisibilityState=g={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class s{constructor(l,h){this.c=!1,this.d=!1,(0,p.$_n)(this,l),this.d=!!h,this.resolve=async o=>{if(h&&!this.c){const $=await h(o);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}o.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$cG=s;class i extends Error{constructor(l){super((0,m.localize)(3,null,l)),this.name="NoTreeViewError"}static is(l){return l.name==="NoTreeViewError"}}e.$dG=i}),define(ye[304],Se([1,0,248,35]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=void 0,e.$hG=new m.$Rj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(0,null)}),e.$iG=new m.$Rj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(1,null)}),e.$jG=new m.$Rj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(2,null)}),e.$kG=new m.$Rj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(3,null)}),e.$lG=new m.$Rj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4,null)}),e.$mG=new m.$Rj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(5,null)}),e.$nG=new m.$Rj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(6,null)}),e.$oG=new m.$Rj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(7,null)}),e.$pG=new m.$Rj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8,null)}),e.$qG=new m.$Rj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(9,null)}),e.$rG=new m.$Rj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(10,null)}),e.$sG=new m.$Rj("inChat",!1,{type:"boolean",description:(0,r.localize)(11,null)}),e.$tG=new m.$Rj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(12,null)}),e.$uG=new m.$Rj("chatCursorAtTop",!1),e.$vG=new m.$Rj("chatInputHasAgent",!1),e.$wG=new m.$Rj("chatLocation",void 0),e.$xG=new m.$Rj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(13,null)})}),define(ye[305],Se([1,0,131,9,21,4,40,3,57,179,13,35,24,5,12,115,285,150,304]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.ChatAgentLocation=void 0,e.$CH=h,e.$DH=o;var s;(function($){$.Panel="panel",$.Terminal="terminal",$.Notebook="notebook",$.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function($){function E(k){switch(k){case"panel":return $.Panel;case"terminal":return $.Terminal;case"notebook":return $.Notebook;case"editor":return $.Editor}return $.Panel}$.fromRaw=E}(s||(e.ChatAgentLocation=s={})),e.$xH=(0,P.$Ai)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new R.$he,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=g.$tG.bindTo(this.f)}registerAgent(E,k){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const v=this,I=k.slashCommands;k={...k,get slashCommands(){return I.filter(y=>!y.when||v.f.contextMatchesRules(S.$yj.deserialize(y.when)))}};const w={data:k};return this.b.set(E,w),(0,T.$Sc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,k){const D=this.b.get(E);if(!D)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(D.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return D.data.isDefault&&this.e.set(!0),D.impl=k,this.d.fire(new t(D.data,k)),(0,T.$Sc)(()=>{D.impl=void 0,this.d.fire(void 0),D.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,k){E.isDynamic=!0;const D={data:E,impl:k};return this.b.set(E.id,D),this.d.fire(new t(E,k)),(0,T.$Sc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,k){return this.g.set(E,k),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,k,D){return await this.g.get(E)?.(k,D)??[]}updateAgent(E,k){const D=this.b.get(E);if(!D?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);D.data.metadata={...D.data.metadata,...k},this.d.fire(new t(D.data,D.impl))}getDefaultAgent(E){return(0,r.$fb)(this.getActivatedAgents(),k=>!!k.isDefault&&k.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(k=>!!k.isDefault&&k.locations.includes(E))}getSecondaryAgent(){return L.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const k=this.b.get(E);return!k?.data.when||this.f.contextMatchesRules(S.$yj.deserialize(k.data.when))}getAgentByFullyQualifiedId(E){const k=L.Iterable.find(this.b.values(),D=>h(D.data)===E)?.data;if(!(k&&!this.h(k.id)))return k}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new t(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(k=>k.name===E)}async invokeAgent(E,k,D,v,I){const w=this.b.get(E);if(!w?.impl)throw new Error(`No activated agent with id "${E}"`);return await w.impl.invoke(k,D,v,I)}async getFollowups(E,k,D,v,I){const w=this.b.get(E);if(!w?.impl)throw new Error(`No activated agent with id "${E}"`);return w.impl?.provideFollowups?w.impl.provideFollowups(k,D,v,I):[]}};e.$yH=i,e.$yH=i=Je([Ge(0,S.$Sj)],i);class t{constructor(E,k){this.b=E,this.d=k}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(E,k,D,v){return this.d.invoke(E,k,D,v)}async provideFollowups(E,k,D,v){return this.d.provideFollowups?this.d.provideFollowups(E,k,D,v):[]}provideWelcomeMessage(E,k){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,k)}provideSampleQuestions(E,k){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,k)}}e.$zH=t,e.$AH=(0,P.$Ai)("chatAgentNameService");let l=class{static{n=this}static{this.b="chat.participantNameRegistry"}constructor(E,k,D,v){if(this.g=k,this.h=D,this.i=v,this.e=(0,c.$3d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const I=v.get(n.b,f.StorageScope.APPLICATION);try{this.e.set(JSON.parse(I??"{}"),void 0)}catch{v.remove(n.b,f.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,m.$Bh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},A.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const k=await(0,u.$2p)(E);if(!k||k.version!==1)throw new Error("Unexpected chat participant registry response.");const D=k.restrictedChatParticipants;this.e.set(D,void 0),this.i.store(n.b,JSON.stringify(D),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}getAgentNameRestriction(E){const k=this.l(E.name,E).get(),D=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return k&&D}l(E,k){return this.e.map(v=>v[E.toLowerCase()]).map(v=>v?v.some(I=>(0,C.$Bf)(I,I.includes(".")?k.extensionId.value:k.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$BH=l,e.$BH=l=n=Je([Ge(0,a.$nk),Ge(1,u.$Vp),Ge(2,b.$7j),Ge(3,f.$9p)],l);function h($){return`${$.extensionId.value}.${$.id}`}function o($){const E="name"in $?$:{...$,name:$.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new d.$Wm("")),(0,p.$0h)(E)}}),define(ye[306],Se([1,0,2,31,5]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9G=e.$8G=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$6G=R,e.$7G=L;function R(c){return!!c&&typeof c=="object"&&"uri"in c&&c.uri instanceof r.URI&&"version"in c&&typeof c.version=="number"&&"ranges"in c&&Array.isArray(c.ranges)&&c.ranges.every(m.$ct.isIRange)}function L(c){return!!c&&typeof c=="object"&&"documents"in c&&Array.isArray(c.documents)&&c.documents.every(R)}var T;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(T||(e.ChatAgentVoteDirection=T={}));var p;(function(c){c[c.Action=1]="Action",c[c.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$8G=(0,A.$Ai)("IChatService"),e.$9G="accessibility.voice.keywordActivation"}),define(ye[152],Se([1,0,4,9,250]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new r.$he,this.o=new r.$he,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,p,c,C){const S={command:T};if(p&&Object.keys(p).length>0&&(S.arguments=p),this.u("request",S),typeof C=="number"){const d=setTimeout(()=>{clearTimeout(d);const P=this.f.get(S.seq);if(P){this.f.delete(S.seq);const b={type:"response",seq:0,request_seq:S.seq,success:!1,command:T,message:(0,A.localize)(0,null,C,T)};P(b)}},C)}return c&&this.f.set(S.seq,c),S.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,p){return T.type!=="event"||p.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,m.$Bh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const p=T,c=this.f.get(p.request_seq);c&&(this.f.delete(p.request_seq),c(p));break}}}}u(T,p){p.type=T,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((p,c)=>T.set(c,p)),await(0,m.$Bh)(500),T.forEach((p,c)=>{p({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$fsb=R}),define(ye[119],Se([1,0,2,251,35,5]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$TJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$RJ=e.MemoryRangeType=e.State=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=void 0,e.$QJ=p,e.$SJ=C,e.$EI="workbench.view.debug",e.$FI="workbench.debug.variablesView",e.$GI="workbench.debug.watchExpressionsView",e.$HI="workbench.debug.callStackView",e.$II="workbench.debug.loadedScriptsView",e.$JI="workbench.debug.breakPointsView",e.$KI="workbench.debug.disassemblyView",e.$LI="workbench.panel.repl",e.$MI="workbench.panel.repl.view",e.$NI=new A.$Rj("debugType",void 0,{type:"string",description:m.localize(0,null)}),e.$OI=new A.$Rj("debugConfigurationType",void 0,{type:"string",description:m.localize(1,null)}),e.$PI=new A.$Rj("debugState","inactive",{type:"string",description:m.localize(2,null)}),e.$QI="debugUx",e.$RI=new A.$Rj(e.$QI,"default",{type:"string",description:m.localize(3,null)}),e.$SI=new A.$Rj("hasDebugged",!1,{type:"boolean",description:m.localize(4,null)}),e.$TI=new A.$Rj("inDebugMode",!1,{type:"boolean",description:m.localize(5,null)}),e.$UI=new A.$Rj("inDebugRepl",!1,{type:"boolean",description:m.localize(6,null)}),e.$VI=new A.$Rj("breakpointWidgetVisible",!1,{type:"boolean",description:m.localize(7,null)}),e.$WI=new A.$Rj("inBreakpointWidget",!1,{type:"boolean",description:m.localize(8,null)}),e.$XI=new A.$Rj("breakpointsFocused",!0,{type:"boolean",description:m.localize(9,null)}),e.$YI=new A.$Rj("watchExpressionsFocused",!0,{type:"boolean",description:m.localize(10,null)}),e.$ZI=new A.$Rj("watchExpressionsExist",!1,{type:"boolean",description:m.localize(11,null)}),e.$1I=new A.$Rj("variablesFocused",!0,{type:"boolean",description:m.localize(12,null)}),e.$2I=new A.$Rj("expressionSelected",!1,{type:"boolean",description:m.localize(13,null)}),e.$3I=new A.$Rj("breakpointInputFocused",!1,{type:"boolean",description:m.localize(14,null)}),e.$4I=new A.$Rj("callStackItemType",void 0,{type:"string",description:m.localize(15,null)}),e.$5I=new A.$Rj("callStackSessionIsAttach",!1,{type:"boolean",description:m.localize(16,null)}),e.$6I=new A.$Rj("callStackItemStopped",!1,{type:"boolean",description:m.localize(17,null)}),e.$7I=new A.$Rj("callStackSessionHasOneThread",!1,{type:"boolean",description:m.localize(18,null)}),e.$8I=new A.$Rj("watchItemType",void 0,{type:"string",description:m.localize(19,null)}),e.$9I=new A.$Rj("canViewMemory",void 0,{type:"boolean",description:m.localize(20,null)}),e.$0I=new A.$Rj("breakpointItemType",void 0,{type:"string",description:m.localize(21,null)}),e.$$I=new A.$Rj("breakpointItemBytes",void 0,{type:"boolean",description:m.localize(22,null)}),e.$_I=new A.$Rj("breakpointHasModes",!1,{type:"boolean",description:m.localize(23,null)}),e.$aJ=new A.$Rj("breakpointSupportsCondition",!1,{type:"boolean",description:m.localize(24,null)}),e.$bJ=new A.$Rj("loadedScriptsSupported",!1,{type:"boolean",description:m.localize(25,null)}),e.$cJ=new A.$Rj("loadedScriptsItemType",void 0,{type:"string",description:m.localize(26,null)}),e.$dJ=new A.$Rj("focusedSessionIsAttach",!1,{type:"boolean",description:m.localize(27,null)}),e.$eJ=new A.$Rj("focusedSessionIsNoDebug",!1,{type:"boolean",description:m.localize(28,null)}),e.$fJ=new A.$Rj("stepBackSupported",!1,{type:"boolean",description:m.localize(29,null)}),e.$gJ=new A.$Rj("restartFrameSupported",!1,{type:"boolean",description:m.localize(30,null)}),e.$hJ=new A.$Rj("stackFrameSupportsRestart",!1,{type:"boolean",description:m.localize(31,null)}),e.$iJ=new A.$Rj("jumpToCursorSupported",!1,{type:"boolean",description:m.localize(32,null)}),e.$jJ=new A.$Rj("stepIntoTargetsSupported",!1,{type:"boolean",description:m.localize(33,null)}),e.$kJ=new A.$Rj("breakpointsExist",!1,{type:"boolean",description:m.localize(34,null)}),e.$lJ=new A.$Rj("debuggersAvailable",!1,{type:"boolean",description:m.localize(35,null)}),e.$mJ=new A.$Rj("debugExtensionAvailable",!0,{type:"boolean",description:m.localize(36,null)}),e.$nJ=new A.$Rj("debugProtocolVariableMenuContext",void 0,{type:"string",description:m.localize(37,null)}),e.$oJ=new A.$Rj("debugSetVariableSupported",!1,{type:"boolean",description:m.localize(38,null)}),e.$pJ=new A.$Rj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:m.localize(39,null)}),e.$qJ=new A.$Rj("debugSetExpressionSupported",!1,{type:"boolean",description:m.localize(40,null)}),e.$rJ=new A.$Rj("breakWhenValueChangesSupported",!1,{type:"boolean",description:m.localize(41,null)}),e.$sJ=new A.$Rj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:m.localize(42,null)}),e.$tJ=new A.$Rj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:m.localize(43,null)}),e.$uJ=new A.$Rj("terminateDebuggeeSupported",!1,{type:"boolean",description:m.localize(44,null)}),e.$vJ=new A.$Rj("suspendDebuggeeSupported",!1,{type:"boolean",description:m.localize(45,null)}),e.$wJ=new A.$Rj("variableEvaluateNamePresent",!1,{type:"boolean",description:m.localize(46,null)}),e.$xJ=new A.$Rj("variableIsReadonly",!1,{type:"boolean",description:m.localize(47,null)}),e.$yJ=new A.$Rj("variableValue",!1,{type:"string",description:m.localize(48,null)}),e.$zJ=new A.$Rj("variableType",!1,{type:"string",description:m.localize(49,null)}),e.$AJ=new A.$Rj("variableInterfaces",!1,{type:"array",description:m.localize(50,null)}),e.$BJ=new A.$Rj("variableName",!1,{type:"string",description:m.localize(51,null)}),e.$CJ=new A.$Rj("variableLanguage",!1,{type:"string",description:m.localize(52,null)}),e.$DJ=new A.$Rj("variableExtensionId",!1,{type:"string",description:m.localize(53,null)}),e.$EJ=new A.$Rj("exceptionWidgetVisible",!1,{type:"boolean",description:m.localize(54,null)}),e.$FJ=new A.$Rj("multiSessionRepl",!1,{type:"boolean",description:m.localize(55,null)}),e.$GJ=new A.$Rj("multiSessionDebug",!1,{type:"boolean",description:m.localize(56,null)}),e.$HJ=new A.$Rj("disassembleRequestSupported",!1,{type:"boolean",description:m.localize(57,null)}),e.$IJ=new A.$Rj("disassemblyViewFocus",!1,{type:"boolean",description:m.localize(58,null)}),e.$JJ=new A.$Rj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:m.localize(59,null)}),e.$KJ=new A.$Rj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:m.localize(60,null)});const L=n=>m.localize(61,null,n);e.$LJ=L,e.$MJ="editor.contrib.debug",e.$NJ="editor.contrib.breakpoint",e.$OJ="debug",e.$PJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:m.localize(62,null)};var T;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(T||(e.State=T={}));function p(n){switch(n){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var c;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$RJ="vscode-debug-memory";function C(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var S;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var d;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(d||(e.DebugConfigurationProviderTriggerKind=d={}));var P;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$TJ=(0,R.$Ai)("debugService");var b;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var a;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var u;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(u||(e.DebugTreeItemCollapsibleState=u={}));var f;(function(n){n.deserialize=s=>s,n.serialize=s=>s})(f||(e.IDebugVisualizationTreeItem=f={}));var g;(function(n){n.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:r.URI.revive(s.iconPath.light),dark:r.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),n.serialize=s=>s})(g||(e.IDebugVisualization=g={}))}),define(ye[307],Se([1,0,13,2,16,25,15,31,21,19]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SH=void 0,e.$GH=S,e.$HH=d,e.$IH=P,e.$JH=b,e.$KH=a,e.$LH=u,e.$MH=f,e.$NH=n,e.$OH=t,e.$PH=l,e.$QH=o,e.$RH=E;const C=/{([^}]+)}/g;function S(D,v,I){return D.replace(C,function(w,y){return v&&y.length>0&&y[0]!=="_"?w:I&&I.hasOwnProperty(y)?I[y]:w})}function d(D){const v={};for(const I of Object.keys(D))I.startsWith("!")||(v[I]=D[I]);return v}function P(D){return D.configuration.request==="attach"&&!b(D)&&(!D.parentSession||P(D.parentSession))}function b(D){let v=D.configuration.type;if(v)return v==="vslsShare"&&(v=D.configuration.adapterProxy.configuration.type),(0,r.$Bf)(v,"extensionhost")||(0,r.$Bf)(v,"pwa-extensionhost")?D:D.parentSession?b(D.parentSession):void 0}function a(D){return D.type&&(D.label||D.program||D.runtime)}function u(D,v,I){let w,y=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=N.exec(D);){const U=O.index+1,j=U+O[0].length;if(U<=v&&j>=I){w=O[0],y=U;break}}if(w){const U=/\w+/g;let j=null;for(;(j=U.exec(w))&&!(j.index+1+y+j[0].length>=I););j&&(w=w.substring(0,U.lastIndex))}return w?{start:y,end:y+w.length-1}:{start:0,end:0}}async function f(D,v,I,w){if(D.evaluatableExpressionProvider.has(v)){const y=D.evaluatableExpressionProvider.ordered(v),N=(0,c.$Hb)(await Promise.all(y.map(async O=>{try{return await O.provideEvaluatableExpression(v,I,w??p.CancellationToken.None)}catch{return}})));if(N.length>0){let O=N[0].expression;const U=N[0].range;return O||(O=v.getLineContent(I.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:O}}}else{const y=v.getLineContent(I.lineNumber),{start:N,end:O}=u(y,I.column,I.column),U=y.substring(N-1,O);return{matchingExpression:U,range:new T.$ct(I.lineNumber,N,I.lineNumber,N+U.length)}}return null}const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(g))}function s(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return m.URI.parse(D.path);if((0,A.$ic)(D.path))return m.URI.file(D.path)}return D.path}function i(D){if(typeof D.path=="object"){const v=m.URI.revive(D.path);if(v)return v.scheme===L.Schemas.file?v.fsPath:v.toString()}return D.path}function t(D,v){const I=v?s:i,w=(0,R.$9n)(D);return h(w,(y,N)=>{y&&N&&(N.path=I(N))}),w}function l(D,v){const I=v?s:i,w=(0,R.$9n)(D);return h(w,(y,N)=>{!y&&N&&(N.path=I(N))}),w}function h(D,v){switch(D.type){case"event":{const I=D;switch(I.event){case"output":v(!1,I.body.source);break;case"loadedSource":v(!1,I.body.source);break;case"breakpoint":v(!1,I.body.breakpoint.source);break;default:break}break}case"request":{const I=D;switch(I.command){case"setBreakpoints":v(!0,I.arguments.source);break;case"breakpointLocations":v(!0,I.arguments.source);break;case"source":v(!0,I.arguments.source);break;case"gotoTargets":v(!0,I.arguments.source);break;case"launchVSCode":I.arguments.args.forEach(w=>v(!1,w));break;default:break}break}case"response":{const I=D;if(I.success&&I.body)switch(I.command){case"stackTrace":I.body.stackFrames.forEach(w=>v(!1,w.source));break;case"loadedSources":I.body.sources.forEach(w=>v(!1,w));break;case"scopes":I.body.scopes.forEach(w=>v(!1,w.source));break;case"setFunctionBreakpoints":I.body.breakpoints.forEach(w=>v(!1,w.source));break;case"setBreakpoints":I.body.breakpoints.forEach(w=>v(!1,w.source));break;case"disassemble":I.body?.instructions.forEach(y=>v(!1,y.location));break;default:break}break}}}function o(D){return D.filter(v=>!v.presentation?.hidden).sort((v,I)=>v.presentation?I.presentation?v.presentation.group?I.presentation.group?v.presentation.group!==I.presentation.group?v.presentation.group.localeCompare(I.presentation.group):$(v.presentation.order,I.presentation.order):-1:I.presentation.group?1:$(v.presentation.order,I.presentation.order):-1:I.presentation?1:0)}function $(D,v){return typeof D!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:D-v}async function E(D,v){const I=D.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(I!=="none"&&(await v.saveAll(),I==="allEditorsInActiveGroup")){const w=v.activeEditorPane;w&&w.input.resource?.scheme===L.Schemas.untitled&&await v.save({editor:w.input,groupId:w.group.id})}await D.reloadConfiguration()}const k=(D,v)=>!D||!v?D===v:D.name===v.name&&D.path===v.path&&D.sourceReference===v.sourceReference;e.$SH=k}),define(ye[308],Se([1,0,59,66,25,16,11,13,34,252,152]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5oc=e.$4oc=e.$3oc=e.$2oc=e.$1oc=void 0;class S extends C.$fsb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(f,g){this.l=g,this.p=Buffer.allocUnsafe(0),this.r=-1,f.on("data",n=>this.v(n))}sendMessage(f){if(this.l){const g=JSON.stringify(f);this.l.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${S.a}${g}`,"utf8")}}v(f){for(this.p=Buffer.concat([this.p,f]);;){if(this.r>=0){if(this.p.length>=this.r){const g=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(n){this.n.fire(new Error((n.message||n)+`
`+g))}continue}}else{const g=this.p.indexOf(S.a);if(g!==-1){const s=this.p.toString("utf8",0,g).split(S.b);for(const i of s){const t=i.split(S.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(g+S.a.length);continue}}break}}}e.$1oc=S;class d extends S{startSession(){return new Promise((f,g)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),f(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.x.on("error",s=>{n?this.n.fire(s):g(s)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$2oc=d;class P extends d{constructor(f){super(),this.z=f}y(f){return m.createConnection(this.z.port,this.z.host||"127.0.0.1",f)}}e.$3oc=P;class b extends d{constructor(f){super(),this.z=f}y(f){return m.createConnection(this.z.path,f)}}e.$4oc=b;class a extends S{constructor(f,g){super(),this.y=f,this.z=g}async startSession(){const f=this.y.command,g=this.y.args,n=this.y.options||{};try{if(f)if(R.$ic(f)){if(!await p.Promises.exists(f))throw new Error(c.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(c.localize(1,null,this.z));let s=process.env;if(n.env&&Object.keys(n.env).length>0&&(s=A.$_n(A.$9n(process.env),n.env)),f==="node")if(Array.isArray(g)&&g.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:s,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const l=r.fork(g[0],g.slice(1),t);if(!l.pid)throw new Error(c.localize(2,null,g[0]));this.x=l}else throw new Error(c.localize(3,null));else{const i={env:s};n.cwd&&(i.cwd=n.cwd),this.x=r.spawn(f,g,i)}this.x.on("error",i=>{this.n.fire(i)}),this.x.on("exit",(i,t)=>{this.o.fire(i)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",i=>{this.n.fire(i)}),this.x.stdin.on("error",i=>{this.n.fire(i)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(s){this.n.fire(s)}}async stopSession(){return this.x?(await this.w(),L.$i?new Promise((f,g)=>{const n=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(s,i,t){if(s)return g(s)});n.on("exit",f),n.on("error",g)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(f,g){if(!f)return;const n=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?n.runtime=R.$jc(g,f.runtime):n.runtime=f.runtime),f.runtimeArgs&&(n.runtimeArgs=f.runtimeArgs),f.program&&(R.$ic(f.program)?n.program=f.program:n.program=R.$jc(g,f.program)),f.args&&(n.args=f.args);const s=f;return s.win&&(n.win=a.A(s.win,g)),s.winx86&&(n.winx86=a.A(s.winx86,g)),s.windows&&(n.windows=a.A(s.windows,g)),s.osx&&(n.osx=a.A(s.osx,g)),s.linux&&(n.linux=a.A(s.linux,g)),n}static platformAdapterExecutable(f,g){let n=Object.create(null);g=g.toLowerCase();for(const o of f)if(o.contributes){const $=o.contributes.debuggers;$&&$.length>0&&$.filter(E=>typeof E.type=="string"&&T.$Bf(E.type,g)).forEach(E=>{const k=a.A(E,o.extensionLocation.fsPath);n=A.$_n(n,k,o.isBuiltin)})}let s;L.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=n.winx86||n.win||n.windows:L.$i?s=n.win||n.windows:L.$j?s=n.osx:L.$k&&(s=n.linux),s=s||n;const i=s.program||n.program,t=s.args||n.args,l=s.runtime||n.runtime,h=s.runtimeArgs||n.runtimeArgs;if(l)return{type:"executable",command:l,args:(h||[]).concat(typeof i=="string"?[i]:[]).concat(t||[])};if(i)return{type:"executable",command:i,args:t||[]}}}e.$5oc=a}),define(ye[309],Se([1,0,59,33,11]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=L,e.$7oc=p;function R(c,C){return new Promise((S,d)=>{let P="";const b=r.spawn(c,C);b.pid&&b.stdout.on("data",a=>{P+=a.toString()}),b.on("error",a=>{d(a)}),b.on("close",a=>{S(P)})})}async function L(c){if(c)if(A.$i){const C=await new Promise((S,d)=>{de(["@vscode/windows-process-tree"],S,d)});return new Promise(S=>{C.getProcessTree(c,d=>{S(!!d&&d.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(c)]).then(C=>{const S=C.trim();return!(S.length===0||S.indexOf(" tmux")>=0)},C=>!0);return Promise.resolve(!0)}var T;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(T||(T={}));function p(c,C,S,d,P){c=c.trim().toLowerCase();let b;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?b=T.powershell:c.indexOf("cmd.exe")>=0?b=T.cmd:c.indexOf("bash")>=0?b=T.bash:A.$i?b=T.cmd:b=T.bash;let a,u=" ";switch(b){case T.powershell:if(a=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),d){const f=(0,m.$Fg)(d);f&&(u+=`${f}:; `),u+=`cd ${a(d)}; `}if(P)for(const f in P){const g=P[f];g===null?u+=`Remove-Item env:${f}; `:u+=`\${env:${f}}='${g}'; `}if(C.length>0){const f=C.shift(),g=S?f:a(f);u+=g[0]==="'"?`& ${g} `:`${g} `;for(const n of C)u+=n==="<"||n===">"||S?n:a(n),u+=" "}break;case T.cmd:if(a=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>f.includes(g))||f.length===0?`"${f}"`:f),d){const f=(0,m.$Fg)(d);f&&(u+=`${f}: && `),u+=`cd ${a(d)} && `}if(P){u+='cmd /C "';for(const f in P){let g=P[f];g===null?u+=`set "${f}=" && `:(g=g.replace(/[&^|<>]/g,n=>`^${n}`),u+=`set "${f}=${g}" && `)}}for(const f of C)u+=f==="<"||f===">"||S?f:a(f),u+=" ";P&&(u+='"');break;case T.bash:{a=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),g.length===0?'""':g);const f=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(d&&(u+=`cd ${a(d)} ; `),P){u+="/usr/bin/env";for(const g in P){const n=P[g];n===null?u+=` -u ${f(g)}`:u+=` ${f(`${g}=${n}`)}`}u+=" "}for(const g of C)u+=g==="<"||g===">"||S?g:a(g),u+=" ";break}}return u}}),define(ye[310],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=e.CellExecutionUpdateType=void 0;var m;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(m||(e.CellExecutionUpdateType=m={})),e.$_J=(0,r.$Ai)("INotebookExecutionService")}),define(ye[311],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujb=e.$tjb=e.ProxyKernelState=e.$sjb=void 0,e.$sjb=100;var m;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(m||(e.ProxyKernelState=m={})),e.$tjb=(0,r.$Ai)("INotebookKernelService"),e.$ujb=(0,r.$Ai)("INotebookKernelHistoryService")}),define(ye[312],Se([1,0,3,31,55,213,106]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Xb=void 0;class T extends r.$Uc{constructor(c,C,S){super(),this._source=c,this.b=C,this.c=S,this.a=void 0}f(c){const C=c.getLineCount();return new m.$ct(1,1,C,this.g(c,C))}g(c,C){if(C<1||C>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(C)+1}get inputTextBuffer(){if(!this.b){const c=new R.$aD;c.acceptChunk(this._source);const C=c.finish(!0),{textBuffer:S,disposable:d}=C.create(A.DefaultEndOfLine.LF);this.b=S,this.B(d)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const C=new R.$aD;C.acceptChunk(c);const S=C.finish(!0),{textBuffer:d,disposable:P}=S.create(A.DefaultEndOfLine.LF);return this.B(P),d})),this.a}findInInputs(c){const S=new L.$1C(c,!1,!1,null).parseSearchRequest();if(!S)return[];const d=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(d,S,!0,5e3)}findInOutputs(c){const S=new L.$1C(c,!1,!1,null).parseSearchRequest();return S?this.outputTextBuffers.map(d=>{const P=d.findMatchesLineByLine(this.f(d),S,!0,5e3);if(P.length!==0)return{textBuffer:d,matches:P}}).filter(d=>!!d):[]}}e.$0Xb=T}),define(ye[73],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(R){R.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var m;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(m||(e.TestPosition=m={}));class A{static fromExtHostTestItem(L,T,p=L.parent){if(L._isRoot)return new A([T]);const c=[L.id];for(let C=p;C&&C.id!==T;C=C.parent)c.push(C.id);return c.push(T),new A(c.reverse())}static isRoot(L){return!L.includes(r.Delimiter)}static root(L){const T=L.indexOf(r.Delimiter);return T===-1?L:L.slice(0,T)}static fromString(L){return new A(L.split(r.Delimiter))}static join(L,T){return new A([...L.path,T])}static joinToString(L,T){return L.toString()+r.Delimiter+T}static parentId(L){const T=L.lastIndexOf(r.Delimiter);return T===-1?void 0:L.slice(0,T)}static localId(L){const T=L.lastIndexOf(r.Delimiter);return T===-1?L:L.slice(T+r.Delimiter.length)}static isChild(L,T){return T.startsWith(L)&&T[L.length]===r.Delimiter}static compare(L,T){return L===T?m.IsSame:A.isChild(L,T)?m.IsChild:A.isChild(T,L)?m.IsParent:m.Disconnected}static getLengthOfCommonPrefix(L,T){if(L===0)return 0;let p=0;for(;p<L-1;){for(let c=1;c<L;c++){const C=T(c-1),S=T(c);if(C.path[p]!==S.path[p])return p}p++}return p}constructor(L,T=L.length){if(this.path=L,this.d=T,L.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new A(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new A(this.path,L)}compare(L){if(typeof L=="string")return A.compare(this.toString(),L);for(let T=0;T<L.d&&T<this.d;T++)if(L.path[T]!==this.path[T])return m.Disconnected;return L.d>this.d?m.IsChild:L.d<this.d?m.IsParent:m.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+=r.Delimiter,this.c+=this.path[L]}return this.c}}e.$gL=A}),define(ye[74],Se([1,0,2,54,31,73]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$oL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$nL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$mL=e.$lL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$kL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$jL=e.$iL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$hL=e.TestResultState=void 0;var L;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.$hL={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var T;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var p;(function(z){z[z.Run=2]="Run",z[z.Debug=4]="Debug",z[z.Coverage=8]="Coverage",z[z.HasNonDefaultProfile=16]="HasNonDefaultProfile",z[z.HasConfigurable=32]="HasConfigurable",z[z.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$iL=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const c=z=>"runId"in z;e.$jL=c;var C;(function(z){z.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),z.deserialize=(M,F)=>({range:A.$ct.lift(F.range),uri:M.asCanonicalUri(r.URI.revive(F.uri))})})(C||(e.IRichLocation=C={}));var S;(function(z){z[z.Error=0]="Error",z[z.Output=1]="Output"})(S||(e.TestMessageType=S={}));var d;(function(z){z.serialize=M=>({message:M.message,type:S.Error,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&C.serialize(M.location)}),z.deserialize=(M,F)=>({message:F.message,type:S.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&C.deserialize(M,F.location)})})(d||(e.ITestErrorMessage=d={}));const P=(z,M)=>`${M?"s":"e"}${z}`;e.$kL=P;var b;(function(z){z.serialize=M=>({message:M.message,type:S.Output,offset:M.offset,length:M.length,location:M.location&&C.serialize(M.location)}),z.deserialize=(M,F)=>({message:F.message,type:S.Output,offset:F.offset,length:F.length,location:F.location&&C.deserialize(M,F.location)})})(b||(e.ITestOutputMessage=b={}));var a;(function(z){z.serialize=M=>M.type===S.Error?d.serialize(M):b.serialize(M),z.deserialize=(M,F)=>F.type===S.Error?d.deserialize(M,F):b.deserialize(M,F)})(a||(e.ITestMessage=a={}));var u;(function(z){z.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),z.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(a.serialize)}),z.deserialize=(M,F)=>({state:F.state,duration:F.duration,messages:F.messages.map(J=>a.deserialize(M,J))})})(u||(e.ITestTaskState=u={}));const f="\0",g=(z,M)=>z+f+M;e.$lL=g;const n=z=>{const M=z.indexOf(f);return{ctrlId:z.slice(0,M),tagId:z.slice(M+1)}};e.$mL=n;var s;(function(z){z.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),z.deserialize=(M,F)=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?M.asCanonicalUri(r.URI.revive(F.uri)):void 0,range:F.range?A.$ct.lift(F.range):null,description:F.description,error:F.error,sortText:F.sortText})})(s||(e.ITestItem=s={}));var i;(function(z){z[z.NotExpandable=0]="NotExpandable",z[z.Expandable=1]="Expandable",z[z.BusyExpanding=2]="BusyExpanding",z[z.Expanded=3]="Expanded"})(i||(e.TestItemExpandState=i={}));var t;(function(z){z.serialize=M=>({expand:M.expand,item:s.serialize(M.item)}),z.deserialize=(M,F)=>({controllerId:R.$gL.root(F.item.extId),expand:F.expand,item:s.deserialize(M,F.item)})})(t||(e.InternalTestItem=t={}));var l;(function(z){z.serialize=M=>{let F;return M.item&&(F={},M.item.label!==void 0&&(F.label=M.item.label),M.item.tags!==void 0&&(F.tags=M.item.tags),M.item.busy!==void 0&&(F.busy=M.item.busy),M.item.uri!==void 0&&(F.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(F.range=M.item.range?.toJSON()),M.item.description!==void 0&&(F.description=M.item.description),M.item.error!==void 0&&(F.error=M.item.error),M.item.sortText!==void 0&&(F.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:F}},z.deserialize=M=>{let F;return M.item&&(F={},M.item.label!==void 0&&(F.label=M.item.label),M.item.tags!==void 0&&(F.tags=M.item.tags),M.item.busy!==void 0&&(F.busy=M.item.busy),M.item.range!==void 0&&(F.range=M.item.range?A.$ct.lift(M.item.range):null),M.item.description!==void 0&&(F.description=M.item.description),M.item.error!==void 0&&(F.error=M.item.error),M.item.sortText!==void 0&&(F.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:F}}})(l||(e.ITestItemUpdate=l={}));const h=(z,M)=>{M.expand!==void 0&&(z.expand=M.expand),M.item!==void 0&&(z.item=z.item?Object.assign(z.item,M.item):M.item)};e.$nL=h;var o;(function(z){z.serializeWithoutMessages=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(u.serializeWithoutMessages)}),z.serialize=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(u.serialize)}),z.deserialize=(M,F)=>({...t.deserialize(M,F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(J=>u.deserialize(M,J)),retired:!0})})(o||(e.TestResultItem=o={}));var $;(function(z){z.empty=()=>({covered:0,total:0}),z.sum=(M,F)=>{M.covered+=F.covered,M.total+=F.total}})($||(e.ICoverageCount=$={}));var E;(function(z){z.serialize=M=>({id:M.id,statement:M.statement,branch:M.branch,declaration:M.declaration,testId:M.testId?.toString(),uri:M.uri.toJSON()}),z.deserialize=(M,F)=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testId:F.testId?R.$gL.fromString(F.testId):void 0,uri:M.asCanonicalUri(r.URI.revive(F.uri))}),z.empty=(M,F)=>({id:M,uri:F,testId:void 0,statement:$.empty()})})(E||(e.IFileCoverage=E={}));function k(z){return{...z,location:z.location?.toJSON()}}function D(z){return z.location=z.location?m.$bt.isIPosition(z.location)?m.$bt.lift(z.location):A.$ct.lift(z.location):void 0,z}e.$oL=3;var v;(function(z){z[z.Declaration=0]="Declaration",z[z.Statement=1]="Statement",z[z.Branch=2]="Branch"})(v||(e.DetailType=v={}));var I;(function(z){z.serialize=M=>M.type===v.Declaration?y.serialize(M):N.serialize(M),z.deserialize=M=>M.type===v.Declaration?y.deserialize(M):N.deserialize(M)})(I||(e.CoverageDetails=I={}));var w;(function(z){z.serialize=k,z.deserialize=D})(w||(e.IBranchCoverage=w={}));var y;(function(z){z.serialize=k,z.deserialize=D})(y||(e.IDeclarationCoverage=y={}));var N;(function(z){z.serialize=M=>({...k(M),branches:M.branches?.map(w.serialize)}),z.deserialize=M=>({...D(M),branches:M.branches?.map(w.deserialize)})})(N||(e.IStatementCoverage=N={}));var O;(function(z){z[z.Add=0]="Add",z[z.Update=1]="Update",z[z.DocumentSynced=2]="DocumentSynced",z[z.Remove=3]="Remove",z[z.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",z[z.Retire=5]="Retire",z[z.AddTag=6]="AddTag",z[z.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var U;(function(z){z.deserialize=(M,F)=>F.op===O.Add?{op:F.op,item:t.deserialize(M,F.item)}:F.op===O.Update?{op:F.op,item:l.deserialize(F.item)}:F.op===O.DocumentSynced?{op:F.op,uri:M.asCanonicalUri(r.URI.revive(F.uri)),docv:F.docv}:F,z.serialize=M=>M.op===O.Add?{op:M.op,item:t.serialize(M.item)}:M.op===O.Update?{op:M.op,item:l.serialize(M.item)}:M})(U||(e.TestsDiffOp=U={}));class j{constructor(M){this.k=M,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(M){const F=this.w();for(const J of M)switch(J.op){case O.Add:this.l(t.deserialize(this.k,J.item),F);break;case O.Update:this.p(l.deserialize(J.item),F);break;case O.Remove:this.q(J.itemId,F);break;case O.Retire:this.v(J.itemId);break;case O.IncrementPendingExtHosts:this.updatePendingRoots(J.amount);break;case O.AddTag:this.c.set(J.tag.id,J.tag);break;case O.RemoveTag:this.c.delete(J.id);break}F.complete?.()}l(M,F){const J=R.$gL.parentId(M.item.extId)?.toString();let ee;if(!J)ee=this.x(M),this.g.add(ee),this.f.set(M.item.extId,ee);else if(this.f.has(J)){const V=this.f.get(J);V.children.add(M.item.extId),ee=this.x(M,V),this.f.set(M.item.extId,ee)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return F.add?.(ee),M.expand===i.BusyExpanding&&this.h++,ee}p(M,F){const J=this.f.get(M.extId);if(J)return M.expand!==void 0&&(J.expand===i.BusyExpanding&&this.h--,M.expand===i.BusyExpanding&&this.h++),(0,e.$nL)(J,M),F.update?.(J),J}q(M,F){const J=this.f.get(M);if(!J)return;const ee=R.$gL.parentId(J.item.extId)?.toString();ee?this.f.get(ee).children.delete(J.item.extId):this.g.delete(J);const V=[[M]];for(;V.length;)for(const H of V.pop()){const _=this.f.get(H);_&&(V.push(_.children),this.f.delete(H),F.remove?.(_,_!==J),_.expand===i.BusyExpanding&&this.h--)}}v(M){}updatePendingRoots(M){this.j+=M}w(){return{}}}e.$pL=j}),define(ye[313],Se([1,0,135,255,74]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$_Eb=e.$$Eb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(S){S.ViewletId="workbench.view.extension.test",S.ExplorerViewId="workbench.view.testing",S.OutputPeekContributionId="editor.contrib.testingOutputPeek",S.DecorationsContributionId="editor.contrib.testingDecorations",S.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",S.CoverageViewId="workbench.view.testCoverage",S.ResultsPanelId="workbench.panel.testResults",S.ResultsViewId="workbench.panel.testResults.view",S.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var L;(function(S){S.List="list",S.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var T;(function(S){S.ByLocation="location",S.ByStatus="status",S.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const p={[A.TestResultState.Errored]:(0,m.localize)(0,null),[A.TestResultState.Failed]:(0,m.localize)(1,null),[A.TestResultState.Passed]:(0,m.localize)(2,null),[A.TestResultState.Queued]:(0,m.localize)(3,null),[A.TestResultState.Running]:(0,m.localize)(4,null),[A.TestResultState.Skipped]:(0,m.localize)(5,null),[A.TestResultState.Unset]:(0,m.localize)(6,null)},c=(S,d)=>(0,m.localize)(7,null,(0,r.$Tk)(S),p[d]);e.$$Eb=c,e.$_Eb={[A.TestRunProfileBitset.Debug]:(0,m.localize)(8,null),[A.TestRunProfileBitset.Run]:(0,m.localize)(9,null),[A.TestRunProfileBitset.Coverage]:(0,m.localize)(10,null)};var C;(function(S){S.CancelTestRefreshAction="testing.cancelTestRefresh",S.CancelTestRunAction="testing.cancelRun",S.ClearTestResultsAction="testing.clearTestResults",S.CollapseAllAction="testing.collapseAll",S.ConfigureTestProfilesAction="testing.configureProfile",S.ContinousRunUsingForTest="testing.continuousRunUsingForTest",S.CoverageAtCursor="testing.coverageAtCursor",S.CoverageByUri="testing.coverage.uri",S.CoverageClear="testing.coverage.close",S.CoverageCurrentFile="testing.coverageCurrentFile",S.CoverageFilterToTest="testing.coverageFilterToTest",S.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",S.CoverageLastRun="testing.coverageLastRun",S.CoverageSelectedAction="testing.coverageSelected",S.CoverageToggleToolbar="testing.coverageToggleToolbar",S.CoverageViewChangeSorting="testing.coverageViewChangeSorting",S.DebugAction="testing.debug",S.DebugAllAction="testing.debugAll",S.DebugAtCursor="testing.debugAtCursor",S.DebugByUri="testing.debug.uri",S.DebugCurrentFile="testing.debugCurrentFile",S.DebugFailedTests="testing.debugFailTests",S.DebugLastRun="testing.debugLastRun",S.DebugSelectedAction="testing.debugSelected",S.FilterAction="workbench.actions.treeView.testExplorer.filter",S.GetExplorerSelection="_testing.getExplorerSelection",S.GetSelectedProfiles="testing.getSelectedProfiles",S.GoToTest="testing.editFocusedTest",S.HideTestAction="testing.hideTest",S.OpenCoverage="testing.openCoverage",S.OpenOutputPeek="testing.openOutputPeek",S.RefreshTestsAction="testing.refreshTests",S.ReRunFailedTests="testing.reRunFailTests",S.ReRunLastRun="testing.reRunLastRun",S.RunAction="testing.run",S.RunAllAction="testing.runAll",S.RunAllWithCoverageAction="testing.coverageAll",S.RunAtCursor="testing.runAtCursor",S.RunByUri="testing.run.uri",S.RunCurrentFile="testing.runCurrentFile",S.RunSelectedAction="testing.runSelected",S.RunUsingProfileAction="testing.runUsing",S.RunWithCoverageAction="testing.coverage",S.SearchForTestExtension="testing.searchForTestExtension",S.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",S.ShowMostRecentOutputAction="testing.showMostRecentOutput",S.StartContinousRun="testing.startContinuousRun",S.StopContinousRun="testing.stopContinuousRun",S.TestingSortByDurationAction="testing.sortByDuration",S.TestingSortByLocationAction="testing.sortByLocation",S.TestingSortByStatusAction="testing.sortByStatus",S.TestingViewAsListAction="testing.viewAsList",S.TestingViewAsTreeAction="testing.viewAsTree",S.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",S.ToggleInlineTestOutput="testing.toggleInlineTestOutput",S.UnhideAllTestsAction="testing.unhideAllTests",S.UnhideTestAction="testing.unhideTest"})(C||(e.TestCommandId=C={}))}),define(ye[120],Se([1,0,9,4,3,65,74,73]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.TestItemEventOp=void 0;var p;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const c=(g,n)=>g===n,S=Object.entries({range:(g,n)=>g===n?!0:!g||!n?!1:g.equalsRange(n),busy:c,label:c,description:c,error:c,sortText:c,tags:(g,n)=>!(g.length!==n.length||g.some(s=>!n.includes(s)))}),d=(g,n)=>{let s;for(const[i,t]of S)t(g[i],n[i])||(s?s[i]=n[i]:s={[i]:n[i]});return s};class P extends A.$Uc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new r.$Mh(()=>this.flushDiff(),200)),this.g=this.B(new m.$he),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case L.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===L.TestDiffOpType.DocumentSynced&&s.uri===n.uri){s.docv=n.docv;return}break}case L.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===L.TestDiffOpType.Update&&s.item.extId===n.item.extId){(0,L.$nL)(s.item,n.item);return}if(s.op===L.TestDiffOpType.Add&&s.item.item.extId===n.item.extId){(0,L.$nL)(s.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,s){const i=this.tree.get(n);if(i){if((i.expandLevels===void 0||s>i.expandLevels)&&(i.expandLevels=s),i.expand===L.TestItemExpandState.Expandable){const t=this.M(i);return t.isOpen()?this.L(i,s-1):t.wait().then(()=>this.L(i,s-1))}else if(i.expand===L.TestItemExpandState.Expanded)return i.resolveBarrier?.isOpen()===!1?i.resolveBarrier.wait().then(()=>this.L(i,s-1)):this.L(i,s-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,s){switch(s.op){case p.RemoveChild:this.O(T.$gL.joinToString(n.fullId,s.id));break;case p.Upsert:this.z(s.item,n);break;case p.Bulk:for(const i of s.ops)this.w(n,i);break;case p.SetTags:this.C(s.new,s.old,n.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(n);break;case p.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:s.update}});break;case p.DocumentSynced:this.y(n.actual.uri);break;default:(0,R.$ed)(s)}}y(n){n&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,s){const i=T.$gL.fromExtHostTestItem(n,this.root.id,s?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==s?.actual&&this.s.getChildren(t.parent).delete(n.id);let l=this.tree.get(i.toString());if(!l){l={fullId:i,actual:n,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},n.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(n,s),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(n)}}),this.I(n,l,s);return}if(l.actual===n){this.H(n,l,s);return}if(l.actual.uri?.toString()!==n.uri?.toString())return this.O(i.toString()),this.z(n,s);const h=this.s.getChildren(l.actual),o=l.actual,$=d(this.s.toITestItem(o),this.s.toITestItem(n));this.s.getApiFor(o).listener=void 0,l.actual=n,l.resolveBarrier=void 0,l.expand=L.TestItemExpandState.NotExpandable,$&&($.hasOwnProperty("tags")&&(this.C(n.tags,o.tags,i.toString()),delete $.tags),this.w(l,{op:p.SetProp,update:$})),this.I(n,l,s);for(const[k,D]of h)this.s.getChildren(n).get(D.id)||this.O(T.$gL.joinToString(i,D.id));const E=l.expandLevels;E!==void 0&&queueMicrotask(()=>{l.expand===L.TestItemExpandState.Expandable&&(l.expandLevels=void 0,this.expand(i.toString(),E))}),this.y(l.actual.uri)}C(n,s,i){const t=new Set(s.map(l=>l.id));for(const l of n)t.delete(l.id)||this.D(l);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i,item:{tags:n.map(l=>(0,L.$lL)(this.s.controllerId,l.id))}}}),t.forEach(this.F,this)}D(n){const s=this.j.get(n.id);s?s.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.$lL)(this.s.controllerId,n.id)}}))}F(n){const s=this.j.get(n);s&&!--s.refCount&&(this.j.delete(n),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.$lL)(this.s.controllerId,n)}))}G(n,s){this.s.getApiFor(n).parent=s&&s.actual!==this.root?s.actual:void 0}H(n,s,i){this.G(n,i);const t=this.s.getApiFor(n);t.parent=i?.actual,t.listener=l=>this.w(s,l),this.J(s)}I(n,s,i){this.H(n,s,i);for(const[t,l]of this.s.getChildren(n))this.z(l,s)}J(n){let s;this.h?n.resolveBarrier?s=n.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:s=n.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:s=L.TestItemExpandState.NotExpandable,s!==n.expand&&(n.expand=s,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:s}}),s===L.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.M(n))}L(n,s){if(s<0)return;const i=[];for(const[t,l]of this.s.getChildren(n.actual)){const h=this.expand(T.$gL.joinToString(n.fullId,l.id),s);(0,r.$mh)(h)&&i.push(h)}if(i.length)return Promise.all(i).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const l=new r.$zh;return l.open(),l}n.expand=L.TestItemExpandState.BusyExpanding,this.N(n);const s=n.resolveBarrier=new r.$zh,i=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(l){i(l)}return(0,r.$mh)(t)?t.catch(i).then(()=>{s.open(),this.J(n)}):(s.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const s=this.tree.get(n);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:n});const i=[s];for(;i.length;){const t=i.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const l of t.actual.tags)this.F(l.id);this.tree.delete(t.fullId.toString());for(const[l,h]of this.s.getChildren(t.actual))i.push(this.tree.get(T.$gL.joinToString(t.fullId,h.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$OO=P;class b extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$PO=b;class a extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$QO=a;class u extends Error{constructor(n,s,i){super(`TestItem with ID "${n}" is from controller "${s}" and cannot be added as a child of an item from controller "${i}".`)}}e.$RO=u;const f=(g,n,s)=>{let i=new Map;return{get size(){return i.size},forEach(t,l){for(const h of i.values())t.call(l,h,this)},[Symbol.iterator](){return i.entries()},replace(t){const l=new Map,h=new Set(i.keys()),o={op:p.Bulk,ops:[]};for(const $ of t){if(!($ instanceof s))throw new a($.id);const E=n($).controllerId;if(E!==g.controllerId)throw new u($.id,E,g.controllerId);if(l.has($.id))throw new b($.id);l.set($.id,$),h.delete($.id),o.ops.push({op:p.Upsert,item:$})}for(const $ of h.keys())o.ops.push({op:p.RemoveChild,id:$});g.listener?.(o),i=l},add(t){if(!(t instanceof s))throw new a(t.id);i.set(t.id,t),g.listener?.({op:p.Upsert,item:t})},delete(t){i.delete(t)&&g.listener?.({op:p.RemoveChild,id:t})},get(t){return i.get(t)},toJSON(){return Array.from(i.values())}}};e.$SO=f}),define(ye[153],Se([1,0,120]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=void 0;const m=new WeakMap,A=(L,T)=>{const p={controllerId:T};return m.set(L,p),p};e.$TO=A;const R=L=>{const T=m.get(L);if(!T)throw new r.$QO(L?.id||"<unknown>");return T};e.$UO=R}),define(ye[121],Se([1,0,27,15,2]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FBb=e.$EBb=e.$DBb=void 0,e.$GBb=R,e.$HBb=T,e.$DBb="vscode-cdn.net",e.$EBb=`vscode-resource.${e.$DBb}`,e.$FBb=`'self' https://*.${e.$DBb}`;function R(p,c){return p.scheme===m.Schemas.http||p.scheme===m.Schemas.https?p:(c&&c.authority&&c.isRemote&&p.scheme===m.Schemas.file&&(p=A.URI.from({scheme:m.Schemas.vscodeRemote,authority:c.authority,path:p.path})),A.URI.from({scheme:m.Schemas.https,authority:`${p.scheme}+${L(p.authority)}.${e.$EBb}`,path:p.path,fragment:p.fragment,query:p.query}))}function L(p){return p.replace(/./g,c=>{const C=c.charCodeAt(0);return C>=r.CharCode.a&&C<=r.CharCode.z||C>=r.CharCode.A&&C<=r.CharCode.Z||C>=r.CharCode.Digit0&&C<=r.CharCode.Digit9?c:"-"+C.toString(16).padStart(4,"0")})}function T(p){return p.replace(/-([0-9a-f]{4})/g,(c,C)=>String.fromCharCode(parseInt(C,16)))}}),define(ye[314],Se([1,0,4,3,121]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;class R{constructor(T,p,c){this.d=T,this.e=p,this.f=c,this.a=0,this.b=new m.$Tc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const C=p.getVisibleTextEditors();for(const S of this.c.values())C.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,p,c,C,S){let d;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===T){d=n;break}if(!d)throw new Error("not a visible editor");const P=this,b=this.a++,a=new r.$he,u=new r.$he,f=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,A.$GBb)(n,P.f)}get cspSource(){return A.$FBb}set options(n){this.b=n,P.d.$setOptions(b,n)}get options(){return this.b}set html(n){this.a=n,P.d.$setHtml(b,n)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(n){return P.d.$postMessage(b,n)}},g=new class{constructor(){this.editor=T,this.line=p,this.height=c,this.webview=f,this.onDidDispose=u.event}dispose(){P.c.has(b)&&(P.c.delete(b),P.d.$disposeEditorInset(b),u.fire(),u.dispose(),a.dispose())}};return this.d.$createEditorInset(b,d.id,d.value.document.uri,p+1,c,C||{},S.identifier,S.extensionLocation),this.c.set(b,{editor:T,inset:g,onDidReceiveMessage:a}),g}$onDidDispose(T){const p=this.c.get(T);p&&p.inset.dispose()}$onDidReceiveMessage(T,p){this.c.get(T)?.onDidReceiveMessage.fire(p)}}e.$2mc=R}),define(ye[154],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.$xL=e.$wL=void 0,e.$wL="__",e.$xL=(0,r.$Ai)("IAuthenticationService"),e.$yL=(0,r.$Ai)("IAuthenticationExtensionsService")}),define(ye[315],Se([1,0,5]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=e.VariableKind=e.$MP=void 0,e.$MP=(0,r.$Ai)("configurationResolverService");var m;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(m||(e.VariableKind=m={}));class A extends Error{constructor(L,T){super(T),this.variable=L}}e.$NP=A}),define(ye[316],Se([1,0,16,56,18,25,11,109,256,315,13]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(P,b,a,u){this.h=new Map,this.a=P,this.b=b,this.g=a,u&&(this.c=u.then(f=>this.i(f)))}i(P){if(L.$i){const b=Object.create(null);return Object.keys(P).forEach(a=>{b[a.toLowerCase()]=P[a]}),b}return P}resolveWithEnvironment(P,b,a){return this.l({env:this.i(P),userHome:void 0},b?b.uri:void 0,a)}async resolveAsync(P,b){const a={env:await this.c,userHome:await this.g};return this.l(a,P?P.uri:void 0,b)}async j(P,b,a,u){const f=R.$9n(b);L.$i&&f.windows?Object.keys(f.windows).forEach(n=>f[n]=f.windows[n]):L.$j&&f.osx?Object.keys(f.osx).forEach(n=>f[n]=f.osx[n]):L.$k&&f.linux&&Object.keys(f.linux).forEach(n=>f[n]=f.linux[n]),delete f.windows,delete f.osx,delete f.linux;const g={env:await this.c,userHome:await this.g};return this.l(g,P?P.uri:void 0,f,a,u)}async resolveAnyAsync(P,b,a){return this.j(P,b,a)}async resolveAnyMap(P,b,a){const u=new Map;return{newConfig:await this.j(P,b,a,u),resolvedVariables:u}}resolveWithInteractionReplace(P,b,a,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,b,a,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,b){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,b)}async l(P,b,a,u,f){if(A.$ag(a))return this.m(P,b,a,u,f);if(Array.isArray(a))return Promise.all(a.map(g=>this.l(P,b,g,u,f)));if(A.$cg(a)){const g=Object.create(null),n=await Promise.all(Object.keys(a).map(async s=>[await this.m(P,b,s,u,f),await this.l(P,b,a[s],u,f)]));for(const[s,i]of n)g[s]=i;return g}return a}m(P,b,a,u,f){return(0,C.$tf)(a,S.VARIABLE_REGEXP,async(g,n)=>{if(n.includes(S.VARIABLE_LHS))return g;let s=await this.o(P,g,n,b,u);return f?.set(n,s),s!==g&&A.$ag(s)&&s.match(S.VARIABLE_REGEXP)&&(s=await this.m(P,b,s,u,f)),s})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,b,a,u,f){let g;const n=a.split(":");n.length>1&&(a=n[0],g=n[1]);const s=l=>{const h=this.a.getFilePath();if(h)return(0,T.$Nw)(h);throw new c.$NP(l,(0,p.localize)(0,null,b))},i=l=>{const h=s(l);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,T.$Nw)(o)}throw new c.$NP(l,(0,p.localize)(1,null,b,r.$nc(h)))},t=l=>{if(g){const h=this.a.getFolderUri(g);if(h)return h;throw new c.$NP(l,(0,p.localize)(2,null,b,g))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new c.$NP(l,(0,p.localize)(3,null,b)):new c.$NP(l,(0,p.localize)(4,null,b))};switch(a){case"env":if(g){if(P.env){const l=P.env[L.$i?g.toLowerCase():g];if(A.$ag(l))return l}return""}throw new c.$NP(c.VariableKind.Env,(0,p.localize)(5,null,b));case"config":if(g){const l=this.a.getConfigurationValue(u,g);if(A.$jg(l))throw new c.$NP(c.VariableKind.Config,(0,p.localize)(6,null,b,g));if(A.$cg(l))throw new c.$NP(c.VariableKind.Config,(0,p.localize)(7,null,b,g));return l}throw new c.$NP(c.VariableKind.Config,(0,p.localize)(8,null,b));case"command":return this.p(c.VariableKind.Command,b,g,f,"command");case"input":return this.p(c.VariableKind.Input,b,g,f,"input");case"extensionInstallFolder":if(g){const l=await this.a.getExtension(g);if(!l)throw new c.$NP(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,b,g));return this.n(l.extensionLocation)}throw new c.$NP(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,b));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,T.$Nw)(this.n(t(c.VariableKind.WorkspaceFolder)));case"cwd":return u||g?(0,T.$Nw)(this.n(t(c.VariableKind.Cwd))):m.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Nw)(r.$nc(this.n(t(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new c.$NP(c.VariableKind.UserHome,(0,p.localize)(11,null,b))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new c.$NP(c.VariableKind.LineNumber,(0,p.localize)(12,null,b))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new c.$NP(c.VariableKind.SelectedText,(0,p.localize)(13,null,b))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return i(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$nc(i(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return u||g?r.$lc(this.n(t(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const l=r.$mc(s(c.VariableKind.RelativeFileDirname));if(u||g){const h=r.$lc(this.n(t(c.VariableKind.RelativeFileDirname)),l);return h.length===0?".":h}return l}case"fileDirname":return r.$mc(s(c.VariableKind.FileDirname));case"fileExtname":return r.$oc(s(c.VariableKind.FileExtname));case"fileBasename":return r.$nc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=r.$nc(s(c.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-r.$oc(l).length)}case"fileDirnameBasename":return r.$nc(r.$mc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||b}case"execInstallFolder":{const l=this.a.getAppRoot();return l||b}case"pathSeparator":case"/":return r.sep;default:try{const l=g?`${a}:${g}`:a;return this.p(c.VariableKind.Unknown,b,l,f,void 0)}catch{return b}}}}p(P,b,a,u,f){if(a&&u){const g=f===void 0?u[a]:u[f+":"+a];if(typeof g=="string")return g;throw new c.$NP(P,(0,p.localize)(14,null,b))}return b}}e.$3P=S}),define(ye[155],Se([1,0,5,151]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$0D=void 0,e.$$D=c,e.$_D=d,e.$aE=P,e.$0D=(0,r.$Ai)("editorGroupsService");var A;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var R;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var T;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var p;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function c(b){const a=b;return(0,m.$UF)(a?.editor)&&(0,m.$UF)(a?.replacement)}var C;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C||(e.GroupsOrder=C={}));var S;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function d(b){const a=b;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function P(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?A.DOWN:A.RIGHT}}),define(ye[317],Se([1,0,5,155]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eE=e.$dE=e.$cE=e.$bE=void 0,e.$fE=A,e.$bE=(0,r.$Ai)("editorService"),e.$cE=-1,e.$dE=-2,e.$eE=-3;function A(R){const L=R;return typeof R=="number"||(0,m.$_D)(L)}}),define(ye[156],Se([1,0,5,143]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=void 0,e.$RL=(0,r.$Bi)(m.$Hi)}),define(ye[157],Se([1,0,24,4,16,3,9]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=e.$dbc=e.$cbc=e.$bbc=e.$abc=void 0;class T{constructor(g,n){this.versionId=g,this.removedDueToLooping=n}}e.$abc=T;class p{static isHostExtension(g,n,s){if(n.getExtensionDescription(g))return!1;const i=s.getExtensionDescription(g);return i?!!((i.main||i.browser)&&i.api==="none"):!1}constructor(g,n){this.j=g,this.c=new m.$he,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(a),this.f=new r.$Ym,this.g=[],this.h=new Map;for(const g of this.e){if(this.f.has(g.identifier)){console.error("Extension `"+g.identifier.value+"` is already registered");continue}this.f.set(g.identifier,g),this.g.push(g);const n=this.j.readActivationEvents(g);for(const s of n)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(g)}}set(g){return this.e=g,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(g,n){this.e=u(this.e,n),this.e=this.e.concat(g);const s=p.l(this.e);return this.e=u(this.e,s.map(i=>i.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,s)}static l(g){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,o){this.addNode(h),this.addNode(o),this.c.has(h)?this.c.get(h).push(o):this.c.set(h,[o])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,o){const $=n.getArcs(h);for(let E=0;E<$.length;E++)if(!o.has($[E]))return!1;return!0}getNodes(){return this.e}},s=new r.$Ym;for(const h of g)if(s.set(h.identifier,h),h.extensionDependencies)for(const o of h.extensionDependencies)n.addArc(r.$Wm.toKey(h.identifier),r.$Wm.toKey(o));const i=new Set;n.getNodes().filter(h=>n.getArcs(h).length===0).forEach(h=>i.add(h));const t=n.getNodes().filter(h=>!i.has(h));let l;do{l=!1;for(let h=0;h<t.length;h++){const o=t[h];n.hasOnlyGoodArcs(o,i)&&(t.splice(h,1),h--,i.add(o),l=!0)}}while(l);return t.map(h=>s.get(h))}containsActivationEvent(g){return this.h.has(g)}containsExtension(g){return this.f.has(g)}getExtensionDescriptionsForActivationEvent(g){const n=this.h.get(g);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(g){const n=this.f.get(g);return n||void 0}getExtensionDescriptionByUUID(g){for(const n of this.g)if(n.uuid===g)return n}getExtensionDescriptionByIdOrUUID(g,n){return this.getExtensionDescription(g)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$bbc=p;class c{constructor(g,n){this.versionId=g,this.extensions=n}}e.$cbc=c;class C{constructor(g){this.d=new P,this.c=new p(g,[])}async acquireLock(g){const n=await this.d.acquire(g);return new S(this,n)}deltaExtensions(g,n,s){if(!g.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,s)}containsActivationEvent(g){return this.c.containsActivationEvent(g)}containsExtension(g){return this.c.containsExtension(g)}getExtensionDescriptionsForActivationEvent(g){return this.c.getExtensionDescriptionsForActivationEvent(g)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(g){return this.c.getExtensionDescription(g)}getExtensionDescriptionByUUID(g){return this.c.getExtensionDescriptionByUUID(g)}getExtensionDescriptionByIdOrUUID(g,n){return this.c.getExtensionDescriptionByIdOrUUID(g,n)}}e.$dbc=C;class S extends R.$Uc{constructor(g,n){super(),this.f=g,this.c=!1,this.B(n)}isAcquiredFor(g){return!this.c&&this.f===g}}e.$ebc=S;class d{constructor(g){this.name=g;const n=(0,L.$th)();this.promise=n.promise,this.c=n.resolve}resolve(g){this.c(g)}}class P{constructor(){this.c=[],this.d=!1}async acquire(g){const n=new d(g);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const g=this.c.shift();this.d=!0;let n=!0;const s=setTimeout(()=>{n&&console.warn(`The customer named ${g.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),i=()=>{n&&(clearTimeout(s),n=!1,this.d=!1,this.e())};g.resolve((0,R.$Sc)(i))}}var b;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(b||(b={}));function a(f,g){const n=f.isBuiltin?b.Builtin:f.isUnderDevelopment?b.Dev:b.User,s=g.isBuiltin?b.Builtin:g.isUnderDevelopment?b.Dev:b.User;if(n!==s)return n-s;const i=A.$gc.basename(f.extensionLocation.path),t=A.$gc.basename(g.extensionLocation.path);return i<t?-1:i>t?1:0}function u(f,g){const n=new r.$Xm(g);return f.filter(s=>!n.has(s.identifier))}}),define(ye[318],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.ExtHostConnectionType=void 0,e.$sn=T,e.$tn=p;var r;(function(C){C[C.IPC=1]="IPC",C[C.Socket=2]="Socket",C[C.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class m{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(S){this.pipeName=S,this.type=r.IPC}serialize(S){S[m.ENV_KEY]=this.pipeName}}e.$pn=m;class A{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(S){S[A.ENV_KEY]="1"}}e.$qn=A;class R{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(S){S[R.ENV_KEY]="1"}}e.$rn=R;function L(C){delete C[m.ENV_KEY],delete C[A.ENV_KEY],delete C[R.ENV_KEY]}function T(C,S){L(S),C.serialize(S)}function p(C){if(C[m.ENV_KEY])return c(C,new m(C[m.ENV_KEY]));if(C[A.ENV_KEY])return c(C,new A);if(C[R.ENV_KEY])return c(C,new R);throw new Error("No connection information defined in environment!")}function c(C,S){return L(C),S}}),define(ye[94],Se([1,0,22]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$5m=L,e.$6m=T;var m;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(m||(e.UIKind=m={}));var A;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var R;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(c){const C=r.$Je.alloc(1);switch(c){case R.Initialized:C.writeUInt8(1,0);break;case R.Ready:C.writeUInt8(2,0);break;case R.Terminate:C.writeUInt8(3,0);break}return C}function T(c,C){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return C===R.Initialized;case 2:return C===R.Ready;case 3:return C===R.Terminate;default:return!1}}var p;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(ye[95],Se([1,0,5,4,148,12,30,94,91,92,25,2,3,239]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$eP=e.$dP=void 0,e.$fP=u;let b=class extends d.$Uc{constructor(g,n){super(),this.s=g,this.t=n,this.a=this.B(new m.$he),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new m.$he),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=A.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=S.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:c.$sp,name:(0,P.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(s=>{(0,R.$9j)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===A.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=A.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=A.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=A.TelemetryLevel.USAGE:!1}}instantiateLogger(g,n,s){const i=this.getTelemetryDetails(),t=new a(n,s,g,this.n,this.j,this.getBuiltInCommonProperties(g),{isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}),l=this.r.get(g.identifier.value)??[];return this.r.set(g.identifier.value,[...l,t]),t.apiTelemetryLogger}$initializeTelemetryLevel(g,n,s){this.f=g,this.g=n,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(g){const n=Object.create(null);switch(n["common.extname"]=`${g.publisher}.${g.name}`,n["common.extversion"]=g.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=u(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:n["common.uikind"]="web";break;case T.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$Nm)((0,c.$yp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(g){this.h=this.getTelemetryConfiguration(),this.f=g;const n=this.getTelemetryDetails();this.r.forEach((s,i)=>{const t=s.filter(l=>!l.isDisposed);t.length===0?this.r.delete(i):this.r.set(i,t)}),this.r.forEach(s=>{for(const i of s)i.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(g,n){const i=this.r.get(g.value)?.filter(l=>!l.isDisposed);if(!i)return this.r.delete(g.value),!1;let t=!1;for(const l of i)l.ignoreUnhandledExtHostErrors||(l.logError(n),t=!0);return t}};e.$dP=b,e.$dP=b=Je([Ge(0,L.$cP),Ge(1,R.$8j)],b);class a{static validateSender(g){if(typeof g!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof g.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof g.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof g.flush<"u"&&typeof g.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(g,n,s,i,t,l,h){this.g=s,this.h=i,this.i=t,this.j=l,this.a=new m.$he,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=g,this.d={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(g,n){this.e&&(this.d={isUsageEnabled:g,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(g){let n="properties"in g?g.properties??{}:g;return n=(0,c.$Bp)(n,[]),this.c&&(n=(0,C.$_n)(n,this.c)),this.b||(n=(0,C.$_n)(n,this.j)),"properties"in g?g.properties=n:g=n,g}k(g,n){this.f&&(this.g.publisher==="vscode"?g=this.g.name+"/"+g:g=this.g.identifier.value+"/"+g,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(g,n),this.h.trace(g,n))}logUsage(g,n){this.d.isUsageEnabled&&this.k(g,n)}logError(g,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof g=="string")this.k(g,n);else{const s={name:g.name,message:g.message,stack:g.stack,cause:g.cause},i=(0,c.$Bp)(s,[]),t=new Error(i.message,{cause:i.cause});t.stack=i.stack,t.name=i.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(t,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const g=this,n={logUsage:g.logUsage.bind(g),get isUsageEnabled(){return g.d.isUsageEnabled},get isErrorsEnabled(){return g.d.isErrorsEnabled},logError:g.logError.bind(g),dispose:g.dispose.bind(g),onDidChangeEnableStates:g.a.event.bind(g)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let g=this.f;this.f=void 0,Promise.resolve(g.flush()).then(g=void 0),this.e=void 0}else this.f=void 0}}e.$eP=a;function u(f){const g=Date.now()-new Date(f).getTime();return isNaN(g)?!1:g<1e3*60*60*24}e.$gP=(0,r.$Ai)("IExtHostTelemetry")}),define(ye[26],Se([1,0,4,2,288,146,24,5]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.ActivationKind=e.$WG=e.$VG=e.$SG=e.ExtensionHostStartup=e.$RG=e.$QG=e.$PG=e.$OG=void 0,e.$TG=d,e.$UG=P,e.$XG=f,e.$YG=g,e.$OG=Object.freeze({identifier:new L.$Wm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:m.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$PG="extensions.webWorker",e.$QG=(0,T.$Ai)("extensionService");class p{constructor(i){this.dependency=i}}e.$RG=p;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class C{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(i,t,l){this.c=i,this.d=t.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$zG.createActivationEventsMap(this.d)}}set(i,t,l){if(this.c>i)throw new Error(`ExtensionHostExtensions: invalid versionId ${i} (current: ${this.c})`);const h=[],o=[],$=[],E=[],k=S(this.d),D=S(t),v=(O,U)=>O.extensionLocation.toString()===U.extensionLocation.toString()||O.isBuiltin===U.isBuiltin||O.isUserBuiltin===U.isUserBuiltin||O.isUnderDevelopment===U.isUnderDevelopment;for(const O of this.d){const U=D.get(O.identifier);if(!U){h.push(O.identifier),k.delete(O.identifier);continue}if(!v(O,U)){h.push(O.identifier),k.delete(O.identifier);continue}}for(const O of t){const U=k.get(O.identifier);if(!U){o.push(O);continue}if(!v(U,O)){h.push(U.identifier),k.delete(U.identifier);continue}}const I=new L.$Xm(this.e),w=new L.$Xm(l);for(const O of this.e)w.has(O)||$.push(O);for(const O of l)I.has(O)||E.push(O);const y=R.$zG.createActivationEventsMap(o),N={versionId:i,toRemove:h,toAdd:o,addActivationEvents:y,myToRemove:$,myToAdd:E};return this.delta(N),N}delta(i){if(this.c>=i.versionId)return null;const{toRemove:t,toAdd:l,myToRemove:h,myToAdd:o}=i,$=new L.$Xm(t),E=new L.$Xm(h);for(let k=0;k<this.d.length;k++)$.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)E.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of l)this.d.push(k);for(const k of o)this.e.push(k);return this.f=null,i}containsExtension(i){for(const t of this.e)if(L.$Wm.equals(t,i))return!0;return!1}containsActivationEvent(i){return this.f||(this.f=this.g()),this.f.has(i)}g(){const i=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const l=R.$zG.readActivationEvents(t);for(const h of l)i.add(h)}return i}}e.$SG=C;function S(s){const i=new L.$Ym;for(const t of s)i.set(t.identifier,t);return i}function d(s,i){return s.enabledApiProposals?s.enabledApiProposals.includes(i):!1}function P(s,i){if(!d(s,i))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${i}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${i}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class b{constructor(i,t,l,h){this.codeLoadingTime=i,this.activateCallTime=t,this.activateResolvedTime=l,this.activationReason=h}}e.$VG=b;class a{constructor(i,t){this.description=i,this.value=t}}e.$WG=a;var u;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function f(s){return{type:s.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,A.$Hp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function g(s,i){return{identifier:new L.$Wm((0,A.$Fp)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===L.ExtensionType.System,isUserBuiltin:s.type===L.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!i,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(i){return Promise.resolve(void 0)}activateById(i,t){return Promise.resolve(void 0)}activationEventIsDone(i){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(i){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(i,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(i){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$ZG=n}),define(ye[319],Se([1,0,14,157,24,26,12,9]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=e.$pnc=e.$onc=e.$nnc=e.$mnc=e.$lnc=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(f,g,n,s){this.startup=f,this.codeLoadingTime=g,this.activateCallTime=n,this.activateResolvedTime=s}}e.$lnc=p;class c{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,g){return f===-1||g===-1?-1:g-f}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$mnc=c;class C{constructor(f,g,n,s,i,t){this.activationFailed=f,this.activationFailedError=g,this.activationTimes=n,this.module=s,this.exports=i,this.subscriptions=t}}e.$nnc=C;class S extends C{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.$onc=S;class d extends C{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$pnc=d;class P extends C{constructor(f){super(!0,f,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(f,g,n,s){this.g=s,this.a=f,this.b=g,this.c=n,this.d=new A.$Ym,this.f=Object.create(null)}dispose(){for(const[f,g]of this.d)g.dispose()}async waitForActivatingExtensions(){const f=[];for(const[g,n]of this.d)f.push(n.wait());await Promise.all(f)}isActivated(f){const g=this.d.get(f);return!!(g&&g.value)}getActivatedExtension(f){const g=this.d.get(f);if(!g||!g.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return g.value}async activateByEvent(f,g){if(this.f[f])return;const n=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(n.map(s=>({id:s.identifier,reason:{startup:g,extensionId:s.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,g){const n=this.a.getExtensionDescription(f);if(!n)throw new Error(`Extension '${f.value}' is not known`);return this.h([{id:n.identifier,reason:g}])}async h(f){const g=f.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(g.map(n=>n.wait()))}j(f){if(this.d.has(f.id))return this.d.get(f.id);if(this.l(f.id))return this.k(f,null,[],null);const g=this.a.getExtensionDescription(f.id);if(!g){const i=new Error(`Cannot activate unknown extension '${f.id.value}'`),t=this.k(f,null,[],new P(i));return this.c.onExtensionActivationError(f.id,i,new R.$RG(f.id.value)),t}const n=[],s=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const i of s){if(this.m(i))continue;const t=this.d.get(i);if(t){n.push(t);continue}if(this.l(i)){n.push(this.j({id:this.b.getExtensionDescription(i).identifier,reason:f.reason}));continue}const l=this.a.getExtensionDescription(i);if(l){if(!l.main&&!l.browser)continue;n.push(this.j({id:l.identifier,reason:f.reason}));continue}const h=g.displayName||g.identifier.value,o=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${i}'`),$=this.k(f,g.displayName,[],new P(o));return this.c.onExtensionActivationError(g.identifier,o,new R.$RG(i)),$}return this.k(f,g.displayName,n,null)}k(f,g,n,s){const i=new a(f.id,g,f.reason,n,s,this.c,this.g);return this.d.set(f.id,i),i}l(f){return m.$bbc.isHostExtension(f,this.a,this.b)}m(f){const g=this.b.getExtensionDescription(f);return g?!g.main&&!g.browser:!1}};e.$qnc=b,e.$qnc=b=Je([Ge(3,L.$7j)],b);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,g,n,s,i,t,l){this.c=f,this.d=g,this.f=n,this.g=s,this.h=i,this.j=t,this.k=l,this.a=new T.$zh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const g=this.g[f];if(g.value&&!g.value.activationFailed){this.g.splice(f,1),f--;continue}if(g.value&&g.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);n.detail=g.value.activationFailedError,this.h=new P(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const g=new Error;if(f&&f.name&&(g.name=f.name),f&&f.message?g.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(g.stack=f.stack),this.h=new P(g),this.b&&r.$4(f))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};a=Je([Ge(6,L.$7j)],a)}),define(ye[320],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[158],Se([1,0,258,14,43,145,116,36,24,320,115,146]),function(de,e,r,m,A,R,L,T,p,c,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0;const d=T.$jo.as(L.$ko.JSONContribution);class P{constructor(i,t,l){this.a=i,this.b=t,this.c=l}d(i,t){this.a({type:i,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(i){this.d(A.default.Error,i)}warn(i){this.d(A.default.Warning,i)}info(i){this.d(A.default.Info,i)}}e.$IG=P;class b{static a(i){const t=new p.$Xm;for(let l=0,h=i.length;l<h;l++)t.add(i[l].description.identifier);return t}static compute(i,t){if(!i||!i.length)return new b(t,[]);if(!t||!t.length)return new b([],i);const l=this.a(i),h=this.a(t),o=t.filter(E=>!l.has(E.description.identifier)),$=i.filter(E=>!h.has(E.description.identifier));return new b(o,$)}constructor(i,t){this.added=i,this.removed=t}}e.$JG=b;class a{constructor(i,t){this.name=i,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(i){if(this.a!==null)throw new Error("Handler already set!");return this.a=i,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(i){this.c=b.compute(this.b,i),this.b=i,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(i){(0,m.$1)(i)}}}e.$KG=a;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},f="vscode://schemas/vscode-extensions";e.$LG={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$Vm},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(42,null)},{label:"*",description:r.localize(43,null),body:"*"}]}},badges:{type:"array",description:r.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(45,null)},href:{type:"string",description:r.localize(46,null)},description:{type:"string",description:r.localize(47,null)}}}},markdown:{type:"string",description:r.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$1o}},extensionPack:{description:r.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$1o}},extensionKind:{description:r.localize(52,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(53,null)},{body:["workspace"],description:r.localize(54,null)},{body:["ui","workspace"],description:r.localize(55,null)},{body:["workspace","ui"],description:r.localize(56,null)},{body:[],description:r.localize(57,null)}]},capabilities:{description:r.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(61,null),r.localize(62,null),r.localize(63,null)]},description:{type:"string",markdownDescription:r.localize(64,null)}}},untrustedWorkspaces:{description:r.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(67,null),r.localize(68,null),r.localize(69,null)]},restrictedConfigurations:{description:r.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(71,null)}}}}},sponsor:{description:r.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(74,null),type:"string"},"vscode:uninstall":{description:r.localize(75,null),type:"string"}}},icon:{type:"string",description:r.localize(76,null)},l10n:{type:"string",description:r.localize(77,null)},pricing:{type:"string",markdownDescription:r.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class g{constructor(){this.a=new Map}registerExtensionPoint(i){if(this.a.has(i.extensionPoint))throw new Error("Duplicate extension point: "+i.extensionPoint);const t=new a(i.extensionPoint,i.defaultExtensionKind);return this.a.set(i.extensionPoint,t),i.activationEventsGenerator&&S.$zG.register(i.extensionPoint,i.activationEventsGenerator),e.$LG.properties.contributes.properties[i.extensionPoint]=i.jsonSchema,d.registerSchema(f,e.$LG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$MG=g;const n={ExtensionsRegistry:"ExtensionsRegistry"};T.$jo.add(n.ExtensionsRegistry,new g),e.$NG=T.$jo.as(n.ExtensionsRegistry),d.registerSchema(f,e.$LG),d.registerSchema(C.$ok,{properties:{extensionEnabledApiProposals:{description:r.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}}]}}}})}),define(ye[321],Se([1,0,4,40,3,13,249,24,5,12,26,158]),function(de,e,r,m,A,R,L,T,p,c,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3G=e.$2G=e.$1G=e.ChatMessageRole=void 0;var d;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(d||(e.ChatMessageRole=d={})),e.$1G=(0,p.$Ai)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(0,null)}}};e.$2G=S.$NG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(1,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(a,u)=>{for(const f of a)u.push(`onLanguageModelChat:${f.vendor}`)}});let b=class{constructor(u,f){this.e=u,this.f=f,this.a=new A.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$he),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$2G.setHandler(g=>{this.c.clear();for(const s of g){if(!(0,C.$TG)(s.description,"chatProvider")){s.collector.error((0,L.localize)(2,null));continue}for(const i of m.Iterable.wrap(s.value)){if(this.c.has(i.vendor)){s.collector.error((0,L.localize)(3,null,i.vendor));continue}if((0,R.$$e)(i.vendor)){s.collector.error((0,L.localize)(4,null));continue}if(i.vendor.trim()!==i.vendor){s.collector.error((0,L.localize)(5,null));continue}this.c.add(i.vendor)}}const n=[];for(const[s,i]of this.b)this.c.has(i.metadata.vendor)||(this.b.delete(s),n.push(s));n.length>0&&this.d.fire({removed:n})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(u){return this.b.get(u)?.metadata}async selectLanguageModels(u){if(u.vendor)await this.e.activateByEvent(`onLanguageModelChat:${u.vendor}}`);else{const g=Array.from(this.c).map(n=>this.e.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(g)}const f=[];for(const[g,n]of this.b)(u.vendor===void 0||n.metadata.vendor===u.vendor)&&(u.family===void 0||n.metadata.family===u.family)&&(u.version===void 0||n.metadata.version===u.version)&&(u.identifier===void 0||n.metadata.id===u.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(s=>T.$Wm.equals(s,u.extension)))&&f.push(g);return this.f.trace("[LM] selected language models",u,f),f}registerLanguageModelChat(u,f){if(this.f.trace("[LM] registering language model chat",u,f.metadata),!this.c.has(f.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${f.metadata.vendor}.`);if(this.b.has(u))throw new Error(`Chat response provider with identifier ${u} is already registered.`);return this.b.set(u,f),this.d.fire({added:[{identifier:u,metadata:f.metadata}]}),(0,A.$Sc)(()=>{this.b.delete(u)&&(this.d.fire({removed:[u]}),this.f.trace("[LM] UNregistered language model chat",u,f.metadata))})}makeLanguageModelChatRequest(u,f,g,n,s,i){const t=this.b.get(u);if(!t)throw new Error(`Chat response provider with identifier ${u} is not registered.`);return t.provideChatResponse(g,f,n,s,i)}computeTokenLength(u,f,g){const n=this.b.get(u);if(!n)throw new Error(`Chat response provider with identifier ${u} is not registered.`);return n.provideTokenCount(f,g)}};e.$3G=b,e.$3G=b=Je([Ge(0,C.$QG),Ge(1,c.$7j)],b)}),define(ye[322],Se([1,0,253,18,25,158,35,4]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tI=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var c;(function(d){function P(b,a,u){if(!b)return;const f=m.$ag(b.type)?b.type:void 0;if(!f||f.length===0){u.error(r.localize(3,null));return}const g=[];if(Array.isArray(b.required))for(const n of b.required)m.$ag(n)&&g.push(n);return{extensionId:a.value,taskType:f,required:g,properties:b.properties?A.$9n(b.properties):{},when:b.when?L.$yj.deserialize(b.when):void 0}}d.from=P})(c||(c={}));const C=R.$NG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(d,P)=>{for(const b of d)b.type&&P.push(`onTaskType:${b.type}`)},jsonSchema:{description:r.localize(4,null),type:"array",items:p}});class S{constructor(){this.d=new T.$he,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,b)=>{C.setHandler((a,u)=>{this.c=void 0;try{for(const f of u.removed){const g=f.value;for(const n of g)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const f of u.added){const g=f.value;for(const n of g){const s=c.from(n,f.description.identifier,f.collector);s&&(this.a[s.taskType]=s)}}(u.removed.length>0||u.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const b of this.all()){const a={type:"object",additionalProperties:!1};b.required.length>0&&(a.required=b.required.slice(0)),b.properties!==void 0?a.properties=A.$9n(b.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[b.taskType]},P.push(a)}this.c={oneOf:P}}return this.c}}e.$tI=new S}),define(ye[323],Se([1,0,254,18,23,25,35,322,44]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$DI=e.JsonSchemaVersion=e.ExecutionEngine=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$xI=e.ShellQuoting=e.$wI=e.$vI=e.$uI=void 0,e.$uI="settings",e.$vI=new L.$Rj("taskRunning",!1,r.localize(0,null)),e.$wI=r.localize2(2,"Tasks");var c;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$xI="$customized",function(M){function F(J){if(!J)return M.Strong;switch(J.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=F}(c||(e.ShellQuoting=c={}));var C;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(C||(e.CommandOptions=C={}));var S;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(S||(e.RevealKind=S={})),function(M){function F(J){switch(J.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=F}(S||(e.RevealKind=S={}));var d;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(d||(e.RevealProblemKind=d={})),function(M){function F(J){switch(J.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=F}(d||(e.RevealProblemKind=d={}));var P;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(P||(e.PanelKind=P={})),function(M){function F(J){switch(J.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=F}(P||(e.PanelKind=P={}));var b;(function(M){M.defaults={echo:!0,reveal:S.Always,revealProblems:d.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var a;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(M){function F(ee){switch(ee.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=F;function J(ee){switch(ee){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=J}(a||(e.RuntimeType=a={}));var u;(function(M){function F(J){return m.$ag(J)?J:J.value}M.value=F})(u||(e.CommandString=u={}));var f;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function F(ee){return ee===M.Clean._id||ee===M.Build._id||ee===M.Rebuild._id||ee===M.Test._id}M.is=F;function J(ee){if(ee!==void 0)return m.$ag(ee)?F(ee)?{_id:ee,isDefault:!1}:void 0:ee}M.from=J})(f||(e.TaskGroup=f={}));var g;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(g||(e.TaskScope=g={}));var n;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function F(J){switch(J){case M.User:return p.ConfigurationTarget.USER;case M.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}M.toConfigurationTarget=F})(n||(e.TaskSourceKind=n={}));var s;(function(M){M.parallel="parallel",M.sequence="sequence"})(s||(e.DependsOrder=s={}));var i;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(i||(e.RunOnOptions=i={}));var t;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:i.default,instanceLimit:1}})(t||(e.RunOptions=t={}));class l{constructor(F,J,ee,V,H,_){this._label="",this._id=F,J&&(this._label=J),ee&&(this.type=ee),this.runOptions=V,this.configurationProperties=H,this._source=_}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,J=!1){if(F===void 0)return!1;if(m.$ag(F))return F===this._label||F===this.configurationProperties.identifier||J&&F===this._id;const ee=this.getDefinition(!0);return ee!==void 0&&ee._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$yI=l;class h extends l{constructor(F,J,ee,V,H,_,ne,he){super(F,ee,void 0,ne,he,J),this.command={},this._source=J,this.hasDefinedMatchers=_,H&&(this.command=H)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let J;switch(this.command?this.command.runtime:void 0){case a.Shell:J="shell";break;case a.Process:J="process";break;case a.CustomExecution:J="customExecution";break;case void 0:J="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:J,_key:this._id,id:this._id}}}static is(F){return F instanceof h}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$uI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let J=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(J+=this._source.kind);const ee={type:e.$xI,folder:F,id:J};return JSON.stringify(ee)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$$g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new h(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$zI=h;class o extends l{constructor(F,J,ee,V,H,_,ne){super(F,ee,V,_,ne,J),this._source=J,this.configures=H}static is(F){return F instanceof o}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$$g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$uI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let J=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(J+=this._source.kind);const ee={type:e.$xI,folder:F,id:J};return JSON.stringify(ee)}}e.$AI=o;class $ extends l{constructor(F,J,ee,V,H,_,ne,he,re){super(F,ee,V,he,re,J),this.defines=H,this.hasDefinedMatchers=ne,this.command=_,this.icon=re.icon,this.hide=re.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof $}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===g.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new $(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$BI=$;class E extends l{constructor(F,J,ee,V,H,_){super(F,ee,V,H,_,J),this._source=J}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new E(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$CI=E;var k;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(k||(e.ExecutionEngine=k={})),function(M){M._default=M.Terminal}(k||(e.ExecutionEngine=k={}));var D;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class v{constructor(F){this.c=new Map;for(let J=0;J<F.length;J++)this.c.set(F[J].uri.toString(),J)}compare(F,J){const ee=F.getWorkspaceFolder(),V=J.getWorkspaceFolder();if(ee&&V){let H=this.c.get(ee.uri.toString());H=H===void 0?0:H+1;let _=this.c.get(V.uri.toString());return _=_===void 0?0:_+1,H===_?F._label.localeCompare(J._label):H-_}else return!ee&&V?-1:ee&&!V?1:0}}e.$DI=v;var I;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(I||(e.TaskEventKind=I={}));var w;(function(M){M.SingleRun="singleRun",M.Background="background"})(w||(e.TaskRunType=w={}));var y;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var N;(function(M){function F(he){return{taskId:he._id,taskName:he.configurationProperties.name,runType:he.configurationProperties.isBackground?w.Background:w.SingleRun,group:he.configurationProperties.group,__task:he}}function J(he,re,ve){return{...F(he),kind:I.Start,terminalId:re,resolvedVariables:ve}}M.start=J;function ee(he,re,ve){return{...F(he),kind:I.ProcessStarted,terminalId:re,processId:ve}}M.processStarted=ee;function V(he,re,ve){return{...F(he),kind:I.ProcessEnded,terminalId:re,exitCode:ve}}M.processEnded=V;function H(he,re,ve){return{...F(he),kind:I.Terminated,exitReason:ve,terminalId:re}}M.terminated=H;function _(he,re,ve){return{...F(re),kind:he,terminalId:ve}}M.general=_;function ne(){return{kind:I.Changed}}M.changed=ne})(N||(e.TaskEvent=N={}));var O;(function(M){function F(ee){const V=Object.keys(ee).sort();let H="";for(const _ of V){let ne=ee[_];ne instanceof Object?ne=F(ne):typeof ne=="string"&&(ne=ne.replace(/,/g,",,")),H+=_+","+ne+","}return H}function J(ee){const H={_key:F(ee),type:ee.taskType};return Object.assign(H,ee),H}M.create=J})(O||(e.KeyedTaskIdentifier=O={}));var U;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var j;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(M){function F(J,ee){const V=T.$tI.get(J.type);if(V===void 0){const he=R.$9n(J);return delete he._key,O.create(he)}const H=Object.create(null);H.type=V.taskType;const _=new Set;V.required.forEach(he=>_.add(he));const ne=V.properties;for(const he of Object.keys(ne)){const re=J[he];if(re!=null)H[he]=re;else if(_.has(he)){const ve=ne[he];if(ve.default!==void 0)H[he]=R.$9n(ve.default);else switch(ve.type){case"boolean":H[he]=!1;break;case"number":case"integer":H[he]=0;break;case"string":H[he]="";break;default:ee.error(r.localize(1,null,JSON.stringify(J,void 0,0),he));return}}}return O.create(H)}M.createTaskIdentifier=F})(z||(e.TaskDefinition=z={}))}),define(ye[324],Se([1,0,14]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=e.$fbc=void 0;class m{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,T)=>{this.b=L,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,r.$1)(L))}then(L,T){return this.j().then(L,T)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$fbc=m;class A extends m{constructor(){super(),this.h=!0,this.i=new r.$5}}e.$gbc=A}),define(ye[52],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kw=e.$Hw=void 0,e.$Iw=A,e.$Jw=R;class r{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++r.count}}e.$Hw=r;const m=[];function A(T){const p=new r(T);return m[p.nid]=p,p}function R(T){return m[T].sid}class L{constructor(p){this.value=p}}e.$Kw=L}),define(ye[6],Se([1,0,52]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$tM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var m;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(m||(e.TextEditorRevealType=m={}));var A;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var R;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var T;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var p;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var c;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var C;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(C||(e.CandidatePortSource=C={}));class S{static{this.a=0}static mixin(u){return u._id=S.a++,u}}e.$tM=S;var d;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(d||(e.ISuggestDataDtoField=d={}));var P;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var b;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$uM={MainThreadAuthentication:(0,r.$Iw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Iw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Iw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Iw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Iw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Iw)("MainThreadChatVariables"),MainThreadClipboard:(0,r.$Iw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Iw)("MainThreadCommands"),MainThreadComments:(0,r.$Iw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Iw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Iw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Iw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Iw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Iw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Iw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Iw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Iw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Iw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Iw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Iw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Iw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Iw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Iw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Iw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Iw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Iw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Iw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Iw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Iw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Iw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Iw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Iw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Iw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Iw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Iw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Iw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Iw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Iw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Iw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Iw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Iw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Iw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Iw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Iw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Iw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Iw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Iw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Iw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Iw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Iw)("MainThreadSCM"),MainThreadSearch:(0,r.$Iw)("MainThreadSearch"),MainThreadShare:(0,r.$Iw)("MainThreadShare"),MainThreadTask:(0,r.$Iw)("MainThreadTask"),MainThreadWindow:(0,r.$Iw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Iw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Iw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Iw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Iw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Iw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Iw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Iw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Iw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Iw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Iw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Iw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Iw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Iw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Iw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Iw)("MainThreadAiEmbeddingVector")},e.$vM={ExtHostCommands:(0,r.$Iw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Iw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Iw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Iw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Iw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Iw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Iw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Iw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Iw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Iw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Iw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Iw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Iw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Iw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Iw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Iw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Iw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Iw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Iw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Iw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Iw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Iw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Iw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Iw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Iw)("ExtHostSCM"),ExtHostSearch:(0,r.$Iw)("ExtHostSearch"),ExtHostTask:(0,r.$Iw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Iw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Iw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Iw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Iw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Iw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Iw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Iw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Iw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Iw)("ExtHostProgress"),ExtHostComments:(0,r.$Iw)("ExtHostComments"),ExtHostSecretState:(0,r.$Iw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Iw)("ExtHostStorage"),ExtHostUrls:(0,r.$Iw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Iw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Iw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Iw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Iw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Iw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Iw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Iw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Iw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Iw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Iw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Iw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Iw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Iw)("ExtHostChatVariables"),ExtHostChatProvider:(0,r.$Iw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Iw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Iw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Iw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Iw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Iw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Iw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Iw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Iw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Iw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Iw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Iw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Iw)("ExtHostLocalization")}}),define(ye[96],Se([1,0,5,12,6,20]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=e.$Lmc=e.$Kmc=void 0,e.$Kmc=(0,r.$Ai)("IExtHostApiDeprecationService");let L=class{constructor(p,c){this.c=c,this.a=new Set,this.b=p.getProxy(A.$uM.MainThreadTelemetry)}report(p,c,C){const S=this.d(p,c);this.a.has(S)||(this.a.add(S),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${C}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:p}))}d(p,c){return`${p}-${c.identifier.value}`}};e.$Lmc=L,e.$Lmc=L=Je([Ge(0,R.$YO),Ge(1,m.$7j)],L),e.$Mmc=Object.freeze(new class{report(T,p,c){}})}),define(ye[325],Se([1,0,6]),function(de,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=void 0;class m{constructor(R){const L=R.getProxy(r.$uM.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(T){return L.$writeText(T)}})}}e.$Zmc=m}),define(ye[326],Se([1,0,25,6,30,20]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;let L=class{constructor(C,S){this.a=C.getProxy(m.$uM.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(C,S){const d=this,P=console[C];Object.defineProperty(console,C,{set:()=>{},get:()=>function(){d.e(C,S,P,arguments)}})}e(C,S,d,P){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:p(P,this.b)}),this.c&&this.f(C,d,P)}};e.$Toc=L,e.$Toc=L=Je([Ge(0,R.$YO),Ge(1,A.$cP)],L);const T=1e5;function p(c,C){const S=[];if(c.length)for(let d=0;d<c.length;d++){let P=c[d];if(typeof P>"u")P="undefined";else if(P instanceof Error){const b=P;b.stack?P=b.stack:P=b.toString()}S.push(P)}if(C){const d=new Error().stack;d&&S.push({__$stack:d.split(`
`).slice(3).join(`
`)})}try{const d=(0,r.$bo)(S);return d.length>T?"Output omitted for a large object that exceeds the limits":d}catch(d){return`Output omitted for an object that cannot be inspected ('${d.toString()}')`}}}),define(ye[327],Se([1,0,2,6,26]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;class R{constructor(T){this.a=T.getProxy(m.$uM.MainThreadDialogs)}showOpenDialog(T,p){return p?.allowUIResources&&(0,A.$UG)(T,"showLocal"),this.a.$showOpenDialog(p).then(c=>c?c.map(C=>r.URI.revive(C)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(p=>p?r.URI.revive(p):void 0)}}e.$Wnc=R}),define(ye[328],Se([1,0,21,4,3,6]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=void 0;class L{constructor(p){this.b=new Map,this.c=new m.$he,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(R.$uM.MainThreadEmbeddings)}registerEmbeddingsProvider(p,c,C){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const S=this.e++;return this.a.$registerEmbeddingProvider(S,c),this.b.set(S,{id:c,provider:C}),(0,A.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(S),this.b.delete(S)})}async computeEmbeddings(p,c,C){C??=r.CancellationToken.None;let S=!1;typeof c=="string"&&(c=[c],S=!0);const d=await this.a.$computeEmbeddings(p,c,C);if(d.length!==c.length)throw new Error;if(S){if(d.length!==1)throw new Error;return d[0]}return d}async $provideEmbeddings(p,c,C){const S=this.b.get(p);if(!S)return[];const d=await S.provider.provideEmbeddings(c,C);return d||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Znc=L}),define(ye[329],Se([1,0,3,6]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=void 0;class A{constructor(L){this.b=0,this.a=L.getProxy(m.$uM.MainThreadLabelService)}$registerResourceLabelFormatter(L){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,L),(0,r.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$eoc=A}),define(ye[122],Se([1,0,11,13,2,5,12,6,30,20]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=e.$Enc=void 0;let C=class{constructor(d,P,b){this.f=b,this.d=new Map,this.a=P.getProxy(T.$uM.MainThreadLocalization),this.b=d.environment.appLanguage,this.c=this.b===r.$g}getMessage(d,P){const{message:b,args:a,comment:u}=P;if(this.c)return(0,m.$af)(b,a??{});let f=b;u&&u.length>0&&(f+=`/${Array.isArray(u)?u.join(""):u}`);const g=this.d.get(d)?.contents[f];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,m.$af)(g??b,a??{})}getBundle(d){return this.d.get(d)?.contents}getBundleUri(d){return this.d.get(d)?.uri}async initializeLocalizedMessages(d){if(this.c||!d.l10n&&!d.isBuiltin||this.d.has(d.identifier.value))return;let P;const b=await this.g(d);if(!b){this.f.error(`No bundle location found for extension ${d.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(b),u=JSON.parse(a);P=d.isBuiltin?u.contents?.bundle:u}catch(a){this.f.error(`Failed to load translations for ${d.identifier.value} from ${b}: ${a.message}`);return}P&&this.d.set(d.identifier.value,{contents:P,uri:b})}async g(d){if(d.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(d.identifier.value,this.b);return A.URI.revive(P)}return d.l10n?A.URI.joinPath(d.extensionLocation,d.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Enc=C,e.$Enc=C=Je([Ge(0,p.$cP),Ge(1,c.$YO),Ge(2,L.$7j)],C),e.$Fnc=(0,R.$Ai)("IExtHostLocalizationService")}),define(ye[159],Se([1,0,12,6,30,20,2,57]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=void 0;let p=class extends r.$fk{constructor(S,d){super(d.logLevel,d.logsLocation,d.loggers.map(P=>(0,T.$0h)(P))),this.r=S.getProxy(m.$uM.MainThreadLogger)}$setLogLevel(S,d){d?this.setLogLevel(L.URI.revive(d),S):this.setLogLevel(S)}setVisibility(S,d){super.setVisibility(S,d),this.r.$setVisibility(S,d)}s(S,d,P){return new c(this.r,S,d,P)}};e.$Soc=p,e.$Soc=p=Je([Ge(0,R.$YO),Ge(1,A.$cP)],p);class c extends r.$ak{constructor(S,d,P,b){super(b?.logLevel==="always"),this.r=S,this.s=d,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(d,b).then(()=>{this.u(this.n),this.m=!0})}g(S,d){const P=[[S,d]];this.m?this.u(P):this.n.push(...P)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(ye[123],Se([1,0,6,5,3,20,22]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0,e.$Gnc=(0,m.$Ai)("IExtHostManagedSockets");let T=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(r.$uM.MainThreadManagedSockets)}setFactory(S,d){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(S,d),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const d=++this.b,P=await this.c.makeConnection(),b=new A.$Tc;return this.d.set(d,new c(d,P,b)),b.add((0,A.$Sc)(()=>this.d.delete(d))),b.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(d),b.dispose()})),b.add(P.onDidClose(a=>{this.a.$onDidManagedSocketClose(d,a?.stack??a?.message),b.dispose()})),b.add(P.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(d,L.$Je.wrap(a)))),d}$remoteSocketWrite(S,d){this.d.get(S)?.actual.send(d.buffer)}$remoteSocketEnd(S){const d=this.d.get(S);d&&(d.actual.end(),d.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$Hnc=T,e.$Hnc=T=Je([Ge(0,R.$YO)],T);class p{constructor(S,d){this.socketFactoryId=S,this.makeConnection=d}}class c extends A.$Uc{constructor(S,d,P){super(),this.socketId=S,this.actual=d,this.B(P)}}}),define(ye[330],Se([1,0,6,12,26]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=void 0;function R(T){return T&&T.title}let L=class{constructor(p,c){this.b=c,this.a=p.getProxy(r.$uM.MainThreadMessageService)}showMessage(p,c,C,S,d){const P={source:{identifier:p.identifier,label:p.displayName||p.name}};let b;typeof S=="string"||R(S)?b=[S,...d]:(P.modal=S?.modal,P.useCustom=S?.useCustom,P.detail=S?.detail,b=d),P.useCustom&&(0,A.$UG)(p,"resolvers");const a=[];let u=!1;for(let f=0;f<b.length;f++){const g=b[f];if(typeof g=="string")a.push({title:g,handle:f,isCloseAffordance:!1});else if(typeof g=="object"){const{title:n,isCloseAffordance:s}=g;a.push({title:n,isCloseAffordance:!!s,handle:f}),s&&(u?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,g):u=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,g)}return this.a.$showMessage(c,C,P,a).then(f=>{if(typeof f=="number")return b[f]})}};e.$goc=L,e.$goc=L=Je([Ge(1,m.$7j)],L)}),define(ye[331],Se([1,0,3,18,2,26,6]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=void 0;class T{constructor(c){this.b=new Map,this.a=c.getProxy(L.$uM.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,C,S){if((0,R.$UG)(c,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,S),this.a.$registerProfileContentHandler(C,S.name,S.description,c.identifier.value),(0,r.$Sc)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(c,C,S,d){const P=this.b.get(c);if(!P)throw new Error(`Unknown handler with id: ${c}`);return P.saveProfile(C,S,d)}async $readProfile(c,C,S){const d=this.b.get(c);if(!d)throw new Error(`Unknown handler with id: ${c}`);return d.readProfile((0,m.$ag)(C)?C:A.URI.revive(C),S)}}e.$poc=T}),define(ye[124],Se([1,0,6,4,5]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=e.$Bnc=void 0;class R{constructor(T){this.b=new m.$he,this.onDidChangePassword=this.b.event,this.a=T.getProxy(r.$uM.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,p){return this.a.$getPassword(T,p)}store(T,p,c){return this.a.$setPassword(T,p,c)}delete(T,p){return this.a.$deletePassword(T,p)}}e.$Bnc=R,e.$Cnc=(0,A.$Ai)("IExtHostSecretState")}),define(ye[332],Se([1,0,21,3,6]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0;class R{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(A.$uM.MainThreadSpeech)}async $createSpeechToTextSession(T,p,c){const C=this.c.get(T);if(!C)return;const S=new m.$Tc,d=new r.$se;this.d.set(p,d);const P=await C.provideSpeechToTextSession(d.token,c?{language:c}:void 0);P&&(S.add(P.onDidChange(b=>{d.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,b)})),S.add(d.token.onCancellationRequested(()=>S.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,p,c){const C=this.c.get(T);if(!C)return;const S=new m.$Tc,d=new r.$se;this.d.set(p,d);const P=await C.provideTextToSpeechSession(d.token,c?{language:c}:void 0);P&&(this.f.set(p,P),S.add(P.onDidChange(b=>{d.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,b)})),S.add(d.token.onCancellationRequested(()=>S.dispose())))}async $synthesizeSpeech(T,p){this.f.get(T)?.synthesize(p)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,p){const c=this.c.get(T);if(!c)return;const C=new m.$Tc,S=new r.$se;this.d.set(p,S);const d=await c.provideKeywordRecognitionSession(S.token);d&&(C.add(d.onDidChange(P=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,P)})),C.add(S.token.onCancellationRequested(()=>C.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,p,c){const C=R.a++;return this.c.set(C,c),this.b.$registerProvider(C,p,{extension:T,displayName:T.value}),(0,m.$Sc)(()=>{this.b.$unregisterProvider(C),this.c.delete(C)})}}e.$woc=R}),define(ye[125],Se([1,0,6,4,5]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=e.$rnc=void 0;class R{constructor(T,p){this.c=p,this.b=new m.$he,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(r.$uM.MainThreadStorage)}registerExtensionStorageKeysToSync(T,p){this.a.$registerExtensionStorageKeysToSync(T,p)}async initializeExtensionStorage(T,p,c){const C=await this.a.$initializeExtensionStorage(T,p);let S;return C&&(S=this.d(T,p,C)),S||c}setValue(T,p,c){return this.a.$setValue(T,p,c)}$acceptValue(T,p,c){const C=this.d(T,p,c);C&&this.b.fire({shared:T,key:p,value:C})}d(T,p,c){try{return JSON.parse(c)}catch(C){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${T}): ${C}`)}}}e.$rnc=R,e.$snc=(0,A.$Ai)("IExtHostStorage")}),define(ye[333],Se([1,0,3,15,2,6]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0;class L{static{this.a=new Set([m.Schemas.http,m.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(R.$uM.MainThreadUriOpeners)}registerExternalUriOpener(p,c,C,S){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const d=S.schemes.find(P=>!L.a.has(P));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this.c.set(c,C),this.b.$registerUriOpener(c,S.schemes,p,S.label),(0,r.$Sc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(p,c,C){const S=this.c.get(p);if(!S)throw new Error(`Unknown opener with id: ${p}`);const d=A.URI.revive(c);return S.canOpenExternalUri(d,C)}async $openUri(p,c,C){const S=this.c.get(p);if(!S)throw new Error(`Unknown opener id: '${p}'`);return S.openExternalUri(A.URI.revive(c.resolvedUri),{sourceUri:A.URI.revive(c.sourceUri)},C)}}e.$Moc=L}),define(ye[334],Se([1,0,6,2,3,14,24]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Noc=void 0;class T{static{this.a=0}constructor(c){this.c=new L.$Xm,this.d=new Map,this.b=c.getProxy(r.$uM.MainThreadUrls)}registerUriHandler(c,C){const S=c.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const d=T.a++;return this.c.add(S),this.d.set(d,C),this.b.$registerUriHandler(d,S,c.displayName||c.name),(0,A.$Sc)(()=>{this.c.delete(S),this.d.delete(d),this.b.$unregisterUriHandler(d)})}$handleExternalUri(c,C){const S=this.d.get(c);if(!S)return Promise.resolve(void 0);try{S.handleUri(m.URI.revive(C))}catch(d){(0,R.$1)(d)}return Promise.resolve(void 0)}async createAppUri(c){return m.URI.revive(await this.b.$createAppUri(c))}}e.$Noc=T}),define(ye[335],Se([1,0,22,6]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5rb=R,e.$6rb=T;class A{constructor(){this.buffers=[]}add(c){let C=this.buffers.indexOf(c);return C<0&&(C=this.buffers.length,this.buffers.push(c)),C}}function R(p,c){if(c.serializeBuffersForPostMessage){const C=new A,d=JSON.stringify(p,(b,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:C.add(a)};if(ArrayBuffer.isView(a)){const u=L(a);if(u)return{$$vscode_array_buffer_reference$$:!0,index:C.add(a.buffer),view:{type:u,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),P=C.buffers.map(b=>{const a=new Uint8Array(b);return r.$Je.wrap(a)});return{message:d,buffers:P}}else return{message:JSON.stringify(p),buffers:[]}}function L(p){switch(p.constructor.name){case"Int8Array":return m.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return m.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return m.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return m.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return m.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return m.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return m.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return m.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return m.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return m.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return m.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(p,c){const C=c.map(P=>{const b=new ArrayBuffer(P.byteLength);return new Uint8Array(b).set(P.buffer),b}),S=c.length?(P,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const a=b,{index:u}=a,f=C[u];if(a.view)switch(a.view.type){case m.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(f,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case m.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(f,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case m.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(f,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case m.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(f,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case m.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(f,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case m.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(f,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case m.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(f,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case m.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(f,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case m.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(f,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case m.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(f,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case m.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(f,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return b}:void 0;return{message:JSON.parse(p,S),arrayBuffers:C}}}),define(ye[97],Se([1,0,4,3,15,25,2,262,335,121,6]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$cnc=void 0,e.$dnc=d,e.$fnc=a,e.$gnc=u;class S{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(s,i,t,l,h,o,$){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$he,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$he,this._onDidDispose=this.#h.event,this.#e=s,this.#t=i,this.#o=t,this.#n=l,this.#s=h,this.#r=o,this.#u=d(o),this.#d=P(o),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#l=!0,(0,c.$GBb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===A.Schemas.https||s.scheme===A.Schemas.http){let i=s.toString();return i.endsWith("/")||(i+="/"),i+" "+c.$FBb}return c.$FBb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),R.$ao(this.#o,s)||this.#t.$setOptions(this.#e,u(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const i=(0,p.$5rb)(s,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,i.message,...i.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const i=this.#r.extensionLocation?.scheme===A.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,h,o,$,E,k)=>{const D=L.URI.from({scheme:$||"file",path:decodeURIComponent(E)}),v=(0,c.$GBb)(D,{isRemote:i,authority:t}).toString();return`${h}${v}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(l,h,o,$,E,k)=>{const D=L.URI.from({scheme:$||"file",path:decodeURIComponent(E)}),v=(0,c.$GBb)(D,{isRemote:i,authority:t}).toString();return`${h}${v}${k}`})}}e.$cnc=S;function d(n){try{const s=(0,T.$Qp)((0,T.$Pp)(n.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function P(n){try{const s=(0,T.$Qp)((0,T.$Pp)(n.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class b extends m.$Uc{constructor(s,i,t,l,h){super(),this.c=i,this.f=t,this.g=l,this.h=h,this.b=new Map,this.a=s.getProxy(C.$uM.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,i,t){const l=this.j(s);if(l){const{message:h}=(0,p.$6rb)(i,t.value);l._onMessageEmitter.fire(h)}}$onMissingCsp(s,i){this.g.warn(`${i} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,i,t){const l=new S(s,this.a,f(i),this.c,this.f,t,this.h);this.b.set(s,l);const h=l._onDidDispose(()=>{h.dispose(),this.deleteWebview(s)});return l}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$enc=b;function a(n){return{id:n.identifier,location:n.extensionLocation}}function u(n,s,i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots||g(n,s)}}function f(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(s=>L.URI.from(s))}}function g(n,s){return[...(s?.getWorkspaceFolders()||[]).map(i=>i.uri),n.extensionLocation]}}),define(ye[160],Se([1,0,4,15,13,2,5,20,6]),function(de,e,r,m,A,R,L,T,p){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=e.$Poc=void 0;let C=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const d=this.d;return{get focused(){return d.focused},get active(){return d.active}}}constructor(d){this.c=new r.$he,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=d.getProxy(p.$uM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:b})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",b)})}$onDidChangeWindowFocus(d){this.onDidChangeWindowProperty("focused",d)}$onDidChangeWindowActive(d){this.onDidChangeWindowProperty("active",d)}onDidChangeWindowProperty(d,P){P!==this.d[d]&&(this.d={...this.d,[d]:P},this.c.fire(this.d))}openUri(d,P){let b;if(typeof d=="string"){b=d;try{d=R.URI.parse(d)}catch{return Promise.reject(`Invalid uri - '${d}'`)}}return(0,A.$$e)(d.scheme)?Promise.reject("Invalid scheme - cannot be empty"):d.scheme===m.Schemas.command?Promise.reject(`Invalid scheme '${d.scheme}'`):this.b.$openUri(d,b,P)}async asExternalUri(d,P){if((0,A.$$e)(d.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(d,P);return R.URI.from(b)}};e.$Poc=C,e.$Poc=C=c=Je([Ge(0,T.$YO)],C),e.$Qoc=(0,L.$Ai)("IExtHostWindow")}),define(ye[336],Se([1,0,326,30,20,94]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=void 0;const L=1024*1024;let T=class extends r.$Toc{constructor(c,C){super(c,C),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(c,C,S){const d=c==="error"||c==="warn"?process.stderr:process.stdout;this.g=!0,d.write(`
${R.NativeLogMarkers.Start}
`),C.apply(console,S),d.write(`
${R.NativeLogMarkers.End}
`),this.g=!1}j(c,C){const S=process[c],d=S.write;let P="";Object.defineProperty(S,"write",{set:()=>{},get:()=>(b,a,u)=>{if(!this.g){P+=b.toString(a);const f=P.length>L?P.length:P.lastIndexOf(`
`);f!==-1&&(console[C](P.slice(0,f)),P=P.slice(f+1))}d.call(S,b,a,u)}})}};e.$spc=T,e.$spc=T=Je([Ge(0,A.$YO),Ge(1,m.$cP)],T)}),define(ye[337],Se([1,0,159,15,278,32]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;class L extends r.$Soc{s(p,c,C){return p.scheme===m.Schemas.file?new A.$bQ(C?.name||(0,R.$Wg)(),p.fsPath,!C?.donotRotate,!!C?.donotUseFormatters,c):super.s(p,c,C)}registerLogger(p){super.registerLogger(p),this.r.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this.r.$deregisterLogger(p)}}e.$Epc=L}),define(ye[338],Se([1,0,9,22,21,27,14,4,3,41,141,324,52]),function(de,e,r,m,A,R,L,T,p,c,C,S,d){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=e.ResponsiveState=e.RequestInitiator=void 0,e.$hbc=g,e.$ibc=n;function b(N,O){try{return JSON.stringify(N,O)}catch{return"null"}}const a="$$ref$$",u={[a]:-1};class f{constructor(O,U){this.jsonString=O,this.referencedBuffers=U}}function g(N,O=null,U=!1){const j=[];return{jsonString:(U?b:JSON.stringify)(N,(M,F)=>{if(typeof F>"u")return u;if(typeof F=="object"){if(F instanceof m.$Je){const J=j.push(F)-1;return{[a]:J}}if(O)return O(M,F)}return F}),referencedBuffers:j}}function n(N,O,U){return JSON.parse(N,(j,z)=>{if(z){const M=z[a];if(typeof M=="number")return O[M];if(U&&z.$mid===c.MarshalledId.Uri)return U.transformIncoming(z)}return z})}function s(N,O){return JSON.stringify(N,O)}function i(N){return N?(O,U)=>U&&U.$mid===c.MarshalledId.Uri?N.transformOutgoing(U):U:null}var t;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(t||(e.RequestInitiator=t={}));var l;(function(N){N[N.Responsive=0]="Responsive",N[N.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const h=()=>{},o=Symbol.for("rpcProtocol"),$=Symbol.for("rpcProxy");class E extends p.$Uc{static{P=o}static{this.a=3*1e3}constructor(O,U=null,j=null){super(),this[P]=!0,this.b=this.B(new T.$he),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=U,this.g=j,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,M=d.$Hw.count;z<M;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=l.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Mh(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(O=>{const U=this.w[O];delete this.w[O],U.resolveErr(L.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(O){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(O){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(l.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(l.Unresponsive):this.D.schedule())}I(O){this.y!==O&&(this.y=O,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(O){return this.g?(0,C.$Gn)(O,this.g):O}getProxy(O){const{nid:U,sid:j}=O;return this.s[U]||(this.s[U]=this.J(U,j)),this.s[U]}J(O,U){const j={get:(z,M)=>(typeof M=="string"&&!z[M]&&M.charCodeAt(0)===R.CharCode.DollarSign&&(z[M]=(...F)=>this.U(O,M,F)),M===$?U:z[M])};return new Proxy(Object.create(null),j)}set(O,U){return this.m[O.nid]=U,U}assertRegistered(O){for(let U=0,j=O.length;U<j;U++){const z=O[U];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(O){if(this.j)return;const U=O.byteLength,j=D.read(O,0),z=j.readUInt8(),M=j.readUInt32();switch(z){case w.RequestJSONArgs:case w.RequestJSONArgsWithCancellation:{let{rpcId:F,method:J,args:ee}=I.deserializeRequestJSONArgs(j);this.g&&(ee=(0,C.$Gn)(ee,this.g)),this.M(U,M,F,J,ee,z===w.RequestJSONArgsWithCancellation);break}case w.RequestMixedArgs:case w.RequestMixedArgsWithCancellation:{let{rpcId:F,method:J,args:ee}=I.deserializeRequestMixedArgs(j);this.g&&(ee=(0,C.$Gn)(ee,this.g)),this.M(U,M,F,J,ee,z===w.RequestMixedArgsWithCancellation);break}case w.Acknowledged:{this.f?.logIncoming(U,M,t.LocalSide,"ack"),this.G(M);break}case w.Cancel:{this.N(U,M);break}case w.ReplyOKEmpty:{this.O(U,M,void 0);break}case w.ReplyOKJSON:{let F=I.deserializeReplyOKJSON(j);this.g&&(F=(0,C.$Gn)(F,this.g)),this.O(U,M,F);break}case w.ReplyOKJSONWithBuffers:{const F=I.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(U,M,F);break}case w.ReplyOKVSBuffer:{const F=I.deserializeReplyOKVSBuffer(j);this.O(U,M,F);break}case w.ReplyErrError:{let F=I.deserializeReplyErrError(j);this.g&&(F=(0,C.$Gn)(F,this.g)),this.P(U,M,F);break}case w.ReplyErrEmpty:{this.P(U,M,void 0);break}default:console.error("received unexpected message"),console.error(O)}}M(O,U,j,z,M,F){this.f?.logIncoming(O,U,t.OtherSide,`receiveRequest ${(0,d.$Jw)(j)}.${z}(`,M);const J=String(U);let ee,V;if(F){const _=new A.$se;M.push(_.token),ee=this.Q(j,z,M),V=()=>_.cancel()}else ee=this.Q(j,z,M),V=h;this.u[J]=V;const H=I.serializeAcknowledged(U);this.f?.logOutgoing(H.byteLength,U,t.OtherSide,"ack"),this.c.send(H),ee.then(_=>{delete this.u[J];const ne=I.serializeReplyOK(U,_,this.h);this.f?.logOutgoing(ne.byteLength,U,t.OtherSide,"reply:",_),this.c.send(ne)},_=>{delete this.u[J];const ne=I.serializeReplyErr(U,_);this.f?.logOutgoing(ne.byteLength,U,t.OtherSide,"replyErr:",_),this.c.send(ne)})}N(O,U){this.f?.logIncoming(O,U,t.OtherSide,"receiveCancel");const j=String(U);this.u[j]?.()}O(O,U,j){this.f?.logIncoming(O,U,t.LocalSide,"receiveReply:",j);const z=String(U);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z],M.resolveOk(j)}P(O,U,j){this.f?.logIncoming(O,U,t.LocalSide,"receiveReplyErr:",j);const z=String(U);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z];let F;j&&(j.$isError?(F=new Error,F.name=j.name,F.message=j.message,F.stack=j.stack):F=j),M.resolveErr(F)}Q(O,U,j){try{return Promise.resolve(this.S(O,U,j))}catch(z){return Promise.reject(z)}}S(O,U,j){const z=this.m[O];if(!z)throw new Error("Unknown actor "+(0,d.$Jw)(O));const M=z[U];if(typeof M!="function")throw new Error("Unknown method "+U+" on actor "+(0,d.$Jw)(O));return M.apply(z,j)}U(O,U,j){if(this.j)return new S.$gbc;let z=null;if(j.length>0&&A.CancellationToken.isCancellationToken(j[j.length-1])&&(z=j.pop()),z&&z.isCancellationRequested)return Promise.reject(L.$6());const M=I.serializeRequestArguments(j,this.h),F=++this.t,J=String(F),ee=new S.$fbc,V=new p.$Tc;z&&V.add(z.onCancellationRequested(()=>{const _=I.serializeCancel(F);this.f?.logOutgoing(_.byteLength,F,t.LocalSide,"cancel"),this.c.send(I.serializeCancel(F))})),this.w[J]=new k(ee,V),this.F(F);const H=I.serializeRequest(F,O,U,M,!!z);return this.f?.logOutgoing(H.byteLength,F,t.LocalSide,`request: ${(0,d.$Jw)(O)}.${U}(`,j),this.c.send(H),ee}}e.$jbc=E;class k{constructor(O,U){this.a=O,this.b=U}resolveOk(O){this.a.resolveOk(O),this.b.dispose()}resolveErr(O){this.a.resolveErr(O),this.b.dispose()}}class D{static alloc(O,U,j){const z=new D(m.$Je.alloc(j+1+4),0);return z.writeUInt8(O),z.writeUInt32(U),z}static read(O,U){return new D(O,U)}get buffer(){return this.a}constructor(O,U){this.a=O,this.b=U}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+O).toString();return this.b+=O,j}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+O).toString();return this.b+=O,j}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+O);return this.b+=O,U}static sizeMixedArray(O){let U=0;U+=1;for(let j=0,z=O.length;j<z;j++){const M=O[j];switch(U+=1,M.type){case y.String:U+=this.sizeLongString(M.value);break;case y.VSBuffer:U+=this.sizeVSBuffer(M.value);break;case y.SerializedObjectWithBuffers:U+=this.sizeUInt32,U+=this.sizeLongString(M.value);for(let F=0;F<M.buffers.length;++F)U+=this.sizeVSBuffer(M.buffers[F]);break;case y.Undefined:break}}return U}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let U=0,j=O.length;U<j;U++){const z=O[U];switch(z.type){case y.String:this.writeUInt8(y.String),this.writeLongString(z.value);break;case y.VSBuffer:this.writeUInt8(y.VSBuffer),this.writeVSBuffer(z.value);break;case y.SerializedObjectWithBuffers:this.writeUInt8(y.SerializedObjectWithBuffers),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let M=0;M<z.buffers.length;++M)this.writeBuffer(z.buffers[M]);break;case y.Undefined:this.writeUInt8(y.Undefined);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const U=new Array(O);for(let j=0;j<O;j++)switch(this.readUInt8()){case y.String:U[j]=this.readLongString();break;case y.VSBuffer:U[j]=this.readVSBuffer();break;case y.SerializedObjectWithBuffers:{const M=this.readUInt32(),F=this.readLongString(),J=[];for(let ee=0;ee<M;++ee)J.push(this.readVSBuffer());U[j]=new d.$Kw(n(F,J,null));break}case y.Undefined:U[j]=void 0;break}return U}}var v;(function(N){N[N.Simple=0]="Simple",N[N.Mixed=1]="Mixed"})(v||(v={}));class I{static a(O){for(let U=0,j=O.length;U<j;U++)if(O[U]instanceof m.$Je||O[U]instanceof d.$Kw||typeof O[U]>"u")return!0;return!1}static serializeRequestArguments(O,U){if(this.a(O)){const j=[];for(let z=0,M=O.length;z<M;z++){const F=O[z];if(F instanceof m.$Je)j[z]={type:y.VSBuffer,value:F};else if(typeof F>"u")j[z]={type:y.Undefined};else if(F instanceof d.$Kw){const{jsonString:J,referencedBuffers:ee}=g(F.value,U);j[z]={type:y.SerializedObjectWithBuffers,value:m.$Je.fromString(J),buffers:ee}}else j[z]={type:y.String,value:m.$Je.fromString(s(F,U))}}return{type:v.Mixed,args:j}}return{type:v.Simple,args:s(O,U)}}static serializeRequest(O,U,j,z,M){switch(z.type){case v.Simple:return this.b(O,U,j,z.args,M);case v.Mixed:return this.c(O,U,j,z.args,M)}}static b(O,U,j,z,M){const F=m.$Je.fromString(j),J=m.$Je.fromString(z);let ee=0;ee+=D.sizeUInt8(),ee+=D.sizeShortString(F),ee+=D.sizeLongString(J);const V=D.alloc(M?w.RequestJSONArgsWithCancellation:w.RequestJSONArgs,O,ee);return V.writeUInt8(U),V.writeShortString(F),V.writeLongString(J),V.buffer}static deserializeRequestJSONArgs(O){const U=O.readUInt8(),j=O.readShortString(),z=O.readLongString();return{rpcId:U,method:j,args:JSON.parse(z)}}static c(O,U,j,z,M){const F=m.$Je.fromString(j);let J=0;J+=D.sizeUInt8(),J+=D.sizeShortString(F),J+=D.sizeMixedArray(z);const ee=D.alloc(M?w.RequestMixedArgsWithCancellation:w.RequestMixedArgs,O,J);return ee.writeUInt8(U),ee.writeShortString(F),ee.writeMixedArray(z),ee.buffer}static deserializeRequestMixedArgs(O){const U=O.readUInt8(),j=O.readShortString(),z=O.readMixedArray(),M=new Array(z.length);for(let F=0,J=z.length;F<J;F++){const ee=z[F];typeof ee=="string"?M[F]=JSON.parse(ee):M[F]=ee}return{rpcId:U,method:j,args:M}}static serializeAcknowledged(O){return D.alloc(w.Acknowledged,O,0).buffer}static serializeCancel(O){return D.alloc(w.Cancel,O,0).buffer}static serializeReplyOK(O,U,j){if(typeof U>"u")return this.d(O);if(U instanceof m.$Je)return this.e(O,U);if(U instanceof d.$Kw){const{jsonString:z,referencedBuffers:M}=g(U.value,j,!0);return this.g(O,z,M)}else return this.f(O,b(U,j))}static d(O){return D.alloc(w.ReplyOKEmpty,O,0).buffer}static e(O,U){let j=0;j+=D.sizeVSBuffer(U);const z=D.alloc(w.ReplyOKVSBuffer,O,j);return z.writeVSBuffer(U),z.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,U){const j=m.$Je.fromString(U);let z=0;z+=D.sizeLongString(j);const M=D.alloc(w.ReplyOKJSON,O,z);return M.writeLongString(j),M.buffer}static g(O,U,j){const z=m.$Je.fromString(U);let M=0;M+=D.sizeUInt32,M+=D.sizeLongString(z);for(const J of j)M+=D.sizeVSBuffer(J);const F=D.alloc(w.ReplyOKJSONWithBuffers,O,M);F.writeUInt32(j.length),F.writeLongString(z);for(const J of j)F.writeBuffer(J);return F.buffer}static deserializeReplyOKJSON(O){const U=O.readLongString();return JSON.parse(U)}static deserializeReplyOKJSONWithBuffers(O,U){const j=O.readUInt32(),z=O.readLongString(),M=[];for(let F=0;F<j;++F)M.push(O.readVSBuffer());return new d.$Kw(n(z,M,U))}static serializeReplyErr(O,U){const j=U?b(L.$3(U),null):void 0;if(typeof j!="string")return this.h(O);const z=m.$Je.fromString(j);let M=0;M+=D.sizeLongString(z);const F=D.alloc(w.ReplyErrError,O,M);return F.writeLongString(z),F.buffer}static deserializeReplyErrError(O){const U=O.readLongString();return JSON.parse(U)}static h(O){return D.alloc(w.ReplyErrEmpty,O,0).buffer}}var w;(function(N){N[N.RequestJSONArgs=1]="RequestJSONArgs",N[N.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",N[N.RequestMixedArgs=3]="RequestMixedArgs",N[N.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",N[N.Acknowledged=5]="Acknowledged",N[N.Cancel=6]="Cancel",N[N.ReplyOKEmpty=7]="ReplyOKEmpty",N[N.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",N[N.ReplyOKJSON=9]="ReplyOKJSON",N[N.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",N[N.ReplyErrError=11]="ReplyErrError",N[N.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var y;(function(N){N[N.String=1]="String",N[N.VSBuffer=2]="VSBuffer",N[N.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",N[N.Undefined=4]="Undefined"})(y||(y={}))}),define(ye[339],Se([1,0,22,29,15,89,5]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$8J=void 0,e.$9J=C,e.$0J=S,e.$8J=(0,L.$Ai)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${T.join("")}]+`),c=7;function C(P){if(P.scheme!==A.Schemas.vscodeNotebookCell)return;const b=P.fragment.indexOf("s");if(b<0)return;const a=parseInt(P.fragment.substring(0,b).replace(p,""),c),u=(0,r.$3e)(P.fragment.substring(b+1)).toString();if(!isNaN(a))return{handle:a,notebook:P.with({scheme:u,fragment:null})}}function S(P,b){const a=b.toString(c),f=`${a.length<T.length?T[a.length-1]:"z"}${a}s${(0,r.$4e)(r.$Je.fromString(P.scheme),!0,!0)}`;return P.with({scheme:A.Schemas.vscodeNotebookCell,fragment:f})}class d{constructor(){this.a=new m.$Ac}getNotebook(b){if(b.scheme===A.Schemas.vscodeNotebookCell){const a=C(b);if(a){const u=this.a.get(a.notebook);if(u)return u}}return this.a.get(b)}addNotebookDocument(b){this.a.set(b.uri,b)}removeNotebookDocument(b){this.a.delete(b.uri)}}e.$$J=d,(0,R.$Fs)(e.$8J,d,R.InstantiationType.Delayed)}),define(ye[126],Se([1,0,22,39,40,107,15,16,11,35,339]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sK=e.$pK=e.CellStatusbarAlignment=e.$oK=e.NotebookEditorPriority=e.$lK=e.$kK=e.$iK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$hK=e.$gK=e.$fK=e.$eK=e.CellKind=e.$dK=e.$cK=e.$bK=void 0,e.$jK=l,e.$mK=o,e.$nK=$,e.$qK=D,e.$rK=I,e.$bK="workbench.editor.notebook",e.$cK="workbench.editor.notebookTextDiffEditor",e.$dK="workbench.editor.interactive";var S;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(S||(e.CellKind=S={})),e.$eK=["application/json","application/javascript","text/html","image/svg+xml",R.$Ys.latex,R.$Ys.markdown,"image/png","image/jpeg",R.$Ys.text],e.$fK=[R.$Ys.latex,R.$Ys.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Ys.text],e.$gK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$hK="_notAvailable";var d;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(d||(e.NotebookRunState=d={}));var P;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var b;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var a;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var u;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(u||(e.RendererMessagingSpec=u={}));var f;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var g;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(g||(e.SelectionStateType=g={}));var n;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var s;(function(F){F.scheme=L.Schemas.vscodeNotebookCell;function J(he,re){return(0,C.$0J)(he,re)}F.generate=J;function ee(he){return(0,C.$9J)(he)}F.parse=ee;function V(he,re){return he.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${he.scheme!==L.Schemas.file?he.scheme:""}`})}F.generateCellOutputUri=V;function H(he){if(he.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(he.fragment);if(!re)return;const ve=re[1]&&re[1]!==""?re[1]:void 0,pe=re[2];return{outputId:ve,notebook:he.with({scheme:pe||L.Schemas.file,fragment:null})}}F.parseCellOutputUri=H;function _(he,re,ve){return F.generate(he,re).with({scheme:ve})}F.generateCellPropertyUri=_;function ne(he,re){if(he.scheme===re)return F.parse(he.with({scheme:F.scheme}))}F.parseCellPropertyUri=ne})(s||(e.CellUri=s={}));const i=F=>p.$i?F.replace(/\//g,"\\"):F;class t{constructor(J=[],ee=e.$eK){this.e=ee,this.d=[...new Set(J)].map(V=>({pattern:V,matches:m.$uk(i(V))}))}sort(J){const ee=new Map(A.Iterable.map(J,H=>[H,i(H)]));let V=[];for(const{matches:H}of this.d)for(const[_,ne]of ee)if(H(ne)){V.push(_),ee.delete(_);break}return ee.size&&(V=V.concat([...ee.keys()].sort((H,_)=>this.e.indexOf(H)-this.e.indexOf(_)))),V}prioritize(J,ee){const V=this.f(J);if(V===-1){this.d.unshift({pattern:J,matches:m.$uk(i(J))});return}const H=new Set(ee.map(ne=>this.f(ne,V)));H.delete(-1);const _=Array.from(H).sort();this.d.splice(V+1,0,..._.map(ne=>this.d[ne]));for(let ne=_.length-1;ne>=0;ne--)this.d.splice(_[ne],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,ee=this.d.length){const V=i(J);for(let H=0;H<ee;H++)if(this.d[H].matches(V))return H;return-1}}e.$iK=t;function l(F,J,ee,V=(H,_)=>H===_){const H=[];function _(re,ve,pe){if(ve===0&&pe.length===0)return;const Q=H[H.length-1];Q&&Q.start+Q.deleteCount===re?(Q.deleteCount+=ve,Q.toInsert.push(...pe)):H.push({start:re,deleteCount:ve,toInsert:pe})}let ne=0,he=0;for(;;){if(ne===F.length){_(ne,0,J.slice(he));break}if(he===J.length){_(ne,F.length-ne,[]);break}const re=F[ne],ve=J[he];if(V(re,ve)){ne+=1,he+=1;continue}ee(ve)?(_(ne,1,[]),ne+=1):(_(ne,0,[ve]),he+=1)}return H}e.$kK=new c.$Rj("notebookEditorCursorAtBoundary","none"),e.$lK=new c.$Rj("notebookEditorCursorAtLineBoundary","none");var h;(function(F){F.default="default",F.option="option"})(h||(e.NotebookEditorPriority=h={}));function o(F){const J=F;return!!((typeof J.include=="string"||m.$vk(J.include))&&(typeof J.exclude=="string"||m.$vk(J.exclude)))}function $(F,J,ee){if(Array.isArray(F.viewType)&&F.viewType.indexOf(J)>=0||F.viewType===J)return!0;if(F.filenamePattern){const V=o(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,H=o(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(m.$tk(V,(0,T.$nc)(ee.fsPath).toLowerCase()))return!(H&&m.$tk(H,(0,T.$nc)(ee.fsPath).toLowerCase()))}return!1}e.$oK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var E;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(E||(e.CellStatusbarAlignment=E={}));class k{static{this.d="notebook/"}static create(J){return`${k.d}${J}`}static parse(J){if(J.startsWith(k.d))return J.substring(k.d.length)}}e.$pK=k;function D(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}const v=new TextDecoder;function I(F){const J=[];let ee=!1;for(const ne of F)(J.length===0||ee)&&(J.push(ne),ee=!0);let V=N(J);const H=r.$Je.concat(J.map(ne=>r.$Je.wrap(ne))),_=M(H);return V=V||_.byteLength!==H.byteLength,{data:_,didCompression:V}}e.$sK="\x1B[A";const w=e.$sK.split("").map(F=>F.charCodeAt(0)),y=10;function N(F){let J=!1;return F.forEach((ee,V)=>{if(V===0||ee.length<e.$sK.length)return;const H=F[V-1],_=ee.subarray(0,e.$sK.length);if(_[0]===w[0]&&_[1]===w[1]&&_[2]===w[2]){const ne=H.lastIndexOf(y);if(ne===-1)return;J=!0,F[V-1]=H.subarray(0,ne),F[V]=ee.subarray(e.$sK.length)}}),J}function O(F){let J=F;do F=J,J=F.replace(/[^\n]\x08/gm,"");while(J.length<F.length);return F}function U(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const J=F.match(/^(.*)\r+/m)[1];let ee=F.match(/\r+(.*)$/m)[1];ee=ee+J.slice(ee.length,J.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return F}const j=8,z=13;function M(F){return!F.buffer.includes(j)&&!F.buffer.includes(z)?F:r.$Je.fromString(U(O(v.decode(F.buffer))))}}),define(ye[10],Se([1,0,19,14,86,29,107,13,18,2,32,24,28,71,126]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b){"use strict";var a,u,f,g,n,s,i,t,l,h,o,$,E,k,D,v,I;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$MO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$sO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$fO=e.$eO=e.$dO=e.$cO=e.$aO=e.$_N=e.$$N=e.$0N=e.TestRunProfileKind=e.TestResultState=e.$9N=e.$8N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7N=e.NotebookVariablesRequestKind=e.$6N=e.$5N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.ColorThemeKind=e.$XN=e.$WN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VN=e.$UN=e.DebugConsoleMode=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$ON=e.$NN=e.FileChangeType=e.$MN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$LN=e.$KN=e.$JN=e.$IN=e.InlineCompletionTriggerKind=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$vN=e.ConfigurationTarget=e.$uN=e.$tN=e.$sN=e.$rN=e.DocumentPasteTriggerKind=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$kN=e.ViewBadge=e.ProgressLocation=e.$jN=e.$iN=e.TaskScope=e.ShellQuoting=e.$hN=e.$gN=e.$fN=e.TaskPanelKind=e.TaskRevealKind=e.$eN=e.TerminalLocation=e.$dN=e.$cN=e.$bN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$aN=e.$_M=e.$$M=e.$0M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$8M=e.$7M=e.$6M=e.$5M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$4M=e.$3M=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.LanguageStatusSeverity=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.CodeActionTriggerKind=e.$QM=e.$PM=e.SymbolTag=e.SymbolKind=e.$OM=e.$NM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.DiagnosticSeverity=e.DiagnosticTag=e.$HM=e.$GM=e.FileEditType=e.$FM=e.$EM=e.$DM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$9M=at,e.$wN=Ai,e.$bO=En;function w(K){return Object.assign(K,{apply:function(...ge){if(ge.length===0)return Reflect.construct(K,[]);{const Oe=ge.length===1?[]:ge[1];return Reflect.construct(K,Oe,ge[0].constructor)}},call:function(...ge){if(ge.length===0)return Reflect.construct(K,[]);{const[Oe,...Ye]=ge;return Reflect.construct(K,Ye,Oe.constructor)}}})}var y;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(y||(e.TerminalOutputAnchor=y={}));var N;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let O=a=class{static from(...G){let ge=G;return new a(function(){if(ge){for(const Oe of ge)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();ge=void 0}})}#e;constructor(G){this.#e=G}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$wM=O,e.$wM=O=a=Je([w],O);let U=u=class{static Min(...G){if(G.length===0)throw new TypeError;let ge=G[0];for(let Oe=1;Oe<G.length;Oe++){const Ye=G[Oe];Ye.isBefore(ge)&&(ge=Ye)}return ge}static Max(...G){if(G.length===0)throw new TypeError;let ge=G[0];for(let Oe=1;Oe<G.length;Oe++){const Ye=G[Oe];Ye.isAfter(ge)&&(ge=Ye)}return ge}static isPosition(G){if(!G)return!1;if(G instanceof u)return!0;const{line:ge,character:Oe}=G;return typeof ge=="number"&&typeof Oe=="number"}static of(G){if(G instanceof u)return G;if(this.isPosition(G))return new u(G.line,G.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(G,ge){if(G<0)throw(0,m.$7)("line must be non-negative");if(ge<0)throw(0,m.$7)("character must be non-negative");this.c=G,this.e=ge}isBefore(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<G.e}isBeforeOrEqual(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<=G.e}isAfter(G){return!this.isBeforeOrEqual(G)}isAfterOrEqual(G){return!this.isBefore(G)}isEqual(G){return this.c===G.c&&this.e===G.e}compareTo(G){return this.c<G.c?-1:this.c>G.line?1:this.e<G.e?-1:this.e>G.e?1:0}translate(G,ge=0){if(G===null||ge===null)throw(0,m.$7)();let Oe;return typeof G>"u"?Oe=0:typeof G=="number"?Oe=G:(Oe=typeof G.lineDelta=="number"?G.lineDelta:0,ge=typeof G.characterDelta=="number"?G.characterDelta:0),Oe===0&&ge===0?this:new u(this.line+Oe,this.character+ge)}with(G,ge=this.character){if(G===null||ge===null)throw(0,m.$7)();let Oe;return typeof G>"u"?Oe=this.line:typeof G=="number"?Oe=G:(Oe=typeof G.line=="number"?G.line:this.line,ge=typeof G.character=="number"?G.character:this.character),Oe===this.line&&ge===this.character?this:new u(Oe,ge)}toJSON(){return{line:this.line,character:this.character}}};e.$xM=U,e.$xM=U=u=Je([w],U);let j=f=class{static isRange(G){return G instanceof f?!0:G?U.isPosition(G.start)&&U.isPosition(G.end):!1}static of(G){if(G instanceof f)return G;if(this.isRange(G))return new f(G.start,G.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(G,ge,Oe,Ye){let nt,mt;if(typeof G=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(nt=new U(G,ge),mt=new U(Oe,Ye)):U.isPosition(G)&&U.isPosition(ge)&&(nt=U.of(G),mt=U.of(ge)),!nt||!mt)throw new Error("Invalid arguments");nt.isBefore(mt)?(this.c=nt,this.e=mt):(this.c=mt,this.e=nt)}contains(G){return f.isRange(G)?this.contains(G.start)&&this.contains(G.end):U.isPosition(G)?!(U.of(G).isBefore(this.c)||this.e.isBefore(G)):!1}isEqual(G){return this.c.isEqual(G.c)&&this.e.isEqual(G.e)}intersection(G){const ge=U.Max(G.start,this.c),Oe=U.Min(G.end,this.e);if(!ge.isAfter(Oe))return new f(ge,Oe)}union(G){if(this.contains(G))return this;if(G.contains(this))return G;const ge=U.Min(G.start,this.c),Oe=U.Max(G.end,this.end);return new f(ge,Oe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(G,ge=this.end){if(G===null||ge===null)throw(0,m.$7)();let Oe;return G?U.isPosition(G)?Oe=G:(Oe=G.start||this.start,ge=G.end||this.end):Oe=this.start,Oe.isEqual(this.c)&&ge.isEqual(this.end)?this:new f(Oe,ge)}toJSON(){return[this.start,this.end]}};e.$yM=j,e.$yM=j=f=Je([w],j);let z=g=class extends j{static isSelection(G){return G instanceof g?!0:G?j.isRange(G)&&U.isPosition(G.anchor)&&U.isPosition(G.active)&&typeof G.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(G,ge,Oe,Ye){let nt,mt;if(typeof G=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof Ye=="number"?(nt=new U(G,ge),mt=new U(Oe,Ye)):U.isPosition(G)&&U.isPosition(ge)&&(nt=U.of(G),mt=U.of(ge)),!nt||!mt)throw new Error("Invalid arguments");super(nt,mt),this.f=nt,this.g=mt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$zM=z,e.$zM=z=g=Je([w],z);const M=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,m.$7)("connectionToken")};class F{static isResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.host=="string"&&typeof G.port=="number"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,ge,Oe){if(typeof G!="string"||G.length===0)throw(0,m.$7)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,m.$7)("port");typeof Oe<"u"&&M(Oe),this.host=G,this.port=Math.round(ge),this.connectionToken=Oe}}e.$AM=F;class J{static isManagedResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.makeConnection=="function"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,ge){this.makeConnection=G,this.connectionToken=ge,typeof ge<"u"&&M(ge)}}e.$BM=J;class ee extends Error{static NotAvailable(G,ge){return new ee(G,P.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(G){return new ee(G,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(G,ge=P.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(G),this._message=G,this._code=ge,this._detail=Oe,Object.setPrototypeOf(this,ee.prototype)}}e.$CM=ee;var V;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(V||(e.EndOfLine=V={}));var H;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(H||(e.EnvironmentVariableMutatorType=H={}));let _=n=class{static isTextEdit(G){return G instanceof n?!0:G?j.isRange(G)&&typeof G.newText=="string":!1}static replace(G,ge){return new n(G,ge)}static insert(G,ge){return n.replace(new j(G,G),ge)}static delete(G){return n.replace(G,"")}static setEndOfLine(G){const ge=new n(new j(new U(0,0),new U(0,0)),"");return ge.newEol=G,ge}get range(){return this.c}set range(G){if(G&&!j.isRange(G))throw(0,m.$7)("range");this.c=G}get newText(){return this.e||""}set newText(G){if(G&&typeof G!="string")throw(0,m.$7)("newText");this.e=G}get newEol(){return this.f}set newEol(G){if(G&&typeof G!="number")throw(0,m.$7)("newEol");this.f=G}constructor(G,ge){this.c=G,this.e=ge}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$DM=_,e.$DM=_=n=Je([w],_);let ne=s=class{static isNotebookCellEdit(G){return G instanceof s?!0:G?bi.isNotebookRange(G)&&Array.isArray(G.newCells):!1}static replaceCells(G,ge){return new s(G,ge)}static insertCells(G,ge){return new s(new bi(G,G),ge)}static deleteCells(G){return new s(G,[])}static updateCellMetadata(G,ge){const Oe=new s(new bi(G,G),[]);return Oe.newCellMetadata=ge,Oe}static updateNotebookMetadata(G){const ge=new s(new bi(0,0),[]);return ge.newNotebookMetadata=G,ge}constructor(G,ge){this.range=G,this.newCells=ge}};e.$EM=ne,e.$EM=ne=s=Je([w],ne);class he{static isSnippetTextEdit(G){return G instanceof he?!0:G?j.isRange(G.range)&&pe.isSnippetString(G.snippet):!1}static replace(G,ge){return new he(G,ge)}static insert(G,ge){return he.replace(new j(G,G),ge)}constructor(G,ge){this.range=G,this.snippet=ge}}e.$FM=he;var re;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let ve=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(G,ge,Oe,Ye){this.c.push({_type:re.File,from:G,to:ge,options:Oe,metadata:Ye})}createFile(G,ge,Oe){this.c.push({_type:re.File,from:void 0,to:G,options:ge,metadata:Oe})}deleteFile(G,ge,Oe){this.c.push({_type:re.File,from:G,to:void 0,options:ge,metadata:Oe})}e(G,ge,Oe){this.c.push({_type:re.Cell,metadata:Oe,uri:G,edit:{editType:b.CellEditType.DocumentMetadata,metadata:ge},notebookMetadata:ge})}f(G,ge,Oe,Ye){const nt=ge.start,mt=ge.end;(nt!==mt||Oe.length>0)&&this.c.push({_type:re.CellReplace,uri:G,index:nt,count:mt-nt,cells:Oe,metadata:Ye})}g(G,ge,Oe,Ye){this.c.push({_type:re.Cell,metadata:Ye,uri:G,edit:{editType:b.CellEditType.Metadata,index:ge,metadata:Oe}})}replace(G,ge,Oe,Ye){this.c.push({_type:re.Text,uri:G,edit:new _(ge,Oe),metadata:Ye})}insert(G,ge,Oe,Ye){this.replace(G,new j(ge,ge),Oe,Ye)}delete(G,ge,Oe){this.replace(G,ge,"",Oe)}has(G){return this.c.some(ge=>ge._type===re.Text&&ge.uri.toString()===G.toString())}set(G,ge){if(ge)for(const Oe of ge){if(!Oe)continue;let Ye,nt;Array.isArray(Oe)?(Ye=Oe[0],nt=Oe[1]):Ye=Oe,ne.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(G,Ye.range.start,Ye.newCellMetadata,nt):Ye.newNotebookMetadata?this.e(G,Ye.newNotebookMetadata,nt):this.f(G,Ye.range,Ye.newCells,nt):he.isSnippetTextEdit(Ye)?this.c.push({_type:re.Snippet,uri:G,range:Ye.range,edit:Ye.snippet,metadata:nt}):this.c.push({_type:re.Text,uri:G,edit:Ye,metadata:nt})}else{for(let Oe=0;Oe<this.c.length;Oe++){const Ye=this.c[Oe];switch(Ye._type){case re.Text:case re.Snippet:case re.Cell:case re.CellReplace:Ye.uri.toString()===G.toString()&&(this.c[Oe]=void 0);break}}(0,r.$Ib)(this.c)}}get(G){const ge=[];for(const Oe of this.c)Oe._type===re.Text&&Oe.uri.toString()===G.toString()&&ge.push(Oe.edit);return ge}entries(){const G=new R.$Ac;for(const ge of this.c)if(ge._type===re.Text){let Oe=G.get(ge.uri);Oe||(Oe=[ge.uri,[]],G.set(ge.uri,Oe)),Oe[1].push(ge.edit)}return[...G.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$GM=ve,e.$GM=ve=Je([w],ve);let pe=i=class{static isSnippetString(G){return G instanceof i?!0:G?typeof G.value=="string":!1}static c(G){return G.replace(/\$|}|\\/g,"\\$&")}constructor(G){this.e=1,this.value=G||""}appendText(G){return this.value+=i.c(G),this}appendTabstop(G=this.e++){return this.value+="$",this.value+=G,this}appendPlaceholder(G,ge=this.e++){if(typeof G=="function"){const Oe=new i;Oe.e=this.e,G(Oe),this.e=Oe.e,G=Oe.value}else G=i.c(G);return this.value+="${",this.value+=ge,this.value+=":",this.value+=G,this.value+="}",this}appendChoice(G,ge=this.e++){const Oe=G.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(G,ge){if(typeof ge=="function"){const Oe=new i;Oe.e=this.e,ge(Oe),this.e=Oe.e,ge=Oe.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=G,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};e.$HM=pe,e.$HM=pe=i=Je([w],pe);var Q;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(Q||(e.DiagnosticTag=Q={}));var B;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(B||(e.DiagnosticSeverity=B={}));let se=t=class{static isLocation(G){return G instanceof t?!0:G?j.isRange(G.range)&&c.URI.isUri(G.uri):!1}constructor(G,ge){if(this.uri=G,ge)if(j.isRange(ge))this.range=j.of(ge);else if(U.isPosition(ge))this.range=new j(ge,ge);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$IM=se,e.$IM=se=t=Je([w],se);let ae=class{static is(G){return G?typeof G.message=="string"&&G.location&&j.isRange(G.location.range)&&c.URI.isUri(G.location.uri):!1}constructor(G,ge){this.location=G,this.message=ge}static isEqual(G,ge){return G===ge?!0:!G||!ge?!1:G.message===ge.message&&G.location.range.isEqual(ge.location.range)&&G.location.uri.toString()===ge.location.uri.toString()}};e.$JM=ae,e.$JM=ae=Je([w],ae);let ie=class{constructor(G,ge,Oe=B.Error){if(!j.isRange(G))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=G,this.message=ge,this.severity=Oe}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(G,ge){return G===ge?!0:!G||!ge?!1:G.message===ge.message&&G.severity===ge.severity&&G.code===ge.code&&G.severity===ge.severity&&G.source===ge.source&&G.range.isEqual(ge.range)&&(0,r.$ub)(G.tags,ge.tags)&&(0,r.$ub)(G.relatedInformation,ge.relatedInformation,ae.isEqual)}};e.$KM=ie,e.$KM=ie=Je([w],ie);let ce=class{constructor(G,ge){if(!G)throw new Error("Illegal argument, contents must be defined");Array.isArray(G)?this.contents=G:this.contents=[G],this.range=ge}};e.$LM=ce,e.$LM=ce=Je([w],ce);let ue=class extends ce{constructor(G,ge,Oe,Ye){super(G,ge),this.canIncreaseHover=Oe,this.canDecreaseHover=Ye}};e.$MM=ue,e.$MM=ue=Je([w],ue);var Z;(function(K){K[K.Increase=0]="Increase",K[K.Decrease=1]="Decrease"})(Z||(e.HoverVerbosityAction=Z={}));var oe;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let $e=class{constructor(G,ge=oe.Text){this.range=G,this.kind=ge}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$NM=$e,e.$NM=$e=Je([w],$e);let be=class{constructor(G,ge){this.uri=G,this.highlights=ge}toJSON(){return{uri:this.uri,highlights:this.highlights.map(G=>G.toJSON())}}};e.$OM=be,e.$OM=be=Je([w],be);var Ne;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(Ne||(e.SymbolKind=Ne={}));var Be;(function(K){K[K.Deprecated=1]="Deprecated"})(Be||(e.SymbolTag=Be={}));let De=l=class{static validate(G){if(!G.name)throw new Error("name must not be falsy")}constructor(G,ge,Oe,Ye,nt){this.name=G,this.kind=ge,this.containerName=nt,typeof Oe=="string"&&(this.containerName=Oe),Ye instanceof se?this.location=Ye:Oe instanceof j&&(this.location=new se(Ye,Oe)),l.validate(this)}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};e.$PM=De,e.$PM=De=l=Je([w],De);let Ie=h=class{static validate(G){if(!G.name)throw new Error("name must not be falsy");if(!G.range.contains(G.selectionRange))throw new Error("selectionRange must be contained in fullRange");G.children?.forEach(h.validate)}constructor(G,ge,Oe,Ye,nt){this.name=G,this.detail=ge,this.kind=Oe,this.range=Ye,this.selectionRange=nt,this.children=[],h.validate(this)}};e.$QM=Ie,e.$QM=Ie=h=Je([w],Ie);var Le;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(Le||(e.CodeActionTriggerKind=Le={}));let W=class{constructor(G,ge){this.title=G,this.kind=ge}};e.$RM=W,e.$RM=W=Je([w],W);let q=class{static{o=this}static{this.c="."}constructor(G){this.value=G}append(G){return new o(this.value?this.value+o.c+G:G)}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+o.c)}};e.$SM=q,e.$SM=q=o=Je([w],q),q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorMove=q.Refactor.append("move"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll"),q.Notebook=q.Empty.append("notebook");let Y=class{constructor(G,ge){if(this.range=G,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$TM=Y,e.$TM=Y=Je([w],Y);class x{constructor(G,ge,Oe,Ye,nt,mt){this.kind=G,this.name=ge,this.detail=Oe,this.uri=Ye,this.range=nt,this.selectionRange=mt}}e.$UM=x;class fe{constructor(G,ge){this.fromRanges=ge,this.from=G}}e.$VM=fe;class we{constructor(G,ge){this.fromRanges=ge,this.to=G}}e.$WM=we;var Me;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Me||(e.LanguageStatusSeverity=Me={}));let qe=class{constructor(G,ge){this.range=G,this.command=ge}get isResolved(){return!!this.command}};e.$XM=qe,e.$XM=qe=Je([w],qe);let He=$=class{#e;static isMarkdownString(G){return G instanceof $?!0:G&&G.appendCodeblock&&G.appendMarkdown&&G.appendText&&G.value!==void 0}constructor(G,ge=!1){this.#e=new A.$Xk(G,{supportThemeIcons:ge})}get value(){return this.#e.value}set value(G){this.#e.value=G}get isTrusted(){return this.#e.isTrusted}set isTrusted(G){this.#e.isTrusted=G}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(G){this.#e.supportThemeIcons=G}get supportHtml(){return this.#e.supportHtml}set supportHtml(G){this.#e.supportHtml=G}get baseUri(){return this.#e.baseUri}set baseUri(G){this.#e.baseUri=G}appendText(G){return this.#e.appendText(G),this}appendMarkdown(G){return this.#e.appendMarkdown(G),this}appendCodeblock(G,ge){return this.#e.appendCodeblock(ge??"",G),this}};e.$YM=He,e.$YM=He=$=Je([w],He);let Ze=class{constructor(G,ge){this.label=G,this.documentation=ge}};e.$ZM=Ze,e.$ZM=Ze=Je([w],Ze);let it=class{constructor(G,ge){this.label=G,this.documentation=ge,this.parameters=[]}};e.$1M=it,e.$1M=it=Je([w],it);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$2M=tt,e.$2M=tt=Je([w],tt);var rt;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(rt||(e.SignatureHelpTriggerKind=rt={}));var ot;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(ot||(e.InlayHintKind=ot={}));let ft=class{constructor(G){this.value=G}};e.$3M=ft,e.$3M=ft=Je([w],ft);let ut=class{constructor(G,ge,Oe){this.position=G,this.label=ge,this.kind=Oe}};e.$4M=ut,e.$4M=ut=Je([w],ut);var st;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var Pe;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Pe||(e.CompletionItemKind=Pe={}));var Ue;(function(K){K[K.Deprecated=1]="Deprecated"})(Ue||(e.CompletionItemTag=Ue={}));let Ae=class{constructor(G,ge){this.label=G,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$5M=Ae,e.$5M=Ae=Je([w],Ae);let Te=class{constructor(G=[],ge=!1){this.items=G,this.isIncomplete=ge}};e.$6M=Te,e.$6M=Te=Je([w],Te);let le=class{constructor(G,ge,Oe){this.insertText=G,this.range=ge,this.command=Oe}};e.$7M=le,e.$7M=le=Je([w],le);let X=class{constructor(G){this.commands=void 0,this.suppressSuggestions=void 0,this.items=G}};e.$8M=X,e.$8M=X=Je([w],X);var Ce;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(Ce||(e.PartialAcceptTriggerKind=Ce={}));var Qe;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Qe||(e.ViewColumn=Qe={}));var _e;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(_e||(e.StatusBarAlignment=_e={}));function at(K,G){return`${S.$Wm.toKey(K)}.${G}`}var lt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(lt||(e.TextEditorLineNumbersStyle=lt={}));var Dt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Dt||(e.TextDocumentSaveReason=Dt={}));var Ct;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ct||(e.TextEditorRevealType=Ct={}));var Ot;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var Yt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Yt||(e.TextDocumentChangeReason=Yt={}));var _t;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(_t||(e.DecorationRangeBehavior=_t={})),function(K){function G(ge){switch(ge){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=G}(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var xe;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(xe||(e.SyntaxTokenType=xe={})),function(K){function G(ge){switch(ge){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=G}(xe||(e.SyntaxTokenType=xe={}));let Vt=class{constructor(G,ge){if(ge&&!c.URI.isUri(ge))throw(0,m.$7)("target");if(!j.isRange(G)||G.isEmpty)throw(0,m.$7)("range");this.range=G,this.target=ge}};e.$0M=Vt,e.$0M=Vt=Je([w],Vt);let zt=class{constructor(G,ge,Oe,Ye){this.red=G,this.green=ge,this.blue=Oe,this.alpha=Ye}};e.$$M=zt,e.$$M=zt=Je([w],zt);let gt=class{constructor(G,ge){if(ge&&!(ge instanceof zt))throw(0,m.$7)("color");if(!j.isRange(G)||G.isEmpty)throw(0,m.$7)("range");this.range=G,this.color=ge}};e.$_M=gt,e.$_M=gt=Je([w],gt);let $t=class{constructor(G){if(!G||typeof G!="string")throw(0,m.$7)("label");this.label=G}};e.$aN=$t,e.$aN=$t=Je([w],$t);var ei;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(ei||(e.ColorFormat=ei={}));var Xt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Xt||(e.SourceControlInputBoxValidationType=Xt={}));var Bt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(Bt||(e.TerminalExitReason=Bt={}));var bt;(function(K){K[K.Low=0]="Low",K[K.Medium=1]="Medium",K[K.High=2]="High"})(bt||(e.TerminalShellExecutionCommandLineConfidence=bt={}));class Mt{constructor(G,ge,Oe){if(this.startIndex=G,this.length=ge,this.tooltip=Oe,typeof G!="number"||G<0)throw(0,m.$7)("startIndex");if(typeof ge!="number"||ge<1)throw(0,m.$7)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,m.$7)("tooltip")}}e.$bN=Mt;class Ht{constructor(G){this.uri=G}}e.$cN=Ht;class Wt{constructor(G){this.terminalCommand=G}}e.$dN=Wt;var Xe;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Xe||(e.TerminalLocation=Xe={}));class ti{constructor(G){if(this.options=G,typeof G!="object")throw(0,m.$7)("options")}}e.$eN=ti;var ii;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(ii||(e.TaskRevealKind=ii={}));var li;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(li||(e.TaskPanelKind=li={}));let kt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(G){switch(G){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(G,ge){if(this.label=ge,typeof G!="string"||typeof ge!="string")throw(0,m.$7)("name");this.c=G}get id(){return this.c}};e.$fN=kt,e.$fN=kt=E=Je([w],kt);function Nt(K){let G="";for(let ge=0;ge<K.length;ge++)G+=K[ge].replace(/,/g,",,")+",";return G}let Rt=class{constructor(G,ge,Oe){if(typeof G!="string")throw(0,m.$7)("process");this.e=[],this.c=G,ge!==void 0&&(Array.isArray(ge)?(this.e=ge,this.f=Oe):this.f=ge)}get process(){return this.c}set process(G){if(typeof G!="string")throw(0,m.$7)("process");this.c=G}get args(){return this.e}set args(G){Array.isArray(G)||(G=[]),this.e=G}get options(){return this.f}set options(G){this.f=G}computeId(){const G=[];if(G.push("process"),this.c!==void 0&&G.push(this.c),this.e&&this.e.length>0)for(const ge of this.e)G.push(ge);return Nt(G)}};e.$gN=Rt,e.$gN=Rt=Je([w],Rt);let Ft=class{constructor(G,ge,Oe){if(this.f=[],Array.isArray(ge)){if(!G)throw(0,m.$7)("command can't be undefined or null");if(typeof G!="string"&&typeof G.value!="string")throw(0,m.$7)("command");this.e=G,this.f=ge,this.g=Oe}else{if(typeof G!="string")throw(0,m.$7)("commandLine");this.c=G,this.g=ge}}get commandLine(){return this.c}set commandLine(G){if(typeof G!="string")throw(0,m.$7)("commandLine");this.c=G}get command(){return this.e?this.e:""}set command(G){if(typeof G!="string"&&typeof G.value!="string")throw(0,m.$7)("command");this.e=G}get args(){return this.f}set args(G){this.f=G||[]}get options(){return this.g}set options(G){this.g=G}computeId(){const G=[];if(G.push("shell"),this.c!==void 0&&G.push(this.c),this.e!==void 0&&G.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ge of this.f)G.push(typeof ge=="string"?ge:ge.value);return Nt(G)}};e.$hN=Ft,e.$hN=Ft=Je([w],Ft);var ui;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(ui||(e.ShellQuoting=ui={}));var qt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(qt||(e.TaskScope=qt={}));class si{constructor(G){this.c=G}computeId(){return"customExecution"+(0,C.$Wg)()}set callback(G){this.c=G}get callback(){return this.c}}e.$iN=si;let Ut=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(G,ge,Oe,Ye,nt,mt){this.k=!1,this.l=this.definition=G;let wt;typeof ge=="string"?(this.o=this.name=ge,this.w=this.source=Oe,this.execution=Ye,wt=nt,this.k=!0):ge===qt.Global||ge===qt.Workspace?(this.target=ge,this.o=this.name=Oe,this.w=this.source=Ye,this.execution=nt,wt=mt):(this.target=ge,this.o=this.name=Oe,this.w=this.source=Ye,this.execution=nt,wt=mt),typeof wt=="string"?(this.r=[wt],this.t=!0):Array.isArray(wt)?(this.r=wt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(G){this.j=G}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Rt?this.l={type:k.e,id:this.q.computeId()}:this.q instanceof Ft?this.l={type:k.f,id:this.q.computeId()}:this.q instanceof si?this.l={type:k.c,id:this.q.computeId()}:this.l={type:k.g,id:(0,C.$Wg)()}}get definition(){return this.l}set definition(G){if(G==null)throw(0,m.$7)("Kind can't be undefined or null");this.B(),this.l=G}get scope(){return this.m}set target(G){this.B(),this.m=G}get name(){return this.o}set name(G){if(typeof G!="string")throw(0,m.$7)("name");this.B(),this.o=G}get execution(){return this.q}set execution(G){G===null&&(G=void 0),this.B(),this.q=G;const ge=this.l.type;(k.g===ge||k.e===ge||k.f===ge||k.c===ge)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(G){if(Array.isArray(G))this.B(),this.r=G,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(G){G!==!0&&G!==!1&&(G=!1),this.B(),this.u=G}get source(){return this.w}set source(G){if(typeof G!="string"||G.length===0)throw(0,m.$7)("source must be a string of length > 0");this.B(),this.w=G}get group(){return this.x}set group(G){G===null&&(G=void 0),this.B(),this.x=G}get detail(){return this.A}set detail(G){G===null&&(G=void 0),this.A=G}get presentationOptions(){return this.y}set presentationOptions(G){G==null&&(G=Object.create(null)),this.B(),this.y=G}get runOptions(){return this.z}set runOptions(G){G==null&&(G=Object.create(null)),this.B(),this.z=G}};e.$jN=Ut,e.$jN=Ut=k=Je([w],Ut);var Zt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(Zt||(e.ProgressLocation=Zt={}));var oi;(function(K){function G(ge){const Oe=ge;return(0,p.$eg)(Oe.value)?Oe.tooltip&&!(0,p.$ag)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}K.isViewBadge=G})(oi||(e.ViewBadge=oi={}));let At=D=class{static isTreeItem(G,ge){const Oe=G;if(Oe.checkboxState!==void 0){const Ye=(0,p.$eg)(Oe.checkboxState)?Oe.checkboxState:(0,p.$cg)(Oe.checkboxState)&&(0,p.$eg)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,nt=!(0,p.$eg)(Oe.checkboxState)&&(0,p.$cg)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==pt.Checked&&Ye!==pt.Unchecked||nt!==void 0&&!(0,p.$ag)(nt))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(G instanceof D)return!0;if(Oe.label!==void 0&&!(0,p.$ag)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,p.$ag)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,p.$ag)(Oe.iconPath)&&!c.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,p.$ag)(Oe.iconPath.id))){const Ye=Oe.iconPath;if(!Ye||!(0,p.$ag)(Ye.light)&&!c.URI.isUri(Ye.light)&&!(0,p.$ag)(Ye.dark)&&!c.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,p.$ag)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!c.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,p.$ag)(Oe.tooltip)&&!(Oe.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<vt.None&&Oe.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,p.$ag)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(G,ge=vt.None){this.collapsibleState=ge,c.URI.isUri(G)?this.resourceUri=G:this.label=G}};e.$kN=At,e.$kN=At=D=Je([w],At);var vt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var pt;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let Gt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(G){this.value=G}};e.$lN=Gt,e.$lN=Gt=Je([w],Gt);class St extends Gt{}e.$mN=St;class ai extends St{#e;constructor(G){super(""),this.#e=G}asFile(){return this.#e}}e.$nN=ai;class Kt{constructor(G,ge,Oe,Ye){this.name=G,this.uri=ge,this._itemId=Oe,this.c=Ye}data(){return this.c()}}e.$oN=Kt;let $i=class{#e=new Map;constructor(G){for(const[ge,Oe]of G??[]){const Ye=this.#e.get(this.#t(ge));Ye?Ye.push(Oe):this.#e.set(this.#t(ge),[Oe])}}get(G){return this.#e.get(this.#t(G))?.[0]}set(G,ge){this.#e.set(this.#t(G),[ge])}forEach(G,ge){for(const[Oe,Ye]of this.#e)for(const nt of Ye)G.call(ge,nt,Oe,this)}*[Symbol.iterator](){for(const[G,ge]of this.#e)for(const Oe of ge)yield[G,Oe]}#t(G){return G.toLowerCase()}};e.$pN=$i,e.$pN=$i=Je([w],$i);let di=class{constructor(G,ge,Oe){this.insertText=G,this.title=ge,this.kind=Oe}};e.$qN=di,e.$qN=di=Je([w],di);var Di;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})(Di||(e.DocumentPasteTriggerKind=Di={}));class Tt{static{this.c="."}constructor(G){this.value=G}append(...G){return new Tt((this.value?[this.value,...G]:G).join(Tt.c))}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+Tt.c)}}e.$rN=Tt,Tt.Empty=new Tt("");class Ci{constructor(G,ge,Oe){this.title=ge,this.insertText=G,this.kind=Oe}}e.$sN=Ci;let ci=class{constructor(G,ge){this.id=G,this.color=ge}static isThemeIcon(G){return typeof G.id!="string"?(console.log("INVALID ThemeIcon, invalid id",G.id),!1):!0}};e.$tN=ci,e.$tN=ci=Je([w],ci),ci.File=new ci("file"),ci.Folder=new ci("folder");let Pt=class{constructor(G){this.id=G}};e.$uN=Pt,e.$uN=Pt=Je([w],Pt);var Ii;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Ii||(e.ConfigurationTarget=Ii={}));let vi=class{get base(){return this.c}set base(G){this.c=G,this.e=c.URI.file(G)}get baseUri(){return this.e}set baseUri(G){this.e=G,this.c=G.fsPath}constructor(G,ge){if(typeof G!="string"&&(!G||!c.URI.isUri(G)&&!c.URI.isUri(G.uri)))throw(0,m.$7)("base");if(typeof ge!="string")throw(0,m.$7)("pattern");typeof G=="string"?this.baseUri=c.URI.file(G):c.URI.isUri(G)?this.baseUri=G:this.baseUri=G.uri,this.pattern=ge}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$vN=vi,e.$vN=vi=Je([w],vi);const pi=new WeakMap;function Ai(K,G){pi.set(K,G)}let fi=class{constructor(G,ge,Oe,Ye,nt){this.enabled=typeof G=="boolean"?G:!0,typeof ge=="string"&&(this.condition=ge),typeof Oe=="string"&&(this.hitCondition=Oe),typeof Ye=="string"&&(this.logMessage=Ye),typeof nt=="string"&&(this.mode=nt)}get id(){return this.c||(this.c=pi.get(this)??(0,C.$Wg)()),this.c}};e.$xN=fi,e.$xN=fi=Je([w],fi);let Re=class extends fi{constructor(G,ge,Oe,Ye,nt,mt){if(super(ge,Oe,Ye,nt,mt),G===null)throw(0,m.$7)("location");this.location=G}};e.$yN=Re,e.$yN=Re=Je([w],Re);let je=class extends fi{constructor(G,ge,Oe,Ye,nt,mt){super(ge,Oe,Ye,nt,mt),this.functionName=G}};e.$zN=je,e.$zN=je=Je([w],je);let ke=class extends fi{constructor(G,ge,Oe,Ye,nt,mt,wt,Qt){if(super(Ye,nt,mt,wt,Qt),!ge)throw(0,m.$7)("dataId");this.label=G,this.dataId=ge,this.canPersist=Oe}};e.$AN=ke,e.$AN=ke=Je([w],ke);let te=class{constructor(G,ge,Oe){this.command=G,this.args=ge||[],this.options=Oe}};e.$BN=te,e.$BN=te=Je([w],te);let Fe=class{constructor(G,ge){this.port=G,this.host=ge}};e.$CN=Fe,e.$CN=Fe=Je([w],Fe);let Ve=class{constructor(G){this.path=G}};e.$DN=Ve,e.$DN=Ve=Je([w],Ve);let et=class{constructor(G){this.implementation=G}};e.$EN=et,e.$EN=et=Je([w],et);class Ke{constructor(G,ge,Oe){this.session=G,this.threadId=ge,this.frameId=Oe}}e.$FN=Ke;class dt{constructor(G,ge){this.session=G,this.threadId=ge}}e.$GN=dt;let It=class{constructor(G,ge){this.range=G,this.expression=ge}};e.$HN=It,e.$HN=It=Je([w],It);var xt;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(xt||(e.InlineCompletionTriggerKind=xt={}));let ni=class{constructor(G,ge){this.range=G,this.text=ge}};e.$IN=ni,e.$IN=ni=Je([w],ni);let jt=class{constructor(G,ge,Oe=!0){this.range=G,this.variableName=ge,this.caseSensitiveLookup=Oe}};e.$JN=jt,e.$JN=jt=Je([w],jt);let Jt=class{constructor(G,ge){this.range=G,this.expression=ge}};e.$KN=Jt,e.$KN=Jt=Je([w],Jt);let Fi=class{constructor(G,ge){this.frameId=G,this.stoppedLocation=ge}};e.$LN=Fi,e.$LN=Fi=Je([w],Fi);var ji;(function(K){K[K.AIGenerated=1]="AIGenerated"})(ji||(e.NewSymbolNameTag=ji={}));var Xi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Xi||(e.NewSymbolNameTriggerKind=Xi={}));class Ui{constructor(G,ge){this.newSymbolName=G,this.tags=ge}}e.$MN=Ui;var Ti;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Ti||(e.FileChangeType=Ti={}));let zi=v=class extends Error{static FileExists(G){return new v(G,d.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(G){return new v(G,d.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(G){return new v(G,d.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(G){return new v(G,d.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(G){return new v(G,d.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(G){return new v(G,d.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(G,ge=d.FileSystemProviderErrorCode.Unknown,Oe){super(c.URI.isUri(G)?G.toString(!0):G),this.code=Oe?.name??"Unknown",(0,d.$jl)(this,ge),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.$NN=zi,e.$NN=zi=v=Je([w],zi);let Bi=class{constructor(G,ge,Oe){this.start=G,this.end=ge,this.kind=Oe}};e.$ON=Bi,e.$ON=Bi=Je([w],Bi);var yi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(yi||(e.FoldingRangeKind=yi={}));var Zi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Zi||(e.CommentThreadCollapsibleState=Zi={}));var xi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(xi||(e.CommentMode=xi={}));var Li;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(Li||(e.CommentState=Li={}));var Wi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(Wi||(e.CommentThreadState=Wi={}));var Vi;(function(K){K[K.Current=0]="Current",K[K.Outdated=1]="Outdated"})(Vi||(e.CommentThreadApplicability=Vi={}));class mn{constructor(G,ge=[]){this.tokenTypes=G,this.tokenModifiers=ge}}e.$PN=mn;function _i(K){return typeof K>"u"||(0,p.$bg)(K)}class qi{constructor(G){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,G){this.m=!0;for(let ge=0,Oe=G.tokenTypes.length;ge<Oe;ge++)this.k.set(G.tokenTypes[ge],ge);for(let ge=0,Oe=G.tokenModifiers.length;ge<Oe;ge++)this.l.set(G.tokenModifiers[ge],ge)}}push(G,ge,Oe,Ye,nt){if(typeof G=="number"&&typeof ge=="number"&&typeof Oe=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.q(G,ge,Oe,Ye,nt);if(j.isRange(G)&&typeof ge=="string"&&_i(Oe))return this.o(G,ge,Oe);throw(0,m.$7)()}o(G,ge,Oe){if(!this.m)throw new Error("Legend must be provided in constructor");if(G.start.line!==G.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ge))throw new Error("`tokenType` is not in the provided legend");const Ye=G.start.line,nt=G.start.character,mt=G.end.character-G.start.character,wt=this.k.get(ge);let Qt=0;if(Oe)for(const hi of Oe){if(!this.l.has(hi))throw new Error("`tokenModifier` is not in the provided legend");const gi=this.l.get(hi);Qt|=1<<gi>>>0}this.q(Ye,nt,mt,wt,Qt)}q(G,ge,Oe,Ye,nt){if(this.f&&(G<this.c||G===this.c&&ge<this.e)){this.f=!1;const Qt=this.g.length/5|0;let hi=0,gi=0;for(let wi=0;wi<Qt;wi++){let ki=this.g[5*wi],Qi=this.g[5*wi+1];ki===0?(ki=hi,Qi+=gi):ki+=hi,this.g[5*wi]=ki,this.g[5*wi+1]=Qi,hi=ki,gi=Qi}}let mt=G,wt=ge;this.f&&this.j>0&&(mt-=this.c,mt===0&&(wt-=this.e)),this.g[this.j++]=mt,this.g[this.j++]=wt,this.g[this.j++]=Oe,this.g[this.j++]=Ye,this.g[this.j++]=nt,this.c=G,this.e=ge}static r(G){const ge=[],Oe=G.length/5|0;for(let wt=0;wt<Oe;wt++)ge[wt]=wt;ge.sort((wt,Qt)=>{const hi=G[5*wt],gi=G[5*Qt];if(hi===gi){const wi=G[5*wt+1],ki=G[5*Qt+1];return wi-ki}return hi-gi});const Ye=new Uint32Array(G.length);let nt=0,mt=0;for(let wt=0;wt<Oe;wt++){const Qt=5*ge[wt],hi=G[Qt+0],gi=G[Qt+1],wi=G[Qt+2],ki=G[Qt+3],Qi=G[Qt+4],jn=hi-nt,br=jn===0?gi-mt:gi,Yi=5*wt;Ye[Yi+0]=jn,Ye[Yi+1]=br,Ye[Yi+2]=wi,Ye[Yi+3]=ki,Ye[Yi+4]=Qi,nt=hi,mt=gi}return Ye}build(G){return this.f?new Ei(new Uint32Array(this.g),G):new Ei(qi.r(this.g),G)}}e.$QN=qi;class Ei{constructor(G,ge){this.resultId=ge,this.data=G}}e.$RN=Ei;class gn{constructor(G,ge,Oe){this.start=G,this.deleteCount=ge,this.data=Oe}}e.$SN=gn;class $n{constructor(G,ge){this.resultId=ge,this.edits=G}}e.$TN=$n;var en;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));class Gi{constructor(G){this.name=G}}e.$UN=Gi;let Oi=class{static{this.Back={iconPath:new ci("arrow-left")}}constructor(){}};e.$VN=Oi,e.$VN=Oi=Je([w],Oi);var We;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(We||(e.QuickPickItemKind=We={}));var mi;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(mi||(e.InputBoxValidationSeverity=mi={}));var Hi;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(Hi||(e.ExtensionKind=Hi={}));class ct{static validate(G){if(typeof G.badge=="string"){let ge=(0,T.$Lf)(G.badge,0);if(ge<G.badge.length&&(ge+=(0,T.$Lf)(G.badge,ge)),G.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}else if(G.badge&&!ci.isThemeIcon(G.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!G.color&&!G.badge&&!G.tooltip)throw new Error("The decoration is empty");return!0}constructor(G,ge,Oe){this.badge=G,this.tooltip=ge,this.color=Oe}}e.$WN=ct;let yt=class{constructor(G){this.kind=G}};e.$XN=yt,e.$XN=yt=Je([w],yt);var tn;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(tn||(e.ColorThemeKind=tn={}));class bi{static isNotebookRange(G){return G instanceof bi?!0:G?typeof G.start=="number"&&typeof G.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(G,ge){if(G<0)throw(0,m.$7)("start must be positive");if(ge<0)throw(0,m.$7)("end must be positive");G<=ge?(this.c=G,this.e=ge):(this.c=ge,this.e=G)}with(G){let ge=this.c,Oe=this.e;return G.start!==void 0&&(ge=G.start),G.end!==void 0&&(Oe=G.end),ge===this.c&&Oe===this.e?this:new bi(ge,Oe)}}e.$YN=bi;class Ri{static validate(G){if(typeof G.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof G.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof G.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(G){return Array.isArray(G)&&G.every(ge=>Ri.isNotebookCellData(ge))}static isNotebookCellData(G){return!0}constructor(G,ge,Oe,Ye,nt,mt,wt){this.kind=G,this.value=ge,this.languageId=Oe,this.mime=Ye,this.outputs=nt??[],this.metadata=mt,this.executionSummary=wt,Ri.validate(this)}}e.$ZN=Ri;class pn{constructor(G){this.cells=G}}e.$1N=pn;class ri{static isNotebookCellOutputItem(G){return G instanceof ri?!0:G?typeof G.mime=="string"&&G.data instanceof Uint8Array:!1}static error(G){const ge={name:G.name,message:G.message,stack:G.stack};return ri.json(ge,"application/vnd.code.notebook.error")}static stdout(G){return ri.text(G,"application/vnd.code.notebook.stdout")}static stderr(G){return ri.text(G,"application/vnd.code.notebook.stderr")}static bytes(G,ge="application/octet-stream"){return new ri(G,ge)}static#e=new TextEncoder;static text(G,ge=L.$Ys.text){const Oe=ri.#e.encode(String(G));return new ri(Oe,ge)}static json(G,ge="text/x-json"){const Oe=JSON.stringify(G,void 0,"	");return ri.text(Oe,ge)}constructor(G,ge){this.data=G,this.mime=ge;const Oe=(0,L.$3s)(ge,!0);if(!Oe)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.$2N=ri;class Ni{static isNotebookCellOutput(G){return G instanceof Ni?!0:!G||typeof G!="object"?!1:typeof G.id=="string"&&Array.isArray(G.items)}static ensureUniqueMimeTypes(G,ge=!1){const Oe=new Set,Ye=new Set;for(let nt=0;nt<G.length;nt++){const mt=G[nt],wt=(0,L.$3s)(mt.mime);if(!Oe.has(wt)||(0,b.$qK)(wt)){Oe.add(wt);continue}Ye.add(nt),ge&&console.warn(`DUPLICATED mime type '${mt.mime}' will be dropped`)}return Ye.size===0?G:G.filter((nt,mt)=>!Ye.has(mt))}constructor(G,ge,Oe){this.items=Ni.ensureUniqueMimeTypes(G,!0),typeof ge=="string"?(this.id=ge,this.metadata=Oe):(this.id=(0,C.$Wg)(),this.metadata=ge??Oe)}}e.$3N=Ni;var nn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(nn||(e.NotebookCellKind=nn={}));var rn;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(rn||(e.NotebookCellExecutionState=rn={}));var Ki;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Ki||(e.NotebookCellStatusBarAlignment=Ki={}));var sn;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class bn{constructor(G,ge){this.text=G,this.alignment=ge}}e.$4N=bn;var on;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(on||(e.NotebookControllerAffinity=on={}));var an;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(an||(e.NotebookControllerAffinity2=an={}));class wn{constructor(G,ge=[]){this.uri=G,this.provides=(0,r.$2b)(ge)}}e.$5N=wn;class vn{constructor(G){this.label=G}}e.$6N=vn;var cn;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ji=class{constructor(G,ge){this.label=G,this.timestamp=ge}};e.$7N=Ji,e.$7N=Ji=Je([w],Ji);var ln;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(ln||(e.ExtensionMode=ln={}));var un;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var hn;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(hn||(e.StandardTokenType=hn={}));class me{constructor(G,ge){this.ranges=G,this.wordPattern=ge}}e.$8N=me;class Ee{constructor(G){this.c=G}get autoForwardAction(){return this.c}}e.$9N=Ee;var ze;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(ze||(e.TestResultState=ze={}));var ht;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(ht||(e.TestRunProfileKind=ht={}));let Et=class{constructor(G=void 0,ge=void 0,Oe=void 0,Ye=!1,nt=!0){this.include=G,this.exclude=ge,this.profile=Oe,this.continuous=Ye,this.preserveFocus=nt}};e.$0N=Et,e.$0N=Et=Je([w],Et);let Lt=I=class{static diff(G,ge,Oe){const Ye=new I(G);return Ye.expectedOutput=ge,Ye.actualOutput=Oe,Ye}constructor(G){this.message=G}};e.$$N=Lt,e.$$N=Lt=I=Je([w],Lt);let Si=class{constructor(G){this.id=G}};e.$_N=Si,e.$_N=Si=Je([w],Si);class Mi{constructor(G,ge){this.covered=G,this.total=ge,En(this)}}e.$aO=Mi;function En(K){if(K){if(K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`);if(K.total<0)throw new Error(`The number of covered items (${K.total}) cannot be negative`)}}class yn{static fromDetails(G,ge){const Oe=new Mi(0,0),Ye=new Mi(0,0),nt=new Mi(0,0);for(const wt of ge)if("branches"in wt){Oe.total+=1,Oe.covered+=wt.executed?1:0;for(const Qt of wt.branches)Ye.total+=1,Ye.covered+=Qt.executed?1:0}else nt.total+=1,nt.covered+=wt.executed?1:0;const mt=new yn(G,Oe,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return mt.detailedCoverage=ge,mt}constructor(G,ge,Oe,Ye,nt){this.uri=G,this.statementCoverage=ge,this.branchCoverage=Oe,this.declarationCoverage=Ye,this.testItem=nt}}e.$cO=yn;class Un{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,ge,Oe=[]){this.executed=G,this.location=ge,this.branches=Oe}}e.$dO=Un;class zn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,ge,Oe){this.executed=G,this.location=ge,this.label=Oe}}e.$eO=zn;class Bn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,ge,Oe){this.name=G,this.executed=ge,this.location=Oe}}e.$fO=Bn;var Sn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Sn||(e.ExternalUriOpenerPriority=Sn={}));var kn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(kn||(e.WorkspaceTrustState=kn={}));var Dn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Dn||(e.PortAutoForwardAction=Dn={}));class Wn{constructor(G,ge,Oe,Ye,nt,mt){this.kind=G,this.name=ge,this.detail=Oe,this.uri=Ye,this.range=nt,this.selectionRange=mt}}e.$gO=Wn;class Vn{constructor(G){this.uri=G}}e.$hO=Vn;class qn{constructor(G,ge){this.original=G,this.modified=ge}}e.$iO=qn;class Gn{constructor(G,ge,Oe,Ye){this.base=G,this.input1=ge,this.input2=Oe,this.result=Ye}}e.$jO=Gn;class Hn{constructor(G,ge){this.uri=G,this.viewType=ge}}e.$kO=Hn;class Kn{constructor(G){this.viewType=G}}e.$lO=Kn;class Jn{constructor(G,ge){this.uri=G,this.notebookType=ge}}e.$mO=Jn;class Qn{constructor(G,ge,Oe){this.original=G,this.modified=ge,this.notebookType=Oe}}e.$nO=Qn;class Yn{constructor(){}}e.$oO=Yn;class Xn{constructor(G,ge){this.uri=G,this.inputBoxUri=ge}}e.$pO=Xn;class Zn{constructor(){}}e.$qO=Zn;class xn{constructor(G){this.textDiffs=G}}e.$rO=xn;var In;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(In||(e.InteractiveSessionVoteDirection=In={}));var Pn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(Pn||(e.ChatCopyKind=Pn={}));var Cn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Cn||(e.ChatVariableLevel=Cn={}));class _n{constructor(G,ge,Oe){this.id=G,this.label=ge,this.values=Oe}}e.$sO=_n;var An;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(An||(e.InteractiveEditorResponseFeedbackKind=An={}));var Rn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Rn||(e.ChatResultFeedbackKind=Rn={}));class er{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new He(G):G}}e.$tO=er;class tr{constructor(G,ge){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new He(G):G,this.vulnerabilities=ge}}e.$uO=tr;class ir{constructor(G,ge){this.participant=G,this.command=ge}}e.$vO=ir;class nr{constructor(G,ge,Oe){this.title=G,this.message=ge,this.data=Oe}}e.$wO=nr;class rr{constructor(G,ge){this.value=G,this.baseUri=ge}}e.$xO=rr;class sr{constructor(G,ge){this.value=G,this.title=ge}}e.$yO=sr;class or{constructor(G){this.value=G}}e.$zO=or;class ar{constructor(G,ge){this.value=G,this.task=ge}}e.$AO=ar;class cr{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new He(G):G}}e.$BO=cr;class lr{constructor(G){this.value=G}}e.$CO=lr;class ur{constructor(G,ge){this.value=G,this.iconPath=ge}}e.$DO=ur;class hr{constructor(G,ge){this.uri=G,this.edits=Array.isArray(ge)?ge:[ge]}}e.$EO=hr;class dr{constructor(G,ge,Oe,Ye){this.prompt=G,this.command=ge,this.references=Oe,this.participant=Ye}}e.$FO=dr;class fr{constructor(G,ge,Oe,Ye){this.response=G,this.result=ge,this.participant=Oe,this.command=Ye}}e.$GO=fr;var Tn;(function(K){K[K.Panel=1]="Panel",K[K.Terminal=2]="Terminal",K[K.Notebook=3]="Notebook",K[K.Editor=4]="Editor"})(Tn||(e.ChatLocation=Tn={}));var dn;(function(K){K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.System=3]="System"})(dn||(e.LanguageModelChatMessageRole=dn={}));class fn{static User(G,ge){return new fn(dn.User,G,ge)}static Assistant(G,ge){return new fn(dn.Assistant,G,ge)}constructor(G,ge,Oe){this.role=G,this.content=ge,this.name=Oe}}e.$HO=fn;class mr{constructor(G){this.content=G}}e.$IO=mr;class gr{constructor(G,ge){this.content=G,this.name=ge}}e.$JO=gr;class $r{constructor(G,ge){this.content=G,this.name=ge}}e.$KO=$r;class Pi extends Error{static NotFound(G){return new Pi(G,Pi.NotFound.name)}static NoPermissions(G){return new Pi(G,Pi.NoPermissions.name)}static Blocked(G){return new Pi(G,Pi.Blocked.name)}constructor(G,ge,Oe){super(G,{cause:Oe}),this.name="LanguageModelError",this.code=ge??""}}e.$LO=Pi;var Ln;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Ln||(e.RelatedInformationType=Ln={}));var On;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped",K[K.Error=5]="Error"})(On||(e.SpeechToTextStatus=On={}));var Nn;(function(K){K[K.Started=1]="Started",K[K.Stopped=2]="Stopped",K[K.Error=3]="Error"})(Nn||(e.TextToSpeechStatus=Nn={}));var Mn;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(Mn||(e.KeywordRecognitionStatus=Mn={}));class pr{constructor(G,ge){this.text=G,this.range=ge}}e.$MO=pr;var Fn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Fn||(e.InlineEditTriggerKind=Fn={}))}),define(ye[340],Se([1,0,6,10]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;class A{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$uM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,T,p){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(L);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(T,p)??[]}getRelatedInformation(L,T,p){return this.c.$getAiRelatedInformation(T,p)}registerRelatedInformationProvider(L,T,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiRelatedInformationProvider(c,T),new m.$wM(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$Jmc=A}),define(ye[127],Se([1,0,4,6,10,24,154,5,20]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=e.$Umc=void 0,e.$Umc=(0,T.$Ai)("IExtHostAuthentication");let c=class{constructor(d){this.b=new Map,this.c=new r.$he,this.onDidChangeSessions=this.c.event,this.d=new C,this.f=new C,this.a=d.getProxy(m.$uM.MainThreadAuthentication)}async getSession(d,P,b,a={}){const u=R.$Wm.toKey(d.identifier),f=[...b].sort().join(" ");return await this.d.getOrCreate(`${u} ${P} ${f}`,async()=>{await this.a.$ensureProvider(P);const g=d.displayName||d.name;return this.a.$getSession(P,b,u,g,a)})}async getSessions(d,P,b){const a=R.$Wm.toKey(d.identifier),u=[...b].sort().join(" ");return await this.f.getOrCreate(`${a} ${u}`,async()=>{await this.a.$ensureProvider(P);const f=d.displayName||d.name;return this.a.$getSessions(P,b,a,f)})}async removeSession(d,P){const b=this.b.get(d);return b?b.provider.removeSession(P):this.a.$removeSession(d,P)}registerAuthenticationProvider(d,P,b,a){if(this.b.get(d))throw new Error(`An authentication provider with id '${d}' is already registered.`);this.b.set(d,{label:P,provider:b,options:a??{supportsMultipleAccounts:!1}});const u=b.onDidChangeSessions(f=>this.a.$sendDidChangeSessions(d,f));return this.a.$registerAuthenticationProvider(d,P,a?.supportsMultipleAccounts??!1),new A.$wM(()=>{u.dispose(),this.b.delete(d),this.a.$unregisterAuthenticationProvider(d)})}async $createSession(d,P,b){const a=this.b.get(d);if(a)return await a.provider.createSession(P,b);throw new Error(`Unable to find authentication provider with handle: ${d}`)}async $removeSession(d,P){const b=this.b.get(d);if(b)return await b.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${d}`)}async $getSessions(d,P){const b=this.b.get(d);if(b)return await b.provider.getSessions(P);throw new Error(`Unable to find authentication provider with handle: ${d}`)}$onDidChangeAuthenticationSessions(d,P){return d.startsWith(L.$wL)||this.c.fire({provider:{id:d,label:P}}),Promise.resolve()}};e.$Vmc=c,e.$Vmc=c=Je([Ge(0,p.$YO)],c);class C{constructor(){this.a=new Map}getOrCreate(d,P){const b=this.a.get(d);if(b)return b;const a=P().finally(()=>this.a.delete(d));return this.a.set(d,a),a}}}),define(ye[161],Se([1,0,2,6,10,5,20,12,19,13,16,26]),function(de,e,r,m,A,R,L,T,p,c,C,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=e.$Unc=void 0;let P=class{static{d=this}static{this.c=0}static{this.d=250}constructor(a,u){this.h=u,this.f=new Map,this.g=a.getProxy(m.$uM.MainThreadDecorations)}registerFileDecorationProvider(a,u){const f=d.c++;this.f.set(f,{provider:a,extensionDescription:u}),this.g.$registerDecorationProvider(f,u.identifier.value);const g=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(f,null);return}const s=(0,p.$2b)(n);if(s.length<=d.d){this.g.$onDidChange(f,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,s.length);const i=s.map(h=>({uri:h,rank:(0,c.$ef)(h.path,"/")})),t=(0,p.$zb)(i,(h,o)=>h.rank-o.rank||(0,c.$uf)(h.uri.path,o.uri.path)),l=[];e:for(const h of t){let o;for(const $ of h){const E=(0,C.$mc)($.uri.path);if(o!==E&&(o=E,l.push($.uri)>=d.d))break e}}this.g.$onDidChange(f,l)});return new A.$wM(()=>{g?.dispose(),this.g.$unregisterDecorationProvider(f),this.f.delete(f)})}async $provideDecorations(a,u,f){if(!this.f.has(a))return Object.create(null);const g=Object.create(null),{provider:n,extensionDescription:s}=this.f.get(a);return await Promise.all(u.map(async i=>{try{const{uri:t,id:l}=i,h=await Promise.resolve(n.provideFileDecoration(r.URI.revive(t),f));if(!h)return;try{A.$WN.validate(h),h.badge&&typeof h.badge!="string"&&(0,S.$UG)(s,"codiconDecoration"),g[l]=[h.propagate,h.tooltip,h.badge,h.color]}catch(o){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${o}`)}}catch(t){this.h.error(t)}})),g}};e.$Unc=P,e.$Unc=P=d=Je([Ge(0,L.$YO),Ge(1,T.$7j)],P),e.$Vnc=(0,R.$Ai)("IExtHostDecorations")}),define(ye[341],Se([1,0,14,2,10,6,15,21,13]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=void 0;class c{static{this.a=0}constructor(S,d,P){this.d=d,this.e=P,this.b=new Map,this.c=S.getProxy(R.$uM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,d){if(Object.keys(L.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const P=c.a++;this.b.set(P,d),this.c.$registerTextContentProvider(P,S);let b;if(typeof d.onDidChange=="function"){let a;b=d.onDidChange(async u=>{if(u.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(u))return;a&&await a;const f=this.$provideTextDocumentContent(P,u).then(async g=>{if(!g&&typeof g!="string")return;const n=this.d.getDocument(u);if(!n)return;const s=(0,p.$of)(g);if(!n.equalLines(s))return this.c.$onVirtualDocumentChange(u,g)}).catch(r.$1).finally(()=>{a===f&&(a=void 0)});a=f})}return new A.$wM(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(S,d){const P=this.b.get(S);return P?Promise.resolve(P.provideTextDocumentContent(m.URI.revive(d),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.$Xnc=c}),define(ye[162],Se([1,0,65,15,13,196,137,10,19]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=e.$2O=void 0,e.$1O=C;const c=new Map;function C(b,a){a?c.set(b,a):c.delete(b)}function S(b){return c.get(b)}class d extends R.$cw{constructor(a,u,f,g,n,s,i){super(u,f,g,n),this.c=a,this.m=s,this.q=i,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,p.$ub)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===m.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(u){return u?a.s(u):a.getText()},get eol(){return a.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(u){return a.t(u)},offsetAt(u){return a.u(u)},positionAt(u){return a.v(u)},validateRange(u){return a.w(u)},validatePosition(u){return a.x(u)},getWordRangeAtPosition(u,f){return a.y(u,f)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,r.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,r.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const u=this.w(a);if(u.isEmpty)return"";if(u.isSingleLine)return this.f[u.start.line].substring(u.start.character,u.end.character);const f=this.g,g=u.start.line,n=u.end.line,s=[];s.push(this.f[g].substring(u.start.character));for(let i=g+1;i<n;i++)s.push(this.f[i]);return s.push(this.f[n].substring(0,u.end.character)),s.join(f)}t(a){let u;if(a instanceof T.$xM?u=a.line:typeof a=="number"&&(u=a),typeof u!="number"||u<0||u>=this.f.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new P(u,this.f[u],u===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const u=this.j.getIndexOf(a),f=this.f[u.index].length;return new T.$xM(u.index,Math.min(u.remainder,f))}w(a){if(!(a instanceof T.$yM))throw new Error("Invalid argument");const u=this.x(a.start),f=this.x(a.end);return u===a.start&&f===a.end?a:new T.$yM(u.line,u.character,f.line,f.character)}x(a){if(!(a instanceof T.$xM))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:u,character:f}=a,g=!1;if(u<0)u=0,f=0,g=!0;else if(u>=this.f.length)u=this.f.length-1,f=this.f[u].length,g=!0;else{const n=this.f[u].length;f<0?(f=0,g=!0):f>n&&(f=n,g=!0)}return g?new T.$xM(u,f):a}y(a,u){const f=this.x(a);if(!u)u=S(this.m);else if((0,A.$nf)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const g=(0,L.$vt)(f.character+1,(0,L.$tt)(u),this.f[f.line],0);if(g)return new T.$yM(f.line,g.startColumn-1,f.line,g.endColumn-1)}}e.$2O=d;class P{constructor(a,u,f){this.a=a,this.b=u,this.c=f}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$yM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$yM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$3O=P}),define(ye[342],Se([1,0,6,10]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=void 0;class A{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$uM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,T,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(L);if(!c)throw new Error("Embedding vector provider not found");const C=await c.provideEmbeddingVector(T,p);if(!C)throw new Error("Embedding vector provider returned undefined");return C}registerEmbeddingVectorProvider(L,T,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiEmbeddingVectorProvider(T,c),new m.$wM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$1nc=A}),define(ye[75],Se([1,0,6,28,10,22,5,20,63,3,9,23,15]),function(de,e,r,m,A,R,L,T,p,c,C,S,d){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=e.$$mc=void 0;let b=P=class{constructor(u,f){this.b=new Map,this.c=new C.$Jh,this.a=u.getProxy(r.$uM.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(n){try{let s;const i=g.b.get(n.scheme);return i?(await g.a.$ensureActivation(n.scheme),s=await i.impl.stat(n)):s=await g.a.$stat(n),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===m.FilePermission.Readonly?1:void 0}}catch(s){P.e(s)}},async readDirectory(n){try{const s=g.b.get(n.scheme);return s?(await g.a.$ensureActivation(n.scheme),(await s.impl.readDirectory(n)).slice()):await g.a.$readdir(n)}catch(s){return P.e(s)}},async createDirectory(n){try{const s=g.b.get(n.scheme);return s&&!s.isReadonly?(await g.a.$ensureActivation(n.scheme),await g.d(s.impl,s.extUri,n)):await g.a.$mkdir(n)}catch(s){return P.e(s)}},async readFile(n){try{const s=g.b.get(n.scheme);return s?(await g.a.$ensureActivation(n.scheme),(await s.impl.readFile(n)).slice()):(await g.a.$readFile(n)).buffer}catch(s){return P.e(s)}},async writeFile(n,s){try{const i=g.b.get(n.scheme);return i&&!i.isReadonly?(await g.a.$ensureActivation(n.scheme),await g.d(i.impl,i.extUri,i.extUri.dirname(n)),await g.c.queueFor(n,()=>Promise.resolve(i.impl.writeFile(n,s,{create:!0,overwrite:!0})))):await g.a.$writeFile(n,R.$Je.wrap(s))}catch(i){return P.e(i)}},async delete(n,s){try{const i=g.b.get(n.scheme);return i&&!i.isReadonly&&!s?.useTrash?(await g.a.$ensureActivation(n.scheme),await i.impl.delete(n,{recursive:!1,...s})):await g.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(i){return P.e(i)}},async rename(n,s,i){try{return await g.a.$rename(n,s,{overwrite:!1,...i})}catch(t){return P.e(t)}},async copy(n,s,i){try{return await g.a.$copy(n,s,{overwrite:!1,...i})}catch(t){return P.e(t)}},isWritableFileSystem(n){const s=f.getCapabilities(n);if(typeof s=="number")return!(s&m.FileSystemProviderCapabilities.Readonly)}})}async d(u,f,g){const n=[];for(;!f.isEqual(g,f.dirname(g));)try{if(!((await u.stat(g)).type&m.FileType.Directory))throw A.$NN.FileExists(`Unable to create folder '${g.scheme===d.Schemas.file?g.fsPath:g.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(m.$kl(s)!==m.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(f.basename(g)),g=f.dirname(g)}for(let s=n.length-1;s>=0;s--){g=f.joinPath(g,n[s]);try{await u.createDirectory(g)}catch(i){if(m.$kl(i)!==m.FileSystemProviderErrorCode.FileExists)throw i}}}static e(u){if(u instanceof A.$NN)throw u;if(u instanceof m.$gl)switch(u.code){case m.FileSystemProviderErrorCode.FileExists:throw A.$NN.FileExists(u.message);case m.FileSystemProviderErrorCode.FileNotFound:throw A.$NN.FileNotFound(u.message);case m.FileSystemProviderErrorCode.FileNotADirectory:throw A.$NN.FileNotADirectory(u.message);case m.FileSystemProviderErrorCode.FileIsADirectory:throw A.$NN.FileIsADirectory(u.message);case m.FileSystemProviderErrorCode.NoPermissions:throw A.$NN.NoPermissions(u.message);case m.FileSystemProviderErrorCode.Unavailable:throw A.$NN.Unavailable(u.message);default:throw new A.$NN(u.message,u.name)}if(!(u instanceof Error))throw new A.$NN(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw A.$NN.Unavailable(u.message);switch(u.name){case m.FileSystemProviderErrorCode.FileExists:throw A.$NN.FileExists(u.message);case m.FileSystemProviderErrorCode.FileNotFound:throw A.$NN.FileNotFound(u.message);case m.FileSystemProviderErrorCode.FileNotADirectory:throw A.$NN.FileNotADirectory(u.message);case m.FileSystemProviderErrorCode.FileIsADirectory:throw A.$NN.FileIsADirectory(u.message);case m.FileSystemProviderErrorCode.NoPermissions:throw A.$NN.NoPermissions(u.message);case m.FileSystemProviderErrorCode.Unavailable:throw A.$NN.Unavailable(u.message);default:throw new A.$NN(u.message,u.name)}}addFileSystemProvider(u,f,g){return this.b.set(u,{impl:f,extUri:g?.isCaseSensitive?S.$4g:S.$6g,isReadonly:!!g?.isReadonly}),(0,c.$Sc)(()=>this.b.delete(u))}getFileSystemProviderExtUri(u){return this.b.get(u)?.extUri??S.$4g}};e.$$mc=b,e.$$mc=b=P=Je([Ge(0,T.$YO),Ge(1,p.$Omc)],b),e.$_mc=(0,L.$Ai)("IExtHostConsumerFileSystem")}),define(ye[98],Se([1,0,5,30,12,75,2]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=e.$anc=void 0,e.$anc=(0,r.$Ai)("IExtensionStoragePaths");let T=class{constructor(c,C,S){this.d=C,this.f=S,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(d=>this.c=d)}async g(c){return L.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,C=await this.g(c);try{return await this.f.value.stat(C),this.d.trace("[ExtHostStorage] storage dir already exists",C),C}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",C),await this.f.value.createDirectory(C),await this.f.value.writeFile(L.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),C}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(c){if(this.c)return L.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return L.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$bnc=T,e.$bnc=T=Je([Ge(0,m.$cP),Ge(1,A.$7j),Ge(2,R.$_mc)],T)}),define(ye[343],Se([1,0,10,20,4]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=void 0;let R=class{constructor(T){this.a=new r.$XN(r.ColorThemeKind.Dark),this.b=new A.$he}get activeColorTheme(){return this.a}$onColorThemeChange(T){let p;switch(T){case"light":p=r.ColorThemeKind.Light;break;case"hcDark":p=r.ColorThemeKind.HighContrast;break;case"hcLight":p=r.ColorThemeKind.HighContrastLight;break;default:p=r.ColorThemeKind.Dark}this.a=new r.$XN(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Ioc=R,e.$Ioc=R=Je([Ge(0,m.$YO)],R)}),define(ye[76],Se([1,0,21,4,3,242,5,12,93,6,30,20,10]),function(de,e,r,m,A,R,L,T,p,c,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oEb=e.$nEb=e.TunnelDtoConverter=void 0;class P extends p.$Bw{}var b;(function(u){function f(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:n.protocol}}u.fromApiTunnel=f;function g(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==p.TunnelPrivacyId.ConstantPrivate&&n.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}u.fromServiceTunnel=g})(b||(e.TunnelDtoConverter=b={})),e.$nEb=(0,L.$Ai)("IExtHostTunnelService");let a=class extends A.$Uc{constructor(f,g,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new m.$he,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=f.getProxy(c.$uM.MainThreadTunnelService)}async openTunnel(f,g){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${g.remoteAddress.host}:${g.remoteAddress.port}.`);const n=await this.a.$openTunnel(g,f.displayName);if(n){const s=new P(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(f,g){f.portRange===void 0&&f.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:f,provider:g}),this.a.$registerPortsAttributesProvider(f,n),new d.$wM(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(f,g,n,s,i){const t=[];for(const h of f){const o=this.r.get(h);if(!o)return[];t.push(...await Promise.all(g.map(async $=>{let E;try{E=await o.provider.providePortAttributes({port:$,pid:n,commandLine:s},i)}catch{E=await o.provider.providePortAttributes($,n,s,i)}return{providedAttributes:E,port:$}})))}const l=t.filter(h=>!!h.providedAttributes);return l.length>0?l.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(f){}registerTunnelProvider(f,g){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,i)=>await f.provideTunnel(s,i,r.CancellationToken.None)??void 0;const n=g.tunnelFeatures?{elevation:!!g.tunnelFeatures?.elevation,privacyOptions:g.tunnelFeatures?.privacyOptions,protocol:g.tunnelFeatures.protocol===void 0?!0:g.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,A.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(f,g){if(f){f.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this.f=f.showCandidatePort,this.a.$setCandidateFilter());const n=f.tunnelFactory??(g?this.w(g):void 0);if(n){this.b=n;let s=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const i=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(i)}}else this.b=void 0;return(0,A.$Sc)(()=>{this.b=void 0})}w(f){}async $closeTunnel(f,g){if(this.g.has(f.host)){const n=this.g.get(f.host);n.has(f.port)&&(g&&n.get(f.port).disposeListener.dispose(),await n.get(f.port).tunnel.dispose(),n.delete(f.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(f,g){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(f,g);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const s=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(f.remoteAddress.host)||this.g.set(f.remoteAddress.host,new Map);const i=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:s,disposeListener:i}),b.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(f){const g=await Promise.all(f.map(s=>this.f(s.host,s.port,s.detail??""))),n=f.filter((s,i)=>g[i]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(s=>s.port).join(", ")} to ${n.map(s=>s.port).join(", ")}`),n}};e.$oEb=a,e.$oEb=a=Je([Ge(0,S.$YO),Ge(1,C.$cP),Ge(2,T.$7j)],a)}),define(ye[17],Se([1,0,19,22,185,80,86,29,175,57,107,25,180,23,50,18,2,113,31,105,88,55,144,90,153,151,305,321,119,126,73,74,317,10]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i,t,l,h,o,$,E,k,D,v,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$VO=ne,e.$WO=re,e.$XO=ve;var N;(function(Re){function je(te){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:et,positionColumn:Ke}=te,dt=new y.$xM(Fe-1,Ve-1),It=new y.$xM(et-1,Ke-1);return new y.$zM(dt,It)}Re.to=je;function ke(te){const{anchor:Fe,active:Ve}=te;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Re.from=ke})(N||(e.Selection=N={}));var O;(function(Re){function je(te){if(!te)return;const{start:Fe,end:Ve}=te;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Re.from=je;function ke(te){if(!te)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:et,endColumn:Ke}=te;return new y.$yM(Fe-1,Ve-1,et-1,Ke-1)}Re.to=ke})(O||(e.Range=O={}));var U;(function(Re){function je(te){return{uri:te.uri,range:O.from(te.range)}}Re.from=je;function ke(te){return new y.$IM(u.URI.revive(te.uri),O.to(te.range))}Re.to=ke})(U||(e.Location=U={}));var j;(function(Re){function je(ke){switch(ke){case n.StandardTokenType.Comment:return y.StandardTokenType.Comment;case n.StandardTokenType.Other:return y.StandardTokenType.Other;case n.StandardTokenType.RegEx:return y.StandardTokenType.RegEx;case n.StandardTokenType.String:return y.StandardTokenType.String}}Re.to=je})(j||(e.TokenType=j={}));var z;(function(Re){function je(te){return new y.$xM(te.lineNumber-1,te.column-1)}Re.to=je;function ke(te){return{lineNumber:te.line+1,column:te.character+1}}Re.from=ke})(z||(e.Position=z={}));var M;(function(Re){function je(Fe,Ve,et){return(0,r.$Hb)((0,r.$2b)(Fe).map(Ke=>ke(Ke,Ve,et)))}Re.from=je;function ke(Fe,Ve,et){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:et?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:te(Fe.scheme,Ve),pattern:at.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:et?.isBuiltin}}function te(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(M||(e.DocumentSelector=M={}));var F;(function(Re){function je(te){switch(te){case y.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case y.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}Re.from=je;function ke(te){switch(te){case t.MarkerTag.Unnecessary:return y.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return y.DiagnosticTag.Deprecated;default:return}}Re.to=ke})(F||(e.DiagnosticTag=F={}));var J;(function(Re){function je(te){let Fe;return te.code&&((0,a.$ag)(te.code)||(0,a.$eg)(te.code)?Fe=String(te.code):Fe={value:String(te.code.value),target:te.code.target}),{...O.from(te.range),message:te.message,source:te.source,code:Fe,severity:V.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(ee.from),tags:Array.isArray(te.tags)?(0,r.$Hb)(te.tags.map(F.from)):void 0}}Re.from=je;function ke(te){const Fe=new y.$KM(O.to(te),te.message,V.to(te.severity));return Fe.source=te.source,Fe.code=(0,a.$ag)(te.code)?te.code:te.code?.value,Fe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(ee.to),Fe.tags=te.tags&&(0,r.$Hb)(te.tags.map(F.to)),Fe}Re.to=ke})(J||(e.Diagnostic=J={}));var ee;(function(Re){function je(te){return{...O.from(te.location.range),message:te.message,resource:te.location.uri}}Re.from=je;function ke(te){return new y.$JM(new y.$IM(te.resource,O.to(te)),te.message)}Re.to=ke})(ee||(e.DiagnosticRelatedInformation=ee={}));var V;(function(Re){function je(te){switch(te){case y.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case y.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case y.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case y.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Re.from=je;function ke(te){switch(te){case t.MarkerSeverity.Info:return y.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return y.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return y.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return y.DiagnosticSeverity.Hint;default:return y.DiagnosticSeverity.Error}}Re.to=ke})(V||(e.DiagnosticSeverity=V={}));var H;(function(Re){function je(te){return typeof te=="number"&&te>=y.ViewColumn.One?te-1:te===y.ViewColumn.Beside?w.$dE:w.$cE}Re.from=je;function ke(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=ke})(H||(e.ViewColumn=H={}));function _(Re){return typeof Re.range<"u"}function ne(Re){return Re.length===0?!0:!!_(Re[0])}var he;(function(Re){function je(Ke){return Ke.map(Re.from)}Re.fromMany=je;function ke(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function te(Ke){let dt;if(ke(Ke)){const{language:jt,value:Jt}=Ke;dt={value:"```"+jt+`
`+Jt+"\n```\n"}}else y.$YM.isMarkdownString(Ke)?dt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?dt={value:Ke}:dt={value:""};const It=Object.create(null);dt.uris=It;const xt=jt=>{try{let Jt=u.URI.parse(jt,!0);Jt=Jt.with({query:Fe(Jt.query,It)}),It[jt]=Jt}catch{}return""},ni=new p.marked.Renderer;return ni.link=xt,ni.image=jt=>typeof jt=="string"?xt(L.$6k(jt).href):"",(0,p.marked)(dt.value,{renderer:ni}),dt}Re.from=te;function Fe(Ke,dt){if(!Ke)return Ke;let It;try{It=(0,c.$9h)(Ke)}catch{}if(!It)return Ke;let xt=!1;return It=(0,S.$$n)(It,ni=>{if(u.URI.isUri(ni)){const jt=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[jt]=ni,xt=!0,jt}else return}),xt?JSON.stringify(It):Ke}function Ve(Ke){const dt=new y.$YM(Ke.value,Ke.supportThemeIcons);return dt.isTrusted=Ke.isTrusted,dt.supportHtml=Ke.supportHtml,dt.baseUri=Ke.baseUri?u.URI.from(Ke.baseUri):void 0,dt}Re.to=Ve;function et(Ke){if(Ke)return typeof Ke=="string"?Ke:Re.from(Ke)}Re.fromStrict=et})(he||(e.MarkdownString=he={}));function re(Re){return ne(Re)?Re.map(je=>({range:O.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?he.fromMany(je.hoverMessage):je.hoverMessage?he.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Re.map(je=>({range:O.from(je)}))}function ve(Re){return typeof Re>"u"?Re:typeof Re=="string"?u.URI.file(Re):Re}var pe;(function(Re){function je(ke){return typeof ke>"u"?ke:{contentText:ke.contentText,contentIconPath:ke.contentIconPath?ve(ke.contentIconPath):void 0,border:ke.border,borderColor:ke.borderColor,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,color:ke.color,backgroundColor:ke.backgroundColor,margin:ke.margin,width:ke.width,height:ke.height}}Re.from=je})(pe||(e.ThemableDecorationAttachmentRenderOptions=pe={}));var Q;(function(Re){function je(ke){return typeof ke>"u"?ke:{backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?ve(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?pe.from(ke.before):void 0,after:ke.after?pe.from(ke.after):void 0}}Re.from=je})(Q||(e.ThemableDecorationRenderOptions=Q={}));var B;(function(Re){function je(ke){if(typeof ke>"u")return ke;switch(ke){case y.DecorationRangeBehavior.OpenOpen:return i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case y.DecorationRangeBehavior.ClosedClosed:return i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case y.DecorationRangeBehavior.OpenClosed:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case y.DecorationRangeBehavior.ClosedOpen:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Re.from=je})(B||(e.DecorationRangeBehavior=B={}));var se;(function(Re){function je(ke){return{isWholeLine:ke.isWholeLine,rangeBehavior:ke.rangeBehavior?B.from(ke.rangeBehavior):void 0,overviewRulerLane:ke.overviewRulerLane,light:ke.light?Q.from(ke.light):void 0,dark:ke.dark?Q.from(ke.dark):void 0,backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?ve(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?pe.from(ke.before):void 0,after:ke.after?pe.from(ke.after):void 0}}Re.from=je})(se||(e.DecorationRenderOptions=se={}));var ae;(function(Re){function je(te){return{text:te.newText,eol:te.newEol&&le.from(te.newEol),range:O.from(te.range)}}Re.from=je;function ke(te){const Fe=new y.$DM(O.to(te.range),te.text);return Fe.newEol=typeof te.eol>"u"?void 0:le.to(te.eol),Fe}Re.to=ke})(ae||(e.TextEdit=ae={}));var ie;(function(Re){function je(te,Fe){const Ve={edits:[]};if(te instanceof y.$GM){const et=new T.$Bc;for(const Ke of te._allEntries())Ke._type===y.FileEditType.File&&u.URI.isUri(Ke.to)&&Ke.from===void 0&&et.add(Ke.to);for(const Ke of te._allEntries())if(Ke._type===y.FileEditType.File){let dt;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?dt={type:"base64",value:(0,m.$4e)(m.$Je.wrap(Ke.options.contents))}:dt={type:"dataTransferItem",id:Ke.options.contents._itemId}),Ve.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:dt},metadata:Ke.metadata})}else Ke._type===y.FileEditType.Text?Ve.edits.push({resource:Ke.uri,textEdit:ae.from(Ke.edit),versionId:et.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===y.FileEditType.Snippet?Ve.edits.push({resource:Ke.uri,textEdit:{range:O.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:et.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===y.FileEditType.Cell?Ve.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===y.FileEditType.CellReplace&&Ve.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:D.CellEditType.Replace,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Vt.from)}})}return Ve}Re.from=je;function ke(te){const Fe=new y.$GM,Ve=new T.$Ac;for(const et of te.edits)if(et.textEdit){const Ke=et,dt=u.URI.revive(Ke.resource),It=O.to(Ke.textEdit.range),xt=Ke.textEdit.text,ni=Ke.textEdit.insertAsSnippet;let jt;ni?jt=y.$FM.replace(It,new y.$HM(xt)):jt=y.$DM.replace(It,xt);const Jt=Ve.get(dt);Jt?Jt.push(jt):Ve.set(dt,[jt])}else Fe.renameFile(u.URI.revive(et.oldResource),u.URI.revive(et.newResource),et.options);for(const[et,Ke]of Ve)Fe.set(et,Ke);return Fe}Re.to=ke})(ie||(e.WorkspaceEdit=ie={}));var ce;(function(Re){const je=Object.create(null);je[y.SymbolKind.File]=s.SymbolKind.File,je[y.SymbolKind.Module]=s.SymbolKind.Module,je[y.SymbolKind.Namespace]=s.SymbolKind.Namespace,je[y.SymbolKind.Package]=s.SymbolKind.Package,je[y.SymbolKind.Class]=s.SymbolKind.Class,je[y.SymbolKind.Method]=s.SymbolKind.Method,je[y.SymbolKind.Property]=s.SymbolKind.Property,je[y.SymbolKind.Field]=s.SymbolKind.Field,je[y.SymbolKind.Constructor]=s.SymbolKind.Constructor,je[y.SymbolKind.Enum]=s.SymbolKind.Enum,je[y.SymbolKind.Interface]=s.SymbolKind.Interface,je[y.SymbolKind.Function]=s.SymbolKind.Function,je[y.SymbolKind.Variable]=s.SymbolKind.Variable,je[y.SymbolKind.Constant]=s.SymbolKind.Constant,je[y.SymbolKind.String]=s.SymbolKind.String,je[y.SymbolKind.Number]=s.SymbolKind.Number,je[y.SymbolKind.Boolean]=s.SymbolKind.Boolean,je[y.SymbolKind.Array]=s.SymbolKind.Array,je[y.SymbolKind.Object]=s.SymbolKind.Object,je[y.SymbolKind.Key]=s.SymbolKind.Key,je[y.SymbolKind.Null]=s.SymbolKind.Null,je[y.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,je[y.SymbolKind.Struct]=s.SymbolKind.Struct,je[y.SymbolKind.Event]=s.SymbolKind.Event,je[y.SymbolKind.Operator]=s.SymbolKind.Operator,je[y.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function ke(Fe){return typeof je[Fe]=="number"?je[Fe]:s.SymbolKind.Property}Re.from=ke;function te(Fe){for(const Ve in je)if(je[Ve]===Fe)return Number(Ve);return y.SymbolKind.Property}Re.to=te})(ce||(e.SymbolKind=ce={}));var ue;(function(Re){function je(te){switch(te){case y.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}Re.from=je;function ke(te){switch(te){case s.SymbolTag.Deprecated:return y.SymbolTag.Deprecated}}Re.to=ke})(ue||(e.SymbolTag=ue={}));var Z;(function(Re){function je(te){return{name:te.name,kind:ce.from(te.kind),tags:te.tags&&te.tags.map(ue.from),containerName:te.containerName,location:Be.from(te.location)}}Re.from=je;function ke(te){const Fe=new y.$PM(te.name,ce.to(te.kind),te.containerName,Be.to(te.location));return Fe.tags=te.tags&&te.tags.map(ue.to),Fe}Re.to=ke})(Z||(e.WorkspaceSymbol=Z={}));var oe;(function(Re){function je(te){const Fe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:O.from(te.range),selectionRange:O.from(te.selectionRange),kind:ce.from(te.kind),tags:te.tags?.map(ue.from)??[]};return te.children&&(Fe.children=te.children.map(je)),Fe}Re.from=je;function ke(te){const Fe=new y.$QM(te.name,te.detail,ce.to(te.kind),O.to(te.range),O.to(te.selectionRange));return(0,r.$Lb)(te.tags)&&(Fe.tags=te.tags.map(ue.to)),te.children&&(Fe.children=te.children.map(ke)),Fe}Re.to=ke})(oe||(e.DocumentSymbol=oe={}));var $e;(function(Re){function je(te){const Fe=new y.$UM(ce.to(te.kind),te.name,te.detail||"",u.URI.revive(te.uri),O.to(te.range),O.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Re.to=je;function ke(te,Fe,Ve){if(Fe=Fe??te._sessionId,Ve=Ve??te._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:te.name,detail:te.detail,kind:ce.from(te.kind),uri:te.uri,range:O.from(te.range),selectionRange:O.from(te.selectionRange),tags:te.tags?.map(ue.from)}}Re.from=ke})($e||(e.CallHierarchyItem=$e={}));var be;(function(Re){function je(ke){return new y.$VM($e.to(ke.from),ke.fromRanges.map(te=>O.to(te)))}Re.to=je})(be||(e.CallHierarchyIncomingCall=be={}));var Ne;(function(Re){function je(ke){return new y.$WM($e.to(ke.to),ke.fromRanges.map(te=>O.to(te)))}Re.to=je})(Ne||(e.CallHierarchyOutgoingCall=Ne={}));var Be;(function(Re){function je(te){return{range:te.range&&O.from(te.range),uri:te.uri}}Re.from=je;function ke(te){return new y.$IM(u.URI.revive(te.uri),O.to(te.range))}Re.to=ke})(Be||(e.location=Be={}));var De;(function(Re){function je(te){const Fe=te,Ve=te;return{originSelectionRange:Fe.originSelectionRange?O.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:O.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?O.from(Fe.targetSelectionRange):void 0}}Re.from=je;function ke(te){return{targetUri:u.URI.revive(te.uri),targetRange:O.to(te.range),targetSelectionRange:te.targetSelectionRange?O.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?O.to(te.originSelectionRange):void 0}}Re.to=ke})(De||(e.DefinitionLink=De={}));var Ie;(function(Re){function je(te){return{range:O.from(te.range),contents:he.fromMany(te.contents),canIncreaseVerbosity:te.canIncreaseVerbosity,canDecreaseVerbosity:te.canDecreaseVerbosity}}Re.from=je;function ke(te){const Fe=te.contents.map(he.to),Ve=O.to(te.range),et=te.canIncreaseVerbosity,Ke=te.canDecreaseVerbosity;return new y.$MM(Fe,Ve,et,Ke)}Re.to=ke})(Ie||(e.Hover=Ie={}));var Le;(function(Re){function je(te){return{range:O.from(te.range),expression:te.expression}}Re.from=je;function ke(te){return new y.$HN(O.to(te.range),te.expression)}Re.to=ke})(Le||(e.EvaluatableExpression=Le={}));var W;(function(Re){function je(te){if(te instanceof y.$IN)return{type:"text",range:O.from(te.range),text:te.text};if(te instanceof y.$JN)return{type:"variable",range:O.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof y.$KN)return{type:"expression",range:O.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=je;function ke(te){switch(te.type){case"text":return{range:O.to(te.range),text:te.text};case"variable":return{range:O.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:O.to(te.range),expression:te.expression}}}Re.to=ke})(W||(e.InlineValue=W={}));var q;(function(Re){function je(te){return{frameId:te.frameId,stoppedLocation:O.from(te.stoppedLocation)}}Re.from=je;function ke(te){return new y.$LN(te.frameId,O.to(te.stoppedLocation))}Re.to=ke})(q||(e.InlineValueContext=q={}));var Y;(function(Re){function je(te){return{range:O.from(te.range),kind:te.kind}}Re.from=je;function ke(te){return new y.$NM(O.to(te.range),te.kind)}Re.to=ke})(Y||(e.DocumentHighlight=Y={}));var x;(function(Re){function je(te){return{uri:te.uri,highlights:te.highlights.map(Y.from)}}Re.from=je;function ke(te){return new y.$OM(u.URI.revive(te.uri),te.highlights.map(Y.to))}Re.to=ke})(x||(e.MultiDocumentHighlight=x={}));var fe;(function(Re){function je(ke){switch(ke){case s.CompletionTriggerKind.TriggerCharacter:return y.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return y.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return y.CompletionTriggerKind.Invoke}}Re.to=je})(fe||(e.CompletionTriggerKind=fe={}));var we;(function(Re){function je(ke){return{triggerKind:fe.to(ke.triggerKind),triggerCharacter:ke.triggerCharacter}}Re.to=je})(we||(e.CompletionContext=we={}));var Me;(function(Re){function je(te){switch(te){case y.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}Re.from=je;function ke(te){switch(te){case s.CompletionItemTag.Deprecated:return y.CompletionItemTag.Deprecated}}Re.to=ke})(Me||(e.CompletionItemTag=Me={}));var qe;(function(Re){const je=new Map([[y.CompletionItemKind.Method,s.CompletionItemKind.Method],[y.CompletionItemKind.Function,s.CompletionItemKind.Function],[y.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[y.CompletionItemKind.Field,s.CompletionItemKind.Field],[y.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[y.CompletionItemKind.Class,s.CompletionItemKind.Class],[y.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[y.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[y.CompletionItemKind.Module,s.CompletionItemKind.Module],[y.CompletionItemKind.Property,s.CompletionItemKind.Property],[y.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[y.CompletionItemKind.Value,s.CompletionItemKind.Value],[y.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[y.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[y.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[y.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[y.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[y.CompletionItemKind.Text,s.CompletionItemKind.Text],[y.CompletionItemKind.Color,s.CompletionItemKind.Color],[y.CompletionItemKind.File,s.CompletionItemKind.File],[y.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[y.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[y.CompletionItemKind.Event,s.CompletionItemKind.Event],[y.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[y.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[y.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[y.CompletionItemKind.User,s.CompletionItemKind.User]]);function ke(Ve){return je.get(Ve)??s.CompletionItemKind.Property}Re.from=ke;const te=new Map([[s.CompletionItemKind.Method,y.CompletionItemKind.Method],[s.CompletionItemKind.Function,y.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,y.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,y.CompletionItemKind.Field],[s.CompletionItemKind.Variable,y.CompletionItemKind.Variable],[s.CompletionItemKind.Class,y.CompletionItemKind.Class],[s.CompletionItemKind.Interface,y.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,y.CompletionItemKind.Struct],[s.CompletionItemKind.Module,y.CompletionItemKind.Module],[s.CompletionItemKind.Property,y.CompletionItemKind.Property],[s.CompletionItemKind.Unit,y.CompletionItemKind.Unit],[s.CompletionItemKind.Value,y.CompletionItemKind.Value],[s.CompletionItemKind.Constant,y.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,y.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,y.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,y.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,y.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,y.CompletionItemKind.Text],[s.CompletionItemKind.Color,y.CompletionItemKind.Color],[s.CompletionItemKind.File,y.CompletionItemKind.File],[s.CompletionItemKind.Reference,y.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,y.CompletionItemKind.Folder],[s.CompletionItemKind.Event,y.CompletionItemKind.Event],[s.CompletionItemKind.Operator,y.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,y.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,y.CompletionItemKind.User],[s.CompletionItemKind.Issue,y.CompletionItemKind.Issue]]);function Fe(Ve){return te.get(Ve)??y.CompletionItemKind.Property}Re.to=Fe})(qe||(e.CompletionItemKind=qe={}));var He;(function(Re){function je(ke,te){const Fe=new y.$5M(ke.label);return Fe.insertText=ke.insertText,Fe.kind=qe.to(ke.kind),Fe.tags=ke.tags?.map(Me.to),Fe.detail=ke.detail,Fe.documentation=L.$Zk(ke.documentation)?he.to(ke.documentation):ke.documentation,Fe.sortText=ke.sortText,Fe.filterText=ke.filterText,Fe.preselect=ke.preselect,Fe.commitCharacters=ke.commitCharacters,g.$ct.isIRange(ke.range)?Fe.range=O.to(ke.range):typeof ke.range=="object"&&(Fe.range={inserting:O.to(ke.range.insert),replacing:O.to(ke.range.replace)}),Fe.keepWhitespace=typeof ke.insertTextRules>"u"?!1:!!(ke.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof ke.insertTextRules<"u"&&ke.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Fe.insertText=new y.$HM(ke.insertText):(Fe.insertText=ke.insertText,Fe.textEdit=Fe.range instanceof y.$yM?new y.$DM(Fe.range,Fe.insertText):void 0),ke.additionalTextEdits&&ke.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ke.additionalTextEdits.map(Ve=>ae.to(Ve))),Fe.command=te&&ke.command?te.fromInternal(ke.command):void 0,Fe}Re.to=je})(He||(e.CompletionItem=He={}));var Ze;(function(Re){function je(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:he.fromStrict(te.documentation)}}Re.from=je;function ke(te){return{label:te.label,documentation:L.$Zk(te.documentation)?he.to(te.documentation):te.documentation}}Re.to=ke})(Ze||(e.ParameterInformation=Ze={}));var it;(function(Re){function je(te){return{label:te.label,documentation:he.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(Ze.from):[],activeParameter:te.activeParameter}}Re.from=je;function ke(te){return{label:te.label,documentation:L.$Zk(te.documentation)?he.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(Ze.to):[],activeParameter:te.activeParameter}}Re.to=ke})(it||(e.SignatureInformation=it={}));var tt;(function(Re){function je(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(it.from):[]}}Re.from=je;function ke(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(it.to):[]}}Re.to=ke})(tt||(e.SignatureHelp=tt={}));var rt;(function(Re){function je(ke,te){const Fe=new y.$4M(z.to(te.position),typeof te.label=="string"?te.label:te.label.map(ot.to.bind(void 0,ke)),te.kind&&ft.to(te.kind));return Fe.textEdits=te.textEdits&&te.textEdits.map(ae.to),Fe.tooltip=L.$Zk(te.tooltip)?he.to(te.tooltip):te.tooltip,Fe.paddingLeft=te.paddingLeft,Fe.paddingRight=te.paddingRight,Fe}Re.to=je})(rt||(e.InlayHint=rt={}));var ot;(function(Re){function je(ke,te){const Fe=new y.$3M(te.label);return Fe.tooltip=L.$Zk(te.tooltip)?he.to(te.tooltip):te.tooltip,s.Command.is(te.command)&&(Fe.command=ke.fromInternal(te.command)),te.location&&(Fe.location=Be.to(te.location)),Fe}Re.to=je})(ot||(e.InlayHintLabelPart=ot={}));var ft;(function(Re){function je(te){return te}Re.from=je;function ke(te){return te}Re.to=ke})(ft||(e.InlayHintKind=ft={}));var ut;(function(Re){function je(te){return{range:O.from(te.range),url:te.target,tooltip:te.tooltip}}Re.from=je;function ke(te){let Fe;if(te.url)try{Fe=typeof te.url=="string"?u.URI.parse(te.url,!0):u.URI.revive(te.url)}catch{}return new y.$0M(O.to(te.range),Fe)}Re.to=ke})(ut||(e.DocumentLink=ut={}));var st;(function(Re){function je(te){const Fe=new y.$aN(te.label);return te.textEdit&&(Fe.textEdit=ae.to(te.textEdit)),te.additionalTextEdits&&(Fe.additionalTextEdits=te.additionalTextEdits.map(Ve=>ae.to(Ve))),Fe}Re.to=je;function ke(te){return{label:te.label,textEdit:te.textEdit?ae.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Fe=>ae.from(Fe)):void 0}}Re.from=ke})(st||(e.ColorPresentation=st={}));var Pe;(function(Re){function je(te){return new y.$$M(te[0],te[1],te[2],te[3])}Re.to=je;function ke(te){return[te.red,te.green,te.blue,te.alpha]}Re.from=ke})(Pe||(e.Color=Pe={}));var Ue;(function(Re){function je(te){return{range:O.from(te.range)}}Re.from=je;function ke(te){return new y.$TM(O.to(te.range))}Re.to=ke})(Ue||(e.SelectionRange=Ue={}));var Ae;(function(Re){function je(ke){switch(ke){case o.SaveReason.AUTO:return y.TextDocumentSaveReason.AfterDelay;case o.SaveReason.EXPLICIT:return y.TextDocumentSaveReason.Manual;case o.SaveReason.FOCUS_CHANGE:case o.SaveReason.WINDOW_CHANGE:return y.TextDocumentSaveReason.FocusOut}}Re.to=je})(Ae||(e.TextDocumentSaveReason=Ae={}));var Te;(function(Re){function je(te){switch(te){case y.TextEditorLineNumbersStyle.Off:return f.RenderLineNumbersType.Off;case y.TextEditorLineNumbersStyle.Relative:return f.RenderLineNumbersType.Relative;case y.TextEditorLineNumbersStyle.Interval:return f.RenderLineNumbersType.Interval;case y.TextEditorLineNumbersStyle.On:default:return f.RenderLineNumbersType.On}}Re.from=je;function ke(te){switch(te){case f.RenderLineNumbersType.Off:return y.TextEditorLineNumbersStyle.Off;case f.RenderLineNumbersType.Relative:return y.TextEditorLineNumbersStyle.Relative;case f.RenderLineNumbersType.Interval:return y.TextEditorLineNumbersStyle.Interval;case f.RenderLineNumbersType.On:default:return y.TextEditorLineNumbersStyle.On}}Re.to=ke})(Te||(e.TextEditorLineNumbersStyle=Te={}));var le;(function(Re){function je(te){if(te===y.EndOfLine.CRLF)return i.EndOfLineSequence.CRLF;if(te===y.EndOfLine.LF)return i.EndOfLineSequence.LF}Re.from=je;function ke(te){if(te===i.EndOfLineSequence.CRLF)return y.EndOfLine.CRLF;if(te===i.EndOfLineSequence.LF)return y.EndOfLine.LF}Re.to=ke})(le||(e.EndOfLine=le={}));var X;(function(Re){function je(ke){if(typeof ke=="object")return ke.viewId;switch(ke){case y.ProgressLocation.SourceControl:return l.ProgressLocation.Scm;case y.ProgressLocation.Window:return l.ProgressLocation.Window;case y.ProgressLocation.Notification:return l.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Re.from=je})(X||(e.ProgressLocation=X={}));var Ce;(function(Re){function je(te){const Fe={start:te.start+1,end:te.end+1};return te.kind&&(Fe.kind=Qe.from(te.kind)),Fe}Re.from=je;function ke(te){const Fe={start:te.start-1,end:te.end-1};return te.kind&&(Fe.kind=Qe.to(te.kind)),Fe}Re.to=ke})(Ce||(e.FoldingRange=Ce={}));var Qe;(function(Re){function je(te){if(te)switch(te){case y.FoldingRangeKind.Comment:return s.$Pv.Comment;case y.FoldingRangeKind.Imports:return s.$Pv.Imports;case y.FoldingRangeKind.Region:return s.$Pv.Region}}Re.from=je;function ke(te){if(te)switch(te.value){case s.$Pv.Comment.value:return y.FoldingRangeKind.Comment;case s.$Pv.Imports.value:return y.FoldingRangeKind.Imports;case s.$Pv.Region.value:return y.FoldingRangeKind.Region}}Re.to=ke})(Qe||(e.FoldingRangeKind=Qe={}));var _e;(function(Re){function je(ke){if(ke)return{pinned:typeof ke.preview=="boolean"?!ke.preview:void 0,inactive:ke.background,preserveFocus:ke.preserveFocus,selection:typeof ke.selection=="object"?O.from(ke.selection):void 0,override:typeof ke.override=="boolean"?o.$FF.id:void 0}}Re.from=je})(_e||(e.TextEditorOpenOptions=_e={}));var at;(function(Re){function je(Ve){return Ve instanceof y.$vN?Ve.toJSON():typeof Ve=="string"?Ve:ke(Ve)||te(Ve)?new y.$vN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Re.from=je;function ke(Ve){const et=Ve;return et?u.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function te(Ve){const et=Ve;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new y.$vN(u.URI.revive(Ve.baseUri),Ve.pattern)}Re.to=Fe})(at||(e.GlobPattern=at={}));var lt;(function(Re){function je(ke){if(ke){if(Array.isArray(ke))return ke.map(je);if(typeof ke=="string")return ke;{const te=ke;return{language:te.language,scheme:te.scheme,pattern:at.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Re.from=je})(lt||(e.LanguageSelector=lt={}));var Dt;(function(Re){function je(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&u.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(et=>et instanceof y.$yM)))}Re.is=je;function ke(te){return{documents:te.documents.map(Fe=>Fe.map(Ve=>({uri:u.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(et=>O.from(et))})))}}Re.from=ke})(Dt||(e.MappedEditsContext=Dt={}));var Ct;(function(Re){function je(te){return{start:te.start,end:te.end}}Re.from=je;function ke(te){return new y.$YN(te.start,te.end)}Re.to=ke})(Ct||(e.NotebookRange=Ct={}));var Ot;(function(Re){function je(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Re.to=je;function ke(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Re.from=ke})(Ot||(e.NotebookCellExecutionSummary=Ot={}));var Yt;(function(Re){function je(ke){if(ke===D.NotebookCellExecutionState.Unconfirmed)return y.NotebookCellExecutionState.Pending;if(ke===D.NotebookCellExecutionState.Pending)return;if(ke===D.NotebookCellExecutionState.Executing)return y.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ke}`)}Re.to=je})(Yt||(e.NotebookCellExecutionState=Yt={}));var _t;(function(Re){function je(te){switch(te){case y.NotebookCellKind.Markup:return D.CellKind.Markup;case y.NotebookCellKind.Code:default:return D.CellKind.Code}}Re.from=je;function ke(te){switch(te){case D.CellKind.Markup:return y.NotebookCellKind.Markup;case D.CellKind.Code:default:return y.NotebookCellKind.Code}}Re.to=ke})(_t||(e.NotebookCellKind=_t={}));var xe;(function(Re){function je(te){const Fe={metadata:te.metadata??Object.create(null),cells:[]};for(const Ve of te.cells)y.$ZN.validate(Ve),Fe.cells.push(Vt.from(Ve));return Fe}Re.from=je;function ke(te){const Fe=new y.$1N(te.cells.map(Vt.to));return(0,a.$ng)(te.metadata)||(Fe.metadata=te.metadata),Fe}Re.to=ke})(xe||(e.NotebookData=xe={}));var Vt;(function(Re){function je(te){return{cellKind:_t.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Ot.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(gt.from):[]}}Re.from=je;function ke(te){return new y.$ZN(_t.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(gt.to):void 0,te.metadata,te.internalMetadata?Ot.to(te.internalMetadata):void 0)}Re.to=ke})(Vt||(e.NotebookCellData=Vt={}));var zt;(function(Re){function je(te){return{mime:te.mime,valueBytes:m.$Je.wrap(te.data)}}Re.from=je;function ke(te){return new y.$2N(te.valueBytes.buffer,te.mime)}Re.to=ke})(zt||(e.NotebookCellOutputItem=zt={}));var gt;(function(Re){function je(te){return{outputId:te.id,items:te.items.map(zt.from),metadata:te.metadata}}Re.from=je;function ke(te){const Fe=te.items.map(zt.to);return new y.$3N(Fe,te.outputId,te.metadata)}Re.to=ke})(gt||(e.NotebookCellOutput=gt={}));var $t;(function(Re){function je(Fe){return te(Fe)?{include:at.from(Fe.include)??void 0,exclude:at.from(Fe.exclude)??void 0}:at.from(Fe)??void 0}Re.from=je;function ke(Fe){return te(Fe)?{include:at.to(Fe.include),exclude:at.to(Fe.exclude)}:at.to(Fe)}Re.to=ke;function te(Fe){const Ve=Fe;return Ve?!(0,a.$jg)(Ve.include)&&!(0,a.$jg)(Ve.exclude):!1}})($t||(e.NotebookExclusiveDocumentPattern=$t={}));var ei;(function(Re){function je(ke,te,Fe){const Ve=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{alignment:ke.alignment===y.NotebookCellStatusBarAlignment.Left?D.CellStatusbarAlignment.Left:D.CellStatusbarAlignment.Right,command:te.toInternal(Ve,Fe),text:ke.text,tooltip:ke.tooltip,accessibilityInformation:ke.accessibilityInformation,priority:ke.priority}}Re.from=je})(ei||(e.NotebookStatusBarItem=ei={}));var Xt;(function(Re){function je(ke,te,Fe){const Ve=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{command:te.toInternal(Ve,Fe),label:ke.label,description:ke.description,detail:ke.detail,documentation:ke.documentation}}Re.from=je})(Xt||(e.NotebookKernelSourceAction=Xt={}));var Bt;(function(Re){function je(ke){return{transientOutputs:ke?.transientOutputs??!1,transientCellMetadata:ke?.transientCellMetadata??{},transientDocumentMetadata:ke?.transientDocumentMetadata??{},cellContentMetadata:ke?.cellContentMetadata??{}}}Re.from=je})(Bt||(e.NotebookDocumentContentOptions=Bt={}));var bt;(function(Re){function je(te){return{uri:te.uri,provides:te.provides}}Re.from=je;function ke(te){return new y.$5N(u.URI.revive(te.uri),te.provides)}Re.to=ke})(bt||(e.NotebookRendererScript=bt={}));var Mt;(function(Re){function je(te){return{message:he.fromStrict(te.message)||"",type:I.TestMessageType.Error,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:O.from(te.location.range),uri:te.location.uri}}}Re.from=je;function ke(te){const Fe=new y.$$N(typeof te.message=="string"?te.message:he.to(te.message));return Fe.actualOutput=te.actual,Fe.expectedOutput=te.expected,Fe.contextValue=te.contextValue,Fe.location=te.location?Be.to(te.location):void 0,Fe}Re.to=ke})(Mt||(e.TestMessage=Mt={}));var Ht;(function(Re){Re.namespace=I.$lL,Re.denamespace=I.$mL})(Ht||(e.TestTag=Ht={}));var Wt;(function(Re){function je(te){const Fe=(0,h.$UO)(te).controllerId;return{extId:v.$gL.fromExtHostTestItem(te,Fe).toString(),label:te.label,uri:u.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(Ve=>Ht.namespace(Fe,Ve.id)),range:g.$ct.lift(O.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&he.fromStrict(te.error)||null}}Re.from=je;function ke(te){return{parent:void 0,error:void 0,id:v.$gL.fromString(te.extId).localId,label:te.label,uri:u.URI.revive(te.uri),tags:(te.tags||[]).map(Fe=>{const{tagId:Ve}=Ht.denamespace(Fe);return new y.$_N(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:O.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Re.toPlain=ke})(Wt||(e.TestItem=Wt={})),function(Re){function je(te){return{id:te.id}}Re.from=je;function ke(te){return new y.$_N(te.id)}Re.to=ke}(Ht||(e.TestTag=Ht={}));var Xe;(function(Re){const je=(te,Fe)=>{const Ve=te.value;if(!Ve)return;const et={...Wt.toPlain(Ve.item),parent:Fe,taskStates:Ve.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(dt=>dt.type===I.TestMessageType.Error).map(Mt.to)})),children:[]};if(te.children)for(const Ke of te.children.values()){const dt=je(Ke,et);dt&&et.children.push(dt)}return et};function ke(te){const Fe=new d.$NO;for(const Ke of te.items)Fe.insert(v.$gL.fromString(Ke.item.extId).path,Ke);const Ve=[Fe.nodes],et=[];for(;Ve.length;)for(const Ke of Ve.pop())Ke.value?et.push(Ke):Ke.children&&Ve.push(Ke.children.values());return{completedAt:te.completedAt,results:et.map(Ke=>je(Ke)).filter(a.$ig)}}Re.to=ke})(Xe||(e.TestResults=Xe={}));var ti;(function(Re){function je(Ve){return{covered:Ve.covered,total:Ve.total}}function ke(Ve){return"line"in Ve?z.from(Ve):O.from(Ve)}function te(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:ke(Ve.location),type:I.DetailType.Statement,branches:Ve.branches.length?Ve.branches.map(et=>({count:et.executed,location:et.location&&ke(et.location),label:et.label})):void 0}:{type:I.DetailType.Declaration,name:Ve.name,count:Ve.executed,location:ke(Ve.location)}}Re.fromDetails=te;function Fe(Ve,et,Ke){return y.$bO(Ke.statementCoverage),y.$bO(Ke.branchCoverage),y.$bO(Ke.declarationCoverage),{id:et,uri:Ke.uri,statement:je(Ke.statementCoverage),branch:Ke.branchCoverage&&je(Ke.branchCoverage),declaration:Ke.declarationCoverage&&je(Ke.declarationCoverage),testId:Ke instanceof y.$cO&&Ke.testItem?v.$gL.fromExtHostTestItem(Ke.testItem,Ve).toString():void 0}}Re.fromFile=Fe})(ti||(e.TestCoverage=ti={}));var ii;(function(Re){function je(ke){switch(ke){case s.CodeActionTriggerType.Invoke:return y.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return y.CodeActionTriggerKind.Automatic}}Re.to=je})(ii||(e.CodeActionTriggerKind=ii={}));var li;(function(Re){function je(te){const Fe=new y.$gO(ce.to(te.kind),te.name,te.detail||"",u.URI.revive(te.uri),O.to(te.range),O.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Re.to=je;function ke(te,Fe,Ve){if(Fe=Fe??te._sessionId,Ve=Ve??te._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:ce.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:O.from(te.range),selectionRange:O.from(te.selectionRange),tags:te.tags?.map(ue.from)}}Re.from=ke})(li||(e.TypeHierarchyItem=li={}));var kt;(function(Re){function je(ke){if(ke)return{value:ke.value,tooltip:ke.tooltip}}Re.from=je})(kt||(e.ViewBadge=kt={}));var Nt;(function(Re){function je(Ve,et,Ke){const dt=et.fileData;return dt?new y.$nN(new y.$oN(dt.name,u.URI.revive(dt.uri),dt.id,(0,R.$db)(()=>Ke(dt.id)))):Ve===C.$Ys.uriList&&et.uriListData?new y.$mN(Fe(et.uriListData)):new y.$mN(et.asString)}Re.to=je;async function ke(Ve,et){const Ke=await et.asString();if(Ve===C.$Ys.uriList)return{asString:Ke,fileData:void 0,uriListData:te(Ke)};const dt=et.asFile();return{asString:Ke,fileData:dt?{name:dt.name,uri:dt.uri,id:dt._itemId??dt.id}:void 0}}Re.from=ke;function te(Ve){return A.$_s.split(Ve).map(et=>{if(et.startsWith("#"))return et;try{return u.URI.parse(et)}catch{}return et})}function Fe(Ve){return A.$_s.create(Ve.map(et=>typeof et=="string"?et:u.URI.revive(et)))}})(Nt||(e.DataTransferItem=Nt={}));var Rt;(function(Re){function je(te,Fe){const Ve=te.items.map(([et,Ke])=>[et,Nt.to(et,Ke,Fe)]);return new y.$pN(Ve)}Re.toDataTransfer=je;async function ke(te){const Fe={items:[]},Ve=[];for(const[et,Ke]of te)Ve.push((async()=>{Fe.items.push([et,await Nt.from(et,Ke)])})());return await Promise.all(Ve),Fe}Re.from=ke})(Rt||(e.DataTransfer=Rt={}));var Ft;(function(Re){function je(te,Fe){return{kind:"reply",agentId:te.participant??Fe?.agentId??"",subCommand:te.command??Fe?.command,message:te.prompt,title:te.label}}Re.from=je;function ke(te){return{prompt:te.message,label:te.title,participant:te.agentId,command:te.subCommand}}Re.to=ke})(Ft||(e.ChatFollowup=Ft={}));var ui;(function(Re){function je(te){switch(te.role){case E.ChatMessageRole.System:return new y.$HO(y.LanguageModelChatMessageRole.System,te.content);case E.ChatMessageRole.User:return new y.$HO(y.LanguageModelChatMessageRole.User,te.content);case E.ChatMessageRole.Assistant:return new y.$HO(y.LanguageModelChatMessageRole.Assistant,te.content)}}Re.to=je;function ke(te){switch(te.role){case y.LanguageModelChatMessageRole.System:return{role:E.ChatMessageRole.System,content:te.content};case y.LanguageModelChatMessageRole.User:return{role:E.ChatMessageRole.User,content:te.content};case y.LanguageModelChatMessageRole.Assistant:return{role:E.ChatMessageRole.Assistant,content:te.content}}}Re.from=ke})(ui||(e.LanguageModelChatMessage=ui={}));var qt;(function(Re){function je(te){return{kind:"markdownContent",content:he.from(te.value)}}Re.from=je;function ke(te){return new y.$tO(he.to(te.content))}Re.to=ke})(qt||(e.ChatResponseMarkdownPart=qt={}));var si;(function(Re){function je(te){return{kind:"markdownVuln",content:he.from(te.value),vulnerabilities:te.vulnerabilities}}Re.from=je;function ke(te){return new y.$uO(he.to(te.content),te.vulnerabilities)}Re.to=ke})(si||(e.ChatResponseMarkdownWithVulnerabilitiesPart=si={}));var Ut;(function(Re){function je(te){return{kind:"agentDetection",agentId:te.participant,command:te.command}}Re.from=je;function ke(te){return new y.$vO(te.agentId,te.command)}Re.to=ke})(Ut||(e.ChatResponseDetectedParticipantPart=Ut={}));var Zt;(function(Re){function je(ke){return{kind:"confirmation",title:ke.title,message:ke.message,data:ke.data}}Re.from=je})(Zt||(e.ChatResponseConfirmationPart=Zt={}));var oi;(function(Re){function je(te){const{value:Fe,baseUri:Ve}=te;function et(Ke,dt){return Ke.map(It=>{const xt=u.URI.joinPath(dt,It.name);return{label:It.name,uri:xt,children:It.children&&et(It.children,xt)}})}return{kind:"treeData",treeData:{label:(0,P.$$g)(Ve),uri:Ve,children:et(Fe,Ve)}}}Re.from=je;function ke(te){const Fe=(0,c.$0h)(te.treeData);function Ve(dt){return dt.map(It=>({name:It.label,children:It.children&&Ve(It.children)}))}const et=Fe.uri,Ke=Fe.children?Ve(Fe.children):[];return new y.$xO(Ke,et)}Re.to=ke})(oi||(e.ChatResponseFilesPart=oi={}));var At;(function(Re){function je(te){const Fe=Ve=>u.URI.isUri(Ve);return{kind:"inlineReference",name:te.title,inlineReference:Fe(te.value)?te.value:U.from(te.value)}}Re.from=je;function ke(te){const Fe=(0,c.$0h)(te);return new y.$yO(u.URI.isUri(Fe.inlineReference)?Fe.inlineReference:U.to(Fe.inlineReference),te.name)}Re.to=ke})(At||(e.ChatResponseAnchorPart=At={}));var vt;(function(Re){function je(te){return{kind:"progressMessage",content:he.from(te.value)}}Re.from=je;function ke(te){return new y.$zO(te.content.value)}Re.to=ke})(vt||(e.ChatResponseProgressPart=vt={}));var pt;(function(Re){function je(te){return{kind:"warning",content:he.from(te.value)}}Re.from=je;function ke(te){return new y.$BO(te.content.value)}Re.to=ke})(pt||(e.ChatResponseWarningPart=pt={}));var Gt;(function(Re){function je(ke){return{kind:"progressTask",content:he.from(ke.value)}}Re.from=je})(Gt||(e.ChatTask=Gt={}));var St;(function(Re){function je(ke){return{kind:"progressTaskResult",content:typeof ke=="string"?he.from(ke):void 0}}Re.from=je})(St||(e.ChatTaskResult=St={}));var ai;(function(Re){function je(te,Fe,Ve){return{kind:"command",command:Fe.toInternal(te.value,Ve)??{command:te.value.command,title:te.value.title}}}Re.from=je;function ke(te,Fe){return new y.$CO(Fe.fromInternal(te.command)??{command:te.command.id,title:te.command.title})}Re.to=ke})(ai||(e.ChatResponseCommandButtonPart=ai={}));var Kt;(function(Re){function je(te){return{kind:"textEdit",uri:te.uri,edits:te.edits.map(Fe=>ae.from(Fe))}}Re.from=je;function ke(te){return new y.$EO(u.URI.revive(te.uri),te.edits.map(Fe=>ae.to(Fe)))}Re.to=ke})(Kt||(e.ChatResponseTextEditPart=Kt={}));var $i;(function(Re){function je(te){const Fe=b.ThemeIcon.isThemeIcon(te.iconPath)?te.iconPath:u.URI.isUri(te.iconPath)?{light:u.URI.revive(te.iconPath)}:te.iconPath&&"light"in te.iconPath&&"dark"in te.iconPath&&u.URI.isUri(te.iconPath.light)&&u.URI.isUri(te.iconPath.dark)?{light:u.URI.revive(te.iconPath.light),dark:u.URI.revive(te.iconPath.dark)}:void 0;return"variableName"in te.value?{kind:"reference",reference:{variableName:te.value.variableName,value:u.URI.isUri(te.value.value)||!te.value.value?te.value.value:U.from(te.value.value)},iconPath:Fe}:{kind:"reference",reference:u.URI.isUri(te.value)?te.value:U.from(te.value),iconPath:Fe}}Re.from=je;function ke(te){const Fe=(0,c.$0h)(te),Ve=et=>u.URI.isUri(et)?et:U.to(et);return new y.$DO("variableName"in Fe.reference?{variableName:Fe.reference.variableName,value:Fe.reference.value&&Ve(Fe.reference.value)}:Ve(Fe.reference))}Re.to=ke})($i||(e.ChatResponseReferencePart=$i={}));var di;(function(Re){function je(Fe,Ve,et){return Fe instanceof y.$tO?qt.from(Fe):Fe instanceof y.$yO?At.from(Fe):Fe instanceof y.$DO?$i.from(Fe):Fe instanceof y.$zO?vt.from(Fe):Fe instanceof y.$xO?oi.from(Fe):Fe instanceof y.$CO?ai.from(Fe,Ve,et):Fe instanceof y.$EO?Kt.from(Fe):Fe instanceof y.$uO?si.from(Fe):Fe instanceof y.$vO?Ut.from(Fe):Fe instanceof y.$BO?pt.from(Fe):{kind:"markdownContent",content:he.from("")}}Re.from=je;function ke(Fe,Ve){switch(Fe.kind){case"reference":return $i.to(Fe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return te(Fe,Ve)}}Re.to=ke;function te(Fe,Ve){switch(Fe.kind){case"markdownContent":return qt.to(Fe);case"inlineReference":return At.to(Fe);case"progressMessage":return;case"treeData":return oi.to(Fe);case"command":return ai.to(Fe,Ve)}}Re.toContent=te})(di||(e.ChatResponsePart=di={}));var Di;(function(Re){function je(ke){return{prompt:ke.message,command:ke.command,attempt:ke.attempt??0,enableCommandDetection:ke.enableCommandDetection??!0,references:ke.variables.variables.map(Ci.to),location:Tt.to(ke.location),acceptedConfirmationData:ke.acceptedConfirmationData,rejectedConfirmationData:ke.rejectedConfirmationData}}Re.to=je})(Di||(e.ChatAgentRequest=Di={}));var Tt;(function(Re){function je(te){switch(te){case $.ChatAgentLocation.Notebook:return y.ChatLocation.Notebook;case $.ChatAgentLocation.Terminal:return y.ChatLocation.Terminal;case $.ChatAgentLocation.Panel:return y.ChatLocation.Panel;case $.ChatAgentLocation.Editor:return y.ChatLocation.Editor}}Re.to=je;function ke(te){switch(te){case y.ChatLocation.Notebook:return $.ChatAgentLocation.Notebook;case y.ChatLocation.Terminal:return $.ChatAgentLocation.Terminal;case y.ChatLocation.Panel:return $.ChatAgentLocation.Panel;case y.ChatLocation.Editor:return $.ChatAgentLocation.Editor}}Re.from=ke})(Tt||(e.ChatLocation=Tt={}));var Ci;(function(Re){function je(ke){const te=ke.value;if(!te)throw new Error("Invalid value reference");return{id:ke.id,name:ke.name,range:ke.range&&[ke.range.start,ke.range.endExclusive],value:(0,u.$vc)(te)?u.URI.revive(te):te&&typeof te=="object"&&"uri"in te&&"range"in te&&(0,u.$vc)(te.uri)?U.to((0,c.$0h)(te)):te,modelDescription:ke.modelDescription}}Re.to=je})(Ci||(e.ChatAgentValueReference=Ci={}));var ci;(function(Re){function je(ke,te,Fe){return{id:ke.id,label:ke.label,fullName:ke.fullName,icon:ke.icon?.id,value:ke.values[0].value,insertText:ke.insertText,detail:ke.detail,documentation:ke.documentation,command:te.toInternal(ke.command,Fe)}}Re.from=je})(ci||(e.ChatAgentCompletionItem=ci={}));var Pt;(function(Re){function je(ke){return{errorDetails:ke.errorDetails,metadata:ke.metadata}}Re.to=je})(Pt||(e.ChatAgentResult=Pt={}));var Ii;(function(Re){function je(ke,te,Fe){if(te.action.kind==="vote")return;const Ve=Pt.to(ke);if(te.action.kind==="command"){const et=te.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Fe.fromInternal(et)??{command:et.id,title:et.title}}},result:Ve}}else return te.action.kind==="followUp"?{action:{kind:"followUp",followup:Ft.to(te.action.followup)},result:Ve}:te.action.kind==="inlineChat"?{action:{kind:"editor",accepted:te.action.action==="accepted"},result:Ve}:{action:te.action,result:Ve}}Re.to=je})(Ii||(e.ChatAgentUserActionEvent=Ii={}));var vi;(function(Re){function je(ke,te,Fe){return"terminalCommand"in ke?{terminalCommand:ke.terminalCommand,shouldExecute:ke.shouldExecute}:"uri"in ke?{uri:ke.uri}:te.toInternal(ke,Fe)}Re.from=je})(vi||(e.TerminalQuickFix=vi={}));var pi;(function(Re){function je(ke){return{kind:Ai.to(ke.kind)}}Re.to=je})(pi||(e.PartialAcceptInfo=pi={}));var Ai;(function(Re){function je(ke){switch(ke){case s.PartialAcceptTriggerKind.Word:return y.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return y.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return y.PartialAcceptTriggerKind.Suggest;default:return y.PartialAcceptTriggerKind.Unknown}}Re.to=je})(Ai||(e.PartialAcceptTriggerKind=Ai={}));var fi;(function(Re){function je(ke,te){return{id:te,label:ke.label,description:ke.description,canEdit:ke.canEdit,collapsibleState:ke.collapsibleState||k.DebugTreeItemCollapsibleState.None,contextValue:ke.contextValue}}Re.from=je})(fi||(e.DebugTreeItem=fi={}))}),define(ye[344],Se([1,0,6,20,17,52]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=void 0;let L=class{constructor(p,c){this.a=p.getProxy(r.$uM.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>c.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,c,C){const S=new R.$Kw(A.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,C?.isRefactoring??!1)}};e.$Wmc=L,e.$Wmc=L=Je([Ge(0,m.$YO)],L)}),define(ye[345],Se([1,0,19,9,51,4,40,3,42,18,2,24,6,17,10,306,26]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=void 0;class f{constructor(i,t,l,h,o){this.j=i,this.k=t,this.l=l,this.m=h,this.n=o,this.b=p.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(h){if(i.c){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,h),o}};const i=this;this.b.reset();const l=(h,o)=>{if(typeof this.d>"u"&&"content"in h&&(this.d=this.b.elapsed()),o){const $=this.l.$handleProgressChunk(this.k.requestId,h),E={report:k=>{$?.then(D=>{D&&(b.$YM.isMarkdownString(k.value)?this.l.$handleProgressChunk(this.k.requestId,P.ChatResponseWarningPart.from(k),D):this.l.$handleProgressChunk(this.k.requestId,P.ChatResponseReferencePart.from(k),D))})}};Promise.all([$,o?.(E)]).then(([k,D])=>{k!==void 0&&D!==void 0&&this.l.$handleProgressChunk(this.k.requestId,P.ChatTaskResult.from(D),k)})}else this.l.$handleProgressChunk(this.k.requestId,h)};this.g={markdown(h){t(this.markdown);const o=new b.$tO(h),$=P.ChatResponseMarkdownPart.from(o);return l($),this},markdownWithVulnerabilities(h,o){t(this.markdown),o&&(0,u.$UG)(i.j,"chatParticipantAdditions");const $=new b.$uO(h,o),E=P.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return l(E),this},filetree(h,o){t(this.filetree);const $=new b.$xO(h,o),E=P.ChatResponseFilesPart.from($);return l(E),this},anchor(h,o){t(this.anchor);const $=new b.$yO(h,o),E=P.ChatResponseAnchorPart.from($);return l(E),this},button(h){t(this.anchor);const o=new b.$CO(h),$=P.ChatResponseCommandButtonPart.from(o,i.m,i.n);return l($),this},progress(h,o){t(this.progress);const $=new b.$AO(h,o),E=o?P.ChatTask.from($):P.ChatResponseProgressPart.from($);return l(E,o),this},warning(h){t(this.progress),(0,u.$UG)(i.j,"chatParticipantAdditions");const o=new b.$BO(h),$=P.ChatResponseWarningPart.from(o);return l($),this},reference(h,o){if(t(this.reference),"variableName"in h&&(0,u.$UG)(i.j,"chatParticipantAdditions"),"variableName"in h&&!h.value){const $=i.k.variables.variables.find(E=>E.name===h.variableName);if($){let E;if($.references?.length)E=$.references.map(k=>({kind:"reference",reference:{variableName:h.variableName,value:k.reference}}));else{const k=new b.$DO(h,o);E=[P.ChatResponseReferencePart.from(k)]}return E.forEach(k=>l(k)),this}}else{const $=new b.$DO(h,o),E=P.ChatResponseReferencePart.from($);l(E)}return this},textEdit(h,o){t(this.textEdit),(0,u.$UG)(i.j,"chatParticipantAdditions");const $=new b.$EO(h,o),E=P.ChatResponseTextEditPart.from($);return l(E),this},detectedParticipant(h,o){t(this.detectedParticipant),(0,u.$UG)(i.j,"chatParticipantAdditions");const $=new b.$vO(h,o),E=P.ChatResponseDetectedParticipantPart.from($);return l(E),this},confirmation(h,o,$){t(this.confirmation),(0,u.$UG)(i.j,"chatParticipantAdditions");const E=new b.$wO(h,o,$),k=P.ChatResponseConfirmationPart.from(E);return l(k),this},push(h){if(t(this.push),(h instanceof b.$EO||h instanceof b.$uO||h instanceof b.$vO||h instanceof b.$BO||h instanceof b.$wO)&&(0,u.$UG)(i.j,"chatParticipantAdditions"),h instanceof b.$DO)this.reference(h.value,h.iconPath);else{const o=P.ChatResponsePart.from(h,i.m,i.n);l(o)}return this}}}return this.g}}class g extends T.$Uc{static{this.b=0}constructor(i,t,l,h){super(),this.n=t,this.s=l,this.t=h,this.c=new Map,this.j=this.B(new T.$4c),this.m=this.B(new T.$4c),this.g=i.getProxy(d.$uM.MainThreadChatAgents2)}transferActiveChat(i){this.g.$transferActiveChatSession(i)}createChatAgent(i,t,l){const h=g.b++,o=new n(i,this.t,t,this.g,h,l);return this.c.set(h,o),o.isAgentEnabled()&&this.g.$registerAgent(h,i.identifier,t,{},void 0),o.apiAgent}createDynamicChatAgent(i,t,l,h){const o=g.b++,$=new n(i,this.t,t,this.g,o,h);return this.c.set(o,$),this.g.$registerAgent(o,i.identifier,t,{isSticky:!0},l),$.apiAgent}async $invokeAgent(i,t,l,h){const o=this.c.get(i);if(!o)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(t.sessionId);$||($=new T.$Tc,this.j.set(t.sessionId,$));const E=new f(o.extension,t,this.g,this.s.converter,$);try{const k=await this.u(t.agentId,l),D=o.invoke(P.ChatAgentRequest.to(t),{history:k},E.apiObject,h);return await(0,m.$oh)(Promise.resolve(D).then(v=>{if(v?.metadata)try{JSON.stringify(v.metadata)}catch(w){const y=`result.metadata MUST be JSON.stringify-able. Got error: ${w.message}`;return this.n.error(`[${o.extension.identifier.value}] [@${o.id}] ${y}`,o.extension),{errorDetails:{message:y},timings:E.timings}}let I;return v?.errorDetails&&(I={...v.errorDetails,responseIsIncomplete:!0}),I?.responseIsRedacted&&(0,u.$UG)(o.extension,"chatParticipantPrivate"),{errorDetails:I,timings:E.timings,metadata:v?.metadata}}),h)}catch(k){return this.n.error(k,o.extension),k instanceof b.$LO&&k.cause&&(k=k.cause),{errorDetails:{message:(0,A.$lj)(k),responseIsIncomplete:!0}}}finally{E.close()}}async u(i,t){const l=[];for(const h of t.history){const o=P.ChatAgentResult.to(h.result),$=i===h.request.agentId?o:{...o,metadata:void 0};l.push(new b.$FO(h.request.message,h.request.command,h.request.variables.variables.map(P.ChatAgentValueReference.to),h.request.agentId));const E=(0,r.$Hb)(h.response.map(k=>P.ChatResponsePart.toContent(k,this.s.converter)));l.push(new b.$GO(E,$,h.request.agentId,h.request.command))}return l}$releaseSession(i){this.j.deleteAndDispose(i)}async $provideFollowups(i,t,l,h,o){const $=this.c.get(t);if(!$)return Promise.resolve([]);const E=await this.u($.id,h),k=P.ChatAgentResult.to(l);return(await $.provideFollowups(k,{history:E},o)).filter(D=>{const v=!D.participant||L.Iterable.some(this.c.values(),I=>I.id===D.participant&&S.$Wm.equals(I.extension.identifier,$.extension.identifier));return v||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${D.participant}`),v}).map(D=>P.ChatFollowup.from(D,i))}$acceptFeedback(i,t,l,h){const o=this.c.get(i);if(!o)return;const $=P.ChatAgentResult.to(t);let E;switch(l){case a.ChatAgentVoteDirection.Down:E=b.ChatResultFeedbackKind.Unhelpful;break;case a.ChatAgentVoteDirection.Up:E=b.ChatResultFeedbackKind.Helpful;break}o.acceptFeedback(Object.freeze(h?{result:$,kind:E,reportIssue:h}:{result:$,kind:E}))}$acceptAction(i,t,l){const h=this.c.get(i);if(!h||l.action.kind==="vote")return;const o=P.ChatAgentUserActionEvent.to(t,l,this.s.converter);o&&h.acceptAction(Object.freeze(o))}async $invokeCompletionProvider(i,t,l){const h=this.c.get(i);if(!h)return[];let o=this.m.get(i);return o?o.clear():(o=new T.$Tc,this.m.set(i,o)),(await h.invokeCompletionProvider(t,l)).map(E=>P.ChatAgentCompletionItem.from(E,this.s.converter,o))}async $provideWelcomeMessage(i,t,l){const h=this.c.get(i);if(h)return await h.provideWelcomeMessage(P.ChatLocation.to(t),l)}async $provideSampleQuestions(i,t,l){const h=this.c.get(i);if(h)return(await h.provideSampleQuestions(P.ChatLocation.to(t),l)).map(o=>P.ChatFollowup.from(o,void 0))}}e.$Xmc=g;class n{constructor(i,t,l,h,o,$){this.extension=i,this.w=t,this.id=l,this.x=h,this.y=o,this.z=$,this.m=new R.$he,this.n=new R.$he}acceptFeedback(i){this.m.fire(i)}acceptAction(i){this.n.fire(i)}async invokeCompletionProvider(i,t){return this.q?await this.q.provider.provideCompletionItems(i,t)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,u.$TG)(this.extension,"chatParticipantPrivate"))}async provideFollowups(i,t,l){if(!this.b)return[];const h=await this.b.provideFollowups(i,t,l);return h?h.filter(o=>!(o&&"commandId"in o)).filter(o=>!(o&&"message"in o)):[]}async provideWelcomeMessage(i,t){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(i,t);return l?l.map(h=>typeof h=="string"?h:P.MarkdownString.from(h)):[]}async provideSampleQuestions(i,t){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(i,t);return l||[]}get apiAgent(){let i=!1,t=!1;const l=()=>{i||t||(t=!0,queueMicrotask(()=>{h.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof C.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof b.$tN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:P.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:P.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:P.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),t=!1)}))},h=this;return{get id(){return h.id},get iconPath(){return h.c},set iconPath(o){h.c=o,l()},get requestHandler(){return h.z},set requestHandler(o){(0,c.$kg)(typeof o=="function","Invalid request handler"),h.z=o},get followupProvider(){return h.b},set followupProvider(o){h.b=o,l()},get isDefault(){return(0,u.$UG)(h.extension,"defaultChatParticipant"),h.d},set isDefault(o){(0,u.$UG)(h.extension,"defaultChatParticipant"),h.d=o,l()},get helpTextPrefix(){return(0,u.$UG)(h.extension,"defaultChatParticipant"),h.g},set helpTextPrefix(o){(0,u.$UG)(h.extension,"defaultChatParticipant"),h.g=o,l()},get helpTextVariablesPrefix(){return(0,u.$UG)(h.extension,"defaultChatParticipant"),h.j},set helpTextVariablesPrefix(o){(0,u.$UG)(h.extension,"defaultChatParticipant"),h.j=o,l()},get helpTextPostfix(){return(0,u.$UG)(h.extension,"defaultChatParticipant"),h.k},set helpTextPostfix(o){(0,u.$UG)(h.extension,"defaultChatParticipant"),h.k=o,l()},get isSecondary(){return(0,u.$UG)(h.extension,"defaultChatParticipant"),h.l},set isSecondary(o){(0,u.$UG)(h.extension,"defaultChatParticipant"),h.l=o,l()},get supportIssueReporting(){return(0,u.$UG)(h.extension,"chatParticipantPrivate"),h.o},set supportIssueReporting(o){(0,u.$UG)(h.extension,"chatParticipantPrivate"),h.o=o,l()},get onDidReceiveFeedback(){return h.m.event},set participantVariableProvider(o){if((0,u.$UG)(h.extension,"chatParticipantAdditions"),h.q=o,o){if(!o.triggerCharacters.length)throw new Error("triggerCharacters are required");h.x.$registerAgentCompletionsProvider(h.y,h.id,o.triggerCharacters)}else h.x.$unregisterAgentCompletionsProvider(h.y,h.id)},get participantVariableProvider(){return(0,u.$UG)(h.extension,"chatParticipantAdditions"),h.q},set welcomeMessageProvider(o){(0,u.$UG)(h.extension,"defaultChatParticipant"),h.s=o,l()},get welcomeMessageProvider(){return(0,u.$UG)(h.extension,"defaultChatParticipant"),h.s},onDidPerformAction:(0,u.$TG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(o){h.t=o,l()},get requester(){return h.t},set supportsSlowReferences(o){(0,u.$UG)(h.extension,"chatParticipantPrivate"),h.u=o,l()},get supportsSlowReferences(){return(0,u.$UG)(h.extension,"chatParticipantPrivate"),h.u},dispose(){i=!0,h.b=void 0,h.m.dispose(),h.x.$unregisterAgent(h.y)}}}invoke(i,t,l,h){return this.z(i,t,l,h)}}}),define(ye[346],Se([1,0,14,3,50,6,17,10,26]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=void 0;class c{static{this.a=0}constructor(d){this.b=new Map,this.c=d.getProxy(R.$uM.MainThreadChatVariables)}async $resolveVariable(d,P,b,a){const u=this.b.get(d);if(u)try{if(u.resolver.resolve2){(0,p.$UG)(u.extension,"chatParticipantAdditions");const f=new C(P,this.c),g=await u.resolver.resolve2(u.data.name,{prompt:b},f.apiObject,a);if(g&&g[0])return g[0].value}else{const f=await u.resolver.resolve(u.data.name,{prompt:b},a);if(f&&f[0])return f[0].value}}catch(f){(0,r.$2)(f)}}registerVariableResolver(d,P,b,a,u,f,g,n,s){const i=c.a++,t=s?A.ThemeIcon.fromId(s):void 0;return this.b.set(i,{extension:d,data:{id:P,name:b,description:a,modelDescription:u,icon:t},resolver:g}),this.c.$registerVariable(i,{id:P,name:b,description:a,modelDescription:u,isSlow:f,fullName:n,icon:t}),(0,m.$Sc)(()=>{this.b.delete(i),this.c.$unregisterVariable(i)})}attachContext(d,P,b){this.c.$attachContext(d,T.$IM.isLocation(P)?L.Location.from(P):P,L.ChatLocation.from(b))}}e.$Ymc=c;class C{constructor(d,P){this.c=d,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(a){if(d.a){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,a),u}};const d=this,b=a=>{this.d.$handleProgressChunk(this.c,a)};this.b={progress(a){P(this.progress);const u=new T.$zO(a),f=L.ChatResponseProgressPart.from(u);return b(f),this},reference(a){P(this.reference);const u=new T.$DO(a),f=L.ChatResponseReferencePart.from(u);return b(f),this},push(a){return P(this.push),a instanceof T.$DO?b(L.ChatResponseReferencePart.from(a)):a instanceof T.$zO&&b(L.ChatResponseProgressPart.from(a)),this}}}return this.b}}}),define(ye[347],Se([1,0,9,60,4,3,41,2,88,24,17,10,6,26]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=b;function b(a,u,f){const g=a.getProxy(d.$uM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$Ym,u.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===L.MarshalledId.CommentController){const v=this.b.get(D.handle);return v?v.value:D}else if(D&&D.$mid===L.MarshalledId.CommentThread){const v=D,I=this.b.get(v.commentControlHandle);if(!I)return v;const w=I.getCommentThread(v.commentThreadHandle);return w?w.value:v}else if(D&&(D.$mid===L.MarshalledId.CommentThreadReply||D.$mid===L.MarshalledId.CommentThreadInstance)){const v=this.b.get(D.thread.commentControlHandle);if(!v)return D;const I=v.getCommentThread(D.thread.commentThreadHandle);return I?D.$mid===L.MarshalledId.CommentThreadInstance?I.value:{thread:I.value,text:D.text}:D}else if(D&&D.$mid===L.MarshalledId.CommentNode){const v=this.b.get(D.thread.commentControlHandle);if(!v)return D;const I=v.getCommentThread(D.thread.commentThreadHandle);if(!I)return D;const w=D.commentUniqueId,y=I.getCommentByUniqueId(w);return y||D}else if(D&&D.$mid===L.MarshalledId.CommentThreadNode){const v=this.b.get(D.thread.commentControlHandle);if(!v)return D;const I=v.getCommentThread(D.thread.commentThreadHandle);if(!I)return D;const w=D.text,y=D.commentUniqueId,N=I.getCommentByUniqueId(y);return N?(typeof N.body=="string"?N.body=w:N.body=new S.$YM(w),N):D}return D}})}createCommentController(D,v,I){const w=n.a++,y=new i(D,w,v,I);this.b.set(y.handle,y);const N=this.c.get(D.identifier)||[];return N.push(y),this.c.set(D.identifier,N),y.value}async $createCommentThreadTemplate(D,v,I,w){const y=this.b.get(D);y&&y.$createCommentThreadTemplate(v,I,w)}async $setActiveComment(D,v){const I=this.b.get(D);I&&I.$setActiveComment(v??void 0)}async $updateCommentThreadTemplate(D,v,I){const w=this.b.get(D);w&&w.$updateCommentThreadTemplate(v,I)}$deleteCommentThread(D,v){this.b.get(D)?.$deleteCommentThread(v)}async $provideCommentingRanges(D,v,I){const w=this.b.get(D);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const y=await f.ensureDocumentData(T.URI.revive(v));return(0,r.$sh)(async()=>{const N=await w.commentingRangeProvider.provideCommentingRanges(y.document,I);let O;return Array.isArray(N)?O={ranges:N,fileComments:!1}:N?O={ranges:N.ranges||[],fileComments:N.fileComments||!1}:O=N??void 0,O}).then(N=>{let O;return N&&(O={ranges:N.ranges.map(U=>C.Range.from(U)),fileComments:N.fileComments}),O})}$toggleReaction(D,v,I,w,y){const N=this.b.get(D);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,r.$sh)(()=>{const O=N.getCommentThread(v);if(O){const U=O.getCommentByUniqueId(w.uniqueIdInThread);if(N!==void 0&&U&&N.reactionHandler)return N.reactionHandler(U,h(y))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(D){this.n=D}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(D){(D===void 0!=(this.p===void 0)||!D||!this.p||!D.isEqual(this.p))&&(this.p=D,this.b.range=D,this.c.fire())}get range(){return this.p}set canReply(D){this.d!==D&&(this.d=D,this.b.canReply=D,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(D){this.e=D,this.b.label=D,this.c.fire()}get contextValue(){return this.f}set contextValue(D){this.f=D,this.b.contextValue=D,this.c.fire()}get comments(){return this.q}set comments(D){this.q=D,this.b.comments=D,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(D){this.g=D,this.b.collapsibleState=D,this.c.fire()}get state(){return this.h}set state(D){this.h=D,typeof D=="object"?((0,P.$UG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=D.resolved,this.b.applicability=D.applicability):this.b.state=D,this.c.fire()}get isDisposed(){return this.j}constructor(D,v,I,w,y,N,O,U,j){this.m=v,this.n=I,this.o=w,this.p=y,this.q=N,this.extensionDescription=O,this.r=U,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$he,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${D}.${this.handle}`),g.$createCommentThread(v,this.handle,this.n,this.o,C.Range.from(this.p),O.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this.i.push({dispose:()=>{g.$deleteCommentThread(v,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(M){z.range=M},get comments(){return z.comments},set comments(M){z.comments=M},get collapsibleState(){return z.collapsibleState},set collapsibleState(M){z.collapsibleState=M},get canReply(){return z.canReply},set canReply(M){z.canReply=M},get contextValue(){return z.contextValue},set contextValue(M){z.contextValue=M},get label(){return z.label},set label(M){z.label=M},get state(){return z.state},set state(M){z.state=M},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const D=I=>Object.prototype.hasOwnProperty.call(this.b,I),v={};D("range")&&(v.range=C.Range.from(this.p)),D("label")&&(v.label=this.label),D("contextValue")&&(v.contextValue=this.contextValue??null),D("comments")&&(v.comments=this.q.map(I=>t(this,I,this.k,this.extensionDescription))),D("collapsibleState")&&(v.collapseState=o(this.g)),D("canReply")&&(v.canReply=this.canReply),D("state")&&(v.state=$(this.h)),D("applicability")&&(v.applicability=E(this.h)),D("isTemplate")&&(v.isTemplate=this.r),this.b={},g.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(D){for(const v of this.k){const I=v[0],w=v[1];if(D===w)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(D=>D.dispose())}}Je([(0,m.$6h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class i{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(D){this.b=D,D?.resourceHints&&(0,P.$UG)(this.h,"commentingRangeHint"),g.$updateCommentingRanges(this.handle,D?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(D){this.c=D,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!D})}get options(){return this.d}set options(D){this.d=D,g.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$UG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$UG)(this.h,"activeComment"),this.f}constructor(D,v,I,w){this.h=D,this.i=v,this.j=I,this.k=w,this.a=new Map,g.$registerCommentController(this.handle,I,w,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(N){y.options=N},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(N){y.commentingRangeProvider=N},get reactionHandler(){return y.reactionHandler},set reactionHandler(N){y.reactionHandler=N},get activeCommentThread(){return y.activeCommentThread},createCommentThread(N,O,U){return y.createCommentThread(N,O,U).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}createCommentThread(D,v,I){v===void 0&&(0,P.$UG)(this.h,"fileComments");const w=new s(this.id,this.handle,void 0,D,v,I,this.h,!1);return this.a.set(w.handle,w),w}$setActiveComment(D){if(!D){this.e=void 0,this.f=void 0;return}const v=this.a.get(D.commentThreadHandle);v&&(this.e=D.uniqueIdInThread?v.getCommentByUniqueId(D.uniqueIdInThread):void 0,this.f=v)}$createCommentThreadTemplate(D,v,I){const w=new s(this.id,this.handle,void 0,T.URI.revive(D),C.Range.to(v),[],this.h,!0,I);return w.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(D,v){const I=this.a.get(D);I&&(I.range=C.Range.to(v))}$deleteCommentThread(D){this.a.get(D)?.dispose(),this.a.delete(D)}getCommentThread(D){return this.a.get(D)}dispose(){this.a.forEach(D=>{D.dispose()}),this.g.forEach(D=>D.dispose())}}function t(k,D,v,I){let w=v.get(D);return w||(w=++k.commentHandle,v.set(D,w)),D.state!==void 0&&(0,P.$UG)(I,"commentsDraftState"),D.reactions?.some(y=>y.reactors!==void 0)&&(0,P.$UG)(I,"commentReactor"),{mode:D.mode,contextValue:D.contextValue,uniqueIdInThread:w,body:typeof D.body=="string"?D.body:C.MarkdownString.from(D.body),userName:D.author.name,userIconPath:D.author.iconPath,label:D.label,commentReactions:D.reactions?D.reactions.map(y=>l(y)):void 0,state:D.state,timestamp:D.timestamp?.toJSON()}}function l(k){return{label:k.label,iconPath:k.iconPath?C.$XO(k.iconPath):void 0,count:k.count,hasReacted:k.authorHasReacted,reactors:k.reactors&&k.reactors.length>0&&typeof k.reactors[0]!="string"?k.reactors.map(D=>D.name):k.reactors}}function h(k){return{label:k.label||"",count:k.count||0,iconPath:k.iconPath?T.URI.revive(k.iconPath):"",authorHasReacted:k.hasReacted||!1,reactors:k.reactors?.map(D=>({name:D}))}}function o(k){if(k!==void 0)switch(k){case S.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case S.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function $(k){let D;if(typeof k=="object"?D=k.resolved:D=k,D!==void 0)switch(D){case S.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case S.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function E(k){let D;if(typeof k=="object"&&(D=k.applicability),D!==void 0)switch(D){case S.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case S.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(ye[348],Se([1,0,21,61,3,15,23,2,17,97,118,6,10]),function(de,e,r,m,A,R,L,T,p,c,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;class P{constructor(l,h){this.document=l,this.b=h,this.a=1,this.c=new C.$Imc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,h){await this.f(l).undo(),h||this.disposeBackup()}async redo(l,h){await this.f(l).redo(),h||this.disposeBackup()}disposeEdits(l){for(const h of l)this.c.delete(h)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=i(this.document.uri)+this.a++;return(0,L.$bh)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const h=this.c.get(l,0);if(!h)throw new Error("No edit found");return h}}class b{constructor(){this.a=new Map}get(l,h){return this.a.get(this.b(l,h))}add(l,h,o){const $=this.b(l,h.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${l} resource:${h.uri}`);const E=new P(h,o);return this.a.set($,E),E}delete(l,h){const o=this.b(l,h.uri);this.a.delete(o)}b(l,h){return`${l}@@@${h}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class u{constructor(){this.a=new Map}addTextProvider(l,h,o){return this.b(l,{type:a.Text,extension:h,provider:o})}addCustomProvider(l,h,o){return this.b(l,{type:a.Custom,extension:h,provider:o})}get(l){return this.a.get(l)}b(l,h){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,h),new d.$wM(()=>this.a.delete(l))}}class f{constructor(l,h,o,$,E){this.d=h,this.f=o,this.g=$,this.h=E,this.b=new u,this.c=new b,this.a=l.getProxy(S.$uM.MainThreadCustomEditors)}registerCustomEditorProvider(l,h,o,$){const E=new A.$Tc;return n(o)?(E.add(this.b.addTextProvider(h,l,o)),this.a.$registerTextEditorProvider((0,c.$fnc)(l),h,$.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,c.$dnc)(l))):(E.add(this.b.addCustomProvider(h,l,o)),g(o)&&E.add(o.onDidChangeCustomDocument(k=>{const D=this.i(h,k.document.uri);if(s(k)){const v=D.addEdit(k);this.a.$onDidEdit(k.document.uri,h,v,k.label)}else this.a.$onContentChange(k.document.uri,h)})),this.a.$registerCustomEditorProvider((0,c.$fnc)(l),h,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,c.$dnc)(l))),d.$wM.from(E,new d.$wM(()=>{this.a.$unregisterEditorProvider(h)}))}async $createCustomDocument(l,h,o,$,E){const k=this.b.get(h);if(!k)throw new Error(`No provider found for '${h}'`);if(k.type!==a.Custom)throw new Error(`Invalid provide type for '${h}'`);const D=T.URI.revive(l),v=await k.provider.openCustomDocument(D,{backupId:o,untitledDocumentData:$?.buffer},E);let I;return g(k.provider)&&this.f&&(I=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(h,v,I),{editable:g(k.provider)}}async $disposeCustomDocument(l,h){const o=this.b.get(h);if(!o)throw new Error(`No provider found for '${h}'`);if(o.type!==a.Custom)throw new Error(`Invalid provider type for '${h}'`);const $=T.URI.revive(l),{document:E}=this.i(h,$);this.c.delete(h,E),E.dispose()}async $resolveCustomEditor(l,h,o,$,E,k){const D=this.b.get(o);if(!D)throw new Error(`No provider found for '${o}'`);const v=p.ViewColumn.to(E),I=this.g.createNewWebview(h,$.contentOptions,D.extension),w=this.h.createNewWebviewPanel(h,o,$.title,v,$.options,I,$.active),y=T.URI.revive(l);switch(D.type){case a.Custom:{const{document:N}=this.i(o,y);return D.provider.resolveCustomEditor(N,w,k)}case a.Text:{const N=this.d.getDocument(y);return D.provider.resolveCustomTextEditor(N,w,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,h,o){this.i(h,l).disposeEdits(o)}async $onMoveCustomEditor(l,h,o){const $=this.b.get(o);if(!$)throw new Error(`No provider found for '${o}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const E=this.h.getWebviewPanel(l);if(!E)throw new Error("No webview found");const k=T.URI.revive(h),D=this.d.getDocument(k);await $.provider.moveCustomTextEditor(D,E,r.CancellationToken.None)}async $undo(l,h,o,$){return this.i(h,l).undo(o,$)}async $redo(l,h,o,$){return this.i(h,l).redo(o,$)}async $revert(l,h,o){const $=this.i(h,l);await this.j(h).revertCustomDocument($.document,o),$.disposeBackup()}async $onSave(l,h,o){const $=this.i(h,l);await this.j(h).saveCustomDocument($.document,o),$.disposeBackup()}async $onSaveAs(l,h,o,$){const E=this.i(h,l);return this.j(h).saveCustomDocumentAs(E.document,T.URI.revive(o),$)}async $backup(l,h,o){const $=this.i(h,l),k=await this.j(h).backupCustomDocument($.document,{destination:$.getNewBackupUri()},o);return $.updateBackup(k),k.id}i(l,h){const o=this.c.get(l,T.URI.revive(h));if(!o)throw new Error("No custom document found");return o}j(l){const o=this.b.get(l)?.provider;if(!o||!g(o))throw new Error("Custom document is not editable");return o}}e.$inc=f;function g(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function i(t){const l=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,m.$oj)(l)+""}}),define(ye[349],Se([1,0,232,144,2,6,10,17,4,12,29,63]),function(de,e,r,m,A,R,L,T,p,c,C,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=void 0;class P{#e;#t;#i;constructor(u,f,g,n,s,i,t,l){this.d=u,this.e=f,this.f=g,this.g=n,this.h=s,this.c=!1,this.f=Math.max(n,g),this.#i=new C.$Ac(h=>i.getComparisonKey(h)),this.#e=t,this.#t=l}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(u,f){if(!u){this.clear();return}this.j();let g=[];if(A.URI.isUri(u)){if(!f){this.delete(u);return}this.#i.set(u,f.slice()),g=[u]}else if(Array.isArray(u)){g=[];let i;u=[...u].sort(P.k);for(const t of u){const[l,h]=t;if((!i||l.toString()!==i.toString())&&(i&&this.#i.get(i).length===0&&this.#i.delete(i),i=l,g.push(l),this.#i.set(l,[])),h)this.#i.get(l)?.push(...h);else{const o=this.#i.get(l);o&&(o.length=0)}}}if(this.#t.fire(g),!this.#e)return;const n=[];let s=0;for(const i of g){let t=[];const l=this.#i.get(i);if(l)if(l.length>this.g){t=[];const h=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const $ of l)if($.severity===h[o]&&t.push({...T.Diagnostic.from($),modelVersionId:this.h(i)})===this.g)break e;t.push({severity:m.MarkerSeverity.Info,message:(0,r.localize)(0,null,l.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=l.map(h=>({...T.Diagnostic.from(h),modelVersionId:this.h(i)}));if(n.push([i,t]),s+=t.length,s>this.f)break}this.#e.$changeMany(this.e,n)}delete(u){this.j(),this.#t.fire([u]),this.#i.delete(u),this.#e?.$changeMany(this.e,[[u,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(u,f){this.j();for(const[g,n]of this)u.call(f,g,n,this)}*[Symbol.iterator](){this.j();for(const u of this.#i.keys())yield[u,this.get(u)]}get(u){this.j();const f=this.#i.get(u);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(u){return this.j(),Array.isArray(this.#i.get(u))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(u,f){return u[0].toString()<f[0].toString()?-1:u[0].toString()>f[0].toString()?1:0}}e.$Pmc=P;let b=class{static{d=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*d.d}static _mapper(u){const f=new C.$Ac;for(const g of u)f.set(g,g);return{uris:Object.freeze(Array.from(f.values()))}}constructor(u,f,g,n){this.j=f,this.k=g,this.l=n,this.g=new Map,this.h=new p.$le({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,d._mapper),this.f=u.getProxy(R.$uM.MainThreadDiagnostics)}createDiagnosticCollection(u,f){const{g,f:n,h:s,j:i,k:t,l}=this,h=new class{$changeMany(E,k){n.$changeMany(E,k),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,E,k.length===0?"CLEARING":k)}$clear(E){n.$clear(E),i.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,E)}dispose(){n.dispose()}};let o;if(!f)f="_generated_diagnostic_collection_name_#"+d.c++,o=f;else if(!g.has(f))o=f;else{this.j.warn(`DiagnosticCollection with name '${f}' does already exist.`);do o=f+d.c++;while(g.has(o))}return new class extends P{constructor(){super(f,o,d.e,d.d,E=>l.getDocument(E)?.version,t.extUri,h,s),g.set(o,this)}dispose(){super.dispose(),g.delete(o)}}}getDiagnostics(u){if(u)return this.m(u);{const f=new Map,g=[];for(const n of this.g.values())n.forEach((s,i)=>{let t=f.get(s.toString());typeof t>"u"&&(t=g.length,f.set(s.toString(),t),g.push([s,[]])),g[t][1]=g[t][1].concat(...i)});return g}}m(u){let f=[];for(const g of this.g.values())g.has(u)&&(f=f.concat(g.get(u)));return f}$acceptMarkersChange(u){if(!this.n){const f="_generated_mirror",g=new P(f,f,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(f,g),this.n=g}for(const[f,g]of u)this.n.set(A.URI.revive(f),g.map(T.Diagnostic.to))}};e.$Qmc=b,e.$Qmc=b=d=Je([Ge(1,c.$7j),Ge(2,S.$Omc)],b)}),define(ye[350],Se([1,0,2,14,10,17,81,52]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=void 0;class p{constructor(C,S,d,P={timeout:1500,errors:3}){this.c=C,this.d=S,this.f=d,this.g=P,this.a=new L.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(S,d,P)=>{const a={dispose:this.a.push([S,d,C])};return Array.isArray(P)&&P.push(a),a}}async $participateInSave(C,S){const d=r.URI.revive(C);let P=!1;const b=setTimeout(()=>P=!0,this.g.timeout),a=[];try{for(const u of[...this.a]){if(P)break;const f=this.d.getDocument(d),g=await this.h(u,{document:f,reason:R.TextDocumentSaveReason.to(S)});a.push(g)}}finally{clearTimeout(b)}return a}h([C,S,d],P){const b=this.b.get(C);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(d,C,S,P).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const u=this.b.get(C);this.b.set(C,u?u+1:1),typeof u=="number"&&u>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,S,d,P){const b=[],a=Date.now(),{document:u,reason:f}=P,{version:g}=u,n=Object.freeze({document:u,reason:f,waitUntil(s){if(Object.isFrozen(b))throw(0,m.$8)("waitUntil can not be called async");b.push(Promise.resolve(s))}});try{S.apply(d,[n])}catch(s){return Promise.reject(s)}return Object.freeze(b),new Promise((s,i)=>{const t=setTimeout(()=>i(new Error("timeout")),this.g.timeout);return Promise.all(b).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(t),s(l)}).catch(l=>{clearTimeout(t),i(l)})}).then(s=>{const i={edits:[]};for(const t of s)if(Array.isArray(t)&&t.every(l=>l instanceof A.$DM))for(const{newText:l,newEol:h,range:o}of t)i.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:o&&R.Range.from(o),text:l,eol:h&&R.EndOfLine.from(h)}});if(i.edits.length!==0)return g===u.version?this.f.$tryApplyWorkspaceEdit(new T.$Kw(i)):Promise.reject(new Error("concurrent_edits"))})}}e.$Ync=p}),define(ye[351],Se([1,0,4,3,2,6,162,17,18,25,10]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;class S{constructor(P,b){this.a=new r.$he,this.b=new r.$he,this.c=new r.$he,this.d=new r.$he,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new m.$Tc,this.h=new Map,this.f=P.getProxy(R.$uM.MainThreadDocuments),this.g=b,this.g.onDidRemoveDocuments(a=>{for(const u of a)this.b.fire(u.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const u of a)this.a.fire(u.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const b=this.g.getDocument(P);if(b)return b}getDocument(P){const b=this.getDocumentData(P);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return b.document}ensureDocumentData(P){const b=this.g.getDocument(P);if(b)return Promise.resolve(b);let a=this.h.get(P.toString());return a||(a=this.f.$tryOpenDocument(P).then(u=>{this.h.delete(P.toString());const f=A.URI.revive(u);return(0,p.$lg)(this.g.getDocument(f))},u=>(this.h.delete(P.toString()),Promise.reject(u))),this.h.set(P.toString(),a)),a}createDocumentData(P){return this.f.$tryCreateDocument(P).then(b=>A.URI.revive(b))}$acceptModelLanguageChanged(P,b){const a=A.URI.revive(P),u=this.g.getDocument(a);if(!u)throw new Error("unknown document");this.b.fire(u.document),u._acceptLanguageId(b),this.a.fire(u.document)}$acceptModelSaved(P){const b=A.URI.revive(P),a=this.g.getDocument(b);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(P,b){const a=A.URI.revive(P),u=this.g.getDocument(a);if(!u)throw new Error("unknown document");u._acceptIsDirty(b),this.c.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,b,a){const u=A.URI.revive(P),f=this.g.getDocument(u);if(!f)throw new Error("unknown document");f._acceptIsDirty(a),f.onEvents(b);let g;b.isUndoing?g=C.TextDocumentChangeReason.Undo:b.isRedoing&&(g=C.TextDocumentChangeReason.Redo),this.c.fire((0,c.$0n)({document:f.document,contentChanges:b.changes.map(n=>({range:T.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:g}))}setWordDefinitionFor(P,b){(0,L.$1O)(P,b)}}e.$Rmc=S}),define(ye[77],Se([1,0,79,4,18,2,5,6,20,17,10]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=e.$jnc=void 0,e.$jnc=(0,L.$Ai)("IExtHostEditorTabs");class S{constructor(u,f,g){this.e=g,this.d=f,this.acceptDtoUpdate(u)}get apiObject(){if(!this.a){const u=this,f={get isActive(){return u.b.id===u.e()},get label(){return u.b.label},get input(){return u.c},get isDirty(){return u.b.isDirty},get isPinned(){return u.b.isPinned},get isPreview(){return u.b.isPreview},get group(){return u.d.apiObject}};this.a=Object.freeze(f)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(u){this.b=u,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new C.$hO(R.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new C.$iO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new C.$jO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new C.$kO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new C.$lO(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new C.$mO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new C.$nO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new C.$oO;case T.TabInputKind.InteractiveEditorInput:return new C.$pO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new C.$qO;case T.TabInputKind.MultiDiffEditorInput:return new C.$rO(this.b.input.diffEditors.map(u=>new C.$iO(R.URI.revive(u.original),R.URI.revive(u.modified))));default:return}}}class d{constructor(u,f){this.c=[],this.d="",this.b=u,this.e=f;for(const g of u.tabs)g.isActive&&(this.d=g.id),this.c.push(new S(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const u=this,f={get isActive(){return u.b.groupId===u.e()},get viewColumn(){return c.ViewColumn.to(u.b.viewColumn)},get activeTab(){return u.c.find(g=>g.tabId===u.d)?.apiObject},get tabs(){return Object.freeze(u.c.map(g=>g.apiObject))}};this.a=Object.freeze(f)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(u){this.b=u}acceptTabOperation(u){if(u.kind===T.TabModelOperationKind.TAB_OPEN){const g=new S(u.tabDto,this,()=>this.activeTabId());return this.c.splice(u.index,0,g),u.tabDto.isActive&&(this.d=g.tabId),g}else if(u.kind===T.TabModelOperationKind.TAB_CLOSE){const g=this.c.splice(u.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(u.kind===T.TabModelOperationKind.TAB_MOVE){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(u.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this.c.splice(u.index,0,g),g}const f=this.c.find(g=>g.tabId===u.tabDto.id);if(!f)throw new Error("INVALID tab");return u.tabDto.isActive?this.d=u.tabDto.id:this.d===u.tabDto.id&&!u.tabDto.isActive&&(this.d=""),f.acceptDtoUpdate(u.tabDto),f}activeTabId(){return this.d}}let P=class{constructor(u){this.b=new m.$he,this.c=new m.$he,this.e=[],this.a=u.getProxy(T.$uM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const u=this,f={onDidChangeTabGroups:u.c.event,onDidChangeTabs:u.b.event,get all(){return Object.freeze(u.e.map(g=>g.apiObject))},get activeTabGroup(){const g=u.d;return(0,A.$lg)(u.e.find(s=>s.groupId===g)?.apiObject)},close:async(g,n)=>{const s=Array.isArray(g)?g:[g];return s.length?b(s[0])?this.j(s,n):this.i(s,n):!0}};this.f=Object.freeze(f)}return this.f}$acceptEditorTabModel(u){const f=new Set(this.e.map(h=>h.groupId)),g=new Set(u.map(h=>h.groupId)),n=(0,r.$L)(f,g),s=this.e.filter(h=>n.removed.includes(h.groupId)).map(h=>h.apiObject),i=[],t=[];this.e=u.map(h=>{const o=new d(h,()=>this.d);return n.added.includes(o.groupId)?i.push(o.apiObject):t.push(o.apiObject),o});const l=(0,A.$lg)(u.find(h=>h.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:i,closed:s,changed:t}))}$acceptTabGroupUpdate(u){const f=this.e.find(g=>g.groupId===u.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(u),u.isActive&&(this.d=u.groupId),this.c.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const f=this.e.find(n=>n.groupId===u.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const g=f.acceptTabOperation(u);switch(u.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(u){for(const f of this.e)for(const g of f.tabs)if(g.apiObject===u)return g}h(u){return this.e.find(f=>f.apiObject===u)}async i(u,f){const g=[];for(const n of u){const s=this.g(n);if(!s)throw new Error("Tab close: Invalid tab not found!");g.push(s.tabId)}return this.a.$closeTab(g,f)}async j(u,f){const g=[];for(const n of u){const s=this.h(n);if(!s)throw new Error("Group close: Invalid group not found!");g.push(s.groupId)}return this.a.$closeGroup(g,f)}};e.$knc=P,e.$knc=P=Je([Ge(0,p.$YO)],P);function b(a){return a.tabs!==void 0}}),define(ye[352],Se([1,0,2,6,28,3,10,17,193,13,27,22,26,86]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=void 0;class b{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const g=this.a.indexOf(f);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),g=[];let n,s,i=p.State.LastKnownState,t=p.State.LastKnownState;for(const l of f){let h=n?(0,c.$Df)(n,l):0;for(h===0?s=p.State.Start:s=t;h<l.length;h++)h+1===l.length?(i=t,t=p.State.BeforeColon):t+=1,g.push([s,l.toUpperCase().charCodeAt(h),t]),g.push([s,l.toLowerCase().charCodeAt(h),t]),s=t;n=l,t=i}g.push([p.State.BeforeColon,C.CharCode.Colon,p.State.AfterColon]),g.push([p.State.AfterColon,C.CharCode.Slash,p.State.End]),this.b=new p.$52(g)}}provideDocumentLinks(f){this.c();const g=[],n=p.$62.computeLinks({getLineContent(s){return f.lineAt(s-1).text},getLineCount(){return f.lineCount}},this.b);for(const s of n){const i=T.DocumentLink.to(s);i.target&&g.push(i)}return g}}class a{constructor(f,g){this.i=g,this.b=new b,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(m.$uM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,g,n,s={}){if(a.j(n),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const i=this.h++;this.b.add(g),this.d.add(g),this.c.set(i,n);let t=A.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(t+=A.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(t+=A.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(t+=A.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,d.$UG)(f,"fsChunks"),t+=A.FileSystemProviderCapabilities.FileOpenReadWriteClose);let l;s.isReadonly&&(0,P.$Zk)(s.isReadonly)&&s.isReadonly.value!==""&&(l={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(i,g,t,l).catch(o=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${g}`),console.error(o)});const h=n.onDidChangeFile(o=>{const $=[];for(const E of o){const{uri:k,type:D}=E;if(k.scheme!==g)continue;let v;switch(D){case L.FileChangeType.Changed:v=A.FileChangeType.UPDATED;break;case L.FileChangeType.Created:v=A.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:v=A.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}$.push({resource:k,type:v})}this.a.$onFileSystemChange(i,$)});return(0,R.$Sc)(()=>{h.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:g,ctime:n,mtime:s,size:i,permissions:t}=f;return{type:g,ctime:n,mtime:s,size:i,permissions:t}}$stat(f,g){return Promise.resolve(this.l(f).stat(r.URI.revive(g))).then(n=>a.k(n))}$readdir(f,g){return Promise.resolve(this.l(f).readDirectory(r.URI.revive(g)))}$readFile(f,g){return Promise.resolve(this.l(f).readFile(r.URI.revive(g))).then(n=>S.$Je.wrap(n))}$writeFile(f,g,n,s){return Promise.resolve(this.l(f).writeFile(r.URI.revive(g),n.buffer,s))}$delete(f,g,n){return Promise.resolve(this.l(f).delete(r.URI.revive(g),n))}$rename(f,g,n,s){return Promise.resolve(this.l(f).rename(r.URI.revive(g),r.URI.revive(n),s))}$copy(f,g,n,s){const i=this.l(f);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(r.URI.revive(g),r.URI.revive(n),s))}$mkdir(f,g){return Promise.resolve(this.l(f).createDirectory(r.URI.revive(g)))}$watch(f,g,n,s){const i=this.l(f).watch(r.URI.revive(n),s);this.f.set(g,i)}$unwatch(f,g){const n=this.f.get(g);n&&(n.dispose(),this.f.delete(g))}$open(f,g,n){const s=this.l(f);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(r.URI.revive(g),n))}$close(f,g){const n=this.l(f);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(g))}$read(f,g,n,s){const i=this.l(f);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const t=S.$Je.alloc(s);return Promise.resolve(i.read(g,n,t.buffer,0,s)).then(l=>t.slice(0,l))}$write(f,g,n,s){const i=this.l(f);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(g,n,s.buffer,0,s.byteLength))}l(f){const g=this.c.get(f);if(!g){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return g}}e.$2nc=a}),define(ye[353],Se([1,0,4,39,2,6,17,10,28,49]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=void 0;class C{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,a,u,f,g,n){this.a=Math.random(),this.b=new r.$he,this.c=new r.$he,this.d=new r.$he,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const s=(0,m.$uk)(g),i=typeof g=="string",t=n?.correlate,l=f(h=>{if(!(typeof h.session=="number"&&h.session!==this.a)&&!(t&&typeof h.session>"u")){if(!n?.ignoreCreateEvents)for(const o of h.created){const $=A.URI.revive(o);s($.fsPath)&&(!i||a.getWorkspaceFolder($))&&this.b.fire($)}if(!n?.ignoreChangeEvents)for(const o of h.changed){const $=A.URI.revive(o);s($.fsPath)&&(!i||a.getWorkspaceFolder($))&&this.c.fire($)}if(!n?.ignoreDeleteEvents)for(const o of h.deleted){const $=A.URI.revive(o);s($.fsPath)&&(!i||a.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=T.$wM.from(this.i(b,u,g,n,n?.correlate),this.b,this.c,this.d,l)}i(b,a,u,f,g){const n=T.$wM.from();if(typeof u=="string"||f?.ignoreChangeEvents&&f?.ignoreCreateEvents&&f?.ignoreDeleteEvents)return n;const s=b.getProxy(R.$uM.MainThreadFileSystemEventService);let i=!1;(u.pattern.includes(m.$qk)||u.pattern.includes(m.$rk))&&(i=!0);let t;return g&&(f?.ignoreChangeEvents||f?.ignoreCreateEvents||f?.ignoreDeleteEvents)&&(t=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,f?.ignoreChangeEvents&&(t&=~p.FileChangeFilter.UPDATED),f?.ignoreCreateEvents&&(t&=~p.FileChangeFilter.ADDED),f?.ignoreDeleteEvents&&(t&=~p.FileChangeFilter.DELETED)),s.$watch(a.identifier.value,this.a,u.baseUri,{recursive:i,excludes:f?.excludes??[],filter:t},!!g),T.$wM.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class S{constructor(b){this.a=b,this.session=this.a.session,this.b=new c.$V(()=>this.a.created.map(A.URI.revive)),this.c=new c.$V(()=>this.a.changed.map(A.URI.revive)),this.d=new c.$V(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class d{constructor(b,a,u){this.j=b,this.k=a,this.l=u,this.a=new r.$he,this.b=new r.$he,this.c=new r.$he,this.d=new r.$he,this.g=new r.$je,this.h=new r.$je,this.i=new r.$je,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,a,u,f){return new C(this.j,b,a,this.a.event,L.GlobPattern.from(u),f)}$onFileEvent(b){this.a.fire(new S(b))}$onDidRunFileOperation(b,a){switch(b){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:a.map(u=>({oldUri:A.URI.revive(u.source),newUri:A.URI.revive(u.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:a.map(u=>A.URI.revive(u.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:a.map(u=>A.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,a){return(u,f,g)=>{const n=function(i){u.call(f,i)};return n.extension=b,a.event(n,void 0,g)}}async $onWillRunFileOperation(b,a,u,f){switch(b){case p.FileOperation.MOVE:return await this.n(this.g,{files:a.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))},u,f);case p.FileOperation.DELETE:return await this.n(this.i,{files:a.map(g=>A.URI.revive(g.target))},u,f);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:a.map(g=>A.URI.revive(g.target))},u,f)}}async n(b,a,u,f){const g=new Set,n=[];if(await b.fireAsync(a,f,async(i,t)=>{const l=Date.now(),h=await Promise.resolve(i);h instanceof T.$GM&&(n.push([t.extension,h]),g.add(t.extension.displayName??t.extension.identifier.value)),Date.now()-l>u&&this.k.warn("SLOW file-participant",t.extension.identifier)}),f.isCancellationRequested||n.length===0)return;const s={edits:[]};for(const[,i]of n){const{edits:t}=L.WorkspaceEdit.from(i,{getTextDocumentVersion:l=>this.l.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(t)}return{edit:s,extensionNames:Array.from(g)}}}e.$3nc=d}),define(ye[354],Se([1,0,19,9,21,14,132,3,25,42,13,18,2,31,189,88,142,234,24,17,10,26,118,6]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=void 0;class h{constructor(W,q){this.d=W,this.e=q}async provideDocumentSymbols(W,q){const Y=this.d.getDocument(W),x=await this.e.provideDocumentSymbols(Y,q);if(!(0,r.$Kb)(x))return x[0]instanceof s.$QM?x.map(n.DocumentSymbol.from):h.f(x)}static f(W){W=W.slice(0).sort((x,fe)=>{let we=x.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(x.location.range.end)),we});const q=[],Y=[];for(const x of W){const fe={name:x.name||"!!MISSING: name!!",kind:n.SymbolKind.from(x.kind),tags:x.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:n.Range.from(x.location.range),selectionRange:n.Range.from(x.location.range),children:[]};for(;;){if(Y.length===0){Y.push(fe),q.push(fe);break}const we=Y[Y.length-1];if(P.$ct.containsRange(we.range,fe.range)&&!P.$ct.equalsRange(we.range,fe.range)){we.children?.push(fe),Y.push(fe);break}Y.pop()}}return q}}class o{constructor(W,q,Y,x,fe,we){this.f=W,this.g=q,this.h=Y,this.j=x,this.k=fe,this.l=we,this.d=new t.$Imc("CodeLens"),this.e=new Map}async provideCodeLenses(W,q){const Y=this.f.getDocument(W),x=await this.h.provideCodeLenses(Y,q);if(!x||q.isCancellationRequested)return;const fe=this.d.add(x),we=new T.$Tc;this.e.set(fe,we);const Me={cacheId:fe,lenses:[]};for(let qe=0;qe<x.length;qe++)Me.lenses.push({cacheId:[fe,qe],range:n.Range.from(x[qe].range),command:this.g.toInternal(x[qe].command,we)});return Me}async resolveCodeLens(W,q){const Y=W.cacheId&&this.d.get(...W.cacheId);if(!Y)return;let x;if(typeof this.h.resolveCodeLens!="function"||Y.isResolved?x=Y:x=await this.h.resolveCodeLens(Y,q),x||(x=Y),q.isCancellationRequested)return;const fe=W.cacheId&&this.e.get(W.cacheId[0]);if(fe){if(!x.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return W.command=this.g.toInternal(x.command,fe),W}}releaseCodeLenses(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}}function $(Le){return Array.isArray(Le)?Le.map(n.DefinitionLink.from):Le?[n.DefinitionLink.from(Le)]:[]}class E{constructor(W,q){this.d=W,this.e=q}async provideDefinition(W,q,Y){const x=this.d.getDocument(W),fe=n.Position.to(q),we=await this.e.provideDefinition(x,fe,Y);return $(we)}}class k{constructor(W,q){this.d=W,this.e=q}async provideDeclaration(W,q,Y){const x=this.d.getDocument(W),fe=n.Position.to(q),we=await this.e.provideDeclaration(x,fe,Y);return $(we)}}class D{constructor(W,q){this.d=W,this.e=q}async provideImplementation(W,q,Y){const x=this.d.getDocument(W),fe=n.Position.to(q),we=await this.e.provideImplementation(x,fe,Y);return $(we)}}class v{constructor(W,q){this.d=W,this.e=q}async provideTypeDefinition(W,q,Y){const x=this.d.getDocument(W),fe=n.Position.to(q),we=await this.e.provideTypeDefinition(x,fe,Y);return $(we)}}class I{static{this.f=10}constructor(W,q){this.g=W,this.h=q,this.d=0,this.e=new Map}async provideHover(W,q,Y,x){const fe=this.g.getDocument(W),we=n.Position.to(q);let Me;if(Y&&Y.verbosityRequest){const it=Y.verbosityRequest.previousHover.id,tt=this.e.get(it);if(!tt)throw new Error(`Hover with id ${it} not found`);const rt={verbosityDelta:Y.verbosityRequest.verbosityDelta,previousHover:tt};Me=await this.h.provideHover(fe,we,x,rt)}else Me=await this.h.provideHover(fe,we,x);if(!Me||(0,r.$Kb)(Me.contents))return;Me.range||(Me.range=fe.getWordRangeAtPosition(we)),Me.range||(Me.range=new s.$yM(we,we));const qe=n.Hover.from(Me),He=this.d;if(this.e.size===I.f){const it=Math.min(...this.e.keys());this.e.delete(it)}return this.e.set(He,Me),this.d+=1,{...qe,id:He}}releaseHover(W){this.e.delete(W)}}class w{constructor(W,q){this.d=W,this.e=q}async provideEvaluatableExpression(W,q,Y){const x=this.d.getDocument(W),fe=n.Position.to(q),we=await this.e.provideEvaluatableExpression(x,fe,Y);if(we)return n.EvaluatableExpression.from(we)}}class y{constructor(W,q){this.d=W,this.e=q}async provideInlineValues(W,q,Y,x){const fe=this.d.getDocument(W),we=await this.e.provideInlineValues(fe,n.Range.to(q),n.InlineValueContext.to(Y),x);if(Array.isArray(we))return we.map(Me=>n.InlineValue.from(Me))}}class N{constructor(W,q){this.d=W,this.e=q}async provideDocumentHighlights(W,q,Y){const x=this.d.getDocument(W),fe=n.Position.to(q),we=await this.e.provideDocumentHighlights(x,fe,Y);if(Array.isArray(we))return we.map(n.DocumentHighlight.from)}}class O{constructor(W,q){this.d=W,this.e=q}async provideMultiDocumentHighlights(W,q,Y,x){const fe=this.d.getDocument(W),we=Y.map(He=>this.d.getDocument(He)),Me=n.Position.to(q),qe=await this.e.provideMultiDocumentHighlights(fe,Me,we,x);if(Array.isArray(qe))return qe.map(n.MultiDocumentHighlight.from)}}class U{constructor(W,q){this.d=W,this.e=q}async provideLinkedEditingRanges(W,q,Y){const x=this.d.getDocument(W),fe=n.Position.to(q),we=await this.e.provideLinkedEditingRanges(x,fe,Y);if(we&&Array.isArray(we.ranges))return{ranges:(0,r.$Hb)(we.ranges.map(n.Range.from)),wordPattern:we.wordPattern}}}class j{constructor(W,q){this.d=W,this.e=q}async provideReferences(W,q,Y,x){const fe=this.d.getDocument(W),we=n.Position.to(q),Me=await this.e.provideReferences(fe,we,Y,x);if(Array.isArray(Me))return Me.map(n.location.from)}}class z{static{this.d=1e3}constructor(W,q,Y,x,fe,we,Me){this.g=W,this.h=q,this.j=Y,this.k=x,this.l=fe,this.m=we,this.n=Me,this.e=new t.$Imc("CodeAction"),this.f=new Map}async provideCodeActions(W,q,Y,x){const fe=this.g.getDocument(W),we=b.$et.isISelection(q)?n.Selection.to(q):n.Range.to(q),Me=[];for(const rt of this.j.getDiagnostics(W))if(we.intersection(rt.range)&&Me.push(rt)>z.d)break;const qe={diagnostics:Me,only:Y.only?new s.$SM(Y.only):void 0,triggerKind:n.CodeActionTriggerKind.to(Y.trigger)},He=await this.k.provideCodeActions(fe,we,qe,x);if(!(0,r.$Lb)(He)||x.isCancellationRequested)return;const Ze=this.e.add(He),it=new T.$Tc;this.f.set(Ze,it);const tt=[];for(let rt=0;rt<He.length;rt++){const ot=He[rt];if(ot)if(z.o(ot))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:ot.title,command:this.h.toInternal(ot,it)});else{qe.only&&(ot.kind?qe.only.contains(ot.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action is of kind '${ot.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=ot.ranges??[];tt.push({cacheId:[Ze,rt],title:ot.title,command:ot.command&&this.h.toInternal(ot.command,it),diagnostics:ot.diagnostics&&ot.diagnostics.map(n.Diagnostic.from),edit:ot.edit&&n.WorkspaceEdit.from(ot.edit,void 0),kind:ot.kind&&ot.kind.value,isPreferred:ot.isPreferred,isAI:(0,i.$TG)(this.m,"codeActionAI")?ot.isAI:!1,ranges:(0,i.$TG)(this.m,"codeActionRanges")?(0,r.$Hb)(ft.map(n.Range.from)):void 0,disabled:ot.disabled?.reason})}}return{cacheId:Ze,actions:tt}}async resolveCodeAction(W,q){const[Y,x]=W,fe=this.e.get(Y,x);if(!fe||z.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,q)??fe;let Me;we.edit&&(Me=n.WorkspaceEdit.from(we.edit,void 0));let qe;if(we.command){const He=this.f.get(Y);He&&(qe=this.h.toInternal(we.command,He))}return{edit:Me,command:qe}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}class M{constructor(W,q,Y,x,fe){this.e=W,this.f=q,this.g=Y,this.h=x,this.j=fe,this.d=new t.$Imc("DocumentPasteEdit")}async prepareDocumentPaste(W,q,Y,x){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(W),we=q.map(He=>n.Range.to(He)),Me=n.DataTransfer.toDataTransfer(Y,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(fe,we,Me,x),x.isCancellationRequested)return;const qe=Array.from(Me).filter(([,He])=>!(He instanceof s.$mN));return n.DataTransfer.from(qe)}async providePasteEdits(W,q,Y,x,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const Me=this.f.getDocument(q),qe=Y.map(tt=>n.Range.to(tt)),He=n.DataTransfer.toDataTransfer(x,async tt=>(await this.e.$resolvePasteFileData(this.h,W,tt)).buffer),Ze=await this.g.provideDocumentPasteEdits(Me,qe,He,{only:fe.only?new s.$rN(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!Ze||we.isCancellationRequested)return[];const it=this.d.add(Ze);return Ze.map((tt,rt)=>({_cacheId:[it,rt],title:tt.title??(0,f.localize)(0,null,this.j.displayName||this.j.name),kind:tt.kind,yieldTo:tt.yieldTo?.map(ot=>ot.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?n.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(W,q){const[Y,x]=W,fe=this.d.get(Y,x);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,q)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(W){this.d.delete(W)}}class F{constructor(W,q){this.d=W,this.e=q}async provideDocumentFormattingEdits(W,q,Y){const x=this.d.getDocument(W),fe=await this.e.provideDocumentFormattingEdits(x,q,Y);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class J{constructor(W,q){this.d=W,this.e=q}async provideDocumentRangeFormattingEdits(W,q,Y,x){const fe=this.d.getDocument(W),we=n.Range.to(q),Me=await this.e.provideDocumentRangeFormattingEdits(fe,we,Y,x);if(Array.isArray(Me))return Me.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,q,Y,x){(0,S.$kg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(W),we=q.map(n.Range.to),Me=await this.e.provideDocumentRangesFormattingEdits(fe,we,Y,x);if(Array.isArray(Me))return Me.map(n.TextEdit.from)}}class ee{constructor(W,q){this.d=W,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,q,Y,x,fe){const we=this.d.getDocument(W),Me=n.Position.to(q),qe=await this.e.provideOnTypeFormattingEdits(we,Me,Y,x,fe);if(Array.isArray(qe))return qe.map(n.TextEdit.from)}}class V{constructor(W,q){this.e=W,this.f=q,this.d=new t.$Imc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,q){const Y=await this.e.provideWorkspaceSymbols(W,q);if(!(0,r.$Lb)(Y))return{symbols:[]};const x=this.d.add(Y),fe={cacheId:x,symbols:[]};for(let we=0;we<Y.length;we++){const Me=Y[we];if(!Me||!Me.name){this.f.warn("INVALID SymbolInformation",Me);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Me),cacheId:[x,we]})}return fe}async resolveWorkspaceSymbol(W,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const Y=this.d.get(...W.cacheId);if(Y){const x=await this.e.resolveWorkspaceSymbol(Y,q);return x&&(0,p.$_n)(W,n.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class H{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,q,Y){this.d=W,this.e=q,this.f=Y}async provideRenameEdits(W,q,Y,x){const fe=this.d.getDocument(W),we=n.Position.to(q);try{const Me=await this.e.provideRenameEdits(fe,we,Y,x);return Me?n.WorkspaceEdit.from(Me):void 0}catch(Me){const qe=H.g(Me);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(Me)}}async resolveRenameLocation(W,q,Y){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(W),fe=n.Position.to(q);try{const we=await this.e.prepareRename(x,fe,Y);let Me,qe;if(s.$yM.isRange(we)?(Me=we,qe=x.getText(we)):(0,S.$cg)(we)&&(Me=we.range,qe=we.placeholder),!Me||!qe)return;if(Me.start.line>fe.line||Me.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Me),text:qe}}catch(we){const Me=H.g(we);return Me?{rejectReason:Me,range:void 0,text:void 0}:Promise.reject(we)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class _{static{this.d={[a.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(W,q,Y){this.e=W,this.f=q,this.g=Y}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(W,q,Y,x){const fe=this.e.getDocument(W),we=n.Range.to(q);try{const Me=_.d[Y],qe=await this.f.provideNewSymbolNames(fe,we,Me,x);return qe?qe.map(He=>typeof He=="string"?{newSymbolName:He}:{newSymbolName:He.newSymbolName,tags:He.tags}):void 0}catch(Me){this.g.error(_.h(Me)??JSON.stringify(Me,null,"	"));return}}static h(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class ne{constructor(W,q){this.resultId=W,this.tokens=q}}class he{constructor(W,q){this.f=W,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,q,Y){const x=this.f.getDocument(W),fe=q!==0?this.d.get(q):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,fe.resultId,Y):await this.g.provideDocumentSemanticTokens(x,Y);return fe&&this.d.delete(q),we?(we=he.h(we),this.o(he.n(fe,we),we)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return he.j(W)?he.k(W)?W:new s.$RN(new Uint32Array(W.data),W.resultId):he.l(W)?he.m(W)?W:new s.$TN(W.edits.map(q=>new s.$SN(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const q of W.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(W,q){if(!he.j(q)||!W||!W.tokens)return q;const Y=W.tokens,x=Y.length,fe=q.data,we=fe.length;let Me=0;const qe=Math.min(x,we);for(;Me<qe&&Y[Me]===fe[Me];)Me++;if(Me===x&&Me===we)return new s.$TN([],q.resultId);let He=0;const Ze=qe-Me;for(;He<Ze&&Y[x-He-1]===fe[we-He-1];)He++;return new s.$TN([{start:Me,deleteCount:x-Me-He,data:fe.subarray(Me,we-He)}],q.resultId)}o(W,q){if(he.j(W)){const Y=this.e++;return this.d.set(Y,new ne(W.resultId,W.data)),(0,u.$5bb)({id:Y,type:"full",data:W.data})}if(he.l(W)){const Y=this.e++;return he.j(q)?this.d.set(Y,new ne(q.resultId,q.data)):this.d.set(Y,new ne(W.resultId)),(0,u.$5bb)({id:Y,type:"delta",deltas:(W.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class re{constructor(W,q){this.d=W,this.e=q}async provideDocumentRangeSemanticTokens(W,q,Y){const x=this.d.getDocument(W),fe=await this.e.provideDocumentRangeSemanticTokens(x,n.Range.to(q),Y);return fe?this.f(fe):null}f(W){return(0,u.$5bb)({id:0,type:"full",data:W.data})}}class ve{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,q,Y,x,fe){this.f=W,this.g=q,this.h=Y,this.j=x,this.k=fe,this.d=new t.$Imc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,q,Y,x){const fe=this.f.getDocument(W),we=n.Position.to(q),Me=fe.getWordRangeAtPosition(we)||new s.$yM(we,we),qe=Me.with({end:we}),He=new c.$be,Ze=await this.h.provideCompletionItems(fe,we,x,n.CompletionContext.to(Y));if(!Ze||x.isCancellationRequested)return;const it=Array.isArray(Ze)?new s.$6M(Ze):Ze,tt=ve.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),rt=new T.$Tc;this.e.set(tt,rt);const ot=[],ft={x:tt,[l.ISuggestResultDtoField.completions]:ot,[l.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Me),insert:n.Range.from(qe)},[l.ISuggestResultDtoField.isIncomplete]:it.isIncomplete||void 0,[l.ISuggestResultDtoField.duration]:He.elapsed()};for(let ut=0;ut<it.items.length;ut++){const st=it.items[ut],Pe=this.l(st,[tt,ut],qe,Me);ot.push(Pe)}return ft}async resolveCompletionItem(W,q){if(typeof this.h.resolveCompletionItem!="function")return;const Y=this.d.get(...W);if(!Y)return;const x=this.l(Y,W),fe=await this.h.resolveCompletionItem(Y,q);if(!fe)return;const we=this.l(fe,W);return(x[l.ISuggestDataDtoField.insertText]!==we[l.ISuggestDataDtoField.insertText]||x[l.ISuggestDataDtoField.insertTextRules]!==we[l.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x[l.ISuggestDataDtoField.commandIdent]!==we[l.ISuggestDataDtoField.commandIdent]||x[l.ISuggestDataDtoField.commandId]!==we[l.ISuggestDataDtoField.commandId]||!(0,p.$ao)(x[l.ISuggestDataDtoField.commandArguments],we[l.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,[l.ISuggestDataDtoField.documentation]:we[l.ISuggestDataDtoField.documentation],[l.ISuggestDataDtoField.detail]:we[l.ISuggestDataDtoField.detail],[l.ISuggestDataDtoField.additionalTextEdits]:we[l.ISuggestDataDtoField.additionalTextEdits],[l.ISuggestDataDtoField.insertText]:we[l.ISuggestDataDtoField.insertText],[l.ISuggestDataDtoField.insertTextRules]:we[l.ISuggestDataDtoField.insertTextRules],[l.ISuggestDataDtoField.commandIdent]:we[l.ISuggestDataDtoField.commandIdent],[l.ISuggestDataDtoField.commandId]:we[l.ISuggestDataDtoField.commandId],[l.ISuggestDataDtoField.commandArguments]:we[l.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,q,Y,x){const fe=this.e.get(q[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(W.command,fe),Me={x:q,[l.ISuggestDataDtoField.label]:W.label,[l.ISuggestDataDtoField.kind]:W.kind!==void 0?n.CompletionItemKind.from(W.kind):void 0,[l.ISuggestDataDtoField.kindModifier]:W.tags&&W.tags.map(n.CompletionItemTag.from),[l.ISuggestDataDtoField.detail]:W.detail,[l.ISuggestDataDtoField.documentation]:typeof W.documentation>"u"?void 0:n.MarkdownString.fromStrict(W.documentation),[l.ISuggestDataDtoField.sortText]:W.sortText!==W.label?W.sortText:void 0,[l.ISuggestDataDtoField.filterText]:W.filterText!==W.label?W.filterText:void 0,[l.ISuggestDataDtoField.preselect]:W.preselect||void 0,[l.ISuggestDataDtoField.insertTextRules]:W.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[l.ISuggestDataDtoField.commitCharacters]:W.commitCharacters?.join(""),[l.ISuggestDataDtoField.additionalTextEdits]:W.additionalTextEdits&&W.additionalTextEdits.map(n.TextEdit.from),[l.ISuggestDataDtoField.commandIdent]:we?.$ident,[l.ISuggestDataDtoField.commandId]:we?.id,[l.ISuggestDataDtoField.commandArguments]:we?.$ident?void 0:we?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Me[l.ISuggestDataDtoField.insertText]=W.textEdit.newText):typeof W.insertText=="string"?Me[l.ISuggestDataDtoField.insertText]=W.insertText:W.insertText instanceof s.$HM&&(Me[l.ISuggestDataDtoField.insertText]=W.insertText.value,Me[l.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let qe;return W.textEdit?qe=W.textEdit.range:W.range&&(qe=W.range),s.$yM.isRange(qe)?Me[l.ISuggestDataDtoField.range]=n.Range.from(qe):qe&&(!Y?.isEqual(qe.inserting)||!x?.isEqual(qe.replacing))&&(Me[l.ISuggestDataDtoField.range]={insert:n.Range.from(qe.inserting),replace:n.Range.from(qe.replacing)}),Me}}class pe{async provideInlineCompletions(W,q,Y,x){}disposeCompletions(W){}handleDidShowCompletionItem(W,q,Y){}handlePartialAccept(W,q,Y,x){}}class Q extends pe{constructor(W,q,Y,x){super(),this.f=W,this.g=q,this.h=Y,this.j=x,this.d=new se,this.e=(0,i.$TG)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$TG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,q,Y,x){const fe=this.g.getDocument(W),we=n.Position.to(q),Me=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:n.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Y.triggerKind]},x);if(!Me||x.isCancellationRequested)return;const qe=Array.isArray(Me)?Me:Me.items,He=this.e?Array.isArray(Me)?[]:Me.commands||[]:[],Ze=this.e&&!Array.isArray(Me)?Me.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:qe}),items:qe.map((rt,ot)=>{let ft;rt.command&&(it||(it=new T.$Tc),ft=this.j.toInternal(rt.command,it));const ut=rt.insertText;return{insertText:typeof ut=="string"?ut:{snippet:ut.value},filterText:rt.filterText,range:rt.range?n.Range.from(rt.range):void 0,command:ft,idx:ot,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:He.map(rt=>(it||(it=new T.$Tc),this.j.toInternal(rt,it))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,q,Y){const x=this.d.get(W)?.items[q];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,Y)}handlePartialAccept(W,q,Y,x){const fe=this.d.get(W)?.items[q];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,Y),this.h.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(x)))}}class B{async provideInlineEdits(W,q,Y){const x=this.f.getDocument(W),fe=await this.g.provideInlineEdit(x,{triggerKind:this.e[q.triggerKind]},Y);if(!fe||Y.isCancellationRequested)return;let we;const Me=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let qe;fe.accepted&&(we||(we=new T.$Tc),qe=this.h.toInternal(fe.accepted,we));let He;return fe.rejected&&(we||(we=new T.$Tc),He=this.h.toInternal(fe.rejected,we)),{pid:Me,text:fe.text,range:n.Range.from(fe.range),accepted:qe,rejected:He}}disposeEdit(W){this.d.disposeReferenceId(W)?.dispose()}constructor(W,q,Y,x){this.f=q,this.g=Y,this.h=x,this.d=new se,this.e={[a.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const q=this.e++;return this.d.set(q,W),q}disposeReferenceId(W){const q=this.d.get(W);return this.d.delete(W),q}get(W){return this.d.get(W)}}class ae{constructor(W,q){this.e=W,this.f=q,this.d=new t.$Imc("SignatureHelp")}async provideSignatureHelp(W,q,Y,x){const fe=this.e.getDocument(W),we=n.Position.to(q),Me=this.g(Y),qe=await this.f.provideSignatureHelp(fe,we,x,Me);if(qe){const He=this.d.add([qe]);return{...n.SignatureHelp.from(qe),id:He}}}g(W){let q;if(W.activeSignatureHelp){const Y=n.SignatureHelp.to(W.activeSignatureHelp),x=this.d.get(W.activeSignatureHelp.id,0);x?(q=x,q.activeSignature=Y.activeSignature,q.activeParameter=Y.activeParameter):q=Y}return{...W,activeSignatureHelp:q}}releaseSignatureHelp(W){this.d.delete(W)}}class ie{constructor(W,q,Y,x,fe){this.f=W,this.g=q,this.h=Y,this.j=x,this.k=fe,this.d=new t.$Imc("InlayHints"),this.e=new Map}async provideInlayHints(W,q,Y){const x=this.f.getDocument(W),fe=n.Range.to(q),we=await this.h.provideInlayHints(x,fe,Y);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(Y.isCancellationRequested)return;const Me=this.d.add(we);this.e.set(Me,new T.$Tc);const qe={hints:[],cacheId:Me};for(let He=0;He<we.length;He++)this.l(we[He],fe)&&qe.hints.push(this.m(we[He],[Me,He]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),qe}async resolveInlayHint(W,q){if(typeof this.h.resolveInlayHint!="function")return;const Y=this.d.get(...W);if(!Y)return;const x=await this.h.resolveInlayHint(Y,q);if(x&&this.l(x))return this.m(x,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,q){return W.label.length===0||Array.isArray(W.label)&&W.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(q&&!q.contains(W.position))}m(W,q){const Y=this.e.get(q[0]);if(!Y)throw Error("DisposableStore is missing...");const x={label:"",cacheId:q,tooltip:n.MarkdownString.fromStrict(W.tooltip),position:n.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(n.TextEdit.from),kind:W.kind&&n.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};if(typeof W.label=="string")x.label=W.label;else{const fe=[];x.label=fe;for(const we of W.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Me={label:we.value,tooltip:n.MarkdownString.fromStrict(we.tooltip)};s.$IM.isLocation(we.location)&&(Me.location=n.location.from(we.location)),we.command&&(Me.command=this.g.toInternal(we.command,Y)),fe.push(Me)}}return x}}class ce{constructor(W,q){this.e=W,this.f=q,this.d=new t.$Imc("DocumentLink")}async provideLinks(W,q){const Y=this.e.getDocument(W),x=await this.f.provideDocumentLinks(Y,q);if(!(!Array.isArray(x)||x.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(ce.g).map(n.DocumentLink.from)};{const fe=this.d.add(x),we={links:[],cacheId:fe};for(let Me=0;Me<x.length;Me++){if(!ce.g(x[Me]))continue;const qe=n.DocumentLink.from(x[Me]);qe.cacheId=[fe,Me],we.links.push(qe)}return we}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,q){if(typeof this.f.resolveDocumentLink!="function")return;const Y=this.d.get(...W);if(!Y)return;const x=await this.f.resolveDocumentLink(Y,q);if(!(!x||!ce.g(x)))return n.DocumentLink.from(x)}releaseLinks(W){this.d.delete(W)}}class ue{constructor(W,q){this.d=W,this.e=q}async provideColors(W,q){const Y=this.d.getDocument(W),x=await this.e.provideDocumentColors(Y,q);return Array.isArray(x)?x.map(we=>({color:n.Color.from(we.color),range:n.Range.from(we.range)})):[]}async provideColorPresentations(W,q,Y){const x=this.d.getDocument(W),fe=n.Range.to(q.range),we=n.Color.to(q.color),Me=await this.e.provideColorPresentations(we,{document:x,range:fe},Y);if(Array.isArray(Me))return Me.map(n.ColorPresentation.from)}}class Z{constructor(W,q){this.d=W,this.e=q}async provideFoldingRanges(W,q,Y){const x=this.d.getDocument(W),fe=await this.e.provideFoldingRanges(x,q,Y);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class oe{constructor(W,q,Y){this.d=W,this.e=q,this.f=Y}async provideSelectionRanges(W,q,Y){const x=this.d.getDocument(W),fe=q.map(n.Position.to),we=await this.e.provideSelectionRanges(x,fe,Y);if(!(0,r.$Lb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Me=[];for(let qe=0;qe<fe.length;qe++){const He=[];Me.push(He);let Ze=fe[qe],it=we[qe];for(;;){if(!it.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(He.push(n.SelectionRange.from(it)),!it.parent)break;Ze=it.range,it=it.parent}}return Me}}class $e{constructor(W,q){this.f=W,this.g=q,this.d=new L.$4O(""),this.e=new Map}async prepareSession(W,q,Y){const x=this.f.getDocument(W),fe=n.Position.to(q),we=await this.g.prepareCallHierarchy(x,fe,Y);if(!we)return;const Me=this.d.nextId();return this.e.set(Me,new Map),Array.isArray(we)?we.map(qe=>this.h(Me,qe)):[this.h(Me,we)]}async provideCallsTo(W,q,Y){const x=this.j(W,q);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(x,Y);if(fe)return fe.map(we=>({from:this.h(W,we.from),fromRanges:we.fromRanges.map(Me=>n.Range.from(Me))}))}async provideCallsFrom(W,q,Y){const x=this.j(W,q);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(x,Y);if(fe)return fe.map(we=>({to:this.h(W,we.to),fromRanges:we.fromRanges.map(Me=>n.Range.from(Me))}))}releaseSession(W){this.e.delete(W)}h(W,q){const Y=this.e.get(W),x=n.CallHierarchyItem.from(q,W,Y.size.toString(36));return Y.set(x._itemId,q),x}j(W,q){return this.e.get(W)?.get(q)}}class be{constructor(W,q){this.f=W,this.g=q,this.d=new L.$4O(""),this.e=new Map}async prepareSession(W,q,Y){const x=this.f.getDocument(W),fe=n.Position.to(q),we=await this.g.prepareTypeHierarchy(x,fe,Y);if(!we)return;const Me=this.d.nextId();return this.e.set(Me,new Map),Array.isArray(we)?we.map(qe=>this.h(Me,qe)):[this.h(Me,we)]}async provideSupertypes(W,q,Y){const x=this.j(W,q);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(x,Y);if(fe)return fe.map(we=>this.h(W,we))}async provideSubtypes(W,q,Y){const x=this.j(W,q);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(x,Y);if(fe)return fe.map(we=>this.h(W,we))}releaseSession(W){this.e.delete(W)}h(W,q){const Y=this.e.get(W),x=n.TypeHierarchyItem.from(q,W,Y.size.toString(36));return Y.set(x._itemId,q),x}j(W,q){return this.e.get(W)?.get(q)}}class Ne{constructor(W,q,Y,x,fe){this.e=W,this.f=q,this.g=Y,this.h=x,this.j=fe,this.d=new t.$Imc("DocumentDropEdit")}async provideDocumentOnDropEdits(W,q,Y,x,fe){const we=this.f.getDocument(q),Me=n.Position.to(Y),qe=n.DataTransfer.toDataTransfer(x,async tt=>(await this.e.$resolveDocumentOnDropFileData(this.h,W,tt)).buffer),He=await this.g.provideDocumentDropEdits(we,Me,qe,fe);if(!He)return;const Ze=(0,r.$2b)(He),it=this.d.add(Ze);return Ze.map((tt,rt)=>({_cacheId:[it,rt],title:tt.title??(0,f.localize)(1,null,this.j.displayName||this.j.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(ot=>ot.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?n.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolveDropEdit(W,q){const[Y,x]=W,fe=this.d.get(Y,x);if(!fe||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(fe,q)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(W){this.d.delete(W)}}class Be{constructor(W,q){this.d=W,this.e=q}async provideMappedEdits(W,q,Y,x){const fe=d.URI.revive(W),we=this.d.getDocument(fe),Me=Y.documents.map(Ze=>Ze.map(it=>({uri:d.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(tt=>n.Range.to(tt))}))),qe={documents:Me,selections:Me[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(we,q,qe,x);return He?n.WorkspaceEdit.from(He):null}}class De{constructor(W,q){this.adapter=W,this.extension=q}}class Ie{static{this.d=0}constructor(W,q,Y,x,fe,we,Me,qe){this.g=q,this.h=Y,this.j=x,this.k=fe,this.l=we,this.m=Me,this.n=qe,this.f=new Map,this.e=W.getProxy(l.$uM.MainThreadLanguageFeatures)}o(W,q){return n.DocumentSelector.from(W,this.g,q)}p(W){return new s.$wM(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return Ie.d++}async s(W,q,Y,x,fe,we=!1){const Me=this.f.get(W);if(!Me||!(Me.adapter instanceof q))return x;const qe=Date.now();we||this.l.trace(`[${Me.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const He=Y(Me.adapter,Me.extension);return Promise.resolve(He).catch(Ze=>{(0,R.$4)(Ze)||(this.l.error(`[${Me.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(Me.extension.identifier,Ze))}).finally(()=>{we||this.l.trace(`[${Me.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),A.CancellationToken.isCancellationToken(fe)?(0,m.$ph)(He,fe):He}t(W,q){const Y=this.q();return this.f.set(Y,new De(W,q)),Y}static u(W){return W.displayName||W.name}static w(W){return W.identifier.value}registerDocumentSymbolProvider(W,q,Y,x){const fe=this.t(new h(this.h,Y),W),we=x&&x.label||Ie.u(W);return this.e.$registerDocumentSymbolProvider(fe,this.o(q,W),we),this.p(fe)}$provideDocumentSymbols(W,q,Y){return this.s(W,h,x=>x.provideDocumentSymbols(d.URI.revive(q),Y),void 0,Y)}registerCodeLensProvider(W,q,Y){const x=this.q(),fe=typeof Y.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new De(new o(this.h,this.j.converter,Y,W,this.n,this.l),W)),this.e.$registerCodeLensSupport(x,this.o(q,W),fe);let we=this.p(x);if(fe!==void 0){const Me=Y.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(fe));we=s.$wM.from(we,Me)}return we}$provideCodeLenses(W,q,Y){return this.s(W,o,x=>x.provideCodeLenses(d.URI.revive(q),Y),void 0,Y)}$resolveCodeLens(W,q,Y){return this.s(W,o,x=>x.resolveCodeLens(q,Y),void 0,void 0)}$releaseCodeLenses(W,q){this.s(W,o,Y=>Promise.resolve(Y.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(W,q,Y){const x=this.t(new E(this.h,Y),W);return this.e.$registerDefinitionSupport(x,this.o(q,W)),this.p(x)}$provideDefinition(W,q,Y,x){return this.s(W,E,fe=>fe.provideDefinition(d.URI.revive(q),Y,x),[],x)}registerDeclarationProvider(W,q,Y){const x=this.t(new k(this.h,Y),W);return this.e.$registerDeclarationSupport(x,this.o(q,W)),this.p(x)}$provideDeclaration(W,q,Y,x){return this.s(W,k,fe=>fe.provideDeclaration(d.URI.revive(q),Y,x),[],x)}registerImplementationProvider(W,q,Y){const x=this.t(new D(this.h,Y),W);return this.e.$registerImplementationSupport(x,this.o(q,W)),this.p(x)}$provideImplementation(W,q,Y,x){return this.s(W,D,fe=>fe.provideImplementation(d.URI.revive(q),Y,x),[],x)}registerTypeDefinitionProvider(W,q,Y){const x=this.t(new v(this.h,Y),W);return this.e.$registerTypeDefinitionSupport(x,this.o(q,W)),this.p(x)}$provideTypeDefinition(W,q,Y,x){return this.s(W,v,fe=>fe.provideTypeDefinition(d.URI.revive(q),Y,x),[],x)}registerHoverProvider(W,q,Y,x){const fe=this.t(new I(this.h,Y),W);return this.e.$registerHoverProvider(fe,this.o(q,W)),this.p(fe)}$provideHover(W,q,Y,x,fe){return this.s(W,I,we=>we.provideHover(d.URI.revive(q),Y,x,fe),void 0,fe)}$releaseHover(W,q){this.s(W,I,Y=>Promise.resolve(Y.releaseHover(q)),void 0,void 0)}registerEvaluatableExpressionProvider(W,q,Y,x){const fe=this.t(new w(this.h,Y),W);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(q,W)),this.p(fe)}$provideEvaluatableExpression(W,q,Y,x){return this.s(W,w,fe=>fe.provideEvaluatableExpression(d.URI.revive(q),Y,x),void 0,x)}registerInlineValuesProvider(W,q,Y,x){const fe=typeof Y.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new y(this.h,Y),W);this.e.$registerInlineValuesProvider(we,this.o(q,W),fe);let Me=this.p(we);if(fe!==void 0){const qe=Y.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(fe));Me=s.$wM.from(Me,qe)}return Me}$provideInlineValues(W,q,Y,x,fe){return this.s(W,y,we=>we.provideInlineValues(d.URI.revive(q),Y,x,fe),void 0,fe)}registerDocumentHighlightProvider(W,q,Y){const x=this.t(new N(this.h,Y),W);return this.e.$registerDocumentHighlightProvider(x,this.o(q,W)),this.p(x)}registerMultiDocumentHighlightProvider(W,q,Y){const x=this.t(new O(this.h,Y),W);return this.e.$registerMultiDocumentHighlightProvider(x,this.o(q,W)),this.p(x)}$provideDocumentHighlights(W,q,Y,x){return this.s(W,N,fe=>fe.provideDocumentHighlights(d.URI.revive(q),Y,x),void 0,x)}$provideMultiDocumentHighlights(W,q,Y,x,fe){return this.s(W,O,we=>we.provideMultiDocumentHighlights(d.URI.revive(q),Y,x.map(Me=>d.URI.revive(Me)),fe),void 0,fe)}registerLinkedEditingRangeProvider(W,q,Y){const x=this.t(new U(this.h,Y),W);return this.e.$registerLinkedEditingRangeProvider(x,this.o(q,W)),this.p(x)}$provideLinkedEditingRanges(W,q,Y,x){return this.s(W,U,async fe=>{const we=await fe.provideLinkedEditingRanges(d.URI.revive(q),Y,x);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ie.y(we.wordPattern):void 0}},void 0,x)}registerReferenceProvider(W,q,Y){const x=this.t(new j(this.h,Y),W);return this.e.$registerReferenceSupport(x,this.o(q,W)),this.p(x)}$provideReferences(W,q,Y,x,fe){return this.s(W,j,we=>we.provideReferences(d.URI.revive(q),Y,x,fe),void 0,fe)}registerCodeActionProvider(W,q,Y,x){const fe=new T.$Tc,we=this.t(new z(this.h,this.j.converter,this.k,Y,this.l,W,this.m),W);return this.e.$registerCodeActionSupport(we,this.o(q,W),{providedKinds:x?.providedCodeActionKinds?.map(Me=>Me.value),documentation:x?.documentation?.map(Me=>({kind:Me.kind.value,command:this.j.converter.toInternal(Me.command,fe)}))},Ie.u(W),Ie.w(W),!!Y.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(W,q,Y,x,fe){return this.s(W,z,we=>we.provideCodeActions(d.URI.revive(q),Y,x,fe),void 0,fe)}$resolveCodeAction(W,q,Y){return this.s(W,z,x=>x.resolveCodeAction(q,Y),{},void 0)}$releaseCodeActions(W,q){this.s(W,z,Y=>Promise.resolve(Y.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(W,q,Y){const x=this.t(new F(this.h,Y),W);return this.e.$registerDocumentFormattingSupport(x,this.o(q,W),W.identifier,W.displayName||W.name),this.p(x)}$provideDocumentFormattingEdits(W,q,Y,x){return this.s(W,F,fe=>fe.provideDocumentFormattingEdits(d.URI.revive(q),Y,x),void 0,x)}registerDocumentRangeFormattingEditProvider(W,q,Y){const x=typeof Y.provideDocumentRangesFormattingEdits=="function",fe=this.t(new J(this.h,Y),W);return this.e.$registerRangeFormattingSupport(fe,this.o(q,W),W.identifier,W.displayName||W.name,x),this.p(fe)}$provideDocumentRangeFormattingEdits(W,q,Y,x,fe){return this.s(W,J,we=>we.provideDocumentRangeFormattingEdits(d.URI.revive(q),Y,x,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(W,q,Y,x,fe){return this.s(W,J,we=>we.provideDocumentRangesFormattingEdits(d.URI.revive(q),Y,x,fe),void 0,fe)}registerOnTypeFormattingEditProvider(W,q,Y,x){const fe=this.t(new ee(this.h,Y),W);return this.e.$registerOnTypeFormattingSupport(fe,this.o(q,W),x,W.identifier),this.p(fe)}$provideOnTypeFormattingEdits(W,q,Y,x,fe,we){return this.s(W,ee,Me=>Me.provideOnTypeFormattingEdits(d.URI.revive(q),Y,x,fe,we),void 0,we)}registerWorkspaceSymbolProvider(W,q){const Y=this.t(new V(q,this.l),W);return this.e.$registerNavigateTypeSupport(Y,typeof q.resolveWorkspaceSymbol=="function"),this.p(Y)}$provideWorkspaceSymbols(W,q,Y){return this.s(W,V,x=>x.provideWorkspaceSymbols(q,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(W,q,Y){return this.s(W,V,x=>x.resolveWorkspaceSymbol(q,Y),void 0,void 0)}$releaseWorkspaceSymbols(W,q){this.s(W,V,Y=>Y.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(W,q,Y){const x=this.t(new H(this.h,Y,this.l),W);return this.e.$registerRenameSupport(x,this.o(q,W),H.supportsResolving(Y)),this.p(x)}$provideRenameEdits(W,q,Y,x,fe){return this.s(W,H,we=>we.provideRenameEdits(d.URI.revive(q),Y,x,fe),void 0,fe)}$resolveRenameLocation(W,q,Y,x){return this.s(W,H,fe=>fe.resolveRenameLocation(d.URI.revive(q),Y,x),void 0,x)}registerNewSymbolNamesProvider(W,q,Y){const x=this.t(new _(this.h,Y,this.l),W);return this.e.$registerNewSymbolNamesProvider(x,this.o(q,W)),this.p(x)}$supportsAutomaticNewSymbolNamesTriggerKind(W){return this.s(W,_,q=>q.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(W,q,Y,x,fe){return this.s(W,_,we=>we.provideNewSymbolNames(d.URI.revive(q),Y,x,fe),void 0,fe)}registerDocumentSemanticTokensProvider(W,q,Y,x){const fe=this.t(new he(this.h,Y),W),we=typeof Y.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(q,W),x,we);let Me=this.p(fe);if(we){const qe=Y.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(we));Me=s.$wM.from(Me,qe)}return Me}$provideDocumentSemanticTokens(W,q,Y,x){return this.s(W,he,fe=>fe.provideDocumentSemanticTokens(d.URI.revive(q),Y,x),null,x)}$releaseDocumentSemanticTokens(W,q){this.s(W,he,Y=>Y.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,q,Y,x){const fe=this.t(new re(this.h,Y),W);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(q,W),x),this.p(fe)}$provideDocumentRangeSemanticTokens(W,q,Y,x){return this.s(W,re,fe=>fe.provideDocumentRangeSemanticTokens(d.URI.revive(q),Y,x),null,x)}registerCompletionItemProvider(W,q,Y,x){const fe=this.t(new ve(this.h,this.j.converter,Y,this.m,W),W);return this.e.$registerCompletionsProvider(fe,this.o(q,W),x,ve.supportsResolving(Y),W.identifier),this.p(fe)}$provideCompletionItems(W,q,Y,x,fe){return this.s(W,ve,we=>we.provideCompletionItems(d.URI.revive(q),Y,x,fe),void 0,fe)}$resolveCompletionItem(W,q,Y){return this.s(W,ve,x=>x.resolveCompletionItem(q,Y),void 0,Y)}$releaseCompletionItems(W,q){this.s(W,ve,Y=>Y.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(W,q,Y,x){const fe=new Q(W,this.h,Y,this.j.converter),we=this.t(fe,W);return this.e.$registerInlineCompletionsSupport(we,this.o(q,W),fe.supportsHandleEvents,g.$Wm.toKey(W.identifier.value),x?.yieldTo?.map(Me=>g.$Wm.toKey(Me))||[]),this.p(we)}$provideInlineCompletions(W,q,Y,x,fe){return this.s(W,pe,we=>we.provideInlineCompletions(d.URI.revive(q),Y,x,fe),void 0,fe)}$handleInlineCompletionDidShow(W,q,Y,x){this.s(W,pe,async fe=>{fe.handleDidShowCompletionItem(q,Y,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,q,Y,x,fe){this.s(W,pe,async we=>{we.handlePartialAccept(q,Y,x,fe)},void 0,void 0)}$freeInlineCompletionsList(W,q){this.s(W,pe,async Y=>{Y.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(W,q,Y){const x=new B(W,this.h,Y,this.j.converter),fe=this.t(x,W);return this.e.$registerInlineEditProvider(fe,this.o(q,W),W.identifier),this.p(fe)}$provideInlineEdit(W,q,Y,x){return this.s(W,B,fe=>fe.provideInlineEdits(d.URI.revive(q),Y,x),void 0,x)}$freeInlineEdit(W,q){this.s(W,B,async Y=>{Y.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(W,q,Y,x){const fe=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,we=this.t(new ae(this.h,Y),W);return this.e.$registerSignatureHelpProvider(we,this.o(q,W),fe),this.p(we)}$provideSignatureHelp(W,q,Y,x,fe){return this.s(W,ae,we=>we.provideSignatureHelp(d.URI.revive(q),Y,x,fe),void 0,fe)}$releaseSignatureHelp(W,q){this.s(W,ae,Y=>Y.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(W,q,Y){const x=typeof Y.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new ie(this.h,this.j.converter,Y,this.l,W),W);this.e.$registerInlayHintsProvider(fe,this.o(q,W),typeof Y.resolveInlayHint=="function",x,Ie.u(W));let we=this.p(fe);if(x!==void 0){const Me=Y.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(x));we=s.$wM.from(we,Me)}return we}$provideInlayHints(W,q,Y,x){return this.s(W,ie,fe=>fe.provideInlayHints(d.URI.revive(q),Y,x),void 0,x)}$resolveInlayHint(W,q,Y){return this.s(W,ie,x=>x.resolveInlayHint(q,Y),void 0,Y)}$releaseInlayHints(W,q){this.s(W,ie,Y=>Y.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(W,q,Y){const x=this.t(new ce(this.h,Y),W);return this.e.$registerDocumentLinkProvider(x,this.o(q,W),typeof Y.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(W,q,Y){return this.s(W,ce,x=>x.provideLinks(d.URI.revive(q),Y),void 0,Y,q.scheme==="output")}$resolveDocumentLink(W,q,Y){return this.s(W,ce,x=>x.resolveLink(q,Y),void 0,void 0,!0)}$releaseDocumentLinks(W,q){this.s(W,ce,Y=>Y.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(W,q,Y){const x=this.t(new ue(this.h,Y),W);return this.e.$registerDocumentColorProvider(x,this.o(q,W)),this.p(x)}$provideDocumentColors(W,q,Y){return this.s(W,ue,x=>x.provideColors(d.URI.revive(q),Y),[],Y)}$provideColorPresentations(W,q,Y,x){return this.s(W,ue,fe=>fe.provideColorPresentations(d.URI.revive(q),Y,x),void 0,x)}registerFoldingRangeProvider(W,q,Y){const x=this.q(),fe=typeof Y.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new De(new Z(this.h,Y),W)),this.e.$registerFoldingRangeProvider(x,this.o(q,W),W.identifier,fe);let we=this.p(x);if(fe!==void 0){const Me=Y.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=s.$wM.from(we,Me)}return we}$provideFoldingRanges(W,q,Y,x){return this.s(W,Z,fe=>fe.provideFoldingRanges(d.URI.revive(q),Y,x),void 0,x)}registerSelectionRangeProvider(W,q,Y){const x=this.t(new oe(this.h,Y,this.l),W);return this.e.$registerSelectionRangeProvider(x,this.o(q,W)),this.p(x)}$provideSelectionRanges(W,q,Y,x){return this.s(W,oe,fe=>fe.provideSelectionRanges(d.URI.revive(q),Y,x),[],x)}registerCallHierarchyProvider(W,q,Y){const x=this.t(new $e(this.h,Y),W);return this.e.$registerCallHierarchyProvider(x,this.o(q,W)),this.p(x)}$prepareCallHierarchy(W,q,Y,x){return this.s(W,$e,fe=>Promise.resolve(fe.prepareSession(d.URI.revive(q),Y,x)),void 0,x)}$provideCallHierarchyIncomingCalls(W,q,Y,x){return this.s(W,$e,fe=>fe.provideCallsTo(q,Y,x),void 0,x)}$provideCallHierarchyOutgoingCalls(W,q,Y,x){return this.s(W,$e,fe=>fe.provideCallsFrom(q,Y,x),void 0,x)}$releaseCallHierarchy(W,q){this.s(W,$e,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(W,q,Y){const x=this.t(new be(this.h,Y),W);return this.e.$registerTypeHierarchyProvider(x,this.o(q,W)),this.p(x)}$prepareTypeHierarchy(W,q,Y,x){return this.s(W,be,fe=>Promise.resolve(fe.prepareSession(d.URI.revive(q),Y,x)),void 0,x)}$provideTypeHierarchySupertypes(W,q,Y,x){return this.s(W,be,fe=>fe.provideSupertypes(q,Y,x),void 0,x)}$provideTypeHierarchySubtypes(W,q,Y,x){return this.s(W,be,fe=>fe.provideSubtypes(q,Y,x),void 0,x)}$releaseTypeHierarchy(W,q){this.s(W,be,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(W,q,Y,x){const fe=this.q();return this.f.set(fe,new De(new Ne(this.e,this.h,Y,fe,W),W)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(q,W),(0,i.$TG)(W,"documentPaste")&&x?{supportsResolve:!!Y.resolveDocumentDropEdit,dropMimeTypes:x.dropMimeTypes}:void 0),this.p(fe)}$provideDocumentOnDropEdits(W,q,Y,x,fe,we){return this.s(W,Ne,Me=>Promise.resolve(Me.provideDocumentOnDropEdits(q,d.URI.revive(Y),x,fe,we)),void 0,void 0)}$resolveDropEdit(W,q,Y){return this.s(W,Ne,x=>x.resolveDropEdit(q,Y),{},void 0)}$releaseDropEdits(W,q){this.s(W,Ne,Y=>Promise.resolve(Y.releaseDropEdits(q)),void 0,void 0)}registerMappedEditsProvider(W,q,Y){const x=this.t(new Be(this.h,Y),W);return this.e.$registerMappedEditsProvider(x,this.o(q,W)),this.p(x)}$provideMappedEdits(W,q,Y,x,fe){return this.s(W,Be,we=>Promise.resolve(we.provideMappedEdits(q,Y,x,fe)),null,fe)}registerDocumentPasteEditProvider(W,q,Y,x){const fe=this.q();return this.f.set(fe,new De(new M(this.e,this.h,Y,fe,W),W)),this.e.$registerPasteEditProvider(fe,this.o(q,W),{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,supportsResolve:!!Y.resolveDocumentPasteEdit,providedPasteEditKinds:x.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(W,q,Y,x,fe){return this.s(W,M,we=>we.prepareDocumentPaste(d.URI.revive(q),Y,x,fe),void 0,fe)}$providePasteEdits(W,q,Y,x,fe,we,Me){return this.s(W,M,qe=>qe.providePasteEdits(q,d.URI.revive(Y),x,fe,we,Me),void 0,Me)}$resolvePasteEdit(W,q,Y){return this.s(W,M,x=>x.resolvePasteEdit(q,Y),{},void 0)}$releasePasteEdits(W,q){this.s(W,M,Y=>Promise.resolve(Y.releasePasteEdits(q)),void 0,void 0)}static y(W){return{pattern:W.source,flags:W.flags}}static z(W){return{decreaseIndentPattern:Ie.y(W.decreaseIndentPattern),increaseIndentPattern:Ie.y(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Ie.y(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Ie.y(W.unIndentedLinePattern):void 0}}static B(W){return{beforeText:Ie.y(W.beforeText),afterText:W.afterText?Ie.y(W.afterText):void 0,previousLineText:W.previousLineText?Ie.y(W.previousLineText):void 0,action:W.action}}static C(W){return W.map(Ie.B)}static D(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(q=>s.SyntaxTokenType.toString(q)):void 0}}static E(W){return W.map(Ie.D)}setLanguageConfiguration(W,q,Y){const{wordPattern:x}=Y;if(x&&(0,C.$nf)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(q,x):this.h.setWordDefinitionFor(q,void 0),Y.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),Y.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const fe=this.q(),we={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?Ie.y(Y.wordPattern):void 0,indentationRules:Y.indentationRules?Ie.z(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?Ie.C(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport,autoClosingPairs:Y.autoClosingPairs?Ie.E(Y.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,q,we),this.p(fe)}$setWordDefinitions(W){for(const q of W)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$Smc=Ie}),define(ye[128],Se([1,0,9,21,14,4,40,3,235,24,5,12,90,6,127,20,17,10,154,26]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=e.$znc=void 0,e.$znc=(0,C.$Ai)("IExtHostLanguageModels");class i{constructor(o,$){this.option=o,this.stream=new r.$4h,this.stream=$??new r.$4h}}class t{constructor(){this.a=new Map,this.b=new r.$4h,this.c=!1,this.d=!1;const o=this;this.apiObject={text:o.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,o]of this.a)yield o.stream;else yield this.b}handleFragment(o){if(this.c)return;this.d=!0;let $=this.a.get(o.index);$||(this.a.size===0?$=new i(o.index,this.b):$=new i(o.index),this.a.set(o.index,$)),$.stream.emitOne(o.part)}get isStreaming(){return this.d}reject(o){this.c=!0;for(const $ of this.f())$.reject(o)}resolve(){this.c=!0;for(const o of this.f())o.resolve()}}let l=class{static{s=this}static{this.a=1}constructor(o,$,E){this.j=$,this.k=E,this.c=new R.$he,this.d=new R.$he,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new c.$Ym,this.i=new Map,this.r=new Set,this.b=o.getProxy(P.$uM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(o,$,E,k){const D=s.a++;this.f.set(D,{extension:o.identifier,provider:E,languageModelId:$});let v;k.auth&&(v={providerLabel:o.displayName||o.name,accountLabel:typeof k.auth=="object"?k.auth.label:void 0}),this.b.$registerLanguageModelProvider(D,`${c.$Wm.toKey(o.identifier)}/${D}/${$}`,{extension:o.identifier,id:$,vendor:k.vendor??c.$Wm.toKey(o.identifier),name:k.name??"",family:k.family??"",version:k.version,maxInputTokens:k.maxInputTokens,maxOutputTokens:k.maxOutputTokens,auth:v,targetExtensions:k.extensions});const I=E.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:y,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade($,new c.$Wm(w),y,N)});return(0,T.$Sc)(()=>{this.f.delete(D),this.b.$unregisterProvider(D),I?.dispose()})}async $provideLanguageModelResponse(o,$,E,k,D,v){const I=this.f.get(o);if(!I)return;const w=new d.$mw(async y=>{if(v.isCancellationRequested){this.j.warn(`[CHAT](${I.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk($,{index:y.index,part:y.part})});return I.provider.provideLanguageModelResponse(k.map(u.LanguageModelChatMessage.to),D,c.$Wm.toKey(E),w,v)}$provideTokenLength(o,$,E){const k=this.f.get(o);return k?Promise.resolve(k.provider.provideTokenCount($,E)):Promise.resolve(0)}$acceptChatModelMetadata(o){if(o.added)for(const{identifier:$,metadata:E}of o.added)this.g.set($,{metadata:E,apiObjects:new c.$Ym});if(o.removed)for(const $ of o.removed){this.g.delete($);for(const[E,k]of this.i)k.languageModelId===$&&(k.res.reject(new A.$5),this.i.delete(E))}o.added?.forEach($=>this.p($.metadata)),this.d.fire(void 0)}async selectLanguageModels(o,$){const E=await this.b.$selectChatModels({...$,extension:o.identifier}),k=[],D=this;for(const v of E){const I=this.g.get(v);if(!I)continue;this.o(o.identifier,I.metadata)&&await this.p(I.metadata);let w=I.apiObjects.get(o.identifier);w||(w={id:v,vendor:I.metadata.vendor,family:I.metadata.family,version:I.metadata.version,name:I.metadata.name,maxInputTokens:I.metadata.maxInputTokens,countTokens(y,N){if(!D.g.has(v))throw f.$LO.NotFound(v);return D.q(v,y,N??m.CancellationToken.None)},sendRequest(y,N,O){if(!D.g.has(v))throw f.$LO.NotFound(v);return D.l(o,v,y,N??{},O??m.CancellationToken.None)}},Object.freeze(w),I.apiObjects.set(o.identifier,w)),k.push(w)}return k}async l(o,$,E,k,D){const v=this.m(o,E),I=o.identifier,w=this.g.get($)?.metadata;if(!w||!this.g.has($))throw f.$LO.NotFound(`Language model '${$}' is unknown.`);if(this.o(I,w)&&(!await this.n(o,{identifier:w.extension,displayName:w.auth.providerLabel},k.justification,!1)||!this.h.get(I)?.has(w.extension)))throw f.$LO.NoPermissions(`Language model '${$}' cannot be used by '${I.value}'.`);const y=Math.random()*1e6|0,N=this.b.$fetchResponse(I,$,y,v,k.modelOptions??{},D),O=new r.$zh,U=new t;this.i.set(y,{languageModelId:$,res:U});let j;if(N.catch(z=>{O.isOpen()?U.reject(z):j=z}).finally(()=>{this.i.delete(y),U.resolve(),O.open()}),await O.wait(),j)throw j.name===f.$LO.name?j:new f.$LO(`Language model '${$}' errored, check cause for more details`,"Unknown",j);return U.apiObject}m(o,$){const E=[];for(const k of $)k.role===f.LanguageModelChatMessageRole.System&&(0,n.$UG)(o,"languageModelSystem"),E.push(u.LanguageModelChatMessage.from(k));return E}async $handleResponseFragment(o,$){const E=this.i.get(o);E&&E.res.handleFragment($)}async n(o,$,E,k){const D=g.$wL+$.identifier.value;if(await this.k.getSession(o,D,[],{silent:!0}))return this.$updateModelAccesslist([{from:o.identifier,to:$.identifier,enabled:!0}]),!0;if(k)return!1;try{const I=E?(0,p.localize)(0,null,$.displayName,E):void 0;return await this.k.getSession(o,D,[],{forceNewSession:{detail:I}}),this.$updateModelAccesslist([{from:o.identifier,to:$.identifier,enabled:!0}]),!0}catch{return!1}}o(o,$){return!!$.auth&&!c.$Wm.equals($.extension,o)}async p(o){if(o.auth)for(const $ of this.r)try{await this.n($,{identifier:o.extension,displayName:""},void 0,!0)}catch(E){this.j.error("Fake Auth request failed"),this.j.error(E)}}async q(o,$,E){if(!this.g.get(o))throw f.$LO.NotFound(`Language model '${o}' is unknown.`);const D=L.Iterable.find(this.f.values(),v=>v.languageModelId===o);return D?D.provider.provideTokenCount($,E):this.b.$countTokens(o,typeof $=="string"?$:u.LanguageModelChatMessage.from($),E)}$updateModelAccesslist(o){const $=new Array;for(const{from:E,to:k,enabled:D}of o){const v=this.h.get(E)??new c.$Xm;if(v.has(k)!==D){D?v.add(k):v.delete(k),this.h.set(E,v);const w={from:E,to:k};$.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation(o){this.r.add(o);const $=this,E=R.Event.signal(R.Event.filter(this.c.event,D=>c.$Wm.equals(D.from,o.identifier))),k=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(E,k)},canSendRequest(D){let v;e:for(const[w,y]of $.g)for(const N of y.apiObjects.values())if(N===D){v=y.metadata;break e}if(!v)return;if(!$.o(o.identifier,v))return!0;const I=$.h.get(o.identifier);if(I)return I.has(v.extension)}}}};e.$Anc=l,e.$Anc=l=s=Je([Ge(0,a.$YO),Ge(1,S.$7j),Ge(2,b.$Umc)],l)}),define(ye[355],Se([1,0,6,17,10,43,9,3,26]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$foc=void 0;class c{constructor(S,d,P,b){this.c=d,this.d=P,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(r.$uM.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,d){await this.a.$changeLanguage(S,d);const P=this.c.getDocumentData(S);if(!P)throw new Error(`document '${S.toString()}' NOT found`);return P.document}async tokenAtPosition(S,d){const P=S.version,b=m.Position.from(d),a=await this.a.$tokensAtPosition(S.uri,b),u={type:A.StandardTokenType.Other,range:S.getWordRangeAtPosition(d)??new A.$yM(d.line,d.character,d.line,d.character)};if(!a)return u;const f={range:m.Range.to(a.range),type:m.TokenType.to(a.type)};return!f.range.contains(d)||P!==S.version?u:f}createLanguageStatusItem(S,d,P){const b=this.f++,a=this.a,u=this.g,f=`${S.identifier.value}/${d}`;if(u.has(f))throw new Error(`LanguageStatusItem with id '${d}' ALREADY exists`);u.add(f);const g={selector:P,id:d,name:S.displayName??S.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const s=new T.$Tc,i=()=>{if(n?.dispose(),!u.has(f)){console.warn(`LanguageStatusItem (${d}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.$Ch)(()=>{s.clear(),this.a.$setLanguageStatus(b,{id:f,name:g.name??S.displayName??S.name,source:S.displayName??S.name,selector:m.DocumentSelector.from(g.selector,this.e),label:g.text,detail:g.detail??"",severity:g.severity===A.LanguageStatusSeverity.Error?R.default.Error:g.severity===A.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:g.command&&this.d.toInternal(g.command,s),accessibilityInfo:g.accessibilityInformation,busy:g.busy})},0)},t={dispose(){s.dispose(),n?.dispose(),a.$removeLanguageStatus(b),u.delete(f)},get id(){return g.id},get name(){return g.name},set name(l){g.name=l,i()},get selector(){return g.selector},set selector(l){g.selector=l,i()},get text(){return g.text},set text(l){g.text=l,i()},set text2(l){(0,p.$UG)(S,"languageStatusText"),g.text=l,i()},get text2(){return(0,p.$UG)(S,"languageStatusText"),g.text},get detail(){return g.detail},set detail(l){g.detail=l,i()},get severity(){return g.severity},set severity(l){g.severity=l,i()},get accessibilityInformation(){return g.accessibilityInformation},set accessibilityInformation(l){g.accessibilityInformation=l,i()},get command(){return g.command},set command(l){g.command=l,i()},get busy(){return g.busy},set busy(l){g.busy=l,i()}};return i(),t}}e.$foc=c}),define(ye[356],Se([1,0,15,2,17,10,126]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=e.$4nc=void 0;class T{constructor(S,d,P,b){this.start=S,this.deletedCount=d,this.deletedItems=P,this.items=b}asApiEvent(){return{range:new R.$YN(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,d,P){this.notebook=S,this.h=d,this.j=P,this.handle=P.handle,this.uri=m.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(A.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,d=this.h.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:d.document,get mime(){return S.g},set mime(b){S.g=b},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(P)}return this.f}setOutputs(S){this.a=S.map(A.NotebookCellOutput.to)}setOutputItems(S,d,P){const b=P.map(A.NotebookCellOutputItem.to),a=this.a.find(u=>u.id===S);if(a&&(d||(a.items.length=0),a.items.push(...b),a.items.length>1&&a.items.every(u=>L.$qK(u.mime)))){const u=new Map,f=[];a.items.forEach(g=>{let n;u.has(g.mime)?n=u.get(g.mime):(n=[],u.set(g.mime,n),f.push(g.mime)),n.push(g.data)}),a.items.length=0,f.forEach(g=>{const n=L.$rK(u.get(g));a.items.push({mime:g,data:n.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$4nc=p;class c{static{this.a=0}constructor(S,d,P,b,a){this.k=S,this.l=d,this.m=P,this.uri=b,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,d={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===r.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(P){return P=S.n(P),S.b[P].apiCell},getCells(P){return(P?S.p(P):S.b).map(a=>a.apiCell)},save(){return S.q()}};this.e=Object.freeze(d)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,d,P){this.g=S.versionId,this.h=d,this.acceptDocumentPropertiesChanged({metadata:P});const b={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},a=[];for(const f of S.rawEvents)f.kind===L.NotebookCellsChangeType.ModelChange?this.r(f.changes,!1,b.contentChanges):f.kind===L.NotebookCellsChangeType.Move?this.s(f.index,f.length,f.newIdx,b.contentChanges):f.kind===L.NotebookCellsChangeType.Output?(this.t(f.index,f.outputs),a.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===L.NotebookCellsChangeType.OutputItem?(this.u(f.index,f.outputId,f.append,f.outputItems),a.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(f.index,f.language),a.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document})):f.kind===L.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document}):f.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(f.index,f.mime):f.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(f.index,f.metadata),a.push({cell:this.b[f.index].apiCell,metadata:this.b[f.index].apiCell.metadata})):f.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(f.index,f.internalMetadata),a.push({cell:this.b[f.index].apiCell,executionSummary:this.b[f.index].apiCell.executionSummary}));const u=new Map;for(let f=0;f<a.length;f++){const g=a[f],n=u.get(g.cell);if(n===void 0){const s=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});u.set(g.cell,s-1)}else b.cellChanges[n]={...b.cellChanges[n],...g}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let d=S.start|0,P=S.end|0;return d<0&&(d=0),P>this.b.length&&(P=this.b.length),S.with({start:d,end:P})}p(S){S=this.o(S);const d=[];for(let P=S.start;P<S.end;P++)d.push(this.b[P]);return d}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,d,P){if(this.j)return;const b=[],a=[],u=[];if(S.reverse().forEach(f=>{const n=f[2].map(t=>{const l=new p(this,this.l,t);return d||a.push(p.asModelAddData(t)),l}),s=new T(f[0],f[1],[],n),i=this.b.splice(f[0],f[1],...n);for(const t of i)u.push(t.uri),s.deletedItems.push(t.apiCell);b.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:u}),P)for(const f of b)P.push(f.asApiEvent())}s(S,d,P,b){const a=this.b.splice(S,d);this.b.splice(P,0,...a);const u=[new T(S,d,a.map(f=>f.apiCell),[]),new T(P,0,[],a)];for(const f of u)b.push(f.asApiEvent())}t(S,d){this.b[S].setOutputs(d)}u(S,d,P,b){this.b[S].setOutputItems(d,P,b)}v(S,d){const P=this.b[S];P.apiCell.document.languageId!==d&&this.m.$acceptModelLanguageChanged(P.uri,d)}w(S,d){const P=this.b[S];P.apiCell.mime=d}x(S,d){this.b[S].setMetadata(d)}y(S,d){this.b[S].setInternalMetadata(d)}getCellFromApiCell(S){return this.b.find(d=>d.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(d=>d.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$5nc=c}),define(ye[357],Se([1,0,4,2,17,10,52]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;class T{constructor(c,C,S,d={timeout:1500,errors:3}){this.b=c,this.c=C,this.d=S,this.f=d,this.a=new r.$je}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(C,S,d)=>{const P=function(a){C.call(S,a)};return P.extension=c,this.a.event(P,void 0,d)}}async $participateInSave(c,C,S){const d=m.URI.revive(c),P=this.c.getNotebookDocument(d);if(!P)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:A.TextDocumentSaveReason.to(C)},S,async(u,f)=>{const g=Date.now(),n=await await Promise.resolve(u);Date.now()-g>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!S.isCancellationRequested&&n&&(n instanceof R.$GM?b.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(b.length===0)return!0;const a={edits:[]};for(const u of b){const{edits:f}=A.WorkspaceEdit.from(u);a.edits=a.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(new L.$Kw(a))}}e.$hoc=T}),define(ye[163],Se([1,0,14,17,10]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,p,c,C,S,d){this.id=T,this.f=p,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=C,this.c=d}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(p){this.selections=[p]},get selections(){return T.a},set selections(p){if(!Array.isArray(p)||!p.every(A.$YN.isNotebookRange))throw(0,r.$7)("selections");T.a=p,T.g(p)},get visibleRanges(){return T.b},revealRange(p,c){T.f.$tryRevealRange(T.id,m.NotebookRange.from(p),c??A.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(m.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$6nc=R}),define(ye[358],Se([1,0,4,12,17]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$joc=void 0;let R=class{constructor(T,p){this.c=T,this.d=p,this.a=new r.$he,this.b=new r.$he,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,p);const c=this.d.getEditorById(T);p.visibleRanges&&c._acceptVisibleRanges(p.visibleRanges.ranges.map(A.NotebookRange.to)),p.selections&&c._acceptSelections(p.selections.selections.map(A.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const p in T)this.d.getEditorById(p)._acceptViewColumn(A.ViewColumn.to(T[p]))}};e.$joc=R,e.$joc=R=Je([Ge(0,m.$7j)],R)}),define(ye[359],Se([1,0,4,6,163]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=void 0;class R{constructor(T,p){this.c=p,this.a=new Map,this.b=T.getProxy(m.$uM.MainThreadNotebookRenderers)}$postRendererMessage(T,p,c){const C=this.c.getEditorById(T);this.a.get(p)?.fire({editor:C.apiEditor,message:c})}createRendererMessaging(T,p){if(!T.contributes?.notebookRenderer?.some(C=>C.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(C,S,d)=>this.d(p).event(C,S,d),postMessage:(C,S)=>{A.$6nc.apiEditorsToExtHost.has(C)&&([C,S]=[S,C]);const d=S&&A.$6nc.apiEditorsToExtHost.get(S);return this.b.$postMessage(d?.id,p,C)}}}d(T){let p=this.a.get(T);return p||(p=new r.$he({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(T)}}),this.a.set(T,p),p)}}e.$moc=R}),define(ye[360],Se([1,0,17,90,21,60,14]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0;class T{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,d,P){const b=this.b++,{title:a,location:u,cancellable:f}=d,g={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(b,{location:r.ProgressLocation.from(u),title:a,source:g,cancellable:f},S.isUnderDevelopment?void 0:S.identifier.value).catch(L.$2),this.d(b,P,!!f)}d(S,d,P){let b;P&&(b=new A.$se,this.c.set(S,b));const a=f=>{this.a.$progressEnd(f),this.c.delete(f),b?.dispose()};let u;try{u=d(new c(this.a,S),P&&b?b.token:A.CancellationToken.None)}catch(f){throw a(S),f}return u.then(f=>a(S),f=>a(S)),u}$acceptProgressCanceled(S){const d=this.c.get(S);d&&(d.cancel(),this.c.delete(S))}}e.$qoc=T;function p(C,S){return C.message=S.message,typeof S.increment=="number"&&(typeof C.increment=="number"?C.increment+=S.increment:C.increment=S.increment),C}class c extends m.$mw{constructor(S,d){super(P=>this.throttledReport(P)),this.c=S,this.d=d}throttledReport(S){this.c.$progressReport(this.d,S)}}Je([(0,R.$7h)(100,(C,S)=>p(C,S),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(ye[361],Se([1,0,2,6,9,17]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0;class L{static{this.a=0}constructor(p,c){this.d=c,this.c=new Map,this.b=p.getProxy(m.$uM.MainThreadQuickDiff)}$provideOriginalResource(p,c,C){const S=r.URI.revive(c),d=this.c.get(p);return d?(0,A.$sh)(()=>d.provideOriginalResource(S,C)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider(p,c,C,S){const d=L.a++;return this.c.set(d,c),this.b.$registerQuickDiffProvider(d,R.DocumentSelector.from(p,this.d),C,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(d),this.c.delete(d)}}}}e.$roc=L}),define(ye[362],Se([1,0,21,4,3,6,2,10,14,19,43,50,26,17]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=b;function b(a,u,f){const g=a.getProxy(R.$uM.MainThreadQuickOpen);class n{constructor(k,D){this.e=new Map,this.f=0,this.a=k,this.b=D}showQuickPick(k,D,v,I=r.CancellationToken.None){this.c=void 0;const w=Promise.resolve(D),y=++this.f,N=g.$show(y,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},I),O={},U=N.then(()=>O);return Promise.race([U,w]).then(j=>{if(j===O)return;const z=(0,d.$TG)(k,"quickPickItemTooltip");return w.then(M=>{const F=[];for(let J=0;J<M.length;J++){const ee=M[J];if(typeof ee=="string")F.push({label:ee,handle:J});else if(ee.kind===T.QuickPickItemKind.Separator)F.push({type:"separator",label:ee.label});else{ee.tooltip&&!z&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const V=ee.iconPath?h(ee.iconPath):void 0;F.push({label:ee.label,iconPath:V?.iconPath,iconClass:V?.iconClass,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:z?P.MarkdownString.fromStrict(ee.tooltip):void 0,handle:J})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=J=>{v.onDidSelectItem(M[J])}),g.$setItems(y,F),N.then(J=>{if(typeof J=="number")return M[J];if(Array.isArray(J))return J.map(ee=>M[ee])})})}).then(void 0,j=>{if(!(0,p.$4)(j))return g.$setError(y,j),Promise.reject(j)})}$onItemSelected(k){this.c?.(k)}showInput(k,D=r.CancellationToken.None){return this.d=k?.validateInput,g.$input(k,typeof this.d=="function",D).then(void 0,v=>{if(!(0,p.$4)(v))return Promise.reject(v)})}async $validateInput(k){if(!this.d)return;const D=await this.d(k);if(!D||typeof D=="string")return D;let v;switch(D.severity){case T.InputBoxValidationSeverity.Info:v=C.default.Info;break;case T.InputBoxValidationSeverity.Warning:v=C.default.Warning;break;case T.InputBoxValidationSeverity.Error:v=C.default.Error;break;default:v=D.message?C.default.Error:C.default.Ignore;break}return{content:D.message,severity:v}}async showWorkspaceFolderPick(k,D=r.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!v)return;const I=await this.a.getWorkspaceFolders2();if(I)return I.find(w=>w.uri.toString()===v.uri.toString())}createQuickPick(k){const D=new o(k,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(k){const D=new $(k,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(k,D){this.e.get(k)?._fireDidChangeValue(D)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,D){const v=this.e.get(k);v instanceof o&&v._fireDidChangeActive(D)}$onDidChangeSelection(k,D){const v=this.e.get(k);v instanceof o&&v._fireDidChangeSelection(D)}$onDidTriggerButton(k,D){this.e.get(k)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(k,D,v){const I=this.e.get(k);I instanceof o&&I._fireDidTriggerItemButton(D,v)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class s{static{this.a=1}constructor(k,D){this.x=k,this.y=D,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new m.$he,this.q=new m.$he,this.r=new m.$he,this.s=new m.$he,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((D,v)=>{const I=D===T.$VN.Back?-1:v;this.o.set(I,D)}),this.z({buttons:k.map((D,v)=>({...h(D.iconPath),tooltip:D.tooltip,handle:D===T.$VN.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const D=this.o.get(k);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),g.$dispose(this._id))}z(k){if(!this.v){for(const D of Object.keys(k)){const v=k[D];this.u[D]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){g.$createOrUpdate(this.u),this.u={id:this._id}}}function i(E){if(E instanceof T.$tN)return{id:E.id};const k=l(E),D=t(E);return{dark:typeof k=="string"?L.URI.file(k):k,light:typeof D=="string"?L.URI.file(D):D}}function t(E){return typeof E=="object"&&"light"in E?E.light:E}function l(E){return typeof E=="object"&&"dark"in E?E.dark:E}function h(E){const k=i(E);let D,v;return"id"in k?v=S.ThemeIcon.asClassName(k):D=k,{iconPath:D,iconClass:v}}class o extends s{constructor(k,D){super(k.identifier,D),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new m.$he,this.L=[],this.M=new m.$he,this.N=new m.$he,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((I,w)=>{this.C.set(w,I),this.D.set(I,w)});const D=(0,d.$TG)(this.O,"quickPickItemTooltip"),v=[];for(let I=0;I<k.length;I++){const w=k[I];if(w.kind===T.QuickPickItemKind.Separator)v.push({type:"separator",label:w.label});else{w.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const y=w.iconPath?h(w.iconPath):void 0;v.push({handle:I,label:w.label,iconPath:y?.iconPath,iconClass:y?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:D?P.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((N,O)=>({...h(N.iconPath),tooltip:N.tooltip,handle:O}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(k){const D=(0,c.$Hb)(k.map(v=>this.C.get(v)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(k){const D=(0,c.$Hb)(k.map(v=>this.C.get(v)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(k,D){const v=this.C.get(k);if(!v||!v.buttons||!v.buttons.length)return;const I=v.buttons[D];I&&this.N.fire({button:I,item:v})}}class $ extends s{constructor(k,D){super(k.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:C.default.Error}):this.z({validationMessage:k.message,severity:k.severity??C.default.Error}):this.z({validationMessage:void 0,severity:C.default.Ignore})}}return new n(u,f)}}),define(ye[363],Se([1,0,2,4,60,3,9,6,19,139,12,24,41,50,17,26,15,11]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=e.$toc=void 0;function n(N){return N instanceof r.URI}function s(N,O){return N.scheme===u.Schemas.file&&O.scheme===u.Schemas.file&&f.$k?N.toString()===O.toString():N.toString().toLowerCase()===O.toString().toLowerCase()}function i(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||P.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function t(N){if(N.icon){if(r.URI.isUri(N.icon))return N.icon;if(P.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const O=N.icon;return{light:O.light,dark:O.dark}}}else return}function l(N,O){if(!N.iconPath&&!O.iconPath)return 0;if(N.iconPath){if(!O.iconPath)return 1}else return-1;const U=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,j=typeof O.iconPath=="string"?O.iconPath:r.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,c.$yr)(U,j)}function h(N,O){let U=0;if(N.strikeThrough!==O.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==O.faded)return N.faded?1:-1;if(N.tooltip!==O.tooltip)return(N.tooltip||"").localeCompare(O.tooltip||"");if(U=l(N,O),U!==0)return U;if(N.light&&O.light)U=l(N.light,O.light);else{if(N.light)return 1;if(O.light)return-1}if(U!==0)return U;if(N.dark&&O.dark)U=l(N.dark,O.dark);else{if(N.dark)return 1;if(O.dark)return-1}return U}function o(N,O){if(N.command!==O.command)return N.command<O.command?-1:1;if(N.title!==O.title)return N.title<O.title?-1:1;if(N.tooltip!==O.tooltip){if(N.tooltip!==void 0&&O.tooltip!==void 0)return N.tooltip<O.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(N.arguments===O.arguments)return 0;if(N.arguments)if(O.arguments){if(N.arguments.length!==O.arguments.length)return N.arguments.length-O.arguments.length}else return 1;else return-1;for(let U=0;U<N.arguments.length;U++){const j=N.arguments[U],z=O.arguments[U];if(j!==z&&!(n(j)&&n(z)&&s(j,z)))return j<z?-1:1}return 0}function $(N,O){let U=(0,c.$yr)(N.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(U!==0)return U;if(N.command&&O.command)U=o(N.command,O.command);else{if(N.command)return 1;if(O.command)return-1}if(U!==0)return U;if(N.decorations&&O.decorations)U=h(N.decorations,O.decorations);else{if(N.decorations)return 1;if(O.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)U=(0,c.$yr)(N.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)U=(0,c.$yr)(N.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return U}function E(N,O){for(let U=0;U<N.length;U++)if(N[U]!==O[U])return!1;return!0}function k(N,O){return N.command===O.command&&N.title===O.title&&N.tooltip===O.tooltip&&(N.arguments&&O.arguments?E(N.arguments,O.arguments):N.arguments===O.arguments)}function D(N,O){return(0,p.$ub)(N,O,k)}class v{#e;#t;get value(){return this.d}set value(O){O=O??"",this.l.queue(async()=>this.#e.$setInputBoxValue(this.m,O)),this.o(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.l.queue(async()=>this.#e.$setInputBoxPlaceholder(this.m,O)),this.f=O}get validateInput(){return(0,a.$UG)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,a.$UG)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.l.queue(async()=>this.#e.$setValidationProviderIsEnabled(this.m,!!O))}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.l.queue(async()=>this.#e.$setInputBoxEnablement(this.m,O)))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.l.queue(async()=>this.#e.$setInputBoxVisibility(this.m,O)))}get document(){return(0,a.$UG)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(O,U,j,z,M,F){this.k=O,this.l=z,this.m=M,this.n=F,this.d="",this.e=new m.$he,this.f="",this.h=!0,this.j=!0,this.#t=U,this.#e=j}showValidationMessage(O,U){(0,a.$UG)(this.k,"scmValidation"),this.l.queue(async()=>this.#e.$showValidationMessage(this.m,O,U))}$onInputBoxValueChange(O){this.o(O)}o(O){this.d=O,this.e.fire(O)}}e.$toc=v;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.v}get label(){return this.w}set label(O){this.w=O,this.t.queue(async()=>this.q.$updateGroupLabel(this.u,this.handle,O))}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.t.queue(async()=>this.q.$updateGroup(this.u,this.handle,this.features))}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,U,j,z,M,F,J,ee){this.q=O,this.s=U,this.t=j,this.u=z,this.v=M,this.w=F,this.multiDiffEditorEnableViewChanges=J,this.x=ee,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new m.$he,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new m.$he,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,U){const j=this.h.get(O);return j?(0,L.$sh)(()=>this.s.executeCommand(j.command,...j.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort($),j=(0,p.$Db)(this.o,O,$).map(F=>{const J=F.toInsert.map(ee=>{const V=this.e++;this.g.set(V,ee);const H=ee.resourceUri;let _;if(ee.command)if(ee.command.command==="vscode.open"||ee.command.command==="vscode.diff"||ee.command.command==="vscode.changes"){const Z=new R.$Tc;_=this.s.converter.toInternal(ee.command,Z),this.j.set(V,Z)}else this.h.set(V,ee.command);const ne=(0,a.$TG)(this.x,"scmMultiDiffEditor"),he=ne?ee.multiDiffEditorOriginalUri:void 0,re=ne?ee.multiFileDiffEditorModifiedUri:void 0,ve=i(ee.decorations),pe=ee.decorations&&i(ee.decorations.light)||ve,Q=ee.decorations&&i(ee.decorations.dark)||ve,B=[pe,Q],se=ee.decorations&&ee.decorations.tooltip||"",ae=ee.decorations&&!!ee.decorations.strikeThrough,ie=ee.decorations&&!!ee.decorations.faded,ce=ee.contextValue||"";return{rawResource:[V,H,B,se,ae,ie,ce,_,he,re],handle:V}});return{start:F.start,deleteCount:F.deleteCount,toInsert:J}}),z=j.map(({start:F,deleteCount:J,toInsert:ee})=>[F,J,ee.map(V=>V.rawResource)]),M=j.reverse();for(const{start:F,deleteCount:J,toInsert:ee}of M){const V=ee.map(_=>_.handle),H=this.n.splice(F,J,...V);for(const _ of H)this.g.delete(_),this.h.delete(_),this.j.get(_)?.dispose(),this.j.delete(_)}return this.o=O,z}dispose(){this.l=!0,this.m.fire()}}class w{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.g}get count(){return this.h}set count(O){this.h!==O&&(this.h=O,this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{count:O})))}get quickDiffProvider(){return this.j}set quickDiffProvider(O){this.j=O;let U;(0,a.$TG)(this.y,"quickDiffProvider")&&(U=O?.label),this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!O,quickDiffLabel:U}))}get historyProvider(){return(0,a.$UG)(this.y,"scmHistoryProvider"),this.k}set historyProvider(O){(0,a.$UG)(this.y,"scmHistoryProvider"),this.k=O,this.l.value=new R.$Tc,this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!O})),O&&this.l.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.m=O?.currentHistoryItemGroup,this.e.queue(async()=>this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m))}))}get commitTemplate(){return this.n}set commitTemplate(O){O!==this.n&&(this.n=O,this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{commitTemplate:O})))}get acceptInputCommand(){return this.p}set acceptInputCommand(O){this.o.value=new R.$Tc,this.p=O;const U=this.z.converter.toInternal(O,this.o.value);this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{acceptInputCommand:U}))}get actionButton(){return(0,a.$UG)(this.y,"scmActionButton"),this.s}set actionButton(O){(0,a.$UG)(this.y,"scmActionButton"),this.q.value=new R.$Tc,this.s=O;const U=O!==void 0?{command:this.z.converter.toInternal(O.command,this.q.value),secondaryCommands:O.secondaryCommands?.map(j=>j.map(z=>this.z.converter.toInternal(z,this.q.value))),description:O.description,enabled:O.enabled}:void 0;this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{actionButton:U??null}))}get statusBarCommands(){return this.u}set statusBarCommands(O){if(this.u&&O&&D(this.u,O))return;this.t.value=new R.$Tc,this.u=O;const U=(O||[]).map(j=>this.z.converter.toInternal(j,this.t.value));this.e.queue(async()=>this.#e.$updateSourceControl(this.x,{statusBarCommands:U}))}get selected(){return this.v}constructor(O,U,j,z,M,F,J){this.y=O,this.z=z,this.A=M,this.B=F,this.C=J,this.e=new L.$vh,this.f=new Map,this.h=void 0,this.j=void 0,this.l=new R.$Vc,this.n=void 0,this.o=new R.$Vc,this.p=void 0,this.q=new R.$Vc,this.t=new R.$Vc,this.u=void 0,this.v=!1,this.w=new m.$he,this.onDidChangeSelection=this.w.event,this.x=w.d++,this.D=new Map,this.E=new Set,this.#e=j;const ee=r.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${M}/scm${this.x}/input`,query:J?`rootUri=${encodeURIComponent(J.toString())}`:void 0});this.e.queue(()=>this.#e.$registerSourceControl(this.x,M,F,J,ee)),this.g=new v(O,U,this.#e,this.e,this.x,ee)}createResourceGroup(O,U,j){const z=(0,a.$TG)(this.y,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,M=new I(this.#e,this.z,this.e,this.x,O,U,z,this.y),F=m.Event.once(M.onDidDispose)(()=>this.D.delete(M));return this.D.set(M,F),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const O=[],U=[];for(const[j,z]of this.D){z.dispose();const M=j.onDidUpdateResourceStates(()=>{this.E.add(j),this.eventuallyUpdateResourceStates()});m.Event.once(j.onDidDispose)(()=>{this.E.delete(j),M.dispose(),this.f.delete(j.handle),this.e.queue(async()=>this.#e.$unregisterGroup(this.x,j.handle))}),O.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const F=j._takeResourceStateSnapshot();F.length>0&&U.push([j.handle,F]),this.f.set(j.handle,j)}this.e.queue(async()=>this.#e.$registerGroups(this.x,O,U)),this.D.clear()}eventuallyUpdateResourceStates(){const O=[];this.E.forEach(U=>{const j=U._takeResourceStateSnapshot();j.length!==0&&O.push([U.handle,j])}),O.length>0&&this.e.queue(async()=>this.#e.$spliceResourceStates(this.x,O)),this.E.clear()}getResourceGroup(O){return this.f.get(O)}setSelectionState(O){this.v=O,this.w.fire(O)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.f.forEach(O=>O.dispose()),this.e.queue(async()=>this.#e.$unregisterSourceControl(this.x))}}Je([(0,A.$6h)(100)],w.prototype,"eventuallyAddResourceGroups",null),Je([(0,A.$6h)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{g=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,U,j,z){this.l=U,this.m=j,this.n=z,this.g=new Map,this.h=new S.$Ym,this.j=new m.$he,this.e=O.getProxy(T.$uM.MainThreadSCM),this.f=O.getProxy(T.$uM.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===d.MarshalledId.ScmResource){const F=this.g.get(M.sourceControlHandle);if(!F)return M;const J=F.getResourceGroup(M.groupHandle);return J?J.getResourceState(M.handle):M}else if(M&&M.$mid===d.MarshalledId.ScmResourceGroup){const F=this.g.get(M.sourceControlHandle);return F?F.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===d.MarshalledId.ScmProvider){const F=this.g.get(M.handle);return F||M}return M}})}createSourceControl(O,U,j,z){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,U,j,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const M=g.d++,F=new w(O,this.m,this.e,this.l,U,j,z);this.g.set(M,F);const J=this.h.get(O.identifier)||[];return J.push(F),this.h.set(O.identifier,J),F}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const U=this.h.get(O.identifier),j=U&&U[U.length-1];return j&&j.inputBox}$provideOriginalResource(O,U,j){const z=r.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",O,z.toString());const M=this.g.get(O);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$sh)(()=>M.quickDiffProvider.provideOriginalResource(z,j)).then(F=>F||null)}$onInputBoxValueChange(O,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const j=this.g.get(O);return j&&j.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(O,U,j,z){this.n.trace("ExtHostSCM#$executeResourceCommand",O,U,j);const M=this.g.get(O);if(!M)return Promise.resolve(void 0);const F=M.getResourceGroup(U);return F?F.$executeResourceCommand(j,z):Promise.resolve(void 0)}$validateInput(O,U,j){this.n.trace("ExtHostSCM#$validateInput",O);const z=this.g.get(O);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,L.$sh)(()=>z.inputBox.validateInput(U,j)).then(M=>{if(!M)return Promise.resolve(void 0);const F=b.MarkdownString.fromStrict(M.message);return F?Promise.resolve([F,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,U,j,z){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,j,z)??void 0}async $provideHistoryItems(O,U,j,z){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(U,j,z))?.map(J=>({...J,icon:t(J)}))??void 0}async $provideHistoryItemSummary(O,U,j,z){const M=this.g.get(O)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const F=await M.provideHistoryItemSummary(U,j,z);return F?{...F,icon:t(F)}:void 0}async $provideHistoryItemChanges(O,U,j,z){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(U,j,z)??void 0}};e.$uoc=y,e.$uoc=y=g=Je([Ge(3,C.$7j)],y)}),define(ye[364],Se([1,0,6,17,2]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0;class R{static{this.a=0}constructor(T,p){this.d=p,this.c=new Map,this.b=T.getProxy(r.$uM.MainThreadShare)}async $provideShare(T,p,c){return await this.c.get(T)?.provideShare({selection:m.Range.to(p.selection),resourceUri:A.URI.revive(p.resourceUri)},c)??void 0}registerShareProvider(T,p){const c=R.a++;return this.c.set(c,p),this.b.$registerShareProvider(c,m.DocumentSelector.from(T,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$voc=R}),define(ye[365],Se([1,0,10,6,238,3,17,18]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=e.$xoc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$uN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$uN("statusBarItem.warningForeground")]])}#e;#t;constructor(d,P,b,a,u,f=r.StatusBarAlignment.Left,g){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=d,this.#t=P,u&&a){this.c=(0,r.$9M)(a.identifier,u);const n=b.get(this.c);n&&(f=n.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,g=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(p.a++);this.e=a,this.f=u,this.g=f,this.h=this.u(g)}u(d){if((0,T.$eg)(d))return d===Number.POSITIVE_INFINITY?Number.MAX_VALUE:d===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:d}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(d){this.k=d,this.v()}set name(d){this.m=d,this.v()}set tooltip(d){this.l=d,this.v()}set color(d){this.n=d,this.v()}set backgroundColor(d){d&&!p.b.has(d.id)&&(d=void 0),this.o=d,this.v()}set command(d){this.r?.fromApi!==d&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof d=="string"?this.r={fromApi:d,internal:this.#t.toInternal({title:"",command:d},this.p)}:d?this.r={fromApi:d,internal:this.#t.toInternal(d,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(d){this.t=d,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let d;this.e?this.f?d=`${this.e.identifier.value}.${this.f}`:d=this.e.identifier.value:d=this.f;let P;this.m?P=this.m:P=(0,A.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=p.b.get(this.o.id));const a=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,d,this.e?.identifier.value,P,this.k,a,this.r?.internal,b,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$xoc=p;class c{constructor(d){this.b=[],this.a=d.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(d){const P={message:d};return this.b.unshift(P),this.c(),new r.$wM(()=>{const b=this.b.indexOf(P);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class C{constructor(d,P){this.e=new Map,this.a=d.getProxy(m.$uM.MainThreadStatusBar),this.b=P,this.c=new c(this)}$acceptStaticEntries(d){for(const P of d)this.e.set(P.entryId,P)}createStatusBarEntry(d,P,b,a){return new p(this.a,this.b,this.e,d,P,b,a)}setStatusBarMessage(d,P){const b=this.c.setMessage(d);let a;return typeof P=="number"?a=setTimeout(()=>b.dispose(),P):typeof P<"u"&&P.then(()=>b.dispose(),()=>b.dispose()),new r.$wM(()=>{b.dispose(),clearTimeout(a)})}}e.$yoc=C}),define(ye[164],Se([1,0,31,153,73,120,74,17,2]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=e.$_O=e.$$O=void 0;const c=(n,s,i,t)=>{let l=s;return{enumerable:!0,configurable:!1,get(){return l},set(h){if(!i(l,h)){const o=l;l=h,n.listener?.(t(h,o))}}}},C=(n,s)=>n===s,S={range:(n,s)=>n===s?!0:!n||!s?!1:n.isEqual(s),label:C,description:C,sortText:C,busy:C,error:C,canResolveChildren:C,tags:(n,s)=>!(n.length!==s.length||n.some(i=>!s.find(t=>i.id===t.id)))},d=n=>s=>({op:R.TestItemEventOp.SetProp,update:n(s)}),P=(n,s)=>({range:(()=>{let i;const t=d(l=>({range:r.$ct.lift(T.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return i},set(l){n.listener?.({op:R.TestItemEventOp.DocumentSynced}),S.range(i,l)||(i=l,n.listener?.(t(l)))}}})(),label:c(n,s,S.label,d(i=>({label:i}))),description:c(n,void 0,S.description,d(i=>({description:i}))),sortText:c(n,void 0,S.sortText,d(i=>({sortText:i}))),canResolveChildren:c(n,!1,S.canResolveChildren,i=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:i})),busy:c(n,!1,S.busy,d(i=>({busy:i}))),error:c(n,void 0,S.error,d(i=>({error:T.MarkdownString.fromStrict(i)||null}))),tags:c(n,[],S.tags,(i,t)=>({op:R.TestItemEventOp.SetTags,new:i.map(T.TestTag.from),old:t.map(T.TestTag.from)}))}),b=n=>{const s=A.$gL.fromString(n.extId),i=new u(s.controllerId,s.localId,n.label,p.URI.revive(n.uri)||void 0);return i.range=T.Range.to(n.range||void 0),i.description=n.description||void 0,i.sortText=n.sortText||void 0,i.tags=n.tags.map(t=>T.TestTag.to({id:(0,L.$mL)(t).tagId})),i},a=n=>{let s;for(const i of n.tests){const t=b(i.item);(0,m.$UO)(t).parent=s,s=t}return s};e.$$O=a;class u{constructor(s,i,t,l){if(i.includes(A.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(i)} symbol`);const h=(0,m.$TO)(this,s);Object.defineProperties(this,{id:{value:i,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof f?void 0:h.parent}},children:{value:(0,R.$SO)(h,m.$UO,u),enumerable:!0,writable:!1},...P(h,t)})}}e.$_O=u;class f extends u{constructor(s,i){super(s,s,i,void 0),this._isRoot=!0}}e.$aP=f;class g extends R.$OO{constructor(s,i,t){super({controllerId:s,getDocumentVersion:l=>l&&t.getDocument(l)?.version,getApiFor:m.$UO,getChildren:l=>l.children,root:new f(s,i),toITestItem:T.TestItem.from})}}e.$bP=g}),define(ye[37],Se([1,0,18,10,17,25,6,19,12,57,31,54,2,3,5,20,164,22,52,51,42,92,95,32]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=void 0;let h=class{#e;#t;#i;constructor(v,I,w){this.b=new Map,this.c=new Map,this.#e=v.getProxy(L.$uM.MainThreadCommands),this.d=I,this.#i=w,this.#t=v.getProxy(L.$uM.MainThreadTelemetry),this.converter=new o(this,y=>{const N=this.c.get(y);return N?.result===E.Void?N:void 0},I),this.f=[{processArgument(y){return(0,c.$0h)(y)}},{processArgument(y){return(0,R.$$n)(y,function(N){if(C.$ct.isIRange(N))return A.Range.to(N);if(S.$bt.isIPosition(N))return A.Position.to(N);if(C.$ct.isIRange(N.range)&&d.URI.isUri(N.uri))return A.location.to(N);if(N instanceof f.$Je)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const I=this.registerCommand(!1,v.id,async(...w)=>{const y=v.args.map((O,U)=>{if(!O.validate(w[U]))throw new Error(`Invalid argument '${O.name}' when running '${v.id}', received: ${typeof w[U]=="object"?JSON.stringify(w[U],null,"	"):w[U]} `);return O.convert(w[U])}),N=await this.executeCommand(v.internalId,...y);return v.result.convert(N,w,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new m.$wM(()=>{I.dispose(),this.c.delete(v.id)})}registerCommand(v,I,w,y,N,O){if(this.d.trace("ExtHostCommands#registerCommand",I),!I.trim().length)throw new Error("invalid id");if(this.b.has(I))throw new Error(`command '${I}' already exists`);return this.b.set(I,{callback:w,thisArg:y,metadata:N,extension:O}),v&&this.#e.$registerCommand(I),new m.$wM(()=>{this.b.delete(I)&&v&&this.#e.$unregisterCommand(I)})}executeCommand(v,...I){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,I,!0)}async g(v,I,w){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,I,!1);{let y=!1;const N=(0,R.$$n)(I,function(O){if(O instanceof m.$xM)return A.Position.from(O);if(O instanceof m.$yM)return A.Range.from(O);if(O instanceof m.$IM)return A.location.from(O);if(m.$YN.isNotebookRange(O))return A.NotebookRange.from(O);if(O instanceof ArrayBuffer)return y=!0,f.$Je.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return y=!0,f.$Je.wrap(O);if(O instanceof f.$Je)return y=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(v,y?new g.$Kw(N):N,w);return(0,c.$0h)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(v,I,!1);throw O}}}async h(v,I,w){const y=this.b.get(v);if(!y)throw new Error("Unknown command");const{callback:N,thisArg:O,metadata:U}=y;if(U?.args)for(let z=0;z<U.args.length;z++)try{(0,r.$rg)(I[z],U.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${U.args[z].name}' - ${U.args[z].description}`)}const j=s.$be.create();try{return await N.apply(O,I)}catch(z){if(v===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...I);M&&(v=M.command)}if(this.d.error(z,v,y.extension?.identifier),!w)throw z;if(y.extension?.identifier){const M=this.#i.onExtensionError(y.extension.identifier,z);this.d.trace("forwarded error to extension?",M,y.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$lj)(z)),this.id=v,this.source=y.extension?.displayName??y.extension?.name}}}finally{this.j(y,v,j.elapsed())}}j(v,I,w){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new i.$np(I),duration:w})}$executeContributedCommand(v,...I){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const w=this.b.get(v);return w?(I=I.map(y=>this.f.reduce((N,O)=>O.processArgument(N,w.extension?.identifier),y)),this.h(v,I,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(I=>(v&&(I=I.filter(w=>w[0]!=="_")),I))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[I,w]of this.b){const{metadata:y}=w;y&&(v[I]=y)}return Promise.resolve(v)}};e.$hP=h,e.$hP=h=Je([Ge(0,a.$YO),Ge(1,p.$7j),Ge(2,t.$gP)],h),e.$iP=(0,b.$Ai)("IExtHostCommands");class o{constructor(v,I,w){this.d=v,this.f=I,this.g=w,this.delegatingCommandId=`__vsc${(0,l.$Wg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,I){if(!v)return;const w={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return w;const y=this.f(v.command);if(y)w.id=y.internalId,w.arguments=y.args.map((N,O)=>N.convert(v.arguments&&v.arguments[O]));else if((0,T.$Lb)(v.arguments)){const N=`${v.command} /${++this.c}`;this.b.set(N,v),I.add((0,P.$Sc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),w.$ident=N,w.id=this.delegatingCommandId,w.arguments=[N],this.g.trace("CommandsConverter#CREATE",v.command,N)}return w}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const I=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],I?I.command:"MISSING"),I?this.d.executeCommand(I.command,...I.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$jP=o;class ${static{this.Uri=new $("uri","Uri of a text document",v=>d.URI.isUri(v),v=>v)}static{this.Position=new $("position","A position in a text document",v=>m.$xM.isPosition(v),A.Position.from)}static{this.Range=new $("range","A range in a text document",v=>m.$yM.isRange(v),A.Range.from)}static{this.Selection=new $("selection","A selection in a text document",v=>m.$zM.isSelection(v),A.Selection.from)}static{this.Number=new $("number","",v=>typeof v=="number",v=>v)}static{this.String=new $("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=$.Arr($.String)}static Arr(v){return new $(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,I=>Array.isArray(I)&&I.every(w=>v.validate(w)),I=>I.map(w=>v.convert(w)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",v=>v instanceof m.$UM,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",v=>v instanceof m.$gO,A.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",v=>v instanceof u.$_O,A.TestItem.from)}constructor(v,I,w,y){this.name=v,this.description=I,this.validate=w,this.convert=y}optional(){return new $(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,I){return new $(v??this.name,I??this.description,this.validate,this.convert)}}e.$kP=$;class E{static{this.Void=new E("no result",v=>v)}constructor(v,I){this.description=v,this.convert=I}}e.$lP=E;class k{constructor(v,I,w,y,N){this.id=v,this.internalId=I,this.description=w,this.args=y,this.result=N}}e.$mP=k}),define(ye[366],Se([1,0,19,15,2,88,142,35,37,17,10]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0;const S=[new p.$mP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$kP.Uri,p.$kP.Position],new p.$lP("A promise that resolves to an array of DocumentHighlight-instances.",P(c.DocumentHighlight.to))),new p.$mP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$kP.Uri],new p.$lP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,u)=>{if((0,r.$Kb)(a))return;class f extends C.$PM{static to(n){const s=new f(n.name,c.SymbolKind.to(n.kind),n.containerName||"",new C.$IM(u[0],c.Range.to(n.range)));return s.detail=n.detail,s.range=s.location.range,s.selectionRange=c.Range.to(n.selectionRange),s.children=n.children?n.children.map(f.to):[],s}}return a.map(f.to)})),new p.$mP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$kP.Uri,new p.$kP("options","Formatting options",a=>!0,a=>a)],new p.$lP("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$mP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$kP.Uri,p.$kP.Range,new p.$kP("options","Formatting options",a=>!0,a=>a)],new p.$lP("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$mP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$kP.Uri,p.$kP.Position,new p.$kP("ch","Trigger character",a=>typeof a=="string",a=>a),new p.$kP("options","Formatting options",a=>!0,a=>a)],new p.$lP("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$mP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$kP.Uri,p.$kP.Position],new p.$lP("A promise that resolves to an array of Location or LocationLink instances.",b)),new p.$mP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$kP.Uri,p.$kP.Position],new p.$lP("A promise that resolves to an array of Location or LocationLink instances.",b)),new p.$mP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$kP.Uri,p.$kP.Position],new p.$lP("A promise that resolves to an array of Location or LocationLink instances.",b)),new p.$mP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$kP.Uri,p.$kP.Position],new p.$lP("A promise that resolves to an array of Location or LocationLink instances.",b)),new p.$mP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$kP.Uri,p.$kP.Position],new p.$lP("A promise that resolves to an array of Location-instances.",P(c.location.to))),new p.$mP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$kP.Uri,p.$kP.Position],new p.$lP("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new p.$mP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$kP.Uri,new p.$kP("position","A position in a text document",a=>Array.isArray(a)&&a.every(u=>C.$xM.isPosition(u)),a=>a.map(c.Position.from))],new p.$lP("A promise that resolves to an array of ranges.",a=>a.map(u=>{let f;for(const g of u.reverse())f=new C.$TM(c.Range.to(g),f);return f}))),new p.$mP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$kP.String.with("query","Search string")],new p.$lP("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(c.WorkspaceSymbol.to))),new p.$mP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$kP.Uri,p.$kP.Position],new p.$lP("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(c.CallHierarchyItem.to))),new p.$mP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$kP.CallHierarchyItem],new p.$lP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(c.CallHierarchyIncomingCall.to))),new p.$mP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$kP.CallHierarchyItem],new p.$lP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(c.CallHierarchyOutgoingCall.to))),new p.$mP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$kP.Uri,p.$kP.Position],new p.$lP("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:c.Range.to(a.range),placeholder:a.text}})),new p.$mP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$kP.Uri,p.$kP.Position,p.$kP.String.with("newName","The new symbol name")],new p.$lP("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return c.WorkspaceEdit.to(a)}})),new p.$mP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$kP.Uri,p.$kP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$lP("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(c.DocumentLink.to))),new p.$mP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$kP.Uri],new p.$lP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new C.$PN(a.tokenTypes,a.tokenModifiers)})),new p.$mP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$kP.Uri],new p.$lP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const u=(0,L.$6bb)(a);if(u.type==="full")return new C.$RN(u.data,void 0)})),new p.$mP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$kP.Uri,p.$kP.Range.optional()],new p.$lP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new C.$PN(a.tokenTypes,a.tokenModifiers)})),new p.$mP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$kP.Uri,p.$kP.Range],new p.$lP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const u=(0,L.$6bb)(a);if(u.type==="full")return new C.$RN(u.data,void 0)})),new p.$mP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$kP.Uri,p.$kP.Position,p.$kP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$kP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$lP("A promise that resolves to a CompletionList-instance.",(a,u,f)=>{if(!a)return new C.$6M([]);const g=a.suggestions.map(n=>c.CompletionItem.to(n,f));return new C.$6M(g,a.incomplete)})),new p.$mP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$kP.Uri,p.$kP.Position,p.$kP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$lP("A promise that resolves to SignatureHelp.",a=>{if(a)return c.SignatureHelp.to(a)})),new p.$mP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$kP.Uri,p.$kP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$lP("A promise that resolves to an array of CodeLens-instances.",(a,u,f)=>P(g=>new C.$XM(c.Range.to(g.range),g.command&&f.fromInternal(g.command)))(a))),new p.$mP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$kP.Uri,new p.$kP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>C.$yM.isRange(a),a=>C.$zM.isSelection(a)?c.Selection.from(a):c.Range.from(a)),p.$kP.String.with("kind","Code action kind to return code actions for").optional(),p.$kP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$lP("A promise that resolves to an array of Command-instances.",(a,u,f)=>P(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(g.command)}else{const n=new C.$RM(g.title,g.kind?new C.$SM(g.kind):void 0);return g.edit&&(n.edit=c.WorkspaceEdit.to(g.edit)),g.command&&(n.command=f.fromInternal(g.command)),n.isPreferred=g.isPreferred,n}})(a))),new p.$mP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$kP.Uri],new p.$lP("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(u=>new C.$_M(c.Range.to(u.range),c.Color.to(u.color))):[])),new p.$mP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$kP("color","The color to show and insert",a=>a instanceof C.$$M,c.Color.from),new p.$kP("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:c.Range.from(a.range)}))],new p.$lP("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(c.ColorPresentation.to):[])),new p.$mP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$kP.Uri,p.$kP.Range],new p.$lP("A promise that resolves to an array of Inlay objects",(a,u,f)=>a.map(c.InlayHint.to.bind(void 0,f)))),new p.$mP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$kP.Uri],new p.$lP("A promise that resolves to an array of FoldingRange objects",(a,u)=>{if(a)return a.map(c.FoldingRange.to)})),new p.$mP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$lP("A promise that resolves to an array of NotebookContentProvider static info objects.",P(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(u=>c.NotebookExclusiveDocumentPattern.to(u))})))),new p.$mP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$kP.Uri,p.$kP.Range,new p.$kP("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof C.$yM,a=>c.InlineValueContext.from(a))],new p.$lP("A promise that resolves to an array of InlineValue objects",a=>a.map(c.InlineValue.to))),new p.$mP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$kP("uriOrString","Uri-instance or string (only http/https)",a=>A.URI.isUri(a)||typeof a=="string"&&(0,m.$Kg)(a,m.Schemas.http,m.Schemas.https),a=>a),new p.$kP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional(),p.$kP.String.with("label","").optional()],p.$lP.Void),new p.$mP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$kP.Uri.with("resource","Resource to open"),p.$kP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$kP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[c.ViewColumn.from(a),void 0]:[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)])).optional()],p.$lP.Void),new p.$mP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$kP.Uri.with("left","Left-hand side resource of the diff editor"),p.$kP.Uri.with("right","Right-hand side resource of the diff editor"),p.$kP.String.with("title","Human readable title for the diff editor").optional(),new p.$kP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[c.ViewColumn.from(a.viewColumn),c.TextEditorOpenOptions.from(a)]).optional()],p.$lP.Void),new p.$mP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$kP.String.with("title","Human readable title for the changes editor"),new p.$kP("resourceList","List of resources to compare",a=>{for(const u of a){if(u.length!==3)return!1;const[f,g,n]=u;if(!A.URI.isUri(f)||!A.URI.isUri(g)&&g!==void 0&&g!==null||!A.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},a=>a)],p.$lP.Void),new p.$mP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$kP.Uri,p.$kP.Position],new p.$lP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new p.$mP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$kP.TypeHierarchyItem],new p.$lP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new p.$mP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$kP.TypeHierarchyItem],new p.$lP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(c.TypeHierarchyItem.to))),new p.$mP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$kP.TestItem],p.$lP.Void),new p.$mP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$kP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$lP.Void),new p.$mP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$kP.String.with("name","The context key name"),new p.$kP("value","The context key value",()=>!0,a=>a)],p.$lP.Void),new p.$mP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$kP.Uri,p.$kP.StringArray,new p.$kP("MappedEditsContext","Mapped Edits Context",a=>c.MappedEditsContext.is(a),a=>c.MappedEditsContext.from(a))],new p.$lP("A promise that resolves to a workspace edit or null",a=>a?c.WorkspaceEdit.to(a):null)),new p.$mP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$kP("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?c.Range.from(a.initialRange):void 0,initialSelection:C.$zM.isSelection(a.initialSelection)?c.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?c.Position.from(a.position):void 0}})],p.$lP.Void)];class d{static register(u){S.forEach(u.registerApiCommand,u),this.a(u)}static a(u){u.registerCommand(!1,"_validateWhenClauses",T.$zj)}}e.$Tmc=d;function P(a){return u=>{if(Array.isArray(u))return u.map(a)}}function b(a){if(!Array.isArray(a))return;const u=[];for(const f of a)R.$Lv(f)?u.push(c.DefinitionLink.to(f)):u.push(c.location.to(f));return u}}),define(ye[367],Se([1,0,2,37]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=void 0;class A{constructor(L,T,p,c,C){this.a=T,this.b=p,this.c=c;const S=new m.$mP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new m.$kP("showOptions","Show Options",d=>!0,d=>d),new m.$kP("resource","Interactive resource Uri",d=>!0,d=>d),new m.$kP("controllerId","Notebook controller Id",d=>!0,d=>d),new m.$kP("title","Interactive editor title",d=>!0,d=>d)],new m.$lP("Notebook and input URI",d=>{if(C.debug("[ExtHostInteractive] open iw with notebook editor id",d.notebookEditorId),d.notebookEditorId!==void 0){const P=this.a.getEditorById(d.notebookEditorId);return C.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:r.URI.revive(d.notebookUri),inputUri:r.URI.revive(d.inputUri),notebookEditor:P.apiEditor}}return C.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",d.notebookUri,d.inputUri),{notebookUri:r.URI.revive(d.notebookUri),inputUri:r.URI.revive(d.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(L,T,p,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:p,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$doc=A}),define(ye[368],Se([1,0,19,9,21,4,3,29,2,24,12,6,37,17,10,121,310,26,52,311]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=void 0,e.$loc=$;let s=class{constructor(k,D,v,I,w){this.m=D,this.n=v,this.o=I,this.q=w,this.b=new T.$Ac,this.c=new T.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$he,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=k.getProxy(S.$uM.MainThreadNotebookKernels);const y=new d.$mP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new d.$kP("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const U=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:U}}else if(O&&"notebookEditor"in O){const U=this.n.getIdByEditor(O.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return O})],d.$lP.Void),N=new d.$mP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[d.$kP.Uri],new d.$lP("A promise that resolves to an array of variables",(O,U)=>O.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(y),this.o.registerApiCommand(N)}createNotebookController(k,D,v,I,w,y){for(const re of this.j.values())if(re.controller.id===D&&c.$Wm.equals(k.identifier,re.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const N=this.k++,O=this;this.q.trace(`NotebookController[${N}], CREATED by ${k.identifier.value}, ${D}`);const U=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${k.identifier}'`);let j=!1;const z=new R.$he,M=new R.$he,F={id:$(k.identifier,D),notebookType:v,extensionId:k.identifier,extensionLocation:k.extensionLocation,label:I||k.identifier.value,preloads:y?y.map(P.NotebookRendererScript.from):[]};let J=w??U,ee,V;this.a.$addKernel(N,F).catch(re=>{console.log(re),j=!0});let H=0;const _=()=>{if(j)return;const re=++H;Promise.resolve().then(()=>{re===H&&this.a.$updateKernel(N,F)})},ne=new T.$Ac,he={get id(){return D},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return F.label},set label(re){F.label=re??k.displayName??k.name,_()},get detail(){return F.detail??""},set detail(re){F.detail=re,_()},get description(){return F.description??""},set description(re){F.description=re,_()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(re){F.supportedLanguages=re,_()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(re){F.supportsExecutionOrder=re,_()},get rendererScripts(){return F.preloads?F.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler(re){J=re??U},get interruptHandler(){return ee},set interruptHandler(re){ee=re,F.supportsInterrupt=!!re,_()},set variableProvider(re){(0,f.$UG)(k,"notebookVariableProvider"),V=re,F.hasVariableProvider=!!re,re?.onDidChangeVariables(ve=>O.a.$variablesUpdated(ve.uri)),_()},get variableProvider(){return V},createNotebookCellExecution(re){if(j)throw new Error("notebook controller is DISPOSED");if(!ne.has(re.notebook.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return O._createNotebookCellExecution(re,$(k.identifier,this.id))},createNotebookExecution(re){if((0,f.$UG)(k,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ne.has(re.uri))throw O.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return O._createNotebookExecution(re,$(k.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${N}], DISPOSED`),j=!0,this.j.delete(N),z.dispose(),M.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(re,ve){ve===b.NotebookControllerAffinity2.Hidden&&(0,f.$UG)(k,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(N,re.uri,ve)},onDidReceiveMessage:M.event,postMessage(re,ve){return(0,f.$UG)(k,"notebookMessaging"),O.a.$postMessage(N,ve&&O.n.getIdByEditor(ve),re)},asWebviewUri(re){return(0,f.$UG)(k,"notebookMessaging"),(0,a.$GBb)(re,O.m.remote)}};return this.j.set(N,{extensionId:k.identifier,controller:he,onDidReceiveMessage:M,onDidChangeSelection:z,associatedNotebooks:ne}),he}getIdByController(k){for(const[D,v]of this.j)if(v.controller===k)return $(v.extensionId,k.id);return null}createNotebookControllerDetectionTask(k,D){const v=this.g++,I=this;this.q.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${k.identifier.value}`),this.a.$addKernelDetectionTask(v,D);const w={dispose:()=>{this.f.delete(v),I.a.$removeKernelDetectionTask(v)}};return this.f.set(v,w),w}registerKernelSourceActionProvider(k,D,v){const I=this.i++,w=typeof v.onDidChangeNotebookKernelSourceActions=="function"?I:void 0,y=this;this.h.set(I,v),this.q.trace(`NotebookKernelSourceActionProvider[${I}], CREATED by ${k.identifier.value}`),this.a.$addKernelSourceActionProvider(I,I,D);let N;return w!==void 0&&(N=v.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(I),y.a.$removeKernelSourceActionProvider(I,I),N?.dispose()}}}async $provideKernelSourceActions(k,D){const v=this.h.get(k);if(v){const I=new L.$Tc;return(await v.provideNotebookKernelSourceActions(D)??[]).map(y=>P.NotebookKernelSourceAction.from(y,this.o.converter,I))}return[]}$acceptNotebookAssociation(k,D,v){const I=this.j.get(k);if(I){const w=this.n.getNotebookDocument(p.URI.revive(D));v?I.associatedNotebooks.set(w.uri,!0):I.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${k}] ASSOCIATE notebook`,w.uri.toString(),v),I.onDidChangeSelection.fire({selected:v,notebook:w.apiNotebook})}}async $executeCells(k,D,v){const I=this.j.get(k);if(!I)return;const w=this.n.getNotebookDocument(p.URI.revive(D)),y=[];for(const N of v){const O=w.getCell(N);O&&y.push(O.apiCell)}try{this.q.trace(`NotebookController[${k}] EXECUTE cells`,w.uri.toString(),y.length),await I.controller.executeHandler.call(I.controller,y,w.apiNotebook,I.controller)}catch(N){this.q.error(`NotebookController[${k}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(k,D,v){const I=this.j.get(k);if(!I)return;const w=this.n.getNotebookDocument(p.URI.revive(D));if(I.controller.interruptHandler)await I.controller.interruptHandler.call(I.controller,w.apiNotebook);else for(const y of v){const N=w.getCell(y);N&&this.b.get(N.uri)?.cancel()}if(I.controller.interruptHandler){const y=this.c.get(w.uri);this.c.delete(w.uri),v.length&&Array.isArray(y)&&y.length&&y.forEach(N=>N.dispose())}}async $provideVariables(k,D,v,I,w,y,N){const O=this.j.get(k);if(!O)return;const U=this.n.getNotebookDocument(p.URI.revive(v)),j=O.controller.variableProvider;if(!j)return;let z;if(I!==void 0){if(z=this.s[I],!z)return}else this.s={};const M=w==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,F=j.provideVariables(U.apiNotebook,z,M,y,N);let J=0;for await(const ee of F){if(N.isCancellationRequested)return;const V={id:this.r++,name:ee.variable.name,value:ee.variable.value,type:ee.variable.type,interfaces:ee.variable.interfaces,language:ee.variable.language,expression:ee.variable.expression,hasNamedChildren:ee.hasNamedChildren,indexedChildrenCount:ee.indexedChildrenCount,extensionId:O.extensionId.value};if(this.s[V.id]=ee.variable,this.a.$receiveVariable(D,V),J++>=n.$sjb)return}}$acceptKernelMessageFromRenderer(k,D,v){const I=this.j.get(k);if(!I)return;const w=this.n.getEditorById(D);I.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:v}))}$cellExecutionChanged(k,D,v){const w=this.n.getNotebookDocument(p.URI.revive(k)).getCell(D);if(w){const y=v?P.NotebookCellExecutionState.to(v):b.NotebookCellExecutionState.Idle;y!==void 0&&this.l.fire({cell:w.apiCell,state:y})}}_createNotebookCellExecution(k,D){if(k.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const I=this.n.getNotebookDocument(k.notebook.uri).getCellFromApiCell(k);if(!I)throw new Error("invalid cell");if(this.b.has(I.uri))throw new Error(`duplicate execution for ${I.uri}`);const w=new t(D,I,this.a);this.b.set(I.uri,w);const y=w.onDidChangeState(()=>{w.state===i.Resolved&&(w.dispose(),y.dispose(),this.b.delete(I.uri))});return w.asApiObject()}_createNotebookExecution(k,D){const v=this.n.getNotebookDocument(k.uri),I=k.getCells().find(N=>{const O=v.getCellFromApiCell(N);return O&&this.b.has(O.uri)});if(I)throw new Error(`duplicate cell execution for ${I.document.uri}`);if(this.c.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const w=new h(D,v,this.a),y=w.onDidChangeState(()=>{w.state===l.Resolved&&(w.dispose(),y.dispose(),this.c.delete(v.uri))});return this.c.set(v.uri,[w,y]),w.asApiObject()}};e.$koc=s,e.$koc=s=Je([Ge(4,C.$7j)],s);var i;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(i||(i={}));class t extends L.$Uc{static{this.a=0}get state(){return this.f}constructor(k,D,v){super(),this.m=D,this.n=v,this.b=t.a++,this.c=new R.$he,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new A.$se),this.h=new o(10,I=>this.s(I)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,k,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(k){await this.h.addItem(k)}async s(k){const D=Array.isArray(k)?k:[k];return this.n.$updateExecution(this.b,new g.$Kw(D))}t(){if(this.f===i.Init)throw new Error("Must call start before modifying cell output");if(this.f===i.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(k){let D=this.m;if(k&&(D=this.m.notebook.getCellFromApiCell(k)),!D)throw new Error("INVALID cell");return D.handle}y(k){return k.map(D=>{const v=b.$3N.ensureUniqueMimeTypes(D.items,!0);return v===D.items?P.NotebookCellOutput.from(D):P.NotebookCellOutput.from({items:v,id:D.id,metadata:D.metadata})})}async z(k,D,v){const I=this.w(D),w=this.y((0,r.$2b)(k));return this.r({editType:u.CellExecutionUpdateType.Output,cellHandle:I,append:v,outputs:w})}async C(k,D,v){return k=b.$3N.ensureUniqueMimeTypes((0,r.$2b)(k),!0),this.r({editType:u.CellExecutionUpdateType.OutputItems,items:k.map(P.NotebookCellOutputItem.from),outputId:D.id,append:v})}asApiObject(){const k=this;return Object.freeze({get token(){return k.g.token},get cell(){return k.m.apiCell},get executionOrder(){return k.j},set executionOrder(v){k.j=v,k.s([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:k.j}])},start(v){if(k.f===i.Resolved||k.f===i.Started)throw new Error("Cannot call start again");k.f=i.Started,k.c.fire(),k.s({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,I,w){if(k.f===i.Resolved)throw new Error("Cannot call resolve twice");k.f=i.Resolved,k.c.fire(),k.h.flush();const y=w?{message:w.message,stack:w.stack,location:w?.location?{startLineNumber:w.location.start.line,startColumn:w.location.start.character,endLineNumber:w.location.end.line,endColumn:w.location.end.character}:void 0,uri:w.uri}:void 0;k.n.$completeExecution(k.b,new g.$Kw({runEndTime:I,lastRunSuccess:v,error:y}))},clearOutput(v){return k.t(),k.z([],v,!1)},appendOutput(v,I){return k.t(),k.z(v,I,!0)},replaceOutput(v,I){return k.t(),k.z(v,I,!1)},appendOutputItems(v,I){return k.t(),k.C(v,I,!0)},replaceOutputItems(v,I){return k.t(),k.C(v,I,!1)}})}}var l;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(l||(l={}));class h extends L.$Uc{static{this.a=0}get state(){return this.f}constructor(k,D,v){super(),this.h=D,this.j=v,this.b=h.a++,this.c=new R.$he,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new A.$se),this.j.$createNotebookExecution(this.b,k,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(k,D){this.f=k,this.g=D,this.a=[],this.b=Date.now()}addItem(k){return this.a.push(k),this.c||(this.c=new m.$Xh,this.b=Date.now(),(0,m.$Bh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const k=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>k.complete())}}function $(E,k){return`${E.value}/${k}`}}),define(ye[46],Se([1,0,4,6,5,2,20,3,10,240,14,289,21,32,290,291,50,9,17,37,41]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=e.$xnc=e.$wnc=e.$vnc=void 0,e.$vnc=(0,A.$Ai)("IExtHostTerminalService");class i extends T.$Uc{constructor(w,y,N,O){super(),this.u=w,this._id=y,this.w=N,this.y=O,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$he),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const U=this;this.value={get name(){return U.y||""},get processId(){return U.b},get creationOptions(){return U.w},get exitStatus(){return U.j},get state(){return U.m},get selection(){return U.n},get shellIntegration(){return U.shellIntegration},sendText(j,z=!0){U.C(),U.u.$sendText(U._id,j,z)},show(j){U.C(),U.u.$show(U._id,j)},hide(){U.C(),U.u.$hide(U._id)},dispose(){U.a||(U.a=!0,U.u.$dispose(U._id))},get dimensions(){if(!(U.f===void 0||U.h===void 0))return{columns:U.f,rows:U.h}}}}dispose(){this.s.fire(),super.dispose()}async create(w,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??y?.cwd??void 0,env:w.env??void 0,icon:k(w.iconPath)??void 0,color:u.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:y?.forceShellIntegration??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.z(w.location,y?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,y,N,O,U){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:O,color:u.ThemeColor.isThemeColor(U)?U.id:void 0,location:y?.location||this.z(w,N),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(w,y){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in w?{viewColumn:g.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.y=w}setExitStatus(w,y){this.j=Object.freeze({code:w,reason:y})}setDimensions(w,y){return w===this.f&&y===this.h||w===0||y===0?!1:(this.f=w,this.h=y,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(w){this.n=w}_setProcessId(w){this.g?(this.g(w),this.g=void 0):this.b.then(y=>{y!==w&&(this.b=Promise.resolve(w))})}}e.$wnc=i;class t{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new r.$he,this.onProcessData=this.a.event,this.b=new r.$he,this.d=new r.$he,this.onDidChangeProperty=this.d.event,this.f=new r.$he,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,y){this.g.setDimensions?.({columns:w,rows:y})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:b.ProcessPropertyType.OverrideDimensions,value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:b.ProcessPropertyType.Title,value:y})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,h=class extends T.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,y,N){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$he,this.onDidCloseTerminal=this.H.event,this.I=new r.$he,this.onDidOpenTerminal=this.I.event,this.J=new r.$he,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$he,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$he,this.onDidChangeTerminalState=this.M.event,this.N=new r.$he,this.onDidChangeShell=this.N.event,this.O=new r.$he({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$he({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=N.getProxy(m.$uM.MainThreadTerminalService),this.y=new a.$5vb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:O=>{const U=j=>{const z=j;return this.getTerminalById(z.instanceId)?.value};switch(O?.$mid){case s.MarshalledId.TerminalContext:return U(O);default:{if(Array.isArray(O))for(let j=0;j<O.length&&O[j].$mid===s.MarshalledId.TerminalContext;j++)O[j]=U(O[j]);return O}}}}),this.B({dispose:()=>{for(const[O,U]of this.g)U.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,y){const N=new i(this.a,(0,P.$Wg)(),w,w.name),O=new t(w.pty);return N.createExtensionTerminal(w.location,y,this.R(w,y).resolvedExtHostIdentifier,k(w.iconPath),D(w.color)).then(U=>{const j=this.S(U,O);this.h[U]=j}),this.f.push(N),N.value}R(w,y){if(y=y||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const N=w.location.parentTerminal;if(N){const O=this.f.find(U=>U.value===N);O&&(y.resolvedExtHostIdentifier=O._id)}}else w.location&&typeof w.location!="object"?y.location=w.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(w,y){if(!this.getTerminalById(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const O=new t(y),U=this.S(w,O);this.h[w]=U}async $acceptActiveTerminalChanged(w){const y=this.b;if(w===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const N=this.getTerminalById(w);N&&(this.b=N,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,y){const N=this.getTerminalById(w);N&&this.O.fire({terminal:N.value,data:y})}async $acceptTerminalDimensions(w,y,N){const O=this.getTerminalById(w);O&&O.setDimensions(y,N)&&this.L.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(w,y){const N=this.getTerminalById(w);N&&this.P.fire({terminal:N.value,...y})}async $acceptTerminalMaximumDimensions(w,y,N){this.g.get(w)?.resize(y,N)}async $acceptTerminalTitleChange(w,y){const N=this.getTerminalById(w);N&&(N.name=y)}async $acceptTerminalClosed(w,y,N){const O=this.X(this.f,w);if(O!==null){const U=this.f.splice(O,1)[0];U.setExitStatus(y,N),this.H.fire(U.value)}}$acceptTerminalOpened(w,y,N,O){if(y){const z=this.X(this.f,y);if(z!==null){this.f[z]._id=w,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const U={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:R.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},j=new i(this.a,w,U,N);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(w,y){this.getTerminalById(w)?._setProcessId(y)}async $startExtensionTerminal(w,y){const N=this.getTerminalById(w);if(!N)return{message:(0,c.localize)(0,null,w)};N.isOpen||await new Promise(U=>{const j=this.onDidOpenTerminal(async z=>{z===N.value&&(j.dispose(),U())})});const O=this.g.get(w);O?O.startSendingEvents(y):this.j[w]={initialDimensions:y}}S(w,y){const N=new T.$Tc;N.add(y.onProcessReady(U=>this.a.$sendProcessReady(w,U.pid,U.cwd,U.windowsPty))),N.add(y.onDidChangeProperty(U=>this.a.$sendProcessProperty(w,U))),this.y.startBuffering(w,y.onProcessData),N.add(y.onProcessExit(U=>this.U(w,U))),this.g.set(w,y);const O=this.j[w];return O&&y instanceof t&&(y.startSendingEvents(O.initialDimensions),delete this.j[w]),N}$acceptProcessAckDataEvent(w,y){this.g.get(w)?.acknowledgeDataEvent(y)}$acceptProcessInput(w,y){this.g.get(w)?.input(y)}$acceptTerminalInteraction(w){const y=this.getTerminalById(w);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(w,y){this.getTerminalById(w)?.setSelection(y)}$acceptProcessResize(w,y,N){try{this.g.get(w)?.resize(y,N)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(w,y){this.g.get(w)?.shutdown(y)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(w,{type:b.ProcessPropertyType.InitialCwd,value:y}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(y=>this.a.$sendProcessProperty(w,{type:b.ProcessPropertyType.Cwd,value:y}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new p.$wM(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,y,N){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,N),this.a.$registerProfileProvider(y,w.identifier.value),new p.$wM(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(w,y,N){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,N),this.a.$registerQuickFixProvider(w,y),new p.$wM(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,y){const N=new d.$se().token;if(N.isCancellationRequested)return;const O=this.D.get(w);if(!O)return;const U=await O.provideTerminalQuickFixes(y,N);if(U===null||Array.isArray(U)&&U.length===0)return;const j=new T.$Tc;if(this.w.value=j,!Array.isArray(U))return U?g.TerminalQuickFix.from(U,this.Q.converter,j):void 0;const z=[];for(const M of U){const F=g.TerminalQuickFix.from(M,this.Q.converter,j);F&&z.push(F)}return z}async $createContributedProfileTerminal(w,y){const N=new d.$se().token;let O=await this.C.get(w)?.provideTerminalProfile(N);if(!N.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,y);return}this.createTerminalFromOptions(O.options,y)}}async $provideLinks(w,y){const N=this.getTerminalById(w);if(!N)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const U=new d.$se;this.G.set(w,U);const j=[],z={terminal:N.value,line:y},M=[];for(const ee of this.z)M.push(f.Promises.withAsyncBody(async V=>{U.token.onCancellationRequested(()=>V({provider:ee,links:[]}));const H=await ee.provideTerminalLinks(z,U.token)||[];U.token.isCancellationRequested||V({provider:ee,links:H})}));const F=await Promise.all(M);if(U.token.isCancellationRequested)return[];const J=new Map;for(const ee of F)ee&&ee.links.length>0&&j.push(...ee.links.map(V=>{const H={id:l++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return J.set(H.id,{provider:ee.provider,link:V}),H}));return this.F.set(w,J),j}$activateLink(w,y){const N=this.F.get(w)?.get(y);N&&N.provider.handleTerminalLink(N.link)}U(w,y){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const N=this.h[w];N&&(N.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,y)}getTerminalById(w){return this.W(this.f,w)}getTerminalIdByApiObject(w){const y=this.f.findIndex(N=>N.value===w);return y>=0?y:null}W(w,y){const N=this.X(w,y);return N!==null?w[N]:null}X(w,y){const N=w.findIndex(O=>O._id===y);return N>=0?N:null}getEnvironmentVariableCollection(w){let y=this.n.get(w.identifier.value);return y||(y=new o,this.Z(w.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Y(w,y){const N=(0,S.$ts)(y.map),O=(0,S.$us)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(w,y.persistent,N.length===0?void 0:N,O)}$initEnvironmentVariableCollections(w){w.forEach(y=>{const N=y[0],O=new o(y[1]);this.Z(N,O)})}$acceptDefaultProfile(w,y){const N=this.s;this.s=w,this.u=y,N?.path!==w.path&&this.N.fire(w.path)}Z(w,y){this.n.set(w,y),y.onDidChangeCollection(()=>{this.Y(w,y)})}};e.$xnc=h,e.$xnc=h=Je([Ge(1,n.$iP),Ge(2,L.$YO)],h);class o{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new r.$he,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const y=this.h(w);let N=this.a.get(y);return N||(N=new $(this,w),this.a.set(y,N),N.onDidChangeCollection(()=>this.d.fire())),N}replace(w,y,N,O){this.f(w,{value:y,type:p.EnvironmentVariableMutatorType.Replace,options:N??{applyAtProcessCreation:!0},scope:O})}append(w,y,N,O){this.f(w,{value:y,type:p.EnvironmentVariableMutatorType.Append,options:N??{applyAtProcessCreation:!0},scope:O})}prepend(w,y,N,O){this.f(w,{value:y,type:p.EnvironmentVariableMutatorType.Prepend,options:N??{applyAtProcessCreation:!0},scope:O})}f(w,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const N=this.g(w,y.scope),O=this.map.get(N),U=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==y.value||O.type!==y.type||O.options?.applyAtProcessCreation!==U.applyAtProcessCreation||O.options?.applyAtShellIntegration!==U.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const j=this.g(w,y.scope),z={variable:w,...y,options:U};this.map.set(j,z),this.d.fire()}}get(w,y){const N=this.g(w,y),O=this.map.get(N);return O?v(O):void 0}g(w,y){const N=this.h(y);return N.length?`${w}:::${N}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const y=new Map;for(const[N,O]of this.map)this.h(O.scope)===this.h(w)&&y.set(O.variable,v(O));return y}delete(w,y){const N=this.g(w,y);this.map.delete(N),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[y,N]of this.map)N.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(y);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,y){const N=this.h(y),O=this.descriptionMap.get(N);if(!O||O.description!==w){let U;typeof w=="string"?U=w:U=w?.value.split(`

`)[0];const j={description:U,scope:y};this.descriptionMap.set(N,j),this.d.fire()}}getDescription(w){const y=this.h(w);return this.descriptionMap.get(y)?.description}k(w){const y=this.h(w);this.descriptionMap.delete(y)}}class ${get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,y){this.b=w,this.d=y,this.a=new r.$he}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,y,N){this.b.replace(w,y,N,this.d)}append(w,y,N){this.b.append(w,y,N,this.d)}prepend(w,y,N){this.b.prepend(w,y,N,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,y){this.b.getVariableMap(this.d).forEach((N,O)=>w.call(y,O,N,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends h{constructor(w,y){super(!1,w,y)}createTerminal(w,y,N){throw new C.$_}createTerminalFromOptions(w,y){throw new C.$_}};e.$ync=E,e.$ync=E=Je([Ge(0,n.$iP),Ge(1,L.$YO)],E);function k(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function D(I){return u.ThemeColor.isThemeColor(I)?I:void 0}function v(I){const w={...I};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(ye[165],Se([1,0,10,3,5,6,20,46,4,2,9]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Coc=void 0,e.$Coc=(0,A.$Ai)("IExtHostTerminalShellIntegration");let S=class extends m.$Uc{constructor(u,f){super(),this.h=f,this.b=new Map,this.c=new p.$he,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$he,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$he,this.onDidEndTerminalShellExecution=this.g.event,this.a=u.getProxy(R.$uM.MainThreadTerminalShellIntegration),this.B((0,m.$Sc)(()=>{for(const[g,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(u){const f=this.h.getTerminalById(u);if(!f)return;const g=f.value;let n=this.b.get(u);n||(n=new d(f.value,this.f),this.b.set(u,n),n.store.add(f.onWillDispose(()=>this.b.get(u)?.dispose())),n.store.add(n.onDidRequestShellExecution(s=>this.a.$executeCommand(u,s))),n.store.add(n.onDidRequestEndExecution(s=>this.g.fire(s))),n.store.add(n.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),f.shellIntegration=n.value),this.c.fire({terminal:g,shellIntegration:n.value})}$shellExecutionStart(u,f,g,n,s){this.b.has(u)||this.$shellIntegrationChange(u);const i={value:f,confidence:g,isTrusted:n};this.b.get(u)?.startShellExecution(i,s)}$shellExecutionEnd(u,f,g,n,s){const i={value:f,confidence:g,isTrusted:n};this.b.get(u)?.endShellExecution(i,s)}$shellExecutionData(u,f){this.b.get(u)?.emitData(f)}$cwdChange(u,f){this.b.get(u)?.setCwd((0,c.$vc)(f)?c.URI.revive(f):f)}$closeTerminal(u){this.b.get(u)?.dispose(),this.b.delete(u)}};e.$Doc=S,e.$Doc=S=Je([Ge(0,L.$YO),Ge(1,T.$vnc)],S);class d extends m.$Uc{get currentExecution(){return this.a}constructor(u,f){super(),this.j=u,this.m=f,this.b=!1,this.store=this.B(new m.$Tc),this.f=this.B(new p.$he),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$he),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$he),this.onDidRequestEndExecution=this.h.event;const g=this;this.value={get cwd(){return g.c},executeCommand(n,s){let i=n;s&&(i+=` "${s.map(h=>`${h.replaceAll('"','\\"')}`).join('" "')}"`),g.g.fire(i);const t={value:i,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=g.startShellExecution(t,g.c,!0).value;return g.b=!0,l}}}startShellExecution(u,f,g){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new P(u,f);g?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(u){this.currentExecution?.emitData(u)}endShellExecution(u,f){this.a&&(this.a.endExecution(u),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:f}),this.a=void 0)}setCwd(u){let f=!1;c.URI.isUri(this.c)?f=!c.URI.isUri(u)||this.c.toString()!==u.toString():this.c!==u&&(f=!0),f&&(this.c=u,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor(u,f){this.c=u,this.cwd=f,this.b=!1;const g=this;this.value={get commandLine(){return g.c},get cwd(){return g.cwd},read(){return g.d()}}}d(){if(!this.a){if(this.b)return C.$1h.EMPTY;this.a=new b}return this.a.createIterable()}emitData(u){this.a?.emitData(u)}endExecution(u){u&&(this.c=u),this.a?.endExecution(),this.a=void 0,this.b=!0}}class b extends m.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new C.$zh);const u=this.a;return new C.$1h(async g=>{this.b.push(g),await u.wait()})}emitData(u){for(const f of this.b)f.emitOne(u)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ye[369],Se([1,0,9,22,21,4,80,61,3,41,18,32,12,6,20,164,17,10,313,73,120,74,26]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=e.$Goc=e.$Foc=e.$Eoc=void 0;let l=0;const h=new WeakMap;let o=class extends p.$Uc{constructor(F,J,ee,V){super(),this.C=J,this.D=ee,this.F=V,this.f=this.B(new R.$he),this.g=new Map,this.w=this.B(new R.$he),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(P.$uM.MainThreadTesting),this.m=new N(this.h),this.j=new D(this.h,J),ee.registerArgumentProcessor({processArgument:H=>{switch(H?.$mid){case c.MarshalledId.TestItemContext:{const _=H,ne=_.tests[_.tests.length-1].item.extId;return this.g.get(n.$gL.root(ne))?.collection.tree.get(ne)?.actual??(0,a.$$O)(H)}case c.MarshalledId.TestMessageMenuArgs:{const{test:_,message:ne}=H,he=_.item.extId;return{test:this.g.get(n.$gL.root(he))?.collection.tree.get(he)?.actual??(0,a.$$O)({$mid:c.MarshalledId.TestItemContext,tests:[_]}),message:u.TestMessage.to(ne)}}default:return H}}}),ee.registerCommand(!1,"testing.getExplorerSelection",async()=>{const H=await ee.executeCommand(g.TestCommandId.GetExplorerSelection),_=ne=>{const he=this.g.get(n.$gL.root(ne));if(he)return n.$gL.isRoot(ne)?he.controller:he.collection.tree.get(ne)?.actual};return{include:H?.include.map(_).filter(C.$ig)||[],exclude:H?.exclude.map(_).filter(C.$ig)||[]}})}createTestController(F,J,ee,V){if(this.g.has(J))throw new Error(`Attempt to insert a duplicate controller with ID "${J}"`);const H=new p.$Tc,_=H.add(new a.$bP(J,ee,this.F));_.root.label=ee;const ne=new Map,he=new Set,re=this.h,ve={items:_.root.children,get label(){return ee},set label(Q){ee=Q,_.root.label=Q,re.$updateController(J,{label:ee})},get refreshHandler(){return V},set refreshHandler(Q){V=Q,re.$updateController(J,{canRefresh:!!Q})},get id(){return J},createRunProfile:(Q,B,se,ae,ie,ce)=>{let ue=(0,T.$oj)(Q);for(;ne.has(ue);)ue++;return new U(this.h,ne,he,this.w.event,J,ue,Q,B,se,ae,ie,ce)},createTestItem(Q,B,se){return new a.$_O(J,Q,B,se)},createTestRun:(Q,B,se=!0)=>this.j.createTestRun(F,J,_,Q,B,se),invalidateTestResults:Q=>{if(Q===void 0)this.h.$markTestRetired(void 0);else{const B=Q instanceof Array?Q:[Q];this.h.$markTestRetired(B.map(se=>n.$gL.fromExtHostTestItem(se,J).toString()))}},set resolveHandler(Q){_.resolveHandler=Q},get resolveHandler(){return _.resolveHandler},dispose:()=>{H.dispose()}};re.$registerTestController(J,ee,!!V),H.add((0,p.$Sc)(()=>re.$unregisterTestController(J)));const pe={controller:ve,collection:_,profiles:ne,extension:F,activeProfiles:he};return this.g.set(J,pe),H.add((0,p.$Sc)(()=>this.g.delete(J))),H.add(_.onDidGenerateDiff(Q=>re.$publishDiff(J,Q.map(i.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(F,J=A.CancellationToken.None){const ee=v(F);if(!ee)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.g.get(ee.controllerId);if(!V)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:F.preserveFocus??!0,targets:[{testIds:F.include?.map(H=>n.$gL.fromExtHostTestItem(H,V.collection.root.id).toString())??[V.collection.root.id],profileGroup:j[ee.kind],profileId:ee.profileId,controllerId:ee.controllerId}],exclude:F.exclude?.map(H=>H.id)},J)}registerTestFollowupProvider(F){return this.y.add(F),{dispose:()=>{this.y.delete(F)}}}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $getCoverageDetails(F,J){return(await this.j.getCoverageDetails(F,J))?.map(u.TestCoverage.fromDetails)}async $disposeRun(F){this.j.disposeTestRun(F)}$configureRunProfile(F,J){this.g.get(F)?.profiles.get(J)?.configureHandler?.()}$setDefaultRunProfiles(F){const J=new Map;for(const[ee,V]of Object.entries(F)){const H=this.g.get(ee);if(!H)continue;const _=new Map,ne=V.filter(re=>!H.activeProfiles.has(re)),he=[...H.activeProfiles].filter(re=>!V.includes(re));for(const re of ne)_.set(re,!0),H.activeProfiles.add(re);for(const re of he)_.set(re,!1),H.activeProfiles.delete(re);_.size&&J.set(ee,_)}this.w.fire(J)}async $refreshTests(F,J){await this.g.get(F)?.controller.refreshHandler?.(J)}$publishTestResults(F){this.results=Object.freeze(F.map(J=>{const ee=u.TestResults.to(J);return h.set(ee,J.id),ee}).concat(this.results).sort((J,ee)=>ee.completedAt-J.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,J){const ee=this.g.get(n.$gL.fromString(F).controllerId)?.collection;ee&&(await ee.expand(F,J<0?1/0:J),ee.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(J=>i.TestsDiffOp.deserialize({asCanonicalUri:ee=>ee},J)))}async $runControllerTests(F,J){return Promise.all(F.map(ee=>this.G(ee,!1,J)))}async $startContinuousRun(F,J){const ee=new A.$se(J),V=await Promise.all(F.map(H=>this.G(H,!0,ee.token)));return!J.isCancellationRequested&&!V.some(H=>H.error)&&await new Promise(H=>J.onCancellationRequested(H)),ee.dispose(!0),V}async $provideTestFollowups(F,J){const ee=this.results.find(_=>h.get(_)===F.resultId),V=ee&&z(n.$gL.fromString(F.extId),ee?.results);if(!V)return[];let H=[];return await Promise.all([...this.y].map(async _=>{try{const ne=await _.provideFollowup(ee,V,F.taskIndex,F.messageIndex,J);ne&&(H=H.concat(ne))}catch(ne){this.C.error("Error thrown while providing followup for test message",ne)}})),J.isCancellationRequested?[]:H.map(_=>{const ne=l++;return this.z.set(ne,_),{title:_.title,id:ne}})}$disposeTestFollowups(F){for(const J of F)this.z.delete(J)}$executeTestFollowup(F){const J=this.z.get(F);return J?this.D.executeCommand(J.command,...J.arguments||[]):Promise.resolve()}async G(F,J,ee){const V=this.g.get(F.controllerId);if(!V)return{};const{collection:H,profiles:_,extension:ne}=V,he=_.get(F.profileId);if(!he)return{};const re=F.testIds.map(B=>H.tree.get(B)).filter(C.$ig),ve=F.excludeExtIds.map(B=>V.collection.tree.get(B)).filter(C.$ig).filter(B=>re.some(se=>se.fullId.compare(B.fullId)===n.TestPosition.IsChild));if(!re.length)return{};const pe=new f.$0N(re.some(B=>B.actual instanceof a.$aP)?void 0:re.map(B=>B.actual),ve.map(B=>B.actual),he,J),Q=(0,i.$jL)(F)&&this.j.prepareForMainThreadTestRun(ne,pe,I.fromInternal(F,V.collection),he,ee);try{return await he.runHandler(pe,ee),{}}catch(B){return{error:String(B)}}finally{Q&&Q.hasRunningTasks&&!ee.isCancellationRequested&&await R.Event.toPromise(Q.onEnd)}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$Eoc=o,e.$Eoc=o=Je([Ge(0,b.$YO),Ge(1,d.$7j)],o);const $=1e4;var E;(function(M){M[M.Running=0]="Running",M[M.Cancelling=1]="Cancelling",M[M.Ended=2]="Ended"})(E||(E={}));class k extends p.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(F,J,ee,V,H,_){super(),this.z=F,this.C=J,this.D=ee,this.F=V,this.G=H,this.c=E.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$he),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new A.$se(_));const ne=this.B(new r.$Mh(()=>this.H(),$));this.B(this.j.token.onCancellationRequested(()=>ne.schedule()));const he=new R.$he;this.w=he.event,this.B((0,p.$Sc)(()=>{he.fire(),he.dispose()}))}cancel(){this.c===E.Running?(this.j.cancel(),this.c=E.Cancelling):this.c===E.Cancelling&&this.H()}getCoverageDetails(F,J){const[,ee]=n.$gL.fromString(F).path,V=this.y.get(F);if(!V)return[];const H=this.g.get(ee);if(!H)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(H.run,V,J)??[]}createRun(F){const J=this.z.id,ee=this.z.controllerId,V=(0,S.$Wg)(),H=ve=>(pe,...Q)=>{if(ne){this.D.warn(`Setting the state of test "${pe.id}" is a no-op after the run ends.`);return}this.z.isIncluded(pe)&&(this.J(pe),ve(pe,...Q))},_=(ve,pe)=>{const Q=pe instanceof Array?pe.map(u.TestMessage.from):[u.TestMessage.from(pe)];if(ve.uri&&ve.range){const B={range:u.Range.from(ve.range),uri:ve.uri};for(const se of Q)se.location=se.location||B}this.C.$appendTestMessagesInRun(J,V,n.$gL.fromExtHostTestItem(ve,ee).toString(),Q)};let ne=!1;const he=new Map,re={isPersisted:this.z.isPersisted,token:this.j.token,name:F,onDidDispose:this.w,addCoverage:ve=>{if(ne)return;const pe=ve instanceof f.$cO?ve.testItem:void 0;let Q;if(pe){if((0,t.$UG)(this.G,"attributableCoverage"),!this.z.isIncluded(pe))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.J(pe),Q=he.get(pe),Q===void 0&&(Q=he.size,he.set(pe,Q))}const B=ve.uri.toString(),se=new n.$gL(Q!==void 0?[J,V,B,String(Q)]:[J,V,B]).toString();this.y.set(se,ve),this.C.$appendCoverage(J,V,u.TestCoverage.fromFile(ee,se,ve))},enqueued:H(ve=>{this.C.$updateTestStateInRun(J,V,n.$gL.fromExtHostTestItem(ve,ee).toString(),i.TestResultState.Queued)}),skipped:H(ve=>{this.C.$updateTestStateInRun(J,V,n.$gL.fromExtHostTestItem(ve,ee).toString(),i.TestResultState.Skipped)}),started:H(ve=>{this.C.$updateTestStateInRun(J,V,n.$gL.fromExtHostTestItem(ve,ee).toString(),i.TestResultState.Running)}),errored:H((ve,pe,Q)=>{_(ve,pe),this.C.$updateTestStateInRun(J,V,n.$gL.fromExtHostTestItem(ve,ee).toString(),i.TestResultState.Errored,Q)}),failed:H((ve,pe,Q)=>{_(ve,pe),this.C.$updateTestStateInRun(J,V,n.$gL.fromExtHostTestItem(ve,ee).toString(),i.TestResultState.Failed,Q)}),passed:H((ve,pe)=>{this.C.$updateTestStateInRun(J,V,n.$gL.fromExtHostTestItem(ve,this.z.controllerId).toString(),i.TestResultState.Passed,pe)}),appendOutput:(ve,pe,Q)=>{ne||(Q&&(this.z.isIncluded(Q)?this.J(Q):Q=void 0),this.C.$appendOutputToRun(J,V,m.$Je.fromString(ve),pe&&u.location.from(pe),Q&&n.$gL.fromExtHostTestItem(Q,ee).toString()))},end:()=>{ne||(ne=!0,he.clear(),this.C.$finishedTestRunTask(J,V),--this.f||this.I())}};return this.f++,this.g.set(V,{run:re}),this.C.$startedTestRunTask(J,{id:V,name:F,running:!0}),re}H(){for(const{run:F}of this.g.values())F.end()}I(){this.c!==E.Ended&&(this.c=E.Ended,this.m.fire())}J(F){if(!(F instanceof a.$_O))throw new s.$QO(F.id);if(this.h.has(n.$gL.fromExtHostTestItem(F,this.z.controllerId).toString()))return;const J=[],ee=this.z.colllection.root;for(;;){const V=u.TestItem.from(F);if(J.unshift(V),this.h.has(V.extId)||(this.h.add(V.extId),F===ee))break;F=F.parent||ee}this.C.$addTestsToRun(this.z.controllerId,this.z.id,J)}dispose(){this.I(),super.dispose()}}class D{get trackers(){return this.c.values()}constructor(F,J){this.g=F,this.h=J,this.c=new Map,this.f=new Map}getCoverageDetails(F,J){const ee=n.$gL.root(F);return this.f.get(ee)?.getCoverageDetails(F,J)||[]}disposeTestRun(F){this.f.get(F)?.dispose(),this.f.delete(F);for(const[J,{id:ee}]of this.c)ee===F&&this.c.delete(J)}prepareForMainThreadTestRun(F,J,ee,V,H){return this.j(J,ee,V,F,H)}cancelRunById(F){this.f.get(F)?.cancel()}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,J,ee,V,H,_){const ne=this.c.get(V);if(ne)return ne.createRun(H);const he=I.fromPublic(J,ee,V,_),re=v(V);this.g.$startedExtensionTestRun({controllerId:J,continuous:!!V.continuous,profile:re&&{group:j[re.kind],id:re.profileId},exclude:V.exclude?.map(pe=>n.$gL.fromExtHostTestItem(pe,ee.root.id).toString())??[],id:he.id,include:V.include?.map(pe=>n.$gL.fromExtHostTestItem(pe,ee.root.id).toString())??[ee.root.id],preserveFocus:V.preserveFocus??!0,persist:_});const ve=this.j(V,he,V.profile,F);return R.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(he.id)}),ve.createRun(H)}j(F,J,ee,V,H){const _=new k(J,this.g,this.h,ee,V,H);return this.c.set(F,_),this.f.set(_.id,_),_}}e.$Foc=D;const v=M=>{if(M.profile){if(!(M.profile instanceof U))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class I{static fromPublic(F,J,ee,V){return new I(F,(0,S.$Wg)(),ee.include?.map(H=>n.$gL.fromExtHostTestItem(H,F).toString())??[F],ee.exclude?.map(H=>n.$gL.fromExtHostTestItem(H,F).toString())??[],V,J)}static fromInternal(F,J){return new I(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,J)}constructor(F,J,ee,V,H,_){this.controllerId=F,this.id=J,this.isPersisted=H,this.colllection=_,this.c=ee.map(ne=>ne+n.TestIdPathParts.Delimiter),this.f=V.map(ne=>ne+n.TestIdPathParts.Delimiter)}isIncluded(F){const J=n.$gL.fromExtHostTestItem(F,this.controllerId).toString()+n.TestIdPathParts.Delimiter;for(const ee of this.f)if(J===ee||J.startsWith(ee))return!1;for(const ee of this.c)if(J===ee||J.startsWith(ee))return!0;return!1}}e.$Goc=I;class w{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,u.TestItem.toPlain(F.item)),this.c.has(F)||this.f.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.f.delete(F);const J=n.$gL.parentId(F.item.extId);if(J&&this.h.has(J.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{c:F,f:J,g:ee}=this;return{get added(){return[...F].map(V=>V.revived)},get updated(){return[...J].map(V=>V.revived)},get removed(){return[...ee].map(V=>V.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends i.$pL{constructor(){super(...arguments),this.y=new R.$he,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}x(F,J){return{...F,revived:u.TestItem.toPlain(F.item),depth:J?J.depth+1:0,children:new Set}}w(){return new w(this.y)}}class N{constructor(F){this.f=F}checkout(){this.c||(this.c=this.g());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(J=>J.revived)},dispose:(0,L.$db)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}g(){const F=new y({asCanonicalUri:J=>J});return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}const O=(M,F,J,ee)=>{J?Object.assign(J,ee):F.$updateTestRunConfig(M.controllerId,M.profileId,ee)};class U{#e;#t;#i;#n;#s;get label(){return this.f}set label(F){F!==this.f&&(this.f=F,O(this,this.#e,this.#n,{label:F}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(F){F!==this.g&&(this.g=F,O(this,this.#e,this.#n,{supportsContinuousRun:F}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?this.#t.add(this.profileId):this.#t.delete(this.profileId),O(this,this.#e,this.#n,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,O(this,this.#e,this.#n,{tag:F?u.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,O(this,this.#e,this.#n,{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return R.Event.chain(this.#i,F=>F.map(J=>J.get(this.controllerId)?.get(this.profileId)).filter(C.$ig))}constructor(F,J,ee,V,H,_,ne,he,re,ve=!1,pe=void 0,Q=!1){this.controllerId=H,this.profileId=_,this.f=ne,this.kind=he,this.runHandler=re,this._tag=pe,this.g=Q,this.#e=F,this.#s=J,this.#t=ee,this.#i=V,J.set(_,this);const B=j[he];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${he}`);ve&&ee.add(_),this.#n={profileId:_,controllerId:H,tag:pe?u.TestTag.namespace(this.controllerId,pe.id):null,label:ne,group:B,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:Q},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Hoc=U;const j={[f.TestRunProfileKind.Coverage]:i.TestRunProfileBitset.Coverage,[f.TestRunProfileKind.Debug]:i.TestRunProfileBitset.Debug,[f.TestRunProfileKind.Run]:i.TestRunProfileBitset.Run};function z(M,F){for(let J=0;J<M.path.length;J++){const ee=F.find(V=>V.id===M.path[J]);if(!ee)return;if(J===M.path.length-1)return ee;F=ee.children}}}),define(ye[166],Se([1,0,65,14,132,17,10]),function(de,e,r,m,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8O=e.$7O=e.$6O=void 0;class T{static{this.c=new A.$4O("TextEditorDecorationType")}constructor(d,P,b){const a=T.c.nextId();d.$registerTextEditorDecorationType(P.identifier,a,R.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:a,dispose(){d.$removeTextEditorDecorationType(a)}})}}e.$6O=T;class p{constructor(d,P){this.g=[],this.h=void 0,this.j=!1,this.c=d,this.d=d.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(d,P){this.k();let b=null;if(d instanceof L.$xM)b=new L.$yM(d,d);else if(d instanceof L.$yM)b=d;else throw new Error("Unrecognized location");this.l(b,P,!1)}insert(d,P){this.k(),this.l(new L.$yM(d,d),P,!0)}delete(d){this.k();let P=null;if(d instanceof L.$yM)P=d;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(d,P,b){const a=this.c.validateRange(d);this.g.push({range:a,text:P,forceMoveMarkers:b})}setEndOfLine(d){if(this.k(),d!==L.EndOfLine.LF&&d!==L.EndOfLine.CRLF)throw(0,m.$7)("endOfLine");this.h=d}}class c{constructor(d,P,b,a){this.c=d,this.d=P,this._accept(b),this.e=a;const u=this;this.value={get tabSize(){return u.f},set tabSize(f){u.n(f)},get indentSize(){return u.g},set indentSize(f){u.p(f)},get insertSpaces(){return u.j},set insertSpaces(f){u.s(f)},get cursorStyle(){return u.k},set cursorStyle(f){u.t(f)},get lineNumbers(){return u.l},set lineNumbers(f){u.u(f)}}}_accept(d){this.f=d.tabSize,this.g=d.indentSize,this.h=d.originalIndentSize,this.j=d.insertSpaces,this.k=d.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(d.lineNumbers)}m(d){if(d==="auto")return"auto";if(typeof d=="number"){const P=Math.floor(d);return P>0?P:null}if(typeof d=="string"){const P=parseInt(d,10);return isNaN(P)?null:P>0?P:null}return null}n(d){const P=this.m(d);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(d){if(d==="tabSize")return"tabSize";if(typeof d=="number"){const P=Math.floor(d);return P>0?P:null}if(typeof d=="string"){const P=parseInt(d,10);return isNaN(P)?null:P>0?P:null}return null}p(d){const P=this.o(d);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(d){return d==="auto"?"auto":d==="false"?!1:!!d}s(d){const P=this.q(d);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(d){this.k!==d&&(this.k=d,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:d})))}u(d){this.l!==d&&(this.l=d,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(d)})))}assign(d){const P={};let b=!1;if(typeof d.tabSize<"u"){const a=this.m(d.tabSize);a==="auto"?(b=!0,P.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,b=!0,P.tabSize=a)}if(typeof d.indentSize<"u"){const a=this.o(d.indentSize);a==="tabSize"?(b=!0,P.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,b=!0,P.indentSize=a)}if(typeof d.insertSpaces<"u"){const a=this.q(d.insertSpaces);a==="auto"?(b=!0,P.insertSpaces=a):this.j!==a&&(this.j=a,b=!0,P.insertSpaces=a)}typeof d.cursorStyle<"u"&&this.k!==d.cursorStyle&&(this.k=d.cursorStyle,b=!0,P.cursorStyle=d.cursorStyle),typeof d.lineNumbers<"u"&&this.l!==d.lineNumbers&&(this.l=d.lineNumbers,b=!0,P.lineNumbers=R.TextEditorLineNumbersStyle.from(d.lineNumbers)),b&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(d,P){P.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${d}' failed:'`),this.e.warn(b)})}}e.$7O=c;class C{constructor(d,P,b,a,u,f,g,n){this.id=d,this.j=P,this.k=b,this.g=!1,this.h=new Set,this.c=u,this.d=new c(this.j,this.id,f,b),this.e=g,this.f=n;const s=this;this.value=Object.freeze({get document(){return a.value},set document(i){throw new m.$9("document")},get selection(){return s.c&&s.c[0]},set selection(i){if(!(i instanceof L.$zM))throw(0,m.$7)("selection");s.c=[i],s.l()},get selections(){return s.c},set selections(i){if(!Array.isArray(i)||i.some(t=>!(t instanceof L.$zM)))throw(0,m.$7)("selections");s.c=i,s.l()},get visibleRanges(){return s.e},set visibleRanges(i){throw new m.$9("visibleRanges")},get options(){return s.d.value},set options(i){s.g||s.d.assign(i)},get viewColumn(){return s.f},set viewColumn(i){throw new m.$9("viewColumn")},edit(i,t={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new p(a.value,t);return i(l),s.m(l)},insertSnippet(i,t,l={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=s.c.map(o=>R.Range.from(o));else if(t instanceof L.$xM){const{lineNumber:o,column:$}=R.Position.from(t);h=[{startLineNumber:o,startColumn:$,endLineNumber:o,endColumn:$}]}else if(t instanceof L.$yM)h=[R.Range.from(t)];else{h=[];for(const o of t)if(o instanceof L.$yM)h.push(R.Range.from(o));else{const{lineNumber:$,column:E}=R.Position.from(o);h.push({startLineNumber:$,startColumn:E,endLineNumber:$,endColumn:E})}}return P.$tryInsertSnippet(d,a.value.version,i.value,h,l)},setDecorations(i,t){const l=t.length===0;l&&!s.h.has(i.key)||(l?s.h.delete(i.key):s.h.add(i.key),s.n(()=>{if(R.$VO(t))return P.$trySetDecorations(d,i.key,R.$WO(t));{const h=new Array(4*t.length);for(let o=0,$=t.length;o<$;o++){const E=t[o];h[4*o]=E.start.line+1,h[4*o+1]=E.start.character+1,h[4*o+2]=E.end.line+1,h[4*o+3]=E.end.character+1}return P.$trySetDecorationsFast(d,i.key,h)}}))},revealRange(i,t){s.n(()=>P.$tryRevealRange(d,R.Range.from(i),t||L.TextEditorRevealType.Default))},show(i){P.$tryShowEditor(d,R.ViewColumn.from(i))},hide(){P.$tryHideEditor(d)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(d){(0,r.ok)(!this.g),this.d._accept(d)}_acceptVisibleRanges(d){(0,r.ok)(!this.g),this.e=d}_acceptViewColumn(d){(0,r.ok)(!this.g),this.f=d}_acceptSelections(d){(0,r.ok)(!this.g),this.c=d}async l(){const d=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,d)),this.value}m(d){const P=d.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const b=P.edits.map(u=>u.range);b.sort((u,f)=>u.end.line===f.end.line?u.end.character===f.end.character?u.start.line===f.start.line?u.start.character-f.start.character:u.start.line-f.start.line:u.end.character-f.end.character:u.end.line-f.end.line);for(let u=0,f=b.length-1;u<f;u++){const g=b[u].end;if(b[u+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=P.edits.map(u=>({range:R.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,a,{setEndOfLine:typeof P.setEndOfLine=="number"?R.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(d){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$8O=C}),define(ye[78],Se([1,0,65,4,3,2,5,6,162,20,166,17,12,29,15,40,49]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0O=e.$9O=void 0;class f{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(s,i){this.h=s,this.i=i,this.a=null,this.b=new Map,this.c=new P.$Ac,this.d=new m.$he,this.e=new m.$he,this.f=new m.$he,this.g=new m.$he,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const i=[],t=[],l=[];if(s.removedDocuments)for(const h of s.removedDocuments){const o=R.URI.revive(h),$=this.c.get(o);$?.unref()&&(this.c.delete(o),i.push($.value))}if(s.addedDocuments)for(const h of s.addedDocuments){const o=R.URI.revive(h.uri);let $=this.c.get(o);if($&&o.scheme!==b.Schemas.vscodeNotebookCell&&o.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);$||($=new f(new p.$2O(this.h.getProxy(T.$uM.MainThreadDocuments),o,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty)),this.c.set(o,$),t.push($.value)),$.ref()}if(s.removedEditors)for(const h of s.removedEditors){const o=this.b.get(h);this.b.delete(h),o&&l.push(o)}if(s.addedEditors)for(const h of s.addedEditors){const o=R.URI.revive(h.documentUri);r.ok(this.c.has(o),`document '${o}' does not exist`),r.ok(!this.b.has(h.id),`editor '${h.id}' already exists!`);const $=this.c.get(o).value,E=new C.$8O(h.id,this.h.getProxy(T.$uM.MainThreadTextEditors),this.i,new u.$V(()=>$.document),h.selections.map(S.Selection.to),h.options,h.visibleRanges.map(k=>S.Range.to(k)),typeof h.editorPosition=="number"?S.ViewColumn.to(h.editorPosition):void 0);this.b.set(h.id,E)}s.newActiveEditor!==void 0&&(r.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,A.$Pc)(i),(0,A.$Pc)(l),s.removedDocuments&&this.e.fire(i),s.addedDocuments&&this.d.fire(t),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(h=>h.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return a.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const i=this.b.get(this.a);return s?i:i?.value}allEditors(){return[...this.b.values()]}};e.$9O=g,e.$9O=g=Je([Ge(0,c.$YO),Ge(1,d.$7j)],g),e.$0O=(0,L.$Ai)("IExtHostDocumentsAndEditors")}),define(ye[370],Se([1,0,19,4,6,166,17,10]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class p{constructor(C,S){this.i=S,this.a=new m.$he,this.b=new m.$he,this.c=new m.$he,this.d=new m.$he,this.f=new m.$he,this.g=new m.$he,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=C.getProxy(A.$uM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(d=>this.g.fire(d)),this.i.onDidChangeActiveTextEditor(d=>this.f.fire(d))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(C){const S=this.i.allEditors();return C?S:S.map(d=>d.value)}async showTextDocument(C,S,d){let P;typeof S=="number"?P={position:L.ViewColumn.from(S),preserveFocus:d}:typeof S=="object"?P={position:L.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?L.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:P={preserveFocus:!1};const b=await this.h.$tryShowTextDocument(C.uri,P),a=b&&this.i.getEditor(b);if(a)return a.value;throw b?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}createTextEditorDecorationType(C,S){return new R.$6O(this.h,C,S).value}$acceptEditorPropertiesChanged(C,S){const d=this.i.getEditor(C);if(!d)throw new Error("unknown text editor");if(S.options&&d._acceptOptions(S.options),S.selections){const P=S.selections.selections.map(L.Selection.to);d._acceptSelections(P)}if(S.visibleRanges){const P=r.$Hb(S.visibleRanges.map(L.Range.to));d._acceptVisibleRanges(P)}if(S.options&&this.b.fire({textEditor:d.value,options:{...S.options,lineNumbers:L.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const P=T.TextEditorSelectionChangeKind.fromValue(S.selections.source),b=S.selections.selections.map(L.Selection.to);this.a.fire({textEditor:d.value,selections:b,kind:P})}if(S.visibleRanges){const P=r.$Hb(S.visibleRanges.map(L.Range.to));this.c.fire({textEditor:d.value,visibleRanges:P})}}$acceptEditorPositionData(C){for(const S in C){const d=this.i.getEditor(S);if(!d)throw new Error("Unknown text editor");const P=L.ViewColumn.to(C[S]);d.value.viewColumn!==P&&(d._acceptViewColumn(P),this.d.fire({textEditor:d.value,viewColumn:P}))}}getDiffInformation(C){return Promise.resolve(this.h.$getDiffInformation(C))}}e.$1mc=p}),define(ye[371],Se([1,0,2,5,6,3,10,17,24,41,18]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=e.$Joc=void 0,e.$Joc=(0,m.$Ai)("IExtHostTimeline");class S{constructor(b,a){this.b=new Map,this.c=new Map,this.a=b.getProxy(A.$uM.MainThreadTimeline),a.registerArgumentProcessor({processArgument:(u,f)=>{if(u&&u.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(u.source)&&p.$Wm.equals(f,this.b.get(u.source)?.extension)){const g=u.uri===void 0?void 0:r.URI.revive(u.uri);return this.c.get(u.source)?.get(d(g))?.get(u.handle)}else return;return u}})}async $getTimeline(b,a,u,f){return this.b.get(b)?.provider.provideTimeline(r.URI.revive(a),u,f)}registerTimelineProvider(b,a,u,f){const g=new R.$Tc,n=this.d(a.id,f,g).bind(this);let s;a.onDidChange&&(s=a.onDidChange(t=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...t,id:a.id}),this));const i=this.c;return this.f({...a,scheme:b,onDidChange:void 0,async provideTimeline(t,l,h){l?.resetCache&&(g.clear(),i.get(a.id)?.clear());const o=await a.provideTimeline(t,l,h);if(o==null)return;const $=n(t,l);return{...o,source:a.id,items:o.items.map($)}},dispose(){for(const t of i.values())t.get(a.id)?.clear();s?.dispose(),g.dispose()}},u)}d(b,a,u){return(f,g)=>{let n;if(g?.cacheResults){let s=this.c.get(b);s===void 0&&(s=new Map,this.c.set(b,s));const i=d(f);n=s.get(i),n===void 0&&(n=new Map,s.set(i,n))}return s=>{const{iconPath:i,...t}=s,l=`${b}|${s.id??s.timestamp}`;n?.set(l,s);let h,o,$;s.iconPath&&(i instanceof L.$tN?$={id:i.id,color:i.color}:r.URI.isUri(i)?(h=i,o=i):{light:h,dark:o}=i);let E;return L.$YM.isMarkdownString(t.tooltip)?E=T.MarkdownString.from(t.tooltip):(0,C.$ag)(t.tooltip)?E=t.tooltip:L.$YM.isMarkdownString(t.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=T.MarkdownString.from(t.detail)):(0,C.$ag)(t.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=t.detail),{...t,id:t.id??void 0,handle:l,source:b,command:s.command?a.toInternal(s.command,u):void 0,icon:h,iconDark:o,themeIcon:$,tooltip:E,accessibilityInformation:s.accessibilityInformation}}}}f(b,a){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:a}),(0,R.$Sc)(()=>{for(const f of this.c.values())f.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Koc=S;function d(P){return P?.toString()}}),define(ye[372],Se([1,0,241,23,2,4,3,303,9,10,18,19,17,86,21,197,26]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=void 0;function f(s,i){if((0,C.$ag)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class g extends L.$Uc{constructor(i,t,l){super(),this.f=i,this.g=t,this.h=l,this.a=new Map,this.b=new a.$00;function h(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:o=>h(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map($=>h($)?this.r($):$):o})}registerTreeDataProvider(i,t,l){const h=this.createTreeView(i,{treeDataProvider:t},l);return{dispose:()=>h.dispose()}}createTreeView(i,t,l){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],o=t.dragAndDropController?.dragMimeTypes??[],$=!!t.dragAndDropController?.handleDrag,E=!!t.dragAndDropController?.handleDrop,k=this.m(i,t,l),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:o,hasHandleDrag:$,hasHandleDrop:E,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(i,D),I={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,u.$UG)(l,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,u.$UG)(l,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(w){(0,P.$Zk)(w)&&(0,u.$UG)(l,"treeViewMarkdownMessage"),k.message=w},get title(){return k.title},set title(w){k.title=w},get description(){return k.description},set description(w){k.description=w},get badge(){return k.badge},set badge(w){w!==void 0&&c.ViewBadge.isViewBadge(w)?k.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(k.badge=void 0)},reveal:(w,y)=>k.reveal(w,y),dispose:async()=>{await v,this.a.delete(i),k.dispose()}};return this.B(I),I}$getChildren(i,t){const l=this.a.get(i);return l?l.getChildren(t):Promise.reject(new T.$dG(i))}async $handleDrop(i,t,l,h,o,$,E,k){const D=this.a.get(i);if(!D)return Promise.reject(new T.$dG(i));const v=d.DataTransfer.toDataTransfer(l,async I=>(await this.f.$resolveDropFileData(i,t,I)).buffer);return E===i&&k&&await this.j(v,D,k,o,$),D.onDrop(v,h,o)}async j(i,t,l,h,o){const $=this.b.removeDragOperationTransfer(o);if($)(await $)?.forEach((E,k)=>{E&&i.set(k,E)});else if(o&&t.handleDrag){const E=t.handleDrag(l,i,h);this.b.addDragOperationTransfer(o,E),await E}return i}async $handleDrag(i,t,l,h){const o=this.a.get(i);if(!o)return Promise.reject(new T.$dG(i));const $=await this.j(new c.$pN,o,t,h,l);if(!(!$||h.isCancellationRequested))return d.DataTransfer.from($)}async $hasResolve(i){const t=this.a.get(i);if(!t)throw new T.$dG(i);return t.hasResolve}$resolve(i,t,l){const h=this.a.get(i);if(!h)throw new T.$dG(i);return h.resolveTreeItem(t,l)}$setExpanded(i,t,l){const h=this.a.get(i);if(!h)throw new T.$dG(i);h.setExpanded(t,l)}$setSelectionAndFocus(i,t,l){const h=this.a.get(i);if(!h)throw new T.$dG(i);h.setSelectionAndFocus(t,l)}$setVisible(i,t){const l=this.a.get(i);if(!l){if(!t)return;throw new T.$dG(i)}l.setVisible(t)}$changeCheckboxState(i,t){const l=this.a.get(i);if(!l)throw new T.$dG(i);l.setCheckboxState(t)}m(i,t,l){const h=this.B(new n(i,t,this.f,this.g.converter,this.h,l));return this.a.set(i,h),h}r(i){const t=this.a.get(i.$treeViewId);return t&&"$treeItemHandle"in i?t.getExtensionElement(i.$treeItemHandle):t&&"$focusedTreeItem"in i&&i.$focusedTreeItem?t.focusedElement:null}}e.$Loc=g;class n extends L.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(i=>this.getExtensionElement(i)).filter(i=>!(0,C.$jg)(i))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(i,t,l,h,o,$){if(super(),this.I=i,this.J=l,this.L=h,this.M=o,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$he),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$he),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$he),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$he),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$he),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$he),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$he),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$se,$.contributes&&$.contributes.views)for(const v in $.contributes.views)for(const I of $.contributes.views[v])I.id===i&&(this.P=I.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>{Array.isArray(v)&&v.length===0||this.F.fire({message:!1,element:v})}));let E,k;const D=R.Event.debounce(this.F.event,(v,I)=>(v||(v={message:!1,elements:[]}),I.element!==!1&&(E||(E=new Promise(w=>k=w),this.G=this.G.then(()=>E)),Array.isArray(I.element)?v.elements.push(...I.element):v.elements.push(I.element)),I.message&&(v.message=!0),v),200,!0);this.B(D(({message:v,elements:I})=>{I.length&&(this.H=this.H.then(()=>{const w=k;return E=null,this.$(I).then(()=>w())})),v&&this.J.$setMessage(this.I,d.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(i){const t=i?this.getExtensionElement(i):void 0;if(i&&!t)return this.M.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let l=this.X(i);return l||(l=await this.Y(t)),l?l.map(h=>h.item):void 0}getExtensionElement(i){return this.j.get(i)}reveal(i,t){t=t||{select:!0,focus:!1};const l=(0,C.$jg)(t.select)?!0:t.select,h=(0,C.$jg)(t.focus)?!1:t.focus,o=(0,C.$jg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.G.then(()=>this.S(i)).then($=>this.W(i,$[$.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:$.map(k=>k.item)},{select:l,focus:h,expand:o})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:l,focus:h,expand:o})}get message(){return this.O}set message(i){this.O=i,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(i){this.P=i,this.J.$setTitle(this.I,i,this.Q)}get description(){return this.Q}set description(i){this.Q=i,this.J.$setTitle(this.I,this.P,i)}get badge(){return this.R}set badge(i){this.R?.value===i?.value&&this.R?.tooltip===i?.tooltip||(this.R=d.ViewBadge.from(i),this.J.$setBadge(this.I,i))}setExpanded(i,t){const l=this.getExtensionElement(i);l&&(t?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(i,t){const l=!(0,S.$ub)(this.s,i);this.s=i;const h=this.t!==t;this.t=t,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),h&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this.r&&(this.r=i,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(i){const t=(await Promise.all(i.map(async l=>{const h=this.getExtensionElement(l.treeItemHandle);return h?{extensionItem:h,treeItem:await this.f.getTreeItem(h),newState:l.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);t.forEach(l=>{l.treeItem.checkboxState=l.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(l=>[l.extensionItem,l.newState])})}async handleDrag(i,t,l){const h=[];for(const o of i){const $=this.getExtensionElement(o);$&&h.push($)}if(!(!this.g?.handleDrag||h.length===0))return await this.g.handleDrag(h,t,l),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(i,t,l){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.g?.handleDrop))return(0,p.$sh)(()=>this.g?.handleDrop?this.g.handleDrop(h,i,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(i,t){if(!this.f.resolveTreeItem)return;const l=this.j.get(i);if(l){const h=this.m.get(l);if(h){const o=await this.f.resolveTreeItem(h.extensionItem,l,t)??h.extensionItem;return this.hb(o),h.item.tooltip=this.eb(o.tooltip),h.item.command=this.fb(h.disposableStore,o.command),h.item}}}S(i){return this.U(i).then(t=>t?this.S(t).then(l=>this.W(t,l[l.length-1]).then(h=>(l.push(h),l))):Promise.resolve([]))}U(i){const t=this.m.get(i);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$sh)(()=>this.f.getParent(i))}W(i,t){const l=this.m.get(i);return l?Promise.resolve(l):(0,p.$sh)(()=>this.f.getTreeItem(i)).then(h=>this.kb(i,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const o=this.getExtensionElement(h);if(o){const $=this.m.get(o);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.N.identifier.value}`)}))}X(i){if(i){let t;if(typeof i=="string"){const l=this.getExtensionElement(i);t=l?this.m.get(l):void 0}else t=i;return t&&t.children||void 0}return this.h}async Y(i){this.rb(i);const t=new b.$se(this.Z.token);try{const l=i?this.m.get(i):void 0,h=await this.f.getChildren(i);if(t.token.isCancellationRequested)return;const o=(0,S.$Hb)(h||[]),$=await Promise.all((0,S.$Hb)(o).map(k=>this.f.getTreeItem(k)));if(t.token.isCancellationRequested)return;const E=$.map((k,D)=>k?this.db(o[D],k,l):null);return(0,S.$Hb)(E)}finally{t.dispose()}}$(i){if(i.some(l=>!l))return this.Z.dispose(!0),this.Z=new b.$se,this.tb(),this.J.$refresh(this.I);{const l=this.ab(i);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(i){const t=new Set,l=i.map(o=>this.m.get(o));for(const o of l)if(o&&!t.has(o.item.handle)){let $=o;for(;$&&$.parent&&l.findIndex(E=>$&&$.parent&&E&&E.item.handle===$.parent.item.handle)===-1;){const E=this.j.get($.parent.item.handle);$=E?this.m.get(E):void 0}$&&!$.parent&&t.add(o.item.handle)}const h=[];return t.forEach(o=>{const $=this.j.get(o);if($){const E=this.m.get($);E&&(!E.parent||!t.has(E.parent.item.handle))&&h.push(o)}}),h}bb(i){const t={};return Promise.all(i.map(l=>this.cb(l).then(h=>{h&&(t[l]=h.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(i){const t=this.getExtensionElement(i);if(t){const l=this.m.get(t);if(l)return this.rb(t),(0,p.$sh)(()=>this.f.getTreeItem(t)).then(h=>{if(h){const o=this.ib(t,h,l.parent);return this.pb(t,o,l,l.parent),l.dispose(),o}return null})}return Promise.resolve(null)}db(i,t,l){const h=this.ib(i,t,l);if(t.id&&this.j.has(h.item.handle))throw new Error((0,r.localize)(0,null,t.id));return this.ob(i,h),this.qb(h,l),h}eb(i){return c.$YM.isMarkdownString(i)?d.MarkdownString.from(i):i}fb(i,t){return t?{...this.L.toInternal(t,i),originalId:t.command}:void 0}gb(i){if(i.checkboxState===void 0)return;let t,l,h;return typeof i.checkboxState=="number"?t=i.checkboxState:(t=i.checkboxState.state,l=i.checkboxState.tooltip,h=i.checkboxState.accessibilityInformation),{isChecked:t===c.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:h}}hb(i){if(!c.$kN.isTreeItem(i,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(i,t,l){this.hb(t);const h=this.B(new L.$Tc),o=this.kb(i,t,l),$=this.lb(t);return{item:{handle:o,parentHandle:l?l.item.handle:void 0,label:f(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(h,t.command),contextValue:t.contextValue,icon:$,iconDark:this.mb(t)||$,themeIcon:this.jb(t),collapsibleState:(0,C.$jg)(t.collapsibleState)?c.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:l,children:void 0,disposableStore:h,dispose(){h.dispose()}}}jb(i){return i.iconPath instanceof c.$tN?i.iconPath:void 0}kb(i,{id:t,label:l,resourceUri:h},o,$){if(t)return`${n.b}/${t}`;const E=f(l,this.N),k=o?o.item.handle:n.a;let D=E?E.label:h?(0,m.$$g)(h):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const v=this.m.has(i)?this.m.get(i).item.handle:void 0,I=this.X(o)||[];let w,y=0;do{if(w=`${k}/${y}:${D}`,$||!this.j.has(w)||v===w)break;y++}while(y<=I.length);return w}lb(i){if(i.iconPath&&!(i.iconPath instanceof c.$tN))return typeof i.iconPath=="string"||A.URI.isUri(i.iconPath)?this.nb(i.iconPath):this.nb(i.iconPath.light)}mb(i){if(i.iconPath&&!(i.iconPath instanceof c.$tN)&&i.iconPath.dark)return this.nb(i.iconPath.dark)}nb(i){return A.URI.isUri(i)?i:A.URI.file(i)}ob(i,t){this.j.set(t.item.handle,i),this.m.set(i,t)}pb(i,t,l,h){this.j.delete(t.item.handle),this.m.delete(i),t.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(i,t);const o=this.X(h)||[],$=o.filter(E=>E.item.handle===l.item.handle)[0];$&&o.splice(o.indexOf($),1,t)}qb(i,t){t?(t.children||(t.children=[]),t.children.push(i)):(this.h||(this.h=[]),this.h.push(i))}rb(i){if(i){const t=this.m.get(i);if(t){if(t.children)for(const l of t.children){const h=this.j.get(l.item.handle);h&&this.sb(h)}t.children=void 0}}else this.tb()}sb(i){const t=this.m.get(i);if(t){if(t.children)for(const l of t.children){const h=this.j.get(l.item.handle);h&&this.sb(h)}this.m.delete(i),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(i=>i.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ye[373],Se([1,0,4,3,2,32,17,97,6,10]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;class C extends m.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(b,a,u,f){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$he),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$he),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=a,this.#n=u,this.#i=f.viewType,this.#s=f.panelOptions,this.#o=f.viewColumn,this.#r=f.title,this.#l=f.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(b){this.c(),this.#r!==b&&(this.#r=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,A.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(b){this.#u||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#l=b.active,this.#c=b.visible,this.#o=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:L.ViewColumn.from(b),preserveFocus:!!a})}c(){if(this.#u)throw new Error("Webview is disposed")}}class S extends m.$Uc{static c(){return(0,R.$Wg)()}constructor(b,a,u){super(),this.j=a,this.m=u,this.g=new Map,this.h=new Map,this.f=b.getProxy(p.$uM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,a,u,f,g={}){const n=typeof f=="object"?f.viewColumn:f,s={viewColumn:L.ViewColumn.from(n),preserveFocus:typeof f=="object"&&!!f.preserveFocus},i=(0,T.$dnc)(b),t=S.c();this.f.$createWebviewPanel((0,T.$fnc)(b),t,a,{title:u,panelOptions:d(g),webviewOptions:(0,T.$gnc)(b,this.m,g),serializeBuffersForPostMessage:i},s);const l=this.j.createNewWebview(t,g,b);return this.createNewWebviewPanel(t,a,u,n,g,l,!0)}$onDidChangeWebviewPanelViewStates(b){const a=Object.keys(b);a.sort((u,f)=>{const g=b[u],n=b[f];return g.active?1:n.active?-1:+g.visible-+n.visible});for(const u of a){const f=this.getWebviewPanel(u);if(!f)continue;const g=b[u];f._updateViewState({active:g.active,visible:g.visible,viewColumn:L.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,a,u){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:u,extension:b}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,T.$dnc)(b)}),new c.$wM(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(b,a,u,f){const g=this.h.get(a);if(!g)throw new Error(`No serializer found for '${a}'`);const{serializer:n,extension:s}=g,i=this.j.createNewWebview(b,u.webviewOptions,s),t=this.createNewWebviewPanel(b,a,u.title,f,u.panelOptions,i,u.active);await n.deserializeWebviewPanel(t,u.state)}createNewWebviewPanel(b,a,u,f,g,n,s){const i=new C(b,this.f,n,{viewType:a,title:u,viewColumn:f,panelOptions:g,active:s});return this.g.set(b,i),i}getWebviewPanel(b){return this.g.get(b)}}e.$hnc=S;function d(P){return{enableFindWidget:P.enableFindWidget,retainContextWhenHidden:P.retainContextWhenHidden}}}),define(ye[374],Se([1,0,4,3,97,17,6,10]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=void 0;class p extends m.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(S,d,P,b,a,u){super(),this.#s=!1,this.#l=this.B(new r.$he),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$he),this.onDidDispose=this.#u.event,this.#i=P,this.#a=b,this.#e=S,this.#t=d,this.#n=a,this.#r=u}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#o}set description(S){this.a(),this.#o!==S&&(this.#o=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(S){S===this.#r||this.#s||(this.#r=S,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(S,d){this.d=d,this.b=new Map,this.c=new Map,this.a=S.getProxy(L.$uM.MainThreadWebviewViews)}registerWebviewViewProvider(S,d,P,b){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:P,extension:S}),this.a.$registerWebviewViewProvider((0,A.$fnc)(S),d,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$dnc)(S)}),new T.$wM(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(S,d,P,b,a){const u=this.b.get(d);if(!u)throw new Error(`No view provider found for '${d}'`);const{provider:f,extension:g}=u,n=this.d.createNewWebview(S,{},g),s=new p(S,this.a,d,P,n,!0);this.c.set(S,s),await f.resolveWebviewView(s,{state:b},a)}async $onDidChangeWebviewViewVisibility(S,d){this.e(S)._setVisible(d)}async $disposeWebviewView(S){const d=this.e(S);this.c.delete(S),d.dispose(),this.d.deleteWebview(S)}e(S){const d=this.c.get(S);if(!d)throw new Error("No webview found");return d}}e.$Ooc=c}),define(ye[375],Se([1,0,75,15,12,276,28,11]),function(de,e,r,m,A,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=void 0;let p=class{constructor(S,d){S.addFileSystemProvider(m.Schemas.file,new c(d),{isCaseSensitive:T.$k})}};e.$tpc=p,e.$tpc=p=Je([Ge(0,r.$_mc),Ge(1,A.$7j)],p);class c{constructor(S){this.b=S,this.a=new R.$hr(this.b)}async stat(S){const d=await this.a.stat(S);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(S){return this.a.readdir(S)}createDirectory(S){return this.a.mkdir(S)}readFile(S){return this.a.readFile(S)}writeFile(S,d,P){return this.a.writeFile(S,d,{...P,unlock:!1,atomic:!1})}delete(S,d){return this.a.delete(S,{...d,useTrash:!1,atomic:!1})}rename(S,d,P){return this.a.rename(S,d,P)}copy(S,d,P){return this.a.copy(S,d,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(S,d){throw new Error("Method not implemented.")}}}),define(ye[376],Se([1,0,16,67,32,37,3,6,2,20]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=void 0;let C=class extends L.$Uc{constructor(d,P){super();const b=d.getProxy(T.$uM.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async a=>{const u=p.URI.file((0,r.$jc)((0,m.tmpdir)(),(0,A.$Wg)()));return await b.$download(a,u),u})}};e.$rpc=C,e.$rpc=C=Je([Ge(0,c.$YO),Ge(1,R.$iP)],C)}),define(ye[377],Se([1,0,58,16,2,98,3,15,9,34]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=void 0;class C extends R.$bnc{constructor(){super(...arguments),this.i=null}async g(t){const l=await super.g(t);if(l.scheme!==T.Schemas.file)return l;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${l.fsPath}.`),l;const h=l.fsPath;let o=0;do{let $;o===0?$=h:$=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${o}`:`${h}-${o}`,await S($);const E=m.$jc($,"vscode.lock"),k=await a(this.d,E,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),A.URI.file($);o++}while(o<10);return l}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Dpc=C;async function S(i){try{await c.Promises.stat(i);return}catch{}try{await c.Promises.mkdir(i,{recursive:!0})}catch{}}const d=1e3,P=10*60*1e3;class b extends L.$Uc{constructor(t,l){super(),this.b=t,this.c=l,this.a=this.B(new p.$Lh),this.a.cancelAndSet(async()=>{const h=await u(t,l);(!h||h.pid!==process.pid)&&(t.info(`Lock '${l}': The lock was lost unexpectedly.`),this.a.cancel());try{await c.Promises.utimes(l,new Date,new Date)}catch(o){t.error(o),t.info(`Lock '${l}': Could not update mtime.`)}},d)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const l={pid:process.pid,willReleaseAt:Date.now()+t};await c.Promises.writeFile(this.c,JSON.stringify(l),{flag:"w"})}catch(l){this.b.error(l)}}}async function a(i,t,l){try{const o={pid:process.pid,willReleaseAt:0};await c.Promises.writeFile(t,JSON.stringify(o),{flag:"wx"})}catch(o){i.error(o)}const h=await u(i,t);return!h||h.pid!==process.pid?l?(i.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(i.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(i,t)):(i.info(`Lock '${t}': Lock acquired.`),new b(i,t))}async function u(i,t){let l;try{l=await c.Promises.readFile(t)}catch(h){return i.error(h),null}try{return JSON.parse(String(l))}catch(h){return i.error(h),null}}async function f(i,t){let l;try{l=await c.Promises.stat(t)}catch(h){return i.error(h),0}return l.mtime.getTime()}function g(i){try{return process.kill(i,0),!0}catch{return!1}}async function n(i,t){const l=await u(i,t);if(!l)return i.info(`Lock '${t}': Could not read pid of lock holder.`),s(i,t);if(l.willReleaseAt){let k=l.willReleaseAt-Date.now();if(k<5e3){for(k>0?i.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):i.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,p.$Bh)(Math.min(100,k)),await f(i,t)===0)return s(i,t);k=l.willReleaseAt-Date.now()}return s(i,t)}}if(!g(l.pid))return i.info(`Lock '${t}': The pid ${l.pid} appears to be gone.`),s(i,t);const h=await f(i,t),o=Date.now()-h;if(o<=P)return i.info(`Lock '${t}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;i.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,p.$Bh)(2e3);const $=await f(i,t),E=Date.now()-$;return E<=P?(i.info(`Lock '${t}': The lock does not look stale, elapsed: ${E} ms, giving up.`),null):(i.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),s(i,t))}async function s(i,t){i.info(`Lock '${t}': Deleting a stale lock.`);try{await c.Promises.unlink(t)}catch{}return a(i,t,!0)}}),define(ye[378],Se([1,0,32,20,46,37]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=void 0;let L=class extends A.$xnc{constructor(p,c){super(!0,p,c)}createTerminal(p,c,C){return this.createTerminalFromOptions({name:p,shellPath:c,shellArgs:C})}createTerminalFromOptions(p,c){const C=new A.$wnc(this.a,(0,r.$Wg)(),p,p.name);return this.f.push(C),C.create(p,this.R(p,c)),C.value}};e.$Yoc=L,e.$Yoc=L=Je([Ge(0,R.$iP),Ge(1,m.$YO)],L)}),define(ye[379],Se([1,0,4,36,35,5]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=e.$PL=e.OutputChannelUpdateMode=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=void 0,e.$CL="text/x-code-output",e.$DL="output",e.$EL="Log",e.$FL="text/x-code-log-output",e.$GL="log",e.$HL="workbench.panel.output",e.$IL=new A.$Rj("inOutput",!1),e.$JL=new A.$Rj("activeLogOutput",!1),e.$KL=new A.$Rj("activeLogOutput.levelSettable",!1),e.$LL=new A.$Rj("activeLogOutput.level",""),e.$ML=new A.$Rj("activeLogOutput.levelIsDefault",!1),e.$NL=new A.$Rj("outputView.scrollLock",!1),e.$OL=(0,R.$Ai)("outputService");var L;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$PL={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new r.$he,this.onDidRegisterChannel=this.b.event,this.c=new r.$he,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(C=>c.push(C)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}m.$jo.add(e.$PL.OutputChannels,new T),e.$QL=new A.$Rj("activeOutputChannel","")}),define(ye[167],Se([1,0,6,5,20,24,12,379,75,30,63,202,22,18,28,4,3]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=e.$noc=void 0;class f extends L.$ak{get disposed(){return this.n}constructor(i,t,l,h,o){super(),this.id=i,this.name=t,this.r=l,this.s=h,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(i){this.append(i+`
`)}append(i){this.info(i)}clear(){const i=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,i)}replace(i){const t=this.m;this.info(i),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(i,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof i=="boolean"?i:t))}hide(){this.s.$close(this.id)}g(i,t){this.m+=d.$Je.fromString(t).byteLength,(0,L.log)(this.r,i,t),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class g extends f{appendLine(i){this.append(i)}}let n=class{constructor(i,t,l,h,o,$){this.i=t,this.j=l,this.k=h,this.l=o,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=i.getProxy(r.$uM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,S.$9m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(i){this.h=i;for(const[t,l]of this.g)l.visible=t===this.h}createOutputChannel(i,t,l){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,o=(0,P.$ag)(t)?t:void 0;if((0,P.$ag)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const E=this.i.environment.extensionLogLevel?.find(([D])=>R.$Wm.equals(l.identifier,D))?.[1];E&&($=(0,L.$lk)(E));const k=h?this.o(i,$,l):this.n(i,o,l);return k.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),h?this.r(i,$??this.m.getLevel(),k):this.q(i,k)}async n(i,t,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const h=await this.c,o=this.k.extUri.joinPath(h,`${this.f++}-${i.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(i,o,t,l.identifier.value);return new f(E,i,$,this.a,l)}async o(i,t,l){const h=await this.p(l),o=i.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(h,`${o}.log`),E=`${l.identifier.value}.${o}`,k=this.l.createLogger($,{id:E,name:i,logLevel:t,extensionId:l.identifier.value});return new g(E,i,k,this.a,l)}p(i){let t=this.d.get(i.identifier.value);if(!t){const l=this.k.extUri.joinPath(this.i.logsLocation,i.identifier.value);this.d.set(i.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(l)}catch(h){if((0,b.$kl)(h)!==b.FileSystemProviderErrorCode.FileExists)throw h}return l})())}return t}q(i,t){let l=!1;const h=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return i},append(o){h(),t.then($=>$.append(o))},appendLine(o){h(),t.then($=>$.appendLine(o))},clear(){h(),t.then(o=>o.clear())},replace(o){h(),t.then($=>$.replace(o))},show(o,$){h(),t.then(E=>E.show(o,$))},hide(){h(),t.then(o=>o.hide())},dispose(){l=!0,t.then(o=>o.dispose())}}}r(i,t,l){const h=new u.$Tc,o=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},$=h.add(new a.$he);function E(k){t=k,$.fire(k)}return l.then(k=>{h.add(k),k.logLevel!==t&&E(k.logLevel),h.add(k.onDidChangeLogLevel(D=>E(D)))}),{...this.q(i,l),get logLevel(){return t},onDidChangeLogLevel:$.event,trace(k,...D){o(),l.then(v=>v.trace(k,...D))},debug(k,...D){o(),l.then(v=>v.debug(k,...D))},info(k,...D){o(),l.then(v=>v.info(k,...D))},warn(k,...D){o(),l.then(v=>v.warn(k,...D))},error(k,...D){o(),l.then(v=>v.error(k,...D))},dispose(){h.dispose()}}}};e.$noc=n,e.$noc=n=Je([Ge(0,A.$YO),Ge(1,c.$cP),Ge(2,p.$_mc),Ge(3,C.$Omc),Ge(4,L.$8j),Ge(5,L.$7j)],n),e.$ooc=(0,m.$Ai)("IExtHostOutputService")}),define(ye[168],Se([1,0,5,9]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=void 0,e.$ln=(0,r.$Ai)("remoteAgentService"),e.$mn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let R=1/0;for(let T=0;T<this.maxSampleCount;T++){const p=await A.getRoundTripTime();if(p===void 0)return;R=Math.min(R,p/2),await(0,m.$Bh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((T,p)=>T+p,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((T,p)=>T+p,0)/this.average.length,high:typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(ye[380],Se([1,0,245,70,36,45,44,3,4,168,11,25,9,149]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohb=e.$nhb=e.$mhb=e.$lhb=e.$khb=e.$jhb=e.$ihb=e.$hhb=e.$ghb=void 0,e.$ghb=Object.freeze({id:"application",order:100,title:(0,r.localize)(0,null),type:"object"}),e.$hhb=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(1,null),type:"object"}),e.$ihb=Object.freeze({id:"security",scope:m.ConfigurationScope.APPLICATION,title:(0,r.localize)(2,null),type:"object",order:7}),e.$jhb=Object.freeze({id:"problems",title:(0,r.localize)(3,null),type:"object",order:101}),e.$khb=Object.freeze({id:"window",order:8,title:(0,r.localize)(4,null),type:"object"}),e.$lhb={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new p.$he,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const a=new b;A.$jo.add(e.$lhb.ConfigurationMigration,a);let u=class extends T.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,t){super(),this.a=i,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async l=>{for(const h of l.added)await this.f(h,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(l=>this.c(l)))}async c(i){await this.f(void 0,i);for(const t of this.b.getWorkspace().folders)await this.f(t,i)}async f(i,t){await Promise.all([t.map(l=>this.g(l,i?.uri))])}async g(i,t){const l=this.a.inspect(i.key,{resource:t}),h=this.b.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[o,$]of h){const E=l[o];if(!E)continue;const k=[];if(E.value!==void 0){const D=await this.h(i,o,E.value,t,void 0);for(const v of D??[])k.push([v,[]])}for(const{identifiers:D,value:v}of E.overrides??[])if(v!==void 0){const I=await this.h(i,o,v,t,D);for(const w of I??[])k.push([w,D])}k.length&&await Promise.allSettled(k.map(async([[D,v],I])=>this.a.updateValue(D,v.value,{resource:t,overrideIdentifiers:I},$)))}}async h(i,t,l,h,o){const $=k=>{const v=this.a.inspect(k,{resource:h})[t];if(v)return o?v.overrides?.find(({identifiers:I})=>(0,S.$ao)(I,o))?.value:v.value},E=await i.migrateFn(l,$);return Array.isArray(E)?E:[[i.key,E]]}};e.$mhb=u,e.$mhb=u=Je([Ge(0,L.$7i),Ge(1,R.$Ji)],u);let f=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new d.$Xh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!C.$i&&(await this.b.getEnvironment())?.os!==C.OperatingSystem.Windows)return;A.$jo.as(m.$oo.Configuration).registerConfiguration({...e.$ihb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(5,null)},default:[],markdownDescription:(0,r.localize)(6,null),scope:m.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(7,null),scope:m.ConfigurationScope.MACHINE}}})}};e.$nhb=f,e.$nhb=f=Je([Ge(0,c.$ln)],f);const g="window.newWindowProfile";let n=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(i,t){super(),this.c=i,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(l=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(l=>{l.source!==L.ConfigurationTarget.DEFAULT&&l.affectsConfiguration(g)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const i=A.$jo.as(m.$oo.Configuration),t={...e.$khb,properties:{[g]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(l=>l.name),null],enumItemLabels:[...this.c.profiles.map(l=>""),(0,r.localize)(8,null)],description:(0,r.localize)(9,null),scope:m.ConfigurationScope.APPLICATION}}};this.a?i.updateConfigurations({add:[t],remove:[this.a]}):i.registerConfiguration(t),this.a=t}h(){const i=this.f.getValue(g);this.b=i?this.c.profiles.find(t=>t.name===i):void 0}j(){const i=this.f.getValue(g);if(!i)return;const t=this.b?this.c.profiles.find(l=>l.id===this.b.id):void 0;i!==t?.name&&this.f.updateValue(g,t?.name)}};e.$ohb=n,e.$ohb=n=Je([Ge(0,P.$Gl),Ge(1,L.$7i)],n)}),define(ye[381],Se([1,0,39,15,16,23,257,380,70,5,36]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$qhb=e.$phb=void 0,e.$rhb=a,e.$shb=u,e.$phb=(0,c.$Ai)("editorResolverService"),e.$qhb="workbench.editorAssociations";const S=C.$jo.as(p.$oo.Configuration),d={...T.$hhb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(d);var P;(function(f){f.builtin="builtin",f.option="option",f.exclusive="exclusive",f.default="default"})(P||(e.RegisteredEditorPriority=P={}));var b;(function(f){f[f.ABORT=1]="ABORT",f[f.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function a(f){switch(f){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function u(f,g){if(new Set([m.Schemas.extension,m.Schemas.webviewPanel,m.Schemas.vscodeWorkspaceTrust,m.Schemas.vscodeSettings]).has(g.scheme))return!1;const i=typeof f=="string"&&f.indexOf(A.$gc.sep)>=0?`${g.scheme}:${g.path}`:(0,R.$$g)(g);return r.$tk(typeof f=="string"?f.toLowerCase():f,i.toLowerCase())}}),define(ye[382],Se([1,0,33,15,16,11,23,2,5,295,45,156,168]),function(de,e,r,m,A,R,L,T,p,c,C,S,d){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=e.$9L=void 0,e.$9L=(0,p.$Ai)("pathService");let b=P=class{constructor(u,f,g,n){this.d=u,this.e=f,this.f=g,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??u})()}hasValidBasename(u,f,g){return typeof f=="string"||typeof f>"u"?this.a.then(n=>this.h(u,n,f)):this.h(u,f,g)}h(u,f,g){return u.scheme===m.Schemas.file||u.scheme===m.Schemas.vscodeRemote?(0,r.$xg)(g??(0,L.$$g)(u),f===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,f){if(u.remoteAuthority)return m.Schemas.vscodeRemote;const g=(0,c.$6L)(f.getWorkspace());if(g)return g;const n=f.getWorkspace().folders[0];if(n)return n.uri.scheme;const s=f.getWorkspace().configuration;return s?s.scheme:m.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===R.OperatingSystem.Windows?A.$fc:A.$gc)}async fileURI(u){let f="";if(await this.a===R.OperatingSystem.Windows&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const n=u.indexOf("/",2);n===-1?(f=u.substring(2),u="/"):(f=u.substring(2,n),u=u.substring(n)||"/")}return T.URI.from({scheme:m.Schemas.file,authority:f,path:u,query:"",fragment:""})}};e.$0L=b,e.$0L=b=P=Je([Ge(1,d.$ln),Ge(2,S.$RL),Ge(3,C.$Ji)],b)}),define(ye[383],Se([1,0,259,60,4,61,3,2,44,265,12,71,150,93,45,156,26,21,18,25,35]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=e.OnPortForward=e.$WL=e.$VL=e.TunnelSource=e.TunnelCloseReason=e.$TL=e.$SL=void 0,e.$UL=o,e.$XL=k,e.$YL=D,e.$ZL=v,e.$1L=w;const i=10*1e3,t="remote.tunnels.toRestore",l="remote.tunnels.toRestoreExpiration",h=1e3*60*60*24*14;e.$SL="onTunnel",e.$TL=new s.$Rj("forwardedPortsViewEnabled",!1,r.localize(0,null));function o(O){const U=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(U)return{host:U[1]?.substring(0,U[1].length-1)||"localhost",port:Number(U[2])}}var $;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})($||(e.TunnelCloseReason=$={}));var E;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(E||(e.TunnelSource=E={})),e.$VL={source:E.User,description:r.localize(1,null)},e.$WL={source:E.Auto,description:r.localize(2,null)};function k(O,U,j){const z=O.get(v(U,j));if(z)return z;if((0,P.$xw)(U))for(const M of P.$ww){const F=v(M,j);if(O.has(F))return O.get(F)}else if((0,P.$zw)(U))for(const M of P.$yw){const F=v(M,j);if(O.has(F))return O.get(F)}}function D(O,U,j){const z=k(O,U,j);if(z)return z;const M=(0,P.$zw)(U)?"localhost":(0,P.$xw)(U)?"0.0.0.0":void 0;if(M)return k(O,M,j)}function v(O,U){return O+":"+U}var I;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})(I||(e.OnPortForward=I={}));function w(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}class y extends L.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(U){super(),this.r=U,this.j=[],this.n=new A.$he,this.onDidChangeAttributes=this.n.event,this.B(U.onDidChangeConfiguration(j=>{(j.affectsConfiguration(y.c)||j.affectsConfiguration(y.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(U,j,z){let M=this.w(U,j,z,this.j,0);const F={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const J=this.j[M];J.key===U?(F.onAutoForward=J.onAutoForward??F.onAutoForward,F.elevateIfNeeded=J.elevateIfNeeded!==void 0?J.elevateIfNeeded:F.elevateIfNeeded,F.label=J.label??F.label,F.requireLocalPort=J.requireLocalPort,F.protocol=J.protocol):(F.onAutoForward=F.onAutoForward??J.onAutoForward,F.elevateIfNeeded=F.elevateIfNeeded!==void 0?F.elevateIfNeeded:J.elevateIfNeeded,F.label=F.label??J.label,F.requireLocalPort=F.requireLocalPort!==void 0?F.requireLocalPort:void 0,F.protocol=F.protocol??J.protocol),M=this.w(U,j,z,this.j,M+1)}return F.onAutoForward!==void 0||F.elevateIfNeeded!==void 0||F.label!==void 0||F.requireLocalPort!==void 0||F.protocol!==void 0?F:this.C()}t(U){return U.start!==void 0&&U.end!==void 0}u(U){return U.host!==void 0&&U.port!==void 0&&(0,g.$ag)(U.host)&&(0,g.$eg)(U.port)}w(U,j,z,M,F){if(F>=M.length)return-1;const J=!(0,P.$xw)(j)&&!(0,P.$zw)(j),V=M.slice(F).findIndex(H=>(0,g.$eg)(H.key)?J?!1:H.key===U:this.t(H.key)?J?!1:U>=H.key.start&&U<=H.key.end:this.u(H.key)?U===H.key.port&&j===H.key.host:z?H.key.test(z):!1);return V>=0?V+F:-1}y(){const U=this.r.getValue(y.c);if(!U||!(0,g.$cg)(U))return[];const j=[];for(const M in U){if(M===void 0)continue;const F=U[M];let J;if(Number(M))J=Number(M);else if((0,g.$ag)(M))if(y.g.test(M)){const ee=M.match(y.g);J={start:Number(ee[1]),end:Number(ee[2])}}else if(y.h.test(M)){const ee=M.match(y.h);J={host:ee[1],port:Number(ee[2])}}else{let ee;try{ee=RegExp(M)}catch{}ee&&(J=ee)}J&&j.push({key:J,elevateIfNeeded:F.elevateIfNeeded,onAutoForward:F.onAutoForward,label:F.label,requireLocalPort:F.requireLocalPort,protocol:F.protocol})}const z=this.r.getValue(y.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(j)}z(U){function j(z,M){return(0,g.$eg)(z.key)?z.key:M.t(z.key)?z.key.start:M.u(z.key)?z.key.port:Number.MAX_VALUE}return U.sort((z,M)=>j(z,this)-j(M,this))}C(){return this.m}static providedActionToAction(U){switch(U){case P.ProvidedOnAutoForward.Notify:return I.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return I.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return I.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return I.OpenPreview;case P.ProvidedOnAutoForward.Silent:return I.Silent;case P.ProvidedOnAutoForward.Ignore:return I.Ignore;default:return}}async addAttributes(U,j,z){const F=this.r.inspect(y.c).userRemoteValue;let J;!F||!(0,g.$cg)(F)?J={}:J=(0,n.$9n)(F),J[`${U}`]||(J[`${U}`]={});for(const ee in j)J[`${U}`][ee]=j[ee];return this.r.updateValue(y.c,J,z)}}e.$2L=y;let N=class extends L.$Uc{constructor(U,j,z,M,F,J,ee,V,H,_){super(),this.H=U,this.I=j,this.J=z,this.L=M,this.M=F,this.N=J,this.O=ee,this.P=V,this.Q=H,this.R=_,this.c=new Map,this.g=new A.$he,this.onForwardPort=this.g.event,this.h=new A.$he,this.onClosePort=this.h.event,this.j=new A.$he,this.onPortName=this.j.event,this.n=new A.$he,this.onCandidatesChanged=this.n.event,this.t=new A.$he,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$he,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new y(z),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ne=>{const he=await this.getAttributes(ne.map(re=>({port:re.tunnelRemotePort,host:re.tunnelRemoteHost})));for(const re of ne)if(re.localAddress){const ve=v(re.tunnelRemoteHost,re.tunnelRemotePort),pe=D(this.m??new Map,re.tunnelRemoteHost,re.tunnelRemotePort);this.forwarded.set(ve,{remotePort:re.tunnelRemotePort,remoteHost:re.tunnelRemoteHost,localAddress:re.localAddress,protocol:he?.get(re.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(re.localAddress,he?.get(re.tunnelRemotePort)),localPort:re.tunnelLocalPort,runningProcess:pe?.detail,hasRunningProcess:!!pe,pid:pe?.pid,privacy:re.privacy,source:e.$VL}),this.f.set(ve,re)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ne=>{const he=v(ne.tunnelRemoteHost,ne.tunnelRemotePort);if(!D(this.forwarded,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!D(this.detected,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!D(this.c,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&ne.localAddress){const re=D(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort),ve=(await this.getAttributes([{port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost}]))?.get(ne.tunnelRemotePort);this.forwarded.set(he,{remoteHost:ne.tunnelRemoteHost,remotePort:ne.tunnelRemotePort,localAddress:ne.localAddress,protocol:ve?.protocol??P.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ve),localPort:ne.tunnelLocalPort,closeable:!0,runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,privacy:ne.privacy,source:e.$VL})}await this.cb(),this.f.set(he,ne),this.g.fire(this.forwarded.get(he))})),this.B(this.H.onTunnelClosed(ne=>this.W(ne,$.Other))),this.U()}S(){return this.Q.extensions.find(U=>U.activationEvents?.includes(e.$SL))?(this.R.createKey(e.$TL.key,!0),!0):!1}U(){if(this.S())return;const U=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&U.dispose()}))}async W(U,j){const z=v(U.host,U.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.cb(),this.h.fire(U))}X(U,j){if(U.startsWith("http"))return T.URI.parse(U);const z=j?.protocol??"http";return T.URI.parse(`${z}://${U}`)}async Y(U){const j=this.N.getWorkspace(),z=j.configuration?(0,R.$oj)(j.configuration.path):j.folders.length>0?(0,R.$oj)(j.folders[0].uri.path):void 0;if(z===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${U}.${this.L.remoteAuthority}.${z}`}async Z(){return this.Y(t)}async $(){return this.Y(l)}async ab(){const U=this.I.get(t,d.StorageScope.WORKSPACE);if(U)return this.I.remove(t,d.StorageScope.WORKSPACE),await this.cb(),U;const j=await this.Z();if(j)return this.I.get(j,d.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const U=await this.s;if(U&&U!==this.y){const j=JSON.parse(U)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(z=>z.remotePort).join(", ")}`);for(const z of j){const M=D(this.detected,z.remoteHost,z.remotePort);z.source.source!==E.Extension&&!M||z.source.source===E.Extension&&M?await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,elevateIfNeeded:!0,source:z.source}):z.source.source===E.Extension&&!M&&this.D.set(v(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const U=await this.Z();this.w=this.B(new L.$Tc),this.w.add(this.I.onDidChangeValue(d.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===U&&(this.s=Promise.resolve(this.I.get(U,d.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const U=this.I.keys(d.StorageScope.PROFILE,d.StorageTarget.USER).filter(j=>j.startsWith(l));for(const j of U){const z=this.I.getNumber(j,d.StorageScope.PROFILE);if(z&&z<Date.now()){this.s=Promise.resolve(void 0);const M=j.replace(l,t);this.I.remove(j,d.StorageScope.PROFILE),this.I.remove(M,d.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const U=Array.from(this.forwarded.values()),j=U.map(J=>({remoteHost:J.remoteHost,remotePort:J.remotePort,localPort:J.localPort,name:J.name,localAddress:J.localAddress,localUri:J.localUri,protocol:J.protocol,source:J.source}));let z;U.length>0&&(z=JSON.stringify(j));const M=await this.Z(),F=await this.$();!z&&M&&F?(this.I.remove(M,d.StorageScope.PROFILE),this.I.remove(F,d.StorageScope.PROFILE)):z!==this.y&&M&&F&&(this.I.store(M,z,d.StorageScope.PROFILE,d.StorageTarget.USER),this.I.store(F,Date.now()+h,d.StorageScope.PROFILE,d.StorageTarget.USER)),this.y=z}}async eb(U,j,z){if(!U.tunnelLocalPort||!z?.requireLocalPort||U.tunnelLocalPort===j)return;const M=new Date;if(this.db.getTime()+i>M.getTime())return;this.db=M;const F=r.localize(3,null,j,U.tunnelRemotePort,U.tunnelLocalPort);return this.P.info(F)}async forward(U,j){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(U,j)}async fb(U,j){await this.Q.activateByEvent(e.$SL);const z=D(this.forwarded,U.remote.host,U.remote.port);j=j??(j!==null?(await this.getAttributes([U.remote]))?.get(U.remote.port):void 0);const M=U.local!==void 0?U.local:U.remote.port;let F;if(z)return this.hb(z,U,j);{const J=this.L.remoteAuthority,ee=J?{getAddress:async()=>(await this.M.resolveAuthority(J)).authority}:void 0,V=v(U.remote.host,U.remote.port);this.c.set(V,!0),U=this.gb(V,U);const H=await this.H.openTunnel(ee,U.remote.host,U.remote.port,void 0,M,U.elevateIfNeeded?U.elevateIfNeeded:j?.elevateIfNeeded,U.privacy,j?.protocol);if(typeof H=="string")F=H;else if(H&&H.localAddress){const _=D(this.m??new Map,U.remote.host,U.remote.port),ne=H.protocol?H.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:j?.protocol??P.TunnelProtocol.Http,he={remoteHost:H.tunnelRemoteHost,remotePort:H.tunnelRemotePort,localPort:H.tunnelLocalPort,name:j?.label??U.name,closeable:!0,localAddress:H.localAddress,protocol:ne,localUri:await this.X(H.localAddress,j),runningProcess:_?.detail,hasRunningProcess:!!_,pid:_?.pid,source:U.source??e.$VL,privacy:H.privacy};return this.forwarded.set(V,he),this.f.set(V,H),this.c.delete(V),await this.cb(),await this.eb(H,M,j),this.g.fire(he),H}this.c.delete(V)}return F}gb(U,j){const z=this.D.has(U)?this.D:this.F.has(U)?this.F:void 0;if(z){const M=z.get(U);z.delete(U),M&&(j.name=M.name??j.name,j.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(U,j,z){const M=z?.label??j.name;let F;(function(ee){ee[ee.None=0]="None",ee[ee.Fire=1]="Fire",ee[ee.Reopen=2]="Reopen"})(F||(F={}));let J=F.None;switch(M!==U.name&&(U.name=M,J=F.Fire),(z?.protocol||U.protocol!==P.TunnelProtocol.Http)&&z?.protocol!==U.protocol&&(j.source=U.source,J=F.Reopen),j.privacy&&U.privacy!==j.privacy&&(J=F.Reopen),J){case F.Fire:{this.g.fire();break}case F.Reopen:await this.close(U.remoteHost,U.remotePort,$.User),await this.fb(j,z)}return D(this.f,j.remote.host,j.remote.port)}async name(U,j,z){const M=D(this.forwarded,U,j),F=v(U,j);if(M){M.name=z,await this.cb(),this.j.fire({host:U,port:j});return}else this.detected.has(F)&&(this.detected.get(F).name=z,this.j.fire({host:U,port:j}))}async close(U,j,z){const M=v(U,j),F=this.forwarded.get(M);return z===$.AutoForwardEnd&&F&&F.source.source===E.Auto&&this.F.set(M,{local:F.localPort,name:F.name,privacy:F.privacy}),await this.H.closeTunnel(U,j),this.W({host:U,port:j},z)}address(U,j){const z=v(U,j);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(U){if(U)for(const j of U){const z=D(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),M=typeof j.localAddress=="string"?j.localAddress:v(j.localAddress.host,j.localAddress.port);this.detected.set(v(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:M,protocol:P.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:E.Extension,description:r.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,M,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(U){this.r=U}async setCandidates(U){let j=U;this.r&&(j=await this.r(U));const z=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(M=>M.port).join(", ")}`),this.n.fire(z)}ib(U){const j=this.m??new Map,z=new Map;return this.m=z,U.forEach(M=>{const F=v(M.host,M.port);z.set(F,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),j.has(F)&&j.delete(F);const J=D(this.forwarded,M.host,M.port);J&&(J.runningProcess=M.detail,J.hasRunningProcess=!0,J.pid=M.pid)}),j.forEach((M,F)=>{const J=o(F);if(!J)return;const ee=D(this.forwarded,J.host,J.port);ee&&(ee.runningProcess=void 0,ee.hasRunningProcess=!1,ee.pid=void 0);const V=D(this.detected,J.host,J.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const U=Array.from(this.forwarded.values()),j=await this.getAttributes(U.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(j)for(const z of U){const M=j.get(z.remotePort);(M?.protocol||z.protocol!==P.TunnelProtocol.Http)&&M?.protocol!==z.protocol&&await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},M),M&&M.label&&M.label!==z.name&&await this.name(z.remoteHost,z.remotePort,M.label)}}async getAttributes(U,j=!0){const z=new Map,M=new Map;U.forEach(H=>{const _=D(this.m??new Map,P.$ww[0],H.port)??H;if(_){z.set(H.port,_);const ne=w(_)?_.pid:void 0;M.has(ne)||M.set(ne,[]),M.get(ne)?.push(H.port)}});const F=new Map;if(U.forEach(H=>{const _=this.configPortsAttributes.getAttributes(H.port,H.host,z.get(H.port)?.detail);_&&F.set(H.port,_)}),this.G.length===0||!j)return F.size>0?F:void 0;const J=await Promise.all(this.G.flatMap(H=>Array.from(M.entries()).map(_=>{const ne=_[1],he=z.get(ne[0]);return H.providePortAttributes(ne,he?.pid,he?.detail,f.CancellationToken.None)}))),ee=new Map;if(J.forEach(H=>H.forEach(_=>{_&&ee.set(_.port,_)})),!F&&!ee)return;const V=new Map;return U.forEach(H=>{const _=F.get(H.port),ne=ee.get(H.port);V.set(H.port,{elevateIfNeeded:_?.elevateIfNeeded,label:_?.label,onAutoForward:_?.onAutoForward??y.providedActionToAction(ne?.autoForwardAction),requireLocalPort:_?.requireLocalPort,protocol:_?.protocol})}),V}addAttributesProvider(U){this.G.push(U)}};e.$3L=N,Je([(0,m.$6h)(1e3)],N.prototype,"cb",null),e.$3L=N=Je([Ge(0,P.$rw),Ge(1,d.$9p),Ge(2,p.$7i),Ge(3,a.$RL),Ge(4,S.$Ll),Ge(5,b.$Ji),Ge(6,C.$7j),Ge(7,c.$Ww),Ge(8,u.$QG),Ge(9,s.$Sj)],N)}),define(ye[99],Se([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$BK=e.$AK=void 0;class r{constructor(L,T){this.line=L,this.character=T}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,T){return new r(0,0)}with(L){return new r(0,0)}}e.$AK=r;class m{constructor(L,T,p,c){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(L,T),this.end=new r(p,c)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new m(0,0,0,0)}with(L){return new m(0,0,0,0)}}e.$BK=m;var A;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(ye[38],Se([1,0,19,39,25,33,13,5,16,14,99,9]),function(de,e,r,m,A,R,L,T,p,c,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1K=e.$YK=e.$RK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$OK=e.$NK=e.$MK=e.$LK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.TextSearchCompleteMessageType=void 0,e.$IK=f,e.$JK=g,e.$KK=n,e.$PK=k,e.$QK=D,e.$SK=w,e.$TK=y,e.$UK=N,e.$VK=O,e.$WK=U,e.$XK=j,e.$ZK=M,e.$2K=ee,e.$3K=V,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return C.TextSearchCompleteMessageType}}),e.$CK="workbench.view.search",e.$DK="workbench.panel.search",e.$EK="workbench.view.search",e.$FK="search-result",e.$GK="search.exclude";const d="\u27EA ",P=" characters skipped \u27EB",b=(d.length+P.length+5)*2;e.$HK=(0,T.$Ai)("searchService");var a;(function(_){_[_.file=0]="file",_[_.text=1]="text",_[_.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var u;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.aiText=3]="aiText"})(u||(e.QueryType=u={}));function f(_){return!!_.preview}function g(_){return!!_.resource}function n(_){return!!_.message}var s;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class i{constructor(ne){this.resource=ne,this.results=[]}}e.$LK=i;class t{constructor(ne,he,re,ve){this.ranges=he,this.webviewIndex=ve;const pe=Array.isArray(he)?he:[he];if(re&&re.matchLines===1&&l(pe)){ne=(0,L.$6f)(ne,re.matchLines);let Q="",B=0,se=0;const ae=Math.floor(re.charsPerLine/5),ie=[];for(const ce of pe){const ue=Math.max(ce.startColumn-ae,0),Z=ce.startColumn+re.charsPerLine;if(ue>se+ae+b){const oe=d+(ue-se)+P;Q+=oe+ne.slice(ue,Z),B+=ue-(se+oe.length)}else Q+=ne.slice(se,Z);ie.push(new o(0,ce.startColumn-B,ce.endColumn-B)),se=Z}this.preview={text:Q,matches:Array.isArray(this.ranges)?ie:ie[0]}}else{const Q=Array.isArray(he)?he[0].startLineNumber:he.startLineNumber;this.preview={text:ne,matches:(0,r.$1b)(he,B=>new h(B.startLineNumber-Q,B.startColumn,B.endLineNumber-Q,B.endColumn))}}}}e.$MK=t;function l(_){const ne=_[0].startLineNumber;for(const he of _)if(he.startLineNumber!==ne||he.endLineNumber!==ne)return!1;return!0}class h{constructor(ne,he,re,ve){this.startLineNumber=ne,this.startColumn=he,this.endLineNumber=re,this.endColumn=ve}}e.$NK=h;class o extends h{constructor(ne,he,re){super(ne,he,ne,re)}}e.$OK=o;var $;(function(_){_.List="list",_.Tree="tree"})($||(e.ViewMode=$={}));var E;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function k(_,ne=!0){const he=_&&_.files&&_.files.exclude,re=ne&&_&&_.search&&_.search.exclude;if(!he&&!re)return;if(!he||!re)return he||re;let ve=Object.create(null);return ve=A.$_n(ve,A.$9n(he)),ve=A.$_n(ve,A.$9n(re),!0),ve}function D(_,ne){return _.excludePattern&&m.$tk(_.excludePattern,ne)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&m.$tk(_.includePattern,ne)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some(he=>{const re=he.folder.fsPath;if(R.$zg(ne,re)){const ve=p.$lc(re,ne);return!he.includePattern||!!m.$tk(he.includePattern,ve)}else return!1}):!1:!0}var v;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class I extends Error{constructor(ne,he){super(ne),this.code=he}}e.$RK=I;function w(_){const ne=_.message;if((0,c.$4)(_))return new I(ne,v.canceled);try{const he=JSON.parse(ne);return new I(he.message,he.code)}catch{return new I(ne,v.other)}}function y(_){const ne={message:_.message,code:_.code};return new Error(JSON.stringify(ne))}function N(_){return _.type==="error"?!0:_.type==="success"}function O(_){return _.type==="success"}function U(_){return!!_.path}function j(_,ne,he=!0){const re=_.searchPath?_.searchPath:_.relativePath;return he?(0,L.$3f)(re,ne):m.$tk(ne,re)}class z{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$YK=z;function M(_,ne){const he={..._||{},...ne||{}};return Object.keys(he).filter(re=>{const ve=he[re];return typeof ve=="boolean"&&ve})}class F{constructor(ne,he){this.c=null,this.a={...ne.excludePattern||{},...he.excludePattern||{}},this.b=m.$uk(this.a);let re=ne.includePattern;he.includePattern&&(re?re={...re,...he.includePattern}:re=he.includePattern),re&&(this.c=m.$uk(re))}matchesExcludesSync(ne,he,re){return!!(this.b&&this.b(ne,he,re))}includedInQuerySync(ne,he,re){return!(this.b&&this.b(ne,he,re)||this.c&&!this.c(ne,he,re))}includedInQuery(ne,he,re){const ve=this.b(ne,he,re),pe=()=>this.c?!!this.c(ne,he,re):!0;return(0,S.$mh)(ve)?ve.then(Q=>Q?!1:pe()):pe()}hasSiblingExcludeClauses(){return J(this.a)}}e.$1K=F;function J(_){for(const ne in _)if(typeof _[ne]!="boolean")return!0;return!1}function ee(_){if(!_)return;let ne;return he=>(ne||(ne=(_()||Promise.resolve([])).then(re=>re?H(re):{})),ne.then(re=>!!re[he]))}function V(_){if(!_)return;let ne;return he=>{if(!ne){const re=_();ne=re?H(re):{}}return!!ne[he]}}function H(_){const ne={};for(const he of _)ne[he]=!0;return ne}}),define(ye[47],Se([1,0,19,9,21,4,3,85,15,133,23,13,2,243,28,5,12,279,45,63,30,20,17,10,72,38,6,57]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i,t,l,h,o,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=e.$6mc=void 0;function k(U,j,z){return new C.$3g(M=>w(M,z)).isEqual(U,j)}function D(U,j,z){return k(U.uri,j.uri,z)?0:(0,S.$uf)(U.uri.toString(),j.uri.toString())}function v(U,j,z){return U.index!==j.index?U.index<j.index?-1:1:k(U.uri,j.uri,z)?(0,S.$uf)(U.name,j.name):(0,S.$uf)(U.uri.toString(),j.uri.toString())}function I(U,j,z,M){const F=U.slice(0).sort((ee,V)=>z(ee,V,M)),J=j.slice(0).sort((ee,V)=>z(ee,V,M));return(0,r.$Eb)(F,J,(ee,V)=>z(ee,V,M))}function w(U,j){const z=j.getCapabilities(U.scheme);return!(z&&z&b.FileSystemProviderCapabilities.PathCaseSensitive)}class y extends g.$Ti{static toExtHostWorkspace(j,z,M,F){if(!j)return{workspace:null,added:[],removed:[]};const{id:J,name:ee,folders:V,configuration:H,transient:_,isUntitled:ne}=j,he=[],re=z;z?V.forEach((B,se)=>{const ae=d.URI.revive(B.uri),ie=y.o(M||z,ae,F);ie?(ie.name=B.name,ie.index=B.index,he.push(ie)):he.push({uri:ae,name:B.name,index:se})}):he.push(...V.map(({uri:B,name:se,index:ae})=>({uri:d.URI.revive(B),name:se,index:ae}))),he.sort((B,se)=>B.index<se.index?-1:1);const ve=new y(J,ee,he,!!_,H?d.URI.revive(H):null,!!ne,B=>w(B,F)),{added:pe,removed:Q}=I(re?re.workspaceFolders:[],ve.workspaceFolders,D,F);return{workspace:ve,added:pe,removed:Q}}static o(j,z,M){for(let F=0;F<j.folders.length;F++){const J=j.workspaceFolders[F];if(k(J.uri,z,M))return J}}constructor(j,z,M,F,J,ee,V){super(j,M.map(H=>new g.$Ui(H)),F,J,V),this.t=z,this.u=ee,this.q=[],this.s=T.$Gi.forUris(V),M.forEach(H=>{this.q.push(H),this.s.set(H.uri,H)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,C.$ah)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let N=class{constructor(j,z,M,F,J){this.c=new R.$he,this.onDidChangeWorkspace=this.c.event,this.g=new R.$he,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$je,this.C=new Map,this.h=F,this.s=M,this.t=J,this.j=new c.$Im,this.k=new m.$zh,this.o=j.getProxy($.$uM.MainThreadWorkspace),this.q=j.getProxy($.$uM.MainThreadMessageService);const ee=z.workspace;this.l=ee?new y(ee.id,ee.name,[],!!ee.transient,ee.configuration?d.URI.revive(ee.configuration):null,!!ee.isUntitled,V=>w(V,M)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?d.URI.from({scheme:p.Schemas.untitled,path:(0,C.$$g)((0,C.$ah)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,M,...F){const J=[];if(Array.isArray(F)&&F.forEach(ne=>{d.URI.isUri(ne.uri)&&!J.some(he=>k(he.uri,ne.uri,this.s))&&J.push({uri:ne.uri,name:ne.name||(0,C.$0g)(ne.uri)})}),this.n||[z,M].some(ne=>typeof ne!="number"||ne<0)||M===0&&J.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(z+M>ee.length)return!1;const V=ee.slice(0);V.splice(z,M,...J.map(ne=>({uri:ne.uri,name:ne.name||(0,C.$0g)(ne.uri),index:void 0})));for(let ne=0;ne<V.length;ne++){const he=V[ne];if(V.some((re,ve)=>ve!==ne&&k(he.uri,re.uri,this.s)))return!1}V.forEach((ne,he)=>ne.index=he);const{added:H,removed:_}=I(ee,V,v,this.s);if(H.length===0&&_.length===0)return!1;if(this.o){const ne=j.displayName||j.name;this.o.$updateWorkspaceFolders(ne,z,M,J).then(void 0,he=>{this.n=void 0;const re={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(f.Severity.Error,(0,P.localize)(0,null,ne,he.toString()),re,[])})}return this.y(V),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let M,F="";if(typeof j=="string"?(M=d.URI.file(j),F=j):typeof j<"u"&&(M=j,F=j.fsPath),!M)return F;const J=this.getWorkspaceFolder(M,!0);if(!J)return F;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let ee=(0,C.$dh)(J.uri,M);return z&&J.name&&(ee=`${J.name}/${ee}`),ee}y(j){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:M,removed:F}=y.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:F}))}findFiles(j,z,M,F,J=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let ee="",V=!0;return z===null?V=!1:z!==void 0&&(typeof z=="string"?ee=z:ee=z.pattern),this.z(j,void 0,{exclude:ee,maxResults:M,useDefaultExcludes:V,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},J)}findFiles2(j,z={},M,F=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,j,z,F)}async z(j,z,M,F=A.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const J=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ee={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:J,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let V;if(j){const{includePattern:H,folder:_}=O(t.GlobPattern.from(j));V=_,ee.includePattern=H}else{const{includePattern:H,folder:_}=O(t.GlobPattern.from(z));V=_,ee.filePattern=H}return this.o.$startFileSearch(V??null,ee,F).then(H=>Array.isArray(H)?H.map(_=>d.URI.revive(_)):[])}async findTextInFiles(j,z,M,F,J=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),V=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:H,folder:_}=O(t.GlobPattern.from(z.include)),ne=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,he={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:V,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:H,excludePattern:ne},re=!1;if(this.u[ee]=ve=>{if(re)return;const pe=d.URI.revive(ve.resource);ve.results.forEach(Q=>{const B=(0,E.$0h)(Q);(0,o.$IK)(B)?M({uri:pe,preview:{text:B.preview.text,matches:(0,r.$1b)(B.preview.matches,se=>new l.$yM(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,r.$1b)(B.ranges,se=>new l.$yM(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):M({uri:pe,text:B.text,lineNumber:B.lineNumber})})},J.isCancellationRequested)return{};try{const ve=await this.o.$startTextSearch(j,_??null,he,ee,J);return delete this.u[ee],ve||{}}catch(ve){throw delete this.u[ee],ve}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return d.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return d.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const M=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,M),(0,L.$Sc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder(d.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const F=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!F),!F)return;const J=await F.provideEditSessionIdentity(M,z);if(this.h.info("Provider returned edit session identifier: ",J),!!J)return J}async $provideEditSessionIdentityMatch(j,z,M,F){this.h.info("Getting edit session identifier for workspaceFolder",j);const J=await this.resolveWorkspaceFolder(d.URI.revive(j));if(!J){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",J);const ee=this.w.get(J.uri.scheme);if(this.h.info(`Provider for scheme ${J.uri.scheme} is defined: `,!!ee),!ee)return;const V=await ee.provideEditSessionIdentityMatch?.(z,M,F);if(this.h.info("Provider returned edit session identifier match result: ",V),!!V)return V}getOnWillCreateEditSessionIdentityEvent(j){return(z,M,F)=>{const J=function(V){z.call(M,V)};return J.extension=j,this.B.event(J,void 0,F)}}async $onWillCreateEditSessionIdentity(j,z,M){const F=await this.resolveWorkspaceFolder(d.URI.revive(j));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},z,async(J,ee)=>{const V=Date.now();await Promise.resolve(J),Date.now()-V>M&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const M=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerCanonicalUriProvider(F,M),(0,L.$Sc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(j,z,M){const F=this.C.get(j.scheme);if(!F)return;const J=await F.provideCanonicalUri?.(d.URI.revive(j),z,M);if(J)return J}async $provideCanonicalUri(j,z,M){return this.provideCanonicalUri(d.URI.revive(j),{targetScheme:z},M)}};e.$6mc=N,e.$6mc=N=Je([Ge(0,i.$YO),Ge(1,s.$cP),Ge(2,n.$Omc),Ge(3,u.$7j),Ge(4,h.$4mc)],N),e.$7mc=(0,a.$Ai)("IExtHostWorkspace");function O(U){let j,z;return U&&(typeof U=="string"?j=U:(j=U.pattern,z=d.URI.revive(U.baseUri))),{includePattern:j,folder:z}}}),define(ye[48],Se([1,0,25,4,47,6,10,44,281,70,18,9,5,20,12,2]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=e.$8mc=void 0;function u(h,o){if(o){const $=o.split(".");let E=h;for(let k=0;E&&k<$.length;k++)E=E[$[k]];return E}}function f(h){return h instanceof a.URI}function g(h){return h&&h.uri instanceof a.URI&&h.languageId&&typeof h.languageId=="string"}function n(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function s(h){return h&&h.uri instanceof a.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function i(h){if(f(h))return{resource:h};if(g(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(n(h))return{overrideIdentifier:h.languageId};if(s(h))return{resource:h.uri};if(h===null)return{resource:null}}let t=class{constructor(o,$,E){this.a=o.getProxy(R.$uM.MainThreadConfiguration),this.c=$,this.b=E,this.d=new S.$zh,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new l(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,$){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(o,$))}};e.$8mc=t,e.$8mc=t=Je([Ge(0,P.$YO),Ge(1,A.$7mc),Ge(2,b.$7j)],t);class l{constructor(o,$,E,k){this.a=new m.$he,this.b=o,this.f=k,this.c=$,this.e=p.$Ho.parse(E,k),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,$){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Ho.parse(o,this.f),this.d=this.k(o.configurationScopes),this.a.fire(this.j($,E))}getConfiguration(o,$,E){const k=i($)||{},D=this.g(o?u(this.e.getValue(void 0,k,this.c.workspace),o):this.e.getValue(void 0,k,this.c.workspace));o&&this.h(o,k,E?.identifier);function v(w){if(w==null)return null;if(typeof w=="boolean")return w?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(w){case L.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const I={has(w){return typeof u(D,w)<"u"},get:(w,y)=>{this.h(o?`${o}.${w}`:w,k,E?.identifier);let N=u(D,w);if(typeof N>"u")N=y;else{let O;const U=(j,z)=>{if((0,C.$cg)(j)){let M;const F=()=>{O=O||(0,r.$9n)(D),M=M||u(O,z)};return new Proxy(j,{get:(J,ee)=>{if(typeof ee=="string"&&ee.toLowerCase()==="tojson")return F(),()=>M;if(O)return M=M||u(O,z),M[ee];const V=J[ee];return typeof ee=="string"?U(V,`${z}.${ee}`):V},set:(J,ee,V)=>(F(),M&&(M[ee]=V),!0),deleteProperty:(J,ee)=>(F(),M&&delete M[ee],!0),defineProperty:(J,ee,V)=>(F(),M&&Object.defineProperty(M,ee,V),!0)})}return Array.isArray(j)?(0,r.$9n)(j):j};N=U(N,w)}return N},update:(w,y,N,O)=>{w=o?`${o}.${w}`:w;const U=v(N);return y!==void 0?this.b.$updateConfigurationOption(U,w,y,k,O):this.b.$removeConfigurationOption(U,w,k,O)},inspect:w=>{w=o?`${o}.${w}`:w;const y=this.e.inspect(w,k,this.c.workspace);if(y)return{key:w,defaultValue:(0,r.$9n)(y.policy?.value??y.default?.value),globalValue:(0,r.$9n)(y.user?.value??y.application?.value),workspaceValue:(0,r.$9n)(y.workspace?.value),workspaceFolderValue:(0,r.$9n)(y.workspaceFolder?.value),defaultLanguageValue:(0,r.$9n)(y.default?.override),globalLanguageValue:(0,r.$9n)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,r.$9n)(y.workspace?.override),workspaceFolderLanguageValue:(0,r.$9n)(y.workspaceFolder?.override),languageIds:(0,r.$9n)(y.overrideIdentifiers)}}};return typeof D=="object"&&(0,r.$_n)(I,D,!1),Object.freeze(I)}g(o){const $=E=>(0,C.$cg)(E)?new Proxy(E,{get:(k,D)=>$(k[D]),set:(k,D,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(k,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(k,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:k=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return $(o)}h(o,$,E){const k=c.$yo.test(o)?c.ConfigurationScope.RESOURCE:this.d.get(o),D=E?`[${E.value}] `:"";if(c.ConfigurationScope.RESOURCE===k){typeof $?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===k){$?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,$){const E=new p.$Jo(o,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(k,D)=>E.affectsConfiguration(k,i(D))})}k(o){return o.reduce(($,E)=>($.set(E[0],E[1]),$),new Map)}}e.$9mc=l,e.$0mc=(0,d.$Ai)("IExtHostConfiguration")}),define(ye[100],Se([1,0,2,9,4,6,10,47,78,48,21,46,20,30,5,15,11,12,96,323,14]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=e.$Aoc=e.$zoc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(O){function U(z){if(z!=null)return z}O.from=U;function j(z){if(z!=null)return z}O.to=j})(i||(i={}));var t;(function(O){function U(z){if(z!=null)return z}O.from=U;function j(z){if(z!=null)return z}O.to=j})(t||(t={}));var l;(function(O){function U(z){if(z!=null)return z}O.from=U;function j(z){if(z!=null)return z}O.to=j})(l||(l={}));var h;(function(O){function U(M){if(M){const F=M;return F&&!!F.process}else return!1}O.is=U;function j(M){if(M==null)return;const F={process:M.process,args:M.args};return M.options&&(F.options=l.from(M.options)),F}O.from=j;function z(M){if(M!=null)return new L.$gN(M.process,M.args,M.options)}O.to=z})(h||(h={}));var o;(function(O){function U(z){if(z!=null)return z}O.from=U;function j(z){if(z!=null)return z}O.to=j})(o||(o={}));var $;(function(O){function U(M){if(M){const F=M;return F&&(!!F.commandLine||!!F.command)}else return!1}O.is=U;function j(M){if(M==null)return;const F={};return M.commandLine!==void 0?F.commandLine=M.commandLine:(F.command=M.command,F.args=M.args),M.options&&(F.options=o.from(M.options)),F}O.from=j;function z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new L.$hN(M.commandLine,M.options):new L.$hN(M.command,M.args?M.args:[],M.options)}O.to=z})($||($={}));var E;(function(O){function U(M){if(M){const F=M;return F&&F.customExecution==="customExecution"}else return!1}O.is=U;function j(M){return{customExecution:"customExecution"}}O.from=j;function z(M,F){return F.get(M)}O.to=z})(E||(e.CustomExecutionDTO=E={}));var k;(function(O){function U(j,z){let M;return j.scope!==void 0&&typeof j.scope!="number"?M=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===L.TaskScope.Workspace&&z&&z.workspaceFile?M=z.workspaceFile:M=n.$uI),{id:j._id,workspaceFolder:M}}O.from=U})(k||(e.TaskHandleDTO=k={}));var D;(function(O){function U(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}O.from=U})(D||(D={}));var v;(function(O){function U(M,F){if(M==null)return[];const J=[];for(const ee of M){const V=j(ee,F);V&&J.push(V)}return J}O.fromMany=U;function j(M,F){if(M==null)return;let J;M.execution instanceof L.$gN?J=h.from(M.execution):M.execution instanceof L.$hN?J=$.from(M.execution):M.execution&&M.execution instanceof L.$iN&&(J=E.from(M.execution));const ee=i.from(M.definition);let V;return M.scope?typeof M.scope=="number"?V=M.scope:V=M.scope.uri:V=L.TaskScope.Workspace,!ee||!V?void 0:{_id:M._id,definition:ee,name:M.name,source:{extensionId:F.identifier.value,label:M.source,scope:V},execution:J,isBackground:M.isBackground,group:D.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}O.from=j;async function z(M,F,J){if(M==null)return;let ee;h.is(M.execution)?ee=h.to(M.execution):$.is(M.execution)?ee=$.to(M.execution):E.is(M.execution)&&(ee=E.to(M._id,J));const V=i.to(M.definition);let H;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?H=M.source.scope:H=await F.resolveWorkspaceFolder(r.URI.revive(M.source.scope)):H=L.TaskScope.Workspace),!V||!H)return;const _=new L.$jN(V,H,M.name,M.source.label,ee,M.problemMatchers);return M.isBackground!==void 0&&(_.isBackground=M.isBackground),M.group!==void 0&&(_.group=L.$fN.from(M.group._id),_.group&&M.group.isDefault&&(_.group=new L.$fN(_.group.id,_.group.label),M.group.isDefault===!0&&(_.group.isDefault=M.group.isDefault))),M.presentationOptions&&(_.presentationOptions=t.to(M.presentationOptions)),M._id&&(_._id=M._id),M.detail&&(_.detail=M.detail),_}O.to=z})(v||(e.TaskDTO=v={}));var I;(function(O){function U(z){return z}O.from=U;function j(z){if(z)return Object.assign(Object.create(null),z)}O.to=j})(I||(I={}));class w{#e;constructor(U,j,z){this._id=j,this.a=z,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let y=class{constructor(U,j,z,M,F,J,ee,V){this.q=new A.$he,this.r=new A.$he,this.s=new A.$he,this.u=new A.$he,this.a=U.getProxy(R.$uM.MainThreadTask),this.b=z,this.c=M,this.d=F,this.e=J,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ee,this.g=V,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,j,z){if(!z)return new L.$wM(()=>{});const M=this.x();return this.j.set(M,{type:j,provider:z,extension:U}),this.a.$registerTaskProvider(M,j),new L.$wM(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(U,j){this.a.$registerTaskSystem(U,j)}fetchTasks(U){return this.a.$fetchTasks(I.from(U)).then(async j=>{const z=[];for(const M of j){const F=await v.to(M,this.b,this.m);F&&z.push(F)}return z})}get taskExecutions(){const U=[];return this.k.forEach(j=>U.push(j)),U}terminateTask(U){if(!(U instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,j,z){const M=this.m.get(U.id);M&&(this.o.set(U.id,M),this.e.attachPtyToTerminal(j,await M.callback(z))),this.p=U.id,this.q.fire({execution:await this.z(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){if(!this.l.has(U.id))return;const j=await this.z(U);this.l.delete(U.id),this.k.delete(U.id),this.B(U),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const j=await this.z(U.id);this.s.fire({execution:j,processId:U.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(U){const j=await this.z(U.id);this.u.fire({execution:j,exitCode:U.exitCode})}$provideTasks(U,j){const z=this.j.get(U);if(!z)return Promise.reject(new Error("no handler found"));const M=[],F=(0,m.$sh)(()=>z.provider.provideTasks(C.CancellationToken.None)).then(J=>this.v(j,M,z,J));return new Promise(J=>{F.then(ee=>{Promise.all(M).then(()=>{J(ee)})})})}async $resolveTask(U,j){const z=this.j.get(U);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const M=await v.to(j,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const F=await z.provider.resolveTask(M,C.CancellationToken.None);if(!F)return;this.A(F,z);const J=v.from(F,z.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(F.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(J.execution)&&await this.y(J,F,!0),await this.w(J)}x(){return this.h++}async y(U,j,z){const M=await this.a.$createTaskId(U);!z&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,j.execution)),this.m.set(M,j.execution)}async z(U,j){if(typeof U=="string"){const F=this.l.get(U);if(!F)throw new s.$bb("Unexpected: The specified task is missing an execution");return F}const z=this.l.get(U.id);if(z)return z;let M;return j?M=Promise.resolve(new w(this,U.id,j)):M=v.to(U.task,this.b,this.m).then(F=>{if(!F)throw new s.$bb("Unexpected: Task does not exist.");return new w(this,U.id,F)}),this.l.set(U.id,M),M.then(F=>(this.k.set(U.id,F),F))}A(U,j){U._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const z=this.n.values();let M=z.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=z.next()}};e.$zoc=y,e.$zoc=y=Je([Ge(0,d.$YO),Ge(1,P.$cP),Ge(2,T.$7mc),Ge(3,p.$0O),Ge(4,c.$0mc),Ge(5,S.$vnc),Ge(6,f.$7j),Ge(7,g.$Kmc)],y);let N=class extends y{constructor(U,j,z,M,F,J,ee,V){super(U,j,z,M,F,J,ee,V),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:u.$h(u.Platform.Web)})}async executeTask(U,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=v.from(j,U);if(z===void 0)throw new Error("Task is not valid");if(E.is(z.execution))await this.y(z,j,!1);else throw new s.$_;const M=await this.z(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(F=>{throw new Error(F)}),M}v(U,j,z,M){const F=[];if(M)for(const J of M){if(this.A(J,z),!J.definition||!U[J.definition.type]){const V=J.source?J.source:"No task source";this.f.warn(`The task [${V}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`)}const ee=v.from(J,z.extension);ee&&E.is(ee.execution)?(F.push(ee),j.push(this.y(ee,J,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:F,extension:z.extension}}async w(U){if(E.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,j,z){}};e.$Aoc=N,e.$Aoc=N=Je([Ge(0,d.$YO),Ge(1,P.$cP),Ge(2,T.$7mc),Ge(3,p.$0O),Ge(4,c.$0mc),Ge(5,S.$vnc),Ge(6,f.$7j),Ge(7,g.$Kmc)],N),e.$Boc=(0,b.$Ai)("IExtHostTask")}),define(ye[384],Se([1,0,38,31]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0K=void 0,e.$9K=A,e.$$K=R;function A(L){return"cellResults"in L}e.$0K="rawCell#";function R(L,T){let p=-1;const c=[];let C=[];return L.forEach(d=>{d.range.startLineNumber!==p&&C.length>0&&(c.push([...C]),C=[]),C.push(d),p=d.range.endLineNumber}),C.length>0&&c.push([...C]),c.map(d=>{const P=[],b=d[0].range.startLineNumber,a=d[d.length-1].range.endLineNumber;for(let u=b;u<=a;u++)P.push(T.getLineContent(u));return new r.$MK(P.join(`
`)+`
`,d.map(u=>new m.$ct(u.range.startLineNumber-1,u.range.startColumn-1,u.range.endLineNumber-1,u.range.endColumn-1)))})}}),define(ye[385],Se([1,0,237,22,4,3,29,41,13,18,2,28,118,6,37,17,10,52,356,163,25,15,38,312,384,381]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i,t,l,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=void 0;class ${static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(k=>k.apiEditor)}constructor(k,D,v,I,w,y,N){this.q=v,this.r=I,this.s=w,this.t=y,this.u=N,this.f=new Map,this.g=new L.$Ac,this.h=new Map,this.j=new A.$he,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$he,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$he,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$he,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new d.$Imc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=k.getProxy(P.$uM.MainThreadNotebook),this.c=k.getProxy(P.$uM.MainThreadNotebookDocuments),this.d=k.getProxy(P.$uM.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===T.MarshalledId.NotebookCellActionContext){const U=O.notebookEditor?.notebookUri,j=O.cell.handle,M=this.g.get(U)?.getCell(j);if(M)return M.apiCell}if(O&&O.$mid===T.MarshalledId.NotebookActionContext){const U=O.uri,j=this.g.get(U);if(j)return j.apiNotebook}return O}}),$.C(D)}getEditorById(k){const D=this.h.get(k);if(!D)throw new Error(`unknown text editor: ${k}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(k){for(const[D,v]of this.h)if(v.apiEditor===k)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(k,D){const v=this.g.get(k);if(!v&&!D)throw new Error(`NO notebook document for '${k}'`);return v}static w(k,D){if(!D)return;const v=D.filenamePattern.map(I=>a.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(D.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:k.identifier,providerDisplayName:k.displayName||k.name,displayName:D.displayName,filenamePattern:v,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(k,D,v){const I=$.a++,w=typeof v.onDidChangeCellStatusBarItems=="function"?$.a++:void 0;this.f.set(I,v),this.b.$registerNotebookCellStatusBarItemProvider(I,w,D);let y;return w!==void 0&&(y=v.onDidChangeCellStatusBarItems(N=>this.b.$emitCellStatusBarEvent(w))),new u.$wM(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,w),y?.dispose()})}async createNotebookDocument(k){const D=await this.c.$tryCreateNotebook({viewType:k.viewType,content:k.content&&a.NotebookData.from(k.content)});return C.URI.revive(D)}async openNotebookDocument(k){const D=this.g.get(k);if(D)return D.apiNotebook;const v=await this.c.$tryOpenNotebook(k),I=this.g.get(C.URI.revive(v));return(0,c.$lg)(I?.apiNotebook)}async showNotebookDocument(k,D){C.URI.isUri(k)&&(k=await this.openNotebookDocument(k));let v;typeof D=="object"?v={position:a.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(a.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:v={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(k.uri,k.notebookType,v),w=I&&this.h.get(I)?.apiEditor;if(w)return w;throw I?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(k,D,v,I){const w=this.f.get(k),y=C.URI.revive(D),N=this.g.get(y);if(!N||!w)return;const O=N.getCellFromIndex(v);if(!O)return;const U=await w.provideCellStatusBarItems(O.apiCell,I);if(!U)return;const j=new R.$Tc,z=this.p.add([j]),F=(Array.isArray(U)?U:[U]).map(J=>a.NotebookStatusBarItem.from(J,this.i,j));return{cacheId:z,items:F}}$releaseNotebookCellStatusBarItems(k){this.p.delete(k)}registerNotebookSerializer(k,D,v,I,w){if((0,p.$$e)(D))throw new Error("viewType cannot be empty or just whitespace");const y=this.x++;return this.y.set(y,{viewType:D,serializer:v,options:I}),this.b.$registerNotebookSerializer(y,{id:k.identifier,location:k.extensionLocation},D,a.NotebookDocumentContentOptions.from(I),$.w(k,w)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(k,D,v){const I=this.y.get(k);if(!I)throw new Error("NO serializer found");const w=await I.serializer.deserializeNotebook(D.buffer,v);return new f.$Kw(a.NotebookData.from(w))}async $notebookToData(k,D,v){const I=this.y.get(k);if(!I)throw new Error("NO serializer found");const w=await I.serializer.serializeNotebook(a.NotebookData.to(D.value),v);return m.$Je.wrap(w)}async $saveNotebook(k,D,v,I,w){const y=C.URI.revive(D),N=this.y.get(k);if(this.D(`enter saveNotebook(versionId: ${v}, ${y.toString()})`),!N)throw new Error("NO serializer found");const O=this.g.get(y);if(!O)throw new Error("Document NOT found");if(O.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new S.$pl((0,r.localize)(0,null,this.A(y)),S.FileOperationResult.FILE_PERMISSION_DENIED);const U={metadata:(0,s.$eo)(O.apiNotebook.metadata,J=>!(N.options?.transientDocumentMetadata??{})[J]),cells:[]};for(const J of O.apiNotebook.getCells()){const ee=new u.$ZN(J.kind,J.document.getText(),J.document.languageId,J.mime,N.options?.transientOutputs?[]:[...J.outputs],J.metadata,J.executionSummary);ee.metadata=(0,s.$eo)(J.metadata,V=>!(N.options?.transientCellMetadata??{})[V]),U.cells.push(ee)}if(await this.z(y,I),w.isCancellationRequested)throw new Error("canceled");const j=await N.serializer.serializeNotebook(U,w);if(w.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${v} ${y.toString()}`),await this.s.value.writeFile(y,j),this.D(`Finished write versionId: ${v} ${y.toString()}`);const z=this.s.getFileSystemProviderExtUri(y.scheme),M=await this.s.value.stat(y),F={name:z.basename(y),isFile:(M.type&S.FileType.File)!==0,isDirectory:(M.type&S.FileType.Directory)!==0,isSymbolicLink:(M.type&S.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&S.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((M.permissions??0)&S.FilePermission.Locked),etag:S.$Al({mtime:M.mtime,size:M.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${v}, ${y.toString()})`),F}async $searchInNotebooks(k,D,v,I,w){const y=this.y.get(k)?.serializer;if(!y)return{limitHit:!1,results:[]};const N=new L.$Bc;await(async(M,F,J)=>{await Promise.all(M.map(async ee=>await Promise.all(ee.filenamePatterns.map(V=>{const H={_reason:J._reason,folderQueries:J.folderQueries,includePattern:J.includePattern,excludePattern:J.excludePattern,maxResults:J.maxResults,type:t.QueryType.File,filePattern:V};return this.t.doInternalFileSearchWithCustomCallback(H,F,_=>{_.forEach(ne=>{N.has(ne)||I.some(re=>ee.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(ve=>(0,o.$shb)(ve,ne)))||N.add(ne)})}).catch(_=>{if(_.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw _})}))))})(v,w,D);const U=new L.$Ac;let j=!1;const z=Array.from(N).map(async M=>{const F=[];try{if(w.isCancellationRequested)return;if(D.maxResults&&[...U.values()].reduce((H,_)=>H+_.cellResults.length,0)>D.maxResults){j=!0;return}const J=[],ee=this.g.get(M);if(ee)ee.apiNotebook.getCells().forEach(_=>J.push({input:_.document.getText(),outputs:_.outputs.flatMap(ne=>ne.items.map(he=>he.data.toString()))}));else{const H=await this.s.value.readFile(M),_=m.$Je.fromString(H.toString()),ne=await y.deserializeNotebook(_.buffer,w);if(w.isCancellationRequested)return;a.NotebookData.from(ne).cells.forEach(re=>J.push({input:re.source,outputs:re.outputs.flatMap(ve=>ve.items.map(pe=>pe.valueBytes.toString()))}))}if(w.isCancellationRequested)return;J.forEach((H,_)=>{const ne=D.contentPattern.pattern,he=new l.$0Xb(H.input,void 0,H.outputs),re=he.findInInputs(ne),ve=he.findInOutputs(ne),pe=ve.flatMap(Q=>(0,h.$$K)(Q.matches,Q.textBuffer)).map((Q,B)=>(Q.webviewIndex=B,Q));if(re.length>0||ve.length>0){const Q={index:_,contentResults:(0,h.$$K)(re,he.inputTextBuffer),webviewResults:pe};F.push(Q)}});const V={resource:M,cellResults:F};U.set(M,V);return}catch{return}});return await Promise.all(z),{limitHit:j,results:[...U.values()]}}async z(k,D){const v=await this.s.value.stat(k);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==S.$zl&&typeof v.mtime=="number"&&typeof v.size=="number"&&D.mtime<v.mtime&&D.etag!==S.$Al({mtime:D.mtime,size:v.size}))throw new S.$pl((0,r.localize)(1,null),S.FileOperationResult.FILE_MODIFIED_SINCE,D)}A(k){return k.scheme===i.Schemas.file?k.fsPath:k.toString()}B(k,D,v){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const I=new n.$6nc(D,this.d,k,v.visibleRanges.map(a.NotebookRange.to),v.selections.map(a.NotebookRange.to),typeof v.viewColumn=="number"?a.ViewColumn.to(v.viewColumn):void 0);this.h.set(D,I)}$acceptDocumentAndEditorsDelta(k){if(k.value.removedDocuments)for(const v of k.value.removedDocuments){const I=C.URI.revive(v),w=this.g.get(I);w&&(w.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(w.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===I.toString()&&this.h.delete(y.id)}if(k.value.addedDocuments){const v=[];for(const I of k.value.addedDocuments){const w=C.URI.revive(I.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const y=new g.$5nc(this.c,this.q,this.r,w,I);v.push(...I.cells.map(N=>g.$4nc.asModelAddData(N))),this.g.get(w)?.dispose(),this.g.set(w,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(y.apiNotebook)}}if(k.value.addedEditors)for(const v of k.value.addedEditors){if(this.h.has(v.id))return;const I=C.URI.revive(v.documentUri),w=this.g.get(I);w&&this.B(w,v.id,v)}const D=[];if(k.value.removedEditors)for(const v of k.value.removedEditors){const I=this.h.get(v);I&&(this.h.delete(v),this.k?.id===I.id&&(this.k=void 0),D.push(I))}if(k.value.visibleEditors){this.l=k.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const v=new Set;this.l.forEach(I=>v.add(I.id));for(const I of this.h.values()){const w=v.has(I.id);I._acceptVisibility(w)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}k.value.newActiveEditor===null?this.k=void 0:k.value.newActiveEditor&&(this.h.get(k.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${k.value.newActiveEditor}`),this.k=this.h.get(k.value.newActiveEditor)),k.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(k){const D=b.$kP.String.with("notebookType","A notebook type"),v=new b.$mP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new b.$kP("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>m.$Je.wrap(w))],new b.$lP("Notebook Data",w=>a.NotebookData.to(w.value))),I=new b.$mP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new b.$kP("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new f.$Kw(a.NotebookData.from(w)))],new b.$lP("Bytes",w=>w.buffer));k.registerApiCommand(v),k.registerApiCommand(I)}D(k){this.u.trace(`[Extension Host Notebook] ${k}`)}}e.$coc=$}),define(ye[386],Se([1,0,16,21,51,39,23,42,38]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=void 0;class c{constructor(d,P,b){this.k=d,this.l=P,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=d.filePattern,this.b=d.includePattern&&R.$uk(d.includePattern),this.c=d.maxResults||void 0,this.d=d.exists,this.h=new Set,this.j=d.excludePattern&&R.$uk(d.excludePattern)}cancel(){this.g=!0,this.h.forEach(d=>d.cancel()),this.h=new Set}search(d){const P=this.k.folderQueries||[];return new Promise((b,a)=>{const u=f=>{this.f++,d(f)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(f=>{const g=f.toString(),n=r.$nc(g);this.j&&this.j(g,n)||this.v(u,{base:f,basename:n})}),Promise.all(P.map(f=>this.p(f,u))).then(f=>{b({limitHit:this.e,stats:f[0]||void 0})},f=>{a(new Error((0,A.$lj)(f)))})})}async p(d,P){const b=new m.$se,a=this.q(d),u=this.r(),f=new p.$1K(this.k,d),g=!f.hasSiblingExcludeClauses();let n;try{this.h.add(b),n=T.$be.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,b.token),i=n.elapsed(),t=T.$be.create();return this.g&&!this.e||(s&&s.forEach(l=>{const h=r.$gc.relative(d.folder.path,l.path);if(g){const o=r.$nc(l.path);this.v(P,{base:d.folder,relativePath:h,basename:o});return}this.s(u,d.folder,h,P)}),this.g&&!this.e)?null:(this.u(u,f,P),{providerTime:i,postProcessTime:t.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(d){const P=(0,p.$ZK)(this.k.includePattern,d.includePattern),b=(0,p.$ZK)(this.k.excludePattern,d.excludePattern);return{folder:d.folder,excludes:b,includes:P,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}s({pathToEntries:d},P,b,a){if(b===this.a){const f=r.$nc(this.a);this.v(a,{base:P,relativePath:this.a,basename:f})}function u(f){const g=r.$nc(f),n=r.$mc(f);let s=d[n];s||(s=d[n]=[],u(n)),s.push({base:P,relativePath:f,basename:g})}u(b)}u({rootEntries:d,pathToEntries:P},b,a){const u=this,f=this.a;function g(n){const s=(0,p.$3K)(()=>n.map(i=>i.basename));for(let i=0,t=n.length;i<t;i++){const l=n[i],{relativePath:h,basename:o}=l;if(b.matchesExcludesSync(h,o,f!==o?s:void 0))continue;const $=P[h];if($)g($);else{if(h===f)continue;u.v(a,l)}if(u.e)break}}g(d)}v(d,P){(!this.b||P.relativePath&&this.b(P.relativePath,P.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||d(P))}}class C{constructor(){this.b=new Map}static{this.a=512}fileSearch(d,P,b,a){const u=this.c(d.cacheKey),f=new c(d,P,u&&u.token);let g=0;const n=s=>{g+=s.length,b(s.map(i=>this.d(i)))};return this.e(f,C.a,n,a).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:s.stats}:void 0,messages:[]}))}clearCache(d){this.c(d)?.cancel()}c(d){if(d)return this.b.has(d)||this.b.set(d,new m.$se),this.b.get(d)}d(d){return d.relativePath?{resource:L.$bh(d.base,d.relativePath)}:{resource:d.base}}e(d,P,b,a){const u=a.onCancellationRequested(()=>{d.cancel()}),f=n=>{n&&(g.push(n),P>0&&g.length>=P&&(b(g),g=[]))};let g=[];return d.search(f).then(n=>(g.length&&b(g),u.dispose(),n),n=>(g.length&&b(g),u.dispose(),Promise.reject(n)))}}e.$7nc=C}),define(ye[387],Se([1,0,19,79,39,109,29,15,16,23,13,18,2,106,260,44,12,45,155,382,38]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=void 0,e.$_L=D;let i=class{constructor(I,w,y,N,O){this.a=I,this.b=w,this.c=y,this.d=N,this.e=O}text(I,w,y={}){I=this.f(I,y);const N=this.a.getValue(),O=w&&w.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(w?.map(f.$Vi),y),type:s.QueryType.Text,contentPattern:I,previewOptions:y.previewOptions,maxFileSize:y.maxFileSize,usePCRE2:N.search.usePCRE2||O||!1,beforeContext:y.beforeContext,afterContext:y.afterContext,userDisabledExcludesAndIgnoreFiles:y.disregardExcludeSettings&&y.disregardIgnoreFiles}}f(I,w){const y=this.a.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const N={...I,wordSeparators:y.editor.wordSeparators};return this.j(I,w)&&(N.isCaseSensitive=!0),this.k(I)&&(N.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),N}file(I,w={}){return{...this.h(I,w),type:s.QueryType.File,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey,shouldGlobMatchFilePattern:w.shouldGlobSearch}}g(I,w){return I?(I=Array.isArray(I)?I.map($):$(I),w?this.parseSearchPaths(I):{pattern:l(...Array.isArray(I)?I:[I])}):{}}h(I=[],w={}){const y=this.g(w.includePattern,w.expandPatterns),N=this.g(w.excludePattern,w.expandPatterns),O=I.length>1,U=(y.searchPaths&&y.searchPaths.length?y.searchPaths.map(M=>this.q(M,w,N)):I.map(M=>this.r(M,w,N,O))).filter(M=>!!M),j={_reason:w._reason,folderQueries:U,usingSearchPaths:!!(y.searchPaths&&y.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:N.pattern,includePattern:y.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const M=r.$Hb(this.c.groups.flatMap(ee=>ee.editors.map(V=>V.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const F=M.filter(ee=>(0,s.$QK)(j,ee.fsPath)),J=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...j,...J}}const z=w.extraFileResources&&w.extraFileResources.filter(M=>(0,s.$QK)(j,M.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(I){const w=[],y=new L.$Ac,N={};let O=!1;return I.forEach(U=>{if(U.scheme===T.Schemas.walkThrough)return;if((0,c.$fh)(U)){const z=this.b.getWorkspaceFolder(U)?.uri??U.with({path:p.$mc(U.fsPath)});let M=y.get(z);M||(O=!0,M={folder:z,includePattern:{}},w.push(M),y.set(z,M));const F=p.$lc(z.fsPath,U.fsPath);(0,S.$lg)(M.includePattern)[F.replace(/\\/g,"/")]=!0}else U.fsPath&&(O=!0,N[U.fsPath]=!0)}),{folderQueries:w,includePattern:N,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(I,w){if(w.isSmartCase){if(I.isRegExp){if(C.$4f(I.pattern,!0))return!0}else if(C.$4f(I.pattern))return!0}return!!I.isCaseSensitive}k(I){return I.isMultiline||I.isRegExp&&(0,P.$2C)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const w=J=>p.$ic(J)||/^\.\.?([\/\\]|$)/.test(J),N=(Array.isArray(I)?I:h(I)).map(J=>{const ee=this.e.resolvedUserHome;return ee?(0,R.$Pw)(J,ee.scheme===T.Schemas.file?ee.fsPath:ee.path):J}),O=m.$K(N,J=>w(J)?"searchPaths":"exprSegments"),U=(O.exprSegments||[]).map(J=>C.$jf(J,"/")).map(J=>C.$jf(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),o(J))),j={},z=this.m(O.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const M=U.flat(),F=l(...M);return F&&(j.pattern=F),j}l(I,w){return w.disregardExcludeSettings?void 0:(0,s.$PK)(I,!w.disregardSearchExcludeSettings)}m(I){if(!I||!I.length)return[];const w=I.flatMap(N=>{let{pathPortion:O,globPortion:U}=t(N);return U&&(U=E(U)),this.n(O).flatMap(z=>this.o(z,U))}),y=new Map;return w.forEach(N=>{const O=N.searchPath.toString(),U=y.get(O);U?N.pattern&&(U.pattern=U.pattern||{},U.pattern[N.pattern]=!0):y.set(O,{searchPath:N.searchPath,pattern:N.pattern?l(N.pattern):void 0})}),Array.from(y.values())}n(I){if(p.$ic(I)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==T.Schemas.file?[{searchPath:w[0].uri.with({path:I})}]:[{searchPath:d.URI.file(p.$hc(I))}]}if(this.b.getWorkbenchState()===f.WorkbenchState.FOLDER){const w=this.b.getWorkspace().folders[0].uri;if(I=$(I),I.startsWith("../")||I===".."){const N=p.$gc.resolve(w.path,I);return[{searchPath:w.with({path:N})}]}const y=E(I);return[{searchPath:w,pattern:y}]}else{if(I==="./"||I===".\\")return[];{const w=I.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(O=>{const U=w.match(new RegExp(`^${C.$df(O.name)}(?:/(.*)|$)`));return U?{match:U,folder:O}:null}).filter(S.$ig);if(N.length)return N.map(O=>{const U=O.match[1];return{searchPath:O.folder.uri,pattern:U&&E(U)}});{const O=I.match(/\.[\/\\](.+)[\/\\]?/),U=O?O[1]:I,j=b.localize(0,null,U);throw new Error(j)}}}}o(I,w){const y=I.pattern&&w?`${I.pattern}/${w}`:I.pattern||w,N=[{searchPath:I.searchPath,pattern:y}];return y&&!y.endsWith("**")&&N.push({searchPath:I.searchPath,pattern:y+"/**"}),N}q(I,w,y){const N=this.r((0,f.$Vi)(I.searchPath),w,y,!1);return N?{...N,includePattern:I.pattern}:null}r(I,w,y,N){let O;const U=d.URI.isUri(I)?I:I.uri;if(y.searchPaths){const J=y.searchPaths.filter(ee=>(0,c.$7g)(ee.searchPath,U))[0];if(J&&!J.pattern)return null;J&&(O=J.pattern)}const j=this.a.getValue({resource:U}),M={...this.l(j,w)||{},...O||{}},F=d.URI.isUri(I)?(0,c.$$g)(I):I.name;return{folder:U,folderName:N?F:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!j.search.followSymlinks}}};e.$$L=i,e.$$L=i=Je([Ge(0,a.$7i),Ge(1,f.$Ji),Ge(2,g.$0D),Ge(3,u.$7j),Ge(4,n.$9L)],i);function t(v){const I=v.match(/[\*\{\}\(\)\[\]\?]/);if(I){const w=I.index,y=v.substr(0,w).match(/[/|\\][^/\\]*$/);if(y){let N=v.substr(0,y.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:v.substr((y.index||0)+1)}}}return{pathPortion:v}}function l(...v){return v.length?v.reduce((I,w)=>(I[w]=!0,I),Object.create(null)):void 0}function h(v){return A.$sk(v,",").map(I=>I.trim()).filter(I=>!!I.length)}function o(v){return[`**/${v}/**`,`**/${v}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function $(v){return v.replace(/\\/g,"/")}function E(v){return $(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(v){return v.replace(/([?*[\]])/g,"[$1]")}function D(v,I){v=r.$Mb(v,N=>N.toString());const w=[],y=I.getWorkspace();return v&&v.forEach(N=>{let O;if(I.getWorkbenchState()===f.WorkbenchState.FOLDER)O=(0,c.$dh)(y.folders[0].uri,N),O&&O!=="."&&(O="./"+O);else{const U=I.getWorkspaceFolder(N);if(U){const j=U.name;if(y.folders.filter(M=>M.name===j).length===1){const M=(0,c.$dh)(U.uri,N);M===""?O=`./${U.name}`:O=`./${U.name}/${M}`}else O=N.fsPath}}O&&w.push(k(O))}),w}}),define(ye[388],Se([1,0,23,2,21,14,5,387,38,45,9]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kwb=d,e.$Lwb=a;const S=7e3;function d(u,f){const g=f.activationEvents;if(!g)return Promise.resolve(void 0);const n=[],s=[];for(const $ of g)if(/^workspaceContains:/.test($)){const E=$.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||u.forceUsingSearch?s.push(E):n.push(E)}if(n.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:i,resolve:t}=(0,C.$th)(),l=$=>t({activationEvent:$}),h=Promise.all(n.map($=>P(u,$,l))).then(()=>{}),o=b(u,f.identifier,s,l);return Promise.all([h,o]).then(()=>{t(void 0)}),i}async function P(u,f,g){for(const n of u.folders)if(await u.exists(r.$bh(m.URI.revive(n),f))){g(`workspaceContains:${f}`);return}}async function b(u,f,g,n){if(g.length===0)return Promise.resolve(void 0);const s=new A.$se,i=u.checkExists(u.folders,g,s.token),t=setTimeout(async()=>{s.cancel(),u.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${g.join(",")}`)},S);let l=!1;try{l=await i}catch(h){R.$4(h)||R.$1(h)}s.dispose(),clearTimeout(t),l&&n(`workspaceContains:${g.join(",")}`)}function a(u,f,g,n){const s=u.get(L.$zi),i=u.get(p.$HK),l=s.createInstance(T.$$L).file(f.map(h=>(0,c.$Vi)(m.URI.revive(h))),{_reason:"checkExists",includePattern:g,exists:!0});return i.fileSearch(l,n).then(h=>!!h.limitHit,h=>R.$4(h)?!1:Promise.reject(h))}}),define(ye[53],Se([1,0,233,16,62,23,9,3,85,2,12,6,48,319,125,47,26,157,14,24,22,297,10,71,5,30,98,20,114,76,46,128,4,388,124,299,15,122,42,11,123]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i,t,l,h,o,$,E,k,D,v,I,w,y,N,O,U,j,z,M,F){"use strict";var J;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=e.$Lnc=e.$Knc=e.$Jnc=e.$Inc=void 0,e.$Inc=(0,h.$Ai)("IHostUtils");let ee=J=class extends T.$Uc{constructor(Q,B,se,ae,ie,ce,ue,Z,oe,$e,be,Ne,Be){super(),this.Y=Ne,this.Z=Be,this.a=this.B(new w.$he),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=B,this.g=se,this.f=ue,this.j=ae,this.m=ie,this.s=ce,this.t=oe,this.u=$e,this.w=be,this.y=this.g.getProxy(S.$uM.MainThreadWorkspace),this.z=this.g.getProxy(S.$uM.MainThreadTelemetry),this.C=this.g.getProxy(S.$uM.MainThreadExtensionService),this.D=new L.$zh,this.F=new L.$zh,this.G=new L.$zh,this.H=new L.$zh,this.I=new ve(this.f.extensions.activationEvents),this.L=new f.$bbc(this.I,this.f.extensions.allExtensions);const De=new n.$Xm(this.f.extensions.myExtensions);this.J=new f.$bbc(this.I,he(this.L,De)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${_(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${_(this.J)}`)),this.M=new b.$rnc(this.g,this.s),this.N=new N.$Bnc(this.g),this.O=Z,this.h=Q.createChild(new k.$yi([b.$snc,this.M],[N.$Cnc,this.N])),this.P=this.B(new P.$qnc(this.J,this.L,{onExtensionActivationError:(Ie,Le,W)=>{this.C.$onExtensionActivationError(Ie,g.$3(Le),W)},actualActivateExtension:async(Ie,Le)=>{if(f.$bbc.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Le),new P.$pnc;const W=this.J.getExtensionDescription(Ie);return this.fb(W,Le)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Q){g.$1(Q)}}async $(){this.O.onWillDeactivateAll();let Q=[];try{Q=this.J.getAllExtensionDescriptions().map(ie=>ie.identifier).filter(ie=>this.isActivated(ie)).map(ie=>this.eb(ie))}catch{}await Promise.all(Q)}terminate(Q,B=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Q}`),this.s.flush(),this.u.dispose(),this.P.dispose(),g.setUnexpectedErrorHandler(ae=>{this.s.error(ae)}),this.g.dispose();const se=this.$();Promise.race([(0,L.$Bh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(Q){return this.G.isOpen()?this.P.isActivated(Q):!1}async getExtension(Q){const B=await this.C.$getExtension(Q);return B&&{...B,identifier:new n.$Wm(B.identifier.value),extensionLocation:c.URI.revive(B.extensionLocation)}}ab(Q,B){return this.P.activateByEvent(Q,B)}bb(Q,B){return this.P.activateById(Q,B)}activateByIdWithErrors(Q,B){return this.bb(Q,B).then(()=>{const se=this.P.getActivatedExtension(Q);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Q=>this.J)}getExtensionExports(Q){if(this.G.isOpen())return this.P.getActivatedExtension(Q).exports;try{return this.P.getActivatedExtension(Q).exports}catch{return null}}async cb(Q){if(Q.scheme===U.Schemas.file&&this.c.fsRealpath){const B=Q.fsPath;this.R.has(B)||this.R.set(B,this.c.fsRealpath(B));const se=await this.R.get(B);return c.URI.file(se)}return Q}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Q=>new re(Q))),this.Q}async db(Q){const B=p.$Gi.forUris(se=>R.$5g.ignorePathCasing(se));return await Promise.all(Q.map(async se=>{if(this.wb(se)){const ae=await this.cb(se.extensionLocation);B.set(ae,se)}})),B}eb(Q){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Q))return B;const se=this.P.getActivatedExtension(Q);if(!se)return B;try{typeof se.module.deactivate=="function"&&(B=Promise.resolve(se.module.deactivate()).then(void 0,ae=>(this.s.error(ae),Promise.resolve(void 0))))}catch(ae){this.s.error(`An error occurred when deactivating the extension '${Q.value}':`),this.s.error(ae)}try{(0,T.$Pc)(se.subscriptions)}catch(ae){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this.s.error(ae)}return B}async fb(Q,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Q.identifier):await this.C.$onWillActivateExtension(Q.identifier),this.hb(Q,B).then(se=>{const ae=se.activationTimes;return this.C.$onDidActivateExtension(Q.identifier,ae.codeLoadingTime,ae.activateCallTime,ae.activateResolvedTime,B),this.gb(Q,B,"success",ae),se},se=>{throw this.gb(Q,B,"failure"),se})}gb(Q,B,se,ae){const ie=H(Q,B);this.z.$publicLog2("extensionActivationTimes",{...ie,...ae||{},outcome:se})}hb(Q,B){const se=H(Q,B);this.z.$publicLog2("activatePlugin",se);const ae=this.wb(Q);if(!ae)return Promise.resolve(new P.$onc(P.$lnc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${Q.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const ie=new P.$mnc(B.startup);return Promise.all([this.xb(Q,(0,R.$bh)(Q.extensionLocation,ae),ie),this.ib(Q)]).then(ce=>(A.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),J.jb(this.s,Q.identifier,ce[0],ce[1],ie))).then(ce=>(A.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),ce))}ib(Q){const B=this.Z.createLanguageModelAccessInformation(Q),se=new i.$unc(Q,this.M),ae=new i.$tnc(Q.identifier.value,!1,this.M),ie=new O.$Dnc(Q,this.N),ce=Q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ue=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([se.whenReady,ae.whenReady,this.O.whenReady]).then(()=>{const Z=this;let oe,$e;const be=(0,u.$TG)(Q,"ipc")?this.f.messagePorts?.get(n.$Wm.toKey(Q.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:ae,secrets:ie,subscriptions:[],get languageModelAccessInformation(){return B},get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(Ne){return m.$jc(Q.extensionLocation.fsPath,Ne)},get storagePath(){return Z.O.workspaceValue(Q)?.fsPath},get globalStoragePath(){return Z.O.globalValue(Q).fsPath},get logPath(){return m.$jc(Z.f.logsLocation.fsPath,Q.identifier.value)},get logUri(){return c.URI.joinPath(Z.f.logsLocation,Q.identifier.value)},get storageUri(){return Z.O.workspaceValue(Q)},get globalStorageUri(){return Z.O.globalValue(Q)},get extensionMode(){return ce},get extension(){return oe===void 0&&(oe=new ne(Z,Q.identifier,Q,ue,!1)),oe},get extensionRuntime(){return(0,u.$UG)(Q,"extensionRuntime"),Z.extensionRuntime},get environmentVariableCollection(){return Z.u.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!$e){if(!be)return;const Ne=w.Event.buffer(w.Event.fromDOMEventEmitter(be,"message",Be=>Be.data));be.start(),$e={onDidReceiveMessage:Ne,postMessage:be.postMessage.bind(be)}}return $e}})})}static jb(Q,B,se,ae,ie){return se=se||{activate:void 0,deactivate:void 0},this.kb(Q,B,se,ae,ie).then(ce=>new P.$nnc(!1,null,ie.build(),se,ce,ae.subscriptions))}static kb(Q,B,se,ae,ie){if(typeof se.activate=="function")try{ie.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ce=typeof global=="object"?global:self,ue=se.activate.apply(ce,[ae]);return ie.activateCallStop(),ie.activateResolveStart(),Promise.resolve(ue).then(Z=>(ie.activateResolveStop(),Z))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(se)}lb(Q,B){this.bb(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:B}).then(void 0,se=>{this.s.error(se)})}mb(Q,B=0){const ae=Date.now();(0,M.$B)(()=>{for(let ie=B;ie<Q.length;ie+=1){const ce=Q[ie];for(const ue of ce.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-ae>50){this.mb(Q,ie);break}else this.lb(ce,ue)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(Q=>{const B=Q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(B)this.mb(se);else for(const ae of se)if(ae.activationEvents)for(const ie of ae.activationEvents)ie==="onStartupFinished"&&this.lb(ae,ie)})}ob(){const Q=this.ab("*",!0).then(void 0,ce=>{this.s.error(ce)});this.B(this.j.onDidChangeWorkspace(ce=>this.pb(ce.added)));const B=this.j.workspace?this.j.workspace.folders:[],se=this.pb(B),ae=this.rb(),ie=Promise.all([ae,Q,se]).then(()=>{});return Promise.race([ie,(0,L.$Bh)(1e4)]).then(()=>{this.nb()}),ie}pb(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.qb(Q,B))).then(()=>{})}async qb(Q,B){if(this.isActivated(B.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,ae={logService:this.s,folders:Q.map(ce=>ce.uri),forceUsingSearch:se||!this.c.fsExists,exists:ce=>this.c.fsExists(ce.fsPath),checkExists:(ce,ue,Z)=>this.y.$checkExists(ce,ue,Z)},ie=await(0,y.$Kwb)(ae,B);if(ie)return this.bb(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:ie.activationEvent}).then(void 0,ce=>this.s.error(ce))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Q){throw console.error(Q),Q}}async sb(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:B}=this.f.environment;if(!Q||!B)throw new Error(r.localize(0,null));const se=await this.xb(null,B,new P.$mnc(!1));if(!se||typeof se.run!="function")throw new Error(r.localize(1,null,B.toString()));return new Promise((ae,ie)=>{const ce=(oe,$e)=>{oe?(M.$t&&this.s.error("Test runner called back with error",oe),ie(oe)):(M.$t&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),ae(typeof $e=="number"&&$e>0?1:0))},ue=(0,R.$2g)(B),Z=se.run(ue,ce);Z&&Z.then&&Z.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),ae(0)}).catch(oe=>{M.$t&&this.s.error("Test runner finished with error",oe),ie(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Bh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,B){return this.S[Q]=B,(0,T.$Sc)(()=>{delete this.S[Q]})}async getRemoteExecServer(Q){const{resolver:B}=await this.ub(Q);return B?.resolveExecServer?.(Q,{resolveAttempt:0})}async ub(Q){const B=Q.indexOf("+");if(B===-1)throw new t.$CM("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=Q.substr(0,B);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(Q,B){const se=z.$be.create(!1),ae=()=>`[resolveAuthority(${(0,l.$Pl)(Q)},${B})][${se.elapsed()}ms] `,ie=q=>this.s.info(`${ae()}${q}`),ce=q=>this.s.warn(`${ae()}${q}`),ue=(q,Y=void 0)=>this.s.error(`${ae()}${q}`,Y),Z=q=>{if(q instanceof t.$CM)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},oe=async q=>{ie(`activating resolver for ${q}...`);const{resolver:Y,authorityPrefix:x}=await this.ub(q);if(!Y)throw ue(`no resolver for ${x}`),new t.$CM(`No remote extension installed to resolve ${x}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:x,remoteAuthority:q}},$e=Q.split(/@|%40/g).reverse();ie(`activating remote resolvers ${$e.join(" -> ")}`);let be;try{be=await Promise.all($e.map(oe)).catch(async q=>{if(!(q instanceof t.$CM)||q._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return ce(`resolving nested authorities failed: ${q.message}`),[await oe(Q)]})}catch(q){return Z(q)}const Ne=new L.$Lh;Ne.cancelAndSet(()=>ie("waiting..."),1e3);let Be,De;for(const[q,{authorityPrefix:Y,resolver:x,remoteAuthority:fe}]of be.entries())try{if(q===be.length-1)ie("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${Y}`),Be=await x.resolve(fe,{resolveAttempt:B,execServer:De}),A.mark(`code/extHost/didResolveAuthorityOK/${Y}`),ie("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,t.$BM.isManagedResolvedAuthority(Be)?Be:void 0));else{if(ie(`invoking resolveExecServer() for ${fe}`),A.mark(`code/extHost/willResolveExecServer/${Y}`),De=await x.resolveExecServer?.(fe,{resolveAttempt:B,execServer:De}),!De)throw new t.$CM(`Exec server was not available for ${fe}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(we){return A.mark(`code/extHost/didResolveAuthorityError/${Y}`),ue("returned an error",we),Ne.dispose(),Z(we)}Ne.dispose();const Ie={environmentTunnels:Be.environmentTunnels,features:Be.tunnelFeatures?{elevation:Be.tunnelFeatures.elevation,privacyOptions:Be.tunnelFeatures.privacyOptions,protocol:Be.tunnelFeatures.protocol===void 0?!0:Be.tunnelFeatures.protocol}:void 0},Le={extensionHostEnv:Be.extensionHostEnv,isTrusted:Be.isTrusted,authenticationSession:Be.authenticationSessionForInitializingExtensions?{id:Be.authenticationSessionForInitializingExtensions.id,providerId:Be.authenticationSessionForInitializingExtensions.providerId}:void 0};ie(`returned ${t.$BM.isManagedResolvedAuthority(Be)?"managed authority":`${Be.host}:${Be.port}`}`);let W;if(t.$BM.isManagedResolvedAuthority(Be)){const q=B;this.Y.setFactory(q,Be.makeConnection),W={authority:Q,connectTo:new l.$Ml(q),connectionToken:Be.connectionToken}}else W={authority:Q,connectTo:new l.$Nl(Be.host,Be.port),connectionToken:Be.connectionToken};return{type:"ok",value:{authority:W,options:Le,tunnelInformation:Ie}}}async $getCanonicalURI(Q,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$Pl)(Q)})`);const{resolver:se}=await this.ub(Q);if(!se)return null;const ae=c.URI.revive(B);if(typeof se.getCanonicalURI>"u")return ae;const ie=await(0,L.$sh)(()=>se.getCanonicalURI(ae));return ie||ae}async $startExtensionHost(Q){Q.toAdd.forEach(ce=>ce.extensionLocation=c.URI.revive(ce.extensionLocation));const{globalRegistry:B,myExtensions:se}=V(this.I,this.L,this.J,Q),ae=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(B.getAllExtensionDescriptions()),this.J.set(se),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${_(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${_(this.J)}`)),this.tb()}$activateByEvent(Q,B){return B===u.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(Q,!1)):this.G.wait().then(se=>this.ab(Q,!1))}async $activate(Q,B){return await this.G.wait(),this.J.getExtensionDescription(Q)?(await this.bb(Q,B),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(ce=>ce.extensionLocation=c.URI.revive(ce.extensionLocation));const{globalRegistry:B,myExtensions:se}=V(this.I,this.L,this.J,Q),ae=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(ae),this.L.set(B.getAllExtensionDescriptions()),this.J.set(se),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${_(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${_(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const B=s.$Je.alloc(Q),se=Math.random()%256;for(let ae=0;ae<Q;ae++)B.writeUInt8(se,ae);return B}async $updateRemoteConnectionData(Q){this.X=Q,this.a.fire()}};e.$Jnc=ee,e.$Jnc=ee=J=Je([Ge(0,h.$zi),Ge(1,e.$Inc),Ge(2,E.$YO),Ge(3,a.$7mc),Ge(4,d.$0mc),Ge(5,C.$7j),Ge(6,o.$cP),Ge(7,$.$anc),Ge(8,D.$nEb),Ge(9,v.$vnc),Ge(10,j.$Fnc),Ge(11,F.$Gnc),Ge(12,I.$znc)],ee);function V(pe,Q,B,se){pe.addActivationEvents(se.addActivationEvents);const ae=new f.$bbc(pe,Q.getAllExtensionDescriptions());ae.deltaExtensions(se.toAdd,se.toRemove);const ie=new n.$Xm(B.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of se.myToRemove)ie.delete(ue);for(const ue of se.myToAdd)ie.add(ue);const ce=he(ae,ie);return{globalRegistry:ae,myExtensions:ce}}function H(pe,Q){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}function _(pe){return pe.getAllExtensionDescriptions().map(Q=>Q.identifier.value).join(",")}e.$Knc=(0,h.$Ai)("IExtHostExtensionService");class ne{#e;#t;#i;constructor(Q,B,se,ae,ie){this.#e=Q,this.#t=B,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=m.$hc((0,R.$2g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ae,this.isFromDifferentExtensionHost=ie}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Lnc=ne;function he(pe,Q){return pe.getAllExtensionDescriptions().filter(B=>Q.has(B.identifier))}class re{constructor(Q){this.a=Q}setSearchTree(Q){this.a=Q}findSubstr(Q){return this.a.findSubstr(Q)}forEach(Q){return this.a.forEach(Q)}}e.$Mnc=re;class ve{constructor(Q){this.a=new n.$Ym,this.addActivationEvents(Q)}readActivationEvents(Q){return this.a.get(Q.identifier)??[]}addActivationEvents(Q){for(const B of Object.keys(Q))this.a.set(B,Q[B])}}}),define(ye[389],Se([1,0,62,2,6,48,26,24,20,30,5,53,12,13]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;let a=class{constructor(s,i,t,l,h,o,$){this.c=s,this.d=i,this.e=t,this.f=l,this.g=h,this.h=o,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new f(this.c,i,this.d,s,this.i)),this.register(this.e.createInstance(u)),this.h.remote.isRemote&&this.register(this.e.createInstance(g,i,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const i of s.nodeModuleName)this.a.set(i,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(i=>s.alternativeModuleName(i))}};e.$Voc=a,e.$Voc=a=Je([Ge(2,C.$zi),Ge(3,R.$0mc),Ge(4,S.$Knc),Ge(5,c.$cP),Ge(6,d.$7j)],a);let u=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&b.a.size){const i=(0,P.$df)(this.c(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",l=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${h}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const i=this.b.exec(this.c(s));if(!i)return;const[,t,l,h]=i,o=b.a.get(l);if(o!==void 0)return console.warn(`${l} as been renamed to ${o}, please update your imports`),t+o+h}c(s){return s.replace(/\\/g,"/")}};u=b=Je([Ge(0,c.$cP)],u);class f{constructor(s,i,t,l,h){this.c=s,this.d=i,this.e=t,this.f=l,this.g=h,this.nodeModuleName="vscode",this.a=new T.$Ym}load(s,i){const t=this.d.findSubstr(i);if(t){let l=this.a.get(t.identifier);return l||(l=this.c(t,this.e,this.f),this.a.set(t.identifier,l)),l}if(!this.b){let l="";this.d.forEach((h,o)=>l+=`	${o} -> ${h.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${l}`),this.b=this.c(L.$OG,this.e,this.f)}return this.b}}let g=class{constructor(s,i,t){this.e=s,this.f=i,this.nodeModuleName=["open","opn"],this.d=t.getProxy(A.$uM.MainThreadTelemetry);const l=t.getProxy(A.$uM.MainThreadWindow);this.c=(h,o)=>{const $=m.URI.parse(h);return o?this.g(h,o):$.scheme==="http"||$.scheme==="https"?l.$openUri($,h,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?l.$openUri($,h,{}):this.g(h,o)}}load(s,i,t){const l=this.e.findSubstr(i);return l&&(this.a=l.identifier.value,this.h()),this.b=t(s),this.c}g(s,i){return this.i(),this.b(s,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};g=Je([Ge(2,p.$YO)],g)}),define(ye[64],Se([1,0,49,3,16,56,5,78,77,53,10,47,316,48]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=e.$Nnc=void 0,e.$Nnc=(0,L.$Ai)("IExtHostVariableResolverProvider");class b extends d.$3P{constructor(f,g,n,s,i,t,l){function h(){if(n){const o=n.activeEditor();if(o)return o.document.uri;const $=s.tabGroups.all.find(E=>E.isActive)?.activeTab;if($!==void 0){if($.input instanceof C.$iO||$.input instanceof C.$nO)return $.input.modified;if($.input instanceof C.$hO||$.input instanceof C.$mO||$.input instanceof C.$kO)return $.input.uri}}}super({getFolderUri:o=>{const $=t.folders.filter(E=>E.name===o);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(o,$)=>i.getConfiguration(void 0,o).get($),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=h();if(o)return A.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const o=h();if(o){const $=g.getWorkspaceFolder(o);if($)return A.$hc($.uri.fsPath)}}},getSelectedText:()=>{if(n){const o=n.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(n){const o=n.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>f.getExtension(o)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(R.env))}}let a=class extends m.$Uc{constructor(f,g,n,s,i){super(),this.b=f,this.c=g,this.g=n,this.h=s,this.j=i,this.a=new r.$V(async()=>{const t=await this.h.getConfigProvider(),h={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{h.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,t,h,this.m())})}getResolver(){return this.a.value}m(){}};e.$Onc=a,e.$Onc=a=Je([Ge(0,c.$Knc),Ge(1,S.$7mc),Ge(2,T.$0O),Ge(3,P.$0mc),Ge(4,p.$jnc)],a)}),define(ye[101],Se([1,0,9,4,2,24,5,6,77,53,20,10,47,152,119,307,48,64,3,50,37,17,19]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnc=e.$Snc=e.$Rnc=e.$Qnc=e.$Pnc=void 0,e.$Pnc=(0,L.$Ai)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(v,I,w,y,N,O,U){this.N=I,this.O=w,this.P=y,this.Q=N,this.R=O,this.S=U,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new m.$he,this.o=new m.$he,this.q=new m.$he,this.w=new m.$he,this.l=v.getProxy(T.$uM.MainThreadDebugService),this.A=new m.$he,this.C=new m.$he,this.y=new o(this.l),this.z=new Map,this.O.getExtensionRegistry().then(j=>{j.onDidChange(z=>{this.V(j)}),this.V(j)})}async $getVisualizerTreeItem(v,I){const w=this.W(I);if(!w)return;const y=await this.H.get(v)?.getTreeItem?.(w);return y?this.U(v,y):void 0}registerDebugVisualizationTree(v,I,w){const y=R.$Wm.toKey(v.identifier),N=this.jb(y,I);if(this.G.has(N))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.H.set(N,w),this.l.$registerDebugVisualizerTree(N,!!w.editItem),(0,g.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(N),this.H.delete(I)})}async $getVisualizerTreeItemChildren(v,I){const w=this.J.get(I)?.item;return w?(await this.H.get(v)?.getChildren?.(w))?.map(N=>this.U(v,N))||[]:[]}async $editVisualizerTreeItem(v,I){const w=this.J.get(v);if(!w)return;const y=await this.H.get(w.provider)?.editItem?.(w.item,I);return this.U(w.provider,y||w.item)}$disposeVisualizedTree(v){const I=this.J.get(v);if(!I)return;const w=[I.children];for(const y of w)if(y)for(const N of y)w.push(this.J.get(N)?.children),this.J.delete(N)}U(v,I){let w=this.I.get(I);return w||(w=this.F++,this.I.set(I,w),this.J.set(w,{provider:v,item:I})),i.DebugTreeItem.from(I,w)}asDebugSourceUri(v,I){const w=v;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let y=`debug:${encodeURIComponent(w.path||"")}`,N="?";return I&&(y+=`${N}session=${encodeURIComponent(I.id)}`,N="&"),y+=`${N}ref=${w.sourceReference}`,A.URI.parse(y)}else{if(w.path)return A.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(v){const I=[];for(const w of v.getAllExtensionDescriptions())if(w.contributes){const y=w.contributes.debuggers;if(y&&y.length>0)for(const N of y)(0,a.$KH)(N)&&I.push(N.type)}this.l.$registerDebugTypes(I)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const v=[];return this.z.forEach(I=>v.push(I)),v}async $resolveDebugVisualizer(v,I){const w=this.L.get(v);if(!w)throw new Error(`No debug visualizer found with id '${v}'`);let{v:y,provider:N,extensionId:O}=w;if(y.visualization||(y=await N.resolveDebugVisualization?.(y,I)||y,w.v=y),!y.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.kb(O,y.visualization)}async $executeDebugVisualizerCommand(v){const I=this.L.get(v);if(!I)throw new Error(`No debug visualizer found with id '${v}'`);const w=I.v.visualization;w&&"command"in w&&this.S.executeCommand(w.command,...w.arguments||[])}W(v){const I=this.m.get(v.sessionId);return I&&{session:I.api,variable:v.variable,containerId:v.containerId,frameId:v.frameId,threadId:v.threadId}}async $provideDebugVisualizers(v,I,w,y){const N=this.W(w),O=this.jb(v,I),U=this.G.get(O);if(!N||!U)return[];const j=await U.provideDebugVisualization(N,y);return j?j.map(z=>{const M=++this.M;this.L.set(M,{v:z,provider:U,extensionId:v});const F=z.iconPath?this.lb(z.iconPath):void 0;return{id:M,name:z.name,iconClass:F?.iconClass,iconPath:F?.iconPath,visualization:this.kb(v,z.visualization)}}):[]}$disposeDebugVisualizers(v){for(const I of v)this.L.delete(I)}registerDebugVisualizationProvider(v,I,w){if(!v.contributes?.debugVisualizers?.some(O=>O.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const y=R.$Wm.toKey(v.identifier),N=this.jb(y,I);if(this.G.has(N))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.G.set(N,w),this.l.$registerDebugVisualizer(y,I),(0,g.$Sc)(()=>{this.l.$unregisterDebugVisualizer(y,I),this.G.delete(I)})}addBreakpoints(v){const I=v.filter(N=>{const O=N.id;return this.z.has(O)?!1:(this.z.set(O,N),!0)});this.gb(I,[],[]);const w=[],y=new Map;for(const N of I)if(N instanceof S.$yN){let O=y.get(N.location.uri.toString());O||(O={type:"sourceMulti",uri:N.location.uri,lines:[]},y.set(N.location.uri.toString(),O),w.push(O)),O.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof S.$zN&&w.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.l.$registerBreakpoints(w)}removeBreakpoints(v){const I=v.filter(O=>this.z.delete(O.id));this.gb([],I,[]);const w=I.filter(O=>O instanceof S.$yN).map(O=>O.id),y=I.filter(O=>O instanceof S.$zN).map(O=>O.id),N=I.filter(O=>O instanceof S.$AN).map(O=>O.id);return this.l.$unregisterBreakpoints(w,y,N)}startDebugging(v,I,w){return this.l.$startDebugging(v?v.uri:void 0,I,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(v){return this.l.$stopDebugging(v?v.id:void 0)}registerDebugConfigurationProvider(v,I,w){if(!I)return new S.$wM(()=>{});const y=this.d++;return this.f.push({type:v,handle:y,provider:I}),this.l.$registerDebugConfigurationProvider(v,w,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,y),new S.$wM(()=>{this.f=this.f.filter(N=>N.provider!==I),this.l.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(v,I,w){if(!w)return new S.$wM(()=>{});if(!this.cb(v,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.$(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:I,handle:y,factory:w}),this.l.$registerDebugAdapterDescriptorFactory(I,y),new S.$wM(()=>{this.h=this.h.filter(N=>N.factory!==w),this.l.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(v,I){if(!I)return new S.$wM(()=>{});const w=this.j++;return this.k.push({type:v,handle:w,factory:I}),new S.$wM(()=>{this.k=this.k.filter(y=>y.factory!==I)})}async $runInTerminal(v,I){return Promise.resolve(void 0)}async $substituteVariables(v,I){let w;const y=await this.ib(v);return y&&(w={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(w,I)}X(v,I){if(v.type==="implementation")return new E(v.implementation)}Y(){}async $startDASession(v,I){const w=this,y=await this.hb(I);return this.eb(this.$(y.type),y).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const O=this.Z(N),U=this.X(O,y);if(!U)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const j=U;return this.D.set(v,j),this.db(y).then(z=>(z&&this.E.set(v,z),j.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const F=M,J={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const ee=await this.K.sign(F.arguments.value);J.body={signature:ee},j.sendResponse(J)}else throw new Error("no signer")}catch(ee){J.success=!1,J.message=ee.message,j.sendResponse(J)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(M),M=(0,a.$PH)(M,!0),w.l.$acceptDAMessage(v,M)}),j.onError(M=>{z&&z.onError&&z.onError(M),this.l.$acceptDAError(v,M.name,M.message,M.stack)}),j.onExit(M=>{z&&z.onExit&&z.onExit(M??void 0,void 0),this.l.$acceptDAExit(v,M??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),j.startSession()))})}$sendDAMessage(v,I){I=(0,a.$OH)(I,!1);const w=this.E.get(v);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(I),this.D.get(v)?.sendMessage(I)}$stopDASession(v){const I=this.E.get(v);this.E.delete(v),I&&I.onWillStopSession&&I.onWillStopSession();const w=this.D.get(v);return this.D.delete(v),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(v){const I=[],w=[],y=[];if(v.added)for(const N of v.added){const O=N.id;if(O&&!this.z.has(O)){let U;if(N.type==="function")U=new S.$zN(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")U=new S.$AN(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const j=A.URI.revive(N.uri);U=new S.$yN(new S.$IM(j,new S.$xM(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,S.$wN)(U,O),this.z.set(O,U),I.push(U)}}if(v.removed)for(const N of v.removed){const O=this.z.get(N);O&&(this.z.delete(N),w.push(O))}if(v.changed){for(const N of v.changed)if(N.id){const O=this.z.get(N.id);if(O){if(O instanceof S.$zN&&N.type==="function"){const U=O;U.enabled=N.enabled,U.condition=N.condition,U.hitCondition=N.hitCondition,U.logMessage=N.logMessage,U.functionName=N.functionName}else if(O instanceof S.$yN&&N.type==="source"){const U=O;U.enabled=N.enabled,U.condition=N.condition,U.hitCondition=N.hitCondition,U.logMessage=N.logMessage,U.location=new S.$IM(A.URI.revive(N.uri),new S.$xM(N.line,N.character))}y.push(O)}}}this.gb(I,w,y)}async $acceptStackFrameFocus(v){let I;if(v){const w=await this.hb(v.sessionId);v.kind==="thread"?I=new S.$GN(w.api,v.threadId):I=new S.$FN(w.api,v.threadId,v.frameId)}this.B=I,this.C.fire(this.B)}$provideDebugConfigurations(v,I,w){return(0,r.$sh)(async()=>{const y=this.bb(v);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.ib(I);return y.provideDebugConfigurations(N,w)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(v,I,w,y){return(0,r.$sh)(async()=>{const N=this.bb(v);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.ib(I);return N.resolveDebugConfiguration(O,w,y)})}$resolveDebugConfigurationWithSubstitutedVariables(v,I,w,y){return(0,r.$sh)(async()=>{const N=this.bb(v);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.ib(I);return N.resolveDebugConfigurationWithSubstitutedVariables(O,w,y)})}async $provideDebugAdapter(v,I){const w=this.ab(v);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.hb(I);return this.eb(w,y).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.Z(N)})}async $acceptDebugSessionStarted(v){const I=await this.hb(v);this.n.fire(I.api)}async $acceptDebugSessionTerminated(v){const I=await this.hb(v);I&&(this.o.fire(I.api),this.m.delete(I.id))}async $acceptDebugSessionActiveChanged(v){this.u=v?await this.hb(v):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(v,I){(await this.hb(v))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(v,I){const y={session:(await this.hb(v)).api,event:I.event,body:I.body};this.w.fire(y)}Z(v){if(v instanceof S.$BN)return{type:"executable",command:v.command,args:v.args,options:v.options};if(v instanceof S.$CN)return{type:"server",port:v.port,host:v.host};if(v instanceof S.$DN)return{type:"pipeServer",path:v.path};if(v instanceof S.$EN)return{type:"implementation",implementation:v.implementation};throw new Error("convertToDto unexpected type")}$(v){const I=this.h.filter(w=>w.type===v);if(I.length>0)return I[0].factory}ab(v){const I=this.h.filter(w=>w.handle===v);if(I.length>0)return I[0].factory}bb(v){const I=this.f.filter(w=>w.handle===v);if(I.length>0)return I[0].provider}cb(v,I){if(v.contributes){const w=v.contributes.debuggers;if(w&&w.length>0){for(const y of w)if(y.label&&y.type&&y.type===I)return!0}}return!1}db(v){const w=v.configuration.type,y=this.k.filter(N=>N.type===w||N.type==="*").map(N=>(0,r.$sh)(()=>N.factory.createDebugAdapterTracker(v.api)).then(O=>O,O=>null));return Promise.race([Promise.all(y).then(N=>{const O=(0,t.$Hb)(N);if(O.length>0)return new $(O)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async eb(v,I){const w=I.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new S.$CN(w));if(v){const N=await this.O.getExtensionRegistry();return(0,r.$sh)(()=>v.createDebugAdapterDescriptor(I.api,this.fb(I,N))).then(O=>{if(O)return O})}const y=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(I,y))}fb(v,I){}gb(v,I,w){(v.length>0||I.length>0||w.length>0)&&this.A.fire(Object.freeze({added:v,removed:I,changed:w}))}async hb(v){if(v)if(typeof v=="string"){const I=this.m.get(v);if(I)return I}else{let I=this.m.get(v.id);if(!I){const w=await this.ib(v.folderUri),y=v.parent?this.m.get(v.parent):void 0;I=new h(this.l,v.id,v.type,v.name,w,v.configuration,y?.api),this.m.set(I.id,I),this.l.$sessionCached(I.id)}return I}throw new Error("cannot find session")}ib(v){if(v){const I=A.URI.revive(v);return this.N.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}jb(v,I){return`${v}\0${I}`}kb(v,I){if(I){if("title"in I&&"command"in I)return{type:b.DebugVisualizationType.Command};if("treeId"in I)return{type:b.DebugVisualizationType.Tree,id:`${v}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(v){const I=this.mb(v);let w,y;return"id"in I?y=n.ThemeIcon.asClassName(I):w=I,{iconPath:w,iconClass:y}}mb(v){if(v instanceof S.$tN)return{id:v.id};const I=typeof v=="object"&&"dark"in v?v.dark:v,w=typeof v=="object"&&"light"in v?v.light:v;return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof w=="string"?A.URI.file(w):w}}};e.$Qnc=l,e.$Qnc=l=Je([Ge(0,C.$YO),Ge(1,d.$7mc),Ge(2,c.$Knc),Ge(3,u.$0mc),Ge(4,p.$jnc),Ge(5,f.$Nnc),Ge(6,s.$iP)],l);class h{constructor(v,I,w,y,N,O,U){this.f=v,this.g=I,this.h=w,this.j=y,this.k=N,this.l=O,this.m=U}get api(){const v=this;return this.d??=Object.freeze({id:v.g,type:v.h,get name(){return v.j},set name(I){v.j=I,v.f.$setDebugSessionName(v.g,I)},parentSession:v.m,workspaceFolder:v.k,configuration:v.l,customRequest(I,w){return v.f.$customDebugAdapterRequest(v.g,I,w)},getDebugProtocolBreakpoint(I){return v.f.$getDebugProtocolBreakpoint(v.g,I.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(v){this.j=v}get configuration(){return this.l}}e.$Rnc=h;class o{constructor(v){this.value=Object.freeze({append(I){v.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.$Snc=o;class ${constructor(v){this.d=v}onWillStartSession(){this.d.forEach(v=>v.onWillStartSession?v.onWillStartSession():void 0)}onWillReceiveMessage(v){this.d.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(v):void 0)}onDidSendMessage(v){this.d.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(v):void 0)}onWillStopSession(){this.d.forEach(v=>v.onWillStopSession?v.onWillStopSession():void 0)}onError(v){this.d.forEach(I=>I.onError?I.onError(v):void 0)}onExit(v,I){this.d.forEach(w=>w.onExit?w.onExit(v,I):void 0)}}class E extends P.$fsb{constructor(v){super(),this.h=v,v.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(v){this.h.handleMessage(v)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let k=class extends l{constructor(v,I,w,y,N,O,U){super(v,I,w,y,N,O,U)}};e.$Tnc=k,e.$Tnc=k=Je([Ge(0,C.$YO),Ge(1,d.$7mc),Ge(2,c.$Knc),Ge(3,u.$0mc),Ge(4,p.$jnc),Ge(5,f.$Nnc),Ge(6,s.$iP)],k)}),define(ye[390],Se([1,0,14,62,2,6,338,12,89,114,30,274,20,72,53,95]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=e.$Woc=void 0;class u{static async installEarlyHandler(n){Error.stackTraceLimit=100;const s=n.get(T.$7j),t=n.get(d.$YO).getProxy(R.$uM.MainThreadErrors);r.setUnexpectedErrorHandler(l=>{s.error(l);const h=r.$3(l);t.$onUnexpectedError(h)})}static async installFullHandler(n){const s=n.get(T.$7j),i=n.get(d.$YO),t=n.get(b.$Knc),l=n.get(a.$gP),h=i.getProxy(R.$uM.MainThreadExtensionService),o=i.getProxy(R.$uM.MainThreadErrors),$=await t.getExtensionPathIndex(),E=new WeakMap;function k(I,w){if(E.has(I))return E.get(I).stack;let y="",N,O;for(const j of w)y+=`
	at ${j.toString()}`,O=j.getFileName(),!N&&O&&(N=$.findSubstr(A.URI.file(O)));const U=`${I.name||"Error"}: ${I.message||""}${y}`;return E.set(I,{extensionIdentifier:N?.identifier,stack:U}),U}const D=Symbol("prepareStackTrace wrapped");let v=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(I){if(I===k||!I||I[D]){v=I||k;return}v=function(w,y){return k(w,y),I.call(Error,w,y)},Object.assign(v,{[D]:!0})}}),r.setUnexpectedErrorHandler(I=>{s.error(I);const w=r.$3(I),y=E.get(I);if(!y?.extensionIdentifier){o.$onUnexpectedError(w);return}h.$onExtensionRuntimeError(y.extensionIdentifier,w);const N=l.onExtensionError(y.extensionIdentifier,I);s.trace("forwarded error to extension?",N,y)})}}e.$Woc=u;class f{constructor(n,s,i,t,l){this.a=i,this.b=new L.$jbc(n,null,t),s=f.e(s,this.b);const h=new c.$yi(...(0,p.$Gs)());h.set(C.$cP,{_serviceBrand:void 0,...s,messagePorts:l}),h.set(d.$YO,new d.$ZO(this.b)),h.set(P.$4mc,new P.$5mc(t)),h.set(b.$Inc,i);const o=new S.$kr(h,!0);o.invokeFunction(u.installEarlyHandler),this.d=o.invokeFunction($=>$.get(T.$7j)),m.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=o.invokeFunction($=>$.get(b.$Knc)),this.c.initialize(),o.invokeFunction(u.installFullHandler)}async asBrowserUri(n){const s=this.b.getProxy(R.$uM.MainThreadExtensionService);return A.URI.revive(await s.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,s){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=A.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=A.URI.revive(s.transformIncomingURIs(n.environment.appRoot));const i=n.environment.extensionDevelopmentLocationURI;return i&&(n.environment.extensionDevelopmentLocationURI=i.map(t=>A.URI.revive(s.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=A.URI.revive(s.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=A.URI.revive(s.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=A.URI.revive(s.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=A.URI.revive(s.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=A.URI.revive(s.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=A.URI.revive(s.transformIncomingURIs(n.logsLocation)),n.workspace=s.transformIncomingURIs(n.workspace),n}}e.$Xoc=f}),define(ye[391],Se([1,0,9,11,244,267,147,101,77,53,20,46,10,64,47,308,309,48,37]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=void 0;let n=class extends T.$Qnc{constructor(h,o,$,E,k,D,v,I){super(h,o,$,E,D,v,I),this.pb=k,this.nb=new t}X(h,o){switch(h.type){case"server":return new a.$3oc(h);case"pipeServer":return new a.$4oc(h);case"executable":return new a.$5oc(h,o.type)}return super.X(h,o)}fb(h,o){const $=a.$5oc.platformAdapterExecutable(o.getAllExtensionDescriptions(),h.type);if($)return new d.$BN($.command,$.args,$.options)}Y(){return new L.$gfc}async $runInTerminal(h,o){if(h.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(j=>{this.nb.onTerminalClosed(j)}));const $=await this.P.getConfigProvider(),E=this.pb.getDefaultShell(!0),k=this.pb.getDefaultShellArgs(!0),D=h.title||A.localize(0,null),v=JSON.stringify({shell:E,shellArgs:k});let I=await this.nb.checkout(v,D),w,y=!1;if(I)w=h.cwd;else{const j={shellPath:E,shellArgs:k,cwd:h.cwd,name:D,iconPath:new d.$tN("debug")};y=!0,I=this.pb.createTerminalFromOptions(j,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(I,v)}I.show(!0);const N=await I.processId;y?await new Promise(j=>setTimeout(j,1e3)):(I.state.isInteractedWith&&(I.sendText(""),await(0,r.$Bh)(200)),$.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0||E.indexOf("cmd.exe")>=0?I.sendText("cls"):E.indexOf("bash")>=0?I.sendText("clear"):m.$i?I.sendText("cls"):I.sendText("clear")));const O=(0,u.$7oc)(E,h.args,!!h.argsCanBeInterpretedByShell,w,h.env);I.sendText(O);const U=this.onDidTerminateDebugSession(j=>{j.id===o&&(this.nb.free(I),U.dispose())});return N}else if(h.kind==="external")return i(h,await this.P.getConfigProvider());return super.$runInTerminal(h,o)}};e.$8oc=n,e.$8oc=n=Je([Ge(0,C.$YO),Ge(1,b.$7mc),Ge(2,c.$Knc),Ge(3,f.$0mc),Ge(4,S.$vnc),Ge(5,p.$jnc),Ge(6,P.$Nnc),Ge(7,g.$iP)],n);let s;function i(l,h){if(!s)if(m.$i)s=new R.$2dc;else if(m.$j)s=new R.$3dc;else if(m.$k)s=new R.$4dc;else throw new Error("external terminals not supported on this platform");const o=h.getConfiguration("terminal");return s.runInTerminal(l.title,l.cwd,l.args,l.env||{},o.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(h,o,$=!1){const k=[...this.b.entries()].map(([D,v])=>(0,r.$nh)(async I=>{if(D.name!==o||v.lastUsedAt!==-1&&await(0,u.$6oc)(await D.processId))return null;const w=Date.now();return v.lastUsedAt+t.a>w||I.isCancellationRequested?null:v.config!==h?($&&D.dispose(),null):(v.lastUsedAt=w,D)}));return await(0,r.$Fh)(k,D=>!!D)}insert(h,o){this.b.set(h,{lastUsedAt:Date.now(),config:o})}free(h){const o=this.b.get(h);o&&(o.lastUsedAt=-1)}onTerminalClosed(h){this.b.delete(h)}}}),define(ye[392],Se([1,0,16,2,111,47,78,48,45,46,20,30,100,15,12,96,23,67,64]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=void 0;let n=class extends d.$zoc{constructor(i,t,l,h,o,$,E,k,D){super(i,t,l,h,o,$,E,k),this.C=l,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(i,t){const l=t;if(!t.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const h=d.TaskHandleDTO.from(l,this.C),o=await this.a.$getTaskExecution(h);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const $=await this.z(o,t);return this.a.$executeTask(h).catch(()=>{}),$}else{const h=d.TaskDTO.from(t,i);if(h===void 0)return Promise.reject(new Error("Task is not valid"));d.CustomExecutionDTO.is(h.execution)&&await this.y(h,t,!1);const o=await this.z(await this.a.$getTaskExecution(h),t);return this.a.$executeTask(h).catch(()=>{}),o}}v(i,t,l,h){const o=[];if(h)for(const $ of h){this.A($,l),(!$.definition||!i[$.definition.type])&&this.f.warn(`The task [${$.source}, ${$.name}] uses an undefined task type. The task will be ignored in the future.`);const E=d.TaskDTO.from($,l.extension);E&&(o.push(E),d.CustomExecutionDTO.is(E.execution)&&t.push(this.y(E,$,!0)))}return{tasks:o,extension:l.extension}}async w(i){return i}async G(i){let t=i&&i.length>0?i[0]:void 0;if(!t){const l=m.URI.file((0,f.homedir)());t=new p.$Ui({uri:l,name:u.$$g(l),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(i,t){const l=m.URI.revive(i),h={process:void 0,variables:Object.create(null)},o=await this.b.resolveWorkspaceFolder(l),$=await this.b.getWorkspaceFolders2()??[],E=await this.D.getResolver(),k=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G($);for(const D of t.variables)h.variables[D]=await E.resolveAsync(k,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(r.$tc);for(let v=0;v<D.length;v++)D[v]=await E.resolveAsync(k,D[v])}h.process=await A.win32.findExecutable(await E.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await E.resolveAsync(k,t.process.cwd):void 0,D)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(i,t,l){return A.win32.findExecutable(i,t,l)}};e.$Zoc=n,e.$Zoc=n=Je([Ge(0,C.$YO),Ge(1,S.$cP),Ge(2,R.$7mc),Ge(3,L.$0O),Ge(4,T.$0mc),Ge(5,c.$vnc),Ge(6,b.$7j),Ge(7,a.$Kmc),Ge(8,g.$Nnc)],n)}),define(ye[393],Se([1,0,67,64]),function(de,e,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0;class A extends m.$Onc{m(){return(0,r.homedir)()}}e.$Fpc=A}),define(ye[169],Se([1,0,19,9,21,51,15,16,23,2,38]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=e.$9nc=e.$8nc=void 0,e.$0nc=a;class S{constructor(g,n,s){this.d=g,this.e=n,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(g,n){const s=this.g.folderQueries||[],i=new A.$se(n);return new Promise((t,l)=>{this.a=new P(g);let h=!1;const o=($,E)=>{if(!h&&!this.b){const k=this.h($);a($)&&typeof this.g.maxResults=="number"&&this.c+k>this.g.maxResults&&(this.b=!0,h=!0,i.cancel(),$=this.j($,this.g.maxResults-this.c));const D=this.h($);this.c+=D,(D>0||!a($))&&this.a.add($,E)}};Promise.all(s.map(($,E)=>this.k($,k=>o(k,E),i.token))).then($=>{i.dispose(),this.a.flush();const E=$.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||E,messages:$.flatMap(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[]),stats:{type:this.f}})},$=>{i.dispose();const E=(0,R.$lj)($);l(new Error(E))})})}h(g){return a(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,n){const s=Array.isArray(g.ranges)?g.ranges:[g.ranges],i=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:s.slice(0,n),preview:{matches:i.slice(0,n),text:g.preview.text},uri:g.uri}}async k(g,n,s){const i=new C.$1K(this.g,g),t=[],l={report:$=>{if(!this.l($))return;const E=g.folder.scheme===L.Schemas.file?(0,C.$2K)(()=>this.e.readdir(p.$ah($.uri))):void 0,k=p.$dh(g.folder,$.uri);if(k){const D=i.includedInQuery(k,T.$nc(k),E);(0,m.$mh)(D)?t.push(D.then(v=>{v&&n($)})):D&&n($)}}},h=this.n(g);let o;return this.d.query.type===C.QueryType.aiText?o=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,h,l,s):o=await this.d.provider.provideTextSearchResults(d(this.d.query.contentPattern),h,l,s),t.length&&await Promise.all(t),o}l(g){if(a(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const n=(0,C.$ZK)(this.g.includePattern,g.includePattern),s=(0,C.$ZK)(this.g.excludePattern,g.excludePattern),i={folder:c.URI.from(g.folder),excludes:s,includes:n,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.e.toCanonicalName(g.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(i.usePCRE2=this.g.usePCRE2),i}}e.$8nc=S;function d(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class P{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new u(512,n=>this.g(n))}add(g,n){this.d&&(this.b!==n||!p.$7g(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:g.uri,results:[]}),this.d.results.push(b(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.$9nc=P;function b(f){return a(f)?{preview:{matches:(0,r.$1b)(f.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:f.preview.text},ranges:(0,r.$1b)(f.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function a(f){return!!f.preview}class u{static{this.a=4e3}static{this.b=50}constructor(g,n){this.g=g,this.h=n,this.c=0,this.d=[],this.e=0}addItem(g,n){g&&this.j(g,n)}addItems(g,n){g&&this.k(g,n)}j(g,n){this.d.push(g),this.e+=n,this.l()}k(g,n){this.d=this.d.concat(g),this.e+=n,this.l()}l(){this.c<u.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},u.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$$nc=u}),define(ye[102],Se([1,0,3,6,5,386,20,72,12,2,169]),function(de,e,r,m,A,R,L,T,p,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=e.$_nc=void 0,e.$boc=d,e.$_nc=(0,A.$Ai)("IExtHostSearch");let S=class{constructor(a,u,f){this.n=a,this.o=u,this.q=f,this.c=this.n.getProxy(m.$uM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$7nc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,u){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const f=this.d++;return this.e.set(f,u),this.c.$registerTextSearchProvider(f,this.s(a)),(0,r.$Sc)(()=>{this.g.delete(a),this.e.delete(f),this.c.$unregisterProvider(f)})}registerAITextSearchProvider(a,u){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const f=this.d++;return this.h.set(f,u),this.c.$registerAITextSearchProvider(f,this.s(a)),(0,r.$Sc)(()=>{this.i.delete(a),this.h.delete(f),this.c.$unregisterProvider(f)})}registerFileSearchProvider(a,u){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const f=this.d++;return this.j.set(f,u),this.c.$registerFileSearchProvider(f,this.s(a)),(0,r.$Sc)(()=>{this.k.delete(a),this.j.delete(f),this.c.$unregisterProvider(f)})}$provideFileSearchResults(a,u,f,g){const n=d(f),s=this.j.get(a);if(s)return this.l.fileSearch(n,s,i=>{this.c.$handleFileMatch(a,u,i.map(t=>t.resource))},g);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,u,f){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,u,f,g){const n=this.e.get(a);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${a}`);const s=d(f);return this.t(s,n).search(t=>this.c.$handleTextMatch(a,u,t),g)}$provideAITextSearchResults(a,u,f,g){const n=this.h.get(a);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${a}`);const s=d(f);return this.v(s,n).search(t=>this.c.$handleTextMatch(a,u,t),g)}$enableExtensionHostSearch(){}t(a,u){return new C.$8nc({query:a,provider:u},{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}v(a,u){return new C.$8nc({query:a,provider:u},{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"aiTextSearchProvider")}};e.$aoc=S,e.$aoc=S=Je([Ge(0,L.$YO),Ge(1,T.$4mc),Ge(2,p.$7j)],S);function d(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(P),extraFileResources:b.extraFileResources&&b.extraFileResources.map(a=>c.URI.revive(a))}}function P(b){return{...b,folder:c.URI.revive(b.folder)}}}),define(ye[394],Se([1,0,21,14,4,3,15,43,2,113,211,192,55,24,28,12,91,92,294,6,340,366,96,127,344,345,346,325,314,37,347,48,348,101,161,349,327,341,350,351,78,77,328,342,53,352,75,353,63,30,367,329,354,128,355,122,123,330,385,357,298,358,368,359,167,331,360,361,362,20,363,102,124,364,332,365,125,98,100,95,46,165,369,370,343,371,372,76,17,10,333,72,334,97,373,374,160,47,119,94,26,99]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i,t,l,h,o,$,E,k,D,v,I,w,y,N,O,U,j,z,M,F,J,ee,V,H,_,ne,he,re,ve,pe,Q,B,se,ae,ie,ce,ue,Z,oe,$e,be,Ne,Be,De,Ie,Le,W,q,Y,x,fe,we,Me,qe,He,Ze,it,tt,rt,ot,ft,ut,st,Pe,Ue,Ae,Te,le,X,Ce,Qe,_e,at,lt,Dt,Ct,Ot,Yt,_t,xe,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=zt;function zt(gt){const $t=gt.get(ve.$cP),ei=gt.get(re.$Omc),Xt=gt.get(ne.$_mc),Bt=gt.get(H.$Knc),bt=gt.get(Ot.$7mc),Mt=gt.get(rt.$gP),Ht=gt.get(I.$0mc),Wt=gt.get(Qe.$4mc),Xe=gt.get(Y.$YO),ti=gt.get(Ze.$snc),ii=gt.get(it.$anc),li=gt.get(a.$8j),kt=gt.get(a.$7j),Nt=gt.get(Te.$nEb),Rt=gt.get(t.$Kmc),Ft=gt.get(Ct.$Qoc),ui=gt.get(we.$Cnc),qt=gt.get(J.$jnc),si=gt.get(ce.$Gnc),Ut=gt.get(l.$Umc),Zt=gt.get(se.$znc);Xe.set(n.$vM.ExtHostFileSystemInfo,ei),Xe.set(n.$vM.ExtHostLogLevelServiceShape,li),Xe.set(n.$vM.ExtHostWorkspace,bt),Xe.set(n.$vM.ExtHostConfiguration,Ht),Xe.set(n.$vM.ExtHostExtensionService,Bt),Xe.set(n.$vM.ExtHostStorage,ti),Xe.set(n.$vM.ExtHostTunnelService,Nt),Xe.set(n.$vM.ExtHostWindow,Ft),Xe.set(n.$vM.ExtHostSecretState,ui),Xe.set(n.$vM.ExtHostTelemetry,Mt),Xe.set(n.$vM.ExtHostEditorTabs,qt),Xe.set(n.$vM.ExtHostManagedSockets,si),Xe.set(n.$vM.ExtHostAuthentication,Ut),Xe.set(n.$vM.ExtHostChatProvider,Zt);const oi=Xe.set(n.$vM.ExtHostDecorations,gt.get(N.$Vnc)),At=Xe.set(n.$vM.ExtHostDocumentsAndEditors,gt.get(F.$0O)),vt=Xe.set(n.$vM.ExtHostCommands,gt.get(D.$iP)),pt=Xe.set(n.$vM.ExtHostTerminalService,gt.get(ot.$vnc)),Gt=Xe.set(n.$vM.ExtHostTerminalShellIntegration,gt.get(ft.$Coc)),St=Xe.set(n.$vM.ExtHostDebugService,gt.get(y.$Pnc)),ai=Xe.set(n.$vM.ExtHostSearch,gt.get(fe.$_nc)),Kt=Xe.set(n.$vM.ExtHostTask,gt.get(tt.$Boc)),$i=Xe.set(n.$vM.ExtHostOutputService,gt.get(De.$ooc)),di=Xe.set(n.$vM.ExtHostLocalization,gt.get(ie.$Fnc)),Di=Xe.set(n.$vM.ExtHostUrls,new _e.$Noc(Xe)),Tt=Xe.set(n.$vM.ExtHostDocuments,new M.$Rmc(Xe,At)),Ci=Xe.set(n.$vM.ExtHostDocumentContentProviders,new j.$Xnc(Xe,At,kt)),ci=Xe.set(n.$vM.ExtHostDocumentSaveParticipant,new z.$Ync(kt,Tt,Xe.getProxy(n.$uM.MainThreadBulkEdits))),Pt=Xe.set(n.$vM.ExtHostNotebook,new Z.$coc(Xe,vt,At,Tt,Xt,ai,kt)),Ii=Xe.set(n.$vM.ExtHostNotebookDocuments,new $e.$ioc(Pt)),vi=Xe.set(n.$vM.ExtHostNotebookEditors,new be.$joc(kt,Pt)),pi=Xe.set(n.$vM.ExtHostNotebookKernels,new Ne.$koc(Xe,$t,Pt,vt,kt)),Ai=Xe.set(n.$vM.ExtHostNotebookRenderers,new Be.$moc(Xe,Pt)),fi=Xe.set(n.$vM.ExtHostNotebookDocumentSaveParticipant,new oe.$hoc(kt,Pt,Xe.getProxy(n.$uM.MainThreadBulkEdits))),Re=Xe.set(n.$vM.ExtHostEditors,new st.$1mc(Xe,At)),je=Xe.set(n.$vM.ExtHostTreeViews,new Ae.$Loc(Xe.getProxy(n.$uM.MainThreadTreeViews),vt,kt)),ke=Xe.set(n.$vM.ExtHostEditorInsets,new k.$2mc(Xe.getProxy(n.$uM.MainThreadEditorInsets),Re,$t.remote)),te=Xe.set(n.$vM.ExtHostDiagnostics,new O.$Qmc(Xe,kt,ei,At)),Fe=Xe.set(n.$vM.ExtHostLanguages,new ae.$foc(Xe,Tt,vt.converter,Wt)),Ve=Xe.set(n.$vM.ExtHostLanguageFeatures,new B.$Smc(Xe,Wt,Tt,vt,te,kt,Rt,Mt)),et=Xe.set(n.$vM.ExtHostFileSystem,new _.$2nc(Xe,Ve)),Ke=Xe.set(n.$vM.ExtHostFileSystemEventService,new he.$3nc(Xe,kt,At)),dt=Xe.set(n.$vM.ExtHostQuickOpen,(0,q.$soc)(Xe,bt,vt)),It=Xe.set(n.$vM.ExtHostSCM,new x.$uoc(Xe,vt,Tt,kt)),xt=Xe.set(n.$vM.ExtHostQuickDiff,new W.$roc(Xe,Wt)),ni=Xe.set(n.$vM.ExtHostShare,new Me.$voc(Xe,Wt)),jt=Xe.set(n.$vM.ExtHostComments,(0,v.$3mc)(Xe,vt,Tt)),Jt=Xe.set(n.$vM.ExtHostProgress,new Le.$qoc(Xe.getProxy(n.$uM.MainThreadProgress))),Fi=Xe.set(n.$vM.ExtHostLabelService,new Q.$eoc(Xe)),ji=Xe.set(n.$vM.ExtHostTheming,new Pe.$Ioc(Xe)),Xi=Xe.set(n.$vM.ExtHostTimeline,new Ue.$Koc(Xe,vt)),Ui=Xe.set(n.$vM.ExtHostWebviews,new at.$enc(Xe,$t.remote,bt,kt,Rt)),Ti=Xe.set(n.$vM.ExtHostWebviewPanels,new lt.$hnc(Xe,Ui,bt)),zi=Xe.set(n.$vM.ExtHostCustomEditors,new w.$inc(Xe,Tt,ii,Ui,Ti)),Bi=Xe.set(n.$vM.ExtHostWebviewViews,new Dt.$Ooc(Xe,Ui)),yi=Xe.set(n.$vM.ExtHostTesting,new ut.$Eoc(Xe,kt,vt,At)),Zi=Xe.set(n.$vM.ExtHostUriOpeners,new Ce.$Moc(Xe)),xi=Xe.set(n.$vM.ExtHostProfileContentHandlers,new Ie.$poc(Xe));Xe.set(n.$vM.ExtHostInteractive,new pe.$doc(Xe,Pt,At,vt,kt));const Li=Xe.set(n.$vM.ExtHostChatAgents2,new o.$Xmc(Xe,kt,vt,$t.quality)),Wi=Xe.set(n.$vM.ExtHostChatVariables,new $.$Ymc(Xe)),Vi=Xe.set(n.$vM.ExtHostAiRelatedInformation,new s.$Jmc(Xe)),mn=Xe.set(n.$vM.ExtHostAiEmbeddingVector,new V.$1nc(Xe)),_i=Xe.set(n.$vM.ExtHostStatusBar,new He.$yoc(Xe,vt.converter)),qi=Xe.set(n.$vM.ExtHostSpeech,new qe.$woc(Xe)),Ei=Xe.set(n.$vM.ExtHostEmbeddings,new ee.$Znc(Xe)),gn=Object.values(n.$vM);Xe.assertRegistered(gn);const $n=new h.$Wmc(Xe,At),en=new E.$Zmc(Xe),Gi=new ue.$goc(Xe,kt),Oi=new U.$Wnc(Xe);return i.$Tmc.register(vt),function(We,mi,Hi){function ct(me){return(Ee,ze,ht)=>{const Et=me(Lt=>{try{Ee.call(ze,Lt)}catch(Si){m.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Mt.onExtensionError(We.identifier,Si)}});return ht?.push(Et),Et}}const yt=function(){let me=!We.isUnderDevelopment;function Ee(){me||(kt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function ze(ht){if(Array.isArray(ht))ht.forEach(ze);else if(typeof ht=="string")Ee();else{const Et=ht;typeof Et.scheme>"u"&&Ee(),typeof Et.exclusive=="boolean"&&(0,xe.$UG)(We,"documentFiltersExclusive")}return ht}}(),tn={getSession(me,Ee,ze){return typeof ze?.forceNewSession=="object"&&ze.forceNewSession.learnMore&&(0,xe.$UG)(We,"authLearnMore"),Ut.getSession(We,me,Ee,ze)},getSessions(me,Ee){return(0,xe.$UG)(We,"authGetSessions"),Ut.getSessions(We,me,Ee)},async hasSession(me,Ee){return(0,xe.$UG)(We,"authSession"),!!await Ut.getSession(We,me,Ee,{silent:!0})},get onDidChangeSessions(){return ct(Ut.onDidChangeSessions)},registerAuthenticationProvider(me,Ee,ze,ht){return Ut.registerAuthenticationProvider(me,Ee,ze,ht)}},bi={registerCommand(me,Ee,ze){return vt.registerCommand(!0,me,Ee,ze,void 0,We)},registerTextEditorCommand(me,Ee,ze){return vt.registerCommand(!0,me,(...ht)=>{const Et=Re.getActiveTextEditor();if(!Et){kt.warn("Cannot execute "+me+" because there is no active text editor.");return}return Et.edit(Lt=>{Ee.apply(ze,[Et,Lt,...ht])}).then(Lt=>{Lt||kt.warn("Edits from command "+me+" were not applied.")},Lt=>{kt.warn("An error occurred while running command "+me,Lt)})},void 0,void 0,We)},registerDiffInformationCommand:(me,Ee,ze)=>((0,xe.$UG)(We,"diffCommand"),vt.registerCommand(!0,me,async(...ht)=>{const Et=At.activeEditor(!0);if(!Et){kt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Lt=await Re.getDiffInformation(Et.id);Ee.apply(ze,[Lt,...ht])},void 0,void 0,We)),executeCommand(me,...Ee){return vt.executeCommand(me,...Ee)},getCommands(me=!1){return vt.getCommands(me)}},Ri={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return en.value},get shell(){return pt.getDefaultShell(!1)},get onDidChangeShell(){return ct(pt.onDidChangeShell)},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ct(Mt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$UG)(We,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$UG)(We,"telemetry"),ct(Mt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,rt.$fP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(me,Ee){return rt.$eP.validateSender(me),Mt.instantiateLogger(We,me,Ee)},openExternal(me,Ee){return Ft.openUri(me,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===$t.environment.appUriScheme)return Di.createAppUri(me);try{return await Ft.asExternalUri(me,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,L.$Jg)(me,L.Schemas.http)||(0,L.$Jg)(me,L.Schemas.https))return me;throw Ee}},get remoteName(){return(0,u.$Nm)($t.remote.authority)},get remoteAuthority(){return(0,xe.$UG)(We,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return kt.getLevel()},get onDidChangeLogLevel(){return ct(kt.onDidChangeLogLevel)},get appQuality(){return(0,xe.$UG)(We,"resolvers"),$t.quality},get appCommit(){return(0,xe.$UG)(We,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Ri);const pn={createTestController(me,Ee,ze){return yi.createTestController(We,me,Ee,ze)},createTestObserver(){return(0,xe.$UG)(We,"testObserver"),yi.createTestObserver()},runTests(me){return(0,xe.$UG)(We,"testObserver"),yi.runTests(me)},registerTestFollowupProvider(me){return(0,xe.$UG)(We,"testObserver"),yi.registerTestFollowupProvider(me)},get onDidChangeTestResults(){return(0,xe.$UG)(We,"testObserver"),ct(yi.onResultsChanged)},get testResults(){return(0,xe.$UG)(We,"testObserver"),yi.results}},ri=$t.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,Ni={getExtension(me,Ee){(0,xe.$TG)(We,"extensionsAny")||(Ee=!1);const ze=mi.mine.getExtensionDescription(me);if(ze)return new H.$Lnc(Bt,We.identifier,ze,ri,!1);if(Ee){const ht=mi.all.getExtensionDescription(me);if(ht)return new H.$Lnc(Bt,We.identifier,ht,ri,!0)}},get all(){const me=[];for(const Ee of mi.mine.getAllExtensionDescriptions())me.push(new H.$Lnc(Bt,We.identifier,Ee,ri,!1));return me},get allAcrossExtensionHosts(){(0,xe.$UG)(We,"extensionsAny");const me=new P.$Xm(mi.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),Ee=[];for(const ze of mi.all.getAllExtensionDescriptions()){const ht=!me.has(ze.identifier);Ee.push(new H.$Lnc(Bt,We.identifier,ze,ri,ht))}return Ee},get onDidChange(){return(0,xe.$TG)(We,"extensionsAny")?ct(A.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):ct(mi.mine.onDidChange)}},nn={createDiagnosticCollection(me){return te.createDiagnosticCollection(We.identifier,me)},get onDidChangeDiagnostics(){return ct(te.onDidChangeDiagnostics)},getDiagnostics:me=>te.getDiagnostics(me),getLanguages(){return Fe.getLanguages()},setTextDocumentLanguage(me,Ee){return Fe.changeLanguage(me.uri,Ee)},match(me,Ee){const ze=le.LanguageSelector.from(me);let ht;return(0,C.$ht)(ze)&&(ht=Pt.notebookDocuments.find(Et=>Et.apiNotebook.getCells().find(Lt=>Lt.document===Ee))?.apiNotebook),(0,C.$gt)(ze,Ee.uri,Ee.languageId,!0,ht?.uri,ht?.notebookType)},registerCodeActionsProvider(me,Ee,ze){return Ve.registerCodeActionProvider(We,yt(me),Ee,ze)},registerDocumentPasteEditProvider(me,Ee,ze){return(0,xe.$UG)(We,"documentPaste"),Ve.registerDocumentPasteEditProvider(We,yt(me),Ee,ze)},registerCodeLensProvider(me,Ee){return Ve.registerCodeLensProvider(We,yt(me),Ee)},registerDefinitionProvider(me,Ee){return Ve.registerDefinitionProvider(We,yt(me),Ee)},registerDeclarationProvider(me,Ee){return Ve.registerDeclarationProvider(We,yt(me),Ee)},registerImplementationProvider(me,Ee){return Ve.registerImplementationProvider(We,yt(me),Ee)},registerTypeDefinitionProvider(me,Ee){return Ve.registerTypeDefinitionProvider(We,yt(me),Ee)},registerHoverProvider(me,Ee){return Ve.registerHoverProvider(We,yt(me),Ee,We.identifier)},registerEvaluatableExpressionProvider(me,Ee){return Ve.registerEvaluatableExpressionProvider(We,yt(me),Ee,We.identifier)},registerInlineValuesProvider(me,Ee){return Ve.registerInlineValuesProvider(We,yt(me),Ee,We.identifier)},registerDocumentHighlightProvider(me,Ee){return Ve.registerDocumentHighlightProvider(We,yt(me),Ee)},registerMultiDocumentHighlightProvider(me,Ee){return Ve.registerMultiDocumentHighlightProvider(We,yt(me),Ee)},registerLinkedEditingRangeProvider(me,Ee){return Ve.registerLinkedEditingRangeProvider(We,yt(me),Ee)},registerReferenceProvider(me,Ee){return Ve.registerReferenceProvider(We,yt(me),Ee)},registerRenameProvider(me,Ee){return Ve.registerRenameProvider(We,yt(me),Ee)},registerNewSymbolNamesProvider(me,Ee){return(0,xe.$UG)(We,"newSymbolNamesProvider"),Ve.registerNewSymbolNamesProvider(We,yt(me),Ee)},registerDocumentSymbolProvider(me,Ee,ze){return Ve.registerDocumentSymbolProvider(We,yt(me),Ee,ze)},registerWorkspaceSymbolProvider(me){return Ve.registerWorkspaceSymbolProvider(We,me)},registerDocumentFormattingEditProvider(me,Ee){return Ve.registerDocumentFormattingEditProvider(We,yt(me),Ee)},registerDocumentRangeFormattingEditProvider(me,Ee){return Ve.registerDocumentRangeFormattingEditProvider(We,yt(me),Ee)},registerOnTypeFormattingEditProvider(me,Ee,ze,...ht){return Ve.registerOnTypeFormattingEditProvider(We,yt(me),Ee,[ze].concat(ht))},registerDocumentSemanticTokensProvider(me,Ee,ze){return Ve.registerDocumentSemanticTokensProvider(We,yt(me),Ee,ze)},registerDocumentRangeSemanticTokensProvider(me,Ee,ze){return Ve.registerDocumentRangeSemanticTokensProvider(We,yt(me),Ee,ze)},registerSignatureHelpProvider(me,Ee,ze,...ht){return typeof ze=="object"?Ve.registerSignatureHelpProvider(We,yt(me),Ee,ze):Ve.registerSignatureHelpProvider(We,yt(me),Ee,typeof ze>"u"?[]:[ze,...ht])},registerCompletionItemProvider(me,Ee,...ze){return Ve.registerCompletionItemProvider(We,yt(me),Ee,ze)},registerInlineCompletionItemProvider(me,Ee,ze){return Ee.handleDidShowCompletionItem&&(0,xe.$UG)(We,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,xe.$UG)(We,"inlineCompletionsAdditions"),ze&&(0,xe.$UG)(We,"inlineCompletionsAdditions"),Ve.registerInlineCompletionsProvider(We,yt(me),Ee,ze)},registerInlineEditProvider(me,Ee){return(0,xe.$UG)(We,"inlineEdit"),Ve.registerInlineEditProvider(We,yt(me),Ee)},registerDocumentLinkProvider(me,Ee){return Ve.registerDocumentLinkProvider(We,yt(me),Ee)},registerColorProvider(me,Ee){return Ve.registerColorProvider(We,yt(me),Ee)},registerFoldingRangeProvider(me,Ee){return Ve.registerFoldingRangeProvider(We,yt(me),Ee)},registerSelectionRangeProvider(me,Ee){return Ve.registerSelectionRangeProvider(We,me,Ee)},registerCallHierarchyProvider(me,Ee){return Ve.registerCallHierarchyProvider(We,me,Ee)},registerTypeHierarchyProvider(me,Ee){return Ve.registerTypeHierarchyProvider(We,me,Ee)},setLanguageConfiguration:(me,Ee)=>Ve.setLanguageConfiguration(We,me,Ee),getTokenInformationAtPosition(me,Ee){return(0,xe.$UG)(We,"tokenInformation"),Fe.tokenAtPosition(me,Ee)},registerInlayHintsProvider(me,Ee){return Ve.registerInlayHintsProvider(We,me,Ee)},createLanguageStatusItem(me,Ee){return Fe.createLanguageStatusItem(We,me,Ee)},registerDocumentDropEditProvider(me,Ee,ze){return Ve.registerDocumentOnDropEditProvider(We,me,Ee,(0,xe.$TG)(We,"documentPaste")?ze:void 0)}},rn={get activeTextEditor(){return Re.getActiveTextEditor()},get visibleTextEditors(){return Re.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(me,Ee,ze){p.URI.isUri(me)&&me.scheme===L.Schemas.vscodeRemote&&!me.authority&&Rt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ht=await(p.URI.isUri(me)?Promise.resolve(Ki.openTextDocument(me)):Promise.resolve(me));return Re.showTextDocument(ht,Ee,ze)},createTextEditorDecorationType(me){return Re.createTextEditorDecorationType(We,me)},onDidChangeActiveTextEditor(me,Ee,ze){return ct(Re.onDidChangeActiveTextEditor)(me,Ee,ze)},onDidChangeVisibleTextEditors(me,Ee,ze){return ct(Re.onDidChangeVisibleTextEditors)(me,Ee,ze)},onDidChangeTextEditorSelection(me,Ee,ze){return ct(Re.onDidChangeTextEditorSelection)(me,Ee,ze)},onDidChangeTextEditorOptions(me,Ee,ze){return ct(Re.onDidChangeTextEditorOptions)(me,Ee,ze)},onDidChangeTextEditorVisibleRanges(me,Ee,ze){return ct(Re.onDidChangeTextEditorVisibleRanges)(me,Ee,ze)},onDidChangeTextEditorViewColumn(me,Ee,ze){return ct(Re.onDidChangeTextEditorViewColumn)(me,Ee,ze)},onDidCloseTerminal(me,Ee,ze){return ct(pt.onDidCloseTerminal)(me,Ee,ze)},onDidOpenTerminal(me,Ee,ze){return ct(pt.onDidOpenTerminal)(me,Ee,ze)},onDidChangeActiveTerminal(me,Ee,ze){return ct(pt.onDidChangeActiveTerminal)(me,Ee,ze)},onDidChangeTerminalDimensions(me,Ee,ze){return(0,xe.$UG)(We,"terminalDimensions"),ct(pt.onDidChangeTerminalDimensions)(me,Ee,ze)},onDidChangeTerminalState(me,Ee,ze){return ct(pt.onDidChangeTerminalState)(me,Ee,ze)},onDidWriteTerminalData(me,Ee,ze){return(0,xe.$UG)(We,"terminalDataWriteEvent"),ct(pt.onDidWriteTerminalData)(me,Ee,ze)},onDidExecuteTerminalCommand(me,Ee,ze){return(0,xe.$UG)(We,"terminalExecuteCommandEvent"),ct(pt.onDidExecuteTerminalCommand)(me,Ee,ze)},onDidChangeTerminalShellIntegration(me,Ee,ze){return(0,xe.$UG)(We,"terminalShellIntegration"),ct(Gt.onDidChangeTerminalShellIntegration)(me,Ee,ze)},onDidStartTerminalShellExecution(me,Ee,ze){return(0,xe.$UG)(We,"terminalShellIntegration"),ct(Gt.onDidStartTerminalShellExecution)(me,Ee,ze)},onDidEndTerminalShellExecution(me,Ee,ze){return(0,xe.$UG)(We,"terminalShellIntegration"),ct(Gt.onDidEndTerminalShellExecution)(me,Ee,ze)},get state(){return Ft.getState()},onDidChangeWindowState(me,Ee,ze){return ct(Ft.onDidChangeWindowState)(me,Ee,ze)},showInformationMessage(me,...Ee){return Gi.showMessage(We,T.default.Info,me,Ee[0],Ee.slice(1))},showWarningMessage(me,...Ee){return Gi.showMessage(We,T.default.Warning,me,Ee[0],Ee.slice(1))},showErrorMessage(me,...Ee){return Gi.showMessage(We,T.default.Error,me,Ee[0],Ee.slice(1))},showQuickPick(me,Ee,ze){return dt.showQuickPick(We,me,Ee,ze)},showWorkspaceFolderPick(me){return dt.showWorkspaceFolderPick(me)},showInputBox(me,Ee){return dt.showInput(me,Ee)},showOpenDialog(me){return Oi.showOpenDialog(We,me)},showSaveDialog(me){return Oi.showSaveDialog(me)},createStatusBarItem(me,Ee,ze){let ht,Et,Lt;return typeof me=="string"?(ht=me,Et=Ee,Lt=ze):(Et=me,Lt=Ee),_i.createStatusBarEntry(We,ht,Et,Lt)},setStatusBarMessage(me,Ee){return _i.setStatusBarMessage(me,Ee)},withScmProgress(me){return Rt.report("window.withScmProgress",We,"Use 'withProgress' instead."),Jt.withProgress(We,{location:X.ProgressLocation.SourceControl},(Ee,ze)=>me({report(ht){}}))},withProgress(me,Ee){return Jt.withProgress(We,me,Ee)},createOutputChannel(me,Ee){return $i.createOutputChannel(me,Ee,We)},createWebviewPanel(me,Ee,ze,ht){return Ti.createWebviewPanel(We,me,Ee,ze,ht)},createWebviewTextEditorInset(me,Ee,ze,ht){return(0,xe.$UG)(We,"editorInsets"),ke.createWebviewEditorInset(me,Ee,ze,ht,We)},createTerminal(me,Ee,ze){return typeof me=="object"?"pty"in me?pt.createExtensionTerminal(me):pt.createTerminalFromOptions(me):pt.createTerminal(me,Ee,ze)},registerTerminalLinkProvider(me){return pt.registerLinkProvider(me)},registerTerminalProfileProvider(me,Ee){return pt.registerProfileProvider(We,me,Ee)},registerTerminalQuickFixProvider(me,Ee){return(0,xe.$UG)(We,"terminalQuickFixProvider"),pt.registerTerminalQuickFixProvider(me,We.identifier.value,Ee)},registerTreeDataProvider(me,Ee){return je.registerTreeDataProvider(me,Ee,We)},createTreeView(me,Ee){return je.createTreeView(me,Ee,We)},registerWebviewPanelSerializer:(me,Ee)=>Ti.registerWebviewPanelSerializer(We,me,Ee),registerCustomEditorProvider:(me,Ee,ze={})=>zi.registerCustomEditorProvider(We,me,Ee,ze),registerFileDecorationProvider(me){return oi.registerFileDecorationProvider(me,We)},registerUriHandler(me){return Di.registerUriHandler(We,me)},createQuickPick(){return dt.createQuickPick(We)},createInputBox(){return dt.createInputBox(We)},get activeColorTheme(){return ji.activeColorTheme},onDidChangeActiveColorTheme(me,Ee,ze){return ct(ji.onDidChangeActiveColorTheme)(me,Ee,ze)},registerWebviewViewProvider(me,Ee,ze){return Bi.registerWebviewViewProvider(We,me,Ee,ze?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,Ee,ze){return ct(Pt.onDidChangeActiveNotebookEditor)(me,Ee,ze)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ct(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(me,Ee,ze){return ct(vi.onDidChangeNotebookEditorSelection)(me,Ee,ze)},onDidChangeNotebookEditorVisibleRanges(me,Ee,ze){return ct(vi.onDidChangeNotebookEditorVisibleRanges)(me,Ee,ze)},showNotebookDocument(me,Ee){return Pt.showNotebookDocument(me,Ee)},registerExternalUriOpener(me,Ee,ze){return(0,xe.$UG)(We,"externalUriOpener"),Zi.registerExternalUriOpener(We.identifier,me,Ee,ze)},registerProfileContentHandler(me,Ee){return(0,xe.$UG)(We,"profileContentHandlers"),xi.registerProfileContentHandler(We,me,Ee)},registerQuickDiffProvider(me,Ee,ze,ht){return(0,xe.$UG)(We,"quickDiffProvider"),xt.registerQuickDiffProvider(yt(me),Ee,ze,ht)},get tabGroups(){return qt.tabGroups},registerShareProvider(me,Ee){return(0,xe.$UG)(We,"shareProvider"),ni.registerShareProvider(yt(me),Ee)}},Ki={get rootPath(){return Rt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),bt.getPath()},set rootPath(me){throw new m.$9("rootPath")},getWorkspaceFolder(me){return bt.getWorkspaceFolder(me)},get workspaceFolders(){return bt.getWorkspaceFolders()},get name(){return bt.name},set name(me){throw new m.$9("name")},get workspaceFile(){return bt.workspaceFile},set workspaceFile(me){throw new m.$9("workspaceFile")},updateWorkspaceFolders:(me,Ee,...ze)=>bt.updateWorkspaceFolders(We,me,Ee||0,...ze),onDidChangeWorkspaceFolders:function(me,Ee,ze){return ct(bt.onDidChangeWorkspace)(me,Ee,ze)},asRelativePath:(me,Ee)=>bt.getRelativePath(me,Ee),findFiles:(me,Ee,ze,ht)=>bt.findFiles(me,Ee,ze,We.identifier,ht),findFiles2:(me,Ee,ze)=>((0,xe.$UG)(We,"findFiles2"),bt.findFiles2(me,Ee,We.identifier,ze)),findTextInFiles:(me,Ee,ze,ht)=>{(0,xe.$UG)(We,"findTextInFiles");let Et,Lt;return typeof Ee=="object"?(Et=Ee,Lt=ze):(Et={},Lt=Ee,ht=ze),bt.findTextInFiles(me,Et||{},Lt,We.identifier,ht)},save:me=>bt.save(me),saveAs:me=>bt.saveAs(me),saveAll:me=>bt.saveAll(me),applyEdit(me,Ee){return $n.applyWorkspaceEdit(me,We,Ee)},createFileSystemWatcher:(me,Ee,ze,ht)=>{let Et;return typeof Ee=="boolean"?Et={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!ht,correlate:!1}:Ee&&((0,xe.$UG)(We,"createFileSystemWatcher"),Et={...Ee,correlate:!0}),Ke.createFileSystemWatcher(bt,We,me,Et)},get textDocuments(){return Tt.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw new m.$9("textDocuments")},openTextDocument(me){let Ee;const ze=me;if(typeof me=="string")Ee=Promise.resolve(p.URI.file(me));else if(p.URI.isUri(me))Ee=Promise.resolve(me);else if(!ze||typeof ze=="object")Ee=Tt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ht=>(ht.scheme===L.Schemas.vscodeRemote&&!ht.authority&&Rt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),Tt.ensureDocumentData(ht).then(Et=>Et.document)))},onDidOpenTextDocument:(me,Ee,ze)=>ct(Tt.onDidAddDocument)(me,Ee,ze),onDidCloseTextDocument:(me,Ee,ze)=>ct(Tt.onDidRemoveDocument)(me,Ee,ze),onDidChangeTextDocument:(me,Ee,ze)=>ct(Tt.onDidChangeDocument)(me,Ee,ze),onDidSaveTextDocument:(me,Ee,ze)=>ct(Tt.onDidSaveDocument)(me,Ee,ze),onWillSaveTextDocument:(me,Ee,ze)=>ct(ci.getOnWillSaveTextDocumentEvent(We))(me,Ee,ze),get notebookDocuments(){return Pt.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,Ee){let ze;if(p.URI.isUri(me))ze=me,await Pt.openNotebookDocument(me);else if(typeof me=="string")ze=p.URI.revive(await Pt.createNotebookDocument({viewType:me,content:Ee}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(me,Ee,ze){return ct(Ii.onDidSaveNotebookDocument)(me,Ee,ze)},onDidChangeNotebookDocument(me,Ee,ze){return ct(Ii.onDidChangeNotebookDocument)(me,Ee,ze)},onWillSaveNotebookDocument(me,Ee,ze){return ct(fi.getOnWillSaveNotebookDocumentEvent(We))(me,Ee,ze)},get onDidOpenNotebookDocument(){return ct(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ct(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer(me,Ee,ze,ht){return Pt.registerNotebookSerializer(We,me,Ee,ze,(0,xe.$TG)(We,"notebookLiveShare")?ht:void 0)},onDidChangeConfiguration:(me,Ee,ze)=>ct(Hi.onDidChangeConfiguration)(me,Ee,ze),getConfiguration(me,Ee){return Ee=arguments.length===1?void 0:Ee,Hi.getConfiguration(me,Ee,We)},registerTextDocumentContentProvider(me,Ee){return Ci.registerTextDocumentContentProvider(me,Ee)},registerTaskProvider:(me,Ee)=>(Rt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(We,me,Ee)),registerFileSystemProvider(me,Ee,ze){return(0,R.$Rc)(et.registerFileSystemProvider(We,me,Ee,ze),Xt.addFileSystemProvider(me,Ee,ze))},get fs(){return Xt.value},registerFileSearchProvider:(me,Ee)=>((0,xe.$UG)(We,"fileSearchProvider"),ai.registerFileSearchProvider(me,Ee)),registerTextSearchProvider:(me,Ee)=>((0,xe.$UG)(We,"textSearchProvider"),ai.registerTextSearchProvider(me,Ee)),registerAITextSearchProvider:(me,Ee)=>((0,xe.$UG)(We,"aiTextSearchProvider"),(0,xe.$UG)(We,"textSearchProvider"),ai.registerAITextSearchProvider(me,Ee)),registerRemoteAuthorityResolver:(me,Ee)=>((0,xe.$UG)(We,"resolvers"),Bt.registerRemoteAuthorityResolver(me,Ee)),registerResourceLabelFormatter:me=>((0,xe.$UG)(We,"resolvers"),Fi.$registerResourceLabelFormatter(me)),getRemoteExecServer:me=>((0,xe.$UG)(We,"resolvers"),Bt.getRemoteExecServer(me)),onDidCreateFiles:(me,Ee,ze)=>ct(Ke.onDidCreateFile)(me,Ee,ze),onDidDeleteFiles:(me,Ee,ze)=>ct(Ke.onDidDeleteFile)(me,Ee,ze),onDidRenameFiles:(me,Ee,ze)=>ct(Ke.onDidRenameFile)(me,Ee,ze),onWillCreateFiles:(me,Ee,ze)=>ct(Ke.getOnWillCreateFileEvent(We))(me,Ee,ze),onWillDeleteFiles:(me,Ee,ze)=>ct(Ke.getOnWillDeleteFileEvent(We))(me,Ee,ze),onWillRenameFiles:(me,Ee,ze)=>ct(Ke.getOnWillRenameFileEvent(We))(me,Ee,ze),openTunnel:me=>((0,xe.$UG)(We,"tunnels"),Nt.openTunnel(We,me).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,xe.$UG)(We,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:(me,Ee,ze)=>((0,xe.$UG)(We,"tunnels"),ct(Nt.onDidChangeTunnels)(me,Ee,ze)),registerPortAttributesProvider:(me,Ee)=>((0,xe.$UG)(We,"portsAttributes"),Nt.registerPortsAttributesProvider(me,Ee)),registerTunnelProvider:(me,Ee)=>((0,xe.$UG)(We,"tunnelFactory"),Nt.registerTunnelProvider(me,Ee)),registerTimelineProvider:(me,Ee)=>((0,xe.$UG)(We,"timeline"),Xi.registerTimelineProvider(me,Ee,We.identifier,vt.converter)),get isTrusted(){return bt.trusted},requestWorkspaceTrust:me=>((0,xe.$UG)(We,"workspaceTrust"),bt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,Ee,ze)=>ct(bt.onDidGrantWorkspaceTrust)(me,Ee,ze),registerEditSessionIdentityProvider:(me,Ee)=>((0,xe.$UG)(We,"editSessionIdentityProvider"),bt.registerEditSessionIdentityProvider(me,Ee)),onWillCreateEditSessionIdentity:(me,Ee,ze)=>((0,xe.$UG)(We,"editSessionIdentityProvider"),ct(bt.getOnWillCreateEditSessionIdentityEvent(We))(me,Ee,ze)),registerCanonicalUriProvider:(me,Ee)=>((0,xe.$UG)(We,"canonicalUriProvider"),bt.registerCanonicalUriProvider(me,Ee)),getCanonicalUri:(me,Ee,ze)=>((0,xe.$UG)(We,"canonicalUriProvider"),bt.provideCanonicalUri(me,Ee,ze))},sn={get inputBox(){return Rt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),It.getLastInputBox(We)},createSourceControl(me,Ee,ze){return It.createSourceControl(We,me,Ee,ze)}},bn={createCommentController(me,Ee){return jt.createCommentController(We,me,Ee)}},on={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get activeStackItem(){return St.activeStackItem},registerDebugVisualizationProvider(me,Ee){return(0,xe.$UG)(We,"debugVisualization"),St.registerDebugVisualizationProvider(We,me,Ee)},registerDebugVisualizationTreeProvider(me,Ee){return(0,xe.$UG)(We,"debugVisualization"),St.registerDebugVisualizationTree(We,me,Ee)},onDidStartDebugSession(me,Ee,ze){return ct(St.onDidStartDebugSession)(me,Ee,ze)},onDidTerminateDebugSession(me,Ee,ze){return ct(St.onDidTerminateDebugSession)(me,Ee,ze)},onDidChangeActiveDebugSession(me,Ee,ze){return ct(St.onDidChangeActiveDebugSession)(me,Ee,ze)},onDidReceiveDebugSessionCustomEvent(me,Ee,ze){return ct(St.onDidReceiveDebugSessionCustomEvent)(me,Ee,ze)},onDidChangeBreakpoints(me,Ee,ze){return ct(St.onDidChangeBreakpoints)(me,Ee,ze)},onDidChangeActiveStackItem(me,Ee,ze){return ct(St.onDidChangeActiveStackItem)(me,Ee,ze)},registerDebugConfigurationProvider(me,Ee,ze){return St.registerDebugConfigurationProvider(me,Ee,ze||Yt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,Ee){return St.registerDebugAdapterDescriptorFactory(We,me,Ee)},registerDebugAdapterTrackerFactory(me,Ee){return St.registerDebugAdapterTrackerFactory(me,Ee)},startDebugging(me,Ee,ze){return!ze||typeof ze=="object"&&"configuration"in ze?St.startDebugging(me,Ee,{parentSession:ze}):St.startDebugging(me,Ee,ze||{})},stopDebugging(me){return St.stopDebugging(me)},addBreakpoints(me){return St.addBreakpoints(me)},removeBreakpoints(me){return St.removeBreakpoints(me)},asDebugSourceUri(me,Ee){return St.asDebugSourceUri(me,Ee)}},an={registerTaskProvider:(me,Ee)=>Kt.registerTaskProvider(We,me,Ee),fetchTasks:me=>Kt.fetchTasks(me),executeTask:me=>Kt.executeTask(We,me),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(me,Ee,ze)=>ct(Kt.onDidStartTask)(me,Ee,ze),onDidEndTask:(me,Ee,ze)=>ct(Kt.onDidEndTask)(me,Ee,ze),onDidStartTaskProcess:(me,Ee,ze)=>ct(Kt.onDidStartTaskProcess)(me,Ee,ze),onDidEndTaskProcess:(me,Ee,ze)=>ct(Kt.onDidEndTaskProcess)(me,Ee,ze)},wn={createNotebookController(me,Ee,ze,ht,Et){return pi.createNotebookController(We,me,Ee,ze,ht,(0,xe.$TG)(We,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(me,Ee)=>Pt.registerNotebookCellStatusBarItemProvider(We,me,Ee),createRendererMessaging(me){return Ai.createRendererMessaging(We,me)},createNotebookControllerDetectionTask(me){return(0,xe.$UG)(We,"notebookKernelSource"),pi.createNotebookControllerDetectionTask(We,me)},registerKernelSourceActionProvider(me,Ee){return(0,xe.$UG)(We,"notebookKernelSource"),pi.registerKernelSourceActionProvider(We,me,Ee)},onDidChangeNotebookCellExecutionState(me,Ee,ze){return(0,xe.$UG)(We,"notebookCellExecutionState"),ct(pi.onDidChangeNotebookCellExecutionState)(me,Ee,ze)}},vn={t(...me){if(typeof me[0]=="string"){const Ee=me.shift(),ze=!me||typeof me[0]!="object"?me:me[0];return di.getMessage(We.identifier.value,{message:Ee,args:ze})}return di.getMessage(We.identifier.value,me[0])},get bundle(){return di.getBundle(We.identifier.value)},get uri(){return di.getBundleUri(We.identifier.value)}},cn={_version:1,transferActiveChat(me){return(0,xe.$UG)(We,"interactive"),Li.transferActiveChat(me)}},Ji={getRelatedInformation(me,Ee){return(0,xe.$UG)(We,"aiRelatedInformation"),Vi.getRelatedInformation(We,me,Ee)},registerRelatedInformationProvider(me,Ee){return(0,xe.$UG)(We,"aiRelatedInformation"),Vi.registerRelatedInformationProvider(We,me,Ee)},registerEmbeddingVectorProvider(me,Ee){return(0,xe.$UG)(We,"aiRelatedInformation"),mn.registerEmbeddingVectorProvider(We,me,Ee)}},ln={_version:1,registerChatResponseProvider(me,Ee,ze){return(0,xe.$UG)(We,"chatProvider"),Zt.registerLanguageModel(We,me,Ee,ze)},registerChatVariableResolver(me,Ee,ze,ht,Et,Lt,Si,Mi){return(0,xe.$UG)(We,"chatVariableResolver"),Wi.registerVariableResolver(We,me,Ee,ze,ht,Et,Lt,Si,Mi?.id)},registerMappedEditsProvider(me,Ee){return(0,xe.$UG)(We,"mappedEditsProvider"),Ve.registerMappedEditsProvider(We,me,Ee)},createChatParticipant(me,Ee){return Li.createChatAgent(We,me,Ee)},createDynamicChatParticipant(me,Ee,ze){return(0,xe.$UG)(We,"chatParticipantPrivate"),Li.createDynamicChatAgent(We,me,Ee,ze)},attachContext(me,Ee,ze){return(0,xe.$UG)(We,"chatVariableResolver"),Wi.attachContext(me,Ee,ze)}},un={selectChatModels:me=>$t.quality==="stable"?(console.warn(`[${P.$Wm.toKey(We.identifier)}] This API is disabled in '${$t.environment.appName}'-stable.`),Promise.resolve([])):Zt.selectLanguageModels(We,me??{}),onDidChangeChatModels:(me,Ee,ze)=>$t.quality==="stable"?(console.warn(`[${P.$Wm.toKey(We.identifier)}] This API is disabled in '${$t.environment.appName}'-stable.`),A.Event.None(me,Ee,ze)):Zt.onDidChangeProviders(me,Ee,ze),get embeddingModels(){return(0,xe.$UG)(We,"embeddings"),Ei.embeddingsModels},onDidChangeEmbeddingModels:(me,Ee,ze)=>((0,xe.$UG)(We,"embeddings"),Ei.onDidChange(me,Ee,ze)),registerEmbeddingsProvider(me,Ee){return(0,xe.$UG)(We,"embeddings"),Ei.registerEmbeddingsProvider(We,me,Ee)},async computeEmbeddings(me,Ee,ze){return(0,xe.$UG)(We,"embeddings"),Ei.computeEmbeddings(me,Ee,ze)}},hn={registerSpeechProvider(me,Ee){return(0,xe.$UG)(We,"speech"),qi.registerProvider(We.identifier,me,Ee)}};return{version:$t.version,ai:Ji,authentication:tn,commands:bi,comments:bn,chat:ln,debug:on,env:Ri,extensions:Ni,interactive:cn,l10n:vn,languages:nn,lm:un,notebooks:wn,scm:sn,speech:hn,tasks:an,tests:pn,window:rn,workspace:Ki,Breakpoint:X.$xN,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatResultFeedbackKind:X.ChatResultFeedbackKind,ChatVariableLevel:X.ChatVariableLevel,ChatCompletionItem:X.$sO,CallHierarchyIncomingCall:X.$VM,CallHierarchyItem:X.$UM,CallHierarchyOutgoingCall:X.$WM,CancellationError:m.$5,CancellationTokenSource:r.$se,CandidatePortSource:n.CandidatePortSource,CodeAction:X.$RM,CodeActionKind:X.$SM,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$XM,Color:X.$$M,ColorInformation:X.$_M,ColorPresentation:X.$aN,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CommentThreadApplicability:X.CommentThreadApplicability,CompletionItem:X.$5M,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$6M,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$iN,DebugAdapterExecutable:X.$BN,DebugAdapterInlineImplementation:X.$EN,DebugAdapterNamedPipeServer:X.$DN,DebugAdapterServer:X.$CN,DebugConfigurationProviderTriggerKind:Yt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DebugVisualization:X.$UN,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$KM,DiagnosticRelatedInformation:X.$JM,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$wM,DocumentHighlight:X.$NM,DocumentHighlightKind:X.DocumentHighlightKind,MultiDocumentHighlight:X.$OM,DocumentLink:X.$0M,DocumentSymbol:X.$QM,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$HN,InlineValueText:X.$IN,InlineValueVariableLookup:X.$JN,InlineValueEvaluatableExpression:X.$KN,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:A.$he,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$WN,FileDecoration2:X.$WN,FileSystemError:X.$NN,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:X.$ON,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$zN,InlineCompletionItem:X.$7M,InlineCompletionList:X.$8M,Hover:X.$LM,VerboseHover:X.$MM,HoverVerbosityAction:X.HoverVerbosityAction,IndentAction:S.IndentAction,Location:X.$IM,MarkdownString:X.$YM,OverviewRulerLane:d.OverviewRulerLane,ParameterInformation:X.$ZM,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$xM,ProcessExecution:X.$gN,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$VN,Range:X.$yM,RelativePattern:X.$vN,Selection:X.$zM,SelectionRange:X.$TM,SemanticTokens:X.$RN,SemanticTokensBuilder:X.$QN,SemanticTokensEdit:X.$SN,SemanticTokensEdits:X.$TN,SemanticTokensLegend:X.$PN,ShellExecution:X.$hN,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$2M,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$1M,SnippetString:X.$HM,SourceBreakpoint:X.$yN,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$PM,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$jN,TaskGroup:X.$fN,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$bN,TerminalQuickFixTerminalCommand:X.$dN,TerminalQuickFixOpener:X.$cN,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$eN,TerminalExitReason:X.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:X.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$DM,SnippetTextEdit:X.$FM,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,SyntaxTokenType:X.SyntaxTokenType,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$uN,ThemeIcon:X.$tN,TreeItem:X.$kN,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$gO,UIKind:_t.UIKind,Uri:p.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$GM,DocumentPasteTriggerKind:X.DocumentPasteTriggerKind,DocumentDropEdit:X.$qN,DocumentDropOrPasteEditKind:X.$rN,DocumentPasteEdit:X.$sN,InlayHint:X.$4M,InlayHintLabelPart:X.$3M,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$CM,ResolvedAuthority:X.$AM,ManagedResolvedAuthority:X.$BM,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$7N,NotebookRange:X.$YN,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$ZN,NotebookData:X.$1N,NotebookRendererScript:X.$5N,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$3N,NotebookCellOutputItem:X.$2N,NotebookCellStatusBarItem:X.$4N,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$EM,NotebookKernelSourceAction:X.$6N,NotebookVariablesRequestKind:X.NotebookVariablesRequestKind,PortAttributes:X.$9N,LinkedEditingRanges:X.$8N,TestResultState:X.TestResultState,TestRunRequest:X.$0N,TestMessage:X.$$N,TestTag:X.$_N,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:Vt.TextSearchCompleteMessageType,DataTransfer:X.$pN,DataTransferItem:X.$lN,TestCoverageCount:X.$aO,FileCoverage:X.$cO,FileCoverage2:X.$cO,StatementCoverage:X.$dO,BranchCoverage:X.$eO,DeclarationCoverage:X.$fO,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$hO,TabInputTextDiff:X.$iO,TabInputTextMerge:X.$jO,TabInputCustom:X.$kO,TabInputNotebook:X.$mO,TabInputNotebookDiff:X.$nO,TabInputWebview:X.$lO,TabInputTerminal:X.$oO,TabInputInteractiveWindow:X.$pO,TabInputChat:X.$qO,TabInputTextMultiDiff:X.$rO,TelemetryTrustedValue:f.$np,LogLevel:a.LogLevel,EditSessionIdentityMatch:g.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,ChatCopyKind:X.ChatCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,DebugStackFrame:X.$FN,DebugThread:X.$GN,RelatedInformationType:X.RelatedInformationType,SpeechToTextStatus:X.SpeechToTextStatus,TextToSpeechStatus:X.TextToSpeechStatus,PartialAcceptTriggerKind:X.PartialAcceptTriggerKind,KeywordRecognitionStatus:X.KeywordRecognitionStatus,ChatResponseMarkdownPart:X.$tO,ChatResponseFileTreePart:X.$xO,ChatResponseAnchorPart:X.$yO,ChatResponseProgressPart:X.$zO,ChatResponseProgressPart2:X.$AO,ChatResponseReferencePart:X.$DO,ChatResponseWarningPart:X.$BO,ChatResponseTextEditPart:X.$EO,ChatResponseMarkdownWithVulnerabilitiesPart:X.$uO,ChatResponseCommandButtonPart:X.$CO,ChatResponseDetectedParticipantPart:X.$vO,ChatResponseConfirmationPart:X.$wO,ChatRequestTurn:X.$FO,ChatResponseTurn:X.$GO,ChatLocation:X.ChatLocation,LanguageModelChatMessageRole:X.LanguageModelChatMessageRole,LanguageModelChatMessage:X.$HO,LanguageModelChatMessage2:X.$HO,LanguageModelChatSystemMessage:X.$IO,LanguageModelChatUserMessage:X.$JO,LanguageModelChatAssistantMessage:X.$KO,LanguageModelError:X.$LO,NewSymbolName:X.$MN,NewSymbolNameTag:X.NewSymbolNameTag,NewSymbolNameTriggerKind:X.NewSymbolNameTriggerKind,InlineEdit:X.$MO,InlineEditTriggerKind:X.InlineEditTriggerKind}}}}),define(ye[395],Se([1,0,89,167,47,161,48,37,78,46,100,101,102,125,76,96,160,75,63,124,95,77,159,12,64,122,123,127,128,165]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i,t,l,h,o,$,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Fs)(o.$Fnc,o.$Enc,r.InstantiationType.Delayed),(0,r.$Fs)(l.$8j,t.$Soc,r.InstantiationType.Delayed),(0,r.$Fs)(a.$Kmc,a.$Lmc,r.InstantiationType.Delayed),(0,r.$Fs)(T.$iP,T.$hP,r.InstantiationType.Eager),(0,r.$Fs)(E.$Umc,E.$Vmc,r.InstantiationType.Eager),(0,r.$Fs)(k.$znc,k.$Anc,r.InstantiationType.Eager),(0,r.$Fs)(L.$0mc,L.$8mc,r.InstantiationType.Eager),(0,r.$Fs)(f.$_mc,f.$$mc,r.InstantiationType.Eager),(0,r.$Fs)(S.$Pnc,S.$Tnc,r.InstantiationType.Eager),(0,r.$Fs)(R.$Vnc,R.$Unc,r.InstantiationType.Eager),(0,r.$Fs)(p.$0O,p.$9O,r.InstantiationType.Eager),(0,r.$Fs)($.$Gnc,$.$Hnc,r.InstantiationType.Eager),(0,r.$Fs)(g.$Omc,g.$Nmc,r.InstantiationType.Eager),(0,r.$Fs)(m.$ooc,m.$noc,r.InstantiationType.Delayed),(0,r.$Fs)(d.$_nc,d.$aoc,r.InstantiationType.Eager),(0,r.$Fs)(P.$snc,P.$rnc,r.InstantiationType.Eager),(0,r.$Fs)(C.$Boc,C.$Aoc,r.InstantiationType.Eager),(0,r.$Fs)(c.$vnc,c.$ync,r.InstantiationType.Eager),(0,r.$Fs)(D.$Coc,D.$Doc,r.InstantiationType.Eager),(0,r.$Fs)(b.$nEb,b.$oEb,r.InstantiationType.Eager),(0,r.$Fs)(u.$Qoc,u.$Poc,r.InstantiationType.Eager),(0,r.$Fs)(A.$7mc,A.$6mc,r.InstantiationType.Eager),(0,r.$Fs)(n.$Cnc,n.$Bnc,r.InstantiationType.Eager),(0,r.$Fs)(s.$gP,s.$dP,r.InstantiationType.Eager),(0,r.$Fs)(i.$jnc,i.$knc,r.InstantiationType.Eager),(0,r.$Fs)(h.$Nnc,h.$Onc,r.InstantiationType.Eager)}),define(ye[129],Se([1,0,19,12,38,99]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=void 0,e.$9oc=L,e.$0oc=T;function L(S){return S.startsWith("**")||S.startsWith("/")?S:`/${S}`}function T(S,d,P,b){const a=(0,r.$1b)(P,p),u=new A.$MK(d,a,b),f=u.preview.matches;return{ranges:(0,r.$1b)(a,c),uri:S,preview:{text:u.preview.text,matches:(0,r.$1b)(f,c)}}}function p(S){return new A.$NK(S.start.line,S.start.character,S.end.line,S.end.character)}function c(S){return new R.$BK(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn)}let C=class{constructor(d,P){this.a=d,this.b=P}appendLine(d){this.b.debug(`${this.a}#search`,d)}};e.$$oc=C,e.$$oc=C=Je([Ge(1,m.$7j)],C)}),define(ye[396],Se([1,0,59,16,82,33,11,13,129,397]),function(de,e,r,m,A,R,L,T,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=S,e.$apc=u,e.$bpc=g;const C=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function S(n,s,i,t){const l=d(n,s,i,t),h=s.folder.fsPath;return{cmd:r.spawn(C,l.args,{cwd:h}),rgDiskPath:C,siblingClauses:l.siblingClauses,rgArgs:l,cwd:h}}function d(n,s,i,t){const l=["--files","--hidden","--case-sensitive","--no-require-git"];b([s],i,!1).forEach(o=>{const $=(0,p.$9oc)(o);if(l.push("-g",$),L.$j){const E=(0,A.$hm)($);E!==$&&l.push("-g",E)}});const h=P([s],t,void 0,!1);return h.globArgs.forEach(o=>{const $=`!${(0,p.$9oc)(o)}`;if(l.push("-g",$),L.$j){const E=(0,A.$hm)($);E!==$&&l.push("-g",E)}}),s.disregardIgnoreFiles!==!1?l.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&l.push("--no-ignore-parent"),s.ignoreSymlinks||l.push("--follow"),n.exists&&l.push("--quiet"),l.push("--no-config"),s.disregardGlobalIgnoreFiles&&l.push("--no-ignore-global"),{args:l,siblingClauses:h.siblingClauses}}function P(n,s,i,t=!0){const l=[];let h={};return n.forEach(o=>{const $=Object.assign({},o.excludePattern||{},s||{}),E=a($,t?o.folder.fsPath:void 0,i);l.push(...E.globArgs),E.siblingClauses&&(h=Object.assign(h,E.siblingClauses))}),{globArgs:l,siblingClauses:h}}function b(n,s,i=!0){const t=[];return n.forEach(l=>{const h=Object.assign({},s||{},l.includePattern||{}),o=a(h,i?l.folder.fsPath:void 0);t.push(...o.globArgs)}),t}function a(n,s,i){const t=[],l={};return Object.keys(n).forEach(h=>{if(i&&i.has(h)||!h)return;const o=n[h];h=f(s?u(s,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof o=="boolean"&&o?(h.startsWith("\\\\")&&(h+="**"),t.push(g(h))):o&&o.when&&(l[h]=o)}),{globArgs:t,siblingClauses:l}}function u(n,s){return m.$ic(s)?s:m.$jc(n,s)}function f(n){return n=T.$jf(n,"\\"),T.$jf(n,"/")}function g(n){return R.$vg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(ye[398],Se([1,0,59,58,16,399,19,51,39,82,33,11,42,13,18,34,38,396,140]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=e.$cpc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(h=>h())});class s{constructor(o){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=o,this.b=o.filePattern||"",this.d=o.includePattern&&p.$uk(o.includePattern),this.f=o.maxResults||null,this.g=!!o.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=o.shouldGlobMatchFilePattern?null:(0,g.$Fr)(this.b).normalizedLowercase),this.u=o.excludePattern&&p.$uk(o.excludePattern),this.t=new Map,o.folderQueries.forEach($=>{const E=Object.assign({},$.excludePattern||{},this.a.excludePattern||{}),k=$.folder.fsPath;o.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==k).forEach(D=>{(0,C.$zg)(D,k)&&(E[A.$lc(k,D)]=!0)}),this.t.set(k,new t(E,k))})}cancel(){this.l=!0,n.forEach(o=>o())}walk(o,$,E,k,D){if(this.m=d.$be.create(!1),this.l)return D(null,this.j);$.forEach(v=>{const I=A.$nc(v.fsPath);this.u&&this.u(v.fsPath,I)||this.J(E,{relativePath:v.fsPath,searchPath:void 0})}),this.r=d.$be.create(!1),this.w(o,(v,I)=>{this.x(this.y,this,v,E,k,w=>{if(w){const y=(0,T.$lj)(w);console.error(y),this.q.push(y),I(w,void 0)}else I(null,void 0)})},(v,I)=>{this.m.stop();const w=v?L.$Hb(v)[0]:null;D(w,this.j)})}w(o,$,E){const k=new Array(o.length),D=new Array(o.length);let v=!1,I=0;if(o.length===0)return E(null,[]);o.forEach((w,y)=>{$(w,(N,O)=>{if(N?(v=!0,k[y]=null,D[y]=N):(k[y]=O,D[y]=null),++I===o.length)return E(v?D:null,k)})})}x(o,$,...E){try{o.apply($,E)}catch(k){E[E.length-1](k)}}y(o,$,E,k){const D=o.folder.fsPath,v=S.$j,I=()=>U&&U.kill();n.add(I);let w=F=>{n.delete(I),w=()=>{},k(F)},y="";const N=this.D(),O=(0,f.$_oc)(this.a,o,this.a.includePattern,this.t.get(o.folder.fsPath).expression),U=O.cmd,j=!Object.keys(O.siblingClauses).length,z=O.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let M=`${O.rgDiskPath} ${z}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),E({message:M}),this.s=0,this.z(U,"utf8",E,(F,J,ee)=>{if(F){w(F);return}if(this.j){w();return}const H=(y+(v?c.$gm(J||""):J)).split(`
`);if(ee){const _=H.length;H[_-1]=H[_-1].trim(),H[_-1]||H.pop()}else y=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=H.length,j){for(const _ of H)if(this.J($,{base:D,relativePath:_,searchPath:this.N(o,_)}),this.j){I();break}(ee||this.j)&&w();return}this.G(o,N,D,H,$),ee&&(this.H(N,D,$),w())})}spawnFindCmd(o){const $=this.t.get(o.folder.fsPath),E=$.getBasenameTerms(),k=$.getPathTerms(),D=["-L","."];if(E.length||k.length){D.push("-not","(","(");for(const v of E)D.push("-name",v),D.push("-o");for(const v of k)D.push("-path",v),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),r.spawn("find",D,{cwd:o.folder.fsPath})}readStdout(o,$,E){let k="";this.z(o,$,()=>{},(D,v,I)=>{if(D){E(D);return}k+=v,I&&E(null,k)})}z(o,$,E,k){let D=(w,y,N)=>{(w||N)&&(D=()=>{},this.r?.stop()),k(w,y,N)},v=!1;o.stdout?(this.A(o.stdout,$,D),o.stdout.once("data",()=>v=!0)):E({message:"stdout is null"});let I;o.stderr?I=this.B(o.stderr):E({message:"stderr is null"}),o.on("error",w=>{D(w)}),o.on("close",w=>{let y;!v&&(y=this.C(I,$))&&l(y)?D(new Error(`command failed with error code ${w}: ${this.C(I,$)}`)):(this.g&&w===0&&(this.j=!0),D(null,"",!0))})}A(o,$,E){const k=new R.StringDecoder($);return o.on("data",D=>{E(null,k.write(D))}),k}B(o){const $=[];return o.on("data",E=>{$.push(E)}),$}C(o,$){const E=new R.StringDecoder($);return o.map(k=>E.write(k)).join("")}D(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}G(o,{pathToEntries:$},E,k,D){k.indexOf(this.b)!==-1&&this.J(D,{base:E,relativePath:this.b,searchPath:this.N(o,this.b)});const v=I=>{const w=A.$nc(I),y=A.$mc(I);let N=$[y];N||(N=$[y]=[],v(y)),N.push({base:E,relativePath:I,basename:w,searchPath:this.N(o,I)})};k.forEach(v)}H({rootEntries:o,pathToEntries:$},E,k){const D=this,v=this.t.get(E),I=this.b;function w(y){D.o++;const N=(0,u.$3K)(()=>y.map(O=>O.basename));for(let O=0,U=y.length;O<U;O++){const j=y[O],{relativePath:z,basename:M}=j;if(v.test(z,M,I!==M?N:void 0))continue;const F=$[z];if(F)w(F);else{if(D.p++,z===I)continue;D.J(k,j)}if(D.j)break}}w(o)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(o,$,E,k,D){const v=o.folder,I=(0,u.$3K)(()=>E);this.w(E,(w,y)=>{if(this.l||this.j)return y(null);const N=$?[$,w].join(A.sep):w;if(this.t.get(o.folder.fsPath).test(N,w,this.a.filePattern!==w?I:void 0))return y(null);const O=[v.fsPath,N].join(A.sep);m.lstat(O,(U,j)=>{if(U||this.l||this.j)return y(null);this.L(O,j,(z,M)=>z||this.l||this.j?y(null):M.isDirectory()?(this.o++,this.M(O,j,(F,J)=>F||this.l||this.j||(J=J||"",this.v[J])?y(null):(this.v[J]=!0,a.Promises.readdir(O).then(ee=>{if(this.l||this.j)return y(null);this.I(o,N,ee,k,V=>y(V||null))},ee=>{y(null)})))):(this.p++,N===this.b||this.h&&b.$eg(M.size)&&M.size>this.h||this.J(k,{base:v.fsPath,relativePath:N,searchPath:this.N(o,N)}),y(null,void 0)))})},w=>{const y=w&&L.$Hb(w);return D(y&&y.length>0?y[0]:void 0)})}J(o,$){this.K($)&&(!this.d||this.d($.relativePath,A.$nc($.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||o($))}K(o){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,u.$XK)(o,this.c);if(this.b)return(0,u.$XK)(o,this.b,!1)}return!0}L(o,$,E){return $.isSymbolicLink()?m.stat(o,E):E(null,$)}M(o,$,E){return $.isSymbolicLink()?m.realpath(o,(k,D)=>k?E(k):E(null,D)):E(null,o)}N(o,$){return o.folderName?A.$jc(o.folderName,$):$}}e.$cpc=s;class i{constructor(o){this.a=o.folderQueries,this.b=o.extraFileResources||[],this.c=new s(o)}search(o,$,E){this.c.walk(this.a,this.b,o,$,(k,D)=>{E(k,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$dpc=i;class t{constructor(o,$){this.expression=o,this.c=$,this.d(o)}d(o){let $,E;Object.keys(o).filter(k=>o[k]).forEach(k=>{A.$ic(k)?($=$||p.$pk(),$[k]=o[k]):(E=E||p.$pk(),E[k]=o[k])}),this.a=$&&p.$uk($,{trimForExclusions:!0}),this.b=E&&p.$uk(E,{trimForExclusions:!0})}test(o,$,E){return this.b&&this.b(o,$,E)||this.a&&this.a(A.$jc(this.c,o),$,E)}getBasenameTerms(){const o=[];return this.a&&o.push(...p.$wk(this.a)),this.b&&o.push(...p.$wk(this.b)),o}getPathTerms(){const o=[];return this.a&&o.push(...p.$xk(this.a)),this.b&&o.push(...p.$xk(this.b)),o}}function l(h){const o=h.trim().split(`
`),$=o[0].trim();if($.startsWith("Error parsing regex"))return $;if($.startsWith("regex parse error"))return P.$5f(o[o.length-1].trim());if($.startsWith("error parsing glob")||$.startsWith("unsupported encoding"))return $.charAt(0).toUpperCase()+$.substr(1);if($==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if($.startsWith("Literal "))return $}}),define(ye[400],Se([1,0,103,22,206,21]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=e.$pE=e.DecodeStreamErrorKind=e.$oE=e.$nE=e.$mE=e.$kE=e.$jE=e.$iE=e.$hE=void 0,e.$lE=L,e.$qE=b,e.$rE=a,e.$sE=u,e.$tE=f,e.$uE=g,e.$vE=h,e.$wE=o,e.$hE="utf8",e.$iE="utf8bom",e.$jE="utf16be",e.$kE="utf16le";function L($){return[e.$hE,e.$iE,e.$jE,e.$kE].some(E=>E===$)}e.$mE=[254,255],e.$nE=[255,254],e.$oE=[239,187,191];const T=512,p=512,c=512*8,C=512*128;var S;(function($){$[$.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(S||(e.DecodeStreamErrorKind=S={}));class d extends Error{constructor(E,k){super(E),this.decodeStreamErrorKind=k}}e.$pE=d;class P{static async create(E){let k;if(E!==e.$hE)k=(await(0,A.$gE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(f(E));else{const D=new TextDecoder;k={write(v){return D.decode(v,{stream:!0})},end(){return D.decode()}}}return new P(k)}constructor(E){this.a=E}write(E){return this.a.write(E)}end(){return this.a.end()}}function b($,E){const k=E.minBytesRequiredForDetection??E.guessEncoding?c:p;return new Promise((D,v)=>{const I=(0,r.$xe)(j=>j.join("")),w=[];let y=0,N;const O=new R.$se,U=async()=>{try{const j=await o({buffer:m.$Je.concat(w),bytesRead:y},E.guessEncoding);if(j.seemsBinary&&E.acceptTextOnly)throw new d("Stream is binary but only text is accepted for decoding",S.STREAM_IS_BINARY);j.encoding=await E.overwriteEncoding(j.encoding),N=await P.create(j.encoding);const z=N.write(m.$Je.concat(w).buffer);I.write(z),w.length=0,y=0,D({stream:I,detected:j})}catch(j){O.cancel(),I.destroy(),v(j)}};(0,r.$Be)($,{onData:async j=>{N?I.write(N.write(j.buffer)):(w.push(j),y+=j.byteLength,y>=k&&($.pause(),await U(),setTimeout(()=>$.resume())))},onError:j=>I.error(j),onEnd:async()=>{N||await U(),I.end(N?.end())}},O.token)})}async function a($,E,k){const v=(await(0,A.$gE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(f(E),k);let I=!1,w=!1;return{read(){if(w)return null;const y=$.read();if(typeof y!="string"){if(w=!0,!I&&k?.addBOM)switch(E){case e.$hE:case e.$iE:return m.$Je.wrap(Uint8Array.from(e.$oE));case e.$jE:return m.$Je.wrap(Uint8Array.from(e.$mE));case e.$kE:return m.$Je.wrap(Uint8Array.from(e.$nE))}const N=v.end();return N&&N.length>0?(I=!0,m.$Je.wrap(N)):null}return I=!0,m.$Je.wrap(v.write(y))}}}async function u($){return(await(0,A.$gE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(f($))}function f($){return $===e.$iE||$===null?e.$hE:$}function g($,E){if(!$||E<e.$mE.length)return null;const k=$.readUInt8(0),D=$.readUInt8(1);if(k===e.$mE[0]&&D===e.$mE[1])return e.$jE;if(k===e.$nE[0]&&D===e.$nE[1])return e.$kE;if(E<e.$oE.length)return null;const v=$.readUInt8(2);return k===e.$oE[0]&&D===e.$oE[1]&&v===e.$oE[2]?e.$iE:null}const n=["ascii","utf-16","utf-32"];async function s($){const E=await(0,A.$gE)("jschardet","dist/jschardet.min.js"),k=$.slice(0,C),D=l(k.buffer),v=E.detect(D);if(!v||!v.encoding)return null;const I=v.encoding.toLowerCase();return 0<=n.indexOf(I)?null:t(v.encoding)}const i={ibm866:"cp866",big5:"cp950"};function t($){const E=$.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return i[E]||E}function l($){let E="";for(let k=0;k<$.length;k++)E+=String.fromCharCode($[k]);return E}function h($){switch($){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const E=$.match(/windows(\d+)/);return E?"windows-"+E[1]:$}}}function o({buffer:$,bytesRead:E},k){let D=g($,E),v=!1;if(D!==e.$jE&&D!==e.$kE&&$){let I=!0,w=!0,y=!1;for(let N=0;N<E&&N<T;N++){const O=N%2===1,U=$.readUInt8(N)===0;if(U&&(y=!0),I&&(O&&!U||!O&&U)&&(I=!1),w&&(O&&U||!O&&!U)&&(w=!1),U&&!I&&!w)break}y&&(I?D=e.$kE:w?D=e.$jE:v=!0)}return k&&!v&&!D&&$?s($.slice(0,E)).then(I=>({seemsBinary:!1,encoding:I})):{seemsBinary:v,encoding:D}}e.$xE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[170],Se([1,0,400,34,169]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=void 0;class R extends A.$8nc{constructor(T,p,c=m,C="searchProcess"){super({query:T,provider:p},{readdir:S=>c.Promises.readdir(S.fsPath),toCanonicalName:S=>(0,r.$vE)(S)},C)}}e.$lpc=R}),define(ye[171],Se([1,0,59,416,399,19,79,39,13,2,38,99,417,397,129]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=e.$epc=void 0,e.$gpc=t,e.$hpc=h,e.$ipc=$,e.$jpc=E,e.$kpc=D;const a=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class u{constructor(I){this.a=I}provideTextSearchResults(I,w,y,N){return this.a.appendLine(`provideTextSearchResults ${I.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((O,U)=>{N.onCancellationRequested(()=>H());const j=t(I,w),z=w.folder.fsPath,M=j.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.a.appendLine(`${a} ${M}
 - cwd: ${z}`);let F=r.spawn(a,j,{cwd:z});F.on("error",ve=>{console.error(ve),this.a.appendLine("Error: "+(ve&&ve.message)),U((0,C.$TK)(new C.$RK(ve&&ve.message,C.SearchErrorCode.rgProcessError)))});let J=!1;const ee=new n(w.maxResults,w.folder,w.previewOptions);ee.on("result",ve=>{J=!0,ne="",y.report(ve)});let V=!1;const H=()=>{V=!0,F?.kill(),ee?.cancel()};let _=!1;ee.on("hitLimit",()=>{_=!0,H()});let ne="";F.stdout.on("data",ve=>{ee.handleData(ve),J||(ne+=ve)});let he=!1;F.stdout.once("data",()=>he=!0);let re="";F.stderr.on("data",ve=>{const pe=ve.toString();this.a.appendLine(pe),re.length+pe.length<1e6&&(re+=pe)}),F.on("close",()=>{if(this.a.appendLine(he?"Got data from stdout":"No data from stdout"),this.a.appendLine(J?"Got result from parser":"No result from parser"),ne&&this.a.appendLine(`Got data without result: ${ne}`),this.a.appendLine(""),V)O({limitHit:_});else{ee.flush(),F=null;let ve;re&&!he&&(ve=f(re))?U((0,C.$TK)(new C.$RK(ve.message,ve.code))):O({limitHit:_})}})})}}e.$epc=u;function f(v){const I=v.split(`
`),w=I[0].trim();if(I.some(N=>N.startsWith("regex parse error")))return new C.$RK(g(I),C.SearchErrorCode.regexParseError);const y=w.match(/grep config error: unknown encoding: (.*)/);if(y)return new C.$RK(`Unknown encoding: ${y[1]}`,C.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new C.$RK(w.charAt(0).toUpperCase()+w.substr(1),C.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new C.$RK(w.charAt(0).toUpperCase()+w.substr(1),C.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new C.$RK(w,C.SearchErrorCode.regexParseError)}function g(v){const I=["Regex parse error"],w=v.filter(y=>y.startsWith("PCRE2:"));if(w.length>=1){const y=w[0].replace("PCRE2:","");if(y.indexOf(":")!==-1&&y.split(":").length>=2){const N=y.split(":")[1];I.push(":"+N)}}return I.join("")}class n extends m.EventEmitter{constructor(I,w,y){super(),this.g=I,this.h=w,this.j=y,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new A.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(I,w){return super.on(I,w),this}handleData(I){if(this.b)return;const w=typeof I=="string"?I:this.d.write(I);this.k(w)}k(I){let w=I.indexOf(`
`);const y=this.a+I;if(w>=0)w+=this.a.length;else{this.a=y;return}let N=0;for(;w>=0;)this.m(y.substring(N,w).trim()),N=w+1,w=y.indexOf(`
`,N);this.a=y.substring(N)}m(I){if(this.b||!I)return;let w;try{w=JSON.parse(I)}catch{throw new Error(`malformed line from rg: ${I}`)}if(w.type==="match"){const y=s(w.data.path),N=c.URI.joinPath(this.h,y),O=this.n(w.data,N);this.p(O),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const y=s(w.data.path),N=c.URI.joinPath(this.h,y);this.o(w.data,N).forEach(U=>this.p(U))}}n(I,w){const y=I.line_number-1,N=s(I.lines),O=Buffer.from(N);let U=0,j=0,z=y;I.submatches.length===0&&I.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const M=(0,R.$Hb)(I.submatches.map((F,J)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=s(F.match),V=O.slice(U,F.start).toString(),H=i(V),_=H.numLines>0?H.lastLineLength:H.lastLineLength+j,ne=i(ee),he=H.numLines+z,re=ne.numLines+he,ve=ne.numLines>0?ne.lastLineLength:ne.lastLineLength+_;return U=F.end,j=ve,z=re,new S.$BK(he,_,re,ve)}));return(0,b.$0oc)(w,N,M,this.j)}o(I,w){const y=s(I.lines),N=I.line_number;return y.replace(/\r?\n$/,"").split(`
`).map((O,U)=>({text:O,uri:w,lineNumber:N+U}))}p(I){this.emit("result",I)}}e.$fpc=n;function s(v){return v.bytes?Buffer.from(v.bytes,"base64").toString():v.text}function i(v){const I=/\n/g;let w=0,y=-1,N;for(;N=I.exec(v);)w++,y=N.index;const O=y>=0?v.length-y-1:v.length;return{numLines:w,lastLineLength:O}}function t(v,I){const w=["--hidden","--no-require-git"];w.push(v.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:y,otherIncludes:N}=(0,L.$K)(I.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const U=new Set;N.forEach(j=>{U.add(j)}),w.push("-g","!*"),U.forEach(j=>{l(j).map(b.$9oc).forEach(z=>{w.push("-g",z)})})}y&&y.length&&y.forEach(U=>{w.push("-g",U)}),I.excludes.map(b.$9oc).forEach(U=>w.push("-g",`!${U}`)),I.maxFileSize&&w.push("--max-filesize",I.maxFileSize+""),I.useIgnoreFiles?I.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),I.followSymlinks&&w.push("--follow"),I.encoding&&I.encoding!=="utf8"&&w.push("--encoding",I.encoding),v.pattern==="--"&&(v.isRegExp=!0,v.pattern="\\-\\-"),v.isMultiline&&!v.isRegExp&&(v.pattern=(0,p.$df)(v.pattern),v.isRegExp=!0),I.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),v.isRegExp&&(v.pattern=h(v.pattern),w.push("--engine","auto"));let O;if(v.isWordMatch){const j=(0,p.$mf)(v.pattern,!!v.isRegExp,{wholeWord:v.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",j)}else if(v.isRegExp){let U=$(v.pattern);U=E(U),w.push("--regexp",U)}else O=v.pattern,w.push("--fixed-strings");return w.push("--no-config"),I.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),v.isMultiline&&w.push("--multiline"),I.beforeContext&&w.push("--before-context",I.beforeContext+""),I.afterContext&&w.push("--after-context",I.afterContext+""),w.push("--"),O&&w.push(O),w.push("."),w}function l(v){return D(v).flatMap(w=>{const y=(0,T.$sk)(w,"/");return y.map((N,O)=>y.slice(0,O+1).join("/"))})}function h(v){const I=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;v.match(I);)v=v.replace(I,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;v.match(w);)v=v.replace(w,"$1\\x{$2}");return v}const o=v=>v.type==="Assertion"&&v.kind==="lookbehind";function $(v){let I;try{I=new d.RegExpParser().parsePattern(v)}catch{return v}let w="",y=0;const N=(j,z,M)=>{w+=v.slice(y,j)+M,y=z},O=[];return new d.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const z=O[0];if(!z)N(j.start,j.end,"\\r?\\n");else if(!O.some(o))if(z.type==="CharacterClass")if(z.negate){const M=v.slice(z.start+2,j.start)+v.slice(j.end,z.end-1);z.parent?.type==="Quantifier"?N(z.start,z.end,M?`[^${M}]`:"."):N(z.start,z.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=v.slice(z.start+1,j.start)+v.slice(j.end,z.end-1);N(z.start,z.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else z.type==="Quantifier"&&N(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){O.unshift(j)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(j){O.unshift(j)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(j){O.unshift(j)},onCharacterClassLeave(){O.shift()},onAssertionEnter(j){o(j)&&O.push(j)},onAssertionLeave(j){O[0]===j&&O.shift()}}).visit(I),w+=v.slice(y),w}function E(v){return v.replace(/\n/g,"\\r?\\n")}function k(v){let I=!1,w=!1,y="",N="";for(let O=0;O<v.length;O++){const U=v[O];switch(U){case"\\":w?(I?N+="\\"+U:y+="\\"+U,w=!1):w=!0;break;case"{":if(w)I?N+=U:y+=U,w=!1;else{if(I)return{strInBraces:y+"{"+N+"{"+v.substring(O+1)};I=!0}break;case"}":if(w)I?N+=U:y+=U,w=!1;else{if(I)return{fixedStart:y,strInBraces:N,fixedEnd:v.substring(O+1)};y+=U}break;default:I?N+=(w?"\\":"")+U:y+=(w?"\\":"")+U,w=!1;break}}return{strInBraces:y+(I?"{"+N:"")}}function D(v){const{fixedStart:I,strInBraces:w,fixedEnd:y}=k(v);if(I===void 0||y===void 0)return[w];let N=(0,T.$sk)(w,",");N.length||(N=[""]);const O=D(y);return N.flatMap(U=>{const j=I+U;return O.map(z=>j+z)})}}),define(ye[401],Se([1,0,21,171,90,15]),function(de,e,r,m,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$opc=void 0;class L{constructor(c){this.b=c,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(c,C,S,d){const P=new m.$epc(this.b);if(C.folder.scheme===R.Schemas.vscodeUserData){const b={...C,folder:C.folder.with({scheme:R.Schemas.file})},a=new A.$mw(u=>S.report({...u,uri:u.uri.with({scheme:C.folder.scheme})}));return this.c(d,u=>P.provideTextSearchResults(c,b,a,u))}else return this.c(d,b=>P.provideTextSearchResults(c,C,S,b))}async c(c,C){const S=T(c);this.a.add(S);const d=await C(S.token);return this.a.delete(S),d}d(){this.a.forEach(c=>c.cancel())}}e.$opc=L;function T(p){const c=new r.$se;return p.onCancellationRequested(()=>c.cancel()),c}}),define(ye[402],Se([1,0,34,171,170]),function(de,e,r,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=void 0;class R{constructor(p){this.a=p}search(p,c,C){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const S={appendLine(P){C({message:P})}},d=new A.$lpc(this.a,new m.$epc(S),r);return new Promise((P,b)=>d.search(a=>{c(a.map(L))},p).then(a=>P({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),b))}}e.$mpc=R;function L(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((p,c)=>{if(c.ranges){const C=c;return p+(Array.isArray(C.ranges)?C.ranges.length:1)}else return p+1},0)}}}),define(ye[403],Se([1,0,19,9,14,4,140,16,42,2,28,38,398,402]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=void 0;class b{static{this.a=512}constructor(s="searchProcess"){this.d=s,this.b=Object.create(null)}fileSearch(s){let i;const t=f(s),l=new R.$he({onDidAddFirstListener:()=>{i=(0,m.$nh)(h=>this.doFileSearchWithEngine(d.$dpc,t,o=>l.fire(o),h)),i.then(h=>l.fire(h),h=>l.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return l.event}textSearch(s){let i;const t=f(s),l=new R.$he({onDidAddFirstListener:()=>{i=(0,m.$nh)(h=>this.f(t,o=>l.fire(o),h)),i.then(h=>l.fire(h),h=>l.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return l.event}f(s,i,t){return s.maxFileSize=this.g().maxFileSize,new P.$mpc(s).search(t,i,i)}g(){return{maxFileSize:16*C.$Cl.GB}}doFileSearch(s,i,t){return this.doFileSearchWithEngine(d.$dpc,s,i,t)}doFileSearchWithEngine(s,i,t,l,h=b.a){let o=0;const $=k=>{Array.isArray(k)?(o+=k.length,t(k.map(D=>this.h(D)))):k.relativePath?(o++,t(this.h(k))):t(k)};if(i.sortByScore){let k=this.l(i,$,l);if(!k){const D=i.maxResults?Object.assign({},i,{maxResults:null}):i,v=new s(D);k=this.j(v,i,t,$,l)}return new Promise((D,v)=>{k.then(([I,w])=>{const y=w.map(N=>this.h(N));this.o(y,t,h),D(I)},v)})}const E=new s(i);return this.r(E,$,h,l).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:o,sortingTime:void 0},messages:[]}))}h(s){return{path:s.base?(0,T.$jc)(s.base,s.relativePath):s.relativePath}}j(s,i,t,l,h){const o=new R.$he;let $=(0,m.$nh)(k=>{let D=[];const v=I=>{Array.isArray(I)?D=I:(l(I),o.fire(I))};return this.r(s,v,-1,k).then(I=>[I,D])}),E;if(i.cacheKey){E=this.k(i.cacheKey);const k={promise:$,event:o.event,resolved:!1};E.resultsToSearchCache[i.filePattern||""]=k,$.then(()=>{k.resolved=!0},D=>{delete E.resultsToSearchCache[i.filePattern||""]}),$=this.s($)}return $.then(([k,D])=>{const v=E?E.scorerCache:Object.create(null),I=(typeof i.maxResults!="number"||i.maxResults>0)&&p.$be.create(!1);return this.n(i,D,v,h).then(w=>{const y=I?I.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:y,fromCache:!1,type:this.d,resultCount:w.length},messages:k.messages,limitHit:k.limitHit||typeof i.maxResults=="number"&&D.length>i.maxResults},w]})})}k(s){const i=this.b[s];return i||(this.b[s]=new a)}l(s,i,t){const l=s.cacheKey&&this.b[s.cacheKey];if(!l)return;const h=this.q(l,s.filePattern||"",i,t);if(h)return h.then(([o,$,E])=>{const k=p.$be.create(!1);return this.n(s,$,l.scorerCache,t).then(D=>{const v=k.elapsed(),I={fromCache:!0,detailStats:E,type:this.d,resultCount:$.length,sortingTime:v};return[{type:"success",limitHit:o.limitHit||typeof s.maxResults=="number"&&$.length>s.maxResults,stats:I,messages:[]},D]})})}n(s,i,t,l){const h=(0,L.$Fr)(s.filePattern||""),o=(E,k)=>(0,L.$Er)(E,k,h,!0,u,t),$=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return r.$Gb(i,o,$,1e4,l)}o(s,i,t){if(t&&t>0)for(let l=0;l<s.length;l+=t)i(s.slice(l,l+t));else i(s)}q(s,i,t,l){const h=p.$be.create(!1),o=i.indexOf(T.sep)>=0;let $;for(const v in s.resultsToSearchCache)if(i.startsWith(v)){if(o&&v.indexOf(T.sep)<0&&v!=="")continue;const I=s.resultsToSearchCache[v];$={promise:this.s(I.promise),event:I.event,resolved:I.resolved};break}if(!$)return null;const E=h.elapsed(),k=p.$be.create(!1),D=$.event(t);return l&&l.onCancellationRequested(()=>{D.dispose()}),$.promise.then(([v,I])=>{if(l&&l.isCancellationRequested)throw(0,A.$6)();const w=[],y=(0,L.$Fr)(i).normalizedLowercase;for(const N of I)(0,S.$XK)(N,y)&&w.push(N);return[v,w,{cacheWasResolved:$.resolved,cacheLookupTime:E,cacheFilterTime:k.elapsed(),cacheEntryCount:I.length}]})}r(s,i,t,l){return new Promise((h,o)=>{let $=[];l?.onCancellationRequested(()=>s.cancel()),s.search(E=>{E&&(t?($.push(E),t>0&&$.length>=t&&(i($),$=[])):i(E))},E=>{i(E)},(E,k)=>{$.length&&i($),E?(i({message:"Search finished. Error: "+E.message}),o(E)):(i({message:"Search finished. Stats: "+JSON.stringify(k.stats)}),h(k))})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}s(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,t){return s.then(i,t)}catch(i){return this.then(void 0,i)}finally(i){return s.finally(i)}}}}e.$npc=b;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const u=new class{getItemLabel(n){return(0,T.$nc)(n.relativePath)}getItemDescription(n){return(0,T.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function f(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(g),extraFileResources:n.extraFileResources&&n.extraFileResources.map(s=>c.URI.revive(s))}}function g(n){return{...n,folder:c.URI.revive(n.folder)}}}),define(ye[404],Se([1,0,3,15,2,34,12,30,20,102,72,38,403,401,129,170]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=void 0;let u=class extends c.$aoc{constructor(g,n,s,i){super(g,s,i),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new r.$Tc;const t=new b.$$oc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(m.Schemas.vscodeUserData,new P.$opc(t))),n.remote.isRemote&&n.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const g=new b.$$oc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(m.Schemas.file,new P.$opc(g))),this.A.add(this.C(m.Schemas.file,new d.$npc("fileSearchProvider")))}C(g,n){const s=this.d++;return this.y=n,this.x=s,this.c.$registerFileSearchProvider(s,this.s(g)),(0,r.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(s)})}$provideFileSearchResults(g,n,s,i){const t=(0,c.$boc)(s);if(g===this.x){const l=Date.now();return this.D(g,n,t,i).then(h=>{const o=Date.now()-l;return this.q.debug(`Ext host file search time: ${o}ms`),h})}return super.$provideFileSearchResults(g,n,s,i)}doInternalFileSearchWithCustomCallback(g,n,s){const i=t=>{if((0,S.$WK)(t)&&(t=[t]),Array.isArray(t)){s(t.map(l=>A.URI.file(l.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(g,i,n)}async D(g,n,s,i){return this.doInternalFileSearchWithCustomCallback(s,i,t=>{this.c.$handleFileMatch(g,n,t)})}$clearCache(g){return this.y?.clearCache(g),super.$clearCache(g)}t(g,n){return new a.$lpc(g,n,void 0,"textSearchProvider")}};e.$ppc=u,e.$ppc=u=Je([Ge(0,p.$YO),Ge(1,T.$cP),Ge(2,C.$4mc),Ge(3,L.$7j)],u)}),define(ye[130],Se([1,0,418,66,67,419,22,14,4,3,16,11,32,87,68]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ri=e.$qi=e.$pi=void 0,e.$si=h,e.$ti=o,e.$vi=k,e.$wi=D;class a{traceSocketEvent(I,w){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,w)}constructor(I,w=""){this.f=!0,this.debugLabel=w,this.socket=I,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=y=>{if(this.traceSocketEvent(b.SocketDiagnosticsEventType.Error,{code:y?.code,message:y?.message}),y){if(y.code==="EPIPE")return;(0,T.$1)(y)}},this.socket.on("error",this.a),this.b=y=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Close,{hadError:y}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(I){const w=y=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Read,y),I(L.$Je.wrap(y))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(I){const w=y=>{I({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:y,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(I){const w=()=>{I()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(I){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(b.SocketDiagnosticsEventType.Write,I),this.socket.write(I.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,T.$1)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,T.$1)(w)}}end(){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((I,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),I();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),I()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.$pi=a;var u;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var f;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(f||(f={}));class g extends c.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(I,w){this.socket.traceSocketEvent(I,w)}constructor(I,w,y,N){super(),this.f=this.B(new p.$he),this.g=this.B(new p.$he),this.h=!1,this.j={state:f.PeekHeader,readLen:u.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:y?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new n(this,w,y,N,this.f,(O,U)=>this.m(O,U))),this.B(this.a.onError(O=>{console.error(O),(0,T.$1)(O),this.g.fire({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:O})})),this.b=new b.$ki,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this.f.event(I)}onClose(I){return this.g.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let w=0;for(;w<I.byteLength;)this.a.writeMessage(I.slice(w,Math.min(w+u.MaxWebSocketMessageLength,I.byteLength)),{compressed:!0,opcode:2}),w+=u.MaxWebSocketMessageLength}m(I,{compressed:w,opcode:y}){if(this.h)return;this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,I);let N=u.MinHeaderByteSize;I.byteLength<126?N+=0:I.byteLength<2**16?N+=2:N+=8;const O=L.$Je.alloc(N),U=w?64:0,j=y&15;if(O.writeUInt8(128|U|j,0),I.byteLength<126)O.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){O.writeUInt8(126,1);let z=1;O.writeUInt8(I.byteLength>>>8&255,++z),O.writeUInt8(I.byteLength>>>0&255,++z)}else{O.writeUInt8(127,1);let z=1;O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(I.byteLength>>>24&255,++z),O.writeUInt8(I.byteLength>>>16&255,++z),O.writeUInt8(I.byteLength>>>8&255,++z),O.writeUInt8(I.byteLength>>>0&255,++z)}this.socket.write(L.$Je.concat([O,I]))}end(){this.h=!0,this.socket.end()}n(I){if(I.byteLength!==0){for(this.b.acceptChunk(I);this.b.byteLength>=this.j.readLen;)if(this.j.state===f.PeekHeader){const w=this.b.peek(this.j.readLen),y=w.readUInt8(0),N=(y&128)>>>7,O=(y&64)>>>6,U=y&15,j=w.readUInt8(1),z=(j&128)>>>7,M=j&127;this.j.state=f.ReadHeader,this.j.readLen=u.MinHeaderByteSize+(z?4:0)+(M===126?2:0)+(M===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=U,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===f.ReadHeader){const w=this.b.read(this.j.readLen),y=w.readUInt8(1),N=(y&128)>>>7;let O=y&127,U=1;O===126?O=w.readUInt8(++U)*2**8+w.readUInt8(++U):O===127&&(O=w.readUInt8(++U)*0+w.readUInt8(++U)*0+w.readUInt8(++U)*0+w.readUInt8(++U)*0+w.readUInt8(++U)*2**24+w.readUInt8(++U)*2**16+w.readUInt8(++U)*2**8+w.readUInt8(++U));let j=0;N&&(j=w.readUInt8(++U)*2**24+w.readUInt8(++U)*2**16+w.readUInt8(++U)*2**8+w.readUInt8(++U)),this.j.state=f.ReadBody,this.j.readLen=O,this.j.mask=j,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===f.ReadBody){const w=this.b.read(this.j.readLen);this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,w),t(w,this.j.mask),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,w),this.j.state=f.PeekHeader,this.j.readLen=u.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(w,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(w,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$qi=g;class n extends c.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Je.alloc(0)}constructor(I,w,y,N,O,U){super(),this.n=I,this.r=O,this.s=U,this.a=this.B(new p.$he),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$he),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$he),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,w?(this.b=this.B(new s(this.n,N,y,{windowBits:15})),this.f=this.B(new i(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(I,w){this.g.push({data:I,options:w}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:I,options:w}=this.g.shift();if(this.f&&w.compressed){const y=await this.w(this.f,I);this.s(y,w)}else this.s(I,{...w,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(I,w){return new Promise((y,N)=>{I.write(w),I.flush(O=>y(O))})}acceptFrame(I,w,y){this.h.push({data:I,isCompressed:w,isLastFrameOfMessage:y}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const I=this.h.shift();if(this.b&&I.isCompressed){const w=await this.C(this.b,I.data,I.isLastFrameOfMessage);this.r.fire(w)}else this.r.fire(I.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(I,w,y){return new Promise((N,O)=>{I.write(w),y&&I.write(L.$Je.fromByteArray([0,0,255,255])),I.flush(U=>N(U))})}}class s extends c.$Uc{get recordedInflateBytes(){return this.j?L.$Je.concat(this.f):L.$Je.alloc(0)}constructor(I,w,y,N){super(),this.h=I,this.j=w,this.a=this.B(new p.$he),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(N),this.b.on("error",O=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateError,{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateData,O),this.g.push(L.$Je.wrap(O))}),y&&(this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialWrite,y.buffer),this.b.write(y.buffer),this.b.flush(()=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(I){this.j&&this.f.push(I.clone()),this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateWrite,I),this.b.write(I.buffer)}flush(I){this.b.flush(()=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateFlushFired);const w=L.$Je.concat(this.g);this.g.length=0,I(w)})}}class i extends c.$Uc{constructor(I,w){super(),this.g=I,this.a=this.B(new p.$he),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",y=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateError,{message:y?.message,code:y?.code}),this.a.fire(y)}),this.b.on("data",y=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateData,y),this.f.push(L.$Je.wrap(y))})}write(I){this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateWrite,I.buffer),this.b.write(I.buffer)}flush(I){this.b.flush(2,()=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateFlushFired);let w=L.$Je.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),I(w)})}}function t(v,I){if(I===0)return;const w=v.byteLength>>>2;for(let z=0;z<w;z++){const M=v.readUInt32BE(z*4);v.writeUInt32BE(M^I,z*4)}const y=w*4,N=v.byteLength-y,O=I>>>24&255,U=I>>>16&255,j=I>>>8&255;N>=1&&v.writeUInt8(v.readUInt8(y)^O,y),N>=2&&v.writeUInt8(v.readUInt8(y+1)^U,y+1),N>=3&&v.writeUInt8(v.readUInt8(y+2)^j,y+2)}e.$ri=process.env.XDG_RUNTIME_DIR;const l={[S.Platform.Linux]:107,[S.Platform.Mac]:103};function h(){const v=(0,d.$Wg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const I=process.platform!=="darwin"&&e.$ri?e.$ri:(0,A.tmpdir)(),w=(0,C.$jc)(I,`vscode-ipc-${v}.sock`);return $(w),w}function o(v,I,w){const N=(0,r.createHash)("sha256").update(v).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${w}-${I}-sock`;const O=w.substr(0,4),U=I.substr(0,6);let j;return process.platform!=="darwin"&&e.$ri&&!process.env.VSCODE_PORTABLE?j=(0,C.$jc)(e.$ri,`vscode-${N}-${O}-${U}.sock`):j=(0,C.$jc)(v,`${O}-${U}.sock`),$(j),j}function $(v){const I=l[S.$u];typeof I=="number"&&v.length>=I&&console.warn(`WARNING: IPC handle "${v}" is longer than ${I} chars, try a shorter --user-data-dir`)}class E extends P.$ei{static b(I){const w=p.Event.fromNodeEventEmitter(I,"connection");return p.Event.map(w,y=>({protocol:new b.$li(new a(y,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(y,"close"))}))}constructor(I){super(E.b(I)),this.d=I}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ui=E;function k(v){return new Promise((I,w)=>{const y=(0,m.createServer)();y.on("error",w),y.listen(v,()=>{y.removeListener("error",w),I(new E(y))})})}function D(v,I){return new Promise((w,y)=>{const N=(0,m.createConnection)(v,()=>{N.removeListener("error",y),w(b.$mi.fromSocket(new a(N,`ipc-client${I}`),I))});N.once("error",y)})}}),define(ye[405],Se([1,0,66,67,186,130,9,3,11,44,12,115,283,284,117,93,22]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=e.$dfc=e.$cfc=e.$bfc=void 0;async function f(t,l,h,o,$){let E;for(let k=3;k&&(E?.dispose(),E=await new g(t,l,h,o,$).waitForReady(),!($&&A.$Zg[$]||!A.$Zg[E.tunnelLocalPort]));k--);return E}class g extends T.$Uc{constructor(l,h,o,$,E){super(),this.m=h,this.n=E,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=l,this.b=r.createServer(),this.c=new L.$zh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=$,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(h=>{h()})}async waitForReady(){const l=this.n??this.tunnelRemotePort,h=(0,a.$zw)(this.m)?"0.0.0.0":"127.0.0.1";let o=await(0,A.$1g)(l,2,1e3,h),$=null;return this.b.listen(o,this.m),await this.c.wait(),$=this.b.address(),$||(o=0,this.b.listen(o,this.m),await this.c.wait(),$=this.b.address()),this.tunnelLocalPort=$.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${$.port}`,this}async r(l){l.pause();const h=(0,a.$xw)(this.tunnelRemoteHost)||(0,a.$zw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,d.$Wl)(this.a,h,this.tunnelRemotePort),$=o.getSocket(),E=o.readEntireBuffer();o.dispose(),E.byteLength>0&&l.write(E.buffer),l.on("end",()=>{l.localAddress&&this.j.delete(l.localAddress),$.end()}),l.on("close",()=>$.end()),l.on("error",()=>{l.localAddress&&this.j.delete(l.localAddress),$ instanceof R.$pi?$.socket.destroy():$.end()}),$ instanceof R.$pi?this.t(l,$):this.s(l,$),l.localAddress&&this.j.set(l.localAddress,()=>{l.end(),$.end()})}s(l,h){h.onClose(()=>l.destroy()),h.onEnd(()=>l.end()),h.onData(o=>l.write(o.buffer)),l.on("data",o=>h.write(u.$Je.wrap(o))),l.resume()}t(l,h){const o=h.socket;o.on("end",()=>l.end()),o.on("close",()=>l.end()),o.on("error",()=>{l.destroy()}),o.pipe(l),l.pipe(o)}}e.$bfc=g;let n=class extends a.$Cw{constructor(l,h,o,$,E){super(h,E),this.v=l,this.w=o,this.y=$}isPortPrivileged(l){return(0,a.$Aw)(l,this.m,p.OS,m.release())}t(l,h,o,$,E,k,D,v){const I=this.s(h,o);if(I)return++I.refcount,I.value;if((0,a.$tw)(l))return this.u(l,h,o,E,k,D,v);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${E}.`);const w={commit:this.y.commit,quality:this.y.quality,addressProvider:l,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},y=f(w,$,h,o,E);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(h,o,y),y}}};e.$cfc=n,e.$cfc=n=Je([Ge(0,P.$Ql),Ge(1,C.$7j),Ge(2,b.$Tl),Ge(3,S.$nk),Ge(4,c.$7i)],n);let s=class extends n{constructor(l,h,o,$,E){super(l,h,o,$,E)}};e.$dfc=s,e.$dfc=s=Je([Ge(0,P.$Ql),Ge(1,C.$7j),Ge(2,b.$Tl),Ge(3,S.$nk),Ge(4,c.$7i)],s);let i=class extends T.$Uc{constructor(l,h,o,$,E){super(),this.b=l,this.c=h,this.f=o,this.g=$,this.h=E,this.a=new Map}async openTunnel(l,h,o,$,E,k,D,v,I){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${$} on local port ${k}.`),!this.a.has(l)){const w=new s(this.b,this.c,this.g,this.f,this.h);this.B(w),this.a.set(l,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(h,o,$,E,k,D,v,I)}};e.$efc=i,e.$efc=i=Je([Ge(0,P.$Ql),Ge(1,C.$7j),Ge(2,S.$nk),Ge(3,b.$Tl),Ge(4,c.$7i)],i)}),define(ye[406],Se([1,0,130,301,58,37,2,12,45]),function(de,e,r,m,A,R,L,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oP=e.$nP=void 0;class c{constructor(d,P,b){this.b=d,this.c=P,this.f=b,this.a=m.createServer((a,u)=>this.h(a,u)),this.g().catch(a=>(P.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",d=>this.c.error(d))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(d,P){const b=(u,f)=>{P.writeHead(u,{"content-type":"application/json"}),P.end(JSON.stringify(f||null),g=>g&&this.c.error(g))},a=[];d.setEncoding("utf8"),d.on("data",u=>a.push(u)),d.on("end",async()=>{try{const u=JSON.parse(a.join(""));let f;switch(u.type){case"open":f=await this.i(u);break;case"openExternal":f=await this.j(u);break;case"status":f=await this.l(u);break;case"extensionManagement":f=await this.k(u);break;default:b(404,`Unknown message type: ${u.type}`);break}b(200,f)}catch(u){const f=u instanceof Error?u.message:JSON.stringify(u);b(500,f),this.c.error("Error while processing pipe request",u)}})}async i(d){const{fileURIs:P,folderURIs:b,forceNewWindow:a,diffMode:u,mergeMode:f,addMode:g,forceReuseWindow:n,gotoLineMode:s,waitMarkerFilePath:i,remoteAuthority:t}=d,l=[];if(Array.isArray(b))for(const E of b)try{l.push({folderUri:L.URI.parse(E)})}catch{}if(Array.isArray(P))for(const E of P)try{(0,p.$6i)(E)?l.push({workspaceUri:L.URI.parse(E)}):l.push({fileUri:L.URI.parse(E)})}catch{}const h=i?L.URI.file(i):void 0,$={forceNewWindow:a,diffMode:u,mergeMode:f,addMode:g,gotoLineMode:s,forceReuseWindow:n,preferNewWindow:!n&&!h&&!g,waitMarkerFileURI:h,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",l,$)}async j(d){for(const P of d.uris){const b=L.URI.parse(P),a=b.scheme==="file"?b:P;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(d){const P=a=>a?.map(u=>/\.vsix$/i.test(u)?L.URI.parse(u):u),b={list:d.list,install:P(d.install),uninstall:P(d.uninstall),force:d.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",b)}async l(d){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&A.existsSync(this.f)&&A.unlinkSync(this.f)}}e.$nP=c;let C=class extends c{constructor(d,P){super(d,P,(0,r.$si)())}};e.$oP=C,e.$oP=C=Je([Ge(0,R.$iP),Ge(1,T.$7j)],C)}),define(ye[407],Se([1,0,62,394,389,300,53,376,2,15,10,406,110,336,375]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=void 0;class a extends A.$Voc{j(){const g=this,n=globalThis._VSCODE_NODE_MODULES.module,s=n._load;n._load=function(h,o,$){return h=t(h),g.a.has(h)?g.a.get(h).load(h,p.URI.file((0,d.$cr)(o.filename)),E=>s.apply(this,[E,o,$])):s.apply(this,arguments)};const i=n._resolveLookupPaths;n._resolveLookupPaths=(l,h)=>i.call(this,t(l),h);const t=l=>{for(const h of g.b){const o=h(l);if(o){l=o;break}}return l}}}class u extends L.$Jnc{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Node}async vb(){this.h.createInstance(P.$spc);const g=this.h.invokeFunction(m.$Roc);if(this.h.createInstance(T.$rpc),this.f.remote.isRemote&&this.f.remote.authority){const i=this.h.createInstance(S.$oP);process.env.VSCODE_IPC_HOOK_CLI=i.ipcHandlePath}this.h.createInstance(b.$tpc),await this.h.createInstance(a,g,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const s=await this.m.getConfigProvider();await(0,R.$qpc)(this.j,s,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(g){return g.main}async xb(g,n,s){if(n.scheme!==c.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let i=null;s.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=g?.identifier.value;g&&await this.w.initializeLocalizedMessages(g);try{t&&r.mark(`code/extHost/willLoadExtensionCode/${t}`),i=de.__$__nodeRequire(n.fsPath)}finally{t&&r.mark(`code/extHost/didLoadExtensionCode/${t}`),s.codeLoadingStop()}return i}async $setRemoteEnvironment(g){if(this.f.remote.isRemote)for(const n in g){const s=g[n];s===null?delete process.env[n]:process.env[n]=s}}}e.$upc=u}),define(ye[408],Se([1,0,59,22,4,3,133,11,23,2,34,68,12,282,71,117,93,405,30,20,76,383]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=void 0,e.$vpc=t,e.$wpc=l,e.$xpc=h,e.$ypc=o,e.$zpc=E,e.$Apc=k,e.$Bpc=D;function t(w){const y=w.trim().split(`
`),N=[];return y.forEach(U=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);j&&j.length>=3&&N.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),N.reduce((U,j)=>(U[j.socket]=j,U),{})}function l(...w){const y=[].concat(...w.map(o));return[...new Map(y.filter(N=>N.st==="0A").map(N=>{const O=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:h(O[0]),port:parseInt(O[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function h(w){let y="";if(w.length===8)for(let N=w.length-2;N>=0;N-=2)y+=parseInt(w.substr(N,2),16),N!==0&&(y+=".");else for(let N=0;N<w.length;N+=8){const O=w.substring(N,N+8);let U="";for(let j=8;j>=2;j-=2)U+=O.substring(j-2,j),(j===6||j===2)&&(U=parseInt(U,16).toString(16),y+=`${U}`,U="",N+j!==w.length-6&&(y+=":"))}return y}function o(w){const y=w.trim().split(`
`),N=y.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return y.map(U=>U.trim().split(/\s+/).reduce((j,z,M)=>(j[N[M]||M]=z,j),{}))}function $(w){return!!w.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||w.indexOf("out/server-main.js")!==-1||w.indexOf("_productName=VSCode")!==-1}function E(w){const y=w.trim().split(`
`),N=[];return y.forEach(O=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);U&&U.length>=4&&N.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),N}async function k(w,y,N){const O=N.reduce((j,z)=>(j[z.pid]=z,j),{}),U=[];return w.forEach(({socket:j,ip:z,port:M})=>{const F=y[j]?y[j].pid:void 0,J=F?O[F]?.cmd:void 0;F&&J&&!$(J)&&U.push({host:z,port:M,detail:J,pid:F})}),U}function D(w,y,N){const O=new Map,U=E(y);for(const j of w){const z=N.get(j.port);if(z){O.set(j.port,z);continue}const M=U.find(F=>F.cmd.includes(`${j.port}`));if(M){let F=M,J;do J=U.find(ee=>ee.ppid===F.pid),J&&(F=J);while(J);O.set(j.port,{host:j.ip,port:j.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else O.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return O}let v=class extends s.$oEb{constructor(y,N,O,U){super(y,N,O),this.D=N,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,T.$k&&N.remote.isRemote&&N.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let N;this.y&&(N=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new L.$Jm;let U=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(J=>(0,u.$xw)(J.host)||(0,u.$zw)(J.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(J=>J.port).join(", ")}`);const M=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),U++>3&&O.update(M),(!N||JSON.stringify(N)!==JSON.stringify(z))&&(N=z,await this.a.$onFoundNewCandidates(N));const F=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(J=>setTimeout(()=>J(),F))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",N="";try{y=await C.Promises.readFile("/proc/net/tcp","utf8"),N=await C.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=l(y,N),U=await new Promise(H=>{(0,r.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(_,ne,he)=>{H(ne)})}),j=t(U),z=await C.Promises.readdir("/proc"),M=[];for(const H of z)try{const _=Number(H),ne=p.$bh(c.URI.file("/proc"),H);if((await C.Promises.stat(ne.fsPath)).isDirectory()&&!isNaN(_)){const re=await C.Promises.readlink(p.$bh(ne,"cwd").fsPath),ve=await C.Promises.readFile(p.$bh(ne,"cmdline").fsPath,"utf8");M.push({pid:_,cwd:re,cmd:ve})}}catch{}const F=[],J=O.filter(H=>{const _=j[H.socket];return _||F.push(H),_}),ee=k(J,j,M);let V;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const H=await new Promise(_=>{(0,r.exec)("ps -F -A -l | grep root",(ne,he,re)=>{_(he)})});this.z=D(F,H,this.z),V=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${V.map(_=>_.port).join(", ")}`)}return ee.then(H=>V?H.concat(V):H)}w(y){return async N=>{const O=new f.$bfc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,M,F){const J=await y.makeConnection();return I.connect(J,z,M,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new b.$Ml(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await O.waitForReady();const U=new A.$he;return{localAddress:(0,i.$UL)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{O.dispose(),U.fire(),U.dispose()}}}}};e.$Cpc=v,e.$Cpc=v=Je([Ge(0,n.$YO),Ge(1,g.$cP),Ge(2,d.$7j),Ge(3,a.$Tl)],v);class I extends P.$Mvb{static connect(y,N,O,U){const j=new R.$Tc,z={onClose:j.add(new A.$he),onData:j.add(new A.$he),onEnd:j.add(new A.$he)};j.add(y.onDidReceiveMessage(F=>z.onData.fire(m.$Je.wrap(F)))),j.add(y.onDidEnd(()=>z.onEnd.fire())),j.add(y.onDidClose(F=>z.onClose.fire({type:S.SocketCloseEventType.NodeSocketCloseEvent,error:F,hadError:!!F})));const M=new I(y,U,z);return M.B(j),(0,P.$Lvb)(M,N,O,U,z)}constructor(y,N,O){super(N,O),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ye[409],Se([1,0,89,378,392,391,404,407,408,101,53,102,100,46,76,98,377,337,12,393,64,296,112,117,147]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f,g,n,s,i,t,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Fs)(C.$Knc,T.$upc,r.InstantiationType.Eager),(0,r.$Fs)(g.$8j,f.$Epc,r.InstantiationType.Delayed),(0,r.$Fs)(g.$7j,new t.$xi(i.$Uoc,[!1],!0)),(0,r.$Fs)(l.$Tl,h.$gfc,r.InstantiationType.Delayed),(0,r.$Fs)(a.$anc,u.$Dpc,r.InstantiationType.Eager),(0,r.$Fs)(c.$Pnc,R.$8oc,r.InstantiationType.Eager),(0,r.$Fs)(S.$_nc,L.$ppc,r.InstantiationType.Eager),(0,r.$Fs)(d.$Boc,A.$Zoc,r.InstantiationType.Eager),(0,r.$Fs)(P.$vnc,m.$Yoc,r.InstantiationType.Eager),(0,r.$Fs)(b.$nEb,p.$Cpc,r.InstantiationType.Eager),(0,r.$Fs)(s.$Nnc,n.$Fpc,r.InstantiationType.Eager)}),define(ye[420],Se([1,0,66,421,62,14,68,130,280,94,390,22,34,110,9,113,302,318,395,409]),function(de,e,r,m,A,R,L,T,p,c,C,S,d,P,b,a,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let k=0;k<process.execArgv.length;k++)process.execArgv[k]==="--inspect-port=0"&&(process.execArgv.splice(k,1),k--)}();const g=m(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const E=globalThis._VSCODE_NODE_MODULES.module,k=E._load;E._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return k.apply(this,arguments)}})();const n=process.exit.bind(process),s=process.on.bind(process);function i(E){process.exit=function(k){if(E)n(k);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const k=new Error("An extension called process.crash() and this was prevented.");console.warn(k.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(k,D){k==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),s(k,D)}}let t=function(E){n()};function l(){const E=(0,f.$tn)(process.env);if(E.type===f.ExtHostConnectionType.MessagePort)return new Promise((k,D)=>{const v=I=>{const w=I[0],y=new L.$ni;w.on("message",N=>y.fire(S.$Je.wrap(N.data))),w.on("close",()=>{t("renderer closed the MessagePort")}),w.start(),k({onMessage:y.event,send:N=>w.postMessage(N.buffer)})};process.parentPort.on("message",I=>v(I.ports))});if(E.type===f.ExtHostConnectionType.Socket)return new Promise((k,D)=>{let v=null;const I=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),w=L.ProtocolConstants.ReconnectionGraceTime,y=L.ProtocolConstants.ReconnectionShortGraceTime,N=new b.$Nh(()=>t("renderer disconnected for too long (1)"),w),O=new b.$Nh(()=>t("renderer disconnected for too long (2)"),y);process.on("message",(j,z)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const M=S.$Je.wrap(Buffer.from(j.initialDataChunk,"base64"));let F;if(j.skipWebSocketFrames)F=new T.$pi(z,"extHost-socket");else{const J=S.$Je.wrap(Buffer.from(j.inflateBytes,"base64"));F=new T.$qi(new T.$pi(z,"extHost-socket"),j.permessageDeflate,J,!1)}v?(N.cancel(),O.cancel(),v.beginAcceptReconnection(F,M),v.endAcceptReconnection(),v.sendResume()):(clearTimeout(I),v=new L.$oi({socket:F,initialChunk:M}),v.sendResume(),v.onDidDispose(()=>t("renderer disconnected")),k(v),v.onSocketClose(()=>{N.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;N.isScheduled()&&O.schedule()}});const U={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(U)});{const k=E.pipeName;return new Promise((D,v)=>{const I=r.createConnection(k,()=>{I.removeListener("error",v);const w=new L.$oi({socket:new T.$pi(I,"extHost-renderer")});w.sendResume(),D(w)});I.once("error",v),I.on("close",()=>{t("renderer closed the socket")})})}}async function h(){const E=await l();return new class{constructor(){this.a=new L.$ni,this.onMessage=this.a.event,this.b=!1,E.onMessage(k=>{(0,c.$6m)(k,c.MessageType.Terminate)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(k)})}send(k){this.b||E.send(k)}async drain(){if(E.drain)return E.drain()}}}function o(E){return new Promise(k=>{const D=E.onMessage(v=>{D.dispose();const I=JSON.parse(v.toString()),w=I.commit,y=p.default.commit;if(w&&y&&w!==y&&n(c.ExtensionHostExitCode.VersionMismatch),I.parentPid){let N=0;setInterval(function(){try{process.kill(I.parentPid,0),N=0}catch(U){U&&U.code==="EPERM"?(N++,N>=3&&t(`parent process ${I.parentPid} does not exist anymore (3 x EPERM): ${U.message} (code: ${U.code}) (errno: ${U.errno})`)):t(`parent process ${I.parentPid} does not exist anymore: ${U.message} (code: ${U.code}) (errno: ${U.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(I.parentPid)}catch(U){(0,R.$1)(U)}}E.send((0,c.$5m)(c.MessageType.Initialized)),k({protocol:E,initData:I})});E.send((0,c.$5m)(c.MessageType.Ready))})}async function $(){const E=[];process.on("unhandledRejection",(N,O)=>{E.push(O),setTimeout(()=>{const U=E.indexOf(O);U>=0&&O.catch(j=>{E.splice(U,1),(0,R.$4)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),N&&(0,R.$1)(N))})},1e3)}),process.on("rejectionHandled",N=>{const O=E.indexOf(N);O>=0&&E.splice(O,1)}),process.on("uncaughtException",function(N){(0,R.$Z)(N)||(0,R.$1)(N)}),A.mark("code/extHost/willConnectToRenderer");const k=await h();A.mark("code/extHost/didConnectToRenderer");const D=await o(k);A.mark("code/extHost/didWaitForInitData");const{initData:v}=D;i(!!v.environment.extensionTestsLocationURI),v.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,v.environment.skipWorkspaceStorageLock=(0,a.boolean)(g.skipWorkspaceStorageLock,!1);const I=new class{constructor(){this.pid=process.pid}exit(O){n(O)}fsExists(O){return d.Promises.exists(O)}fsRealpath(O){return(0,P.$br)(O)}};let w=null;v.remote.authority&&g.transformURIs&&(w=(0,u.$Js)(v.remote.authority));const y=new C.$Xoc(D.protocol,v,I,w);t=N=>y.terminate(N)}$().catch(E=>console.log(E))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/611f9bfce64f25108829dd295f54a6894e87339d/core/vs/workbench/api/node/extensionHostProcess.js.map
